/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/lazy","vs/base/common/normalization","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],te=function(K){for(var e=[],S=0,D=K.length;S<D;S++)e[S]=ee[K[S]];return e};define(ee[132],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function S(w,$,g){const h=D(w,$);if(h!==-1)return w[h]}e.$db=S;function D(w,$,g=w.length-1){for(let h=g;h>=0;h--){const c=w[h];if($(c))return h}return-1}e.$eb=D;function s(w,$){const g=L(w,$);return g===-1?void 0:w[g]}e.$fb=s;function L(w,$,g=0,h=w.length){let c=g,k=h;for(;c<k;){const u=Math.floor((c+k)/2);$(w[u])?c=u+1:k=u}return c-1}e.$gb=L;function C(w,$){const g=P(w,$);return g===w.length?void 0:w[g]}e.$hb=C;function P(w,$,g=0,h=w.length){let c=g,k=h;for(;c<k;){const u=Math.floor((c+k)/2);$(w[u])?k=u:c=u+1}return c}e.$ib=P;function f(w,$,g=0,h=w.length){const c=P(w,$,g,h);return c===w.length?-1:c}e.$jb=f;class a{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(a.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!$(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const g=L(this.e,$,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$kb=a;function m(w,$){if(w.length===0)return;let g=w[0];for(let h=1;h<w.length;h++){const c=w[h];$(c,g)>0&&(g=c)}return g}e.$lb=m;function b(w,$){if(w.length===0)return;let g=w[0];for(let h=1;h<w.length;h++){const c=w[h];$(c,g)>=0&&(g=c)}return g}e.$mb=b;function p(w,$){return m(w,(g,h)=>-$(g,h))}e.$nb=p;function d(w,$){if(w.length===0)return-1;let g=0;for(let h=1;h<w.length;h++){const c=w[h];$(c,w[g])>0&&(g=h)}return g}e.$ob=d;function y(w,$){for(const g of w){const h=$(g);if(h!==void 0)return h}}e.$pb=y}),define(ee[133],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function S(C,P){const f=Object.create(null);for(const a of C){const m=P(a);let b=f[m];b||(b=f[m]=[]),b.push(a)}return f}e.$I=S;function D(C,P){const f=[],a=[];for(const m of C)P.has(m)||f.push(m);for(const m of P)C.has(m)||a.push(m);return{removed:f,added:a}}e.$J=D;function s(C,P){const f=[],a=[];for(const[m,b]of C)P.has(m)||f.push(b);for(const[m,b]of P)C.has(m)||a.push(b);return{removed:f,added:a}}e.$K=s;function L(C,P){const f=new Set;for(const a of P)C.has(a)&&f.add(a);return f}e.$L=L}),define(ee[134],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=e.$Ns=void 0;function S(P,f){const a=Math.pow(10,f);return Math.round(P*a)/a}class D{constructor(f,a,m,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=S(Math.max(Math.min(1,b),0),3)}static equals(f,a){return f.r===a.r&&f.g===a.g&&f.b===a.b&&f.a===a.a}}e.$Ns=D;class s{constructor(f,a,m,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.l=S(Math.max(Math.min(1,m),0),3),this.a=S(Math.max(Math.min(1,b),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.l===a.l&&f.a===a.a}static fromRGBA(f){const a=f.r/255,m=f.g/255,b=f.b/255,p=f.a,d=Math.max(a,m,b),y=Math.min(a,m,b);let w=0,$=0;const g=(y+d)/2,h=d-y;if(h>0){switch($=Math.min(g<=.5?h/(2*g):h/(2-2*g),1),d){case a:w=(m-b)/h+(m<b?6:0);break;case m:w=(b-a)/h+2;break;case b:w=(a-m)/h+4;break}w*=60,w=Math.round(w)}return new s(w,$,g,p)}static i(f,a,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?f+(a-f)*6*m:m<1/2?a:m<2/3?f+(a-f)*(2/3-m)*6:f}static toRGBA(f){const a=f.h/360,{s:m,l:b,a:p}=f;let d,y,w;if(m===0)d=y=w=b;else{const $=b<.5?b*(1+m):b+m-b*m,g=2*b-$;d=s.i(g,$,a+1/3),y=s.i(g,$,a),w=s.i(g,$,a-1/3)}return new D(Math.round(d*255),Math.round(y*255),Math.round(w*255),p)}}e.$Os=s;class L{constructor(f,a,m,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.v=S(Math.max(Math.min(1,m),0),3),this.a=S(Math.max(Math.min(1,b),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.v===a.v&&f.a===a.a}static fromRGBA(f){const a=f.r/255,m=f.g/255,b=f.b/255,p=Math.max(a,m,b),d=Math.min(a,m,b),y=p-d,w=p===0?0:y/p;let $;return y===0?$=0:p===a?$=((m-b)/y%6+6)%6:p===m?$=(b-a)/y+2:$=(a-m)/y+4,new L(Math.round($*60),w,p,f.a)}static toRGBA(f){const{h:a,s:m,v:b,a:p}=f,d=b*m,y=d*(1-Math.abs(a/60%2-1)),w=b-d;let[$,g,h]=[0,0,0];return a<60?($=d,g=y):a<120?($=y,g=d):a<180?(g=d,h=y):a<240?(g=y,h=d):a<300?($=y,h=d):a<=360&&($=d,h=y),$=Math.round(($+w)*255),g=Math.round((g+w)*255),h=Math.round((h+w)*255),new D($,g,h,p)}}e.$Ps=L;class C{static fromHex(f){return C.Format.CSS.parseHex(f)||C.red}static equals(f,a){return!f&&!a?!0:!f||!a?!1:f.equals(a)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:L.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof D)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof L)this.j=f,this.rgba=L.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&D.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&L.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=C.k(this.rgba.r),a=C.k(this.rgba.g),m=C.k(this.rgba.b),b=.2126*f+.7152*a+.0722*m;return S(b,4)}static k(f){const a=f/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(f){const a=this.getRelativeLuminance(),m=f.getRelativeLuminance();return a>m?(a+.05)/(m+.05):(m+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const a=this.getRelativeLuminance(),m=f.getRelativeLuminance();return a>m}isDarkerThan(f){const a=this.getRelativeLuminance(),m=f.getRelativeLuminance();return a<m}lighten(f){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:a,g:m,b,a:p}=this.rgba;return new C(new D(a,m,b,p*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const a=f.rgba,m=this.rgba.a,b=a.a,p=m+b*(1-m);if(p<1e-6)return C.transparent;const d=this.rgba.r*m/p+a.r*b*(1-m)/p,y=this.rgba.g*m/p+a.g*b*(1-m)/p,w=this.rgba.b*m/p+a.b*b*(1-m)/p;return new C(new D(d,y,w,p))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:a,g:m,b,a:p}=this.rgba;return new C(new D(f.rgba.r-p*(f.rgba.r-a),f.rgba.g-p*(f.rgba.g-m),f.rgba.b-p*(f.rgba.b-b),1))}flatten(...f){const a=f.reduceRight((m,b)=>C.o(b,m));return C.o(this,a)}static o(f,a){const m=1-f.rgba.a;return new C(new D(m*a.rgba.r+f.rgba.a*f.rgba.r,m*a.rgba.g+f.rgba.a*f.rgba.g,m*a.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(f,a,m){if(f.isLighterThan(a))return f;m=m||.5;const b=f.getRelativeLuminance(),p=a.getRelativeLuminance();return m=m*(p-b)/p,f.lighten(m)}static getDarkerColor(f,a,m){if(f.isDarkerThan(a))return f;m=m||.5;const b=f.getRelativeLuminance(),p=a.getRelativeLuminance();return m=m*(b-p)/b,f.darken(m)}static{this.white=new C(new D(255,255,255,1))}static{this.black=new C(new D(0,0,0,1))}static{this.red=new C(new D(255,0,0,1))}static{this.blue=new C(new D(0,0,255,1))}static{this.green=new C(new D(0,255,0,1))}static{this.cyan=new C(new D(0,255,255,1))}static{this.lightgrey=new C(new D(211,211,211,1))}static{this.transparent=new C(new D(0,0,0,0))}}e.$Qs=C,function(P){let f;(function(a){let m;(function(b){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}b.formatRGB=p;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}b.formatRGBA=d;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}b.formatHSL=y;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}b.formatHSLA=w;function $(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function g(t){return`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}`}b.formatHex=g;function h(t,l=!1){return l&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}${$(Math.round(t.rgba.a*255))}`}b.formatHexA=h;function c(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}b.format=c;function k(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6));return new P(new D(r,i,n,1))}if(l===9){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6)),o=16*u(t.charCodeAt(7))+u(t.charCodeAt(8));return new P(new D(r,i,n,o/255))}if(l===4){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3));return new P(new D(16*r+r,16*i+i,16*n+n))}if(l===5){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3)),o=u(t.charCodeAt(4));return new P(new D(16*r+r,16*i+i,16*n+n,(16*o+o)/255))}return null}b.parseHex=k;function u(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=a.CSS||(a.CSS={}))})(f=P.Format||(P.Format={}))}(C||(e.$Qs=C={}))}),define(ee[54],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=void 0;function S(C){return(P,f,a)=>{let m=null,b=null;if(typeof a.value=="function"?(m="value",b=a.value):typeof a.get=="function"&&(m="get",b=a.get),!b)throw new Error("not supported");a[m]=C(b,f)}}function D(C,P,f){let a=null,m=null;if(typeof f.value=="function"?(a="value",m=f.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(a="get",m=f.get),!m)throw new Error("not supported");const b=`$memoize$${P}`;f[a]=function(...p){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[b]}}e.$eh=D;function s(C,P,f){return S((a,m)=>{const b=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...d){this[p]||(this[p]=f?f():void 0),clearTimeout(this[b]),P&&(this[p]=P(this[p],...d),d=[this[p]]),this[b]=setTimeout(()=>{a.apply(this,d),this[p]=f?f():void 0},C)}})}e.$fh=s;function L(C,P,f){return S((a,m)=>{const b=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,d=`$throttle$lastRun$${m}`,y=`$throttle$pending$${m}`;return function(...w){if(this[p]||(this[p]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...w)),this[y])return;const $=this[d]+C;$<=Date.now()?(this[d]=Date.now(),a.apply(this,[this[p]]),this[p]=f?f():void 0):(this[y]=!0,this[b]=setTimeout(()=>{this[y]=!1,this[d]=Date.now(),a.apply(this,[this[p]]),this[p]=f?f():void 0},$-Date.now()))}})}e.$gh=L}),define(ee[14],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class S{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=S,e.$V=new S;function D(u){e.$V.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=D;function s(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=s;function L(u){a(u)||e.$V.onUnexpectedError(u)}e.$Y=L;function C(u){a(u)||e.$V.onUnexpectedExternalError(u)}e.$Z=C;function P(u){if(u instanceof Error){const{name:t,message:l}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:c.isErrorNoTelemetry(u)}}return u}e.$1=P;const f="Canceled";function a(u){return u instanceof m?!0:u instanceof Error&&u.name===f&&u.message===f}e.$2=a;class m extends Error{constructor(){super(f),this.name=this.message}}e.$3=m;function b(){const u=new Error(f);return u.name=u.message,u}e.$4=b;function p(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$5=p;function d(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$6=d;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=y;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$8=w;class $ extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=$;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=g;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=h;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const l=new c;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=c;class k extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$ab=k}),define(ee[23],te([0,1,14,132]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function s(W,z=0){return W[W.length-(1+z)]}e.$qb=s;function L(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.$rb=L;function C(W,z,G=(ce,de)=>ce===de){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let ce=0,de=W.length;ce<de;ce++)if(!G(W[ce],z[ce]))return!1;return!0}e.$sb=C;function P(W,z){const G=W.length-1;z<G&&(W[z]=W[G]),W.pop()}e.$tb=P;function f(W,z,G){return a(W.length,ce=>G(W[ce],z))}e.$ub=f;function a(W,z){let G=0,ce=W-1;for(;G<=ce;){const de=(G+ce)/2|0,ue=z(de);if(ue<0)G=de+1;else if(ue>0)ce=de-1;else return de}return-(G+1)}e.$vb=a;function m(W,z,G){if(W=W|0,W>=z.length)throw new TypeError("invalid index");const ce=z[Math.floor(z.length*Math.random())],de=[],ue=[],fe=[];for(const ye of z){const be=G(ye,ce);be<0?de.push(ye):be>0?ue.push(ye):fe.push(ye)}return W<de.length?m(W,de,G):W<de.length+fe.length?fe[0]:m(W-(de.length+fe.length),ue,G)}e.$wb=m;function b(W,z){const G=[];let ce;for(const de of W.slice(0).sort(z))!ce||z(ce[0],de)!==0?(ce=[de],G.push(ce)):ce.push(de);return G}e.$xb=b;function*p(W,z){let G,ce;for(const de of W)ce!==void 0&&z(ce,de)?G.push(de):(G&&(yield G),G=[de]),ce=de;G&&(yield G)}e.$yb=p;function d(W,z){for(let G=0;G<=W.length;G++)z(G===0?void 0:W[G-1],G===W.length?void 0:W[G])}e.$zb=d;function y(W,z){for(let G=0;G<W.length;G++)z(G===0?void 0:W[G-1],W[G],G+1===W.length?void 0:W[G+1])}e.$Ab=y;function w(W,z,G){const ce=[];function de(ye,be,pe){if(be===0&&pe.length===0)return;const Re=ce[ce.length-1];Re&&Re.start+Re.deleteCount===ye?(Re.deleteCount+=be,Re.toInsert.push(...pe)):ce.push({start:ye,deleteCount:be,toInsert:pe})}let ue=0,fe=0;for(;;){if(ue===W.length){de(ue,0,z.slice(fe));break}if(fe===z.length){de(ue,W.length-ue,[]);break}const ye=W[ue],be=z[fe],pe=G(ye,be);pe===0?(ue+=1,fe+=1):pe<0?(de(ue,1,[]),ue+=1):pe>0&&(de(ue,0,[be]),fe+=1)}return ce}e.$Bb=w;function $(W,z,G){const ce=w(W,z,G),de=[],ue=[];for(const fe of ce)de.push(...W.slice(fe.start,fe.start+fe.deleteCount)),ue.push(...fe.toInsert);return{removed:de,added:ue}}e.$Cb=$;function g(W,z,G){if(G===0)return[];const ce=W.slice(0,G).sort(z);return c(W,z,ce,G,W.length),ce}e.top=g;function h(W,z,G,ce,de){return G===0?Promise.resolve([]):new Promise((ue,fe)=>{(async()=>{const ye=W.length,be=W.slice(0,G).sort(z);for(let pe=G,Re=Math.min(G+ce,ye);pe<ye;pe=Re,Re=Math.min(Re+ce,ye)){if(pe>G&&await new Promise(Te=>setTimeout(Te)),de&&de.isCancellationRequested)throw new S.$3;c(W,z,be,pe,Re)}return be})().then(ue,fe)})}e.$Eb=h;function c(W,z,G,ce,de){for(const ue=G.length;ce<de;ce++){const fe=W[ce];if(z(fe,G[ue-1])<0){G.pop();const ye=(0,D.$ib)(G,be=>z(fe,be)<0);G.splice(ye,0,fe)}}}function k(W){return W.filter(z=>!!z)}e.$Fb=k;function u(W){let z=0;for(let G=0;G<W.length;G++)W[G]&&(W[z]=W[G],z+=1);W.length=z}e.$Gb=u;function t(W,z,G){W.splice(G,0,W.splice(z,1)[0])}e.$Hb=t;function l(W){return!Array.isArray(W)||W.length===0}e.$Ib=l;function r(W){return Array.isArray(W)&&W.length>0}e.$Jb=r;function i(W,z=G=>G){const G=new Set;return W.filter(ce=>{const de=z(ce);return G.has(de)?!1:(G.add(de),!0)})}e.$Kb=i;function n(W){const z=new Set;return G=>{const ce=W(G);return z.has(ce)?!1:(z.add(ce),!0)}}e.$Lb=n;function o(W,z){return W.length>0?W[0]:z}e.$Mb=o;function v(W,z){return W.length>0?W[W.length-1]:z}e.$Nb=v;function R(W,z,G=(ce,de)=>ce===de){let ce=0;for(let de=0,ue=Math.min(W.length,z.length);de<ue&&G(W[de],z[de]);de++)ce++;return ce}e.$Ob=R;function A(W){return[].concat(...W)}e.$Pb=A;function E(W,z){let G=typeof z=="number"?W:0;typeof z=="number"?G=W:(G=0,z=W);const ce=[];if(G<=z)for(let de=G;de<z;de++)ce.push(de);else for(let de=G;de>z;de--)ce.push(de);return ce}e.$Qb=E;function I(W,z,G){return W.reduce((ce,de)=>(ce[z(de)]=G?G(de):de,ce),Object.create(null))}e.$Rb=I;function M(W,z){return W.push(z),()=>U(W,z)}e.$Sb=M;function U(W,z){const G=W.indexOf(z);if(G>-1)return W.splice(G,1),z}e.$Tb=U;function B(W,z,G){const ce=W.slice(0,z),de=W.slice(z);return ce.concat(G,de)}e.$Ub=B;function se(W,z){let G;if(typeof z=="number"){let ce=z;G=()=>{const de=Math.sin(ce++)*179426549;return de-Math.floor(de)}}else G=Math.random;for(let ce=W.length-1;ce>0;ce-=1){const de=Math.floor(G()*(ce+1)),ue=W[ce];W[ce]=W[de],W[de]=ue}}e.$Vb=se;function x(W,z){const G=W.indexOf(z);G>-1&&(W.splice(G,1),W.unshift(z))}e.$Wb=x;function ae(W,z){const G=W.indexOf(z);G>-1&&(W.splice(G,1),W.push(z))}e.$Xb=ae;function ne(W,z){for(const G of z)W.push(G)}e.$Yb=ne;function re(W,z){return Array.isArray(W)?W.map(z):z(W)}e.$Zb=re;function Q(W){return Array.isArray(W)?W:[W]}e.$1b=Q;function J(W){return W[Math.floor(Math.random()*W.length)]}e.$2b=J;function V(W,z,G){const ce=N(W,z),de=W.length,ue=G.length;W.length=de+ue;for(let fe=de-1;fe>=ce;fe--)W[fe+ue]=W[fe];for(let fe=0;fe<ue;fe++)W[fe+ce]=G[fe]}e.$3b=V;function F(W,z,G,ce){const de=N(W,z);let ue=W.splice(de,G);return ue===void 0&&(ue=[]),V(W,de,ce),ue}e.$4b=F;function N(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}var H;(function(W){function z(ue){return ue<0}W.isLessThan=z;function G(ue){return ue<=0}W.isLessThanOrEqual=G;function ce(ue){return ue>0}W.isGreaterThan=ce;function de(ue){return ue===0}W.isNeitherLessOrGreaterThan=de,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function Y(W,z){return(G,ce)=>z(W(G),W(ce))}e.$5b=Y;function ie(...W){return(z,G)=>{for(const ce of W){const de=ce(z,G);if(!H.isNeitherLessOrGreaterThan(de))return de}return H.neitherLessOrGreaterThan}}e.$6b=ie;const oe=(W,z)=>W-z;e.$7b=oe;const T=(W,z)=>(0,e.$7b)(W?1:0,z?1:0);e.$8b=T;function O(W){return(z,G)=>-W(z,G)}e.$9b=O;class j{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let G=this.c;for(;G<this.g.length&&z(this.g[G]);)G++;const ce=G===this.c?null:this.g.slice(this.c,G);return this.c=G,ce}takeFromEndWhile(z){let G=this.d;for(;G>=0&&z(this.g[G]);)G--;const ce=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,ce}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const G=this.g.slice(this.c,this.c+z);return this.c+=z,G}}e.$0b=j;class q{static{this.empty=new q(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(G=>(z(G),!0))}toArray(){const z=[];return this.iterate(G=>(z.push(G),!0)),z}filter(z){return new q(G=>this.iterate(ce=>z(ce)?G(ce):!0))}map(z){return new q(G=>this.iterate(ce=>G(z(ce))))}some(z){let G=!1;return this.iterate(ce=>(G=z(ce),!G)),G}findFirst(z){let G;return this.iterate(ce=>z(ce)?(G=ce,!1):!0),G}findLast(z){let G;return this.iterate(ce=>(z(ce)&&(G=ce),!0)),G}findLastMaxBy(z){let G,ce=!0;return this.iterate(de=>((ce||H.isGreaterThan(z(de,G)))&&(ce=!1,G=de),!0)),G}}e.$$b=q}),define(ee[135],te([0,1,14]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$4c=e.$3c=e.$2c=e.ok=void 0;function D(f,a){if(!f)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=D;function s(f,a="Unreachable"){throw new Error(a)}e.$2c=s;function L(f){if(!f)throw new S.$ab("Assertion Failed")}e.$3c=L;function C(f){if(!f()){debugger;f(),(0,S.$Y)(new S.$ab("Assertion Failed"))}}e.$4c=C;function P(f,a){let m=0;for(;m<f.length-1;){const b=f[m],p=f[m+1];if(!a(b,p))return!1;m++}return!0}e.$5c=P}),define(ee[82],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function S(D){const s=this;let L=!1,C;return function(){return L||(L=!0,C=D.apply(s,arguments)),C}}e.$bb=S}),define(ee[69],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(D){function s(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}D.is=s;const L=Object.freeze([]);function C(){return L}D.empty=C;function*P(u){yield u}D.single=P;function f(u){return s(u)?u:P(u)}D.wrap=f;function a(u){return u||L}D.from=a;function*m(u){for(let t=u.length-1;t>=0;t--)yield u[t]}D.reverse=m;function b(u){return!u||u[Symbol.iterator]().next().done===!0}D.isEmpty=b;function p(u){return u[Symbol.iterator]().next().value}D.first=p;function d(u,t){for(const l of u)if(t(l))return!0;return!1}D.some=d;function y(u,t){for(const l of u)if(t(l))return l}D.find=y;function*w(u,t){for(const l of u)t(l)&&(yield l)}D.filter=w;function*$(u,t){let l=0;for(const r of u)yield t(r,l++)}D.map=$;function*g(...u){for(const t of u)for(const l of t)yield l}D.concat=g;function h(u,t,l){let r=l;for(const i of u)r=t(r,i);return r}D.reduce=h;function*c(u,t,l=u.length){for(t<0&&(t+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);t<l;t++)yield u[t]}D.slice=c;function k(u,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,u];const r=u[Symbol.iterator]();for(let i=0;i<t;i++){const n=r.next();if(n.done)return[l,D.empty()];l.push(n.value)}return[l,{[Symbol.iterator](){return r}}]}D.consume=k})(S||(e.Iterable=S={}))}),define(ee[44],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function C(t,l=!1){let r=0;const i=t.length;let n="",o=0,v=16,R=0;function A(x){let ae=0,ne=0;for(;ae<x;){const re=t.charCodeAt(r);if(re>=48&&re<=57)ne=ne*16+re-48;else if(re>=65&&re<=70)ne=ne*16+re-65+10;else if(re>=97&&re<=102)ne=ne*16+re-97+10;else break;r++,ae++}return ae<x&&(ne=-1),ne}function E(x){r=x,n="",o=0,v=16,R=0}function I(){const x=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&a(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&a(t.charCodeAt(r)))for(r++;r<t.length&&a(t.charCodeAt(r));)r++;else return R=3,t.substring(x,r);let ae=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&a(t.charCodeAt(r))){for(r++;r<t.length&&a(t.charCodeAt(r));)r++;ae=r}else R=3;return t.substring(x,ae)}function M(){let x="",ae=r;for(;;){if(r>=i){x+=t.substring(ae,r),R=2;break}const ne=t.charCodeAt(r);if(ne===34){x+=t.substring(ae,r),r++;break}if(ne===92){if(x+=t.substring(ae,r),r++,r>=i){R=2;break}switch(t.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const Q=A(4);Q>=0?x+=String.fromCharCode(Q):R=4;break}default:R=5}ae=r;continue}if(ne>=0&&ne<=31)if(f(ne)){x+=t.substring(ae,r),R=2;break}else R=6;r++}return x}function U(){if(n="",R=0,o=r,r>=i)return o=i,v=17;let x=t.charCodeAt(r);if(P(x)){do r++,n+=String.fromCharCode(x),x=t.charCodeAt(r);while(P(x));return v=15}if(f(x))return r++,n+=String.fromCharCode(x),x===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),v=14;switch(x){case 123:return r++,v=1;case 125:return r++,v=2;case 91:return r++,v=3;case 93:return r++,v=4;case 58:return r++,v=6;case 44:return r++,v=5;case 34:return r++,n=M(),v=10;case 47:{const ae=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(ae,r),v=12}if(t.charCodeAt(r+1)===42){r+=2;const ne=i-1;let re=!1;for(;r<ne;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,re=!0;break}r++}return re||(r++,R=1),n=t.substring(ae,r),v=13}return n+=String.fromCharCode(x),r++,v=16}case 45:if(n+=String.fromCharCode(x),r++,r===i||!a(t.charCodeAt(r)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),v=11;default:for(;r<i&&B(x);)r++,x=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return n+=String.fromCharCode(x),r++,v=16}}function B(x){if(P(x)||f(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let x;do x=U();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:l?se:U,getToken:()=>v,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>R}}e.$Lm=C;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function a(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function b(t,l){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function R(A,E,I,M){o.value=A,o.offset=E,o.length=I,o.type=M,o.colonOffset=void 0,n=o}try{c(t,{onObjectBegin:(A,E)=>{if(l<=A)throw i;n=void 0,v=l>A,r.push("")},onObjectProperty:(A,E,I)=>{if(l<E||(R(A,E,I,"property"),r[r.length-1]=A,l<=E+I))throw i},onObjectEnd:(A,E)=>{if(l<=A)throw i;n=void 0,r.pop()},onArrayBegin:(A,E)=>{if(l<=A)throw i;n=void 0,r.push(0)},onArrayEnd:(A,E)=>{if(l<=A)throw i;n=void 0,r.pop()},onLiteralValue:(A,E,I)=>{if(l<E||(R(A,E,I,u(A)),l<=E+I))throw i},onSeparator:(A,E,I)=>{if(l<=E)throw i;if(A===":"&&n&&n.type==="property")n.colonOffset=E,v=!1,n=void 0;else if(A===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(v=!0,r[r.length-1]=""),n=void 0}}})}catch(A){if(A!==i)throw A}return{path:r,previousNode:n,isAtPropertyKey:v,matches:A=>{let E=0;for(let I=0;E<A.length&&I<r.length;I++)if(A[E]===r[I]||A[E]==="*")E++;else if(A[E]!=="**")return!1;return E===A.length}}}e.$Mm=b;function p(t,l=[],r=L.DEFAULT){let i=null,n=[];const o=[];function v(A){Array.isArray(n)?n.push(A):i!==null&&(n[i]=A)}return c(t,{onObjectBegin:()=>{const A={};v(A),o.push(n),n=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const A=[];v(A),o.push(n),n=A,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:v,onError:(A,E,I)=>{l.push({error:A,offset:E,length:I})}},r),n[0]}e.$Nm=p;function d(t,l=[],r=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function o(A){return i.children.push(A),A}c(t,{onObjectBegin:A=>{i=o({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,E,I)=>{i=o({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:E,length:I,parent:i})},onObjectEnd:(A,E)=>{i.length=A+E-i.offset,i=i.parent,n(A+E)},onArrayBegin:(A,E)=>{i=o({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,E)=>{i.length=A+E-i.offset,i=i.parent,n(A+E)},onLiteralValue:(A,E,I)=>{o({type:u(A),offset:E,length:I,parent:i,value:A}),n(E+I)},onSeparator:(A,E,I)=>{i.type==="property"&&(A===":"?i.colonOffset=E:A===","&&n(E))},onError:(A,E,I)=>{l.push({error:A,offset:E,length:I})}},r);const R=i.children[0];return R&&delete R.parent,R}e.$Om=d;function y(t,l){if(!t)return;let r=t;for(const i of l)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Pm=y;function w(t){if(!t.parent||!t.parent.children)return[];const l=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}e.$Qm=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const l=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(l[r.children[0].value]=$(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Rm=$;function g(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}e.$Sm=g;function h(t,l,r=!1){if(g(t,l,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=l;n++){const o=h(i[n],l,r);if(o)return o}return t}}e.$Tm=h;function c(t,l,r=L.DEFAULT){const i=C(t,!1);function n(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Y){return Y?ie=>Y(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=n(l.onObjectBegin),R=o(l.onObjectProperty),A=n(l.onObjectEnd),E=n(l.onArrayBegin),I=n(l.onArrayEnd),M=o(l.onLiteralValue),U=o(l.onSeparator),B=n(l.onComment),se=o(l.onError),x=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function ne(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:x||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(Y){case 12:case 13:x?re(10):B();break;case 16:re(1);break;case 15:case 14:break;default:return Y}}}function re(Y,ie=[],oe=[]){if(se(Y),ie.length+oe.length>0){let T=i.getToken();for(;T!==17;){if(ie.indexOf(T)!==-1){ne();break}else if(oe.indexOf(T)!==-1)break;T=ne()}}}function Q(Y){const ie=i.getTokenValue();return Y?M(ie):R(ie),ne(),!0}function J(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(re(2),Y=0)}catch{re(2)}M(Y);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return ne(),!0}function V(){return i.getToken()!==10?(re(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(U(":"),ne(),H()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function F(){v(),ne();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||re(4,[],[]),U(","),ne(),i.getToken()===2&&ae)break}else Y&&re(6,[],[]);V()||re(4,[],[2,5]),Y=!0}return A(),i.getToken()!==2?re(7,[2],[]):ne(),!0}function N(){E(),ne();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||re(4,[],[]),U(","),ne(),i.getToken()===4&&ae)break}else Y&&re(6,[],[]);H()||re(4,[],[4,5]),Y=!0}return I(),i.getToken()!==4?re(8,[4],[]):ne(),!0}function H(){switch(i.getToken()){case 3:return N();case 1:return F();case 10:return Q(!0);default:return J()}}return ne(),i.getToken()===17?r.allowEmptyContent?!0:(re(4,[],[]),!1):H()?(i.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.$Um=c;function k(t,l){const r=C(t),i=[];let n,o=0,v;do switch(v=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:o!==v&&i.push(t.substring(o,v)),l!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,l)),o=r.getPosition();break}while(n!==17);return i.join("")}e.$Vm=k;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Wm=u}),define(ee[136],te([0,1,44]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MS=e.$LS=e.$KS=e.$JS=void 0;function D(a,m,b){let p,d,y,w,$;if(m){for(w=m.offset,$=w+m.length,y=w;y>0&&!f(a,y-1);)y--;let v=$;for(;v<a.length&&!f(a,v);)v++;d=a.substring(y,v),p=C(d,b)}else d=a,p=0,y=0,w=0,$=a.length;const g=P(b,a);let h=!1,c=0,k;b.insertSpaces?k=L(" ",b.tabSize||4):k="	";const u=(0,S.$Lm)(d,!1);let t=!1;function l(){return g+L(k,p+c)}function r(){let v=u.scan();for(h=!1;v===15||v===14;)h=h||v===14,v=u.scan();return t=v===16||u.getTokenError()!==0,v}const i=[];function n(v,R,A){!t&&R<$&&A>w&&a.substring(R,A)!==v&&i.push({offset:R,length:A-R,content:v})}let o=r();if(o!==17){const v=u.getTokenOffset()+y,R=L(k,p);n(R,y,v)}for(;o!==17;){let v=u.getTokenOffset()+u.getTokenLength()+y,R=r(),A="";for(;!h&&(R===12||R===13);){const I=u.getTokenOffset()+y;n(" ",v,I),v=u.getTokenOffset()+u.getTokenLength()+y,A=R===12?l():"",R=r()}if(R===2)o!==1&&(c--,A=l());else if(R===4)o!==3&&(c--,A=l());else{switch(o){case 3:case 1:c++,A=l();break;case 5:case 12:A=l();break;case 13:h?A=l():A=" ";break;case 6:A=" ";break;case 10:if(R===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?A=" ":R!==5&&R!==17&&(t=!0);break;case 16:t=!0;break}h&&(R===12||R===13)&&(A=l())}const E=u.getTokenOffset()+y;n(A,v,E),o=R}return i}e.$JS=D;function s(a,m){const b=JSON.stringify(a,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?b.replace(/\r\n|\r|\n/g,m.eol):b}e.$KS=s;function L(a,m){let b="";for(let p=0;p<m;p++)b+=a;return b}function C(a,m){let b=0,p=0;const d=m.tabSize||4;for(;b<a.length;){const y=a.charAt(b);if(y===" ")p++;else if(y==="	")p+=d;else break;b++}return Math.floor(p/d)}function P(a,m){for(let b=0;b<m.length;b++){const p=m.charAt(b);if(p==="\r")return b+1<m.length&&m.charAt(b+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return a&&a.eol||`
`}e.$LS=P;function f(a,m){return`\r
`.indexOf(a.charAt(m))!==-1}e.$MS=f}),define(ee[137],te([0,1,44,136]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RS=e.$QS=e.$PS=e.$OS=e.$NS=void 0;function s(a,m,b){return L(a,m,void 0,b)}e.$NS=s;function L(a,m,b,p,d){const y=m.slice(),w=[],$=(0,S.$Om)(a,w);let g,h;for(;y.length>0&&(h=y.pop(),g=(0,S.$Pm)($,y),g===void 0&&b!==void 0);)typeof h=="string"?b={[h]:b}:b=[b];if(g)if(g.type==="object"&&typeof h=="string"&&Array.isArray(g.children)){const c=(0,S.$Pm)(g,[h]);if(c!==void 0)if(b===void 0){if(!c.parent)throw new Error("Malformed AST");const k=g.children.indexOf(c.parent);let u,t=c.parent.offset+c.parent.length;if(k>0){const l=g.children[k-1];u=l.offset+l.length}else u=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return C(a,{offset:u,length:t-u,content:""},p)}else return C(a,{offset:c.offset,length:c.length,content:JSON.stringify(b)},p);else{if(b===void 0)return[];const k=`${JSON.stringify(h)}: ${JSON.stringify(b)}`,u=d?d(g.children.map(l=>l.children[0].value)):g.children.length;let t;if(u>0){const l=g.children[u-1];t={offset:l.offset+l.length,length:0,content:","+k}}else g.children.length===0?t={offset:g.offset+1,length:0,content:k}:t={offset:g.offset+1,length:0,content:k+","};return C(a,t,p)}}else if(g.type==="array"&&typeof h=="number"&&Array.isArray(g.children))if(b!==void 0){const c=`${JSON.stringify(b)}`;let k;if(g.children.length===0||h===0)k={offset:g.offset+1,length:0,content:g.children.length===0?c:c+","};else{const u=h===-1||h>g.children.length?g.children.length:h,t=g.children[u-1];k={offset:t.offset+t.length,length:0,content:","+c}}return C(a,k,p)}else{const c=h,k=g.children[c];let u;if(g.children.length===1)u={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===c){const t=g.children[c-1],l=t.offset+t.length,r=g.offset+g.length;u={offset:l,length:r-2-l,content:""}}else u={offset:k.offset,length:g.children[c+1].offset-k.offset,content:""};return C(a,u,p)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${g.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return C(a,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(b)},p)}}e.$OS=L;function C(a,m,b){let p=P(a,m),d=m.offset,y=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;d>0&&!(0,D.$MS)(p,d-1);)d--;for(;y<p.length&&!(0,D.$MS)(p,y);)y++}const w=(0,D.$JS)(p,{offset:d,length:y-d},b);for(let g=w.length-1;g>=0;g--){const h=w[g];p=P(p,h),d=Math.min(d,h.offset),y=Math.max(y,h.offset+h.length),y+=h.content.length-h.length}const $=a.length-(p.length-y)-d;return[{offset:d,length:$,content:p.substring(d,y)}]}e.$PS=C;function P(a,m){return a.substring(0,m.offset)+m.content+a.substring(m.offset+m.length)}e.$QS=P;function f(a,m){const b=m.slice(0).sort((d,y)=>{const w=d.offset-y.offset;return w===0?d.length-y.length:w});let p=a.length;for(let d=b.length-1;d>=0;d--){const y=b[d];if(y.offset+y.length<=p)a=P(a,y);else throw new Error("Overlapping edit");p=y.offset}return a}e.$RS=f}),define(ee[83],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=S}),define(ee[101],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=void 0;class S{static{this.Undefined=new S(void 0)}constructor(L){this.element=L,this.next=S.Undefined,this.prev=S.Undefined}}class D{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let L=this.a;for(;L!==S.Undefined;){const C=L.next;L.prev=S.Undefined,L.next=S.Undefined,L=C}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,C){const P=new S(L);if(this.a===S.Undefined)this.a=P,this.b=P;else if(C){const a=this.b;this.b=P,P.prev=a,a.next=P}else{const a=this.a;this.a=P,P.next=a,a.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==S.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==S.Undefined&&L.next!==S.Undefined){const C=L.prev;C.next=L.next,L.next.prev=C}else L.prev===S.Undefined&&L.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):L.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):L.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==S.Undefined;)yield L.element,L=L.next}}e.$Zc=D}),define(ee[31],te([0,1]),function(K,e){"use strict";var S,D,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.Touch=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=void 0;function L(h,c,k){let u=h.get(c);return u===void 0&&(u=k,h.set(c,u)),u}e.$vc=L;function C(h){const c=[];return h.forEach((k,u)=>{c.push(`${u} => ${k}`)}),`Map(${h.size}) {${c.join(", ")}}`}e.$wc=C;function P(h){const c=[];return h.forEach(k=>{c.push(k)}),`Set(${h.size}) {${c.join(", ")}}`}e.$xc=P;class f{constructor(c,k){this.uri=c,this.value=k}}function a(h){return Array.isArray(h)}class m{static{this.a=c=>c.toString()}constructor(c,k){if(this[S]="ResourceMap",c instanceof m)this.b=new Map(c.b),this.c=k??m.a;else if(a(c)){this.b=new Map,this.c=k??m.a;for(const[u,t]of c)this.set(u,t)}else this.b=new Map,this.c=c??m.a}set(c,k){return this.b.set(this.c(c),new f(c,k)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,k){typeof k<"u"&&(c=c.bind(k));for(const[u,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$yc=m;class b{constructor(c,k){this[D]="ResourceSet",!c||typeof c=="function"?this.a=new m(c):(this.a=new m(k),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,k){this.a.forEach((u,t)=>c.call(k,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zc=b;var p;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class d{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,k=0){const u=this.a.get(c);if(u)return k!==0&&this.j(u,k),u.value}set(c,k,u=0){let t=this.a.get(c);if(t)t.value=k,u!==0&&this.j(t,u);else{switch(t={key:c,value:k,next:void 0,previous:void 0},u){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const k=this.a.get(c);if(k)return this.a.delete(c),this.i(k),this.d--,k.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,k){const u=this.e;let t=this.b;for(;t;){if(k?c.bind(k)(t.value,t.key,this):c(t.value,t.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,k=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==k)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.key,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}values(){const c=this,k=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==k)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.value,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}entries(){const c=this,k=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==k)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:[u.key,u.value],done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let k=this.b,u=this.size;for(;k&&u>c;)this.a.delete(k.key),k=k.next,u--;this.b=k,this.d=u,k&&(k.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const k=c.next,u=c.previous;if(!k||!u)throw new Error("Invalid list");k.previous=u,u.next=k}c.next=void 0,c.previous=void 0,this.e++}j(c,k){if(!this.b||!this.c)throw new Error("Invalid list");if(!(k!==1&&k!==2)){if(k===1){if(c===this.b)return;const u=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(u.previous=t,t.next=u),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(k===2){if(c===this.c)return;const u=c.next,t=c.previous;c===this.b?(u.previous=void 0,this.b=u):(u.previous=t,t.next=u),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((k,u)=>{c.push([u,k])}),c}fromJSON(c){this.clear();for(const[k,u]of c)this.set(k,u)}}e.$Ac=d;class y extends d{constructor(c,k=1){super(),this.k=c,this.l=Math.min(Math.max(0,k),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,k=2){return super.get(c,k)}peek(c){return super.get(c,0)}set(c,k){return super.set(c,k,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bc=y;class w{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let k=this.a.get(c)||0;return k===0?!1:(k--,k===0?this.a.delete(c):this.a.set(c,k),!0)}has(c){return this.a.has(c)}}e.$Cc=w;class ${constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[k,u]of c)this.set(k,u)}clear(){this.a.clear(),this.b.clear()}set(c,k){this.a.set(c,k),this.b.set(k,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const k=this.a.get(c);return k===void 0?!1:(this.a.delete(c),this.b.delete(k),!0)}forEach(c,k){this.a.forEach((u,t)=>{c.call(k,u,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Dc=$;class g{constructor(){this.a=new Map}add(c,k){let u=this.a.get(c);u||(u=new Set,this.a.set(c,u)),u.add(k)}delete(c,k){const u=this.a.get(c);u&&(u.delete(k),u.size===0&&this.a.delete(c))}forEach(c,k){const u=this.a.get(c);u&&u.forEach(k)}get(c){const k=this.a.get(c);return k||new Set}}e.$Ec=g}),define(ee[2],te([0,1,23,133,31,82,69]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=void 0;const P=!1;let f=null;class a{constructor(){this.b=new Map}static{this.a=0}c(I){let M=this.b.get(I);return M||(M={parent:null,source:null,isSingleton:!1,value:I,idx:a.a++},this.b.set(I,M)),M}trackDisposable(I){const M=this.c(I);M.source||(M.source=new Error().stack)}setParent(I,M){const U=this.c(I);U.parent=M}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,M){const U=M.get(I);if(U)return U;const B=I.parent?this.f(this.c(I.parent),M):I;return M.set(I,B),B}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,M){let U;if(M)U=M;else{const ne=new Map,re=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,ne).isSingleton);if(re.length===0)return;const Q=new Set(re.map(J=>J.value));if(U=re.filter(J=>!(J.parent&&Q.has(J.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function B(ne){function re(J,V){for(;J.length>0&&V.some(F=>typeof F=="string"?F===J[0]:J[0].match(F));)J.shift()}const Q=ne.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return re(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const se=new s.$Ec;for(const ne of U){const re=B(ne);for(let Q=0;Q<=re.length;Q++)se.add(re.slice(0,Q).join(`
`),ne)}U.sort((0,S.$5b)(ne=>ne.idx,S.$7b));let x="",ae=0;for(const ne of U.slice(0,I)){ae++;const re=B(ne),Q=[];for(let J=0;J<re.length;J++){let V=re[J];V=`(shared with ${se.get(re.slice(0,J+1).join(`
`)).size}/${U.length} leaks) at ${V}`;const N=se.get(re.slice(0,J).join(`
`)),H=(0,D.$I)([...N].map(Y=>B(Y)[J]),Y=>Y);delete H[re[J]];for(const[Y,ie]of Object.entries(H))Q.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${Y}`);Q.unshift(V)}x+=`


==================== Leaking disposable ${ae}/${U.length}: ${ne.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return U.length>I&&(x+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:x}}}e.$Fc=a;function m(E){f=E}if(e.$Gc=m,P){const E="__is_disposable_tracked__";m(new class{trackDisposable(I){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[E]||console.log(M)},3e3)}setParent(I,M){if(I&&I!==t.None)try{I[E]=!0}catch{}}markAsDisposed(I){if(I&&I!==t.None)try{I[E]=!0}catch{}}markAsSingleton(I){}})}function b(E){return f?.trackDisposable(E),E}e.$Hc=b;function p(E){f?.markAsDisposed(E)}e.$Ic=p;function d(E,I){f?.setParent(E,I)}function y(E,I){if(f)for(const M of E)f.setParent(M,I)}function w(E){return f?.markAsSingleton(E),E}e.$Jc=w;function $(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Kc=$;function g(E){if(C.Iterable.is(E)){const I=[];for(const M of E)if(M)try{M.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Lc=g;function h(E){for(const I of E)$(I)&&I.dispose();return[]}e.$Mc=h;function c(...E){const I=k(()=>g(E));return y(E,I),I}e.$Nc=c;function k(E){const I=b({dispose:(0,L.$bb)(()=>{p(I),E()})});return I}e.$Oc=k;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),d(I,null))}}e.$Pc=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,b(this),d(this.q,this)}dispose(){p(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Qc=t;class l{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&d(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&d(I,null),I}}e.$Rc=l;class r{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Sc=r;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(I){let M=I;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,p(this))},this}}e.$Tc=i;class n{constructor(){this.a=new Map}acquire(I,...M){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...M)},this.a.set(I,U));const{object:B}=U,se=(0,L.$bb)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:B,dispose:se}}}e.$Uc=n;class o{constructor(I){this.a=I}async acquire(I,...M){const U=this.a.acquire(I,...M);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(B){throw U.dispose(),B}}}e.$Vc=o;class v{constructor(I){this.object=I}dispose(){}}e.$Wc=v;function R(E){const I=new u;try{E(I)}finally{I.dispose()}}e.$Xc=R;class A{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,M,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,M)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Yc=A}),define(ee[84],te([0,1,31]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=e.$jl=void 0;const D=new S.$Bc(1e4);function s(a){return f(a,"NFC",D)}e.$jl=s;const L=new S.$Bc(1e4);function C(a){return f(a,"NFD",L)}e.$kl=C;const P=/[^\u0000-\u0080]/;function f(a,m,b){if(!a)return a;const p=b.get(a);if(p)return p;let d;return P.test(a)?d=a.normalize(m):d=a,b.set(a,d),d}e.$ll=function(){const a=/[\u0300-\u036f]/g;return function(m){return C(m).replace(a,"")}}()}),define(ee[138],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.rot=e.$Jl=void 0;function S(P,f,a){return Math.min(Math.max(P,f),a)}e.$Jl=S;function D(P,f){return(f+P%f)%f}e.rot=D;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Ll=s;class L{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ml=L;class C{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const a=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nl=C}),function(){function K(s){const L=[];typeof s=="number"&&L.push("code/timeOrigin",s);function C(f){L.push(f,Date.now())}function P(){const f=[];for(let a=0;a<L.length;a+=2)f.push({name:L[a],startTime:L[a+1]});return f}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))L.push({name:C.name,startTime:Math.round(s+C.startTime)});return L}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=S(D))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var D in S)(typeof exports=="object"?exports:K)[D]=S[D]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function S(D){if(e[D])return e[D].exports;var s=e[D]={i:D,l:!1,exports:{}};return K[D].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=K,S.c=e,S.d=function(D,s,L){S.o(D,s)||Object.defineProperty(D,s,{enumerable:!0,get:L})},S.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},S.t=function(D,s){if(1&s&&(D=S(D)),8&s||4&s&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&s&&typeof D!="string")for(var C in D)S.d(L,C,function(P){return D[P]}.bind(null,C));return L},S.n=function(D){var s=D&&D.__esModule?function(){return D.default}:function(){return D};return S.d(s,"a",s),s},S.o=function(D,s){return Object.prototype.hasOwnProperty.call(D,s)},S.p="",S(S.s=0)}([function(K,e,S){(function(D){var s;e=K.exports=oe,s=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],a=0,m=a++;f[m]="0|[1-9]\\d*";var b=a++;f[b]="[0-9]+";var p=a++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=a++;f[d]="("+f[m]+")\\.("+f[m]+")\\.("+f[m]+")";var y=a++;f[y]="("+f[b]+")\\.("+f[b]+")\\.("+f[b]+")";var w=a++;f[w]="(?:"+f[m]+"|"+f[p]+")";var $=a++;f[$]="(?:"+f[b]+"|"+f[p]+")";var g=a++;f[g]="(?:-("+f[w]+"(?:\\."+f[w]+")*))";var h=a++;f[h]="(?:-?("+f[$]+"(?:\\."+f[$]+")*))";var c=a++;f[c]="[0-9A-Za-z-]+";var k=a++;f[k]="(?:\\+("+f[c]+"(?:\\."+f[c]+")*))";var u=a++,t="v?"+f[d]+f[g]+"?"+f[k]+"?";f[u]="^"+t+"$";var l="[v=\\s]*"+f[y]+f[h]+"?"+f[k]+"?",r=a++;f[r]="^"+l+"$";var i=a++;f[i]="((?:<|>)?=?)";var n=a++;f[n]=f[b]+"|x|X|\\*";var o=a++;f[o]=f[m]+"|x|X|\\*";var v=a++;f[v]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[g]+")?"+f[k]+"?)?)?";var R=a++;f[R]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[h]+")?"+f[k]+"?)?)?";var A=a++;f[A]="^"+f[i]+"\\s*"+f[v]+"$";var E=a++;f[E]="^"+f[i]+"\\s*"+f[R]+"$";var I=a++;f[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=a++;f[M]="(?:~>?)";var U=a++;f[U]="(\\s*)"+f[M]+"\\s+",P[U]=new RegExp(f[U],"g");var B=a++;f[B]="^"+f[M]+f[v]+"$";var se=a++;f[se]="^"+f[M]+f[R]+"$";var x=a++;f[x]="(?:\\^)";var ae=a++;f[ae]="(\\s*)"+f[x]+"\\s+",P[ae]=new RegExp(f[ae],"g");var ne=a++;f[ne]="^"+f[x]+f[v]+"$";var re=a++;f[re]="^"+f[x]+f[R]+"$";var Q=a++;f[Q]="^"+f[i]+"\\s*("+l+")$|^$";var J=a++;f[J]="^"+f[i]+"\\s*("+t+")$|^$";var V=a++;f[V]="(\\s*)"+f[i]+"\\s*("+l+"|"+f[v]+")",P[V]=new RegExp(f[V],"g");var F=a++;f[F]="^\\s*("+f[v]+")\\s+-\\s+("+f[v]+")\\s*$";var N=a++;f[N]="^\\s*("+f[R]+")\\s+-\\s+("+f[R]+")\\s*$";var H=a++;f[H]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)s(Y,f[Y]),P[Y]||(P[Y]=new RegExp(f[Y]));function ie(X,le){if(X instanceof oe)return X;if(typeof X!="string"||X.length>L||!(le?P[r]:P[u]).test(X))return null;try{return new oe(X,le)}catch{return null}}function oe(X,le){if(X instanceof oe){if(X.loose===le)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof oe))return new oe(X,le);s("SemVer",X,le),this.loose=le;var ge=X.trim().match(le?P[r]:P[u]);if(!ge)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ae){if(/^[0-9]+$/.test(Ae)){var Ce=+Ae;if(Ce>=0&&Ce<C)return Ce}return Ae}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ie,e.valid=function(X,le){var ge=ie(X,le);return ge?ge.version:null},e.clean=function(X,le){var ge=ie(X.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(X){return s("SemVer.compare",this.version,this.loose,X),X instanceof oe||(X=new oe(X,this.loose)),this.compareMain(X)||this.comparePre(X)},oe.prototype.compareMain=function(X){return X instanceof oe||(X=new oe(X,this.loose)),O(this.major,X.major)||O(this.minor,X.minor)||O(this.patch,X.patch)},oe.prototype.comparePre=function(X){if(X instanceof oe||(X=new oe(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Ae=X.prerelease[le];if(s("prerelease compare",le,ge,Ae),ge===void 0&&Ae===void 0)return 0;if(Ae===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ae)return O(ge,Ae)}while(++le)},oe.prototype.inc=function(X,le){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,le,ge,Ae){typeof ge=="string"&&(Ae=ge,ge=void 0);try{return new oe(X,ge).inc(le,Ae).version}catch{return null}},e.diff=function(X,le){if(z(X,le))return null;var ge=ie(X),Ae=ie(le);if(ge.prerelease.length||Ae.prerelease.length){for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Ae[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Ae[Ce])return Ce},e.compareIdentifiers=O;var T=/^[0-9]+$/;function O(X,le){var ge=T.test(X),Ae=T.test(le);return ge&&Ae&&(X=+X,le=+le),ge&&!Ae?-1:Ae&&!ge?1:X<le?-1:X>le?1:0}function j(X,le,ge){return new oe(X,ge).compare(new oe(le,ge))}function q(X,le,ge){return j(X,le,ge)>0}function W(X,le,ge){return j(X,le,ge)<0}function z(X,le,ge){return j(X,le,ge)===0}function G(X,le,ge){return j(X,le,ge)!==0}function ce(X,le,ge){return j(X,le,ge)>=0}function de(X,le,ge){return j(X,le,ge)<=0}function ue(X,le,ge,Ae){var Ce;switch(le){case"===":typeof X=="object"&&(X=X.version),typeof ge=="object"&&(ge=ge.version),Ce=X===ge;break;case"!==":typeof X=="object"&&(X=X.version),typeof ge=="object"&&(ge=ge.version),Ce=X!==ge;break;case"":case"=":case"==":Ce=z(X,ge,Ae);break;case"!=":Ce=G(X,ge,Ae);break;case">":Ce=q(X,ge,Ae);break;case">=":Ce=ce(X,ge,Ae);break;case"<":Ce=W(X,ge,Ae);break;case"<=":Ce=de(X,ge,Ae);break;default:throw new TypeError("Invalid operator: "+le)}return Ce}function fe(X,le){if(X instanceof fe){if(X.loose===le)return X;X=X.value}if(!(this instanceof fe))return new fe(X,le);s("comparator",X,le),this.loose=le,this.parse(X),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(X,le){return O(le,X)},e.major=function(X,le){return new oe(X,le).major},e.minor=function(X,le){return new oe(X,le).minor},e.patch=function(X,le){return new oe(X,le).patch},e.compare=j,e.compareLoose=function(X,le){return j(X,le,!0)},e.rcompare=function(X,le,ge){return j(le,X,ge)},e.sort=function(X,le){return X.sort(function(ge,Ae){return e.compare(ge,Ae,le)})},e.rsort=function(X,le){return X.sort(function(ge,Ae){return e.rcompare(ge,Ae,le)})},e.gt=q,e.lt=W,e.eq=z,e.neq=G,e.gte=ce,e.lte=de,e.cmp=ue,e.Comparator=fe;var ye={};function be(X,le){if(X instanceof be)return X.loose===le?X:new be(X.raw,le);if(X instanceof fe)return new be(X.value,le);if(!(this instanceof be))return new be(X,le);if(this.loose=le,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function pe(X){return!X||X.toLowerCase()==="x"||X==="*"}function Re(X,le,ge,Ae,Ce,Ue,Oe,Be,We,Z,he,me,ve){return((le=pe(ge)?"":pe(Ae)?">="+ge+".0.0":pe(Ce)?">="+ge+"."+Ae+".0":">="+le)+" "+(Be=pe(We)?"":pe(Z)?"<"+(+We+1)+".0.0":pe(he)?"<"+We+"."+(+Z+1)+".0":me?"<="+We+"."+Z+"."+he+"-"+me:"<="+Be)).trim()}function Te(X,le){for(var ge=0;ge<X.length;ge++)if(!X[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<X.length;ge++)if(s(X[ge].semver),X[ge].semver!==ye&&X[ge].semver.prerelease.length>0){var Ae=X[ge].semver;if(Ae.major===le.major&&Ae.minor===le.minor&&Ae.patch===le.patch)return!0}return!1}return!0}function $e(X,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(X)}function we(X,le,ge,Ae){var Ce,Ue,Oe,Be,We;switch(X=new oe(X,Ae),le=new be(le,Ae),ge){case">":Ce=q,Ue=de,Oe=W,Be=">",We=">=";break;case"<":Ce=W,Ue=ce,Oe=q,Be="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(X,le,Ae))return!1;for(var Z=0;Z<le.set.length;++Z){var he=le.set[Z],me=null,ve=null;if(he.forEach(function(De){De.semver===ye&&(De=new fe(">=0.0.0")),me=me||De,ve=ve||De,Ce(De.semver,me.semver,Ae)?me=De:Oe(De.semver,ve.semver,Ae)&&(ve=De)}),me.operator===Be||me.operator===We||(!ve.operator||ve.operator===Be)&&Ue(X,ve.semver)||ve.operator===We&&Oe(X,ve.semver))return!1}return!0}fe.prototype.parse=function(X){var le=this.loose?P[Q]:P[J],ge=X.match(le);if(!ge)throw new TypeError("Invalid comparator: "+X);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new oe(ge[2],this.loose):this.semver=ye},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(X){return s("Comparator.test",X,this.loose),this.semver===ye||(typeof X=="string"&&(X=new oe(X,this.loose)),ue(X,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(X,le){if(!(X instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(X.value,le),$e(this.value,ge,le);if(X.operator==="")return ge=new be(this.value,le),$e(X.semver,ge,le);var Ae=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Ue=this.semver.version===X.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Be=ue(this.semver,"<",X.semver,le)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),We=ue(this.semver,">",X.semver,le)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Ae||Ce||Ue&&Oe||Be||We},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(X){var le=this.loose;X=X.trim(),s("range",X,le);var ge=le?P[N]:P[F];X=X.replace(ge,Re),s("hyphen replace",X),X=X.replace(P[V],"$1$2$3"),s("comparator trim",X,P[V]),X=(X=(X=X.replace(P[U],"$1~")).replace(P[ae],"$1^")).split(/\s+/).join(" ");var Ae=le?P[Q]:P[J],Ce=X.split(" ").map(function(Ue){return function(Oe,Be){return s("comp",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function(me,ve){s("caret",me,ve);var De=ve?P[re]:P[ne];return me.replace(De,function(Fe,Me,Ne,ze,He){var Ge;return s("caret",me,Fe,Me,Ne,ze,He),pe(Me)?Ge="":pe(Ne)?Ge=">="+Me+".0.0 <"+(+Me+1)+".0.0":pe(ze)?Ge=Me==="0"?">="+Me+"."+Ne+".0 <"+Me+"."+(+Ne+1)+".0":">="+Me+"."+Ne+".0 <"+(+Me+1)+".0.0":He?(s("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=Me==="0"?Ne==="0"?">="+Me+"."+Ne+"."+ze+He+" <"+Me+"."+Ne+"."+(+ze+1):">="+Me+"."+Ne+"."+ze+He+" <"+Me+"."+(+Ne+1)+".0":">="+Me+"."+Ne+"."+ze+He+" <"+(+Me+1)+".0.0"):(s("no pr"),Ge=Me==="0"?Ne==="0"?">="+Me+"."+Ne+"."+ze+" <"+Me+"."+Ne+"."+(+ze+1):">="+Me+"."+Ne+"."+ze+" <"+Me+"."+(+Ne+1)+".0":">="+Me+"."+Ne+"."+ze+" <"+(+Me+1)+".0.0"),s("caret return",Ge),Ge})}(he,Z)}).join(" ")}(Oe,Be),s("caret",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function(me,ve){var De=ve?P[se]:P[B];return me.replace(De,function(Fe,Me,Ne,ze,He){var Ge;return s("tilde",me,Fe,Me,Ne,ze,He),pe(Me)?Ge="":pe(Ne)?Ge=">="+Me+".0.0 <"+(+Me+1)+".0.0":pe(ze)?Ge=">="+Me+"."+Ne+".0 <"+Me+"."+(+Ne+1)+".0":He?(s("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=">="+Me+"."+Ne+"."+ze+He+" <"+Me+"."+(+Ne+1)+".0"):Ge=">="+Me+"."+Ne+"."+ze+" <"+Me+"."+(+Ne+1)+".0",s("tilde return",Ge),Ge})}(he,Z)}).join(" ")}(Oe,Be),s("tildes",Oe),Oe=function(We,Z){return s("replaceXRanges",We,Z),We.split(/\s+/).map(function(he){return function(me,ve){me=me.trim();var De=ve?P[E]:P[A];return me.replace(De,function(Fe,Me,Ne,ze,He,Ge){s("xRange",me,Fe,Me,Ne,ze,He,Ge);var tt=pe(Ne),Ze=tt||pe(ze),it=Ze||pe(He);return Me==="="&&it&&(Me=""),tt?Fe=Me===">"||Me==="<"?"<0.0.0":"*":Me&&it?(Ze&&(ze=0),it&&(He=0),Me===">"?(Me=">=",Ze?(Ne=+Ne+1,ze=0,He=0):it&&(ze=+ze+1,He=0)):Me==="<="&&(Me="<",Ze?Ne=+Ne+1:ze=+ze+1),Fe=Me+Ne+"."+ze+"."+He):Ze?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":it&&(Fe=">="+Ne+"."+ze+".0 <"+Ne+"."+(+ze+1)+".0"),s("xRange return",Fe),Fe})}(he,Z)}).join(" ")}(Oe,Be),s("xrange",Oe),Oe=function(We,Z){return s("replaceStars",We,Z),We.trim().replace(P[H],"")}(Oe,Be),s("stars",Oe),Oe}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Ue){return!!Ue.match(Ae)})),Ce=Ce.map(function(Ue){return new fe(Ue,le)})},be.prototype.intersects=function(X,le){if(!(X instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ae){return X.set.some(function(Ce){return Ce.every(function(Ue){return Ae.intersects(Ue,le)})})})})},e.toComparators=function(X,le){return new be(X,le).set.map(function(ge){return ge.map(function(Ae){return Ae.value}).join(" ").trim().split(" ")})},be.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new oe(X,this.loose));for(var le=0;le<this.set.length;le++)if(Te(this.set[le],X))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(X,le,ge){var Ae=null,Ce=null;try{var Ue=new be(le,ge)}catch{return null}return X.forEach(function(Oe){Ue.test(Oe)&&(Ae&&Ce.compare(Oe)!==-1||(Ce=new oe(Ae=Oe,ge)))}),Ae},e.minSatisfying=function(X,le,ge){var Ae=null,Ce=null;try{var Ue=new be(le,ge)}catch{return null}return X.forEach(function(Oe){Ue.test(Oe)&&(Ae&&Ce.compare(Oe)!==1||(Ce=new oe(Ae=Oe,ge)))}),Ae},e.validRange=function(X,le){try{return new be(X,le).range||"*"}catch{return null}},e.ltr=function(X,le,ge){return we(X,le,"<",ge)},e.gtr=function(X,le,ge){return we(X,le,">",ge)},e.outside=we,e.prerelease=function(X,le){var ge=ie(X,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(X,le,ge){return X=new be(X,ge),le=new be(le,ge),X.intersects(le)},e.coerce=function(X){if(X instanceof oe)return X;if(typeof X!="string")return null;var le=X.match(P[I]);return le==null?null:ie((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,S(1))},function(K,e){var S,D,s=K.exports={};function L(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P($){if(S===setTimeout)return setTimeout($,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout($,0);try{return S($,0)}catch{try{return S.call(null,$,0)}catch{return S.call(this,$,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch{S=L}try{D=typeof clearTimeout=="function"?clearTimeout:C}catch{D=C}})();var f,a=[],m=!1,b=-1;function p(){m&&f&&(m=!1,f.length?a=f.concat(a):b=-1,a.length&&d())}function d(){if(!m){var $=P(p);m=!0;for(var g=a.length;g;){for(f=a,a=[];++b<g;)f&&f[b].run();b=-1,g=a.length}f=null,m=!1,function(h){if(D===clearTimeout)return clearTimeout(h);if((D===C||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(h);try{D(h)}catch{try{return D.call(null,h)}catch{return D.call(this,h)}}}($)}}function y($,g){this.fun=$,this.array=g}function w(){}s.nextTick=function($){var g=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)g[h-1]=arguments[h];a.push(new y($,g)),a.length!==1||m||P(d)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function($){return[]},s.binding=function($){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function($){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ee[139],te([0,1]),function(K,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class D{constructor(P,f,a){this.level=P,this.key=f,this.value=a,this.forward=[]}}const s=void 0;class L{constructor(P,f=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new D(this.c,s,s)}get size(){return this.f}clear(){this.e=new D(this.c,s,s)}has(P){return!!L.g(this,P,this.comparator)}get(P){return L.g(this,P,this.comparator)?.value}set(P,f){return L.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=L.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let a=this.e.forward[0];for(;a;)P.call(f,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,a){let m=P.e;for(let b=P.d-1;b>=0;b--)for(;m.forward[b]&&a(m.forward[b].key,f)<0;)m=m.forward[b];if(m=m.forward[0],m&&a(m.key,f)===0)return m}static h(P,f,a,m){const b=[];let p=P.e;for(let d=P.d-1;d>=0;d--){for(;p.forward[d]&&m(p.forward[d].key,f)<0;)p=p.forward[d];b[d]=p}if(p=p.forward[0],p&&m(p.key,f)===0)return p.value=a,!1;{const d=L.j(P);if(d>P.d){for(let y=P.d;y<d;y++)b[y]=P.e;P.d=d}p=new D(d,f,a);for(let y=0;y<d;y++)p.forward[y]=b[y].forward[y],b[y].forward[y]=p;return!0}}static j(P,f=.5){let a=1;for(;Math.random()<f&&a<P.c;)a+=1;return a}static k(P,f,a){const m=[];let b=P.e;for(let p=P.d-1;p>=0;p--){for(;b.forward[p]&&a(b.forward[p].key,f)<0;)b=b.forward[p];m[p]=b}if(b=b.forward[0],!b||a(b.key,f)!==0)return!1;for(let p=0;p<P.d&&m[p].forward[p]===b;p++)m[p].forward[p]=b.forward[p];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$qr=L}),define(ee[70],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(L){return new D(L)}constructor(L){this.c=S&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Hd=D}),define(ee[3],te([0,1,14,82,2,101,70]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.Event=void 0;const P=!1,f=!1;var a;(function(A){A.None=()=>s.$Qc.None;function E(ue){if(f){const{onDidAddListener:fe}=ue,ye=y.create();let be=0;ue.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),fe?.()}}}function I(ue,fe){return J(ue,()=>{},0,void 0,!0,void 0,fe)}A.defer=I;function M(ue){return(fe,ye=null,be)=>{let pe=!1,Re;return Re=ue(Te=>{if(!pe)return Re?Re.dispose():pe=!0,fe.call(ye,Te)},null,be),pe&&Re.dispose(),Re}}A.once=M;function U(ue,fe,ye){return re((be,pe=null,Re)=>ue(Te=>be.call(pe,fe(Te)),null,Re),ye)}A.map=U;function B(ue,fe,ye){return re((be,pe=null,Re)=>ue(Te=>{fe(Te),be.call(pe,Te)},null,Re),ye)}A.forEach=B;function se(ue,fe,ye){return re((be,pe=null,Re)=>ue(Te=>fe(Te)&&be.call(pe,Te),null,Re),ye)}A.filter=se;function x(ue){return ue}A.signal=x;function ae(...ue){return(fe,ye=null,be)=>{const pe=(0,s.$Nc)(...ue.map(Re=>Re(Te=>fe.call(ye,Te))));return Q(pe,be)}}A.any=ae;function ne(ue,fe,ye,be){let pe=ye;return U(ue,Re=>(pe=fe(pe,Re),pe),be)}A.reduce=ne;function re(ue,fe){let ye;const be={onWillAddFirstListener(){ye=ue(pe.fire,pe)},onDidRemoveLastListener(){ye?.dispose()}};fe||E(be);const pe=new c(be);return fe?.add(pe),pe.event}function Q(ue,fe){return fe instanceof Array?fe.push(ue):fe&&fe.add(ue),ue}function J(ue,fe,ye=100,be=!1,pe=!1,Re,Te){let $e,we,X,le=0,ge;const Ae={leakWarningThreshold:Re,onWillAddFirstListener(){$e=ue(Ue=>{le++,we=fe(we,Ue),be&&!X&&(Ce.fire(we),we=void 0),ge=()=>{const Oe=we;we=void 0,X=void 0,(!be||le>1)&&Ce.fire(Oe),le=0},typeof ye=="number"?(clearTimeout(X),X=setTimeout(ge,ye)):X===void 0&&(X=0,queueMicrotask(ge))})},onWillRemoveListener(){pe&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,$e.dispose()}};Te||E(Ae);const Ce=new c(Ae);return Te?.add(Ce),Ce.event}A.debounce=J;function V(ue,fe=0,ye){return A.debounce(ue,(be,pe)=>be?(be.push(pe),be):[pe],fe,void 0,!0,void 0,ye)}A.accumulate=V;function F(ue,fe=(be,pe)=>be===pe,ye){let be=!0,pe;return se(ue,Re=>{const Te=be||!fe(Re,pe);return be=!1,pe=Re,Te},ye)}A.latch=F;function N(ue,fe,ye){return[A.filter(ue,fe,ye),A.filter(ue,be=>!fe(be),ye)]}A.split=N;function H(ue,fe=!1,ye=[],be){let pe=ye.slice(),Re=ue(we=>{pe?pe.push(we):$e.fire(we)});be&&be.add(Re);const Te=()=>{pe?.forEach(we=>$e.fire(we)),pe=null},$e=new c({onWillAddFirstListener(){Re||(Re=ue(we=>$e.fire(we)),be&&be.add(Re))},onDidAddFirstListener(){pe&&(fe?setTimeout(Te):Te())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return be&&be.add($e),$e.event}A.buffer=H;function Y(ue,fe){return(be,pe,Re)=>{const Te=fe(new oe);return ue(function($e){const we=Te.evaluate($e);we!==ie&&be.call(pe,we)},void 0,Re)}}A.chain=Y;const ie=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ye=>(fe(ye),ye)),this}filter(fe){return this.f.push(ye=>fe(ye)?ye:ie),this}reduce(fe,ye){let be=ye;return this.f.push(pe=>(be=fe(be,pe),be)),this}latch(fe=(ye,be)=>ye===be){let ye=!0,be;return this.f.push(pe=>{const Re=ye||!fe(pe,be);return ye=!1,be=pe,Re?pe:ie}),this}evaluate(fe){for(const ye of this.f)if(fe=ye(fe),fe===ie)break;return fe}}function T(ue,fe,ye=be=>be){const be=(...$e)=>Te.fire(ye(...$e)),pe=()=>ue.on(fe,be),Re=()=>ue.removeListener(fe,be),Te=new c({onWillAddFirstListener:pe,onDidRemoveLastListener:Re});return Te.event}A.fromNodeEventEmitter=T;function O(ue,fe,ye=be=>be){const be=(...$e)=>Te.fire(ye(...$e)),pe=()=>ue.addEventListener(fe,be),Re=()=>ue.removeEventListener(fe,be),Te=new c({onWillAddFirstListener:pe,onDidRemoveLastListener:Re});return Te.event}A.fromDOMEventEmitter=O;function j(ue){return new Promise(fe=>M(ue)(fe))}A.toPromise=j;function q(ue){const fe=new c;return ue.then(ye=>{fe.fire(ye)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}A.fromPromise=q;function W(ue,fe){return fe(void 0),ue(ye=>fe(ye))}A.runAndSubscribe=W;function z(ue,fe){let ye=null;function be(Re){ye?.dispose(),ye=new s.$Pc,fe(Re,ye)}be(void 0);const pe=ue(Re=>be(Re));return(0,s.$Oc)(()=>{pe.dispose(),ye?.dispose()})}A.runAndSubscribeWithStore=z;class G{constructor(fe,ye){this._observable=fe,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ye||E(be),this.emitter=new c(be),ye&&ye.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ye){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ce(ue,fe){return new G(ue,fe).emitter.event}A.fromObservable=ce;function de(ue){return fe=>{let ye=0,be=!1;const pe={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ue.reportChanges(),be&&(be=!1,fe()))},handlePossibleChange(){},handleChange(){be=!0}};return ue.addObserver(pe),ue.reportChanges(),{dispose(){ue.removeObserver(pe)}}}}A.fromObservableLight=de})(a||(e.Event=a={}));class m{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${m.f++}`,m.all.add(this)}start(E){this.g=new C.$Hd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Jd=m;let b=-1;function p(A){const E=b;return b=A,{dispose(){b=E}}}e.$Kd=p;class d{constructor(E,I=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=I,this.g=0}dispose(){this.f?.clear()}check(E,I){const M=this.threshold;if(M<=0||I<M)return;this.f||(this.f=new Map);const U=this.f.get(E.value)||0;if(this.f.set(E.value,U+1),this.g-=1,this.g<=0){this.g=M*.5;let B,se=0;for(const[x,ae]of this.f)(!B||se<ae)&&(B=x,se=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${se}):`),console.warn(B)}return()=>{const B=this.f.get(E.value)||0;this.f.set(E.value,B-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class ${constructor(E){this.value=E,this.id=w++}}const g=2,h=(A,E)=>{if(A instanceof $)E(A);else for(let I=0;I<A.length;I++){const M=A[I];M&&E(M)}};class c{constructor(E){this.x=0,this.f=E,this.g=b>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const E=this.t;queueMicrotask(()=>{h(E,I=>I.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,I,M)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Qc.None;if(this.m)return s.$Qc.None;I&&(E=E.bind(I));const U=new $(E);let B,se;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(U.stack=y.create(),B=this.g.check(U.stack,this.x+1)),P&&(U.stack=se??y.create()),this.t?this.t instanceof $?(this.u??=new u,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.x++;const x=(0,s.$Oc)(()=>{B?.(),this.y(U)});return M instanceof s.$Pc?M.add(x):Array.isArray(M)&&M.push(x),x},this.q}y(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const I=this.t,M=I.indexOf(E);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,I[M]=void 0;const U=this.u.current===this;if(this.x*g<=I.length){let B=0;for(let se=0;se<I.length;se++)I[se]?I[B++]=I[se]:U&&(this.u.end--,B<this.u.i&&this.u.i--);I.length=B}}z(E,I){if(!E)return;const M=this.f?.onListenerError||S.$Y;if(!M){E.value(I);return}try{E.value(I)}catch(U){M(U)}}A(E){const I=E.current.t;for(;E.i<E.end;)this.z(I[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof $)this.z(this.t,E);else{const I=this.u;I.enqueue(this,E,this.t.length),this.A(I)}this.j?.stop()}hasListeners(){return this.x>0}}e.$Ld=c;const k=()=>new u;e.$Md=k;class u{constructor(){this.i=-1,this.end=0}enqueue(E,I,M){this.i=0,this.end=M,this.current=E,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(E,I,M){if(this.t)for(this.h||(this.h=new L.$Zc),h(this.t,U=>this.h.push([U.value,E]));this.h.size>0&&!I.isCancellationRequested;){const[U,B]=this.h.shift(),se=[],x={...B,token:I,waitUntil:ae=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");M&&(ae=M(ae,U)),se.push(ae)}};try{U(x)}catch(ae){(0,S.$Y)(ae);continue}Object.freeze(se),await Promise.allSettled(se).then(ae=>{for(const ne of ae)ne.status==="rejected"&&(0,S.$Y)(ne.reason)})}}}e.$Nd=t;class l extends c{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new L.$Zc,this.w=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.w(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.x&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Od=l;class r extends l{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Pd=r;class i extends c{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Qd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const I={event:E,listener:null};this.h.push(I),this.g&&this.m(I);const M=()=>{this.g&&this.o(I);const U=this.h.indexOf(I);this.h.splice(U,1)};return(0,s.$Oc)((0,D.$bb)(M))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(I=>this.f.fire(I))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$Rd=n;class o{constructor(E,I,M,U){this.f=new s.$Pc;const B=this.f.add(new n),se=this.f.add(new s.$Yc);function x(ae){se.set(ae,B.add(U(ae)))}for(const ae of E)x(ae);this.f.add(I(ae=>{x(ae)})),this.f.add(M(ae=>{se.deleteAndDispose(ae)})),this.event=B.event}dispose(){this.f.dispose()}}e.$Sd=o;class v{constructor(){this.f=[]}wrapEvent(E){return(I,M,U)=>E(B=>{const se=this.f[this.f.length-1];se?se.push(()=>I.call(M,B)):I.call(M,B)},void 0,U)}bufferEvents(E){const I=[];this.f.push(I);const M=E();return this.f.pop(),I.forEach(U=>U()),M}}e.$Td=v;class R{constructor(){this.f=!1,this.g=a.None,this.h=s.$Qc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Ud=R}),define(ee[22],te([0,1,3]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.CancellationToken=void 0;const D=Object.freeze(function(P,f){const a=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(a)}}});var s;(function(P){function f(a){return a===P.None||a===P.Cancelled||a instanceof L?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(s||(e.CancellationToken=s={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new S.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=s.None}}e.$Vd=C}),define(ee[140],te([0,1,22]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=void 0;class D{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$Vd,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$ue=D;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.$ve=s;class L{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.$we=L}),define(ee[62],te([0,1,14,2]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function s(k){const u=k;return u?typeof u.read=="function":!1}e.$Wd=s;function L(k){const u=k;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$Xd=L;function C(k){const u=k;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$Yd=C;function P(k,u){return new f(k,u)}e.$Zd=P;class f{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,S.$Y)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let l;switch(u){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(k,u){const t=[];let l;for(;(l=k.read())!==null;)t.push(l);return u(t)}e.$1d=a;function m(k,u,t){const l=[];let r;for(;(r=k.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?u(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return k.read()}}}e.$2d=m;function b(k,u){return new Promise((t,l)=>{const r=[];p(k,{onData:i=>{u&&r.push(i)},onError:i=>{u?l(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}e.$3d=b;function p(k,u,t){k.on("error",l=>{t?.isCancellationRequested||u.onError(l)}),k.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),k.on("data",l=>{t?.isCancellationRequested||u.onData(l)})}e.$4d=p;function d(k,u){return new Promise((t,l)=>{const r=new D.$Pc,i=[],n=R=>{if(i.push(R),i.length>u)return r.dispose(),k.pause(),t({stream:k,buffer:i,ended:!1})},o=R=>(r.dispose(),l(R)),v=()=>(r.dispose(),t({stream:k,buffer:i,ended:!0}));r.add((0,D.$Oc)(()=>k.removeListener("error",o))),k.on("error",o),r.add((0,D.$Oc)(()=>k.removeListener("end",v))),k.on("end",v),r.add((0,D.$Oc)(()=>k.removeListener("data",n))),k.on("data",n)})}e.$5d=d;function y(k,u){const t=P(u);return t.end(k),t}e.$6d=y;function w(){const k=P(()=>{throw new Error("not supported")});return k.end(),k}e.$7d=w;function $(k){let u=!1;return{read:()=>u?null:(u=!0,k)}}e.$8d=$;function g(k,u,t){const l=P(t);return p(k,{onData:r=>l.write(u.data(r)),onError:r=>l.error(u.error?u.error(r):r),onEnd:()=>l.end()}),l}e.$9d=g;function h(k,u,t){let l=!1;return{read:()=>{const r=u.read();return l?r:(l=!0,r!==null?t([k,r]):k)}}}e.$0d=h;function c(k,u,t){let l=!1;const r=P(t);return p(u,{onData:i=>l?r.write(i):(l=!0,r.write(t([k,i]))),onError:i=>r.error(i),onEnd:()=>{l||(l=!0,r.write(k)),r.end()}}),r}e.$$d=c}),define(ee[17],te([0,1,83,62]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const s=typeof Buffer<"u",L=new S.$T(()=>new Uint8Array(256));let C,P;class f{static alloc(I){return s?new f(Buffer.allocUnsafe(I)):new f(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new f(I)}static fromString(I,M){return!(M?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(I)):(C||(C=new TextEncoder),new f(C.encode(I)))}static fromByteArray(I){const M=f.alloc(I.length);for(let U=0,B=I.length;U<B;U++)M.buffer[U]=I[U];return M}static concat(I,M){if(typeof M>"u"){M=0;for(let se=0,x=I.length;se<x;se++)M+=I[se].byteLength}const U=f.alloc(M);let B=0;for(let se=0,x=I.length;se<x;se++){const ae=I[se];U.set(ae,B),B+=ae.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=f.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,M){return new f(this.buffer.subarray(I,M))}set(I,M){if(I instanceof f)this.buffer.set(I.buffer,M);else if(I instanceof Uint8Array)this.buffer.set(I,M);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),M);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return p(this.buffer,I)}writeUInt32BE(I,M){d(this.buffer,I,M)}readUInt32LE(I){return y(this.buffer,I)}writeUInt32LE(I,M){w(this.buffer,I,M)}readUInt8(I){return $(this.buffer,I)}writeUInt8(I,M){g(this.buffer,I,M)}indexOf(I,M=0){return a(this.buffer,I instanceof f?I.buffer:I,M)}}e.$_d=f;function a(E,I,M=0){const U=I.byteLength,B=E.byteLength;if(U===0)return 0;if(U===1)return E.indexOf(I[0]);if(U>B-M)return-1;const se=L.value;se.fill(I.length);for(let re=0;re<I.length;re++)se[I[re]]=I.length-re-1;let x=M+I.length-1,ae=x,ne=-1;for(;x<B;)if(E[x]===I[ae]){if(ae===0){ne=x;break}x--,ae--}else x+=Math.max(I.length-ae,se[E[x]]),ae=I.length-1;return ne}e.$ae=a;function m(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0}e.$be=m;function b(E,I,M){E[M+0]=I&255,I=I>>>8,E[M+1]=I&255}e.$ce=b;function p(E,I){return E[I]*2**24+E[I+1]*2**16+E[I+2]*2**8+E[I+3]}e.$de=p;function d(E,I,M){E[M+3]=I,I=I>>>8,E[M+2]=I,I=I>>>8,E[M+1]=I,I=I>>>8,E[M]=I}e.$ee=d;function y(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0|E[I+2]<<16>>>0|E[I+3]<<24>>>0}e.$fe=y;function w(E,I,M){E[M+0]=I&255,I=I>>>8,E[M+1]=I&255,I=I>>>8,E[M+2]=I&255,I=I>>>8,E[M+3]=I&255}e.$ge=w;function $(E,I){return E[I]}e.$he=$;function g(E,I,M){E[M]=I}e.$ie=g;function h(E){return D.$1d(E,I=>f.concat(I))}e.$je=h;function c(E){return D.$8d(E)}e.$ke=c;function k(E){return D.$3d(E,I=>f.concat(I))}e.$le=k;async function u(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await k(E.stream)])}e.$me=u;function t(E){return D.$6d(E,I=>f.concat(I))}e.$ne=t;function l(E){return D.$9d(E,{data:I=>typeof I=="string"?f.fromString(I):f.wrap(I)},I=>f.concat(I))}e.$oe=l;function r(E){return D.$Zd(I=>f.concat(I),E)}e.$pe=r;function i(E,I){return D.$0d(E,I,M=>f.concat(M))}e.$qe=i;function n(E,I){return D.$$d(E,I,M=>f.concat(M))}e.$re=n;function o(E){let I=0,M=0,U=0;const B=new Uint8Array(Math.floor(E.length/4*3)),se=ae=>{switch(M){case 3:B[U++]=I|ae,M=0;break;case 2:B[U++]=I|ae>>>2,I=ae<<6,M=3;break;case 1:B[U++]=I|ae>>>4,I=ae<<4,M=2;break;default:I=ae<<2,M=1}};for(let ae=0;ae<E.length;ae++){const ne=E.charCodeAt(ae);if(ne>=65&&ne<=90)se(ne-65);else if(ne>=97&&ne<=122)se(ne-97+26);else if(ne>=48&&ne<=57)se(ne-48+52);else if(ne===43||ne===45)se(62);else if(ne===47||ne===95)se(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ae]}`)}}const x=U;for(;M>0;)se(0);return f.wrap(B).slice(0,x)}e.$se=o;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:E},I=!0,M=!1){const U=M?R:v;let B="";const se=E.byteLength%3;let x=0;for(;x<E.byteLength-se;x+=3){const ae=E[x+0],ne=E[x+1],re=E[x+2];B+=U[ae>>>2],B+=U[(ae<<4|ne>>>4)&63],B+=U[(ne<<2|re>>>6)&63],B+=U[re&63]}if(se===1){const ae=E[x+0];B+=U[ae>>>2],B+=U[ae<<4&63],I&&(B+="==")}else if(se===2){const ae=E[x+0],ne=E[x+1];B+=U[ae>>>2],B+=U[(ae<<4|ne>>>4)&63],B+=U[ne<<2&63],I&&(B+="=")}return B}e.$te=A}),define(ee[27],te([0,1,140,83]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vf=e.$uf=e.$tf=e.$sf=e.GraphemeBreakType=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=void 0;function s(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.$ze=s;const L=/{(\d+)}/g;function C(Z,...he){return he.length===0?Z:Z.replace(L,function(me,ve){const De=parseInt(ve,10);return isNaN(De)||De<0||De>=he.length?me:he[De]})}e.$Ae=C;const P=/{([^}]+)}/g;function f(Z,he){return Z.replace(P,(me,ve)=>he[ve]??me)}e.$Be=f;function a(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$Ce=a;function m(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$De=m;function b(Z,he){let me=0;const ve=he.charCodeAt(0);for(let De=Z.length-1;De>=0;De--)Z.charCodeAt(De)===ve&&me++;return me}e.$Ee=b;function p(Z,he,me="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${me}`}e.$Fe=p;function d(Z,he=" "){const me=y(Z,he);return w(me,he)}e.$Ge=d;function y(Z,he){if(!Z||!he)return Z;const me=he.length;if(me===0||Z.length===0)return Z;let ve=0;for(;Z.indexOf(he,ve)===ve;)ve=ve+me;return Z.substring(ve)}e.$He=y;function w(Z,he){if(!Z||!he)return Z;const me=he.length,ve=Z.length;if(me===0||ve===0)return Z;let De=ve,Fe=-1;for(;Fe=Z.lastIndexOf(he,De-1),!(Fe===-1||Fe+me!==De);){if(Fe===0)return"";De=Fe}return Z.substring(0,De)}e.$Ie=w;function $(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Je=$;function g(Z){return Z.replace(/\*/g,"")}e.$Ke=g;function h(Z,he,me={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=m(Z)),me.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ve="";return me.global&&(ve+="g"),me.matchCase||(ve+="i"),me.multiline&&(ve+="m"),me.unicode&&(ve+="u"),new RegExp(Z,ve)}e.$Le=h;function c(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.$Me=c;function k(Z){return Z.split(/\r\n|\r|\n/)}e.$Ne=k;function u(Z){for(let he=0,me=Z.length;he<me;he++){const ve=Z.charCodeAt(he);if(ve!==32&&ve!==9)return he}return-1}e.$Oe=u;function t(Z,he=0,me=Z.length){for(let ve=he;ve<me;ve++){const De=Z.charCodeAt(ve);if(De!==32&&De!==9)return Z.substring(he,ve)}return Z.substring(he,me)}e.$Pe=t;function l(Z,he=Z.length-1){for(let me=he;me>=0;me--){const ve=Z.charCodeAt(me);if(ve!==32&&ve!==9)return me}return-1}e.$Qe=l;function r(Z,he,me){const ve=[];let De=0;for(const Fe of Z.matchAll(he)){if(ve.push(Z.slice(De,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");De=Fe.index+Fe[0].length,ve.push(me(Fe[0],...Fe.slice(1),Fe.index,Z,Fe.groups))}return ve.push(Z.slice(De)),Promise.all(ve).then(Fe=>Fe.join(""))}e.$Re=r;function i(Z,he){return Z<he?-1:Z>he?1:0}e.$Se=i;function n(Z,he,me=0,ve=Z.length,De=0,Fe=he.length){for(;me<ve&&De<Fe;me++,De++){const ze=Z.charCodeAt(me),He=he.charCodeAt(De);if(ze<He)return-1;if(ze>He)return 1}const Me=ve-me,Ne=Fe-De;return Me<Ne?-1:Me>Ne?1:0}e.$Te=n;function o(Z,he){return v(Z,he,0,Z.length,0,he.length)}e.$Ue=o;function v(Z,he,me=0,ve=Z.length,De=0,Fe=he.length){for(;me<ve&&De<Fe;me++,De++){let ze=Z.charCodeAt(me),He=he.charCodeAt(De);if(ze===He)continue;if(ze>=128||He>=128)return n(Z.toLowerCase(),he.toLowerCase(),me,ve,De,Fe);A(ze)&&(ze-=32),A(He)&&(He-=32);const Ge=ze-He;if(Ge!==0)return Ge}const Me=ve-me,Ne=Fe-De;return Me<Ne?-1:Me>Ne?1:0}e.$Ve=v;function R(Z){return Z>=48&&Z<=57}e.$We=R;function A(Z){return Z>=97&&Z<=122}e.$Xe=A;function E(Z){return Z>=65&&Z<=90}e.$Ye=E;function I(Z,he){return Z.length===he.length&&v(Z,he)===0}e.$Ze=I;function M(Z,he){const me=he.length;return he.length>Z.length?!1:v(Z,he,0,me)===0}e.$1e=M;function U(Z,he){const me=Math.min(Z.length,he.length);let ve;for(ve=0;ve<me;ve++)if(Z.charCodeAt(ve)!==he.charCodeAt(ve))return ve;return me}e.$2e=U;function B(Z,he){const me=Math.min(Z.length,he.length);let ve;const De=Z.length-1,Fe=he.length-1;for(ve=0;ve<me;ve++)if(Z.charCodeAt(De-ve)!==he.charCodeAt(Fe-ve))return ve;return me}e.$3e=B;function se(Z){return 55296<=Z&&Z<=56319}e.$4e=se;function x(Z){return 56320<=Z&&Z<=57343}e.$5e=x;function ae(Z,he){return(Z-55296<<10)+(he-56320)+65536}e.$6e=ae;function ne(Z,he,me){const ve=Z.charCodeAt(me);if(se(ve)&&me+1<he){const De=Z.charCodeAt(me+1);if(x(De))return ae(ve,De)}return ve}e.$7e=ne;function re(Z,he){const me=Z.charCodeAt(he-1);if(x(me)&&he>1){const ve=Z.charCodeAt(he-2);if(se(ve))return ae(ve,me)}return me}class Q{get offset(){return this.e}constructor(he,me=0){this.c=he,this.d=he.length,this.e=me}setOffset(he){this.e=he}prevCodePoint(){const he=re(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=ne(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$8e=Q;class J{get offset(){return this.c.offset}constructor(he,me=0){this.c=new Q(he,me)}nextGraphemeLength(){const he=le.getInstance(),me=this.c,ve=me.offset;let De=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Fe=me.offset,Me=he.getGraphemeBreakType(me.nextCodePoint());if(we(De,Me)){me.setOffset(Fe);break}De=Me}return me.offset-ve}prevGraphemeLength(){const he=le.getInstance(),me=this.c,ve=me.offset;let De=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Fe=me.offset,Me=he.getGraphemeBreakType(me.prevCodePoint());if(we(Me,De)){me.setOffset(Fe);break}De=Me}return ve-me.offset}eol(){return this.c.eol()}}e.$9e=J;function V(Z,he){return new J(Z,he).nextGraphemeLength()}e.$0e=V;function F(Z,he){return new J(Z,he).prevGraphemeLength()}e.$$e=F;function N(Z,he){he>0&&x(Z.charCodeAt(he))&&he--;const me=he+V(Z,he);return[me-F(Z,me),me]}e.$_e=N;function H(Z){const he=new J(Z);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.$af=H;let Y;function ie(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Z){return Y||(Y=ie()),Y.test(Z)}e.$bf=oe;const T=/^[\t\n\r\x20-\x7E]*$/;function O(Z){return T.test(Z)}e.$cf=O,e.$df=/[\u2028\u2029]/;function j(Z){return e.$df.test(Z)}e.$ef=j;function q(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.$ff=q;function W(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.$gf=W;function z(Z,he){if(Z.length<he)return Z;const me=/\b/g;let ve=0;for(;me.test(Z)&&!(Z.length-me.lastIndex<he);)ve=me.lastIndex,me.lastIndex+=1;return Z.substring(ve).replace(/^\s/,"")}e.$hf=z;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function de(Z){return Z&&(Z=Z.replace(G,"").replace(ce,"")),Z}e.$if=de,e.$jf=String.fromCharCode(65279);function ue(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.$kf=ue;function fe(Z){return ue(Z)?Z.substr(1):Z}e.$lf=fe;function ye(Z,he){if(!Z||!he||Z.length<he.length)return!1;const me=he.length,ve=Z.toLowerCase();let De=0,Fe=-1;for(;De<me;){const Me=ve.indexOf(he[De],Fe+1);if(Me<0)return!1;Fe=Me,De++}return!0}e.$mf=ye;function be(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.$nf=be;function pe(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.$of=pe;function Re(Z,he=1){if(he===0)return"";let me=-1;do me=Z.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?Z:(Z[me-1]==="\r"&&me--,Z.substr(0,me))}e.$pf=Re;function Te(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}e.$qf=Te;function $e(Z){return le.getInstance().getGraphemeBreakType(Z)}e.$rf=$e;function we(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var X;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(X||(e.GraphemeBreakType=X={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this.d,ve=me.length/3;let De=1;for(;De<=ve;)if(he<me[3*De])De=2*De;else if(he>me[3*De+1])De=2*De+1;else return me[3*De+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ae(Z,he){if(Z===0)return 0;const me=Ce(Z,he);if(me!==void 0)return me;const ve=new Q(he,Z);return ve.prevCodePoint(),ve.offset}e.$sf=Ae;function Ce(Z,he){const me=new Q(he,Z);let ve=me.prevCodePoint();for(;Ue(ve)||ve===65039||ve===8419;){if(me.offset===0)return;ve=me.prevCodePoint()}if(!W(ve))return;let De=me.offset;return De>0&&me.prevCodePoint()===8205&&(De=me.offset),De}function Ue(Z){return 127995<=Z&&Z<=127999}var Oe;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$tf="\xA0";class Be{static{this.c=new D.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$ve(he=>{function me(Ge){const tt=new Map;for(let Ze=0;Ze<Ge.length;Ze+=2)tt.set(Ge[Ze],Ge[Ze+1]);return tt}function ve(Ge,tt){const Ze=new Map(Ge);for(const[it,nt]of tt)Ze.set(it,nt);return Ze}function De(Ge,tt){if(!Ge)return tt;const Ze=new Map;for(const[it,nt]of Ge)tt.has(it)&&Ze.set(it,nt);return Ze}const Fe=this.c.value;let Me=he.filter(Ge=>!Ge.startsWith("_")&&Ge in Fe);Me.length===0&&(Me=["_default"]);let Ne;for(const Ge of Me){const tt=me(Fe[Ge]);Ne=De(Ne,tt)}const ze=me(Fe._common),He=ve(ze,Ne);return new Be(He)})}static getInstance(he){return Be.d.get(Array.from(he))}static{this.e=new D.$T(()=>Object.keys(Be.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Be.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$uf=Be;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(he){return We.e().has(he)}static get codePoints(){return We.e()}}e.$vf=We}),define(ee[55],te([0,1,27]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;function D(g){return s(g,0)}e.$Ai=D;function s(g,h){switch(typeof g){case"object":return g===null?L(349,h):Array.isArray(g)?f(g,h):a(g,h);case"string":return P(g,h);case"boolean":return C(g,h);case"number":return L(g,h);case"undefined":return L(937,h);default:return L(617,h)}}e.$Bi=s;function L(g,h){return(h<<5)-h+g|0}e.$Ci=L;function C(g,h){return L(g?433:863,h)}function P(g,h){h=L(149417,h);for(let c=0,k=g.length;c<k;c++)h=L(g.charCodeAt(c),h);return h}e.$Di=P;function f(g,h){return h=L(104579,h),g.reduce((c,k)=>s(k,c),h)}function a(g,h){return h=L(181387,h),Object.keys(g).sort().reduce((c,k)=>(c=P(k,c),s(g[k],c)),h)}class m{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Ei=m;var b;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function p(g,h,c=32){const k=c-h,u=~((1<<k)-1);return(g<<h|(u&g)>>>k)>>>0}function d(g,h=0,c=g.byteLength,k=0){for(let u=0;u<c;u++)g[h+u]=k}function y(g,h,c="0"){for(;g.length<h;)g=c+g;return g}function w(g,h=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(c=>c.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),h/4)}e.$Fi=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const c=h.length;if(c===0)return;const k=this.p;let u=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=h.charCodeAt(0),r=0);;){let i=l;if(S.$4e(l))if(r+1<c){const n=h.charCodeAt(r+1);S.$5e(n)?(r++,i=S.$6e(l,n)):i=65533}else{t=l;break}else S.$5e(l)&&(i=65533);if(u=this.w(k,u,i),r++,r<c)l=h.charCodeAt(r);else break}this.r=u,this.u=t}w(h,c,k){return k<128?h[c++]=k:k<2048?(h[c++]=192|(k&1984)>>>6,h[c++]=128|(k&63)>>>0):k<65536?(h[c++]=224|(k&61440)>>>12,h[c++]=128|(k&4032)>>>6,h[c++]=128|(k&63)>>>0):(h[c++]=240|(k&1835008)>>>18,h[c++]=128|(k&258048)>>>12,h[c++]=128|(k&4032)>>>6,h[c++]=128|(k&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=$.g,c=this.q;for(let v=0;v<64;v+=4)h.setUint32(v,c.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)h.setUint32(v,p(h.getUint32(v-12,!1)^h.getUint32(v-32,!1)^h.getUint32(v-56,!1)^h.getUint32(v-64,!1),1),!1);let k=this.h,u=this.l,t=this.m,l=this.n,r=this.o,i,n,o;for(let v=0;v<80;v++)v<20?(i=u&t|~u&l,n=1518500249):v<40?(i=u^t^l,n=1859775393):v<60?(i=u&t|u&l|t&l,n=2400959708):(i=u^t^l,n=3395469782),o=p(k,5)+i+r+n+h.getUint32(v*4,!1)&4294967295,r=l,l=t,t=p(u,30),u=k,k=o;this.h=this.h+k&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.$Gi=$}),define(ee[71],te([0,1,27]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(D||(D={})),function(s){const L="error",C="warning",P="warn",f="info",a="ignore";function m(p){return p?S.$Ze(L,p)?s.Error:S.$Ze(C,p)||S.$Ze(P,p)?s.Warning:S.$Ze(f,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=m;function b(p){switch(p){case s.Error:return L;case s.Warning:return C;case s.Info:return f;default:return a}}s.toString=b}(D||(D={})),e.default=D}),define(ee[141],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(ee[56],te([0,1,23,27]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;class s{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const y=d.charCodeAt(0),w=this.b.charCodeAt(this.c);return y-w}value(){return this.b[this.c]}}e.$Oh=s;class L{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,D.$Te)(d,this.b,0,d.length,this.c,this.d):(0,D.$Ve)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ph=L;class C{constructor(d=!0,y=!0){this.f=d,this.g=y}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let y=d.length-1;y>=0;y--,this.c--){const w=this.b.charCodeAt(y);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,D.$Te)(d,this.b,0,d.length,this.d,this.e):(0,D.$Ve)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Qh=C;var P;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(d,y){this.f=d,this.g=y,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,D.$Ue)(d,this.c.scheme);if(this.d[this.e]===2)return(0,D.$Ue)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,D.$Se)(d,this.c.query);if(this.d[this.e]===5)return(0,D.$Se)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Rh=f;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(m||(m={}));class b{static forUris(d=()=>!1,y=()=>!1){return new b(new f(d,y))}static forPaths(d=!1){return new b(new C(void 0,!d))}static forStrings(){return new b(new s)}static forConfigKeys(){return new b(new L)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,y){if(y){const w=y.slice(0);(0,S.$Vb)(w);for(const $ of w)this.set($,d)}else{const w=d.slice(0);(0,S.$Vb)(w);for(const $ of w)this.set($[0],$[1])}}set(d,y){const w=this.b.reset(d);let $;this.c||(this.c=new a,this.c.segment=w.value());const g=[];for($=this.c;;){const c=w.cmp($.segment);if(c>0)$.left||($.left=new a,$.left.segment=w.value()),g.push([-1,$]),$=$.left;else if(c<0)$.right||($.right=new a,$.right.segment=w.value()),g.push([1,$]),$=$.right;else if(w.hasNext())w.next(),$.mid||($.mid=new a,$.mid.segment=w.value()),g.push([0,$]),$=$.mid;else break}const h=$.value;$.value=y,$.key=d;for(let c=g.length-1;c>=0;c--){const k=g[c][1];k.updateHeight();const u=k.balanceFactor();if(u<-1||u>1){const t=g[c][0],l=g[c+1][0];if(t===1&&l===1)g[c][1]=k.rotateLeft();else if(t===-1&&l===-1)g[c][1]=k.rotateRight();else if(t===1&&l===-1)k.right=g[c+1][1]=g[c+1][1].rotateRight(),g[c][1]=k.rotateLeft();else if(t===-1&&l===1)k.left=g[c+1][1]=g[c+1][1].rotateLeft(),g[c][1]=k.rotateRight();else throw new Error;if(c>0)switch(g[c-1][0]){case-1:g[c-1][1].left=g[c][1];break;case 1:g[c-1][1].right=g[c][1];break;case 0:g[c-1][1].mid=g[c][1];break}else this.c=g[0][1]}}return h}get(d){return this.d(d)?.value}d(d){const y=this.b.reset(d);let w=this.c;for(;w;){const $=y.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(d){const y=this.d(d);return!(y?.value===void 0&&y?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,y){const w=this.b.reset(d),$=[];let g=this.c;for(;g;){const h=w.cmp(g.segment);if(h>0)$.push([-1,g]),g=g.left;else if(h<0)$.push([1,g]),g=g.right;else if(w.hasNext())w.next(),$.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const h=this.f(g.right);if(h.key){const{key:c,value:k,segment:u}=h;this.e(h.key,!1),g.key=c,g.value=k,g.segment=u}}else{const h=g.left??g.right;if($.length>0){const[c,k]=$[$.length-1];switch(c){case-1:k.left=h;break;case 0:k.mid=h;break;case 1:k.right=h;break}}else this.c=h}for(let h=$.length-1;h>=0;h--){const c=$[h][1];c.updateHeight();const k=c.balanceFactor();if(k>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),$[h][1]=c.rotateLeft()):k<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),$[h][1]=c.rotateRight()),h>0)switch($[h-1][0]){case-1:$[h-1][1].left=$[h][1];break;case 1:$[h-1][1].right=$[h][1];break;case 0:$[h-1][1].mid=$[h][1];break}else this.c=$[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const y=this.b.reset(d);let w=this.c,$;for(;w;){const g=y.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(y.hasNext())y.next(),$=w.value||$,w=w.mid;else break}return w&&w.value||$}findSuperstr(d){return this.g(d,!1)}g(d,y){const w=this.b.reset(d);let $=this.c;for(;$;){const g=w.cmp($.segment);if(g>0)$=$.left;else if(g<0)$=$.right;else if(w.hasNext())w.next(),$=$.mid;else return $.mid?this.h($.mid):y?$.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[y,w]of this)d(w,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const y=[];return this.j(d,y),y[Symbol.iterator]()}j(d,y){d&&(d.left&&this.j(d.left,y),d.value&&y.push([d.key,d.value]),d.mid&&this.j(d.mid,y),d.right&&this.j(d.right,y))}_isBalanced(){const d=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:d(y.left)&&d(y.right)};return d(this.c)}}e.$Sh=b}),define(ee[12],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=void 0;function S(u){return typeof u=="string"}e.$wf=S;function D(u){return Array.isArray(u)&&u.every(t=>S(t))}e.$xf=D;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$yf=s;function L(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.$zf=L;function C(u){return typeof u=="number"&&!isNaN(u)}e.$Af=C;function P(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$Bf=P;function f(u){return u===!0||u===!1}e.$Cf=f;function a(u){return typeof u>"u"}e.$Df=a;function m(u){return!b(u)}e.$Ef=m;function b(u){return a(u)||u===null}e.$Ff=b;function p(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Gf=p;function d(u){if(b(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$Hf=d;function y(...u){const t=[];for(let l=0;l<u.length;l++){const r=u[l];if(b(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(r)}return t}e.$If=y;const w=Object.prototype.hasOwnProperty;function $(u){if(!s(u))return!1;for(const t in u)if(w.call(u,t))return!1;return!0}e.$Jf=$;function g(u){return typeof u=="function"}e.$Kf=g;function h(...u){return u.length>0&&u.every(g)}e.$Lf=h;function c(u,t){const l=Math.min(u.length,t.length);for(let r=0;r<l;r++)k(u[r],t[r])}e.$Mf=c;function k(u,t){if(S(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(u instanceof t)return}catch{}if(!b(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Nf=k}),define(ee[72],te([0,1,12]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=void 0;const D=Object.create(null);function s(P,f){if((0,S.$wf)(f)){const a=D[f];if(a===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=a}return D[P]=f,{id:P}}function L(){return D}e.$Pj=L;function C(){return Object.values(e.$Rj)}e.$Qj=C,e.$Rj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,12]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function D(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([c,k])=>{h[c]=k&&typeof k=="object"?D(k):k}),h}e.$Xm=D;function s(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const c=h.shift();Object.freeze(c);for(const k in c)if(L.call(c,k)){const u=c[k];typeof u=="object"&&!Object.isFrozen(u)&&!(0,S.$zf)(u)&&h.push(u)}}return g}e.$Ym=s;const L=Object.prototype.hasOwnProperty;function C(g,h){return P(g,h,new Set)}e.$Zm=C;function P(g,h,c){if((0,S.$Ff)(g))return g;const k=h(g);if(typeof k<"u")return k;if(Array.isArray(g)){const u=[];for(const t of g)u.push(P(t,h,c));return u}if((0,S.$yf)(g)){if(c.has(g))throw new Error("Cannot clone recursive data-structure");c.add(g);const u={};for(const t in g)L.call(g,t)&&(u[t]=P(g[t],h,c));return c.delete(g),u}return g}function f(g,h,c=!0){return(0,S.$yf)(g)?((0,S.$yf)(h)&&Object.keys(h).forEach(k=>{k in g?c&&((0,S.$yf)(g[k])&&(0,S.$yf)(h[k])?f(g[k],h[k],c):g[k]=h[k]):g[k]=h[k]}),g):h}e.$1m=f;function a(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let c,k;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(c=0;c<g.length;c++)if(!a(g[c],h[c]))return!1}else{const u=[];for(k in g)u.push(k);u.sort();const t=[];for(k in h)t.push(k);if(t.sort(),!a(u,t))return!1;for(c=0;c<u.length;c++)if(!a(g[u[c]],h[u[c]]))return!1}return!0}e.$2m=a;function m(g){const h=new Set;return JSON.stringify(g,(c,k)=>{if((0,S.$yf)(k)||Array.isArray(k)){if(h.has(k))return"[Circular]";h.add(k)}return k})}e.$3m=m;function b(g,h){const c=Object.create(null);return!g||!h||Object.keys(h).forEach(u=>{const t=g[u],l=h[u];a(t,l)||(c[u]=l)}),c}e.$4m=b;function p(g,h){const c=h.toLowerCase(),k=Object.keys(g).find(u=>u.toLowerCase()===c);return k?g[k]:g[h]}e.$5m=p;function d(g,h){const c=Object.create(null);for(const[k,u]of Object.entries(g))h(k,u)&&(c[k]=u);return c}e.$6m=d;function y(g){let h=[];for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}e.$7m=y;function w(g){const h=[];for(const c of y(g))typeof g[c]=="function"&&h.push(c);return h}e.$8m=w;function $(g,h){const c=u=>function(){const t=Array.prototype.slice.call(arguments,0);return h(u,t)},k={};for(const u of g)k[u]=c(u);return k}e.$9m=$}),define(ee[102],te([0,1,72]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Sj=e.ThemeColor=void 0;var D;(function(C){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}C.isThemeColor=P})(D||(e.ThemeColor=D={}));function s(C){return{id:C}}e.$Sj=s;var L;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function f(h){const c=P.exec(h.id);if(!c)return f(S.$Rj.error);const[,k,u]=c,t=["codicon","codicon-"+k];return u&&t.push("codicon-modifier-"+u.substring(1)),t}C.asClassNameArray=f;function a(h){return f(h).join(" ")}C.asClassName=a;function m(h){return"."+f(h).join(".")}C.asCSSSelector=m;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||D.isThemeColor(h.color))}C.isThemeIcon=b;const p=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function d(h){const c=p.exec(h);if(!c)return;const[,k]=c;return{id:k}}C.fromString=d;function y(h){return{id:h}}C.fromId=y;function w(h,c){let k=h.id;const u=k.lastIndexOf("~");return u!==-1&&(k=k.substring(0,u)),c&&(k=`${k}~${c}`),{id:k}}C.modify=w;function $(h){const c=h.id.lastIndexOf("~");if(c!==-1)return h.id.substring(c+1)}C.getModifier=$;function g(h,c){return h.id===c.id&&h.color?.id===c.color?.id}C.isEqual=g})(L||(e.ThemeIcon=L={}))}),define(ee[32],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(s){return S.test(s)}e.$bg=D,e.$cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){s(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,a="";return a+=C[L[f++]],a+=C[L[f++]],a+=C[L[f++]],a+=C[L[f++]],a+="-",a+=C[L[f++]],a+=C[L[f++]],a+="-",a+=C[L[f++]],a+=C[L[f++]],a+="-",a+=C[L[f++]],a+=C[L[f++]],a+="-",a+=C[L[f++]],a+=C[L[f++]],a+=C[L[f++]],a+=C[L[f++]],a+=C[L[f++]],a+=C[L[f++]],a}}()}),define(ee[142],te([0,1,85,45,82]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=void 0;async function L(C,P){if(await new Promise((m,b)=>{const p=D.createReadStream(C),d=S.createHash("sha1");p.pipe(d);const y=(0,s.$bb)((w,$)=>{p.removeAllListeners(),d.removeAllListeners(),w?b(w):m($)});p.once("error",y),p.once("end",y),d.once("error",y),d.once("data",w=>y(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$2S=L}),define(ee[143],te([0,1,28]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const P=C.replace(/\-/g,":").toLowerCase();return!D.has(P)}function L(){const C=(0,S.networkInterfaces)();for(const P in C){const f=C[P];if(f){for(const{mac:a}of f)if(s(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Im=L}),define(ee[86],te([0,1,28,56,32,143]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=void 0,e.$Jm=new class{c(a){return this.a||(this.a=D.$Sh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(a)}value(){if(this.b===void 0){let a=0,m=0;const b=(0,S.networkInterfaces)();for(const p in b){const d=b[p];if(d)for(const{mac:y,internal:w}of d)w||(m+=1,this.c(y.toUpperCase())&&(a+=1))}this.b=m>0?a/m:0}return this.b}};let C;async function P(a){return C||(C=(async()=>await f(a)||s.$cg())()),C}e.$Km=P;async function f(a){try{const m=await new Promise((p,d)=>{K(["crypto"],p,d)}),b=(0,L.$Im)();return m.createHash("sha256").update(b,"utf8").digest("hex")}catch(m){a(m);return}}}),define(ee[103],te([0,1,87]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.$fg=e.$eg=void 0;function D(P,f,a,m=1){let b=!1;return new Promise(p=>{const d=setTimeout(()=>{if(!b)return b=!0,p(0)},a);s(P,f,m,y=>{if(!b)return b=!0,clearTimeout(d),p(y)})})}e.$eg=D;function s(P,f,a,m){if(f===0)return m(0);const b=new S.Socket;b.once("connect",()=>(C(b),s(P+a,f-1,a,m))),b.once("data",()=>{}),b.once("error",p=>(C(b),p.code!=="ECONNREFUSED"?s(P+a,f-1,a,m):m(P))),b.connect(P,"127.0.0.1")}e.$fg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,f,a,m="127.0.0.1"){let b=!1,p,d=1;const y=S.createServer({pauseOnConnect:!0});function w($,g){b||(b=!0,y.removeAllListeners(),y.close(),p&&clearTimeout(p),g($))}return new Promise($=>{p=setTimeout(()=>{w(0,$)},a),y.on("listening",()=>{w(P,$)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&d<f?(P++,d++,y.listen(P,m)):w(0,$)}),y.on("close",()=>{w(0,$)}),y.listen(P,m)})}e.$gg=L;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function S(f){const a=new Set;if(Array.isArray(f))for(const m of f)typeof m=="string"&&a.add(m);return Array.from(a)}function D(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const a=e();if(a)if(typeof f=="string")a.add(f.toLowerCase());else for(const m of S(f))s(m)}function L(f){if(typeof f!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const b of a){if(f.indexOf(b)!==0)continue;const d=f.indexOf("\\",b.length);if(d===-1)continue;const y=f.substring(b.length,d);if(y){m=y;break}}return m}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:D,addUNCHostToAllowlist:s,getUNCHost:L,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ee[144],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6S=e.$5S=void 0,e.$5S="vscode:contextmenu",e.$6S="vscode:onCloseContextMenu"}),define(ee[145],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aT=void 0;class S{constructor(s,L){this.a=s,this.onMessage=L}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$aT=S}),define(ee[146],te([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(ee[147],te([0,1,146]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0;const D=60,s=D*60,L=s*24,C=L*7,P=L*30,f=L*365;function a(b,p,d,y){typeof b!="number"&&(b=b.getTime());const w=Math.round((new Date().getTime()-b)/1e3);if(w<-30)return(0,S.localize)(0,null,a(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,S.localize)(1,null);let $;return w<D?($=w,p?$===1?d?(0,S.localize)(2,null,$):(0,S.localize)(3,null,$):d?(0,S.localize)(4,null,$):(0,S.localize)(5,null,$):$===1?d?(0,S.localize)(6,null,$):(0,S.localize)(7,null,$):d?(0,S.localize)(8,null,$):(0,S.localize)(9,null,$)):w<s?($=Math.floor(w/D),p?$===1?d?(0,S.localize)(10,null,$):(0,S.localize)(11,null,$):d?(0,S.localize)(12,null,$):(0,S.localize)(13,null,$):$===1?d?(0,S.localize)(14,null,$):(0,S.localize)(15,null,$):d?(0,S.localize)(16,null,$):(0,S.localize)(17,null,$)):w<L?($=Math.floor(w/s),p?$===1?d?(0,S.localize)(18,null,$):(0,S.localize)(19,null,$):d?(0,S.localize)(20,null,$):(0,S.localize)(21,null,$):$===1?d?(0,S.localize)(22,null,$):(0,S.localize)(23,null,$):d?(0,S.localize)(24,null,$):(0,S.localize)(25,null,$)):w<C?($=Math.floor(w/L),p?$===1?(0,S.localize)(26,null,$):(0,S.localize)(27,null,$):$===1?(0,S.localize)(28,null,$):(0,S.localize)(29,null,$)):w<P?($=Math.floor(w/C),p?$===1?d?(0,S.localize)(30,null,$):(0,S.localize)(31,null,$):d?(0,S.localize)(32,null,$):(0,S.localize)(33,null,$):$===1?d?(0,S.localize)(34,null,$):(0,S.localize)(35,null,$):d?(0,S.localize)(36,null,$):(0,S.localize)(37,null,$)):w<f?($=Math.floor(w/P),p?$===1?d?(0,S.localize)(38,null,$):(0,S.localize)(39,null,$):d?(0,S.localize)(40,null,$):(0,S.localize)(41,null,$):$===1?d?(0,S.localize)(42,null,$):(0,S.localize)(43,null,$):d?(0,S.localize)(44,null,$):(0,S.localize)(45,null,$)):($=Math.floor(w/f),p?$===1?d?(0,S.localize)(46,null,$):(0,S.localize)(47,null,$):d?(0,S.localize)(48,null,$):(0,S.localize)(49,null,$):$===1?d?(0,S.localize)(50,null,$):(0,S.localize)(51,null,$):d?(0,S.localize)(52,null,$):(0,S.localize)(53,null,$))}e.$8l=a;function m(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$9l=m}),define(ee[148],te([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ee[49],te([0,1,23,12,148]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=void 0;function L(b,p){return p&&(b.stack||b.stacktrace)?s.localize(0,null,P(b),C(b.stack)||C(b.stacktrace)):P(b)}function C(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?s.localize(1,null,b.message):b.message||s.localize(2,null)}function f(b=null,p=!1){if(!b)return s.localize(3,null);if(Array.isArray(b)){const d=S.$Fb(b),y=f(d[0],p);return d.length>1?s.localize(4,null,y,d.length):y}if(D.$wf(b))return b;if(b.detail){const d=b.detail;if(d.error)return L(d.error,p);if(d.exception)return L(d.exception,p)}return b.stack?L(b,p):b.message?b.message:s.localize(5,null)}e.$xi=f;function a(b){const p=b;return p instanceof Error&&Array.isArray(p.actions)}e.$yi=a;function m(b,p){let d;return typeof b=="string"?d=new Error(b):d=b,d.actions=p,d}e.$zi=m}),define(ee[149],te([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(ee[150],te([0,1,149]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;function D(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$op=D}),define(ee[151],te([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,151]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let D=!1,s=!1,L=!1,C=!1,P=!1,f=!1,a=!1,m=!1,b=!1,p=!1,d,y=e.$f,w=e.$f,$,g;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?h=e.$g.vscode.process:typeof process<"u"&&(h=process);const c=typeof h?.versions?.electron=="string",k=c&&h?.type==="renderer";if(typeof navigator=="object"&&!k)g=navigator.userAgent,D=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,m=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=g.indexOf("Linux")>=0,p=g?.indexOf("Mobi")>=0,f=!0,d=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$f,y=d,w=navigator.language;else if(typeof h=="object"){D=h.platform==="win32",s=h.platform==="darwin",L=h.platform==="linux",C=L&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,a=c,b=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$f,y=e.$f;const R=h.env.VSCODE_NLS_CONFIG;if(R)try{const A=JSON.parse(R),E=A.availableLanguages["*"];d=A.locale,w=A.osLocale,y=E||e.$f,$=A._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var u;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let l=0;s?l=1:D?l=3:L&&(l=2),e.$i=D,e.$j=s,e.$k=L,e.$l=C,e.$m=P,e.$n=a,e.$o=f,e.$p=f&&typeof e.$g.importScripts=="function",e.$q=m,e.$r=p,e.$s=b,e.$t=l,e.$u=g,e.$v=y;var r;(function(R){function A(){return e.$v}R.value=A;function E(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}R.isDefaultVariant=E;function I(){return e.$v==="en"}R.isDefault=I})(r||(e.Language=r={})),e.$w=d,e.$x=w,e.$y=$,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const R=[];e.$g.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let I=0,M=R.length;I<M;I++){const U=R[I];if(U.id===E.data.vscodeScheduleAsyncWork){R.splice(I,1),U.callback();return}}});let A=0;return E=>{const I=++A;R.push({id:I,callback:E}),e.$g.postMessage({vscodeScheduleAsyncWork:I},"*")}}return R=>setTimeout(R)})();var i;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||m?2:D?1:3;let n=!0,o=!1;function v(){if(!o){o=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,n=new Uint16Array(R.buffer)[0]===(2<<8)+1}return n}e.$C=v,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(ee[35],te([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.env=e.cwd=void 0;let D;if(typeof S.$g.vscode<"u"&&typeof S.$g.vscode.process<"u"){const s=S.$g.vscode.process;D={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.$bc=D.platform,e.$cc=D.arch}),define(ee[9],te([0,1,35]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.sep=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=void 0;const D=65,s=97,L=90,C=122,P=46,f=47,a=92,m=58,b=63;class p extends Error{constructor(l,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=l.indexOf(".")!==-1?"property":"argument";let v=`The "${l}" ${o} ${n} of type ${r}`;v+=`. Received type ${typeof i}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,l){if(t===null||typeof t!="object")throw new p(l,"Object",t)}function y(t,l){if(typeof t!="string")throw new p(l,"string",t)}const w=S.$bc==="win32";function $(t){return t===f||t===a}function g(t){return t===f}function h(t){return t>=D&&t<=L||t>=s&&t<=C}function c(t,l,r,i){let n="",o=0,v=-1,R=0,A=0;for(let E=0;E<=t.length;++E){if(E<t.length)A=t.charCodeAt(E);else{if(i(A))break;A=f}if(i(A)){if(!(v===E-1||R===1))if(R===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const I=n.lastIndexOf(r);I===-1?(n="",o=0):(n=n.slice(0,I),o=n.length-1-n.lastIndexOf(r)),v=E,R=0;continue}else if(n.length!==0){n="",o=0,v=E,R=0;continue}}l&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(v+1,E)}`:n=t.slice(v+1,E),o=E-v-1;v=E,R=0}else A===P&&R!==-1?++R:R=-1}return n}function k(t,l){d(l,"pathObject");const r=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${i}`:`${r}${t}${i}`:i}e.$dc={resolve(...t){let l="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else l.length===0?o=S.cwd():(o=S.env[`=${l}`]||S.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===a)&&(o=`${l}\\`));const v=o.length;let R=0,A="",E=!1;const I=o.charCodeAt(0);if(v===1)$(I)&&(R=1,E=!0);else if($(I))if(E=!0,$(o.charCodeAt(1))){let M=2,U=M;for(;M<v&&!$(o.charCodeAt(M));)M++;if(M<v&&M!==U){const B=o.slice(U,M);for(U=M;M<v&&$(o.charCodeAt(M));)M++;if(M<v&&M!==U){for(U=M;M<v&&!$(o.charCodeAt(M));)M++;(M===v||M!==U)&&(A=`\\\\${B}\\${o.slice(U,M)}`,R=M)}}}else R=1;else h(I)&&o.charCodeAt(1)===m&&(A=o.slice(0,2),R=2,v>2&&$(o.charCodeAt(2))&&(E=!0,R=3));if(A.length>0)if(l.length>0){if(A.toLowerCase()!==l.toLowerCase())continue}else l=A;if(i){if(l.length>0)break}else if(r=`${o.slice(R)}\\${r}`,i=E,E&&l.length>0)break}return r=c(r,!i,"\\",$),i?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){y(t,"path");const l=t.length;if(l===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(l===1)return g(o)?"\\":t;if($(o))if(n=!0,$(t.charCodeAt(1))){let R=2,A=R;for(;R<l&&!$(t.charCodeAt(R));)R++;if(R<l&&R!==A){const E=t.slice(A,R);for(A=R;R<l&&$(t.charCodeAt(R));)R++;if(R<l&&R!==A){for(A=R;R<l&&!$(t.charCodeAt(R));)R++;if(R===l)return`\\\\${E}\\${t.slice(A)}\\`;R!==A&&(i=`\\\\${E}\\${t.slice(A,R)}`,r=R)}}}else r=1;else h(o)&&t.charCodeAt(1)===m&&(i=t.slice(0,2),r=2,l>2&&$(t.charCodeAt(2))&&(n=!0,r=3));let v=r<l?c(t.slice(r),!n,"\\",$):"";return v.length===0&&!n&&(v="."),v.length>0&&$(t.charCodeAt(l-1))&&(v+="\\"),i===void 0?n?`\\${v}`:v:n?`${i}\\${v}`:`${i}${v}`},isAbsolute(t){y(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return $(r)||l>2&&h(r)&&t.charCodeAt(1)===m&&$(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let o=0;o<t.length;++o){const v=t[o];y(v,"path"),v.length>0&&(l===void 0?l=r=v:l+=`\\${v}`)}if(l===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&$(r.charCodeAt(0))){++n;const o=r.length;o>1&&$(r.charCodeAt(1))&&(++n,o>2&&($(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<l.length&&$(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.$dc.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l)return"";const r=e.$dc.resolve(t),i=e.$dc.resolve(l);if(r===i||(t=r.toLowerCase(),l=i.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===a;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===a;)o--;const v=o-n;let R=0;for(;R<l.length&&l.charCodeAt(R)===a;)R++;let A=l.length;for(;A-1>R&&l.charCodeAt(A-1)===a;)A--;const E=A-R,I=v<E?v:E;let M=-1,U=0;for(;U<I;U++){const se=t.charCodeAt(n+U);if(se!==l.charCodeAt(R+U))break;se===a&&(M=U)}if(U!==I){if(M===-1)return i}else{if(E>I){if(l.charCodeAt(R+U)===a)return i.slice(R+U+1);if(U===2)return i.slice(R+U)}v>I&&(t.charCodeAt(n+U)===a?M=U:U===2&&(M=3)),M===-1&&(M=0)}let B="";for(U=n+M+1;U<=o;++U)(U===o||t.charCodeAt(U)===a)&&(B+=B.length===0?"..":"\\..");return R+=M,B.length>0?`${B}${i.slice(R,A)}`:(i.charCodeAt(R)===a&&++R,i.slice(R,A))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$dc.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===a){if(l.charCodeAt(1)===a){const r=l.charCodeAt(2);if(r!==b&&r!==P)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(h(l.charCodeAt(0))&&l.charCodeAt(1)===m&&l.charCodeAt(2)===a)return`\\\\?\\${l}`;return t},dirname(t){y(t,"path");const l=t.length;if(l===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(l===1)return $(n)?t:".";if($(n)){if(r=i=1,$(t.charCodeAt(1))){let R=2,A=R;for(;R<l&&!$(t.charCodeAt(R));)R++;if(R<l&&R!==A){for(A=R;R<l&&$(t.charCodeAt(R));)R++;if(R<l&&R!==A){for(A=R;R<l&&!$(t.charCodeAt(R));)R++;if(R===l)return t;R!==A&&(r=i=R+1)}}}}else h(n)&&t.charCodeAt(1)===m&&(r=l>2&&$(t.charCodeAt(2))?3:2,i=r);let o=-1,v=!0;for(let R=l-1;R>=i;--R)if($(t.charCodeAt(R))){if(!v){o=R;break}}else v=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let v=l.length-1,R=-1;for(o=t.length-1;o>=r;--o){const A=t.charCodeAt(o);if($(A)){if(!n){r=o+1;break}}else R===-1&&(n=!1,R=o+1),v>=0&&(A===l.charCodeAt(v)?--v===-1&&(i=o):(v=-1,i=R))}return r===i?i=R:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if($(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let l=0,r=-1,i=0,n=-1,o=!0,v=0;t.length>=2&&t.charCodeAt(1)===m&&h(t.charCodeAt(0))&&(l=i=2);for(let R=t.length-1;R>=l;--R){const A=t.charCodeAt(R);if($(A)){if(!o){i=R+1;break}continue}n===-1&&(o=!1,n=R+1),A===P?r===-1?r=R:v!==1&&(v=1):r!==-1&&(v=-1)}return r===-1||n===-1||v===0||v===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:k.bind(null,"\\"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return $(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if($(n)){if(i=1,$(t.charCodeAt(1))){let M=2,U=M;for(;M<r&&!$(t.charCodeAt(M));)M++;if(M<r&&M!==U){for(U=M;M<r&&$(t.charCodeAt(M));)M++;if(M<r&&M!==U){for(U=M;M<r&&!$(t.charCodeAt(M));)M++;M===r?i=M:M!==U&&(i=M+1)}}}}else if(h(n)&&t.charCodeAt(1)===m){if(r<=2)return l.root=l.dir=t,l;if(i=2,$(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let o=-1,v=i,R=-1,A=!0,E=t.length-1,I=0;for(;E>=i;--E){if(n=t.charCodeAt(E),$(n)){if(!A){v=E+1;break}continue}R===-1&&(A=!1,R=E+1),n===P?o===-1?o=E:I!==1&&(I=1):o!==-1&&(I=-1)}return R!==-1&&(o===-1||I===0||I===1&&o===R-1&&o===v+1?l.base=l.name=t.slice(v,R):(l.name=t.slice(v,o),l.base=t.slice(v,R),l.ext=t.slice(o,R))),v>0&&v!==i?l.dir=t.slice(0,v-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(w){const t=/\\/g;return()=>{const l=S.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>S.cwd()})();e.$ec={resolve(...t){let l="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:u();y(n,"path"),n.length!==0&&(l=`${n}/${l}`,r=n.charCodeAt(0)===f)}return l=c(l,!r,"/",g),r?`/${l}`:l.length>0?l:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=c(t,!l,"/",g),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.$ec.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l||(t=e.$ec.resolve(t),l=e.$ec.resolve(l),t===l))return"";const r=1,i=t.length,n=i-r,o=1,v=l.length-o,R=n<v?n:v;let A=-1,E=0;for(;E<R;E++){const M=t.charCodeAt(r+E);if(M!==l.charCodeAt(o+E))break;M===f&&(A=E)}if(E===R)if(v>R){if(l.charCodeAt(o+E)===f)return l.slice(o+E+1);if(E===0)return l.slice(o+E)}else n>R&&(t.charCodeAt(r+E)===f?A=E:E===0&&(A=0));let I="";for(E=r+A+1;E<=i;++E)(E===i||t.charCodeAt(E)===f)&&(I+=I.length===0?"..":"/..");return`${I}${l.slice(o+A)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let v=l.length-1,R=-1;for(o=t.length-1;o>=0;--o){const A=t.charCodeAt(o);if(A===f){if(!n){r=o+1;break}}else R===-1&&(n=!1,R=o+1),v>=0&&(A===l.charCodeAt(v)?--v===-1&&(i=o):(v=-1,i=R))}return r===i?i=R:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===f){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let l=-1,r=0,i=-1,n=!0,o=0;for(let v=t.length-1;v>=0;--v){const R=t.charCodeAt(v);if(R===f){if(!n){r=v+1;break}continue}i===-1&&(n=!1,i=v+1),R===P?l===-1?l=v:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||i===-1||o===0||o===1&&l===i-1&&l===r+1?"":t.slice(l,i)},format:k.bind(null,"/"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===f;let i;r?(l.root="/",i=1):i=0;let n=-1,o=0,v=-1,R=!0,A=t.length-1,E=0;for(;A>=i;--A){const I=t.charCodeAt(A);if(I===f){if(!R){o=A+1;break}continue}v===-1&&(R=!1,v=A+1),I===P?n===-1?n=A:E!==1&&(E=1):n!==-1&&(E=-1)}if(v!==-1){const I=o===0&&r?1:o;n===-1||E===0||E===1&&n===v-1&&n===o+1?l.base=l.name=t.slice(I,v):(l.name=t.slice(I,n),l.base=t.slice(I,v),l.ext=t.slice(n,v))}return o>0?l.dir=t.slice(0,o-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$ec.win32=e.$dc.win32=e.$dc,e.$ec.posix=e.$dc.posix=e.$ec,e.$fc=w?e.$dc.normalize:e.$ec.normalize,e.$gc=w?e.$dc.isAbsolute:e.$ec.isAbsolute,e.$hc=w?e.$dc.join:e.$ec.join,e.$ic=w?e.$dc.resolve:e.$ec.resolve,e.$jc=w?e.$dc.relative:e.$ec.relative,e.$kc=w?e.$dc.dirname:e.$ec.dirname,e.$lc=w?e.$dc.basename:e.$ec.basename,e.$mc=w?e.$dc.extname:e.$ec.extname,e.$nc=w?e.$dc.format:e.$ec.format,e.$oc=w?e.$dc.parse:e.$ec.parse,e.$pc=w?e.$dc.toNamespacedPath:e.$ec.toNamespacedPath,e.sep=w?e.$dc.sep:e.$ec.sep,e.$rc=w?e.$dc.delimiter:e.$ec.delimiter}),define(ee[33],te([0,1,9,4,27,12]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function C(o){return o===47||o===92}e.$Of=C;function P(o){return o.replace(/[\\/]/g,S.$ec.sep)}e.$Pf=P;function f(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Qf=f;function a(o,v=S.$ec.sep){if(!o)return"";const R=o.length,A=o.charCodeAt(0);if(C(A)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let I=3;const M=I;for(;I<R&&!C(o.charCodeAt(I));I++);if(M!==I&&!C(o.charCodeAt(I+1))){for(I+=1;I<R;I++)if(C(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,v)}}return v}else if(g(A)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+v:o.slice(0,2);let E=o.indexOf("://");if(E!==-1){for(E+=3;E<R;E++)if(C(o.charCodeAt(E)))return o.slice(0,E+1)}return""}e.$Rf=a;function m(o){if(!D.$i||!o||o.length<5)return!1;let v=o.charCodeAt(0);if(v!==92||(v=o.charCodeAt(1),v!==92))return!1;let R=2;const A=R;for(;R<o.length&&(v=o.charCodeAt(R),v!==92);R++);return!(A===R||(v=o.charCodeAt(R+1),isNaN(v)||v===92))}e.$Sf=m;const b=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,v=D.$i){const R=v?b:p;return!(!o||o.length===0||/^\s+$/.test(o)||(R.lastIndex=0,R.test(o))||v&&d.test(o)||o==="."||o===".."||v&&o[o.length-1]==="."||v&&o.length!==o.trim().length||o.length>255)}e.$Tf=y;function w(o,v,R){const A=o===v;return!R||A?A:!o||!v?!1:(0,s.$Ze)(o,v)}e.$Uf=w;function $(o,v,R,A=S.sep){if(o===v)return!0;if(!o||!v||v.length>o.length)return!1;if(R){if(!(0,s.$1e)(o,v))return!1;if(v.length===o.length)return!0;let I=v.length;return v.charAt(v.length-1)===A&&I--,o.charAt(I)===A}return v.charAt(v.length-1)!==A&&(v+=A),o.indexOf(v)===0}e.$Vf=$;function g(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Wf=g;function h(o,v){return D.$i&&o.endsWith(":")&&(o+=S.sep),(0,S.$gc)(o)||(o=(0,S.$hc)(v,o)),o=(0,S.$fc)(o),D.$i?(o=(0,s.$Ie)(o,S.sep),o.endsWith(":")&&(o+=S.sep)):(o=(0,s.$Ie)(o,S.sep),o||(o=S.sep)),o}e.$Xf=h;function c(o){const v=(0,S.$fc)(o);return D.$i?o.length>3?!1:k(v)&&(o.length===2||v.charCodeAt(2)===92):v===S.$ec.sep}e.$Yf=c;function k(o,v=D.$i){return v?g(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Zf=k;function u(o,v=D.$i){return k(o,v)?o[0]:void 0}e.$1f=u;function t(o,v,R){return v.length>o.length?-1:o===v?0:(R&&(o=o.toLowerCase(),v=v.toLowerCase()),o.indexOf(v))}e.$2f=t;function l(o){const v=o.split(":");let R,A,E;for(const I of v){const M=Number(I);(0,L.$Af)(M)?A===void 0?A=M:E===void 0&&(E=M):R=R?[R,I].join(":"):I}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:A!==void 0?A:void 0,column:E!==void 0?E:A!==void 0?1:void 0}}e.$3f=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,v,R=8){let A="";for(let I=0;I<R;I++){let M;I===0&&D.$i&&!v&&(R===3||R===4)?M=i:M=r,A+=M.charAt(Math.floor(Math.random()*M.length))}let E;return v?E=`${v}-${A}`:E=A,o?(0,S.$hc)(o,E):E}e.$4f=n}),define(ee[73],te([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D||(e.Source=D={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function L(P,...f){const a=f.reduce((p,d)=>(p[d]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!a[p]).forEach(p=>{for(let d=0;d<m.length;d++)if(p.search(m[d])!==-1){delete P[p];break}})}e.$ul=L;function C(P){P&&(delete P.DEBUG,S.$j&&delete P.DYLD_LIBRARY_PATH,S.$k&&delete P.LD_PRELOAD)}e.$vl=C}),define(ee[7],te([0,1,9,4]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.$tc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,L=/^\//,C=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function a(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const m="",b="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,v,R,A,E=!1){typeof n=="object"?(this.scheme=n.scheme||m,this.authority=n.authority||m,this.path=n.path||m,this.query=n.query||m,this.fragment=n.fragment||m):(this.scheme=f(n,E),this.authority=o||m,this.path=a(this.scheme,v||m),this.query=R||m,this.fragment=A||m,P(this,E))}get fsPath(){return k(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:v,path:R,query:A,fragment:E}=n;return o===void 0?o=this.scheme:o===null&&(o=m),v===void 0?v=this.authority:v===null&&(v=m),R===void 0?R=this.path:R===null&&(R=m),A===void 0?A=this.query:A===null&&(A=m),E===void 0?E=this.fragment:E===null&&(E=m),o===this.scheme&&v===this.authority&&R===this.path&&A===this.query&&E===this.fragment?this:new $(o,v,R,A,E)}static parse(n,o=!1){const v=p.exec(n);return v?new $(v[2]||m,r(v[4]||m),r(v[5]||m),r(v[7]||m),r(v[9]||m),o):new $(m,m,m,m,m)}static file(n){let o=m;if(D.$i&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const v=n.indexOf(b,2);v===-1?(o=n.substring(2),n=b):(o=n.substring(2,v),n=n.substring(v)||b)}return new $("file",o,n,m,m)}static from(n,o){return new $(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return D.$i&&n.scheme==="file"?v=d.file(S.$dc.join(k(n,!0),...o)).path:v=S.$ec.join(n.path,...o),n.with({path:v})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const o=new $(n);return o._formatted=n.external??null,o._fsPath=n._sep===w?n.fsPath??null:null,o}}else return n}}e.URI=d;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$tc=y;const w=D.$i?1:void 0;class $ extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,o){let v,R=-1;for(let A=0;A<i.length;A++){const E=i.charCodeAt(A);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||o&&E===91||o&&E===93||o&&E===58)R!==-1&&(v+=encodeURIComponent(i.substring(R,A)),R=-1),v!==void 0&&(v+=i.charAt(A));else{v===void 0&&(v=i.substr(0,A));const I=g[E];I!==void 0?(R!==-1&&(v+=encodeURIComponent(i.substring(R,A)),R=-1),v+=I):R===-1&&(R=A)}}return R!==-1&&(v+=encodeURIComponent(i.substring(R))),v!==void 0?v:i}function c(i){let n;for(let o=0;o<i.length;o++){const v=i.charCodeAt(o);v===35||v===63?(n===void 0&&(n=i.substr(0,o)),n+=g[v]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function k(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,D.$i&&(o=o.replace(/\//g,"\\")),o}e.$uc=k;function u(i,n){const o=n?c:h;let v="",{scheme:R,authority:A,path:E,query:I,fragment:M}=i;if(R&&(v+=R,v+=":"),(A||R==="file")&&(v+=b,v+=b),A){let U=A.indexOf("@");if(U!==-1){const B=A.substr(0,U);A=A.substr(U+1),U=B.lastIndexOf(":"),U===-1?v+=o(B,!1,!1):(v+=o(B.substr(0,U),!1,!1),v+=":",v+=o(B.substr(U+1),!1,!0)),v+="@"}A=A.toLowerCase(),U=A.lastIndexOf(":"),U===-1?v+=o(A,!1,!0):(v+=o(A.substr(0,U),!1,!0),v+=A.substr(U))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const U=E.charCodeAt(1);U>=65&&U<=90&&(E=`/${String.fromCharCode(U+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const U=E.charCodeAt(0);U>=65&&U<=90&&(E=`${String.fromCharCode(U+32)}:${E.substr(2)}`)}v+=o(E,!0,!1)}return I&&(v+="?",v+=o(I,!1,!1)),M&&(v+="#",v+=n?M:h(M,!1,!1)),v}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(l)?i.replace(l,n=>t(n)):i}}),define(ee[152],te([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Rp=e.$Qp=e.$Pp=void 0;function D(a){const m=a;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.$Pp=D;function s(a){const m=[];let b;try{const p=JSON.parse(a.arguments),d=p[p.length-1];d&&d.__$stack&&(p.pop(),b=d.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",a.arguments)}return{args:m,stack:b}}e.$Qp=s;function L(a){if(typeof a!="string")return L(s(a).stack);const m=a;if(m){const b=C(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(p&&p.length===4)return{uri:S.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Rp=L;function C(a){if(!a)return a;const m=a.indexOf(`
`);return m===-1?a:a.substring(0,m)}function P(a,m){const{args:b,stack:p}=s(a),d=typeof b[0]=="string"&&b.length===1;let y=C(p);y&&(y=`(${y.trim()})`);let w=[];if(typeof b[0]=="string"?y&&d?w=[`%c[${m}] %c${b[0]} %c${y}`,f("blue"),f(""),f("grey")]:w=[`%c[${m}] %c${b[0]}`,f("blue"),f(""),...b.slice(1)]:w=[`%c[${m}]%`,f("blue"),...b],y&&!d&&w.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,w)}e.log=P;function f(a){return`color: ${a}`}}),define(ee[74],te([0,1,17,7]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function s(f){return JSON.stringify(f,C)}e.$hh=s;function L(f){let a=JSON.parse(f);return a=P(a),a}e.$ih=L;function C(f,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(f,a=0){if(!f||a>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return D.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$_d||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let m=0;m<f.length;++m)f[m]=P(f[m],a+1);else for(const m in f)Object.hasOwnProperty.call(f,m)&&(f[m]=P(f[m],a+1))}return f}e.$jh=P}),define(ee[13],te([0,1,14,4,7]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var L;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$5f="vscode-tkn",e.$6f="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${L.vscodeRemoteResource}`}set(m,b,p){this.a[m]=b,this.b[m]=p}setConnectionToken(m,b){this.c[m]=b}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch($){return S.$Y($),m}const b=m.authority;let p=this.a[b];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const d=this.b[b],y=this.c[b];let w=`path=${encodeURIComponent(m.path)}`;return typeof y=="string"&&(w+=`&${e.$6f}=${encodeURIComponent(y)}`),s.URI.from({scheme:D.$o?this.d:L.vscodeRemoteResource,authority:`${p}:${d}`,path:this.f,query:w})}}e.$7f=new C,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked",e.$_f="vscode-app";class P{static{this.a=e.$_f}asBrowserUri(m){const b=this.b(m,K);return this.uriToBrowserUri(b)}uriToBrowserUri(m){return m.scheme===L.vscodeRemote?e.$7f.rewrite(m):m.scheme===L.file&&(D.$m||D.$p&&D.$g.origin===`${L.vscodeFileResource}://${P.a}`)?m.with({scheme:L.vscodeFileResource,authority:m.authority||P.a,query:null,fragment:null}):m}asFileUri(m){const b=this.b(m,K);return this.uriToFileUri(b)}uriToFileUri(m){return m.scheme===L.vscodeFileResource?m.with({scheme:L.file,authority:m.authority!==P.a?m.authority:null,query:null,fragment:null}):m}b(m,b){return s.URI.isUri(m)?m:s.URI.parse(b.toUrl(m))}}e.$ag=new P;var f;(function(a){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(m.get("3"));const b="vscode-coi";function p(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:s.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const $=w?.get(b);if($)return m.get($)}a.getHeadersFromQuery=p;function d(y,w,$){if(!globalThis.crossOriginIsolated)return;const g=w&&$?"3":$?"2":"1";y instanceof URLSearchParams?y.set(b,g):y[b]=g}a.addSearchParam=d})(f||(e.COI=f={}))}),define(ee[19],te([0,1,33,13,9,4,27,7]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=e.DataUri=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function f(d){return(0,P.$uc)(d,!0)}e.$hg=f;class a{constructor(y){this.a=y}compare(y,w,$=!1){return y===w?0:(0,C.$Se)(this.getComparisonKey(y,$),this.getComparisonKey(w,$))}isEqual(y,w,$=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,$)===this.getComparisonKey(w,$)}getComparisonKey(y,w=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,w,$=!1){if(y.scheme===w.scheme){if(y.scheme===D.Schemas.file)return S.$Vf(f(y),f(w),this.a(y))&&y.query===w.query&&($||y.fragment===w.fragment);if((0,e.$yg)(y.authority,w.authority))return S.$Vf(y.path,w.path,this.a(y),"/")&&y.query===w.query&&($||y.fragment===w.fragment)}return!1}joinPath(y,...w){return P.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.$qg)(y)||y.authority}basename(y){return s.$ec.basename(y.path)}extname(y){return s.$ec.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===D.Schemas.file?w=P.URI.file(s.$kc(f(y))).path:(w=s.$ec.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===D.Schemas.file?w=P.URI.file(s.$fc(f(y))).path:w=s.$ec.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.$yg)(y.authority,w.authority))return;if(y.scheme===D.Schemas.file){const h=s.$jc(f(y),f(w));return L.$i?S.$Pf(h):h}let $=y.path||"/";const g=w.path||"/";if(this.a(y)){let h=0;for(const c=Math.min($.length,g.length);h<c&&!($.charCodeAt(h)!==g.charCodeAt(h)&&$.charAt(h).toLowerCase()!==g.charAt(h).toLowerCase());h++);$=g.substr(0,h)+$.substr(h)}return s.$ec.relative($,g)}resolvePath(y,w){if(y.scheme===D.Schemas.file){const $=P.URI.file(s.$ic(f(y),w));return y.with({authority:$.authority,path:$.path})}return w=S.$Qf(w),y.with({path:s.$ec.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,C.$Ze)(y,w)}hasTrailingPathSeparator(y,w=s.sep){if(y.scheme===D.Schemas.file){const $=f(y);return $.length>S.$Rf($).length&&$[$.length-1]===w}else{const $=y.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=s.sep){return(0,e.$zg)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=s.sep){let $=!1;if(y.scheme===D.Schemas.file){const g=f(y);$=g!==void 0&&g.length===S.$Rf(g).length&&g[g.length-1]===w}else{w="/";const g=y.path;$=g.length===1&&g.charCodeAt(g.length-1)===47}return!$&&!(0,e.$zg)(y,w)?y.with({path:y.path+"/"}):y}}e.$ig=a,e.$jg=new a(()=>!1),e.$kg=new a(d=>d.scheme===D.Schemas.file?!L.$k:!0),e.$lg=new a(d=>!0),e.$mg=e.$jg.isEqual.bind(e.$jg),e.$ng=e.$jg.isEqualOrParent.bind(e.$jg),e.$og=e.$jg.getComparisonKey.bind(e.$jg),e.$pg=e.$jg.basenameOrAuthority.bind(e.$jg),e.$qg=e.$jg.basename.bind(e.$jg),e.$rg=e.$jg.extname.bind(e.$jg),e.$sg=e.$jg.dirname.bind(e.$jg),e.$tg=e.$jg.joinPath.bind(e.$jg),e.$ug=e.$jg.normalizePath.bind(e.$jg),e.$vg=e.$jg.relativePath.bind(e.$jg),e.$wg=e.$jg.resolvePath.bind(e.$jg),e.$xg=e.$jg.isAbsolutePath.bind(e.$jg),e.$yg=e.$jg.isEqualAuthority.bind(e.$jg),e.$zg=e.$jg.hasTrailingPathSeparator.bind(e.$jg),e.$Ag=e.$jg.removeTrailingPathSeparator.bind(e.$jg),e.$Bg=e.$jg.addTrailingPathSeparator.bind(e.$jg);function m(d,y){const w=[];for(let $=0;$<d.length;$++){const g=y(d[$]);d.some((h,c)=>c===$?!1:(0,e.$ng)(g,y(h)))||w.push(d[$])}return w}e.$Cg=m;var b;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function y(w){const $=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[k,u]=c.split(":");k&&u&&$.set(k,u)});const h=w.path.substring(0,w.path.indexOf(";"));return h&&$.set(d.META_DATA_MIME,h),$}d.parseMetaData=y})(b||(e.DataUri=b={}));function p(d,y,w){if(y){let $=d.path;return $&&$[0]!==s.$ec.sep&&($=s.$ec.sep+$),d.with({scheme:w,authority:y,path:$})}return d.with({scheme:w})}e.$Dg=p}),define(ee[8],te([0,1,22,14,3,2,19,4,141]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.Promises=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=void 0;function a(O){return!!O&&typeof O.then=="function"}e.$Eg=a;function m(O){const j=new S.$Vd,q=O(j.token),W=new Promise((z,G)=>{const ce=j.token.onCancellationRequested(()=>{ce.dispose(),j.dispose(),G(new D.$3)});Promise.resolve(q).then(de=>{ce.dispose(),j.dispose(),z(de)},de=>{ce.dispose(),j.dispose(),G(de)})});return new class{cancel(){j.cancel()}then(z,G){return W.then(z,G)}catch(z){return this.then(void 0,z)}finally(z){return W.finally(z)}}}e.$Fg=m;function b(O,j,q){return new Promise((W,z)=>{const G=j.onCancellationRequested(()=>{G.dispose(),W(q)});O.then(W,z).finally(()=>G.dispose())})}e.$Gg=b;function p(O,j){return new Promise((q,W)=>{const z=j.onCancellationRequested(()=>{z.dispose(),W(new D.$3)});O.then(q,W).finally(()=>z.dispose())})}e.$Hg=p;async function d(O){let j=-1;const q=O.map((W,z)=>W.then(G=>(j=z,G)));try{return await Promise.race(q)}finally{O.forEach((W,z)=>{z!==j&&W.cancel()})}}e.$Ig=d;function y(O,j,q){let W;const z=setTimeout(()=>{W?.(void 0),q?.()},j);return Promise.race([O.finally(()=>clearTimeout(z)),new Promise(G=>W=G)])}e.$Jg=y;function w(O){return new Promise((j,q)=>{const W=O();a(W)?W.then(j,q):j(W)})}e.$Kg=w;class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const q=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(q,q).then(W)})}return new Promise((q,W)=>{this.b.then(q,W)})}return this.a=j(),new Promise((q,W)=>{this.a.then(z=>{this.a=null,q(z)},z=>{this.a=null,W(z)})})}dispose(){this.f=!0}}e.$Lg=$;class g{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Mg=g;class h{constructor(){this.a=new Map}queue(j,q){const z=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.a.get(j)===z&&this.a.delete(j)});return this.a.set(j,z),z}}e.$Ng=h;const c=(O,j)=>{let q=!0;const W=setTimeout(()=>{q=!1,j()},O);return{isTriggered:()=>q,dispose:()=>{clearTimeout(W),q=!1}}},k=O=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,O())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class u{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,q=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((z,G)=>{this.d=z,this.f=G}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=q===f.$Id?k(W):c(q,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Og=u;class t{constructor(j){this.a=new u(j),this.b=new $}trigger(j,q){return this.a.trigger(()=>this.b.queue(j),q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Pg=t;class l{constructor(){this.a=!1,this.b=new Promise((j,q)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Qg=l;class r extends l{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Rg=r;function i(O,j){return j?new Promise((q,W)=>{const z=setTimeout(()=>{G.dispose(),q()},O),G=j.onCancellationRequested(()=>{clearTimeout(z),G.dispose(),W(new D.$3)})}):m(q=>i(O,q))}e.$Sg=i;function n(O,j=0,q){const W=setTimeout(()=>{O(),q&&z.dispose()},j),z=(0,L.$Oc)(()=>{clearTimeout(W),q?.deleteAndLeak(z)});return q?.add(z),z}e.$Tg=n;function o(O){const j=[];let q=0;const W=O.length;function z(){return q<W?O[q++]():null}function G(ce){ce!=null&&j.push(ce);const de=z();return de?de.then(G):Promise.resolve(j)}return Promise.resolve(null).then(G)}e.$Ug=o;function v(O,j=W=>!!W,q=null){let W=0;const z=O.length,G=()=>{if(W>=z)return Promise.resolve(q);const ce=O[W++];return Promise.resolve(ce()).then(ue=>j(ue)?Promise.resolve(ue):G())};return G()}e.$Vg=v;function R(O,j=W=>!!W,q=null){if(O.length===0)return Promise.resolve(q);let W=O.length;const z=()=>{W=-1;for(const G of O)G.cancel?.()};return new Promise((G,ce)=>{for(const de of O)de.then(ue=>{--W>=0&&j(ue)?(z(),G(ue)):W===0&&G(q)}).catch(ue=>{--W>=0&&(z(),ce(ue))})})}e.$Wg=R;class A{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((q,W)=>{this.f.push({factory:j,c:q,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const q=j.factory();q.then(j.c,j.e),q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Xg=A;class E extends A{constructor(){super(1)}}e.$Yg=E;class I{constructor(){this.a=new J,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$Zg=I;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new N;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,q=C.$jg){const W=q.getComparisonKey(j);let z=this.a.get(W);if(!z){z=new E;const G=this.f++,ce=s.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(G),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Yc),this.d.set(G,ce),this.a.set(W,z)}return z}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$1g=M;class U{constructor(j,q){this.a=-1,typeof j=="function"&&typeof q=="number"&&this.setIfNotSet(j,q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},q)}setIfNotSet(j,q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},q))}}e.$2g=U;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,q){this.cancel(),this.a=setInterval(()=>{j()},q)}}e.$3g=B;class se{constructor(j,q){this.b=-1,this.a=j,this.d=q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$4g=se;class x{constructor(j,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.a=j,this.b=q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$5g=x;class ae extends se{constructor(j,q){super(j,q),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$6g=ae;class ne extends L.$Qc{constructor(j,q){super(),this.g=j,this.h=q,this.a=[],this.b=this.B(new L.$Rc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const q of j)this.a.push(q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$7g=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$8g=O=>{(0,P.$A)(()=>{if(j)return;const q=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$8g=(O,j)=>{const q=requestIdleCallback(O,typeof j=="number"?{timeout:j}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(q))}}}}();class re{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(q){this.g=q}finally{this.d=!0}},this.b=(0,e.$8g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$9g=re;async function Q(O,j,q){let W;for(let z=0;z<q;z++)try{return await O()}catch(G){W=G,await i(j)}throw W}e.$0g=Q;class J{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,q,W){return this.a={taskId:j,cancel:()=>W?.(),promise:q},q.then(()=>this.d(j),()=>this.d(j)),q}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let q,W;const z=new Promise((G,ce)=>{q=G,W=ce});this.b={run:j,promise:z,promiseResolve:q,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$$g=J;class V{constructor(j,q=()=>Date.now()){this.d=j,this.f=q,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$_g=V;var F;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(F||(F={}));class N{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,q)=>{this.a=j,this.b=q})}complete(j){return new Promise(q=>{this.a(j),this.d={outcome:0,value:j},q()})}error(j){return new Promise(q=>{this.b(j),this.d={outcome:1,value:j},q()})}cancel(){return this.error(new D.$3)}}e.$ah=N;var H;(function(O){async function j(W){let z;const G=await Promise.all(W.map(ce=>ce.then(de=>de,de=>{z||(z=de)})));if(typeof z<"u")throw z;return G}O.settled=j;function q(W){return new Promise(async(z,G)=>{try{await W(z,G)}catch(ce){G(ce)}})}O.withAsyncBody=q})(H||(e.Promises=H={}));var Y;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Y||(Y={}));class ie{static fromArray(j){return new ie(q=>{q.emitMany(j)})}static fromPromise(j){return new ie(async q=>{q.emitMany(await j)})}static fromPromises(j){return new ie(async q=>{await Promise.all(j.map(async W=>q.emitOne(await W)))})}static merge(j){return new ie(async q=>{await Promise.all(j.map(async W=>{for await(const z of W)q.emitOne(z)}))})}static{this.EMPTY=ie.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$Ld,queueMicrotask(async()=>{const q={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(j(q)),this.j()}catch(W){this.k(W)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,q){return new ie(async W=>{for await(const z of j)W.emitOne(q(z))})}map(j){return ie.map(this,j)}static filter(j,q){return new ie(async W=>{for await(const z of j)q(z)&&W.emitOne(z)})}filter(j){return ie.filter(this,j)}static coalesce(j){return ie.filter(j,q=>!!q)}coalesce(){return ie.coalesce(this)}static async toPromise(j){const q=[];for await(const W of j)q.push(W);return q}toPromise(){return ie.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$bh=ie;class oe extends ie{constructor(j,q){super(q),this.l=j}cancel(){this.l.cancel()}}e.$ch=oe;function T(O){const j=new S.$Vd,q=O(j.token);return new oe(j,async W=>{const z=j.token.onCancellationRequested(()=>{z.dispose(),j.dispose(),W.reject(new D.$3)});try{for await(const G of q){if(j.token.isCancellationRequested)return;W.emitOne(G)}z.dispose(),j.dispose()}catch(G){z.dispose(),j.dispose(),W.reject(G)}})}e.$dh=T}),define(ee[104],te([0,1,23,8,33,31,9,4,27]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=void 0;function a(){return Object.create(null)}e.$oj=a,e.$pj="**",e.$qj="/";const m="[/\\\\]",b="[^/\\\\]",p=/\//g;function d(J,V){switch(J){case 0:return"";case 1:return`${b}*?`;default:return`(?:${m}|${b}+${m}${V?`|${m}${b}+`:""})*?`}}function y(J,V){if(!J)return[];const F=[];let N=!1,H=!1,Y="";for(const ie of J){switch(ie){case V:if(!N&&!H){F.push(Y),Y="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":H=!0;break;case"]":H=!1;break}Y+=ie}return Y&&F.push(Y),F}e.$rj=y;function w(J){if(!J)return"";let V="";const F=y(J,e.$qj);if(F.every(N=>N===e.$pj))V=".*";else{let N=!1;F.forEach((H,Y)=>{if(H===e.$pj){if(N)return;V+=d(2,Y===F.length-1)}else{let ie=!1,oe="",T=!1,O="";for(const j of H){if(j!=="}"&&ie){oe+=j;continue}if(T&&(j!=="]"||!O)){let q;j==="-"?q=j:(j==="^"||j==="!")&&!O?q="^":j===e.$qj?q="":q=(0,f.$De)(j),O+=q;continue}switch(j){case"{":ie=!0;continue;case"[":T=!0;continue;case"}":{const W=`(?:${y(oe,",").map(z=>w(z)).join("|")})`;V+=W,ie=!1,oe="";break}case"]":{V+="["+O+"]",T=!1,O="";break}case"?":V+=b;continue;case"*":V+=d(1);continue;default:V+=(0,f.$De)(j)}}Y<F.length-1&&(F[Y+1]!==e.$pj||Y+2<F.length)&&(V+=m)}N=H===e.$pj})}return V}const $=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Bc(1e4),l=function(){return!1},r=function(){return null};function i(J,V){if(!J)return r;let F;typeof J!="string"?F=J.pattern:F=J,F=F.trim();const N=`${F}_${!!V.trimForExclusions}`;let H=t.get(N);if(H)return n(H,J);let Y;return $.test(F)?H=v(F.substr(4),F):(Y=g.exec(o(F,V)))?H=R(Y[1],F):(V.trimForExclusions?c:h).test(F)?H=A(F,V):(Y=k.exec(o(F,V)))?H=E(Y[1].substr(1),F,!0):(Y=u.exec(o(F,V)))?H=E(Y[1],F,!1):H=I(F),t.set(N,H),n(H,J)}function n(J,V){if(typeof V=="string")return J;const F=function(N,H){return(0,s.$Vf)(N,V.base,!P.$k)?J((0,f.$He)(N.substr(V.base.length),C.sep),H):null};return F.allBasenames=J.allBasenames,F.allPaths=J.allPaths,F.basenames=J.basenames,F.patterns=J.patterns,F}function o(J,V){return V.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function v(J,V){return function(F,N){return typeof F=="string"&&F.endsWith(J)?V:null}}function R(J,V){const F=`/${J}`,N=`\\${J}`,H=function(ie,oe){return typeof ie!="string"?null:oe?oe===J?V:null:ie===J||ie.endsWith(F)||ie.endsWith(N)?V:null},Y=[J];return H.basenames=Y,H.patterns=[V],H.allBasenames=Y,H}function A(J,V){const F=re(J.slice(1,-1).split(",").map(oe=>i(oe,V)).filter(oe=>oe!==r),J),N=F.length;if(!N)return r;if(N===1)return F[0];const H=function(oe,T){for(let O=0,j=F.length;O<j;O++)if(F[O](oe,T))return J;return null},Y=F.find(oe=>!!oe.allBasenames);Y&&(H.allBasenames=Y.allBasenames);const ie=F.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return ie.length&&(H.allPaths=ie),H}function E(J,V,F){const N=C.sep===C.$ec.sep,H=N?J:J.replace(p,C.sep),Y=C.sep+H,ie=C.$ec.sep+J;let oe;return F?oe=function(T,O){return typeof T=="string"&&(T===H||T.endsWith(Y)||!N&&(T===J||T.endsWith(ie)))?V:null}:oe=function(T,O){return typeof T=="string"&&(T===H||!N&&T===J)?V:null},oe.allPaths=[(F?"*/":"./")+J],oe}function I(J){try{const V=new RegExp(`^${w(J)}$`);return function(F){return V.lastIndex=0,typeof F=="string"&&V.test(F)?J:null}}catch{return r}}function M(J,V,F){return!J||typeof V!="string"?!1:U(J)(V,void 0,F)}e.$sj=M;function U(J,V={}){if(!J)return l;if(typeof J=="string"||B(J)){const F=i(J,V);if(F===r)return l;const N=function(H,Y){return!!F(H,Y)};return F.allBasenames&&(N.allBasenames=F.allBasenames),F.allPaths&&(N.allPaths=F.allPaths),N}return ae(J,V)}e.$tj=U;function B(J){const V=J;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$uj=B;function se(J){return J.allBasenames||[]}e.$vj=se;function x(J){return J.allPaths||[]}e.$wj=x;function ae(J,V){const F=re(Object.getOwnPropertyNames(J).map(oe=>ne(oe,J[oe],V)).filter(oe=>oe!==r)),N=F.length;if(!N)return r;if(!F.some(oe=>!!oe.requiresSiblings)){if(N===1)return F[0];const oe=function(j,q){let W;for(let z=0,G=F.length;z<G;z++){const ce=F[z](j,q);if(typeof ce=="string")return ce;(0,D.$Eg)(ce)&&(W||(W=[]),W.push(ce))}return W?(async()=>{for(const z of W){const G=await z;if(typeof G=="string")return G}return null})():null},T=F.find(j=>!!j.allBasenames);T&&(oe.allBasenames=T.allBasenames);const O=F.reduce((j,q)=>q.allPaths?j.concat(q.allPaths):j,[]);return O.length&&(oe.allPaths=O),oe}const H=function(oe,T,O){let j,q;for(let W=0,z=F.length;W<z;W++){const G=F[W];G.requiresSiblings&&O&&(T||(T=(0,C.$lc)(oe)),j||(j=T.substr(0,T.length-(0,C.$mc)(oe).length)));const ce=G(oe,T,j,O);if(typeof ce=="string")return ce;(0,D.$Eg)(ce)&&(q||(q=[]),q.push(ce))}return q?(async()=>{for(const W of q){const z=await W;if(typeof z=="string")return z}return null})():null},Y=F.find(oe=>!!oe.allBasenames);Y&&(H.allBasenames=Y.allBasenames);const ie=F.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return ie.length&&(H.allPaths=ie),H}function ne(J,V,F){if(V===!1)return r;const N=i(J,F);if(N===r)return r;if(typeof V=="boolean")return N;if(V){const H=V.when;if(typeof H=="string"){const Y=(ie,oe,T,O)=>{if(!O||!N(ie,oe))return null;const j=H.replace("$(basename)",()=>T),q=O(j);return(0,D.$Eg)(q)?q.then(W=>W?J:null):q?J:null};return Y.requiresSiblings=!0,Y}}return N}function re(J,V){const F=J.filter(oe=>!!oe.basenames);if(F.length<2)return J;const N=F.reduce((oe,T)=>{const O=T.basenames;return O?oe.concat(O):oe},[]);let H;if(V){H=[];for(let oe=0,T=N.length;oe<T;oe++)H.push(V)}else H=F.reduce((oe,T)=>{const O=T.patterns;return O?oe.concat(O):oe},[]);const Y=function(oe,T){if(typeof oe!="string")return null;if(!T){let j;for(j=oe.length;j>0;j--){const q=oe.charCodeAt(j-1);if(q===47||q===92)break}T=oe.substr(j)}const O=N.indexOf(T);return O!==-1?H[O]:null};Y.basenames=N,Y.patterns=H,Y.allBasenames=N;const ie=J.filter(oe=>!oe.basenames);return ie.push(Y),ie}function Q(J,V){return(0,S.$sb)(J,V,(F,N)=>typeof F=="string"&&typeof N=="string"?F===N:typeof F!="string"&&typeof N!="string"?F.base===N.base&&F.pattern===N.pattern:!1)}e.$xj=Q}),define(ee[46],te([0,1,23,33,9,4,19,27]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=void 0;function f(i,n){const{os:o,tildify:v,relative:R}=n;if(R){const I=a(i,R,o);if(typeof I=="string")return I}let A=i.fsPath;if(o===1&&!L.$i?A=A.replace(/\//g,"\\"):o!==1&&L.$i&&(A=A.replace(/\\/g,"/")),o!==1&&v?.userHome){const I=v.userHome.fsPath;let M;i.scheme!==v.userHome.scheme&&i.path.startsWith(s.$ec.sep)?M=v.userHome.with({path:i.path}).fsPath:M=i.fsPath,A=p(M,I,o)}return(o===1?s.$dc:s.$ec).normalize(m(A,o===1))}e.$jv=f;function a(i,n,o){const v=o===1?s.$dc:s.$ec,R=o===3?C.$jg:C.$lg,A=n.getWorkspace(),E=(0,S.$Mb)(A.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path.startsWith(s.$ec.sep)&&(i=E.uri.with({path:i.path}));const I=n.getWorkspaceFolder(i);if(!I)return;let M;if(R.isEqual(I.uri,i)?M="":M=R.relativePath(I.uri,i)??"",M&&(M=v.normalize(M)),A.folders.length>1&&!n.noPrefix){const U=I.name?I.name:R.basenameOrAuthority(I.uri);M=M?`${U} \u2022 ${M}`:U}return M}function m(i,n=L.$i){return(0,D.$Zf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$kv=m;let b=Object.create(null);function p(i,n,o=L.OS){if(o===1||!i||!n)return i;let v=b.original===n?b.normalized:void 0;v||(v=n,L.$i&&(v=(0,D.$Pf)(v)),v=`${(0,P.$Ie)(v,s.$ec.sep)}${s.$ec.sep}`,b={original:n,normalized:v});let R=i;return L.$i&&(R=(0,D.$Pf)(R)),(o===3?R.startsWith(v):(0,P.$1e)(R,v))?`~/${R.substr(v.length)}`:i}e.$lv=p;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$mv=d;const y="\u2026",w="\\\\",$="~";function g(i,n=s.sep){const o=new Array(i.length);let v=!1;for(let R=0;R<i.length;R++){const A=i[R];if(A===""){o[R]=`.${n}`;continue}if(!A){o[R]=A;continue}v=!0;let E="",I=A;I.indexOf(w)===0?(E=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length)):I.indexOf(n)===0?(E=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf($)===0&&(E=I.substr(0,I.indexOf($)+$.length),I=I.substr(I.indexOf($)+$.length));const M=I.split(n);for(let U=1;v&&U<=M.length;U++)for(let B=M.length-U;v&&B>=0;B--){v=!1;let se=M.slice(B,B+U).join(n);for(let x=0;!v&&x<i.length;x++)if(x!==R&&i[x]&&i[x].indexOf(se)>-1){const ae=B+U===M.length,ne=B>0&&i[x].indexOf(n)>-1?n+se:se,re=i[x].endsWith(ne);v=!ae||re}if(!v){let x="";(M[0].endsWith(":")||E!=="")&&(B===1&&(B=0,U++,se=M[0]+n+se),B>0&&(x=M[0]+n),x=E+x),B>0&&(x=x+y+n),x=x+se,B+U<M.length&&(x=x+n+y),o[R]=x}}v&&(o[R]=A)}return o}e.$nv=g;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function c(i,n=Object.create(null)){const o=[];let v=!1,R="";for(const A of i)if(A==="$"||v&&A==="{")R&&o.push({value:R,type:h.TEXT}),R="",v=!0;else if(A==="}"&&v){const E=n[R];if(typeof E=="string")E.length&&o.push({value:E,type:h.VARIABLE});else if(E){const I=o[o.length-1];(!I||I.type!==h.SEPARATOR)&&o.push({value:E.label,type:h.SEPARATOR})}R="",v=!1}else R+=A;return R&&!v&&o.push({value:R,type:h.TEXT}),o.filter((A,E)=>{if(A.type===h.SEPARATOR){const I=o[E-1],M=o[E+1];return[I,M].every(U=>U&&(U.type===h.VARIABLE||U.type===h.TEXT)&&U.value.length>0)}return!0}).map(A=>A.value).join("")}e.$ov=c;function k(i,n){return L.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$pv=k;function u(i,n){return L.$j||n?i.replace(/\(&&\w\)|&&/g,""):L.$i?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$qv=u;function t(i){return i.replace(/&/g,"&&")}e.$rv=t;function l(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=r(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return r(i)}e.$sv=l;function r(i){const n=i.indexOf("/")!==-1?s.$ec:s.$dc,o=n.basename(i),v=n.dirname(i);return o.length?{name:o,parentPath:v}:{name:v,parentPath:""}}}),define(ee[153],te([0,1,17,7]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function s(b){return b.toJSON()}class L{constructor(p){this.a=p}transformIncoming(p){const d=this.a.transformIncoming(p);return d===p?p:s(D.URI.from(d))}transformOutgoing(p){const d=this.a.transformOutgoing(p);return d===p?p:s(D.URI.from(d))}transformOutgoingURI(p){const d=this.a.transformOutgoing(p);return d===p?p:D.URI.from(d)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Dm=L,e.$Em=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,p,d){if(!b||d>200)return null;if(typeof b=="object"){if(b instanceof D.URI)return p.transformOutgoing(b);for(const y in b)if(Object.hasOwnProperty.call(b,y)){const w=C(b[y],p,d+1);w!==null&&(b[y]=w)}}return null}function P(b,p){const d=C(b,p,0);return d===null?b:d}e.$Fm=P;function f(b,p,d,y){if(!b||y>200)return null;if(typeof b=="object"){if(b.$mid===1)return d?D.URI.revive(p.transformIncoming(b)):p.transformIncoming(b);if(b instanceof S.$_d)return null;for(const w in b)if(Object.hasOwnProperty.call(b,w)){const $=f(b[w],p,d,y+1);$!==null&&(b[w]=$)}}return null}function a(b,p){const d=f(b,p,!1,0);return d===null?b:d}e.$Gm=a;function m(b,p){const d=f(b,p,!0,0);return d===null?b:d}e.$Hm=m}),define(ee[21],te([0,1,45,28,154,8,33,84,9,4,19,7]),function(K,e,S,D,s,L,C,P,f,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function d(ne,re=p.UNLINK,Q){if((0,C.$Yf)(ne))throw new Error("rimraf - will refuse to recursively delete root");return re===p.UNLINK?w(ne):y(ne,Q)}async function y(ne,re=(0,C.$4f)((0,D.tmpdir)())){try{try{await S.promises.rename(ne,re)}catch(Q){return Q.code==="ENOENT"?void 0:w(ne)}w(re).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function w(ne){return(0,s.promisify)(S.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function $(ne){if((0,C.$Yf)(ne))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=$;async function g(ne,re){return k(await(re?h(ne):(0,s.promisify)(S.readdir)(ne)))}async function h(ne){try{return await(0,s.promisify)(S.readdir)(ne,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const re=[],Q=await g(ne);for(const J of Q){let V=!1,F=!1,N=!1;try{const H=await e.Promises.lstat((0,f.$hc)(ne,J));V=H.isFile(),F=H.isDirectory(),N=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}re.push({name:J,isFile:()=>V,isDirectory:()=>F,isSymbolicLink:()=>N})}return re}function c(ne){return k(S.readdirSync(ne))}e.readdirSync=c;function k(ne){return ne.map(re=>typeof re=="string"?a.$j?(0,P.$jl)(re):re:(re.name=a.$j?(0,P.$jl)(re.name):re.name,re))}async function u(ne){const re=await g(ne),Q=[];for(const J of re)await l.existsDirectory((0,f.$hc)(ne,J))&&Q.push(J);return Q}function t(ne,re=1e3){return new Promise(Q=>{let J=!1;const V=setInterval(()=>{J||(J=!0,S.access(ne,F=>{J=!1,F&&(clearInterval(V),Q(void 0))}))},re)})}e.whenDeleted=t;var l;(function(ne){async function re(V){let F;try{if(F=await e.Promises.lstat(V),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(a.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw H}throw N}}ne.stat=re;async function Q(V){try{const{stat:F,symbolicLink:N}=await ne.stat(V);return F.isFile()&&N?.dangling!==!0}catch{}return!1}ne.existsFile=Q;async function J(V){try{const{stat:F,symbolicLink:N}=await ne.stat(V);return F.isDirectory()&&N?.dangling!==!0}catch{}return!1}ne.existsDirectory=J})(l||(e.SymlinkSupport=l={}));const r=new L.$1g;function i(ne,re,Q){return r.queueFor(b.URI.file(ne),m.$kg).queue(()=>{const J=A(Q);return new Promise((V,F)=>v(ne,re,J,N=>N?F(N):V()))})}let n=!0;function o(ne){n=ne}e.configureFlushOnWrite=o;function v(ne,re,Q,J){if(!n)return S.writeFile(ne,re,{mode:Q.mode,flag:Q.flag},J);S.open(ne,Q.flag,Q.mode,(V,F)=>{if(V)return J(V);S.writeFile(F,re,N=>{if(N)return S.close(F,()=>J(N));S.fdatasync(F,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),o(!1)),S.close(F,Y=>J(Y))))})})}function R(ne,re,Q){const J=A(Q);if(!n)return S.writeFileSync(ne,re,{mode:J.mode,flag:J.flag});const V=S.openSync(ne,J.flag,J.mode);try{S.writeFileSync(V,re);try{S.fdatasyncSync(V)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),o(!1)}}finally{S.closeSync(V)}}e.writeFileSync=R;function A(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function E(ne,re,Q=6e4){if(ne!==re)try{a.$i&&typeof Q=="number"?await I(ne,re,Date.now(),Q):await(0,s.promisify)(S.rename)(ne,re)}catch(J){if(ne.toLowerCase()!==re.toLowerCase()&&J.code==="EXDEV"||ne.endsWith("."))await M(ne,re,{preserveSymlinks:!1}),await d(ne,p.MOVE);else throw J}}async function I(ne,re,Q,J,V=0){try{return await(0,s.promisify)(S.rename)(ne,re)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-Q>=J)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${F}`),F;if(V===0){let N=!1;try{const{stat:H}=await l.stat(re);H.isFile()||(N=!0)}catch{}if(N)throw F}return await(0,L.$Sg)(Math.min(100,V*10)),I(ne,re,Q,J,V+1)}}async function M(ne,re,Q){return B(ne,re,{root:{source:ne,target:re},options:Q,handledSourcePaths:new Set})}const U=511;async function B(ne,re,Q){if(Q.handledSourcePaths.has(ne))return;Q.handledSourcePaths.add(ne);const{stat:J,symbolicLink:V}=await l.stat(ne);if(V){if(Q.options.preserveSymlinks)try{return await ae(ne,re,Q)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(V.dangling)return}return J.isDirectory()?se(ne,re,J.mode&U,Q):x(ne,re,J.mode&U)}async function se(ne,re,Q,J){await e.Promises.mkdir(re,{recursive:!0,mode:Q});const V=await g(ne);for(const F of V)await B((0,f.$hc)(ne,F),(0,f.$hc)(re,F),J)}async function x(ne,re,Q){await e.Promises.copyFile(ne,re),await e.Promises.chmod(re,Q)}async function ae(ne,re,Q){let J=await e.Promises.readlink(ne);(0,C.$Vf)(J,Q.root.source,!a.$k)&&(J=(0,f.$hc)(Q.root.target,J.substr(Q.root.source.length+1))),await e.Promises.symlink(J,re)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(ne,re,Q,J,V)=>new Promise((F,N)=>{S.read(ne,re,Q,J,V,(H,Y,ie)=>H?N(H):F({bytesRead:Y,buffer:ie}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(ne,re,Q,J,V)=>new Promise((F,N)=>{S.write(ne,re,Q,J,V,(H,Y,ie)=>H?N(H):F({bytesWritten:Y,buffer:ie}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return d}get rename(){return E}get copy(){return M}}}),define(ee[105],te([0,1,45,9,4,27,21]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0;function P(p){if(s.$k)return p;const d=(0,D.$kc)(p);if(p===d)return p;const y=((0,D.$lc)(p)||p).toLowerCase();try{const $=(0,C.readdirSync)(d).filter(g=>g.toLowerCase()===y);if($.length===1){const g=P(d);if(g)return(0,D.$hc)(g,$[0])}else if($.length>1){const g=$.indexOf(y);if(g>=0){const h=P(d);if(h)return(0,D.$hc)(h,$[g])}}}catch{}return null}e.$Wp=P;async function f(p){if(s.$k)return p;const d=(0,D.$kc)(p);if(p===d)return p;const y=((0,D.$lc)(p)||p).toLowerCase();try{const $=(await C.Promises.readdir(d)).filter(g=>g.toLowerCase()===y);if($.length===1){const g=await f(d);if(g)return(0,D.$hc)(g,$[0])}else if($.length>1){const g=$.indexOf(y);if(g>=0){const h=await f(d);if(h)return(0,D.$hc)(h,$[g])}}}catch{}return null}e.$Xp=f;async function a(p){try{return await C.Promises.realpath(p)}catch{const y=b(p);return await C.Promises.access(y,S.constants.R_OK),y}}e.$Yp=a;function m(p){try{return S.realpathSync(p)}catch{const y=b(p);return S.accessSync(y,S.constants.R_OK),y}}e.$Zp=m;function b(p){return(0,L.$Ie)((0,D.$fc)(p),D.sep)}}),define(ee[106],te([0,1,28,9,21]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0;const L=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(f||(f={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class b{constructor(u,t,l){this.exePath=u,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:k=!1}={}){return k?a===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:k=!1,findPreview:u=!1}={}){const t=p({useAlternateBitness:k});if(!t)return null;const l=D.$hc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(l))return null;let r=-1,i=null;for(const v of await s.Promises.readdir(l)){let R=-1;if(u){const E=v.indexOf("-");if(E<0)continue;const I=v.substring(0,E);if(!L.test(I)||v.substring(E+1)!=="preview")continue;R=parseInt(I,10)}else{if(!L.test(v))continue;R=parseInt(v,10)}if(R<=r)continue;const A=D.$hc(l,v,"pwsh.exe");await s.SymlinkSupport.existsFile(A)&&(i=A,r=R)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=u?" Preview":"";return new b(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const u=D.$hc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=k?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(u))if(t.test(r)){const i=D.$hc(u,r,"pwsh.exe");return new b(i,l)}return null}function w(){const k=D.$hc(S.homedir(),".dotnet","tools","pwsh.exe");return new b(k,".NET Core PowerShell Global Tool")}function $(){const k=D.$hc(process.env.windir,a===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(k,"Windows PowerShell",!0)}async function*g(){let k=await d();k&&(yield k),k=await d({useAlternateBitness:!0}),k&&(yield k),k=await y(),k&&(yield k),k=w(),k&&(yield k),k=await d({findPreview:!0}),k&&(yield k),k=await y({findPreview:!0}),k&&(yield k),k=await d({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=$(),k&&(yield k)}async function*h(){for await(const k of g())await k.exists()&&(yield k)}e.$sl=h;async function c(){for await(const k of h())return k;return null}e.$tl=c}),define(ee[88],te([0,1,9,4,35,73,12,21]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function f(b=s.env){return b.comspec||"cmd.exe"}e.$wl=f;function a(b){let p=[],d=!1;const y=function(w){if(d){p.push(w);return}(!b.send(w,g=>{if(g&&console.error(g),d=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(c=>y(c))}})||D.$i)&&(d=!0)};return{send:y}}e.$xl=a;var m;(function(b){async function p(d,y,w){if(S.$gc(d))return d;if(y===void 0&&(y=s.cwd()),S.$kc(d)!=="."||(w===void 0&&C.$wf(s.env.PATH)&&(w=s.env.PATH.split(S.$rc)),w===void 0||w.length===0))return S.$hc(y,d);async function g(h){if(await P.Promises.exists(h)){let c;try{c=await P.Promises.stat(h)}catch(k){k.message.startsWith("EACCES")&&(c=await P.Promises.lstat(h))}return c?!c.isDirectory():!1}return!1}for(const h of w){let c;if(S.$gc(h)?c=S.$hc(h,d):c=S.$hc(y,h,d),await g(c))return c;let k=c+".com";if(await g(k)||(k=c+".exe",await g(k)))return k}return S.$hc(y,d)}b.findExecutable=p})(m||(e.win32=m={}))}),define(ee[107],te([0,1,47,13]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;function s(C){return new Promise((P,f)=>{let a;const m=new Map;function b(d,y,w,$,g){const h=m.get(y);if(d===C||h){const c={name:p(w),cmd:w,pid:d,ppid:y,load:$,mem:g};m.set(d,c),d===C&&(a=c),h&&(h.children||(h.children=[]),h.children.push(c),h.children.length>1&&(h.children=h.children.sort((k,u)=>k.pid-u.pid)))}}function p(d){const y=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,$=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if($.exec(d))return"electron-crash-reporter";if(g.exec(d))return"winpty-agent";if(h.exec(d))return"conpty-agent";let k=c.exec(d);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?y.exec(d)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const u=/[a-zA-Z-]+\.js/g;let t="";do k=u.exec(d),k&&(t+=k+" ");while(k);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,w)=>{K(["@vscode/windows-process-tree"],y,w)}).then(y=>{y.getProcessList(C,w=>{if(!w){f(new Error(`Root process ${C} not found`));return}y.getProcessCpuUsage(w,$=>{const g=new Map;$.forEach(h=>{const c=d(h.commandLine||"");g.set(h.pid,{name:p(c),cmd:c,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),a=g.get(C),a?(g.forEach(h=>{const c=g.get(h.ppid);c&&(c.children||(c.children=[]),c.children.push(h))}),g.forEach(h=>{h.children&&(h.children=h.children.sort((c,k)=>c.pid-k.pid))}),P(a)):f(new Error(`Root process ${C} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let d=function(){let y=[a];const w=[];for(;y.length;){const g=y.shift();g&&(w.push(g.pid),g.children&&(y=y.concat(g.children)))}let $=JSON.stringify(D.$ag.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+w.join(" "),(0,S.exec)($,{},(g,h,c)=>{if(g||c)f(g||new Error(c.toString()));else{const k=h.toString().split(`
`);for(let u=0;u<w.length;u++){const t=m.get(w[u]);t.load=parseFloat(k[u])}if(!a){f(new Error(`Root process ${C} not found`));return}P(a)}})};(0,S.exec)("which ps",{},(y,w,$)=>{if(y||$)if(process.platform!=="linux")f(y||new Error($.toString()));else{const g=JSON.stringify(D.$ag.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(g,{},(h,c,k)=>{h||k?f(h||new Error(k.toString())):(L(c,b),d())})}else{const g=w.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${g} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,k,u)=>{c||u&&!u.includes("screen size is bogus")?f(c||new Error(u.toString())):(L(k,b),process.platform==="linux"?d():a?P(a):f(new Error(`Root process ${C} not found`)))})}})}})}e.$ur=s;function L(C,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=C.toString().split(`
`);for(const m of a){const b=f.exec(m.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ee[108],te([0,1,28,4,106,88]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=void 0;async function C(b,p){return b===1?D.$i?m():L.$wl(p):f(b,p)}e.$yl=C;let P=null;function f(b,p){if(D.$k&&b===2||D.$j&&b===3)return"/bin/bash";if(!P){let d;if(D.$i)d="/bin/bash";else{if(d=p.SHELL,!d)try{d=(0,S.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}P=d}return P}let a=null;async function m(){return a||(a=(await(0,s.$tl)()).exePath),a}});var ke=this&&this.__decorate||function(K,e,S,D){var s=arguments.length,L=s<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,S):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(K,e,S,D);else for(var P=K.length-1;P>=0;P--)(C=K[P])&&(L=(s<3?C(L):s>3?C(e,S,L):C(e,S))||L);return s>3&&L&&Object.defineProperty(e,S,L),L};define(ee[42],te([0,1,23,8,17,22,54,14,3,2,74,27,12]),function(K,e,S,D,s,L,C,P,f,a,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.ProxyChannel=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.RequestInitiator=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0;var d;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(d||(d={}));function y(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(w||(w={}));function $(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(g||(g={}));function h(V){let F=0;for(let N=0;;N+=7){const H=V.read(1);if(F|=(H.buffer[0]&127)<<N,!(H.buffer[0]&128))return F}}const c=r(0);function k(V,F){if(F===0){V.write(c);return}let N=0;for(let Y=F;Y!==0;Y=Y>>>7)N++;const H=s.$_d.alloc(N);for(let Y=0;F!==0;Y++)H.buffer[Y]=F&127,F=F>>>7,F>0&&(H.buffer[Y]|=128);V.write(H)}class u{constructor(F){this.b=F,this.a=0}read(F){const N=this.b.slice(this.a,this.a+F);return this.a+=N.byteLength,N}}e.$kh=u;class t{constructor(){this.a=[]}get buffer(){return s.$_d.concat(this.a)}write(F){this.a.push(F)}}e.$lh=t;var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(l||(l={}));function r(V){const F=s.$_d.alloc(1);return F.writeUInt8(V,0),F}const i={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},n=typeof Buffer<"u";function o(V,F){if(typeof F>"u")V.write(i.Undefined);else if(typeof F=="string"){const N=s.$_d.fromString(F);V.write(i.String),k(V,N.byteLength),V.write(N)}else if(n&&Buffer.isBuffer(F)){const N=s.$_d.wrap(F);V.write(i.Buffer),k(V,N.byteLength),V.write(N)}else if(F instanceof s.$_d)V.write(i.VSBuffer),k(V,F.byteLength),V.write(F);else if(Array.isArray(F)){V.write(i.Array),k(V,F.length);for(const N of F)o(V,N)}else if(typeof F=="number"&&(F|0)===F)V.write(i.Uint),k(V,F);else{const N=s.$_d.fromString(JSON.stringify(F));V.write(i.Object),k(V,N.byteLength),V.write(N)}}e.$mh=o;function v(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(h(V)).toString();case l.Buffer:return V.read(h(V)).buffer;case l.VSBuffer:return V.read(h(V));case l.Array:{const N=h(V),H=[];for(let Y=0;Y<N;Y++)H.push(v(V));return H}case l.Object:return JSON.parse(V.read(h(V)).toString());case l.Int:return h(V)}}e.$nh=v;class R{constructor(F,N,H=null,Y=1e3){this.h=F,this.j=N,this.k=H,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:200})}registerChannel(F,N){this.b.set(F,N),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const N=this.o([F.type]);this.k?.logOutgoing(N,0,1,$(F.type));return}case 201:case 202:case 204:case 203:{const N=this.o([F.type,F.id],F.data);this.k?.logOutgoing(N,F.id,1,$(F.type),F.data);return}}}o(F,N=void 0){const H=new t;return o(H,F),o(H,N),this.p(H.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const N=new u(F),H=v(N),Y=v(N),ie=H[0];switch(ie){case 100:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(ie)}: ${H[2]}.${H[3]}`,Y),this.s({type:ie,id:H[1],channelName:H[2],name:H[3],arg:Y});case 102:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(ie)}: ${H[2]}.${H[3]}`,Y),this.t({type:ie,id:H[1],channelName:H[2],name:H[3],arg:Y});case 101:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(ie)}`),this.u({type:ie,id:H[1]});case 103:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(ie)}`),this.u({type:ie,id:H[1]})}}s(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const H=new L.$Vd;let Y;try{Y=N.call(this.j,F.name,F.arg,H.token)}catch(T){Y=Promise.reject(T)}const ie=F.id;Y.then(T=>{this.m({id:ie,data:T,type:201})},T=>{T instanceof Error?this.m({id:ie,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.m({id:ie,data:T,type:203})}).finally(()=>{oe.dispose(),this.d.delete(F.id)});const oe=(0,a.$Oc)(()=>H.cancel());this.d.set(F.id,oe)}t(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const H=F.id,ie=N.listen(this.j,F.name,F.arg)(oe=>this.m({id:H,data:oe,type:204}));this.d.set(F.id,ie)}u(F){const N=this.d.get(F.id);N&&(N.dispose(),this.d.delete(F.id))}v(F){let N=this.g.get(F.channelName);N||(N=[],this.g.set(F.channelName,N));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:F,timeoutTimer:H})}w(F){const N=this.g.get(F);if(N){for(const H of N)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Lc)(this.d.values()),this.d.clear()}}e.$oh=R;var A;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class E{constructor(F,N=null){this.l=F,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=N}getChannel(F){const N=this;return{call(H,Y,ie){return N.a?Promise.reject(new P.$3):N.m(F,H,Y,ie)},listen(H,Y){return N.a?f.Event.None:N.o(F,H,Y)}}}m(F,N,H,Y=L.CancellationToken.None){const ie=this.g++,T={id:ie,type:100,channelName:F,name:N,arg:H};if(Y.isCancellationRequested)return Promise.reject(new P.$3);let O;return new Promise((q,W)=>{if(Y.isCancellationRequested)return W(new P.$3);const z=()=>{const ue=fe=>{switch(fe.type){case 201:this.f.delete(ie),q(fe.data);break;case 202:{this.f.delete(ie);const ye=new Error(fe.data.message);ye.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ye.name=fe.data.name,W(ye);break}case 203:this.f.delete(ie),W(fe.data);break}};this.f.set(ie,ue),this.p(T)};let G=null;this.b===g.Idle?z():(G=(0,D.$Fg)(ue=>this.u()),G.then(()=>{G=null,z()}));const ce=()=>{G?(G.cancel(),G=null):this.p({id:ie,type:101}),W(new P.$3)},de=Y.onCancellationRequested(ce);O=(0,a.$Nc)((0,a.$Oc)(ce),de),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(F,N,H){const Y=this.g++,oe={id:Y,type:102,channelName:F,name:N,arg:H};let T=null;const O=new f.$Ld({onWillAddFirstListener:()=>{T=(0,D.$Fg)(q=>this.u()),T.then(()=>{T=null,this.d.add(O),this.p(oe)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.d.delete(O),this.p({id:Y,type:103}))}}),j=q=>O.fire(q.data);return this.f.set(Y,j),O.event}p(F){switch(F.type){case 100:case 102:{const N=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(N,F.id,0,`${y(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const N=this.q([F.type,F.id]);this.j?.logOutgoing(N,F.id,0,y(F.type));return}}}q(F,N=void 0){const H=new t;return o(H,F),o(H,N),this.r(H.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const N=new u(F),H=v(N),Y=v(N),ie=H[0];switch(ie){case 200:return this.j?.logIncoming(F.byteLength,0,0,$(ie)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,H[1],0,$(ie),Y),this.t({type:H[0],id:H[1],data:Y})}}t(F){if(F.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Lc)(this.d.values()),this.d.clear()}}e.$ph=E,ke([C.$eh],E.prototype,"onDidInitializePromise",null);class I{get connections(){const F=[];return this.f.forEach(N=>F.push(N)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new f.$Ld,this.onDidAddConnection=this.g.event,this.h=new f.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new a.$Pc,this.j.add(F(({protocol:N,onDidClientDisconnect:H})=>{const Y=f.Event.once(N.onMessage);this.j.add(Y(ie=>{const oe=new u(ie),T=v(oe),O=new R(N,T),j=new E(N);this.a.forEach((W,z)=>O.registerChannel(z,W));const q={channelServer:O,channelClient:j,ctx:T};this.f.add(q),this.g.fire(q),this.j.add(H(()=>{O.dispose(),j.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(F,N){const H=this;return{call(Y,ie,oe){let T;if((0,p.$Kf)(N)){const j=(0,S.$2b)(H.connections.filter(N));T=j?Promise.resolve(j):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,N))}else T=N.routeCall(H,Y,ie);const O=T.then(j=>j.channelClient.getChannel(F));return U(O).call(Y,ie,oe)},listen(Y,ie){if((0,p.$Kf)(N))return H.k(F,N,Y,ie);const oe=N.routeEvent(H,Y,ie).then(T=>T.channelClient.getChannel(F));return U(oe).listen(Y,ie)}}}k(F,N,H,Y){const ie=this;let oe;const T=new f.$Ld({onWillAddFirstListener:()=>{oe=new a.$Pc;const O=new f.$Rd,j=new Map,q=z=>{const ce=z.channelClient.getChannel(F).listen(H,Y),de=O.add(ce);j.set(z,de)},W=z=>{const G=j.get(z);G&&(G.dispose(),j.delete(z))};ie.connections.filter(N).forEach(q),f.Event.filter(ie.onDidAddConnection,N)(q,void 0,oe),ie.onDidRemoveConnection(W,void 0,oe),O.event(T.fire,T,oe),oe.add(O)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return T.event}registerChannel(F,N){this.a.set(F,N);for(const H of this.f)H.channelServer.registerChannel(F,N)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$qh=I;class M{constructor(F,N,H=null){const Y=new t;o(Y,N),F.send(Y.buffer),this.a=new E(F,H),this.d=new R(F,N,H)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,N){this.d.registerChannel(F,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$rh=M;function U(V){return{call(F,N,H){return V.then(Y=>Y.call(F,N,H))},listen(F,N){const H=new f.$Ud;return V.then(Y=>H.input=Y.listen(F,N)),H.event}}}e.$sh=U;function B(V){let F=!1;return{call(N,H,Y){return F?V.call(N,H,Y):(0,D.$Sg)(0).then(()=>F=!0).then(()=>V.call(N,H,Y))},listen(N,H){if(F)return V.listen(N,H);const Y=new f.$Ud;return(0,D.$Sg)(0).then(()=>F=!0).then(()=>Y.input=V.listen(N,H)),Y.event}}}e.$th=B;class se{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const N of F.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await f.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$uh=se;var x;(function(V){function F(ie,oe,T){const O=ie,j=T&&T.disableMarshalling,q=new Map;for(const W in O)H(W)&&q.set(W,f.Event.buffer(O[W],!0,void 0,oe));return new class{listen(W,z,G){const ce=q.get(z);if(ce)return ce;if(Y(z)){const de=O[z];if(typeof de=="function")return de.call(O,G)}throw new P.$_(`Event not found: ${z}`)}call(W,z,G){const ce=O[z];if(typeof ce=="function"){if(!j&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,m.$jh)(G[ue]);let de=ce.apply(O,G);return de instanceof Promise||(de=Promise.resolve(de)),de}throw new P.$_(`Method not found: ${z}`)}}}V.fromService=F;function N(ie,oe){const T=oe&&oe.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return oe?.properties?.has(j)?oe.properties.get(j):Y(j)?function(q){return ie.listen(j,q)}:H(j)?ie.listen(j):async function(...q){let W;oe&&!(0,p.$Ff)(oe.context)?W=[oe.context,...q]:W=q;const z=await ie.call(j,W);return T?z:(0,m.$jh)(z)};throw new P.$_(`Property not found: ${String(j)}`)}})}V.toService=N;function H(ie){return ie[0]==="o"&&ie[1]==="n"&&b.$Ye(ie.charCodeAt(2))}function Y(ie){return/^onDynamic/.test(ie)&&b.$Ye(ie.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const F=V.toString();if(F!=="[object Object]")return F}return V}function re(V){return Array.isArray(V)?V.map(ne):ne(V)}function Q(V,F,N,H,Y,ie,oe){oe=re(oe);const T=ae[Y],O=T[H%T.length];let j=[`%c[${V}]%c[${String(F).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(ie)?(j=j.concat(oe),j.push(")")):j.push(oe),console.log.apply(console,j)}class J{constructor(F,N){this.d=F,this.f=N,this.a=0,this.b=0}logOutgoing(F,N,H,Y,ie){this.b+=F,Q(this.d,this.b,F,N,H,Y,ie)}logIncoming(F,N,H,Y,ie){this.a+=F,Q(this.f,this.a,F,N,H,Y,ie)}}e.$vh=J}),define(ee[155],te([0,1,17,3,42]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$S=e.$0S=void 0;class L{constructor(f){this.a=f,this.onMessage=D.Event.fromDOMEventEmitter(this.a,"message",a=>S.$_d.wrap(a.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$0S=L;class C extends s.$rh{constructor(f,a){const m=new L(f);super(m,a),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$$S=C}),define(ee[109],te([0,1,17,3,2,42]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=e.$xh=e.ProtocolConstants=e.$wh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function v(A,E){if(!n.has(A)){const I=String(++o);n.set(A,I)}return n.get(A)}function R(A,E,I,M){if(!i.enableDiagnostics)return;const U=v(A,E);if(M instanceof S.$_d||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const B=S.$_d.alloc(M.byteLength);B.set(M),i.records.push({timestamp:Date.now(),id:U,label:E,type:I,buff:B})}else i.records.push({timestamp:Date.now(),id:U,label:E,type:I,data:M})}i.traceSocketEvent=R})(P||(e.SocketDiagnostics=P={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let a=null;function m(){return a||(a=S.$_d.alloc(0)),a}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return m();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return o&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const v=S.$_d.alloc(n);let R=0,A=0;for(;n>0;){const E=this.a[A];if(E.byteLength>n){const I=E.slice(0,n);v.set(I,R),R+=n,o&&(this.a[A]=E.slice(n),this.b-=n),n-=n}else v.set(E,R),R+=E.byteLength,o?(this.a.shift(),this.b-=E.byteLength):A++,n-=E.byteLength}return v}}e.$wh=b;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class w{constructor(n,o,v,R){this.type=n,this.id=o,this.ack=v,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends s.$Qc{constructor(n){super(),this.f=this.B(new D.$Ld),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new b,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,R=this.g.id,A=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new w(v,R,A,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=S.$_d.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const v=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,v}h(){const n=S.$_d.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Qc{constructor(n){super(),this.f=new D.$Ld,this.onMessage=this.f.event,this.g=new D.$Ld,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$xh=h;class c extends L.$rh{static fromSocket(n,o){return new c(new h(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,v=null){super(n,o,v),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$yh=c;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.$Ld({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$zh=k;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,v=this.a;for(;v;)n[o++]=v.data,v=v.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new u(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<l.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=l.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+l.a)*1e3;let v=0;for(let R=0;R<l.a;R++)n-this.c[R]<=o&&v++;return 1-v/l.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??l.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Pc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,m());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,m());this.p.write(n)}sendResume(){const n=new w(8,0,0,m());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new s.$Pc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,m());this.p.write(n);const o=this.b.toArray();for(let v=0,R=o.length;v<R;v++)this.p.write(o[v]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new w(6,0,0,m())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let v=0,R=o.length;v<R;v++)this.p.write(o[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const v=new w(1,o,this.h,n);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(n){const o=new w(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,v=Date.now()-this.q.lastReadTime,R=Date.now()-this.n;if(o>=2e4&&v>=2e4&&R>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:v});return}const A=Math.max(2e4-o,2e4-v,2e4-R,500);this.f=setTimeout(()=>{this.f=null,this.B()},A)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,m());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,m());this.p.write(n)}}e.$Ah=r}),define(ee[38],te([0,1,15,14,13]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7S=void 0;class L{constructor(){this.a=new WeakMap}on(P,f){const a=(m,...b)=>{this.b(P,m)&&f(m,...b)};return this.a.set(f,a),S.ipcMain.on(P,a),this}once(P,f){return S.ipcMain.once(P,(a,...m)=>{this.b(P,a)&&f(a,...m)}),this}handle(P,f){return S.ipcMain.handle(P,(a,...m)=>this.b(P,a)?f(a,...m):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,f){const a=this.a.get(f);return a&&(S.ipcMain.removeListener(P,a),this.a.delete(f)),this}b(P,f){if(!P||!P.startsWith("vscode:"))return(0,D.$Y)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const a=f.senderFrame,m=a.url;if(!m||m==="about:blank")return!0;let b="unknown";try{b=new URL(m).host}catch{return(0,D.$Y)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${m}'.`),!1}return b!==s.$_f?((0,D.$Y)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${b}'.`),!1):a.parent!==null?((0,D.$Y)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$7S=new L}),define(ee[156],te([0,1,15,38,144]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8S=void 0;function L(){D.$7S.on(s.$5S,(P,f,a,m,b)=>{const p=C(P,m,a);p.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{p&&P.sender.send(s.$6S,f)}})})}e.$8S=L;function C(P,f,a){const m=new S.Menu;return a.forEach(b=>{let p;b.type==="separator"?p=new S.MenuItem({type:b.type}):Array.isArray(b.submenu)?p=new S.MenuItem({submenu:C(P,f,b.submenu),label:b.label}):p=new S.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(d,y,w)=>P.sender.send(f,b.id,w)}),m.append(p)}),m}}),define(ee[157],te([0,1,38,17,3,2,42,145]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bT=void 0;function f(m,b){const p=s.Event.fromNodeEventEmitter(S.$7S,b,(y,w)=>({event:y,message:w})),d=s.Event.filter(p,({event:y})=>y.sender.id===m);return s.Event.map(d,({message:y})=>y&&D.$_d.wrap(y))}class a extends C.$qh{static{this.b=new Map}static d(){const b=s.Event.fromNodeEventEmitter(S.$7S,"vscode:hello",({sender:p})=>p);return s.Event.map(b,p=>{const d=p.id;a.b.get(d)?.dispose();const w=new s.$Ld;a.b.set(d,(0,L.$Oc)(()=>w.fire()));const $=f(d,"vscode:message"),g=s.Event.any(s.Event.signal(f(d,"vscode:disconnect")),w.event);return{protocol:new P.$aT(p,$),onDidClientDisconnect:g}})}constructor(){super(a.d())}}e.$bT=a}),define(ee[110],te([0,1,38,3,32,155]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dT=e.$cT=void 0;class C extends L.$$S{constructor(a,m){super({addEventListener:(b,p)=>a.addListener(b,p),removeEventListener:(b,p)=>a.removeListener(b,p),postMessage:b=>a.postMessage(b),start:()=>a.start(),close:()=>a.close()},m)}}e.$cT=C;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,s.$cg)();f.webContents.send("vscode:createMessageChannel",a);const m=D.Event.fromNodeEventEmitter(S.$7S,"vscode:createMessageChannelResult",(p,d)=>({nonce:d,port:p.ports[0]})),{port:b}=await D.Event.toPromise(D.Event.once(D.Event.filter(m,p=>p.nonce===a)));return b}e.$dT=P}),define(ee[158],te([0,1,47,8,17,22,152,14,3,2,37,88,73,42]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0;class y extends d.$oh{constructor(g){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>s.$_d.wrap(Buffer.from(h,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$Tp=y;class w{constructor(g,h){this.i=g,this.j=h,this.c=new Set,this.g=new Map,this.h=new f.$Ld,this.onDidProcessExit=this.h.event;const c=h&&h.timeout?h.timeout:6e4;this.b=new D.$Og(c),this.d=null,this.f=null}getChannel(g){const h=this;return{call(c,k,u){return h.k(g,c,k,u)},listen(c,k){return h.l(g,c,k)}}}k(g,h,c,k=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(P.$4());this.b.cancel();const u=this.n(g),t=(0,D.$Fg)(i=>u.call(h,c,i)),l=k.onCancellationRequested(()=>t.cancel()),r=(0,a.$Oc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{l.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,h,c){if(!this.b)return f.Event.None;this.b.cancel();let k;const u=new f.$Ld({onWillAddFirstListener:()=>{k=this.n(g).listen(h,c)(u.fire,u),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,m.$Xm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$vl)(h.env),this.d=(0,S.fork)(this.i,g,h);const c=new f.$Ld;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$Pp)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}c.fire(s.$_d.wrap(Buffer.from(n,"base64")))});const u=this.j.useQueue?(0,b.$xl)(this.d):this.d,t=n=>this.d&&this.d.connected&&u.send(n.buffer.toString("base64")),l=c.event,r={send:t,onMessage:l};this.f=new d.$ph(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(v=>(0,a.$Lc)(v)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(g){let h=this.g.get(g);return h||(h=this.m.getChannel(g),this.g.set(g,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Up=w}),define(ee[111],te([0,1,8,3,2,74,12]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.StorageState=e.$So=e.StorageHint=void 0;var P;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function f(p){const d=p;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$So=f;var a;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(a||(e.StorageState=a={}));class m extends s.$Qc{static{this.a=100}constructor(d,y=Object.create(null)){super(),this.r=d,this.s=y,this.b=this.B(new D.$Od),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Pg(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((y,w)=>this.w(w,y)),d.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(d,y){if(this.c===a.Closed)return;let w=!1;(0,C.$Ff)(y)?w=this.f.delete(d):this.f.get(d)!==y&&(this.f.set(d,y),w=!0),w&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,y){const w=this.f.get(d);return(0,C.$Ff)(w)?y:w}getBoolean(d,y){const w=this.get(d);return(0,C.$Ff)(w)?y:w==="true"}getNumber(d,y){const w=this.get(d);return(0,C.$Ff)(w)?y:parseInt(w,10)}getObject(d,y){const w=this.get(d);return(0,C.$Ff)(w)?y:(0,L.$ih)(w)}async set(d,y,w=!1){if(this.c===a.Closed)return;if((0,C.$Ff)(y))return this.delete(d,w);const $=(0,C.$yf)(y)||Array.isArray(y)?(0,L.$hh)(y):String(y);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:w}),this.D()}async delete(d,y=!1){if(!(this.c===a.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$To=m;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((y,w)=>this.a.set(w,y)),d.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Uo=b}),define(ee[159],te([0,1,8,3,31,9,21]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zT=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return D.Event.None}static{this.a=2e3}static{this.b=256}constructor(m,b=Object.create(null)){this.g=m,this.h=b,this.c=(0,L.$lc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const m=await this.f,b=new Map;return(await this.s(m,"SELECT * FROM ItemTable")).forEach(d=>b.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(m){const b=await this.f;return this.j(b,m)}j(m,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,s.$wc)(b.insert):"0"}), delete(${b.delete?(0,s.$xc)(b.delete):"0"})`),this.t(m,()=>{const p=b.insert,d=b.delete;if(p&&p.size>0){const y=[];y.push([]);let w=0;p.forEach(($,g)=>{let h=y[w];h.length>P.b&&(w++,h=[],y.push(h)),h.push(g,$)}),y.forEach($=>{this.u(m,`INSERT INTO ItemTable VALUES ${new Array($.length/2).fill("(?,?)").join(",")}`,g=>g.run($),()=>{const g=[];let h=0;return p.forEach((c,k)=>{g.push(k),h+=c.length}),`Keys: ${g.join(", ")} Length: ${h}`})})}if(d&&d.size){const y=[];y.push([]);let w=0;d.forEach($=>{let g=y[w];g.length>P.b&&(w++,g=[],y.push(g)),g.push($)}),y.forEach($=>{this.u(m,`DELETE FROM ItemTable WHERE key IN (${new Array($.length).fill("?").join(",")})`,g=>g.run($),()=>{const g=[];return d.forEach(h=>{g.push(h)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const m=await this.f;return this.q(m,"VACUUM")}async close(m){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,m)}k(m,b){return new Promise((p,d)=>{m.db.close(y=>(y&&this.o(m,`[storage ${this.c}] close(): ${y}`),this.g===P.IN_MEMORY_PATH?p():!m.isErroneous&&!m.isInMemory?this.l().then(p,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),p())):typeof b=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const $=()=>this.k(w,void 0);return this.j(w,{insert:b()}).then(()=>$(),g=>($(),Promise.reject(g)))})).then(p,d):d(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const m=this.m(this.g);return C.Promises.copy(this.g,m,{preserveSymlinks:!1})}m(m){return`${m}.backup`}async checkIntegrity(m){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${m})`);const b=await this.f,p=await this.r(b,m?"PRAGMA integrity_check":"PRAGMA quick_check"),d=m?p.integrity_check:p.quick_check;return b.isErroneous?`${d} (last error: ${b.lastError})`:b.isInMemory?`${d} (in-memory!)`:d}async n(m,b=!0){this.d.trace(`[storage ${this.c}] open(${m}, retryOnBusy: ${b})`);try{return await this.p(m)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&b)return await(0,S.$Sg)(P.a),this.n(m,!1);try{await C.Promises.unlink(m);try{await C.Promises.rename(this.m(m),m,!1)}catch{}return await this.p(m)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(P.IN_MEMORY_PATH)}}}o(m,b){m.isErroneous=!0,m.lastError=b,this.d.error(b)}p(m){return new Promise((b,p)=>{new Promise((d,y)=>{K(["@vscode/sqlite3"],d,y)}).then(d=>{const y={db:new(this.d.isTracing?d.verbose().Database:d.Database)(m,w=>w?y.db&&w.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(w)):p(w):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(y),$=>y.db.close(()=>p($)))),isInMemory:m===P.IN_MEMORY_PATH};y.db.on("error",w=>this.o(y,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&y.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},p)})}q(m,b){return new Promise((p,d)=>{m.db.exec(b,y=>y?(this.o(m,`[storage ${this.c}] exec(): ${y}`),d(y)):p())})}r(m,b){return new Promise((p,d)=>{m.db.get(b,(y,w)=>y?(this.o(m,`[storage ${this.c}] get(): ${y}`),d(y)):p(w))})}s(m,b){return new Promise((p,d)=>{m.db.all(b,(y,w)=>y?(this.o(m,`[storage ${this.c}] all(): ${y}`),d(y)):p(w))})}t(m,b){return new Promise((p,d)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),b(),m.db.run("END TRANSACTION",y=>y?(this.o(m,`[storage ${this.c}] transaction(): ${y}`),d(y)):p())})})}u(m,b,p,d){const y=m.db.prepare(b),w=$=>{this.o(m,`[storage ${this.c}] prepare(): ${$} (${b}). Details: ${d()}`)};y.on("error",w),p(y),y.finalize($=>{$&&w($),y.removeListener("error",w)})}}e.$zT=P;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(m){m&&typeof m.logTrace=="function"&&process.env[f.a]&&(this.b=m.logTrace),m&&typeof m.logError=="function"&&(this.c=m.logError)}get isTracing(){return!!this.b}trace(m){this.b?.(m)}error(m){this.c?.(m)}}}),define(ee[160],te([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(ee[161],te([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[162],te([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[163],te([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(ee[164],te([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[165],te([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[166],te([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(ee[167],te([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(ee[168],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[169],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[170],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[171],te([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[172],te([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[173],te([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(ee[174],te([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(ee[175],te([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(ee[176],te([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[177],te([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[178],te([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[179],te([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[180],te([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[181],te([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(ee[182],te([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(ee[183],te([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[184],te([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ee[185],te([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ee[186],te([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[187],te([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[188],te([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[189],te([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[190],te([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(ee[191],te([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[192],te([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[193],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=e.$pU=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$pU=S;function D(s){return s&&s.hasOwnProperty("workspace")}e.$qU=D}),define(ee[194],te([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=e.$_5b=e.$$5b=void 0;function D(C){return typeof C?.backupFolder=="string"}e.$$5b=D;function s(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(f=>({workspace:{id:f.id,configPath:S.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$_5b=s;function L(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(f=>({folderUri:S.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$a6b=L}),define(ee[195],te([0,1,14,163]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.TokenType=void 0;var s;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(s||(e.TokenType=s={}));function L(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const C=(0,D.localize)(3,null),P=(0,D.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,S.$6)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const b=this.d,p=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:p};this.g.push({offset:b,lexeme:p,additionalInfo:m}),this.f.push(d)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const b=this.c.substring(this.d,this.e),p=f.b.get(b);p?this.k(p):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,b=!1,p=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(P);return}const y=this.c.charCodeAt(m);if(b)b=!1;else if(y===47&&!p){m++;break}else y===91?p=!0:y===92?b=!0:y===93&&(p=!1);m++}for(;m<this.c.length&&f.a.has(this.c.charCodeAt(m));)m++;this.e=m;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Hi=f}),define(ee[196],te([0,1,3,2]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=void 0;class s{constructor(){this.a=new S.$Ld,this.b=new S.$Ld,this.c=new S.$Ld,this.d=new S.$Ld}static{this.ChannelName="extensionhostdebugservice"}call(P,f,a){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(P,f,a){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Dn=s;class L extends D.$Qc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,a){this.b.call("attach",[P,f,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.$En=L}),define(ee[197],te([0,1,147,54,13,9,35,19,7]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,L.$kc)(s.$ag.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,L.$hc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.$tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,S.$9l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$hc)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$tg)(f.URI.file((0,L.$hc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=C.env.VSCODE_PORTABLE;return d?f.URI.file((0,L.$hc)(d,"argv.json")):(0,P.$tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,L.$hc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,L.$ic)(d):(0,L.$fc)((0,L.$hc)(s.$ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,L.$ic)(d)):f.URI.file((0,L.$hc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,L.$ic)(d);const y=C.env.VSCODE_EXTENSIONS;if(y)return y;const w=C.env.VSCODE_PORTABLE;return w?(0,L.$hc)(w,"extensions"):(0,P.$tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,L.$fc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,L.$fc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$0l.test(d))}get extensionLogLevel(){const d=[];for(const y of this.args.log||[]){const w=e.$0l.exec(y);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,P.$tg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=C.env.VSCODE_PORTABLE;return d?f.URI.file((0,L.$hc)(d,"policy.json")):(0,P.$tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,y,w){this.a=d,this.b=y,this.c=w,this.editSessionId=this.args.editSessionId}}e.$$l=a,ke([D.$eh],a.prototype,"appRoot",null),ke([D.$eh],a.prototype,"userHome",null),ke([D.$eh],a.prototype,"userDataPath",null),ke([D.$eh],a.prototype,"appSettingsHome",null),ke([D.$eh],a.prototype,"tmpDir",null),ke([D.$eh],a.prototype,"cacheHome",null),ke([D.$eh],a.prototype,"stateResource",null),ke([D.$eh],a.prototype,"userRoamingDataHome",null),ke([D.$eh],a.prototype,"userDataSyncHome",null),ke([D.$eh],a.prototype,"sync",null),ke([D.$eh],a.prototype,"machineSettingsResource",null),ke([D.$eh],a.prototype,"workspaceStorageHome",null),ke([D.$eh],a.prototype,"localHistoryHome",null),ke([D.$eh],a.prototype,"keyboardLayoutResource",null),ke([D.$eh],a.prototype,"argvResource",null),ke([D.$eh],a.prototype,"isExtensionDevelopment",null),ke([D.$eh],a.prototype,"untitledWorkspacesHome",null),ke([D.$eh],a.prototype,"builtinExtensionsPath",null),ke([D.$eh],a.prototype,"extensionsPath",null),ke([D.$eh],a.prototype,"extensionDevelopmentLocationURI",null),ke([D.$eh],a.prototype,"extensionDevelopmentKind",null),ke([D.$eh],a.prototype,"extensionTestsLocationURI",null),ke([D.$eh],a.prototype,"debugExtensionHost",null),ke([D.$eh],a.prototype,"logLevel",null),ke([D.$eh],a.prototype,"extensionLogLevel",null),ke([D.$eh],a.prototype,"serviceMachineIdResource",null),ke([D.$eh],a.prototype,"disableTelemetry",null),ke([D.$eh],a.prototype,"disableWorkspaceTrust",null),ke([D.$eh],a.prototype,"useInMemorySecretStorage",null),ke([D.$eh],a.prototype,"policyFile",null);function m(p,d){return b(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId,p.extensionEnvironment)}e.$_l=m;function b(p,d,y,w,$,g){const c=Number(d||p)||(w?null:y),k=c?!!d:!1;let u;if(g)try{u=JSON.parse(g)}catch{}return{port:c,break:k,debugId:$,env:u}}e.$am=b}),define(ee[112],te([0,1,306,4,166]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0;const L={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$zl=["tunnel","serve-web"],e.$Al={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,$,g=C){const h=w.find(o=>o.length>0&&o[0]!=="-"),c={},k=["_"],u=[],t={};let l;for(const o in $){const v=$[o];v.type==="subcommand"?o===h&&(l=v):(v.alias&&(c[o]=v.alias),v.type==="string"||v.type==="string[]"?(k.push(o),v.deprecates&&k.push(...v.deprecates)):v.type==="boolean"&&(u.push(o),v.deprecates&&u.push(...v.deprecates)),v.global&&(t[o]=v))}if(l&&h){const o=t;for(const E in l.options)o[E]=l.options[E];const v=w.filter(E=>E!==h),R=g.getSubcommandReporter?g.getSubcommandReporter(h):void 0,A=P(v,o,R);return{[h]:A,_:[]}}const r=S(w,{string:k,boolean:u,alias:c}),i={},n=r;i._=r._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in $){const v=$[o];if(v.type==="subcommand")continue;v.alias&&delete n[v.alias];let R=n[o];if(v.deprecates)for(const A of v.deprecates)n.hasOwnProperty(A)&&(R||(R=n[A],R&&g.onDeprecatedOption(A,v.deprecationMessage||(0,s.localize)(37,null,o))),delete n[A]);if(typeof R<"u"){if(v.type==="string[]"){if(Array.isArray(R)||(R=[R]),!v.allowEmptyValue){const A=R.filter(E=>E.length>0);A.length!==R.length&&(g.onEmptyValue(o),R=A.length>0?A:void 0)}}else v.type==="string"&&(Array.isArray(R)?(R=R.pop(),g.onMultipleValues(o,R)):!R&&!v.allowEmptyValue&&(g.onEmptyValue(o),R=void 0));i[o]=R,v.deprecationMessage&&g.onDeprecatedOption(o,v.deprecationMessage)}delete n[o]}for(const o in n)g.onUnknownOption(o);return i}e.$Bl=P;function f(w,$){let g="";return $.args&&(Array.isArray($.args)?g=` <${$.args.join("> <")}>`:g=` <${$.args}>`),$.alias?`-${$.alias} --${w}${g}`:`--${w}${g}`}function a(w,$){const g=[];for(const h in w){const c=w[h],k=f(h,c);g.push([k,c.description])}return m(g,$)}e.$Cl=a;function m(w,$){const h=w.reduce((u,t)=>Math.max(u,t[0].length),12)+2+1;if($-h<25)return w.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=$-h-1,k=[];for(const u of w){const t=u[0],l=p(u[1],c),r=b(h-t.length-2);k.push("  "+t+r+l[0]);for(let i=1;i<l.length;i++)k.push(b(h)+l[i])}return k}function b(w){return" ".repeat(w)}function p(w,$){const g=[];for(;w.length;){const h=w.length<$?w.length:w.lastIndexOf(" ",$),c=w.slice(0,h).trim();w=w.slice(h),g.push(c)}return g}function d(w,$,g,h,c){const k=process.stdout.isTTY&&process.stdout.columns||80,u=c?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${w} ${g}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${$} [${(0,s.localize)(40,null)}]${u}`),t.push(""),c?.noPipe!==!0&&(D.$i?t.push((0,s.localize)(41,null,$)):t.push((0,s.localize)(42,null,$)),t.push(""));const l={},r=[];for(const i in h){const n=h[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let o=l[n.cat];o||(l[n.cat]=o={}),o[i]=n}}for(const i in l){const n=i,o=l[n];o&&(t.push(L[n]),t.push(...a(o,k)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...m(r.map(i=>[i.command,i.description]),k)),t.push("")),t.join(`
`)}e.$Dl=d;function y(w,$){return`${w||(0,s.localize)(44,null)}
${$||(0,s.localize)(45,null)}
${process.arch}`}e.$El=y}),define(ee[198],te([0,1,87,196,112]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=void 0;class L extends D.$Dn{constructor(P){super(),this.f=P}call(P,f,a){return f==="openExtensionDevelopmentHostWindow"?this.g(a[0],a[1]):super.call(P,f,a)}async g(P,f){const a=(0,s.$Bl)(P,s.$Al);a.debugRenderer=f;const m=a.extensionDevelopmentPath;if(!m)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(m,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!f)return{success:!0};const p=b.win;if(!p)return{success:!0};const d=p.webContents.debugger;let y=d.isAttached()?1/0:0;const w=(0,S.createServer)($=>{y++===0&&d.attach();let g=!1;const h=u=>{g||$.write(JSON.stringify(u)+"\0")},c=(u,t,l,r)=>h({method:t,params:l,sessionId:r});p.on("close",()=>{d.removeListener("message",c),$.end(),g=!0}),d.addListener("message",c);let k=Buffer.alloc(0);$.on("data",u=>{k=Buffer.concat([k,u]);for(let t=k.indexOf(0);t!==-1;t=k.indexOf(0)){let l;try{const r=k.slice(0,t).toString("utf8");k=k.slice(t+1),l=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(l.method,l.params,l.sessionId).then(r=>h({id:l.id,sessionId:l.sessionId,result:r})).catch(r=>h({id:l.id,sessionId:l.sessionId,error:{code:0,message:r.message}}))}}),$.on("error",u=>{console.error("error on cdp pipe:",u)}),$.on("close",()=>{g=!0,--y===0&&d.detach()})});return await new Promise($=>w.listen(0,$)),p.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$h6b=L}),define(ee[63],te([0,1,307,167,112]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0;function L(b,p){const d=(c,k)=>{console.warn((0,D.localize)(0,null,c,k))},y=c=>{console.warn((0,D.localize)(1,null,c))},w=(c,k)=>{console.warn((0,D.localize)(2,null,c,k))},$=c=>({onUnknownOption:k=>{s.$zl.includes(c)||console.warn((0,D.localize)(3,null,k,c))},onMultipleValues:d,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:s.$zl.includes(c)?$:void 0}),g={onUnknownOption:c=>{console.warn((0,D.localize)(4,null,c))},onMultipleValues:d,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:$},h=(0,s.$Bl)(b,s.$Al,p?g:void 0);return h.goto&&h._.forEach(c=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,D.localize)(5,null))),h}function C(b){const p=b.findIndex(d=>!/^-/.test(d));if(p>-1)return[...b.slice(0,p),...b.slice(p+1)]}function P(b){let[,...p]=b;process.env.VSCODE_DEV&&(p=C(p)||[]);const d=!m(process.env);return L(p,d)}e.$Fl=P;function f(b){let[,,...p]=b;return process.env.VSCODE_DEV&&(p=C(p)||[]),L(p,!0)}e.$Gl=f;function a(b,...p){const d=b.indexOf("--");return d===-1?b.push(...p):b.splice(d,0,...p),b}e.$Hl=a;function m(b){return b.VSCODE_CLI==="1"}e.$Il=m}),function(){"use strict";function K(e,S,D){function s(C,P){const f=L(C,P),a=[f];return e.isAbsolute(f)||a.unshift(D),e.resolve(...a)}function L(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const m=C["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:s}}if(typeof define=="function")define(ee[199],te([113,28,35]),function(e,S,D){return K(e,S,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=K(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[89],te([0,1,28,197,199]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=void 0;class L extends D.$$l{constructor(a,m){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(a,m.nameShort)},m)}}e.$bm=L;function C(f,a){return(0,D.$am)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,a,f.extensionEnvironment)}e.$cm=C;function P(f,a){return(0,D.$am)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,a,f.extensionEnvironment)}e.$dm=P}),define(ee[200],te([0,1,45,28,33]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=void 0;function L(C){const P=(0,s.$4f)((0,D.tmpdir)());try{return(0,S.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){C&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$H7b=L}),define(ee[201],te([0,1,12,169]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;function s(C,P,f,a){try{L(C,P,f,a)}catch(m){C.error(m?.message??m)}return P}e.$pp=s;function L(C,P,f,a){const m=(b,p,d)=>{const y=b[p];if((0,S.$wf)(y)){const w=y,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const g=w.substr(1,$-2);let h=f[g];h===void 0&&a&&(h=a[g]);const c=typeof h=="string"?h:h?.message,k=a?.[g],u=typeof k=="string"?k:k?.message;if(!c){u||C.warn(`[${P.name}]: ${(0,D.localize)(0,null,g)}`);return}if(d&&(p==="title"||p==="category")&&u&&u!==c){const t={value:c,original:u};b[p]=t}else b[p]=c}}else if((0,S.$yf)(y))for(const w in y)y.hasOwnProperty(w)&&(w==="commands"?m(y,w,!0):m(y,w,d));else if(Array.isArray(y))for(let w=0;w<y.length;w++)m(y,w,d)};for(const b in P)P.hasOwnProperty(b)&&m(P,b)}}),define(ee[202],te([0,1,19,71,171,203]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||C.test(g)}e.$Do=f;function a(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=g.match(C);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Eo=a;function m(g){if(!g)return null;const h=g.majorBase,c=g.majorMustEqual,k=g.minorBase;let u=g.minorMustEqual;const t=g.patchBase;let l=g.patchMustEqual;g.hasCaret&&(h===0||(u=!1),l=!1);let r=0;if(g.preRelease){const i=P.exec(g.preRelease);if(i){const[,n,o,v]=i;r=Date.UTC(Number(n),Number(o)-1,Number(v))}}return{majorBase:h,majorMustEqual:c,minorBase:k,minorMustEqual:u,patchBase:t,patchMustEqual:l,isMinimum:g.hasGreaterEquals,notBefore:r}}e.$Fo=m;function b(g,h,c){let k;typeof g=="string"?k=m(a(g)):k=g;let u;h instanceof Date?u=h.getTime():typeof h=="string"&&(u=new Date(h).getTime());let t;if(typeof c=="string"?t=m(a(c)):t=c,!k||!t)return!1;const l=k.majorBase,r=k.minorBase,i=k.patchBase;let n=t.majorBase,o=t.minorBase,v=t.patchBase;const R=t.notBefore;let A=t.majorMustEqual,E=t.minorMustEqual,I=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:r>o?!0:r<o||u&&u<R?!1:i>=v:(l===1&&n===0&&(!A||!E||!I)&&(n=1,o=0,v=0,A=!0,E=!1,I=!1),l<n?!1:l>n?!A:r<o?!1:r>o?!E:i<v?!1:i>v?!I:!(u&&u<R))}e.$Go=b;function p(g,h,c,k,u){const t=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return t.push([D.default.Error,s.localize(0,null)]),t;if(typeof k.name!="string")return t.push([D.default.Error,s.localize(1,null,"name")]),t;if(typeof k.version!="string")return t.push([D.default.Error,s.localize(2,null,"version")]),t;if(!k.engines)return t.push([D.default.Error,s.localize(3,null,"engines")]),t;if(typeof k.engines.vscode!="string")return t.push([D.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof k.extensionDependencies<"u"&&!$(k.extensionDependencies))return t.push([D.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof k.activationEvents<"u"){if(!$(k.activationEvents))return t.push([D.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof k.main>"u"&&typeof k.browser>"u")return t.push([D.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&t.push([D.default.Warning,s.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return t.push([D.default.Error,s.localize(9,null,"main")]),t;{const i=(0,S.$tg)(c,k.main);(0,S.$ng)(i,c)||t.push([D.default.Warning,s.localize(10,null,i.path,c.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return t.push([D.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,S.$tg)(c,k.browser);(0,S.$ng)(i,c)||t.push([D.default.Warning,s.localize(12,null,i.path,c.path)])}}if(!L.valid(k.version))return t.push([D.default.Error,s.localize(13,null)]),t;const l=[];if(!d(g,h,k,u,l))for(const i of l)t.push([D.default.Error,i]);return t}e.$Ho=p;function d(g,h,c,k,u){return k||typeof c.main>"u"&&typeof c.browser>"u"?!0:w(g,h,c.engines.vscode,u)}e.$Io=d;function y(g,h,c){return g==="*"||w(h,c,g)}e.$Jo=y;function w(g,h,c,k=[]){const u=m(a(c));if(!u)return k.push(s.localize(14,null,c)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return k.push(s.localize(15,null,c)),!1}else if(!u.majorMustEqual)return k.push(s.localize(16,null,c)),!1;return b(g,h,u)?!0:(k.push(s.localize(17,null,g,c)),!1)}function $(g){if(!Array.isArray(g))return!1;for(let h=0,c=g.length;h<c;h++)if(typeof g[h]!="string")return!1;return!0}}),define(ee[204],te([0,1,17,32]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;async function s(L,C,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const m=(await C.readFile(L.serviceMachineIdResource)).value.toString();f=(0,D.$bg)(m)?m:null}catch{f=null}if(!f){f=(0,D.$cg)();try{await C.writeFile(L.serviceMachineIdResource,S.$_d.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.$4o=s}),define(ee[75],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class S{constructor(s,L=[],C=!1){this.ctor=s,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.$Jh=S}),define(ee[205],te([0,1,75]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.InstantiationType=void 0;const D=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function L(P,f,a){f instanceof S.$Jh||(f=new S.$Jh(f,[],!!a)),D.push([P,f])}e.$or=L;function C(){return D}e.$pr=C}),define(ee[206],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class S{constructor(L,C){this.key=L,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$6p=S;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const C of this.a.values())C.outgoing.size===0&&L.push(C);return L}insertEdge(L,C){const P=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(C);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(L){const C=this.b(L);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(L){const C=this.b(L);let P=this.a.get(C);return P||(P=new S(C,L),this.a.set(C,P)),P}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[C,P]of this.a)L.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,C]of this.a){const P=new Set([L]),f=this.c(C,P);if(f)return f}}c(L,C){for(const[P,f]of L.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const a=this.c(f,C);if(a)return a;C.delete(P)}}}e.$7p=D}),define(ee[6],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=e._util=void 0;var S;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(S||(e._util=S={})),e.$Lh=s("instantiationService");function D(C,P,f){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:C,index:f}):(P[S.DI_DEPENDENCIES]=[{id:C,index:f}],P[S.DI_TARGET]=P)}function s(C){if(S.serviceIds.has(C))return S.serviceIds.get(C);const P=function(f,a,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(P,f,m)};return P.toString=()=>C,S.serviceIds.set(C,P),P}e.$Mh=s;function L(C){return C}e.$Nh=L}),define(ee[64],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=void 0,e.$b6b=(0,S.$Mh)("backupMainService")}),define(ee[18],te([0,1,12,7,6]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.ConfigurationTarget=e.$ii=e.$hi=e.$gi=void 0,e.$gi=(0,s.$Mh)("configurationService");function L(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof D.URI)}e.$hi=L;function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof D.URI)}e.$ii=C;var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function f(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ji=f;function a(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$ki=a;function m(g,h){const c=Object.create(null);for(const k in g)b(c,k,g[k],h);return c}e.$li=m;function b(g,h,c,k){const u=h.split("."),t=u.pop();let l=g;for(let r=0;r<u.length;r++){const i=u[r];let n=l[i];switch(typeof n){case"undefined":n=l[i]=Object.create(null);break;case"object":break;default:k(`Ignoring ${h} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=c}catch{k(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(l)}`)}else k(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(l)}`)}e.$mi=b;function p(g,h){const c=h.split(".");d(g,c)}e.$ni=p;function d(g,h){const c=h.shift();if(h.length===0){delete g[c];return}if(Object.keys(g).indexOf(c)!==-1){const k=g[c];typeof k=="object"&&!Array.isArray(k)&&(d(k,h),Object.keys(k).length===0&&delete g[c])}}function y(g,h,c){function k(l,r){let i=l;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=h.split("."),t=k(g,u);return typeof t>"u"?c:t}e.$oi=y;function w(g,h,c){Object.keys(h).forEach(k=>{k!=="__proto__"&&(k in g?S.$yf(g[k])&&S.$yf(h[k])?w(g[k],h[k],c):c&&(g[k]=h[k]):g[k]=h[k])})}e.$pi=w;function $(g){return g.replace(/[\[\]]/g,"")}e.$qi=$}),define(ee[114],te([0,1,4,27,195,6,162,14]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.ContextKeyExprType=e.$Ii=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$G),f.set("isFirefox",S.$E),f.set("isChrome",S.$D),f.set("isSafari",S.$F);function a(T,O){if(f.get(T)!==void 0)throw(0,P.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(T,O)}e.$Ii=a;const m=Object.prototype.hasOwnProperty;var b;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const p={regexParsingWithErrorRecovery:!0},d=(0,C.localize)(0,null),y=(0,C.localize)(1,null),w=(0,C.localize)(2,null),$=(0,C.localize)(3,null),g=(0,C.localize)(4,null),h=(0,C.localize)(5,null),c=(0,C.localize)(6,null),k=(0,C.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=p){this.k=O,this.d=new s.$Hi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const q=this.D(),W=q.type===17?h:void 0;throw this.h.push({message:g,offset:q.offset,lexeme:s.$Hi.getLexeme(q),additionalInfo:W}),u.c}return j}catch(j){if(j!==u.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,$),j?.negate()}case 17:return this.z(),M.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const j=this.l();return this.A(1,$),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const z=W.lexeme,G=z.lastIndexOf("/"),ce=G===z.length-1?void 0:this.w(z.substring(G+1));let de;try{de=new RegExp(z.substring(1,G),ce)}catch{throw this.B("REGEX",W)}return ne.create(j,de)}switch(W.type){case 10:case 19:{const z=[W.lexeme];this.z();let G=this.D(),ce=0;for(let be=0;be<W.lexeme.length;be++)W.lexeme.charCodeAt(be)===40?ce++:W.lexeme.charCodeAt(be)===41&&ce--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let be=0;be<G.lexeme.length;be++)G.lexeme.charCodeAt(be)===40?ce++:W.lexeme.charCodeAt(be)===41&&ce--}if(ce<0)break;z.push(s.$Hi.getLexeme(G)),this.z(),G=this.D()}const de=z.join(""),ue=de.lastIndexOf("/"),fe=ue===de.length-1?void 0:this.w(de.substring(ue+1));let ye;try{ye=new RegExp(de.substring(1,ue),fe)}catch{throw this.B("REGEX",W)}return t.regex(j,ye)}case 18:{const z=W.lexeme;this.z();let G=null;if(!(0,D.$ze)(z)){const ce=z.indexOf("/"),de=z.lastIndexOf("/");if(ce!==de&&ce>=0){const ue=z.slice(ce+1,de),fe=z[de+1]==="i"?"i":"";try{G=new RegExp(ue,fe)}catch{throw this.B("REGEX",W)}}}if(G===null)throw this.B("REGEX",W);return ne.create(j,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const W=this.u();return t.notIn(j,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return t.equals(j,W);switch(W){case"true":return t.has(j);case"false":return t.not(j);default:return t.equals(j,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return t.notEquals(j,W);switch(W){case"true":return t.not(j);case"false":return t.has(j);default:return t.notEquals(j,W)}}case 5:return this.z(),x.create(j,this.u());case 6:return this.z(),ae.create(j,this.u());case 7:return this.z(),B.create(j,this.u());case 8:return this.z(),se.create(j,this.u());case 13:return this.z(),t.in(j,this.u());default:return t.has(j)}}case 20:throw this.h.push({message:c,offset:O.offset,lexeme:"",additionalInfo:k}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,q){const W=(0,C.localize)(8,null,O,s.$Hi.getLexeme(j)),z=j.offset,G=s.$Hi.getLexeme(j);return this.h.push({message:W,offset:z,lexeme:G,additionalInfo:q}),u.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ji=u;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(O){return v.create(O)}static equals(O,j){return R.create(O,j)}static notEquals(O,j){return I.create(O,j)}static regex(O,j){return ne.create(O,j)}static in(O,j){return A.create(O,j)}static notIn(O,j){return E.create(O,j)}static not(O){return M.create(O)}static and(...O){return J.create(O,null,!0)}static or(...O){return V.create(O,null,!0)}static greater(O,j){return B.create(O,j)}static greaterEquals(O,j){return se.create(O,j)}static smaller(O,j){return x.create(O,j)}static smallerEquals(O,j){return ae.create(O,j)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Ki=t;function l(T){const O=new u({regexParsingWithErrorRecovery:!1});return T.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,C.localize)(9,null,q.additionalInfo):(0,C.localize)(10,null),offset:q.offset,length:q.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}e.$Li=l;function r(T,O){const j=T?T.substituteConstants():void 0,q=O?O.substituteConstants():void 0;return!j&&!q?!0:!j||!q?!1:j.equals(q)}e.$Mi=r;function i(T,O){return T.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return o.INSTANCE}}e.$Ni=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Oi=o;class v{static create(O,j=null){const q=f.get(O);return typeof q=="boolean"?q?o.INSTANCE:n.INSTANCE:new v(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?o.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Pi=v;class R{static create(O,j,q=null){if(typeof j=="boolean")return j?v.create(O,q):M.create(O,q);const W=f.get(O);return typeof W=="boolean"?j===(W?"true":"false")?o.INSTANCE:n.INSTANCE:new R(O,j,q)}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?o.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Qi=R;class A{static create(O,j){return new A(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:H(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),q=O.getValue(this.d);return Array.isArray(j)?j.includes(q):typeof q=="string"&&typeof j=="object"&&j!==null?m.call(j,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Ri=A;class E{static create(O,j){return new E(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=A.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Si=E;class I{static create(O,j,q=null){if(typeof j=="boolean")return j?M.create(O,q):v.create(O,q);const W=f.get(O);return typeof W=="boolean"?j===(W?"true":"false")?n.INSTANCE:o.INSTANCE:new I(O,j,q)}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?n.INSTANCE:o.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Ti=I;class M{static create(O,j=null){const q=f.get(O);return typeof q=="boolean"?q?n.INSTANCE:o.INSTANCE:new M(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:N(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:o.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Ui=M;function U(T,O){if(typeof T=="string"){const j=parseFloat(T);isNaN(j)||(T=j)}return typeof T=="string"||typeof T=="number"?O(T):n.INSTANCE}class B{static create(O,j,q=null){return U(j,W=>new B(O,W,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Vi=B;class se{static create(O,j,q=null){return U(j,W=>new se(O,W,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Wi=se;class x{static create(O,j,q=null){return U(j,W=>new x(O,W,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Xi=x;class ae{static create(O,j,q=null){return U(j,W=>new ae(O,W,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Yi=ae;class ne{static create(O,j){return new ne(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",q=O.f?O.f.source:"";return j<q?-1:j>q?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",q=O.f?O.f.source:"";return this.d===O.d&&j===q}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$Zi=ne;class re{static create(O){return new re(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new re(this.c.map(O))}negate(){return this.c}}e.$1i=re;function Q(T){let O=null;for(let j=0,q=T.length;j<q;j++){const W=T[j].substituteConstants();if(T[j]!==W&&O===null){O=[];for(let z=0;z<j;z++)O[z]=T[z]}O!==null&&(O[j]=W)}return O===null?T:O}class J{static create(O,j,q){return J.d(O,j,q)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,q=this.expr.length;j<q;j++){const W=i(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:J.create(O,this.c,!1)}evaluate(O){for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,q){const W=[];let z=!1;for(const G of O)if(G){if(G.type===1){z=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){W.push(...G.expr);continue}W.push(G)}if(W.length===0&&z)return o.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let G=1;G<W.length;G++)W[G-1].equals(W[G])&&(W.splice(G,1),G--);if(W.length===1)return W[0];for(;W.length>1;){const G=W[W.length-1];if(G.type!==9)break;W.pop();const ce=W.pop(),de=W.length===0,ue=V.create(G.expr.map(fe=>J.create([fe,ce],null,q)),null,de);ue&&(W.push(ue),W.sort(i))}if(W.length===1)return W[0];if(q){for(let G=0;G<W.length;G++)for(let ce=G+1;ce<W.length;ce++)if(W[G].negate().equals(W[ce]))return n.INSTANCE;if(W.length===1)return W[0]}return new J(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new J(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=V.create(O,this,!0)}return this.c}}e.$2i=J;class V{static create(O,j,q){return V.d(O,j,q)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,q=this.expr.length;j<q;j++){const W=i(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:V.create(O,this.c,!1)}evaluate(O){for(let j=0,q=this.expr.length;j<q;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,q){let W=[],z=!1;if(O){for(let G=0,ce=O.length;G<ce;G++){const de=O[G];if(de){if(de.type===0){z=!0;continue}if(de.type===1)return o.INSTANCE;if(de.type===9){W=W.concat(de.expr);continue}W.push(de)}}if(W.length===0&&z)return n.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let G=1;G<W.length;G++)W[G-1].equals(W[G])&&(W.splice(G,1),G--);if(W.length===1)return W[0];if(q){for(let G=0;G<W.length;G++)for(let ce=G+1;ce<W.length;ce++)if(W[G].negate().equals(W[ce]))return o.INSTANCE;if(W.length===1)return W[0]}return new V(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new V(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),q=O.shift(),W=[];for(const z of oe(j))for(const G of oe(q))W.push(J.create([z,G],null,!1));O.unshift(V.create(W,null,!1))}this.c=V.create(O,this,!0)}return this.c}}e.$3i=V;class F extends v{static{this.d=[]}static all(){return F.d.values()}constructor(O,j,q){super(O,null),this.f=j,typeof q=="object"?F.d.push({...q,key:O}):q!==!0&&F.d.push({key:O,description:q,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return R.create(this.key,O)}notEqualsTo(O){return I.create(this.key,O)}}e.$4i=F,e.$5i=(0,L.$Mh)("contextKeyService");function N(T,O){return T<O?-1:T>O?1:0}function H(T,O,j,q){return T<j?-1:T>j?1:O<q?-1:O>q?1:0}function Y(T,O){if(T.type===0||O.type===1)return!0;if(T.type===9)return O.type===9?ie(T.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(Y(T,j))return!0;return!1}if(T.type===6){if(O.type===6)return ie(O.expr,T.expr);for(const j of T.expr)if(Y(j,O))return!0;return!1}return T.equals(O)}e.$6i=Y;function ie(T,O){let j=0,q=0;for(;j<T.length&&q<O.length;){const W=T[j].cmp(O[q]);if(W<0)return!1;W===0&&j++,q++}return j===T.length}function oe(T){return T.type===9?T.expr:[T]}}),define(ee[90],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.ID=void 0,e.ID="diagnosticsService",e.$im=(0,S.$Mh)(e.ID);function D(L){return!!L.hostName&&!!L.errorMessage}e.$jm=D;class s{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$km=s}),define(ee[115],te([0,1,19,71,164,6,46,4,37]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.ConfirmResult=e.$vv=e.$uv=e.$tv=void 0,e.$tv=(0,L.$Mh)("dialogService");var a;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(a||(a={}));class m{a($){return this.d($,a.Confirmation)}b($){return this.d($,a.Prompt)}c($){return this.d($,a.Input)}d($,g){const h=[];switch(g){case a.Confirmation:{const c=$;c.primaryButton?h.push(c.primaryButton):h.push((0,s.localize)(0,null)),c.cancelButton?h.push(c.cancelButton):h.push((0,s.localize)(1,null));break}case a.Prompt:{const c=$;Array.isArray(c.buttons)&&c.buttons.length>0&&h.push(...c.buttons.map(k=>k.label)),c.cancelButton&&(c.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof c.cancelButton=="string"?h.push(c.cancelButton):c.cancelButton.label?h.push(c.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case a.Input:{const c=$;c.primaryButton?h.push(c.primaryButton):h.push((0,s.localize)(5,null)),c.cancelButton?h.push(c.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===D.default.Info?"info":$===D.default.Error?"error":$===D.default.Warning?"warning":"none"}async f($,g,h){const c=[...$.buttons??[]];return $.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&c.push($.cancelButton),{result:await c[g]?.run({checkboxChecked:h}),checkboxChecked:h}}}e.$uv=m,e.$vv=(0,L.$Mh)("fileDialogService");var b;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const p=10;function d(w){const $=[];return $.push(...w.slice(0,p).map(g=>typeof g=="string"?g:(0,S.$qg)(g))),w.length>p&&(w.length-p===1?$.push((0,s.localize)(7,null)):$.push((0,s.localize)(8,null,w.length-p))),$.push(""),$.join(`
`)}e.$wv=d;function y(w,$){const g=(0,f.$Xm)(w);let h=(g.buttons??[]).map(t=>(0,C.$qv)(t)),c=(w.buttons||[]).map((t,l)=>l),k=0,u=g.cancelId??h.length-1;if(h.length>1){const t=typeof u=="number"?h[u]:void 0;if(P.$k||P.$j){if(typeof t=="string"&&h.length>1&&u!==1){h.splice(u,1),h.splice(1,0,t);const l=c[u];c.splice(u,1),c.splice(1,0,l),u=1}P.$k&&h.length>1&&(h=h.reverse(),c=c.reverse(),k=h.length-1,typeof t=="string"&&(u=k-1))}else if(P.$i&&typeof t=="string"&&h.length>1&&u!==h.length-1){h.splice(u,1),h.push(t);const l=c[u];c.splice(u,1),c.push(l),u=h.length-1}}return g.buttons=h,g.defaultId=k,g.cancelId=u,g.noLink=!0,g.title=g.title||$.nameLong,{options:g,buttonIndeces:c}}e.$xv=y}),define(ee[116],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QT=e.$PT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$OT=e.$NT=void 0,e.$NT=(0,S.$Mh)("encryptionService"),e.$OT=(0,S.$Mh)("encryptionMainService");var D;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(D||(e.PasswordStoreCLIOption=D={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function L(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$PT=L;function C(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$QT=C}),define(ee[36],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=void 0,e.$Th=(0,S.$Mh)("environmentService"),e.$Uh=(0,S.$Nh)(e.$Th)}),define(ee[117],te([0,1,168,6]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$2n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0,e.$On="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Pn=new RegExp(e.$On),e.$Qn="__web_extension",e.$Rn="skipWalkthrough",e.$Sn="extensionsSync",e.$Tn="dependecyOrPackExtensionInstall";function s(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Un=s;function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Vn=L;function C(h,c){switch(h){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Wn=C;function P(h,c){return c==="web"&&!h.includes("web")}e.$Xn=P;function f(h,c,k){return P(c,k)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===k?!0:a(k).includes(h)}e.$Yn=f;function a(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Zn=a;function m(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$1n=m;var b;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var p;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var y;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$2n=(0,D.$Mh)("extensionGalleryService");var w;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var $;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class g extends Error{constructor(c,k){super(c),this.code=k,this.name=k}}e.$3n=g,e.$4n=(0,D.$Mh)("extensionManagementService"),e.$5n="extensionsIdentifiers/disabled",e.$6n="extensionsIdentifiers/enabled",e.$7n=(0,D.$Mh)("IGlobalExtensionEnablementService"),e.$8n=(0,D.$Mh)("IExtensionTipsService"),e.$9n=(0,S.localize)(0,null),e.$0n={value:e.$9n,original:"Extensions"},e.$$n={value:(0,S.localize)(1,null),original:"Preferences"}}),define(ee[207],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=void 0,e.$v6b=(0,S.$Mh)("extensionHostStarter"),e.$w6b="extensionHostStarter"}),define(ee[208],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OXb=e.$NXb=void 0,e.$NXb=(0,S.$Mh)("externalTerminal"),e.$OXb="Terminal.app"}),define(ee[209],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=void 0,e.$y6b=(0,S.$Mh)("externalTerminal")}),define(ee[210],te([0,1,47,13,9,4,73,21,88,172,208]),function(K,e,S,D,s,L,C,P,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=e.$A6b=e.$z6b=void 0;const b=a.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends p{static{this.b="cmd.exe"}openTerminal(k,u){return this.spawnTerminal(S,k,f.$wl(),u)}spawnTerminal(k,u,t,l){const r=u.windowsExec||d.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=s.$lc(r,".exe").toLowerCase();if(i==="cmder")return k.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((o,v)=>{const R=$(process),A=k.spawn(t,n,{cwd:l,env:R});A.on("error",v),A.on("exit",()=>o())})}runInTerminal(k,u,t,l,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:d.getDefaultTerminalWindows();return new Promise((n,o)=>{const v=`"${u} - ${b}"`,R=`""${t.join('" "')}" & pause"`,A=Object.assign({},$(process),l);Object.keys(A).filter(B=>A[B]===null).forEach(B=>delete A[B]);const E={cwd:u,env:A,windowsVerbatimArguments:!0};let I,M;s.$lc(i,".exe")==="wt"?(I=i,M=["-d",".",d.b,"/c",R]):(I=d.b,M=["/c","start",v,"/wait",i,"/c",R]),S.spawn(I,M,E).on("error",B=>{o(g(B))}),n(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const k=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${k?"Sysnative":"System32"}\\cmd.exe`}return d.d}}e.$z6b=d;class y extends p{static{this.b="/usr/bin/osascript"}openTerminal(k,u){return this.spawnTerminal(S,k,u)}runInTerminal(k,u,t,l,r){const i=r.osxExec||m.$OXb;return new Promise((n,o)=>{if(i===m.$OXb||i==="iTerm.app"){const v=i===m.$OXb?"TerminalHelper":"iTermHelper",A=[D.$ag.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",k||b,"-w",u];for(const M of t)A.push("-a"),A.push(M);if(l){const M=Object.assign({},$(process),l);for(const U in M){const B=M[U];B===null?(A.push("-u"),A.push(U)):(A.push("-e"),A.push(`${U}=${B}`))}}let E="";const I=S.spawn(y.b,A);I.on("error",M=>{o(g(M))}),I.stderr.on("data",M=>{E+=M.toString()}),I.on("exit",M=>{if(M===0)n(void 0);else if(E){const U=E.split(`
`,1);o(new Error(U[0]))}else o(new Error(a.localize(1,null,v,M)))})}else o(new Error(a.localize(2,null,i)))})}spawnTerminal(k,u,t){const l=u.osxExec||m.$OXb;return new Promise((r,i)=>{const n=["-a",l];t&&n.push(t);const o=$(process),v=k.spawn("/usr/bin/open",n,{cwd:t,env:o});v.on("error",i),v.on("exit",()=>r())})}}e.$A6b=y;class w extends p{static{this.b=a.localize(3,null)}openTerminal(k,u){return this.spawnTerminal(S,k,u)}runInTerminal(k,u,t,l,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const v=[];i.then(R=>{R.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const A=`${h(t)}; echo; read -p "${w.b}" -n1;`;v.push(`''${A}''`);const E=Object.assign({},$(process),l);Object.keys(E).filter(B=>E[B]===null).forEach(B=>delete E[B]);const I={cwd:u,env:E};let M="";const U=S.spawn(R,v,I);U.on("error",B=>{o(g(B))}),U.stderr.on("data",B=>{M+=B.toString()}),U.on("exit",B=>{if(B===0)n(void 0);else if(M){const se=M.split(`
`,1);o(new Error(se[0]))}else o(new Error(a.localize(4,null,R,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!L.$k)w.d=Promise.resolve("xterm");else{const k=await P.Promises.exists("/etc/debian_version");w.d=new Promise(u=>{k?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return w.d}spawnTerminal(k,u,t){const l=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{l.then(n=>{const o=$(process),v=k.spawn(n,[],{cwd:t,env:o});v.on("error",i),v.on("exit",()=>r())})})}}e.$B6b=w;function $(c){const k={...c.env};return(0,C.$ul)(k),k}function g(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(a.localize(5,null,c.path)):c}function h(c){let k="";for(const u of c)u.indexOf(" ")>=0?k+='"'+u+'"':k+=u,k+=" ";return k}}),define(ee[16],te([0,1,56,9,27,12,7,174,6,4,13]),function(K,e,S,D,s,L,C,P,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileKind=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileOperationResult=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileChangeType=e.$mk=e.FileOperation=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileSystemProviderErrorCode=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$9j=e.$8j=void 0,e.$8j=(0,f.$Mh)("fileService");function b(N){return N.create===!0}e.$9j=b;var p;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var d;(function(N){N[N.Readonly=1]="Readonly",N[N.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var y;(function(N){N[N.None=0]="None",N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileAtomicWrite=32768]="FileAtomicWrite",N[N.FileAtomicDelete=65536]="FileAtomicDelete",N[N.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function w(N){return!!(N.capabilities&2)}e.$0j=w;function $(N){return!!(N.capabilities&8)}e.$$j=$;function g(N){return!!(N.capabilities&131072)}e.$_j=g;function h(N){return!!(N.capabilities&4)}e.$ak=h;function c(N){return!!(N.capabilities&16)}e.$bk=c;function k(N){return w(N)?!!(N.capabilities&16384):!1}e.$ck=k;function u(N){return w(N)?!!(N.capabilities&32768):!1}e.$dk=u;function t(N){return!!(N.capabilities&65536)}e.$ek=t;function l(N){return!!(N.capabilities&2048)}e.$fk=l;var r;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsStorageQuota="EntryExceedsStorageQuota",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(H,Y){const ie=new i(H.toString(),Y);return v(ie,Y),ie}constructor(H,Y){super(H),this.code=Y}}e.$gk=i;function n(N,H){return i.create(N,H)}e.$hk=n;function o(N){return N||n((0,P.localize)(0,null),r.Unknown)}e.$ik=o;function v(N,H){return N.name=H?`${H} (FileSystemError)`:"FileSystemError",N}e.$jk=v;function R(N){if(!N)return r.Unknown;if(N instanceof i)return N.code;const H=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!H)return r.Unknown;switch(H[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$kk=R;function A(N){if(N instanceof se)return N.fileOperationResult;switch(R(N)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$lk=A;var E;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(E||(e.FileOperation=E={}));class I{constructor(H,Y,ie){this.resource=H,this.operation=Y,this.target=ie}isOperation(H){return this.operation===H}}e.$mk=I;var M;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class U{constructor(H,Y){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const oe of H){const T=ie.get(oe.type);switch(T?T.push([oe.resource,oe]):ie.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,T]of ie)switch(oe){case 1:this.a=S.$Sh.forUris(()=>Y),this.a.fill(T);break;case 0:this.b=S.$Sh.forUris(()=>Y),this.b.fill(T);break;case 2:this.c=S.$Sh.forUris(()=>Y),this.c.fill(T);break}}contains(H,...Y){return this.d(H,{includeChildren:!1},...Y)}affects(H,...Y){return this.d(H,{includeChildren:!0},...Y)}d(H,Y,...ie){if(!H)return!1;const oe=ie.length>0;return!!((!oe||ie.includes(1))&&(this.a?.get(H)||Y.includeChildren&&this.a?.findSuperstr(H))||(!oe||ie.includes(0))&&(this.b?.get(H)||Y.includeChildren&&this.b?.findSuperstr(H))||(!oe||ie.includes(2))&&(this.c?.findSubstr(H)||Y.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$nk=U;function B(N,H,Y){return!N||!H||N===H||H.length>N.length?!1:(H.charAt(H.length-1)!==D.sep&&(H+=D.sep),Y?(0,s.$1e)(N,H):N.indexOf(H)===0)}e.$ok=B;class se extends Error{constructor(H,Y,ie){super(H),this.fileOperationResult=Y,this.options=ie}}e.$pk=se;class x extends se{constructor(H,Y,ie,oe){super(H,Y,oe),this.fileOperationResult=Y,this.size=ie}}e.$qk=x;class ae extends se{constructor(H,Y,ie){super(H,2,ie),this.stat=Y}}e.$rk=ae;var ne;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$sk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$uk="files.associations",e.$vk="files.exclude",e.$wk="files.readonlyInclude",e.$xk="files.readonlyExclude",e.$yk="files.readonlyFromPermissions";var re;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(e.FileKind=re={})),e.$zk="";function Q(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.$Ak=Q;async function J(N,H){if(!H.hasProvider(C.URI.from({scheme:N.scheme})))return new Promise(Y=>{const ie=H.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===N.scheme&&oe.added&&(ie.dispose(),Y())})})}e.$Bk=J;class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(H){return(0,L.$Af)(H)||(H=0),H<V.KB?(0,P.localize)(1,null,H.toFixed(0)):H<V.MB?(0,P.localize)(2,null,(H/V.KB).toFixed(2)):H<V.GB?(0,P.localize)(3,null,(H/V.MB).toFixed(2)):H<V.TB?(0,P.localize)(4,null,(H/V.GB).toFixed(2)):(0,P.localize)(5,null,(H/V.TB).toFixed(2))}}e.$Ck=V;function F(N){const H=typeof N=="string"||N?.scheme===m.Schemas.vscodeRemote;return typeof N!="string"&&N?.scheme===m.Schemas.file?1024*V.MB:H?10*V.MB:a.$o?50*V.MB:1024*V.MB}e.$Dk=F}),define(ee[211],te([0,1,17,49,14,3,2,62,7,32,16]),function(K,e,S,D,s,L,C,P,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0,e.$bN="localFilesystem";class b extends C.$Qc{constructor(d,y){super(),this.a=d,this.b=y,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$Ld),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$Ld),this.onDidWatchError=this.g.event,this.h=(0,a.$cg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,y){const{buffer:w}=await this.a.call("readFile",[d,y]);return w}readFileStream(d,y,w){const $=(0,P.$Zd)(h=>S.$_d.concat(h.map(c=>S.$_d.wrap(c))).buffer),g=new C.$Pc;return g.add(this.a.listen("readFileStream",[d,y])(h=>{if(h instanceof S.$_d)$.write(h.buffer);else{if(h==="end")$.end();else{let c;if(h instanceof Error)c=h;else{const k=h;c=(0,m.$hk)(k.message??(0,D.$xi)(k),k.code??m.FileSystemProviderErrorCode.Unknown)}$.error(c),$.end()}g.dispose()}})),g.add(w.onCancellationRequested(()=>{$.error((0,s.$4)()),$.end(),g.dispose()})),$}writeFile(d,y,w){return this.a.call("writeFile",[d,S.$_d.wrap(y),w])}open(d,y){return this.a.call("open",[d,y])}close(d){return this.a.call("close",[d])}async read(d,y,w,$,g){const[h,c]=await this.a.call("read",[d,y,g]);return w.set(h.buffer.slice(0,c),$),c}write(d,y,w,$,g){return this.a.call("write",[d,y,S.$_d.wrap(w),$,g])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,y){return this.a.call("delete",[d,y])}rename(d,y,w){return this.a.call("rename",[d,y,w])}copy(d,y,w){return this.a.call("copy",[d,y,w])}cloneFile(d,y){return this.a.call("cloneFile",[d,y])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const y=d;this.f.fire(y.map(w=>({resource:f.URI.revive(w.resource),type:w.type})))}else{const y=d;this.g.fire(y)}}))}watch(d,y){const w=(0,a.$cg)();return this.a.call("watch",[this.h,w,d,y]),(0,C.$Oc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$cN=b}),define(ee[118],te([0,1,17,14,175,16]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;async function C(m,b,p,d,y,w){let $;try{await P(m,b,p,d,y,w)}catch(g){$=g}finally{$&&y.errorTransformer&&($=y.errorTransformer($)),typeof $<"u"&&p.error($),p.end()}}e.$Ep=C;async function P(m,b,p,d,y,w){f(w);const $=await m.open(b,{create:!1});try{f(w);let g=0,h=0,c=y&&typeof y.length=="number"?y.length:void 0,k=S.$_d.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),u=y&&typeof y.position=="number"?y.position:0,t=0;do h=await m.read($,u,k.buffer,t,k.byteLength-t),u+=h,t+=h,g+=h,typeof c=="number"&&(c-=h),t===k.byteLength&&(await p.write(d(k)),k=S.$_d.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),t=0);while(h>0&&(typeof c!="number"||c>0)&&f(w)&&a(g,y));if(t>0){let l=t;typeof c=="number"&&(l=Math.min(t,c)),p.write(d(k.slice(0,l)))}}catch(g){throw(0,L.$ik)(g)}finally{await m.close($)}}function f(m){if(m.isCancellationRequested)throw(0,D.$4)();return!0}function a(m,b){if(typeof b?.limits?.size=="number"&&m>b.limits.size)throw(0,L.$hk)((0,s.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ee[76],te([0,1,104,2,9,4,7,16]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=void 0;function f(g){return g.recursive===!0}e.$Gp=f;class a extends D.$Qc{static{this.a=5}constructor(h,c,k,u){super(),this.h=h,this.j=c,this.m=k,this.n=u,this.c=this.B(new D.$Rc),this.f=void 0,this.g=0}s(){const h=new D.$Pc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(c=>this.h(c))),h.add(this.b.onDidLogMessage(c=>this.j(c))),h.add(this.b.onDidError(c=>this.t(c)))}t(h){this.n.restartOnError?this.g<a.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Hp=a;class m extends a{constructor(h,c,k){super(h,c,k,{type:"node.js",restartOnError:!1})}}e.$Ip=m;class b extends a{constructor(h,c,k){super(h,c,k,{type:"universal",restartOnError:!0})}}e.$Jp=b;function p(g){return g.map(h=>({type:h.type,resource:C.URI.revive(h.resource)}))}e.$Kp=p;function d(g){const h=new $;for(const c of g)h.processEvent(c);return h.coalesce()}e.$Lp=d;function y(g,h){return typeof h=="string"&&!h.startsWith(S.$pj)&&!(0,s.$gc)(h)?{base:g,pattern:h}:h}e.$Mp=y;function w(g,h){const c=[];for(const k of h)c.push((0,S.$tj)(y(g,k)));return c}e.$Np=w;class ${constructor(){this.a=new Set,this.b=new Map}c(h){return L.$k?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const c=this.b.get(this.c(h));let k=!1;if(c){const u=c.type,t=h.type;c.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?k=!0:u===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(c)):u===2&&t===1?c.type=0:u===1&&t===0||(c.type=t)}else k=!0;k&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],c=[];return Array.from(this.a).filter(k=>k.type!==2?(h.push(k),!1):!0).sort((k,u)=>k.resource.fsPath.length-u.resource.fsPath.length).filter(k=>c.some(u=>(0,P.$ok)(k.resource.fsPath,u,!L.$k))?!1:(c.push(k.resource.fsPath),!0)).concat(h)}}}),define(ee[212],te([0,1,45,8,22,33,2,84,9,4,7,105,21,76]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class y extends C.$Qc{static{this.a=100}static{this.b=75}constructor(g,h,c,k){super(),this.m=g,this.n=h,this.r=c,this.s=k,this.c=this.B(new D.$7g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.n(u))),this.f=this.B(new D.$6g(u=>this.z(u),y.b)),this.g=(0,d.$Np)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$Np)(this.m.path,this.m.includes):void 0,this.j=new s.$Vd,this.ready=this.t()}async t(){try{const g=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await p.Promises.stat(g);this.B(await this.w(g,h.isDirectory()))}catch(g){g.code!=="ENOENT"?this.D(g):this.G(g)}}async u(g){let h=g.path;try{h=await p.Promises.realpath(g.path),g.path===h&&(h=await(0,b.$Xp)(g.path)??g.path),g.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${h})`)}catch{}return h}async w(g,h){if(a.$j&&(0,L.$Vf)(g,"/Volumes/",!0))return this.D(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Qc.None;const c=new s.$Vd(this.j.token),k=new C.$Pc;try{const u=(0,f.$lc)(g),t=(0,S.watch)(g);k.add((0,C.$Oc)(()=>{t.removeAllListeners(),t.close()})),this.G(`Started watching: '${g}'`);const l=new Set;if(h)try{for(const i of await p.Promises.readdir(g))l.add(i)}catch(i){this.D(i)}const r=new Map;k.add((0,C.$Oc)(()=>{for(const[,i]of r)i.dispose();r.clear()})),t.on("error",(i,n)=>{this.D(`Failed to watch ${g} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),t.on("change",(i,n)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),a.$j&&(o=(0,P.$jl)(o))),!(!o||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){r.get(o)?.dispose();const v=setTimeout(async()=>{if(r.delete(o),o===u&&!await p.Promises.exists(g)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const R=await this.C((0,f.$hc)(g,o));if(c.token.isCancellationRequested)return;let A;R?l.has(o)?A=0:(A=1,l.add(o)):(l.delete(o),A=2),this.y({resource:m.URI.file((0,f.$hc)(this.m.path,o)),type:A})},y.a);r.set(o,(0,C.$Oc)(()=>clearTimeout(v)))}else{let v;l.has(o)?v=0:(v=1,l.add(o)),this.y({resource:m.URI.file((0,f.$hc)(this.m.path,o)),type:v})}else if(i==="rename"||o!==u){const v=setTimeout(async()=>{const R=await p.Promises.exists(g);c.token.isCancellationRequested||(R?(this.y({resource:m.URI.file(this.m.path),type:0},!0),k.add(await this.w(g,!1))):(this.y({resource:m.URI.file(this.m.path),type:2},!0),this.f.flush(),this.dispose()))},y.a);k.clear(),k.add((0,C.$Oc)(()=>clearTimeout(v)))}else this.y({resource:m.URI.file(this.m.path),type:0},!0)})}catch(u){await p.Promises.exists(g)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${g} for changes using fs.watch() (${u.toString()})`)}return(0,C.$Oc)(()=>{c.dispose(!0),k.dispose()})}y(g,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!h&&this.g.some(c=>c(g.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${g.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(c=>c(g.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}z(g){const h=(0,d.$Lp)(g);if(h.length>0){if(this.s)for(const k of h)this.G(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(g){if(a.$k)return p.Promises.exists(g);try{const h=(0,f.$lc)(g);return(await p.Promises.readdir((0,f.$kc)(g))).some(k=>k===h)}catch(h){return this.G(h),!1}}setVerboseLogging(g){this.s=g}D(g){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}F(g){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}G(g){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$1p=y;async function w($,g,h,c,k=512){const u=await p.Promises.open($,"r"),t=Buffer.allocUnsafe(k),l=new s.$Vd(c);let r,i=!1;const n={path:$,excludes:[],recursive:!1},o=new y(n,v=>{(async()=>{for(const{type:R}of v)if(R===0){if(i)return;i=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:A}=await p.Promises.read(u,t,0,k,null);if(!A||l.token.isCancellationRequested)break;g(t.slice(0,A))}}catch(A){r=new Error(A),l.dispose(!0)}finally{i=!1}}})()});return await o.ready,h(),new Promise((v,R)=>{l.token.onCancellationRequested(async()=>{o.dispose();try{await p.Promises.close(u)}catch(A){r=new Error(A)}r?R(r):v()})})}e.$2p=w}),define(ee[213],te([0,1,3,104,2,4,212]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class P extends s.$Qc{constructor(){super(...arguments),this.a=this.B(new S.$Ld),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Ld),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(a){const m=this.j(a),b=m.filter(d=>{const y=this.c.get(d.path);return y?!(0,D.$xj)(y.request.excludes,d.excludes)||!(0,D.$xj)(y.request.includes,d.includes):!0}),p=Array.from(this.c.values()).filter(({request:d})=>!m.find(y=>y.path===d.path&&(0,D.$xj)(y.excludes,d.excludes)&&(0,D.$xj)(y.includes,d.includes))).map(({request:d})=>d.path);b.length&&this.m(`Request to start watching: ${b.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const d of p)this.h(d);for(const d of b)this.g(d)}g(a){const m=new C.$1p(a,p=>this.a.fire(p),p=>this.b.fire(p),this.f),b={request:a,instance:m};this.c.set(a.path,b)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const m=this.c.get(a);m&&(this.c.delete(a),m.instance.dispose())}j(a){const m=new Map;for(const b of a){const p=L.$k?b.path:b.path.toLowerCase();m.set(p,b)}return Array.from(m.values())}async setVerboseLogging(a){this.f=a;for(const[,m]of this.c)m.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,m){return m?`[File Watcher (node.js)] ${a} (path: ${m.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$3p=P}),define(ee[214],te([0,1,76,213]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class s extends S.$Ip{constructor(C,P,f){super(C,P,f),this.s()}r(C){return C.add(new D.$3p)}}e.$4p=s}),define(ee[215],te([0,1,13,42,158,76]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;class C extends L.$Jp{constructor(f,a,m){super(f,a,m),this.s()}r(f){const a=f.add(new s.$Up(S.$ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(a.onDidProcessExit(({code:m,signal:b})=>this.t(`terminated by itself with code ${m}, signal: ${b}`))),D.ProxyChannel.toService((0,D.$th)(a.getChannel("watcher")))}}e.$Vp=C}),define(ee[91],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class S{constructor(...s){this.a=new Map;for(const[L,C]of s)this.set(L,C)}set(s,L){const C=this.a.get(s);return this.a.set(s,L),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Kh=S}),define(ee[216],te([0,1,8,14,2,75,206,6,91,101]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;const m=!1;class b extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class p{constructor($=new f.$Kh,g=!1,h,c=m){this.f=$,this.g=g,this.h=h,this.i=c,this.o=new Set,this.f.set(P.$Lh,this),this._globalGraph=c?h?._globalGraph??new C.$7p(k=>k):void 0}createChild($){return new p($,this.g,this,this.i)}invokeFunction($,...g){const h=y.traceInvocation(this.i,$);let c=!1;try{return $({get:u=>{if(c)throw(0,D.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(u,h);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...g)}finally{c=!0,h.stop()}}createInstance($,...g){let h,c;return $ instanceof L.$Jh?(h=y.traceCreation(this.i,$.ctor),c=this.j($.ctor,$.staticArguments.concat(g),h)):(h=y.traceCreation(this.i,$),c=this.j($,g,h)),h.stop(),c}j($,g=[],h){const c=P._util.getServiceDependencies($).sort((t,l)=>t.index-l.index),k=[];for(const t of c){const l=this.m(t.id,h);l||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),k.push(l)}const u=c.length>0?c[0].index:g.length;if(g.length!==u){console.trace(`[createInstance] First service dependency of ${$.name} at position ${u+1} conflicts with ${g.length} static arguments`);const t=u-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,u)}return Reflect.construct($,g.concat(k))}k($,g){if(this.f.get($)instanceof L.$Jh)this.f.set($,g);else if(this.h)this.h.k($,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const g=this.f.get($);return!g&&this.h?this.h.l($):g}m($,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const h=this.l($);return h instanceof L.$Jh?this.q($,h,g.branch($,!0)):(g.branch($,!1),h)}q($,g,h){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,g,h)}finally{this.o.delete($)}}r($,g,h){const c=new C.$7p(t=>t.id.toString());let k=0;const u=[{id:$,desc:g,_trace:h}];for(;u.length;){const t=u.pop();if(c.lookupOrInsertNode(t),k++>1e3)throw new b(c);for(const l of P._util.getServiceDependencies(t.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${$} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof L.$Jh){const i={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};c.insertEdge(t,i),u.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new b(c);break}for(const{data:l}of t){if(this.l(l.id)instanceof L.$Jh){const i=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,i)}c.removeNode(l)}}return this.l($)}s($,g,h=[],c,k){if(this.f.get($)instanceof L.$Jh)return this.t($,g,h,c,k);if(this.h)return this.h.s($,g,h,c,k);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t($,g,h=[],c,k){if(c){const u=new p(void 0,this.g,this,this.i);u.c=String($);const t=new Map,l=new S.$9g(()=>{const r=u.j(g,h,k);for(const[i,n]of t){const o=r[i];if(typeof o=="function")for(const v of n)o.apply(r,v)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let v=t.get(i);return v||(v=new a.$Zc,t.set(i,v)),(A,E,I)=>{const M=v.push([A,E,I]);return(0,s.$Oc)(M)}}if(i in r)return r[i];const n=l.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),r[i]=o),o},set(r,i,n){return l.value[i]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,h,k)}u($,g){if(g&&console.warn($),this.g)throw new Error($)}}e.$8p=p;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,g){return $?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation($,g){return $?new y(1,g.name):y.c}static{this.f=0}constructor($,g){this.type=$,this.name=g,this.g=Date.now(),this.h=[]}branch($,g){const h=new y(3,$.toString());return this.h.push([$,g,h]),h}stop(){const $=Date.now()-this.g;y.f+=$;let g=!1;function h(k,u){const t=[],l=new Array(k+1).join("	");for(const[r,i,n]of u.h)if(i&&n){g=!0,t.push(`${l}CREATES -> ${r}`);const o=h(k+1,n);o&&t.push(o)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];($>2||g)&&y.all.add(c.join(`
`))}}e.$9p=y}),define(ee[217],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nwb=e.IssueType=void 0;var D;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(D||(e.IssueType=D={})),e.$Nwb=(0,S.$Mh)("issueService")}),define(ee[5],te([0,1,49,3,55,2,31,4,19,12,7,114,6]),function(K,e,S,D,s,L,C,P,f,a,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.log=e.$0i=e.LogLevel=e.$9i=e.$8i=e.$7i=void 0,e.$7i=(0,p.$Mh)("logService"),e.$8i=(0,p.$Mh)("loggerService");function d(){return new Date().toISOString()}function y(A){return(0,a.$Af)(A)}e.$9i=y;var w;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$0i=w.Info;function $(A,E,I){switch(E){case w.Trace:A.trace(I);break;case w.Debug:A.debug(I);break;case w.Info:A.info(I);break;case w.Warning:A.warn(I);break;case w.Error:A.error(I);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function g(A,E=!1){let I="";for(let M=0;M<A.length;M++){let U=A[M];if(U instanceof Error&&(U=(0,S.$xi)(U,E)),typeof U=="object")try{U=JSON.stringify(U)}catch{}I+=(M>0?" ":"")+U}return I}class h extends L.$Qc{constructor(){super(...arguments),this.b=e.$0i,this.c=this.B(new D.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$_i=h;class c extends h{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...I){this.f(w.Trace)&&this.g(w.Trace,g([E,...I],!0))}debug(E,...I){this.f(w.Debug)&&this.g(w.Debug,g([E,...I]))}info(E,...I){this.f(w.Info)&&this.g(w.Info,g([E,...I]))}warn(E,...I){this.f(w.Warning)&&this.g(w.Warning,g([E,...I]))}error(E,...I){if(this.f(w.Error))if(E instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=E.stack,this.g(w.Error,g(M))}else this.g(w.Error,g([E,...I]))}flush(){}}e.$aj=c;class k extends h{constructor(E=e.$0i){super(),this.setLevel(E),this.g=!P.$i}trace(E,...I){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...I):console.log(`[main ${d()}]`,E,...I))}debug(E,...I){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...I):console.log(`[main ${d()}]`,E,...I))}info(E,...I){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...I):console.log(`[main ${d()}]`,E,...I))}warn(E,...I){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,E,...I):console.warn(`[main ${d()}]`,E,...I))}error(E,...I){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,E,...I):console.error(`[main ${d()}]`,E,...I))}dispose(){}flush(){}}e.$bj=k;class u extends h{constructor(E=e.$0i,I=!0){super(),this.g=I,this.setLevel(E)}trace(E,...I){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...I):console.log(E,...I))}debug(E,...I){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...I):console.log(E,...I))}info(E,...I){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...I):console.log(E,...I))}warn(E,...I){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...I):console.log(E,...I))}error(E,...I){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...I):console.error(E,...I))}dispose(){}flush(){}}e.$cj=u;class t extends h{constructor(E,I=e.$0i){super(),this.g=E,this.setLevel(I)}trace(E,...I){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...I])}debug(E,...I){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...I])}info(E,...I){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...I])}warn(E,...I){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...I])}error(E,...I){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...I])}h(E){return typeof E=="string"?E:(0,S.$xi)(E,this.f(w.Trace))}dispose(){}flush(){}}e.$dj=t;class l extends h{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const I of this.g)I.setLevel(E);super.setLevel(E)}trace(E,...I){for(const M of this.g)M.trace(E,...I)}debug(E,...I){for(const M of this.g)M.debug(E,...I)}info(E,...I){for(const M of this.g)M.info(E,...I)}warn(E,...I){for(const M of this.g)M.warn(E,...I)}error(E,...I){for(const M of this.g)M.error(E,...I)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$ej=l;class r extends L.$Qc{constructor(E,I,M){if(super(),this.h=E,this.j=I,this.b=new C.$yc,this.c=this.B(new D.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Ld),this.onDidChangeVisibility=this.g.event,M)for(const U of M)this.b.set(U.resource,{logger:void 0,info:U})}m(E){return(0,a.$wf)(E)?[...this.b.values()].find(I=>I.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,I){const M=this.n(E),U=(0,a.$wf)(E)?E:I?.id??(0,s.$Ai)(M.toString()).toString(16);let B=this.b.get(M)?.logger;const se=I?.logLevel==="always"?w.Trace:I?.logLevel;B||(B=this.s(M,se??this.getLogLevel(M)??this.h,{...I,id:U}));const x={logger:B,info:{resource:M,id:U,logLevel:se,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(x.info),this.b.set(M,x),B}n(E){return(0,a.$wf)(E)?(0,f.$tg)(this.j,`${E}.log`):E}setLogLevel(E,I){if(m.URI.isUri(E)){const M=E,U=I,B=this.b.get(M);B&&U!==B.info.logLevel&&(B.info.logLevel=U===this.h?void 0:U,B.logger?.setLevel(U),this.b.set(B.info.resource,B),this.f.fire([M,U]))}else{this.h=E;for(const[M,U]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,I){const M=this.m(E);M&&I!==!M.info.hidden&&(M.info.hidden=!I,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,I]))}getLogLevel(E){let I;return E&&(I=this.b.get(E)?.info.logLevel),I??this.h}registerLogger(E){const I=this.b.get(E.resource);I?I.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const I=this.b.get(E);I&&(I.logger&&I.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fj=r;class i{constructor(){this.onDidChangeLogLevel=new D.$Ld().event}setLevel(E){}getLevel(){return w.Info}trace(E,...I){}debug(E,...I){}info(E,...I){}warn(E,...I){}error(E,...I){}critical(E,...I){}dispose(){}flush(){}}e.$gj=i;class n extends i{}e.$hj=n;function o(A){if(A.verbose)return w.Trace;if(typeof A.logLevel=="string"){const E=R(A.logLevel.toLowerCase());if(E!==void 0)return E}return e.$0i}e.$ij=o;function v(A){switch(A){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$jj=v;function R(A){switch(A){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$kj=R,e.$lj=new b.$4i("logLevel",v(w.Info))});var _=this&&this.__param||function(K,e){return function(S,D){e(S,D,K)}};define(ee[218],te([0,1,15,4,5]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=void 0;const L=S.safeStorage;let C=class{constructor(f){this.a=f,S.app.commandLine.getSwitchValue("password-store")==="basic"&&L.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(L.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.a.error(a),a}}async decrypt(f){let a;try{if(a=JSON.parse(f),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const m=Buffer.from(a.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=L.decryptString(m);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch(m){throw this.a.error(m),m}}isEncryptionAvailable(){return Promise.resolve(L.isEncryptionAvailable())}getKeyStorageProvider(){if(D.$i)return Promise.resolve("dpapi");if(D.$j)return Promise.resolve("keychain_access");if(L.getSelectedStorageBackend)try{const f=L.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(D.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(D.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!L.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");L.setUsePlainTextEncryption(!0)}};e.$u6b=C,e.$u6b=C=ke([_(0,s.$7i)],C)}),define(ee[219],te([0,1,23,8,14,3,2,9,76,5]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class m extends C.$Qc{constructor(p,d){super(),this.a=p,this.b=d,this.c=this.B(new L.$Ld),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Ld),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Pg(0)),this.w=[],this.y=this.B(new D.$Pg(0))}watch(p,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(p,d):this.z(p,d)}n(p,d){const y={path:this.H(p),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,S.$Sb)(this.j,y);return this.r(),(0,C.$Oc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$Y)(p))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,f.$Kp)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const d of this.j)(0,f.$Gp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const d of this.j)(0,f.$Gp)(d)&&p.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,d){const y={path:this.H(p),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,S.$Sb)(this.w,y);return this.C(),(0,C.$Oc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,f.$Kp)(p)),p=>this.G(p),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,P.$fc)(p.fsPath)}}e.$Op=m}),define(ee[220],te([0,1,23,8,17,22,3,55,69,2,56,13,65,19,62,173,16,118,5,14]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;let k=class extends a.$Qc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.$Ld),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Ld),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Ld),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Ld),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Ld),this.onDidFilesChange=this.X.event,this.Y=this.B(new C.$Ld),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new D.$1g)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const r=new a.$Pc;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),r.add(l.onDidChangeFile(i=>this.X.fire(new $.$nk(i,!this.S(l))))),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(i=>this.Y.fire(new Error(i)))),r.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,a.$Oc)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,a.$Lc)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(r){l.push(r)}}),!this.h.has(t)&&await D.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return f.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,d.$xg)(t))throw new $.$pk((0,w.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const r=new c.$_;throw r.message=(0,w.localize)(1,null,t.toString()),r}return l}async m(t){const l=await this.j(t);if((0,$.$ak)(l)||(0,$.$0j)(l)||(0,$.$bk)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const l=await this.j(t);if((0,$.$ak)(l)||(0,$.$0j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.s(t,l)}catch(r){throw(0,$.$kk)(r)===$.FileSystemProviderErrorCode.FileNotFound?new $.$pk((0,w.localize)(2,null,this.qb(t)),1):(0,$.$ik)(r)}}async s(t,l){const r=await this.j(t),i=this.S(r),n=l?.resolveTo,o=l?.resolveSingleChildDescendants,v=l?.resolveMetadata,R=await r.stat(t);let A;return this.t(r,t,R,void 0,!!v,(E,I)=>(A||(A=m.$Sh.forUris(()=>!i),A.set(t,!0),n&&A.fill(!0,n)),A.get(E.resource)||A.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?I===1:!1))}async t(t,l,r,i,n,o){const{providerExtUri:v}=this.R(t),R={resource:l,name:v.basename(l),isFile:(r.type&$.FileType.File)!==0,isDirectory:(r.type&$.FileType.Directory)!==0,isSymbolicLink:(r.type&$.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Ak)({mtime:r.mtime,size:r.size}),children:void 0};if(R.isDirectory&&o(R,i)){try{const A=await t.readdir(l),E=await D.Promises.settled(A.map(async([I,M])=>{try{const U=v.joinPath(l,I),B=n?await t.stat(U):{type:M};return await this.t(t,U,B,A.length,n,o)}catch(U){return this.b.trace(U),null}}));R.children=(0,S.$Fb)(E)}catch(A){this.b.trace(A),R.children=[]}return R}return R}async resolveAll(t){return D.Promises.settled(t.map(async l=>{try{return{stat:await this.s(l.resource,l.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),r=await l.stat(t);return this.t(l,t,r,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.u(t,l)}catch(r){return r}return!0}async u(t,l){if(!l?.overwrite&&await this.exists(t))throw new $.$pk((0,w.localize)(3,null,this.qb(t)),3,l)}async createFile(t,l=s.$_d.fromString(""),r){await this.u(t,r);const i=await this.writeFile(t,l);return this.r.fire(new $.$mk(t,0,i)),i}async writeFile(t,l,r){const i=this.ob(await this.n(t),t),{providerExtUri:n}=this.R(i);let o=r;if((0,$.$dk)(i)&&!o?.atomic){const v=i.enforceAtomicWriteFile?.(t);v&&(o={...r,atomic:v})}try{await this.w(i,t,o)||await this.U(i,n.dirname(t));let R;if((0,$.$0j)(i)&&!(l instanceof s.$_d))if((0,y.$Xd)(l)){const A=await(0,y.$5d)(l,3);A.ended?R=s.$_d.concat(A.buffer):R=A}else R=(0,y.$2d)(l,A=>s.$_d.concat(A),3);else R=l;!(0,$.$ak)(i)||(0,$.$0j)(i)&&R instanceof s.$_d||(0,$.$0j)(i)&&(0,$.$dk)(i)&&o?.atomic?await this.fb(i,t,o,R):await this.bb(i,t,o,R instanceof s.$_d?(0,s.$ke)(R):R),this.r.fire(new $.$mk(t,4))}catch(v){throw new $.$pk((0,w.localize)(4,null,this.qb(t),(0,$.$ik)(v).toString()),(0,$.$lk)(v),o)}return this.resolve(t,{resolveMetadata:!0})}async w(t,l,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.qb(l)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.qb(l)));if(!(t.capabilities&2))throw new Error((0,w.localize)(7,null,this.qb(l)));if(i)throw new Error((0,w.localize)(8,null,this.qb(l)))}let o;try{o=await t.stat(l)}catch{return}if(o.type&$.FileType.Directory)throw new $.$pk((0,w.localize)(9,null,this.qb(l)),0,r);if(this.pb(l,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==$.$zk&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,$.$Ak)({mtime:r.mtime,size:o.size}))throw new $.$pk((0,w.localize)(10,null),3,r);return o}async readFile(t,l,r){const i=await this.m(t);return l?.atomic?this.z(i,t,l,r):this.C(i,t,l,r)}async z(t,l,r,i){return new Promise((n,o)=>{this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{try{const v=await this.C(t,l,r,i);n(v)}catch(v){o(v)}})})}async C(t,l,r,i){const n=await this.D(t,l,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$le)(n.value)}}async readFileStream(t,l,r){const i=await this.m(t);return this.D(i,t,l,r)}async D(t,l,r,i){const n=new L.$Vd(i);let o=r;(0,$.$ck)(t)&&t.enforceAtomicReadFile?.(l)&&(o={...r,atomic:!0});const v=this.J(l,o).then(A=>A,A=>{throw n.dispose(!0),A});let R;try{return typeof o?.etag=="string"&&o.etag!==$.$zk&&await v,o?.atomic&&(0,$.$ck)(t)||!((0,$.$ak)(t)||(0,$.$bk)(t))||(0,$.$0j)(t)&&o?.preferUnbuffered?R=this.I(t,l,o):(0,$.$bk)(t)?R=this.G(t,l,n.token,o):R=this.H(t,l,n.token,o),R.on("end",()=>n.dispose()),R.on("error",()=>n.dispose()),{...await v,value:R}}catch(A){throw R&&await(0,y.$3d)(R),this.F(A,l,o)}}F(t,l,r){const i=(0,w.localize)(11,null,this.qb(l),(0,$.$ik)(t).toString());return t instanceof $.$rk?new $.$rk(i,t.stat,r):t instanceof $.$qk?new $.$qk(i,t.fileOperationResult,t.size,t.options):new $.$pk(i,(0,$.$lk)(t),r)}G(t,l,r,i=Object.create(null)){const n=t.readFileStream(l,i,r);return(0,y.$9d)(n,{data:o=>o instanceof s.$_d?o:s.$_d.wrap(o),error:o=>this.F(o,l,i)},o=>s.$_d.concat(o))}H(t,l,r,i=Object.create(null)){const n=(0,s.$pe)();return(0,g.$Ep)(t,l,n,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.F(o,l,i)},r),n}I(t,l,r){const i=(0,y.$Zd)(n=>s.$_d.concat(n));return(async()=>{try{let n;r?.atomic&&(0,$.$ck)(t)?n=await t.readFile(l,{atomic:!0}):n=await t.readFile(l),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.L(l,n.byteLength,r),i.end(s.$_d.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,l){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new $.$pk((0,w.localize)(12,null,this.qb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==$.$zk&&l.etag===r.etag)throw new $.$rk((0,w.localize)(13,null),r,l);return this.L(t,r.size,l),r}L(t,l,r){if(typeof r?.limits?.size=="number"&&l>r.limits.size)throw new $.$qk((0,w.localize)(14,null,this.qb(t)),7,l,r)}async canMove(t,l,r){return this.M(t,l,"move",r)}async canCopy(t,l,r){return this.M(t,l,"copy",r)}async M(t,l,r,i){if(t.toString()!==l.toString())try{const n=r==="move"?this.ob(await this.n(t),t):await this.m(t),o=this.ob(await this.n(l),l);await this.Q(n,t,o,l,r,i)}catch(n){return n}return!0}async move(t,l,r){const i=this.ob(await this.n(t),t),n=this.ob(await this.n(l),l),o=await this.N(i,t,n,l,"move",!!r),v=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new $.$mk(t,o==="move"?2:3,v)),v}async copy(t,l,r){const i=await this.m(t),n=this.ob(await this.n(l),l),o=await this.N(i,t,n,l,"copy",!!r),v=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new $.$mk(t,o==="copy"?3:2,v)),v}async N(t,l,r,i,n,o){if(l.toString()===i.toString())return n;const{exists:v,isSameResourceWithDifferentPathCase:R}=await this.Q(t,l,r,i,n,o);if(v&&!R&&o&&await this.del(i,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,$.$$j)(t))await t.copy(l,i,{overwrite:o});else{const A=await this.resolve(l);A.isDirectory?await this.P(t,A,r,i):await this.O(t,l,r,i)}return n}else return t===r?(await t.rename(l,i,{overwrite:o}),n):(await this.N(t,l,r,i,"copy",o),await this.del(l,{recursive:!0}),"copy")}async O(t,l,r,i){if((0,$.$ak)(t)&&(0,$.$ak)(r))return this.hb(t,l,r,i);if((0,$.$ak)(t)&&(0,$.$0j)(r))return this.nb(t,l,r,i);if((0,$.$0j)(t)&&(0,$.$ak)(r))return this.lb(t,l,r,i);if((0,$.$0j)(t)&&(0,$.$0j)(r))return this.jb(t,l,r,i)}async P(t,l,r,i){await r.mkdir(i),Array.isArray(l.children)&&await D.Promises.settled(l.children.map(async n=>{const o=this.R(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),r,o):this.O(t,n.resource,r,o)}))}async Q(t,l,r,i,n,o){let v=!1;if(t===r){const{providerExtUri:A,isPathCaseSensitive:E}=this.R(t);if(E||(v=A.isEqual(l,i)),v&&n==="copy")throw new Error((0,w.localize)(15,null,this.qb(l),this.qb(i)));if(!v&&A.isEqualOrParent(i,l))throw new Error((0,w.localize)(16,null,this.qb(l),this.qb(i)))}const R=await this.exists(i);if(R&&!v){if(!o)throw new $.$pk((0,w.localize)(17,null,this.qb(l),this.qb(i)),4);if(t===r){const{providerExtUri:A}=this.R(t);if(A.isEqualOrParent(l,i))throw new Error((0,w.localize)(18,null,this.qb(l),this.qb(i)))}}return{exists:R,isSameResourceWithDifferentPathCase:v}}R(t){const l=this.S(t);return{providerExtUri:l?d.$jg:d.$lg,isPathCaseSensitive:l}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.ob(await this.j(t),t);await this.U(l,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$mk(t,0,r)),r}async U(t,l){const r=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&$.FileType.Directory))throw new Error((0,w.localize)(19,null,this.qb(l)));break}catch(n){if((0,$.$kk)(n)!==$.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(l)),l=i.dirname(l)}for(let n=r.length-1;n>=0;n--){l=i.joinPath(l,r[n]);try{await t.mkdir(l)}catch(o){if((0,$.$kk)(o)!==$.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,l){try{await this.W(t,l)}catch(r){return r}return!0}async W(t,l){const r=this.ob(await this.j(t),t),i=!!l?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,w.localize)(20,null,this.qb(t)));const n=l?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,w.localize)(21,null,this.qb(t)));if(i&&n)throw new Error((0,w.localize)(22,null,this.qb(t)));let o;try{o=await r.stat(t)}catch{}if(o)this.pb(t,o);else throw new $.$pk((0,w.localize)(23,null,this.qb(t)),1);if(!!!l?.recursive){const R=await this.resolve(t);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,w.localize)(24,null,this.qb(t)))}return r}async del(t,l){const r=await this.W(t,l);let i=l;if((0,$.$ek)(r)&&!i?.atomic){const R=r.enforceAtomicDelete?.(t);R&&(i={...l,atomic:R})}const n=!!i?.useTrash,o=!!i?.recursive,v=i?.atomic??!1;await r.delete(t,{recursive:o,useTrash:n,atomic:v}),this.r.fire(new $.$mk(t,1))}async cloneFile(t,l){const r=await this.j(t),i=this.ob(await this.n(l),l);if(r===i&&this.R(r).providerExtUri.isEqual(t,l))return;if(r===i&&(0,$.$_j)(r))return r.cloneFile(t,l);await this.U(i,this.R(i).providerExtUri.dirname(l));const n=this.ab.queueFor(t,this.R(r).providerExtUri);return r===i&&(0,$.$$j)(r)?n.queue(()=>r.copy(t,l,{overwrite:!0})):n.queue(()=>this.O(r,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const r=new a.$Pc;let i=!1,n=()=>{i=!0};return r.add((0,a.$Oc)(()=>n())),(async()=>{try{const o=await this.$(t,l);i?(0,a.$Lc)(o):n=()=>(0,a.$Lc)(o)}catch(o){this.b.error(o)}})(),r}async $(t,l){const r=await this.j(t),i=(0,P.$Ai)([this.R(r).providerExtUri.getComparisonKey(t),l]);let n=this.Z.get(i);return n||(n={count:0,disposable:r.watch(t,l)},this.Z.set(i,n)),n.count+=1,(0,a.$Oc)(()=>{n&&(n.count--,n.count===0&&((0,a.$Lc)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,a.$Lc)(t.disposable);this.Z.clear()}async bb(t,l,r,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,y.$Xd)(i)||(0,y.$Yd)(i)?await this.cb(t,n,i):await this.db(t,n,i)}catch(o){throw(0,$.$ik)(o)}finally{await t.close(n)}})}async cb(t,l,r){let i=0,n;if((0,y.$Yd)(r)){if(r.buffer.length>0){const o=s.$_d.concat(r.buffer);await this.eb(t,l,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,v)=>{(0,y.$4d)(n,{onData:async R=>{n.pause();try{await this.eb(t,l,R,R.byteLength,i,0)}catch(A){return v(A)}i+=R.byteLength,setTimeout(()=>n.resume())},onError:R=>v(R),onEnd:()=>o()})})}async db(t,l,r){let i=0,n;for(;(n=r.read())!==null;)await this.eb(t,l,n,n.byteLength,i,0),i+=n.byteLength}async eb(t,l,r,i,n,o){let v=0;for(;v<i;){const R=await t.write(l,n+v,r.buffer,o+v,i-v);v+=R}}async fb(t,l,r,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(()=>this.gb(t,l,r,i))}async gb(t,l,r,i){let n;i instanceof s.$_d?n=i:(0,y.$Xd)(i)?n=await(0,s.$le)(i):(0,y.$Yd)(i)?n=await(0,s.$me)(i):n=(0,s.$je)(i),await t.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async hb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.ib(t,l,r,i))}async ib(t,l,r,i){let n,o;try{n=await t.open(l,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const v=s.$_d.alloc(this.a);let R=0,A=0,E=0;do E=await t.read(n,R,v.buffer,A,v.byteLength-A),await this.eb(r,o,v,E,R,A),R+=E,A+=E,A===v.byteLength&&(A=0);while(E>0)}catch(v){throw(0,$.$ik)(v)}finally{await D.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async jb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.kb(t,l,r,i))}async kb(t,l,r,i){return r.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.mb(t,l,r,i))}async mb(t,l,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(l);await this.eb(r,n,s.$_d.wrap(o),o.byteLength,0,0)}catch(o){throw(0,$.$ik)(o)}finally{await r.close(n)}}async nb(t,l,r,i){const n=await(0,s.$le)(this.H(t,l,L.CancellationToken.None));await this.fb(r,i,void 0,n)}ob(t,l){if(t.capabilities&2048)throw new $.$pk((0,w.localize)(25,null,this.qb(l)),6);return t}pb(t,l){if((l.permissions??0)&$.FilePermission.Readonly)throw new $.$pk((0,w.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===b.Schemas.file?t.fsPath:t.toString(!0)}};e.$Fp=k,e.$Fp=k=ke([_(0,h.$7i)],k)}),define(ee[92],te([0,1,45,308,8,31,17,3,33,2,9,4,19,62,21,177,16,118,219,49,215,214]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0,(()=>{try{(0,D.gracefulify)(S)}catch(l){console.error(`Error enabling graceful-fs: ${(0,c.$xi)(l)}`)}})();class t extends h.$Op{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=P.Event.None,this.N=new L.$yc(n=>p.$kg.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,b.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let v;o.isSymbolicLink()?v=(await this.stat((0,p.$tg)(r,o.name))).type:v=this.M(o),n.push([o.name,v])}catch(v){this.a.trace(v)}})),n}catch(i){throw this.eb(i)}}M(r,i){let n;return i?.dangling?n=$.FileType.Unknown:r.isFile()?n=$.FileType.File:r.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new s.$Qg;return this.N.set(r,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Oc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const o=this.H(r);return await y.Promises.readFile(o)}catch(o){throw this.eb(o)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const o=(0,d.$Zd)(v=>C.$_d.concat(v.map(R=>C.$_d.wrap(R))).buffer);return(0,g.$Ep)(this,r,o,v=>v.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(r,(0,p.$tg)((0,p.$sg)(r),`${(0,p.$qg)(r)}${n.atomic.postfix}`),i,n):this.R(r,i,n)}async Q(r,i,n,o){const v=new a.$Pc;try{v.add(await this.O(r)),v.add(await this.O(i)),await this.R(i,n,o,!0);try{await this.rename(i,r,{overwrite:!0})}catch(R){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{v.dispose()}}async R(r,i,n,o){let v;try{const R=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(R)){if(!n.overwrite)throw(0,$.$hk)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$hk)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(r,{create:!0,unlock:n.unlock},o),await this.write(v,0,i,0,i.byteLength)}catch(R){throw await this.fb(r,R)}finally{typeof v=="number"&&await this.close(v)}}static{this.X=!0}static configureFlushOnWrite(r){t.X=r}async open(r,i,n){const o=this.H(r);let v;(0,$.$9j)(i)&&!n&&(v=await this.O(r));let R;try{if((0,$.$9j)(i)&&i.unlock)try{const{stat:E}=await y.SymlinkSupport.stat(o);E.mode&128||await y.Promises.chmod(o,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let A;if((0,$.$9j)(i)){if(b.$i)try{await y.Promises.truncate(o,0),A="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}A||(A="w")}else A="r";R=await y.Promises.open(o,A)}catch(A){throw v?.dispose(),(0,$.$9j)(i)?await this.fb(r,A):this.eb(A)}if(this.S.set(R,0),(0,$.$9j)(i)&&this.W.set(R,r),v){const A=this.U.get(R);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${o})`),this.U.set(R,v),A&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${o})`),A.dispose())}return R}async close(r){const i=this.U.get(r);try{if(this.S.delete(r),this.W.delete(r)&&t.X)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.eb(n)}finally{i&&(this.U.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.U.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,o,v){const R=this.Y(r,i);let A=null;try{A=(await y.Promises.read(r,n,o,v,R)).bytesRead}catch(E){throw this.eb(E)}finally{this.Z(r,R,A)}return A}Y(r,i){return i===this.S.get(r)?null:i}Z(r,i,n){const o=this.S.get(r);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.S.set(r,o+n):this.S.delete(r)))}async write(r,i,n,o,v){return(0,s.$0g)(()=>this.$(r,i,n,o,v),100,3)}async $(r,i,n,o,v){const R=this.Y(r,i);let A=null;try{A=(await y.Promises.write(r,n,o,v,R)).bytesWritten}catch(E){throw await this.fb(this.W.get(r),E)}finally{this.Z(r,R,A)}return A}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(i){throw this.eb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,m.$hc)((0,m.$kc)(n),`${(0,m.$lc)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let v=!1;try{const{stat:R,symbolicLink:A}=await y.SymlinkSupport.stat(n);v=R.isDirectory()&&!A}catch{}if(v)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.eb(n)}}async rename(r,i,n){const o=this.H(r),v=this.H(i);if(o!==v)try{await this.ab(r,i,"move",n.overwrite),await y.Promises.rename(o,v)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,w.localize)(2,null,(0,m.$lc)(o),(0,m.$lc)((0,m.$kc)(v)),R.toString()))),this.eb(R)}}async copy(r,i,n){const o=this.H(r),v=this.H(i);if(o!==v)try{await this.ab(r,i,"copy",n.overwrite),await y.Promises.copy(o,v,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,w.localize)(3,null,(0,m.$lc)(o),(0,m.$lc)((0,m.$kc)(v)),R.toString()))),this.eb(R)}}async ab(r,i,n,o){const v=this.H(r),R=this.H(i);let A=!1;if(!!(this.capabilities&1024)||(A=(0,f.$Uf)(v,R,!0)),A){if(n==="copy")throw(0,$.$hk)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(r);if(!I)throw(0,$.$hk)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(i);if(M){if(!o)throw(0,$.$hk)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);I.type&$.FileType.File&&M.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.bb(r,i,!1)}async bb(r,i,n){const o=this.H(r),v=this.H(i),R=!!(this.capabilities&1024);if((0,f.$Uf)(o,v,!R))return;const A=new a.$Pc;try{A.add(await this.O(r)),A.add(await this.O(i)),n&&await y.Promises.mkdir((0,m.$kc)(v),{recursive:!0}),await y.Promises.copyFile(o,v)}catch(E){if(E.code==="ENOENT"&&!n)return this.bb(r,i,!0);throw this.eb(E)}finally{A.dispose()}}t(r,i,n){return new k.$Vp(o=>r(o),o=>i(o),n)}F(r,i,n){return new u.$4p(o=>r(o),o=>i(o),n)}eb(r){if(r instanceof $.$gk)return r;let i=r,n;switch(r.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$hk)(i,n)}async fb(r,i){let n=this.eb(i);if(r&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.H(r));o.mode&128||(n=(0,$.$hk)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$5p=t}),define(ee[221],te([0,1,3,92,2,17,62,22]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class f extends s.$Qc{constructor(b,p){super(),this.a=b,this.b=p,this.F=new Map,this.G=new Map}call(b,p,d){const y=this.c(b);switch(p){case"stat":return this.g(y,d[0]);case"readdir":return this.h(y,d[0]);case"open":return this.r(y,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(y,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(y,d[0],d[1],d[2]);case"rename":return this.z(y,d[0],d[1],d[2]);case"copy":return this.C(y,d[0],d[1],d[2]);case"cloneFile":return this.D(y,d[0],d[1]);case"mkdir":return this.w(y,d[0]);case"delete":return this.y(y,d[0],d[1]);case"watch":return this.I(y,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${p} not found`)}listen(b,p,d){const y=this.c(b);switch(p){case"fileChange":return this.H(y,d[0]);case"readFileStream":return this.m(y,d[0],d[1])}throw new Error(`Unknown event ${p}`)}g(b,p){const d=this.f(b,p,!0);return this.a.stat(d)}h(b,p){const d=this.f(b,p);return this.a.readdir(d)}async j(b,p,d){const y=this.f(b,p,!0),w=await this.a.readFile(y,d);return L.$_d.wrap(w)}m(b,p,d){const y=this.f(b,p,!0),w=new P.$Vd,$=new S.$Ld({onDidRemoveLastListener:()=>{w.cancel()}}),g=this.a.readFileStream(y,d,w.token);return(0,C.$4d)(g,{onData:h=>$.fire(L.$_d.wrap(h)),onError:h=>$.fire(h),onEnd:()=>{$.fire("end"),$.dispose(),w.dispose()}}),$.event}n(b,p,d,y){const w=this.f(b,p);return this.a.writeFile(w,d.buffer,y)}r(b,p,d){const y=this.f(b,p,!0);return this.a.open(y,d)}s(b){return this.a.close(b)}async t(b,p,d){const y=L.$_d.alloc(d),w=0,$=await this.a.read(b,p,y.buffer,w,d);return[y,$]}u(b,p,d,y,w){return this.a.write(b,p,d.buffer,y,w)}w(b,p){const d=this.f(b,p);return this.a.mkdir(d)}y(b,p,d){const y=this.f(b,p);return this.a.delete(y,d)}z(b,p,d,y){const w=this.f(b,p),$=this.f(b,d);return this.a.rename(w,$,y)}C(b,p,d,y){const w=this.f(b,p),$=this.f(b,d);return this.a.copy(w,$,y)}D(b,p,d){const y=this.f(b,p),w=this.f(b,d);return this.a.cloneFile(y,w)}H(b,p){const d=new S.$Ld({onWillAddFirstListener:()=>{this.F.set(p,this.L(b,d))},onDidRemoveLastListener:()=>{(0,s.$Lc)(this.F.get(p)),this.F.delete(p)}});return d.event}async I(b,p,d,y,w){const $=this.F.get(p);if($){const g=this.f(b,y),h=$.watch(d,g,w);this.G.set(p+d,h)}}async J(b,p){const d=b+p,y=this.G.get(d);y&&((0,s.$Lc)(y),this.G.delete(d))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$Ar=f;class a extends s.$Qc{constructor(b,p,d,y){super(),this.c=b,this.f=d,this.g=y,this.a=new Map,this.b=this.B(new D.$5p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(b){const p=this.B(new S.$Ld);this.B(p.event(d=>{b.fire(d.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(d=>p.fire(d))),this.B(this.b.onDidWatchError(d=>b.fire(d)))}j(b){}m(b){}watch(b,p,d){const y=this.m(this.g);return Array.isArray(y)&&(d.excludes=[...d.excludes,...y]),this.a.set(b,this.b.watch(p,d)),(0,s.$Oc)(()=>{(0,s.$Lc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$Br=a}),define(ee[222],te([0,1,15,176,4,7,16,9,221,153]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=void 0;class m extends f.$Ar{constructor(d,y,w){super(d,y),this.M=w}c(d){return a.$Em}f(d,y){return L.URI.revive(y)}async y(d,y,w){if(!w.useTrash)return super.y(d,y,w);const $=this.f(d,y),g=(0,P.$fc)($.fsPath);try{await S.shell.trashItem(g)}catch{throw(0,C.$hk)(s.$i?(0,D.localize)(0,null,(0,P.$lc)(g)):(0,D.localize)(1,null,(0,P.$lc)(g)),C.FileSystemProviderErrorCode.Unknown)}}L(d,y){return new b(d,y,this.b,this.M)}}e.$C6b=m;class b extends f.$Br{watch(d,y,w){if(w.recursive)throw(0,C.$hk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(d,y,w)}}}),define(ee[223],te([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A3b=void 0;class D extends S.$aj{constructor(L=S.$0i){super(),this.m=[],this.n=void 0,this.setLevel(L),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(L){this.n=L;for(const{level:C,message:P}of this.m)(0,S.log)(L,C,P);this.m=[]}g(L,C){this.n?(0,S.log)(this.n,L,C):this.getLevel()<=L&&this.m.push({level:L,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$A3b=D}),define(ee[224],te([0,1,7,3,5,2]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0;class C extends s.$fj{constructor(b,p,d,y,w){super(p,d,y),this.r=b,this.t=w,this.B(w.listen("onDidChangeLogLevel",b)($=>{(0,s.$9i)($)?super.setLogLevel($):super.setLogLevel(S.URI.revive($[0]),$[1])})),this.B(w.listen("onDidChangeVisibility",b)(([$,g])=>super.setVisibility(S.URI.revive($),g))),this.B(w.listen("onDidChangeLoggers",b)(({added:$,removed:g})=>{for(const h of $)super.registerLogger({...h,resource:S.URI.revive(h.resource)});for(const h of g)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$dj({log:(b,p)=>{this.t.call("consoleLog",[b,p])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,p){super.setLogLevel(b,p),this.t.call("setLogLevel",[b,p])}setVisibility(b,p){super.setVisibility(b,p),this.t.call("setVisibility",[this.n(b),p])}s(b,p,d){return new P(this.t,b,p,d,this.r)}static setLogLevel(b,p,d){return b.call("setLogLevel",[p,d])}}e.$3q=C;class P extends s.$aj{constructor(b,p,d,y,w){super(y?.logLevel==="always"),this.r=b,this.s=p,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[p,y,w]).then(()=>{this.u(this.n),this.m=!0})}g(b,p){const d=[[b,p]];this.m?this.u(d):this.n.push(...d)}u(b){this.r.call("log",[this.s,b])}}class f{constructor(b,p){this.a=b,this.b=p}listen(b,p){const d=this.b(b);switch(p){case"onDidChangeLoggers":return D.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(w=>this.c(w,d)),removed:[...y.removed].map(w=>this.c(w,d))}));case"onDidChangeVisibility":return D.Event.map(this.a.onDidChangeVisibility,y=>[d.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return D.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$9i)(y)?y:[d.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${p}`)}async call(b,p,d){const y=this.b(b);switch(p){case"setLogLevel":return(0,s.$9i)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(S.URI.revive(y.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,y)))}throw new Error(`Call not found: ${p}`)}c(b,p){return{...b,resource:p.transformOutgoingURI(b.resource)}}}e.$4q=f;class a extends L.$Qc{constructor(b,p){super(),p.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(d=>p.call("setLogLevel",[d]))),p.call("getRegisteredLoggers").then(d=>{for(const y of d)b.registerLogger({...y,resource:S.URI.revive(y.resource)})}),this.B(p.listen("onDidChangeVisibility")(([d,y])=>b.setVisibility(S.URI.revive(d),y))),this.B(p.listen("onDidChangeLoggers")(({added:d,removed:y})=>{for(const w of d)b.registerLogger({...w,resource:S.URI.revive(w.resource)});for(const w of y)b.deregisterLogger(w.resource)}))}}e.$5q=a}),define(ee[225],te([0,1,2,5]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;class s extends S.$Qc{constructor(C,P=[]){super(),this.a=new D.$ej([C,...P]),this.B(C.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.$tN=s}),define(ee[226],te([0,1,31,7,5]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;class L{constructor(P){this.b=P,this.a=new S.$yc}listen(P,f,a){switch(f){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,a){switch(f){case"createLogger":this.c(D.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(D.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,s.$9i)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(D.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(D.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:D.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(D.URI.revive(a[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,a){this.a.set(P,this.b.createLogger(P,f,a))}d(P,f){let a=console.log;switch(P){case s.LogLevel.Error:a=console.error;break;case s.LogLevel.Warning:a=console.warn;break;case s.LogLevel.Info:a=console.info;break}a.call(console,...f)}e(P,f){const a=this.a.get(P);if(!a)throw new Error("Create the logger before logging");for(const[m,b]of f)(0,s.log)(a,m,b)}}e.$y7b=L}),define(ee[227],te([0,1,16,5]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;var s;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(s||(s={}));async function L(a,m,b,p,d){try{const y=await new Promise(($,g)=>{K(["@vscode/spdlog"],$,g)});y.setFlushOn(s.Trace);const w=await y.createAsyncRotatingLogger(a,m,b,p);return d?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function C(a,m,b){switch(m){case D.LogLevel.Trace:a.trace(b);break;case D.LogLevel.Debug:a.debug(b);break;case D.LogLevel.Info:a.info(b);break;case D.LogLevel.Warning:a.warn(b);break;case D.LogLevel.Error:a.error(b);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function P(a,m){switch(m){case D.LogLevel.Trace:a.setLevel(s.Trace);break;case D.LogLevel.Debug:a.setLevel(s.Debug);break;case D.LogLevel.Info:a.setLevel(s.Info);break;case D.LogLevel.Warning:a.setLevel(s.Warning);break;case D.LogLevel.Error:a.setLevel(s.Error);break;case D.LogLevel.Off:a.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class f extends D.$aj{constructor(m,b,p,d,y){super(),this.m=[],this.setLevel(y),this.n=this.s(m,b,p,d),this.B(this.onDidChangeLogLevel(w=>{this.r&&P(this.r,w)}))}async s(m,b,p,d){const y=p?6:1,w=30/y*S.$Ck.MB,$=await L(m,b,w,y,d);if($){this.r=$,P(this.r,this.getLevel());for(const{level:g,message:h}of this.m)C(this.r,g,h);this.m=[]}}g(m,b){this.r?C(this.r,m,b):this.getLevel()<=m&&this.m.push({level:m,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$iN=f}),define(ee[228],te([0,1,32,5,227]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=void 0;class L extends D.$fj{s(P,f,a){return new s.$iN((0,S.$cg)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,f)}}e.$jN=L}),define(ee[66],te([0,1,31,3,6,5,228]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=e.$Y6b=void 0,e.$Y6b=(0,s.$Nh)(L.$8i);class P extends C.$jN{constructor(){super(...arguments),this.u=new S.$yc}createLogger(a,m,b){b!==void 0&&this.u.set(this.n(a),b);try{return super.createLogger(a,m)}catch(p){throw this.u.delete(this.n(a)),p}}registerLogger(a,m){m!==void 0&&this.u.set(a.resource,m),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const m=[];for(const b of super.getRegisteredLoggers())a===this.u.get(b.resource)&&m.push(b);return m}getOnDidChangeLogLevelEvent(a){return D.Event.filter(this.onDidChangeLogLevel,m=>(0,L.$9i)(m)||this.w(m[0],a))}getOnDidChangeVisibilityEvent(a){return D.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,a))}getOnDidChangeLoggersEvent(a){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(p=>this.w(p.resource,a)),removed:[...m.removed].filter(p=>this.w(p.resource,a))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(a){for(const[m,b]of this.u)b===a&&this.deregisterLogger(m)}w(a,m){const b=this.u.get(a);return b===void 0||b===m}dispose(){super.dispose(),this.u.clear()}}e.$Z6b=P}),define(ee[229],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=e.$R6b=e.$Q6b=e.$P6b=void 0;function S(C){return C.submenu!==void 0}e.$P6b=S;function D(C){return C.id==="vscode.menubar.separator"}e.$Q6b=D;function s(C){return C.uri!==void 0}e.$R6b=s;function L(C){return!S(C)&&!D(C)&&!s(C)}e.$S6b=L}),define(ee[39],te([0,1,3,69,2,6]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=void 0,e.$_m=(0,L.$Mh)("policy");class C extends s.$Qc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Ld),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const m=Object.keys(this.f).length;return this.f={...a,...this.f},m!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(b,[p,d])=>({...b,[p]:d}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[m,b])=>({...a,[m]:{definition:b,value:this.g.get(m)}}),{})}}e.$an=C;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$bn=P}),define(ee[230],te([0,1,8,3,69,12,16,5,39]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;function a(b,p){const d=[];for(const y of new Set(s.Iterable.concat(b.keys(),p.keys())))b.get(y)!==p.get(y)&&d.push(y);return d}let m=class extends f.$an{constructor(p,d,y){super(),this.m=p,this.n=d,this.s=y,this.c=this.B(new S.$Pg(500));const w=D.Event.filter(d.onDidFilesChange,$=>$.affects(p));this.B(d.watch(p)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const d=await this.n.readFile(this.m),y=JSON.parse(d.value.toString());if(!(0,L.$yf)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.f[w]&&p.set(w,y[w])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return p}async w(){const p=await this.u(),d=a(this.g,p);this.g=p,d.length>0&&this.h.fire(d)}};e.$Q7b=m,e.$Q7b=m=ke([_(1,C.$8j),_(2,P.$7i)],m)}),define(ee[231],te([0,1,3,2,39]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=void 0;class L{constructor(f){this.b=f,this.a=new D.$Pc}listen(f,a){switch(a){case"onDidChange":return S.Event.map(this.b.onDidChange,m=>m.reduce((b,p)=>({...b,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(f,a,m){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$r7b=L;class C extends s.$an{constructor(f,a){super(),this.a=a;for(const m in f){const{definition:b,value:p}=f[m];this.f[m]=b,p!==void 0&&this.g.set(m,p)}this.a.listen("onDidChange")(m=>{for(const b in m){const p=m[b];p===null?this.g.delete(b):this.g.set(b,p)}this.h.fire(Object.keys(m))})}async j(f){const a=await this.a.call("updatePolicyDefinitions",f);for(const m in a)this.g.set(m,a[m])}}e.$s7b=C}),define(ee[232],te([0,1,39,8,309,2,5]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;let P=class extends S.$an{constructor(a,m){super(),this.m=a,this.n=m,this.a=new D.$Lg,this.b=this.B(new L.$Rc)}async j(a){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.a.queue(()=>new Promise((m,b)=>{try{this.b.value=(0,s.createWatcher)(this.n,a,p=>{this.t(p),m()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),b(p)}}))}t(a){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const m in a){const b=a[m];b===void 0?this.g.delete(m):this.g.set(m,b)}this.h.fire(Object.keys(a))}};e.$P7b=P,e.$P7b=P=ke([_(0,C.$7i)],P)}),define(ee[77],te([0,1,4,35]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof S.$g.vscode<"u"&&typeof S.$g.vscode.context<"u"){const L=S.$g.vscode.context.configuration();if(L)s=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:L.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ee[24],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=void 0,e.$mj=(0,S.$Mh)("productService"),e.$nj="vscode://schemas/vscode-product"}),define(ee[233],te([0,1,8,5]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=void 0;let s=class{constructor(C,P,f){this.a=C,this.b=P,this.c=f}async inspect(C){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Sg)(C);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$F6b=s,e.$F6b=s=ke([_(2,D.$7i)],s)}),define(ee[78],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=void 0,e.$I6b=(0,S.$Mh)("protocolMainService")}),define(ee[43],te([0,1,135,12]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;class s{constructor(){this.a=new Map}add(C,P){S.ok(D.$wf(C)),S.ok(D.$yf(P)),S.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$0m=new s}),define(ee[234],te([0,1,3,43]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$$m={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this.b=new S.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,a){this.a[s(f)]=a,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const C=new L;D.$0m.add(e.$$m.JSONContribution,C)}),define(ee[57],te([0,1,23,3,12,161,18,234,43]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ConfigurationScope=e.$cn=e.EditPresentationTypes=void 0;var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$cn={Configuration:"base.contributions.configuration"};var m;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn="vscode://schemas/settings/resourceLanguage",e.$kn="vscode://schemas/settings/configurationDefaults";const b=f.$0m.as(P.$$m.JSONContribution);class p{constructor(){this.h=new Set,this.i=new D.$Ld,this.onDidSchemaChange=this.i.event,this.j=new D.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$jn,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),b.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),b.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),b.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(l.add(o),e.$mn.test(o)){const v=this.a.get(o),R=v?.valuesSources??new Map;if(n)for(const M of Object.keys(i[o]))R.set(M,n);const A={...v?.value||{},...i[o]};this.a.set(o,{source:n,value:A,valuesSources:R});const E=(0,C.$qi)(o),I={type:"object",default:A,description:L.localize(1,null,E),$ref:e.$jn,defaultDefaultValue:A,source:s.$wf(n)?void 0:n,defaultValueSource:n};r.push(...w(o)),this.d[o]=I,this.b.properties[o]=I}else{this.a.set(o,{value:i[o],source:n});const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),v=s.$wf(i)?i:i?.id,R=s.$wf(o?.source)?o?.source:o?.source?.id;if(v===R)if(l.add(n),this.a.delete(n),e.$mn.test(n))delete this.d[n],delete this.b.properties[n];else{const A=this.d[n];A&&(this.w(n,A),this.r(n,A))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(i=>{this.p(i,l,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,l){const r=i=>{if(i.properties)for(const n in i.properties){l.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,l=!0,r,i,n=3,o){n=s.$Ff(t.scope)?n:t.scope;const v=t.properties;if(v)for(const A in v){const E=v[A];if(l&&c(A,E)){delete v[A];continue}if(E.source=r,E.defaultDefaultValue=v[A].default,this.w(A,E),e.$mn.test(A)?E.scope=void 0:(E.scope=s.$Ff(E.scope)?n:E.scope,E.restricted=s.$Ff(E.restricted)?!!i?.includes(A):E.restricted),v[A].hasOwnProperty("included")&&!v[A].included){this.f[A]=v[A],delete v[A];continue}else this.d[A]=v[A],v[A].policy?.name&&this.e.set(v[A].policy.name,A);!v[A].deprecationMessage&&v[A].markdownDeprecationMessage&&(v[A].deprecationMessage=v[A].markdownDeprecationMessage),o.add(A)}const R=t.allOf;if(R)for(const A of R)this.p(A,l,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$dn.properties[t]=l,l.scope){case 1:e.$en.properties[t]=l;break;case 2:e.$fn.properties[t]=l;break;case 6:e.$gn.properties[t]=l;break;case 3:e.$hn.properties[t]=l;break;case 4:e.$in.properties[t]=l;break;case 5:e.$in.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$dn.properties[t],l.scope){case 1:delete e.$en.properties[t];break;case 2:delete e.$fn.properties[t];break;case 6:delete e.$gn.properties[t];break;case 3:delete e.$hn.properties[t];break;case 4:case 5:delete e.$in.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$jn};this.w(l,r),e.$dn.properties[l]=r,e.$en.properties[l]=r,e.$fn.properties[l]=r,e.$gn.properties[l]=r,e.$hn.properties[l]=r,e.$in.properties[l]=r}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$jn};e.$dn.patternProperties[e.$ln]=t,e.$en.patternProperties[e.$ln]=t,e.$fn.patternProperties[e.$ln]=t,e.$gn.patternProperties[e.$ln]=t,e.$hn.patternProperties[e.$ln]=t,e.$in.patternProperties[e.$ln]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Df(i)&&(i=l.defaultDefaultValue,n=void 0),s.$Df(i)&&(i=g(l.type)),l.default=i,l.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");e.$ln=`^(${d})+$`,e.$mn=new RegExp(e.$ln);function w(u){const t=[];if(e.$mn.test(u)){let l=y.exec(u);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=y.exec(u)}}return(0,S.$Kb)(t)}e.$nn=w;function $(u){return u.reduce((t,l)=>`${t}[${l}]`,"")}e.$on=$;function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$pn=g;const h=new p;f.$0m.add(e.$cn.Configuration,h);function c(u,t){return u.trim()?e.$mn.test(u)?L.localize(7,null,u):h.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,u,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$qn=c;function k(){const u=[],t=h.getConfigurationProperties();for(const l of Object.keys(t))u.push([l,t[l].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$rn=k}),define(ee[119],te([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(K,e,S,D,s,L,C,P,f,a,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=void 0;function d(l){return Object.isFrozen(l)?l:P.$Ym(l)}class y{constructor(r={},i=[],n=[],o){this.b=r,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new w("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,m.$oi)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),o=i?this.rawConfiguration.getOverrideValue(r,i):void 0,v=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:o,merged:v}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,m.$oi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return S.$Kb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return S.$Kb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=P.$Xm(this.contents),n=P.$Xm(this.overrides),o=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const R of r)if(v.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.h(i,R.contents);for(const A of R.overrides){const[E]=n.filter(I=>S.$sb(I.identifiers,A.identifiers));E?(this.h(E.contents,A.contents),E.keys.push(...A.keys),E.keys=S.$Kb(E.keys)):n.push(P.$Xm(A))}for(const A of R.keys)o.indexOf(A)===-1&&o.push(A)}return new y(i,o,n,v.every(R=>R instanceof y)?void 0:v)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of S.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let v=this.contents[o];const R=i[o];R&&(typeof v=="object"&&typeof R=="object"?(v=P.$Xm(v),this.h(v,R)):v=R),n[o]=v}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$yf(r[n])&&f.$yf(i[n])){this.h(r[n],i[n]);continue}r[n]=P.$Xm(i[n])}}i(r){let i=null,n=null;const o=v=>{v&&(n?this.h(n,v):n=P.$Xm(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===r?i=v.contents:v.identifiers.includes(r)&&o(v.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,m.$ni)(this.contents,r),b.$mn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$sb(n.identifiers,(0,b.$nn)(r))),1))}j(r,i,n){(0,m.$mi)(this.contents,r,i,o=>console.error(o)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),b.$mn.test(r)&&this.overrides.push({identifiers:(0,b.$nn)(r),keys:Object.keys(this.contents[r]),contents:(0,m.$li)(this.contents[r],o=>console.error(o))})}}e.$sn=y;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$Ff(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:o,overrides:v,restricted:R,hasExcludedProperties:A}=this.h(r,i);this.b=new y(n,o,v,A?[r]:void 0),this.c=R||[]}g(r){let i={},n=null,o=[];const v=[],R=[];function A(I){Array.isArray(o)?o.push(I):n!==null&&(o[n]=I)}const E={onObjectBegin:()=>{const I={};A(I),v.push(o),o=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{o=v.pop()},onArrayBegin:()=>{const I=[];A(I),v.push(o),o=I,n=null},onArrayEnd:()=>{o=v.pop()},onLiteralValue:A,onError:(I,M,U)=>{R.push({error:I,offset:M,length:U})}};if(r)try{s.$Um(r,E),i=o[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return i}h(r,i){const n=p.$0m.as(b.$cn.Configuration).getConfigurationProperties(),o=this.i(r,n,!0,i);r=o.raw;const v=(0,m.$li)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),R=Object.keys(r),A=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:v,keys:R,overrides:A,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(r,i,n,o){let v=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:v};const R={},A=[];for(const E in r)if(b.$mn.test(E)&&n){const I=this.i(r[E],i,!1,o);R[E]=I.raw,v=v||I.hasExcludedProperties,A.push(...I.restricted)}else{const I=i[E],M=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&A.push(E),!o.exclude?.includes(E)&&(o.include?.includes(E)||(M===void 0||o.scopes===void 0||o.scopes.includes(M))&&!(o.skipRestricted&&I?.restricted))?R[E]=r[E]:v=!0}return{raw:R,restricted:A,hasExcludedProperties:v}}j(r,i){const n=[];for(const o of Object.keys(r))if(b.$mn.test(o)){const v={};for(const R in r[o])v[R]=r[o][R];n.push({identifiers:(0,b.$nn)(o),keys:Object.keys(v),contents:(0,m.$li)(v,i)})}return n}}e.$tn=w;class $ extends L.$Qc{constructor(r,i,n,o){super(),this.c=r,this.f=i,this.g=o,this.b=this.B(new D.$Ld),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&n.isEqual(v.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$un=$;class g{constructor(r,i,n,o,v,R,A,E,I,M,U,B,se){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=v,this.f=R,this.g=A,this.h=E,this.i=I,this.j=M,this.k=U,this.l=B,this.m=se}get value(){return d(this.c)}n(r,i,n){const o=r.inspect(i,n);return{get value(){return d(o.value)},get override(){return d(o.override)},get merged(){return d(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,i,n,o,v=new y,R=new y,A=new C.$yc,E=new y,I=new C.$yc){this.c=r,this.d=i,this.f=n,this.g=o,this.h=v,this.i=R,this.j=A,this.l=E,this.m=I,this.a=null,this.b=new C.$yc,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new y,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const o=this.q(r,i,n),v=this.u(i.resource,n),R=i.resource?this.m.get(i.resource)||this.l:this.l,A=new Set;for(const E of o.overrides)for(const I of E.identifiers)o.getOverrideValue(r,I)!==void 0&&A.add(I);return new g(r,i,o.getValue(r),A.size?[...A]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,v||void 0,R)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:v,removed:R}=u(this.c,r);i=[...o,...v,...R]}for(const o of i)for(const v of(0,b.$nn)(o)){const R=this.c.getKeysForOverrideIdentifier(v),A=r.getKeysForOverrideIdentifier(v),E=[...A.filter(I=>R.indexOf(I)===-1),...R.filter(I=>A.indexOf(I)===-1),...R.filter(I=>!P.$2m(this.c.override(v).getValue(I),r.override(v).getValue(I)))];n.push([v,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=u(this.d,r),v=[...i,...n,...o];return v.length&&this.updatePolicyConfiguration(r),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.applicationConfiguration,r),R=[...i,...n,...o];return R.length&&this.updateApplicationConfiguration(r),{keys:R,overrides:v}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.localUserConfiguration,r),R=[...i,...n,...o];return R.length&&this.updateLocalUserConfiguration(r),{keys:R,overrides:v}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.remoteUserConfiguration,r),R=[...i,...n,...o];return R.length&&this.updateRemoteUserConfiguration(r),{keys:R,overrides:v}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.workspaceConfiguration,r),R=[...i,...n,...o];return R.length&&this.updateWorkspaceConfiguration(r),{keys:R,overrides:v}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:o,updated:v,removed:R,overrides:A}=u(n,i),E=[...o,...v,...R];return(E.length||!n)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:A}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:v,overrides:R}=u(i,void 0);return{keys:[...n,...o,...v],overrides:R}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}r({resource:r},i){let n=this.s();if(i&&r){const o=i.getFolder(r);o&&(n=this.t(o.uri)||n);const v=this.m.get(r);v&&(n=n.merge(v))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),o=this.j.get(r);o?(i=n.merge(o),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:v}=this.j.get(i);return r.push([i,{contents:n,overrides:o,keys:v}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),o=this.x(r.application),v=this.x(r.user),R=this.x(r.workspace),A=r.folders.reduce((E,I)=>(E.set(a.URI.revive(I[0]),this.x(I[1])),E),new C.$yc);return new h(i,n,o,v,new y,R,A,new y,new C.$yc)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$vn=h;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,i=new Map;for(const o of l)o.keys.forEach(v=>r.add(v)),o.overrides.forEach(([v,R])=>{const A=(0,C.$vc)(i,v,new Set);R.forEach(E=>A.add(E))});const n=[];return i.forEach((o,v)=>n.push([v,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.$wn=c;class k{constructor(r,i,n,o){this.change=r,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const v of r.keys)this.affectedKeys.add(v);for(const[,v]of r.overrides)for(const R of v)this.affectedKeys.add(R);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,o=this.d.indexOf(n);if(o<0)return!1;const v=o+n.length;if(v>=this.d.length)return!1;const R=this.d.charCodeAt(v);if(R!==this.b&&R!==this.c)return!1;if(i){const A=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!P.$2m(A,E)}return!0}}e.$xn=k;function u(l,r){const{added:i,removed:n,updated:o}=t(r?.rawConfiguration,l?.rawConfiguration),v=[],R=l?.getAllOverrideIdentifiers()||[],A=r?.getAllOverrideIdentifiers()||[];if(r){const E=A.filter(I=>!R.includes(I));for(const I of E)v.push([I,r.getKeysForOverrideIdentifier(I)])}if(l){const E=R.filter(I=>!A.includes(I));for(const I of E)v.push([I,l.getKeysForOverrideIdentifier(I)])}if(r&&l){for(const E of R)if(A.includes(E)){const I=t({contents:l.getOverrideValue(void 0,E)||{},keys:l.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});v.push([E,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:n,updated:o,overrides:v}}function t(l,r){const i=l?r?l.keys.filter(v=>r.keys.indexOf(v)===-1):[...l.keys]:[],n=r?l?r.keys.filter(v=>l.keys.indexOf(v)===-1):[...r.keys]:[],o=[];if(l&&r){for(const v of r.keys)if(l.keys.indexOf(v)!==-1){const R=(0,m.$oi)(r.contents,v),A=(0,m.$oi)(l.contents,v);P.$2m(R,A)||o.push(v)}}return{added:i,removed:n,updated:o}}}),define(ee[235],te([0,1,23,3,2,37,12,119,57,5,39,43]),function(K,e,S,D,s,L,C,P,f,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=void 0;class p extends s.$Qc{constructor(){super(...arguments),this.a=this.B(new D.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new P.$sn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$0m.as(f.$cn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:g})=>this.c(Array.from($),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,g){this.h($,b.$0m.as(f.$cn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new P.$sn;const $=b.$0m.as(f.$cn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,g){const h=this.f();for(const c of $){const k=h[c],u=g[c];k!==void 0?this.b.addValue(c,k):u?this.b.addValue(c,u.default):this.b.removeValue(c)}}}e.$yn=p;class d{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new P.$sn}async initialize(){return this.configurationModel}}e.$zn=d;let y=class extends s.$Qc{get configurationModel(){return this.b}constructor($,g,h){super(),this.c=$,this.f=g,this.g=h,this.a=this.B(new D.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new P.$sn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const g={},h=[],c=b.$0m.as(f.$cn.Configuration).getConfigurationProperties();for(const k of $){const u=c[k];if(!u){h.push(k);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}h.push(k),g[u.policy.name]={type:u.type}}}return(0,C.$Jf)(g)||await this.f.updatePolicyDefinitions(g),h}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const g=b.$0m.as(f.$cn.Configuration).getPolicyConfigurations(),h=(0,S.$Fb)($.map(c=>g.get(c)));this.m(h,!0)}m($,g){this.g.trace("PolicyConfiguration#update",$);const h=b.$0m.as(f.$cn.Configuration).getConfigurationProperties(),c=[],k=this.b.isEmpty();for(const u of $){const t=h[u]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(k?l!==void 0:!(0,L.$2m)(this.b.getValue(u),l))&&c.push([u,l])}else this.b.getValue(u)!==void 0&&c.push([u,void 0])}if(c.length){this.g.trace("PolicyConfiguration#changed",c);const u=this.b;this.b=new P.$sn;for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,l]of c)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);g&&this.a.fire(this.b)}}};e.$An=y,e.$An=y=ke([_(1,m.$_m),_(2,a.$7i)],y)}),define(ee[236],te([0,1,8,3,2,19,18,119,235,39]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=void 0;class m extends s.$Qc{constructor(p,d,y,w){super(),this.j=p,this.h=this.B(new D.$Ld),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$yn),this.c=y instanceof a.$bn?new f.$zn:this.B(new f.$An(this.b,y,w)),this.f=this.B(new P.$un(this.j,{},L.$kg,d)),this.a=new P.$vn(this.b.configurationModel,this.c.configurationModel,new P.$sn,new P.$sn),this.g=this.B(new S.$4g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:g})=>this.n($,g))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,d,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$vn(p,d,new P.$sn,y)}getConfigurationData(){return this.a.toData()}getValue(p,d){const y=typeof p=="string"?p:void 0,w=(0,C.$hi)(p)?p:(0,C.$hi)(d)?d:{};return this.a.getValue(y,w,void 0)}updateValue(p,d,y,w){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.m(p)}m(p){const d=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.s(y,d,2)}n(p,d){const y=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(p,d);this.s(w,y,7)}r(p){const d=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.s(y,d,7)}s(p,d,y){const w=new P.$xn(p,{data:d},this.a);w.source=y,w.sourceConfig=this.t(y),this.h.fire(w)}t(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Bn=m}),define(ee[237],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=e.$E7b=e.$D7b=void 0,e.$D7b="request",e.$E7b="remoteResourceHandler";class S{async routeCall(s,L,C){if(L!==e.$D7b)throw new Error(`Call not found: ${L}`);const P=C[0];if(P?.authority){const f=s.connections.find(a=>a.ctx===P.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,L){throw new Error(`Event not found: ${L}`)}}e.$F7b=S}),define(ee[238],te([0,1,14,6]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.RemoteAuthorityResolverErrorCode=e.$Nk=e.$Mk=e.RemoteConnectionType=e.$Lk=void 0,e.$Lk=(0,D.$Mh)("remoteAuthorityResolverService");var s;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class L{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Mk=L;class C{constructor(b,p){this.host=b,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nk=C;var P;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class f extends S.$_{static isNotAvailable(b){return b instanceof f&&b._code===P.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof f&&b._code===P.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof f&&b._code===P.NoResolverFound}static isInvalidAuthority(b){return b instanceof f&&b._code===P.InvalidAuthority}static isHandled(b){return b instanceof f&&b.isHandled}constructor(b,p=P.Unknown,d){super(b),this._message=b,this._code=p,this._detail=d,this.isHandled=p===P.NotAvailable&&d===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Ok=f;function a(m){const b=m.indexOf("+");return b===-1?m:m.substring(0,b)}e.$Pk=a}),define(ee[58],te([0,1,13]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=void 0;function D(a){return a.scheme===S.Schemas.vscodeRemote?a.authority:void 0}e.$Qk=D;function s(a){if(!a)return;const m=a.indexOf("+");return m<0?a:a.substr(0,m)}e.$Rk=s;function L(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$Sk=L;function C(a){const{host:m,port:b}=f(a);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:b}}e.$Tk=C;function P(a,m){let{host:b,port:p}=f(a);return typeof p>"u"&&(p=m),{host:b,port:p}}e.$Uk=P;function f(a){const m=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const b=a.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const p=a.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:a,port:void 0}}}),define(ee[120],te([0,1,27,6,58]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.TargetPlatform=e.ExtensionType=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl="extensions.user.cache",e.$Sl="extensions.builtin.cache",e.$Tl="undefined_publisher",e.$Ul=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Vl=L,e.$Wl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C||(e.ExtensionType=C={}));var P;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class f{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,g){if(typeof $>"u"||$===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof $=="string"||typeof g=="string"){const h=typeof $=="string"?$:$.value,c=typeof g=="string"?g:g.value;return S.$Ze(h,c)}return $._lower===g._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Xl=f;class a{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const g of $)this.add(g)}add($){this.c.add(f.toKey($))}delete($){return this.c.delete(f.toKey($))}has($){return this.c.has(f.toKey($))}}e.$Yl=a;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(f.toKey($))}get($){return this.c.get(f.toKey($))}has($){return this.c.has(f.toKey($))}set($,g){this.c.set(f.toKey($),g)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zl=m;function b(w){return p(w)}e.$1l=b;function p(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$2l=p;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$3l=d;function y(w,$){if($){const g=`onResolveRemoteAuthority:${(0,s.$Rk)($)}`;return!!w.activationEvents?.includes(g)}return!1}e.$4l=y,e.$5l=(0,D.$Mh)("IBuiltinExtensionsScannerService")}),define(ee[239],te([0,1,8,17,22,14,3,2,65,70,32,109,238,58]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.PersistentConnectionEventType=e.$2k=e.$1k=e.$Zk=e.ConnectionType=void 0;const y=30*1e3;var w;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function $(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(T){const O=new s.$Vd;return setTimeout(()=>O.cancel(),T),O.token}function h(T,O){if(T.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$Vd;return T.onCancellationRequested(()=>j.cancel()),O.onCancellationRequested(()=>j.cancel()),j.token}class c{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Pc,this.promise=new Promise((j,q)=>{this.f=j,this.g=q}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function k(T,O){const j=new c(O);return j.registerDisposable(T.onControlMessage(q=>{const W=JSON.parse(q.toString()),z=F(W);z?j.reject(z):j.resolve(W)})),j.promise}function u(T,O,j,q,W,z,G,ce){const de=new c(ce),ue=a.$Hd.create(!1);return T.info(`Creating a socket (${G})...`),f.mark(`code/willCreateSocket/${z}`),O.connect(j,q,W,G).then(fe=>{de.didTimeout?(f.mark(`code/didCreateSocketError/${z}`),T.info(`Creating a socket (${G}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(f.mark(`code/didCreateSocketOK/${z}`),T.info(`Creating a socket (${G}) was successful after ${ue.elapsed()} ms.`),de.resolve(fe))},fe=>{f.mark(`code/didCreateSocketError/${z}`),T.info(`Creating a socket (${G}) returned an error after ${ue.elapsed()} ms.`),T.error(fe),de.reject(fe)}),de.promise}function t(T,O){const j=new c(O);return T.then(q=>{j.didTimeout||j.resolve(q)},q=>{j.didTimeout||j.reject(q)}),j.promise}async function l(T,O,j,q){const W=ie(T,O);T.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let z;try{z=await u(T.logService,T.remoteSocketFactoryService,T.connectTo,(0,d.$Sk)(T),`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,$(O),`renderer-${$(O)}-${T.reconnectionToken}`,q)}catch(fe){throw T.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),T.logService.error(fe),fe}T.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let G,ce;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(z,null),G=T.reconnectionProtocol,ce=!1):(G=new b.$Ah({socket:z}),ce=!0),T.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const de=await t(T.signService.createNewMessage((0,m.$cg)()),q),ue={type:"auth",auth:T.connectionToken||"00000000000000000000",data:de.data};G.sendControl(D.$_d.fromString(JSON.stringify(ue)));try{const fe=await k(G,h(q,g(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(T.logService.trace(`${W} 4/6. received SignRequest control message.`),!await t(T.signService.validate(de,fe.signedData),q)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const be=await t(T.signService.sign(fe.data),q),pe={type:"connectionType",commit:T.commit,signedData:be,desiredConnectionType:O};return j&&(pe.args=j),T.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(D.$_d.fromString(JSON.stringify(pe))),{protocol:G,ownsProtocol:ce}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(T.logService.error(`${W} the handshake timed out. Error:`),T.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${W} received error control message when negotiating connection. Error:`),T.logService.error(fe)),ce&&V(G),fe}}async function r(T,O,j,q){const W=Date.now(),z=ie(T,O),{protocol:G,ownsProtocol:ce}=await l(T,O,j,q),de=new c(q);return de.registerDisposable(G.onControlMessage(ue=>{const fe=JSON.parse(ue.toString()),ye=F(fe);ye?(T.logService.error(`${z} received error control message when negotiating connection. Error:`),T.logService.error(ye),ce&&V(G),de.reject(ye)):(T.reconnectionProtocol?.endAcceptReconnection(),T.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(W)}!`),de.resolve({protocol:G,firstMessage:fe}))})),de.promise}async function i(T,O){const{protocol:j}=await r(T,1,void 0,O);return{protocol:j}}async function n(T,O,j){const{protocol:q,firstMessage:W}=await r(T,2,O,j),z=W&&W.debugPort;return{protocol:q,debugPort:z}}async function o(T,O,j){const q=Date.now(),W=ie(T,3),{protocol:z}=await l(T,3,O,j);return T.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${oe(q)}!`),z}async function v(T,O,j){const{connectTo:q,connectionToken:W}=await T.addressProvider.getAddress();return{commit:T.commit,quality:T.quality,connectTo:q,connectionToken:W,reconnectionToken:O,reconnectionProtocol:j,remoteSocketFactoryService:T.remoteSocketFactoryService,signService:T.signService,logService:T.logService}}async function R(T,O,j){return E(T,async q=>{const{protocol:W}=await i(q,s.CancellationToken.None);return new Q(T,O,j,q.reconnectionToken,W)})}e.$Zk=R;async function A(T,O){return E(T,async j=>{const{protocol:q,debugPort:W}=await n(j,O,s.CancellationToken.None);return new J(T,O,j.reconnectionToken,q,W)})}e.$1k=A;async function E(T,O){for(let q=1;;q++)try{const W=(0,m.$cg)(),z=await v(T,W,null);return await O(z)}catch(W){if(q<5)T.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),T.logService.error(W);else throw T.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),T.logService.error(W),re.triggerPermanentFailure(0,0,p.$Ok.isHandled(W)),W}}async function I(T,O,j){const q=await v(T,(0,m.$cg)(),null);return await o(q,{host:O,port:j},s.CancellationToken.None)}e.$2k=I;function M(T){return(0,S.$Fg)(O=>new Promise((j,q)=>{const W=setTimeout(j,T*1e3);O.onCancellationRequested(()=>{clearTimeout(W),j()})}))}var U;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class B{constructor(O,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.type=0}}e.$3k=B;class se{constructor(O,j,q,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.durationSeconds=q,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.$4k=se;class x{constructor(O,j,q){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=q,this.type=2}}e.$5k=x;class ae{constructor(O,j,q){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=q,this.type=4}}e.$6k=ae;class ne{constructor(O,j,q,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=q,this.handled=W,this.type=3}}e.$7k=ne;class re extends P.$Qc{static triggerPermanentFailure(O,j,q){this._permanentFailure=!0,this.f=O,this.g=j,this.h=q,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||re._permanentFailure}constructor(O,j,q,W,z){super(),this.t=O,this.u=j,this.reconnectionToken=q,this.protocol=W,this.w=z,this.m=this.B(new C.$Ld),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(W.onSocketClose(G=>{const ce=Y(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${ce} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${ce} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${ce} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(G=>{const ce=Y(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),re.j.push(this),this.B((0,P.$Oc)(()=>{const G=re.j.indexOf(this);G>=0&&re.j.splice(G,1)})),this.n&&this.D(re.f,re.g,re.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=Y(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const W=q<j.length?j[q]:j[j.length-1];try{if(W>0){const G=M(W);this.m.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,G)),this.u.logService.info(`${O} waiting for ${W} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this.u.logService.info(`${O} resolving connection...`);const z=await v(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${z.connectTo}...`),await this.G(z,g(y)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(p.$Ok.isTemporarilyNotAvailable(z)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,L.$2)(z)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof p.$Ok){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,p.$Ok.isHandled(z));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this.n&&!this.s)}C(O,j,q){this.w?re.triggerPermanentFailure(O,j,q):this.D(O,j,q)}D(O,j,q){this.m.fire(new ne(this.reconnectionToken,O,j,q)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8k=re;class Q extends re{constructor(O,j,q,W,z){super(1,O,W,z,!0),this.client=this.B(new b.$yh(z,{remoteAuthority:j,clientId:q},O.ipcLogger))}async G(O,j){await i(O,j)}}e.$9k=Q;class J extends re{constructor(O,j,q,W,z){super(2,O,q,W,!1),this.H=j,this.debugPort=z}async G(O,j){await n(O,this.H,j)}}e.$0k=J;function V(T){try{T.acceptDisconnect();const O=T.getSocket();T.dispose(),O.dispose()}catch(O){(0,L.$Y)(O)}}function F(T){if(T&&T.type==="error"){const O=new Error(`Connection error: ${T.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function N(T,O){for(;T.length<O;)T+=" ";return T}function H(T,O){return`[remote-connection][${N($(T),13)}][${O.substr(0,5)}\u2026]`}function Y(T,O,j){return`${H(T,O)}[${j?"reconnect":"initial"}]`}function ie(T,O){return`${Y(O,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.connectTo}]`}function oe(T){return`${Date.now()-T} ms`}}),define(ee[240],te([0,1,2,6]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk=(0,D.$Mh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,P){return this.a[C]??=[],this.a[C].push(P),(0,S.$Oc)(()=>{const f=this.a[C]?.indexOf(P);typeof f=="number"&&f>=0&&this.a[C]?.splice(f,1)})}b(C){return(this.a[C.type]||[]).find(f=>f.supports(C))}connect(C,P,f,a){const m=this.b(C);if(!m)throw new Error(`No socket factory found for ${C}`);return m.connect(C,P,f,a)}}e.$Wk=s}),define(ee[241],te([0,1,28,47,21,113]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=void 0;let C;async function P(d=!1){return(C===void 0||d)&&(C=f()),C}e.$E6b=P;async function f(){const d=a();if(d===void 0)return!1;if(d>=22e3){const y=b();if(y)return new Promise(w=>{D.execFile(y,["--status"],$=>w(!$))})}else{const y=p();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function a(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(d)return parseInt(d[3])}function m(d){const y=process.env.SystemRoot;if(y){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return L.join(y,w?"Sysnative":"System32",d)}}function b(){return m("wsl.exe")}function p(){return m("lxss\\LxssManager.dll")}}),define(ee[50],te([0,1,17,14,2,181,57,6,5,43]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Ko=(0,P.$Mh)("requestService");class m{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class b extends s.$Qc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,L.localize)(0,null),when:f.$lj.isEqualTo((0,f.$jj)(f.LogLevel.Trace)).serialize()})}async c(u,t,l){const r=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new m(t.headers??{}));try{const i=await l();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,D.$8)(i)),i}}}e.$Lo=b;function p(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}e.$Mo=p;function d(k){return k.res.statusCode===204}e.$No=d;async function y(k){return d(k)?null:(await(0,S.$le)(k.stream)).toString()}e.$Oo=y;async function w(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);return y(k)}e.$Po=w;async function $(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);if(d(k))return null;const t=(await(0,S.$le)(k.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.$Qo=$;function g(k){c(k)}e.$Ro=g;let h;function c(k){const u=a.$0m.as(C.$cn.Configuration),t=h;h={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[h],remove:t?[t]:[]})}c(1)}),define(ee[242],te([0,1,17,22]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;class s{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,a,m=D.CancellationToken.None){switch(f){case"request":return this.a.request(a[0],m).then(async({res:b,stream:p})=>{const d=await(0,S.$le)(p);return[{statusCode:b.statusCode,headers:b.headers},d]});case"resolveProxy":return this.a.resolveProxy(a[0])}throw new Error("Invalid call")}}e.$Nq=s;class L{constructor(P){this.a=P}async request(P,f){const[a,m]=await this.a.call("request",[P],f);return{res:a,stream:(0,S.$ne)(m)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$Oq=L}),define(ee[243],te([0,1,244,12]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;function s(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function L(C,P,f={}){const a=(0,S.parse)(C),m=f.proxyUrl||s(a,P);if(!m)return null;const b=(0,S.parse)(m);if(!/^https?:$/.test(b.protocol||""))return null;const p={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,D.$Cf)(f.strictSSL)?f.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((d,y)=>{K(["http-proxy-agent"],d,y)}))(p):new(await new Promise((d,y)=>{K(["https-proxy-agent"],d,y)}))(p)}e.$Pq=L}),define(ee[245],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=e.$16b=void 0,e.$16b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$26b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$36b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ee[93],te([0,1,47,9,182,22,49,14,4,32,108,63,8,138]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=void 0;let y;async function w(g,h,c,k){return c["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Il)(k)&&!c["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Il)(k)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(u,t)=>{const l=new L.$Vd;let r=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,d.$Jl)(i,1,120)*1e3);const n=setTimeout(()=>{l.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{u(await $(h,l.token))}catch(o){!(0,P.$2)(o)&&!l.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,C.$xi)(o)))):u({})}finally{clearTimeout(n),l.dispose()}})),y)}e.$Ol=w;async function $(g,h){const c=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",c);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",k);const u=(0,a.$cg)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"({.*})"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",l);const r=await(0,m.$yl)(f.OS,l);return g.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(h.isCancellationRequested)return n(new P.$3);const o=(0,D.$lc)(r);let v,R;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(v=`& '${process.execPath}' ${A} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,R=["-Login","-Command"]):o==="nu"?(v=`^'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,R=["-i","-l","-c"]):(v=`'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"||o==="csh"?R=["-ic"]:R=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),v);const E=(0,S.spawn)(r,[...R,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});h.onCancellationRequested(()=>(E.kill(),n(new P.$3))),E.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,C.$xi)(U)),n(U)});const I=[];E.stdout.on("data",U=>I.push(U));const M=[];E.stderr.on("data",U=>M.push(U)),E.on("close",(U,B)=>{const se=Buffer.concat(I).toString("utf8");g.trace("getUnixShellEnvironment#raw",se);const x=Buffer.concat(M).toString("utf8");if(x.trim()&&g.trace("getUnixShellEnvironment#stderr",x),U||B)return n(new Error((0,s.localize)(2,null,U,B)));const ae=t.exec(se),ne=ae?ae[1]:"{}";try{const re=JSON.parse(ne);c?re.ELECTRON_RUN_AS_NODE=c:delete re.ELECTRON_RUN_AS_NODE,k?re.ELECTRON_NO_ATTACH_CONSOLE=k:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",re),i(re)}catch(re){g.error("getUnixShellEnvironment#errorCaught",(0,C.$xi)(re)),n(re)}})})}}),define(ee[246],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const L=await this.c();if(L){const C=String(S.a++);return this.b.set(C,L),{id:C,data:L.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,L){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(L)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$22b=S}),define(ee[94],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=void 0,e.$Xk="signService",e.$Yk=(0,S.$Mh)(e.$Xk)}),define(ee[247],te([0,1,246]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=void 0;class D extends S.$22b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(C=>new C.signer().sign(L))}h(){return new Promise((L,C)=>K(["vsda"],L,C))}}e.$O7b=D}),define(ee[34],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=void 0,e.$kN=(0,S.$Mh)("stateReadService"),e.$lN=(0,S.$Mh)("stateService")}),define(ee[121],te([0,1,8,17,2,12,36,16,5]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.$nN=e.$mN=e.SaveStrategy=void 0;var a;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class m extends s.$Qc{constructor(y,w,$,g){super(),this.h=y,this.j=$,this.m=g,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new S.$Pg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.j.error(y)}}getItem(y,w){const $=this.a[y];return(0,L.$Ff)($)?w:$}setItem(y,w){this.setItems([{key:y,data:w}])}setItems(y){let w=!1;for(const{key:$,data:g}of y)this.a[$]!==g&&((0,L.$Ff)(g)?(0,L.$Df)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=g,w=!0));w&&this.r()}removeItem(y){(0,L.$Df)(this.a[y])||(this.a[y]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.m.writeFile(this.h,D.$_d.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$mN=m;let b=class extends s.$Qc{constructor(y,w,$,g){super(),this.a=this.B(new m(w.stateResource,y,$,g))}async init(){await this.a.init()}getItem(y,w){return this.a.getItem(y,w)}};e.$nN=b,e.$nN=b=ke([_(1,C.$Th),_(2,f.$7i),_(3,P.$8j)],b);class p extends b{setItem(y,w){this.a.setItem(y,w)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$oN=p}),define(ee[122],te([0,1,4,35,32]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=void 0;function L(f){if(S.$t===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function C(f,a,m,b,p,d,y,w){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,s.$cg)()+Date.now(),$.commitHash=b,$.version=p,$["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,S.$h)(S.$t),$["common.nodePlatform"]=D.$bc,$["common.nodeArch"]=m,$["common.product"]=w||"desktop",y&&($["common.msftInternal"]=y);let g=0;const h=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),S.$l&&($["common.snap"]="true");const c=L(a);return c&&($["common.platformDetail"]=c),$}e.$_n=C;function P(f){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const m=a.toLowerCase();return f.some(b=>m===b)}e.$ao=P}),define(ee[25],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=void 0,e.$$k=(0,S.$Mh)("telemetryService"),e.$_k=(0,S.$Mh)("customEndpointTelemetryService"),e.$al="telemetry.currentSessionDate",e.$bl="telemetry.firstSessionDate",e.$cl="telemetry.lastSessionDate",e.$dl="telemetry.machineId",e.$el="telemetry",e.$fl="telemetry.telemetryLevel",e.$gl="telemetry.enableCrashReporter",e.$hl="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var s;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ee[248],te([0,1,28,8,44,13,9,4,7,86,21,107,90,16,24,25]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=e.$vr=void 0;const $=new Map;async function g(t,l){const r=`${t}::${l.join(":")}`,i=$.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,v=new Map,R=2e4;function A(I,M,U,B){const se=M.substring(I.length+1);return D.Promises.withAsyncBody(async x=>{let ae;try{ae=await m.Promises.readdir(M,{withFileTypes:!0})}catch{x();return}if(B.count>=R){B.count+=ae.length,B.maxReached=!0,x();return}let ne=ae.length;if(ne===0){x();return}let re=ae;B.count+ae.length>R&&(B.maxReached=!0,ne=R-B.count,re=ae.slice(0,ne)),B.count+=ae.length;for(const Q of re)if(Q.isDirectory()){if(U.includes(Q.name)||await A(I,(0,C.$hc)(M,Q.name),U,B),--ne===0){x();return}}else{const J=Q.name.lastIndexOf(".");if(J>=0){const V=Q.name.substring(J+1);V&&o.set(V,(o.get(V)??0)+1)}for(const V of n)V.relativePathPattern?.test(se)!==!1&&V.filePattern.test(Q.name)&&v.set(V.tag,(v.get(V.tag)??0)+1);if(--ne===0){x();return}}})}const E=D.Promises.withAsyncBody(async I=>{const M={count:0,maxReached:!1};await A(t,t,l,M);const U=await k(t);I({configFiles:h(v),fileTypes:h(o),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:U})});return $.set(r,E),E}e.$vr=g;function h(t){return Array.from(t.entries(),([l,r])=>({name:l,count:r})).sort((l,r)=>r.count-l.count)}function c(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/d.$Ck.GB).toFixed(2)}GB (${(S.freemem()/d.$Ck.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.$Jm.value()*100)}%`},l=S.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.$wr=c;async function k(t){try{const l=new Map,r=(0,C.$hc)(t,".vscode","launch.json"),i=await m.Promises.readFile(r),n=[],o=(0,s.$Nm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$Wm)(o)==="object"&&o.configurations)for(const v of o.configurations){const R=v.type;R&&(l.has(R)?l.set(R,l.get(R)+1):l.set(R,1))}return h(l)}catch{return[]}}e.$xr=k;let u=class{constructor(l,r){this.c=l,this.d=r}f(l){const r=[];return r.push(`OS Version:       ${l.os}`),r.push(`CPUs:             ${l.cpus}`),r.push(`Memory (System):  ${l.memory}`),r.push(`VM:               ${l.vmHint}`),r.join(`
`)}g(l){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/d.$Ck.GB).toFixed(2)}GB (${(S.freemem()/d.$Ck.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(a.$Jm.value()*100)}%`),r.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${l.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(l,r){return Promise.all([(0,b.$ur)(l.mainPID),this.k(l)]).then(async i=>{let[n,o]=i,v=this.m(l,n);return r.forEach(R=>{if((0,p.$jm)(R))v+=`
${R.errorMessage}`,o+=`
${R.errorMessage}`;else if(v+=`

Remote: ${R.hostName}`,R.processes&&(v+=`
${this.m(l,R.processes)}`),R.workspaceMetadata){o+=`
|  Remote: ${R.hostName}`;for(const A of Object.keys(R.workspaceMetadata)){const E=R.workspaceMetadata[A];let I=`${E.fileCount} files`;E.maxFilesReached&&(I=`more than ${I}`),o+=`|    Folder (${A}): ${I}`,o+=this.h(E)}}}),{processInfo:v,workspaceInfo:o}})}async getSystemInfo(l,r){const{memory:i,vmHint:n,os:o,cpus:v}=c(),R={os:o,memory:i,cpus:v,vmHint:n,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(R.load=`${S.loadavg().map(A=>Math.round(A)).join(", ")}`),P.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(l,r){const i=[];return(0,b.$ur)(l.mainPID).then(async n=>(i.push(""),i.push(this.g(l)),i.push(""),i.push(this.m(l,n)),l.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(l))),r.forEach(o=>{if((0,p.$jm)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(l,o.processes)),o.workspaceMetadata)for(const v of Object.keys(o.workspaceMetadata)){const R=o.workspaceMetadata[v];let A=`${R.fileCount} files`;R.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${v}): ${A}`),i.push(this.h(R))}}),i.push(""),i.push(""),i.join(`
`)))}h(l){const r=[];let n=0;const o=(E,I)=>{const M=` ${E}(${I})`;n+M.length>60?(r.push(v),v="|                 ",n=v.length):n+=M.length,v+=M};let v="|      File types:";const R=10,A=l.fileTypes.length>R?R:l.fileTypes.length;for(let E=0;E<A;E++){const I=l.fileTypes[E];o(I.name,I.count)}if(r.push(v),l.configFiles.length>=0&&(v="|      Conf files:",n=0,l.configFiles.forEach(E=>{o(E.name,E.count)}),r.push(v)),l.launchConfigFiles.length>0){let E="|      Launch Configs:";l.launchConfigFiles.forEach(I=>{const M=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;E+=M}),r.push(E)}return r.join(`
`)}j(l){const r=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${l[i]}`).join(`
                  `)}k(l){const r=[],i=[];return l.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const v=f.URI.revive(o);if(v.scheme===L.Schemas.file){const R=v.fsPath;i.push(g(R,["node_modules",".git"]).then(A=>{let E=`${A.fileCount} files`;A.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,C.$lc)(R)}): ${E}`),r.push(this.h(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${R} (${A.toString()})`)}))}else r.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(l,r){const i=new Map;l.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),l.pidToNames.forEach(({pid:o,name:v})=>i.set(o,v));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(l.mainPID,i,n,r,0),n.join(`
`)}n(l,r,i,n,o){const v=o===0;let R;v?R=n.pid===l?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?R=r.get(n.pid):R=`${"  ".repeat(o)} ${n.name}`;const A=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(A/d.$Ck.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(l,r,i,E,o+1))}async getWorkspaceFileExtensions(l){const r=new Set;for(const{uri:i}of l.folders){const n=f.URI.revive(i);if(n.scheme!==L.Schemas.file)continue;const o=n.fsPath;try{(await g(o,["node_modules",".git"])).fileTypes.forEach(R=>r.add(R.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(l){for(const{uri:r}of l.folders){const i=f.URI.revive(r);if(i.scheme!==L.Schemas.file)continue;const n=i.fsPath;try{const o=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),o.fileTypes.forEach(v=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})}),o.launchConfigFiles.forEach(v=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})}),o.configFiles.forEach(v=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};e.$yr=u,e.$yr=u=ke([_(0,w.$$k),_(1,y.$mj)],u)}),define(ee[249],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=e.$66b=void 0;class S{constructor(L){this.b=L}listen(L,C){throw new Error(`Event not found: ${C}`)}call(L,C,{eventName:P,data:f}){return this.b.forEach(a=>a.log(P,f)),Promise.resolve(null)}}e.$66b=S;class D{constructor(L){this.b=L}log(L,C){return this.b.call("log",{eventName:L,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$76b=D}),define(ee[51],te([0,1,37,12,3,18,58,122,25]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$bo=a;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$co=m,e.$do=new m;class b{async publicLog(n,o,v){}async publicLogError(n,o,v){}}e.$eo=b,e.$fo="telemetry",e.$go="extensionTelemetryLog",e.$ho={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(v,R)=>{const A=v?new Set([...v.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:A}},1e3,!0)(v=>{v.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$ji)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.$io=p;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$jo=d;function y(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$ko=y;function w(i){const n=i.getValue(f.$fl),o=i.getValue(f.$gl);if(i.getValue(f.$hl)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$lo=w;function $(i){const n={},o={},v={};c(i,v);for(let R in v){R=R.length>150?R.substr(R.length-149):R;const A=v[R];typeof A=="number"?o[R]=A:typeof A=="boolean"?o[R]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${A.length}`),n[R]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(n[R]=A)}return{properties:n,measurements:o}}e.$mo=$;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const n=(0,C.$Rk)(i);return g.has(n)?n:"other"}e.$no=h;function c(i,n,o=0,v){if(i)for(const R of Object.getOwnPropertyNames(i)){const A=i[R],E=v?v+R:R;Array.isArray(A)?n[E]=(0,S.$3m)(A):A instanceof Date?n[E]=A.toISOString():(0,D.$yf)(A)?o<2?c(A,n,o+1,E+"."):n[E]=(0,S.$3m)(A):n[E]=A}}function k(i,n){const o=i.msftInternalDomains||[],v=n.getValue("telemetry.internalTesting");return(0,P.$ao)(o)||v}e.$oo=k;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$po=u;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const v=[];for(const I of n)for(;;){const M=I.exec(i);if(!M)break;v.push([M.index,I.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(o="";;){const I=A.exec(i);if(!I)break;const M=v.some(([U,B])=>I.index<B&&U<A.lastIndex);!R.test(I[0])&&!M&&(o+=i.substring(E,I.index)+"<REDACTED: user-file-path>",E=A.lastIndex)}return E<i.length&&(o+=i.substr(E)),o}function l(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function r(i,n){return(0,S.$Zm)(i,o=>{if(o instanceof a||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let v=o.replaceAll("%20"," ");v=t(v,n);for(const R of n)v=v.replace(R,"");return v=l(v),v}})}e.$qo=r}),define(ee[123],te([0,1,27,117,120,4,7,14,35,51]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;function m(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,S.$Ue)(r.id,i.id)===0}e.$ro=m;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,o)}static parse(i){const n=b.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$so=p;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=d.exec(r);return i&&i[1]?[$(i[1]),i[2]]:[$(r),void 0]}e.$to=y;function w(r,i){return`${r}.${i}`}e.$uo=w;function $(r){return r.toLowerCase()}e.$vo=$;function g(r,i){return $(w(r??s.$Tl,i))}e.$wo=g;function h(r,i){const n=[],o=v=>{for(const R of n)if(R.some(A=>m(i(A),i(v))))return R;return null};for(const v of r){const R=o(v);R?R.push(v):n.push([v])}return n}e.$xo=h;function c(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$yo=c;function k(r){return{id:new a.$bo(r.identifier.id),name:new a.$bo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$zo=k,e.$Ao=new s.$Xl("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const v=o.shift();if(v&&n.every(R=>!m(R.identifier,{id:v}))){const R=r.filter(A=>m(A.identifier,{id:v}));R.length===1&&(n.push(R[0]),o.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Bo=u;async function t(r,i){if(!L.$k)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){i.debug("Error while getting the os-release file.",(0,P.$8)(v))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,i){const n=await t(r,i),o=(0,D.$Wn)(n?"alpine":L.$t,f.$cc);return i.debug("ComputeTargetPlatform:",o),o}e.$Co=l}),define(ee[250],te([0,1,204,51]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=void 0;async function s(L,C,P,f,a,m,b){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${C.nameShort})`};if((0,D.$jo)(C,P)&&(0,D.$lo)(f)===3){const d=await(0,S.$4o)(P,a,m);p["X-Market-User-Id"]=d,p["VSCode-SessionId"]=b.machineId||d}return p}e.$5o=s}),define(ee[251],te([0,1,2,37,4,27,183,18,57,77,24,43,25,51]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,h,c){this.k=h,this.l=c,this.d={},this.i=new S.$Pc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,L.$De)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$De)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(p.$fl)||k.affectsConfiguration(p.$hl)||k.affectsConfiguration(p.$gl))&&this.m()}))}setExperimentProperty(g,h){this.d[g]=h}m(){let g=(0,d.$lo)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const c=h.usage?3:h.error?2:0;g=Math.min(g,c)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,h,c){this.g<h||(c=(0,D.$1m)(c,this.d),c=(0,d.$qo)(c,this.j),c=(0,D.$1m)(c,this.c),this.b.forEach(k=>k.log(g,c)))}publicLog(g,h){this.n(g,3,h)}publicLog2(g,h){this.publicLog(g,h)}publicLogError(g,h){this.h&&this.n(g,2,h)}publicLogError2(g,h){this.publicLogError(g,h)}};e.$Sq=y,e.$Sq=y=ke([_(1,P.$gi),_(2,m.$mj)],y);function w(){const $=(0,C.localize)(0,null,a.default.nameLong),g=a.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$o?"":(0,C.localize)(3,null),c=(0,C.localize)(4,null),k=(0,C.localize)(5,null),u=(0,C.localize)(6,null),t=(0,C.localize)(7,null),l=`
|       | ${c} | ${k} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${$} ${g} ${h}

&nbsp;

${t}
${l}

&nbsp;

${r}
`}b.$0m.as(f.$cn.Configuration).registerConfiguration({id:p.$el,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[p.$fl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$0m.as(f.$cn.Configuration).registerConfiguration({id:p.$el,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[p.$hl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,C.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,C.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${p.$fl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[252],te([0,1,4,86,25]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;async function L(C,P){let f=C.getItem(s.$dl);return(typeof f!="string"||S.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,D.$Km)(P.error.bind(P))),f}e.$w7b=L}),define(ee[253],te([0,1,25,252]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=void 0;async function s(L,C){const P=await(0,D.$w7b)(L,C);return L.setItem(S.$dl,P),P}e.$x7b=s}),define(ee[124],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(ee[254],te([0,1,4,124]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;const s=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class L{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((b,p)=>{this.d(b,p);const d=b.map.entries();let y=d.next();for(;!y.done;){const w=y.value[1],$=y.value[0];let g=this.a.get($);if(g||(g=[],this.a.set($,g)),g.length>0&&g[0].type===D.EnvironmentVariableMutatorType.Replace){y=d.next();continue}const h={extensionIdentifier:p,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};h.scope||delete h.scope,g.unshift(h),y=d.next()}})}async applyToProcessEnvironment(m,b,p){let d;S.$i&&(d={},Object.keys(m).forEach(y=>d[y.toLowerCase()]=y));for(const[y,w]of this.getVariableMap(b)){const $=S.$i&&d[y.toLowerCase()]||y;for(const g of w){const h=p?await p(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case D.EnvironmentVariableMutatorType.Append:m[$]=(m[$]||"")+h;break;case D.EnvironmentVariableMutatorType.Prepend:m[$]=h+(m[$]||"");break;case D.EnvironmentVariableMutatorType.Replace:m[$]=h;break}if(g.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${s.get(g.type)}`;m[c]=(m[c]?m[c]+":":"")+y+"="+this.c(h)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,b){const p=new Map,d=new Map,y=new Map;if(m.getVariableMap(b).forEach((w,$)=>{const g=this.getVariableMap(b).get($),h=P(w,g);h&&p.set($,h)}),this.getVariableMap(b).forEach((w,$)=>{const g=m.getVariableMap(b).get($),h=P(w,g);h&&y.set($,h)}),this.getVariableMap(b).forEach((w,$)=>{const g=m.getVariableMap(b).get($),h=f(w,g);h&&d.set($,h)}),!(p.size===0&&d.size===0&&y.size===0))return{added:p,changed:d,removed:y}}getVariableMap(m){const b=new Map;for(const p of this.a.values()){const d=p.filter(y=>C(y,m));d.length>0&&b.set(d[0].variable,d)}return b}getDescriptionMap(m){const b=new Map;for(const p of this.b.values()){const d=p.filter(y=>C(y,m,!0));for(const y of d)b.set(y.extensionIdentifier,y.description)}return b}d(m,b){if(!m.descriptionMap)return;const p=m.descriptionMap.entries();let d=p.next();for(;!d.done;){const y=d.value[1],w=d.value[0];let $=this.b.get(w);$||($=[],this.b.set(w,$));const g={extensionIdentifier:b,scope:y.scope,description:y.description};g.scope||delete g.scope,$.push(g),d=p.next()}}}e.$ir=L;function C(a,m,b=!1){return a.scope?!!(a.scope.workspaceFolder&&m?.workspaceFolder&&a.scope.workspaceFolder.index===m.workspaceFolder.index):b?m===a.scope:!0}function P(a,m){if(!m)return a;const b=new Set;m.forEach(d=>b.add(d.extensionIdentifier));const p=[];return a.forEach(d=>{b.has(d.extensionIdentifier)||p.push(d)}),p.length===0?void 0:p}function f(a,m){if(!m)return;const b=new Map;m.forEach(d=>b.set(d.extensionIdentifier,d));const p=[];return a.forEach(d=>{const y=b.get(d.extensionIdentifier);y&&(d.type!==y.type||d.value!==y.value||d.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&p.push(y)}),p.length===0?void 0:p}}),define(ee[255],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=e.$er=e.$dr=e.$cr=void 0;function S(f){return[...f.entries()]}e.$cr=S;function D(f){return f?[...f.entries()]:[]}e.$dr=D;function s(f){return new Map(f)}e.$er=s;function L(f){return new Map(f??[])}e.$fr=L;function C(f){return Array.from(f.entries()).map(a=>[a[0],S(a[1].map),D(a[1].descriptionMap)])}e.$gr=C;function P(f){return new Map(f.map(a=>[a[0],{map:s(a[1]),descriptionMap:L(a[2])}]))}e.$hr=P}),define(ee[256],te([0,1,8,22,3,2,5]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let P=class extends L.$Qc{constructor(a,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Ld),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,L.$Oc)(()=>{for(const b of this.f.values())(0,L.$Lc)(b)}))}createRequest(a){return new Promise((m,b)=>{const p=++this.a;this.c.set(p,m),this.g.fire({requestId:p,...a});const d=new D.$Vd;(0,S.$Sg)(this.b,d.token).then(()=>b(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,L.$Oc)(()=>d.cancel())])})}acceptReply(a,m){const b=this.c.get(a);b?(this.c.delete(a),(0,L.$Lc)(this.f.get(a)||[]),this.f.delete(a),b(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$6q=P,e.$6q=P=ke([_(1,C.$7i)],P)}),define(ee[125],te([0,1,6,114,43]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Yq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Xq=void 0,e.$Xq=new D.$4i("terminalTabFocusMode",!1,!0);var L;(function(u){u.AutomationProfile="terminal.integrated.automationProfile.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(L||(e.TerminalSettingPrefix=L={}));var C;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var P;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(P||(e.PosixShellType=P={}));var f;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var a;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var m;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var b;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$Yq=(0,S.$Mh)("ptyService");var p;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var d;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y||(e.TerminalLocationString=y={}));var w;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var $;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var g;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var h;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var c;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.$Zq={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$0m.add(e.$Zq.Backend,new k),e.$1q=(0,S.$Mh)("localPtyService"),e.$2q=(0,S.$Mh)("terminalLogService")}),define(ee[257],te([0,1,72,7,185,102]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.$7q=void 0;function C(p,d){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...p.map(w=>({name:w.profileName,description:P(w)}))),d&&y.push(...d.map(w=>({name:w.title,description:f(w)}))),{values:y.map(w=>w.name),markdownDescriptions:y.map(w=>w.description)}}e.$7q=C;function P(p){let d=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:S.$Rj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?d+=`
- args: "${p.args}"`:d+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(d+=`
- overrideName: ${p.overrideName}`),p.color&&(d+=`
- color: ${p.color}`),p.env&&(d+=`
- env: ${JSON.stringify(p.env)}`),d}function f(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:S.$Rj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function a(p,d){if(!p&&!d)return!0;if(typeof p=="string"&&typeof d=="string")return p===d;if(Array.isArray(p)&&Array.isArray(d)){if(p.length!==d.length)return!1;for(let y=0;y<p.length;y++)if(p[y]!==d[y])return!1;return!0}return!1}e.$8q=a;function m(p,d){if(!p&&!d)return!0;if(!p||!d)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(d))return p.id===d.id&&p.color===d.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof d=="object"&&"light"in d&&"dark"in d){const y=p,w=d;if((D.URI.isUri(y.light)||b(y.light))&&(D.URI.isUri(y.dark)||b(y.dark))&&(D.URI.isUri(w.light)||b(w.light))&&(D.URI.isUri(w.dark)||b(w.dark)))return y.light.path===w.light.path&&y.dark.path===w.dark.path}if(D.URI.isUri(p)&&D.URI.isUri(d)||b(p)||b(d)){const y=p,w=d;return y.path===w.path&&y.scheme===w.scheme}return!1}e.$9q=m;function b(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$0q=b}),define(ee[258],te([0,1,72,4,184,57,43,257]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=e.$$q=void 0,e.$$q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$_q={type:"string",enum:Array.from((0,S.$Qj)(),$=>$.id),markdownEnumDescriptions:Array.from((0,S.$Qj)(),$=>`$(${$.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$_q},color:{description:(0,s.localize)(3,null),...e.$$q},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},m={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function b($){const g=$===2?"linux":$===1?"osx":"windows";return(0,s.localize)(7,null,(0,D.$h)($),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){C.$0m.as(L.$cn.Configuration).registerConfiguration(p),w()}e.$ar=d;let y;function w($,g){const h=C.$0m.as(L.$cn.Configuration);let c;$&&(c=(0,P.$7q)($?.profiles,g));const k=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:$?.os===3?c?.values:void 0,markdownEnumDescriptions:$?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:$?.os===2?c?.values:void 0,markdownEnumDescriptions:$?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:$?.os===1?c?.values:void 0,markdownEnumDescriptions:$?.os===1?c?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[y],remove:k?[k]:[]})}e.$br=w}),define(ee[259],te([0,1,28,13,37,9,4,35,27,12,21,124,255,254]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$jr=y;async function w(i,n,o,v=P.env,R=m.Promises.exists){if(L.$gc(i))return await R(i)?i:void 0;if(n===void 0&&(n=P.cwd()),L.$kc(i)!=="."){const M=L.$hc(n,i);return await R(M)?M:void 0}const E=(0,s.$5m)(v,"PATH");if(o===void 0&&(0,a.$wf)(E)&&(o=E.split(L.$rc)),o===void 0||o.length===0){const M=L.$hc(n,i);return await R(M)?M:void 0}for(const M of o){let U;if(L.$gc(M)?U=L.$hc(M,i):U=L.$hc(n,M,i),await R(U))return U;if(C.$i){let B=U+".com";if(await R(B)||(B=U+".exe",await R(B)))return B}}const I=L.$hc(n,i);return await R(I)?I:void 0}e.$kr=w;function $(i,n,o,v,R){const A=C.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||A)return;const E=i.args,I=P.$bc==="win32"?L.$lc(i.executable).toLowerCase():L.$lc(i.executable),M=L.$kc(D.$ag.asFileUri("").fsPath);let U;const B={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(B.VSCODE_NONCE=n.shellIntegration.nonce),C.$i){if(I==="pwsh.exe"||I==="powershell.exe")return!E||l(E)?U=c.get(h.WindowsPwsh):t(E)&&(U=c.get(h.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$Ae)(U[U.length-1],M,""),{newArgs:U,envMixin:B}):void 0;v.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(I){case"bash":return!E||E.length===0?U=c.get(h.Bash):r(E)&&(B.VSCODE_SHELL_LOGIN="1",g(n,B),U=c.get(h.Bash)),U?(U=[...U],U[U.length-1]=(0,f.$Ae)(U[U.length-1],M),{newArgs:U,envMixin:B}):void 0;case"fish":{const se=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${se}:${x}`,g(n,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!E||l(E)?U=c.get(h.Pwsh):t(E)&&(U=c.get(h.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$Ae)(U[U.length-1],M,""),{newArgs:U,envMixin:B}):void 0;case"zsh":{if(!E||E.length===0?U=c.get(h.Zsh):r(E)?(U=c.get(h.ZshLogin),g(n,B)):(E===c.get(h.Zsh)||E===c.get(h.ZshLogin))&&(U=E),!U)return;U=[...U],U[U.length-1]=(0,f.$Ae)(U[U.length-1],M);let se;try{se=S.userInfo().username}catch{se="unknown"}const x=L.$hc(S.tmpdir(),`${se}-${R.applicationName}-zsh`);B.ZDOTDIR=x;const ae=o?.ZDOTDIR??S.homedir()??"~";B.USER_ZDOTDIR=ae;const ne=[];return ne.push({source:L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.$hc(x,".zshrc")}),ne.push({source:L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.$hc(x,".zprofile")}),ne.push({source:L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.$hc(x,".zshenv")}),ne.push({source:L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.$hc(x,".zlogin")}),{newArgs:U,envMixin:B,filesToCopy:ne}}}v.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$lr=$;function g(i,n){if(C.$j&&i.environmentVariableCollections){const o=(0,p.$hr)(i.environmentVariableCollections),R=new d.$ir(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),A=[];if(R)for(const E of R)E.type===b.EnvironmentVariableMutatorType.Prepend&&A.push(E.value);A.length>0&&(n.VSCODE_PATH_PREFIX=A.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const c=new Map;c.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(h.Zsh,["-i"]),c.set(h.ZshLogin,["-il"]),c.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],u=["-nol","-nologo"];function t(i){return typeof i=="string"?k.includes(i.toLowerCase()):i.length===1&&k.includes(i[0].toLowerCase())||i.length===2&&(k.includes(i[0].toLowerCase())||k.includes(i[1].toLowerCase()))&&(u.includes(i[0].toLowerCase())||u.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?u.includes(i.toLowerCase()):i.length===0||i?.length===1&&u.includes(i[0].toLowerCase())}function r(i){return i==="string"&&k.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&k.includes(i[0].toLowerCase())}}),define(ee[260],te([0,1,47,72,9,4,12,21,106,259,113]),function(K,e,S,D,s,L,C,P,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;let b,p=!0;function d(n,o,v,R,A=process.env,E,I,M,U){return E=E||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},L.$i?y(v,E,A,I,R.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:R.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:R.getValue("terminal.integrated.defaultProfile.windows"),U,M):l(E,I,v,n&&typeof n=="object"?{...n}:R.getValue(L.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:R.getValue(L.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,M,A)}e.$mr=d;async function y(n,o,v,R,A,E,I,M,U){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let x=!1;(0,a.$jr)()>=16299&&(x=!0),await h(M);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:D.$Rj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.$Rj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:D.$Rj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:D.$Rj.terminalBash,isAutoDetected:!0});const re=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",re],requiresPath:process.env.CMDER_ROOT?re:{path:re,isUnsafe:!0},isAutoDetected:!0})}r(E,ae);const ne=await w(ae.entries(),I,o,v,R,U);if(n&&A)try{const re=await u(`${se}\\${x?"wsl":"bash"}.exe`,I);for(const Q of re)(!E||!(Q.profileName in E))&&ne.push(Q)}catch{p&&(R?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return ne}async function w(n,o,v,R=process.env,A,E){const I=[];for(const[M,U]of n)I.push($(M,U,o,v,R,A,E));return(await Promise.all(I)).filter(M=>!!M)}async function $(n,o,v,R,A=process.env,E,I){if(o===null)return;let M,U,B;if("source"in o&&!("path"in o)){const ne=b?.get(o.source);if(!ne)return;M=ne.paths,U=o.args||ne.args,o.icon?B=g(o.icon):ne.icon&&(B=ne.icon)}else M=Array.isArray(o.path)?o.path:[o.path],U=L.$i||Array.isArray(o.args)?o.args:void 0,B=g(o.icon);let se;if(I){const ne=M.map(Q=>typeof Q=="string"?Q:Q.path),re=await I(ne);se=new Array(M.length);for(let Q=0;Q<M.length;Q++)typeof M[Q]=="string"?se[Q]=re[Q]:se[Q]={path:re[Q],isUnsafe:!0}}else se=M.slice();let x;if(o.requiresPath){let ne;if((0,C.$wf)(o.requiresPath)?ne=o.requiresPath:(ne=o.requiresPath.path,o.requiresPath.isUnsafe&&(x=ne)),!await R.existsFile(ne))return}const ae=await i(n,v,se,R,A,U,o.env,o.overrideName,o.isAutoDetected,x);if(!ae){E?.debug("Terminal profile not validated",n,M);return}return ae.isAutoDetected=o.isAutoDetected,ae.icon=B,ae.color=o.color,ae}function g(n){return typeof n=="string"?{id:n}:n}async function h(n){if(b&&!n)return;const[o,v]=await Promise.all([c(),n||k()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:v,icon:D.$Rj.terminalPowershell})}async function c(){const n=new Set,o=await(0,a.$kr)("git.exe");if(o){const A=(0,m.dirname)(o);n.add((0,m.resolve)(A,"../.."))}function v(A,E){E&&A.add(E)}v(n,process.env.ProgramW6432),v(n,process.env.ProgramFiles),v(n,process.env["ProgramFiles(X86)"]),v(n,`${process.env.LocalAppData}\\Program`);const R=[];for(const A of n)R.push(`${A}\\Git\\bin\\bash.exe`,`${A}\\Git\\usr\\bin\\bash.exe`,`${A}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function k(){const n=[];for await(const o of(0,f.$sl)())n.push(o.exePath);return n}async function u(n,o){const v=[],R=await new Promise((I,M)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,B)=>{if(U)return M("Problem occurred when getting wsl distros");I(B)})});if(!R)return[];const A=new RegExp(/[\r?\n]/),E=R.split(A).filter(I=>I.trim().length>0&&I!=="");for(const I of E){if(I===""||I.startsWith("docker-desktop"))continue;const M=`${I} (WSL)`,U={profileName:M,path:n,args:["-d",`${I}`],isDefault:M===o,icon:t(I),isAutoDetected:!1};v.push(U)}return v}function t(n){return n.includes("Ubuntu")?D.$Rj.terminalUbuntu:n.includes("Debian")?D.$Rj.terminalDebian:D.$Rj.terminalLinux}async function l(n,o,v,R,A,E,I,M){const U=new Map;if(v){const B=(await n.readFile("/etc/shells")).toString(),se=(E||B.split(`
`)).map(ae=>{const ne=ae.indexOf("#");return ne===-1?ae:ae.substring(0,ne)}).filter(ae=>ae.trim().length>0),x=new Map;for(const ae of se){let ne=(0,s.$lc)(ae),re=x.get(ne)||0;re++,re>1&&(ne=`${ne} (${re})`),x.set(ne,re),U.set(ne,{path:ae,isAutoDetected:!0})}}return r(R,U),await w(U.entries(),A,n,M,o,I)}function r(n,o){if(n)for(const[v,R]of Object.entries(n))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?o.delete(v):(R.icon=R.icon||o.get(v)?.icon,o.set(v,R))}async function i(n,o,v,R,A,E,I,M,U,B){if(v.length===0)return Promise.resolve(void 0);const se=v.shift();if(se==="")return i(n,o,v,R,A,E,I,M,U);const x=typeof se!="string"&&se.isUnsafe,ae=typeof se=="string"?se:se.path,ne={profileName:n,path:ae,args:E,env:I,overrideName:M,isAutoDetected:U,isDefault:n===o,isUnsafePath:x,requiresUnsafePath:B};if((0,s.$lc)(ae)===ae){const Q=A.PATH?A.PATH.split(s.$rc):void 0,J=await(0,a.$kr)(ae,void 0,Q,void 0,R.existsFile);return J?(ne.path=J,ne.isFromPath=!0,ne):i(n,o,v,R,A,E)}return await R.existsFile((0,s.$fc)(ae))?ne:i(n,o,v,R,A,E,I,M,U)}}),define(ee[261],te([0,1,3,2,4,42,18,5,224,93,256,125,258,260,108,70]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;var $;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})($||($={}));let g=class extends D.$Qc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(c,k,u,t){super(),this.M=c,this.N=k,this.O=u,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Ld),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Ld),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Ld),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Ld),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Ld),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Ld),this.onProcessData=this.D.event,this.F=this.B(new S.$Ld),this.onProcessReady=this.F.event,this.G=this.B(new S.$Ld),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Ld),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Ld),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Ld),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Ld),this.onProcessExit=this.L.event,(0,p.$ar)(),this.B(this.M),this.B((0,D.$Oc)(()=>this.W())),this.j=this.B(new m.$6q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,a.$Ol)(this.N,this.O,{_:[]},process.env)}catch(c){return this.O.error("ptyHost was unable to resolve shell environment",c),{}}}U(){const c=this.M.start(),k=c.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),L.ProxyChannel.toService(k.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(c.onDidProcessExit(l=>{this.u.fire(l.code),!this.m&&!this.q.isDisposed&&(this.n<=$.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=L.ProxyChannel.toService(k.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(l=>this.D.fire(l))),this.B(t.onProcessReady(l=>this.F.fire(l))),this.B(t.onProcessExit(l=>this.L.fire(l))),this.B(t.onDidChangeProperty(l=>this.J.fire(l))),this.B(t.onProcessReplay(l=>this.G.fire(l))),this.B(t.onProcessOrphanQuestion(l=>this.H.fire(l))),this.B(t.onDidRequestDetach(l=>this.I.fire(l))),this.B(new f.$5q(this.P,k.getChannel(b.TerminalIpcChannels.Logger))),this.a=c,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[c,t]}async createProcess(c,k,u,t,l,r,i,n,o,v,R){const A=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(c,k,u,t,l,r,i,n,o,v,R);return clearTimeout(A),E}updateTitle(c,k,u){return this.f.updateTitle(c,k,u)}updateIcon(c,k,u,t){return this.f.updateIcon(c,k,u,t)}attachToProcess(c){return this.f.attachToProcess(c)}detachFromProcess(c,k){return this.f.detachFromProcess(c,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(c){return this.f.start(c)}shutdown(c,k){return this.f.shutdown(c,k)}input(c,k){return this.f.input(c,k)}processBinary(c,k){return this.f.processBinary(c,k)}resize(c,k,u){return this.f.resize(c,k,u)}clearBuffer(c){return this.f.clearBuffer(c)}acknowledgeDataEvent(c,k){return this.f.acknowledgeDataEvent(c,k)}setUnicodeVersion(c,k){return this.f.setUnicodeVersion(c,k)}getInitialCwd(c){return this.f.getInitialCwd(c)}getCwd(c){return this.f.getCwd(c)}async getLatency(){const c=new w.$Hd,k=await this.f.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...k]}orphanQuestionReply(c){return this.f.orphanQuestionReply(c)}installAutoReply(c,k){return this.f.installAutoReply(c,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(c){return this.f.uninstallAutoReply(c)}getDefaultSystemShell(c){return this.g?.getDefaultSystemShell(c)??(0,y.$yl)(c??s.OS,process.env)}async getProfiles(c,k,u,t=!1){const l=await this.S();return(0,d.$mr)(k,u,t,this.N,l,void 0,this.O,this.bb.bind(this,c))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(c,k){return this.f.getWslPath(c,k)}getRevivedPtyNewId(c,k){return this.f.getRevivedPtyNewId(c,k)}setTerminalLayoutInfo(c){return this.f.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this.g?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,k){return this.f.requestDetachInstance(c,k)}async acceptDetachInstanceReply(c,k){return this.f.acceptDetachInstanceReply(c,k)}async freePortKillProcess(c){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(c)}async serializeTerminalState(c){return this.f.serializeTerminalState(c)}async reviveTerminalProcesses(c,k,u){return this.f.reviveTerminalProcesses(c,k,u)}async refreshProperty(c,k){return this.f.refreshProperty(c,k)}async updateProperty(c,k,u){return this.f.updateProperty(c,k,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(c){this.ab(),this.s=setTimeout(()=>this.Y(),c?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(c,k){return this.j.createRequest({workspaceId:c,originalText:k})}async acceptPtyHostResolvedVariables(c,k){this.j.acceptReply(c,k)}};e.$nr=g,e.$nr=g=ke([_(1,C.$gi),_(2,P.$7i),_(3,P.$8i)],g)}),define(ee[67],te([0,1,15,3,2,4,18,6,34]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=e.$65b=void 0;const a="#FFFFFF",m="#1E1E1E",b="#000000",p="#FFFFFF",d="theme",y="themeBackground",w="windowSplash";e.$65b=(0,P.$Mh)("themeMainService");let $=class extends s.$Qc{constructor(h,c){super(),this.b=h,this.c=c,this.a=this.B(new D.$Ld),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(L.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(L.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?b:p;let c=this.b.getItem(y,null);if(!c)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":c=a;break;case"hc-black":c=b;break;case"hc-light":c=p;break;default:c=m}return L.$j&&c.toUpperCase()===m&&(c="#171717"),c}saveWindowSplash(h,c){this.b.setItems([{key:d,data:c.baseTheme},{key:y,data:c.colorInfo.background},{key:w,data:c}]),typeof h=="number"&&this.f(h,c)}f(h,c){for(const k of S.BrowserWindow.getAllWindows())if(k.id===h){k.setBackgroundColor(c.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$75b=$,e.$75b=$=ke([_(0,f.$lN),_(1,C.$gi)],$)}),define(ee[126],te([0,1,3,18,6,5]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.ProvidedOnAutoForward=e.$4u=e.TunnelPrivacyId=e.TunnelProtocol=e.$3u=e.$2u=void 0,e.$2u=(0,s.$Mh)("tunnelService"),e.$3u=(0,s.$Mh)("sharedTunnelsService");var C;(function($){$.Http="http",$.Https="https"})(C||(e.TunnelProtocol=C={}));var P;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(P||(e.TunnelPrivacyId=P={}));function f($){return!!$.forwardPort}e.$4u=f;var a;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function m($){if($.scheme!=="http"&&$.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(g)return{address:g[1],port:+g[2]}}e.$5u=m,e.$6u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b($){return e.$6u.indexOf($)>=0}e.$7u=b,e.$8u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p($){return e.$8u.indexOf($)>=0}e.$9u=p;function d($,g,h,c){if(h===1)return!1;if(h===2&&p(g)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(k?.length===4&&parseInt(k[1])>=18)return!1}return $<1024}e.$0u=d;class y{constructor(g,h,c){this.remoteAddress=g,this.localAddress=h,this.b=c,this.a=new S.$Ld,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$$u=y;let w=class{constructor(g,h){this.j=g,this.k=h,this.a=new S.$Ld,this.onTunnelOpened=this.a.event,this.b=new S.$Ld,this.onTunnelClosed=this.b.event,this.c=new S.$Ld,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const g=this.k.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.f=g,g?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.g=g.elevation,this.h=g.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const g=[],h=Array.from(this.e.values());for(const c of h){const k=Array.from(c.values());for(const u of k){const t=await u.value;t&&typeof t!="string"&&g.push(t)}}return g}async dispose(){for(const g of this.e.values()){for(const{value:h}of g.values())await h.then(c=>typeof c!="string"?c?.dispose():void 0);g.clear()}this.e.clear()}setEnvironmentTunnel(g,h,c,k,u){this.p(g,h,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:h,localAddress:c,privacy:k,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,h){(p(g)||b(g))&&(g=e.$6u[0]);const c=this.r(g,h);if(c)return++c.refcount,c.value}openTunnel(g,h,c,k,u,t=!1,l,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${c} on local port ${u}.`);const i=this.f??g;if(!i)return;if(h||(h="localhost"),k||(k=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,h,c,k,u,t,l,r);return n?n.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,c),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.n(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&o.privacy!==l&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const h=this.e.get(g.tunnelRemoteHost);if(h){const c=h.get(g.tunnelRemotePort);c&&(c.refcount--,await this.o(g.tunnelRemoteHost,g.tunnelRemotePort,c))}}}}async o(g,h,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${h}.`);const k=c.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(g)&&this.e.get(g).delete(h),k}}async closeTunnel(g,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${h} `);const c=this.e.get(g);if(c&&c.has(h)){const k=c.get(h);k.refcount=0,await this.o(g,h,k)}}p(g,h,c){this.e.has(g)||this.e.set(g,new Map),this.e.get(g).set(h,{refcount:1,value:c})}async q(g,h){const c=this.e.get(g);if(c){const k=c.get(h),u=k?await k.value:void 0;(!u||typeof u=="string")&&c.delete(h),c.size===0&&this.e.delete(g)}}r(g,h){const c=[g];b(g)?(c.push(...e.$6u),c.push(...e.$8u)):p(g)&&c.push(...e.$8u);const k=c.map(u=>this.e.get(u));for(const u of k){const t=u?.get(h);if(t)return t}}canTunnel(g){return!!m(g)}t(g,h,c,k,u,t,l){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${c} on local port ${k}.`);const r=c;this.i.add(r);const i=k===void 0?c:k,n={elevationRequired:u?this.isPortPrivileged(i):!1},o={remoteAddress:{host:h,port:c},localAddressPort:k,privacy:t,public:t?t!==P.Private:void 0,protocol:l},v=g.forwardPort(o,n);return v?(this.p(h,c,v),v.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),v}};e.$_u=w,e.$_u=w=ke([_(0,L.$7i),_(1,D.$gi)],w)}),define(ee[48],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7T=e.$6T=e.DisablementReason=e.UpdateType=e.StateType=void 0;var D;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(D||(e.StateType=D={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var L;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(L||(e.DisablementReason=L={})),e.$6T={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$7T=(0,S.$Mh)("updateService")}),define(ee[262],te([0,1,4,186,57,43]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),L.$0m.as(s.$cn.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[263],te([0,1,3,48]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=e.$86b=void 0;class s{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,a){switch(f){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${f}`)}}e.$86b=s;class L{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Ld,this.onStateChange=this.a.event,this.b=D.$6T.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$96b=L}),define(ee[40],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=void 0,e.$Ek=(0,S.$Mh)("IUriIdentityService")}),define(ee[264],te([0,1,40,205,16,19,139,3,2]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class a{static{this._clock=0}constructor(p){this.uri=p,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let m=class{constructor(p){this.g=p,this.c=new f.$Pc,this.f=2**16;const d=new Map,y=w=>{let $=d.get(w.scheme);return $===void 0&&($=p.hasProvider(w)&&!this.g.hasCapability(w,1024),d.set(w.scheme,$)),$};this.c.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new L.$ig(y),this.d=new C.$qr((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,L.$ug)(p));const d=this.d.get(p);return d?d.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new a(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);a._clock=0,this.d.clear();const d=this.f*.5;for(let y=0;y<d;y++)this.d.set(p[y][0],p[y][1].touch())}};e.$rr=m,e.$rr=m=ke([_(0,s.$8j)],m),(0,D.$or)(S.$Ek,m,1)}),define(ee[127],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UT=void 0,e.$UT=(0,S.$Mh)("urlService")}),define(ee[265],te([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=e.$e7b=e.$d7b=void 0;class D{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,a){switch(f){case"handleURL":return this.a.handleURL(S.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${f}`)}}e.$d7b=D;class s{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.$e7b=s;class L{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,a,m){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(a)&&a.length>0){const b=S.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const p=/\bwindowId=(\d+)/.exec(b.query);if(p){const d=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,b.toString(!0));const y=new RegExp(`window:${d}`),w=P.connections.find($=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",$.ctx),y.test($.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,a,m)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.$f7b=L}),define(ee[266],te([0,1,8,2,7,24]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WT=e.$VT=void 0;class C extends D.$Qc{constructor(){super(...arguments),this.a=new Set}open(a,m){const b=[...this.a.values()];return(0,S.$Vg)(b.map(p=>()=>p.handleURL(a,m)),void 0,!1).then(p=>p||!1)}registerHandler(a){return this.a.add(a),(0,D.$Oc)(()=>this.a.delete(a))}}e.$VT=C;let P=class extends C{constructor(a){super(),this.b=a}create(a){let{authority:m,path:b,query:p,fragment:d}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&b&&b.indexOf("/")!==0&&(b=`/${b}`),s.URI.from({scheme:this.b.urlProtocol,authority:m,path:b,query:p,fragment:d})}};e.$WT=P,e.$WT=P=ke([_(0,L.$mj)],P)}),define(ee[267],te([0,1,15,8,3,2,4,7]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;class f extends L.$Qc{constructor(m,b,p,d,y,w){if(super(),this.c=b,this.f=w,this.a=[],this.b=0,m&&(w.trace("ElectronURLListener initialUrisToHandle:",m.map(h=>h.originalUrl)),this.a=m),C.$i){const h=d.isBuilt?[]:[`"${d.appRoot}"`];h.push("--open-url","--"),S.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,h)}const $=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(h,c)=>({event:h,url:c})),({event:h,url:c})=>(h.preventDefault(),c));this.B($(h=>{const c=this.g(h);c&&this.c.open(c,{originalUrl:h})})),p.getWindows().filter(h=>h.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(p.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return P.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const b of this.a)await this.c.open(b.uri,{originalUrl:b.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),m.push(b));m.length!==0&&(this.a=m,(0,D.$Tg)(()=>this.h(),500,this.q))}}e.$g7b=f}),define(ee[268],te([0,1,3,2,16,56,31]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=void 0;class P extends D.$Qc{constructor(a,m,b,p,d,y){super(),this.f=a,this.g=m,this.h=b,this.j=p,this.m=d,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Ld),this.onDidChangeFile=this.a.event,this.b=L.$Sh.forUris(()=>!(this.capabilities&1024)),this.c=new C.$zc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,m){return this.g.open(this.t(a),m)}close(a){return this.g.close(a)}read(a,m,b,p,d){return this.g.read(a,m,b,p,d)}write(a,m,b,p,d){return this.g.write(a,m,b,p,d)}watch(a,m){this.b.set(a,a);const b=this.g.watch(this.t(a),m);return(0,D.$Oc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,m,b){return this.g.rename(this.t(a),this.t(m),b)}readFile(a,m){return this.g.readFile(this.t(a),m)}readFileStream(a,m,b){return this.g.readFileStream(this.t(a),m,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,m,b){return this.g.writeFile(this.t(a),m,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,m){return this.g.delete(this.t(a),m)}copy(a,m,b){if((0,s.$$j)(this.g))return this.g.copy(this.t(a),this.t(m),b);throw new Error("copy not supported")}cloneFile(a,m){if((0,s.$_j)(this.g))return this.g.cloneFile(this.t(a),this.t(m));throw new Error("clone not supported")}s(a){const m=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const p=this.u(b.resource);this.b.findSubstr(p)&&m.push({resource:p,type:b.type})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$R7b=P}),define(ee[269],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0,e.$z7b="utilityProcessWorker"}),define(ee[270],te([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0,e.$h7b=(0,S.$Mh)("webviewManagerService")}),define(ee[271],te([0,1,15,2,13,7]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=void 0;class C extends D.$Qc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,a){try{const m=L.URI.parse(f.url),b=C.a.get(m.path);if(typeof b=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${b}`,d=s.$ag.asFileUri(p);return a({path:d.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$i7b=C}),define(ee[59],te([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=e.$UC=e.$TC=void 0,e.$TC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(m){return!!m.workspaceUri}e.$UC=D;function s(m){return!!m.folderUri}e.$VC=s;function L(m){return!!m.fileUri}e.$WC=L;function C(m){const b=P(m),p=m.getValue("window.menuBarVisibility");return p==="default"||b==="native"&&p==="compact"||S.$j&&S.$m?"classic":p}e.$XC=C;function P(m){if(S.$o)return"custom";const b=m.getValue("window");if(b){if(S.$j&&b.nativeTabs===!0||S.$j&&b.nativeFullScreen===!1)return"native";const y=b.titleBarStyle;if(y==="native"||y==="custom")return y}return S.$k?"native":"custom"}e.$YC=P;function f(m){return!(!S.$i||S.$o||P(m)==="native")}e.$ZC=f;function a(m=0){return Math.pow(1.2,m)}e.$1C=a}),define(ee[95],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Q5b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var D;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(D||(e.UnloadReason=D={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$Q5b=s;var L;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(L||(e.WindowMode=L={}));var C;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(ee[272],te([0,1,8,3,2]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;class L extends s.$Qc{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:a}){super(),this.a=this.B(new s.$Pc),D.Event.latch(D.Event.any(P,f))(this.f,this,this.a),this.b=(0,S.$Fg)(()=>a()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$p7b=L}),define(ee[29],te([0,1,190,9,56,19,7,6,13]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.WorkbenchState=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,P.$Mh)("contextService");function a(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$Wh=a;function m(i){return typeof i?.id=="string"&&!a(i)&&!p(i)}e.$Xh=m,e.$Yh={id:"ext-dev"},e.$Zh={id:"empty-window"};function b(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$lc)(i)}:n?e.$Yh:e.$Zh;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$1h=b;function p(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$2h=p;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$3h=d;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$4h=w;function $(i){const n=i;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$5h=$;class g{constructor(n,o,v,R,A){this.h=n,this.j=v,this.k=R,this.l=A,this.c=s.$Sh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Sh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$6h=g;class h{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.$tg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$7h=h;function c(i){return new h({uri:i,index:0,name:(0,L.$pg)(i)},{uri:i.toString()})}e.$8h=c,e.$9h="code-workspace",e.$0h=`.${e.$9h}`,e.$$h=[{name:(0,S.localize)(0,null),extensions:[e.$9h]}],e.$_h="workspace.json";function k(i,n){return L.$kg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$ai=k;function u(i){let n;return C.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$bi=u,e.$ci="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$ci}e.$di=t;function l(i,n){return!k(i,n)&&!u(i)}e.$ei=l;function r(i){return(typeof i=="string"?(0,D.$mc)(i):(0,L.$rg)(i))===e.$0h}e.$fi=r}),define(ee[60],te([0,1,15,8,55,46,2,84,4,21,165,115,6,5,24,29]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=e.$i6b=void 0,e.$i6b=(0,p.$Mh)("dialogMainService");let $=class{constructor(h,c){this.d=h,this.e=c,this.a=new Map,this.b=new Map,this.c=new D.$Yg}pickFileFolder(h,c){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},c)}pickFolder(h,c){return this.f({...h,pickFolders:!0,title:(0,m.localize)(1,null)},c)}pickFile(h,c){return this.f({...h,pickFiles:!0,title:(0,m.localize)(2,null)},c)}pickWorkspace(h,c){const k=(0,m.localize)(3,null),u=(0,L.$qv)((0,m.localize)(4,null)),t=w.$$h;return this.f({...h,pickFiles:!0,title:k,filters:t,buttonLabel:u},c)}async f(h,c){const k={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(k.properties=void 0,h.pickFiles&&h.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&k.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(k,(c||S.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}g(h){if(h){let c=this.b.get(h.id);return c||(c=new D.$Yg,this.b.set(h.id,c)),c}else return this.c}showMessageBox(h,c){return this.g(c).queue(async()=>{const{options:k,buttonIndeces:u}=(0,b.$xv)(h,this.e);let t;return c?t=await S.dialog.showMessageBox(c,k):t=await S.dialog.showMessageBox(k),{response:u[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(h,c){const k=this.j(h,c);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(c).queue(async()=>{let u;return c?u=await S.dialog.showSaveDialog(c,h):u=await S.dialog.showSaveDialog(h),u.filePath=this.h(u.filePath),u})}finally{(0,C.$Lc)(k)}}h(h){return h&&f.$j&&(h=(0,P.$jl)(h)),h}i(h){return h.map(c=>this.h(c))}async showOpenDialog(h,c){h.defaultPath&&(await a.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const k=this.j(h,c);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(c).queue(async()=>{let u;return c?u=await S.dialog.showOpenDialog(c,h):u=await S.dialog.showOpenDialog(h),u.filePaths=this.i(u.filePaths),u})}finally{(0,C.$Lc)(k)}}j(h,c){if(!c)return C.$Qc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let k=this.a.get(c.id);k||(k=new Set,this.a.set(c.id,k));const u=(0,s.$Ai)(h);if(!k.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",h),k.add(u),(0,C.$Oc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),k?.delete(u),k?.size===0&&this.a.delete(c.id)})}};e.$j6b=$,e.$j6b=$=ke([_(0,d.$7i),_(1,y.$mj)],$)}),define(ee[273],te([0,1,3,2,74,29]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;class C extends D.$Qc{static{this.a=100}constructor(f,a){super(),this.f=f,this.g=a,this.b=this.B(new S.$Ld),this.c=new Map,this.h(a.applicationStorage,this.b)}h(f,a){this.B(S.Event.debounce(f.onDidChangeStorage,(m,b)=>(m?m.push(b):m=[b],m),C.a)(m=>{m.length&&a.fire(this.j(m,f))}))}j(f,a){const m=new Map,b=new Set;return f.forEach(p=>{const d=a.get(p.key);typeof d=="string"?m.set(p.key,d):b.add(p.key)}),{changed:Array.from(m.entries()),deleted:Array.from(b.values())}}listen(f,a,m){switch(a){case"onDidChangeStorage":{const b=m.profile?(0,s.$jh)(m.profile):void 0;if(!b)return this.b.event;let p=this.c.get(b.id);return p||(p=this.B(new S.$Ld),this.h(this.g.profileStorage(b),p),this.c.set(b.id,p)),p.event}}throw new Error(`Event not found: ${a}`)}async call(f,a,m){const b=m.profile?(0,s.$jh)(m.profile):void 0,p=(0,L.$3h)(m.workspace),d=await this.m(b,p);switch(a){case"getItems":return Array.from(d.items.entries());case"updateItems":{const y=m;if(y.insert)for(const[w,$]of y.insert)d.set(w,$);y.delete?.forEach(w=>d.delete(w));break}case"optimize":return d.optimize();case"isUsed":{const y=m.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${a}`)}}async m(f,a){let m;a?m=this.g.workspaceStorage(a):f?m=this.g.profileStorage(f):m=this.g.applicationStorage;try{await m.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":f?"profile":"application"} storage due to ${b}`)}return m}}e.$56b=C}),define(ee[41],te([0,1,55,3,2,19,7,187,36,16,6,5,29,31,40,8,32,27,12]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function k(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Fk=k,e.$Gk=(0,m.$Mh)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:C.URI.revive(i.location).with({scheme:n}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Hk=u;function t(i,n,o,v,R,A){return{id:i,name:n,location:o,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:A&&R?.useDefaultFlags?.globalState?A.globalStorageHome:(0,L.$tg)(o,"globalStorage"),settingsResource:A&&R?.useDefaultFlags?.settings?A.settingsResource:(0,L.$tg)(o,"settings.json"),keybindingsResource:A&&R?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,L.$tg)(o,"keybindings.json"),tasksResource:A&&R?.useDefaultFlags?.tasks?A.tasksResource:(0,L.$tg)(o,"tasks.json"),snippetsHome:A&&R?.useDefaultFlags?.snippets?A.snippetsHome:(0,L.$tg)(o,"snippets"),extensionsResource:A&&R?.useDefaultFlags?.extensions?A.extensionsResource:(0,L.$tg)(o,"extensions.json"),cacheHome:(0,L.$tg)(v,i),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.$Ik=t;let l=class extends s.$Qc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,v,R){super(),this.t=n,this.u=o,this.w=v,this.y=R,this.f=!0,this.h=this.B(new D.$Ld),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Ld),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Ld),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Ld),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$yc,emptyWindows:new Map},this.profilesHome=(0,L.$tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,h.$wf)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}o.push(t((0,L.$qg)(A.location),A.name,A.location,this.g,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},n))}}catch(A){this.y.error(A)}const v=new d.$yc,R=new Map;if(o.length)try{const A=this.Q();if(A.workspaces)for(const[E,I]of Object.entries(A.workspaces)){const M=C.URI.parse(E),U=o.find(B=>B.id===I);U&&v.set(M,U)}if(A.emptyWindows)for(const[E,I]of Object.entries(A.emptyWindows)){const M=o.find(U=>U.id===I);M&&R.set(E,M)}}catch(A){this.y.error(A)}this.z={profiles:o,workspaces:v,emptyWindows:R}}return this.z}D(){const n=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",v=new RegExp(`${(0,g.$De)(o)}\\s(\\d+)`);let R=0;for(const E of this.profiles){const I=v.exec(E.name),M=I?parseInt(I[1]):0;R=M>R?M:R}const A=`${o} ${R+1}`;return this.createProfile((0,S.$Ai)((0,$.$cg)()).toString(16),A,{transient:!0},n)}async createNamedProfile(n,o,v){return this.createProfile((0,S.$Ai)((0,$.$cg)()).toString(16),n,o,v)}async createProfile(n,o,v,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(n,o,v);return R&&await this.setProfileForWorkspace(R,A),A}async F(n,o,v){if(!(0,h.$wf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(o);return R||(R=(async()=>{try{const A=this.profiles.find(M=>M.name===o||M.id===n);if(A)return A;const E=t(n,o,(0,L.$tg)(this.profilesHome,n),this.g,v,this.defaultProfile);await this.u.createFolder(E.location);const I=[];return this.j.fire({profile:E,join(M){I.push(M)}}),await w.Promises.settled(I),this.I([E],[],[]),E}finally{this.r.delete(o)}})(),this.r.set(o,R)),R}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(R=>R.id===n.id);if(!v)throw new Error(`Profile '${n.name}' does not exist`);return v=t(v.id,o.name??v.name,v.location,this.g,{shortName:o.shortName??v.shortName,icon:o.icon===null?void 0:o.icon??v.icon,transient:o.transient??v.isTransient,useDefaultFlags:o.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(R=>R.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const v=[];this.m.fire({profile:o,join(R){v.push(R)}});try{await Promise.allSettled(v)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(R){(0,a.$lk)(R)!==1&&this.y.error(R)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(R=>R.id===o.id);if(!v)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,v)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n);return C.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(n){return(0,p.$Wh)(n)?n.uri:(0,p.$2h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,v){const R=[...this.profiles,...n],A=[];this.s.profiles=[];for(let E of R)E.isDefault||o.some(I=>E.id===I.id)||(E=v.find(I=>E.id===I.id)??E,E.isTransient?this.s.profiles.push(E):A.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(A),this.z=void 0,this.J(n,o,v)}J(n,o,v){this.h.fire({added:n,removed:o,updated:v,all:this.profiles})}L(n,o,v){v=o?.isTransient?!0:v,v||this.L(n,void 0,!0);const R=this.G(n),A=v?this.s:this.C;C.URI.isUri(R)?(A.workspaces.delete(R),o&&A.workspaces.set(R,o)):(A.emptyWindows.delete(R),o&&A.emptyWindows.set(R,o)),v||this.M()}M(){const n={};for(const[v,R]of this.C.workspaces.entries())n[v.toString()]=R.id;const o={};for(const[v,R]of this.C.emptyWindows.entries())o[v.toString()]=R.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},v=this.D();if(n.workspaces)for(const[A,E]of Object.entries(n.workspaces)){const I=C.URI.parse(E);o[A]=this.w.extUri.isEqual(I,v.location)?v.id:this.w.extUri.basename(I)}const R={};if(n.emptyWindows)for(const[A,E]of Object.entries(n.emptyWindows)){const I=C.URI.parse(E);R[A]=this.w.extUri.isEqual(I,v.location)?v.id:this.w.extUri.basename(I)}return{workspaces:o,emptyWindows:R}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Jk=l,e.$Jk=l=ke([_(0,f.$Th),_(1,a.$8j),_(2,y.$Ek),_(3,b.$7i)],l);class r extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Kk=r}),define(ee[79],te([0,1,8,17,2,3,31,7,117,123,16,6,5,41,40,12,14,25]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class c extends Error{constructor(r,i){super(r),this.code=i}}e.$lp=c,e.$mp=(0,b.$Mh)("IExtensionsProfileScannerService");let k=class extends s.$Qc{constructor(r,i,n,o,v,R){super(),this.j=r,this.m=i,this.n=n,this.r=o,this.s=v,this.t=R,this.b=this.B(new L.$Ld),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Ld),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Ld),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Ld),this.onDidRemoveExtensions=this.g.event,this.h=new C.$yc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],o=[];try{return await this.u(i,v=>{const R=[];for(const A of v)r.some(([E])=>(0,a.$ro)(E.identifier,A.identifier)&&E.manifest.version!==A.version)?n.push(A):R.push(A);for(const[A,E]of r){const I=R.findIndex(U=>(0,a.$ro)(U.identifier,A.identifier)&&U.version===A.manifest.version),M={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:E};I===-1?(o.push(M),R.push(M)):R.splice(I,1,M)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),R}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(v){throw o.length&&this.c.fire({extensions:o,error:v,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:v,profileLocation:i}),v}}async updateMetadata(r,i){const n=[];return await this.u(i,o=>{const v=[];for(const R of o){const A=r.find(([E])=>(0,a.$ro)(E.identifier,R.identifier)&&E.manifest.version===R.version);A&&(R.metadata={...R.metadata,...A[1]},n.push(R)),v.push(R)}return v}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,o=>{const v=[];for(const R of o)(0,a.$ro)(R.identifier,r.identifier)?n.push(R):v.push(R);return n.length&&this.f.fire({extensions:n,profileLocation:i}),v}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(r,i,n){return this.F(r).queue(async()=>{let o=[],v;try{const R=await this.m.readFile(r);v=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,m.$lk)(R)!==1)throw R;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(v=await this.D()),!v&&n?.bailOutWhenFileNotFound)throw new c((0,$.$8)(R),"ERROR_PROFILE_NOT_FOUND")}if(v){Array.isArray(v)||this.w(r);let R=!1;for(const A of v){u(A)||this.w(r);let E;if((0,w.$wf)(A.relativeLocation)&&A.relativeLocation)E=this.z(A.relativeLocation);else if((0,w.$wf)(A.location))E=this.z(A.location),R=!0,A.relativeLocation=A.location,A.location=E.toJSON();else{E=P.URI.revive(A.location);const I=this.y(E);I&&(R=!0,A.relativeLocation=I)}o.push({identifier:A.identifier,location:E,version:A.version,metadata:A.metadata})}R&&await this.m.writeFile(r,D.$_d.fromString(JSON.stringify(v)))}if(i){o=i(o);const R=o.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(r,D.$_d.fromString(JSON.stringify(R)))}return o})}w(r){const i=new c(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(v){if((0,m.$lk)(v)===1)return;throw v}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const v=JSON.parse(n);Array.isArray(v)&&v.every(R=>u(R))?o=v:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",v)}catch(v){this.t.error(v)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$_d.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(v){if((0,m.$lk)(v)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw v}try{await this.m.del(r)}catch(v){(0,m.$lk)(v)!==1&&this.t.error(v)}try{await this.m.del(i)}catch(v){(0,m.$lk)(v)!==1&&this.t.error(v)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new S.$Yg,this.h.set(r,i)),i}};e.$np=k,e.$np=k=ke([_(1,m.$8j),_(2,d.$Gk),_(3,y.$Ek),_(4,g.$$k),_(5,p.$7i)],k);function u(l){return(0,w.$yf)(l)&&(0,f.$1n)(l.identifier)&&(t(l.location)||(0,w.$wf)(l.location)&&l.location)&&((0,w.$Df)(l.relativeLocation)||(0,w.$wf)(l.relativeLocation))&&l.version&&(0,w.$wf)(l.version)}function t(l){return l?(0,w.$wf)(l.path)&&(0,w.$wf)(l.scheme):!1}}),define(ee[128],te([0,1,23,8,37,17,14,44,150,2,13,9,4,19,203,71,12,7,170,36,123,120,202,16,6,5,24,3,74,79,41,40,201]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.Translations=void 0;var M;(function(re){function Q(J,V){if(J===V)return!0;const F=Object.keys(J),N=new Set;for(const H of Object.keys(V))N.add(H);if(F.length!==N.size)return!1;for(const H of F){if(J[H]!==V[H])return!1;N.delete(H)}return N.size===0}re.equals=Q})(M||(e.Translations=M={})),e.$qp=(0,r.$Mh)("IExtensionsScannerService");let U=class extends a.$Qc{constructor(Q,J,V,F,N,H,Y,ie,oe,T,O,j){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=J,this.r=V,this.s=F,this.t=N,this.u=H,this.w=Y,this.y=ie,this.z=oe,this.C=T,this.D=O,this.F=j,this.g=this.B(new o.$Ld),this.onDidChangeCache=this.g.event,this.h=(0,d.$tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(x,this.s,this.h)),this.m=this.B(this.F.createInstance(x,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,k.$Co)(this.w,this.y)),this.G}async scanAllExtensions(Q,J,V){const[F,N]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(J)]),H=V?await this.scanExtensionsUnderDevelopment(Q,[...F,...N]):[];return this.L(F,N,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const J=[];J.push(this.M(!!Q.useCache,Q.language)),J.push(this.N(Q.language,!!Q.checkControlFile));const[V,F]=await Promise.all(J);return this.J([...V,...F],0,Q,!1)}async scanUserExtensions(Q){const J=Q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const V=this.D.extUri.isEqual(Q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.P(J,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,V),N=Q.useCache&&!F.devMode&&F.excludeObsolete?this.m:this.n;let H;try{H=await N.scanExtensions(F)}catch(Y){if(Y instanceof R.$lp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await N.scanExtensions(F);else throw Y}return H=await this.J(H,1,Q,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(Q,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(F=>F.scheme===m.Schemas.file).map(async F=>{const N=await this.P(F,!1,1,!0,Q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(Y=>(Y.type=J.find(ie=>(0,k.$ro)(ie.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,N)))}))).flat();return this.J(V,"development",Q,!0)}return[]}async scanExistingExtension(Q,J,V){const F=await this.P(Q,!1,J,!0,V.language,!0,void 0),N=await this.n.scanExtension(F);return!N||!V.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Q,J,V){const F=await this.P(Q,!1,J,!0,V.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(F);return this.J(N,J,V,!0)}async scanMetadata(Q){const J=(0,d.$tg)(Q,"package.json"),V=(await this.w.readFile(J)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(Q,J){const V=(0,d.$tg)(Q,"package.json"),F=(await this.w.readFile(V)).value.toString(),N=JSON.parse(F);J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,N.__metadata={...N.__metadata,...J},await this.w.writeFile((0,d.$tg)(Q,"package.json"),L.$_d.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof R.$lp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.u.addExtensionsToProfile(Q.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$_d.fromString(JSON.stringify([])))}catch(J){(0,l.$lk)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$8)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.y.error(Q)}finally{this.H=void 0}})()),this.H}async J(Q,J,V,F){return V.includeAllVersions||(Q=this.L(J===0?Q:void 0,J===1?Q:void 0,J==="development"?Q:void 0,await this.getTargetPlatform(),F)),V.includeInvalid||(Q=Q.filter(N=>N.isValid)),Q.sort((N,H)=>{const Y=b.$lc(N.location.fsPath),ie=b.$lc(H.location.fsPath);return Y<ie?-1:Y>ie?1:0})}L(Q,J,V,F,N){const H=(ie,oe,T)=>{if(ie.isValid&&!oe.isValid)return!1;if(ie.isValid===oe.isValid){if(N&&y.gt(ie.manifest.version,oe.manifest.version))return this.y.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(y.eq(ie.manifest.version,oe.manifest.version)){if(ie.type===0)return this.y.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===F)return this.y.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return T?this.y.warn(`Overwriting user extension ${ie.location.path} with ${oe.location.path}.`):this.y.debug(`Overwriting user extension ${ie.location.path} with ${oe.location.path}.`),!0},Y=new u.$Zl;return Q?.forEach(ie=>{const oe=Y.get(ie.identifier.id);(!oe||H(oe,ie,!1))&&Y.set(ie.identifier.id,ie)}),J?.forEach(ie=>{const oe=Y.get(ie.identifier.id);if(!oe&&Q&&ie.type===0){this.y.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!oe||H(oe,ie,!1))&&Y.set(ie.identifier.id,ie)}),V?.forEach(ie=>{const oe=Y.get(ie.identifier.id);(!oe||H(oe,ie,!0))&&Y.set(ie.identifier.id,ie),Y.set(ie.identifier.id,ie)}),[...Y.values()]}async M(Q,J){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),N=await(Q&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",N.length),N}async N(Q,J){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const F=J?await this.O():{},N=[],H=g.URI.file(b.$fc(b.$hc(m.$ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of V){const oe=F[ie.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":N.push((0,d.$tg)(H,ie.name));break;default:N.push(g.URI.file(oe));break}}const Y=await Promise.all(N.map(async ie=>this.n.scanExtension(await this.P(ie,!1,0,!0,Q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,S.$Fb)(Y)}async O(){try{const Q=await this.w.readFile(this.r);return JSON.parse(Q.value.toString())}catch{return{}}}async P(Q,J,V,F,N,H,Y){const ie=await this.f(N??p.$v),oe=await this.Q(Q),T=J&&!this.D.extUri.isEqual(Q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=T?await this.Q(T):void 0;return new B(Q,oe,T,O,J,Y,V,F,H,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,ie)}async Q(Q){try{const J=await this.w.stat(Q);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.$rp=U,e.$rp=U=ke([_(4,A.$Gk),_(5,R.$mp),_(6,l.$8j),_(7,i.$7i),_(8,c.$Th),_(9,n.$mj),_(10,E.$Ek),_(11,r.$Lh)],U);class B{constructor(Q,J,V,F,N,H,Y,ie,oe,T,O,j,q,W,z){this.location=Q,this.mtime=J,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=F,this.profile=N,this.profileScanOptions=H,this.type=Y,this.excludeObsolete=ie,this.validate=oe,this.productVersion=T,this.productDate=O,this.productCommit=j,this.devMode=q,this.language=W,this.translations=z}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,J){return(0,d.$mg)(Q.location,J.location)&&Q.mtime===J.mtime&&(0,d.$mg)(Q.applicationExtensionslocation,J.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&Q.profile===J.profile&&s.$2m(Q.profileScanOptions,J.profileScanOptions)&&Q.type===J.type&&Q.excludeObsolete===J.excludeObsolete&&Q.validate===J.validate&&Q.productVersion===J.productVersion&&Q.productDate===J.productDate&&Q.productCommit===J.productCommit&&Q.devMode===J.devMode&&Q.language===J.language&&M.equals(Q.translations,J.translations)}}e.$sp=B;let se=class extends a.$Qc{constructor(Q,J,V,F,N){super(),this.f=Q,this.g=J,this.h=V,this.j=F,this.m=N}async scanExtensions(Q){const J=Q.profile?await this.r(Q):await this.n(Q);let V={};if(Q.excludeObsolete&&Q.type===1)try{const F=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(F)}catch{}return(0,$.$Jf)(V)?J:J.filter(F=>!V[k.$so.create(F).toString()])}async n(Q){const J=await this.j.resolve(Q.location);if(!J.children?.length)return[];const V=await Promise.all(J.children.map(async F=>{if(!F.isDirectory||Q.type===1&&(0,d.$qg)(F.resource).indexOf(".")===0)return null;const N=new B(F.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(N)}));return(0,S.$Fb)(V).sort((F,N)=>F.location.path<N.location.path?-1:1)}async r(Q){let J=await this.s(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.h.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){J=J.filter(F=>!F.metadata?.isApplicationScoped);const V=await this.s(Q.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,Q);J.push(...V)}return J}async s(Q,J,V){const F=await this.g.scanProfileExtensions(Q,V.profileScanOptions);if(!F.length)return[];const N=await Promise.all(F.map(async H=>{if(J(H)){const Y=new B(H.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(Y,H.metadata)}return null}));return(0,S.$Fb)(N)}async scanOneOrMultipleExtensions(Q){try{if(await this.j.exists((0,d.$tg)(Q.location,"package.json"))){const J=await this.scanExtension(Q);return J?[J]:[]}else return await this.scanExtensions(Q)}catch(J){return this.m.error(`Error scanning extensions at ${Q.location.path}:`,(0,C.$8)(J)),[]}}async scanExtension(Q,J){try{let V=await this.scanExtensionManifest(Q.location);if(V){V.publisher||(V.publisher=u.$Tl),J=J??V.__metadata,delete V.__metadata;const F=(0,k.$wo)(V.publisher,V.name),N=J?.id?{id:F,uuid:J.id}:{id:F},H=J?.isSystem?0:Q.type,Y=H===0||!!J?.isBuiltin;V=await this.t(Q.location,V,B.createNlsConfiguration(Q));const ie={type:H,identifier:N,manifest:V,location:Q.location,isBuiltin:Y,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return Q.validate?this.validate(ie,Q):ie}}catch(V){Q.type!==0&&this.m.error(V)}return null}validate(Q,J){let V=!0;const F=(0,t.$Ho)(J.productVersion,J.productDate,J.location,Q.manifest,Q.isBuiltin);for(const[N,H]of F)N===w.default.Error&&(V=!1,this.m.error(this.z(J.location,H)));return Q.isValid=V,Q.validations=F,Q}async scanExtensionManifest(Q){const J=(0,d.$tg)(Q,"package.json");let V;try{V=(await this.j.readFile(J)).value.toString()}catch(N){return(0,l.$lk)(N)!==1&&this.m.error(this.z(Q,(0,h.localize)(0,null,J.path,N.message))),null}let F;try{F=JSON.parse(V)}catch{const H=[];(0,P.$Nm)(V,H);for(const Y of H)this.m.error(this.z(Q,(0,h.localize)(1,null,J.path,Y.offset,Y.length,(0,f.$op)(Y.error))));return null}return(0,P.$Wm)(F)!=="object"?(this.m.error(this.z(Q,(0,h.localize)(2,null,J.path))),null):F}async t(Q,J,V){const F=await this.u(Q,J,V);if(F)try{const N=[],H=await this.w(F.default,N);if(N.length>0)return N.forEach(ie=>{this.m.error(this.z(Q,(0,h.localize)(3,null,F.default?.path,(0,f.$op)(ie.error))))}),J;if((0,P.$Wm)(F)!=="object")return this.m.error(this.z(Q,(0,h.localize)(4,null,F.default?.path))),J;const Y=F.values||Object.create(null);return(0,I.$pp)(this.m,J,Y,H)}catch{}return J}async u(Q,J,V){const F=(0,d.$tg)(Q,"package.nls.json"),N=(oe,T)=>{T.forEach(O=>{this.m.error(this.z(Q,(0,h.localize)(5,null,oe?.path,(0,f.$op)(O.error))))})},H=oe=>{this.m.error(this.z(Q,(0,h.localize)(6,null,oe?.path)))},Y=`${J.publisher}.${J.name}`,ie=V.translations[Y];if(ie)try{const oe=g.URI.file(ie),T=(await this.j.readFile(oe)).value.toString(),O=[],j=(0,P.$Nm)(T,O);return O.length>0?(N(oe,O),{values:void 0,default:F}):(0,P.$Wm)(j)!=="object"?(H(oe),{values:void 0,default:F}):{values:j.contents?j.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.j.exists(F))return;let T;try{T=await this.y(Q,V)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const O=(await this.j.readFile(T.localized)).value.toString(),j=[],q=(0,P.$Nm)(O,j);return j.length>0?(N(T.localized,j),{values:void 0,default:T.original}):(0,P.$Wm)(q)!=="object"?(H(T.localized),{values:void 0,default:T.original}):{values:q,default:T.original}}catch{return{values:void 0,default:T.original}}}}async w(Q,J){if(Q)try{const V=(await this.j.readFile(Q)).value.toString();return(0,P.$Nm)(V,J)}catch{}}y(Q,J){return new Promise((V,F)=>{const N=H=>{const Y=(0,d.$tg)(Q,`package.nls.${H}.json`);this.j.exists(Y).then(ie=>{ie&&V({localized:Y,original:(0,d.$tg)(Q,"package.nls.json")});const oe=H.lastIndexOf("-");oe===-1?V({localized:(0,d.$tg)(Q,"package.nls.json"),original:null}):(H=H.substring(0,oe),N(H))})};if(J.devMode||J.pseudo||!J.language)return V({localized:(0,d.$tg)(Q,"package.nls.json"),original:null});N(J.language)})}z(Q,J){return`[${Q.path}]: ${J}`}};se=ke([_(1,R.$mp),_(2,E.$Ek),_(3,l.$8j),_(4,i.$7i)],se);let x=class extends se{constructor(Q,J,V,F,N,H,Y){super(J,F,N,H,Y),this.G=Q,this.H=V,this.D=this.B(new D.$Pg(3e3)),this.F=this.B(new o.$Ld),this.onDidChangeCache=this.F.event}async scanExtensions(Q){const J=this.M(Q),V=await this.I(J);if(this.C=Q,V&&V.input&&B.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",Q.location.toString()),this.D.trigger(()=>this.L()),V.result.map(N=>(N.location=g.URI.revive(N.location),N));const F=await super.scanExtensions(Q);return await this.J(J,{input:Q,result:F}),F}async I(Q){try{const J=await this.j.readFile(Q),V=JSON.parse(J.value.toString());return{result:V.result,input:(0,v.$jh)(V.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",Q.path,(0,C.$8)(J))}return null}async J(Q,J){try{await this.j.writeFile(Q,L.$_d.fromString(JSON.stringify(J)))}catch(V){this.m.debug("Error while writing the extension cache file:",Q.path,(0,C.$8)(V))}}async L(){if(!this.C)return;const Q=this.M(this.C),J=await this.I(Q);if(!J)return;const V=J.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$2m(F,V))try{this.m.info("Invalidating Cache",V,F),await this.j.del(Q),this.F.fire()}catch(N){this.m.error(N)}}M(Q){const J=this.N(Q);return this.h.extUri.joinPath(J.cacheHome,Q.type===0?u.$Sl:u.$Rl)}N(Q){return Q.type===0?this.H.defaultProfile:Q.profile?this.h.extUri.isEqual(Q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(Q.location,J.extensionsResource))??this.G:this.H.defaultProfile}};x=ke([_(2,A.$Gk),_(3,R.$mp),_(4,E.$Ek),_(5,l.$8j),_(6,i.$7i)],x);function ae(re,Q){const J=(0,k.$uo)(re.manifest.publisher,re.manifest.name);return{id:J,identifier:new u.$Xl(J),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:Q,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.$tp=ae;class ne extends U{constructor(Q,J,V,F,N,H,Y,ie,oe,T,O,j){super(Q,J,(0,d.$tg)(V,".vscode-oss-dev","extensions","control.json"),F,N,H,Y,ie,oe,T,O,j),this.R=(async()=>{if(p.$y)try{const q=await this.w.readFile(g.URI.file(p.$y));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}f(Q){return this.R}}e.$up=ne}),define(ee[274],te([0,1,5,41,40,25,79,16,36,7]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;let m=class extends C.$np{constructor(p,d,y,w,$,g){super(a.URI.file(p.extensionsPath),d,y,w,$,g)}};e.$sN=m,e.$sN=m=ke([_(0,f.$Uh),_(1,P.$8j),_(2,D.$Gk),_(3,s.$Ek),_(4,L.$$k),_(5,S.$7i)],m)}),define(ee[275],te([0,1,7,36,79,128,16,6,5,24,40,41]),function(K,e,S,D,s,L,C,P,f,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;let p=class extends L.$up{constructor(y,w,$,g,h,c,k,u){super(S.URI.file(h.builtinExtensionsPath),S.URI.file(h.extensionsPath),h.userHome,y.defaultProfile,y,w,$,g,h,c,k,u)}};e.$t7b=p,e.$t7b=p=ke([_(0,b.$Gk),_(1,s.$mp),_(2,C.$8j),_(3,f.$7i),_(4,D.$Uh),_(5,a.$mj),_(6,m.$Ek),_(7,P.$Lh)],p)}),define(ee[276],te([0,1,15,2,13,9,4,56,7,32,38,36,5,41]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=void 0;let y=class extends D.$Qc{constructor($,g,h){super(),this.c=$,this.f=h,this.a=P.$Sh.forPaths(!C.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot($.appRoot),this.addValidFileRoot($.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot($.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:$}=S.session;$.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,h)=>this.j(g,h)),$.protocol.interceptFileProtocol(s.Schemas.file,(g,h)=>this.h(g,h)),this.B((0,D.$Oc)(()=>{$.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),$.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot($){const g=(0,L.$fc)($);return this.a.get(g)?D.$Qc.None:(this.a.set(g,!0),(0,D.$Oc)(()=>this.a.delete(g)))}h($,g){const h=f.URI.parse($.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${$.url})`),g({error:-3})}j($,g){const h=this.m($);let c;return this.c.crossOriginIsolated&&((0,L.$lc)(h)==="workbench.html"||(0,L.$lc)(h)==="workbench-dev.html"?c=s.COI.CoopAndCoep:c=s.COI.getHeadersFromQuery($.url)),this.a.findSubstr(h)?g({path:h,headers:c}):this.b.has((0,L.$mc)(h).toLowerCase())?g({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${$.url})`),g({error:-3}))}m($){const g=f.URI.parse($.url),h=s.$ag.uriToFileUri(g);return(0,L.$fc)(h.fsPath)}createIPCObjectUrl(){let $;const g=f.URI.from({scheme:"vscode",path:(0,a.$cg)()}),h=g.toString(),c=async()=>$;return m.$7S.handle(h,c),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:g,update:k=>$=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),m.$7S.removeHandler(h)}}}};e.$I7b=y,e.$I7b=y=ke([_(0,b.$Uh),_(1,d.$Gk),_(2,p.$7i)],y)}),define(ee[96],te([0,1,8,3,2,65,12,111,6,41]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo="__$__isNewStorageMarker",e.$Wo="__$__targetStorageMarker",e.$Xo=(0,f.$Mh)("storageService");var m;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var b;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function d(h){const c=h.get(e.$Wo);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$Yo=d;class y extends s.$Qc{static{this.a=60*1e3}constructor(c={flushInterval:y.a}){super(),this.m=c,this.b=this.B(new D.$Od),this.c=this.B(new D.$Od),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Ld),this.onWillSaveState=this.f.event,this.h=this.B(new S.$4g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Rc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,k,u){return D.Event.filter(this.b.event,t=>t.scope===c&&(k===void 0||t.key===k),u)}n(){this.j.value=(0,S.$8g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Lc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,k){const{key:u,external:t}=k;if(u===e.$Wo){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:u,target:this.J(c)[u],external:t})}w(c){this.f.fire({reason:c})}get(c,k,u){return this.P(k)?.get(c,u)}getBoolean(c,k,u){return this.P(k)?.getBoolean(c,u)}getNumber(c,k,u){return this.P(k)?.getNumber(c,u)}getObject(c,k,u){return this.P(k)?.getObject(c,u)}storeAll(c,k){this.y(()=>{for(const u of c)this.store(u.key,u.value,u.scope,u.target,k)})}store(c,k,u,t,l=!1){if((0,C.$Ff)(k)){this.remove(c,u,l);return}this.y(()=>{this.z(c,u,t),this.P(u)?.set(c,k,l)})}remove(c,k,u=!1){this.y(()=>{this.z(c,k,void 0),this.P(k)?.delete(c,u)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,k){const u=[],t=this.J(c);for(const l of Object.keys(t))t[l]===k&&u.push(l);return u}z(c,k,u,t=!1){const l=this.J(k);typeof u=="number"?l[c]!==u&&(l[c]=u,this.P(k)?.set(e.$Wo,JSON.stringify(l),t)):typeof l[c]=="number"&&(delete l[c],this.P(k)?.set(e.$Wo,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const k=this.P(c);return k?d(k):Object.create(null)}isNew(c){return this.getBoolean(e.$Vo,c)===!0}async flush(c=m.NONE){this.f.fire({reason:c});const k=this.P(-1),u=this.P(0),t=this.P(1);switch(c){case m.NONE:await S.Promises.settled([k?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await S.Promises.settled([k?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,k=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return g(c,k,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,k){return this.w(m.NONE),(0,a.$Fk)(c)?this.R(c,k):this.S(c,k)}M(c,k){return!(c.id===k.id||w(k)&&w(c))}N(c,k,u){this.y(()=>{const t=new Set;for(const[l,r]of c)t.add(l),k.get(l)!==r&&this.u(u,{key:l,external:!0});for(const[l]of k.items)t.has(l)||this.u(u,{key:l,external:!0})})}}e.$Zo=y;function w(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$1o=w;class $ extends y{constructor(){super(),this.U=this.B(new P.$To(new P.$Uo,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$To(new P.$Uo,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$To(new P.$Uo,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$2o=$;async function g(h,c,k,u,t,l){const r=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,n=new Map;h.forEach((M,U)=>{i.set(U,M),n.set(U,r(M))});const o=new Map,v=new Map;c.forEach((M,U)=>{o.set(U,M),v.set(U,r(M))});const R=new Map,A=new Map;k.forEach((M,U)=>{R.set(U,M),A.set(U,r(M))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const E=[];if(i.forEach((M,U)=>{E.push({key:U,value:M})}),console.table(E),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];o.forEach((U,B)=>{M.push({key:B,value:U})}),console.table(M),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${l})`);const I=[];R.forEach((M,U)=>{I.push({key:U,value:M})}),console.table(I),console.groupEnd(),console.log(A)}e.$3o=g}),define(ee[277],te([0,1,23,8,3,2,9,70,7,21,111,159,5,96,25,29,13]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=e.$W5b=e.$V5b=void 0;class g extends L.$Qc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Ld),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Ld),this.onDidCloseStorage=this.c.event,this.f=this.B(new m.$To(new m.$Uo,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new D.$ah,this.whenInit=this.h.p,this.j=m.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===m.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(d.$Vo);i===void 0?r.set(d.$Vo,!0):i&&r.set(d.$Vo,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=m.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$Hd(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,S.top)(Array.from(this.f.items.entries()).map(([o,v])=>({key:o,length:v.length})),(o,v)=>v.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=m.StorageState.Closed,await this.f.close()}}class h extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$hc)(this.z.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,h.y)}constructor(r,i,n,o){super(n,o),this.z=r,this.C=i}async t(){return new m.$To(new b.$zT(this.path??b.$zT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}class c extends h{constructor(r,i,n,o){super(r,i,n,o)}}e.$V5b=c;class k extends h{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$bl,void 0)===void 0&&r.set(y.$bl,new Date().toUTCString());const n=r.get(y.$al,void 0),o=new Date().toUTCString();r.set(y.$cl,typeof n>"u"?null:n),r.set(y.$al,o)}}e.$W5b=k;class u extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$hc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id,u.y)}constructor(r,i,n,o,v){super(n,v),this.C=r,this.D=i,this.F=o}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new m.$To(new b.$zT(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:i?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$zT.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$hc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id),i=(0,C.$hc)(r,u.y);return await a.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await a.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$Wh)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$2h)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,C.$hc)(r,u.z);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$X5b=u;class t extends g{get path(){}async t(){return new m.$To(new m.$Uo,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.$Y5b=t}),define(ee[278],te([0,1,3,2,96]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;class L extends D.$Qc{constructor(P,f,a){super(),this.b=P,this.c=f,this.f=a;const m=this.B(new D.$Rc);this.a=this.B(new S.$Ld({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new D.$Pc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,a)=>(f?f.push(a.key):f=[a.key],f),100)(f=>this.h(f))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(f,a)=>{f||(f=new Map);let m=f.get(a.profile.id);return m||f.set(a.profile.id,m={profile:a.profile,keys:[],storage:a.storage}),m.keys.push(a.key),f},100)(f=>this.j(f))),P}h(P){const f=P.includes(s.$Wo)?[this.c.defaultProfile]:[],a=[];if(P=P.filter(m=>m!==s.$Wo),P.length){const m=(0,s.$Yo)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:P.map(b=>({key:b,scope:0,target:m[b]}))})}this.m(f,a)}j(P){const f=[],a=new Map;for(const[m,b]of P.entries()){b.keys.includes(s.$Wo)&&f.push(b.profile);const p=b.keys.filter(d=>d!==s.$Wo);if(p.length){const d=(0,s.$Yo)(b.storage.storage);a.set(m,{profile:b.profile,changes:p.map(y=>({key:y,scope:0,target:d[y]}))})}}this.m(f,[...a.values()])}m(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,a){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.$v7b=L}),define(ee[279],te([0,1,7,36,16,5,34,40,41,12,121]),function(K,e,S,D,s,L,C,P,f,a,m){"use strict";var b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.$pN=void 0;let d=class extends f.$Jk{static{b=this}static{this.a="profileAssociationsMigration"}constructor(g,h,c,k,u){super(c,k,h,u),this.U=g,this.W=c}O(){return this.U.getItem(b.b,[]).map(h=>({...h,location:(0,a.$wf)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):S.URI.revive(h.location)}))}Q(){const g=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$pN=d,e.$pN=d=b=ke([_(0,C.$kN),_(1,P.$Ek),_(2,D.$Uh),_(3,s.$8j),_(4,L.$7i)],d);let y=p=class extends d{constructor(g,h,c,k,u){super(g,h,c,k,u),this.$=g}P(g){g.length?this.$.setItem(p.b,g.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(p.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(p.c,g):this.$.removeItem(p.c)}Q(){const g="workspaceAndProfileInfo",h=this.$.getItem(g,void 0);if(h){this.$.removeItem(g);const k=h.reduce((u,{workspace:t,profile:l})=>(u[S.URI.revive(t).toString()]=S.URI.revive(l).toString(),u),{});this.$.setItem(p.c,{workspaces:k})}const c=super.Q();return this.$.getItem(p.a,!1)||(this.R(c),this.$.setItem(p.a,!0)),c}};e.$qN=y,e.$qN=y=p=ke([_(0,C.$lN),_(1,P.$Ek),_(2,D.$Uh),_(3,s.$8j),_(4,L.$7i)],y);let w=class extends y{constructor(g,h,c,k){super(new m.$oN(0,h,k,c),g,h,c,k)}async init(){return await this.$.init(),super.init()}};e.$rN=w,e.$rN=w=ke([_(0,P.$Ek),_(1,D.$Uh),_(2,s.$8j),_(3,L.$7i)],w)}),define(ee[52],te([0,1,36,16,6,5,40,41,279,34]),function(K,e,S,D,s,L,C,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.$Z5b=void 0,e.$Z5b=(0,s.$Nh)(P.$Gk);let m=class extends f.$qN{constructor(p,d,y,w,$){super(p,d,y,w,$)}getAssociatedEmptyWindows(){const p=[];for(const d of this.C.emptyWindows.keys())p.push({id:d});return p}};e.$15b=m,e.$15b=m=ke([_(0,a.$lN),_(1,C.$Ek),_(2,S.$Uh),_(3,D.$8j),_(4,L.$7i)],m)}),define(ee[129],te([0,1,19,7,29]),function(K,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=e.$l6b=e.$k6b=void 0;async function L(f,a,m){for(const p of f){const d=p.openedWorkspace;if((0,s.$2h)(d)){const y=await m(d);if(y){if(y.folders.some(w=>S.$kg.isEqualOrParent(a,w.uri)))return p}else if(S.$kg.isEqualOrParent(a,d.configPath))return p}}const b=f.filter(p=>(0,s.$Wh)(p.openedWorkspace)&&S.$kg.isEqualOrParent(a,p.openedWorkspace.uri));if(b.length)return b.sort((p,d)=>-(p.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.$k6b=L;function C(f,a){for(const m of f)if((0,s.$2h)(m.openedWorkspace)&&S.$kg.isEqual(m.openedWorkspace.configPath,a)||(0,s.$Wh)(m.openedWorkspace)&&S.$kg.isEqual(m.openedWorkspace.uri,a))return m}e.$l6b=C;function P(f,a){const m=b=>a.some(p=>S.$kg.isEqual(D.URI.file(p),D.URI.file(b)));for(const b of f)if(b.config?.extensionDevelopmentPath?.some(p=>m(p)))return b}e.$m6b=P}),define(ee[97],te([0,1,33,44,137,46,13,9,4,19,7,6,58,29]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AU=e.$zU=e.$yU=e.$xU=e.$wU=e.$vU=e.$uU=e.$tU=e.$sU=e.$rU=void 0,e.$rU=(0,b.$Mh)("workspacesService");function y(A){return A.hasOwnProperty("workspace")}e.$sU=y;function w(A){return A.hasOwnProperty("folderUri")}e.$tU=w;function $(A){return A.hasOwnProperty("fileUri")}e.$uU=$;function g(A){return h(A)||c(A)}e.$vU=g;function h(A){const E=A;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function c(A){const E=A;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function k(A,E,I,M,U){if(A.scheme!==M.scheme)return{name:I,uri:A.toString(!0)};let B=E?void 0:U.relativePath(M,A);if(B!==void 0)B.length===0?B=".":f.$i&&(B=u(B));else if(A.scheme===C.Schemas.file)B=A.fsPath,f.$i&&(B=u(B));else if(U.isEqualAuthority(A.authority,M.authority))B=A.path;else return{name:I,uri:A.toString(!0)};return{name:I,path:B}}e.$wU=k;function u(A){return A=(0,L.$kv)(A),(0,S.$Sf)(A)||(A=(0,S.$Pf)(A)),A}function t(A,E,I){const M=[],U=new Set,B=I.dirname(E);for(const se of A){let x;if(h(se))se.path&&(x=I.resolvePath(B,se.path));else if(c(se))try{x=m.URI.parse(se.uri),x.path[0]!==P.$ec.sep&&(x=x.with({path:P.$ec.sep+x.path}))}catch(ae){console.warn(ae)}if(x){const ae=I.getComparisonKey(x);if(!U.has(ae)){U.add(ae);const ne=se.name||I.basenameOrAuthority(x);M.push(new d.$7h({uri:x,name:ne,index:M.length},se))}}}return M}e.$xU=t;function l(A,E,I,M,U){const B=r(E,A),se=U.dirname(E),x=U.dirname(M),ae=[];for(const J of B.folders){const V=h(J)?U.resolvePath(se,J.path):m.URI.parse(J.uri);let F;I?F=!1:F=!h(J)||(0,P.$gc)(J.path),ae.push(k(V,F,J.name,x,U))}const ne={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},re=s.$OS(A,["folders"],ae,ne);let Q=s.$RS(A,re);return(0,a.$yg)(B.remoteAuthority,(0,p.$Qk)(M))&&(Q=s.$RS(Q,s.$NS(Q,["remoteAuthority"],ne))),Q}e.$yU=l;function r(A,E){const I=D.$Nm(E);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(M=>g(M));else throw new Error(`${A} looks like an invalid workspace file.`);return I}function i(A){return A.workspace&&typeof A.workspace=="object"&&typeof A.workspace.id=="string"&&typeof A.workspace.configPath=="string"}function n(A){return typeof A.folderUri=="string"}function o(A){return typeof A.fileUri=="string"}function v(A,E){const I={workspaces:[],files:[]};if(A){const M=function(B,se){for(let x=0;x<B.length;x++)try{se(B[x],x)}catch(ae){E.warn(`Error restoring recent entry ${JSON.stringify(B[x])}: ${ae.toString()}. Skip entry.`)}},U=A;Array.isArray(U.entries)&&M(U.entries,B=>{const se=B.label,x=B.remoteAuthority;i(B)?I.workspaces.push({label:se,remoteAuthority:x,workspace:{id:B.workspace.id,configPath:m.URI.parse(B.workspace.configPath)}}):n(B)?I.workspaces.push({label:se,remoteAuthority:x,folderUri:m.URI.parse(B.folderUri)}):o(B)&&I.files.push({label:se,remoteAuthority:x,fileUri:m.URI.parse(B.fileUri)})})}return I}e.$zU=v;function R(A){const E={entries:[]};for(const I of A.workspaces)w(I)?E.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):E.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of A.files)E.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return E}e.$AU=R}),define(ee[98],te([0,1,85,13,4,19]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=e.$e6b=e.$d6b=e.$c6b=void 0,e.$c6b=128/4;function C(a){function m(){let b=a.scheme===D.Schemas.file?(0,L.$hg)(a):a.toString();return s.$k||(b=b.toLowerCase()),(0,S.createHash)("md5").update(b).digest("hex")}return{id:m(),configPath:a}}e.$d6b=C;function P(a,m){function b(){if(a.scheme!==D.Schemas.file)return(0,S.createHash)("md5").update(a.toString()).digest("hex");if(!m)return;let d;return s.$k?d=m.ino:s.$j?d=m.birthtime.getTime():s.$i&&(typeof m.birthtimeMs=="number"?d=Math.floor(m.birthtimeMs):d=m.birthtime.getTime()),(0,S.createHash)("md5").update(a.fsPath).update(d?String(d):"").digest("hex")}const p=b();if(typeof p=="string")return{id:p,uri:a}}e.$e6b=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$f6b=f}),define(ee[99],te([0,1,85,87,28,280,17,14,3,2,9,4,32,42,109]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;class w{traceSocketEvent(E,I){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,I)}constructor(E,I=""){this.f=!0,this.debugLabel=I,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,P.$Y)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const I=M=>{this.traceSocketEvent("read",M),E(C.$_d.wrap(M))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(E){const I=M=>{E({type:0,hadError:M,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(E){const I=()=>{E()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,P.$Y)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,P.$Y)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$Bh=w;var $;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var g;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(g||(g={}));class h extends a.$Qc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,I){this.socket.traceSocketEvent(E,I)}constructor(E,I,M,U){super(),this.f=this.B(new f.$Ld),this.g=this.B(new f.$Ld),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:M?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new c(this,I,M,U,this.f,(B,se)=>this.m(B,se))),this.B(this.a.onError(B=>{console.error(B),(0,P.$Y)(B),this.g.fire({type:0,hadError:!0,error:B})})),this.b=new y.$wh,this.B(this.socket.onData(B=>this.n(B))),this.B(this.socket.onClose(async B=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(B)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let I=0;for(;I<E.byteLength;)this.a.writeMessage(E.slice(I,Math.min(I+262144,E.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(E,{compressed:I,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let U=2;E.byteLength<126?U+=0:E.byteLength<2**16?U+=2:U+=8;const B=C.$_d.alloc(U),se=I?64:0,x=M&15;if(B.writeUInt8(128|se|x,0),E.byteLength<126)B.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){B.writeUInt8(126,1);let ae=1;B.writeUInt8(E.byteLength>>>8&255,++ae),B.writeUInt8(E.byteLength>>>0&255,++ae)}else{B.writeUInt8(127,1);let ae=1;B.writeUInt8(0,++ae),B.writeUInt8(0,++ae),B.writeUInt8(0,++ae),B.writeUInt8(0,++ae),B.writeUInt8(E.byteLength>>>24&255,++ae),B.writeUInt8(E.byteLength>>>16&255,++ae),B.writeUInt8(E.byteLength>>>8&255,++ae),B.writeUInt8(E.byteLength>>>0&255,++ae)}this.socket.write(C.$_d.concat([B,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),M=I.readUInt8(0),U=(M&128)>>>7,B=(M&64)>>>6,se=M&15,x=I.readUInt8(1),ae=(x&128)>>>7,ne=x&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(ne===126?2:0)+(ne===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!B),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=se,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),M=I.readUInt8(1),U=(M&128)>>>7;let B=M&127,se=1;B===126?B=I.readUInt8(++se)*2**8+I.readUInt8(++se):B===127&&(B=I.readUInt8(++se)*0+I.readUInt8(++se)*0+I.readUInt8(++se)*0+I.readUInt8(++se)*0+I.readUInt8(++se)*2**24+I.readUInt8(++se)*2**16+I.readUInt8(++se)*2**8+I.readUInt8(++se));let x=0;U&&(x=I.readUInt8(++se)*2**24+I.readUInt8(++se)*2**16+I.readUInt8(++se)*2**8+I.readUInt8(++se)),this.j.state=3,this.j.readLen=B,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),t(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Ch=h;class c extends a.$Qc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$_d.alloc(0)}constructor(E,I,M,U,B,se){super(),this.n=E,this.r=B,this.s=se,this.a=this.B(new f.$Ld),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Ld),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Ld),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new k(this.n,U,M,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(E,I){this.g.push({data:E,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:I}=this.g.shift();if(this.f&&I.compressed){const M=await this.w(this.f,E);this.s(M,I)}else this.s(E,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,I){return new Promise((M,U)=>{E.write(I),E.flush(B=>M(B))})}acceptFrame(E,I,M){this.h.push({data:E,isCompressed:I,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const I=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,I,M){return new Promise((U,B)=>{E.write(I),M&&E.write(C.$_d.fromByteArray([0,0,255,255])),E.flush(se=>U(se))})}}class k extends a.$Qc{get recordedInflateBytes(){return this.j?C.$_d.concat(this.f):C.$_d.alloc(0)}constructor(E,I,M,U){super(),this.h=E,this.j=I,this.a=this.B(new f.$Ld),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(U),this.b.on("error",B=>{this.h.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.h.traceSocketEvent("zlibInflateData",B),this.g.push(C.$_d.wrap(B))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=C.$_d.concat(this.g);this.g.length=0,E(I)})}}class u extends a.$Qc{constructor(E,I){super(),this.g=E,this.a=this.B(new f.$Ld),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(C.$_d.wrap(M))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=C.$_d.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),E(I)})}}function t(A,E){if(E===0)return;const I=A.byteLength>>>2;for(let ae=0;ae<I;ae++){const ne=A.readUInt32BE(ae*4);A.writeUInt32BE(ne^E,ae*4)}const M=I*4,U=A.byteLength-M,B=E>>>24&255,se=E>>>16&255,x=E>>>8&255;U>=1&&A.writeUInt8(A.readUInt8(M)^B,M),U>=2&&A.writeUInt8(A.readUInt8(M+1)^se,M+1),U>=3&&A.writeUInt8(A.readUInt8(M+2)^x,M+2)}e.$Dh=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function r(){const A=(0,p.$cg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const E=process.platform!=="darwin"&&e.$Dh?e.$Dh:(0,s.tmpdir)(),I=(0,m.$hc)(E,`vscode-ipc-${A}.sock`);return n(I),I}e.$Eh=r;function i(A,E,I){const M=(0,S.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${I}-${E}-sock`;const U=I.substr(0,4),B=E.substr(0,6),se=M.substr(0,8);let x;return process.platform!=="darwin"&&e.$Dh&&!process.env.VSCODE_PORTABLE?x=(0,m.$hc)(e.$Dh,`vscode-${se}-${U}-${B}.sock`):x=(0,m.$hc)(A,`${U}-${B}.sock`),n(x),x}e.$Fh=i;function n(A){const E=l[b.$t];typeof E=="number"&&A.length>=E&&console.warn(`WARNING: IPC handle "${A}" is longer than ${E} chars, try a shorter --user-data-dir`)}class o extends d.$qh{static b(E){const I=f.Event.fromNodeEventEmitter(E,"connection");return f.Event.map(I,M=>({protocol:new y.$xh(new w(M,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(M,"close"))}))}constructor(E){super(o.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Gh=o;function v(A){return new Promise((E,I)=>{const M=(0,D.createServer)();M.on("error",I),M.listen(A,()=>{M.removeListener("error",I),E(new o(M))})})}e.$Hh=v;function R(A,E){return new Promise((I,M)=>{const U=(0,D.createConnection)(A,()=>{U.removeListener("error",M),I(y.$yh.fromSocket(new w(U,`ipc-client${E}`),E))});U.once("error",M)})}e.$Ih=R}),define(ee[26],te([0,1,54,9,4,99,36,89,6]),function(K,e,S,D,s,L,C,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=e.$R5b=void 0,e.$R5b=(0,f.$Nh)(C.$Th);class a extends P.$bm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,D.$hc)(this.userDataPath,"clp")}get backupHome(){return(0,D.$hc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,L.$Fh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,D.$hc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const p=b.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[b]?process.env[p]=process.env[b]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$k)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$S5b=a,ke([S.$eh],a.prototype,"cachedLanguagesPath",null),ke([S.$eh],a.prototype,"backupHome",null),ke([S.$eh],a.prototype,"mainIPCHandle",null),ke([S.$eh],a.prototype,"mainLockfile",null),ke([S.$eh],a.prototype,"disableUpdates",null),ke([S.$eh],a.prototype,"crossOriginIsolated",null),ke([S.$eh],a.prototype,"codeCachePath",null),ke([S.$eh],a.prototype,"useCodeCache",null)}),define(ee[281],te([0,1,85,33,13,9,4,19,21,194,18,26,34,16,5,193,29,98]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=void 0;let c=class{static{h=this}static{this.a="backupWorkspaces"}constructor(u,t,l,r){this.j=u,this.k=t,this.l=l,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$kg,this.i={isEqual:(i,n)=>(0,D.$Uf)(i,n,!C.$k)}}async initialize(){const u=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(u.emptyWindows),this.d=await this.u((0,a.$_5b)(u)),this.e=await this.v((0,a.$a6b)(u)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.$tk.OFF}q(){return this.s()===d.$tk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.$tk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,t){this.d.some(r=>u.workspace.id===r.workspace.id)||(this.d.push(u),this.C());const l=(0,L.$hc)(this.c,u.workspace.id);return t?this.t(l,t).then(()=>l):l}async t(u,t){if(await f.Promises.exists(u)&&await this.z(u),await f.Promises.exists(t))try{await f.Promises.rename(t,u,!1)}catch(l){this.l.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}registerFolderBackup(u){return this.e.some(t=>this.h.isEqual(u.folderUri,t.folderUri))||(this.e.push(u),this.C()),(0,L.$hc)(this.c,this.D(u))}registerEmptyWindowBackup(u){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,L.$hc)(this.c,u.backupFolder)}async u(u){if(!Array.isArray(u))return[];const t=new Set,l=[];for(const r of u){const i=r.workspace;if(!(0,$.$2h)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,L.$hc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?l.push(r):await this.z(n):await this.x(n)}}return l}async v(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const r of u){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!l.has(n)){l.add(n);const o=(0,L.$hc)(this.c,this.D(r));await this.B(o)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(o):await this.x(o)}}return t}async w(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!l.has(i)){l.add(i);const n=(0,L.$hc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(u){try{await f.Promises.rm(u,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let u=(0,g.$f6b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.id));)u=(0,g.$f6b)();return{backupFolder:u.id}}async z(u){const t=this.y(),l=(0,L.$hc)(this.c,t.backupFolder);try{await f.Promises.rename(u,l,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const u=[];for(const t of this.d)await this.A(t)&&u.push(t);for(const t of this.e)await this.A(t)&&u.push(t);return u}A(u){let t;return(0,a.$$5b)(u)?t=(0,L.$hc)(this.c,u.backupFolder):(0,w.$pU)(u)?t=(0,L.$hc)(this.c,this.D(u)):t=(0,L.$hc)(this.c,u.workspace.id),this.B(t)}async B(u){try{const t=await f.Promises.readdir(u);for(const l of t)try{if((await f.Promises.readdir((0,L.$hc)(u,l))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:t,remoteAuthority:l})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return l&&(r.remoteAuthority=l),r}),folders:this.e.map(({folderUri:t,remoteAuthority:l})=>{const r={folderUri:t.toString()};return l&&(r.remoteAuthority=l),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:l})=>{const r={backupFolder:t};return l&&(r.remoteAuthority=l),r})};this.m.setItem(h.a,u)}D(u){const t=u.folderUri;let l;return t.scheme===s.Schemas.file?l=C.$k?t.fsPath:t.fsPath.toLowerCase():l=t.toString().toLowerCase(),(0,S.createHash)("md5").update(l).digest("hex")}};e.$g6b=c,e.$g6b=c=h=ke([_(0,b.$R5b),_(1,m.$gi),_(2,y.$7i),_(3,p.$lN)],c)}),define(ee[20],te([0,1,15,38,8,3,2,4,35,12,6,5,34,26]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=e.LifecycleMainPhase=e.ShutdownReason=e.$T5b=void 0,e.$T5b=(0,m.$Mh)("lifecycleMainService");var w;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var $;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let g=class extends C.$Qc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(c,k,u){super(),this.F=c,this.G=k,this.H=u,this.c=this.B(new L.$Ld),this.onBeforeShutdown=this.c.event,this.f=this.B(new L.$Ld),this.onWillShutdown=this.f.event,this.g=this.B(new L.$Ld),this.onWillLoadWindow=this.g.event,this.h=this.B(new L.$Ld),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const c=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",c);const k=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&S.app.quit()};S.app.addListener("window-all-closed",k),S.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",c),S.app.removeListener("window-all-closed",k),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(c){if(this.y)return this.y;const k=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:c,join(t,l){k.trace(`Lifecycle#onWillShutdown - begin '${t}'`),u.push(l.finally(()=>{k.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(u)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===c)return;this.S(`lifecycle (main): phase changed (value: ${c})`),this.n=c;const k=this.C.get(this.n);k&&(k.open(),this.C.delete(this.n))}async when(c){if(c<=this.n)return;let k=this.C.get(c);k||(k=new s.$Qg,this.C.set(c,k)),await k.wait()}registerWindow(c){const k=new C.$Pc;this.t++,k.add(c.onWillLoad(t=>this.g.fire({window:c,workspace:t.workspace,reason:t.reason})));const u=(0,a.$Hf)(c.win);u.on("close",t=>{const l=c.id;if(this.r.has(l)){this.r.delete(l);return}this.S(`Lifecycle#window.on('close') - window ID ${c.id}`),t.preventDefault(),this.unload(c,1).then(r=>{if(r){this.r.delete(l);return}this.r.add(l),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this.h.fire(c),c.close()})}),u.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.t--,k.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}async reload(c,k){await this.unload(c,3)||c.reload(k)}unload(c,k){const u=this.z.get(c.id);if(u)return u;const t=this.M(c,k).finally(()=>{this.z.delete(c.id)});return this.z.set(c.id,t),t}async M(c,k){if(!c.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${c.id}`);const u=this.j?2:k,t=await this.P(c,u);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.N(t)):(await this.Q(c,u),!1)}N(c){return c?(this.O(!0),this.j=!1,!0):!1}O(c){this.w&&(this.w(c),this.w=void 0,this.u=void 0)}P(c,k){return new Promise(u=>{const t=this.s++,l=`vscode:ok${t}`,r=`vscode:cancel${t}`;D.$7S.once(l,()=>{u(!1)}),D.$7S.once(r,()=>{u(!0)}),c.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:r,reason:k})})}Q(c,k){return new Promise(u=>{const l=`vscode:reply${this.s++}`;D.$7S.once(l,()=>u()),c.send("vscode:onWillUnload",{replyChannel:l,reason:k})})}quit(c){return this.R(c).then(k=>{if(!k&&c)try{if(P.$i){const u=(0,f.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return k})}R(c){return this.S(`Lifecycle#quit() - begin (willRestart: ${c})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(c&&this.G.setItem(y.b,!0),this.u=new Promise(k=>{this.w=k,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(c){this.H.args["enable-smoke-test-driver"]?this.F.info(c):this.F.trace(c)}setRelaunchHandler(c){this.D=c}async relaunch(c){this.S("Lifecycle#relaunch()");const k=process.argv.slice(1);if(c?.addArgs&&k.push(...c.addArgs),c?.removeArgs)for(const l of c.removeArgs){const r=k.indexOf(l);r>=0&&k.splice(r,1)}const u=()=>{this.D?.handleRelaunch(c)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:k}))};S.app.once("quit",u),await this.quit(!0)&&S.app.removeListener("quit",u)}async kill(c){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Sg)(1e3),(async()=>{for(const k of S.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let u;k.webContents&&!k.webContents.isDestroyed()?u=new Promise(t=>k.once("closed",t)):u=Promise.resolve(),k.destroy(),await u}})()]),S.app.exit(c)}};e.$U5b=g,e.$U5b=g=y=ke([_(0,b.$7i),_(1,p.$lN),_(2,d.$R5b)],g)}),define(ee[282],te([0,1,4,3,2,6,20]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=e.$K6b=void 0,e.$K6b=(0,L.$Mh)("keyboardLayoutMainService");let P=class extends s.$Qc{constructor(m){super(),this.a=this.B(new D.$Ld),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((b,p)=>{K(["native-keymap"],b,p)});this.c=f(m),S.$s||m.onDidChangeKeyboardLayout(()=>{this.c=f(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$L6b=P,e.$L6b=P=ke([_(0,C.$T5b)],P);function f(a){const m=a.getKeyMap(),b=a.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:b}}}),define(ee[283],te([0,1,244,8,17,14,12,18,36,93,5,50,243,280]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;let y=class extends b.$Lo{constructor(h,c,k,u){super(u),this.m=h,this.n=c,this.r=k,this.s(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,c){const{f:k,g:u}=this;let t;try{t=await(0,a.$Ol)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$8)(i)))}const l={...process.env,...t},r=h.agent?h.agent:await(0,p.$Pq)(h.url||"",l,{proxyUrl:k,strictSSL:u});return h.agent=r,h.strictSSL=u,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>$(h,c))}async resolveProxy(h){}};e.$Qq=y,e.$Qq=y=ke([_(0,P.$gi),_(1,f.$Uh),_(2,m.$7i),_(3,m.$8i)],y);async function w(g){return((0,S.parse)(g.url).protocol==="https:"?await new Promise((k,u)=>{K(["https"],k,u)}):await new Promise((k,u)=>{K(["http"],k,u)})).request}async function $(g,h){return D.Promises.withAsyncBody(async(c,k)=>{const u=(0,S.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await w(g),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,C.$Cf)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(l.auth=g.user+":"+g.password);const r=t(l,i=>{const n=(0,C.$Af)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...g,url:i.headers.location,followRedirects:n-1},h).then(c,k);else{let o=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,d.createGunzip)())),c({res:i,stream:(0,s.$oe)(o)})}});r.on("error",k),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),h.onCancellationRequested(()=>{r.abort(),k(new L.$3)})})}e.$Rq=$}),define(ee[284],te([0,1,15,283]),function(K,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=void 0;function s(C){return S.net.request}class L extends D.$Qq{request(P,f){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$N7b=L}),define(ee[80],te([0,1,7,3,2,36,16,6,20,5,96,277,41,52,40,13]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=e.$45b=e.$35b=e.$25b=void 0,e.$25b=(0,P.$Mh)("storageMainService");let $=class extends s.$Qc{constructor(c,k,u,t,l,r){super(),this.c=c,this.f=k,this.g=u,this.h=t,this.j=l,this.m=r,this.a=void 0,this.b=this.B(new D.$Ld),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(c=>{c.window.profile&&this.profileStorage(c.window.profile).init(),c.workspace&&this.workspaceStorage(c.workspace).init()})),this.B(this.h.onWillShutdown(c=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=c.reason,c.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)c.join("profileStorage",k.close());for(const[,k]of this.w)c.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(c=>{c.join((async()=>{await this.j.exists(c.profile.globalStorageHome)||await this.j.createFolder(c.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(c=>{const k=this.t.get(c.profile.id);k&&c.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const c=new b.$W5b(this.n(),this.g,this.c,this.j);return this.B(D.Event.once(c.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),c}profileStorage(c){if((0,m.$1o)(c))return this.applicationStorage;let k=this.t.get(c.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${c.name})`),k=this.B(this.u(c)),this.t.set(c.id,k);const u=this.B(k.onDidChangeStorage(t=>this.b.fire({...t,storage:k,profile:c})));this.B(D.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${c.name})`),this.t.delete(c.id),u.dispose()}))}return k}u(c){return this.a===2?new b.$Y5b(this.c,this.j):new b.$V5b(c,this.n(),this.c,this.j)}workspaceStorage(c){let k=this.w.get(c.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${c.id})`),k=this.B(this.y(c)),this.w.set(c.id,k),this.B(D.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${c.id})`),this.w.delete(c.id)}))),k}y(c){return this.a===2?new b.$Y5b(this.c,this.j):new b.$X5b(c,this.n(),this.c,this.f,this.j)}isUsed(c){const k=S.URI.file(c);for(const u of[this.applicationStorage,...this.t.values(),...this.w.values()])if(u.path&&this.m.extUri.isEqualOrParent(S.URI.file(u.path),k))return!0;return!1}};e.$35b=$,e.$35b=$=ke([_(0,a.$7i),_(1,L.$Th),_(2,d.$Z5b),_(3,f.$T5b),_(4,C.$8j),_(5,y.$Ek)],$),e.$45b=(0,P.$Mh)("applicationStorageMainService");let g=class extends m.$Zo{constructor(c,k){super(),this.s=c,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(c){if(c===-1)return this.U.applicationStorage.storage}Q(c){if(c===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$55b=g,e.$55b=g=ke([_(0,p.$Gk),_(1,e.$25b)],g)}),define(ee[285],te([0,1,87,28,103,99,8,2,4,18,5,24,239,240,94,126,17]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=e.$L7b=e.$K7b=e.$J7b=void 0;async function g(t,l,r,i,n){let o;for(let v=3;v&&(o?.dispose(),o=await new h(t,l,r,i,n).waitForReady(),!(n&&s.$fg[n]||!s.$fg[o.tunnelLocalPort]));v--);return o}class h extends P.$Qc{constructor(l,r,i,n,o){super(),this.m=r,this.n=o,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=S.createServer(),this.c=new C.$Qg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.r(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,r=(0,w.$9u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$gg)(l,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(l){l.pause();const r=(0,w.$7u)(this.tunnelRemoteHost)||(0,w.$9u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$2k)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),n instanceof L.$Bh?n.socket.destroy():n.end()}),n instanceof L.$Bh?this.t(l,n):this.s(l,n),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),n.end()})}s(l,r){r.onClose(()=>l.destroy()),r.onEnd(()=>l.end()),r.onData(i=>l.write(i.buffer)),l.on("data",i=>r.write($.$_d.wrap(i))),l.resume()}t(l,r){const i=r.socket;i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),i.pipe(l),l.pipe(i)}}e.$J7b=h;let c=class extends w.$_u{constructor(l,r,i,n,o){super(r,o),this.u=l,this.v=i,this.w=n}isPortPrivileged(l){return(0,w.$0u)(l,this.l,f.OS,D.release())}s(l,r,i,n,o,v,R,A){const E=this.r(r,i);if(E)return++E.refcount,E.value;if((0,w.$4u)(l))return this.t(l,r,i,o,v,R,A);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:l,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},M=g(I,n,r,i,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,M),M}}};e.$K7b=c,e.$K7b=c=ke([_(0,d.$Vk),_(1,m.$7i),_(2,y.$Yk),_(3,b.$mj),_(4,a.$gi)],c);let k=class extends c{constructor(l,r,i,n,o){super(l,r,i,n,o)}};e.$L7b=k,e.$L7b=k=ke([_(0,d.$Vk),_(1,m.$7i),_(2,y.$Yk),_(3,b.$mj),_(4,a.$gi)],k);let u=class extends P.$Qc{constructor(l,r,i,n,o){super(),this.b=l,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(l,r,i,n,o,v,R,A,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${v}.`),!this.a.has(l)){const I=new k(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(l,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(r,i,n,o,v,R,A,E)}};e.$M7b=u,e.$M7b=u=ke([_(0,d.$Vk),_(1,m.$7i),_(2,b.$mj),_(3,y.$Yk),_(4,a.$gi)],u)}),define(ee[100],te([0,1,8,22,3,18,26,20,5,24,50,48]),function(K,e,S,D,s,L,C,P,f,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$6b=e.$06b=void 0;function p(y,w,$){return`${$.updateUrl}/api/update/${y}/${w}/${$.commit}`}e.$06b=p;let d=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,$,g,h,c,k){this.f=w,this.g=$,this.h=g,this.i=h,this.j=c,this.k=k,this.b=b.$6T.Uninitialized,this.c=new s.$Ld,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$6T.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$6T.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$6T.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),$=this.m(w);if(!$){this.d(b.$6T.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s($),!this.a){this.d(b.$6T.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.$6T.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,S.$Sg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},D.CancellationToken.None)).res.statusCode===204}catch($){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error($);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$$6b=d,e.$$6b=d=ke([_(0,P.$T5b),_(1,L.$gi),_(2,C.$R5b),_(3,m.$Ko),_(4,f.$7i),_(5,a.$mj)],d)}),define(ee[286],te([0,1,15,54,3,2,18,26,20,5,24,50,25,48,100]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=void 0;let w=class extends y.$$6b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(g,h)=>h)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(g,h,c)=>({url:h,version:c,productVersion:c}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(g,h,c,k)=>({releaseNotes:h,version:c,productVersion:c,date:k}))}constructor(g,h,c,k,u,t,l){super(g,h,k,u,t,l),this.z=c,this.u=new L.$Pc,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const h=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.d(d.$6T.Idle(1,h))}s(g){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,y.$06b)(h,g,this.k);try{S.autoUpdater.setFeedURL({url:c})}catch(k){this.j.error("Failed to set update feed URL",k);return}return c}t(g){this.d(d.$6T.CheckingForUpdates(g)),S.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(d.$6T.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(d.$6T.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$6T.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$_6b=w,ke([D.$eh],w.prototype,"v",null),ke([D.$eh],w.prototype,"w",null),ke([D.$eh],w.prototype,"x",null),ke([D.$eh],w.prototype,"y",null),e.$_6b=w=ke([_(0,f.$T5b),_(1,C.$gi),_(2,p.$$k),_(3,P.$R5b),_(4,b.$Ko),_(5,a.$7i),_(6,m.$mj)],w)}),define(ee[287],te([0,1,47,45,8,3,9,26,20,5,25,48]),function(K,e,S,D,s,L,C,P,f,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0;let p=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,$,g){if(this.f=w,this.g=g,this.a=b.$6T.Uninitialized,this.b=new L.$Ld,this.onStateChange=this.b.event,$.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$6T.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(w=60*60*1e3){return(0,s.$Sg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};p=ke([_(0,f.$T5b),_(1,P.$R5b),_(2,a.$7i)],p);let d=class extends p{constructor(w,$,g,h,c,k){super(g,h,c),this.o=w,this.p=$,this.q=k;const u=(0,D.watch)(C.$kc(this.o)),t=L.Event.fromNodeEventEmitter(u,"change",(n,o)=>o),l=L.Event.filter(t,n=>n==="current"),i=L.Event.debounce(l,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),u.close()})}m(){this.d(b.$6T.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(b.$6T.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$6T.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$6T.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+C.$lc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((g,h)=>(0,D.realpath)(`${C.$kc(this.o)}/current`,(c,k)=>c?h(c):g(k))),$=C.$lc(w);return this.p!==$}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$b7b=d,e.$b7b=d=ke([_(2,f.$T5b),_(3,P.$R5b),_(4,a.$7i),_(5,m.$$k)],d)}),define(ee[30],te([0,1,4,6,95,59,67,24,18,26,9]),function(K,e,S,D,s,L,C,P,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=e.OpenContext=e.$85b=void 0,e.$85b=(0,D.$Mh)("windowsMainService");var b;(function(d){d[d.CLI=0]="CLI",d[d.DOCK=1]="DOCK",d[d.MENU=2]="MENU",d[d.DIALOG=3]="DIALOG",d[d.DESKTOP=4]="DESKTOP",d[d.API=5]="API"})(b||(e.OpenContext=b={}));function p(d,y=(0,s.$Q5b)(),w){const $=d.get(C.$65b),g=d.get(P.$mj),h=d.get(f.$gi),c=d.get(a.$R5b),k=h.getValue("window"),u={width:y.width,height:y.height,x:y.x,y:y.y,backgroundColor:$.getBackgroundColor(),minWidth:L.$TC.WIDTH,minHeight:L.$TC.HEIGHT,title:g.nameLong,...w,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,L.$1C)(k?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...w?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return S.$k?u.icon=(0,m.$hc)(c.appRoot,"resources/linux/code.png"):S.$i&&!c.isBuilt&&(u.icon=(0,m.$hc)(c.appRoot,"resources/win32/code_150x150.png")),S.$j&&(u.acceptFirstMouse=!0,k?.clickThroughInactive===!1&&(u.acceptFirstMouse=!1)),u}e.$95b=p}),define(ee[288],te([0,1,15,22,3,55,2,32,116,5,80,30]),function(K,e,S,D,s,L,C,P,f,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=void 0;var p;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let d=class extends C.$Qc{constructor(w,$,g,h){super(),this.g=w,this.h=$,this.j=g,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=p.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(S.app,"login",($,g,h,c,k)=>({event:$,webContents:g,req:h,authInfo:c,callback:k}));this.B(w(this.r,this))}async r({event:w,authInfo:$,req:g,callback:h}){if(!$.isProxy)return;if(!this.b&&this.c===p.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let c;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{c=await this.b}finally{this.b=void 0}}h(c?.username,c?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(w);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const $=String((0,L.$Ai)({scheme:w.scheme,host:w.host,port:w.port}));let g,h;try{const t=this.m.get(this.a+$,-1);if(t){const l=JSON.parse(await this.j.decrypt(t));g=l.username,h=l.password}}catch(t){this.g.error(t)}if(this.c!==p.StoredCredentialsUsed&&typeof g=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=p.StoredCredentialsUsed,{username:g,password:h};const c=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!c){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${c.id} to handle proxy login`);const k={authInfo:w,username:this.f?.username??g,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,P.$cg)()}`};c.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,k),this.c=p.LoginDialogShown;const u=await new Promise(t=>{const l=async(r,i,n)=>{if(i===k.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${c.id}`),c.win?.webContents.off("ipc-message",l),n){const o={username:n.username,password:n.password};try{if(n.remember){const v=await this.j.encrypt(JSON.stringify(o));this.m.store(this.a+$,v,-1,1)}else this.m.remove(this.a+$,-1)}catch(v){this.g.error(v)}t({username:o.username,password:o.password})}else t(void 0)};c.win?.webContents.on("ipc-message",l)});return this.f=u,u}};e.$05b=d,e.$05b=d=ke([_(0,a.$7i),_(1,b.$85b),_(2,f.$OT),_(3,m.$45b)],d)}),define(ee[289],te([0,1,15,23,4,7,21,18,63,6,5,127,30]),function(K,e,S,D,s,L,C,P,f,a,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=e.$N6b=e.ID=void 0,e.ID="launchMainService",e.$N6b=(0,a.$Mh)(e.ID);let d=class{constructor(w,$,g,h){this.a=w,this.b=$,this.c=g,this.d=h}async start(w,$){this.a.trace("Received data from other instance: ",w,$),s.$j&&S.app.focus({steal:!0});const g=this.e(w);if(g.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const c=(0,D.$Mb)(await this.b.openEmptyWindow({context:4}));c&&(h=c.ready())}h.then(()=>{for(const{uri:c,originalUrl:k}of g)this.c.open(c,{originalUrl:k})})}else return this.f(w,$)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,D.$Fb)(w._urls.map($=>{try{return{uri:L.URI.parse($),originalUrl:$}}catch{return null}})):[]}async f(w,$){const g=(0,f.$Il)($)?0:4;let h=[];const c=w.wait&&w.waitMarkerFilePath?L.URI.file(w.waitMarkerFilePath):void 0,k=w.remote||void 0,u={context:g,cli:w,userEnv:$,waitMarkerFileURI:c,remoteAuthority:k,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,u);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||u.forceProfile||u.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)h=await this.b.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,u),h=[l]):h=await this.b.open({...u,forceEmpty:!0})}}else h=await this.b.open({...u,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(c&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,C.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$O6b=d,e.$O6b=d=ke([_(0,m.$7i),_(1,p.$85b),_(2,b.$UT),_(3,P.$gi)],d)}),define(ee[290],te([0,1,2,20,52,29,8,30]),function(K,e,S,D,s,L,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=void 0;let f=class extends S.$Qc{constructor(m,b,p){super(),this.a=b,this.b=p,this.B(m.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(m.onBeforeCloseWindow(d=>this.c(d))),this.B(new C.$4g(()=>this.g(),30*1e3)).schedule()}async c(m){const b=this.f(m),p=this.a.getProfileForWorkspace(b);p?.isTransient&&(this.a.unsetWorkspace(b,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(m){return m.openedWorkspace??(0,L.$1h)(m.backupPath,m.isExtensionDevelopmentHost)}g(){const m=this.a.getAssociatedEmptyWindows();if(m.length===0)return;const b=this.b.getWindows().map(p=>this.f(p));for(const p of m)b.some(d=>d.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$u7b=f,e.$u7b=f=ke([_(0,D.$T5b),_(1,s.$Z5b),_(2,P.$85b)],f)}),define(ee[61],te([0,1,15,2,3,5,310,8,13,30,71,25,20,73,37,4,130]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=e.$p6b=void 0;function h(u){return typeof u.responseWindowId=="number"}let c=class extends D.$Qc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,l,r){super(),this.t=t,this.u=l,this.w=r,this.c=String(++g.a),this.f=this.B(new s.$Ld),this.onStdout=this.f.event,this.g=this.B(new s.$Ld),this.onStderr=this.g.event,this.h=this.B(new s.$Ld),this.onMessage=this.h.event,this.j=this.B(new s.$Ld),this.onExit=this.j.event,this.m=this.B(new s.$Ld),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(t,l){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`,l){case m.default.Error:this.t.error(r);break;case m.default.Warning:this.t.warn(r);break;case m.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const l=this.C(t);return l&&t.payload&&this.postMessage(t.payload),l}C(t){if(!this.z())return!1;this.s=t;const l=`${this.s.type}-${this.c}`,r=f.$ag.asFileUri("bootstrap-fork.js").fsPath,i=this.s.args??[],n=this.s.execArgv??[],o=this.s.allowLoadingUnsignedLibraries,v=this.s.forceAllocationsToV8Sandbox,R="pipe",A=this.D(t);return this.y("creating new...",m.default.Info),this.n=S.utilityProcess.fork(r,i,{serviceName:l,env:A,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:v,stdio:R}),this.F(this.n,this.s,l),!0}D(t){const l=t.env?{...t.env}:{...(0,y.$Xm)(process.env)};l.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(l.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),l.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$i&&((0,$.isUNCAccessRestrictionsDisabled)()?l.NODE_DISABLE_UNC_ACCESS_CHECKS="1":l.NODE_UNC_HOST_ALLOWLIST=(0,$.getUNCHostAllowlist)().join("\\")),(0,d.$vl)(l);for(const r of Object.keys(l))l[r]=String(l[r]);return l}F(t,l,r){if(t.stdout){const i=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.r=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:h(l)?`${l.type} [${l.responseWindowId}]`:l.type}),this.y("successfully created",m.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.y(`received exit event with code ${i}`,m.default.Info),this.j.fire({pid:this.r,code:i,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.y(`crashed with code ${i.exitCode} and reason '${i.reason}'`,m.default.Error),this.u.publicLog2("utilityprocesscrash",{type:l.type,reason:i.reason,code:i.exitCode}),this.m.fire({pid:this.r,code:i.exitCode,reason:i.reason}),this.G())}))}once(t,l){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),l())}))}postMessage(t,l){this.n&&this.n.postMessage(t,l)}connect(t){const{port1:l,port2:r}=new S.MessageChannelMain;return this.postMessage(t,[r]),l}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",m.default.Info),this.n.kill()?(this.y("successfully killed the process",m.default.Info),this.G()):this.y("unable to kill the process",m.default.Warning)}G(){typeof this.r=="number"&&g.b.delete(this.r),this.n=void 0}async waitForExit(t){this.n&&(this.y("waiting to exit...",m.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$Sg)(t)]),this.n&&(this.y(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$p6b=c,e.$p6b=c=g=ke([_(0,L.$7i),_(1,b.$$k),_(2,p.$T5b)],c);let k=class extends c{constructor(t,l,r,i){super(t,r,i),this.H=l}start(t){const l=this.H.getWindowById(t.responseWindowId);if(!l?.win||l.win.isDestroyed()||l.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.C(t))return!1;this.I(l.win,t);const i=this.connect(t.payload);return l.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}I(t,l){l.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$q6b=k,e.$q6b=k=ke([_(0,L.$7i),_(1,a.$85b),_(2,b.$$k),_(3,p.$T5b)],k)}),define(ee[291],te([0,1,14,5,20,8,61,30,25]),function(K,e,S,D,s,L,C,P,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=void 0;let m=class{static{a=this}static{this.a=0}constructor(p,d,y,w){this.d=p,this.f=d,this.g=y,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(p){const d=this.b.get(p);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(p){return this.i(p).onStdout}onDynamicStderr(p){return this.i(p).onStderr}onDynamicMessage(p){return this.i(p).onMessage}onDynamicExit(p){return this.i(p).onExit}async createExtensionHost(){if(this.c)throw(0,S.$4)();const p=String(++a.a),d=new C.$q6b(this.d,this.g,this.h,this.f);return this.b.set(p,d),d.onExit(({pid:y,code:w,signal:$})=>{this.d.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${$}.`),setTimeout(()=>{d.dispose(),this.b.delete(p)})}),{id:p}}async start(p,d){if(this.c)throw(0,S.$4)();this.i(p).start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:p})}async enableInspectPort(p){if(this.c)throw(0,S.$4)();const d=this.b.get(p);return d?d.enableInspectPort():!1}async kill(p){if(this.c)throw(0,S.$4)();const d=this.b.get(p);d&&d.kill()}async _killAllNow(){for(const[,p]of this.b)p.kill()}async _waitForAllExit(p){const d=[];for(const[,y]of this.b)d.push(y.waitForExit(p));return L.Promises.settled(d).then(()=>{})}};e.$x6b=m,e.$x6b=m=a=ke([_(0,D.$7i),_(1,s.$T5b),_(2,P.$85b),_(3,f.$$k)],m)}),define(ee[292],te([0,1,38,8,2,26,20,5,41,39,66,61,51,89,12,245,24]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=void 0;let g=class extends s.$Qc{constructor(c,k,u,t,l,r,i,n){super(),this.c=c,this.f=k,this.g=u,this.h=t,this.j=l,this.m=r,this.n=i,this.r=n,this.a=new D.$Qg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$7S.on(w.$26b.request,(c,k)=>this.t(c,k,w.$26b.response)),S.$7S.on(w.$36b.request,(c,k)=>this.t(c,k,w.$36b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t(c,k,u){this.j.trace(`[SharedProcess] onWindowConnection for: ${u}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(u);if(c.sender.isDestroyed())return t.close();c.sender.postMessage(u,k,[t])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$16b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const c=new D.$ah;this.b?this.b.once(w.$16b.initDone,()=>c.complete()):S.$7S.once(w.$16b.initDone,()=>c.complete()),await c.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const c=new D.$ah;this.b?this.b.once(w.$16b.ipcReady,()=>c.complete()):S.$7S.once(w.$16b.ipcReady,()=>c.complete()),await c.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new b.$p6b(this.j,p.$do,this.h));const c=(0,d.$dm)(this.f.args,this.f.isBuilt);let k;c.port&&(k=["--nolazy"],c.break?k.push(`--inspect-brk=${c.port}`):k.push(`--inspect=${c.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:k,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect(c){return await this.z,(0,y.$Hf)(this.b).connect(c)}};e.$46b=g,e.$46b=g=ke([_(1,L.$R5b),_(2,f.$Gk),_(3,C.$T5b),_(4,P.$7i),_(5,m.$Y6b),_(6,a.$_m),_(7,$.$mj)],g)}),define(ee[293],te([0,1,26,89,20,5,51,61,110,38,2,3,37,18,13]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0;let w=class extends m.$Qc{constructor(g,h,c,k,u){super(),this.f=g,this.g=h,this.h=c,this.j=k,this.m=u,this.a=void 0,this.b=new b.$Ld,this.onRequestConnection=this.b.event,this.c=new b.$Ld,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),a.$7S.on("vscode:createPtyHostMessageChannel",(t,l)=>this.r(t,l)),this.B((0,m.$Oc)(()=>{a.$7S.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$p6b(this.m,C.$do,this.j);const g=(0,D.$cm)(this.h.args,this.h.isBuilt),h=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const c=this.a.connect(),k=new f.$cT(c,"ptyHost"),u=new m.$Pc;return u.add(k),u.add((0,m.$Oc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:k,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,p.$Xm)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(g.VSCODE_LATENCY=String(h));const c=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(g.VSCODE_STARTUP_DELAY=String(c)),this.h.restoreSnapExportedVariables(),g}r(g,h){this.b.fire();const c=this.a.connect();if(g.sender.isDestroyed()){c.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[c])}};e.$C7b=w,e.$C7b=w=ke([_(1,d.$gi),_(2,S.$R5b),_(3,s.$T5b),_(4,L.$7i)],w)}),define(ee[294],te([0,1,2,6,5,30,61,25,55,3,8,20]),function(K,e,S,D,s,L,C,P,f,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=e.$A7b=void 0,e.$A7b=(0,D.$Mh)("utilityProcessWorker");let p=class extends S.$Qc{constructor(w,$,g,h){super(),this.b=w,this.c=$,this.f=g,this.g=h,this.a=new Map}async createWorker(w){const $=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${$})`);const g=this.h(w);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${$})`),this.disposeWorker(w));const h=new d(this.b,this.c,this.f,this.g,w);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,h);const c=new m.$ah;return a.Event.once(h.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(g),c.complete({reason:k})}),c.p}h(w){return(0,f.$Ai)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const $=this.h(w),g=this.a.get($);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),g.kill(),this.a.delete($))}};e.$B7b=p,e.$B7b=p=ke([_(0,s.$7i),_(1,L.$85b),_(2,P.$$k),_(3,b.$T5b)],p);let d=class extends S.$Qc{constructor(w,$,g,h,c){super(),this.c=w,this.f=$,this.g=g,this.h=h,this.j=c,this.a=this.B(new a.$Ld),this.onDidTerminate=this.a.event,this.b=new C.$q6b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const $=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:$,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};d=ke([_(0,s.$7i),_(1,L.$85b),_(2,P.$$k),_(3,b.$T5b)],d)}),define(ee[295],te([0,1,15,3,2,271,30]),function(K,e,S,D,s,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;let P=class extends s.$Qc{constructor(a){super(),this.b=a,this.a=this.B(new D.$Ld),this.onFoundInFrame=this.a.event,this.B(new L.$i7b)}async setIgnoreMenuShortcuts(a,m){let b;if(typeof a.windowId=="number"){const{windowId:p}=a,d=this.b.getWindowById(p);if(!d?.win)throw new Error(`Invalid windowId: ${p}`);b=d.win.webContents}else{const{webContentsId:p}=a;if(b=S.webContents.fromId(p),!b)throw new Error(`Invalid webContentsId: ${p}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(m)}async findInFrame(a,m,b,p){const y=this.c(a,m);if(typeof y.findInFrame=="function"){y.findInFrame(b,{findNext:p.findNext,forward:p.forward});const w=($,g)=>{g.finalUpdate&&(this.a.fire(g),y.removeListener("found-in-frame",w))};y.on("found-in-frame",w)}}async stopFindInFrame(a,m,b){const d=this.c(a,m);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(a,m){const b=this.b.getWindowById(a.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${a}`);const p=b.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===m);if(!p)throw new Error(`Unknown frame: ${m}`);return p}};e.$j7b=P,e.$j7b=P=ke([_(0,C.$85b)],P)}),define(ee[296],te([0,1,15,2,4,19,7,18,20,5,34,30,95,29]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=e.$m7b=e.$l7b=void 0;let w=class extends D.$Qc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(u,t,l,r,i){super(),this.g=u,this.h=t,this.j=l,this.m=r,this.n=i,this.b=$(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(u=>this.u(u)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.u(u))}s(){this.f=!0,this.t()}t(){const u=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&u.add(t.lastActiveWindow.uiState.display))}const l=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);l&&(t.lastPluginDevelopmentHostWindow=this.w(l),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!l.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const r=h(t);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(u){if(this.j.quitRequested)return;const t=this.w(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(l=>{const r=(0,d.$2h)(u.openedWorkspace)&&l.workspace?.id===u.openedWorkspace.id,i=(0,d.$Wh)(u.openedWorkspace)&&l.folderUri&&L.$kg.isEqual(l.folderUri,u.openedWorkspace.uri);(r||i)&&(l.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(u){return{windowId:u.id,workspace:(0,d.$2h)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,d.$Wh)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const t=this.z(u),l=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||l?.restoreFullscreen),r||(t.mode=1)}return t}z(u){const t=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const v=u.workspace;if((0,d.$2h)(v)){const A=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===v.id).map(E=>E.uiState);if(A.length)return A[0]}if((0,d.$Wh)(v)){const A=this.state.openedWindows.filter(E=>E.folderUri&&L.$kg.isEqual(E.folderUri,v.uri)).map(E=>E.uiState);if(A.length)return A[0]}else if(u.backupPath){const A=this.state.openedWindows.filter(E=>E.backupPath===u.backupPath).map(E=>E.uiState);if(A.length)return A[0]}const R=this.c||this.state.lastActiveWindow;if(!t&&R)return R.uiState}let l;const r=S.screen.getAllDisplays();if(r.length===1)l=r[0];else{if(s.$j){const v=S.screen.getCursorScreenPoint();l=S.screen.getDisplayNearestPoint(v)}!l&&t&&(l=S.screen.getDisplayMatching(t.getBounds())),l||(l=S.screen.getPrimaryDisplay()||r[0])}let i=(0,p.$Q5b)();i.x=Math.round(l.bounds.x+l.bounds.width/2-i.width/2),i.y=Math.round(l.bounds.y+l.bounds.height/2-i.height/2);const n=this.n.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const v=t.serializeWindowState();v.mode===3?i.mode=3:i=v,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.C(i)),i.hasDefaultState=!0,i}C(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const t=this.g.getWindows().map(l=>l.getBounds());for(;t.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};e.$l7b=w,e.$l7b=w=y=ke([_(0,b.$85b),_(1,m.$lN),_(2,f.$T5b),_(3,a.$7i),_(4,P.$gi)],w);function $(k){const u={openedWindows:[]},t=k||{openedWindows:[]};return t.lastActiveWindow&&(u.lastActiveWindow=g(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(u.openedWindows=t.openedWindows.map(l=>g(l))),u}e.$m7b=$;function g(k){const u={uiState:k.uiState};return k.backupPath&&(u.backupPath=k.backupPath),k.remoteAuthority&&(u.remoteAuthority=k.remoteAuthority),k.folder&&(u.folderUri=C.URI.parse(k.folder)),k.workspaceIdentifier&&(u.workspace={id:k.workspaceIdentifier.id,configPath:C.URI.parse(k.workspaceIdentifier.configURIPath)}),u}function h(k){return{lastActiveWindow:k.lastActiveWindow&&c(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&c(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(u=>c(u))}}e.$n7b=h;function c(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ee[53],te([0,1,15,3,44,2,13,9,19,21,192,64,60,26,6,5,52,129,29,97,98]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=e.$n6b=void 0,e.$n6b=(0,y.$Mh)("workspacesManagementMainService");let u=class extends L.$Qc{constructor(l,r,i,n,o){super(),this.g=l,this.h=r,this.j=i,this.m=n,this.n=o,this.a=this.B(new D.$Ld),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new D.$Ld),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const l=(await a.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,f.$tg)(this.c,r,h.$_h));for(const r of l){const i=(0,k.$d6b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(l){l.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${l}).`)}}resolveLocalWorkspace(l){return this.r(l,r=>a.Promises.readFile(r,"utf8"))}r(l,r){if(this.s(l)&&l.scheme===C.Schemas.file)try{const i=r(l.fsPath);return i instanceof Promise?i.then(n=>this.t(l,n),n=>{}):this.t(l,i)}catch{return}}s(l){return(0,h.$ai)(l,this.g)||(0,h.$fi)(l)}t(l,r){try{const i=this.u(l,r),n=(0,k.$d6b)(l);return{id:n.id,configPath:n.configPath,folders:(0,c.$xU)(i.folders,n.configPath,f.$kg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(l,r){const i=(0,s.$Nm)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,c.$vU)(n));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(l,r){const{workspace:i,storedWorkspace:n}=this.w(l,r),o=i.configPath.fsPath;return await a.Promises.mkdir((0,P.$kc)(o),{recursive:!0}),await a.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(l=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$tg)(this.c,i),o=(0,f.$tg)(n,h.$_h),v=[];for(const R of l)v.push((0,c.$wU)(R.uri,!0,R.name,n,f.$kg));return{workspace:(0,k.$d6b)(o),storedWorkspace:{folders:v,remoteAuthority:r}}}async getWorkspaceIdentifier(l){return(0,k.$d6b)(l)}isUntitledWorkspace(l){return(0,h.$ai)(l.configPath,this.g)}async deleteUntitledWorkspace(l){this.isUntitledWorkspace(l)&&(await this.y(l),this.j.isEnabled()&&this.j.unsetWorkspace(l),this.a.fire(l))}async y(l){const r=(0,f.$hg)(l.configPath);try{await a.Promises.rm((0,P.$kc)(r));const i=(0,P.$hc)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,l.id);await a.Promises.exists(i)&&await a.Promises.writeFile((0,P.$hc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==l.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(l,r,i){if(!l||!l.win||!l.isReady||!await this.z(l,r,i))return;const o=await this.C(l,(0,k.$d6b)(i));if(o)return this.b.fire({window:l,workspace:o.workspace}),o}async z(l,r,i){return i?(0,h.$2h)(l.openedWorkspace)&&f.$kg.isEqual(l.openedWorkspace.configPath,i)?!1:(0,g.$l6b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,f.$qg)(i)),detail:(0,m.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(l,r){if(!l.config)return;l.focus();let i;return l.config.extensionDevelopmentPath||(l.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority},l.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority})),(0,h.$2h)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=r,l.config.backupPath=i,{workspace:r,backupPath:i}}};e.$o6b=u,e.$o6b=u=ke([_(0,d.$R5b),_(1,w.$7i),_(2,$.$Z5b),_(3,b.$b6b),_(4,p.$i6b)],u)}),define(ee[131],te([0,1,15,38,22,6,30,29,53,12,5,61]),function(K,e,S,D,s,L,C,P,f,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t6b=e.$s6b=e.ID=void 0,e.ID="diagnosticsMainService",e.$s6b=(0,L.$Mh)(e.ID);let p=class{constructor(y,w,$){this.a=y,this.b=w,this.c=$}async getRemoteDiagnostics(y){const w=this.a.getWindows();return(await Promise.all(w.map(async g=>{const h=g.remoteAuthority;if(!h)return;const c=`vscode:getDiagnosticInfoResponse${g.id}`,k={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(u=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:c,args:k}),D.$7S.once(c,(t,l)=>{l||u({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),u(l)}),setTimeout(()=>{u({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const $ of S.BrowserWindow.getAllWindows()){const g=this.a.getWindowById($.id);g?y.push(await this.d(g)):y.push(this.e($))}const w=[];for(const{pid:$,name:g}of b.$p6b.getAll())w.push({pid:$,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:w,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(y){const w=await this.f(y),$=(0,a.$Hf)(y.win);return this.e($,w,y.remoteAuthority)}e(y,w=[],$){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:w,remoteAuthority:$}}async f(y){const w=[],$=y.openedWorkspace;if((0,P.$Wh)($))w.push($.uri);else if((0,P.$2h)($)){const g=await this.b.resolveLocalWorkspace($.configPath);g&&g.folders.forEach(c=>{w.push(c.uri)})}return w}};e.$t6b=p,e.$t6b=p=ke([_(0,C.$85b),_(1,f.$n6b),_(2,m.$7i)],p)}),define(ee[68],te([0,1,47,15,28,154,54,3,2,13,9,4,7,105,86,21,103,180,60,26,6,20,5,24,67,30,29,53,17,241,233]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u,t,l,r,i,n,o,v,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=e.$G6b=void 0,e.$G6b=(0,k.$Mh)("nativeHostMainService");let E=class extends f.$Qc{constructor(M,U,B,se,x,ae,ne,re){super(),this.a=M,this.b=U,this.c=B,this.f=se,this.g=x,this.h=ae,this.j=ne,this.m=re,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,Q=>Q.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:Q,x:J,y:V})=>({windowId:Q.id,x:J,y:V})),({windowId:Q})=>!!this.a.getWindowById(Q)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(Q,J)=>J.id),Q=>!!this.a.getWindowById(Q)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(Q,J)=>J.id),Q=>!!this.a.getWindowById(Q)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(Q,J)=>J.id),Q=>!!this.a.getWindowById(Q)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),Q=>!!Q),Q=>Q.id),P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(Q,J)=>J.id),Q=>!!this.a.getWindowById(Q))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new P.$Ld),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(Q,J,V)=>V),Q=>!(Array.isArray(Q)&&Q.length===1&&Q[0]==="workArea")),P.Event.fromNodeEventEmitter(D.screen,"display-added"),P.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,n.$1h)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(M){return this.a.getWindowCount()}async getActiveWindowId(M){const U=D.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(M,U,B){return Array.isArray(U)?this.r(M,U,B):this.s(M,U)}async r(M,U,B=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:M,urisToOpen:U,cli:this.f.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async s(M,U){await this.a.openEmptyWindow({context:5,contextWindowId:M},U)}async toggleFullScreen(M){this.C(M)?.toggleFullScreen()}async handleTitleDoubleClick(M){this.C(M)?.handleTitleDoubleClick()}async isMaximized(M){const U=this.C(M);return U?.win?U.win.isMaximized():!1}async maximizeWindow(M){const U=this.C(M);U?.win&&U.win.maximize()}async unmaximizeWindow(M){const U=this.C(M);U?.win&&U.win.unmaximize()}async minimizeWindow(M){const U=this.C(M);U?.win&&U.win.minimize()}async updateWindowControls(M,U){const B=this.C(M);B&&B.updateWindowControls(U)}async focusWindow(M,U){U&&typeof U.windowId=="number"&&(M=U.windowId),this.C(M)?.focus({force:U?.force??!1})}async setMinimumSize(M,U,B){const se=this.C(M);if(se?.win){const[x,ae]=se.win.getSize(),[ne,re]=se.win.getMinimumSize(),[Q,J]=[U??ne,B??re],[V,F]=[Math.max(x,Q),Math.max(ae,J)];(ne!==Q||re!==J)&&se.win.setMinimumSize(Q,J),(x!==V||ae!==F)&&se.win.setSize(V,F)}}async saveWindowSplash(M,U){this.j.saveWindowSplash(M,U)}async installShellCommand(M){const{source:U,target:B}=await this.t();try{const{symbolicLink:se}=await w.SymlinkSupport.stat(U);if(se&&!se.dangling){const x=await(0,d.$Yp)(U);if(B===x)return}await w.Promises.unlink(U)}catch(se){if(se.code!=="ENOENT")throw se}try{await w.Promises.symlink(B,U)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:x}=await this.showMessageBox(M,{type:"info",message:(0,g.localize)(0,null,this.h.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(x===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${U}'\\" with administrator privileges"`;await(0,L.promisify)(S.exec)(ae)}catch{throw new Error((0,g.localize)(3,null,U))}}}async uninstallShellCommand(M){const{source:U}=await this.t();try{await w.Promises.unlink(U)}catch(B){switch(B.code){case"EACCES":{const{response:se}=await this.showMessageBox(M,{type:"info",message:(0,g.localize)(4,null,this.h.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(se===0)try{const x=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,L.promisify)(S.exec)(x)}catch{throw new Error((0,g.localize)(7,null,U))}break}case"ENOENT":break;default:throw B}}}async t(){const M=(0,m.$ic)(this.f.appRoot,"bin","code"),U=`/usr/local/bin/${this.h.applicationName}`;if(!await w.Promises.exists(M))throw new Error((0,g.localize)(8,null,M));return{source:U,target:M}}async showMessageBox(M,U){return this.b.showMessageBox(U,this.u(M))}async showSaveDialog(M,U){return this.b.showSaveDialog(U,this.u(M))}async showOpenDialog(M,U){return this.b.showOpenDialog(U,this.u(M))}u(M){const U=this.C(M);if(U?.win)return U.win}async pickFileFolderAndOpen(M,U){const B=await this.b.pickFileFolder(U);B&&await this.w(await Promise.all(B.map(async se=>await w.SymlinkSupport.existsDirectory(se)?{folderUri:p.URI.file(se)}:{fileUri:p.URI.file(se)})),U,M)}async pickFolderAndOpen(M,U){const B=await this.b.pickFolder(U);B&&await this.w(B.map(se=>({folderUri:p.URI.file(se)})),U,M)}async pickFileAndOpen(M,U){const B=await this.b.pickFile(U);B&&await this.w(B.map(se=>({fileUri:p.URI.file(se)})),U,M)}async pickWorkspaceAndOpen(M,U){const B=await this.b.pickWorkspace(U);B&&await this.w(B.map(se=>({workspaceUri:p.URI.file(se)})),U,M)}async w(M,U,B){await this.a.open({context:3,contextWindowId:B,cli:this.f.args,urisToOpen:M,forceNewWindow:U.forceNewWindow})}async showItemInFolder(M,U){D.shell.showItemInFolder(U)}async setRepresentedFilename(M,U){this.C(M)?.setRepresentedFilename(U)}async setDocumentEdited(M,U){this.C(M)?.setDocumentEdited(U)}async openExternal(M,U){return this.f.unsetSnapExportedVariables(),D.shell.openExternal(U),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(M,U){return D.shell.trashItem(U)}async isAdmin(){let M;return b.$i?M=(await new Promise((U,B)=>{K(["native-is-elevated"],U,B)}))():M=process.getuid?.()===0,M}async writeElevated(M,U,B,se){const x=await new Promise((ae,ne)=>{K(["@vscode/sudo-prompt"],ae,ne)});return new Promise((ae,ne)=>{const re=[`"${this.z}"`];se?.unlock&&re.push("--file-chmod"),re.push("--file-write",`"${U.fsPath}"`,`"${B.fsPath}"`);const Q={name:this.h.nameLong.replace("-",""),icns:b.$j&&this.f.isBuilt?(0,m.$hc)((0,m.$kc)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};x.exec(re.join(" "),Q,(J,V,F)=>{V&&this.g.trace(`[sudo-prompt] received stdout: ${V}`),F&&this.g.trace(`[sudo-prompt] received stderr: ${F}`),J?ne(J):ae(void 0)})})}async isRunningUnderARM64Translation(){return b.$k||b.$i?!1:D.app.runningUnderARM64Translation}get z(){return b.$i?this.f.isBuilt?(0,m.$hc)((0,m.$kc)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,m.$hc)(this.f.appRoot,"scripts","code-cli.bat"):b.$k?this.f.isBuilt?(0,m.$hc)((0,m.$kc)(process.execPath),"bin",`${this.h.applicationName}`):(0,m.$hc)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,m.$hc)(this.f.appRoot,"bin","code"):(0,m.$hc)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Jm.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return b.$i&&(0,R.$E6b)()}async killProcess(M,U,B){process.kill(U,B)}async readClipboardText(M,U){return D.clipboard.readText(U)}async writeClipboardText(M,U,B){return D.clipboard.writeText(U,B)}async readClipboardFindText(M){return D.clipboard.readFindText()}async writeClipboardFindText(M,U){return D.clipboard.writeFindText(U)}async writeClipboardBuffer(M,U,B,se){return D.clipboard.writeBuffer(U,Buffer.from(B.buffer),se)}async readClipboardBuffer(M,U){return v.$_d.wrap(D.clipboard.readBuffer(U))}async hasClipboard(M,U,B){return D.clipboard.has(U,B)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(M,U){this.C(M)?.updateTouchBar(U)}async notifyReady(M){this.C(M)?.setReady()}async relaunch(M,U){return this.c.relaunch(U)}async reload(M,U){const B=this.C(M);if(B){if((0,n.$2h)(B.openedWorkspace)){const se=B.openedWorkspace.configPath;if(se.scheme===a.Schemas.file&&(await this.m.resolveLocalWorkspace(se))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.c.reload(B,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(M){this.closeWindowById(M,M)}async closeWindowById(M,U){const B=this.C(U);if(B?.win)return B.win.close()}async quit(M){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.c.quit()}async exit(M,U){await this.c.kill(U)}async resolveProxy(M,U){return this.C(M)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(M,U,B,se,x=1){return(0,$.$eg)(U,B,se,x)}async openDevTools(M,U){const B=this.C(M);B?.win&&B.win.webContents.openDevTools(U)}async toggleDevTools(M){const U=this.C(M);U?.win&&U.win.webContents.toggleDevTools();for(const B of D.BrowserWindow.getAllWindows())B.webContents.getURL()==="about:blank"&&B.webContents.toggleDevTools()}async sendInputEvent(M,U){const B=this.C(M);B?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&B.win.webContents.sendInputEvent(U)}async profileRenderer(M,U,B){const se=this.C(M);if(!se||!se.win)throw new Error;return await new A.$F6b(se.win,U,this.g).inspect(B)}async windowsGetStringRegKey(M,U,B,se){if(!b.$i)return;const x=await new Promise((ae,ne)=>{K(["@vscode/windows-registry"],ae,ne)});try{return x.GetStringRegKey(U,B,se)}catch{return}}C(M){if(typeof M=="number")return this.a.getWindowById(M)}};e.$H6b=E,ke([C.$eh],E.prototype,"z",null),e.$H6b=E=ke([_(0,i.$85b),_(1,h.$i6b),_(2,u.$T5b),_(3,c.$R5b),_(4,t.$7i),_(5,l.$mj),_(6,r.$65b),_(7,o.$n6b)],E)}),define(ee[297],te([0,1,15,38,28,2,13,4,107,178,90,131,60,26,5,68,77,24,78,59,33,34,61,22,7,30,8]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u,t,l,r,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=void 0;const v="issue.processExplorerWindowState";let R=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,M,U,B,se,x,ae,ne,re,Q,J){this.g=I,this.h=M,this.i=U,this.j=B,this.k=se,this.l=x,this.m=ae,this.n=ne,this.o=re,this.p=Q,this.q=J,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){D.$7S.on("vscode:listProcesses",async I=>{const M=[];try{M.push({name:(0,a.localize)(0,null),rootProcess:await(0,f.$ur)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(B=>{(0,m.$jm)(B)?M.push({name:B.hostName,rootProcess:B}):B.processes&&M.push({name:B.hostName,rootProcess:B.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(I,"vscode:listProcessesResponse",M)}),D.$7S.on("vscode:workbenchCommand",(I,M)=>{const{id:U,from:B,args:se}=M;let x;switch(B){case"processExplorer":x=this.f;break;default:throw new Error(`Unexpected command source: ${B}`)}x?.webContents.send("vscode:runAction",{id:U,from:B,args:se})}),D.$7S.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),D.$7S.on("vscode:pidToNameRequest",async I=>{const M=await this.k.getMainDiagnostics(),U=[];for(const B of M.windows)U.push([B.pid,`window [${B.id}] (${B.title})`]);for(const{pid:B,name:se}of t.$p6b.getAll())U.push([B,se]);this.t(I,"vscode:pidToNameResponse",U)})}async openReporter(I){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const M=new L.$Pc,U=M.add(this.n.createIPCObjectUrl()),B=this.v(this.c,700,800);this.b=this.u(B,U,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:$.default}),this.b.loadURL(C.$ag.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,M.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,M.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const M=new L.$Pc,U=M.add(this.n.createIPCObjectUrl()),B=this.p.getItem(v,void 0),se=A(B)?B:this.v(this.f,800,500);this.d=this.u(se,U,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:$.default}),this.d.loadURL(C.$ag.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,M.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,M.dispose())});const x=()=>{if(!this.d)return;const ae=this.d.getSize(),ne=this.d.getPosition();if(!ae||!ne)return;const re={width:ae[0],height:ae[1],x:ne[0],y:ne[1]};this.p.setItem(v,re)};this.d.on("moved",x),this.d.on("resized",x)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await S.contentTracing.stopRecording(`${(0,k.$4f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,a.localize)(3,null),detail:(0,a.localize)(4,null,I),buttons:[(0,a.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,M)}async $getSystemInfo(){const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,M)}async $getPerformanceInfo(){try{const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,M)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(6,null),buttons:[(0,a.localize)(7,null),(0,a.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(9,null),buttons:[(0,a.localize)(10,null),(0,a.localize)(11,null)]},this.b);return I===0}return!1}async $getIssueReporterUri(I){if(!this.c)throw new Error("Issue reporter window not available");const M=this.q.getWindowById(this.c.id);if(!M)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${M.id}`;return n.Promises.withAsyncBody(async(B,se)=>{const x=new l.$Vd;M.sendWhenReady("vscode:triggerIssueUriRequestHandler",x.token,{replyChannel:U,extensionId:I}),D.$7S.once(U,(ae,ne)=>{B(r.URI.parse(ne))});try{await(0,n.$Sg)(5e3),x.cancel(),se(new Error("Timed out waiting for issue reporter URI"))}finally{D.$7S.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,M,...U){I.sender.isDestroyed()||I.sender.send(M,...U)}u(I,M,U,B){const se=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:U.title,backgroundColor:U.backgroundColor||o.a,webPreferences:{preload:C.$ag.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.$1C)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return se.setMenuBarVisibility(!1),se}v(I,M,U){let B;const se=S.screen.getAllDisplays();if(se.length===1)B=se[0];else{if(P.$j){const ne=S.screen.getCursorScreenPoint();B=S.screen.getDisplayNearestPoint(ne)}!B&&I&&(B=S.screen.getDisplayMatching(I.getBounds())),B||(B=S.screen.getPrimaryDisplay()||se[0])}const x=B.bounds,ae={width:M,height:U,x:x.x+x.width/2-M/2,y:x.y+x.height/2-U/2};return x.width>0&&x.height>0&&(ae.x<x.x&&(ae.x=x.x),ae.y<x.y&&(ae.y=x.y),ae.x>x.x+x.width&&(ae.x=x.x),ae.y>x.y+x.height&&(ae.y=x.y),ae.width>x.width&&(ae.width=x.width),ae.height>x.height&&(ae.height=x.height)),ae}};e.$J6b=R,e.$J6b=R=o=ke([_(1,d.$R5b),_(2,y.$7i),_(3,m.$im),_(4,b.$s6b),_(5,p.$i6b),_(6,w.$G6b),_(7,h.$I6b),_(8,g.$mj),_(9,u.$lN),_(10,i.$85b)],R);function A(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ee[298],te([0,1,22,18,26,20,5,68,24,50,25,48,100]),function(K,e,S,D,s,L,C,P,f,a,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=void 0;let d=class extends p.$$6b{constructor(w,$,g,h,c,k,u,t){super(w,$,h,c,k,t),this.e=g,this.u=u}s(w){return(0,p.$06b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(b.$6T.CheckingForUpdates(w)),this.i.request({url:this.a},S.CancellationToken.None).then(a.$Qo).then($=>{!$||!$.url||!$.version||!$.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(b.$6T.Idle(1))):this.d(b.$6T.AvailableForDownload($))}).then(void 0,$=>{this.j.error($),this.e.publicLog2("update:notAvailable",{explicit:!!w});const g=w?$.message||$:void 0;this.d(b.$6T.Idle(1,g))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(b.$6T.Idle(1))}};e.$a7b=d,e.$a7b=d=ke([_(0,L.$T5b),_(1,D.$gi),_(2,m.$$k),_(3,s.$R5b),_(4,a.$Ko),_(5,C.$7i),_(6,P.$G6b),_(7,f.$mj)],d)}),define(ee[299],te([0,1,47,45,28,8,22,54,9,7,142,21,18,26,16,20,5,68,24,50,25,48,100]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=void 0;async function l(o,v=1e3){for(;!o();)await(0,L.$Sg)(v)}let r;function i(){return typeof r>"u"&&(r=D.existsSync(f.$hc(f.$kc(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$$6b{get cachePath(){const v=f.$hc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(v,{recursive:!0}).then(()=>v)}constructor(v,R,A,E,I,M,U,B,se){super(v,R,E,I,M,se),this.u=A,this.v=U,this.w=B,v.setRelaunchHandler(this)}handleRelaunch(v){return v?.addArgs||v?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$6T.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(v){let R="win32";return process.arch!=="ia32"&&(R+=`-${process.arch}`),i()===1?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,t.$06b)(R,v,this.k)}t(v){this.a&&(this.d(u.$6T.CheckingForUpdates(v)),this.i.request({url:this.a},C.CancellationToken.None).then(c.$Qo).then(R=>{const A=i();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!v}),this.d(u.$6T.Idle(A)),Promise.resolve(null)):A===1?(this.d(u.$6T.AvailableForDownload(R)),Promise.resolve(null)):(this.d(u.$6T.Downloading(R)),this.C(R.version).then(()=>this.B(R.version).then(E=>b.Promises.exists(E).then(I=>{if(I)return Promise.resolve(E);const M=R.url,U=R.hash,B=`${E}.tmp`;return this.i.request({url:M},C.CancellationToken.None).then(se=>this.v.writeFile(a.URI.file(B),se.stream)).then(U?()=>(0,m.$2S)(B,R.hash):()=>{}).then(()=>b.Promises.rename(B,E,!1)).then(()=>E)})).then(E=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:E},I?this.k.target==="user"?this.p():this.d(u.$6T.Downloaded(R)):this.d(u.$6T.Ready(R))})))}).then(void 0,R=>{this.j.error(R),this.u.publicLog2("update:notAvailable",{explicit:!!v});const A=v?R.message||R:void 0;this.d(u.$6T.Idle(i(),A))}))}async o(v){v.update.url&&this.w.openExternal(void 0,v.update.url),this.d(u.$6T.Idle(i()))}async B(v){const R=await this.cachePath;return f.$hc(R,`CodeSetup-${this.k.quality}-${v}.exe`)}async C(v=null){const R=v?M=>!new RegExp(`${this.k.quality}-${v}\\.exe$`).test(M):()=>!0,A=await this.cachePath,I=(await b.Promises.readdir(A)).filter(R).map(async M=>{try{await b.Promises.unlink(f.$hc(A,M))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const v=this.state.update;this.d(u.$6T.Updating(v));const R=await this.cachePath;this.e.updateFilePath=f.$hc(R,`CodeSetup-${this.k.quality}-${v.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$6T.Idle(i()))});const E=`${this.k.win32MutexName}-ready`,I=await new Promise((M,U)=>{K(["@vscode/windows-mutex"],M,U)});l(()=>I.isActive(E)).then(()=>this.d(u.$6T.Ready(v)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?D.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(v){if(this.state.type!=="idle")return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),A={version:"unknown",productVersion:"unknown"};this.d(u.$6T.Downloading(A)),this.e={packagePath:v},R?this.k.target==="user"?this.p():this.d(u.$6T.Downloaded(A)):this.d(u.$6T.Ready(A))}};e.$c7b=n,ke([P.$eh],n.prototype,"cachePath",null),e.$c7b=n=ke([_(0,w.$T5b),_(1,p.$gi),_(2,k.$$k),_(3,d.$R5b),_(4,c.$Ko),_(5,$.$7i),_(6,y.$8j),_(7,g.$G6b),_(8,h.$mj)],n)}),define(ee[300],te([0,1,15,8,22,49,3,2,13,65,4,7,188,64,18,60,26,63,16,20,5,24,78,250,80,25,102,67,59,30,29,53,95,134,39,34,52,66,23,6]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I,M,U,B,se,x,ae,ne){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=void 0;var Q;(function(V){V[V.NONE=0]="NONE",V[V.NAVIGATING=1]="NAVIGATING",V[V.READY=2]="READY"})(Q||(Q={}));let J=class extends P.$Qc{static{re=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const F=this.R.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.R.getProfileForWorkspace(this.config.workspace??(0,A.$1h)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(F,N,H,Y,ie,oe,T,O,j,q,W,z,G,ce,de,ue,fe,ye,be,pe,Re){super(),this.N=N,this.O=H,this.P=Y,this.Q=ie,this.R=oe,this.S=T,this.U=O,this.W=j,this.X=q,this.Y=W,this.Z=z,this.$=G,this.ab=ce,this.bb=de,this.db=ue,this.eb=fe,this.fb=ye,this.gb=be,this.hb=pe,this.b=this.B(new C.$Ld),this.onWillLoad=this.b.event,this.c=this.B(new C.$Ld),this.onDidSignalReady=this.c.event,this.f=this.B(new C.$Ld),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new C.$Ld),this.onDidClose=this.g.event,this.h=this.B(new C.$Ld),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.ib=0;{const[Te,$e]=this.sb(F.state);this.s=Te,this.N.trace("window#ctor: using window state",Te);const we=this.s.mode===0||this.s.mode===3,X=this.X.getValue("window"),le=Re.invokeFunction(R.$95b,this.s,{show:!we,webPreferences:{preload:f.$ag.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none"}});m.$j&&!this.zb()&&(le.fullscreenable=!1);const ge=m.$j&&X?.nativeTabs===!0;ge&&(le.tabbingIdentifier=this.eb.nameShort);const Ae=(0,v.$YC)(this.X)==="custom";if(Ae&&(le.titleBarStyle="hidden",m.$j||(le.frame=!1),(0,v.$ZC)(this.X))){const Ce=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Ue=M.$Qs.fromHex(Ce).isDarker()?"#FFFFFF":"#000000";le.titleBarOverlay={height:29,color:Ce,symbolColor:Ue},this.D=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this.m=new S.BrowserWindow(le),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,m.$j&&Ae&&this.m.setSheetOffset(22),Ae&&(m.$i&&(0,v.$ZC)(this.X)||m.$j)){const Ce=this.hb.getItem(re.a);Ce&&this.updateWindowControls({height:Ce})}m.$i&&Ae&&this.m.hookWindowMessage(278,()=>{const[Ue,Oe]=this.m.getPosition(),Be=S.screen.getCursorScreenPoint(),We=Be.x-Ue,Z=Be.y-Oe;return(()=>!(We>30&&Z>=0&&Z<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:We,y:Z})),0}),(m.$j||m.$i)&&$e&&(!ge||S.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Ce=>typeof Ce=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),we&&((0,a.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3&&this.vb(!0),this.m.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.pb(),this.Db(),this.jb()}setRepresentedFilename(F){m.$j?this.m.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return m.$j?this.m.getRepresentedFilename():this.z}setDocumentEdited(F){m.$j&&this.m.setDocumentEdited(F),this.C=F}isDocumentEdited(){return m.$j?this.m.isDocumentEdited():!!this.C}focus(F){m.$j&&F?.force&&S.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.ib=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.F.push(F)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(F=>{function N(){H.dispose(),Y.dispose(),F()}const H=this.onDidClose(()=>N()),Y=this.onWillLoad(()=>N())})}jb(){this.m.on("unresponsive",()=>this.mb(1)),this.m.webContents.on("render-process-gone",(N,H)=>this.mb(2,{...H})),this.m.webContents.on("did-fail-load",(N,H,Y)=>this.mb(3,{reason:Y,exitCode:H})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",N=>{this.r&&(this.r.maximized=!0),S.app.emit("browser-window-maximize",N,this.m)}),this.m.on("unmaximize",N=>{this.r&&(this.r.maximized=!1),S.app.emit("browser-window-unmaximize",N,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(N=>this.pb(N))),this.B(this.Z.onDidDeleteUntitledWorkspace(N=>this.ob(N)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(N,H)=>{const Y=await this.lb();H({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,Y)})})}lb(){return this.kb||(this.kb=(0,l.$5o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.kb}async mb(F,N){switch(F){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:F,reason:N?.reason,code:N?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.db.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:Y}=await this.bb.showMessageBox({type:"warning",buttons:[(0,p.localize)(0,null),(0,p.localize)(1,null),(0,p.localize)(2,null)],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),checkboxLabel:this.r?.workspace?(0,p.localize)(5,null):void 0},this.m);if(H!==2){const ie=H===0;await this.nb(ie,Y)}}else if(F===2){let H;N?H=(0,p.localize)(7,null,N.reason,N.exitCode??"<unknown>"):H=(0,p.localize)(6,null);const{response:Y,checkboxChecked:ie}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,p.localize)(8,null):(0,p.localize)(9,null),(0,p.localize)(10,null)],message:H,detail:this.r?.workspace?(0,p.localize)(11,null):(0,p.localize)(12,null),checkboxLabel:this.r?.workspace?(0,p.localize)(13,null):void 0},this.m),oe=Y===0;await this.nb(oe,ie)}break}}async nb(F,N){const H=this.r?.workspace;if(N&&H)try{const Y=this.W.workspaceStorage(H);await Y.init(),Y.delete("memento/workbench.parts.editor"),await Y.close()}catch(Y){this.N.error(Y)}if(this.h.fire(),this.m?.destroy(),F&&this.r){let Y,ie;(0,A.$Wh)(H)?Y={folderUri:H.uri}:(0,A.$2h)(H)?Y={workspaceUri:H.configPath}:ie=!0,(0,ae.$Mb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:Y?[Y]:void 0,forceEmpty:ie,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}ob(F){this.r?.workspace?.id===F.id&&(this.r.workspace=void 0)}pb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const N=this.Ab();N!==this.t&&(this.t=N,this.Bb(N))}if(!F||F.affectsConfiguration("http.proxy")){let N=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.H||H!==this.I)){this.H=N,this.I=H;const Y=N||"",ie=H?`${H},<local>`:"<local>";this.N.trace(`Setting proxy to '${Y}', bypassing '${ie}'`),this.m.webContents.session.setProxy({proxyRules:Y,proxyBypassRules:ie,pacScript:""})}}}addTabbedWindow(F){m.$j&&F.win&&this.m.addTabbedWindow(F.win)}load(F,N=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!N.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.qb(F,N),this.ib===0?this.r=F:this.L=F,this.ib=1,this.m.loadURL(f.$ag.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new D.$4g(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:F.workspace,reason:N.isReload?3:H?2:1})}qb(F,N){const H=(this.r??this.L)?.userEnv;if(H){const Y=(0,g.$Il)(H)&&!(0,g.$Il)(F.userEnv),ie=this.isExtensionDevelopmentHost;(Y||ie)&&(F.userEnv={...H,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(F["disable-extensions"]=N.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.Y.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),F.perfMarks=(0,a.getMarks)(),this.J.update(F)}async reload(F){const N=Object.assign({},this.r);N.workspace=await this.rb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&F&&(N.verbose=F.verbose,N.debugId=F.debugId,N.extensionEnvironment=F.extensionEnvironment,N["inspect-extensions"]=F["inspect-extensions"],N["inspect-brk-extensions"]=F["inspect-brk-extensions"],N["extensions-dir"]=F["extensions-dir"]),N.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.Q.serialize(),N.continueOn=this.P.continueOn,N.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},N.logLevel=this.O.getLogLevel(),N.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async rb(F){if((0,A.$2h)(F.workspace)){const N=F.workspace.configPath;if(N.scheme===f.Schemas.file&&!await this.S.exists(N))return}else if((0,A.$Wh)(F.workspace)){const N=F.workspace.uri;if(N.scheme===f.Schemas.file&&!await this.S.exists(N))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,I.$Q5b)();if(this.isFullScreen){let H;try{H=S.screen.getDisplayMatching(this.getBounds())}catch{}const Y=(0,I.$Q5b)();return{mode:3,display:H?H.id:void 0,width:this.s.width||Y.width,height:this.s.height||Y.height,x:this.s.x||0,y:this.s.y||0}}const F=Object.create(null);let N;if(!m.$j&&this.m.isMaximized()?N=0:N=1,N===0?F.mode=0:F.mode=1,N===1||N===0){let H;N===1?H=this.getBounds():H=this.m.getNormalBounds(),F.x=H.x,F.y=H.y,F.width=H.width,F.height=H.height}return F}updateWindowControls(F){if(F.height&&this.hb.setItem(re.a,F.height),m.$i&&this.D)this.m.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(m.$j&&F.height!==void 0){const N=(F.height-15)/2;N?this.m.setWindowButtonPosition({x:N,y:N}):this.m.setWindowButtonPosition(null)}}sb(F){(0,a.mark)("code/willRestoreCodeWindowState");let N=!1;if(F)try{const H=S.screen.getAllDisplays();N=H.length>1,F=this.tb(F,H)}catch(H){this.N.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[F||(0,I.$Q5b)(),N]}tb(F,N){if(this.N.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const ie=this.ub(N[0]);if(ie){let oe=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!ie||(F.x<ie.x&&(F.x=ie.x),F.y<ie.y&&(F.y=ie.y))};this.N.trace("window#validateWindowState: 1 monitor working area",ie),oe(),F.width>ie.width&&(F.width=ie.width),F.height>ie.height&&(F.height=ie.height),F.x>ie.x+ie.width-128&&(F.x=ie.x+ie.width-F.width),F.y>ie.y+ie.height-128&&(F.y=ie.y+ie.height-F.height),oe()}return F}if(F.display&&F.mode===3){const ie=N.find(oe=>oe.id===F.display);if(ie&&typeof ie.bounds?.x=="number"&&typeof ie.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const oe=(0,I.$Q5b)(3);return oe.x=ie.bounds.x,oe.y=ie.bounds.y,oe}}let H,Y;try{H=S.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),Y=this.ub(H)}catch{}if(H&&Y&&F.x+F.width>Y.x&&F.y+F.height>Y.y&&F.x<Y.x+Y.width&&F.y<Y.y+Y.height)return this.N.trace("window#validateWindowState: multi-monitor working area",Y),F}ub(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,N]=this.m.getPosition(),[H,Y]=this.m.getSize();return{x:F,y:N,width:H,height:Y}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(F){this.zb()?this.wb(F):this.yb(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Bb(this.t,!1)}get isFullScreen(){return m.$j&&typeof this.u=="boolean"?this.u:this.m.isFullScreen()||this.m.isSimpleFullScreen()}wb(F){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.xb(F)}xb(F){m.$j&&(this.u=F,this.w=new D.$ah,Promise.race([this.w.p,(0,D.$Sg)(1e3)]).finally(()=>this.u=void 0)),this.m.setFullScreen(F)}yb(F){this.m.isFullScreen()&&this.xb(!1),this.m.setSimpleFullScreen(F),this.m.webContents.focus()}zb(){const F=this.X.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Ab(){let F=(0,v.$XC)(this.X);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Bb(F,N=!0){m.$j||(F==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,p.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.Cb(F)}):this.Cb(F))}Cb(F){const N=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(F,N,...H){this.isReady?this.send(F,...H):this.ready().then(()=>{N.isCancellationRequested||this.send(F,...H)})}send(F,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...N)}catch(H){this.N.warn(`Error sending IPC message to channel '${F}' of window ${this.j}: ${(0,L.$xi)(H)}`)}}}updateTouchBar(F){m.$j&&this.G.forEach((N,H)=>{const Y=F[H];N.segments=this.Fb(Y)})}Db(){if(m.$j){for(let F=0;F<10;F++){const N=this.Eb();this.G.push(N)}this.m.setTouchBar(new S.TouchBar({items:this.G}))}}Eb(F=[]){const N=this.Fb(F),H=new S.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:Y=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[Y].id,from:"touchbar"})}});return H}Fb(F=[]){return F.map(H=>{let Y;H.icon&&!n.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(Y=S.nativeImage.createFromPath(b.URI.revive(H.icon.dark).fsPath),Y.isEmpty()&&(Y=void 0));let ie;return typeof H.title=="string"?ie=H.title:ie=H.title.value,{id:H.id,label:Y?void 0:ie,icon:Y}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$k7b=J,e.$k7b=J=re=ke([_(1,k.$7i),_(2,x.$Y6b),_(3,$.$R5b),_(4,U.$_m),_(5,se.$Z5b),_(6,h.$8j),_(7,r.$45b),_(8,r.$25b),_(9,y.$gi),_(10,o.$65b),_(11,E.$n6b),_(12,d.$b6b),_(13,i.$$k),_(14,w.$i6b),_(15,c.$T5b),_(16,u.$mj),_(17,t.$I6b),_(18,R.$85b),_(19,B.$lN),_(20,ne.$Lh)],J)}),define(ee[81],te([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,80,97,29,53,31]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=e.$T6b=void 0,e.$T6b=(0,y.$Mh)("workspacesHistoryMainService");let l=class extends P.$Qc{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,o,v){super(),this.f=i,this.g=n,this.h=o,this.j=v,this.c=this.B(new L.$Ld),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Pg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const R of i)if((0,h.$sU)(R))!this.g.isUntitledWorkspace(R.workspace)&&!this.u(n,R.workspace)&&n.push(R);else if((0,h.$tU)(R))this.w(n,R.folderUri)||n.push(R);else{const A=this.y(o,R.fileUri),E=R.fileUri.scheme===f.Schemas.file&&t.F.indexOf((0,m.$qg)(R.fileUri))>=0;!A&&!E&&(o.push(R),a.$i&&R.fileUri.scheme===f.Schemas.file&&S.app.addRecentDocument(R.fileUri.fsPath))}const v=await this.n({workspaces:n,files:o});n=v.workspaces,o=v.files,n.length>t.a&&(n.length=t.a),o.length>t.a&&(o.length=t.a),await this.s({workspaces:n,files:o}),this.c.fire(),a.$j&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(i){const n=A=>{const E=this.t(A);for(const I of i)if(m.$kg.isEqual(I,E))return!1;return!0},o=await this.getRecentlyOpened(),v=o.workspaces.filter(n),R=o.files.filter(n);(v.length!==o.workspaces.length||R.length!==o.files.length)&&(await this.s({files:R,workspaces:v}),this.c.fire(),a.$j&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(i){const n=new u.$yc(R=>m.$kg.getComparisonKey(R));if(i?.workspaces)for(const R of i.workspaces)n.set(this.t(R),R);const o=new u.$yc(R=>m.$kg.getComparisonKey(R));if(i?.files)for(const R of i.files)o.set(this.t(R),R);const v=await this.r();for(const R of v.workspaces){const A=n.get(this.t(R));A?A.label=A.label??R.label:n.set(this.t(R),R)}for(const R of v.files){const A=o.get(this.t(R));A?A.label=A.label??R.label:o.set(this.t(R),R)}return{workspaces:[...n.values()],files:[...o.values()]}}async r(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,h.$zU)(i,this.f)}async s(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,h.$AU)(i)),-1,1)}t(i){return(0,h.$tU)(i)?i.folderUri:(0,h.$uU)(i)?i.fileUri:i.workspace.configPath}u(i,n){return!!i.find(o=>(0,h.$sU)(o)&&o.workspace.id===n.id)}w(i,n){return!!i.find(o=>(0,h.$tU)(o)&&m.$kg.isEqual(o.folderUri,n))}y(i,n){return!!i.find(o=>m.$kg.isEqual(o.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){a.$i&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!a.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const R of S.app.getJumpListSettings().removedItems){const A=R.args;if(A){const E=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);E&&n.push(b.URI.parse(E[2]))}}await this.removeRecentlyOpened(n);let o=!1;const v=(0,D.$Fb)((await this.getRecentlyOpened()).workspaces.slice(0,t.D).map(R=>{const A=(0,h.$sU)(R)?R.workspace:R.folderUri,{title:E,description:I}=this.J(A,R.label);let M;return b.URI.isUri(A)?M=`--folder-uri "${A.toString()}"`:(o=!0,M=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:E.substr(0,255),description:I.substr(0,255),program:process.execPath,args:M,iconPath:"explorer.exe",iconIndex:0}}));v.length>0&&i.push({type:"custom",name:o?(0,d.localize)(2,null):(0,d.localize)(3,null),items:v})}i.push({type:"recent"});try{const n=S.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(i,n){if(n)return{title:(0,C.$sv)(n).name,description:n};if(b.URI.isUri(i))return{title:(0,m.$qg)(i),description:this.L(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,d.localize)(4,null),description:""};let o=(0,m.$qg)(i.configPath);return o.endsWith(c.$9h)&&(o=o.substr(0,o.length-c.$9h.length-1)),{title:(0,d.localize)(5,null,o),description:this.L(i.configPath)}}L(i){return i.scheme==="file"?(0,C.$kv)(i.fsPath):i.toString()}async M(){if(!a.$j)return;S.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let R=0;R<i.workspaces.length&&o<t.z;R++){const A=this.t(i.workspaces[R]);if(A.scheme===f.Schemas.file){const E=(0,m.$hg)(A);await p.Promises.exists(E)&&(n.push(E),o++)}}const v=[];for(let R=0;R<i.files.length&&o<t.C;R++){const A=this.t(i.files[R]);if(A.scheme===f.Schemas.file){const E=(0,m.$hg)(A);if(t.F.includes((0,m.$qg)(A))||n.includes(E))continue;await p.Promises.exists(E)&&(v.push(E),o++)}}v.reverse().forEach(R=>S.app.addRecentDocument(R)),n.reverse().forEach(R=>S.app.addRecentDocument(R))}};e.$U6b=l,e.$U6b=l=t=ke([_(0,$.$7i),_(1,k.$n6b),_(2,w.$T5b),_(3,g.$45b)],l)}),define(ee[301],te([0,1,15,8,22,46,4,7,179,18,26,20,5,229,68,24,34,25,48,59,30,81]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=void 0;const l="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(o,v,R,A,E,I,M,U,B,se,x){this.n=o,this.o=v,this.p=R,this.q=A,this.r=E,this.s=I,this.t=M,this.u=U,this.v=B,this.w=se,this.x=x,this.m=Object.create(null),this.g=new D.$4g(()=>this.E(),0),this.h=new D.$4g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$j||(0,c.$YC)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(t.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(I,M,U)=>this.p.openEmptyWindow({context:2,contextWindowId:M?.id}),this.m["workbench.action.newWindow"]=(I,M,U)=>this.p.openEmptyWindow({context:2,contextWindowId:M?.id}),this.m["workbench.action.files.openFileFolder"]=(I,M,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.files.openFolder"]=(I,M,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.openWorkspace"]=(I,M,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.youTubeUrl;o&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(o,"openYouTubeUrl"));const v=this.x.requestFeatureUrl;v&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(v,"openUserVoiceUrl"));const R=this.x.reportIssueUrl;R&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(R,"openReportIssues"));const A=this.x.licenseUrl;A&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$v){const I=A.indexOf("?")>0?"&":"?";this.Z(`${A}${I}lang=${C.$v}`,"openLicenseUrl")}else this.Z(A,"openLicenseUrl")});const E=this.x.privacyStatementUrl;E&&A&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(E,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!C.$j)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,v){this.k=o.menus,this.l=o.keybindings,this.t.setItem(t.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){C.$j&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){C.$j&&(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=S.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(C.$j?new S.Menu:null);return}const v=new S.Menu;let R;if(C.$j){const E=new S.Menu;R=new S.MenuItem({label:this.x.nameShort,submenu:E}),this.I(E),v.append(R)}if(C.$j&&!this.c){this.c=!0;const E=new S.Menu;E.append(new S.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(E)}if(this.K("File")){const E=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(1,null)),submenu:E});this.M(E,"File"),v.append(I)}if(this.K("Edit")){const E=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(2,null)),submenu:E});this.M(E,"Edit"),v.append(I)}if(this.K("Selection")){const E=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(3,null)),submenu:E});this.M(E,"Selection"),v.append(I)}if(this.K("View")){const E=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(4,null)),submenu:E});this.M(E,"View"),v.append(I)}if(this.K("Go")){const E=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(5,null)),submenu:E});this.M(E,"Go"),v.append(I)}if(this.K("Run")){const E=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(6,null)),submenu:E});this.M(E,"Run"),v.append(I)}if(this.K("Terminal")){const E=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(7,null)),submenu:E});this.M(E,"Terminal"),v.append(I)}let A;if(this.K("Window")){const E=new S.Menu;A=new S.MenuItem({label:this.ab(f.localize(8,null)),submenu:E,role:"window"}),this.S(E)}if(A&&v.append(A),this.K("Help")){const E=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(9,null)),submenu:E,role:"help"});this.M(E,"Help"),v.append(I)}v.items&&v.items.length>0?S.Menu.setApplicationMenu(v):S.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const v=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),R=this.T();let A;if(this.K("Preferences")){const ae=new S.Menu;this.M(ae,"Preferences"),A=new S.MenuItem({label:this.ab(f.localize(11,null)),submenu:ae})}const E=new S.Menu,I=new S.MenuItem({label:f.localize(12,null),role:"services",submenu:E}),M=new S.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),B=new S.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new S.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ae,ne,re)=>{const Q=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&await this.J(re)&&this.w.quit(void 0)}})),x=[v];x.push(...R),A&&x.push(i(),A),x.push(i(),I,i(),M,U,B,i(),se),x.forEach(ae=>o.append(ae))}async J(o){if(this.p.getWindowCount()===0)return!0;const v=this.o.getValue("window.confirmBeforeClose");if(v==="always"||v==="keyboardOnly"&&this.Q(o)){const{response:R}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return R===0}return!0}K(o){if(!C.$j&&(0,c.$YC)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,v){v.forEach(R=>{if((0,d.$Q6b)(R))o.append(i());else if((0,d.$P6b)(R)){const A=new S.Menu,E=new S.MenuItem({label:this.ab(R.label),submenu:A});this.L(A,R.submenu.items),o.append(E)}else(0,d.$R6b)(R)?o.append(this.O(R)):(0,d.$S6b)(R)&&(R.id==="workbench.action.showAboutDialog"&&this.N(o),C.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[R.id]?o.append(new S.MenuItem(this.Y(R.id,{label:this.ab(R.label),click:this.m[R.id]}))):o.append(this.U(R.label,R.id,!1,R.checked)):o.append(this.U(R.label,R.id,R.enabled!==!1,!!R.checked)):o.append(this.U(R.label,R.id,R.enabled!==!1,!!R.checked)))})}M(o,v){this.k&&this.k[v]&&this.L(o,this.k[v].items)}N(o){const v=this.T();v.length&&(v.forEach(R=>o.append(R)),o.append(i()))}O(o){const v=P.URI.revive(o.uri),R=o.id,A=R==="openRecentFile"?{fileUri:v}:R==="openRecentWorkspace"?{workspaceUri:v}:{folderUri:v};return new S.MenuItem(this.Y(R,{label:o.label,click:async(E,I,M)=>{const U=this.P(M);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[A],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([v])}},!1))}P(o){return!!(o&&(!C.$j&&(o.ctrlKey||o.shiftKey)||C.$j&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,v,R){const A={label:this.ab(o),role:R,enabled:!0};return new S.MenuItem(this.X(v,A))}S(o){const v=new S.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),R=new S.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),A=new S.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),E=this.U(f.localize(23,null),"workbench.action.switchWindow"),I=[];this.C&&(I.push(i()),I.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),I.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),I.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),I.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),I.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[v,R,i(),E,...I,i(),A].forEach(M=>o.append(M))}T(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(o,v,R,A){const E=this.ab(o),I=typeof v=="function"?v:(x,ae,ne)=>{const re=x?x.userSettingsLabel:null;let Q=v;Array.isArray(v)&&(Q=this.P(ne)?v[1]:v[0]),re&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:re}):this.W({type:"commandId",commandId:Q})},M=typeof R=="boolean"?R:this.p.getWindowCount()>0,U=typeof A=="boolean"?A:!1,B={label:E,click:I,enabled:M};U&&(B.type="checkbox",B.checked=U);let se;return typeof v=="string"?se=v:Array.isArray(v)&&(se=v[0]),C.$j&&(se==="editor.action.clipboardCutAction"?B.role="cut":se==="editor.action.clipboardCopyAction"?B.role="copy":se==="editor.action.clipboardPasteAction"&&(B.role="paste"),se==="undo"?B.click=this.V(I,{inDevTools:x=>x.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?B.click=this.V(I,{inDevTools:x=>x.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(B.click=this.V(I,{inDevTools:x=>x.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(se,B))}V(o,v){return(R,A,E)=>{const I=S.BrowserWindow.getFocusedWindow();if(!I)return v.inNoWindow();if(I.webContents.isDevToolsFocused()&&I.webContents.devToolsWebContents)return v.inDevTools(I.webContents.devToolsWebContents);o(R,A||I,E)}}W(o){let v=S.BrowserWindow.getFocusedWindow();if(!v){const A=this.p.getLastActiveWindow();A?.isMinimized()&&(v=A.win)}const R=v?this.p.getWindowById(v.id):void 0;if(R){if(this.v.trace("menubar#runActionInRenderer",o),C.$j&&!this.q.isBuilt&&!R.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const A={id:o.commandId,from:"menu"};R.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:o.userSettingsLabel};R.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,v){const R=typeof o=="string"?this.l[o]:void 0;if(R?.label){if(R.isNative!==!1)v.accelerator=R.label,v.userSettingsLabel=R.userSettingsLabel;else if(typeof v.label=="string"){const A=v.label.indexOf("[");A>=0?v.label=`${v.label.substr(0,A)} [${R.label}]`:v.label=`${v.label} [${R.label}]`}}else v.accelerator=void 0;return v}Y(o,v,R=!v.accelerator){R&&(v=this.X(o,v));const A=v.click;return v.click=(E,I,M)=>{this.$(o),A?.(E,I,M)},v}Z(o,v){this.w.openExternal(void 0,o),this.$(v)}$(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:l})}ab(o){return(0,L.$pv)(o,!this.B)}};e.$V6b=r,e.$V6b=r=t=ke([_(0,h.$7T),_(1,a.$gi),_(2,k.$85b),_(3,m.$R5b),_(4,g.$$k),_(5,u.$T6b),_(6,$.$lN),_(7,b.$T5b),_(8,p.$7i),_(9,y.$G6b),_(10,w.$mj)],r);function i(){return new S.MenuItem({type:"separator"})}}),define(ee[302],te([0,1,6,20,5,301]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=e.$W6b=void 0,e.$W6b=(0,S.$Mh)("menubarMainService");let C=class{constructor(f,a,m){this.b=f,this.c=a,this.d=m,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(L.$V6b)}async updateMenubar(f,a){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(a,f)}};e.$X6b=C,e.$X6b=C=ke([_(0,S.$Lh),_(1,D.$T5b),_(2,s.$7i)],C)}),define(ee[303],te([0,1,15,21,130,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,189,64,18,60,26,16,6,20,5,77,78,58,34,59,300,129,296,29,98,81,53,67,39,52,66]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I,M,U,B,se,x,ae,ne,re,Q,J,V,F){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=void 0;function H(oe){return(0,x.$2h)(oe?.workspace)}function Y(oe){return(0,x.$Wh)(oe?.workspace)}let ie=class extends b.$Qc{static{N=this}static{this.a=[]}constructor(T,O,j,q,W,z,G,ce,de,ue,fe,ye,be,pe,Re,Te,$e,we){super(),this.m=T,this.n=O,this.r=j,this.s=q,this.t=W,this.u=z,this.w=G,this.z=ce,this.C=de,this.D=ue,this.F=fe,this.G=ye,this.H=be,this.I=pe,this.J=Re,this.L=Te,this.M=$e,this.N=we,this.b=this.B(new f.$Ld),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$Ld),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$Ld),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$Ld),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$Ld),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new se.$l7b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(T=>this.c.fire(T.window))),this.B(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const O=new b.$Pc;if(O.add(f.Event.any(T.onDidClose,T.onDidDestroy)(()=>O.dispose())),T.config.extensionDevelopmentPath)for(const j of T.config.extensionDevelopmentPath)O.add(this.M.addValidFileRoot(j));T.config.extensionTestsPath&&O.add(this.M.addValidFileRoot(T.config.extensionTestsPath))}}))}openEmptyWindow(T,O){const j=this.w.args,q=O?.remoteAuthority||void 0,W=!0,z=O?.forceReuseWindow,G=!z;return this.open({...T,cli:j,forceEmpty:W,forceNewWindow:G,forceReuseWindow:z,remoteAuthority:q})}openExistingWindow(T,O){T.focus(),this.P(O,[T])}async open(T){this.r.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const O=[],j=[],q=[],W=[],z=[];let G,ce=0;const de=await this.X(T);this.r.trace("windowsManager#open pathsToOpen",de);for(const pe of de)Y(pe)?T.addMode?O.push(pe):j.push(pe):H(pe)?q.push(pe):pe.fileUri?(G||(G={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:pe.remoteAuthority}),G.filesToOpenOrCreate.push(pe)):pe.backupPath?z.push({backupFolder:(0,d.$lc)(pe.backupPath),remoteAuthority:pe.remoteAuthority}):ce++;T.diffMode&&G&&G.filesToOpenOrCreate.length>=2&&(G.filesToDiff=G.filesToOpenOrCreate.slice(0,2),G.filesToOpenOrCreate=[]),T.mergeMode&&G&&G.filesToOpenOrCreate.length===4&&(G.filesToMerge=G.filesToOpenOrCreate.slice(0,4),G.filesToOpenOrCreate=[],G.filesToDiff=[]),G&&T.waitMarkerFileURI&&(G.filesToWait={paths:(0,C.$Fb)([...G.filesToDiff,G.filesToMerge[3],...G.filesToOpenOrCreate]),waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(W.push(...this.H.getUntitledWorkspaces()),q.push(...W),z.push(...this.D.getEmptyWindowBackups())):z.length=0;const{windows:ue,filesOpenedInWindow:fe}=await this.Q(T,q,j,z,ce,G,O);if(this.r.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${j.length}, emptyToRestore: ${z.length}, emptyToOpen: ${ce})`),ue.length>1)if(fe)fe.focus();else{const pe=this.j.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let Re=!0,Te=!0;if(pe){const $e=ue.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);$e.length&&($e[0].focus(),Re=!1,Te=!1)}if(Re)for(let $e=ue.length-1;$e>=0;$e--){const we=ue[$e];if(!(we.openedWorkspace&&W.some(X=>we.openedWorkspace&&X.workspace.id===we.openedWorkspace.id)||we.backupPath&&z.some(X=>we.backupPath&&X.backupFolder===(0,d.$lc)(we.backupPath)))){we.focus(),Te=!1;break}}Te&&ue[ue.length-1].focus()}const ye=G&&G.filesToDiff.length>0,be=G&&G.filesToMerge.length>0;if(!ue.some(pe=>pe.isExtensionDevelopmentHost)&&!ye&&!be&&!T.noRecentEntry){const pe=[];for(const Re of de)H(Re)&&!Re.transient?pe.push({label:Re.label,workspace:Re.workspace,remoteAuthority:Re.remoteAuthority}):Y(Re)?pe.push({label:Re.label,folderUri:Re.workspace.uri,remoteAuthority:Re.remoteAuthority}):Re.fileUri&&pe.push({label:Re.label,fileUri:Re.fileUri,remoteAuthority:Re.remoteAuthority});this.G.addRecentlyOpened(pe)}return this.P(T,ue),ue}P(T,O){const j=T.waitMarkerFileURI;T.context===0&&j&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.L.del(j)}catch{}})()}async Q(T,O,j,q,W,z,G){const ce=[];let de;function ue($e,we){ce.push($e),we&&(de=$e,z=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:ye}=this.ib(T);if(!T.initialStartup&&G.length>0){const $e=G[0].remoteAuthority,we=this.nb($e);we&&ue(this.S(we,G.map(X=>X.workspace.uri)))}const be=j.length+O.length+q.length;if(z&&be===0){const $e=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],we=this.getWindows().filter(le=>z&&(0,g.$yg)(le.remoteAuthority,z.remoteAuthority));let X;$e?.fileUri&&!ye&&((T.context===4||T.context===0||T.context===1)&&(X=await(0,B.$k6b)(we,$e.fileUri,async le=>le.configPath.scheme===p.Schemas.file?this.H.resolveLocalWorkspace(le.configPath):void 0)),X||(X=this.ob(we))),X?(0,x.$2h)(X.openedWorkspace)?O.push({workspace:X.openedWorkspace,remoteAuthority:X.remoteAuthority}):(0,x.$Wh)(X.openedWorkspace)?j.push({workspace:X.openedWorkspace,remoteAuthority:X.remoteAuthority}):ue(this.R(T,X,z),!0):ue(await this.jb({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile}),!0)}const pe=(0,C.$Kb)(O,$e=>$e.workspace.id);if(pe.length>0){const $e=(0,C.$Fb)(pe.map(we=>(0,B.$l6b)(this.getWindows(),we.workspace.configPath)));if($e.length>0){const we=$e[0],X=(0,g.$yg)(z?.remoteAuthority,we.remoteAuthority)?z:void 0;ue(this.R(T,we,X),!!X),fe=!0}for(const we of pe){if($e.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const X=we.remoteAuthority,le=(0,g.$yg)(z?.remoteAuthority,X)?z:void 0;ue(await this.W(T,we,fe,le),!!le),fe=!0}}const Re=(0,C.$Kb)(j,$e=>g.$kg.getComparisonKey($e.workspace.uri));if(Re.length>0){const $e=(0,C.$Fb)(Re.map(we=>(0,B.$l6b)(this.getWindows(),we.workspace.uri)));if($e.length>0){const we=$e[0],X=(0,g.$yg)(z?.remoteAuthority,we.remoteAuthority)?z:void 0;ue(this.R(T,we,X),!!X),fe=!0}for(const we of Re){if($e.some(ge=>(0,x.$Wh)(ge.openedWorkspace)&&g.$kg.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const X=we.remoteAuthority,le=(0,g.$yg)(z?.remoteAuthority,X)?z:void 0;ue(await this.W(T,we,fe,le),!!le),fe=!0}}const Te=(0,C.$Kb)(q,$e=>$e.backupFolder);if(Te.length>0)for(const $e of Te){const we=$e.remoteAuthority,X=(0,g.$yg)(z?.remoteAuthority,we)?z:void 0;ue(await this.U(T,!0,we,X,$e),!!X),fe=!0}if(ce.length===0||z){z&&!W&&W++;const $e=z?z.remoteAuthority:T.remoteAuthority;for(let we=0;we<W;we++)ue(await this.U(T,fe,$e,z),!!z),fe=!0}return{windows:(0,C.$Kb)(ce),filesOpenedInWindow:de}}R(T,O,j){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:j}),O.focus();const q={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToMerge:j?.filesToMerge,filesToWait:j?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",P.CancellationToken.None,q),O}S(T,O){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),T.focus();const j={foldersToAdd:O};return T.sendWhenReady("vscode:addFolders",P.CancellationToken.None,j),T}U(T,O,j,q,W){this.r.trace("windowsManager#doOpenEmpty",{restore:!!W,remoteAuthority:j,filesToOpen:q,forceNewWindow:O});let z;return!O&&typeof T.contextWindowId=="number"&&(z=this.getWindowById(T.contextWindowId)),this.jb({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:j,forceNewWindow:O,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:q,windowToUse:z,emptyWindowBackupInfo:W,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}W(T,O,j,q,W){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:q}),!j&&!W&&typeof T.contextWindowId=="number"&&(W=this.getWindowById(T.contextWindowId)),this.jb({workspace:O.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:q,windowToUse:W,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}async X(T){let O,j=!1,q=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(O=await this.Y(T),j=!0):T.forceEmpty?O=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(O=await this.Z(T.cli),O.length===0&&O.push(Object.create(null)),j=!0):(O=await this.ab(),O.length===0&&O.push(Object.create(null)),q=!0),!T.addMode&&j){const W=O.filter(z=>Y(z));if(W.length>1){const z=W[0].remoteAuthority;if(W.every(G=>(0,g.$yg)(G.remoteAuthority,z))){const G=await this.H.createUntitledWorkspace(W.map(ce=>({uri:ce.workspace.uri})));O.push({workspace:G,remoteAuthority:z}),O=O.filter(ce=>!Y(ce))}}}if(T.initialStartup&&!q&&this.F.getValue("window")?.restoreWindows==="preserve"){const W=await this.ab();O.unshift(...W.filter(z=>H(z)||Y(z)||z.backupPath))}return O}async Y(T){const O={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority},j=await Promise.all((0,C.$Fb)(T.urisToOpen||[]).map(async q=>{const W=await this.cb(q,O);if(W)return W.label=q.label,W;const z=this.eb(q);this.J.showMessageBox({type:"info",buttons:[(0,k.localize)(0,null)],message:z.scheme===p.Schemas.file?(0,k.localize)(1,null):(0,k.localize)(2,null),detail:z.scheme===p.Schemas.file?(0,k.localize)(3,null,(0,m.$jv)(z,{os:w.OS,tildify:this.w})):(0,k.localize)(4,null,z.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Fb)(j)}async Z(T){const O=[],j={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:T.diff&&T._.length===2||T.merge&&T._.length===4},q=T["folder-uri"];if(q){const G=await Promise.all(q.map(ce=>{const de=this.$(ce);if(de)return this.cb({folderUri:de},j)}));O.push(...(0,C.$Fb)(G))}const W=T["file-uri"];if(W){const G=await Promise.all(W.map(ce=>{const de=this.$(ce);if(de)return this.cb((0,x.$fi)(ce)?{workspaceUri:de}:{fileUri:de},j)}));O.push(...(0,C.$Fb)(G))}const z=await Promise.all(T._.map(G=>j.remoteAuthority?this.hb(G,j):this.fb(G,j)));return O.push(...(0,C.$Fb)(z)),O}$(T){try{const O=c.URI.parse(T);if(!O.scheme){this.r.error(`Invalid URI input string, scheme missing: ${T}`);return}return O.path?O:O.with({path:"/"})}catch(O){this.r.error(`Invalid URI input string: ${T}, ${O.message}`)}}async ab(){const T=this.bb();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];T!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const j=await Promise.all(O.map(async q=>{if(q.workspace){const W=await this.cb({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(H(W))return W}else if(q.folderUri){const W=await this.cb({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(Y(W))return W}else if(T!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,C.$Fb)(j)}}}bb(){let T;return this.C.wasRestarted?T="all":(T=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}async cb(T,O=Object.create(null)){const j=this.eb(T);return j.scheme===p.Schemas.file?((0,M.$WC)(T)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.fb(j.fsPath,O)):this.db(T,O)}db(T,O){let j=this.eb(T);const q=(0,E.$Qk)(j)||O.remoteAuthority;if(j=(0,g.$Ag)((0,g.$ug)(j)),(0,M.$WC)(T)){if(O.gotoLineMode){const{path:W,line:z,column:G}=(0,a.$3f)(j.path);return{fileUri:j.with({path:W}),options:{selection:z?{startLineNumber:z,startColumn:G||1}:void 0},remoteAuthority:q}}return{fileUri:j,remoteAuthority:q}}else if((0,M.$UC)(T))return{workspace:(0,ae.$d6b)(j),remoteAuthority:q};return{workspace:(0,ae.$e6b)(j),remoteAuthority:q}}eb(T){return(0,M.$UC)(T)?T.workspaceUri:(0,M.$VC)(T)?T.folderUri:T.fileUri}async fb(T,O,j){let q,W;O.gotoLineMode&&({path:T,line:q,column:W}=(0,a.$3f)(T)),T=(0,a.$Xf)((0,d.$fc)(T),(0,$.cwd)());try{const z=await D.Promises.stat(T);if(z.isFile()){if(!O.forceOpenWorkspaceAsFile){const G=await this.H.resolveLocalWorkspace(c.URI.file(T));if(G)return G.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:G.id,configPath:G.configPath},type:i.FileType.File,exists:!0,remoteAuthority:G.remoteAuthority,transient:G.transient}}return{fileUri:c.URI.file(T),type:i.FileType.File,exists:!0,options:{selection:q?{startLineNumber:q,startColumn:W||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ae.$e6b)(c.URI.file(T),z),type:i.FileType.Directory,exists:!0};if(!w.$i&&T==="/dev/null")return{fileUri:c.URI.file(T),type:i.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!j)return this.gb(T,O);const G=c.URI.file(T);if(this.G.removeRecentlyOpened([G]),O.ignoreFileNotFound)return{fileUri:G,type:i.FileType.File,exists:!1}}}async gb(T,O){const j=c.URI.file(T),{response:q,checkboxChecked:W}=await this.J.showMessageBox({type:"warning",buttons:[(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],message:(0,k.localize)(8,null,j.authority),detail:(0,k.localize)(9,null,(0,m.$jv)(j,{os:w.OS,tildify:this.w})),checkboxLabel:(0,k.localize)(10,null,j.authority),cancelId:1});if(q===0)return(0,s.addUNCHostToAllowlist)(j.authority),W&&this.sendToOpeningWindow("vscode:configureAllowedUNCHost",j.authority),this.fb(T,O,!0);if(q===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(T,O)}hb(T,O){const j=T.charCodeAt(0),q=O.remoteAuthority;let W,z;O.gotoLineMode&&({path:T,line:W,column:z}=(0,a.$3f)(T)),j!==47&&((0,a.$Wf)(j)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,a.$Pf)(T)),T=`/${T}`);const G=c.URI.from({scheme:p.Schemas.vscodeRemote,authority:q,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,x.$fi)(T))return O.forceOpenWorkspaceAsFile?{fileUri:G,options:{selection:W?{startLineNumber:W,startColumn:z||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ae.$d6b)(G),remoteAuthority:q};if(O.gotoLineMode||d.$ec.basename(T).indexOf(".")!==-1)return{fileUri:G,options:{selection:W?{startLineNumber:W,startColumn:z||1}:void 0},remoteAuthority:q}}return{workspace:(0,ae.$e6b)(G),remoteAuthority:q}}ib(T){const O=this.F.getValue("window"),j=O?.openFoldersInNewWindow||"default",q=O?.openFilesInNewWindow||"off";let W=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(j==="on"||j==="off")&&(W=j==="on");let z=!1;return T.forceNewWindow||T.forceReuseWindow?z=!!T.forceNewWindow&&!T.forceReuseWindow:(w.$j?T.context===1&&(z=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!T.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(z=q==="on")),{openFolderInNewWindow:!!W,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(T,O){const j=(0,B.$m6b)(this.getWindows(),T);if(j)return this.C.reload(j,O.cli),j.focus(),[j];let q=O.cli["folder-uri"]||[],W=O.cli["file-uri"]||[],z=O.cli._;if(!z.length&&!q.length&&!W.length&&!O.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(c.URI.isUri(ue)?ue.scheme===p.Schemas.file?z=[ue.fsPath]:q=[ue.toString()]:ue.configPath.scheme===p.Schemas.file?z=[(0,g.$hg)(ue.configPath)]:W=[ue.configPath.toString()])}let G=O.remoteAuthority;for(const de of T)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=c.URI.parse(de),fe=(0,E.$Qk)(ue);fe&&(G?(0,g.$yg)(fe,G)||this.r.error("more than one extension development path authority"):G=fe)}z=z.filter(de=>{const ue=c.URI.file(de);return(0,B.$l6b)(this.getWindows(),ue)?!1:(0,g.$yg)((0,E.$Qk)(ue),G)}),q=q.filter(de=>{const ue=this.$(de);return ue&&(0,B.$l6b)(this.getWindows(),ue)?!1:ue?(0,g.$yg)((0,E.$Qk)(ue),G):!1}),W=W.filter(de=>{const ue=this.$(de);return ue&&(0,B.$l6b)(this.getWindows(),ue)?!1:ue?(0,g.$yg)((0,E.$Qk)(ue),G):!1}),O.cli._=z,O.cli["folder-uri"]=q,O.cli["file-uri"]=W;const ce={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!z.length&&!q.length&&!W.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:G,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(ce)}async jb(T){const O=this.F.getValue("window"),j=this.getLastActiveWindow(),q=j?.profile??this.z.defaultProfile;let W;!T.forceNewWindow&&!T.forceNewTabbedWindow&&(W=T.windowToUse||j,W&&W.focus());const z={...this.w.args,...T.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,d.$hc)(this.w.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:q},homeDir:this.w.userHome.with({scheme:p.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:p.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.n,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToMerge:T.filesToOpen?.filesToMerge,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:p.Schemas.file}).fsPath,product:R.default,isInitialStartup:T.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,L.release)(),hostname:(0,L.hostname)(),arch:(0,L.arch)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(W){const G=W.config;!z.extensionDevelopmentPath&&G?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=G.extensionDevelopmentPath,z.extensionDevelopmentKind=G.extensionDevelopmentKind,z["enable-proposed-api"]=G["enable-proposed-api"],z.verbose=G.verbose,z["inspect-extensions"]=G["inspect-extensions"],z["inspect-brk-extensions"]=G["inspect-brk-extensions"],z.debugId=G.debugId,z.extensionEnvironment=G.extensionEnvironment,z["extensions-dir"]=G["extensions-dir"],z["disable-extensions"]=G["disable-extensions"]),z.loggers={global:z.loggers.global,window:G?.loggers.window??z.loggers.window}}else{const G=this.j.getNewWindowState(z);(0,y.mark)("code/willCreateCodeWindow");const ce=W=this.I.createInstance(U.$k7b,{state:G,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ce),N.a.push(ce),this.b.fire(ce),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new b.$Pc;de.add(ce.onDidSignalReady(()=>this.c.fire(ce))),de.add(f.Event.once(ce.onDidClose)(()=>this.mb(ce,de))),de.add(f.Event.once(ce.onDidDestroy)(()=>this.f.fire(ce))),de.add(ce.onDidTriggerSystemContextMenu(({x:fe,y:ye})=>this.h.fire({window:ce,x:fe,y:ye})));const ue=(0,h.$Hf)(ce.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.C.reload(ce)),this.C.registerWindow(ce)}return z.windowId=W.id,W.isReady?this.C.unload(W,4).then(async G=>{G||await this.kb(W,z,T,q)}):await this.kb(W,z,T,q),W}async kb(T,O,j,q){if(O.extensionDevelopmentPath||((0,x.$2h)(O.workspace)?O.backupPath=this.D.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,x.$Wh)(O.workspace)?O.backupPath=this.D.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.D.registerEmptyWindowBackup({backupFolder:j.emptyWindowBackupInfo?.backupFolder??(0,ae.$f6b)().id,remoteAuthority:O.remoteAuthority})),this.z.isEnabled()){const W=O.workspace??(0,x.$1h)(O.backupPath,!1),z=this.lb(j,W,q),G=z instanceof Promise?await z:z;O.profiles.profile=G,O.extensionDevelopmentPath||await this.z.setProfileForWorkspace(W,G)}T.load(O)}lb(T,O,j){return T.forceProfile?this.z.profiles.find(q=>q.name===T.forceProfile)??this.z.createNamedProfile(T.forceProfile):T.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(O)??j}mb(T,O){const j=N.a.indexOf(T);N.a.splice(j,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),O.dispose()}getFocusedWindow(){const T=S.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(T){return this.ob(this.getWindows().filter(O=>(0,g.$yg)(O.remoteAuthority,T)))}ob(T){const O=Math.max.apply(Math,T.map(j=>j.lastFocusTime));return T.find(j=>j.lastFocusTime===O)}sendToFocused(T,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(T,P.CancellationToken.None,...O)}sendToOpeningWindow(T,...O){this.B(f.Event.once(this.onDidSignalReadyWindow)(j=>{j.sendWhenReady(T,P.CancellationToken.None,...O)}))}sendToAll(T,O,j){for(const q of this.getWindows())j&&j.indexOf(q.id)>=0||q.sendWhenReady(T,P.CancellationToken.None,O)}getWindows(){return N.a}getWindowCount(){return N.a.length}getWindowById(T){const O=this.getWindows().filter(j=>j.id===T);return(0,C.$Mb)(O)}getWindowByWebContents(T){const O=S.BrowserWindow.fromWebContents(T);if(O)return this.getWindowById(O.id)}};e.$o7b=ie,e.$o7b=ie=N=ke([_(2,v.$7i),_(3,F.$Y6b),_(4,I.$lN),_(5,J.$_m),_(6,r.$R5b),_(7,V.$Z5b),_(8,o.$T5b),_(9,u.$b6b),_(10,t.$gi),_(11,ne.$T6b),_(12,re.$n6b),_(13,n.$Lh),_(14,l.$i6b),_(15,i.$8j),_(16,A.$I6b),_(17,Q.$65b)],ie)}),define(ee[304],te([0,1,64,30,81,53]),function(K,e,S,D,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;let C=class{constructor(f,a,m,b){this.a=f,this.b=a,this.c=m,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,a){const m=this.b.getWindowById(f);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),a)}createUntitledWorkspace(f,a,m){return this.a.createUntitledWorkspace(a,m)}deleteUntitledWorkspace(f,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(f,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(f,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$q7b=C,e.$q7b=C=ke([_(0,L.$n6b),_(1,D.$85b),_(2,s.$T6b),_(3,S.$b6b)],C)}),define(ee[305],te([0,1,15,130,38,28,17,49,14,33,3,44,46,2,13,9,4,12,7,32,156,42,157,110,288,160,64,281,18,198,90,131,60,116,218,26,63,93,207,291,209,210,211,16,222,92,75,6,91,217,297,282,289,20,5,302,68,24,58,292,94,34,273,80,122,25,249,251,51,48,263,286,298,287,299,127,265,266,267,270,295,59,30,303,272,29,97,81,304,53,39,231,52,242,50,79,128,275,290,278,8,253,274,226,66,294,269,23,125,293,261,237,83]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I,M,U,B,se,x,ae,ne,re,Q,J,V,F,N,H,Y,ie,oe,T,O,j,q,W,z,G,ce,de,ue,fe,ye,be,pe,Re,Te,$e,we,X,le,ge,Ae,Ce,Ue,Oe,Be,We,Z,he,me,ve,De,Fe,Me,Ne,ze,He,Ge,tt,Ze,it,nt,rt,$t,wt,bt,pt,yt,vt,kt,ot,Et,St,Pt,It,at,Rt,ft,ct,At,Ct,lt,Dt){"use strict";var ut;Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;let ht=class extends d.$Qc{static{ut=this}static{this.a={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Pe,Ie,Ee,Se,Le,je,qe,Ye,Qe,Ve,Je,Ke){super(),this.f=Pe,this.g=Ie,this.h=Ee,this.j=Se,this.m=Le,this.n=je,this.s=qe,this.t=Ye,this.u=Qe,this.w=Ve,this.y=Je,this.z=Ke,this.C(),this.D()}C(){const Pe=Ve=>Ve?.startsWith(`${y.Schemas.vscodeWebview}://`),Ie=new Set(this.y.quality==="stable"?[]:["media"]),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ve,Je,Ke,Xe)=>Pe(Xe.requestingUrl)?Ke(Ee.has(Je)):Xe.isMainFrame&&Xe.securityOrigin===`${y.Schemas.vscodeFileResource}://${y.$_f}/`?Ke(Ie.has(Je)):Ke(!1)),S.session.defaultSession.setPermissionCheckHandler((Ve,Je,Ke,Xe)=>Pe(Xe.requestingUrl)?Ee.has(Je):Xe.isMainFrame&&Xe.securityOrigin===`${y.Schemas.vscodeFileResource}://${y.$_f}/`?Ie.has(Je):!1);const Se=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),Le=Ve=>{for(let Je=Ve;Je;Je=Je.parent)if(Je.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},je=Ve=>Ve.resourceType==="xhr"||Le(Ve.frame),qe=Ve=>{const Je=Ve.frame;if(!Je||!this.b)return!1;const Ke=S.BrowserWindow.getAllWindows();for(const Xe of Ke)if(Je.processId===Xe.webContents.mainFrame.processId)return!0;return!1},Ye=(Ve,Je)=>{if(Ve.path!=="/index.html")return!0;const Ke=Je.frame;if(!Ke||!this.b)return!1;for(const Xe of this.b.getWindows())if(Xe.win&&Ke.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ve,Je)=>{const Ke=h.URI.parse(Ve.url);return Ke.scheme===y.Schemas.vscodeWebview&&!Ye(Ke,Ve)?(this.j.error("Blocked vscode-webview request",Ve.url),Je({cancel:!0})):Ke.scheme===y.Schemas.vscodeFileResource&&!qe(Ve)?(this.j.error("Blocked vscode-file request",Ve.url),Je({cancel:!0})):Ke.path.endsWith(".svg")&&!Se.has(Ke.scheme)?Je({cancel:!je(Ve)}):Je({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ve,Je)=>{const Ke=Ve.responseHeaders,Xe=Ke["content-type"]||Ke["Content-Type"];if(Xe&&Array.isArray(Xe)){const xe=h.URI.parse(Ve.url);if(xe.path.endsWith(".svg")&&Se.has(xe.scheme))return Ke["Content-Type"]=["image/svg+xml"],Je({cancel:!1,responseHeaders:Ke});if(!xe.path.endsWith(y.Schemas.vscodeRemoteResource)&&Xe.some(_e=>_e.toLowerCase().includes("image/svg")))return Je({cancel:!je(Ve)})}return Je({cancel:!1})});const Qe=S.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.n.codeCachePath&&Qe.setCodeCachePath((0,w.$hc)(this.n.codeCachePath,"chrome")),$.$i&&(this.t.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(this.t.getValue("security.allowedUNCHosts")))}D(){(0,f.setUnexpectedErrorHandler)(Ee=>this.G(Ee)),process.on("uncaughtException",Ee=>{(0,f.$X)(Ee)||(0,f.$Y)(Ee)}),process.on("unhandledRejection",Ee=>(0,f.$Y)(Ee)),this.s.onWillShutdown(()=>this.dispose()),(0,k.$8S)(),S.app.on("accessibility-support-changed",(Ee,Se)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Se)}),S.app.on("activate",async(Ee,Se)=>{this.j.trace("app#activate"),Se||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Ee,Se)=>{Se.on("will-navigate",je=>{this.j.error("webContents#will-navigate: Prevented webcontent navigation"),je.preventDefault()}),Se?.opener?.url.startsWith(`${y.Schemas.vscodeFileResource}://${y.$_f}/`)&&(Se.on("dom-ready",()=>{const je=this.t.getValue("window")?.zoomLevel??0;Se.setZoomLevel(je),Se.setZoomFactor((0,De.$1C)(je))}),this.n.args["open-devtools"]===!0&&Se.openDevTools({mode:"bottom"})),Se.setWindowOpenHandler(je=>je.url==="about:blank"?(this.j.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:this.h.invokeFunction(Fe.$95b)}):(this.j.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${je.url}}`),this.c?.openExternal(void 0,je.url),{action:"deny"}))});let Pe=[],Ie;S.app.on("open-file",(Ee,Se)=>{this.j.trace("app#open-file: ",Se),Ee.preventDefault(),Pe.push((0,ze.$fi)(Se)?{workspaceUri:h.URI.file(Se)}:{fileUri:h.URI.file(Se)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.n.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$7S.handle("vscode:fetchShellEnv",Ee=>{const Se=this.b?.getWindowByWebContents(Ee.sender);let Le,je;return Se?.config?(Le=Se.config,je={...process.env,...Se.config.userEnv}):(Le=this.n.args,je=process.env),this.W(Le,je,!1)}),s.$7S.handle("vscode:writeNlsFile",(Ee,Se,Le)=>{const je=this.F([Se]);if(!je||typeof Le!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.w.writeFile(je,C.$_d.fromString(Le))}),s.$7S.handle("vscode:readNlsFile",async(Ee,...Se)=>{const Le=this.F(Se);if(!Le)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.w.readFile(Le)).value.toString()}),s.$7S.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),s.$7S.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),s.$7S.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}F(Pe){let Ie;for(const Ee of Pe)typeof Ee=="string"&&(typeof Ie!="string"?Ie=Ee:Ie=(0,w.$hc)(Ie,Ee));if(!(typeof Ie!="string"||!(0,w.$gc)(Ie)||!(0,a.$Vf)(Ie,this.n.cachedLanguagesPath,!$.$k)))return h.URI.file(Ie)}G(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.j.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.j.error(Pe.stack)}async startup(){this.j.debug("Starting VS Code"),this.j.debug(`from: ${this.n.appRoot}`),this.j.debug("args:",this.n.args);const Pe=this.y.win32AppUserModelId;$.$i&&Pe&&S.app.setAppUserModelId(Pe);try{$.$j&&this.t.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Qe){this.j.error(Qe)}const Ie=new t.$bT;this.s.onWillShutdown(Qe=>{Qe.reason===2&&Ie.dispose()}),this.j.trace("Resolving machine identifier...");const Ee=await(0,Et.$x7b)(this.u,this.j);this.j.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcessReady:Se,sharedProcessClient:Le}=this.O(Ee),je=await this.P(Ee,Se);this.B(je.createInstance(r.$05b)),this.B(je.createInstance(vt.$u7b)),je.invokeFunction(Qe=>this.Q(Qe,Ie,Le));const qe=await je.invokeFunction(Qe=>this.H(Qe,Ie));this.I(Ie),this.s.phase=2,await je.invokeFunction(Qe=>this.R(Qe,qe)),this.s.phase=3,this.S(),this.B(new ot.$4g(()=>{this.B((0,ot.$8g)(()=>this.s.phase=4,2500))},2500)).schedule()}async H(Pe,Ie){const Ee=this.b=Pe.get(Fe.$85b),Se=Pe.get(Be.$UT),Le=this.c=Pe.get(G.$G6b),je=Pe.get(I.$i6b),qe=this;Se.registerHandler({async handleURL(Xe,xe){return qe.N(Ee,je,Se,Xe,xe)}});const Ye=this.B(new Ne.$p7b({onDidOpenWindow:Le.onDidOpenWindow,onDidFocusWindow:Le.onDidFocusWindow,getActiveWindowId:()=>Le.getActiveWindowId(-1)})),Qe=new u.$uh(Xe=>Ye.getActiveClientId().then(xe=>Xe===xe)),Ve=new We.$f7b(Qe,this.j),Je=Ie.getChannel("urlHandler",Ve);Se.registerHandler(new We.$e7b(Je));const Ke=await this.J(Ee,je);return this.B(new he.$g7b(Ke?.urls,Se,Ee,this.n,this.y,this.j)),Ke}I(Pe){const Ie=()=>({statusCode:404,data:"Not found"}),Ee=new Dt.$T(()=>Pe.getChannel(lt.$E7b,new lt.$F7b));S.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Se,Le)=>{const je=h.URI.parse(Se.url);if(!je.authority.startsWith("window:"))return Le(Ie());Ee.value.call(lt.$D7b,[je]).then(qe=>Le({...qe,data:Buffer.from(qe.body,"base64")}),qe=>{this.j.warn("error dispatching remote resource call",qe),Le({statusCode:500,data:String(qe)})})})}async J(Pe,Ie){const Ee=this.n.args["open-url"]?this.n.args._urls||[]:[];Ee.length>0&&this.j.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ee);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.j.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Ee.length+Se.length===0)return;const Le=[...Ee,...Se].map(Ye=>{try{return{uri:h.URI.parse(Ye),originalUrl:Ye}}catch{this.j.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ye);return}}),je=[],qe=[];for(const Ye of Le){if(!Ye)continue;if(await this.L(Ye.uri,Pe,Ie)){this.j.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ye.uri.toString(!0));continue}const Qe=this.M(Ye.uri);Qe?(this.j.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ye.uri.toString(!0),Qe),je.push(Qe)):(this.j.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ye.uri.toString(!0)),qe.push(Ye))}return{urls:qe,openables:je}}async L(Pe,Ie,Ee){if(Pe.authority!==y.Schemas.file&&Pe.authority!==y.Schemas.vscodeRemote||this.t.getValue(ut.a[Pe.authority])===!1)return!1;const{response:Le,checkboxChecked:je}=await Ee.showMessageBox({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,Pe.authority===y.Schemas.file?(0,p.$jv)(Pe,{os:$.OS,tildify:this.n}):Pe.toString(!0),this.y.nameShort),detail:(0,i.localize)(3,null),checkboxLabel:(0,i.localize)(4,null),cancelId:1});return Le!==0?!0:(je&&Ie.sendToOpeningWindow("vscode:disablePromptForProtocolHandling",Pe.authority===y.Schemas.file?"local":"remote"),!1)}M(Pe){if(Pe.path){if(Pe.authority===y.Schemas.file){const Ie=h.URI.file(Pe.fsPath);return(0,ze.$fi)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===y.Schemas.vscodeRemote){const Ie=Pe.path.indexOf(w.$ec.sep,1);if(Ie!==-1){const Ee=Pe.path.substring(1,Ie),Se=Pe.path.substring(Ie);let Le=Pe.query;const je=new URLSearchParams(Pe.query);je.get("windowId")==="_blank"&&(je.delete("windowId"),Le=je.toString());const qe=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:Ee,path:Se,query:Le,fragment:Pe.fragment});return(0,ze.$fi)(Se)?{workspaceUri:qe}:/:[\d]+$/.test(Se)?{fileUri:qe}:{folderUri:qe}}}}}async N(Pe,Ie,Ee,Se,Le){if(this.j.trace("app#handleProtocolUrl():",Se.toString(!0),Le),Se.scheme===this.y.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:h.URI.parse(Se.query).path,query:""})),await this.L(Se,Pe,Ie))return this.j.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0;let je=!1;const qe=new URLSearchParams(Se.query);qe.get("windowId")==="_blank"?(this.j.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),qe.delete("windowId"),Se=Se.with({query:qe.toString()}),je=!0):$.$j&&Pe.getWindowCount()===0&&(this.j.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),je=!0);const Ye=qe.get("continueOn");Ye!==null&&(this.j.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),qe.delete("continueOn"),Se=Se.with({query:qe.toString()}),this.n.continueOn=Ye??void 0);const Qe=this.M(Se);return Qe?(this.j.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,Se.toString(!0)),(0,ft.$Mb)(await Pe.open({context:5,cli:{...this.n.args},urisToOpen:[Qe],forceNewWindow:je,gotoLineMode:!0}))?.focus(),!0):je?(this.j.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,ft.$Mb)(await Pe.open({context:5,cli:{...this.n.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.$Qk)(Se)}))?.ready(),Ee.open(Se,Le)):(this.j.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Le),!1)}O(Pe){const Ie=this.B(this.h.createInstance(ue.$46b,Pe)),Ee=(async()=>{this.j.trace("Main->SharedProcess#connect");const Le=await Ie.connect();return this.j.trace("Main->SharedProcess#connect: connection established"),new l.$cT(Le,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),Ee))(),sharedProcessClient:Ee}}async P(Pe,Ie){const Ee=new ie.$Kh;switch(process.platform){case"win32":Ee.set(le.$7T,new H.$Jh(Oe.$c7b));break;case"linux":$.$l?Ee.set(le.$7T,new H.$Jh(Ue.$b7b,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(le.$7T,new H.$Jh(Ce.$a7b));break;case"darwin":Ee.set(le.$7T,new H.$Jh(Ae.$_6b));break}Ee.set(Fe.$85b,new H.$Jh(Me.$o7b,[Pe,this.g],!1));const Se=new I.$j6b(this.j,this.y);Ee.set(I.$i6b,Se),Ee.set(j.$N6b,new H.$Jh(j.$O6b,void 0,!1)),Ee.set(E.$s6b,new H.$Jh(E.$t6b,void 0,!1)),Ee.set(A.$im,u.ProxyChannel.toService((0,u.$sh)(Ie.then(Qe=>Qe.getChannel("diagnostics"))))),Ee.set(oe.$Nwb,new H.$Jh(T.$J6b,[this.g])),Ee.set(M.$OT,new H.$Jh(U.$u6b)),Ee.set(O.$K6b,new H.$Jh(O.$L6b)),Ee.set(G.$G6b,new H.$Jh(G.$H6b,void 0,!1)),Ee.set(me.$h7b,new H.$Jh(ve.$j7b)),Ee.set(z.$W6b,new H.$Jh(z.$X6b)),Ee.set(ae.$v6b,new H.$Jh(ne.$x6b)),Ee.set(pe.$25b,new H.$Jh(pe.$35b)),Ee.set(pe.$45b,new H.$Jh(pe.$55b));const Le=new At.$C7b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.t.getValue("terminal.integrated.persistentSessionScrollback")??100},this.t,this.n,this.s,this.j),je=new Ct.$nr(Le,this.t,this.j,this.m);Ee.set(ct.$1q,je),$.$i?Ee.set(re.$y6b,new H.$Jh(Q.$z6b)):$.$j?Ee.set(re.$y6b,new H.$Jh(Q.$A6b)):$.$k&&Ee.set(re.$y6b,new H.$Jh(Q.$B6b));const qe=new o.$g6b(this.n,this.t,this.j,this.u);Ee.set(n.$b6b,qe);const Ye=new Ze.$o6b(this.n,this.j,this.z,qe,Se);if(Ee.set(Ze.$n6b,Ye),Ee.set(He.$rU,new H.$Jh(tt.$q7b,void 0,!1)),Ee.set(Ge.$T6b,new H.$Jh(Ge.$U6b,void 0,!1)),Ee.set(Be.$UT,new H.$Jh(Z.$WT,void 0,!1)),(0,X.$jo)(this.y,this.n)){const Qe=(0,X.$oo)(this.y,this.t),Ve=(0,u.$sh)(Ie.then(_e=>_e.getChannel("telemetryAppender"))),Je=new $e.$76b(Ve),Ke=(0,Re.$_n)((0,L.release)(),(0,L.hostname)(),process.arch,this.y.commit,this.y.version,Pe,Qe),Xe=(0,X.$po)(this.n),xe={appenders:[Je],commonProperties:Ke,piiPaths:Xe,sendErrorTelemetry:!0};Ee.set(Te.$$k,new H.$Jh(we.$Sq,[xe],!1))}else Ee.set(Te.$$k,X.$do);return Ee.set(bt.$mp,new H.$Jh(St.$sN,void 0,!0)),Ee.set(pt.$qp,new H.$Jh(yt.$t7b,void 0,!0)),Ee.set(at.$A7b,new H.$Jh(at.$B7b,void 0,!0)),await ot.Promises.settled([qe.initialize(),Ye.initialize()]),this.h.createChild(Ee)}Q(Pe,Ie,Ee){const Se=this.B(new d.$Pc),Le=u.ProxyChannel.fromService(Pe.get(j.$N6b),Se,{disableMarshalling:!0});this.f.registerChannel("launch",Le);const je=u.ProxyChannel.fromService(Pe.get(E.$s6b),Se,{disableMarshalling:!0});this.f.registerChannel("diagnostics",je);const qe=new nt.$r7b(Pe.get(it.$_m));Ie.registerChannel("policy",qe),Ee.then(et=>et.registerChannel("policy",qe));const Ye=this.w.getProvider(y.Schemas.file);(0,g.$Gf)(Ye instanceof N.$5p);const Qe=new F.$C6b(Ye,this.j,this.n);Ie.registerChannel(J.$bN,Qe),Ee.then(et=>et.registerChannel(J.$bN,Qe));const Ve=u.ProxyChannel.fromService(Pe.get(rt.$Z5b),Se);Ie.registerChannel("userDataProfiles",Ve),Ee.then(et=>et.registerChannel("userDataProfiles",Ve));const Je=new $t.$Nq(Pe.get(wt.$Ko));Ee.then(et=>et.registerChannel("request",Je));const Ke=new ge.$86b(Pe.get(le.$7T));Ie.registerChannel("update",Ke);const Xe=u.ProxyChannel.fromService(Pe.get(oe.$Nwb),Se);Ie.registerChannel("issue",Xe);const xe=u.ProxyChannel.fromService(Pe.get(M.$OT),Se);Ie.registerChannel("encryption",xe);const _e=u.ProxyChannel.fromService(Pe.get(fe.$Yk),Se);Ie.registerChannel("sign",_e);const st=u.ProxyChannel.fromService(Pe.get(O.$K6b),Se);Ie.registerChannel("keyboardLayout",st),this.c=Pe.get(G.$G6b);const dt=u.ProxyChannel.fromService(this.c,Se);Ie.registerChannel("nativeHost",dt),Ee.then(et=>et.registerChannel("nativeHost",dt));const Ot=u.ProxyChannel.fromService(Pe.get(He.$rU),Se);Ie.registerChannel("workspaces",Ot);const Lt=u.ProxyChannel.fromService(Pe.get(z.$W6b),Se);Ie.registerChannel("menubar",Lt);const Mt=u.ProxyChannel.fromService(Pe.get(Be.$UT),Se);Ie.registerChannel("url",Mt);const jt=u.ProxyChannel.fromService(Pe.get(me.$h7b),Se);Ie.registerChannel("webview",jt);const gt=this.B(new be.$56b(this.j,Pe.get(pe.$25b)));Ie.registerChannel("storage",gt),Ee.then(et=>et.registerChannel("storage",gt));const Ft=this.B(new kt.$v7b(Pe.get(pe.$25b),Pe.get(rt.$Z5b),this.j));Ee.then(et=>et.registerChannel("profileStorageListener",Ft));const Ut=u.ProxyChannel.fromService(Pe.get(ct.$1q),Se);Ie.registerChannel(ct.TerminalIpcChannels.LocalPty,Ut);const Nt=u.ProxyChannel.fromService(Pe.get(re.$y6b),Se);Ie.registerChannel("externalTerminal",Nt);const mt=new Pt.$y7b(Pe.get(It.$Y6b));Ie.registerChannel("logger",mt),Ee.then(et=>et.registerChannel("logger",mt));const Tt=new R.$h6b(Pe.get(Fe.$85b));Ie.registerChannel("extensionhostdebugservice",Tt);const Wt=u.ProxyChannel.fromService(Pe.get(ae.$v6b),Se);Ie.registerChannel(ae.$w6b,Wt);const zt=u.ProxyChannel.fromService(Pe.get(at.$A7b),Se);Ie.registerChannel(Rt.$z7b,zt)}async R(Pe,Ie){const Ee=this.b=Pe.get(Fe.$85b),Se=(0,se.$Il)(process.env)?0:4,Le=this.n.args;if(Ie){if(Ie.openables.length>0)return Ee.open({context:Se,cli:Le,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const _e of Ie.urls){const st=new URLSearchParams(_e.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:st.toString()}),Ee.open({context:Se,cli:Le,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const je=global.macOpenFiles,qe=Le._.length,Ye=!!Le["folder-uri"],Qe=!!Le["file-uri"],Ve=Le["skip-add-to-recently-opened"]===!0,Je=Le.wait&&Le.waitMarkerFilePath?h.URI.file(Le.waitMarkerFilePath):void 0,Ke=Le.remote||void 0,Xe=Le.profile,xe=Le["profile-temp"];if(!qe&&!Ye&&!Qe){if(Le["new-window"]||Xe||xe)return Ee.open({context:Se,cli:Le,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:Je,initialStartup:!0,remoteAuthority:Ke,forceProfile:Xe,forceTempProfile:xe});if(je.length)return Ee.open({context:1,cli:Le,urisToOpen:je.map(_e=>(0,ze.$fi)(_e)?{workspaceUri:h.URI.file(_e)}:{fileUri:h.URI.file(_e)}),noRecentEntry:Ve,waitMarkerFileURI:Je,initialStartup:!0})}return Ee.open({context:Se,cli:Le,forceNewWindow:Le["new-window"]||!qe&&Le["unity-launch"],diffMode:Le.diff,mergeMode:Le.merge,noRecentEntry:Ve,waitMarkerFileURI:Je,gotoLineMode:Le.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:Xe,forceTempProfile:xe})}S(){this.U(),S.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.W(this.n.args,process.env,!0),this.X(),$.$j&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Pe=this.y.win32MutexName;if($.$i&&Pe)try{const Ie=await new Promise((Se,Le)=>{K(["@vscode/windows-mutex"],Se,Le)}),Ee=new Ie.Mutex(Pe);m.Event.once(this.s.onWillShutdown)(()=>Ee.release())}catch(Ie){this.j.error(Ie)}}async W(Pe,Ie,Ee){try{return await(0,x.$Ol)(this.t,this.j,Pe,Ie)}catch(Se){const Le=(0,P.$xi)(Se);Ee?this.b?.sendToFocused("vscode:showResolveShellEnvError",Le):this.j.error(Le)}return{}}async X(){try{const Ie=(await this.w.readFile(this.n.argvResource)).value.toString(),Ee=JSON.parse((0,b.$Vm)(Ie)),Le=(0,X.$lo)(this.t)>=1;if(Ee["enable-crash-reporter"]===void 0){const je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Le},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.$cg)()}"`,"}"],qe=Ie.substring(0,Ie.length-2).concat(`,
`,je.join(`
`));await this.w.writeFile(this.n.argvResource,C.$_d.fromString(qe))}else{const je=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Le},`);je!==Ie&&await this.w.writeFile(this.n.argvResource,C.$_d.fromString(je))}}catch(Pe){this.j.error(Pe)}}};e.$G7b=ht,e.$G7b=ht=ut=ke([_(2,Y.$Lh),_(3,W.$7i),_(4,W.$8i),_(5,B.$R5b),_(6,q.$T5b),_(7,v.$gi),_(8,ye.$lN),_(9,V.$8j),_(10,ce.$mj),_(11,rt.$Z5b)],ht)}),define(ee[311],te([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,305,10,18,236,248,26,63,200,16,220,92,75,216,91,20,223,5,77,24,78,276,126,285,50,284,94,247,34,51,67,52,39,232,230,2,40,264,66,225,115,121,268,262]),function(K,e,S,D,s,L,C,P,f,a,m,b,p,d,y,w,$,g,h,c,k,u,t,l,r,i,n,o,v,R,A,E,I,M,U,B,se,x,ae,ne,re,Q,J,V,F,N,H,Y,ie,oe,T,O,j,q,W,z,G,ce,de,ue,fe,ye,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class pe{main(){try{this.a()}catch($e){console.error($e.message),S.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,we,X,le,ge,Ae,Ce,Ue]=this.b();try{try{await this.d(X,Ue,le,ge,Ce)}catch(Oe){throw this.f(X,Ce,Oe),Oe}await $e.invokeFunction(async Oe=>{const Be=Oe.get(x.$7i),We=Oe.get(B.$T5b),Z=Oe.get(R.$8j),he=Oe.get(x.$8i),me=await this.e(Be,X,We,$e,Ce,!0);return h.Promises.writeFile(X.mainLockfile,String(process.pid)).catch(ve=>{Be.warn(`app#startup(): Error writing main lockfile: ${ve.stack}`)}),Ae.logger=he.createLogger("main",{name:(0,t.localize)(0,null)}),m.Event.once(We.onWillShutdown)(ve=>{Z.dispose(),le.dispose(),ve.join("instanceLockfile",h.Promises.unlink(X.mainLockfile).catch(()=>{}))}),$e.createInstance(u.$G7b,me,we).startup()})}catch(Oe){$e.invokeFunction(this.i,Oe)}}b(){const $e=new U.$Kh,we=new z.$Pc;process.once("exit",()=>we.dispose());const X={_serviceBrand:void 0,...ae.default};$e.set(ne.$mj,X);const le=new n.$S5b(this.j(),X),ge=this.c(le);$e.set(n.$R5b,le);const Ae=new de.$Z6b((0,x.$ij)(le),le.logsHome);$e.set(de.$Y6b,Ae);const Ce=new se.$A3b(Ae.getLogLevel()),Ue=we.add(new ue.$tN(Ce,[new x.$bj(Ae.getLogLevel())]));$e.set(x.$7i,Ue);const Oe=new A.$Fp(Ue);$e.set(R.$8j,Oe);const Be=new E.$5p(Ue);Oe.registerProvider(p.Schemas.file,Be);const We=new ce.$rr(Oe);$e.set(G.$Ek,We);const Z=new ye.$oN(1,le,Ue,Oe);$e.set(ie.$kN,Z),$e.set(ie.$lN,Z);const he=new O.$15b(Z,We,le,Oe,Ue);$e.set(O.$Z5b,he),Oe.registerProvider(p.Schemas.vscodeUserData,new be.$R7b(p.Schemas.file,Be,p.Schemas.vscodeUserData,he,We,Ue));const me=w.$i&&X.win32RegValueName?we.add(new q.$P7b(Ue,X.win32RegValueName)):le.policyFile?we.add(new W.$Q7b(le.policyFile,Oe,Ue)):new j.$bn;$e.set(j.$_m,me);const ve=new r.$Bn(he.defaultProfile.settingsResource,Oe,me,Ue);return $e.set(l.$gi,ve),$e.set(B.$T5b,new I.$Jh(B.$U5b,void 0,!1)),$e.set(F.$Ko,new I.$Jh(N.$N7b,void 0,!0)),$e.set(T.$65b,new I.$Jh(T.$75b)),$e.set(H.$Yk,new I.$Jh(Y.$O7b,void 0,!1)),$e.set(J.$2u,new I.$Jh(V.$L7b)),$e.set(re.$I6b,new Q.$I7b(le,he,Ue)),[new M.$8p($e,!0),ge,le,ve,Z,Ce,X,he]}c($e){const we={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(X=>{const le=process.env[X];typeof le=="string"&&(we[X]=le)}),Object.assign(process.env,we),we}async d($e,we,X,le,ge){await C.Promises.settled([Promise.all([$e.extensionsPath,$e.codeCachePath,$e.logsHome.with({scheme:p.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,$e.backupHome].map(Ae=>Ae?h.Promises.mkdir(Ae,{recursive:!0}):void 0)),le.init(),X.initialize()]),we.init()}async e($e,we,X,le,ge,Ae){let Ce;try{(0,y.mark)("code/willStartMainServer"),Ce=await(0,k.$Hh)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),m.Event.once(X.onWillShutdown)(()=>Ce.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(we,ge,Ue),Ue;let Oe;try{Oe=await(0,k.$Ih)(we.mainIPCHandle,"main")}catch(he){if(!Ae||w.$i||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),he;try{(0,D.unlinkSync)(we.mainIPCHandle)}catch(me){throw $e.warn("Could not delete obsolete instance handle",me),me}return this.e($e,we,X,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw $e.error(he),Oe.dispose(),new Error(he)}let Be;!we.args.wait&&!we.args.status&&(Be=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const We=c.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Z=c.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const he=new i.$yr(oe.$do,ge),me=await Z.getMainDiagnostics(),ve=await Z.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),De=await he.getDiagnostics(me,ve);throw console.log(De),new f.$$});throw w.$i&&await this.h(We,$e),$e.trace("Sending env to running instance..."),await We.start(we.args,process.env),Oe.dispose(),Be&&clearTimeout(Be),new f.$$("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new f.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f($e,we,X){if(X.code==="EACCES"||X.code==="EPERM"){const le=(0,L.$Fb)([$e.userDataPath,$e.extensionsPath,k.$Dh]).map(ge=>(0,b.$jv)(s.URI.file(ge),{os:w.OS,tildify:$e}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.$xi)(X),le.join(`
`)),we)}}g($e,we,X){S.dialog.showMessageBoxSync((0,fe.$xv)({type:"warning",buttons:[(0,t.localize)(8,null)],message:$e,detail:we},X).options)}async h($e,we){if(w.$i){const X=await $e.getMainProcessId();we.trace("Sending some foreground love to the running instance:",X);try{(await new Promise((le,ge)=>{K(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(X)}catch(le){we.error(le)}}}i($e,we){const X=$e.get(x.$7i),le=$e.get(B.$T5b);let ge=0;we&&(we.isExpected?we.message&&X.trace(we.message):(ge=1,we.stack?X.error(we.stack):X.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const $e=this.k((0,o.$Fl)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const we=(0,v.$H7b)($e.verbose);we&&((0,o.$Hl)(process.argv,"--waitMarkerFilePath",we),$e.waitMarkerFilePath=we)}return $e}k($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const we=this.l($e._,$e.goto);$e._=we}return $e}l($e,we){const X=(0,$.cwd)(),le=$e.map(Ce=>{let Ue=String(Ce),Oe;we&&(Oe=(0,a.$3f)(Ue),Ue=Oe.path),Ue&&(Ue=this.m(X,Ue));const Be=(0,a.$Xf)(Ue,X),We=(0,d.$lc)(Be);return We&&!(0,a.$Tf)(We)?null:we&&Oe?(Oe.path=Be,this.n(Oe)):Be}),ge=w.$i||w.$j,Ae=(0,L.$Kb)(le,Ce=>Ce&&ge?Ce.toLowerCase():Ce||"");return(0,L.$Fb)(Ae)}m($e,we){return w.$i&&(we=(0,g.$Ie)(we,'"')),we=(0,g.$Ge)((0,g.$Ge)(we," "),"	"),w.$i&&(we=(0,d.$ic)($e,we),we=(0,g.$Ie)(we,".")),we}n($e){const we=[$e.path];return typeof $e.line=="number"&&we.push(String($e.line)),typeof $e.column=="number"&&we.push(String($e.column)),we.join(":")}}new pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4a0e77678c0295b518151ae2d706436bab96ef4f/core/vs/code/electron-main/main.js.map
