/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/lazy","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(oe){for(var t=[],y=0,N=oe.length;y<N;y++)t[y]=be[oe[y]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:jt,setPrototypeOf:zt,isFrozen:Xt,getPrototypeOf:Zt,getOwnPropertyDescriptor:Jt}=Object;let{freeze:it,seal:at,create:ei}=Object,{apply:Nt,construct:Pt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,y,N){return t.apply(y,N)}),it||(it=function(t){return t}),at||(at=function(t){return t}),Pt||(Pt=function(t,y){return new t(...y)});const ti=rt(Array.prototype.forEach),Ht=rt(Array.prototype.pop),bt=rt(Array.prototype.push),wt=rt(String.prototype.toLowerCase),Ot=rt(String.prototype.toString),ii=rt(String.prototype.match),ht=rt(String.prototype.replace),ni=rt(String.prototype.indexOf),si=rt(String.prototype.trim),st=rt(RegExp.prototype.test),$t=ri(TypeError);function rt(oe){return function(t){for(var y=arguments.length,N=new Array(y>1?y-1:0),i=1;i<y;i++)N[i-1]=arguments[i];return Nt(oe,t,N)}}function ri(oe){return function(){for(var t=arguments.length,y=new Array(t),N=0;N<t;N++)y[N]=arguments[N];return Pt(oe,y)}}function Be(oe,t,y){var N;y=(N=y)!==null&&N!==void 0?N:wt,zt&&zt(oe,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const w=y(U);w!==U&&(Xt(t)||(t[i]=w),U=w)}oe[U]=!0}return oe}function gt(oe){const t=ei(null);for(const[y,N]of jt(oe))t[y]=N;return t}function vt(oe,t){for(;oe!==null;){const N=Jt(oe,t);if(N){if(N.get)return rt(N.get);if(typeof N.value=="function")return rt(N.value)}oe=Zt(oe)}function y(N){return console.warn("fallback value for",N),null}return y}const Ut=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Tt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),oi=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),li=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=it(["#text"]),_t=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ai=at(/\{\{[\w\W]*|[\w\W]*\}\}/gm),hi=at(/<%[\w\W]*|[\w\W]*%>/gm),ui=at(/\${[\w\W]*}/gm),ci=at(/^data-[\-\w.\u00B7-\uFFFF]/),fi=at(/^aria-[\-\w]+$/),Vt=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),di=at(/^(?:\w+script|data):/i),gi=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Kt=at(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:ai,ERB_EXPR:hi,TMPLIT_EXPR:ui,DATA_ATTR:ci,ARIA_ATTR:fi,IS_ALLOWED_URI:Vt,IS_SCRIPT_OR_DATA:di,ATTR_WHITESPACE:gi,DOCTYPE_NAME:Kt});const mi=()=>typeof window>"u"?null:window,bi=function(t,y){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let N=null;const i="data-tt-policy-suffix";y&&y.hasAttribute(i)&&(N=y.getAttribute(i));const U="dompurify"+(N?"#"+N:"");try{return t.createPolicy(U,{createHTML(w){return w},createScriptURL(w){return w}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function Qt(){let oe=arguments.length>0&&arguments[0]!==void 0?arguments[0]:mi();const t=Te=>Qt(Te);if(t.version="3.0.5",t.removed=[],!oe||!oe.document||oe.document.nodeType!==9)return t.isSupported=!1,t;const y=oe.document,N=y.currentScript;let{document:i}=oe;const{DocumentFragment:U,HTMLTemplateElement:w,Node:D,Element:h,NodeFilter:f,NamedNodeMap:d=oe.NamedNodeMap||oe.MozNamedAttrMap,HTMLFormElement:L,DOMParser:s,trustedTypes:a}=oe,e=h.prototype,u=vt(e,"cloneNode"),l=vt(e,"nextSibling"),m=vt(e,"childNodes"),n=vt(e,"parentNode");if(typeof w=="function"){const Te=i.createElement("template");Te.content&&Te.content.ownerDocument&&(i=Te.content.ownerDocument)}let r,$="";const{implementation:c,createNodeIterator:o,createDocumentFragment:C,getElementsByTagName:R}=i,{importNode:M}=y;let b={};t.isSupported=typeof jt=="function"&&typeof n=="function"&&c&&c.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:j,TMPLIT_EXPR:z,DATA_ATTR:W,ARIA_ATTR:I,IS_SCRIPT_OR_DATA:F,ATTR_WHITESPACE:X}=xt;let{IS_ALLOWED_URI:te}=xt,re=null;const ce=Be({},[...Ut,...Lt,...Tt,...It,...Wt]);let le=null;const ae=Be({},[..._t,...Mt,...qt,...Dt]);let me=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),ke=null,Le=null,Pe=!0,de=!0,ne=!1,Q=!0,V=!1,ee=!1,J=!1,k=!1,K=!1,g=!1,p=!1,q=!0,T=!1;const P="user-content-";let O=!0,_=!1,S={},B=null;const E=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let A=null;const H=Be({},["audio","video","img","source","image","track"]);let x=null;const ie=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml";let Fe=we,Ae=!1,ve=null;const Ie=Be({},[se,ge,we],Ot);let Oe;const qe=["application/xhtml+xml","text/html"],je="text/html";let Me,Ge=null;const Z=i.createElement("form"),he=function(fe){return fe instanceof RegExp||fe instanceof Function},pe=function(fe){if(!(Ge&&Ge===fe)){if((!fe||typeof fe!="object")&&(fe={}),fe=gt(fe),Oe=qe.indexOf(fe.PARSER_MEDIA_TYPE)===-1?Oe=je:Oe=fe.PARSER_MEDIA_TYPE,Me=Oe==="application/xhtml+xml"?Ot:wt,re="ALLOWED_TAGS"in fe?Be({},fe.ALLOWED_TAGS,Me):ce,le="ALLOWED_ATTR"in fe?Be({},fe.ALLOWED_ATTR,Me):ae,ve="ALLOWED_NAMESPACES"in fe?Be({},fe.ALLOWED_NAMESPACES,Ot):Ie,x="ADD_URI_SAFE_ATTR"in fe?Be(gt(ie),fe.ADD_URI_SAFE_ATTR,Me):ie,A="ADD_DATA_URI_TAGS"in fe?Be(gt(H),fe.ADD_DATA_URI_TAGS,Me):H,B="FORBID_CONTENTS"in fe?Be({},fe.FORBID_CONTENTS,Me):E,ke="FORBID_TAGS"in fe?Be({},fe.FORBID_TAGS,Me):{},Le="FORBID_ATTR"in fe?Be({},fe.FORBID_ATTR,Me):{},S="USE_PROFILES"in fe?fe.USE_PROFILES:!1,Pe=fe.ALLOW_ARIA_ATTR!==!1,de=fe.ALLOW_DATA_ATTR!==!1,ne=fe.ALLOW_UNKNOWN_PROTOCOLS||!1,Q=fe.ALLOW_SELF_CLOSE_IN_ATTR!==!1,V=fe.SAFE_FOR_TEMPLATES||!1,ee=fe.WHOLE_DOCUMENT||!1,K=fe.RETURN_DOM||!1,g=fe.RETURN_DOM_FRAGMENT||!1,p=fe.RETURN_TRUSTED_TYPE||!1,k=fe.FORCE_BODY||!1,q=fe.SANITIZE_DOM!==!1,T=fe.SANITIZE_NAMED_PROPS||!1,O=fe.KEEP_CONTENT!==!1,_=fe.IN_PLACE||!1,te=fe.ALLOWED_URI_REGEXP||Vt,Fe=fe.NAMESPACE||we,me=fe.CUSTOM_ELEMENT_HANDLING||{},fe.CUSTOM_ELEMENT_HANDLING&&he(fe.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(me.tagNameCheck=fe.CUSTOM_ELEMENT_HANDLING.tagNameCheck),fe.CUSTOM_ELEMENT_HANDLING&&he(fe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(me.attributeNameCheck=fe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),fe.CUSTOM_ELEMENT_HANDLING&&typeof fe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(me.allowCustomizedBuiltInElements=fe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),V&&(de=!1),g&&(K=!0),S&&(re=Be({},[...Wt]),le=[],S.html===!0&&(Be(re,Ut),Be(le,_t)),S.svg===!0&&(Be(re,Lt),Be(le,Mt),Be(le,Dt)),S.svgFilters===!0&&(Be(re,Tt),Be(le,Mt),Be(le,Dt)),S.mathMl===!0&&(Be(re,It),Be(le,qt),Be(le,Dt))),fe.ADD_TAGS&&(re===ce&&(re=gt(re)),Be(re,fe.ADD_TAGS,Me)),fe.ADD_ATTR&&(le===ae&&(le=gt(le)),Be(le,fe.ADD_ATTR,Me)),fe.ADD_URI_SAFE_ATTR&&Be(x,fe.ADD_URI_SAFE_ATTR,Me),fe.FORBID_CONTENTS&&(B===E&&(B=gt(B)),Be(B,fe.FORBID_CONTENTS,Me)),O&&(re["#text"]=!0),ee&&Be(re,["html","head","body"]),re.table&&(Be(re,["tbody"]),delete ke.tbody),fe.TRUSTED_TYPES_POLICY){if(typeof fe.TRUSTED_TYPES_POLICY.createHTML!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof fe.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=fe.TRUSTED_TYPES_POLICY,$=r.createHTML("")}else r===void 0&&(r=bi(a,N)),r!==null&&typeof $=="string"&&($=r.createHTML(""));it&&it(fe),Ge=fe}},De=Be({},["mi","mo","mn","ms","mtext"]),Ce=Be({},["foreignobject","desc","title","annotation-xml"]),Re=Be({},["title","style","font","a","script"]),ze=Be({},Lt);Be(ze,Tt),Be(ze,oi);const Ke=Be({},It);Be(Ke,li);const Ye=function(fe){let ye=n(fe);(!ye||!ye.tagName)&&(ye={namespaceURI:Fe,tagName:"template"});const Ne=wt(fe.tagName),We=wt(ye.tagName);return ve[fe.namespaceURI]?fe.namespaceURI===ge?ye.namespaceURI===we?Ne==="svg":ye.namespaceURI===se?Ne==="svg"&&(We==="annotation-xml"||De[We]):!!ze[Ne]:fe.namespaceURI===se?ye.namespaceURI===we?Ne==="math":ye.namespaceURI===ge?Ne==="math"&&Ce[We]:!!Ke[Ne]:fe.namespaceURI===we?ye.namespaceURI===ge&&!Ce[We]||ye.namespaceURI===se&&!De[We]?!1:!Ke[Ne]&&(Re[Ne]||!ze[Ne]):!!(Oe==="application/xhtml+xml"&&ve[fe.namespaceURI]):!1},Ve=function(fe){bt(t.removed,{element:fe});try{fe.parentNode.removeChild(fe)}catch{fe.remove()}},_e=function(fe,ye){try{bt(t.removed,{attribute:ye.getAttributeNode(fe),from:ye})}catch{bt(t.removed,{attribute:null,from:ye})}if(ye.removeAttribute(fe),fe==="is"&&!le[fe])if(K||g)try{Ve(ye)}catch{}else try{ye.setAttribute(fe,"")}catch{}},et=function(fe){let ye,Ne;if(k)fe="<remove></remove>"+fe;else{const nt=ii(fe,/^[\r\n\t ]+/);Ne=nt&&nt[0]}Oe==="application/xhtml+xml"&&Fe===we&&(fe='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+fe+"</body></html>");const We=r?r.createHTML(fe):fe;if(Fe===we)try{ye=new s().parseFromString(We,Oe)}catch{}if(!ye||!ye.documentElement){ye=c.createDocument(Fe,"template",null);try{ye.documentElement.innerHTML=Ae?$:We}catch{}}const Ze=ye.body||ye.documentElement;return fe&&Ne&&Ze.insertBefore(i.createTextNode(Ne),Ze.childNodes[0]||null),Fe===we?R.call(ye,ee?"html":"body")[0]:ee?ye.documentElement:Ze},tt=function(fe){return o.call(fe.ownerDocument||fe,fe,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},ft=function(fe){return fe instanceof L&&(typeof fe.nodeName!="string"||typeof fe.textContent!="string"||typeof fe.removeChild!="function"||!(fe.attributes instanceof d)||typeof fe.removeAttribute!="function"||typeof fe.setAttribute!="function"||typeof fe.namespaceURI!="string"||typeof fe.insertBefore!="function"||typeof fe.hasChildNodes!="function")},ct=function(fe){return typeof D=="object"?fe instanceof D:fe&&typeof fe=="object"&&typeof fe.nodeType=="number"&&typeof fe.nodeName=="string"},ut=function(fe,ye,Ne){b[fe]&&ti(b[fe],We=>{We.call(t,ye,Ne,Ge)})},yt=function(fe){let ye;if(ut("beforeSanitizeElements",fe,null),ft(fe))return Ve(fe),!0;const Ne=Me(fe.nodeName);if(ut("uponSanitizeElement",fe,{tagName:Ne,allowedTags:re}),fe.hasChildNodes()&&!ct(fe.firstElementChild)&&(!ct(fe.content)||!ct(fe.content.firstElementChild))&&st(/<[/\w]/g,fe.innerHTML)&&st(/<[/\w]/g,fe.textContent))return Ve(fe),!0;if(!re[Ne]||ke[Ne]){if(!ke[Ne]&&At(Ne)&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,Ne)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Ne)))return!1;if(O&&!B[Ne]){const We=n(fe)||fe.parentNode,Ze=m(fe)||fe.childNodes;if(Ze&&We){const nt=Ze.length;for(let xe=nt-1;xe>=0;--xe)We.insertBefore(u(Ze[xe],!0),l(fe))}}return Ve(fe),!0}return fe instanceof h&&!Ye(fe)||(Ne==="noscript"||Ne==="noembed"||Ne==="noframes")&&st(/<\/no(script|embed|frames)/i,fe.innerHTML)?(Ve(fe),!0):(V&&fe.nodeType===3&&(ye=fe.textContent,ye=ht(ye,v," "),ye=ht(ye,j," "),ye=ht(ye,z," "),fe.textContent!==ye&&(bt(t.removed,{element:fe.cloneNode()}),fe.textContent=ye)),ut("afterSanitizeElements",fe,null),!1)},Et=function(fe,ye,Ne){if(q&&(ye==="id"||ye==="name")&&(Ne in i||Ne in Z))return!1;if(!(de&&!Le[ye]&&st(W,ye))){if(!(Pe&&st(I,ye))){if(!le[ye]||Le[ye]){if(!(At(fe)&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,fe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(fe))&&(me.attributeNameCheck instanceof RegExp&&st(me.attributeNameCheck,ye)||me.attributeNameCheck instanceof Function&&me.attributeNameCheck(ye))||ye==="is"&&me.allowCustomizedBuiltInElements&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,Ne)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Ne))))return!1}else if(!x[ye]){if(!st(te,ht(Ne,X,""))){if(!((ye==="src"||ye==="xlink:href"||ye==="href")&&fe!=="script"&&ni(Ne,"data:")===0&&A[fe])){if(!(ne&&!st(F,ht(Ne,X,"")))){if(Ne)return!1}}}}}}return!0},At=function(fe){return fe.indexOf("-")>0},kt=function(fe){let ye,Ne,We,Ze;ut("beforeSanitizeAttributes",fe,null);const{attributes:nt}=fe;if(!nt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(Ze=nt.length;Ze--;){ye=nt[Ze];const{name:ot,namespaceURI:dt}=ye;if(Ne=ot==="value"?ye.value:si(ye.value),We=Me(ot),xe.attrName=We,xe.attrValue=Ne,xe.keepAttr=!0,xe.forceKeepAttr=void 0,ut("uponSanitizeAttribute",fe,xe),Ne=xe.attrValue,xe.forceKeepAttr||(_e(ot,fe),!xe.keepAttr))continue;if(!Q&&st(/\/>/i,Ne)){_e(ot,fe);continue}V&&(Ne=ht(Ne,v," "),Ne=ht(Ne,j," "),Ne=ht(Ne,z," "));const Ct=Me(fe.nodeName);if(Et(Ct,We,Ne)){if(T&&(We==="id"||We==="name")&&(_e(ot,fe),Ne=P+Ne),r&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!dt)switch(a.getAttributeType(Ct,We)){case"TrustedHTML":{Ne=r.createHTML(Ne);break}case"TrustedScriptURL":{Ne=r.createScriptURL(Ne);break}}try{dt?fe.setAttributeNS(dt,ot,Ne):fe.setAttribute(ot,Ne),Ht(t.removed)}catch{}}}ut("afterSanitizeAttributes",fe,null)},St=function Te(fe){let ye;const Ne=tt(fe);for(ut("beforeSanitizeShadowDOM",fe,null);ye=Ne.nextNode();)ut("uponSanitizeShadowNode",ye,null),!yt(ye)&&(ye.content instanceof U&&Te(ye.content),kt(ye));ut("afterSanitizeShadowDOM",fe,null)};return t.sanitize=function(Te){let fe=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ye,Ne,We,Ze;if(Ae=!Te,Ae&&(Te="<!-->"),typeof Te!="string"&&!ct(Te))if(typeof Te.toString=="function"){if(Te=Te.toString(),typeof Te!="string")throw $t("dirty is not a string, aborting")}else throw $t("toString is not a function");if(!t.isSupported)return Te;if(J||pe(fe),t.removed=[],typeof Te=="string"&&(_=!1),_){if(Te.nodeName){const ot=Me(Te.nodeName);if(!re[ot]||ke[ot])throw $t("root node is forbidden and cannot be sanitized in-place")}}else if(Te instanceof D)ye=et("<!---->"),Ne=ye.ownerDocument.importNode(Te,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?ye=Ne:ye.appendChild(Ne);else{if(!K&&!V&&!ee&&Te.indexOf("<")===-1)return r&&p?r.createHTML(Te):Te;if(ye=et(Te),!ye)return K?null:p?$:""}ye&&k&&Ve(ye.firstChild);const nt=tt(_?Te:ye);for(;We=nt.nextNode();)yt(We)||(We.content instanceof U&&St(We.content),kt(We));if(_)return Te;if(K){if(g)for(Ze=C.call(ye.ownerDocument);ye.firstChild;)Ze.appendChild(ye.firstChild);else Ze=ye;return(le.shadowroot||le.shadowrootmode)&&(Ze=M.call(y,Ze,!0)),Ze}let xe=ee?ye.outerHTML:ye.innerHTML;return ee&&re["!doctype"]&&ye.ownerDocument&&ye.ownerDocument.doctype&&ye.ownerDocument.doctype.name&&st(Kt,ye.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+ye.ownerDocument.doctype.name+`>
`+xe),V&&(xe=ht(xe,v," "),xe=ht(xe,j," "),xe=ht(xe,z," ")),r&&p?r.createHTML(xe):xe},t.setConfig=function(Te){pe(Te),J=!0},t.clearConfig=function(){Ge=null,J=!1},t.isValidAttribute=function(Te,fe,ye){Ge||pe({});const Ne=Me(Te),We=Me(fe);return Et(Ne,We,ye)},t.addHook=function(Te,fe){typeof fe=="function"&&(b[Te]=b[Te]||[],bt(b[Te],fe))},t.removeHook=function(Te){if(b[Te])return Ht(b[Te])},t.removeHooks=function(Te){b[Te]&&(b[Te]=[])},t.removeAllHooks=function(){b={}},t}var $i=Qt();define("vs/base/browser/dompurify/dompurify",function(){return $i}),define(be[40],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SP=t.$RP=void 0;class y{constructor(w){this.domNode=w,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(w){const D=N(w);this.a!==D&&(this.a=D,this.domNode.style.maxWidth=this.a)}setWidth(w){const D=N(w);this.b!==D&&(this.b=D,this.domNode.style.width=this.b)}setHeight(w){const D=N(w);this.c!==D&&(this.c=D,this.domNode.style.height=this.c)}setTop(w){const D=N(w);this.d!==D&&(this.d=D,this.domNode.style.top=this.d)}setLeft(w){const D=N(w);this.e!==D&&(this.e=D,this.domNode.style.left=this.e)}setBottom(w){const D=N(w);this.f!==D&&(this.f=D,this.domNode.style.bottom=this.f)}setRight(w){const D=N(w);this.g!==D&&(this.g=D,this.domNode.style.right=this.g)}setPaddingTop(w){const D=N(w);this.h!==D&&(this.h=D,this.domNode.style.paddingTop=this.h)}setPaddingLeft(w){const D=N(w);this.i!==D&&(this.i=D,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(w){const D=N(w);this.j!==D&&(this.j=D,this.domNode.style.paddingBottom=this.j)}setPaddingRight(w){const D=N(w);this.k!==D&&(this.k=D,this.domNode.style.paddingRight=this.k)}setFontFamily(w){this.l!==w&&(this.l=w,this.domNode.style.fontFamily=this.l)}setFontWeight(w){this.m!==w&&(this.m=w,this.domNode.style.fontWeight=this.m)}setFontSize(w){const D=N(w);this.n!==D&&(this.n=D,this.domNode.style.fontSize=this.n)}setFontStyle(w){this.o!==w&&(this.o=w,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(w){this.p!==w&&(this.p=w,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(w){this.q!==w&&(this.q=w,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(w){this.r!==w&&(this.r=w,this.domNode.style.textDecoration=this.r)}setLineHeight(w){const D=N(w);this.s!==D&&(this.s=D,this.domNode.style.lineHeight=this.s)}setLetterSpacing(w){const D=N(w);this.t!==D&&(this.t=D,this.domNode.style.letterSpacing=this.t)}setClassName(w){this.u!==w&&(this.u=w,this.domNode.className=this.u)}toggleClassName(w,D){this.domNode.classList.toggle(w,D),this.u=this.domNode.className}setDisplay(w){this.v!==w&&(this.v=w,this.domNode.style.display=this.v)}setPosition(w){this.w!==w&&(this.w=w,this.domNode.style.position=this.w)}setVisibility(w){this.x!==w&&(this.x=w,this.domNode.style.visibility=this.x)}setColor(w){this.y!==w&&(this.y=w,this.domNode.style.color=this.y)}setBackgroundColor(w){this.z!==w&&(this.z=w,this.domNode.style.backgroundColor=this.z)}setLayerHinting(w){this.A!==w&&(this.A=w,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this.C!==w&&(this.C=w,this.domNode.style.boxShadow=w)}setContain(w){this.B!==w&&(this.B=w,this.domNode.style.contain=this.B)}setAttribute(w,D){this.domNode.setAttribute(w,D)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.$RP=y;function N(U){return typeof U=="number"?`${U}px`:U}function i(U){return new y(U)}t.$SP=i}),define(be[67],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kO=t.$jO=void 0;let y=!1,N=null;function i(h){if(!h.parent||h.parent===h)return null;try{const f=h.location,d=h.parent.location;if(f.origin!=="null"&&d.origin!=="null"&&f.origin!==d.origin)return y=!0,null}catch{return y=!0,null}return h.parent}class U{static getSameOriginWindowChain(){if(!N){N=[];let f=window,d;do d=i(f),d?N.push({window:f,iframeElement:f.frameElement||null}):N.push({window:f,iframeElement:null}),f=d;while(f)}return N.slice(0)}static hasDifferentOriginAncestor(){return N||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(f,d){if(!d||f===d)return{top:0,left:0};let L=0,s=0;const a=this.getSameOriginWindowChain();for(const e of a){if(L+=e.window.scrollY,s+=e.window.scrollX,e.window===d||!e.iframeElement)break;const u=e.iframeElement.getBoundingClientRect();L+=u.top,s+=u.left}return{top:L,left:s}}}t.$jO=U;async function w(h,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const d=JSON.stringify({parentOrigin:h,salt:f}),s=new TextEncoder().encode(d),a=await crypto.subtle.digest("sha-256",s);return D(a)}t.$kO=w;function D(h){const d=Array.from(new Uint8Array(h)).map(L=>L.toString(16).padStart(2,"0")).join("");return BigInt(`0x${d}`).toString(32).padStart(52,"0")}}),define(be[68],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pQ=t.$oQ=t.$nQ=t.ListDragOverEffect=void 0;var y;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.$nQ={reject(){return{accept:!1}},accept(){return{accept:!0}}};class N extends Error{constructor(w,D){super(`ListError [${w}] ${D}`)}}t.$oQ=N;class i{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,D){D>0&&this.c.set(w,D)}}t.$pQ=i}),define(be[69],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mQ=void 0;class y{constructor(i){this.a=i}splice(i,U,w){this.a.forEach(D=>D.splice(i,U,w))}}t.$mQ=y}),define(be[41],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XP=void 0;const y=20;class N{constructor(U,w,D,h,f,d){this.a=Math.round(w),this.b=Math.round(D),this.c=Math.round(U),this.d=h,this.e=f,this.f=d,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new N(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const w=Math.round(U);return this.d!==w?(this.d=w,this.m(),!0):!1}setScrollSize(U){const w=Math.round(U);return this.e!==w?(this.e=w,this.m(),!0):!1}setScrollPosition(U){const w=Math.round(U);return this.f!==w?(this.f=w,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,w,D,h,f){const d=Math.max(0,D-U),L=Math.max(0,d-2*w),s=h>0&&h>D;if(!s)return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(y,Math.floor(D*L/h))),e=(L-a)/(h-D),u=f*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(u)}}m(){const U=N.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const w=U-this.c-this.i/2;return Math.round(w/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const w=U-this.c;let D=this.f;return w<this.k?D-=this.d:D+=this.d,D}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const w=this.k+U;return Math.round(w/this.j)}}t.$XP=N}),define(be[24],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jS=t.$iS=t.$hS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(h){h[h.Hidden=0]="Hidden",h[h.Visible=1]="Visible",h[h.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var N;(function(h){h[h.Expanded=0]="Expanded",h[h.Collapsed=1]="Collapsed",h[h.PreserveOrExpanded=2]="PreserveOrExpanded",h[h.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(t.ObjectTreeElementCollapseState=N={}));var i;(function(h){h[h.Unknown=0]="Unknown",h[h.Twistie=1]="Twistie",h[h.Element=2]="Element",h[h.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(h){h[h.Down=0]="Down",h[h.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$hS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(h=!1){return{accept:!0,bubble:0,autoExpand:h}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(h=!1){return{accept:!0,bubble:0,effect:0,autoExpand:h}}};class w extends Error{constructor(f,d){super(`TreeError [${f}] ${d}`)}}t.$iS=w;class D{constructor(f){this.a=f,this.b=new WeakMap}map(f){let d=this.b.get(f);return d||(d=this.a(f),this.b.set(f,d)),d}}t.$jS=D}),define(be[70],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;function y(u,l,m){const n=N(u,l);if(n!==-1)return u[n]}t.$db=y;function N(u,l,m=u.length-1){for(let n=m;n>=0;n--){const r=u[n];if(l(r))return n}return-1}t.$eb=N;function i(u,l){const m=U(u,l);return m===-1?void 0:u[m]}t.$fb=i;function U(u,l,m=0,n=u.length){let r=m,$=n;for(;r<$;){const c=Math.floor((r+$)/2);l(u[c])?r=c+1:$=c}return r-1}t.$gb=U;function w(u,l){const m=D(u,l);return m===u.length?void 0:u[m]}t.$hb=w;function D(u,l,m=0,n=u.length){let r=m,$=n;for(;r<$;){const c=Math.floor((r+$)/2);l(u[c])?$=c:r=c+1}return r}t.$ib=D;function h(u,l,m=0,n=u.length){const r=D(u,l,m,n);return r===u.length?-1:r}t.$jb=h;class f{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(f.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const m=U(this.e,l,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$kb=f;function d(u,l){if(u.length===0)return;let m=u[0];for(let n=1;n<u.length;n++){const r=u[n];l(r,m)>0&&(m=r)}return m}t.$lb=d;function L(u,l){if(u.length===0)return;let m=u[0];for(let n=1;n<u.length;n++){const r=u[n];l(r,m)>=0&&(m=r)}return m}t.$mb=L;function s(u,l){return d(u,(m,n)=>-l(m,n))}t.$nb=s;function a(u,l){if(u.length===0)return-1;let m=0;for(let n=1;n<u.length;n++){const r=u[n];l(r,u[m])>0&&(m=n)}return m}t.$ob=a;function e(u,l){for(const m of u){const n=l(m);if(n!==void 0)return n}}t.$pb=e}),define(be[71],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function y(w,D){const h=Object.create(null);for(const f of w){const d=D(f);let L=h[d];L||(L=h[d]=[]),L.push(f)}return h}t.$I=y;function N(w,D){const h=[],f=[];for(const d of w)D.has(d)||h.push(d);for(const d of D)w.has(d)||f.push(d);return{removed:h,added:f}}t.$J=N;function i(w,D){const h=[],f=[];for(const[d,L]of w)D.has(d)||h.push(L);for(const[d,L]of D)w.has(d)||f.push(L);return{removed:h,added:f}}t.$K=i;function U(w,D){const h=new Set;for(const f of D)w.has(f)&&h.add(f);return h}t.$L=U}),define(be[72],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qs=t.$Ps=t.$Os=t.$Ns=void 0;function y(D,h){const f=Math.pow(10,h);return Math.round(D*f)/f}class N{constructor(h,f,d,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=y(Math.max(Math.min(1,L),0),3)}static equals(h,f){return h.r===f.r&&h.g===f.g&&h.b===f.b&&h.a===f.a}}t.$Ns=N;class i{constructor(h,f,d,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=y(Math.max(Math.min(1,f),0),3),this.l=y(Math.max(Math.min(1,d),0),3),this.a=y(Math.max(Math.min(1,L),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.l===f.l&&h.a===f.a}static fromRGBA(h){const f=h.r/255,d=h.g/255,L=h.b/255,s=h.a,a=Math.max(f,d,L),e=Math.min(f,d,L);let u=0,l=0;const m=(e+a)/2,n=a-e;if(n>0){switch(l=Math.min(m<=.5?n/(2*m):n/(2-2*m),1),a){case f:u=(d-L)/n+(d<L?6:0);break;case d:u=(L-f)/n+2;break;case L:u=(f-d)/n+4;break}u*=60,u=Math.round(u)}return new i(u,l,m,s)}static i(h,f,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?h+(f-h)*6*d:d<1/2?f:d<2/3?h+(f-h)*(2/3-d)*6:h}static toRGBA(h){const f=h.h/360,{s:d,l:L,a:s}=h;let a,e,u;if(d===0)a=e=u=L;else{const l=L<.5?L*(1+d):L+d-L*d,m=2*L-l;a=i.i(m,l,f+1/3),e=i.i(m,l,f),u=i.i(m,l,f-1/3)}return new N(Math.round(a*255),Math.round(e*255),Math.round(u*255),s)}}t.$Os=i;class U{constructor(h,f,d,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=y(Math.max(Math.min(1,f),0),3),this.v=y(Math.max(Math.min(1,d),0),3),this.a=y(Math.max(Math.min(1,L),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.v===f.v&&h.a===f.a}static fromRGBA(h){const f=h.r/255,d=h.g/255,L=h.b/255,s=Math.max(f,d,L),a=Math.min(f,d,L),e=s-a,u=s===0?0:e/s;let l;return e===0?l=0:s===f?l=((d-L)/e%6+6)%6:s===d?l=(L-f)/e+2:l=(f-d)/e+4,new U(Math.round(l*60),u,s,h.a)}static toRGBA(h){const{h:f,s:d,v:L,a:s}=h,a=L*d,e=a*(1-Math.abs(f/60%2-1)),u=L-a;let[l,m,n]=[0,0,0];return f<60?(l=a,m=e):f<120?(l=e,m=a):f<180?(m=a,n=e):f<240?(m=e,n=a):f<300?(l=e,n=a):f<=360&&(l=a,n=e),l=Math.round((l+u)*255),m=Math.round((m+u)*255),n=Math.round((n+u)*255),new N(l,m,n,s)}}t.$Ps=U;class w{static fromHex(h){return w.Format.CSS.parseHex(h)||w.red}static equals(h,f){return!h&&!f?!0:!h||!f?!1:h.equals(f)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof N)this.rgba=h;else if(h instanceof i)this.i=h,this.rgba=i.toRGBA(h);else if(h instanceof U)this.j=h,this.rgba=U.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&N.equals(this.rgba,h.rgba)&&i.equals(this.hsla,h.hsla)&&U.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=w.k(this.rgba.r),f=w.k(this.rgba.g),d=w.k(this.rgba.b),L=.2126*h+.7152*f+.0722*d;return y(L,4)}static k(h){const f=h/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f>d?(f+.05)/(d+.05):(d+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f>d}isDarkerThan(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f<d}lighten(h){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:f,g:d,b:L,a:s}=this.rgba;return new w(new N(f,d,L,s*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const f=h.rgba,d=this.rgba.a,L=f.a,s=d+L*(1-d);if(s<1e-6)return w.transparent;const a=this.rgba.r*d/s+f.r*L*(1-d)/s,e=this.rgba.g*d/s+f.g*L*(1-d)/s,u=this.rgba.b*d/s+f.b*L*(1-d)/s;return new w(new N(a,e,u,s))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:f,g:d,b:L,a:s}=this.rgba;return new w(new N(h.rgba.r-s*(h.rgba.r-f),h.rgba.g-s*(h.rgba.g-d),h.rgba.b-s*(h.rgba.b-L),1))}flatten(...h){const f=h.reduceRight((d,L)=>w.o(L,d));return w.o(this,f)}static o(h,f){const d=1-h.rgba.a;return new w(new N(d*f.rgba.r+h.rgba.a*h.rgba.r,d*f.rgba.g+h.rgba.a*h.rgba.g,d*f.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(h,f,d){if(h.isLighterThan(f))return h;d=d||.5;const L=h.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(s-L)/s,h.lighten(d)}static getDarkerColor(h,f,d){if(h.isDarkerThan(f))return h;d=d||.5;const L=h.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(L-s)/L,h.darken(d)}static{this.white=new w(new N(255,255,255,1))}static{this.black=new w(new N(0,0,0,1))}static{this.red=new w(new N(255,0,0,1))}static{this.blue=new w(new N(0,0,255,1))}static{this.green=new w(new N(0,255,0,1))}static{this.cyan=new w(new N(0,255,255,1))}static{this.lightgrey=new w(new N(211,211,211,1))}static{this.transparent=new w(new N(0,0,0,0))}}t.$Qs=w,function(D){let h;(function(f){let d;(function(L){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:D.Format.CSS.formatRGBA(o)}L.formatRGB=s;function a(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}L.formatRGBA=a;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(o)}L.formatHSL=e;function u(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}L.formatHSLA=u;function l(o){const C=o.toString(16);return C.length!==2?"0"+C:C}function m(o){return`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}`}L.formatHex=m;function n(o,C=!1){return C&&o.rgba.a===1?D.Format.CSS.formatHex(o):`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}${l(Math.round(o.rgba.a*255))}`}L.formatHexA=n;function r(o){return o.isOpaque()?D.Format.CSS.formatHex(o):D.Format.CSS.formatRGBA(o)}L.format=r;function $(o){const C=o.length;if(C===0||o.charCodeAt(0)!==35)return null;if(C===7){const R=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),M=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),b=16*c(o.charCodeAt(5))+c(o.charCodeAt(6));return new D(new N(R,M,b,1))}if(C===9){const R=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),M=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),b=16*c(o.charCodeAt(5))+c(o.charCodeAt(6)),v=16*c(o.charCodeAt(7))+c(o.charCodeAt(8));return new D(new N(R,M,b,v/255))}if(C===4){const R=c(o.charCodeAt(1)),M=c(o.charCodeAt(2)),b=c(o.charCodeAt(3));return new D(new N(16*R+R,16*M+M,16*b+b))}if(C===5){const R=c(o.charCodeAt(1)),M=c(o.charCodeAt(2)),b=c(o.charCodeAt(3)),v=c(o.charCodeAt(4));return new D(new N(16*R+R,16*M+M,16*b+b,(16*v+v)/255))}return null}L.parseHex=$;function c(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=f.CSS||(f.CSS={}))})(h=D.Format||(D.Format={}))}(w||(t.$Qs=w={}))}),define(be[25],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gh=t.$fh=t.$eh=void 0;function y(w){return(D,h,f)=>{let d=null,L=null;if(typeof f.value=="function"?(d="value",L=f.value):typeof f.get=="function"&&(d="get",L=f.get),!L)throw new Error("not supported");f[d]=w(L,h)}}function N(w,D,h){let f=null,d=null;if(typeof h.value=="function"?(f="value",d=h.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(f="get",d=h.get),!d)throw new Error("not supported");const L=`$memoize$${D}`;h[f]=function(...s){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,s)}),this[L]}}t.$eh=N;function i(w,D,h){return y((f,d)=>{const L=`$debounce$${d}`,s=`$debounce$result$${d}`;return function(...a){this[s]||(this[s]=h?h():void 0),clearTimeout(this[L]),D&&(this[s]=D(this[s],...a),a=[this[s]]),this[L]=setTimeout(()=>{f.apply(this,a),this[s]=h?h():void 0},w)}})}t.$fh=i;function U(w,D,h){return y((f,d)=>{const L=`$throttle$timer$${d}`,s=`$throttle$result$${d}`,a=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...u){if(this[s]||(this[s]=h?h():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),D&&(this[s]=D(this[s],...u)),this[e])return;const l=this[a]+w;l<=Date.now()?(this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=h?h():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=h?h():void 0},l-Date.now()))}})}t.$gh=U}),define(be[73],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ps=void 0;class y{constructor(i,U,w,D){this.originalStart=i,this.originalLength=U,this.modifiedStart=w,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ps=y}),define(be[6],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class y{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(C=>{C(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$U=y,t.$V=new y;function N(c){t.$V.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=N;function i(c){if(!c||typeof c!="object")return!1;const o=c;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$X=i;function U(c){f(c)||t.$V.onUnexpectedError(c)}t.$Y=U;function w(c){f(c)||t.$V.onUnexpectedExternalError(c)}t.$Z=w;function D(c){if(c instanceof Error){const{name:o,message:C}=c,R=c.stacktrace||c.stack;return{$isError:!0,name:o,message:C,stack:R,noTelemetry:r.isErrorNoTelemetry(c)}}return c}t.$1=D;const h="Canceled";function f(c){return c instanceof d?!0:c instanceof Error&&c.name===h&&c.message===h}t.$2=f;class d extends Error{constructor(){super(h),this.name=this.message}}t.$3=d;function L(){const c=new Error(h);return c.name=c.message,c}t.$4=L;function s(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$5=s;function a(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$6=a;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$7=e;function u(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$8=u;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$9=l;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$0=m;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const C=new r;return C.message=o.message,C.stack=o.stack,C}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$_=r;class $ extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}t.$ab=$}),define(be[11],$e([1,0,6,70]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.$5b=t.CompareResult=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.$Eb=t.top=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=t.$qb=void 0;function i(T,P=0){return T[T.length-(1+P)]}t.$qb=i;function U(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.$rb=U;function w(T,P,O=(_,S)=>_===S){if(T===P)return!0;if(!T||!P||T.length!==P.length)return!1;for(let _=0,S=T.length;_<S;_++)if(!O(T[_],P[_]))return!1;return!0}t.$sb=w;function D(T,P){const O=T.length-1;P<O&&(T[P]=T[O]),T.pop()}t.$tb=D;function h(T,P,O){return f(T.length,_=>O(T[_],P))}t.$ub=h;function f(T,P){let O=0,_=T-1;for(;O<=_;){const S=(O+_)/2|0,B=P(S);if(B<0)O=S+1;else if(B>0)_=S-1;else return S}return-(O+1)}t.$vb=f;function d(T,P,O){if(T=T|0,T>=P.length)throw new TypeError("invalid index");const _=P[Math.floor(P.length*Math.random())],S=[],B=[],E=[];for(const A of P){const H=O(A,_);H<0?S.push(A):H>0?B.push(A):E.push(A)}return T<S.length?d(T,S,O):T<S.length+E.length?E[0]:d(T-(S.length+E.length),B,O)}t.$wb=d;function L(T,P){const O=[];let _;for(const S of T.slice(0).sort(P))!_||P(_[0],S)!==0?(_=[S],O.push(_)):_.push(S);return O}t.$xb=L;function*s(T,P){let O,_;for(const S of T)_!==void 0&&P(_,S)?O.push(S):(O&&(yield O),O=[S]),_=S;O&&(yield O)}t.$yb=s;function a(T,P){for(let O=0;O<=T.length;O++)P(O===0?void 0:T[O-1],O===T.length?void 0:T[O])}t.$zb=a;function e(T,P){for(let O=0;O<T.length;O++)P(O===0?void 0:T[O-1],T[O],O+1===T.length?void 0:T[O+1])}t.$Ab=e;function u(T,P,O){const _=[];function S(A,H,x){if(H===0&&x.length===0)return;const ie=_[_.length-1];ie&&ie.start+ie.deleteCount===A?(ie.deleteCount+=H,ie.toInsert.push(...x)):_.push({start:A,deleteCount:H,toInsert:x})}let B=0,E=0;for(;;){if(B===T.length){S(B,0,P.slice(E));break}if(E===P.length){S(B,T.length-B,[]);break}const A=T[B],H=P[E],x=O(A,H);x===0?(B+=1,E+=1):x<0?(S(B,1,[]),B+=1):x>0&&(S(B,0,[H]),E+=1)}return _}t.$Bb=u;function l(T,P,O){const _=u(T,P,O),S=[],B=[];for(const E of _)S.push(...T.slice(E.start,E.start+E.deleteCount)),B.push(...E.toInsert);return{removed:S,added:B}}t.$Cb=l;function m(T,P,O){if(O===0)return[];const _=T.slice(0,O).sort(P);return r(T,P,_,O,T.length),_}t.top=m;function n(T,P,O,_,S){return O===0?Promise.resolve([]):new Promise((B,E)=>{(async()=>{const A=T.length,H=T.slice(0,O).sort(P);for(let x=O,ie=Math.min(O+_,A);x<A;x=ie,ie=Math.min(ie+_,A)){if(x>O&&await new Promise(se=>setTimeout(se)),S&&S.isCancellationRequested)throw new y.$3;r(T,P,H,x,ie)}return H})().then(B,E)})}t.$Eb=n;function r(T,P,O,_,S){for(const B=O.length;_<S;_++){const E=T[_];if(P(E,O[B-1])<0){O.pop();const A=(0,N.$ib)(O,H=>P(E,H)<0);O.splice(A,0,E)}}}function $(T){return T.filter(P=>!!P)}t.$Fb=$;function c(T){let P=0;for(let O=0;O<T.length;O++)T[O]&&(T[P]=T[O],P+=1);T.length=P}t.$Gb=c;function o(T,P,O){T.splice(O,0,T.splice(P,1)[0])}t.$Hb=o;function C(T){return!Array.isArray(T)||T.length===0}t.$Ib=C;function R(T){return Array.isArray(T)&&T.length>0}t.$Jb=R;function M(T,P=O=>O){const O=new Set;return T.filter(_=>{const S=P(_);return O.has(S)?!1:(O.add(S),!0)})}t.$Kb=M;function b(T){const P=new Set;return O=>{const _=T(O);return P.has(_)?!1:(P.add(_),!0)}}t.$Lb=b;function v(T,P){return T.length>0?T[0]:P}t.$Mb=v;function j(T,P){return T.length>0?T[T.length-1]:P}t.$Nb=j;function z(T,P,O=(_,S)=>_===S){let _=0;for(let S=0,B=Math.min(T.length,P.length);S<B&&O(T[S],P[S]);S++)_++;return _}t.$Ob=z;function W(T){return[].concat(...T)}t.$Pb=W;function I(T,P){let O=typeof P=="number"?T:0;typeof P=="number"?O=T:(O=0,P=T);const _=[];if(O<=P)for(let S=O;S<P;S++)_.push(S);else for(let S=O;S>P;S--)_.push(S);return _}t.$Qb=I;function F(T,P,O){return T.reduce((_,S)=>(_[P(S)]=O?O(S):S,_),Object.create(null))}t.$Rb=F;function X(T,P){return T.push(P),()=>te(T,P)}t.$Sb=X;function te(T,P){const O=T.indexOf(P);if(O>-1)return T.splice(O,1),P}t.$Tb=te;function re(T,P,O){const _=T.slice(0,P),S=T.slice(P);return _.concat(O,S)}t.$Ub=re;function ce(T,P){let O;if(typeof P=="number"){let _=P;O=()=>{const S=Math.sin(_++)*179426549;return S-Math.floor(S)}}else O=Math.random;for(let _=T.length-1;_>0;_-=1){const S=Math.floor(O()*(_+1)),B=T[_];T[_]=T[S],T[S]=B}}t.$Vb=ce;function le(T,P){const O=T.indexOf(P);O>-1&&(T.splice(O,1),T.unshift(P))}t.$Wb=le;function ae(T,P){const O=T.indexOf(P);O>-1&&(T.splice(O,1),T.push(P))}t.$Xb=ae;function me(T,P){for(const O of P)T.push(O)}t.$Yb=me;function ke(T,P){return Array.isArray(T)?T.map(P):P(T)}t.$Zb=ke;function Le(T){return Array.isArray(T)?T:[T]}t.$1b=Le;function Pe(T){return T[Math.floor(Math.random()*T.length)]}t.$2b=Pe;function de(T,P,O){const _=Q(T,P),S=T.length,B=O.length;T.length=S+B;for(let E=S-1;E>=_;E--)T[E+B]=T[E];for(let E=0;E<B;E++)T[E+_]=O[E]}t.$3b=de;function ne(T,P,O,_){const S=Q(T,P);let B=T.splice(S,O);return B===void 0&&(B=[]),de(T,S,_),B}t.$4b=ne;function Q(T,P){return P<0?Math.max(P+T.length,0):Math.min(P,T.length)}var V;(function(T){function P(B){return B<0}T.isLessThan=P;function O(B){return B<=0}T.isLessThanOrEqual=O;function _(B){return B>0}T.isGreaterThan=_;function S(B){return B===0}T.isNeitherLessOrGreaterThan=S,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(V||(t.CompareResult=V={}));function ee(T,P){return(O,_)=>P(T(O),T(_))}t.$5b=ee;function J(...T){return(P,O)=>{for(const _ of T){const S=_(P,O);if(!V.isNeitherLessOrGreaterThan(S))return S}return V.neitherLessOrGreaterThan}}t.$6b=J;const k=(T,P)=>T-P;t.$7b=k;const K=(T,P)=>(0,t.$7b)(T?1:0,P?1:0);t.$8b=K;function g(T){return(P,O)=>-T(P,O)}t.$9b=g;class p{constructor(P){this.g=P,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(P){let O=this.c;for(;O<this.g.length&&P(this.g[O]);)O++;const _=O===this.c?null:this.g.slice(this.c,O);return this.c=O,_}takeFromEndWhile(P){let O=this.d;for(;O>=0&&P(this.g[O]);)O--;const _=O===this.d?null:this.g.slice(O+1,this.d+1);return this.d=O,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const P=this.g[this.c];return this.c++,P}removeLast(){const P=this.g[this.d];return this.d--,P}takeCount(P){const O=this.g.slice(this.c,this.c+P);return this.c+=P,O}}t.$0b=p;class q{static{this.empty=new q(P=>{})}constructor(P){this.iterate=P}forEach(P){this.iterate(O=>(P(O),!0))}toArray(){const P=[];return this.iterate(O=>(P.push(O),!0)),P}filter(P){return new q(O=>this.iterate(_=>P(_)?O(_):!0))}map(P){return new q(O=>this.iterate(_=>O(P(_))))}some(P){let O=!1;return this.iterate(_=>(O=P(_),!O)),O}findFirst(P){let O;return this.iterate(_=>P(_)?(O=_,!1):!0),O}findLast(P){let O;return this.iterate(_=>(P(_)&&(O=_),!0)),O}findLastMaxBy(P){let O,_=!0;return this.iterate(S=>((_||V.isGreaterThan(P(S,O)))&&(_=!1,O=S),!0)),O}}t.$$b=q}),define(be[74],$e([1,0,6]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$4c=t.$3c=t.$2c=t.ok=void 0;function N(h,f){if(!h)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}t.ok=N;function i(h,f="Unreachable"){throw new Error(f)}t.$2c=i;function U(h){if(!h)throw new y.$ab("Assertion Failed")}t.$3c=U;function w(h){if(!h()){debugger;h(),(0,y.$Y)(new y.$ab("Assertion Failed"))}}t.$4c=w;function D(h,f){let d=0;for(;d<h.length-1;){const L=h[d],s=h[d+1];if(!f(L,s))return!1;d++}return!0}t.$5c=D}),define(be[42],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function y(N){const i=this;let U=!1,w;return function(){return U||(U=!0,w=N.apply(i,arguments)),w}}t.$bb=y}),define(be[75],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cM=t.$bM=void 0;class y{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$bM=y,t.$cM=new y("id#")}),define(be[26],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(N){function i(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}N.is=i;const U=Object.freeze([]);function w(){return U}N.empty=w;function*D(c){yield c}N.single=D;function h(c){return i(c)?c:D(c)}N.wrap=h;function f(c){return c||U}N.from=f;function*d(c){for(let o=c.length-1;o>=0;o--)yield c[o]}N.reverse=d;function L(c){return!c||c[Symbol.iterator]().next().done===!0}N.isEmpty=L;function s(c){return c[Symbol.iterator]().next().value}N.first=s;function a(c,o){for(const C of c)if(o(C))return!0;return!1}N.some=a;function e(c,o){for(const C of c)if(o(C))return C}N.find=e;function*u(c,o){for(const C of c)o(C)&&(yield C)}N.filter=u;function*l(c,o){let C=0;for(const R of c)yield o(R,C++)}N.map=l;function*m(...c){for(const o of c)for(const C of o)yield C}N.concat=m;function n(c,o,C){let R=C;for(const M of c)R=o(R,M);return R}N.reduce=n;function*r(c,o,C=c.length){for(o<0&&(o+=c.length),C<0?C+=c.length:C>c.length&&(C=c.length);o<C;o++)yield c[o]}N.slice=r;function $(c,o=Number.POSITIVE_INFINITY){const C=[];if(o===0)return[C,c];const R=c[Symbol.iterator]();for(let M=0;M<o;M++){const b=R.next();if(b.done)return[C,N.empty()];C.push(b.value)}return[C,{[Symbol.iterator](){return R}}]}N.consume=$})(y||(t.Iterable=y={}))}),define(be[43],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xq=t.KeyMod=t.KeyCodeUtils=t.$wq=t.$vq=t.$uq=t.$tq=t.$sq=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(N||(t.ScanCode=N={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,l){this._keyCodeToStr[u]=l,this._strToKeyCode[l.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const U=new i,w=new i,D=new i;t.$sq=new Array(230),t.$tq={};const h=[],f=Object.create(null),d=Object.create(null);t.$uq={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>f[e]||0,toString:e=>h[e]||"None"},t.$vq=[],t.$wq=[];for(let e=0;e<=193;e++)t.$vq[e]=-1;for(let e=0;e<=132;e++)t.$wq[e]=-1;(function(){const e="",u=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],m=[];for(const n of u){const[r,$,c,o,C,R,M,b,v]=n;if(m[$]||(m[$]=!0,h[$]=c,f[c]=$,d[c.toLowerCase()]=$,r&&(t.$vq[$]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$wq[o]=$))),!l[o]){if(l[o]=!0,!C)throw new Error(`String representation missing for key code ${o} around scan code ${c}`);U.define(o,C),w.define(o,b||C),D.define(o,v||b||C)}R&&(t.$sq[R]=o),M&&(t.$tq[M]=o)}t.$wq[3]=46})();var L;(function(e){function u(c){return U.keyCodeToStr(c)}e.toString=u;function l(c){return U.strToKeyCode(c)}e.fromString=l;function m(c){return w.keyCodeToStr(c)}e.toUserSettingsUS=m;function n(c){return D.keyCodeToStr(c)}e.toUserSettingsGeneral=n;function r(c){return w.strToKeyCode(c)||D.strToKeyCode(c)}e.fromUserSettings=r;function $(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(c)}e.toElectronAccelerator=$})(L||(t.KeyCodeUtils=L={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,u){const l=(u&65535)<<16>>>0;return(e|l)>>>0}t.$xq=a}),define(be[76],$e([1,0,6]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eq=t.$Dq=t.$Cq=t.$Bq=t.$Aq=t.$zq=t.$yq=void 0;var N;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(N||(N={}));function i(L,s){if(typeof L=="number"){if(L===0)return null;const a=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new h([U(a,s),U(e,s)]):new h([U(a,s)])}else{const a=[];for(let e=0;e<L.length;e++)a.push(U(L[e],s));return new h(a)}}t.$yq=i;function U(L,s){const a=!!(L&2048),e=!!(L&256),u=s===2?e:a,l=!!(L&1024),m=!!(L&512),n=s===2?a:e,r=L&255;return new w(u,l,m,n,r)}t.$zq=U;class w{constructor(s,a,e,u,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.keyCode=l}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",u=this.metaKey?"1":"0";return`K${s}${a}${e}${u}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new h([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Aq=w;class D{constructor(s,a,e,u,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.scanCode=l}equals(s){return s instanceof D&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",u=this.metaKey?"1":"0";return`S${s}${a}${e}${u}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Bq=D;class h{constructor(s){if(s.length===0)throw(0,y.$5)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Cq=h;class f{constructor(s,a,e,u,l,m){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.keyLabel=l,this.keyAriaLabel=m}}t.$Dq=f;class d{}t.$Eq=d}),define(be[30],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class y{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=y}),define(be[44],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=void 0;class y{static{this.Undefined=new y(void 0)}constructor(U){this.element=U,this.next=y.Undefined,this.prev=y.Undefined}}class N{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let U=this.a;for(;U!==y.Undefined;){const w=U.next;U.prev=y.Undefined,U.next=y.Undefined,U=w}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,w){const D=new y(U);if(this.a===y.Undefined)this.a=D,this.b=D;else if(w){const f=this.b;this.b=D,D.prev=f,f.next=D}else{const f=this.a;this.a=D,D.next=f,f.prev=D}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(D))}}shift(){if(this.a!==y.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==y.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==y.Undefined&&U.next!==y.Undefined){const w=U.prev;w.next=U.next,U.next.prev=w}else U.prev===y.Undefined&&U.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):U.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):U.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==y.Undefined;)yield U.element,U=U.next}}t.$Zc=N}),define(be[31],$e([1,0]),function(oe,t){"use strict";var y,N,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.$Ac=t.Touch=t.$zc=t.$yc=t.$xc=t.$wc=t.$vc=void 0;function U(n,r,$){let c=n.get(r);return c===void 0&&(c=$,n.set(r,c)),c}t.$vc=U;function w(n){const r=[];return n.forEach(($,c)=>{r.push(`${c} => ${$}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$wc=w;function D(n){const r=[];return n.forEach($=>{r.push($)}),`Set(${n.size}) {${r.join(", ")}}`}t.$xc=D;class h{constructor(r,$){this.uri=r,this.value=$}}function f(n){return Array.isArray(n)}class d{static{this.a=r=>r.toString()}constructor(r,$){if(this[y]="ResourceMap",r instanceof d)this.b=new Map(r.b),this.c=$??d.a;else if(f(r)){this.b=new Map,this.c=$??d.a;for(const[c,o]of r)this.set(c,o)}else this.b=new Map,this.c=r??d.a}set(r,$){return this.b.set(this.c(r),new h(r,$)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,$){typeof $<"u"&&(r=r.bind($));for(const[c,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$yc=d;class L{constructor(r,$){this[N]="ResourceSet",!r||typeof r=="function"?this.a=new d(r):(this.a=new d($),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,$){this.a.forEach((c,o)=>r.call($,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$zc=L;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,$=0){const c=this.a.get(r);if(c)return $!==0&&this.j(c,$),c.value}set(r,$,c=0){let o=this.a.get(r);if(o)o.value=$,c!==0&&this.j(o,c);else{switch(o={key:r,value:$,next:void 0,previous:void 0},c){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const $=this.a.get(r);if($)return this.a.delete(r),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,$){const c=this.e;let o=this.b;for(;o;){if($?r.bind($)(o.value,o.key,this):r(o.value,o.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.key,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return o}values(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.value,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return o}entries(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:[c.key,c.value],done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let $=this.b,c=this.size;for(;$&&c>r;)this.a.delete($.key),$=$.next,c--;this.b=$,this.d=c,$&&($.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const $=r.next,c=r.previous;if(!$||!c)throw new Error("Invalid list");$.previous=c,c.next=$}r.next=void 0,r.previous=void 0,this.e++}j(r,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(r===this.b)return;const c=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(c.previous=o,o.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if($===2){if(r===this.c)return;const c=r.next,o=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=o,o.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach(($,c)=>{r.push([c,$])}),r}fromJSON(r){this.clear();for(const[$,c]of r)this.set($,c)}}t.$Ac=a;class e extends a{constructor(r,$=1){super(),this.k=r,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,$=2){return super.get(r,$)}peek(r){return super.get(r,0)}set(r,$){return super.set(r,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Bc=e;class u{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let $=this.a.get(r)||0;return $===0?!1:($--,$===0?this.a.delete(r):this.a.set(r,$),!0)}has(r){return this.a.has(r)}}t.$Cc=u;class l{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[$,c]of r)this.set($,c)}clear(){this.a.clear(),this.b.clear()}set(r,$){this.a.set(r,$),this.b.set($,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const $=this.a.get(r);return $===void 0?!1:(this.a.delete(r),this.b.delete($),!0)}forEach(r,$){this.a.forEach((c,o)=>{r.call($,c,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Dc=l;class m{constructor(){this.a=new Map}add(r,$){let c=this.a.get(r);c||(c=new Set,this.a.set(r,c)),c.add($)}delete(r,$){const c=this.a.get(r);c&&(c.delete($),c.size===0&&this.a.delete(r))}forEach(r,$){const c=this.a.get(r);c&&c.forEach($)}get(r){const $=this.a.get(r);return $||new Set}}t.$Ec=m}),define(be[2],$e([1,0,11,71,31,42,26]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=t.$Fc=void 0;const D=!1;let h=null;class f{constructor(){this.b=new Map}static{this.a=0}c(F){let X=this.b.get(F);return X||(X={parent:null,source:null,isSingleton:!1,value:F,idx:f.a++},this.b.set(F,X)),X}trackDisposable(F){const X=this.c(F);X.source||(X.source=new Error().stack)}setParent(F,X){const te=this.c(F);te.parent=X}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,X){const te=X.get(F);if(te)return te;const re=F.parent?this.f(this.c(F.parent),X):F;return X.set(F,re),re}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,F).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(F=10,X){let te;if(X)te=X;else{const me=new Map,ke=[...this.b.values()].filter(Pe=>Pe.source!==null&&!this.f(Pe,me).isSingleton);if(ke.length===0)return;const Le=new Set(ke.map(Pe=>Pe.value));if(te=ke.filter(Pe=>!(Pe.parent&&Le.has(Pe.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function re(me){function ke(Pe,de){for(;Pe.length>0&&de.some(ne=>typeof ne=="string"?ne===Pe[0]:Pe[0].match(ne));)Pe.shift()}const Le=me.source.split(`
`).map(Pe=>Pe.trim().replace("at ","")).filter(Pe=>Pe!=="");return ke(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const ce=new i.$Ec;for(const me of te){const ke=re(me);for(let Le=0;Le<=ke.length;Le++)ce.add(ke.slice(0,Le).join(`
`),me)}te.sort((0,y.$5b)(me=>me.idx,y.$7b));let le="",ae=0;for(const me of te.slice(0,F)){ae++;const ke=re(me),Le=[];for(let Pe=0;Pe<ke.length;Pe++){let de=ke[Pe];de=`(shared with ${ce.get(ke.slice(0,Pe+1).join(`
`)).size}/${te.length} leaks) at ${de}`;const Q=ce.get(ke.slice(0,Pe).join(`
`)),V=(0,N.$I)([...Q].map(ee=>re(ee)[Pe]),ee=>ee);delete V[ke[Pe]];for(const[ee,J]of Object.entries(V))Le.unshift(`    - stacktraces of ${J.length} other leaks continue with ${ee}`);Le.unshift(de)}le+=`


==================== Leaking disposable ${ae}/${te.length}: ${me.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return te.length>F&&(le+=`


... and ${te.length-F} more leaking disposables

`),{leaks:te,details:le}}}t.$Fc=f;function d(I){h=I}if(t.$Gc=d,D){const I="__is_disposable_tracked__";d(new class{trackDisposable(F){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[I]||console.log(X)},3e3)}setParent(F,X){if(F&&F!==o.None)try{F[I]=!0}catch{}}markAsDisposed(F){if(F&&F!==o.None)try{F[I]=!0}catch{}}markAsSingleton(F){}})}function L(I){return h?.trackDisposable(I),I}t.$Hc=L;function s(I){h?.markAsDisposed(I)}t.$Ic=s;function a(I,F){h?.setParent(I,F)}function e(I,F){if(h)for(const X of I)h.setParent(X,F)}function u(I){return h?.markAsSingleton(I),I}t.$Jc=u;function l(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.$Kc=l;function m(I){if(w.Iterable.is(I)){const F=[];for(const X of I)if(X)try{X.dispose()}catch(te){F.push(te)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.$Lc=m;function n(I){for(const F of I)l(F)&&F.dispose();return[]}t.$Mc=n;function r(...I){const F=$(()=>m(I));return e(I,F),F}t.$Nc=r;function $(I){const F=L({dispose:(0,U.$bb)(()=>{s(F),I()})});return F}t.$Oc=$;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,L(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return a(F,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),a(F,null))}}t.$Pc=c;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,L(this),a(this.q,this)}dispose(){s(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}t.$Qc=o;class C{constructor(){this.b=!1,L(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&a(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&a(F,null),F}}t.$Rc=C;class R{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Sc=R;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(F){let X=F;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,s(this))},this}}t.$Tc=M;class b{constructor(){this.a=new Map}acquire(F,...X){let te=this.a.get(F);te||(te={counter:0,object:this.b(F,...X)},this.a.set(F,te));const{object:re}=te,ce=(0,U.$bb)(()=>{--te.counter===0&&(this.c(F,te.object),this.a.delete(F))});return te.counter++,{object:re,dispose:ce}}}t.$Uc=b;class v{constructor(F){this.a=F}async acquire(F,...X){const te=this.a.acquire(F,...X);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(re){throw te.dispose(),re}}}t.$Vc=v;class j{constructor(F){this.object=F}dispose(){}}t.$Wc=j;function z(I){const F=new c;try{I(F)}finally{F.dispose()}}t.$Xc=z;class W{constructor(){this.a=new Map,this.b=!1,L(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,X,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(F)?.dispose(),this.a.set(F,X)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Yc=W}),function(oe,t){typeof define=="function"&&define.amd?define(be[77],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,t(oe.marked={}))}(this,function(oe){"use strict";function t(P,O){for(var _=0;_<O.length;_++){var S=O[_];S.enumerable=S.enumerable||!1,S.configurable=!0,"value"in S&&(S.writable=!0),Object.defineProperty(P,S.key,S)}}function y(P,O,_){return O&&t(P.prototype,O),_&&t(P,_),Object.defineProperty(P,"prototype",{writable:!1}),P}function N(P,O){if(P){if(typeof P=="string")return i(P,O);var _=Object.prototype.toString.call(P).slice(8,-1);if(_==="Object"&&P.constructor&&(_=P.constructor.name),_==="Map"||_==="Set")return Array.from(P);if(_==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_))return i(P,O)}}function i(P,O){(O==null||O>P.length)&&(O=P.length);for(var _=0,S=new Array(O);_<O;_++)S[_]=P[_];return S}function U(P,O){var _=typeof Symbol<"u"&&P[Symbol.iterator]||P["@@iterator"];if(_)return(_=_.call(P)).next.bind(_);if(Array.isArray(P)||(_=N(P))||O&&P&&typeof P.length=="number"){_&&(P=_);var S=0;return function(){return S>=P.length?{done:!0}:{done:!1,value:P[S++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=w();function D(P){oe.defaults=P}var h=/[&<>"']/,f=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(O){return s[O]};function e(P,O){if(O){if(h.test(P))return P.replace(f,a)}else if(d.test(P))return P.replace(L,a);return P}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(P){return P.replace(u,function(O,_){return _=_.toLowerCase(),_==="colon"?":":_.charAt(0)==="#"?_.charAt(1)==="x"?String.fromCharCode(parseInt(_.substring(2),16)):String.fromCharCode(+_.substring(1)):""})}var m=/(^|[^\[])\^/g;function n(P,O){P=typeof P=="string"?P:P.source,O=O||"";var _={replace:function(B,E){return E=E.source||E,E=E.replace(m,"$1"),P=P.replace(B,E),_},getRegex:function(){return new RegExp(P,O)}};return _}var r=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(P,O,_){if(P){var S;try{S=decodeURIComponent(l(_)).replace(r,"").toLowerCase()}catch{return null}if(S.indexOf("javascript:")===0||S.indexOf("vbscript:")===0||S.indexOf("data:")===0)return null}O&&!$.test(_)&&(_=b(O,_));try{_=encodeURI(_).replace(/%25/g,"%")}catch{return null}return _}var o={},C=/^[^:]+:\/*[^/]*$/,R=/^([^:]+:)[\s\S]*$/,M=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(P,O){o[" "+P]||(C.test(P)?o[" "+P]=P+"/":o[" "+P]=W(P,"/",!0)),P=o[" "+P];var _=P.indexOf(":")===-1;return O.substring(0,2)==="//"?_?O:P.replace(R,"$1")+O:O.charAt(0)==="/"?_?O:P.replace(M,"$1")+O:P+O}var v={exec:function(){}};function j(P){for(var O=1,_,S;O<arguments.length;O++){_=arguments[O];for(S in _)Object.prototype.hasOwnProperty.call(_,S)&&(P[S]=_[S])}return P}function z(P,O){var _=P.replace(/\|/g,function(E,A,H){for(var x=!1,ie=A;--ie>=0&&H[ie]==="\\";)x=!x;return x?"|":" |"}),S=_.split(/ \|/),B=0;if(S[0].trim()||S.shift(),S.length>0&&!S[S.length-1].trim()&&S.pop(),S.length>O)S.splice(O);else for(;S.length<O;)S.push("");for(;B<S.length;B++)S[B]=S[B].trim().replace(/\\\|/g,"|");return S}function W(P,O,_){var S=P.length;if(S===0)return"";for(var B=0;B<S;){var E=P.charAt(S-B-1);if(E===O&&!_)B++;else if(E!==O&&_)B++;else break}return P.slice(0,S-B)}function I(P,O){if(P.indexOf(O[1])===-1)return-1;for(var _=P.length,S=0,B=0;B<_;B++)if(P[B]==="\\")B++;else if(P[B]===O[0])S++;else if(P[B]===O[1]&&(S--,S<0))return B;return-1}function F(P){P&&P.sanitize&&!P.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function X(P,O){if(O<1)return"";for(var _="";O>1;)O&1&&(_+=P),O>>=1,P+=P;return _+P}function te(P,O,_,S){var B=O.href,E=O.title?e(O.title):null,A=P[1].replace(/\\([\[\]])/g,"$1");if(P[0].charAt(0)!=="!"){S.state.inLink=!0;var H={type:"link",raw:_,href:B,title:E,text:A,tokens:S.inlineTokens(A)};return S.state.inLink=!1,H}return{type:"image",raw:_,href:B,title:E,text:e(A)}}function re(P,O){var _=P.match(/^(\s+)(?:```)/);if(_===null)return O;var S=_[1];return O.split(`
`).map(function(B){var E=B.match(/^\s+/);if(E===null)return B;var A=E[0];return A.length>=S.length?B.slice(S.length):B}).join(`
`)}var ce=function(){function P(_){this.options=_||oe.defaults}var O=P.prototype;return O.space=function(S){var B=this.rules.block.newline.exec(S);if(B&&B[0].length>0)return{type:"space",raw:B[0]}},O.code=function(S){var B=this.rules.block.code.exec(S);if(B){var E=B[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:B[0],codeBlockStyle:"indented",text:this.options.pedantic?E:W(E,`
`)}}},O.fences=function(S){var B=this.rules.block.fences.exec(S);if(B){var E=B[0],A=re(E,B[3]||"");return{type:"code",raw:E,lang:B[2]?B[2].trim():B[2],text:A}}},O.heading=function(S){var B=this.rules.block.heading.exec(S);if(B){var E=B[2].trim();if(/#$/.test(E)){var A=W(E,"#");(this.options.pedantic||!A||/ $/.test(A))&&(E=A.trim())}return{type:"heading",raw:B[0],depth:B[1].length,text:E,tokens:this.lexer.inline(E)}}},O.hr=function(S){var B=this.rules.block.hr.exec(S);if(B)return{type:"hr",raw:B[0]}},O.blockquote=function(S){var B=this.rules.block.blockquote.exec(S);if(B){var E=B[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:B[0],tokens:this.lexer.blockTokens(E,[]),text:E}}},O.list=function(S){var B=this.rules.block.list.exec(S);if(B){var E,A,H,x,ie,se,ge,we,Fe,Ae,ve,Ie,Oe=B[1].trim(),qe=Oe.length>1,je={type:"list",raw:"",ordered:qe,start:qe?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=qe?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=qe?Oe:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");S&&(Ie=!1,!(!(B=Me.exec(S))||this.rules.block.hr.test(S)));){if(E=B[0],S=S.substring(E.length),we=B[2].split(`
`,1)[0],Fe=S.split(`
`,1)[0],this.options.pedantic?(x=2,ve=we.trimLeft()):(x=B[2].search(/[^ ]/),x=x>4?1:x,ve=we.slice(x),x+=B[1].length),se=!1,!we&&/^ *$/.test(Fe)&&(E+=Fe+`
`,S=S.substring(Fe.length+1),Ie=!0),!Ie)for(var Ge=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Z=new RegExp("^ {0,"+Math.min(3,x-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:```|~~~)"),pe=new RegExp("^ {0,"+Math.min(3,x-1)+"}#");S&&(Ae=S.split(`
`,1)[0],we=Ae,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(we)||pe.test(we)||Ge.test(we)||Z.test(S)));){if(we.search(/[^ ]/)>=x||!we.trim())ve+=`
`+we.slice(x);else if(!se)ve+=`
`+we;else break;!se&&!we.trim()&&(se=!0),E+=Ae+`
`,S=S.substring(Ae.length+1)}je.loose||(ge?je.loose=!0:/\n *\n *$/.test(E)&&(ge=!0)),this.options.gfm&&(A=/^\[[ xX]\] /.exec(ve),A&&(H=A[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:E,task:!!A,checked:H,loose:!1,text:ve}),je.raw+=E}je.items[je.items.length-1].raw=E.trimRight(),je.items[je.items.length-1].text=ve.trimRight(),je.raw=je.raw.trimRight();var De=je.items.length;for(ie=0;ie<De;ie++){this.lexer.state.top=!1,je.items[ie].tokens=this.lexer.blockTokens(je.items[ie].text,[]);var Ce=je.items[ie].tokens.filter(function(ze){return ze.type==="space"}),Re=Ce.every(function(ze){for(var Ke=ze.raw.split(""),Ye=0,Ve=U(Ke),_e;!(_e=Ve()).done;){var et=_e.value;if(et===`
`&&(Ye+=1),Ye>1)return!0}return!1});!je.loose&&Ce.length&&Re&&(je.loose=!0,je.items[ie].loose=!0)}return je}},O.html=function(S){var B=this.rules.block.html.exec(S);if(B){var E={type:"html",raw:B[0],pre:!this.options.sanitizer&&(B[1]==="pre"||B[1]==="script"||B[1]==="style"),text:B[0]};if(this.options.sanitize){var A=this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]);E.type="paragraph",E.text=A,E.tokens=this.lexer.inline(A)}return E}},O.def=function(S){var B=this.rules.block.def.exec(S);if(B){B[3]&&(B[3]=B[3].substring(1,B[3].length-1));var E=B[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:E,raw:B[0],href:B[2],title:B[3]}}},O.table=function(S){var B=this.rules.block.table.exec(S);if(B){var E={type:"table",header:z(B[1]).map(function(ge){return{text:ge}}),align:B[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:B[3]&&B[3].trim()?B[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(E.header.length===E.align.length){E.raw=B[0];var A=E.align.length,H,x,ie,se;for(H=0;H<A;H++)/^ *-+: *$/.test(E.align[H])?E.align[H]="right":/^ *:-+: *$/.test(E.align[H])?E.align[H]="center":/^ *:-+ *$/.test(E.align[H])?E.align[H]="left":E.align[H]=null;for(A=E.rows.length,H=0;H<A;H++)E.rows[H]=z(E.rows[H],E.header.length).map(function(ge){return{text:ge}});for(A=E.header.length,x=0;x<A;x++)E.header[x].tokens=this.lexer.inline(E.header[x].text);for(A=E.rows.length,x=0;x<A;x++)for(se=E.rows[x],ie=0;ie<se.length;ie++)se[ie].tokens=this.lexer.inline(se[ie].text);return E}}},O.lheading=function(S){var B=this.rules.block.lheading.exec(S);if(B)return{type:"heading",raw:B[0],depth:B[2].charAt(0)==="="?1:2,text:B[1],tokens:this.lexer.inline(B[1])}},O.paragraph=function(S){var B=this.rules.block.paragraph.exec(S);if(B){var E=B[1].charAt(B[1].length-1)===`
`?B[1].slice(0,-1):B[1];return{type:"paragraph",raw:B[0],text:E,tokens:this.lexer.inline(E)}}},O.text=function(S){var B=this.rules.block.text.exec(S);if(B)return{type:"text",raw:B[0],text:B[0],tokens:this.lexer.inline(B[0])}},O.escape=function(S){var B=this.rules.inline.escape.exec(S);if(B)return{type:"escape",raw:B[0],text:e(B[1])}},O.tag=function(S){var B=this.rules.inline.tag.exec(S);if(B)return!this.lexer.state.inLink&&/^<a /i.test(B[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(B[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(B[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(B[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:B[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]):B[0]}},O.link=function(S){var B=this.rules.inline.link.exec(S);if(B){var E=B[2].trim();if(!this.options.pedantic&&/^</.test(E)){if(!/>$/.test(E))return;var A=W(E.slice(0,-1),"\\");if((E.length-A.length)%2===0)return}else{var H=I(B[2],"()");if(H>-1){var x=B[0].indexOf("!")===0?5:4,ie=x+B[1].length+H;B[2]=B[2].substring(0,H),B[0]=B[0].substring(0,ie).trim(),B[3]=""}}var se=B[2],ge="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);we&&(se=we[1],ge=we[3])}else ge=B[3]?B[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(E)?se=se.slice(1):se=se.slice(1,-1)),te(B,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},B[0],this.lexer)}},O.reflink=function(S,B){var E;if((E=this.rules.inline.reflink.exec(S))||(E=this.rules.inline.nolink.exec(S))){var A=(E[2]||E[1]).replace(/\s+/g," ");if(A=B[A.toLowerCase()],!A||!A.href){var H=E[0].charAt(0);return{type:"text",raw:H,text:H}}return te(E,A,E[0],this.lexer)}},O.emStrong=function(S,B,E){E===void 0&&(E="");var A=this.rules.inline.emStrong.lDelim.exec(S);if(A&&!(A[3]&&E.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=A[1]||A[2]||"";if(!H||H&&(E===""||this.rules.inline.punctuation.exec(E))){var x=A[0].length-1,ie,se,ge=x,we=0,Fe=A[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Fe.lastIndex=0,B=B.slice(-1*S.length+x);(A=Fe.exec(B))!=null;)if(ie=A[1]||A[2]||A[3]||A[4]||A[5]||A[6],!!ie){if(se=ie.length,A[3]||A[4]){ge+=se;continue}else if((A[5]||A[6])&&x%3&&!((x+se)%3)){we+=se;continue}if(ge-=se,!(ge>0)){if(se=Math.min(se,se+ge+we),Math.min(x,se)%2){var Ae=S.slice(1,x+A.index+se);return{type:"em",raw:S.slice(0,x+A.index+se+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var ve=S.slice(2,x+A.index+se-1);return{type:"strong",raw:S.slice(0,x+A.index+se+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},O.codespan=function(S){var B=this.rules.inline.code.exec(S);if(B){var E=B[2].replace(/\n/g," "),A=/[^ ]/.test(E),H=/^ /.test(E)&&/ $/.test(E);return A&&H&&(E=E.substring(1,E.length-1)),E=e(E,!0),{type:"codespan",raw:B[0],text:E}}},O.br=function(S){var B=this.rules.inline.br.exec(S);if(B)return{type:"br",raw:B[0]}},O.del=function(S){var B=this.rules.inline.del.exec(S);if(B)return{type:"del",raw:B[0],text:B[2],tokens:this.lexer.inlineTokens(B[2])}},O.autolink=function(S,B){var E=this.rules.inline.autolink.exec(S);if(E){var A,H;return E[2]==="@"?(A=e(this.options.mangle?B(E[1]):E[1]),H="mailto:"+A):(A=e(E[1]),H=A),{type:"link",raw:E[0],text:A,href:H,tokens:[{type:"text",raw:A,text:A}]}}},O.url=function(S,B){var E;if(E=this.rules.inline.url.exec(S)){var A,H;if(E[2]==="@")A=e(this.options.mangle?B(E[0]):E[0]),H="mailto:"+A;else{var x;do x=E[0],E[0]=this.rules.inline._backpedal.exec(E[0])[0];while(x!==E[0]);A=e(E[0]),E[1]==="www."?H="http://"+A:H=A}return{type:"link",raw:E[0],text:A,href:H,tokens:[{type:"text",raw:A,text:A}]}}},O.inlineText=function(S,B){var E=this.rules.inline.text.exec(S);if(E){var A;return this.lexer.state.inRawBlock?A=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(E[0]):e(E[0]):E[0]:A=e(this.options.smartypants?B(E[0]):E[0]),{type:"text",raw:E[0],text:A}}},P}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=n(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=n(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=n(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=n(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=n(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=n(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=n(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=n(le._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=n(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=n(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=n(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=n(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=n(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=n(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=n(ae.reflink).replace("label",ae._label).replace("ref",le._label).getRegex(),ae.nolink=n(ae.nolink).replace("ref",le._label).getRegex(),ae.reflinkSearch=n(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=j({},ae),ae.pedantic=j({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=j({},ae.normal,{escape:n(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=n(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=j({},ae.gfm,{br:n(ae.br).replace("{2,}","*").getRegex(),text:n(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function me(P){return P.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ke(P){var O="",_,S,B=P.length;for(_=0;_<B;_++)S=P.charCodeAt(_),Math.random()>.5&&(S="x"+S.toString(16)),O+="&#"+S+";";return O}var Le=function(){function P(_){this.tokens=[],this.tokens.links=Object.create(null),this.options=_||oe.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var S={block:le.normal,inline:ae.normal};this.options.pedantic?(S.block=le.pedantic,S.inline=ae.pedantic):this.options.gfm&&(S.block=le.gfm,this.options.breaks?S.inline=ae.breaks:S.inline=ae.gfm),this.tokenizer.rules=S}P.lex=function(S,B){var E=new P(B);return E.lex(S)},P.lexInline=function(S,B){var E=new P(B);return E.inlineTokens(S)};var O=P.prototype;return O.lex=function(S){S=S.replace(/\r\n|\r/g,`
`),this.blockTokens(S,this.tokens);for(var B;B=this.inlineQueue.shift();)this.inlineTokens(B.src,B.tokens);return this.tokens},O.blockTokens=function(S,B){var E=this;B===void 0&&(B=[]),this.options.pedantic?S=S.replace(/\t/g,"    ").replace(/^ +$/gm,""):S=S.replace(/^( *)(\t+)/gm,function(ge,we,Fe){return we+"    ".repeat(Fe.length)});for(var A,H,x,ie;S;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(A=ge.call({lexer:E},S,B))?(S=S.substring(A.raw.length),B.push(A),!0):!1}))){if(A=this.tokenizer.space(S)){S=S.substring(A.raw.length),A.raw.length===1&&B.length>0?B[B.length-1].raw+=`
`:B.push(A);continue}if(A=this.tokenizer.code(S)){S=S.substring(A.raw.length),H=B[B.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+A.raw,H.text+=`
`+A.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):B.push(A);continue}if(A=this.tokenizer.fences(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.heading(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.hr(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.blockquote(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.list(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.html(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.def(S)){S=S.substring(A.raw.length),H=B[B.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+A.raw,H.text+=`
`+A.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[A.tag]||(this.tokens.links[A.tag]={href:A.href,title:A.title});continue}if(A=this.tokenizer.table(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.lheading(S)){S=S.substring(A.raw.length),B.push(A);continue}if(x=S,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,we=S.slice(1),Fe=void 0;E.options.extensions.startBlock.forEach(function(Ae){Fe=Ae.call({lexer:this},we),typeof Fe=="number"&&Fe>=0&&(ge=Math.min(ge,Fe))}),ge<1/0&&ge>=0&&(x=S.substring(0,ge+1))}(),this.state.top&&(A=this.tokenizer.paragraph(x))){H=B[B.length-1],ie&&H.type==="paragraph"?(H.raw+=`
`+A.raw,H.text+=`
`+A.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):B.push(A),ie=x.length!==S.length,S=S.substring(A.raw.length);continue}if(A=this.tokenizer.text(S)){S=S.substring(A.raw.length),H=B[B.length-1],H&&H.type==="text"?(H.raw+=`
`+A.raw,H.text+=`
`+A.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):B.push(A);continue}if(S){var se="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,B},O.inline=function(S,B){return B===void 0&&(B=[]),this.inlineQueue.push({src:S,tokens:B}),B},O.inlineTokens=function(S,B){var E=this;B===void 0&&(B=[]);var A,H,x,ie=S,se,ge,we;if(this.tokens.links){var Fe=Object.keys(this.tokens.links);if(Fe.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(ie))!=null;)Fe.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(ie=ie.slice(0,se.index)+"["+X("a",se[0].length-2)+"]"+ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(ie))!=null;)ie=ie.slice(0,se.index)+"["+X("a",se[0].length-2)+"]"+ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(ie))!=null;)ie=ie.slice(0,se.index)+"++"+ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;S;)if(ge||(we=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(A=ve.call({lexer:E},S,B))?(S=S.substring(A.raw.length),B.push(A),!0):!1}))){if(A=this.tokenizer.escape(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.tag(S)){S=S.substring(A.raw.length),H=B[B.length-1],H&&A.type==="text"&&H.type==="text"?(H.raw+=A.raw,H.text+=A.text):B.push(A);continue}if(A=this.tokenizer.link(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.reflink(S,this.tokens.links)){S=S.substring(A.raw.length),H=B[B.length-1],H&&A.type==="text"&&H.type==="text"?(H.raw+=A.raw,H.text+=A.text):B.push(A);continue}if(A=this.tokenizer.emStrong(S,ie,we)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.codespan(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.br(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.del(S)){S=S.substring(A.raw.length),B.push(A);continue}if(A=this.tokenizer.autolink(S,ke)){S=S.substring(A.raw.length),B.push(A);continue}if(!this.state.inLink&&(A=this.tokenizer.url(S,ke))){S=S.substring(A.raw.length),B.push(A);continue}if(x=S,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ie=S.slice(1),Oe=void 0;E.options.extensions.startInline.forEach(function(qe){Oe=qe.call({lexer:this},Ie),typeof Oe=="number"&&Oe>=0&&(ve=Math.min(ve,Oe))}),ve<1/0&&ve>=0&&(x=S.substring(0,ve+1))}(),A=this.tokenizer.inlineText(x,me)){S=S.substring(A.raw.length),A.raw.slice(-1)!=="_"&&(we=A.raw.slice(-1)),ge=!0,H=B[B.length-1],H&&H.type==="text"?(H.raw+=A.raw,H.text+=A.text):B.push(A);continue}if(S){var Ae="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return B},y(P,null,[{key:"rules",get:function(){return{block:le,inline:ae}}}]),P}(),Pe=function(){function P(_){this.options=_||oe.defaults}var O=P.prototype;return O.code=function(S,B,E){var A=(B||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(S,A);H!=null&&H!==S&&(E=!0,S=H)}return S=S.replace(/\n$/,"")+`
`,A?'<pre><code class="'+this.options.langPrefix+e(A,!0)+'">'+(E?S:e(S,!0))+`</code></pre>
`:"<pre><code>"+(E?S:e(S,!0))+`</code></pre>
`},O.blockquote=function(S){return`<blockquote>
`+S+`</blockquote>
`},O.html=function(S){return S},O.heading=function(S,B,E,A){if(this.options.headerIds){var H=this.options.headerPrefix+A.slug(E);return"<h"+B+' id="'+H+'">'+S+"</h"+B+`>
`}return"<h"+B+">"+S+"</h"+B+`>
`},O.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},O.list=function(S,B,E){var A=B?"ol":"ul",H=B&&E!==1?' start="'+E+'"':"";return"<"+A+H+`>
`+S+"</"+A+`>
`},O.listitem=function(S){return"<li>"+S+`</li>
`},O.checkbox=function(S){return"<input "+(S?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},O.paragraph=function(S){return"<p>"+S+`</p>
`},O.table=function(S,B){return B&&(B="<tbody>"+B+"</tbody>"),`<table>
<thead>
`+S+`</thead>
`+B+`</table>
`},O.tablerow=function(S){return`<tr>
`+S+`</tr>
`},O.tablecell=function(S,B){var E=B.header?"th":"td",A=B.align?"<"+E+' align="'+B.align+'">':"<"+E+">";return A+S+("</"+E+`>
`)},O.strong=function(S){return"<strong>"+S+"</strong>"},O.em=function(S){return"<em>"+S+"</em>"},O.codespan=function(S){return"<code>"+S+"</code>"},O.br=function(){return this.options.xhtml?"<br/>":"<br>"},O.del=function(S){return"<del>"+S+"</del>"},O.link=function(S,B,E){if(S=c(this.options.sanitize,this.options.baseUrl,S),S===null)return E;var A='<a href="'+e(S)+'"';return B&&(A+=' title="'+B+'"'),A+=">"+E+"</a>",A},O.image=function(S,B,E){if(S=c(this.options.sanitize,this.options.baseUrl,S),S===null)return E;var A='<img src="'+S+'" alt="'+E+'"';return B&&(A+=' title="'+B+'"'),A+=this.options.xhtml?"/>":">",A},O.text=function(S){return S},P}(),de=function(){function P(){}var O=P.prototype;return O.strong=function(S){return S},O.em=function(S){return S},O.codespan=function(S){return S},O.del=function(S){return S},O.html=function(S){return S},O.text=function(S){return S},O.link=function(S,B,E){return""+E},O.image=function(S,B,E){return""+E},O.br=function(){return""},P}(),ne=function(){function P(){this.seen={}}var O=P.prototype;return O.serialize=function(S){return S.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},O.getNextSafeSlug=function(S,B){var E=S,A=0;if(this.seen.hasOwnProperty(E)){A=this.seen[S];do A++,E=S+"-"+A;while(this.seen.hasOwnProperty(E))}return B||(this.seen[S]=A,this.seen[E]=0),E},O.slug=function(S,B){B===void 0&&(B={});var E=this.serialize(S);return this.getNextSafeSlug(E,B.dryrun)},P}(),Q=function(){function P(_){this.options=_||oe.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ne}P.parse=function(S,B){var E=new P(B);return E.parse(S)},P.parseInline=function(S,B){var E=new P(B);return E.parseInline(S)};var O=P.prototype;return O.parse=function(S,B){B===void 0&&(B=!0);var E="",A,H,x,ie,se,ge,we,Fe,Ae,ve,Ie,Oe,qe,je,Me,Ge,Z,he,pe,De=S.length;for(A=0;A<De;A++){if(ve=S[A],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(pe=this.options.extensions.renderers[ve.type].call({parser:this},ve),pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){E+=pe||"";continue}switch(ve.type){case"space":continue;case"hr":{E+=this.renderer.hr();continue}case"heading":{E+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{E+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Fe="",we="",ie=ve.header.length,H=0;H<ie;H++)we+=this.renderer.tablecell(this.parseInline(ve.header[H].tokens),{header:!0,align:ve.align[H]});for(Fe+=this.renderer.tablerow(we),Ae="",ie=ve.rows.length,H=0;H<ie;H++){for(ge=ve.rows[H],we="",se=ge.length,x=0;x<se;x++)we+=this.renderer.tablecell(this.parseInline(ge[x].tokens),{header:!1,align:ve.align[x]});Ae+=this.renderer.tablerow(we)}E+=this.renderer.table(Fe,Ae);continue}case"blockquote":{Ae=this.parse(ve.tokens),E+=this.renderer.blockquote(Ae);continue}case"list":{for(Ie=ve.ordered,Oe=ve.start,qe=ve.loose,ie=ve.items.length,Ae="",H=0;H<ie;H++)Me=ve.items[H],Ge=Me.checked,Z=Me.task,je="",Me.task&&(he=this.renderer.checkbox(Ge),qe?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=he+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=he+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:he}):je+=he),je+=this.parse(Me.tokens,qe),Ae+=this.renderer.listitem(je,Z,Ge);E+=this.renderer.list(Ae,Ie,Oe);continue}case"html":{E+=this.renderer.html(ve.text);continue}case"paragraph":{E+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ae=ve.tokens?this.parseInline(ve.tokens):ve.text;A+1<De&&S[A+1].type==="text";)ve=S[++A],Ae+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);E+=B?this.renderer.paragraph(Ae):Ae;continue}default:{var Ce='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return E},O.parseInline=function(S,B){B=B||this.renderer;var E="",A,H,x,ie=S.length;for(A=0;A<ie;A++){if(H=S[A],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(x=this.options.extensions.renderers[H.type].call({parser:this},H),x!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){E+=x||"";continue}switch(H.type){case"escape":{E+=B.text(H.text);break}case"html":{E+=B.html(H.text);break}case"link":{E+=B.link(H.href,H.title,this.parseInline(H.tokens,B));break}case"image":{E+=B.image(H.href,H.title,H.text);break}case"strong":{E+=B.strong(this.parseInline(H.tokens,B));break}case"em":{E+=B.em(this.parseInline(H.tokens,B));break}case"codespan":{E+=B.codespan(H.text);break}case"br":{E+=B.br();break}case"del":{E+=B.del(this.parseInline(H.tokens,B));break}case"text":{E+=B.text(H.text);break}default:{var se='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return E},P}();function V(P,O,_){if(typeof P>"u"||P===null)throw new Error("marked(): input parameter is undefined or null");if(typeof P!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(P)+", string expected");if(typeof O=="function"&&(_=O,O=null),O=j({},V.defaults,O||{}),F(O),_){var S=O.highlight,B;try{B=Le.lex(P,O)}catch(ie){return _(ie)}var E=function(se){var ge;if(!se)try{O.walkTokens&&V.walkTokens(B,O.walkTokens),ge=Q.parse(B,O)}catch(we){se=we}return O.highlight=S,se?_(se):_(null,ge)};if(!S||S.length<3||(delete O.highlight,!B.length))return E();var A=0;V.walkTokens(B,function(ie){ie.type==="code"&&(A++,setTimeout(function(){S(ie.text,ie.lang,function(se,ge){if(se)return E(se);ge!=null&&ge!==ie.text&&(ie.text=ge,ie.escaped=!0),A--,A===0&&E()})},0))}),A===0&&E();return}function H(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(ie.message+"",!0)+"</pre>";throw ie}try{var x=Le.lex(P,O);if(O.walkTokens){if(O.async)return Promise.all(V.walkTokens(x,O.walkTokens)).then(function(){return Q.parse(x,O)}).catch(H);V.walkTokens(x,O.walkTokens)}return Q.parse(x,O)}catch(ie){H(ie)}}V.options=V.setOptions=function(P){return j(V.defaults,P),D(V.defaults),V},V.getDefaults=w,V.defaults=oe.defaults,V.use=function(){for(var P=arguments.length,O=new Array(P),_=0;_<P;_++)O[_]=arguments[_];var S=j.apply(void 0,[{}].concat(O)),B=V.defaults.extensions||{renderers:{},childTokens:{}},E;O.forEach(function(A){if(A.extensions&&(E=!0,A.extensions.forEach(function(x){if(!x.name)throw new Error("extension name required");if(x.renderer){var ie=B.renderers?B.renderers[x.name]:null;ie?B.renderers[x.name]=function(){for(var se=arguments.length,ge=new Array(se),we=0;we<se;we++)ge[we]=arguments[we];var Fe=x.renderer.apply(this,ge);return Fe===!1&&(Fe=ie.apply(this,ge)),Fe}:B.renderers[x.name]=x.renderer}if(x.tokenizer){if(!x.level||x.level!=="block"&&x.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");B[x.level]?B[x.level].unshift(x.tokenizer):B[x.level]=[x.tokenizer],x.start&&(x.level==="block"?B.startBlock?B.startBlock.push(x.start):B.startBlock=[x.start]:x.level==="inline"&&(B.startInline?B.startInline.push(x.start):B.startInline=[x.start]))}x.childTokens&&(B.childTokens[x.name]=x.childTokens)})),A.renderer&&function(){var x=V.defaults.renderer||new Pe,ie=function(we){var Fe=x[we];x[we]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Ie=0;Ie<Ae;Ie++)ve[Ie]=arguments[Ie];var Oe=A.renderer[we].apply(x,ve);return Oe===!1&&(Oe=Fe.apply(x,ve)),Oe}};for(var se in A.renderer)ie(se);S.renderer=x}(),A.tokenizer&&function(){var x=V.defaults.tokenizer||new ce,ie=function(we){var Fe=x[we];x[we]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Ie=0;Ie<Ae;Ie++)ve[Ie]=arguments[Ie];var Oe=A.tokenizer[we].apply(x,ve);return Oe===!1&&(Oe=Fe.apply(x,ve)),Oe}};for(var se in A.tokenizer)ie(se);S.tokenizer=x}(),A.walkTokens){var H=V.defaults.walkTokens;S.walkTokens=function(x){var ie=[];return ie.push(A.walkTokens.call(this,x)),H&&(ie=ie.concat(H.call(this,x))),ie}}E&&(S.extensions=B),V.setOptions(S)})},V.walkTokens=function(P,O){for(var _=[],S=function(){var H=E.value;switch(_=_.concat(O.call(V,H)),H.type){case"table":{for(var x=U(H.header),ie;!(ie=x()).done;){var se=ie.value;_=_.concat(V.walkTokens(se.tokens,O))}for(var ge=U(H.rows),we;!(we=ge()).done;)for(var Fe=we.value,Ae=U(Fe),ve;!(ve=Ae()).done;){var Ie=ve.value;_=_.concat(V.walkTokens(Ie.tokens,O))}break}case"list":{_=_.concat(V.walkTokens(H.items,O));break}default:V.defaults.extensions&&V.defaults.extensions.childTokens&&V.defaults.extensions.childTokens[H.type]?V.defaults.extensions.childTokens[H.type].forEach(function(Oe){_=_.concat(V.walkTokens(H[Oe],O))}):H.tokens&&(_=_.concat(V.walkTokens(H.tokens,O)))}},B=U(P),E;!(E=B()).done;)S();return _},V.parseInline=function(P,O){if(typeof P>"u"||P===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof P!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(P)+", string expected");O=j({},V.defaults,O||{}),F(O);try{var _=Le.lexInline(P,O);return O.walkTokens&&V.walkTokens(_,O.walkTokens),Q.parseInline(_,O)}catch(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}},V.Parser=Q,V.parser=Q.parse,V.Renderer=Pe,V.TextRenderer=de,V.Lexer=Le,V.lexer=Le.lex,V.Tokenizer=ce,V.Slugger=ne,V.parse=V;var ee=V.options,J=V.setOptions,k=V.use,K=V.walkTokens,g=V.parseInline,p=V,q=Q.parse,T=Le.lex;oe.Lexer=Le,oe.Parser=Q,oe.Renderer=Pe,oe.Slugger=ne,oe.TextRenderer=de,oe.Tokenizer=ce,oe.getDefaults=w,oe.lexer=T,oe.marked=V,oe.options=ee,oe.parse=p,oe.parseInline=g,oe.parser=q,oe.setOptions=J,oe.use=k,oe.walkTokens=K,Object.defineProperty(oe,"__esModule",{value:!0})}),define(be[78],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=void 0;class y{constructor(i,U=0,w=i.length,D=U-1){this.a=i,this.b=U,this.c=w,this.d=D}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$AR=y}),define(be[79],$e([1,0,78]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CR=t.$BR=void 0;class N{constructor(w=[],D=10){this.h(w),this.b=D,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new y.$AR(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const D of w)this.a.add(D)}get j(){const w=[];return this.a.forEach(D=>w.push(D)),w}}t.$BR=N;class i{get size(){return this.f}constructor(w,D=10){if(this.g=D,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new Set([w[0]]);for(let h=1;h<w.length;h++)this.add(w[h])}add(w){const D={value:w,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(w)?this.h(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.c.value===w)return w;const D=this.c.value;return this.a.delete(D),this.c.value=w,this.a.has(w)?this.h(w):this.a.add(w),D}prepend(w){if(this.f===this.g||this.a.has(w))return;const D={value:w,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}h(w){let D=this.b;for(;D!==this.c;)D.value===w&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$CR=i}),define(be[45],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nl=t.$Ml=t.$Ll=t.rot=t.$Jl=void 0;function y(D,h,f){return Math.min(Math.max(D,h),f)}t.$Jl=y;function N(D,h){return(h+D%h)%h}t.rot=N;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Ll=i;class U{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Ml=U;class w{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const f=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Nl=w}),define(be[46],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(N){function i(h,f){if(h.start>=f.end||f.start>=h.end)return{start:0,end:0};const d=Math.max(h.start,f.start),L=Math.min(h.end,f.end);return L-d<=0?{start:0,end:0}:{start:d,end:L}}N.intersect=i;function U(h){return h.end-h.start<=0}N.isEmpty=U;function w(h,f){return!U(i(h,f))}N.intersects=w;function D(h,f){const d=[],L={start:h.start,end:Math.min(f.start,h.end)},s={start:Math.max(f.end,h.start),end:h.end};return U(L)||d.push(L),U(s)||d.push(s),d}N.relativeComplement=D})(y||(t.Range=y={}))}),define(be[80],$e([1,0,46]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tQ=t.$sQ=t.$rQ=t.$qQ=void 0;function N(h,f){const d=[];for(const L of f){if(h.start>=L.range.end)continue;if(h.end<L.range.start)break;const s=y.Range.intersect(h,L.range);y.Range.isEmpty(s)||d.push({range:s,size:L.size})}return d}t.$qQ=N;function i({start:h,end:f},d){return{start:h+d,end:f+d}}t.$rQ=i;function U(h){const f=[];let d=null;for(const L of h){const s=L.range.start,a=L.range.end,e=L.size;if(d&&e===d.size){d.range.end=a;continue}d={range:{start:s,end:a},size:e},f.push(d)}return f}t.$sQ=U;function w(...h){return U(h.reduce((f,d)=>f.concat(d),[]))}class D{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,d,L=[]){const s=L.length-d,a=N({start:0,end:f},this.a),e=N({start:f+d,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:i(l.range,s),size:l.size})),u=L.map((l,m)=>({range:{start:f+m,end:f+m+1},size:l.size}));this.a=w(a,u,e),this.b=this.c+this.a.reduce((l,m)=>l+m.size*(m.range.end-m.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let d=0,L=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=L+a*s.size;if(f<e)return d+Math.floor((f-L)/s.size);d+=a,L=e}return d}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let d=0,L=0;for(const s of this.a){const a=s.range.end-s.range.start,e=L+a;if(f<e)return this.c+d+(f-L)*s.size;d+=a*s.size,L=e}return-1}}t.$tQ=D}),define(be[81],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(U){return new N(U)}constructor(U){this.c=y&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Hd=N}),define(be[3],$e([1,0,6,42,2,44,81]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.Event=void 0;const D=!1,h=!1;var f;(function(W){W.None=()=>i.$Qc.None;function I(B){if(h){const{onDidAddListener:E}=B,A=e.create();let H=0;B.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),A.print()),E?.()}}}function F(B,E){return Pe(B,()=>{},0,void 0,!0,void 0,E)}W.defer=F;function X(B){return(E,A=null,H)=>{let x=!1,ie;return ie=B(se=>{if(!x)return ie?ie.dispose():x=!0,E.call(A,se)},null,H),x&&ie.dispose(),ie}}W.once=X;function te(B,E,A){return ke((H,x=null,ie)=>B(se=>H.call(x,E(se)),null,ie),A)}W.map=te;function re(B,E,A){return ke((H,x=null,ie)=>B(se=>{E(se),H.call(x,se)},null,ie),A)}W.forEach=re;function ce(B,E,A){return ke((H,x=null,ie)=>B(se=>E(se)&&H.call(x,se),null,ie),A)}W.filter=ce;function le(B){return B}W.signal=le;function ae(...B){return(E,A=null,H)=>{const x=(0,i.$Nc)(...B.map(ie=>ie(se=>E.call(A,se))));return Le(x,H)}}W.any=ae;function me(B,E,A,H){let x=A;return te(B,ie=>(x=E(x,ie),x),H)}W.reduce=me;function ke(B,E){let A;const H={onWillAddFirstListener(){A=B(x.fire,x)},onDidRemoveLastListener(){A?.dispose()}};E||I(H);const x=new r(H);return E?.add(x),x.event}function Le(B,E){return E instanceof Array?E.push(B):E&&E.add(B),B}function Pe(B,E,A=100,H=!1,x=!1,ie,se){let ge,we,Fe,Ae=0,ve;const Ie={leakWarningThreshold:ie,onWillAddFirstListener(){ge=B(qe=>{Ae++,we=E(we,qe),H&&!Fe&&(Oe.fire(we),we=void 0),ve=()=>{const je=we;we=void 0,Fe=void 0,(!H||Ae>1)&&Oe.fire(je),Ae=0},typeof A=="number"?(clearTimeout(Fe),Fe=setTimeout(ve,A)):Fe===void 0&&(Fe=0,queueMicrotask(ve))})},onWillRemoveListener(){x&&Ae>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,ge.dispose()}};se||I(Ie);const Oe=new r(Ie);return se?.add(Oe),Oe.event}W.debounce=Pe;function de(B,E=0,A){return W.debounce(B,(H,x)=>H?(H.push(x),H):[x],E,void 0,!0,void 0,A)}W.accumulate=de;function ne(B,E=(H,x)=>H===x,A){let H=!0,x;return ce(B,ie=>{const se=H||!E(ie,x);return H=!1,x=ie,se},A)}W.latch=ne;function Q(B,E,A){return[W.filter(B,E,A),W.filter(B,H=>!E(H),A)]}W.split=Q;function V(B,E=!1,A=[],H){let x=A.slice(),ie=B(we=>{x?x.push(we):ge.fire(we)});H&&H.add(ie);const se=()=>{x?.forEach(we=>ge.fire(we)),x=null},ge=new r({onWillAddFirstListener(){ie||(ie=B(we=>ge.fire(we)),H&&H.add(ie))},onDidAddFirstListener(){x&&(E?setTimeout(se):se())},onDidRemoveLastListener(){ie&&ie.dispose(),ie=null}});return H&&H.add(ge),ge.event}W.buffer=V;function ee(B,E){return(H,x,ie)=>{const se=E(new k);return B(function(ge){const we=se.evaluate(ge);we!==J&&H.call(x,we)},void 0,ie)}}W.chain=ee;const J=Symbol("HaltChainable");class k{constructor(){this.f=[]}map(E){return this.f.push(E),this}forEach(E){return this.f.push(A=>(E(A),A)),this}filter(E){return this.f.push(A=>E(A)?A:J),this}reduce(E,A){let H=A;return this.f.push(x=>(H=E(H,x),H)),this}latch(E=(A,H)=>A===H){let A=!0,H;return this.f.push(x=>{const ie=A||!E(x,H);return A=!1,H=x,ie?x:J}),this}evaluate(E){for(const A of this.f)if(E=A(E),E===J)break;return E}}function K(B,E,A=H=>H){const H=(...ge)=>se.fire(A(...ge)),x=()=>B.on(E,H),ie=()=>B.removeListener(E,H),se=new r({onWillAddFirstListener:x,onDidRemoveLastListener:ie});return se.event}W.fromNodeEventEmitter=K;function g(B,E,A=H=>H){const H=(...ge)=>se.fire(A(...ge)),x=()=>B.addEventListener(E,H),ie=()=>B.removeEventListener(E,H),se=new r({onWillAddFirstListener:x,onDidRemoveLastListener:ie});return se.event}W.fromDOMEventEmitter=g;function p(B){return new Promise(E=>X(B)(E))}W.toPromise=p;function q(B){const E=new r;return B.then(A=>{E.fire(A)},()=>{E.fire(void 0)}).finally(()=>{E.dispose()}),E.event}W.fromPromise=q;function T(B,E){return E(void 0),B(A=>E(A))}W.runAndSubscribe=T;function P(B,E){let A=null;function H(ie){A?.dispose(),A=new i.$Pc,E(ie,A)}H(void 0);const x=B(ie=>H(ie));return(0,i.$Oc)(()=>{x.dispose(),A?.dispose()})}W.runAndSubscribeWithStore=P;class O{constructor(E,A){this._observable=E,this.f=0,this.g=!1;const H={onWillAddFirstListener:()=>{E.addObserver(this)},onDidRemoveLastListener:()=>{E.removeObserver(this)}};A||I(H),this.emitter=new r(H),A&&A.add(this.emitter)}beginUpdate(E){this.f++}handlePossibleChange(E){}handleChange(E,A){this.g=!0}endUpdate(E){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(B,E){return new O(B,E).emitter.event}W.fromObservable=_;function S(B){return E=>{let A=0,H=!1;const x={beginUpdate(){A++},endUpdate(){A--,A===0&&(B.reportChanges(),H&&(H=!1,E()))},handlePossibleChange(){},handleChange(){H=!0}};return B.addObserver(x),B.reportChanges(),{dispose(){B.removeObserver(x)}}}}W.fromObservableLight=S})(f||(t.Event=f={}));class d{static{this.all=new Set}static{this.f=0}constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${d.f++}`,d.all.add(this)}start(I){this.g=new w.$Hd,this.listenerCount=I}stop(){if(this.g){const I=this.g.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.g=void 0}}}t.$Jd=d;let L=-1;function s(W){const I=L;return L=W,{dispose(){L=I}}}t.$Kd=s;class a{constructor(I,F=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=F,this.g=0}dispose(){this.f?.clear()}check(I,F){const X=this.threshold;if(X<=0||F<X)return;this.f||(this.f=new Map);const te=this.f.get(I.value)||0;if(this.f.set(I.value,te+1),this.g-=1,this.g<=0){this.g=X*.5;let re,ce=0;for(const[le,ae]of this.f)(!re||ce<ae)&&(re=le,ce=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${ce}):`),console.warn(re)}return()=>{const re=this.f.get(I.value)||0;this.f.set(I.value,re-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class l{constructor(I){this.value=I,this.id=u++}}const m=2,n=(W,I)=>{if(W instanceof l)I(W);else for(let F=0;F<W.length;F++){const X=W[F];X&&I(X)}};class r{constructor(I){this.x=0,this.f=I,this.g=L>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??L):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(D){const I=this.t;queueMicrotask(()=>{n(I,F=>F.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(I,F,X)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Qc.None;if(this.m)return i.$Qc.None;F&&(I=I.bind(F));const te=new l(I);let re,ce;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(te.stack=e.create(),re=this.g.check(te.stack,this.x+1)),D&&(te.stack=ce??e.create()),this.t?this.t instanceof l?(this.u??=new c,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.x++;const le=(0,i.$Oc)(()=>{re?.(),this.y(te)});return X instanceof i.$Pc?X.add(le):Array.isArray(X)&&X.push(le),le},this.q}y(I){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const F=this.t,X=F.indexOf(I);if(X===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,F[X]=void 0;const te=this.u.current===this;if(this.x*m<=F.length){let re=0;for(let ce=0;ce<F.length;ce++)F[ce]?F[re++]=F[ce]:te&&(this.u.end--,re<this.u.i&&this.u.i--);F.length=re}}z(I,F){if(!I)return;const X=this.f?.onListenerError||y.$Y;if(!X){I.value(F);return}try{I.value(F)}catch(te){X(te)}}A(I){const F=I.current.t;for(;I.i<I.end;)this.z(F[I.i++],I.value);I.reset()}fire(I){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof l)this.z(this.t,I);else{const F=this.u;F.enqueue(this,I,this.t.length),this.A(F)}this.j?.stop()}hasListeners(){return this.x>0}}t.$Ld=r;const $=()=>new c;t.$Md=$;class c{constructor(){this.i=-1,this.end=0}enqueue(I,F,X){this.i=0,this.end=X,this.current=I,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(I,F,X){if(this.t)for(this.h||(this.h=new U.$Zc),n(this.t,te=>this.h.push([te.value,I]));this.h.size>0&&!F.isCancellationRequested;){const[te,re]=this.h.shift(),ce=[],le={...re,token:F,waitUntil:ae=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");X&&(ae=X(ae,te)),ce.push(ae)}};try{te(le)}catch(ae){(0,y.$Y)(ae);continue}Object.freeze(ce),await Promise.allSettled(ce).then(ae=>{for(const me of ae)me.status==="rejected"&&(0,y.$Y)(me.reason)})}}}t.$Nd=o;class C extends r{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new U.$Zc,this.w=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.w(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.x&&(this.h!==0?this.s.push(I):super.fire(I))}}t.$Od=C;class R extends C{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}t.$Pd=R;class M extends r{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}t.$Qd=M;class b{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(I){const F={event:I,listener:null};this.h.push(F),this.g&&this.m(F);const X=()=>{this.g&&this.o(F);const te=this.h.indexOf(F);this.h.splice(te,1)};return(0,i.$Oc)((0,N.$bb)(X))}j(){this.g=!0,this.h.forEach(I=>this.m(I))}k(){this.g=!1,this.h.forEach(I=>this.o(I))}m(I){I.listener=I.event(F=>this.f.fire(F))}o(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.f.dispose()}}t.$Rd=b;class v{constructor(I,F,X,te){this.f=new i.$Pc;const re=this.f.add(new b),ce=this.f.add(new i.$Yc);function le(ae){ce.set(ae,re.add(te(ae)))}for(const ae of I)le(ae);this.f.add(F(ae=>{le(ae)})),this.f.add(X(ae=>{ce.deleteAndDispose(ae)})),this.event=re.event}dispose(){this.f.dispose()}}t.$Sd=v;class j{constructor(){this.f=[]}wrapEvent(I){return(F,X,te)=>I(re=>{const ce=this.f[this.f.length-1];ce?ce.push(()=>F.call(X,re)):F.call(X,re)},void 0,te)}bufferEvents(I){const F=[];this.f.push(F);const X=I();return this.f.pop(),F.forEach(te=>te()),X}}t.$Td=j;class z{constructor(){this.f=!1,this.g=f.None,this.h=i.$Qc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(I){this.g=I,this.f&&(this.h.dispose(),this.h=I(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Ud=z}),define(be[16],$e([1,0,3,2]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hO=t.$gO=t.$fO=t.$eO=t.$dO=t.$cO=t.$bO=t.$aO=t.$_N=t.$$N=t.$0N=t.$9N=t.$8N=t.$7N=t.$6N=t.$5N=t.$4N=t.$3N=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new y.$Ld,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel($){this.a!==$&&(this.a=$)}getZoomFactor(){return this.b}setZoomFactor($){this.b=$}setFullscreen($){this.c!==$&&(this.c=$,this.d.fire())}isFullscreen(){return this.c}}class U extends N.$Qc{constructor(){super(),this.a=this.B(new y.$Ld),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f($){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),$&&this.a.fire()}}class w extends N.$Qc{get value(){return this.b}constructor(){super(),this.a=this.B(new y.$Ld),this.onDidChange=this.a.event,this.b=this.c();const $=this.B(new U);this.B($.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const $=document.createElement("canvas").getContext("2d"),c=window.devicePixelRatio||1,o=$.webkitBackingStorePixelRatio||$.mozBackingStorePixelRatio||$.msBackingStorePixelRatio||$.oBackingStorePixelRatio||$.backingStorePixelRatio||1;return c/o}}class D{constructor(){this.a=null}b(){return this.a||(this.a=(0,N.$Jc)(new w)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function h(r,$){typeof r=="string"&&(r=window.matchMedia(r)),r.addEventListener("change",$)}t.$3N=h,t.$4N=new D;function f(r){i.INSTANCE.setZoomLevel(r)}t.$5N=f;function d(){return i.INSTANCE.getZoomLevel()}t.$6N=d;function L(){return i.INSTANCE.getZoomFactor()}t.$7N=L;function s(r){i.INSTANCE.setZoomFactor(r)}t.$8N=s;function a(r){i.INSTANCE.setFullscreen(r)}t.$9N=a;function e(){return i.INSTANCE.isFullscreen()}t.$0N=e,t.$$N=i.INSTANCE.onDidChangeFullscreen;const u=navigator.userAgent;t.$_N=u.indexOf("Firefox")>=0,t.$aO=u.indexOf("AppleWebKit")>=0,t.$bO=u.indexOf("Chrome")>=0,t.$cO=!t.$bO&&u.indexOf("Safari")>=0,t.$dO=!t.$bO&&!t.$cO&&t.$aO,t.$eO=u.indexOf("Electron/")>=0,t.$fO=u.indexOf("Android")>=0;let l=!1;if(window.matchMedia){const r=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),$=window.matchMedia("(display-mode: fullscreen)");l=r.matches,h(r,({matches:c})=>{l&&$.matches||(l=c)})}function m(){return l}t.$gO=m;function n(){return navigator?.windowControlsOverlay?.visible}t.$hO=n}),define(be[21],$e([1,0,3]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iQ=void 0;class N{get event(){return this.a.event}constructor(U,w,D){const h=f=>this.a.fire(f);this.a=new y.$Ld({onWillAddFirstListener:()=>U.addEventListener(w,h,D),onDidRemoveLastListener:()=>U.removeEventListener(w,h,D)})}dispose(){this.a.dispose()}}t.$iQ=N}),define(be[27],$e([1,0,3]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=t.CancellationToken=void 0;const N=Object.freeze(function(D,h){const f=setTimeout(D.bind(h),0);return{dispose(){clearTimeout(f)}}});var i;(function(D){function h(f){return f===D.None||f===D.Cancelled||f instanceof U?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}D.isCancellationToken=h,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new y.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$Vd=w}),define(be[82],$e([1,0,27]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=t.$ve=t.$ue=void 0;class N{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new y.$Vd,h=this.b(D.token);return this.a={promise:h,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$ue=N;class i{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const h=JSON.stringify(D);return this.b!==h&&(this.b=h,this.a=this.c(D)),this.a}}t.$ve=i;class U{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const h=this.b(D);return this.a.set(D,h),h}}t.$we=U}),define(be[47],$e([1,0,3,2]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rr=t.$Qr=t.$Pr=t.$Or=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,u,l,m,n,r,$){this.c=e,this._scrollStateBrand=void 0,this.c&&(u=u|0,l=l|0,m=m|0,n=n|0,r=r|0,$=$|0),this.rawScrollLeft=m,this.rawScrollTop=$,u<0&&(u=0),m+u>l&&(m=l-u),m<0&&(m=0),n<0&&(n=0),$+n>r&&($=r-n),$<0&&($=0),this.width=u,this.scrollWidth=l,this.scrollLeft=m,this.height=n,this.scrollHeight=r,this.scrollTop=$}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,u){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,u?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,u?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,u){const l=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,$=this.scrollHeight!==e.scrollHeight,c=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:u,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:m,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:$,scrollTopChanged:c}}}t.$Or=U;class w extends N.$Qc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new y.$Ld),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,u){const l=this.g.withScrollDimensions(e,u);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const u=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(u,!1)}setScrollPositionSmooth(e,u){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let m;u?m=new d(this.h.from,l,this.h.startTime,this.h.duration):m=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=m}else{const l=this.g.withScrollPosition(e);this.h=d.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),u=this.g.withScrollPosition(e);if(this.n(u,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,u){const l=this.g;l.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(l,u)))}}t.$Pr=w;class D{constructor(e,u,l){this.scrollLeft=e,this.scrollTop=u,this.isDone=l}}t.$Qr=D;function h(a,e){const u=e-a;return function(l){return a+u*s(l)}}function f(a,e,u){return function(l){return l<u?a(l/u):e((l-u)/(1-u))}}class d{constructor(e,u,l,m){this.from=e,this.to=u,this.duration=m,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,u,l){if(Math.abs(e-u)>2.5*l){let n,r;return e<u?(n=e+.75*l,r=u-.75*l):(n=e-.75*l,r=u+.75*l),f(h(e,n),h(r,u),.33)}return h(e,u)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const u=(e-this.startTime)/this.duration;if(u<1){const l=this.c(u),m=this.d(u);return new D(l,m,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,u,l){return d.start(e,u,l)}static start(e,u,l){l=l+10;const m=Date.now()-10;return new d(e,u,m,l)}}t.$Rr=d;function L(a){return Math.pow(a,3)}function s(a){return 1-L(1-a)}}),define(be[83],$e([1,0,6,2]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=void 0;function i($){const c=$;return c?typeof c.read=="function":!1}t.$Wd=i;function U($){const c=$;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}t.$Xd=U;function w($){const c=$;return c?U(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}t.$Yd=w;function D($,c){return new h($,c)}t.$Zd=D;class h{constructor(c,o){this.e=c,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(o=>o(c))}h(c){this.c.error.length===0?(0,y.$Y)(c):this.c.error.slice(0).forEach(o=>o(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,o){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(c,o){if(this.a.destroyed)return;let C;switch(c){case"data":C=this.c.data;break;case"end":C=this.c.end;break;case"error":C=this.c.error;break}if(C){const R=C.indexOf(o);R>=0&&C.splice(R,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(C=>C())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f($,c){const o=[];let C;for(;(C=$.read())!==null;)o.push(C);return c(o)}t.$1d=f;function d($,c,o){const C=[];let R;for(;(R=$.read())!==null&&C.length<o;)C.push(R);return R===null&&C.length>0?c(C):{read:()=>{if(C.length>0)return C.shift();if(typeof R<"u"){const M=R;return R=void 0,M}return $.read()}}}t.$2d=d;function L($,c){return new Promise((o,C)=>{const R=[];s($,{onData:M=>{c&&R.push(M)},onError:M=>{c?C(M):o(void 0)},onEnd:()=>{o(c?c(R):void 0)}})})}t.$3d=L;function s($,c,o){$.on("error",C=>{o?.isCancellationRequested||c.onError(C)}),$.on("end",()=>{o?.isCancellationRequested||c.onEnd()}),$.on("data",C=>{o?.isCancellationRequested||c.onData(C)})}t.$4d=s;function a($,c){return new Promise((o,C)=>{const R=new N.$Pc,M=[],b=z=>{if(M.push(z),M.length>c)return R.dispose(),$.pause(),o({stream:$,buffer:M,ended:!1})},v=z=>(R.dispose(),C(z)),j=()=>(R.dispose(),o({stream:$,buffer:M,ended:!0}));R.add((0,N.$Oc)(()=>$.removeListener("error",v))),$.on("error",v),R.add((0,N.$Oc)(()=>$.removeListener("end",j))),$.on("end",j),R.add((0,N.$Oc)(()=>$.removeListener("data",b))),$.on("data",b)})}t.$5d=a;function e($,c){const o=D(c);return o.end($),o}t.$6d=e;function u(){const $=D(()=>{throw new Error("not supported")});return $.end(),$}t.$7d=u;function l($){let c=!1;return{read:()=>c?null:(c=!0,$)}}t.$8d=l;function m($,c,o){const C=D(o);return s($,{onData:R=>C.write(c.data(R)),onError:R=>C.error(c.error?c.error(R):R),onEnd:()=>C.end()}),C}t.$9d=m;function n($,c,o){let C=!1;return{read:()=>{const R=c.read();return C?R:(C=!0,R!==null?o([$,R]):$)}}}t.$0d=n;function r($,c,o){let C=!1;const R=D(o);return s(c,{onData:M=>C?R.write(M):(C=!0,R.write(o([$,M]))),onError:M=>R.error(M),onEnd:()=>{C||(C=!0,R.write($)),R.end()}}),R}t.$$d=r}),define(be[32],$e([1,0,30,83]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=void 0;const i=typeof Buffer<"u",U=new y.$T(()=>new Uint8Array(256));let w,D;class h{static alloc(F){return i?new h(Buffer.allocUnsafe(F)):new h(new Uint8Array(F))}static wrap(F){return i&&!Buffer.isBuffer(F)&&(F=Buffer.from(F.buffer,F.byteOffset,F.byteLength)),new h(F)}static fromString(F,X){return!(X?.dontUseNodeBuffer||!1)&&i?new h(Buffer.from(F)):(w||(w=new TextEncoder),new h(w.encode(F)))}static fromByteArray(F){const X=h.alloc(F.length);for(let te=0,re=F.length;te<re;te++)X.buffer[te]=F[te];return X}static concat(F,X){if(typeof X>"u"){X=0;for(let ce=0,le=F.length;ce<le;ce++)X+=F[ce].byteLength}const te=h.alloc(X);let re=0;for(let ce=0,le=F.length;ce<le;ce++){const ae=F[ce];te.set(ae,re),re+=ae.byteLength}return te}constructor(F){this.buffer=F,this.byteLength=this.buffer.byteLength}clone(){const F=h.alloc(this.byteLength);return F.set(this),F}toString(){return i?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(F,X){return new h(this.buffer.subarray(F,X))}set(F,X){if(F instanceof h)this.buffer.set(F.buffer,X);else if(F instanceof Uint8Array)this.buffer.set(F,X);else if(F instanceof ArrayBuffer)this.buffer.set(new Uint8Array(F),X);else if(ArrayBuffer.isView(F))this.buffer.set(new Uint8Array(F.buffer,F.byteOffset,F.byteLength),X);else throw new Error("Unknown argument 'array'")}readUInt32BE(F){return s(this.buffer,F)}writeUInt32BE(F,X){a(this.buffer,F,X)}readUInt32LE(F){return e(this.buffer,F)}writeUInt32LE(F,X){u(this.buffer,F,X)}readUInt8(F){return l(this.buffer,F)}writeUInt8(F,X){m(this.buffer,F,X)}indexOf(F,X=0){return f(this.buffer,F instanceof h?F.buffer:F,X)}}t.$_d=h;function f(I,F,X=0){const te=F.byteLength,re=I.byteLength;if(te===0)return 0;if(te===1)return I.indexOf(F[0]);if(te>re-X)return-1;const ce=U.value;ce.fill(F.length);for(let ke=0;ke<F.length;ke++)ce[F[ke]]=F.length-ke-1;let le=X+F.length-1,ae=le,me=-1;for(;le<re;)if(I[le]===F[ae]){if(ae===0){me=le;break}le--,ae--}else le+=Math.max(F.length-ae,ce[I[le]]),ae=F.length-1;return me}t.$ae=f;function d(I,F){return I[F+0]<<0>>>0|I[F+1]<<8>>>0}t.$be=d;function L(I,F,X){I[X+0]=F&255,F=F>>>8,I[X+1]=F&255}t.$ce=L;function s(I,F){return I[F]*2**24+I[F+1]*2**16+I[F+2]*2**8+I[F+3]}t.$de=s;function a(I,F,X){I[X+3]=F,F=F>>>8,I[X+2]=F,F=F>>>8,I[X+1]=F,F=F>>>8,I[X]=F}t.$ee=a;function e(I,F){return I[F+0]<<0>>>0|I[F+1]<<8>>>0|I[F+2]<<16>>>0|I[F+3]<<24>>>0}t.$fe=e;function u(I,F,X){I[X+0]=F&255,F=F>>>8,I[X+1]=F&255,F=F>>>8,I[X+2]=F&255,F=F>>>8,I[X+3]=F&255}t.$ge=u;function l(I,F){return I[F]}t.$he=l;function m(I,F,X){I[X]=F}t.$ie=m;function n(I){return N.$1d(I,F=>h.concat(F))}t.$je=n;function r(I){return N.$8d(I)}t.$ke=r;function $(I){return N.$3d(I,F=>h.concat(F))}t.$le=$;async function c(I){return I.ended?h.concat(I.buffer):h.concat([...I.buffer,await $(I.stream)])}t.$me=c;function o(I){return N.$6d(I,F=>h.concat(F))}t.$ne=o;function C(I){return N.$9d(I,{data:F=>typeof F=="string"?h.fromString(F):h.wrap(F)},F=>h.concat(F))}t.$oe=C;function R(I){return N.$Zd(F=>h.concat(F),I)}t.$pe=R;function M(I,F){return N.$0d(I,F,X=>h.concat(X))}t.$qe=M;function b(I,F){return N.$$d(I,F,X=>h.concat(X))}t.$re=b;function v(I){let F=0,X=0,te=0;const re=new Uint8Array(Math.floor(I.length/4*3)),ce=ae=>{switch(X){case 3:re[te++]=F|ae,X=0;break;case 2:re[te++]=F|ae>>>2,F=ae<<6,X=3;break;case 1:re[te++]=F|ae>>>4,F=ae<<4,X=2;break;default:F=ae<<2,X=1}};for(let ae=0;ae<I.length;ae++){const me=I.charCodeAt(ae);if(me>=65&&me<=90)ce(me-65);else if(me>=97&&me<=122)ce(me-97+26);else if(me>=48&&me<=57)ce(me-48+52);else if(me===43||me===45)ce(62);else if(me===47||me===95)ce(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${I[ae]}`)}}const le=te;for(;X>0;)ce(0);return h.wrap(re).slice(0,le)}t.$se=v;const j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:I},F=!0,X=!1){const te=X?z:j;let re="";const ce=I.byteLength%3;let le=0;for(;le<I.byteLength-ce;le+=3){const ae=I[le+0],me=I[le+1],ke=I[le+2];re+=te[ae>>>2],re+=te[(ae<<4|me>>>4)&63],re+=te[(me<<2|ke>>>6)&63],re+=te[ke&63]}if(ce===1){const ae=I[le+0];re+=te[ae>>>2],re+=te[ae<<4&63],F&&(re+="==")}else if(ce===2){const ae=I[le+0],me=I[le+1];re+=te[ae>>>2],re+=te[(ae<<4|me>>>4)&63],re+=te[me<<2&63],F&&(re+="=")}return re}t.$te=W}),define(be[12],$e([1,0,82,30]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vf=t.$uf=t.$tf=t.$sf=t.GraphemeBreakType=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=void 0;function i(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}t.$ze=i;const U=/{(\d+)}/g;function w(Z,...he){return he.length===0?Z:Z.replace(U,function(pe,De){const Ce=parseInt(De,10);return isNaN(Ce)||Ce<0||Ce>=he.length?pe:he[Ce]})}t.$Ae=w;const D=/{([^}]+)}/g;function h(Z,he){return Z.replace(D,(pe,De)=>he[De]??pe)}t.$Be=h;function f(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$Ce=f;function d(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$De=d;function L(Z,he){let pe=0;const De=he.charCodeAt(0);for(let Ce=Z.length-1;Ce>=0;Ce--)Z.charCodeAt(Ce)===De&&pe++;return pe}t.$Ee=L;function s(Z,he,pe="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${pe}`}t.$Fe=s;function a(Z,he=" "){const pe=e(Z,he);return u(pe,he)}t.$Ge=a;function e(Z,he){if(!Z||!he)return Z;const pe=he.length;if(pe===0||Z.length===0)return Z;let De=0;for(;Z.indexOf(he,De)===De;)De=De+pe;return Z.substring(De)}t.$He=e;function u(Z,he){if(!Z||!he)return Z;const pe=he.length,De=Z.length;if(pe===0||De===0)return Z;let Ce=De,Re=-1;for(;Re=Z.lastIndexOf(he,Ce-1),!(Re===-1||Re+pe!==Ce);){if(Re===0)return"";Ce=Re}return Z.substring(0,Ce)}t.$Ie=u;function l(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Je=l;function m(Z){return Z.replace(/\*/g,"")}t.$Ke=m;function n(Z,he,pe={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=d(Z)),pe.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let De="";return pe.global&&(De+="g"),pe.matchCase||(De+="i"),pe.multiline&&(De+="m"),pe.unicode&&(De+="u"),new RegExp(Z,De)}t.$Le=n;function r(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}t.$Me=r;function $(Z){return Z.split(/\r\n|\r|\n/)}t.$Ne=$;function c(Z){for(let he=0,pe=Z.length;he<pe;he++){const De=Z.charCodeAt(he);if(De!==32&&De!==9)return he}return-1}t.$Oe=c;function o(Z,he=0,pe=Z.length){for(let De=he;De<pe;De++){const Ce=Z.charCodeAt(De);if(Ce!==32&&Ce!==9)return Z.substring(he,De)}return Z.substring(he,pe)}t.$Pe=o;function C(Z,he=Z.length-1){for(let pe=he;pe>=0;pe--){const De=Z.charCodeAt(pe);if(De!==32&&De!==9)return pe}return-1}t.$Qe=C;function R(Z,he,pe){const De=[];let Ce=0;for(const Re of Z.matchAll(he)){if(De.push(Z.slice(Ce,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ce=Re.index+Re[0].length,De.push(pe(Re[0],...Re.slice(1),Re.index,Z,Re.groups))}return De.push(Z.slice(Ce)),Promise.all(De).then(Re=>Re.join(""))}t.$Re=R;function M(Z,he){return Z<he?-1:Z>he?1:0}t.$Se=M;function b(Z,he,pe=0,De=Z.length,Ce=0,Re=he.length){for(;pe<De&&Ce<Re;pe++,Ce++){const Ye=Z.charCodeAt(pe),Ve=he.charCodeAt(Ce);if(Ye<Ve)return-1;if(Ye>Ve)return 1}const ze=De-pe,Ke=Re-Ce;return ze<Ke?-1:ze>Ke?1:0}t.$Te=b;function v(Z,he){return j(Z,he,0,Z.length,0,he.length)}t.$Ue=v;function j(Z,he,pe=0,De=Z.length,Ce=0,Re=he.length){for(;pe<De&&Ce<Re;pe++,Ce++){let Ye=Z.charCodeAt(pe),Ve=he.charCodeAt(Ce);if(Ye===Ve)continue;if(Ye>=128||Ve>=128)return b(Z.toLowerCase(),he.toLowerCase(),pe,De,Ce,Re);W(Ye)&&(Ye-=32),W(Ve)&&(Ve-=32);const _e=Ye-Ve;if(_e!==0)return _e}const ze=De-pe,Ke=Re-Ce;return ze<Ke?-1:ze>Ke?1:0}t.$Ve=j;function z(Z){return Z>=48&&Z<=57}t.$We=z;function W(Z){return Z>=97&&Z<=122}t.$Xe=W;function I(Z){return Z>=65&&Z<=90}t.$Ye=I;function F(Z,he){return Z.length===he.length&&j(Z,he)===0}t.$Ze=F;function X(Z,he){const pe=he.length;return he.length>Z.length?!1:j(Z,he,0,pe)===0}t.$1e=X;function te(Z,he){const pe=Math.min(Z.length,he.length);let De;for(De=0;De<pe;De++)if(Z.charCodeAt(De)!==he.charCodeAt(De))return De;return pe}t.$2e=te;function re(Z,he){const pe=Math.min(Z.length,he.length);let De;const Ce=Z.length-1,Re=he.length-1;for(De=0;De<pe;De++)if(Z.charCodeAt(Ce-De)!==he.charCodeAt(Re-De))return De;return pe}t.$3e=re;function ce(Z){return 55296<=Z&&Z<=56319}t.$4e=ce;function le(Z){return 56320<=Z&&Z<=57343}t.$5e=le;function ae(Z,he){return(Z-55296<<10)+(he-56320)+65536}t.$6e=ae;function me(Z,he,pe){const De=Z.charCodeAt(pe);if(ce(De)&&pe+1<he){const Ce=Z.charCodeAt(pe+1);if(le(Ce))return ae(De,Ce)}return De}t.$7e=me;function ke(Z,he){const pe=Z.charCodeAt(he-1);if(le(pe)&&he>1){const De=Z.charCodeAt(he-2);if(ce(De))return ae(De,pe)}return pe}class Le{get offset(){return this.e}constructor(he,pe=0){this.c=he,this.d=he.length,this.e=pe}setOffset(he){this.e=he}prevCodePoint(){const he=ke(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=me(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$8e=Le;class Pe{get offset(){return this.c.offset}constructor(he,pe=0){this.c=new Le(he,pe)}nextGraphemeLength(){const he=Ae.getInstance(),pe=this.c,De=pe.offset;let Ce=he.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,ze=he.getGraphemeBreakType(pe.nextCodePoint());if(we(Ce,ze)){pe.setOffset(Re);break}Ce=ze}return pe.offset-De}prevGraphemeLength(){const he=Ae.getInstance(),pe=this.c,De=pe.offset;let Ce=he.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,ze=he.getGraphemeBreakType(pe.prevCodePoint());if(we(ze,Ce)){pe.setOffset(Re);break}Ce=ze}return De-pe.offset}eol(){return this.c.eol()}}t.$9e=Pe;function de(Z,he){return new Pe(Z,he).nextGraphemeLength()}t.$0e=de;function ne(Z,he){return new Pe(Z,he).prevGraphemeLength()}t.$$e=ne;function Q(Z,he){he>0&&le(Z.charCodeAt(he))&&he--;const pe=he+de(Z,he);return[pe-ne(Z,pe),pe]}t.$_e=Q;function V(Z){const he=new Pe(Z);let pe=0;for(;!he.eol();)pe++,he.nextGraphemeLength();return pe}t.$af=V;let ee;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function k(Z){return ee||(ee=J()),ee.test(Z)}t.$bf=k;const K=/^[\t\n\r\x20-\x7E]*$/;function g(Z){return K.test(Z)}t.$cf=g,t.$df=/[\u2028\u2029]/;function p(Z){return t.$df.test(Z)}t.$ef=p;function q(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}t.$ff=q;function T(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}t.$gf=T;function P(Z,he){if(Z.length<he)return Z;const pe=/\b/g;let De=0;for(;pe.test(Z)&&!(Z.length-pe.lastIndex<he);)De=pe.lastIndex,pe.lastIndex+=1;return Z.substring(De).replace(/^\s/,"")}t.$hf=P;const O=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,_=/\x1b\].*?\x07/g;function S(Z){return Z&&(Z=Z.replace(O,"").replace(_,"")),Z}t.$if=S,t.$jf=String.fromCharCode(65279);function B(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}t.$kf=B;function E(Z){return B(Z)?Z.substr(1):Z}t.$lf=E;function A(Z,he){if(!Z||!he||Z.length<he.length)return!1;const pe=he.length,De=Z.toLowerCase();let Ce=0,Re=-1;for(;Ce<pe;){const ze=De.indexOf(he[Ce],Re+1);if(ze<0)return!1;Re=ze,Ce++}return!0}t.$mf=A;function H(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}t.$nf=H;function x(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}t.$of=x;function ie(Z,he=1){if(he===0)return"";let pe=-1;do pe=Z.indexOf(`
`,pe+1),he--;while(he>0&&pe>=0);return pe===-1?Z:(Z[pe-1]==="\r"&&pe--,Z.substr(0,pe))}t.$pf=ie;function se(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}t.$qf=se;function ge(Z){return Ae.getInstance().getGraphemeBreakType(Z)}t.$rf=ge;function we(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var Fe;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(t.GraphemeBreakType=Fe={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=ve()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const pe=this.d,De=pe.length/3;let Ce=1;for(;Ce<=De;)if(he<pe[3*Ce])Ce=2*Ce;else if(he>pe[3*Ce+1])Ce=2*Ce+1;else return pe[3*Ce+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(Z,he){if(Z===0)return 0;const pe=Oe(Z,he);if(pe!==void 0)return pe;const De=new Le(he,Z);return De.prevCodePoint(),De.offset}t.$sf=Ie;function Oe(Z,he){const pe=new Le(he,Z);let De=pe.prevCodePoint();for(;qe(De)||De===65039||De===8419;){if(pe.offset===0)return;De=pe.prevCodePoint()}if(!T(De))return;let Ce=pe.offset;return Ce>0&&pe.prevCodePoint()===8205&&(Ce=pe.offset),Ce}function qe(Z){return 127995<=Z&&Z<=127999}var je;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$tf="\xA0";class Me{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$ve(he=>{function pe(_e){const et=new Map;for(let tt=0;tt<_e.length;tt+=2)et.set(_e[tt],_e[tt+1]);return et}function De(_e,et){const tt=new Map(_e);for(const[ft,ct]of et)tt.set(ft,ct);return tt}function Ce(_e,et){if(!_e)return et;const tt=new Map;for(const[ft,ct]of _e)et.has(ft)&&tt.set(ft,ct);return tt}const Re=this.c.value;let ze=he.filter(_e=>!_e.startsWith("_")&&_e in Re);ze.length===0&&(ze=["_default"]);let Ke;for(const _e of ze){const et=pe(Re[_e]);Ke=Ce(Ke,et)}const Ye=pe(Re._common),Ve=De(Ye,Ke);return new Me(Ve)})}static getInstance(he){return Me.d.get(Array.from(he))}static{this.e=new N.$T(()=>Object.keys(Me.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$uf=Me;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(he){return Ge.e().has(he)}static get codePoints(){return Ge.e()}}t.$vf=Ge}),define(be[33],$e([1,0,31,12]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.FuzzyScore=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.$Bj=t.$Aj=t.$zj=t.or=void 0;function i(...E){return function(A,H){for(let x=0,ie=E.length;x<ie;x++){const se=E[x](A,H);if(se)return se}return null}}t.or=i,t.$zj=U.bind(void 0,!1),t.$Aj=U.bind(void 0,!0);function U(E,A,H){if(!H||H.length<A.length)return null;let x;return E?x=N.$1e(H,A):x=H.indexOf(A)===0,x?A.length>0?[{start:0,end:A.length}]:[]:null}function w(E,A){const H=A.toLowerCase().indexOf(E.toLowerCase());return H===-1?null:[{start:H,end:H+E.length}]}t.$Bj=w;function D(E,A){return h(E.toLowerCase(),A.toLowerCase(),0,0)}t.$Cj=D;function h(E,A,H,x){if(H===E.length)return[];if(x===A.length)return null;if(E[H]===A[x]){let ie=null;return(ie=h(E,A,H+1,x+1))?m({start:x,end:x+1},ie):null}return h(E,A,H,x+1)}function f(E){return 97<=E&&E<=122}function d(E){return 65<=E&&E<=90}t.$Dj=d;function L(E){return 48<=E&&E<=57}function s(E){return E===32||E===9||E===10||E===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(E=>a.add(E.charCodeAt(0)));function e(E){return s(E)||a.has(E)}function u(E,A){return E===A||e(E)&&e(A)}function l(E){return f(E)||d(E)||L(E)}function m(E,A){return A.length===0?A=[E]:E.end===A[0].start?A[0].start=E.start:A.unshift(E),A}function n(E,A){for(let H=A;H<E.length;H++){const x=E.charCodeAt(H);if(d(x)||L(x)||H>0&&!l(E.charCodeAt(H-1)))return H}return E.length}function r(E,A,H,x){if(H===E.length)return[];if(x===A.length)return null;if(E[H]!==A[x].toLowerCase())return null;{let ie=null,se=x+1;for(ie=r(E,A,H+1,x+1);!ie&&(se=n(A,se))<A.length;)ie=r(E,A,H+1,se),se++;return ie===null?null:m({start:x,end:x+1},ie)}}function $(E){let A=0,H=0,x=0,ie=0,se=0;for(let ve=0;ve<E.length;ve++)se=E.charCodeAt(ve),d(se)&&A++,f(se)&&H++,l(se)&&x++,L(se)&&ie++;const ge=A/E.length,we=H/E.length,Fe=x/E.length,Ae=ie/E.length;return{upperPercent:ge,lowerPercent:we,alphaPercent:Fe,numericPercent:Ae}}function c(E){const{upperPercent:A,lowerPercent:H}=E;return H===0&&A>.6}function o(E){const{upperPercent:A,lowerPercent:H,alphaPercent:x,numericPercent:ie}=E;return H>.2&&A<.8&&x>.6&&ie<.2}function C(E){let A=0,H=0,x=0,ie=0;for(let se=0;se<E.length;se++)x=E.charCodeAt(se),d(x)&&A++,f(x)&&H++,s(x)&&ie++;return(A===0||H===0)&&ie===0?E.length<=30:A<=5}function R(E,A){if(!A||(A=A.trim(),A.length===0)||!C(E)||A.length>60)return null;const H=$(A);if(!o(H)){if(!c(H))return null;A=A.toLowerCase()}let x=null,ie=0;for(E=E.toLowerCase();ie<A.length&&(x=r(E,A,0,ie))===null;)ie=n(A,ie+1);return x}t.$Ej=R;function M(E,A,H=!1){if(!A||A.length===0)return null;let x=null,ie=0;for(E=E.toLowerCase(),A=A.toLowerCase();ie<A.length&&(x=b(E,A,0,ie,H))===null;)ie=v(A,ie+1);return x}t.$Fj=M;function b(E,A,H,x,ie){if(H===E.length)return[];if(x===A.length)return null;if(u(E.charCodeAt(H),A.charCodeAt(x))){let se=null,ge=x+1;if(se=b(E,A,H+1,x+1,ie),!ie)for(;!se&&(ge=v(A,ge))<A.length;)se=b(E,A,H+1,ge,ie),ge++;return se?E.charCodeAt(H)!==A.charCodeAt(x)?se:m({start:x,end:x+1},se):null}else return null}function v(E,A){for(let H=A;H<E.length;H++)if(e(E.charCodeAt(H))||H>0&&e(E.charCodeAt(H-1)))return H;return E.length}const j=i(t.$Aj,R,w),z=i(t.$Aj,R,D),W=new y.$Bc(1e4);function I(E,A,H=!1){if(typeof E!="string"||typeof A!="string")return null;let x=W.get(E);x||(x=new RegExp(N.$Je(E),"i"),W.set(E,x));const ie=x.exec(A);return ie?[{start:ie.index,end:ie.index+ie[0].length}]:H?z(E,A):j(E,A)}t.$Gj=I;function F(E,A){const H=q(E,E.toLowerCase(),0,A,A.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?te(H):null}t.$Hj=F;function X(E,A,H,x,ie,se){const ge=Math.min(13,E.length);for(;H<ge;H++){const we=q(E,A,H,x,ie,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,se]}t.$Ij=X;function te(E){if(typeof E>"u")return[];const A=[],H=E[1];for(let x=E.length-1;x>1;x--){const ie=E[x]+H,se=A[A.length-1];se&&se.end===ie?se.end=ie+1:A.push({start:ie,end:ie+1})}return A}t.$Jj=te;const re=128;function ce(){const E=[],A=[];for(let H=0;H<=re;H++)A[H]=0;for(let H=0;H<=re;H++)E.push(A.slice(0));return E}function le(E){const A=[];for(let H=0;H<=E;H++)A[H]=0;return A}const ae=le(2*re),me=le(2*re),ke=ce(),Le=ce(),Pe=ce(),de=!1;function ne(E,A,H,x,ie){function se(we,Fe,Ae=" "){for(;we.length<Fe;)we=Ae+we;return we}let ge=` |   |${x.split("").map(we=>se(we,3)).join("|")}
`;for(let we=0;we<=H;we++)we===0?ge+=" |":ge+=`${A[we-1]}|`,ge+=E[we].slice(0,ie+1).map(Fe=>se(Fe.toString(),3)).join("|")+`
`;return ge}function Q(E,A,H,x){E=E.substr(A),H=H.substr(x),console.log(ne(Le,E,E.length,H,H.length)),console.log(ne(Pe,E,E.length,H,H.length)),console.log(ne(ke,E,E.length,H,H.length))}function V(E,A){if(A<0||A>=E.length)return!1;const H=E.codePointAt(A);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!N.$gf(H)}}function ee(E,A){if(A<0||A>=E.length)return!1;switch(E.charCodeAt(A)){case 32:case 9:return!0;default:return!1}}function J(E,A,H){return A[E]!==H[E]}function k(E,A,H,x,ie,se,ge=!1){for(;A<H&&ie<se;)E[A]===x[ie]&&(ge&&(ae[A]=ie),A+=1),ie+=1;return A===H}t.$Kj=k;var K;(function(E){E[E.Diag=1]="Diag",E[E.Left=2]="Left",E[E.LeftLeft=3]="LeftLeft"})(K||(K={}));var g;(function(E){E.Default=[-100,0];function A(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}E.isDefault=A})(g||(t.FuzzyScore=g={}));class p{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(A,H){this.firstMatchCanBeWeak=A,this.boostFullMatch=H}}t.$Lj=p;function q(E,A,H,x,ie,se,ge=p.default){const we=E.length>re?re:E.length,Fe=x.length>re?re:x.length;if(H>=we||se>=Fe||we-H>Fe-se||!k(A,H,we,ie,se,Fe,!0))return;T(we,Fe,H,se,A,ie);let Ae=1,ve=1,Ie=H,Oe=se;const qe=[!1];for(Ae=1,Ie=H;Ie<we;Ae++,Ie++){const he=ae[Ie],pe=me[Ie],De=Ie+1<we?me[Ie+1]:Fe;for(ve=he-se+1,Oe=he;Oe<De;ve++,Oe++){let Ce=Number.MIN_SAFE_INTEGER,Re=!1;Oe<=pe&&(Ce=P(E,A,Ie,H,x,ie,Oe,Fe,se,ke[Ae-1][ve-1]===0,qe));let ze=0;Ce!==Number.MAX_SAFE_INTEGER&&(Re=!0,ze=Ce+Le[Ae-1][ve-1]);const Ke=Oe>he,Ye=Ke?Le[Ae][ve-1]+(ke[Ae][ve-1]>0?-5:0):0,Ve=Oe>he+1&&ke[Ae][ve-1]>0,_e=Ve?Le[Ae][ve-2]+(ke[Ae][ve-2]>0?-5:0):0;if(Ve&&(!Ke||_e>=Ye)&&(!Re||_e>=ze))Le[Ae][ve]=_e,Pe[Ae][ve]=3,ke[Ae][ve]=0;else if(Ke&&(!Re||Ye>=ze))Le[Ae][ve]=Ye,Pe[Ae][ve]=2,ke[Ae][ve]=0;else if(Re)Le[Ae][ve]=ze,Pe[Ae][ve]=1,ke[Ae][ve]=ke[Ae-1][ve-1]+1;else throw new Error("not possible")}}if(de&&Q(E,H,x,se),!qe[0]&&!ge.firstMatchCanBeWeak)return;Ae--,ve--;const je=[Le[Ae][ve],se];let Me=0,Ge=0;for(;Ae>=1;){let he=ve;do{const pe=Pe[Ae][he];if(pe===3)he=he-2;else if(pe===2)he=he-1;else break}while(he>=1);Me>1&&A[H+Ae-1]===ie[se+ve-1]&&!J(he+se-1,x,ie)&&Me+1>ke[Ae][he]&&(he=ve),he===ve?Me++:Me=1,Ge||(Ge=he),Ae--,ve=he-1,je.push(ve)}Fe===we&&ge.boostFullMatch&&(je[0]+=2);const Z=Ge-we;return je[0]-=Z,je}t.$Mj=q;function T(E,A,H,x,ie,se){let ge=E-1,we=A-1;for(;ge>=H&&we>=x;)ie[ge]===se[we]&&(me[ge]=we,ge--),we--}function P(E,A,H,x,ie,se,ge,we,Fe,Ae,ve){if(A[H]!==se[ge])return Number.MIN_SAFE_INTEGER;let Ie=1,Oe=!1;return ge===H-x?Ie=E[H]===ie[ge]?7:5:J(ge,ie,se)&&(ge===0||!J(ge-1,ie,se))?(Ie=E[H]===ie[ge]?7:5,Oe=!0):V(se,ge)&&(ge===0||!V(se,ge-1))?Ie=5:(V(se,ge-1)||ee(se,ge-1))&&(Ie=5,Oe=!0),Ie>1&&H===x&&(ve[0]=!0),Oe||(Oe=J(ge,ie,se)||V(se,ge-1)||ee(se,ge-1)),H===x?ge>Fe&&(Ie-=Oe?3:5):Ae?Ie+=Oe?2:0:Ie+=Oe?0:1,ge+1===we&&(Ie-=Oe?3:5),Ie}function O(E,A,H,x,ie,se,ge){return S(E,A,H,x,ie,se,!0,ge)}t.$Nj=O;function _(E,A,H,x,ie,se,ge){return S(E,A,H,x,ie,se,!1,ge)}t.$Oj=_;function S(E,A,H,x,ie,se,ge,we){let Fe=q(E,A,H,x,ie,se,we);if(Fe&&!ge)return Fe;if(E.length>=3){const Ae=Math.min(7,E.length-1);for(let ve=H+1;ve<Ae;ve++){const Ie=B(E,ve);if(Ie){const Oe=q(Ie,Ie.toLowerCase(),H,x,ie,se,we);Oe&&(Oe[0]-=3,(!Fe||Oe[0]>Fe[0])&&(Fe=Oe))}}}return Fe}function B(E,A){if(A+1>=E.length)return;const H=E[A],x=E[A+1];if(H!==x)return E.slice(0,A)+x+H+E.slice(A+2)}}),define(be[84],$e([1,0,12]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gi=t.$Fi=t.$Ei=t.$Di=t.$Ci=t.$Bi=t.$Ai=void 0;function N(m){return i(m,0)}t.$Ai=N;function i(m,n){switch(typeof m){case"object":return m===null?U(349,n):Array.isArray(m)?h(m,n):f(m,n);case"string":return D(m,n);case"boolean":return w(m,n);case"number":return U(m,n);case"undefined":return U(937,n);default:return U(617,n)}}t.$Bi=i;function U(m,n){return(n<<5)-n+m|0}t.$Ci=U;function w(m,n){return U(m?433:863,n)}function D(m,n){n=U(149417,n);for(let r=0,$=m.length;r<$;r++)n=U(m.charCodeAt(r),n);return n}t.$Di=D;function h(m,n){return n=U(104579,n),m.reduce((r,$)=>i($,r),n)}function f(m,n){return n=U(181387,n),Object.keys(m).sort().reduce((r,$)=>(r=D($,r),i(m[$],r)),n)}class d{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Ei=d;var L;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function s(m,n,r=32){const $=r-n,c=~((1<<$)-1);return(m<<n|(c&m)>>>$)>>>0}function a(m,n=0,r=m.byteLength,$=0){for(let c=0;c<r;c++)m[n+c]=$}function e(m,n,r="0"){for(;m.length<n;)m=r+m;return m}function u(m,n=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),n/4)}t.$Fi=u;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const $=this.p;let c=this.r,o=this.u,C,R;for(o!==0?(C=o,R=-1,o=0):(C=n.charCodeAt(0),R=0);;){let M=C;if(y.$4e(C))if(R+1<r){const b=n.charCodeAt(R+1);y.$5e(b)?(R++,M=y.$6e(C,b)):M=65533}else{o=C;break}else y.$5e(C)&&(M=65533);if(c=this.w($,c,M),R++,R<r)C=n.charCodeAt(R);else break}this.r=c,this.u=o}w(n,r,$){return $<128?n[r++]=$:$<2048?(n[r++]=192|($&1984)>>>6,n[r++]=128|($&63)>>>0):$<65536?(n[r++]=224|($&61440)>>>12,n[r++]=128|($&4032)>>>6,n[r++]=128|($&63)>>>0):(n[r++]=240|($&1835008)>>>18,n[r++]=128|($&258048)>>>12,n[r++]=128|($&4032)>>>6,n[r++]=128|($&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,r=this.q;for(let j=0;j<64;j+=4)n.setUint32(j,r.getUint32(j,!1),!1);for(let j=64;j<320;j+=4)n.setUint32(j,s(n.getUint32(j-12,!1)^n.getUint32(j-32,!1)^n.getUint32(j-56,!1)^n.getUint32(j-64,!1),1),!1);let $=this.h,c=this.l,o=this.m,C=this.n,R=this.o,M,b,v;for(let j=0;j<80;j++)j<20?(M=c&o|~c&C,b=1518500249):j<40?(M=c^o^C,b=1859775393):j<60?(M=c&o|c&C|o&C,b=2400959708):(M=c^o^C,b=3395469782),v=s($,5)+M+R+b+n.getUint32(j*4,!1)&4294967295,R=C,C=o,o=s(c,30),c=$,$=v;this.h=this.h+$&4294967295,this.l=this.l+c&4294967295,this.m=this.m+o&4294967295,this.n=this.n+C&4294967295,this.o=this.o+R&4294967295}}t.$Gi=l}),define(be[85],$e([1,0,73,84]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ss=t.$rs=t.$qs=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,u=s.length;e<u;e++)a[e]=s.charCodeAt(e);return a}}t.$qs=i;function U(L,s,a){return new d(new i(L),new i(s)).ComputeDiff(a).changes}t.$rs=U;class w{static Assert(s,a){if(!s)throw new Error(a)}}class D{static Copy(s,a,e,u,l){for(let m=0;m<l;m++)e[u+m]=s[a+m]}static Copy2(s,a,e,u,l){for(let m=0;m<l;m++)e[u+m]=s[a+m]}}var h;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(h||(h={}));class f{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.$ps(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class d{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[u,l,m]=d.o(s),[n,r,$]=d.o(a);this.d=m&&$,this.e=u,this.f=l,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(d.n(a)){const e=new Int32Array(a.length);for(let u=0,l=a.length;u<l;u++)e[u]=(0,N.$Di)(a[u],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=d.r(this.b,s),u=d.r(this.c,a);return e===u}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,u,l){const m=[!1];let n=this.w(s,a,e,u,m);return l&&(n=this.z(n)),{quitEarly:m[0],changes:n}}w(s,a,e,u,l){for(l[0]=!1;s<=a&&e<=u&&this.p(s,e);)s++,e++;for(;a>=s&&u>=e&&this.p(a,u);)a--,u--;if(s>a||e>u){let o;return e<=u?(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),o=[new y.$ps(s,0,e,u-e+1)]):s<=a?(w.Assert(e===u+1,"modifiedStart should only be one more than modifiedEnd"),o=[new y.$ps(s,a-s+1,e,0)]):(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),w.Assert(e===u+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const m=[0],n=[0],r=this.y(s,a,e,u,m,n,l),$=m[0],c=n[0];if(r!==null)return r;if(!l[0]){const o=this.w(s,$,e,c,l);let C=[];return l[0]?C=[new y.$ps($+1,a-($+1)+1,c+1,u-(c+1)+1)]:C=this.w($+1,a,c+1,u,l),this.H(o,C)}return[new y.$ps(s,a-s+1,e,u-e+1)]}x(s,a,e,u,l,m,n,r,$,c,o,C,R,M,b,v,j,z){let W=null,I=null,F=new f,X=a,te=e,re=R[0]-v[0]-u,ce=-1073741824,le=this.k.length-1;do{const ae=re+s;ae===X||ae<te&&$[ae-1]<$[ae+1]?(o=$[ae+1],M=o-re-u,o<ce&&F.MarkNextChange(),ce=o,F.AddModifiedElement(o+1,M),re=ae+1-s):(o=$[ae-1]+1,M=o-re-u,o<ce&&F.MarkNextChange(),ce=o-1,F.AddOriginalElement(o,M+1),re=ae-1-s),le>=0&&($=this.k[le],s=$[0],X=1,te=$.length-1)}while(--le>=-1);if(W=F.getReverseChanges(),z[0]){let ae=R[0]+1,me=v[0]+1;if(W!==null&&W.length>0){const ke=W[W.length-1];ae=Math.max(ae,ke.getOriginalEnd()),me=Math.max(me,ke.getModifiedEnd())}I=[new y.$ps(ae,C-ae+1,me,b-me+1)]}else{F=new f,X=m,te=n,re=R[0]-v[0]-r,ce=1073741824,le=j?this.m.length-1:this.m.length-2;do{const ae=re+l;ae===X||ae<te&&c[ae-1]>=c[ae+1]?(o=c[ae+1]-1,M=o-re-r,o>ce&&F.MarkNextChange(),ce=o+1,F.AddOriginalElement(o+1,M+1),re=ae+1-l):(o=c[ae-1],M=o-re-r,o>ce&&F.MarkNextChange(),ce=o,F.AddModifiedElement(o+1,M+1),re=ae-1-l),le>=0&&(c=this.m[le],l=c[0],X=1,te=c.length-1)}while(--le>=-1);I=F.getChanges()}return this.H(W,I)}y(s,a,e,u,l,m,n){let r=0,$=0,c=0,o=0,C=0,R=0;s--,e--,l[0]=0,m[0]=0,this.k=[],this.m=[];const M=a-s+(u-e),b=M+1,v=new Int32Array(b),j=new Int32Array(b),z=u-e,W=a-s,I=s-e,F=a-u,te=(W-z)%2===0;v[z]=s,j[W]=a,n[0]=!1;for(let re=1;re<=M/2+1;re++){let ce=0,le=0;c=this.J(z-re,re,z,b),o=this.J(z+re,re,z,b);for(let me=c;me<=o;me+=2){me===c||me<o&&v[me-1]<v[me+1]?r=v[me+1]:r=v[me-1]+1,$=r-(me-z)-I;const ke=r;for(;r<a&&$<u&&this.p(r+1,$+1);)r++,$++;if(v[me]=r,r+$>ce+le&&(ce=r,le=$),!te&&Math.abs(me-W)<=re-1&&r>=j[me])return l[0]=r,m[0]=$,ke<=j[me]&&1447>0&&re<=1447+1?this.x(z,c,o,I,W,C,R,F,v,j,r,a,l,$,u,m,te,n):null}const ae=(ce-s+(le-e)-re)/2;if(this.a!==null&&!this.a(ce,ae))return n[0]=!0,l[0]=ce,m[0]=le,ae>0&&1447>0&&re<=1447+1?this.x(z,c,o,I,W,C,R,F,v,j,r,a,l,$,u,m,te,n):(s++,e++,[new y.$ps(s,a-s+1,e,u-e+1)]);C=this.J(W-re,re,W,b),R=this.J(W+re,re,W,b);for(let me=C;me<=R;me+=2){me===C||me<R&&j[me-1]>=j[me+1]?r=j[me+1]-1:r=j[me-1],$=r-(me-W)-F;const ke=r;for(;r>s&&$>e&&this.p(r,$);)r--,$--;if(j[me]=r,te&&Math.abs(me-z)<=re&&r<=v[me])return l[0]=r,m[0]=$,ke>=v[me]&&1447>0&&re<=1447+1?this.x(z,c,o,I,W,C,R,F,v,j,r,a,l,$,u,m,te,n):null}if(re<=1447){let me=new Int32Array(o-c+2);me[0]=z-c+1,D.Copy2(v,c,me,1,o-c+1),this.k.push(me),me=new Int32Array(R-C+2),me[0]=W-C+1,D.Copy2(j,C,me,1,R-C+1),this.m.push(me)}}return this.x(z,c,o,I,W,C,R,F,v,j,r,a,l,$,u,m,te,n)}z(s){for(let a=0;a<s.length;a++){const e=s[a],u=a<s.length-1?s[a+1].originalStart:this.f.length,l=a<s.length-1?s[a+1].modifiedStart:this.h.length,m=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<u&&e.modifiedStart+e.modifiedLength<l&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const $=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!$)break;e.originalStart++,e.modifiedStart++}const r=[null];if(a<s.length-1&&this.I(s[a],s[a+1],r)){s[a]=r[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let u=0,l=0;if(a>0){const o=s[a-1];u=o.originalStart+o.originalLength,l=o.modifiedStart+o.modifiedLength}const m=e.originalLength>0,n=e.modifiedLength>0;let r=0,$=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const C=e.originalStart-o,R=e.modifiedStart-o;if(C<u||R<l||m&&!this.s(C,C+e.originalLength)||n&&!this.u(R,R+e.modifiedLength))break;const b=(C===u&&R===l?5:0)+this.G(C,e.originalLength,R,e.modifiedLength);b>$&&($=b,r=o)}e.originalStart-=r,e.modifiedStart-=r;const c=[null];if(a>0&&this.I(s[a-1],s[a],c)){s[a-1]=c[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const u=s[a-1],l=s[a],m=l.originalStart-u.originalStart-u.originalLength,n=u.originalStart,r=l.originalStart+l.originalLength,$=r-n,c=u.modifiedStart,o=l.modifiedStart+l.modifiedLength,C=o-c;if(m<5&&$<20&&C<20){const R=this.A(n,$,c,C,m);if(R){const[M,b]=R;(M!==u.originalStart+u.originalLength||b!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=M-u.originalStart,u.modifiedLength=b-u.modifiedStart,l.originalStart=M+m,l.modifiedStart=b+m,l.originalLength=r-l.originalStart,l.modifiedLength=o-l.modifiedStart)}}}return s}A(s,a,e,u,l){if(a<l||u<l)return null;const m=s+a-l+1,n=e+u-l+1;let r=0,$=0,c=0;for(let o=s;o<m;o++)for(let C=e;C<n;C++){const R=this.B(o,C,l);R>0&&R>r&&(r=R,$=o,c=C)}return r>0?[$,c]:null}B(s,a,e){let u=0;for(let l=0;l<e;l++){if(!this.p(s+l,a+l))return 0;u+=this.e[s+l].length}return u}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,u){const l=this.D(s,a)?1:0,m=this.F(e,u)?1:0;return l+m}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const u=new Array(s.length+a.length-1);return D.Copy(s,0,u,0,s.length-1),u[s.length-1]=e[0],D.Copy(a,1,u,s.length,a.length-1),u}else{const u=new Array(s.length+a.length);return D.Copy(s,0,u,0,s.length),D.Copy(a,0,u,s.length,a.length),u}}I(s,a,e){if(w.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),w.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const u=s.originalStart;let l=s.originalLength;const m=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(l=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new y.$ps(u,l,m,n),!0}else return e[0]=null,!1}J(s,a,e,u){if(s>=0&&s<u)return s;const l=e,m=u-e-1,n=a%2===0;if(s<0){const r=l%2===0;return n===r?0:1}else{const r=m%2===0;return n===r?u-1:u-2}}}t.$ss=d}),define(be[48],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Id=void 0,t.$Id=Symbol("MicrotaskDelay")}),define(be[86],$e([1,0,11,12]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=void 0;class i{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),u=this.b.charCodeAt(this.c);return e-u}value(){return this.b[this.c]}}t.$Oh=i;class U{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,N.$Te)(a,this.b,0,a.length,this.c,this.d):(0,N.$Ve)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Ph=U;class w{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const u=this.b.charCodeAt(e);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,N.$Te)(a,this.b,0,a.length,this.d,this.e):(0,N.$Ve)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Qh=w;var D;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(D||(D={}));class h{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new w(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,N.$Ue)(a,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Ue)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,N.$Se)(a,this.c.query);if(this.d[this.e]===5)return(0,N.$Se)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Rh=h;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(d||(d={}));class L{static forUris(a=()=>!1,e=()=>!1){return new L(new h(a,e))}static forPaths(a=!1){return new L(new w(void 0,!a))}static forStrings(){return new L(new i)}static forConfigKeys(){return new L(new U)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const u=e.slice(0);(0,y.$Vb)(u);for(const l of u)this.set(l,a)}else{const u=a.slice(0);(0,y.$Vb)(u);for(const l of u)this.set(l[0],l[1])}}set(a,e){const u=this.b.reset(a);let l;this.c||(this.c=new f,this.c.segment=u.value());const m=[];for(l=this.c;;){const r=u.cmp(l.segment);if(r>0)l.left||(l.left=new f,l.left.segment=u.value()),m.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new f,l.right.segment=u.value()),m.push([1,l]),l=l.right;else if(u.hasNext())u.next(),l.mid||(l.mid=new f,l.mid.segment=u.value()),m.push([0,l]),l=l.mid;else break}const n=l.value;l.value=e,l.key=a;for(let r=m.length-1;r>=0;r--){const $=m[r][1];$.updateHeight();const c=$.balanceFactor();if(c<-1||c>1){const o=m[r][0],C=m[r+1][0];if(o===1&&C===1)m[r][1]=$.rotateLeft();else if(o===-1&&C===-1)m[r][1]=$.rotateRight();else if(o===1&&C===-1)$.right=m[r+1][1]=m[r+1][1].rotateRight(),m[r][1]=$.rotateLeft();else if(o===-1&&C===1)$.left=m[r+1][1]=m[r+1][1].rotateLeft(),m[r][1]=$.rotateRight();else throw new Error;if(r>0)switch(m[r-1][0]){case-1:m[r-1][1].left=m[r][1];break;case 1:m[r-1][1].right=m[r][1];break;case 0:m[r-1][1].mid=m[r][1];break}else this.c=m[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let u=this.c;for(;u;){const l=e.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(e.hasNext())e.next(),u=u.mid;else break}return u}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const u=this.b.reset(a),l=[];let m=this.c;for(;m;){const n=u.cmp(m.segment);if(n>0)l.push([-1,m]),m=m.left;else if(n<0)l.push([1,m]),m=m.right;else if(u.hasNext())u.next(),l.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:r,value:$,segment:c}=n;this.e(n.key,!1),m.key=r,m.value=$,m.segment=c}}else{const n=m.left??m.right;if(l.length>0){const[r,$]=l[l.length-1];switch(r){case-1:$.left=n;break;case 0:$.mid=n;break;case 1:$.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const $=r.balanceFactor();if($>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[n][1]=r.rotateLeft()):$<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[n][1]=r.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let u=this.c,l;for(;u;){const m=e.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(e.hasNext())e.next(),l=u.value||l,u=u.mid;else break}return u&&u.value||l}findSuperstr(a){return this.g(a,!1)}g(a,e){const u=this.b.reset(a);let l=this.c;for(;l;){const m=u.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(u.hasNext())u.next(),l=l.mid;else return l.mid?this.h(l.mid):e?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,u]of this)a(u,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const u=e.balanceFactor();return u<-1||u>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$Sh=L}),define(be[7],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=void 0;function y(c){return typeof c=="string"}t.$wf=y;function N(c){return Array.isArray(c)&&c.every(o=>y(o))}t.$xf=N;function i(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$yf=i;function U(c){const o=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof o}t.$zf=U;function w(c){return typeof c=="number"&&!isNaN(c)}t.$Af=w;function D(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Bf=D;function h(c){return c===!0||c===!1}t.$Cf=h;function f(c){return typeof c>"u"}t.$Df=f;function d(c){return!L(c)}t.$Ef=d;function L(c){return f(c)||c===null}t.$Ff=L;function s(c,o){if(!c)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$Gf=s;function a(c){if(L(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$Hf=a;function e(...c){const o=[];for(let C=0;C<c.length;C++){const R=c[C];if(L(R))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);o.push(R)}return o}t.$If=e;const u=Object.prototype.hasOwnProperty;function l(c){if(!i(c))return!1;for(const o in c)if(u.call(c,o))return!1;return!0}t.$Jf=l;function m(c){return typeof c=="function"}t.$Kf=m;function n(...c){return c.length>0&&c.every(m)}t.$Lf=n;function r(c,o){const C=Math.min(c.length,o.length);for(let R=0;R<C;R++)$(c[R],o[R])}t.$Mf=r;function $(c,o){if(y(o)){if(typeof c!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(c instanceof o)return}catch{}if(!L(c)&&c.constructor===o||o.length===1&&o.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Nf=$}),define(be[17],$e([1,0,7]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rj=t.$Qj=t.$Pj=void 0;const N=Object.create(null);function i(D,h){if((0,y.$wf)(h)){const f=N[h];if(f===void 0)throw new Error(`${D} references an unknown codicon: ${h}`);h=f}return N[D]=h,{id:D}}function U(){return N}t.$Pj=U;function w(){return Object.values(t.$Rj)}t.$Qj=w,t.$Rj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(be[49],$e([1,0,7]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9m=t.$8m=t.$7m=t.$6m=t.$5m=t.$4m=t.$3m=t.$2m=t.$1m=t.$Zm=t.$Ym=t.$Xm=void 0;function N(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([r,$])=>{n[r]=$&&typeof $=="object"?N($):$}),n}t.$Xm=N;function i(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const $ in r)if(U.call(r,$)){const c=r[$];typeof c=="object"&&!Object.isFrozen(c)&&!(0,y.$zf)(c)&&n.push(c)}}return m}t.$Ym=i;const U=Object.prototype.hasOwnProperty;function w(m,n){return D(m,n,new Set)}t.$Zm=w;function D(m,n,r){if((0,y.$Ff)(m))return m;const $=n(m);if(typeof $<"u")return $;if(Array.isArray(m)){const c=[];for(const o of m)c.push(D(o,n,r));return c}if((0,y.$yf)(m)){if(r.has(m))throw new Error("Cannot clone recursive data-structure");r.add(m);const c={};for(const o in m)U.call(m,o)&&(c[o]=D(m[o],n,r));return r.delete(m),c}return m}function h(m,n,r=!0){return(0,y.$yf)(m)?((0,y.$yf)(n)&&Object.keys(n).forEach($=>{$ in m?r&&((0,y.$yf)(m[$])&&(0,y.$yf)(n[$])?h(m[$],n[$],r):m[$]=n[$]):m[$]=n[$]}),m):n}t.$1m=h;function f(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let r,$;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(r=0;r<m.length;r++)if(!f(m[r],n[r]))return!1}else{const c=[];for($ in m)c.push($);c.sort();const o=[];for($ in n)o.push($);if(o.sort(),!f(c,o))return!1;for(r=0;r<c.length;r++)if(!f(m[c[r]],n[c[r]]))return!1}return!0}t.$2m=f;function d(m){const n=new Set;return JSON.stringify(m,(r,$)=>{if((0,y.$yf)($)||Array.isArray($)){if(n.has($))return"[Circular]";n.add($)}return $})}t.$3m=d;function L(m,n){const r=Object.create(null);return!m||!n||Object.keys(n).forEach(c=>{const o=m[c],C=n[c];f(o,C)||(r[c]=C)}),r}t.$4m=L;function s(m,n){const r=n.toLowerCase(),$=Object.keys(m).find(c=>c.toLowerCase()===r);return $?m[$]:m[n]}t.$5m=s;function a(m,n){const r=Object.create(null);for(const[$,c]of Object.entries(m))n($,c)&&(r[$]=c);return r}t.$6m=a;function e(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}t.$7m=e;function u(m){const n=[];for(const r of e(m))typeof m[r]=="function"&&n.push(r);return n}t.$8m=u;function l(m,n){const r=c=>function(){const o=Array.prototype.slice.call(arguments,0);return n(c,o)},$={};for(const c of m)$[c]=r(c);return $}t.$9m=l}),define(be[18],$e([1,0,17]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Sj=t.ThemeColor=void 0;var N;(function(w){function D(h){return h&&typeof h=="object"&&typeof h.id=="string"}w.isThemeColor=D})(N||(t.ThemeColor=N={}));function i(w){return{id:w}}t.$Sj=i;var U;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function h(n){const r=D.exec(n.id);if(!r)return h(y.$Rj.error);const[,$,c]=r,o=["codicon","codicon-"+$];return c&&o.push("codicon-modifier-"+c.substring(1)),o}w.asClassNameArray=h;function f(n){return h(n).join(" ")}w.asClassName=f;function d(n){return"."+h(n).join(".")}w.asCSSSelector=d;function L(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}w.isThemeIcon=L;const s=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function a(n){const r=s.exec(n);if(!r)return;const[,$]=r;return{id:$}}w.fromString=a;function e(n){return{id:n}}w.fromId=e;function u(n,r){let $=n.id;const c=$.lastIndexOf("~");return c!==-1&&($=$.substring(0,c)),r&&($=`${$}~${r}`),{id:$}}w.modify=u;function l(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}w.getModifier=l;function m(n,r){return n.id===r.id&&n.color?.id===r.color?.id}w.isEqual=m})(U||(t.ThemeIcon=U={}))}),define(be[34],$e([1,0,33,12,18]),function(oe,t,y,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=void 0;const U="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${w.source}`,"g");function h(m){return m.replace(D,(n,r)=>r?n:`\\${n}`)}t.$Tj=h;const f=new RegExp(`\\\\${w.source}`,"g");function d(m){return m.replace(f,n=>`\\${n}`)}t.$Uj=d;const L=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function s(m){return m.indexOf(U)===-1?m:m.replace(L,(n,r,$,c)=>$?n:r||c||"")}t.$Vj=s;function a(m){return m?m.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$Wj=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(m){e.lastIndex=0;let n="";const r=[];let $=0;for(;;){const c=e.lastIndex,o=e.exec(m),C=m.substring(c,o?.index);if(C.length>0){n+=C;for(let R=0;R<C.length;R++)r.push($)}if(!o)break;$+=o[0].length}return{text:n,iconOffsets:r}}t.$Xj=u;function l(m,n,r=!1){const{text:$,iconOffsets:c}=n;if(!c||c.length===0)return(0,y.$Gj)(m,$,r);const o=(0,N.$He)($," "),C=$.length-o.length,R=(0,y.$Gj)(m,o,r);if(R)for(const M of R){const b=c[M.start+C]+C;M.start+=b,M.end+=b}return R}t.$Yj=l}),define(be[87],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6S=t.$5S=void 0,t.$5S="vscode:contextmenu",t.$6S="vscode:onCloseContextMenu"}),define(be[88],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aT=void 0;class y{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$aT=y}),define(be[50],$e([8]),{}),define(be[89],$e([8]),{}),define(be[90],$e([8]),{}),define(be[91],$e([8]),{}),define(be[92],$e([1,0,90,91]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([8]),{}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[103],$e([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[104],$e([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[105],$e([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[106],$e([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[107],$e([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[108],$e([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[109],$e([13,10]),function(oe,t){return oe.create("vs/base/common/actions",t)}),define(be[35],$e([1,0,3,2,109]),function(oe,t,y,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wi=t.$vi=t.$ui=t.$ti=t.$si=t.$ri=void 0;class U extends N.$Qc{constructor(s,a="",e="",u=!0,l){super(),this.h=this.B(new y.$Ld),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=u,this.C=l}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$ri=U;class w extends N.$Qc{constructor(){super(...arguments),this.f=this.B(new y.$Ld),this.onWillRun=this.f.event,this.m=this.B(new y.$Ld),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(u){e=u}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$si=w;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new D,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$ti=D;class h{get actions(){return this.a}constructor(s,a,e,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=u,this.a=e}async run(){}}t.$ui=h;class f extends U{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,i.localize(0,null),void 0,!1)}}t.$vi=f;function d(L){return{id:L.id,label:L.label,class:void 0,enabled:L.enabled??!0,checked:L.checked??!1,run:async(...s)=>L.run(...s),tooltip:L.label}}t.$wi=d}),define(be[110],$e([13,10]),function(oe,t){return oe.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,110]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let N=!1,i=!1,U=!1,w=!1,D=!1,h=!1,f=!1,d=!1,L=!1,s=!1,a,e=t.$f,u=t.$f,l,m;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?n=t.$g.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",$=r&&n?.type==="renderer";if(typeof navigator=="object"&&!$)m=navigator.userAgent,N=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,d=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,h=!0,a=y.getConfiguredDefaultLocale(y.localize(0,null))||t.$f,e=a,u=navigator.language;else if(typeof n=="object"){N=n.platform==="win32",i=n.platform==="darwin",U=n.platform==="linux",w=U&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,f=r,L=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$f,e=t.$f;const z=n.env.VSCODE_NLS_CONFIG;if(z)try{const W=JSON.parse(z),I=W.availableLanguages["*"];a=W.locale,u=W.osLocale,e=I||t.$f,l=W._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var c;(function(z){z[z.Web=0]="Web",z[z.Mac=1]="Mac",z[z.Linux=2]="Linux",z[z.Windows=3]="Windows"})(c||(t.Platform=c={}));function o(z){switch(z){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=o;let C=0;i?C=1:N?C=3:U&&(C=2),t.$i=N,t.$j=i,t.$k=U,t.$l=w,t.$m=D,t.$n=f,t.$o=h,t.$p=h&&typeof t.$g.importScripts=="function",t.$q=d,t.$r=s,t.$s=L,t.$t=C,t.$u=m,t.$v=e;var R;(function(z){function W(){return t.$v}z.value=W;function I(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}z.isDefaultVariant=I;function F(){return t.$v==="en"}z.isDefault=F})(R||(t.Language=R={})),t.$w=a,t.$x=u,t.$y=l,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const z=[];t.$g.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let F=0,X=z.length;F<X;F++){const te=z[F];if(te.id===I.data.vscodeScheduleAsyncWork){z.splice(F,1),te.callback();return}}});let W=0;return I=>{const F=++W;z.push({id:F,callback:I}),t.$g.postMessage({vscodeScheduleAsyncWork:F},"*")}}return z=>setTimeout(z)})();var M;(function(z){z[z.Windows=1]="Windows",z[z.Macintosh=2]="Macintosh",z[z.Linux=3]="Linux"})(M||(t.OperatingSystem=M={})),t.OS=i||d?2:N?1:3;let b=!0,v=!1;function j(){if(!v){v=!0;const z=new Uint8Array(2);z[0]=1,z[1]=2,b=new Uint16Array(z.buffer)[0]===(2<<8)+1}return b}t.$C=j,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),define(be[111],$e([1,0,16,5]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iO=t.KeyboardSupport=void 0;var i;(function(U){U[U.Always=0]="Always",U[U.FullScreen=1]="FullScreen",U[U.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$iO={clipboard:{writeText:N.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:N.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>N.$m||y.$gO()?0:navigator.keyboard||y.$cO?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,43,76,5]),function(oe,t,y,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qO=t.$pO=t.$oO=void 0;function w(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return N.KeyCodeUtils.fromString(l)}const u=e.keyCode;if(u===3)return 7;if(y.$_N)switch(u){case 59:return 85;case 60:if(U.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$j)return 57;break}else if(y.$aO){if(U.$j&&u===93)return 57;if(!U.$j&&u===92)return 57}return N.$sq[u]||0}const D=U.$j?256:2048,h=512,f=1024,d=U.$j?2048:256;function L(e){const u=[];return e.ctrlKey&&u.push("ctrl"),e.shiftKey&&u.push("shift"),e.altKey&&u.push("alt"),e.metaKey&&u.push("meta"),`modifiers: [${u.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$oO=L;function s(e){const u=[];return e.ctrlKey&&u.push("ctrl"),e.shiftKey&&u.push("shift"),e.altKey&&u.push("alt"),e.metaKey&&u.push("meta"),`modifiers: [${u.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${N.KeyCodeUtils.toString(e.keyCode)}')`}t.$pO=s;class a{constructor(u){this._standardKeyboardEventBrand=!0;const l=u;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.altGraphKey=l.getModifierState("AltGraph"),this.keyCode=w(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(u){return this.a===u}c(){let u=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(u=this.keyCode);let l=0;return this.ctrlKey&&(l|=D),this.altKey&&(l|=h),this.shiftKey&&(l|=f),this.metaKey&&(l|=d),l|=u,l}d(){let u=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(u=this.keyCode),new i.$Aq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,u)}}t.$qO=a}),define(be[19],$e([1,0,16,67,5]),function(oe,t,y,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nO=t.$mO=t.$lO=void 0;class U{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=f.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const d=N.$jO.getPositionOfChildWindowRelativeToAncestorWindow(window,f.view);this.posx-=d.left,this.posy-=d.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$lO=U;class w extends U{constructor(f){super(f),this.dataTransfer=f.dataTransfer}}t.$mO=w;class D{constructor(f,d=0,L=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=L,this.deltaX=d,f){const s=f,a=f;if(typeof s.wheelDeltaY<"u")this.deltaY=s.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?y.$_N&&!i.$j?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof s.wheelDeltaX<"u")y.$cO&&i.$i?this.deltaX=-(s.wheelDeltaX/120):this.deltaX=s.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?y.$_N&&!i.$j?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$nO=D}),define(be[112],$e([1,0,5]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cc=t.$bc=t.env=t.cwd=void 0;let N;if(typeof y.$g.vscode<"u"&&typeof y.$g.vscode.process<"u"){const i=y.$g.vscode.process;N={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return y.$i?"win32":y.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=N.cwd,t.env=N.env,t.$bc=N.platform,t.$cc=N.arch}),define(be[22],$e([1,0,112]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rc=t.sep=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=void 0;const N=65,i=97,U=90,w=122,D=46,h=47,f=92,d=58,L=63;class s extends Error{constructor(C,R,M){let b;typeof R=="string"&&R.indexOf("not ")===0?(b="must not be",R=R.replace(/^not /,"")):b="must be";const v=C.indexOf(".")!==-1?"property":"argument";let j=`The "${C}" ${v} ${b} of type ${R}`;j+=`. Received type ${typeof M}`,super(j),this.code="ERR_INVALID_ARG_TYPE"}}function a(o,C){if(o===null||typeof o!="object")throw new s(C,"Object",o)}function e(o,C){if(typeof o!="string")throw new s(C,"string",o)}const u=y.$bc==="win32";function l(o){return o===h||o===f}function m(o){return o===h}function n(o){return o>=N&&o<=U||o>=i&&o<=w}function r(o,C,R,M){let b="",v=0,j=-1,z=0,W=0;for(let I=0;I<=o.length;++I){if(I<o.length)W=o.charCodeAt(I);else{if(M(W))break;W=h}if(M(W)){if(!(j===I-1||z===1))if(z===2){if(b.length<2||v!==2||b.charCodeAt(b.length-1)!==D||b.charCodeAt(b.length-2)!==D){if(b.length>2){const F=b.lastIndexOf(R);F===-1?(b="",v=0):(b=b.slice(0,F),v=b.length-1-b.lastIndexOf(R)),j=I,z=0;continue}else if(b.length!==0){b="",v=0,j=I,z=0;continue}}C&&(b+=b.length>0?`${R}..`:"..",v=2)}else b.length>0?b+=`${R}${o.slice(j+1,I)}`:b=o.slice(j+1,I),v=I-j-1;j=I,z=0}else W===D&&z!==-1?++z:z=-1}return b}function $(o,C){a(C,"pathObject");const R=C.dir||C.root,M=C.base||`${C.name||""}${C.ext||""}`;return R?R===C.root?`${R}${M}`:`${R}${o}${M}`:M}t.$dc={resolve(...o){let C="",R="",M=!1;for(let b=o.length-1;b>=-1;b--){let v;if(b>=0){if(v=o[b],e(v,"path"),v.length===0)continue}else C.length===0?v=y.cwd():(v=y.env[`=${C}`]||y.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==C.toLowerCase()&&v.charCodeAt(2)===f)&&(v=`${C}\\`));const j=v.length;let z=0,W="",I=!1;const F=v.charCodeAt(0);if(j===1)l(F)&&(z=1,I=!0);else if(l(F))if(I=!0,l(v.charCodeAt(1))){let X=2,te=X;for(;X<j&&!l(v.charCodeAt(X));)X++;if(X<j&&X!==te){const re=v.slice(te,X);for(te=X;X<j&&l(v.charCodeAt(X));)X++;if(X<j&&X!==te){for(te=X;X<j&&!l(v.charCodeAt(X));)X++;(X===j||X!==te)&&(W=`\\\\${re}\\${v.slice(te,X)}`,z=X)}}}else z=1;else n(F)&&v.charCodeAt(1)===d&&(W=v.slice(0,2),z=2,j>2&&l(v.charCodeAt(2))&&(I=!0,z=3));if(W.length>0)if(C.length>0){if(W.toLowerCase()!==C.toLowerCase())continue}else C=W;if(M){if(C.length>0)break}else if(R=`${v.slice(z)}\\${R}`,M=I,I&&C.length>0)break}return R=r(R,!M,"\\",l),M?`${C}\\${R}`:`${C}${R}`||"."},normalize(o){e(o,"path");const C=o.length;if(C===0)return".";let R=0,M,b=!1;const v=o.charCodeAt(0);if(C===1)return m(v)?"\\":o;if(l(v))if(b=!0,l(o.charCodeAt(1))){let z=2,W=z;for(;z<C&&!l(o.charCodeAt(z));)z++;if(z<C&&z!==W){const I=o.slice(W,z);for(W=z;z<C&&l(o.charCodeAt(z));)z++;if(z<C&&z!==W){for(W=z;z<C&&!l(o.charCodeAt(z));)z++;if(z===C)return`\\\\${I}\\${o.slice(W)}\\`;z!==W&&(M=`\\\\${I}\\${o.slice(W,z)}`,R=z)}}}else R=1;else n(v)&&o.charCodeAt(1)===d&&(M=o.slice(0,2),R=2,C>2&&l(o.charCodeAt(2))&&(b=!0,R=3));let j=R<C?r(o.slice(R),!b,"\\",l):"";return j.length===0&&!b&&(j="."),j.length>0&&l(o.charCodeAt(C-1))&&(j+="\\"),M===void 0?b?`\\${j}`:j:b?`${M}\\${j}`:`${M}${j}`},isAbsolute(o){e(o,"path");const C=o.length;if(C===0)return!1;const R=o.charCodeAt(0);return l(R)||C>2&&n(R)&&o.charCodeAt(1)===d&&l(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let C,R;for(let v=0;v<o.length;++v){const j=o[v];e(j,"path"),j.length>0&&(C===void 0?C=R=j:C+=`\\${j}`)}if(C===void 0)return".";let M=!0,b=0;if(typeof R=="string"&&l(R.charCodeAt(0))){++b;const v=R.length;v>1&&l(R.charCodeAt(1))&&(++b,v>2&&(l(R.charCodeAt(2))?++b:M=!1))}if(M){for(;b<C.length&&l(C.charCodeAt(b));)b++;b>=2&&(C=`\\${C.slice(b)}`)}return t.$dc.normalize(C)},relative(o,C){if(e(o,"from"),e(C,"to"),o===C)return"";const R=t.$dc.resolve(o),M=t.$dc.resolve(C);if(R===M||(o=R.toLowerCase(),C=M.toLowerCase(),o===C))return"";let b=0;for(;b<o.length&&o.charCodeAt(b)===f;)b++;let v=o.length;for(;v-1>b&&o.charCodeAt(v-1)===f;)v--;const j=v-b;let z=0;for(;z<C.length&&C.charCodeAt(z)===f;)z++;let W=C.length;for(;W-1>z&&C.charCodeAt(W-1)===f;)W--;const I=W-z,F=j<I?j:I;let X=-1,te=0;for(;te<F;te++){const ce=o.charCodeAt(b+te);if(ce!==C.charCodeAt(z+te))break;ce===f&&(X=te)}if(te!==F){if(X===-1)return M}else{if(I>F){if(C.charCodeAt(z+te)===f)return M.slice(z+te+1);if(te===2)return M.slice(z+te)}j>F&&(o.charCodeAt(b+te)===f?X=te:te===2&&(X=3)),X===-1&&(X=0)}let re="";for(te=b+X+1;te<=v;++te)(te===v||o.charCodeAt(te)===f)&&(re+=re.length===0?"..":"\\..");return z+=X,re.length>0?`${re}${M.slice(z,W)}`:(M.charCodeAt(z)===f&&++z,M.slice(z,W))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const C=t.$dc.resolve(o);if(C.length<=2)return o;if(C.charCodeAt(0)===f){if(C.charCodeAt(1)===f){const R=C.charCodeAt(2);if(R!==L&&R!==D)return`\\\\?\\UNC\\${C.slice(2)}`}}else if(n(C.charCodeAt(0))&&C.charCodeAt(1)===d&&C.charCodeAt(2)===f)return`\\\\?\\${C}`;return o},dirname(o){e(o,"path");const C=o.length;if(C===0)return".";let R=-1,M=0;const b=o.charCodeAt(0);if(C===1)return l(b)?o:".";if(l(b)){if(R=M=1,l(o.charCodeAt(1))){let z=2,W=z;for(;z<C&&!l(o.charCodeAt(z));)z++;if(z<C&&z!==W){for(W=z;z<C&&l(o.charCodeAt(z));)z++;if(z<C&&z!==W){for(W=z;z<C&&!l(o.charCodeAt(z));)z++;if(z===C)return o;z!==W&&(R=M=z+1)}}}}else n(b)&&o.charCodeAt(1)===d&&(R=C>2&&l(o.charCodeAt(2))?3:2,M=R);let v=-1,j=!0;for(let z=C-1;z>=M;--z)if(l(o.charCodeAt(z))){if(!j){v=z;break}}else j=!1;if(v===-1){if(R===-1)return".";v=R}return o.slice(0,v)},basename(o,C){C!==void 0&&e(C,"ext"),e(o,"path");let R=0,M=-1,b=!0,v;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===d&&(R=2),C!==void 0&&C.length>0&&C.length<=o.length){if(C===o)return"";let j=C.length-1,z=-1;for(v=o.length-1;v>=R;--v){const W=o.charCodeAt(v);if(l(W)){if(!b){R=v+1;break}}else z===-1&&(b=!1,z=v+1),j>=0&&(W===C.charCodeAt(j)?--j===-1&&(M=v):(j=-1,M=z))}return R===M?M=z:M===-1&&(M=o.length),o.slice(R,M)}for(v=o.length-1;v>=R;--v)if(l(o.charCodeAt(v))){if(!b){R=v+1;break}}else M===-1&&(b=!1,M=v+1);return M===-1?"":o.slice(R,M)},extname(o){e(o,"path");let C=0,R=-1,M=0,b=-1,v=!0,j=0;o.length>=2&&o.charCodeAt(1)===d&&n(o.charCodeAt(0))&&(C=M=2);for(let z=o.length-1;z>=C;--z){const W=o.charCodeAt(z);if(l(W)){if(!v){M=z+1;break}continue}b===-1&&(v=!1,b=z+1),W===D?R===-1?R=z:j!==1&&(j=1):R!==-1&&(j=-1)}return R===-1||b===-1||j===0||j===1&&R===b-1&&R===M+1?"":o.slice(R,b)},format:$.bind(null,"\\"),parse(o){e(o,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return C;const R=o.length;let M=0,b=o.charCodeAt(0);if(R===1)return l(b)?(C.root=C.dir=o,C):(C.base=C.name=o,C);if(l(b)){if(M=1,l(o.charCodeAt(1))){let X=2,te=X;for(;X<R&&!l(o.charCodeAt(X));)X++;if(X<R&&X!==te){for(te=X;X<R&&l(o.charCodeAt(X));)X++;if(X<R&&X!==te){for(te=X;X<R&&!l(o.charCodeAt(X));)X++;X===R?M=X:X!==te&&(M=X+1)}}}}else if(n(b)&&o.charCodeAt(1)===d){if(R<=2)return C.root=C.dir=o,C;if(M=2,l(o.charCodeAt(2))){if(R===3)return C.root=C.dir=o,C;M=3}}M>0&&(C.root=o.slice(0,M));let v=-1,j=M,z=-1,W=!0,I=o.length-1,F=0;for(;I>=M;--I){if(b=o.charCodeAt(I),l(b)){if(!W){j=I+1;break}continue}z===-1&&(W=!1,z=I+1),b===D?v===-1?v=I:F!==1&&(F=1):v!==-1&&(F=-1)}return z!==-1&&(v===-1||F===0||F===1&&v===z-1&&v===j+1?C.base=C.name=o.slice(j,z):(C.name=o.slice(j,v),C.base=o.slice(j,z),C.ext=o.slice(v,z))),j>0&&j!==M?C.dir=o.slice(0,j-1):C.dir=C.root,C},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(u){const o=/\\/g;return()=>{const C=y.cwd().replace(o,"/");return C.slice(C.indexOf("/"))}}return()=>y.cwd()})();t.$ec={resolve(...o){let C="",R=!1;for(let M=o.length-1;M>=-1&&!R;M--){const b=M>=0?o[M]:c();e(b,"path"),b.length!==0&&(C=`${b}/${C}`,R=b.charCodeAt(0)===h)}return C=r(C,!R,"/",m),R?`/${C}`:C.length>0?C:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const C=o.charCodeAt(0)===h,R=o.charCodeAt(o.length-1)===h;return o=r(o,!C,"/",m),o.length===0?C?"/":R?"./":".":(R&&(o+="/"),C?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===h},join(...o){if(o.length===0)return".";let C;for(let R=0;R<o.length;++R){const M=o[R];e(M,"path"),M.length>0&&(C===void 0?C=M:C+=`/${M}`)}return C===void 0?".":t.$ec.normalize(C)},relative(o,C){if(e(o,"from"),e(C,"to"),o===C||(o=t.$ec.resolve(o),C=t.$ec.resolve(C),o===C))return"";const R=1,M=o.length,b=M-R,v=1,j=C.length-v,z=b<j?b:j;let W=-1,I=0;for(;I<z;I++){const X=o.charCodeAt(R+I);if(X!==C.charCodeAt(v+I))break;X===h&&(W=I)}if(I===z)if(j>z){if(C.charCodeAt(v+I)===h)return C.slice(v+I+1);if(I===0)return C.slice(v+I)}else b>z&&(o.charCodeAt(R+I)===h?W=I:I===0&&(W=0));let F="";for(I=R+W+1;I<=M;++I)(I===M||o.charCodeAt(I)===h)&&(F+=F.length===0?"..":"/..");return`${F}${C.slice(v+W)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const C=o.charCodeAt(0)===h;let R=-1,M=!0;for(let b=o.length-1;b>=1;--b)if(o.charCodeAt(b)===h){if(!M){R=b;break}}else M=!1;return R===-1?C?"/":".":C&&R===1?"//":o.slice(0,R)},basename(o,C){C!==void 0&&e(C,"ext"),e(o,"path");let R=0,M=-1,b=!0,v;if(C!==void 0&&C.length>0&&C.length<=o.length){if(C===o)return"";let j=C.length-1,z=-1;for(v=o.length-1;v>=0;--v){const W=o.charCodeAt(v);if(W===h){if(!b){R=v+1;break}}else z===-1&&(b=!1,z=v+1),j>=0&&(W===C.charCodeAt(j)?--j===-1&&(M=v):(j=-1,M=z))}return R===M?M=z:M===-1&&(M=o.length),o.slice(R,M)}for(v=o.length-1;v>=0;--v)if(o.charCodeAt(v)===h){if(!b){R=v+1;break}}else M===-1&&(b=!1,M=v+1);return M===-1?"":o.slice(R,M)},extname(o){e(o,"path");let C=-1,R=0,M=-1,b=!0,v=0;for(let j=o.length-1;j>=0;--j){const z=o.charCodeAt(j);if(z===h){if(!b){R=j+1;break}continue}M===-1&&(b=!1,M=j+1),z===D?C===-1?C=j:v!==1&&(v=1):C!==-1&&(v=-1)}return C===-1||M===-1||v===0||v===1&&C===M-1&&C===R+1?"":o.slice(C,M)},format:$.bind(null,"/"),parse(o){e(o,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return C;const R=o.charCodeAt(0)===h;let M;R?(C.root="/",M=1):M=0;let b=-1,v=0,j=-1,z=!0,W=o.length-1,I=0;for(;W>=M;--W){const F=o.charCodeAt(W);if(F===h){if(!z){v=W+1;break}continue}j===-1&&(z=!1,j=W+1),F===D?b===-1?b=W:I!==1&&(I=1):b!==-1&&(I=-1)}if(j!==-1){const F=v===0&&R?1:v;b===-1||I===0||I===1&&b===j-1&&b===v+1?C.base=C.name=o.slice(F,j):(C.name=o.slice(F,b),C.base=o.slice(F,j),C.ext=o.slice(b,j))}return v>0?C.dir=o.slice(0,v-1):R&&(C.dir="/"),C},sep:"/",delimiter:":",win32:null,posix:null},t.$ec.win32=t.$dc.win32=t.$dc,t.$ec.posix=t.$dc.posix=t.$ec,t.$fc=u?t.$dc.normalize:t.$ec.normalize,t.$gc=u?t.$dc.isAbsolute:t.$ec.isAbsolute,t.$hc=u?t.$dc.join:t.$ec.join,t.$ic=u?t.$dc.resolve:t.$ec.resolve,t.$jc=u?t.$dc.relative:t.$ec.relative,t.$kc=u?t.$dc.dirname:t.$ec.dirname,t.$lc=u?t.$dc.basename:t.$ec.basename,t.$mc=u?t.$dc.extname:t.$ec.extname,t.$nc=u?t.$dc.format:t.$ec.format,t.$oc=u?t.$dc.parse:t.$ec.parse,t.$pc=u?t.$dc.toNamespacedPath:t.$ec.toNamespacedPath,t.sep=u?t.$dc.sep:t.$ec.sep,t.$rc=u?t.$dc.delimiter:t.$ec.delimiter}),define(be[113],$e([1,0,22,5,12,7]),function(oe,t,y,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=void 0;function w(v){return v===47||v===92}t.$Of=w;function D(v){return v.replace(/[\\/]/g,y.$ec.sep)}t.$Pf=D;function h(v){return v.indexOf("/")===-1&&(v=D(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$Qf=h;function f(v,j=y.$ec.sep){if(!v)return"";const z=v.length,W=v.charCodeAt(0);if(w(W)){if(w(v.charCodeAt(1))&&!w(v.charCodeAt(2))){let F=3;const X=F;for(;F<z&&!w(v.charCodeAt(F));F++);if(X!==F&&!w(v.charCodeAt(F+1))){for(F+=1;F<z;F++)if(w(v.charCodeAt(F)))return v.slice(0,F+1).replace(/[\\/]/g,j)}}return j}else if(m(W)&&v.charCodeAt(1)===58)return w(v.charCodeAt(2))?v.slice(0,2)+j:v.slice(0,2);let I=v.indexOf("://");if(I!==-1){for(I+=3;I<z;I++)if(w(v.charCodeAt(I)))return v.slice(0,I+1)}return""}t.$Rf=f;function d(v){if(!N.$i||!v||v.length<5)return!1;let j=v.charCodeAt(0);if(j!==92||(j=v.charCodeAt(1),j!==92))return!1;let z=2;const W=z;for(;z<v.length&&(j=v.charCodeAt(z),j!==92);z++);return!(W===z||(j=v.charCodeAt(z+1),isNaN(j)||j===92))}t.$Sf=d;const L=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,j=N.$i){const z=j?L:s;return!(!v||v.length===0||/^\s+$/.test(v)||(z.lastIndex=0,z.test(v))||j&&a.test(v)||v==="."||v===".."||j&&v[v.length-1]==="."||j&&v.length!==v.trim().length||v.length>255)}t.$Tf=e;function u(v,j,z){const W=v===j;return!z||W?W:!v||!j?!1:(0,i.$Ze)(v,j)}t.$Uf=u;function l(v,j,z,W=y.sep){if(v===j)return!0;if(!v||!j||j.length>v.length)return!1;if(z){if(!(0,i.$1e)(v,j))return!1;if(j.length===v.length)return!0;let F=j.length;return j.charAt(j.length-1)===W&&F--,v.charAt(F)===W}return j.charAt(j.length-1)!==W&&(j+=W),v.indexOf(j)===0}t.$Vf=l;function m(v){return v>=65&&v<=90||v>=97&&v<=122}t.$Wf=m;function n(v,j){return N.$i&&v.endsWith(":")&&(v+=y.sep),(0,y.$gc)(v)||(v=(0,y.$hc)(j,v)),v=(0,y.$fc)(v),N.$i?(v=(0,i.$Ie)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,i.$Ie)(v,y.sep),v||(v=y.sep)),v}t.$Xf=n;function r(v){const j=(0,y.$fc)(v);return N.$i?v.length>3?!1:$(j)&&(v.length===2||j.charCodeAt(2)===92):j===y.$ec.sep}t.$Yf=r;function $(v,j=N.$i){return j?m(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$Zf=$;function c(v,j=N.$i){return $(v,j)?v[0]:void 0}t.$1f=c;function o(v,j,z){return j.length>v.length?-1:v===j?0:(z&&(v=v.toLowerCase(),j=j.toLowerCase()),v.indexOf(j))}t.$2f=o;function C(v){const j=v.split(":");let z,W,I;for(const F of j){const X=Number(F);(0,U.$Af)(X)?W===void 0?W=X:I===void 0&&(I=X):z=z?[z,F].join(":"):F}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:W!==void 0?W:void 0,column:I!==void 0?I:W!==void 0?1:void 0}}t.$3f=C;const R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(v,j,z=8){let W="";for(let F=0;F<z;F++){let X;F===0&&N.$i&&!j&&(z===3||z===4)?X=M:X=R,W+=X.charAt(Math.floor(Math.random()*X.length))}let I;return j?I=`${j}-${W}`:I=W,v?(0,y.$hc)(v,I):I}t.$4f=b}),define(be[114],$e([1,0,22]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nr=t.$Mr=t.$Lr=t.$Kr=t.$Jr=void 0,t.$Jr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(d){const L=(0,y.$mc)(d),s=N[L.toLowerCase()];return s!==void 0?s:w(d)}t.$Kr=U;function w(d){const L=(0,y.$mc)(d);return i[L.toLowerCase()]}t.$Lr=w;function D(d){for(const L in i)if(i[L]===d)return L}t.$Mr=D;const h=/^(.+)\/(.+?)(;.+)?$/;function f(d,L){const s=h.exec(d);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:L?void 0:d}t.$Nr=f}),define(be[15],$e([1,0,22,5]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.$tc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,w=/^\/\//;function D(M,b){if(!M.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${M.authority}", path: "${M.path}", query: "${M.query}", fragment: "${M.fragment}"}`);if(M.scheme&&!i.test(M.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(M.path){if(M.authority){if(!U.test(M.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(M.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(M,b){return!M&&!b?"file":M}function f(M,b){switch(M){case"https":case"http":case"file":b?b[0]!==L&&(b=L+b):b=L;break}return b}const d="",L="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(b){return b instanceof a?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,v,j,z,W,I=!1){typeof b=="object"?(this.scheme=b.scheme||d,this.authority=b.authority||d,this.path=b.path||d,this.query=b.query||d,this.fragment=b.fragment||d):(this.scheme=h(b,I),this.authority=v||d,this.path=f(this.scheme,j||d),this.query=z||d,this.fragment=W||d,D(this,I))}get fsPath(){return $(this,!1)}with(b){if(!b)return this;let{scheme:v,authority:j,path:z,query:W,fragment:I}=b;return v===void 0?v=this.scheme:v===null&&(v=d),j===void 0?j=this.authority:j===null&&(j=d),z===void 0?z=this.path:z===null&&(z=d),W===void 0?W=this.query:W===null&&(W=d),I===void 0?I=this.fragment:I===null&&(I=d),v===this.scheme&&j===this.authority&&z===this.path&&W===this.query&&I===this.fragment?this:new l(v,j,z,W,I)}static parse(b,v=!1){const j=s.exec(b);return j?new l(j[2]||d,R(j[4]||d),R(j[5]||d),R(j[7]||d),R(j[9]||d),v):new l(d,d,d,d,d)}static file(b){let v=d;if(N.$i&&(b=b.replace(/\\/g,L)),b[0]===L&&b[1]===L){const j=b.indexOf(L,2);j===-1?(v=b.substring(2),b=L):(v=b.substring(2,j),b=b.substring(j)||L)}return new l("file",v,b,d,d)}static from(b,v){return new l(b.scheme,b.authority,b.path,b.query,b.fragment,v)}static joinPath(b,...v){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let j;return N.$i&&b.scheme==="file"?j=a.file(y.$dc.join($(b,!0),...v)).path:j=y.$ec.join(b.path,...v),b.with({path:j})}toString(b=!1){return c(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof a)return b;{const v=new l(b);return v._formatted=b.external??null,v._fsPath=b._sep===u?b.fsPath??null:null,v}}else return b}}t.URI=a;function e(M){return!M||typeof M!="object"?!1:typeof M.scheme=="string"&&(typeof M.authority=="string"||typeof M.authority>"u")&&(typeof M.path=="string"||typeof M.path>"u")&&(typeof M.query=="string"||typeof M.query>"u")&&(typeof M.fragment=="string"||typeof M.fragment>"u")}t.$tc=e;const u=N.$i?1:void 0;class l extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(b=!1){return b?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=u),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(M,b,v){let j,z=-1;for(let W=0;W<M.length;W++){const I=M.charCodeAt(W);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||b&&I===47||v&&I===91||v&&I===93||v&&I===58)z!==-1&&(j+=encodeURIComponent(M.substring(z,W)),z=-1),j!==void 0&&(j+=M.charAt(W));else{j===void 0&&(j=M.substr(0,W));const F=m[I];F!==void 0?(z!==-1&&(j+=encodeURIComponent(M.substring(z,W)),z=-1),j+=F):z===-1&&(z=W)}}return z!==-1&&(j+=encodeURIComponent(M.substring(z))),j!==void 0?j:M}function r(M){let b;for(let v=0;v<M.length;v++){const j=M.charCodeAt(v);j===35||j===63?(b===void 0&&(b=M.substr(0,v)),b+=m[j]):b!==void 0&&(b+=M[v])}return b!==void 0?b:M}function $(M,b){let v;return M.authority&&M.path.length>1&&M.scheme==="file"?v=`//${M.authority}${M.path}`:M.path.charCodeAt(0)===47&&(M.path.charCodeAt(1)>=65&&M.path.charCodeAt(1)<=90||M.path.charCodeAt(1)>=97&&M.path.charCodeAt(1)<=122)&&M.path.charCodeAt(2)===58?b?v=M.path.substr(1):v=M.path[1].toLowerCase()+M.path.substr(2):v=M.path,N.$i&&(v=v.replace(/\//g,"\\")),v}t.$uc=$;function c(M,b){const v=b?r:n;let j="",{scheme:z,authority:W,path:I,query:F,fragment:X}=M;if(z&&(j+=z,j+=":"),(W||z==="file")&&(j+=L,j+=L),W){let te=W.indexOf("@");if(te!==-1){const re=W.substr(0,te);W=W.substr(te+1),te=re.lastIndexOf(":"),te===-1?j+=v(re,!1,!1):(j+=v(re.substr(0,te),!1,!1),j+=":",j+=v(re.substr(te+1),!1,!0)),j+="@"}W=W.toLowerCase(),te=W.lastIndexOf(":"),te===-1?j+=v(W,!1,!0):(j+=v(W.substr(0,te),!1,!0),j+=W.substr(te))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const te=I.charCodeAt(1);te>=65&&te<=90&&(I=`/${String.fromCharCode(te+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const te=I.charCodeAt(0);te>=65&&te<=90&&(I=`${String.fromCharCode(te+32)}:${I.substr(2)}`)}j+=v(I,!0,!1)}return F&&(j+="?",j+=v(F,!1,!1)),X&&(j+="#",j+=b?X:n(X,!1,!1)),j}function o(M){try{return decodeURIComponent(M)}catch{return M.length>3?M.substr(0,3)+o(M.substr(3)):M}}const C=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function R(M){return M.match(C)?M.replace(C,b=>o(b)):M}}),define(be[51],$e([1,0,32,15]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jh=t.$ih=t.$hh=void 0;function i(h){return JSON.stringify(h,w)}t.$hh=i;function U(h){let f=JSON.parse(h);return f=D(f),f}t.$ih=U;function w(h,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function D(h,f=0){if(!h||f>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return N.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof y.$_d||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let d=0;d<h.length;++d)h[d]=D(h[d],f+1);else for(const d in h)Object.hasOwnProperty.call(h,d)&&(h[d]=D(h[d],f+1))}return h}t.$jh=D}),define(be[28],$e([1,0,6,5,15]),function(oe,t,y,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.Schemas=void 0;var U;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(U||(t.Schemas=U={})),t.$5f="vscode-tkn",t.$6f="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d){this.f=`${d}/${U.vscodeRemoteResource}`}set(d,L,s){this.a[d]=L,this.b[d]=s}setConnectionToken(d,L){this.c[d]=L}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(l){return y.$Y(l),d}const L=d.authority;let s=this.a[L];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[L],e=this.c[L];let u=`path=${encodeURIComponent(d.path)}`;return typeof e=="string"&&(u+=`&${t.$6f}=${encodeURIComponent(e)}`),i.URI.from({scheme:N.$o?this.d:U.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:u})}}t.$7f=new w,t.$8f="vs/../../extensions",t.$9f="vs/../../node_modules",t.$0f="vs/../../node_modules.asar",t.$$f="vs/../../node_modules.asar.unpacked",t.$_f="vscode-app";class D{static{this.a=t.$_f}asBrowserUri(d){const L=this.b(d,oe);return this.uriToBrowserUri(L)}uriToBrowserUri(d){return d.scheme===U.vscodeRemote?t.$7f.rewrite(d):d.scheme===U.file&&(N.$m||N.$p&&N.$g.origin===`${U.vscodeFileResource}://${D.a}`)?d.with({scheme:U.vscodeFileResource,authority:d.authority||D.a,query:null,fragment:null}):d}asFileUri(d){const L=this.b(d,oe);return this.uriToFileUri(L)}uriToFileUri(d){return d.scheme===U.vscodeFileResource?d.with({scheme:U.file,authority:d.authority!==D.a?d.authority:null,query:null,fragment:null}):d}b(d,L){return i.URI.isUri(d)?d:i.URI.parse(L.toUrl(d))}}t.$ag=new D;var h;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const L="vscode-coi";function s(e){let u;typeof e=="string"?u=new URL(e).searchParams:e instanceof URL?u=e.searchParams:i.URI.isUri(e)&&(u=new URL(e.toString(!0)).searchParams);const l=u?.get(L);if(l)return d.get(l)}f.getHeadersFromQuery=s;function a(e,u,l){if(!globalThis.crossOriginIsolated)return;const m=u&&l?"3":l?"2":"1";e instanceof URLSearchParams?e.set(L,m):e[L]=m}f.addSearchParam=a})(h||(t.COI=h={}))}),define(be[36],$e([1,0,113,28,22,5,12,15]),function(oe,t,y,N,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dg=t.DataUri=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=void 0;function h(a){return(0,D.$uc)(a,!0)}t.$hg=h;class f{constructor(e){this.a=e}compare(e,u,l=!1){return e===u?0:(0,w.$Se)(this.getComparisonKey(e,l),this.getComparisonKey(u,l))}isEqual(e,u,l=!1){return e===u?!0:!e||!u?!1:this.getComparisonKey(e,l)===this.getComparisonKey(u,l)}getComparisonKey(e,u=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,u,l=!1){if(e.scheme===u.scheme){if(e.scheme===N.Schemas.file)return y.$Vf(h(e),h(u),this.a(e))&&e.query===u.query&&(l||e.fragment===u.fragment);if((0,t.$yg)(e.authority,u.authority))return y.$Vf(e.path,u.path,this.a(e),"/")&&e.query===u.query&&(l||e.fragment===u.fragment)}return!1}joinPath(e,...u){return D.URI.joinPath(e,...u)}basenameOrAuthority(e){return(0,t.$qg)(e)||e.authority}basename(e){return i.$ec.basename(e.path)}extname(e){return i.$ec.extname(e.path)}dirname(e){if(e.path.length===0)return e;let u;return e.scheme===N.Schemas.file?u=D.URI.file(i.$kc(h(e))).path:(u=i.$ec.dirname(e.path),e.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),u="/")),e.with({path:u})}normalizePath(e){if(!e.path.length)return e;let u;return e.scheme===N.Schemas.file?u=D.URI.file(i.$fc(h(e))).path:u=i.$ec.normalize(e.path),e.with({path:u})}relativePath(e,u){if(e.scheme!==u.scheme||!(0,t.$yg)(e.authority,u.authority))return;if(e.scheme===N.Schemas.file){const n=i.$jc(h(e),h(u));return U.$i?y.$Pf(n):n}let l=e.path||"/";const m=u.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(l.length,m.length);n<r&&!(l.charCodeAt(n)!==m.charCodeAt(n)&&l.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);l=m.substr(0,n)+l.substr(n)}return i.$ec.relative(l,m)}resolvePath(e,u){if(e.scheme===N.Schemas.file){const l=D.URI.file(i.$ic(h(e),u));return e.with({authority:l.authority,path:l.path})}return u=y.$Qf(u),e.with({path:i.$ec.resolve(e.path,u)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,u){return e===u||e!==void 0&&u!==void 0&&(0,w.$Ze)(e,u)}hasTrailingPathSeparator(e,u=i.sep){if(e.scheme===N.Schemas.file){const l=h(e);return l.length>y.$Rf(l).length&&l[l.length-1]===u}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,u=i.sep){return(0,t.$zg)(e,u)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,u=i.sep){let l=!1;if(e.scheme===N.Schemas.file){const m=h(e);l=m!==void 0&&m.length===y.$Rf(m).length&&m[m.length-1]===u}else{u="/";const m=e.path;l=m.length===1&&m.charCodeAt(m.length-1)===47}return!l&&!(0,t.$zg)(e,u)?e.with({path:e.path+"/"}):e}}t.$ig=f,t.$jg=new f(()=>!1),t.$kg=new f(a=>a.scheme===N.Schemas.file?!U.$k:!0),t.$lg=new f(a=>!0),t.$mg=t.$jg.isEqual.bind(t.$jg),t.$ng=t.$jg.isEqualOrParent.bind(t.$jg),t.$og=t.$jg.getComparisonKey.bind(t.$jg),t.$pg=t.$jg.basenameOrAuthority.bind(t.$jg),t.$qg=t.$jg.basename.bind(t.$jg),t.$rg=t.$jg.extname.bind(t.$jg),t.$sg=t.$jg.dirname.bind(t.$jg),t.$tg=t.$jg.joinPath.bind(t.$jg),t.$ug=t.$jg.normalizePath.bind(t.$jg),t.$vg=t.$jg.relativePath.bind(t.$jg),t.$wg=t.$jg.resolvePath.bind(t.$jg),t.$xg=t.$jg.isAbsolutePath.bind(t.$jg),t.$yg=t.$jg.isEqualAuthority.bind(t.$jg),t.$zg=t.$jg.hasTrailingPathSeparator.bind(t.$jg),t.$Ag=t.$jg.removeTrailingPathSeparator.bind(t.$jg),t.$Bg=t.$jg.addTrailingPathSeparator.bind(t.$jg);function d(a,e){const u=[];for(let l=0;l<a.length;l++){const m=e(a[l]);a.some((n,r)=>r===l?!1:(0,t.$ng)(m,e(n)))||u.push(a[l])}return u}t.$Cg=d;var L;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(u){const l=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(r=>{const[$,c]=r.split(":");$&&c&&l.set($,c)});const n=u.path.substring(0,u.path.indexOf(";"));return n&&l.set(a.META_DATA_MIME,n),l}a.parseMetaData=e})(L||(t.DataUri=L={}));function s(a,e,u){if(e){let l=a.path;return l&&l[0]!==i.$ec.sep&&(l=i.$ec.sep+l),a.with({scheme:u,authority:e,path:l})}return a.with({scheme:u})}t.$Dg=s}),define(be[9],$e([1,0,27,6,3,2,36,5,48]),function(oe,t,y,N,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dh=t.$ch=t.$bh=t.Promises=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=void 0;function f(g){return!!g&&typeof g.then=="function"}t.$Eg=f;function d(g){const p=new y.$Vd,q=g(p.token),T=new Promise((P,O)=>{const _=p.token.onCancellationRequested(()=>{_.dispose(),p.dispose(),O(new N.$3)});Promise.resolve(q).then(S=>{_.dispose(),p.dispose(),P(S)},S=>{_.dispose(),p.dispose(),O(S)})});return new class{cancel(){p.cancel()}then(P,O){return T.then(P,O)}catch(P){return this.then(void 0,P)}finally(P){return T.finally(P)}}}t.$Fg=d;function L(g,p,q){return new Promise((T,P)=>{const O=p.onCancellationRequested(()=>{O.dispose(),T(q)});g.then(T,P).finally(()=>O.dispose())})}t.$Gg=L;function s(g,p){return new Promise((q,T)=>{const P=p.onCancellationRequested(()=>{P.dispose(),T(new N.$3)});g.then(q,T).finally(()=>P.dispose())})}t.$Hg=s;async function a(g){let p=-1;const q=g.map((T,P)=>T.then(O=>(p=P,O)));try{return await Promise.race(q)}finally{g.forEach((T,P)=>{P!==p&&T.cancel()})}}t.$Ig=a;function e(g,p,q){let T;const P=setTimeout(()=>{T?.(void 0),q?.()},p);return Promise.race([g.finally(()=>clearTimeout(P)),new Promise(O=>T=O)])}t.$Jg=e;function u(g){return new Promise((p,q)=>{const T=g();f(T)?T.then(p,q):p(T)})}t.$Kg=u;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const q=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(q,q).then(T)})}return new Promise((q,T)=>{this.b.then(q,T)})}return this.a=p(),new Promise((q,T)=>{this.a.then(P=>{this.a=null,q(P)},P=>{this.a=null,T(P)})})}dispose(){this.f=!0}}t.$Lg=l;class m{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Mg=m;class n{constructor(){this.a=new Map}queue(p,q){const P=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.a.get(p)===P&&this.a.delete(p)});return this.a.set(p,P),P}}t.$Ng=n;const r=(g,p)=>{let q=!0;const T=setTimeout(()=>{q=!1,p()},g);return{isTriggered:()=>q,dispose:()=>{clearTimeout(T),q=!1}}},$=g=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,g())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class c{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,q=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((P,O)=>{this.d=P,this.f=O}).then(()=>{if(this.b=null,this.d=null,this.g){const P=this.g;return this.g=null,P()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=q===h.$Id?$(T):r(q,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Og=c;class o{constructor(p){this.a=new c(p),this.b=new l}trigger(p,q){return this.a.trigger(()=>this.b.queue(p),q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Pg=o;class C{constructor(){this.a=!1,this.b=new Promise((p,q)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Qg=C;class R extends C{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Rg=R;function M(g,p){return p?new Promise((q,T)=>{const P=setTimeout(()=>{O.dispose(),q()},g),O=p.onCancellationRequested(()=>{clearTimeout(P),O.dispose(),T(new N.$3)})}):d(q=>M(g,q))}t.$Sg=M;function b(g,p=0,q){const T=setTimeout(()=>{g(),q&&P.dispose()},p),P=(0,U.$Oc)(()=>{clearTimeout(T),q?.deleteAndLeak(P)});return q?.add(P),P}t.$Tg=b;function v(g){const p=[];let q=0;const T=g.length;function P(){return q<T?g[q++]():null}function O(_){_!=null&&p.push(_);const S=P();return S?S.then(O):Promise.resolve(p)}return Promise.resolve(null).then(O)}t.$Ug=v;function j(g,p=T=>!!T,q=null){let T=0;const P=g.length,O=()=>{if(T>=P)return Promise.resolve(q);const _=g[T++];return Promise.resolve(_()).then(B=>p(B)?Promise.resolve(B):O())};return O()}t.$Vg=j;function z(g,p=T=>!!T,q=null){if(g.length===0)return Promise.resolve(q);let T=g.length;const P=()=>{T=-1;for(const O of g)O.cancel?.()};return new Promise((O,_)=>{for(const S of g)S.then(B=>{--T>=0&&p(B)?(P(),O(B)):T===0&&O(q)}).catch(B=>{--T>=0&&(P(),_(B))})})}t.$Wg=z;class W{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((q,T)=>{this.f.push({factory:p,c:q,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const q=p.factory();q.then(p.c,p.e),q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Xg=W;class I extends W{constructor(){super(1)}}t.$Yg=I;class F{constructor(){this.a=new Pe,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$Zg=F;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new Q;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,q=w.$jg){const T=q.getComparisonKey(p);let P=this.a.get(T);if(!P){P=new I;const O=this.f++,_=i.Event.once(P.onDrained)(()=>{P?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(O),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$Yc),this.d.set(O,_),this.a.set(T,P)}return P}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$1g=X;class te{constructor(p,q){this.a=-1,typeof p=="function"&&typeof q=="number"&&this.setIfNotSet(p,q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},q)}setIfNotSet(p,q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},q))}}t.$2g=te;class re{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(p,q){this.cancel(),this.a=setInterval(()=>{p()},q)}}t.$3g=re;class ce{constructor(p,q){this.b=-1,this.a=p,this.d=q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$4g=ce;class le{constructor(p,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.a=p,this.b=q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$5g=le;class ae extends ce{constructor(p,q){super(p,q),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$6g=ae;class me extends U.$Qc{constructor(p,q){super(),this.g=p,this.h=q,this.a=[],this.b=this.B(new U.$Rc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const q of p)this.a.push(q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ce(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$7g=me,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$8g=g=>{(0,D.$A)(()=>{if(p)return;const q=Date.now()+15;g(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$8g=(g,p)=>{const q=requestIdleCallback(g,typeof p=="number"?{timeout:p}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(q))}}}}();class ke{constructor(p){this.d=!1,this.a=()=>{try{this.f=p()}catch(q){this.g=q}finally{this.d=!0}},this.b=(0,t.$8g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$9g=ke;async function Le(g,p,q){let T;for(let P=0;P<q;P++)try{return await g()}catch(O){T=O,await M(p)}throw T}t.$0g=Le;class Pe{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,q,T){return this.a={taskId:p,cancel:()=>T?.(),promise:q},q.then(()=>this.d(p),()=>this.d(p)),q}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let q,T;const P=new Promise((O,_)=>{q=O,T=_});this.b={run:p,promise:P,promiseResolve:q,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$$g=Pe;class de{constructor(p,q=()=>Date.now()){this.d=p,this.f=q,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$_g=de;var ne;(function(g){g[g.Resolved=0]="Resolved",g[g.Rejected=1]="Rejected"})(ne||(ne={}));class Q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,q)=>{this.a=p,this.b=q})}complete(p){return new Promise(q=>{this.a(p),this.d={outcome:0,value:p},q()})}error(p){return new Promise(q=>{this.b(p),this.d={outcome:1,value:p},q()})}cancel(){return this.error(new N.$3)}}t.$ah=Q;var V;(function(g){async function p(T){let P;const O=await Promise.all(T.map(_=>_.then(S=>S,S=>{P||(P=S)})));if(typeof P<"u")throw P;return O}g.settled=p;function q(T){return new Promise(async(P,O)=>{try{await T(P,O)}catch(_){O(_)}})}g.withAsyncBody=q})(V||(t.Promises=V={}));var ee;(function(g){g[g.Initial=0]="Initial",g[g.DoneOK=1]="DoneOK",g[g.DoneError=2]="DoneError"})(ee||(ee={}));class J{static fromArray(p){return new J(q=>{q.emitMany(p)})}static fromPromise(p){return new J(async q=>{q.emitMany(await p)})}static fromPromises(p){return new J(async q=>{await Promise.all(p.map(async T=>q.emitOne(await T)))})}static merge(p){return new J(async q=>{await Promise.all(p.map(async T=>{for await(const P of T)q.emitOne(P)}))})}static{this.EMPTY=J.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$Ld,queueMicrotask(async()=>{const q={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(p(q)),this.j()}catch(T){this.k(T)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,q){return new J(async T=>{for await(const P of p)T.emitOne(q(P))})}map(p){return J.map(this,p)}static filter(p,q){return new J(async T=>{for await(const P of p)q(P)&&T.emitOne(P)})}filter(p){return J.filter(this,p)}static coalesce(p){return J.filter(p,q=>!!q)}coalesce(){return J.coalesce(this)}static async toPromise(p){const q=[];for await(const T of p)q.push(T);return q}toPromise(){return J.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$bh=J;class k extends J{constructor(p,q){super(q),this.l=p}cancel(){this.l.cancel()}}t.$ch=k;function K(g){const p=new y.$Vd,q=g(p.token);return new k(p,async T=>{const P=p.token.onCancellationRequested(()=>{P.dispose(),p.dispose(),T.reject(new N.$3)});try{for await(const O of q){if(p.token.isCancellationRequested)return;T.emitOne(O)}P.dispose(),p.dispose()}catch(O){P.dispose(),p.dispose(),T.reject(O)}})}t.$dh=K}),define(be[4],$e([1,0,16,111,14,19,9,6,3,115,2,28,5,15]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s,a){"use strict";var e;Object.defineProperty(t,"__esModule",{value:!0}),t.$MP=t.$LP=t.h=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.DetectedFullscreenMode=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$=t.Namespace=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=t.$tO=t.$sO=t.onDidRegisterWindow=t.getWindows=t.registerWindow=void 0,e=function(){const Y=new Set([window]),G=new h.$Ld;return{onDidRegisterWindow:G.event,registerWindow(ue){if(Y.has(ue))return d.$Qc.None;Y.add(ue);const Ee=new d.$Pc;return Ee.add((0,d.$Oc)(()=>{Y.delete(ue)})),G.fire({window:ue,disposableStore:Ee}),Ee},getWindows(){return Y}}}(),t.registerWindow=e.registerWindow,t.getWindows=e.getWindows,t.onDidRegisterWindow=e.onDidRegisterWindow;function u(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.$sO=u;class l{constructor(G,ue,Ee,Se){this.f=G,this.g=ue,this.d=Ee,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function m(Y,G,ue,Ee){return new l(Y,G,ue,Ee)}t.$tO=m;function n(Y){return function(G){return Y(new U.$lO(G))}}function r(Y){return function(G){return Y(new i.$qO(G))}}const $=function(G,ue,Ee,Se){let He=Ee;return ue==="click"||ue==="mousedown"?He=n(Ee):(ue==="keydown"||ue==="keypress"||ue==="keyup")&&(He=r(Ee)),m(G,ue,He,Se)};t.$uO=$;const c=function(G,ue,Ee){const Se=n(ue);return C(G,Se,Ee)};t.$vO=c;const o=function(G,ue,Ee){const Se=n(ue);return M(G,Se,Ee)};t.$wO=o;function C(Y,G,ue){return m(Y,s.$q&&N.$iO.pointerEvents?t.$aP.POINTER_DOWN:t.$aP.MOUSE_DOWN,G,ue)}t.$xO=C;function R(Y,G,ue){return m(Y,s.$q&&N.$iO.pointerEvents?t.$aP.POINTER_MOVE:t.$aP.MOUSE_MOVE,G,ue)}t.$yO=R;function M(Y,G,ue){return m(Y,s.$q&&N.$iO.pointerEvents?t.$aP.POINTER_UP:t.$aP.MOUSE_UP,G,ue)}t.$zO=M;class b{constructor(G,ue=0){this.d=G,this.priority=ue,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,D.$Y)(G)}}static sort(G,ue){return ue.priority-G.priority}}(function(){let Y=[],G=null,ue=!1,Ee=!1;const Se=()=>{for(ue=!1,G=Y,Y=[],Ee=!0;G.length>0;)G.sort(b.sort),G.shift().execute();Ee=!1};t.$BO=(He,Ue=0)=>{const Je=new b(He,Ue);return Y.push(Je),ue||(ue=!0,requestAnimationFrame(Se)),Je},t.$AO=(He,Ue)=>{if(Ee){const Je=new b(He,Ue);return G.push(Je),Je}else return(0,t.$BO)(He,Ue)}})();function v(Y){return(0,t.$BO)(Y,1e4)}t.$CO=v;function j(Y){return(0,t.$BO)(Y,-1e4)}t.$DO=j;const z=8,W=function(Y,G){return G};class I extends d.$Qc{constructor(G,ue,Ee,Se=W,He=z){super();let Ue=null,Je=0;const lt=this.B(new w.$2g),Xe=()=>{Je=new Date().getTime(),Ee(Ue),Ue=null};this.B(m(G,ue,pt=>{Ue=Se(Ue,pt);const Ft=new Date().getTime()-Je;Ft>=He?(lt.cancel(),Xe()):lt.setIfNotSet(Xe,He-Ft)}))}}function F(Y,G,ue,Ee,Se){return new I(Y,G,ue,Ee,Se)}t.$EO=F;function X(Y){return Y.ownerDocument.defaultView.getComputedStyle(Y,null)}t.$FO=X;function te(Y){const G=Y.ownerDocument,ue=G.defaultView?.window;if(Y!==G.body)return new ce(Y.clientWidth,Y.clientHeight);if(s.$q&&ue?.visualViewport)return new ce(ue.visualViewport.width,ue.visualViewport.height);if(ue?.innerWidth&&ue.innerHeight)return new ce(ue.innerWidth,ue.innerHeight);if(G.body&&G.body.clientWidth&&G.body.clientHeight)return new ce(G.body.clientWidth,G.body.clientHeight);if(G.documentElement&&G.documentElement.clientWidth&&G.documentElement.clientHeight)return new ce(G.documentElement.clientWidth,G.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$GO=te;class re{static d(G,ue){return parseFloat(ue)||0}static f(G,ue,Ee){const Se=X(G),He=Se?Se.getPropertyValue(ue):"0";return re.d(G,He)}static getBorderLeftWidth(G){return re.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return re.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return re.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return re.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return re.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return re.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return re.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return re.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return re.f(G,"margin-left","marginLeft")}static getMarginTop(G){return re.f(G,"margin-top","marginTop")}static getMarginRight(G){return re.f(G,"margin-right","marginRight")}static getMarginBottom(G){return re.f(G,"margin-bottom","marginBottom")}}class ce{static{this.None=new ce(0,0)}constructor(G,ue){this.width=G,this.height=ue}with(G=this.width,ue=this.height){return G!==this.width||ue!==this.height?new ce(G,ue):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof ce?G:new ce(G.width,G.height)}static equals(G,ue){return G===ue?!0:!G||!ue?!1:G.width===ue.width&&G.height===ue.height}}t.$HO=ce;function le(Y){let G=Y.offsetParent,ue=Y.offsetTop,Ee=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==Y.ownerDocument.body&&Y!==Y.ownerDocument.documentElement;){ue-=Y.scrollTop;const Se=O(Y)?null:X(Y);Se&&(Ee-=Se.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Ee+=re.getBorderLeftWidth(Y),ue+=re.getBorderTopWidth(Y),ue+=Y.offsetTop,Ee+=Y.offsetLeft,G=Y.offsetParent)}return{left:Ee,top:ue}}t.$IO=le;function ae(Y,G,ue){typeof G=="number"&&(Y.style.width=`${G}px`),typeof ue=="number"&&(Y.style.height=`${ue}px`)}t.$JO=ae;function me(Y,G,ue,Ee,Se,He="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof ue=="number"&&(Y.style.right=`${ue}px`),typeof Ee=="number"&&(Y.style.bottom=`${Ee}px`),typeof Se=="number"&&(Y.style.left=`${Se}px`),Y.style.position=He}t.$KO=me;function ke(Y){const G=Y.getBoundingClientRect();return{left:G.left+(Y.ownerDocument.defaultView?.scrollX??0),top:G.top+(Y.ownerDocument.defaultView?.scrollY??0),width:G.width,height:G.height}}t.$LO=ke;function Le(Y){let G=Y,ue=1;do{const Ee=X(G).zoom;Ee!=null&&Ee!=="1"&&(ue*=Ee),G=G.parentElement}while(G!==null&&G!==G.ownerDocument.documentElement);return ue}t.$MO=Le;function Pe(Y){const G=re.getMarginLeft(Y)+re.getMarginRight(Y);return Y.offsetWidth+G}t.$NO=Pe;function de(Y){const G=re.getBorderLeftWidth(Y)+re.getBorderRightWidth(Y),ue=re.getPaddingLeft(Y)+re.getPaddingRight(Y);return Y.offsetWidth-G-ue}t.$OO=de;function ne(Y){const G=re.getMarginLeft(Y)+re.getMarginRight(Y);return Y.scrollWidth+G}t.$PO=ne;function Q(Y){const G=re.getBorderTopWidth(Y)+re.getBorderBottomWidth(Y),ue=re.getPaddingTop(Y)+re.getPaddingBottom(Y);return Y.offsetHeight-G-ue}t.$QO=Q;function V(Y){const G=re.getMarginTop(Y)+re.getMarginBottom(Y);return Y.offsetHeight+G}t.$RO=V;function ee(Y,G){if(Y===null)return 0;const ue=le(Y),Ee=le(G);return ue.left-Ee.left}function J(Y,G){const ue=G.map(Se=>Math.max(ne(Se),Pe(Se))+ee(Se,Y)||0);return Math.max(...ue)}t.$SO=J;function k(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.$TO=k;const K="parentFlowToElementId";function g(Y,G){Y.dataset[K]=G.id}t.$UO=g;function p(Y){const G=Y.dataset[K];return typeof G=="string"?Y.ownerDocument.getElementById(G):null}function q(Y,G){let ue=Y;for(;ue;){if(ue===G)return!0;if(ue instanceof HTMLElement){const Ee=p(ue);if(Ee){ue=Ee;continue}}ue=ue.parentNode}return!1}t.$VO=q;function T(Y,G,ue){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(ue){if(typeof ue=="string"){if(Y.classList.contains(ue))return null}else if(Y===ue)return null}Y=Y.parentNode}return null}t.$WO=T;function P(Y,G,ue){return!!T(Y,G,ue)}t.$XO=P;function O(Y){return Y&&!!Y.host&&!!Y.mode}t.$YO=O;function _(Y){return!!S(Y)}t.$ZO=_;function S(Y){for(;Y.parentNode;){if(Y===Y.ownerDocument?.body)return null;Y=Y.parentNode}return O(Y)?Y:null}t.$1O=S;function B(){let Y=E().activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.$2O=B;function E(){return Array.from((0,t.getWindows)()).map(G=>G.document).find(G=>G.hasFocus())??document}t.$3O=E;function A(){return E().defaultView?.window??window}t.$4O=A;function H(Y){const G=Y;if(G?.ownerDocument?.defaultView)return G.ownerDocument.defaultView.window;const ue=Y;return ue?.view?ue.view.window:window}function x(Y=document.getElementsByTagName("head")[0],G){const ue=document.createElement("style");return ue.type="text/css",ue.media="screen",G?.(ue),Y.appendChild(ue),ue}t.$5O=x;function ie(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.$6O=ie;let se=null;function ge(){return se||(se=x()),se}function we(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function Fe(Y,G,ue=ge()){!ue||!G||ue.sheet.insertRule(Y+"{"+G+"}",0)}t.$7O=Fe;function Ae(Y,G=ge()){if(!G)return;const ue=we(G),Ee=[];for(let Se=0;Se<ue.length;Se++)ue[Se].selectorText.indexOf(Y)!==-1&&Ee.push(Se);for(let Se=Ee.length-1;Se>=0;Se--)G.sheet.deleteRule(Ee[Se])}t.$8O=Ae;function ve(Y){return Y instanceof MouseEvent||Y instanceof H(Y).MouseEvent}t.$9O=ve;function Ie(Y){return Y instanceof KeyboardEvent||Y instanceof H(Y).KeyboardEvent}t.$0O=Ie;function Oe(Y){return Y instanceof PointerEvent||Y instanceof H(Y).PointerEvent}t.$$O=Oe;function qe(Y){return Y instanceof DragEvent||Y instanceof H(Y).DragEvent}t.$_O=qe,t.$aP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.$aO?"webkitAnimationStart":"animationstart",ANIMATION_END:y.$aO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.$aO?"webkitAnimationIteration":"animationiteration"};function je(Y){const G=Y;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.$bP=je,t.$cP={stop:(Y,G)=>(Y.preventDefault(),G&&Y.stopPropagation(),Y)};function Me(Y){const G=[];for(let ue=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ue++)G[ue]=Y.scrollTop,Y=Y.parentNode;return G}t.$dP=Me;function Ge(Y,G){for(let ue=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ue++)Y.scrollTop!==G[ue]&&(Y.scrollTop=G[ue]),Y=Y.parentNode}t.$eP=Ge;class Z extends d.$Qc{static m(G){if(G instanceof HTMLElement){const ue=S(G),Ee=ue?ue.activeElement:G.ownerDocument.activeElement;return k(Ee,G)}else return k(window.document.activeElement,window.document)}constructor(G){super(),this.f=this.B(new h.$Ld),this.onDidFocus=this.f.event,this.g=this.B(new h.$Ld),this.onDidBlur=this.g.event;let ue=Z.m(G),Ee=!1;const Se=()=>{Ee=!1,ue||(ue=!0,this.f.fire())},He=()=>{ue&&(Ee=!0,window.setTimeout(()=>{Ee&&(Ee=!1,ue=!1,this.g.fire())},0))};this.j=()=>{Z.m(G)!==ue&&(ue?He():Se())},this.B(m(G,t.$aP.FOCUS,Se,!0)),this.B(m(G,t.$aP.BLUR,He,!0)),G instanceof HTMLElement&&(this.B(m(G,t.$aP.FOCUS_IN,()=>this.j())),this.B(m(G,t.$aP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function he(Y){return new Z(Y)}t.$fP=he;function pe(Y,G){return Y.after(G),G}t.$gP=pe;function De(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.$hP=De;function Ce(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.$iP=Ce;function Re(Y,...G){Y.innerText="",De(Y,...G)}t.$jP=Re;const ze=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ke;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(Ke||(t.Namespace=Ke={}));function Ye(Y,G,ue,...Ee){const Se=ze.exec(G);if(!Se)throw new Error("Bad use of emmet");const He=Se[1]||"div";let Ue;return Y!==Ke.HTML?Ue=document.createElementNS(Y,He):Ue=document.createElement(He),Se[3]&&(Ue.id=Se[3]),Se[4]&&(Ue.className=Se[4].replace(/\./g," ").trim()),ue&&Object.entries(ue).forEach(([Je,lt])=>{typeof lt>"u"||(/^on\w+$/.test(Je)?Ue[Je]=lt:Je==="selected"?lt&&Ue.setAttribute(Je,"true"):Ue.setAttribute(Je,lt))}),Ue.append(...Ee),Ue}function Ve(Y,G,...ue){return Ye(Ke.HTML,Y,G,...ue)}t.$=Ve,Ve.SVG=function(Y,G,...ue){return Ye(Ke.SVG,Y,G,...ue)};function _e(Y,G){const ue=[];return Y.forEach((Ee,Se)=>{Se>0&&(G instanceof Node?ue.push(G.cloneNode()):ue.push(document.createTextNode(G))),ue.push(Ee)}),ue}t.$lP=_e;function et(Y,...G){Y?tt(...G):ft(...G)}t.$mP=et;function tt(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.$nP=tt;function ft(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.$oP=ft;function ct(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function ut(Y){!Y||!Y.hasAttribute("tabIndex")||(Y.ownerDocument.activeElement===Y&&ct(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.$pP=ut;function yt(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.$qP=yt;function Et(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.$rP=Et;function At(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.$sP=At;function kt(Y){window.open(Y,"_blank","noopener")}t.$tP=kt;const St=780,Te=640;function fe(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-St/2),ue=Math.floor(window.screenTop+window.innerHeight/2-Te/2);window.open(Y,"_blank",`width=${St},height=${Te},top=${ue},left=${G}`)}t.$uP=fe;function ye(Y,G=!0){const ue=window.open();return ue?(G&&(ue.opener=null),ue.location.href=Y,!0):!1}t.$vP=ye;function Ne(Y){const G=()=>{Y(),ue=(0,t.$BO)(G)};let ue=(0,t.$BO)(G);return(0,d.$Oc)(()=>ue.dispose())}t.$wP=Ne,L.$7f.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function We(Y){return Y?`url('${L.$ag.uriToBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$xP=We;function Ze(Y){return`'${Y.replace(/'/g,"%27")}'`}t.$yP=Ze;function nt(Y,G){if(Y!==void 0){const ue=Y.match(/^\s*var\((.+)\)$/);if(ue){const Ee=ue[1].split(",",2);return Ee.length===2&&(G=nt(Ee[1].trim(),G)),`var(${Ee[0]}, ${G})`}return Y}return G}t.$zP=nt;function xe(Y,G){let ue;if(a.URI.isUri(Y))ue=Y.toString(!0);else{const Se=new Blob([Y]);ue=URL.createObjectURL(Se),setTimeout(()=>URL.revokeObjectURL(ue))}const Ee=document.createElement("a");document.body.appendChild(Ee),Ee.download=G,Ee.href=ue,Ee.click(),setTimeout(()=>document.body.removeChild(Ee))}t.$AP=xe;function ot(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,h.Event.once(h.Event.fromDOMEventEmitter(G,"input"))(()=>{Y(G.files??void 0)}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.$BP=ot;var dt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(dt||(t.DetectedFullscreenMode=dt={}));function Ct(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(s.$j||s.$k)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.$CP=Ct;function Rt(Y,G=!1){const ue=document.createElement("a");return f.addHook("afterSanitizeAttributes",Ee=>{for(const Se of["href","src"])if(Ee.hasAttribute(Se)){const He=Ee.getAttribute(Se);if(Se==="href"&&He.startsWith("#"))continue;if(ue.href=He,!Y.includes(ue.protocol.replace(/:$/,""))){if(G&&Se==="src"&&ue.href.startsWith("data:"))continue;Ee.removeAttribute(Se)}}}),(0,d.$Oc)(()=>{f.removeHook("afterSanitizeAttributes")})}t.$DP=Rt;const wi=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$EP=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const vi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Di(Y,G){const ue=Rt(wi);try{const Ee=f.sanitize(G,vi);Y.innerHTML=Ee}finally{ue.dispose()}}t.$FP=Di;function yi(Y){const G=new Uint16Array(Y.length);for(let Se=0;Se<G.length;Se++)G[Se]=Y.charCodeAt(Se);let ue="";const Ee=new Uint8Array(G.buffer);for(let Se=0;Se<Ee.length;Se++)ue+=String.fromCharCode(Ee[Se]);return ue}function Ei(Y){return btoa(yi(Y))}t.$GP=Ei;class mt extends h.$Ld{constructor(){super(),this.o=new d.$Pc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m(window,"keydown",G=>{if(G.defaultPrevented)return;const ue=new i.$qO(G);if(!(ue.keyCode===6&&G.repeat)){if(G.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(G.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(G.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(G.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ue.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=G.altKey,this.s.ctrlKey=G.ctrlKey,this.s.metaKey=G.metaKey,this.s.shiftKey=G.shiftKey,this.s.lastKeyPressed&&(this.s.event=G,this.fire(this.s))}},!0)),this.o.add(m(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!G.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!G.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!G.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=G.altKey,this.s.ctrlKey=G.ctrlKey,this.s.metaKey=G.metaKey,this.s.shiftKey=G.shiftKey,this.s.lastKeyReleased&&(this.s.event=G,this.fire(this.s)))},!0)),this.o.add(m(document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),this.o.add(m(document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),this.o.add(m(document.body,"mousemove",G=>{G.buttons&&(this.s.lastKeyPressed=void 0)},!0)),this.o.add(m(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return mt.B||(mt.B=new mt),mt.B}dispose(){super.dispose(),this.o.dispose()}}t.$HP=mt;function Ai(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.$IP=Ai;class ki extends d.$Qc{constructor(G,ue){super(),this.j=G,this.m=ue,this.f=0,this.g=0,this.n()}n(){this.B(m(this.j,t.$aP.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.m.onDragEnter(G)})),this.B(m(this.j,t.$aP.DRAG_OVER,G=>{G.preventDefault(),this.m.onDragOver?.(G,G.timeStamp-this.g)})),this.B(m(this.j,t.$aP.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(G))})),this.B(m(this.j,t.$aP.DRAG_END,G=>{this.f=0,this.g=0,this.m.onDragEnd(G)})),this.B(m(this.j,t.$aP.DROP,G=>{this.f=0,this.g=0,this.m.onDrop(G)}))}}t.$JP=ki;const Si=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ci(Y,...G){let ue,Ee;Array.isArray(G[0])?(ue={},Ee=G[0]):(ue=G[0]||{},Ee=G[1]);const Se=Si.exec(Y);if(!Se||!Se.groups)throw new Error("Bad use of h");const He=Se.groups.tag||"div",Ue=document.createElement(He);Se.groups.id&&(Ue.id=Se.groups.id);const Je=[];if(Se.groups.class)for(const Xe of Se.groups.class.split("."))Xe!==""&&Je.push(Xe);if(ue.className!==void 0)for(const Xe of ue.className.split("."))Xe!==""&&Je.push(Xe);Je.length>0&&(Ue.className=Je.join(" "));const lt={};if(Se.groups.name&&(lt[Se.groups.name]=Ue),Ee)for(const Xe of Ee)Xe instanceof HTMLElement?Ue.appendChild(Xe):typeof Xe=="string"?Ue.append(Xe):"root"in Xe&&(Object.assign(lt,Xe),Ue.appendChild(Xe.root));for(const[Xe,pt]of Object.entries(ue))if(Xe!=="className")if(Xe==="style")for(const[Ft,Bt]of Object.entries(pt))Ue.style.setProperty(Gt(Ft),typeof Bt=="number"?Bt+"px":""+Bt);else Xe==="tabIndex"?Ue.tabIndex=pt:Ue.setAttribute(Gt(Xe),pt.toString());return lt.root=Ue,lt}t.h=Ci;function Gt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function Fi(Y,G){const ue=new h.$Ld,Ee=new MutationObserver(Se=>{for(const He of Se)He.type==="attributes"&&He.attributeName&&ue.fire(He.attributeName)});return Ee.observe(Y,{attributes:!0,attributeFilter:G}),{onDidChangeAttribute:ue.event,dispose:()=>{Ee.disconnect(),ue.dispose()}}}function Yt(Y,G){for(const{name:ue,value:Ee}of Y.attributes)G.setAttribute(ue,Ee)}t.$LP=Yt;function Ni(Y,G,ue){const Ee=Y.getAttribute(ue);Ee?G.setAttribute(ue,Ee):G.removeAttribute(ue)}function Pi(Y,G,ue){Yt(Y,G);const Ee=Fi(Y,ue);return(0,d.$Nc)(Ee,Ee.onDidChangeAttribute(Se=>Ni(Y,G,Se)))}t.$MP=Pi}),define(be[52],$e([1,0,4,2,114]),function(oe,t,y,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PP=t.$OP=t.$NP=void 0;class U extends N.$Qc{constructor(h,f){super(),this.B((0,y.$tO)(h,"dragover",d=>{d.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this.B((0,y.$tO)(h,d,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$NP=U,t.$OP={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Jr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(D,h,f,d,L){const s=document.createElement("div");s.className=f,s.textContent=h,L&&(s.style.color=L),d&&(s.style.background=d),D.dataTransfer&&(document.body.appendChild(s),D.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>document.body.removeChild(s),0))}t.$PP=w}),define(be[53],$e([1,0,4]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hQ=t.$gQ=t.$fQ=void 0;function N(s,a={}){const e=U(a);return e.textContent=s,e}t.$fQ=N;function i(s,a={}){const e=U(a);return h(e,f(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$gQ=i;function U(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$hQ=U;class w{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var D;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(D||(D={}));function h(s,a,e,u){let l;if(a.type===2)l=document.createTextNode(a.content||"");else if(a.type===3)l=document.createElement("b");else if(a.type===4)l=document.createElement("i");else if(a.type===7&&u)l=document.createElement("code");else if(a.type===5&&e){const m=document.createElement("a");e.disposables.add(y.$uO(m,"click",n=>{e.callback(String(a.index),n)})),l=m}else a.type===8?l=document.createElement("br"):a.type===1&&(l=s);l&&s!==l&&s.appendChild(l),l&&Array.isArray(a.children)&&a.children.forEach(m=>{h(l,m,e,u)})}function f(s,a){const e={type:1,children:[]};let u=0,l=e;const m=[],n=new w(s);for(;!n.eos();){let r=n.next();const $=r==="\\"&&L(n.peek(),a)!==0;if($&&(r=n.next()),!$&&d(r,a)&&r===n.peek()){n.advance(),l.type===2&&(l=m.pop());const c=L(r,a);if(l.type===c||l.type===5&&c===6)l=m.pop();else{const o={type:c,children:[]};c===5&&(o.index=u,u++),l.children.push(o),m.push(l),l=o}}else if(r===`
`)l.type===2&&(l=m.pop()),l.children.push({type:8});else if(l.type!==2){const c={type:2,content:r};l.children.push(c),m.push(l),l=c}else l.content+=r}return l.type===2&&(l=m.pop()),m.length,e}function d(s,a){return L(s,a)!==0}function L(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(be[54],$e([1,0,4,2]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TP=void 0;class i{constructor(){this.a=new N.$Pc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(w,D){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const h=this.c;this.c=null,w&&h&&h(D)}isMonitoring(){return!!this.b}startMonitoring(w,D,h,f,d){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=d;let L=w;try{w.setPointerCapture(D),this.a.add((0,N.$Oc)(()=>{try{w.releasePointerCapture(D)}catch{}}))}catch{L=window}this.a.add(y.$tO(L,y.$aP.POINTER_MOVE,s=>{if(s.buttons!==h){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(y.$tO(L,y.$aP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$TP=i});var Qe=this&&this.__decorate||function(oe,t,y,N){var i=arguments.length,U=i<3?t:N===null?N=Object.getOwnPropertyDescriptor(t,y):N,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(oe,t,y,N);else for(var D=oe.length-1;D>=0;D--)(w=oe[D])&&(U=(i<3?w(U):i>3?w(t,y,U):w(t,y))||U);return i>3&&U&&Object.defineProperty(t,y,U),U};define(be[23],$e([1,0,4,11,25,2,44]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QP=t.EventType=void 0;var D;(function(f){f.Tap="-monaco-gesturetap",f.Change="-monaco-gesturechange",f.Start="-monaco-gesturestart",f.End="-monaco-gesturesend",f.Contextmenu="-monaco-gesturecontextmenu"})(D||(t.EventType=D={}));class h extends U.$Qc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new w.$Zc,this.h=new w.$Zc,this.m={},this.j=null,this.n=0,this.B(y.$tO(document,"touchstart",d=>this.s(d),{passive:!1})),this.B(y.$tO(document,"touchend",d=>this.u(d))),this.B(y.$tO(document,"touchmove",d=>this.D(d),{passive:!1}))}static addTarget(d){if(!h.isTouchDevice())return U.$Qc.None;h.b||(h.b=(0,U.$Jc)(new h));const L=h.b.g.push(d);return(0,U.$Oc)(L)}static ignoreTarget(d){if(!h.isTouchDevice())return U.$Qc.None;h.b||(h.b=(0,U.$Jc)(new h));const L=h.b.h.push(d);return(0,U.$Oc)(L)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(d){const L=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let s=0,a=d.targetTouches.length;s<a;s++){const e=d.targetTouches.item(s);this.m[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:L,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[L],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const u=this.w(D.Start,e.target);u.pageX=e.pageX,u.pageY=e.pageY,this.z(u)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}u(d){const L=Date.now(),s=Object.keys(this.m).length;for(let a=0,e=d.changedTouches.length;a<e;a++){const u=d.changedTouches.item(a);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("move of an UNKNOWN touch",u);continue}const l=this.m[u.identifier],m=Date.now()-l.initialTimeStamp;if(m<h.c&&Math.abs(l.initialPageX-N.$qb(l.rollingPageX))<30&&Math.abs(l.initialPageY-N.$qb(l.rollingPageY))<30){const n=this.w(D.Tap,l.initialTarget);n.pageX=N.$qb(l.rollingPageX),n.pageY=N.$qb(l.rollingPageY),this.z(n)}else if(m>=h.c&&Math.abs(l.initialPageX-N.$qb(l.rollingPageX))<30&&Math.abs(l.initialPageY-N.$qb(l.rollingPageY))<30){const n=this.w(D.Contextmenu,l.initialTarget);n.pageX=N.$qb(l.rollingPageX),n.pageY=N.$qb(l.rollingPageY),this.z(n)}else if(s===1){const n=N.$qb(l.rollingPageX),r=N.$qb(l.rollingPageY),$=N.$qb(l.rollingTimestamps)-l.rollingTimestamps[0],c=n-l.rollingPageX[0],o=r-l.rollingPageY[0],C=[...this.g].filter(R=>l.initialTarget instanceof Node&&R.contains(l.initialTarget));this.C(C,L,Math.abs(c)/$,c>0?1:-1,n,Math.abs(o)/$,o>0?1:-1,r)}this.z(this.w(D.End,l.initialTarget)),delete this.m[u.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}w(d,L){const s=document.createEvent("CustomEvent");return s.initEvent(d,!1,!0),s.initialTarget=L,s.tapCount=0,s}z(d){if(d.type===D.Tap){const L=new Date().getTime();let s=0;L-this.n>h.r?s=1:s=2,this.n=L,d.tapCount=s}else(d.type===D.Change||d.type===D.Contextmenu)&&(this.n=0);if(d.initialTarget instanceof Node){for(const L of this.h)if(L.contains(d.initialTarget))return;for(const L of this.g)L.contains(d.initialTarget)&&(L.dispatchEvent(d),this.f=!0)}}C(d,L,s,a,e,u,l,m){this.j=y.$BO(()=>{const n=Date.now(),r=n-L;let $=0,c=0,o=!0;s+=h.a*r,u+=h.a*r,s>0&&(o=!1,$=a*s*r),u>0&&(o=!1,c=l*u*r);const C=this.w(D.Change);C.translationX=$,C.translationY=c,d.forEach(R=>R.dispatchEvent(C)),o||this.C(d,n,s,a,e+$,u,l,m+c)})}D(d){const L=Date.now();for(let s=0,a=d.changedTouches.length;s<a;s++){const e=d.changedTouches.item(s);if(!this.m.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const u=this.m[e.identifier],l=this.w(D.Change,u.initialTarget);l.translationX=e.pageX-N.$qb(u.rollingPageX),l.translationY=e.pageY-N.$qb(u.rollingPageY),l.pageX=e.pageX,l.pageY=e.pageY,this.z(l),u.rollingPageX.length>3&&(u.rollingPageX.shift(),u.rollingPageY.shift(),u.rollingTimestamps.shift()),u.rollingPageX.push(e.pageX),u.rollingPageY.push(e.pageY),u.rollingTimestamps.push(L)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}}t.$QP=h,Qe([i.$eh],h,"isTouchDevice",null)}),define(be[55],$e([1,0,4,89]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lQ=t.$kQ=t.$jQ=void 0;const N=2e4;let i,U,w,D,h;function f(a){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};U=e(),w=e();const u=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};D=u(),h=u(),a.appendChild(i)}t.$jQ=f;function d(a){i&&(U.textContent!==a?(y.$sO(w),s(U,a)):(y.$sO(U),s(w,a)))}t.$kQ=d;function L(a){i&&(D.textContent!==a?(y.$sO(h),s(D,a)):(y.$sO(D),s(h,a)))}t.$lQ=L;function s(a,e){y.$sO(a),e.length>N&&(e=e.substr(0,N)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define(be[116],$e([1,0,4,18]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KQ=t.$JQ=void 0;const i=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(D){const h=new Array;let f,d=0,L=0;for(;(f=i.exec(D))!==null;){L=f.index||0,d<L&&h.push(D.substring(d,L)),d=(f.index||0)+f[0].length;const[,s,a]=f;h.push(s?`$(${a})`:w({id:a}))}return d<D.length&&h.push(D.substring(d)),h}t.$JQ=U;function w(D){const h=y.$("span");return h.classList.add(...N.ThemeIcon.asClassNameArray(D)),h}t.$KQ=w}),define(be[117],$e([1,0,4]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uQ=void 0;function N(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(w){this.d=w,this.a=new Map,this.b=new Set,this.c=!1}alloc(w){let D=this.h(w).pop(),h=!1;if(D)h=this.b.has(D.domNode),h&&this.b.delete(D.domNode);else{const f=(0,y.$)(".monaco-list-row"),L=this.i(w).renderTemplate(f);D={domNode:f,templateId:w,templateData:L}}return{row:D,isReusingConnectedDomNode:h}}release(w){w&&this.f(w)}transact(w){if(this.c)throw new Error("Already in transaction");this.c=!0;try{w()}finally{for(const D of this.b)this.g(D);this.b.clear(),this.c=!1}}f(w){const{domNode:D,templateId:h}=w;D&&(this.c?this.b.add(D):this.g(D)),this.h(h).push(w)}g(w){w.classList.remove("scrolling"),N(w)}h(w){let D=this.a.get(w);return D||(D=[],this.a.set(w,D)),D}dispose(){this.a.forEach((w,D)=>{for(const h of w)this.i(D).disposeTemplate(h.templateData),h.templateData=null}),this.a.clear(),this.b.clear()}i(w){const D=this.d.get(w);if(!D)throw new Error(`No renderer found for ${w}`);return D}}t.$uQ=i}),define(be[118],$e([1,0,9,2]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YP=void 0;class i extends N.$Qc{constructor(w,D,h){super(),this.a=w,this.b=D,this.c=h,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new y.$2g)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$YP=i}),define(be[119],$e([1,0,4,23,11,3,2,5]),function(oe,t,y,N,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RQ=void 0;class h extends w.$Qc{constructor(d,L,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Ld),this.h=s,this.j(),this.setOptions(d,L)}j(){this.B(N.$QP.addTarget(this.a)),[N.EventType.Tap].forEach(d=>{this.B(y.$tO(this.a,d,L=>{this.a.focus()}))}),this.B(y.$uO(this.a,"click",d=>{y.$cP.stop(d,!0)})),this.B(y.$uO(this.a,"change",d=>{this.a.title=d.target.value,this.g.fire({index:d.target.selectedIndex,selected:d.target.value})})),this.B(y.$uO(this.a,"keydown",d=>{let L=!1;D.$j?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(L=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(L=!0),L&&d.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(d,L){(!this.c||!i.$sb(this.c,d))&&(this.c=d,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),L!==void 0&&this.select(L)}select(d){this.c.length===0?this.f=0:d>=0&&d<this.c.length?this.f=d:d>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(d){this.b.ariaLabel=d,this.a.setAttribute("aria-label",d)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(d){this.a.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(d){this.h=d,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(d,L,s){const a=document.createElement("option");return a.value=d,a.text=d,a.disabled=!!s,a}}t.$RQ=h}),define(be[56],$e([1,0,24,11,9,48,85,3,26]),function(oe,t,y,N,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mS=t.$lS=t.$kS=void 0;function f(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$kS=f;function d(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$lS=d;function L(a){return typeof a.collapsible=="boolean"}class s{constructor(e,u,l,m={}){this.o=e,this.p=u,this.rootRef=[],this.d=new D.$Td,this.f=new D.$Ld,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.$Ld,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.$Ld,this.onDidSplice=this.l.event,this.m=new i.$Og(U.$Id),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:l,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,u,l=h.Iterable.empty(),m={}){if(e.length===0)throw new y.$iS(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,u,l,m):this.s(e,u,l,m)}q(e,u,l,m=h.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:$}=this.G(u);if(!$.lastDiffIds)return this.s(u,l,m,n);const c=[...m],o=u[u.length-1],C=new w.$ss({getElements:()=>$.lastDiffIds},{getElements:()=>[...$.children.slice(0,o),...c,...$.children.slice(o+l)].map(j=>e.getId(j.element).toString())}).ComputeDiff(!1);if(C.quitEarly)return $.lastDiffIds=void 0,this.s(u,l,c,n);const R=u.slice(0,-1),M=(j,z,W)=>{if(r>0)for(let I=0;I<W;I++)j--,z--,this.q(e,[...R,j,0],Number.MAX_SAFE_INTEGER,c[z].children,n,r-1)};let b=Math.min($.children.length,o+l),v=c.length;for(const j of C.changes.sort((z,W)=>W.originalStart-z.originalStart))M(b,v,b-(j.originalStart+j.originalLength)),b=j.originalStart,v=j.modifiedStart-o,this.s([...R,b],j.originalLength,h.Iterable.slice(c,v,v+j.modifiedLength),n);M(b,v,b)}s(e,u,l=h.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:$,listIndex:c,revealed:o,visible:C}=this.G(e),R=[],M=h.Iterable.map(l,ce=>this.w(ce,$,$.visible?1:0,o,R,m)),b=e[e.length-1],v=$.children.length>0;let j=0;for(let ce=b;ce>=0&&ce<$.children.length;ce--){const le=$.children[ce];if(le.visible){j=le.visibleChildIndex;break}}const z=[];let W=0,I=0;for(const ce of M)z.push(ce),I+=ce.renderNodeCount,ce.visible&&(ce.visibleChildIndex=j+W++);const F=(0,N.$4b)($.children,b,u,z);r?$.lastDiffIds?(0,N.$4b)($.lastDiffIds,b,u,z.map(ce=>r.getId(ce.element).toString())):$.lastDiffIds=$.children.map(ce=>r.getId(ce.element).toString()):$.lastDiffIds=void 0;let X=0;for(const ce of F)ce.visible&&X++;if(X!==0)for(let ce=b+z.length;ce<$.children.length;ce++){const le=$.children[ce];le.visible&&(le.visibleChildIndex-=X)}if($.visibleChildrenCount+=W-X,o&&C){const ce=F.reduce((le,ae)=>le+(ae.visible?ae.renderNodeCount:0),0);this.B($,I-ce),this.p.splice(c,ce,R)}if(F.length>0&&n){const ce=le=>{n(le),le.children.forEach(ce)};F.forEach(ce)}this.l.fire({insertedNodes:z,deletedNodes:F});const te=$.children.length>0;v!==te&&this.setCollapsible(e.slice(0,-1),te);let re=$;for(;re;){if(re.visibility===2){this.m.trigger(()=>this.refilter());break}re=re.parent}}rerender(e){if(e.length===0)throw new y.$iS(this.o,"Invalid tree location");const{node:u,listIndex:l,revealed:m}=this.F(e);u.visible&&m&&this.p.splice(l,1,[u])}updateElementHeight(e,u){if(e.length===0)throw new y.$iS(this.o,"Invalid tree location");const{listIndex:l}=this.F(e);this.p.updateElementHeight(l,u)}has(e){return this.D(e)}getListIndex(e){const{listIndex:u,visible:l,revealed:m}=this.F(e);return l&&m?u:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,u){const l=this.E(e);typeof u>"u"&&(u=!l.collapsible);const m={collapsible:u};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,u,l){const m=this.E(e);typeof u>"u"&&(u=!m.collapsed);const n={collapsed:u,recursive:l||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,u){const{node:l,listIndex:m,revealed:n}=this.F(e),r=this.u(l,m,n,u);if(l!==this.c&&this.k&&r&&!L(u)&&l.collapsible&&!l.collapsed&&!u.recursive){let $=-1;for(let c=0;c<l.children.length;c++)if(l.children[c].visible)if($>-1){$=-1;break}else $=c;$>-1&&this.t([...e,$],u)}return r}u(e,u,l,m){const n=this.v(e,m,!1);if(!l||!e.visible||!n)return n;const r=e.renderNodeCount,$=this.x(e),c=r-(u===-1?0:1);return this.p.splice(u+1,c,$.slice(1)),n}v(e,u,l){let m;if(e===this.c?m=!1:(L(u)?(m=e.collapsible!==u.collapsible,e.collapsible=u.collapsible):e.collapsible?(m=e.collapsed!==u.collapsed,e.collapsed=u.collapsed):m=!1,m&&this.f.fire({node:e,deep:l})),!L(u)&&u.recursive)for(const n of e.children)m=this.v(n,u,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let u=this.E(e);for(;u.parent;)u=u.parent,e=e.slice(0,e.length-1),u.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,u=this.z(this.c);this.p.splice(0,e,u),this.m.cancel()}w(e,u,l,m,n,r){const $={parent:u,element:e.element,children:[],depth:u.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},c=this.C($,l);$.visibility=c,m&&n.push($);const o=e.children||h.Iterable.empty(),C=m&&c!==0&&!$.collapsed;let R=0,M=1;for(const b of o){const v=this.w(b,$,c,C,n,r);$.children.push(v),M+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=R++)}return $.collapsible=$.collapsible||$.children.length>0,$.visibleChildrenCount=R,$.visible=c===2?R>0:c===1,$.visible?$.collapsed||($.renderNodeCount=M):($.renderNodeCount=0,m&&n.pop()),r?.($),$}x(e){const u=e.renderNodeCount,l=[];return this.y(e,l),this.B(e.parent,l.length-u),l}y(e,u){if(e.visible===!1)return 0;if(u.push(e),e.renderNodeCount=1,!e.collapsed)for(const l of e.children)e.renderNodeCount+=this.y(l,u);return this.g.fire(e),e.renderNodeCount}z(e){const u=e.renderNodeCount,l=[];return this.A(e,e.visible?1:0,l),this.B(e.parent,l.length-u),l}A(e,u,l,m=!0){let n;if(e!==this.c){if(n=this.C(e,u),n===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&l.push(e)}const r=l.length;e.renderNodeCount=e===this.c?0:1;let $=!1;if(!e.collapsed||n!==0){let c=0;for(const o of e.children)$=this.A(o,n,l,m&&!e.collapsed)||$,o.visible&&(o.visibleChildIndex=c++);e.visibleChildrenCount=c}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?$:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=l.length-r):(e.renderNodeCount=0,m&&l.pop()),this.g.fire(e),e.visible}B(e,u){if(u!==0)for(;e;)e.renderNodeCount+=u,this.g.fire(e),e=e.parent}C(e,u){const l=this.j?this.j.filter(e.element,u):1;return typeof l=="boolean"?(e.filterData=void 0,l?1:0):f(l)?(e.filterData=l.data,d(l.visibility)):(e.filterData=void 0,d(l))}D(e,u=this.c){if(!e||e.length===0)return!0;const[l,...m]=e;return l<0||l>u.children.length?!1:this.D(m,u.children[l])}E(e,u=this.c){if(!e||e.length===0)return u;const[l,...m]=e;if(l<0||l>u.children.length)throw new y.$iS(this.o,"Invalid tree location");return this.E(m,u.children[l])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:u,listIndex:l,revealed:m,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>u.children.length)throw new y.$iS(this.o,"Invalid tree location");const $=u.children[r];return{node:$,listIndex:l,revealed:m,visible:n&&$.visible}}G(e,u=this.c,l=0,m=!0,n=!0){const[r,...$]=e;if(r<0||r>u.children.length)throw new y.$iS(this.o,"Invalid tree location");for(let c=0;c<r;c++)l+=u.children[c].renderNodeCount;return m=m&&!u.collapsed,n=n&&u.visible,$.length===0?{parentNode:u,listIndex:l,revealed:m,visible:n}:this.G($,u.children[r],l+1,m,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const u=[];let l=e;for(;l.parent;)u.push(l.parent.children.indexOf(l)),l=l.parent;return u.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,N.$rb)(e)[0]}getFirstElementChild(e){const u=this.E(e);if(u.children.length!==0)return u.children[0].element}getLastElementAncestor(e=[]){const u=this.E(e);if(u.children.length!==0)return this.H(u)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$mS=s}),define(be[120],$e([1,0,56,24,26]),function(oe,t,y,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sS=void 0;class U{get size(){return this.d.size}constructor(D,h,f={}){this.k=D,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new y.$mS(D,h,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(d,L){return f.sorter.compare(d.element,L.element)}}),this.h=f.identityProvider}setChildren(D,h=i.Iterable.empty(),f={}){const d=this.o(D);this.l(d,this.m(h),f)}l(D,h=i.Iterable.empty(),f){const d=new Set,L=new Set,s=e=>{if(e.element===null)return;const u=e;if(d.add(u.element),this.d.set(u.element,u),this.h){const l=this.h.getId(u.element).toString();L.add(l),this.f.set(l,u)}f.onDidCreateNode?.(u)},a=e=>{if(e.element===null)return;const u=e;if(d.has(u.element)||this.d.delete(u.element),this.h){const l=this.h.getId(u.element).toString();L.has(l)||this.f.delete(l)}f.onDidDeleteNode?.(u)};this.c.splice([...D,0],Number.MAX_VALUE,h,{...f,onDidCreateNode:s,onDidDeleteNode:a})}m(D=i.Iterable.empty()){return this.j&&(D=[...D].sort(this.j.compare.bind(this.j))),i.Iterable.map(D,h=>{let f=this.d.get(h.element);if(!f&&this.h){const s=this.h.getId(h.element).toString();f=this.f.get(s)}if(!f){let s;return typeof h.collapsed>"u"?s=void 0:h.collapsed===N.ObjectTreeElementCollapseState.Collapsed||h.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:h.collapsed===N.ObjectTreeElementCollapseState.Expanded||h.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!h.collapsed,{...h,children:this.m(h.children),collapsed:s}}const d=typeof h.collapsible=="boolean"?h.collapsible:f.collapsible;let L;return typeof h.collapsed>"u"||h.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||h.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?L=f.collapsed:h.collapsed===N.ObjectTreeElementCollapseState.Collapsed?L=!0:h.collapsed===N.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!h.collapsed,{...h,collapsible:d,collapsed:L,children:this.m(h.children)}})}rerender(D){const h=this.o(D);this.c.rerender(h)}updateElementHeight(D,h){const f=this.o(D);this.c.updateElementHeight(f,h)}resort(D=null,h=!0){if(!this.j)return;const f=this.o(D),d=this.c.getNode(f);this.l(f,this.n(d,h),{})}n(D,h,f=!0){let d=[...D.children];return(h||f)&&(d=d.sort(this.j.compare.bind(this.j))),i.Iterable.map(d,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,h,!1)}))}getFirstElementChild(D=null){const h=this.o(D);return this.c.getFirstElementChild(h)}getLastElementAncestor(D=null){const h=this.o(D);return this.c.getLastElementAncestor(h)}has(D){return this.d.has(D)}getListIndex(D){const h=this.o(D);return this.c.getListIndex(h)}getListRenderCount(D){const h=this.o(D);return this.c.getListRenderCount(h)}isCollapsible(D){const h=this.o(D);return this.c.isCollapsible(h)}setCollapsible(D,h){const f=this.o(D);return this.c.setCollapsible(f,h)}isCollapsed(D){const h=this.o(D);return this.c.isCollapsed(h)}setCollapsed(D,h,f){const d=this.o(D);return this.c.setCollapsed(d,h,f)}expandTo(D){const h=this.o(D);this.c.expandTo(h)}refilter(){this.c.refilter()}getNode(D=null){if(D===null)return this.c.getNode(this.c.rootRef);const h=this.d.get(D);if(!h)throw new N.$iS(this.k,`Tree element not found: ${D}`);return h}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new N.$iS(this.k,"Invalid getParentNodeLocation call");const h=this.d.get(D);if(!h)throw new N.$iS(this.k,`Tree element not found: ${D}`);const f=this.c.getNodeLocation(h),d=this.c.getParentNodeLocation(f);return this.c.getNode(d).element}o(D){if(D===null)return[];const h=this.d.get(D);if(!h)throw new N.$iS(this.k,`Tree element not found: ${D}`);return this.c.getNodeLocation(h)}}t.$sS=U}),define(be[20],$e([1,0,4,14,19,23,2]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UP=void 0;class D extends w.$Qc{f(f,d){this.B(y.$tO(f,y.$aP.CLICK,L=>d(new i.$lO(L))))}j(f,d){this.B(y.$tO(f,y.$aP.MOUSE_DOWN,L=>d(new i.$lO(L))))}m(f,d){this.B(y.$tO(f,y.$aP.MOUSE_OVER,L=>d(new i.$lO(L))))}u(f,d){this.B(y.$tO(f,y.$aP.MOUSE_LEAVE,L=>d(new i.$lO(L))))}z(f,d){this.B(y.$tO(f,y.$aP.KEY_DOWN,L=>d(new N.$qO(L))))}C(f,d){this.B(y.$tO(f,y.$aP.KEY_UP,L=>d(new N.$qO(L))))}D(f,d){this.B(y.$tO(f,y.$aP.INPUT,d))}F(f,d){this.B(y.$tO(f,y.$aP.BLUR,d))}G(f,d){this.B(y.$tO(f,y.$aP.FOCUS,d))}H(f,d){this.B(y.$tO(f,y.$aP.CHANGE,d))}I(f){return U.$QP.ignoreTarget(f)}}t.$UP=D}),define(be[37],$e([1,0,54,20,9,18,4]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WP=t.$VP=void 0,t.$VP=11;class D extends N.$UP{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$VP+"px",this.domNode.style.height=t.$VP+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new y.$TP),this.B(w.$uO(this.bgDomNode,w.$aP.POINTER_DOWN,d=>this.h(d))),this.B(w.$uO(this.domNode,w.$aP.POINTER_DOWN,d=>this.h(d))),this.b=this.B(new i.$3g),this.c=this.B(new i.$2g)}h(f){if(!f.target||!(f.target instanceof Element))return;const d=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(d,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$WP=D}),define(be[57],$e([1,0,4,40,54,37,118,20,5]),function(oe,t,y,N,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZP=void 0;const f=140;class d extends D.$UP{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new w.$YP(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$TP),this.s=!0,this.domNode=(0,N.$SP)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(y.$tO(this.domNode.domNode,y.$aP.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new U.$WP(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,u){this.slider=(0,N.$SP)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof u=="number"&&this.slider.setHeight(u),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(y.$tO(this.slider.domNode,y.$aP.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.O(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),u=a+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.U(s);e<=l&&l<=u?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const l=y.$LO(this.domNode.domNode);a=s.pageX-l.left,e=s.pageY-l.top}const u=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(u):this.h.getDesiredScrollPositionFromOffset(u)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),u=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,l=>{const m=this.W(l),n=Math.abs(m-e);if(h.$i&&n>f){this.P(u.getScrollPosition());return}const $=this.U(l)-a;this.P(u.getDesiredScrollPositionFromDelta($))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$ZP=d}),define(be[121],$e([1,0,19,57,37,41,17]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1P=void 0;class D extends N.$ZP{constructor(f,d,L){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:L,scrollbarState:new U.$XP(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-i.$VP)/2,u=(d.horizontalScrollbarSize-i.$VP)/2;this.t({className:"scra",icon:w.$Rj.scrollbarButtonLeft,top:u,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$nO(null,1,0))}),this.t({className:"scra",icon:w.$Rj.scrollbarButtonRight,top:u,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$nO(null,-1,0))})}this.w(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}R(f,d){this.slider.setWidth(f),this.slider.setLeft(d)}Q(f,d){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this.s=this.J(f.scrollWidth)||this.s,this.s=this.L(f.scrollLeft)||this.s,this.s=this.y(f.width)||this.s,this.s}S(f,d){return f}U(f){return f.pageX}W(f){return f.pageY}X(f){this.slider.setHeight(f)}writeScrollPosition(f,d){f.scrollLeft=d}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.n.setVisibility(f.horizontal),this.c=f.scrollByPage}}t.$1P=D}),define(be[122],$e([1,0,19,57,37,41,17]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2P=void 0;class D extends N.$ZP{constructor(f,d,L){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:L,scrollbarState:new U.$XP(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-i.$VP)/2,u=(d.verticalScrollbarSize-i.$VP)/2;this.t({className:"scra",icon:w.$Rj.scrollbarButtonUp,top:e,left:u,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$nO(null,0,1))}),this.t({className:"scra",icon:w.$Rj.scrollbarButtonDown,top:void 0,left:u,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$nO(null,0,-1))})}this.w(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}R(f,d){this.slider.setHeight(f),this.slider.setTop(d)}Q(f,d){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this.s=this.J(f.scrollHeight)||this.s,this.s=this.L(f.scrollTop)||this.s,this.s=this.y(f.height)||this.s,this.s}S(f,d){return d}U(f){return f.pageY}W(f){return f.pageX}X(f){this.slider.setWidth(f)}writeScrollPosition(f,d){f.scrollTop=d}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(f.vertical),this.c=f.scrollByPage}}t.$2P=D}),define(be[58],$e([1,0,16,4,40,19,121,122,20,9,3,2,5,47,96]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=void 0;const e=500,u=50,l=!0;class m{constructor(M,b,v){this.timestamp=M,this.deltaX=b,this.deltaY=v,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let M=1,b=0,v=1,j=this.d;do{const z=j===this.c?M:Math.pow(2,-v);if(M-=z,b+=this.b[j].score*z,j===this.c)break;j=(this.a+j-1)%this.a,v++}while(!0);return b<=.5}acceptStandardWheelEvent(M){const b=window.devicePixelRatio/(0,y.$7N)();s.$i||s.$k?this.accept(Date.now(),M.deltaX/b,M.deltaY/b):this.accept(Date.now(),M.deltaX,M.deltaY)}accept(M,b,v){const j=new m(M,b,v);j.score=this.f(j),this.c===-1&&this.d===-1?(this.b[0]=j,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=j)}f(M){if(Math.abs(M.deltaX)>0&&Math.abs(M.deltaY)>0)return 1;let b=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(M.deltaX)||!this.g(M.deltaY))&&(b+=.25),Math.min(Math.max(b,0),1)}g(M){return Math.abs(Math.round(M)-M)<.01}}t.$3P=n;class r extends h.$UP{get options(){return this.a}constructor(M,b,v){super(),this.O=this.B(new d.$Ld),this.onScroll=this.O.event,this.P=this.B(new d.$Ld),this.onWillScroll=this.P.event,M.style.overflow="hidden",this.a=C(b),this.b=v,this.B(this.b.onScroll(z=>{this.P.fire(z),this.S(z),this.O.fire(z)}));const j={onMouseWheel:z=>this.R(z),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new D.$2P(this.b,this.a,j)),this.g=this.B(new w.$1P(this.b,this.a,j)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(M),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$SP)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$SP)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$SP)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,z=>this.Z(z)),this.u(this.t,z=>this.Y(z)),this.L=this.B(new f.$2g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,L.$Lc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(M){this.c.delegatePointerDown(M)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(M){this.b.setScrollDimensions(M,!1)}updateClassName(M){this.a.className=M,s.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(M){typeof M.handleMouseWheel<"u"&&(this.a.handleMouseWheel=M.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof M.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=M.mouseWheelScrollSensitivity),typeof M.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=M.fastScrollSensitivity),typeof M.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=M.scrollPredominantAxis),typeof M.horizontal<"u"&&(this.a.horizontal=M.horizontal),typeof M.vertical<"u"&&(this.a.vertical=M.vertical),typeof M.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=M.horizontalScrollbarSize),typeof M.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=M.verticalScrollbarSize),typeof M.scrollByPage<"u"&&(this.a.scrollByPage=M.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(M){this.N=M}delegateScrollFromMouseWheelEvent(M){this.R(new U.$nO(M))}Q(M){if(this.w.length>0!==M&&(this.w=(0,L.$Lc)(this.w),M)){const v=j=>{this.R(new U.$nO(j))};this.w.push(N.$tO(this.t,N.$aP.MOUSE_WHEEL,v,{passive:!1}))}}R(M){if(M.browserEvent?.defaultPrevented)return;const b=n.INSTANCE;l&&b.acceptStandardWheelEvent(M);let v=!1;if(M.deltaY||M.deltaX){let z=M.deltaY*this.a.mouseWheelScrollSensitivity,W=M.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&W+z===0?W=z=0:Math.abs(z)>=Math.abs(W)?W=0:z=0),this.a.flipAxes&&([z,W]=[W,z]);const I=!s.$j&&M.browserEvent&&M.browserEvent.shiftKey;(this.a.scrollYToX||I)&&!W&&(W=z,z=0),M.browserEvent&&M.browserEvent.altKey&&(W=W*this.a.fastScrollSensitivity,z=z*this.a.fastScrollSensitivity);const F=this.b.getFutureScrollPosition();let X={};if(z){const te=u*z,re=F.scrollTop-(te<0?Math.floor(te):Math.ceil(te));this.c.writeScrollPosition(X,re)}if(W){const te=u*W,re=F.scrollLeft-(te<0?Math.floor(te):Math.ceil(te));this.g.writeScrollPosition(X,re)}X=this.b.validateScrollPosition(X),(F.scrollLeft!==X.scrollLeft||F.scrollTop!==X.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&b.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(X):this.b.setScrollPositionNow(X),v=!0)}let j=v;!j&&this.a.alwaysConsumeMouseWheel&&(j=!0),!j&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(j=!0),j&&(M.preventDefault(),M.stopPropagation())}S(M){this.M=this.g.onDidScroll(M)||this.M,this.M=this.c.onDidScroll(M)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const M=this.b.getCurrentScrollPosition(),b=M.scrollTop>0,v=M.scrollLeft>0,j=v?" left":"",z=b?" top":"",W=v||b?" top-left-corner":"";this.n.setClassName(`shadow${j}`),this.r.setClassName(`shadow${z}`),this.s.setClassName(`shadow${W}${z}${j}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(M){this.J=!1,this.ab()}Z(M){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$4P=r;class $ extends r{constructor(M,b){b=b||{},b.mouseWheelSmoothScroll=!1;const v=new a.$Pr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:j=>N.$BO(j)});super(M,b,v),this.B(v)}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$5P=$;class c extends r{constructor(M,b,v){super(M,b,v)}setScrollPosition(M){M.reuseAnimation?this.b.setScrollPositionSmooth(M,M.reuseAnimation):this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$6P=c;class o extends r{constructor(M,b){b=b||{},b.mouseWheelSmoothScroll=!1;const v=new a.$Pr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:j=>N.$BO(j)});super(M,b,v),this.B(v),this.cb=M,this.B(this.onScroll(j=>{j.scrollTopChanged&&(this.cb.scrollTop=j.scrollTop),j.scrollLeftChanged&&(this.cb.scrollLeft=j.scrollLeft)})),this.scanDomNode()}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$7P=o;function C(R){const M={lazyRender:typeof R.lazyRender<"u"?R.lazyRender:!1,className:typeof R.className<"u"?R.className:"",useShadows:typeof R.useShadows<"u"?R.useShadows:!0,handleMouseWheel:typeof R.handleMouseWheel<"u"?R.handleMouseWheel:!0,flipAxes:typeof R.flipAxes<"u"?R.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof R.consumeMouseWheelIfScrollbarIsNeeded<"u"?R.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof R.alwaysConsumeMouseWheel<"u"?R.alwaysConsumeMouseWheel:!1,scrollYToX:typeof R.scrollYToX<"u"?R.scrollYToX:!1,mouseWheelScrollSensitivity:typeof R.mouseWheelScrollSensitivity<"u"?R.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof R.fastScrollSensitivity<"u"?R.fastScrollSensitivity:5,scrollPredominantAxis:typeof R.scrollPredominantAxis<"u"?R.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof R.mouseWheelSmoothScroll<"u"?R.mouseWheelSmoothScroll:!0,arrowSize:typeof R.arrowSize<"u"?R.arrowSize:11,listenOnDomNode:typeof R.listenOnDomNode<"u"?R.listenOnDomNode:null,horizontal:typeof R.horizontal<"u"?R.horizontal:1,horizontalScrollbarSize:typeof R.horizontalScrollbarSize<"u"?R.horizontalScrollbarSize:10,horizontalSliderSize:typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:0,horizontalHasArrows:typeof R.horizontalHasArrows<"u"?R.horizontalHasArrows:!1,vertical:typeof R.vertical<"u"?R.vertical:1,verticalScrollbarSize:typeof R.verticalScrollbarSize<"u"?R.verticalScrollbarSize:10,verticalHasArrows:typeof R.verticalHasArrows<"u"?R.verticalHasArrows:!1,verticalSliderSize:typeof R.verticalSliderSize<"u"?R.verticalSliderSize:0,scrollByPage:typeof R.scrollByPage<"u"?R.scrollByPage:!1};return M.horizontalSliderSize=typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:M.horizontalScrollbarSize,M.verticalSliderSize=typeof R.verticalSliderSize<"u"?R.verticalSliderSize:M.verticalScrollbarSize,s.$j&&(M.className+=" mac"),M}}),define(be[59],$e([1,0,52,4,21,23,58,11,9,25,3,2,46,47,80,117,6]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s,a,e,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=t.$xQ=t.$wQ=t.$vQ=void 0;const m={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(M){return[M]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(b){this.d=b}constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.$vQ=r;class ${constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.$wQ=$;class c{constructor(){this.types=[],this.files=[]}update(b){if(b.types&&this.types.splice(0,this.types.length,...b.types),b.files){this.files.splice(0,this.files.length);for(let v=0;v<b.files.length;v++){const j=b.files.item(v);j&&(j.size||j.type)&&this.files.push(j)}}}getData(){return{types:this.types,files:this.files}}}t.$xQ=c;function o(M,b){return Array.isArray(M)&&Array.isArray(b)?(0,D.$sb)(M,b):M===b}class C{constructor(b){b?.getSetSize?this.getSetSize=b.getSetSize.bind(b):this.getSetSize=(v,j,z)=>z,b?.getPosInSet?this.getPosInSet=b.getPosInSet.bind(b):this.getPosInSet=(v,j)=>j+1,b?.getRole?this.getRole=b.getRole.bind(b):this.getRole=v=>"listitem",b?.isChecked?this.isChecked=b.isChecked.bind(b):this.isChecked=v=>{}}}class R{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(b){if(b!==this.O){if(b&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=b,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const v of this.d)this.Y(v);this.V(),this.q.setScrollDimensions({width:(0,N.$OO)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(b,v,j,z=n){if(this.Q=v,this.domId=`list_id_${++R.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new h.$Og(50),this.v=!1,this.x=L.$Qc.None,this.y=0,this.G=!1,this.J=L.$Qc.None,this.K=L.$Qc.None,this.L=new L.$Pc,this.M=new d.$Ld,this.N=new d.$Ld,this.onDidChangeContentHeight=d.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=d.Event.latch(this.N.event,void 0,this.L),this.O=!1,z.horizontalScrolling&&z.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$tQ(z.paddingTop??0);for(const I of j)this.j.set(I.templateId,I);this.h=this.L.add(new u.$uQ(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof z.mouseSupport=="boolean"?z.mouseSupport:!0),this.O=z.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof z.paddingBottom>"u"?0:z.paddingBottom,this.D=new C(z.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(z.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$QP.addTarget(this.o)),this.p=this.L.add(new a.$Pr({forceIntegerValues:!0,smoothScrollDuration:z.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:I=>(0,N.$BO)(I)})),this.q=this.L.add(new w.$6P(this.o,{alwaysConsumeMouseWheel:z.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:z.verticalScrollMode??n.verticalScrollMode,useShadows:z.useShadows??n.useShadows,mouseWheelScrollSensitivity:z.mouseWheelScrollSensitivity,fastScrollSensitivity:z.fastScrollSensitivity,scrollByPage:z.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),b.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,N.$tO)(this.o,U.EventType.Change,I=>this.hb(I))),this.L.add((0,N.$tO)(this.q.getDomNode(),"scroll",I=>I.target.scrollTop=0)),this.L.add((0,N.$tO)(this.domNode,"dragover",I=>this.jb(this.fb(I)))),this.L.add((0,N.$tO)(this.domNode,"drop",I=>this.lb(this.fb(I)))),this.L.add((0,N.$tO)(this.domNode,"dragleave",I=>this.kb(this.fb(I)))),this.L.add((0,N.$tO)(this.domNode,"dragend",I=>this.mb(I))),this.z=z.setRowLineHeight??n.setRowLineHeight,this.A=z.setRowHeight??n.setRowHeight,this.B=z.supportDynamicHeights??n.supportDynamicHeights,this.F=z.dnd??this.L.add(n.dnd),this.layout(z.initialSize?.height,z.initialSize?.width)}updateOptions(b){b.paddingBottom!==void 0&&(this.C=b.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),b.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(b.smoothScrolling?125:0),b.horizontalScrolling!==void 0&&(this.P=b.horizontalScrolling);let v;if(b.scrollByPage!==void 0&&(v={...v??{},scrollByPage:b.scrollByPage}),b.mouseWheelScrollSensitivity!==void 0&&(v={...v??{},mouseWheelScrollSensitivity:b.mouseWheelScrollSensitivity}),b.fastScrollSensitivity!==void 0&&(v={...v??{},fastScrollSensitivity:b.fastScrollSensitivity}),v&&this.q.updateOptions(v),b.paddingTop!==void 0&&b.paddingTop!==this.g.paddingTop){const j=this.sb(this.k,this.m),z=b.paddingTop-this.g.paddingTop;this.g.paddingTop=b.paddingTop,this.W(j,Math.max(0,this.k+z),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(b){this.q.delegateScrollFromMouseWheelEvent(b)}delegateVerticalScrollbarPointerDown(b){this.q.delegateVerticalScrollbarPointerDown(b)}updateElementHeight(b,v,j){if(b<0||b>=this.d.length)return;const z=this.d[b].size;if(typeof v>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[b].lastDynamicHeightWidth=void 0,v=z+this.ub(b)}if(z===v)return;const W=this.sb(this.k,this.m);let I=0;b<W.start||j!==null&&j>b&&j<W.end?I=v-z:I=0,this.g.splice(b,1,[{size:v}]),this.d[b].size=v,this.W(W,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(b,v,j=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(b,v,j)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(b,v,j=[]){const z=this.sb(this.k,this.m),W={start:b,end:b+v},I=s.Range.intersect(z,W),F=new Map;for(let ee=I.end-1;ee>=I.start;ee--){const J=this.d[ee];if(J.dragStartDisposable.dispose(),J.checkedDisposable.dispose(),J.row){let k=F.get(J.templateId);k||(k=[],F.set(J.templateId,k));const K=this.j.get(J.templateId);K&&K.disposeElement&&K.disposeElement(J.element,ee,J.row.templateData,J.size),k.push(J.row)}J.row=null}const X={start:b+v,end:this.d.length},te=s.Range.intersect(X,z),re=s.Range.relativeComplement(X,z),ce=j.map(ee=>({id:String(this.f++),element:ee,templateId:this.Q.getTemplateId(ee),size:this.Q.getHeight(ee),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(ee),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$Qc.None,checkedDisposable:L.$Qc.None}));let le;b===0&&v>=this.d.length?(this.g=new e.$tQ(this.g.paddingTop),this.g.splice(0,0,ce),le=this.d,this.d=ce):(this.g.splice(b,v,ce),le=this.d.splice(b,v,...ce));const ae=j.length-v,me=this.sb(this.k,this.m),ke=(0,e.$rQ)(te,ae),Le=s.Range.intersect(me,ke);for(let ee=Le.start;ee<Le.end;ee++)this.Z(this.d[ee],ee);const Pe=s.Range.relativeComplement(ke,me);for(const ee of Pe)for(let J=ee.start;J<ee.end;J++)this.ab(J);const de=re.map(ee=>(0,e.$rQ)(ee,ae)),Q=[{start:b,end:b+j.length},...de].map(ee=>s.Range.intersect(me,ee)),V=this.vb(Q);for(const ee of Q)for(let J=ee.start;J<ee.end;J++){const k=this.d[J],g=F.get(k.templateId)?.pop();this.X(J,V,g)}for(const ee of F.values())for(const J of ee)this.h.release(J);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),le.map(ee=>ee.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,N.$BO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let b=0;for(const v of this.d)typeof v.width<"u"&&(b=Math.max(b,v.width));this.E=b,this.q.setScrollDimensions({scrollWidth:b===0?0:b+10}),this.N.fire(this.E)}updateWidth(b){if(!this.P||typeof this.E>"u")return;const v=this.d[b];this.Y(v),typeof v.width<"u"&&v.width>this.E&&(this.E=v.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const b of this.d)b.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const b=this.sb(this.k,this.m),v=this.g.positionAt(b.start),j=this.g.positionAt(b.start+1);return j!==-1&&(j-v)/2+v<this.scrollTop?b.start+1:b.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(b){return this.d[b].element}indexOf(b){return this.d.findIndex(v=>v.element===b)}domElement(b){const v=this.d[b].row;return v&&v.domNode}elementHeight(b){return this.d[b].size}elementTop(b){return this.g.positionAt(b)}indexAt(b){return this.g.indexAt(b)}indexAfter(b){return this.g.indexAfter(b)}layout(b,v){const j={height:typeof b=="number"?b:(0,N.$QO)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,j.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(j),typeof v<"u"&&(this.n=v,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof v=="number"?v:(0,N.$OO)(this.domNode)})}W(b,v,j,z,W,I=!1){const F=this.sb(v,j),X=s.Range.relativeComplement(F,b),te=s.Range.relativeComplement(b,F),re=this.vb(X);if(I){const ce=s.Range.intersect(b,F);for(let le=ce.start;le<ce.end;le++)this.Z(this.d[le],le)}this.h.transact(()=>{for(const ce of te)for(let le=ce.start;le<ce.end;le++)this.ab(le);for(const ce of X)for(let le=ce.start;le<ce.end;le++)this.X(le,re)}),z!==void 0&&(this.o.style.left=`-${z}px`),this.o.style.top=`-${v}px`,this.P&&W!==void 0&&(this.o.style.width=`${Math.max(W,this.n)}px`),this.k=v,this.m=j}X(b,v,j){const z=this.d[b];let W=!1;if(!z.row)if(j)z.row=j;else{const re=this.h.alloc(z.templateId);z.row=re.row,W=re.isReusingConnectedDomNode}const I=this.D.getRole(z.element)||"listitem";z.row.domNode.setAttribute("role",I);const F=this.D.isChecked(z.element);if(typeof F=="boolean")z.row.domNode.setAttribute("aria-checked",String(!!F));else if(F){const re=ce=>z.row.domNode.setAttribute("aria-checked",String(!!ce));re(F.value),z.checkedDisposable=F.onDidChange(re)}(W||!z.row.domNode.parentElement)&&(v?this.o.insertBefore(z.row.domNode,v):this.o.appendChild(z.row.domNode)),this.Z(z,b);const X=this.j.get(z.templateId);if(!X)throw new Error(`No renderer found for template id ${z.templateId}`);X?.renderElement(z.element,b,z.row.templateData,z.size);const te=this.F.getDragURI(z.element);z.dragStartDisposable.dispose(),z.row.domNode.draggable=!!te,te&&(z.dragStartDisposable=(0,N.$tO)(z.row.domNode,"dragstart",re=>this.ib(z.element,te,re))),this.P&&(this.Y(z),this.U())}Y(b){if(!b.row||!b.row.domNode)return;b.row.domNode.style.width="fit-content",b.width=(0,N.$OO)(b.row.domNode);const v=window.getComputedStyle(b.row.domNode);v.paddingLeft&&(b.width+=parseFloat(v.paddingLeft)),v.paddingRight&&(b.width+=parseFloat(v.paddingRight)),b.row.domNode.style.width=""}Z(b,v){b.row.domNode.style.top=`${this.elementTop(v)}px`,this.A&&(b.row.domNode.style.height=`${b.size}px`),this.z&&(b.row.domNode.style.lineHeight=`${b.size}px`),b.row.domNode.setAttribute("data-index",`${v}`),b.row.domNode.setAttribute("data-last-element",v===this.length-1?"true":"false"),b.row.domNode.setAttribute("data-parity",v%2===0?"even":"odd"),b.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(b.element,v,this.length))),b.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(b.element,v))),b.row.domNode.setAttribute("id",this.getElementDomId(v)),b.row.domNode.classList.toggle("drop-target",b.dropTarget)}ab(b){const v=this.d[b];if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const j=this.j.get(v.templateId);j&&j.disposeElement&&j.disposeElement(v.element,b,v.row.templateData,v.size),this.h.release(v.row),v.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(b,v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:b,reuseAnimation:v})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(b){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:b})}get scrollTop(){return this.getScrollTop()}set scrollTop(b){this.setScrollTop(b)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return d.Event.map(this.L.add(new i.$iQ(this.domNode,"click")).event,b=>this.bb(b),this.L)}get onMouseDblClick(){return d.Event.map(this.L.add(new i.$iQ(this.domNode,"dblclick")).event,b=>this.bb(b),this.L)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.L.add(new i.$iQ(this.domNode,"auxclick")).event,b=>this.bb(b),this.L),b=>b.browserEvent.button===1,this.L)}get onMouseUp(){return d.Event.map(this.L.add(new i.$iQ(this.domNode,"mouseup")).event,b=>this.bb(b),this.L)}get onMouseDown(){return d.Event.map(this.L.add(new i.$iQ(this.domNode,"mousedown")).event,b=>this.bb(b),this.L)}get onMouseOver(){return d.Event.map(this.L.add(new i.$iQ(this.domNode,"mouseover")).event,b=>this.bb(b),this.L)}get onMouseMove(){return d.Event.map(this.L.add(new i.$iQ(this.domNode,"mousemove")).event,b=>this.bb(b),this.L)}get onMouseOut(){return d.Event.map(this.L.add(new i.$iQ(this.domNode,"mouseout")).event,b=>this.bb(b),this.L)}get onContextMenu(){return d.Event.any(d.Event.map(this.L.add(new i.$iQ(this.domNode,"contextmenu")).event,b=>this.bb(b),this.L),d.Event.map(this.L.add(new i.$iQ(this.domNode,U.EventType.Contextmenu)).event,b=>this.eb(b),this.L))}get onTouchStart(){return d.Event.map(this.L.add(new i.$iQ(this.domNode,"touchstart")).event,b=>this.db(b),this.L)}get onTap(){return d.Event.map(this.L.add(new i.$iQ(this.o,U.EventType.Tap)).event,b=>this.eb(b),this.L)}bb(b){const v=this.rb(b.target||null),j=typeof v>"u"?void 0:this.d[v],z=j&&j.element;return{browserEvent:b,index:v,element:z}}db(b){const v=this.rb(b.target||null),j=typeof v>"u"?void 0:this.d[v],z=j&&j.element;return{browserEvent:b,index:v,element:z}}eb(b){const v=this.rb(b.initialTarget||null),j=typeof v>"u"?void 0:this.d[v],z=j&&j.element;return{browserEvent:b,index:v,element:z}}fb(b){const v=this.rb(b.target||null),j=typeof v>"u"?void 0:this.d[v],z=j&&j.element;return{browserEvent:b,index:v,element:z}}gb(b){try{const v=this.sb(this.k,this.m);this.W(v,b.scrollTop,b.height,b.scrollLeft,b.scrollWidth),this.B&&this.tb(b.scrollTop,b.height,b.inSmoothScrolling)}catch(v){throw console.error("Got bad scroll event:",b),v}}hb(b){b.preventDefault(),b.stopPropagation(),this.scrollTop-=b.translationY}ib(b,v,j){if(!j.dataTransfer)return;const z=this.F.getDragElements(b);if(j.dataTransfer.effectAllowed="copyMove",j.dataTransfer.setData(y.$OP.TEXT,v),j.dataTransfer.setDragImage){let W;this.F.getDragLabel&&(W=this.F.getDragLabel(z,j)),typeof W>"u"&&(W=String(z.length));const I=(0,N.$)(".monaco-drag-image");I.textContent=W;const X=(te=>{for(;te&&!te.classList.contains("monaco-workbench");)te=te.parentElement;return te||document.body})(this.domNode);X.appendChild(I),j.dataTransfer.setDragImage(I,-10,-10),setTimeout(()=>X.removeChild(I),0)}this.domNode.classList.add("dragging"),this.H=new r(z),m.CurrentDragAndDropData=new $(z),this.F.onDragStart?.(this.H,j)}jb(b){if(b.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(b.browserEvent),!b.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!b.browserEvent.dataTransfer.types)return!1;this.H=new c}const v=this.F.onDragOver(this.H,b.element,b.index,b.browserEvent);if(this.G=typeof v=="boolean"?v:v.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;b.browserEvent.dataTransfer.dropEffect=typeof v!="boolean"&&v.effect===0?"copy":"move";let j;if(typeof v!="boolean"&&v.feedback?j=v.feedback:typeof b.index>"u"?j=[-1]:j=[b.index],j=(0,D.$Kb)(j).filter(z=>z>=-1&&z<this.length).sort((z,W)=>z-W),j=j[0]===-1?[-1]:j,o(this.I,j))return!0;if(this.I=j,this.J.dispose(),j[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$Oc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const z of j){const W=this.d[z];W.dropTarget=!0,W.row?.domNode.classList.add("drop-target")}this.J=(0,L.$Oc)(()=>{for(const z of j){const W=this.d[z];W.dropTarget=!1,W.row?.domNode.classList.remove("drop-target")}})}return!0}kb(b){this.K.dispose(),this.K=(0,h.$Tg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,b.element,b.index,b.browserEvent)}lb(b){if(!this.G)return;const v=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!v||!b.browserEvent.dataTransfer)&&(b.browserEvent.preventDefault(),v.update(b.browserEvent.dataTransfer),this.F.drop(v,b.element,b.index,b.browserEvent))}mb(b){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(b)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$Qc.None}ob(b){if(!this.w){const v=(0,N.$IO)(this.domNode).top;this.w=(0,N.$wP)(this.pb.bind(this,v))}this.x.dispose(),this.x=(0,h.$Tg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=b.pageY}pb(b){if(this.y===void 0)return;const v=this.y-b,j=this.renderHeight-35;v<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(v-35))):v>j&&(this.scrollTop+=Math.min(14,Math.floor(.3*(v-j))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(b){const v=this.q.getDomNode();let j=b;for(;j instanceof HTMLElement&&j!==this.o&&v.contains(j);){const z=j.getAttribute("data-index");if(z){const W=Number(z);if(!isNaN(W))return W}j=j.parentElement}}sb(b,v){return{start:this.g.indexAt(b),end:this.g.indexAfter(b+v-1)}}tb(b,v,j){const z=this.sb(b,v);let W,I;b===this.elementTop(z.start)?(W=z.start,I=0):z.end-z.start>1&&(W=z.start+1,I=this.elementTop(W)-b);let F=0;for(;;){const X=this.sb(b,v);let te=!1;for(let re=X.start;re<X.end;re++){const ce=this.ub(re);ce!==0&&this.g.splice(re,1,[this.d[re]]),F+=ce,te=te||ce!==0}if(!te){F!==0&&this.S();const re=s.Range.relativeComplement(z,X);for(const le of re)for(let ae=le.start;ae<le.end;ae++)this.d[ae].row&&this.ab(ae);const ce=s.Range.relativeComplement(X,z);for(const le of ce)for(let ae=le.start;ae<le.end;ae++){const me=ae+1,ke=me<this.d.length?this.d[me].row:null,Le=ke?ke.domNode:null;this.X(ae,Le)}for(let le=X.start;le<X.end;le++)this.d[le].row&&this.Z(this.d[le],le);if(typeof W=="number"){const le=this.p.getFutureScrollPosition().scrollTop-b,ae=this.elementTop(W)-I+le;this.setScrollTop(ae,j)}this.M.fire(this.contentHeight);return}}}ub(b){const v=this.d[b];if(this.Q.getDynamicHeight){const I=this.Q.getDynamicHeight(v.element);if(I!==null){const F=v.size;return v.size=I,v.lastDynamicHeightWidth=this.n,I-F}}if(!v.hasDynamicHeight||v.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(v.element))return 0;const j=v.size;if(v.row)return v.row.domNode.style.height="",v.size=v.row.domNode.offsetHeight,v.lastDynamicHeightWidth=this.n,v.size-j;const{row:z}=this.h.alloc(v.templateId);z.domNode.style.height="",this.o.appendChild(z.domNode);const W=this.j.get(v.templateId);if(!W)throw new l.$ab("Missing renderer for templateId: "+v.templateId);return W.renderElement(v.element,b,z.templateData,void 0),v.size=z.domNode.offsetHeight,W.disposeElement?.(v.element,b,z.templateData,void 0),this.Q.setDynamicHeight?.(v.element,v.size),v.lastDynamicHeightWidth=this.n,this.o.removeChild(z.domNode),this.h.release(z),v.size-j}vb(b){const v=b[b.length-1];if(!v)return null;const j=this.d[v.end];return!j||!j.row?null:j.row.domNode}getElementDomId(b){return`${this.domId}_${b}`}dispose(){for(const b of this.d)if(b.dragStartDisposable.dispose(),b.checkedDisposable.dispose(),b.row){const v=this.j.get(b.row.templateId);v&&(v.disposeElement?.(b.element,-1,b.row.templateData,void 0),v.disposeTemplate(b.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$yQ=R,Qe([f.$eh],R.prototype,"onMouseClick",null),Qe([f.$eh],R.prototype,"onMouseDblClick",null),Qe([f.$eh],R.prototype,"onMouseMiddleClick",null),Qe([f.$eh],R.prototype,"onMouseUp",null),Qe([f.$eh],R.prototype,"onMouseDown",null),Qe([f.$eh],R.prototype,"onMouseOver",null),Qe([f.$eh],R.prototype,"onMouseMove",null),Qe([f.$eh],R.prototype,"onMouseOut",null),Qe([f.$eh],R.prototype,"onContextMenu",null),Qe([f.$eh],R.prototype,"onTouchStart",null),Qe([f.$eh],R.prototype,"onTap",null)}),define(be[38],$e([1,0,4,21,14,23,55,69,11,9,72,25,3,33,2,45,5,7,68,59,19,95]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s,a,e,u,l,m,n,r,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IQ=t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=t.$CQ=t.TypeNavigationMode=t.$BQ=t.$AQ=t.$zQ=void 0;class c{constructor(k){this.d=k,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(k){return k}renderElement(k,K,g){const p=this.c.findIndex(q=>q.templateData===g);if(p>=0){const q=this.c[p];this.d.unrender(g),q.index=K}else{const q={index:K,templateData:g};this.c.push(q)}this.d.renderIndex(K,g)}splice(k,K,g){const p=[];for(const q of this.c)q.index<k?p.push(q):q.index>=k+K&&p.push({index:q.index+g-K,templateData:q.templateData});this.c=p}renderIndexes(k){for(const{index:K,templateData:g}of this.c)k.indexOf(K)>-1&&this.d.renderIndex(K,g)}disposeTemplate(k){const K=this.c.findIndex(g=>g.templateData===k);K<0||this.c.splice(K,1)}}class o{get name(){return this.h}get renderer(){return new c(this)}constructor(k){this.h=k,this.c=0,this.d=[],this.f=[],this.g=new s.$Ld,this.onChange=this.g.event}splice(k,K,g){K=Math.max(0,Math.min(K,this.c-k));const p=g.length-K,q=k+K,T=[];let P=0;for(;P<this.f.length&&this.f[P]<k;)T.push(this.f[P++]);for(let _=0;_<g.length;_++)g[_]&&T.push(_+k);for(;P<this.f.length&&this.f[P]>=q;)T.push(this.f[P++]+p);const O=this.c+p;if(this.f.length>0&&T.length===0&&O>0){const _=this.f.find(S=>S>=k)??O-1;T.push(Math.min(_,O-1))}this.renderer.splice(k,K,g.length),this.k(T,T),this.c=O}renderIndex(k,K){K.classList.toggle(this.h,this.contains(k))}unrender(k){k.classList.remove(this.h)}set(k,K){return this.k(k,[...k].sort(de),K)}k(k,K,g){const p=this.d,q=this.f;this.d=k,this.f=K;const T=Le(q,k);return this.renderer.renderIndexes(T),this.g.fire({indexes:k,browserEvent:g}),p}get(){return this.d}contains(k){return(0,h.$ub)(this.f,k,de)>=0}dispose(){(0,e.$Lc)(this.g)}}Qe([L.$eh],o.prototype,"renderer",null);class C extends o{constructor(k){super("selected"),this.l=k}renderIndex(k,K){super.renderIndex(k,K),this.l&&(this.contains(k)?K.setAttribute("aria-selected","true"):K.setAttribute("aria-selected","false"))}}class R{constructor(k,K,g){this.c=k,this.d=K,this.f=g}splice(k,K,g){if(!this.f)return this.c.splice(k,K,new Array(g.length).fill(!1));const p=this.c.get().map(P=>this.f.getId(this.d.element(P)).toString());if(p.length===0)return this.c.splice(k,K,new Array(g.length).fill(!1));const q=new Set(p),T=g.map(P=>q.has(this.f.getId(P).toString()));this.c.splice(k,K,T)}}function M(J){return J.tagName==="INPUT"||J.tagName==="TEXTAREA"}t.$zQ=M;function b(J){return J.classList.contains("monaco-editor")?!0:J.classList.contains("monaco-list")||!J.parentElement?!1:b(J.parentElement)}t.$AQ=b;function v(J){return J.tagName==="A"&&J.classList.contains("monaco-button")||J.tagName==="DIV"&&J.classList.contains("monaco-button-dropdown")?!0:J.classList.contains("monaco-list")||!J.parentElement?!1:v(J.parentElement)}t.$BQ=v;class j{get g(){return s.Event.chain(this.c.add(new N.$iQ(this.k.domNode,"keydown")).event,k=>k.filter(K=>!M(K.target)).map(K=>new i.$qO(K)))}constructor(k,K,g){this.h=k,this.k=K,this.c=new e.$Pc,this.d=new e.$Pc,this.f=g.multipleSelectionSupport,this.c.add(this.g(p=>{switch(p.keyCode){case 3:return this.l(p);case 16:return this.o(p);case 18:return this.p(p);case 11:return this.q(p);case 12:return this.s(p);case 9:return this.u(p);case 31:this.f&&(l.$j?p.metaKey:p.ctrlKey)&&this.t(p)}}))}updateOptions(k){k.multipleSelectionSupport!==void 0&&(this.f=k.multipleSelectionSupport)}l(k){k.preventDefault(),k.stopPropagation(),this.h.setSelection(this.h.getFocus(),k.browserEvent)}o(k){k.preventDefault(),k.stopPropagation(),this.h.focusPrevious(1,!1,k.browserEvent);const K=this.h.getFocus()[0];this.h.setAnchor(K),this.h.reveal(K),this.k.domNode.focus()}p(k){k.preventDefault(),k.stopPropagation(),this.h.focusNext(1,!1,k.browserEvent);const K=this.h.getFocus()[0];this.h.setAnchor(K),this.h.reveal(K),this.k.domNode.focus()}q(k){k.preventDefault(),k.stopPropagation(),this.h.focusPreviousPage(k.browserEvent);const K=this.h.getFocus()[0];this.h.setAnchor(K),this.h.reveal(K),this.k.domNode.focus()}s(k){k.preventDefault(),k.stopPropagation(),this.h.focusNextPage(k.browserEvent);const K=this.h.getFocus()[0];this.h.setAnchor(K),this.h.reveal(K),this.k.domNode.focus()}t(k){k.preventDefault(),k.stopPropagation(),this.h.setSelection((0,h.$Qb)(this.h.length),k.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(k){this.h.getSelection().length&&(k.preventDefault(),k.stopPropagation(),this.h.setSelection([],k.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Qe([L.$eh],j.prototype,"g",null);var z;(function(J){J[J.Automatic=0]="Automatic",J[J.Trigger=1]="Trigger"})(z||(t.TypeNavigationMode=z={}));var W;(function(J){J[J.Idle=0]="Idle",J[J.Typing=1]="Typing"})(W||(W={})),t.$CQ=new class{mightProducePrintableCharacter(J){return J.ctrlKey||J.metaKey||J.altKey?!1:J.keyCode>=31&&J.keyCode<=56||J.keyCode>=21&&J.keyCode<=30||J.keyCode>=98&&J.keyCode<=107||J.keyCode>=85&&J.keyCode<=95}};class I{constructor(k,K,g,p,q){this.o=k,this.p=K,this.q=g,this.s=p,this.t=q,this.c=!1,this.d=W.Idle,this.f=z.Automatic,this.g=!1,this.h=-1,this.k=new e.$Pc,this.l=new e.$Pc,this.updateOptions(k.options)}updateOptions(k){k.typeNavigationEnabled??!0?this.u():this.v(),this.f=k.typeNavigationMode??z.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let k=!1;const K=s.Event.chain(this.k.add(new N.$iQ(this.p.domNode,"keydown")).event,q=>q.filter(T=>!M(T.target)).filter(()=>this.f===z.Automatic||this.g).map(T=>new i.$qO(T)).filter(T=>k||this.s(T)).filter(T=>this.t.mightProducePrintableCharacter(T)).forEach(T=>y.$cP.stop(T,!0)).map(T=>T.browserEvent.key)),g=s.Event.debounce(K,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(K,g),(q,T)=>T===null?null:(q||"")+T,void 0,this.k)(this.x,this,this.k),g(this.w,this,this.k),K(()=>k=!0,void 0,this.k),g(()=>k=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const k=this.o.getFocus();if(k.length>0&&k[0]===this.h){const K=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(k[0]));K&&(0,w.$kQ)(K)}this.h=-1}x(k){if(!k){this.d=W.Idle,this.g=!1;return}const K=this.o.getFocus(),g=K.length>0?K[0]:0,p=this.d===W.Idle?1:0;this.d=W.Typing;for(let q=0;q<this.o.length;q++){const T=(g+q+p)%this.o.length,P=this.q.getKeyboardNavigationLabel(this.p.element(T)),O=P&&P.toString();if(this.o.options.typeNavigationEnabled){if(typeof O<"u"){if((0,a.$Aj)(k,O)){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}const _=(0,a.$Hj)(k,O);if(_&&_[0].end-_[0].start>1&&_.length===1){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}}}else if(typeof O>"u"||(0,a.$Aj)(k,O)){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class F{constructor(k,K){this.d=k,this.f=K,this.c=new e.$Pc;const g=s.Event.chain(this.c.add(new N.$iQ(K.domNode,"keydown")).event,q=>q.filter(T=>!M(T.target)).map(T=>new i.$qO(T)));s.Event.chain(g,q=>q.filter(T=>T.keyCode===2&&!T.ctrlKey&&!T.metaKey&&!T.shiftKey&&!T.altKey))(this.g,this,this.c)}g(k){if(k.target!==this.f.domNode)return;const K=this.d.getFocus();if(K.length===0)return;const g=this.f.domElement(K[0]);if(!g)return;const p=g.querySelector("[tabIndex]");if(!p||!(p instanceof HTMLElement)||p.tabIndex===-1)return;const q=window.getComputedStyle(p);q.visibility==="hidden"||q.display==="none"||(k.preventDefault(),k.stopPropagation(),p.focus())}dispose(){this.c.dispose()}}function X(J){return l.$j?J.browserEvent.metaKey:J.browserEvent.ctrlKey}t.$DQ=X;function te(J){return J.browserEvent.shiftKey}t.$EQ=te;function re(J){return(0,y.$9O)(J)&&J.button===2}const ce={isSelectionSingleChangeEvent:X,isSelectionRangeChangeEvent:te};class le{constructor(k){this.k=k,this.f=new e.$Pc,this.g=new s.$Ld,this.onPointer=this.g.event,k.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ce),this.d=typeof k.options.mouseSupport>"u"||!!k.options.mouseSupport,this.d&&(k.onMouseDown(this.s,this,this.f),k.onContextMenu(this.t,this,this.f),k.onMouseDblClick(this.v,this,this.f),k.onTouchStart(this.s,this,this.f),this.f.add(U.$QP.addTarget(k.getHTMLElement()))),s.Event.any(k.onMouseClick,k.onMouseMiddleClick,k.onTap)(this.u,this,this.f)}updateOptions(k){k.multipleSelectionSupport!==void 0&&(this.c=void 0,k.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ce))}o(k){return this.c?this.c.isSelectionSingleChangeEvent(k):!1}p(k){return this.c?this.c.isSelectionRangeChangeEvent(k):!1}q(k){return this.o(k)||this.p(k)}s(k){b(k.browserEvent.target)||(0,y.$2O)()!==k.browserEvent.target&&this.k.domFocus()}t(k){if(M(k.browserEvent.target)||b(k.browserEvent.target))return;const K=typeof k.index>"u"?[]:[k.index];this.k.setFocus(K,k.browserEvent)}u(k){if(!this.d||M(k.browserEvent.target)||b(k.browserEvent.target)||k.browserEvent.isHandledByList)return;k.browserEvent.isHandledByList=!0;const K=k.index;if(typeof K>"u"){this.k.setFocus([],k.browserEvent),this.k.setSelection([],k.browserEvent),this.k.setAnchor(void 0);return}if(this.q(k))return this.w(k);this.k.setFocus([K],k.browserEvent),this.k.setAnchor(K),re(k.browserEvent)||this.k.setSelection([K],k.browserEvent),this.g.fire(k)}v(k){if(M(k.browserEvent.target)||b(k.browserEvent.target)||this.q(k)||k.browserEvent.isHandledByList)return;k.browserEvent.isHandledByList=!0;const K=this.k.getFocus();this.k.setSelection(K,k.browserEvent)}w(k){const K=k.index;let g=this.k.getAnchor();if(this.p(k)){typeof g>"u"&&(g=this.k.getFocus()[0]??K,this.k.setAnchor(g));const p=Math.min(g,K),q=Math.max(g,K),T=(0,h.$Qb)(p,q+1),P=this.k.getSelection(),O=ke(Le(P,[g]),g);if(O.length===0)return;const _=Le(T,Pe(P,O));this.k.setSelection(_,k.browserEvent),this.k.setFocus([K],k.browserEvent)}else if(this.o(k)){const p=this.k.getSelection(),q=p.filter(T=>T!==K);this.k.setFocus([K]),this.k.setAnchor(K),p.length===q.length?this.k.setSelection([...q,K],k.browserEvent):this.k.setSelection(q,k.browserEvent)}}dispose(){this.f.dispose()}}t.$FQ=le;class ae{constructor(k,K){this.c=k,this.d=K}style(k){const K=this.d&&`.${this.d}`,g=[];k.listBackground&&g.push(`.monaco-list${K} .monaco-list-rows { background: ${k.listBackground}; }`),k.listFocusBackground&&(g.push(`.monaco-list${K}:focus .monaco-list-row.focused { background-color: ${k.listFocusBackground}; }`),g.push(`.monaco-list${K}:focus .monaco-list-row.focused:hover { background-color: ${k.listFocusBackground}; }`)),k.listFocusForeground&&g.push(`.monaco-list${K}:focus .monaco-list-row.focused { color: ${k.listFocusForeground}; }`),k.listActiveSelectionBackground&&(g.push(`.monaco-list${K}:focus .monaco-list-row.selected { background-color: ${k.listActiveSelectionBackground}; }`),g.push(`.monaco-list${K}:focus .monaco-list-row.selected:hover { background-color: ${k.listActiveSelectionBackground}; }`)),k.listActiveSelectionForeground&&g.push(`.monaco-list${K}:focus .monaco-list-row.selected { color: ${k.listActiveSelectionForeground}; }`),k.listActiveSelectionIconForeground&&g.push(`.monaco-list${K}:focus .monaco-list-row.selected .codicon { color: ${k.listActiveSelectionIconForeground}; }`),k.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.selected.focused { background-color: ${k.listFocusAndSelectionBackground}; }
			`),k.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.selected.focused { color: ${k.listFocusAndSelectionForeground}; }
			`),k.listInactiveFocusForeground&&(g.push(`.monaco-list${K} .monaco-list-row.focused { color:  ${k.listInactiveFocusForeground}; }`),g.push(`.monaco-list${K} .monaco-list-row.focused:hover { color:  ${k.listInactiveFocusForeground}; }`)),k.listInactiveSelectionIconForeground&&g.push(`.monaco-list${K} .monaco-list-row.focused .codicon { color:  ${k.listInactiveSelectionIconForeground}; }`),k.listInactiveFocusBackground&&(g.push(`.monaco-list${K} .monaco-list-row.focused { background-color:  ${k.listInactiveFocusBackground}; }`),g.push(`.monaco-list${K} .monaco-list-row.focused:hover { background-color:  ${k.listInactiveFocusBackground}; }`)),k.listInactiveSelectionBackground&&(g.push(`.monaco-list${K} .monaco-list-row.selected { background-color:  ${k.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${K} .monaco-list-row.selected:hover { background-color:  ${k.listInactiveSelectionBackground}; }`)),k.listInactiveSelectionForeground&&g.push(`.monaco-list${K} .monaco-list-row.selected { color: ${k.listInactiveSelectionForeground}; }`),k.listHoverBackground&&g.push(`.monaco-list${K}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${k.listHoverBackground}; }`),k.listHoverForeground&&g.push(`.monaco-list${K}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${k.listHoverForeground}; }`);const p=(0,y.$zP)(k.listFocusAndSelectionOutline,(0,y.$zP)(k.listSelectionOutline,k.listFocusOutline??""));p&&g.push(`.monaco-list${K}:focus .monaco-list-row.focused.selected { outline: 1px solid ${p}; outline-offset: -1px;}`),k.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.focused { outline: 1px solid ${k.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${K}.last-focused .monaco-list-row.focused { outline: 1px solid ${k.listFocusOutline}; outline-offset: -1px; }
			`);const q=(0,y.$zP)(k.listSelectionOutline,k.listInactiveFocusOutline??"");q&&g.push(`.monaco-list${K} .monaco-list-row.focused.selected { outline: 1px dotted ${q}; outline-offset: -1px; }`),k.listSelectionOutline&&g.push(`.monaco-list${K} .monaco-list-row.selected { outline: 1px dotted ${k.listSelectionOutline}; outline-offset: -1px; }`),k.listInactiveFocusOutline&&g.push(`.monaco-list${K} .monaco-list-row.focused { outline: 1px dotted ${k.listInactiveFocusOutline}; outline-offset: -1px; }`),k.listHoverOutline&&g.push(`.monaco-list${K} .monaco-list-row:hover { outline: 1px dashed ${k.listHoverOutline}; outline-offset: -1px; }`),k.listDropBackground&&g.push(`
				.monaco-list${K}.drop-target,
				.monaco-list${K} .monaco-list-rows.drop-target,
				.monaco-list${K} .monaco-list-row.drop-target { background-color: ${k.listDropBackground} !important; color: inherit !important; }
			`),k.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${k.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),k.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${k.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=g.join(`
`)}}t.$GQ=ae,t.$HQ={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:d.$Qs.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:d.$Qs.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:d.$Qs.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const me={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function ke(J,k){const K=J.indexOf(k);if(K===-1)return[];const g=[];let p=K-1;for(;p>=0&&J[p]===k-(K-p);)g.push(J[p--]);for(g.reverse(),p=K;p<J.length&&J[p]===k+(p-K);)g.push(J[p++]);return g}function Le(J,k){const K=[];let g=0,p=0;for(;g<J.length||p<k.length;)if(g>=J.length)K.push(k[p++]);else if(p>=k.length)K.push(J[g++]);else if(J[g]===k[p]){K.push(J[g]),g++,p++;continue}else J[g]<k[p]?K.push(J[g++]):K.push(k[p++]);return K}function Pe(J,k){const K=[];let g=0,p=0;for(;g<J.length||p<k.length;)if(g>=J.length)K.push(k[p++]);else if(p>=k.length)K.push(J[g++]);else if(J[g]===k[p]){g++,p++;continue}else J[g]<k[p]?K.push(J[g++]):p++;return K}const de=(J,k)=>J-k;class ne{constructor(k,K){this.c=k,this.d=K}get templateId(){return this.c}renderTemplate(k){return this.d.map(K=>K.renderTemplate(k))}renderElement(k,K,g,p){let q=0;for(const T of this.d)T.renderElement(k,K,g[q++],p)}disposeElement(k,K,g,p){let q=0;for(const T of this.d)T.disposeElement?.(k,K,g[q],p),q+=1}disposeTemplate(k){let K=0;for(const g of this.d)g.disposeTemplate(k[K++])}}class Q{constructor(k){this.c=k,this.templateId="a18n"}renderTemplate(k){return k}renderElement(k,K,g){const p=this.c.getAriaLabel(k);p?g.setAttribute("aria-label",p):g.removeAttribute("aria-label");const q=this.c.getAriaLevel&&this.c.getAriaLevel(k);typeof q=="number"?g.setAttribute("aria-level",`${q}`):g.removeAttribute("aria-level")}disposeTemplate(k){}}class V{constructor(k,K){this.c=k,this.d=K}getDragElements(k){const K=this.c.getSelectedElements();return K.indexOf(k)>-1?K:[k]}getDragURI(k){return this.d.getDragURI(k)}getDragLabel(k,K){if(this.d.getDragLabel)return this.d.getDragLabel(k,K)}onDragStart(k,K){this.d.onDragStart?.(k,K)}onDragOver(k,K,g,p){return this.d.onDragOver(k,K,g,p)}onDragLeave(k,K,g,p){this.d.onDragLeave?.(k,K,g,p)}onDragEnd(k){this.d.onDragEnd?.(k)}drop(k,K,g,p){this.d.drop(k,K,g,p)}dispose(){this.d.dispose()}}class ee{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),k=>this.G(k),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),k=>this.G(k),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let k=!1;const K=s.Event.chain(this.y.add(new N.$iQ(this.k.domNode,"keydown")).event,q=>q.map(T=>new i.$qO(T)).filter(T=>k=T.keyCode===58||T.shiftKey&&T.keyCode===68).map(T=>y.$cP.stop(T,!0)).filter(()=>!1)),g=s.Event.chain(this.y.add(new N.$iQ(this.k.domNode,"keyup")).event,q=>q.forEach(()=>k=!1).map(T=>new i.$qO(T)).filter(T=>T.keyCode===58||T.shiftKey&&T.keyCode===68).map(T=>y.$cP.stop(T,!0)).map(({browserEvent:T})=>{const P=this.getFocus(),O=P.length?P[0]:void 0,_=typeof O<"u"?this.k.element(O):void 0,S=typeof O<"u"?this.k.domElement(O):this.k.domNode;return{index:O,element:_,anchor:S,browserEvent:T}})),p=s.Event.chain(this.k.onContextMenu,q=>q.filter(T=>!k).map(({element:T,index:P,browserEvent:O})=>({element:T,index:P,anchor:new $.$lO(O),browserEvent:O})));return s.Event.any(K,g,p)}get onKeyDown(){return this.y.add(new N.$iQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new N.$iQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new N.$iQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new N.$iQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new N.$iQ(this.k.domNode,"blur",!0)).event)}constructor(k,K,g,p,q=me){this.A=k,this.B=q,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Td,this.x="",this.y=new e.$Pc,this.z=new s.$Ld,this.onDidDispose=this.z.event;const T=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new C(T!=="listbox");const P=[this.c.renderer,this.d.renderer];this.u=q.accessibilityProvider,this.u&&(P.push(new Q(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),p=p.map(_=>new ne(_.templateId,[...P,_]));const O={...q,dnd:q.dnd&&new V(this,q.dnd)};if(this.k=this.C(K,g,p,O),this.k.domNode.setAttribute("role",T),q.styleController)this.q=q.styleController(this.k.domId);else{const _=(0,y.$5O)(this.k.domNode);this.q=new ae(_,this.k.domId)}if(this.o=new D.$mQ([new R(this.c,this.k,q.identityProvider),new R(this.d,this.k,q.identityProvider),new R(this.f,this.k,q.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new F(this,this.k)),(typeof q.keyboardSupport!="boolean"||q.keyboardSupport)&&(this.v=new j(this,this.k,q),this.y.add(this.v)),q.keyboardNavigationLabelProvider){const _=q.keyboardNavigationDelegate||t.$CQ;this.t=new I(this,this.k,q.keyboardNavigationLabelProvider,q.keyboardNavigationEventFilter??(()=>!0),_),this.y.add(this.t)}this.w=this.D(q),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(k,K,g,p){return new r.$yQ(k,K,g,p)}D(k){return new le(this)}updateOptions(k={}){this.B={...this.B,...k},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(k),this.v?.updateOptions(k),this.k.updateOptions(k)}get options(){return this.B}splice(k,K,g=[]){if(k<0||k>this.k.length)throw new n.$oQ(this.A,`Invalid start index: ${k}`);if(K<0)throw new n.$oQ(this.A,`Invalid delete count: ${K}`);K===0&&g.length===0||this.g.bufferEvents(()=>this.o.splice(k,K,g))}updateWidth(k){this.k.updateWidth(k)}updateElementHeight(k,K){this.k.updateElementHeight(k,K,null)}rerender(){this.k.rerender()}element(k){return this.k.element(k)}indexOf(k){return this.k.indexOf(k)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(k){this.k.setScrollTop(k)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(k){this.k.setScrollLeft(k)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(k){this.x=k,this.k.domNode.setAttribute("aria-label",k)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(k,K){this.k.layout(k,K)}triggerTypeNavigation(){this.t?.trigger()}setSelection(k,K){for(const g of k)if(g<0||g>=this.length)throw new n.$oQ(this.A,`Invalid index ${g}`);this.d.set(k,K)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(k=>this.k.element(k))}setAnchor(k){if(typeof k>"u"){this.f.set([]);return}if(k<0||k>=this.length)throw new n.$oQ(this.A,`Invalid index ${k}`);this.f.set([k])}getAnchor(){return(0,h.$Mb)(this.f.get(),void 0)}getAnchorElement(){const k=this.getAnchor();return typeof k>"u"?void 0:this.element(k)}setFocus(k,K){for(const g of k)if(g<0||g>=this.length)throw new n.$oQ(this.A,`Invalid index ${g}`);this.c.set(k,K)}focusNext(k=1,K=!1,g,p){if(this.length===0)return;const q=this.c.get(),T=this.E(q.length>0?q[0]+k:0,K,p);T>-1&&this.setFocus([T],g)}focusPrevious(k=1,K=!1,g,p){if(this.length===0)return;const q=this.c.get(),T=this.F(q.length>0?q[0]-k:0,K,p);T>-1&&this.setFocus([T],g)}async focusNextPage(k,K){let g=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);g=g===0?0:g-1;const p=this.getFocus()[0];if(p!==g&&(p===void 0||g>p)){const q=this.F(g,!1,K);q>-1&&p!==q?this.setFocus([q],k):this.setFocus([g],k)}else{const q=this.k.getScrollTop();let T=q+this.k.renderHeight;g>p&&(T-=this.k.elementHeight(g)),this.k.setScrollTop(T),this.k.getScrollTop()!==q&&(this.setFocus([]),await(0,f.$Sg)(0),await this.focusNextPage(k,K))}}async focusPreviousPage(k,K){let g;const p=this.k.getScrollTop();p===0?g=this.k.indexAt(p):g=this.k.indexAfter(p-1);const q=this.getFocus()[0];if(q!==g&&(q===void 0||q>=g)){const T=this.E(g,!1,K);T>-1&&q!==T?this.setFocus([T],k):this.setFocus([g],k)}else{const T=p;this.k.setScrollTop(p-this.k.renderHeight),this.k.getScrollTop()!==T&&(this.setFocus([]),await(0,f.$Sg)(0),await this.focusPreviousPage(k,K))}}focusLast(k,K){if(this.length===0)return;const g=this.F(this.length-1,!1,K);g>-1&&this.setFocus([g],k)}focusFirst(k,K){this.focusNth(0,k,K)}focusNth(k,K,g){if(this.length===0)return;const p=this.E(k,!1,g);p>-1&&this.setFocus([p],K)}E(k,K=!1,g){for(let p=0;p<this.length;p++){if(k>=this.length&&!K)return-1;if(k=k%this.length,!g||g(this.element(k)))return k;k++}return-1}F(k,K=!1,g){for(let p=0;p<this.length;p++){if(k<0&&!K)return-1;if(k=(this.length+k%this.length)%this.length,!g||g(this.element(k)))return k;k--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(k=>this.k.element(k))}reveal(k,K){if(k<0||k>=this.length)throw new n.$oQ(this.A,`Invalid index ${k}`);const g=this.k.getScrollTop(),p=this.k.elementTop(k),q=this.k.elementHeight(k);if((0,m.$Af)(K)){const T=q-this.k.renderHeight;this.k.setScrollTop(T*(0,u.$Jl)(K,0,1)+p)}else{const T=p+q,P=g+this.k.renderHeight;p<g&&T>=P||(p<g||T>=P&&q>=this.k.renderHeight?this.k.setScrollTop(p):T>=P&&this.k.setScrollTop(T-this.k.renderHeight))}}getRelativeTop(k){if(k<0||k>=this.length)throw new n.$oQ(this.A,`Invalid index ${k}`);const K=this.k.getScrollTop(),g=this.k.elementTop(k),p=this.k.elementHeight(k);if(g<K||g+p>K+this.k.renderHeight)return null;const q=p-this.k.renderHeight;return Math.abs((K-g)/q)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(k){return this.k.getElementDomId(k)}style(k){this.q.style(k)}G({indexes:k,browserEvent:K}){return{indexes:k,elements:k.map(g=>this.k.element(g)),browserEvent:K}}H(){const k=this.c.get();this.k.domNode.classList.toggle("element-focused",k.length>0),this.I()}I(){const k=this.c.get();if(k.length>0){let K;this.u?.getActiveDescendantId&&(K=this.u.getActiveDescendantId(this.k.element(k[0]))),this.k.domNode.setAttribute("aria-activedescendant",K||this.k.getElementDomId(k[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const k=this.d.get();this.k.domNode.classList.toggle("selection-none",k.length===0),this.k.domNode.classList.toggle("selection-single",k.length===1),this.k.domNode.classList.toggle("selection-multiple",k.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$IQ=ee,Qe([L.$eh],ee.prototype,"onDidChangeFocus",null),Qe([L.$eh],ee.prototype,"onDidChangeSelection",null),Qe([L.$eh],ee.prototype,"onContextMenu",null),Qe([L.$eh],ee.prototype,"onKeyDown",null),Qe([L.$eh],ee.prototype,"onKeyUp",null),Qe([L.$eh],ee.prototype,"onKeyPress",null),Qe([L.$eh],ee.prototype,"onDidFocus",null),Qe([L.$eh],ee.prototype,"onDidBlur",null)}),define(be[60],$e([1,0,6,34,36,12,15]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(D||(t.MarkdownStringTextNewlineStyle=D={}));class h{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,y.$5)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=0){return this.value+=s(this.supportThemeIcons?(0,N.$Tj)(m):m).replace(/([ \t]+)/g,(r,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(m,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(m,n){const r=new RegExp((0,U.$De)(n),"g");return m.replace(r,($,c)=>m.charAt(c-1)!=="\\"?`\\${$}`:$)}}t.$Zj=h;function f(l){return d(l)?!l.value:Array.isArray(l)?l.every(f):!0}t.$1j=f;function d(l){return l instanceof h?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.$2j=d;function L(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons&&l.supportHtml===m.supportHtml&&(l.baseUri===m.baseUri||!!l.baseUri&&!!m.baseUri&&(0,i.$mg)(w.URI.from(l.baseUri),w.URI.from(m.baseUri)))}t.$3j=L;function s(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$4j=s;function a(l){return l.replace(/"/g,"&quot;")}t.$5j=a;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$6j=e;function u(l){const m=[],n=l.split("|").map($=>$.trim());l=n[0];const r=n[1];if(r){const $=/height=(\d+)/.exec(r),c=/width=(\d+)/.exec(r),o=$?$[1]:"",C=c?c[1]:"",R=isFinite(parseInt(C)),M=isFinite(parseInt(o));R&&m.push(`width="${C}"`),M&&m.push(`height="${o}"`)}return{href:l,dimensions:m}}t.$7j=u}),define(be[123],$e([1,0,4,115,21,53,14,19,116,6,3,60,34,75,30,2,77,51,28,49,36,12,15]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s,a,e,u,l,m,n,r,$,c,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=void 0;const C=Object.freeze({image:(V,ee,J)=>{let k=[],K=[];return V&&({href:V,dimensions:k}=(0,L.$7j)(V),K.push(`src="${(0,L.$5j)(V)}"`)),J&&K.push(`alt="${(0,L.$5j)(J)}"`),ee&&K.push(`title="${(0,L.$5j)(ee)}"`),k.length&&(K=K.concat(k)),"<img "+K.join(" ")+">"},paragraph:V=>`<p>${V}</p>`,link:(V,ee,J)=>typeof V!="string"?"":(V===J&&(J=(0,L.$6j)(J)),ee=typeof ee=="string"?(0,L.$5j)((0,L.$6j)(ee)):"",V=(0,L.$6j)(V),V=V.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${V}" title="${ee||V}">${J}</a>`)});function R(V,ee={},J={}){const k=new u.$Pc;let K=!1;const g=(0,U.$hQ)(ee),p=function(A){let H;try{H=(0,m.$ih)(decodeURIComponent(A))}catch{}return H?(H=(0,r.$Zm)(H,x=>{if(V.uris&&V.uris[x])return o.URI.revive(V.uris[x])}),encodeURIComponent(JSON.stringify(H))):A},q=function(A,H){const x=V.uris&&V.uris[A];let ie=o.URI.revive(x);return H?A.startsWith(n.Schemas.data+":")?A:(ie||(ie=o.URI.parse(A)),n.$ag.uriToBrowserUri(ie).toString(!0)):!ie||o.URI.parse(A).toString()===ie.toString()?A:(ie.query&&(ie=ie.with({query:p(ie.query)})),ie.toString())},T=new l.marked.Renderer;T.image=C.image,T.link=C.link,T.paragraph=C.paragraph;const P=[],O=[];if(ee.codeBlockRendererSync?T.code=(A,H)=>{const x=a.$cM.nextId(),ie=ee.codeBlockRendererSync(M(H),A);return O.push([x,ie]),`<div class="code" data-code="${x}">${(0,c.$Ce)(A)}</div>`}:ee.codeBlockRenderer&&(T.code=(A,H)=>{const x=a.$cM.nextId(),ie=ee.codeBlockRenderer(M(H),A);return P.push(ie.then(se=>[x,se])),`<div class="code" data-code="${x}">${(0,c.$Ce)(A)}</div>`}),ee.actionHandler){const A=function(ie){let se=ie.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let ge=se.dataset.href;ge&&(V.baseUri&&(ge=b(o.URI.from(V.baseUri),ge)),ee.actionHandler.callback(ge,ie))}catch(ge){(0,f.$Y)(ge)}finally{ie.preventDefault()}},H=ee.actionHandler.disposables.add(new i.$iQ(g,"click")),x=ee.actionHandler.disposables.add(new i.$iQ(g,"auxclick"));ee.actionHandler.disposables.add(d.Event.any(H.event,x.event)(ie=>{const se=new D.$lO(ie);!se.leftButton&&!se.middleButton||A(se)})),ee.actionHandler.disposables.add(y.$tO(g,"keydown",ie=>{const se=new w.$qO(ie);!se.equals(10)&&!se.equals(3)||A(se)}))}V.supportHtml||(J.sanitizer=A=>(V.isTrusted?A.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?A:"",J.sanitize=!0,J.silent=!0),J.renderer=T;let _=V.value??"";_.length>1e5&&(_=`${_.substr(0,1e5)}\u2026`),V.supportThemeIcons&&(_=(0,s.$Uj)(_));let S;if(ee.fillInIncompleteTokens){const A={...l.marked.defaults,...J},H=l.marked.lexer(_,A),x=re(H);S=l.marked.parser(x,A)}else S=l.marked.parse(_,J);V.supportThemeIcons&&(S=(0,h.$JQ)(S).map(H=>typeof H=="string"?H:H.outerHTML).join(""));const E=new DOMParser().parseFromString(v(V,S),"text/html");if(E.body.querySelectorAll("img").forEach(A=>{const H=A.getAttribute("src");if(H){let x=H;try{V.baseUri&&(x=b(o.URI.from(V.baseUri),x))}catch{}A.src=q(x,!0)}}),E.body.querySelectorAll("a").forEach(A=>{const H=A.getAttribute("href");if(A.setAttribute("href",""),!H||/^data:|javascript:/i.test(H)||/^command:/i.test(H)&&!V.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(H))A.replaceWith(...A.childNodes);else{let x=q(H,!1);V.baseUri&&(x=b(o.URI.from(V.baseUri),H)),A.dataset.href=x}}),g.innerHTML=v(V,E.body.innerHTML),P.length>0)Promise.all(P).then(A=>{if(K)return;const H=new Map(A),x=g.querySelectorAll("div[data-code]");for(const ie of x){const se=H.get(ie.dataset.code??"");se&&y.$jP(ie,se)}ee.asyncRenderCallback?.()});else if(O.length>0){const A=new Map(O),H=g.querySelectorAll("div[data-code]");for(const x of H){const ie=A.get(x.dataset.code??"");ie&&y.$jP(x,ie)}}if(ee.asyncRenderCallback)for(const A of g.getElementsByTagName("img")){const H=k.add(y.$tO(A,"load",()=>{H.dispose(),ee.asyncRenderCallback()}))}return{element:g,dispose:()=>{K=!0,k.dispose()}}}t.$LQ=R;function M(V){if(!V)return"";const ee=V.split(/[\s+|:|,|\{|\?]/,1);return ee.length?ee[0]:V}function b(V,ee){return/^\w[\w\d+.-]*:/.test(ee)?ee:V.path.endsWith("/")?(0,$.$wg)(V,ee).toString():(0,$.$wg)((0,$.$sg)(V),ee).toString()}function v(V,ee){const{config:J,allowedSchemes:k}=j(V);N.addHook("uponSanitizeAttribute",(g,p)=>{if(p.attrName==="style"||p.attrName==="class"){if(g.tagName==="SPAN"){if(p.attrName==="style"){p.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(p.attrValue);return}else if(p.attrName==="class"){p.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(p.attrValue);return}}p.keepAttr=!1;return}});const K=y.$DP(k);try{return N.sanitize(ee,{...J,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),K.dispose()}}t.$MQ=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function j(V){const ee=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return V.isTrusted&&ee.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...y.$EP],ALLOWED_ATTR:t.$MQ,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ee}}function z(V){return typeof V=="string"?V:W(V)}t.$NQ=z;function W(V){let ee=V.value??"";ee.length>1e5&&(ee=`${ee.substr(0,1e5)}\u2026`);const J=l.marked.parse(ee,{renderer:F.value}).replace(/&(#\d+|[a-zA-Z]+);/g,k=>I.get(k)??k);return v({isTrusted:!1},J).toString()}t.$OQ=W;const I=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),F=new e.$T(()=>{const V=new l.marked.Renderer;return V.code=ee=>ee,V.blockquote=ee=>ee,V.html=ee=>"",V.heading=(ee,J,k)=>ee+`
`,V.hr=()=>"",V.list=(ee,J)=>ee,V.listitem=ee=>ee+`
`,V.paragraph=ee=>ee+`
`,V.table=(ee,J)=>ee+J+`
`,V.tablerow=ee=>ee,V.tablecell=(ee,J)=>ee+" ",V.strong=ee=>ee,V.em=ee=>ee,V.codespan=ee=>ee,V.br=()=>`
`,V.del=ee=>ee,V.image=(ee,J,k)=>"",V.text=ee=>ee,V.link=(ee,J,k)=>k,V});function X(V){let ee="";return V.forEach(J=>{ee+=J.raw}),ee}function te(V){for(const ee of V.tokens)if(ee.type==="text"){const J=ee.raw.split(`
`),k=J[J.length-1];if(k.includes("`"))return le(V);if(k.includes("**"))return Pe(V);if(k.match(/\*\w/))return ae(V);if(k.match(/(^|\s)__\w/))return de(V);if(k.match(/(^|\s)_\w/))return me(V);if(k.match(/(^|\s)\[.*\]\(\w*/))return ke(V);if(k.match(/(^|\s)\[\w/))return Le(V)}}function re(V){let ee,J;for(ee=0;ee<V.length;ee++){const k=V[ee];if(k.type==="paragraph"&&k.raw.match(/(\n|^)```/)){J=ce(V.slice(ee));break}if(k.type==="paragraph"&&k.raw.match(/(\n|^)\|/)){J=Q(V.slice(ee));break}if(ee===V.length-1&&k.type==="paragraph"){const K=te(k);if(K){J=[K];break}}}if(J){const k=[...V.slice(0,ee),...J];return k.links=V.links,k}return V}t.$PQ=re;function ce(V){const ee=X(V);return l.marked.lexer(ee+"\n```")}function le(V){return ne(V,"`")}function ae(V){return ne(V,"*")}function me(V){return ne(V,"_")}function ke(V){return ne(V,")")}function Le(V){return ne(V,"](about:blank)")}function Pe(V){return ne(V,"**")}function de(V){return ne(V,"__")}function ne(V,ee){const J=X(Array.isArray(V)?V:[V]);return l.marked.lexer(J+ee)[0]}function Q(V){const ee=X(V),J=ee.split(`
`);let k,K=!1;for(let g=0;g<J.length;g++){const p=J[g].trim();if(typeof k>"u"&&p.match(/^\s*\|/)){const q=p.match(/(\|[^\|]+)(?=\||$)/g);q&&(k=q.length)}else if(typeof k=="number")if(p.match(/^\s*\|/)){if(g!==J.length-1)return;K=!0}else return}if(typeof k=="number"&&k>0){const g=K?J.slice(0,-1).join(`
`):ee,p=!!g.match(/\|\s*$/),q=g+(p?"":"|")+`
|${" --- |".repeat(k)}`;return l.marked.lexer(q)}}}),define(be[124],$e([1,0,4,9,27,60,34,2,7,105]),function(oe,t,y,N,i,U,w,D,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_P=t.$$P=void 0;function d(a,e){(0,h.$wf)(e)?a.title=(0,w.$Vj)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$$P=d;class L{constructor(e,u,l){this.c=e,this.d=u,this.f=l}async update(e,u,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,h.$wf)(e)||e instanceof HTMLElement)m=e;else if(!(0,h.$Kf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,f.localize)(0,null),u),this.b=new i.$Vd;const n=this.b.token;if(m=await e.markdown(n),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(m,u,l)}g(e,u,l){const m=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...l};this.a=this.c.showHover(n,u)}m?.dispose()}h(e){return e?(0,U.$2j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,u,l){let m,n;const r=(R,M)=>{const b=n!==void 0;R&&(n?.dispose(),n=void 0),M&&(m?.dispose(),m=void 0),b&&a.onDidHideHover?.()},$=(R,M,b)=>new N.$2g(async()=>{(!n||n.isDisposed)&&(n=new L(a,b||e,R>0),await n.update(u,M,l))},R),c=()=>{if(m)return;const R=new D.$Pc,M=j=>r(!1,j.fromElement===e);R.add(y.$tO(e,y.$aP.MOUSE_LEAVE,M,!0));const b=()=>r(!0,!0);R.add(y.$tO(e,y.$aP.MOUSE_DOWN,b,!0));const v={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const j=z=>{v.x=z.x+10,z.target instanceof HTMLElement&&z.target.classList.contains("action-label")&&r(!0,!0)};R.add(y.$tO(e,y.$aP.MOUSE_MOVE,j,!0))}R.add($(a.delay,!1,v)),m=R},o=y.$tO(e,y.$aP.MOUSE_OVER,c,!0);return{show:R=>{r(!1,!0),$(0,R)},hide:()=>{r(!0,!0)},update:async(R,M)=>{u=R,await n?.update(u,void 0,M)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$_P=s}),define(be[125],$e([1,0,4,21,14,123,38,11,3,43,2,5,107,98]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=void 0;const a=y.$,e="selectOption.entry.template";class u{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=y.$hP(n,a(".option-text")),r.detail=y.$hP(n,a(".option-detail")),r.decoratorRight=y.$hP(n,a(".option-decorator-right")),r}renderElement(n,r,$){const c=$,o=n.text,C=n.detail,R=n.decoratorRight,M=n.isDisabled;c.text.textContent=o,c.detail.textContent=C||"",c.decoratorRight.innerText=R||"",M?c.root.classList.add("option-disabled"):c.root.classList.remove("option-disabled")}disposeTemplate(n){}}class l extends d.$Qc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,$,c,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=c,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new h.$Ld,this.B(this.r),this.O(),this.N($),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=y.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=y.$hP(this.w,a(".select-box-details-pane"));const r=y.$hP(this.w,a(".select-box-dropdown-container-width-control")),$=y.$hP(r,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",y.$hP($,this.D),this.G=0,this.y=y.$5O(this.w),this.w.setAttribute("draggable","true"),this.B(y.$tO(this.w,y.$aP.DRAG_START,c=>{y.$cP.stop(c,!0)}))}O(){this.B(y.$uO(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(y.$tO(this.h,y.$aP.CLICK,r=>{y.$cP.stop(r),this.f?this.X(!0):this.W()})),this.B(y.$tO(this.h,y.$aP.MOUSE_DOWN,r=>{y.$cP.stop(r)}));let n;this.B(y.$tO(this.h,"touchstart",r=>{n=this.f})),this.B(y.$tO(this.h,"touchend",r=>{y.$cP.stop(r),n?this.X(!0):this.W()})),this.B(y.$tO(this.h,y.$aP.KEY_DOWN,r=>{const $=new i.$qO(r);let c=!1;L.$j?($.keyCode===18||$.keyCode===16||$.keyCode===10||$.keyCode===3)&&(c=!0):($.keyCode===18&&$.altKey||$.keyCode===16&&$.altKey||$.keyCode===10||$.keyCode===3)&&(c=!0),c&&(this.W(),y.$cP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){D.$sb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach(($,c)=>{this.h.add(this.U($.text,c,$.isDisabled)),typeof $.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",$=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=$}S(){const n=this.s.selectBackground??"",r=y.$zP(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const $=this.s.focusBorder??"";this.w.style.outlineColor=$,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,$){const c=document.createElement("option");return c.value=n,c.text=n,c.disabled=!!$,c}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,$)=>{this.hb($),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=y.$LO(this.h),$=getComputedStyle(this.h),c=parseFloat($.getPropertyValue("--dropdown-padding-top"))+parseFloat($.getPropertyValue("--dropdown-padding-bottom")),o=window.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),C=r.top-l.b,R=this.h.offsetWidth,M=this.bb(this.D),b=Math.max(M,Math.round(R)).toString()+"px";this.w.style.width=b,this.z.getHTMLElement().style.height="",this.z.layout();let v=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const j=this.H?this.L:0,z=v+c+j,W=Math.floor((o-c-j)/this.getHeight()),I=Math.floor((C-c-j)/this.getHeight());if(n)return r.top+r.height>window.innerHeight-22||r.top<l.b||W<1&&I<1?!1:(W<l.c&&I>W&&this.m.length>W?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>window.innerHeight-22||r.top<l.b||this.G===0&&W<1||this.G===1&&I<1)return this.X(!0),!1;if(this.G===0){if(this.f&&W+I<1)return this.X(!0),!1;z>o&&(v=W*this.getHeight())}else z>C&&(v=I*this.getHeight());return this.z.layout(v),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=v+c+"px",this.w.style.height=""):this.w.style.height=v+c+"px",this.hb(this.n),this.w.style.width=b,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let $=0,c=0;this.m.forEach((o,C)=>{const R=o.detail?o.detail.length:0,M=o.decoratorRight?o.decoratorRight.length:0,b=o.text.length+R+M;b>c&&($=C,c=b)}),n.textContent=this.m[$].text+(this.m[$].decoratorRight?this.m[$].decoratorRight+" ":""),r=y.$NO(n)}return r}cb(n){if(this.z)return;this.C=y.$hP(n,a(".select-box-dropdown-list-container")),this.t=new u,this.z=new w.$IQ("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:c=>{let o=c.text;return c.detail&&(o+=`. ${c.detail}`),c.decoratorRight&&(o+=`. ${c.decoratorRight}`),c.description&&(o+=`. ${c.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>L.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new N.$iQ(this.C,"keydown")),$=h.Event.chain(r.event,c=>c.filter(()=>this.z.length>0).map(o=>new i.$qO(o)));this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===3))(this.jb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===2))(this.jb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===9))(this.ib,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===16))(this.lb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===18))(this.kb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===12))(this.nb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===11))(this.mb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===14))(this.ob,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===13))(this.pb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(y.$tO(this.z.getHTMLElement(),y.$aP.POINTER_UP,c=>this.db(c))),this.B(this.z.onMouseOver(c=>typeof c.index<"u"&&this.z.setFocus([c.index]))),this.B(this.z.onDidChangeFocus(c=>this.gb(c))),this.B(y.$tO(this.w,y.$aP.FOCUS_OUT,c=>{!this.f||y.$TO(c.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;y.$cP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const $=r.closest(".monaco-list-row");if(!$)return;const c=Number($.getAttribute("data-index")),o=$.classList.contains("option-disabled");c>=0&&c<this.m.length&&!o&&(this.n=c,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const $=o=>{for(let C=0;C<o.childNodes.length;C++){const R=o.childNodes.item(C);(R.tagName&&R.tagName.toLowerCase())==="img"?o.removeChild(R):$(R)}},c=(0,U.$LQ)({value:n,supportThemeIcons:!0},{actionHandler:r});return c.element.classList.add("select-box-description-markdown"),$(c.element),c.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],$=r?.description??"",c=r?.descriptionIsMarkdown??!1;if($){if(c){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb($,o))}else this.I.innerText=$;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){y.$cP.stop(n),this.select(this.F),this.X(!0)}jb(n){y.$cP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){y.$cP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(y.$cP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){y.$cP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){y.$cP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){y.$cP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){y.$cP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=f.KeyCodeUtils.toString(n.keyCode);let $=-1;for(let c=0;c<this.m.length-1;c++)if($=(c+this.n+1)%this.m.length,this.m[$].text.charAt(0).toUpperCase()===r&&!this.m[$].isDisabled){this.select($),this.z.setFocus([$]),this.z.reveal(this.z.getFocus()[0]),y.$cP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$QQ=l}),define(be[126],$e([1,0,38,125,119,20,5,97]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.$SQ=void 0,t.$SQ={...y.$HQ,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends U.$UP{constructor(f,d,L,s,a){super(),w.$j&&!a?.useCustomDrawn?this.a=new i.$RQ(f,d,s,a):this.a=new N.$QQ(f,d,L,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,d){this.a.setOptions(f,d)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}}t.$TQ=D}),define(be[61],$e([1,0,16,52,4,23,124,126,35,2,5,7,102,50]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Q=t.$ZQ=t.$YQ=void 0;class a extends f.$Qc{get action(){return this._action}constructor(m,n,r={}){super(),this.m=r,this._context=m||this,this._action=n,n instanceof h.$ri&&this.B(n.onDidChange($=>{this.element&&this.t($)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new h.$si)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const n=this.element=m;this.B(U.$QP.addTarget(m));const r=this.m&&this.m.draggable;r&&(m.draggable=!0,y.$_N&&this.B((0,i.$tO)(m,i.$aP.DRAG_START,$=>$.dataTransfer?.setData(N.$OP.TEXT,this._action.label)))),this.B((0,i.$tO)(n,U.EventType.Tap,$=>this.onClick($,!0))),this.B((0,i.$tO)(n,i.$aP.MOUSE_DOWN,$=>{r||i.$cP.stop($,!0),this._action.enabled&&$.button===0&&n.classList.add("active")})),d.$j&&this.B((0,i.$tO)(n,i.$aP.CONTEXT_MENU,$=>{$.button===0&&$.ctrlKey===!0&&this.onClick($)})),this.B((0,i.$tO)(n,i.$aP.CLICK,$=>{i.$cP.stop($,!0),this.m&&this.m.isMenu||this.onClick($)})),this.B((0,i.$tO)(n,i.$aP.DBLCLICK,$=>{i.$cP.stop($,!0)})),[i.$aP.MOUSE_UP,i.$aP.MOUSE_OUT].forEach($=>{this.B((0,i.$tO)(n,$,c=>{i.$cP.stop(c),n.classList.remove("active")}))})}onClick(m,n=!1){i.$cP.stop(m,!0);const r=L.$Ff(this._context)?this.m?.useEventAsContext?m:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,w.$_P)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$YQ=a;class e extends a{constructor(m,n,r){super(m,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(m){super.render(m),L.$Gf(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===h.$ti.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$ZQ=e;class u extends a{constructor(m,n,r,$,c,o,C){super(m,n),this.b=new D.$TQ(r,$,c,o,C),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,n){this.b.setOptions(m,n)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,n){this.actionRunner.run(this._action,this.r(m,n))}r(m,n){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$1Q=u}),define(be[62],$e([1,0,4,14,61,35,3,2,7,50]),function(oe,t,y,N,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bQ=t.$aQ=t.ActionsOrientation=void 0;var f;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(f||(t.ActionsOrientation=f={}));class d extends D.$Qc{constructor(a,e={}){super(),this.g=this.B(new D.$Pc),this.r=this.B(new D.$Yc),this.w=!1,this.y=!0,this.C=this.B(new w.$Ld),this.onDidBlur=this.C.event,this.D=this.B(new w.$Ld({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new w.$Ld),this.onDidRun=this.G.event,this.H=this.B(new w.$Ld),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$si,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let u,l;switch(this.m){case 0:u=[15],l=[17];break;case 1:u=[16],l=[18],this.domNode.className+=" vertical";break}this.B(y.$tO(this.domNode,y.$aP.KEY_DOWN,m=>{const n=new N.$qO(m);let r=!0;const $=typeof this.t=="number"?this.viewItems[this.t]:void 0;u&&(n.equals(u[0])||n.equals(u[1]))?r=this.P():l&&(n.equals(l[0])||n.equals(l[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&$ instanceof i.$YQ&&$.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(y.$tO(this.domNode,y.$aP.KEY_UP,m=>{const n=new N.$qO(m);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(y.$fP(this.domNode)),this.B(this.u.onDidBlur(()=>{(y.$2O()===this.domNode||!y.$TO(y.$2O(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(u=>u instanceof i.$YQ&&u.isEnabled());e instanceof i.$YQ&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$YQ&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(u=>{e=e||a.equals(u)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(y.$TO(y.$2O(),e)){this.t=a;break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const u=Array.isArray(a)?a:[a];let l=h.$Af(e.index)?e.index:null;u.forEach(m=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const $={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(m,$)),r||(r=new i.$ZQ(this.context,m,$)),this.b.allowContextMenu||this.r.set(r,y.$tO(n,y.$aP.CONTEXT_MENU,c=>{y.$cP.stop(c,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$YQ&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,D.$Lc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,D.$Lc)(this.viewItems),this.r.clearAndDisposeAll(),y.$sO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,u;if(a===void 0?e=!0:typeof a=="number"?u=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const l=this.viewItems.findIndex(m=>m.isEnabled());this.t=l===-1?void 0:l,this.Q(void 0,void 0,!0)}else u!==void 0&&(this.t=u),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let u;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,u=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===U.$ti.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let u;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}u=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===U.$ti.ID));return this.Q(!0),!0}Q(a,e,u=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const l=this.t!==void 0&&this.viewItems[this.t];if(l){let m=!0;h.$Kf(l.focus)||(m=!1),this.b.focusOnlyEnabledItems&&h.$Kf(l.isEnabled)&&!l.isEnabled()&&(m=!1),l.action.id===U.$ti.ID&&(m=!1),m?(u||this.s!==this.t)&&(l.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$YQ){const u=e._context===null||e._context===void 0?a:e._context;this.run(e._action,u)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,D.$Lc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$aQ=d;function L(s){if(!s.length)return s;let a=-1;for(let u=0;u<s.length;u++)if(s[u].id!==U.$ti.ID){a=u;break}if(a===-1)return[];s=s.slice(a);for(let u=s.length-1;u>=0&&s[u].id===U.$ti.ID;u--)s.splice(u,1);let e=!1;for(let u=s.length-1;u>=0;u--){const l=s[u].id===U.$ti.ID;l&&!e?s.splice(u,1):l?l&&(e=!1):e=!0}return s}t.$bQ=L}),define(be[63],$e([1,0,4,21,53,62,55,58,20,3,79,49,106,94]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FR=t.$ER=t.$DR=t.MessageType=void 0;const a=y.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$DR={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class u extends h.$UP{constructor(n,r,$){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new f.$Ld),this.onDidChange=this.O.event,this.P=this.B(new f.$Ld),this.onDidHeightChange=this.P.event,this.a=r,this.g=$,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=y.$hP(n,a(".monaco-inputbox.idle"));const c=this.g.flexibleHeight?"textarea":"input",o=y.$hP(this.element,a(".ibwrapper"));if(this.b=y.$hP(o,a(c+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=y.$hP(o,a("div.mirror")),this.y.innerText="\xA0",this.N=new D.$5P(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),y.$hP(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(M=>this.b.scrollTop=M.scrollTop));const C=this.B(new N.$iQ(document,"selectionchange")),R=f.Event.filter(C.event,()=>document.getSelection()?.anchorNode===o);this.B(R(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$aQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:y.$RO(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return y.$NO(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const $=parseFloat(this.y.style.paddingLeft||"")||0,c=parseFloat(this.y.style.paddingRight||"")||0;r=$+c}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,$=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:$})}showMessage(n,r){if(this.w==="open"&&(0,L.$2m)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const $=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${y.$zP($.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=y.$NO(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:c=>{if(!this.h)return null;n=y.$hP(c,a(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},C=this.h.formatContent?(0,i.$gQ)(this.h.content,o):(0,i.$fQ)(this.h.content,o);C.classList.add(this.U(this.h.type));const R=this.stylesForType(this.h.type);return C.style.backgroundColor=R.background??"",C.style.color=R.foreground??"",C.style.border=R.border?`1px solid ${R.border}`:"",y.$hP(n,C),null},onHide:()=>{this.w="closed"},layout:r});let $;this.h.type===3?$=s.localize(0,null,this.h.content):this.h.type===2?$=s.localize(1,null,this.h.content):$=s.localize(2,null,this.h.content),w.$kQ($),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,$=n.charCodeAt(n.length-1)===10?" ":"";(n+$).replace(/\u000c/g,"")?this.y.textContent=n+$:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",$=n.inputForeground??"",c=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=$,this.b.style.backgroundColor="inherit",this.b.style.color=$,this.element.style.border=`1px solid ${y.$zP(c,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=y.$RO(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,$=r.selectionStart,c=r.selectionEnd,o=r.value;$!==null&&c!==null&&(this.value=o.substr(0,$)+n+o.substr(c),r.setSelectionRange($+1,$+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$ER=u;class l extends u{constructor(n,r,$){const c=s.localize(3,null),o=` or \u21C5 ${c}`,C=` (\u21C5 ${c})`;super(n,r,$),this.db=this.B(new f.$Ld),this.onDidFocus=this.db.event,this.eb=this.B(new f.$Ld),this.onDidBlur=this.eb.event,this.bb=new d.$BR($.history,100);const R=()=>{if($.showHistoryHint&&$.showHistoryHint()&&!this.n.endsWith(o)&&!this.n.endsWith(C)&&this.bb.getHistory().length){const M=this.n.endsWith(")")?o:C,b=this.n+M;$.showPlaceholderOnFocus&&document.activeElement!==this.b?this.n=b:this.setPlaceHolder(b)}};this.cb=new MutationObserver((M,b)=>{M.forEach(v=>{v.target.textContent||R()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>R()),this.F(this.b,()=>{const M=b=>{if(this.n.endsWith(b)){const v=this.n.slice(0,this.n.length-b.length);return $.showPlaceholderOnFocus?this.n=v:this.setPlaceHolder(v),!0}else return!1};M(C)||M(o)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach($=>{this.bb.add($)}),r.forEach($=>{this.bb.add($)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",w.$lQ(this.value?this.value:s.localize(4,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,w.$lQ(this.value))}clearHistory(){this.bb.clear()}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$FR=l}),define(be[64],$e([1,0,61,20,17,18,3,99]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XQ=t.$WQ=t.$VQ=t.$UQ=void 0,t.$UQ={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class D extends y.$YQ{constructor(L,s,a){super(L,s,a),this.a=this.B(new h({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(L){this.element=L,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(L){this.a.domNode.tabIndex=L?0:-1}}t.$VQ=D;class h extends N.$UP{constructor(L){super(),this.a=this.B(new w.$Ld),this.onChange=this.a.event,this.b=this.B(new w.$Ld),this.onKeyDown=this.b.event,this.c=L,this.s=this.c.isChecked;const s=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,s.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&s.push(...this.c.actionClassName.split(" ")),this.s&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...s),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,a=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),a.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,a=>{if(a.keyCode===10||a.keyCode===3){this.checked=!this.s,this.a.fire(!0),a.preventDefault(),a.stopPropagation();return}this.b.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(L){this.s=L,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(L){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=L,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(L){this.domNode.title=L,this.domNode.setAttribute("aria-label",L)}}t.$WQ=h;class f extends N.$UP{constructor(L,s,a){super(),this.c=L,this.g=s,this.a=new h({title:this.c,isChecked:this.g,icon:i.$Rj.check,actionClassName:"monaco-checkbox",...t.$UQ}),this.domNode=this.a.domNode,this.b=a,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(L){this.a.checked=L,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$XQ=f}),define(be[127],$e([1,0,64,17,104]),function(oe,t,y,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SR=t.$RR=t.$QR=void 0;const U=i.localize(0,null),w=i.localize(1,null),D=i.localize(2,null);class h extends y.$WQ{constructor(s){super({icon:N.$Rj.caseSensitive,title:U+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$QR=h;class f extends y.$WQ{constructor(s){super({icon:N.$Rj.wholeWord,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$RR=f;class d extends y.$WQ{constructor(s){super({icon:N.$Rj.regex,title:D+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$SR=d}),define(be[128],$e([1,0,4,127,63,20,3,103,2,93]),function(oe,t,y,N,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TR=void 0;const f=D.localize(0,null);class d extends U.$UP{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new h.$Rc),this.N=[],this.O=this.B(new w.$Ld),this.onDidOptionChange=this.O.event,this.P=this.B(new w.$Ld),this.onKeyDown=this.P.event,this.Q=this.B(new w.$Ld),this.onMouseDown=this.Q.event,this.R=this.B(new w.$Ld),this.onInput=this.R.event,this.S=this.B(new w.$Ld),this.onKeyUp=this.S.event,this.U=this.B(new w.$Ld),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new w.$Ld),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||f,this.h=!!e.showCommonFindToggles;const u=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,$=!!e.flexibleWidth,c=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$FR(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:$,flexibleMaxHeight:c,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new N.$SR({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(C=>{this.W.fire(C)})),this.L=this.B(new N.$RR({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new N.$QR({appendTitle:u,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(C=>{this.U.fire(C)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,C=>{if(C.equals(15)||C.equals(17)||C.equals(9)){const R=o.indexOf(document.activeElement);if(R>=0){let M=-1;C.equals(17)?M=(R+1)%o.length:C.equals(15)&&(R===0?M=o.length-1:M=R-1),C.equals(9)?(o[R].blur(),this.inputBox.focus()):M>=0&&o[M].focus(),y.$cP.stop(C,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(y.$tO(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(y.$tO(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new h.$Pc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$TR=d}),define(be[129],$e([1,0,4,21,14,62,128,63,59,38,64,56,24,35,11,9,17,18,31,3,33,2,45,7,108,100]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s,a,e,u,l,m,n,r,$,c,o,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rS=t.TreeFindMatchType=t.TreeFindMode=t.$qS=t.$pS=t.RenderIndentGuides=t.$oS=t.$nS=void 0;class M extends h.$vQ{set context(g){this.c.context=g}get context(){return this.c.context}constructor(g){super(g.elements.map(p=>p.element)),this.c=g}}function b(K){return K instanceof h.$vQ?new M(K):K}class v{constructor(g,p){this.d=g,this.f=p,this.b=c.$Qc.None,this.c=new c.$Pc}getDragURI(g){return this.f.getDragURI(g.element)}getDragLabel(g,p){if(this.f.getDragLabel)return this.f.getDragLabel(g.map(q=>q.element),p)}onDragStart(g,p){this.f.onDragStart?.(b(g),p)}onDragOver(g,p,q,T,P=!0){const O=this.f.onDragOver(b(g),p&&p.element,q,T),_=this.a!==p;if(_&&(this.b.dispose(),this.a=p),typeof p>"u")return O;if(_&&typeof O!="boolean"&&O.autoExpand&&(this.b=(0,u.$Tg)(()=>{const H=this.d(),x=H.getNodeLocation(p);H.isCollapsed(x)&&H.setCollapsed(x,!1),this.a=void 0},500,this.c)),typeof O=="boolean"||!O.accept||typeof O.bubble>"u"||O.feedback){if(!P){const H=typeof O=="boolean"?O:O.accept,x=typeof O=="boolean"?void 0:O.effect;return{accept:H,effect:x,feedback:[q]}}return O}if(O.bubble===1){const H=this.d(),x=H.getNodeLocation(p),ie=H.getParentNodeLocation(x),se=H.getNode(ie),ge=ie&&H.getListIndex(ie);return this.onDragOver(g,se,ge,T,!1)}const S=this.d(),B=S.getNodeLocation(p),E=S.getListIndex(B),A=S.getListRenderCount(B);return{...O,feedback:(0,e.$Qb)(E,E+A)}}drop(g,p,q,T){this.b.dispose(),this.a=void 0,this.f.drop(b(g),p&&p.element,q,T)}onDragEnd(g){this.f.onDragEnd?.(g)}dispose(){this.c.dispose(),this.f.dispose()}}function j(K,g){return g&&{...g,identityProvider:g.identityProvider&&{getId(p){return g.identityProvider.getId(p.element)}},dnd:g.dnd&&new v(K,g.dnd),multipleSelectionController:g.multipleSelectionController&&{isSelectionSingleChangeEvent(p){return g.multipleSelectionController.isSelectionSingleChangeEvent({...p,element:p.element})},isSelectionRangeChangeEvent(p){return g.multipleSelectionController.isSelectionRangeChangeEvent({...p,element:p.element})}},accessibilityProvider:g.accessibilityProvider&&{...g.accessibilityProvider,getSetSize(p){const q=K(),T=q.getNodeLocation(p),P=q.getParentNodeLocation(T);return q.getNode(P).visibleChildrenCount},getPosInSet(p){return p.visibleChildIndex+1},isChecked:g.accessibilityProvider&&g.accessibilityProvider.isChecked?p=>g.accessibilityProvider.isChecked(p.element):void 0,getRole:g.accessibilityProvider&&g.accessibilityProvider.getRole?p=>g.accessibilityProvider.getRole(p.element):()=>"treeitem",getAriaLabel(p){return g.accessibilityProvider.getAriaLabel(p.element)},getWidgetAriaLabel(){return g.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:g.accessibilityProvider&&g.accessibilityProvider.getWidgetRole?()=>g.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:g.accessibilityProvider&&g.accessibilityProvider.getAriaLevel?p=>g.accessibilityProvider.getAriaLevel(p.element):p=>p.depth,getActiveDescendantId:g.accessibilityProvider.getActiveDescendantId&&(p=>g.accessibilityProvider.getActiveDescendantId(p.element))},keyboardNavigationLabelProvider:g.keyboardNavigationLabelProvider&&{...g.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(p){return g.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(p.element)}}}}class z{constructor(g){this.a=g}getHeight(g){return this.a.getHeight(g.element)}getTemplateId(g){return this.a.getTemplateId(g.element)}hasDynamicHeight(g){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(g.element)}setDynamicHeight(g,p){this.a.setDynamicHeight?.(g.element,p)}}t.$nS=z;class W{static lift(g){return g instanceof W?g:new W(g)}static empty(g=0){return new W({focus:[],selection:[],expanded:Object.create(null),scrollTop:g})}constructor(g){if(this.focus=new Set(g.focus),this.selection=new Set(g.selection),g.expanded instanceof Array){this.expanded=Object.create(null);for(const p of g.expanded)this.expanded[p]=1}else this.expanded=g.expanded;this.expanded=g.expanded,this.scrollTop=g.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$oS=W;var I;(function(K){K.None="none",K.OnHover="onHover",K.Always="always"})(I||(t.RenderIndentGuides=I={}));class F{get elements(){return this.b}constructor(g,p=[]){this.b=p,this.a=new c.$Pc,this.onDidChange=r.Event.forEach(g,q=>this.b=q,this.a)}dispose(){this.a.dispose()}}class X{static{this.a=8}constructor(g,p,q,T,P,O={}){this.o=g,this.p=p,this.q=T,this.s=P,this.b=new Map,this.c=new Map,this.d=X.a,this.f=!1,this.g=!1,this.j=new Set,this.k=c.$Qc.None,this.m=new c.$Pc,this.templateId=g.templateId,this.updateOptions(O),r.Event.map(q,_=>_.node)(this.u,this,this.m),g.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(g={}){if(typeof g.indent<"u"){const p=(0,o.$Jl)(g.indent,0,40);if(p!==this.d){this.d=p;for(const[q,T]of this.c)this.v(q,T)}}if(typeof g.renderIndentGuides<"u"){const p=g.renderIndentGuides!==I.None;if(p!==this.g){this.g=p;for(const[q,T]of this.c)this.w(q,T);if(this.k.dispose(),p){const q=new c.$Pc;this.q.onDidChange(this.x,this,q),this.k=q,this.x(this.q.elements)}}}typeof g.hideTwistiesOfChildlessElements<"u"&&(this.f=g.hideTwistiesOfChildlessElements)}renderTemplate(g){const p=(0,y.$hP)(g,(0,y.$)(".monaco-tl-row")),q=(0,y.$hP)(p,(0,y.$)(".monaco-tl-indent")),T=(0,y.$hP)(p,(0,y.$)(".monaco-tl-twistie")),P=(0,y.$hP)(p,(0,y.$)(".monaco-tl-contents")),O=this.o.renderTemplate(P);return{container:g,indent:q,twistie:T,indentGuidesDisposable:c.$Qc.None,templateData:O}}renderElement(g,p,q,T){this.c.set(g,q),this.b.set(g.element,g),this.v(g,q),this.o.renderElement(g,p,q.templateData,T)}disposeElement(g,p,q,T){q.indentGuidesDisposable.dispose(),this.o.disposeElement?.(g,p,q.templateData,T),typeof T=="number"&&(this.c.delete(g),this.b.delete(g.element))}disposeTemplate(g){this.o.disposeTemplate(g.templateData)}t(g){const p=this.b.get(g);p&&this.u(p)}u(g){const p=this.c.get(g);p&&(this.x(this.q.elements),this.v(g,p))}v(g,p){const q=X.a+(g.depth-1)*this.d;p.twistie.style.paddingLeft=`${q}px`,p.indent.style.width=`${q+this.d-16}px`,g.collapsible?p.container.setAttribute("aria-expanded",String(!g.collapsed)):p.container.removeAttribute("aria-expanded"),p.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(l.$Rj.treeItemExpanded));let T=!1;this.o.renderTwistie&&(T=this.o.renderTwistie(g.element,p.twistie)),g.collapsible&&(!this.f||g.visibleChildrenCount>0)?(T||p.twistie.classList.add(...m.ThemeIcon.asClassNameArray(l.$Rj.treeItemExpanded)),p.twistie.classList.add("collapsible"),p.twistie.classList.toggle("collapsed",g.collapsed)):p.twistie.classList.remove("collapsible","collapsed"),this.w(g,p)}w(g,p){if((0,y.$sO)(p.indent),p.indentGuidesDisposable.dispose(),!this.g)return;const q=new c.$Pc,T=this.p();for(;;){const P=T.getNodeLocation(g),O=T.getParentNodeLocation(P);if(!O)break;const _=T.getNode(O),S=(0,y.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(_)&&S.classList.add("active"),p.indent.childElementCount===0?p.indent.appendChild(S):p.indent.insertBefore(S,p.indent.firstElementChild),this.s.add(_,S),q.add((0,c.$Oc)(()=>this.s.delete(_,S))),g=_}p.indentGuidesDisposable=q}x(g){if(!this.g)return;const p=new Set,q=this.p();g.forEach(T=>{const P=q.getNodeLocation(T);try{const O=q.getParentNodeLocation(P);T.collapsible&&T.children.length>0&&!T.collapsed?p.add(T):O&&p.add(q.getNode(O))}catch{}}),this.j.forEach(T=>{p.has(T)||this.s.forEach(T,P=>P.classList.remove("active"))}),p.forEach(T=>{this.j.has(T)||this.s.forEach(T,P=>P.classList.add("active"))}),this.j=p}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,c.$Lc)(this.m)}}class te{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(g){this.c=g,this.d=g.toLowerCase()}constructor(g,p,q){this.g=g,this.j=p,this.k=q,this.a=0,this.b=0,this.c="",this.d="",this.f=new c.$Pc,g.onWillRefilter(this.m,this,this.f)}filter(g,p){let q=1;if(this.k){const O=this.k.filter(g,p);if(typeof O=="boolean"?q=O?1:0:(0,L.$kS)(O)?q=(0,L.$lS)(O.visibility):q=O,q===0)return!1}if(this.a++,!this.c)return this.b++,{data:$.FuzzyScore.Default,visibility:q};const T=this.j.getKeyboardNavigationLabel(g),P=Array.isArray(T)?T:[T];for(const O of P){const _=O&&O.toString();if(typeof _>"u")return{data:$.FuzzyScore.Default,visibility:q};let S;if(this.g.findMatchType===me.Contiguous){const B=_.toLowerCase().indexOf(this.d);if(B>-1){S=[Number.MAX_SAFE_INTEGER,0];for(let E=this.d.length;E>0;E--)S.push(B+E-1)}}else S=(0,$.$Mj)(this.c,this.d,0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(S)return this.b++,P.length===1?{data:S,visibility:q}:{data:{label:_,score:S},visibility:q}}return this.g.findMode===ae.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(g):2:{data:$.FuzzyScore.Default,visibility:q}}m(){this.a=0,this.b=0}dispose(){(0,c.$Lc)(this.f)}}class re extends d.$WQ{constructor(g){super({icon:l.$Rj.listFilter,title:(0,R.localize)(0,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$pS=re;class ce extends d.$WQ{constructor(g){super({icon:l.$Rj.searchFuzzy,title:(0,R.localize)(1,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$qS=ce;const le={inputBoxStyles:D.$DR,toggleStyles:d.$UQ,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ae;(function(K){K[K.Highlight=0]="Highlight",K[K.Filter=1]="Filter"})(ae||(t.TreeFindMode=ae={}));var me;(function(K){K[K.Fuzzy=0]="Fuzzy",K[K.Contiguous=1]="Contiguous"})(me||(t.TreeFindMatchType=me={}));class ke extends c.$Qc{set mode(g){this.b.checked=g===ae.Filter,this.f.inputBox.setPlaceHolder(g===ae.Filter?(0,R.localize)(2,null):(0,R.localize)(3,null))}set matchType(g){this.c.checked=g===me.Fuzzy}get value(){return this.f.inputBox.value}set value(g){this.f.inputBox.value=g}constructor(g,p,q,T,P,O){super(),this.t=p,this.a=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Ld,this.onDidDisable=this._onDidDisable.event,g.appendChild(this.a.root),this.B((0,c.$Oc)(()=>g.removeChild(this.a.root)));const _=O?.styles??le;_.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=_.listFilterWidgetBackground),_.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${_.listFilterWidgetShadow}`),this.b=this.B(new re({..._.toggleStyles,isChecked:T===ae.Filter})),this.c=this.B(new ce({..._.toggleStyles,isChecked:P===me.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?ae.Filter:ae.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?me.Fuzzy:me.Contiguous,this.q),this.f=this.B(new w.$TR(this.a.findInput,q,{label:(0,R.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:_.inputBoxStyles,toggleStyles:_.toggleStyles,history:O?.history})),this.g=this.B(new U.$aQ(this.a.actionbar)),this.mode=T;const S=this.B(new N.$iQ(this.f.inputBox.inputElement,"keydown")),B=r.Event.chain(S.event,x=>x.map(ie=>new i.$qO(ie)));this.B(B(x=>{if(x.equals(3)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(x.equals(18)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(x.equals(16)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const E=this.B(new a.$ri("close",(0,R.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(E,{icon:!0,label:!1});const A=this.B(new N.$iQ(this.a.grab,"mousedown"));this.B(A.event(x=>{const ie=new c.$Pc,se=ie.add(new N.$iQ(window,"mousemove")),ge=ie.add(new N.$iQ(window,"mouseup")),we=this.m,Fe=x.pageX,Ae=this.s,ve=x.pageY;this.a.grab.classList.add("grabbing");const Ie=this.a.root.style.transition;this.a.root.style.transition="unset";const Oe=qe=>{const je=qe.pageX-Fe;this.m=we-je;const Me=qe.pageY-ve;this.s=Ae+Me,this.layout()};ie.add(se.event(Oe)),ie.add(ge.event(qe=>{Oe(qe),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ie,ie.dispose()}))}));const H=r.Event.chain(this.B(new N.$iQ(this.a.grab,"keydown")).event,x=>x.map(ie=>new i.$qO(ie)));this.B(H(x=>{let ie,se;if(x.keyCode===15?ie=Number.POSITIVE_INFINITY:x.keyCode===17?ie=0:x.keyCode===10&&(ie=this.m===0?Number.POSITIVE_INFINITY:0),x.keyCode===16?se=0:x.keyCode===18&&(se=Number.POSITIVE_INFINITY),ie!==void 0&&(x.preventDefault(),x.stopPropagation(),this.m=ie,this.layout()),se!==void 0){x.preventDefault(),x.stopPropagation(),this.s=se;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(g=this.j){this.j=g,this.m=(0,o.$Jl)(this.m,0,Math.max(0,g-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Jl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(g){this.f.showMessage(g)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,u.$Sg)(300),super.dispose()}}class Le{get pattern(){return this.b}get mode(){return this.d}set mode(g){g!==this.d&&(this.d=g,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(g))}get matchType(){return this.f}set matchType(g){g!==this.f&&(this.f=g,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(g))}constructor(g,p,q,T,P,O={}){this.t=g,this.u=q,this.v=T,this.w=P,this.x=O,this.b="",this.c="",this.j=0,this.k=new r.$Ld,this.onDidChangeMode=this.k.event,this.m=new r.$Ld,this.onDidChangeMatchType=this.m.event,this.o=new r.$Ld,this.onDidChangePattern=this.o.event,this.p=new r.$Ld,this.onDidChangeOpenState=this.p.event,this.q=new c.$Pc,this.s=new c.$Pc,this.d=g.options.defaultFindMode??ae.Highlight,this.f=g.options.defaultFindMatchType??me.Fuzzy,p.onDidSplice(this.z,this,this.s)}updateOptions(g={}){g.defaultFindMode!==void 0&&(this.mode=g.defaultFindMode),g.defaultFindMatchType!==void 0&&(this.matchType=g.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new ke(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(g=>this.mode=g,void 0,this.q),this.g.onDidChangeMatchType(g=>this.matchType=g,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(g){this.b=g,this.o.fire(g),this.v.pattern=g,this.t.refilter(),g&&this.t.focusNext(0,!0,void 0,q=>!$.FuzzyScore.isDefault(q.filterData));const p=this.t.getFocus();if(p.length>0){const q=p[0];this.t.getRelativeTop(q)===null&&this.t.reveal(q,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const g=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&g?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,R.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(g){return!this.g||!this.pattern||this.d===ae.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!$.FuzzyScore.isDefault(g.filterData)}layout(g){this.j=g,this.g?.layout(g)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Pe(K){let g=s.TreeMouseEventTarget.Unknown;return(0,y.$XO)(K.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?g=s.TreeMouseEventTarget.Twistie:(0,y.$XO)(K.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?g=s.TreeMouseEventTarget.Element:(0,y.$XO)(K.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(g=s.TreeMouseEventTarget.Filter),{browserEvent:K.browserEvent,element:K.element?K.element.element:null,target:g}}function de(K){return{element:K.element?K.element.element:null,browserEvent:K.browserEvent,anchor:K.anchor}}function ne(K,g){g(K),K.children.forEach(p=>ne(p,g))}class Q{get f(){return this.d||(this.d=this.m()),this.d}constructor(g,p){this.g=g,this.j=p,this.a=[],this.c=new r.$Ld,this.onDidChange=this.c.event}set(g,p){!p?.__forceEvent&&(0,e.$sb)(this.a,g)||this.k(g,!1,p)}k(g,p,q){if(this.a=[...g],this.b=void 0,this.d=void 0,!p){const T=this;this.c.fire({get elements(){return T.get()},browserEvent:q})}}get(){return this.b||(this.b=this.a.map(g=>g.element)),[...this.b]}getNodes(){return this.a}has(g){return this.f.has(g)}onDidModelSplice({insertedNodes:g,deletedNodes:p}){if(!this.j){const S=this.m(),B=E=>S.delete(E);p.forEach(E=>ne(E,B)),this.set([...S.values()]);return}const q=new Set,T=S=>q.add(this.j.getId(S.element).toString());p.forEach(S=>ne(S,T));const P=new Map,O=S=>P.set(this.j.getId(S.element).toString(),S);g.forEach(S=>ne(S,O));const _=[];for(const S of this.a){const B=this.j.getId(S.element).toString();if(!q.has(B))_.push(S);else{const A=P.get(B);A&&A.visible&&_.push(A)}}if(this.a.length>0&&_.length===0){const S=this.g();S&&_.push(S)}this.k(_,!0)}m(){const g=new Set;for(const p of this.a)g.add(p);return g}}class V extends f.$FQ{constructor(g,p){super(g),this.x=p}u(g){if((0,f.$BQ)(g.browserEvent.target)||(0,f.$zQ)(g.browserEvent.target)||(0,f.$AQ)(g.browserEvent.target)||g.browserEvent.isHandledByList)return;const p=g.element;if(!p)return super.u(g);if(this.p(g)||this.o(g))return super.u(g);const q=g.browserEvent.target,T=q.classList.contains("monaco-tl-twistie")||q.classList.contains("monaco-icon-label")&&q.classList.contains("folder-icon")&&g.browserEvent.offsetX<16;let P=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?P=this.x.expandOnlyOnTwistieClick(p.element):P=!!this.x.expandOnlyOnTwistieClick,P&&!T&&g.browserEvent.detail!==2)return super.u(g);if(!this.x.expandOnDoubleClick&&g.browserEvent.detail===2)return super.u(g);if(p.collapsible){const O=this.x.getNodeLocation(p),_=g.browserEvent.altKey;if(this.x.setFocus([O]),this.x.toggleCollapsed(O,_),P&&T){g.browserEvent.isHandledByList=!0;return}}super.u(g)}v(g){g.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||g.browserEvent.isHandledByList||super.v(g)}}class ee extends f.$IQ{constructor(g,p,q,T,P,O,_,S){super(g,p,q,T,S),this.p=P,this.s=O,this.K=_}D(g){return new V(this,g.tree)}splice(g,p,q=[]){if(super.splice(g,p,q),q.length===0)return;const T=[],P=[];let O;q.forEach((_,S)=>{this.p.has(_)&&T.push(g+S),this.s.has(_)&&P.push(g+S),this.K.has(_)&&(O=g+S)}),T.length>0&&super.setFocus((0,e.$Kb)([...super.getFocus(),...T])),P.length>0&&super.setSelection((0,e.$Kb)([...super.getSelection(),...P])),typeof O=="number"&&super.setAnchor(O)}setFocus(g,p,q=!1){super.setFocus(g,p),q||this.p.set(g.map(T=>this.element(T)),p)}setSelection(g,p,q=!1){super.setSelection(g,p),q||this.s.set(g.map(T=>this.element(T)),p)}setAnchor(g,p=!1){super.setAnchor(g),p||(typeof g>"u"?this.K.set([]):this.K.set([this.element(g)]))}}class J{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Pe)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Pe),g=>g.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Pe)}get onPointer(){return r.Event.map(this.j.onPointer,Pe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??ae.Highlight}set findMode(g){this.x&&(this.x.mode=g)}get findMatchType(){return this.x?.matchType??me.Fuzzy}set findMatchType(g){this.x&&(this.x.matchType=g)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(g,p,q,T,P={}){this.D=g,this.E=P,this.w=new r.$Td,this.onDidChangeFindOpenState=r.Event.None,this.A=new c.$Pc,this.B=new r.$Ld,this.onWillRefilter=this.B.event,this.C=new r.$Ld,this.onDidUpdateOptions=this.C.event;const O=new z(q),_=new r.$Ud,S=new r.$Ud,B=this.A.add(new F(S.event)),E=new n.$Ec;this.k=T.map(se=>new X(se,()=>this.o,_.event,B,E,P));for(const se of this.k)this.A.add(se);let A;P.keyboardNavigationLabelProvider&&(A=new te(this,P.keyboardNavigationLabelProvider,P.filter),P={...P,filter:A},this.A.add(A)),this.p=new Q(()=>this.j.getFocusedElements()[0],P.identityProvider),this.q=new Q(()=>this.j.getSelectedElements()[0],P.identityProvider),this.u=new Q(()=>this.j.getAnchorElement(),P.identityProvider),this.j=new ee(g,p,O,this.k,this.p,this.q,this.u,{...j(()=>this.o,P),tree:this}),this.o=this.I(g,this.j,P),_.input=this.o.onDidChangeCollapseState;const H=r.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);H(()=>null,null,this.A);const x=this.A.add(new r.$Ld),ie=this.A.add(new u.$Og(0));if(this.A.add(r.Event.any(H,this.p.onDidChange,this.q.onDidChange)(()=>{ie.trigger(()=>{const se=new Set;for(const ge of this.p.getNodes())se.add(ge);for(const ge of this.q.getNodes())se.add(ge);x.fire([...se.values()])})})),S.input=x.event,P.keyboardSupport!==!1){const se=r.Event.chain(this.j.onKeyDown,ge=>ge.filter(we=>!(0,f.$zQ)(we.target)).map(we=>new i.$qO(we)));r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===15))(this.F,this,this.A),r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===17))(this.G,this,this.A),r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===10))(this.H,this,this.A)}if((P.findWidgetEnabled??!0)&&P.keyboardNavigationLabelProvider&&P.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Le(this,this.o,this.j,A,P.contextViewProvider,se),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,y.$5O)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===I.Always)}updateOptions(g={}){this.E={...this.E,...g};for(const p of this.k)p.updateOptions(g);this.j.updateOptions(this.E),this.x?.updateOptions(g),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===I.Always)}get options(){return this.E}updateWidth(g){const p=this.o.getListIndex(g);p!==-1&&this.j.updateWidth(p)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(g){this.j.scrollTop=g}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(g){this.j.scrollLeft=g}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const g=this.j.firstVisibleIndex;return g<0||g>=this.j.length?void 0:this.j.element(g).element}get lastVisibleElement(){const g=this.j.lastVisibleIndex;return this.j.element(g).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(g){this.j.ariaLabel=g}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(g,p){this.j.layout(g,p),(0,C.$Af)(p)&&this.x?.layout(p)}style(g){const p=`.${this.j.domId}`,q=[];g.treeIndentGuidesStroke&&(q.push(`.monaco-list${p}:hover .monaco-tl-indent > .indent-guide, .monaco-list${p}.always .monaco-tl-indent > .indent-guide  { border-color: ${g.treeInactiveIndentGuidesStroke}; }`),q.push(`.monaco-list${p} .monaco-tl-indent > .indent-guide.active { border-color: ${g.treeIndentGuidesStroke}; }`)),this.z.textContent=q.join(`
`),this.j.style(g)}getParentElement(g){const p=this.o.getParentNodeLocation(g);return this.o.getNode(p).element}getFirstElementChild(g){return this.o.getFirstElementChild(g)}getNode(g){return this.o.getNode(g)}getNodeLocation(g){return this.o.getNodeLocation(g)}collapse(g,p=!1){return this.o.setCollapsed(g,!0,p)}expand(g,p=!1){return this.o.setCollapsed(g,!1,p)}toggleCollapsed(g,p=!1){return this.o.setCollapsed(g,void 0,p)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(g){return this.o.isCollapsible(g)}setCollapsible(g,p){return this.o.setCollapsible(g,p)}isCollapsed(g){return this.o.isCollapsed(g)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(g){if(typeof g>"u")return this.j.setAnchor(void 0);const p=this.o.getNode(g);this.u.set([p]);const q=this.o.getListIndex(g);q>-1&&this.j.setAnchor(q,!0)}getAnchor(){return(0,e.$Mb)(this.u.get(),void 0)}setSelection(g,p){const q=g.map(P=>this.o.getNode(P));this.q.set(q,p);const T=g.map(P=>this.o.getListIndex(P)).filter(P=>P>-1);this.j.setSelection(T,p,!0)}getSelection(){return this.q.get()}setFocus(g,p){const q=g.map(P=>this.o.getNode(P));this.p.set(q,p);const T=g.map(P=>this.o.getListIndex(P)).filter(P=>P>-1);this.j.setFocus(T,p,!0)}focusNext(g=1,p=!1,q,T=this.y){this.j.focusNext(g,p,q,T)}focusPrevious(g=1,p=!1,q,T=this.y){this.j.focusPrevious(g,p,q,T)}focusNextPage(g,p=this.y){return this.j.focusNextPage(g,p)}focusPreviousPage(g,p=this.y){return this.j.focusPreviousPage(g,p)}focusLast(g,p=this.y){this.j.focusLast(g,p)}focusFirst(g,p=this.y){this.j.focusFirst(g,p)}getFocus(){return this.p.get()}reveal(g,p){this.o.expandTo(g);const q=this.o.getListIndex(g);q!==-1&&this.j.reveal(q,p)}getRelativeTop(g){const p=this.o.getListIndex(g);return p===-1?null:this.j.getRelativeTop(p)}getViewState(g=this.options.identityProvider){if(!g)throw new s.$iS(this.D,"Can't get tree view state without an identity provider");const p=O=>g.getId(O).toString(),q=W.empty(this.scrollTop);for(const O of this.getFocus())q.focus.add(p(O));for(const O of this.getSelection())q.selection.add(p(O));const T=this.o.getNode(),P=[T];for(;P.length>0;){const O=P.shift();O!==T&&O.collapsible&&(q.expanded[p(O.element)]=O.collapsed?0:1),P.push(...O.children)}return q}F(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const q=p[0],T=this.o.getNodeLocation(q);if(!this.o.setCollapsed(T,!0)){const O=this.o.getParentNodeLocation(T);if(!O)return;const _=this.o.getListIndex(O);this.j.reveal(_),this.j.setFocus([_])}}G(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const q=p[0],T=this.o.getNodeLocation(q);if(!this.o.setCollapsed(T,!1)){if(!q.children.some(S=>S.visible))return;const[O]=this.j.getFocus(),_=O+1;this.j.reveal(_),this.j.setFocus([_])}}H(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const q=p[0],T=this.o.getNodeLocation(q),P=g.browserEvent.altKey;this.o.setCollapsed(T,void 0,P)}navigate(g){return new k(this.j,this.o,g)}dispose(){(0,c.$Lc)(this.A),this.j.dispose()}}t.$rS=J;class k{constructor(g,p,q){this.b=g,this.c=p,q?this.a=this.c.getListIndex(q):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[130],$e([1,0,129,120,24,26]),function(oe,t,y,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=void 0;class w extends y.$rS{constructor(h,f,d,L,s,a={}){super(h,f,d,L,a),this.f=h,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(h,f){if(f&&!this.c)throw new i.$iS(this.f,"Can't restore tree view state without an identity provider");if(this.b=h,!h){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!f){this.m(h);return}const d=[],L=[],s=e=>{const u=this.c.getId(e).toString();return!f.expanded[u]},a=e=>{const u=this.c.getId(e.element).toString();f.focus.has(u)&&d.push(e.element),f.selection.has(u)&&L.push(e.element)};this.m(h,s,a),this.setFocus(d),this.setSelection(L),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(h=this.b){if(typeof this.b>"u")throw new i.$iS(this.f,"Tree input not set");let f;this.c&&(f=d=>{const L=this.c.getId(d).toString(),s=this.d.get(L);if(s)return s.collapsed}),this.m(h,f)}resort(h=this.b,f=!0){this.o.resort(h===this.b?null:h,f)}refresh(h){if(h===void 0){this.j.rerender();return}this.o.rerender(h)}m(h,f,d){let L;if(this.c){const s=new Set,a=d;d=e=>{const u=this.c.getId(e.element).toString();s.add(u),this.d.set(u,e),a?.(e)},L=e=>{const u=this.c.getId(e.element).toString();s.has(u)||this.d.delete(u)}}this.o.setChildren(h===this.b?null:h,this.s(h,f).elements,{onDidCreateNode:d,onDidDeleteNode:L})}s(h,f){const d=[...this.g.getChildren(h)];return{elements:U.Iterable.map(d,s=>{const{elements:a,size:e}=this.s(s,f),u=this.g.hasChildren?this.g.hasChildren(s):void 0,l=e===0?void 0:f&&f(s);return{element:s,children:a,collapsible:u,collapsed:l}}),size:d.length}}I(h,f,d){return new N.$sS(h,f,d)}}t.$CS=w}),define(be[65],$e([1,0,11,9,32,27,25,6,3,2,51,12,7]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vh=t.ProxyChannel=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.RequestInitiator=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=void 0;var a;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(a||(a={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(u||(u={}));function l(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(m||(m={}));function n(de){let ne=0;for(let Q=0;;Q+=7){const V=de.read(1);if(ne|=(V.buffer[0]&127)<<Q,!(V.buffer[0]&128))return ne}}const r=R(0);function $(de,ne){if(ne===0){de.write(r);return}let Q=0;for(let ee=ne;ee!==0;ee=ee>>>7)Q++;const V=i.$_d.alloc(Q);for(let ee=0;ne!==0;ee++)V.buffer[ee]=ne&127,ne=ne>>>7,ne>0&&(V.buffer[ee]|=128);de.write(V)}class c{constructor(ne){this.b=ne,this.a=0}read(ne){const Q=this.b.slice(this.a,this.a+ne);return this.a+=Q.byteLength,Q}}t.$kh=c;class o{constructor(){this.a=[]}get buffer(){return i.$_d.concat(this.a)}write(ne){this.a.push(ne)}}t.$lh=o;var C;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(C||(C={}));function R(de){const ne=i.$_d.alloc(1);return ne.writeUInt8(de,0),ne}const M={Undefined:R(C.Undefined),String:R(C.String),Buffer:R(C.Buffer),VSBuffer:R(C.VSBuffer),Array:R(C.Array),Object:R(C.Object),Uint:R(C.Int)},b=typeof Buffer<"u";function v(de,ne){if(typeof ne>"u")de.write(M.Undefined);else if(typeof ne=="string"){const Q=i.$_d.fromString(ne);de.write(M.String),$(de,Q.byteLength),de.write(Q)}else if(b&&Buffer.isBuffer(ne)){const Q=i.$_d.wrap(ne);de.write(M.Buffer),$(de,Q.byteLength),de.write(Q)}else if(ne instanceof i.$_d)de.write(M.VSBuffer),$(de,ne.byteLength),de.write(ne);else if(Array.isArray(ne)){de.write(M.Array),$(de,ne.length);for(const Q of ne)v(de,Q)}else if(typeof ne=="number"&&(ne|0)===ne)de.write(M.Uint),$(de,ne);else{const Q=i.$_d.fromString(JSON.stringify(ne));de.write(M.Object),$(de,Q.byteLength),de.write(Q)}}t.$mh=v;function j(de){switch(de.read(1).readUInt8(0)){case C.Undefined:return;case C.String:return de.read(n(de)).toString();case C.Buffer:return de.read(n(de)).buffer;case C.VSBuffer:return de.read(n(de));case C.Array:{const Q=n(de),V=[];for(let ee=0;ee<Q;ee++)V.push(j(de));return V}case C.Object:return JSON.parse(de.read(n(de)).toString());case C.Int:return n(de)}}t.$nh=j;class z{constructor(ne,Q,V=null,ee=1e3){this.h=ne,this.j=Q,this.k=V,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:200})}registerChannel(ne,Q){this.b.set(ne,Q),setTimeout(()=>this.w(ne),0)}m(ne){switch(ne.type){case 200:{const Q=this.o([ne.type]);this.k?.logOutgoing(Q,0,1,l(ne.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([ne.type,ne.id],ne.data);this.k?.logOutgoing(Q,ne.id,1,l(ne.type),ne.data);return}}}o(ne,Q=void 0){const V=new o;return v(V,ne),v(V,Q),this.p(V.buffer)}p(ne){try{return this.h.send(ne),ne.byteLength}catch{return 0}}q(ne){const Q=new c(ne),V=j(Q),ee=j(Q),J=V[0];switch(J){case 100:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(J)}: ${V[2]}.${V[3]}`,ee),this.s({type:J,id:V[1],channelName:V[2],name:V[3],arg:ee});case 102:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(J)}: ${V[2]}.${V[3]}`,ee),this.t({type:J,id:V[1],channelName:V[2],name:V[3],arg:ee});case 101:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(J)}`),this.u({type:J,id:V[1]});case 103:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(J)}`),this.u({type:J,id:V[1]})}}s(ne){const Q=this.b.get(ne.channelName);if(!Q){this.v(ne);return}const V=new U.$Vd;let ee;try{ee=Q.call(this.j,ne.name,ne.arg,V.token)}catch(K){ee=Promise.reject(K)}const J=ne.id;ee.then(K=>{this.m({id:J,data:K,type:201})},K=>{K instanceof Error?this.m({id:J,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:J,data:K,type:203})}).finally(()=>{k.dispose(),this.d.delete(ne.id)});const k=(0,f.$Oc)(()=>V.cancel());this.d.set(ne.id,k)}t(ne){const Q=this.b.get(ne.channelName);if(!Q){this.v(ne);return}const V=ne.id,J=Q.listen(this.j,ne.name,ne.arg)(k=>this.m({id:V,data:k,type:204}));this.d.set(ne.id,J)}u(ne){const Q=this.d.get(ne.id);Q&&(Q.dispose(),this.d.delete(ne.id))}v(ne){let Q=this.g.get(ne.channelName);Q||(Q=[],this.g.set(ne.channelName,Q));const V=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.m({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:ne,timeoutTimer:V})}w(ne){const Q=this.g.get(ne);if(Q){for(const V of Q)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(ne)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Lc)(this.d.values()),this.d.clear()}}t.$oh=z;var W;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(W||(t.RequestInitiator=W={}));class I{constructor(ne,Q=null){this.l=ne,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=Q}getChannel(ne){const Q=this;return{call(V,ee,J){return Q.a?Promise.reject(new D.$3):Q.m(ne,V,ee,J)},listen(V,ee){return Q.a?h.Event.None:Q.o(ne,V,ee)}}}m(ne,Q,V,ee=U.CancellationToken.None){const J=this.g++,K={id:J,type:100,channelName:ne,name:Q,arg:V};if(ee.isCancellationRequested)return Promise.reject(new D.$3);let g;return new Promise((q,T)=>{if(ee.isCancellationRequested)return T(new D.$3);const P=()=>{const B=E=>{switch(E.type){case 201:this.f.delete(J),q(E.data);break;case 202:{this.f.delete(J);const A=new Error(E.data.message);A.stack=Array.isArray(E.data.stack)?E.data.stack.join(`
`):E.data.stack,A.name=E.data.name,T(A);break}case 203:this.f.delete(J),T(E.data);break}};this.f.set(J,B),this.p(K)};let O=null;this.b===m.Idle?P():(O=(0,N.$Fg)(B=>this.u()),O.then(()=>{O=null,P()}));const _=()=>{O?(O.cancel(),O=null):this.p({id:J,type:101}),T(new D.$3)},S=ee.onCancellationRequested(_);g=(0,f.$Nc)((0,f.$Oc)(_),S),this.d.add(g)}).finally(()=>{g.dispose(),this.d.delete(g)})}o(ne,Q,V){const ee=this.g++,k={id:ee,type:102,channelName:ne,name:Q,arg:V};let K=null;const g=new h.$Ld({onWillAddFirstListener:()=>{K=(0,N.$Fg)(q=>this.u()),K.then(()=>{K=null,this.d.add(g),this.p(k)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(g),this.p({id:ee,type:103}))}}),p=q=>g.fire(q.data);return this.f.set(ee,p),g.event}p(ne){switch(ne.type){case 100:case 102:{const Q=this.q([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.j?.logOutgoing(Q,ne.id,0,`${e(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const Q=this.q([ne.type,ne.id]);this.j?.logOutgoing(Q,ne.id,0,e(ne.type));return}}}q(ne,Q=void 0){const V=new o;return v(V,ne),v(V,Q),this.r(V.buffer)}r(ne){try{return this.l.send(ne),ne.byteLength}catch{return 0}}s(ne){const Q=new c(ne),V=j(Q),ee=j(Q),J=V[0];switch(J){case 200:return this.j?.logIncoming(ne.byteLength,0,0,l(J)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ne.byteLength,V[1],0,l(J),ee),this.t({type:V[0],id:V[1],data:ee})}}t(ne){if(ne.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ne.id)?.(ne)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Lc)(this.d.values()),this.d.clear()}}t.$ph=I,Qe([w.$eh],I.prototype,"onDidInitializePromise",null);class F{get connections(){const ne=[];return this.f.forEach(Q=>ne.push(Q)),ne}constructor(ne){this.a=new Map,this.f=new Set,this.g=new h.$Ld,this.onDidAddConnection=this.g.event,this.h=new h.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new f.$Pc,this.j.add(ne(({protocol:Q,onDidClientDisconnect:V})=>{const ee=h.Event.once(Q.onMessage);this.j.add(ee(J=>{const k=new c(J),K=j(k),g=new z(Q,K),p=new I(Q);this.a.forEach((T,P)=>g.registerChannel(P,T));const q={channelServer:g,channelClient:p,ctx:K};this.f.add(q),this.g.fire(q),this.j.add(V(()=>{g.dispose(),p.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(ne,Q){const V=this;return{call(ee,J,k){let K;if((0,s.$Kf)(Q)){const p=(0,y.$2b)(V.connections.filter(Q));K=p?Promise.resolve(p):h.Event.toPromise(h.Event.filter(V.onDidAddConnection,Q))}else K=Q.routeCall(V,ee,J);const g=K.then(p=>p.channelClient.getChannel(ne));return te(g).call(ee,J,k)},listen(ee,J){if((0,s.$Kf)(Q))return V.k(ne,Q,ee,J);const k=Q.routeEvent(V,ee,J).then(K=>K.channelClient.getChannel(ne));return te(k).listen(ee,J)}}}k(ne,Q,V,ee){const J=this;let k;const K=new h.$Ld({onWillAddFirstListener:()=>{k=new f.$Pc;const g=new h.$Rd,p=new Map,q=P=>{const _=P.channelClient.getChannel(ne).listen(V,ee),S=g.add(_);p.set(P,S)},T=P=>{const O=p.get(P);O&&(O.dispose(),p.delete(P))};J.connections.filter(Q).forEach(q),h.Event.filter(J.onDidAddConnection,Q)(q,void 0,k),J.onDidRemoveConnection(T,void 0,k),g.event(K.fire,K,k),k.add(g)},onDidRemoveLastListener:()=>{k?.dispose(),k=void 0}});return K.event}registerChannel(ne,Q){this.a.set(ne,Q);for(const V of this.f)V.channelServer.registerChannel(ne,Q)}dispose(){this.j.dispose();for(const ne of this.f)ne.channelClient.dispose(),ne.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$qh=F;class X{constructor(ne,Q,V=null){const ee=new o;v(ee,Q),ne.send(ee.buffer),this.a=new I(ne,V),this.d=new z(ne,Q,V)}getChannel(ne){return this.a.getChannel(ne)}registerChannel(ne,Q){this.d.registerChannel(ne,Q)}dispose(){this.a.dispose(),this.d.dispose()}}t.$rh=X;function te(de){return{call(ne,Q,V){return de.then(ee=>ee.call(ne,Q,V))},listen(ne,Q){const V=new h.$Ud;return de.then(ee=>V.input=ee.listen(ne,Q)),V.event}}}t.$sh=te;function re(de){let ne=!1;return{call(Q,V,ee){return ne?de.call(Q,V,ee):(0,N.$Sg)(0).then(()=>ne=!0).then(()=>de.call(Q,V,ee))},listen(Q,V){if(ne)return de.listen(Q,V);const ee=new h.$Ud;return(0,N.$Sg)(0).then(()=>ne=!0).then(()=>ee.input=de.listen(Q,V)),ee.event}}}t.$th=re;class ce{constructor(ne){this.a=ne}routeCall(ne){return this.b(ne)}routeEvent(ne){return this.b(ne)}async b(ne){for(const Q of ne.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await h.Event.toPromise(ne.onDidAddConnection),await this.b(ne)}}t.$uh=ce;var le;(function(de){function ne(J,k,K){const g=J,p=K&&K.disableMarshalling,q=new Map;for(const T in g)V(T)&&q.set(T,h.Event.buffer(g[T],!0,void 0,k));return new class{listen(T,P,O){const _=q.get(P);if(_)return _;if(ee(P)){const S=g[P];if(typeof S=="function")return S.call(g,O)}throw new D.$_(`Event not found: ${P}`)}call(T,P,O){const _=g[P];if(typeof _=="function"){if(!p&&Array.isArray(O))for(let B=0;B<O.length;B++)O[B]=(0,d.$jh)(O[B]);let S=_.apply(g,O);return S instanceof Promise||(S=Promise.resolve(S)),S}throw new D.$_(`Method not found: ${P}`)}}}de.fromService=ne;function Q(J,k){const K=k&&k.disableMarshalling;return new Proxy({},{get(g,p){if(typeof p=="string")return k?.properties?.has(p)?k.properties.get(p):ee(p)?function(q){return J.listen(p,q)}:V(p)?J.listen(p):async function(...q){let T;k&&!(0,s.$Ff)(k.context)?T=[k.context,...q]:T=q;const P=await J.call(p,T);return K?P:(0,d.$jh)(P)};throw new D.$_(`Property not found: ${String(p)}`)}})}de.toService=Q;function V(J){return J[0]==="o"&&J[1]==="n"&&L.$Ye(J.charCodeAt(2))}function ee(J){return/^onDynamic/.test(J)&&L.$Ye(J.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ne=de.toString();if(ne!=="[object Object]")return ne}return de}function ke(de){return Array.isArray(de)?de.map(me):me(de)}function Le(de,ne,Q,V,ee,J,k){k=ke(k);const K=ae[ee],g=K[V%K.length];let p=[`%c[${de}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(J)?(p=p.concat(k),p.push(")")):p.push(k),console.log.apply(console,p)}class Pe{constructor(ne,Q){this.d=ne,this.f=Q,this.a=0,this.b=0}logOutgoing(ne,Q,V,ee,J){this.b+=ne,Le(this.d,this.b,ne,Q,V,ee,J)}logIncoming(ne,Q,V,ee,J){this.a+=ne,Le(this.f,this.a,ne,Q,V,ee,J)}}t.$vh=Pe}),define(be[29],$e([1,0,5]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q=t.$P=t.$O=t.$N=t.$M=void 0,t.$M=y.$g.vscode.ipcRenderer,t.$N=y.$g.vscode.ipcMessagePort,t.$O=y.$g.vscode.webFrame,t.$P=y.$g.vscode.process,t.$Q=y.$g.vscode.context}),define(be[131],$e([1,0,87,29]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9S=void 0;let i=0;function U(D,h,f){const d=[],L=i++,s=`vscode:onContextMenu${L}`,a=(e,u,l)=>{d[u].click?.(l)};N.$M.once(s,a),N.$M.once(y.$6S,(e,u)=>{u===L&&(N.$M.removeListener(s,a),f?.())}),N.$M.send(y.$5S,L,D.map(e=>w(e,d)),s,h)}t.$9S=U;function w(D,h){const f={id:h.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return h.push(D),Array.isArray(D.submenu)&&(f.submenu=D.submenu.map(d=>w(d,h))),f}}),define(be[132],$e([1,0,32,3,65,88,29]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eT=void 0;class D extends i.$rh{static f(){const f=N.Event.fromNodeEventEmitter(w.$M,"vscode:message",(d,L)=>y.$_d.wrap(L));return w.$M.send("vscode:hello"),new U.$aT(w.$M,f)}constructor(f){const d=D.f();super(d,f),this.b=d}dispose(){this.b.disconnect()}}t.$eT=D}),define(be[133],$e([13,10]),function(oe,t){return oe.create("vs/platform/files/common/files",t)}),define(be[134],$e([13,10]),function(oe,t){return oe.create("vs/platform/theme/common/iconRegistry",t)}),define(be[39],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nh=t.$Mh=t.$Lh=t._util=void 0;var y;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function D(h){return h[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=D})(y||(t._util=y={})),t.$Lh=i("instantiationService");function N(w,D,h){D[y.DI_TARGET]===D?D[y.DI_DEPENDENCIES].push({id:w,index:h}):(D[y.DI_DEPENDENCIES]=[{id:w,index:h}],D[y.DI_TARGET]=D)}function i(w){if(y.serviceIds.has(w))return y.serviceIds.get(w);const D=function(h,f,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(D,h,d)};return D.toString=()=>w,y.serviceIds.set(w,D),D}t.$Mh=i;function U(w){return w}t.$Nh=U}),define(be[135],$e([1,0,39]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$km=t.$jm=t.$im=t.ID=void 0,t.ID="diagnosticsService",t.$im=(0,y.$Mh)(t.ID);function N(U){return!!U.hostName&&!!U.errorMessage}t.$jm=N;class i{async getPerformanceInfo(w,D){return{}}async getSystemInfo(w,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,D){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.$km=i}),define(be[136],$e([1,0,86,22,12,7,15,133,39,5,28]),function(oe,t,y,N,i,U,w,D,h,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.FileKind=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.FileOperationResult=t.$rk=t.$qk=t.$pk=t.$ok=t.$nk=t.FileChangeType=t.$mk=t.FileOperation=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.FileSystemProviderErrorCode=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=t.$$j=t.$0j=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$9j=t.$8j=void 0,t.$8j=(0,h.$Mh)("fileService");function L(Q){return Q.create===!0}t.$9j=L;var s;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.File=1]="File",Q[Q.Directory=2]="Directory",Q[Q.SymbolicLink=64]="SymbolicLink"})(s||(t.FileType=s={}));var a;(function(Q){Q[Q.Readonly=1]="Readonly",Q[Q.Locked=2]="Locked"})(a||(t.FilePermission=a={}));var e;(function(Q){Q[Q.None=0]="None",Q[Q.FileReadWrite=2]="FileReadWrite",Q[Q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Q[Q.FileReadStream=16]="FileReadStream",Q[Q.FileFolderCopy=8]="FileFolderCopy",Q[Q.PathCaseSensitive=1024]="PathCaseSensitive",Q[Q.Readonly=2048]="Readonly",Q[Q.Trash=4096]="Trash",Q[Q.FileWriteUnlock=8192]="FileWriteUnlock",Q[Q.FileAtomicRead=16384]="FileAtomicRead",Q[Q.FileAtomicWrite=32768]="FileAtomicWrite",Q[Q.FileAtomicDelete=65536]="FileAtomicDelete",Q[Q.FileClone=131072]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function u(Q){return!!(Q.capabilities&2)}t.$0j=u;function l(Q){return!!(Q.capabilities&8)}t.$$j=l;function m(Q){return!!(Q.capabilities&131072)}t.$_j=m;function n(Q){return!!(Q.capabilities&4)}t.$ak=n;function r(Q){return!!(Q.capabilities&16)}t.$bk=r;function $(Q){return u(Q)?!!(Q.capabilities&16384):!1}t.$ck=$;function c(Q){return u(Q)?!!(Q.capabilities&32768):!1}t.$dk=c;function o(Q){return!!(Q.capabilities&65536)}t.$ek=o;function C(Q){return!!(Q.capabilities&2048)}t.$fk=C;var R;(function(Q){Q.FileExists="EntryExists",Q.FileNotFound="EntryNotFound",Q.FileNotADirectory="EntryNotADirectory",Q.FileIsADirectory="EntryIsADirectory",Q.FileExceedsStorageQuota="EntryExceedsStorageQuota",Q.FileTooLarge="EntryTooLarge",Q.FileWriteLocked="EntryWriteLocked",Q.NoPermissions="NoPermissions",Q.Unavailable="Unavailable",Q.Unknown="Unknown"})(R||(t.FileSystemProviderErrorCode=R={}));class M extends Error{static create(V,ee){const J=new M(V.toString(),ee);return j(J,ee),J}constructor(V,ee){super(V),this.code=ee}}t.$gk=M;function b(Q,V){return M.create(Q,V)}t.$hk=b;function v(Q){return Q||b((0,D.localize)(0,null),R.Unknown)}t.$ik=v;function j(Q,V){return Q.name=V?`${V} (FileSystemError)`:"FileSystemError",Q}t.$jk=j;function z(Q){if(!Q)return R.Unknown;if(Q instanceof M)return Q.code;const V=/^(.+) \(FileSystemError\)$/.exec(Q.name);if(!V)return R.Unknown;switch(V[1]){case R.FileExists:return R.FileExists;case R.FileIsADirectory:return R.FileIsADirectory;case R.FileNotADirectory:return R.FileNotADirectory;case R.FileNotFound:return R.FileNotFound;case R.FileTooLarge:return R.FileTooLarge;case R.FileWriteLocked:return R.FileWriteLocked;case R.NoPermissions:return R.NoPermissions;case R.Unavailable:return R.Unavailable}return R.Unknown}t.$kk=z;function W(Q){if(Q instanceof ce)return Q.fileOperationResult;switch(z(Q)){case R.FileNotFound:return 1;case R.FileIsADirectory:return 0;case R.FileNotADirectory:return 9;case R.FileWriteLocked:return 5;case R.NoPermissions:return 6;case R.FileExists:return 4;case R.FileTooLarge:return 7;default:return 10}}t.$lk=W;var I;(function(Q){Q[Q.CREATE=0]="CREATE",Q[Q.DELETE=1]="DELETE",Q[Q.MOVE=2]="MOVE",Q[Q.COPY=3]="COPY",Q[Q.WRITE=4]="WRITE"})(I||(t.FileOperation=I={}));class F{constructor(V,ee,J){this.resource=V,this.operation=ee,this.target=J}isOperation(V){return this.operation===V}}t.$mk=F;var X;(function(Q){Q[Q.UPDATED=0]="UPDATED",Q[Q.ADDED=1]="ADDED",Q[Q.DELETED=2]="DELETED"})(X||(t.FileChangeType=X={}));class te{constructor(V,ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const J=new Map;for(const k of V){const K=J.get(k.type);switch(K?K.push([k.resource,k]):J.set(k.type,[[k.resource,k]]),k.type){case 1:this.rawAdded.push(k.resource);break;case 0:this.rawUpdated.push(k.resource);break;case 2:this.rawDeleted.push(k.resource);break}}for(const[k,K]of J)switch(k){case 1:this.a=y.$Sh.forUris(()=>ee),this.a.fill(K);break;case 0:this.b=y.$Sh.forUris(()=>ee),this.b.fill(K);break;case 2:this.c=y.$Sh.forUris(()=>ee),this.c.fill(K);break}}contains(V,...ee){return this.d(V,{includeChildren:!1},...ee)}affects(V,...ee){return this.d(V,{includeChildren:!0},...ee)}d(V,ee,...J){if(!V)return!1;const k=J.length>0;return!!((!k||J.includes(1))&&(this.a?.get(V)||ee.includeChildren&&this.a?.findSuperstr(V))||(!k||J.includes(0))&&(this.b?.get(V)||ee.includeChildren&&this.b?.findSuperstr(V))||(!k||J.includes(2))&&(this.c?.findSubstr(V)||ee.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.$nk=te;function re(Q,V,ee){return!Q||!V||Q===V||V.length>Q.length?!1:(V.charAt(V.length-1)!==N.sep&&(V+=N.sep),ee?(0,i.$1e)(Q,V):Q.indexOf(V)===0)}t.$ok=re;class ce extends Error{constructor(V,ee,J){super(V),this.fileOperationResult=ee,this.options=J}}t.$pk=ce;class le extends ce{constructor(V,ee,J,k){super(V,ee,k),this.fileOperationResult=ee,this.size=J}}t.$qk=le;class ae extends ce{constructor(V,ee,J){super(V,2,J),this.stat=ee}}t.$rk=ae;var me;(function(Q){Q[Q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Q[Q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Q[Q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Q[Q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Q[Q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Q[Q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Q[Q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Q[Q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Q[Q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Q[Q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Q[Q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(me||(t.FileOperationResult=me={})),t.$sk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$tk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$uk="files.associations",t.$vk="files.exclude",t.$wk="files.readonlyInclude",t.$xk="files.readonlyExclude",t.$yk="files.readonlyFromPermissions";var ke;(function(Q){Q[Q.FILE=0]="FILE",Q[Q.FOLDER=1]="FOLDER",Q[Q.ROOT_FOLDER=2]="ROOT_FOLDER"})(ke||(t.FileKind=ke={})),t.$zk="";function Le(Q){if(!(typeof Q.size!="number"||typeof Q.mtime!="number"))return Q.mtime.toString(29)+Q.size.toString(31)}t.$Ak=Le;async function Pe(Q,V){if(!V.hasProvider(w.URI.from({scheme:Q.scheme})))return new Promise(ee=>{const J=V.onDidChangeFileSystemProviderRegistrations(k=>{k.scheme===Q.scheme&&k.added&&(J.dispose(),ee())})})}t.$Bk=Pe;class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(V){return(0,U.$Af)(V)||(V=0),V<de.KB?(0,D.localize)(1,null,V.toFixed(0)):V<de.MB?(0,D.localize)(2,null,(V/de.KB).toFixed(2)):V<de.GB?(0,D.localize)(3,null,(V/de.MB).toFixed(2)):V<de.TB?(0,D.localize)(4,null,(V/de.GB).toFixed(2)):(0,D.localize)(5,null,(V/de.TB).toFixed(2))}}t.$Ck=de;function ne(Q){const V=typeof Q=="string"||Q?.scheme===d.Schemas.vscodeRemote;return typeof Q!="string"&&Q?.scheme===d.Schemas.file?1024*de.MB:V?10*de.MB:f.$o?50*de.MB:1024*de.MB}t.$Dk=ne}),define(be[137],$e([1,0,39]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T7b=t.$S7b=void 0,t.$S7b=(0,y.$Mh)("mainProcessService");class N{constructor(U,w){this.a=U,this.b=w}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,w){this.a.registerChannel(U,w)}}t.$T7b=N}),define(be[138],$e([1,0,2,132]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U7b=void 0;class i extends y.$Qc{constructor(w){super(),this.a=this.B(new N.$eT(`window:${w}`))}getChannel(w){return this.a.getChannel(w)}registerChannel(w,D){this.a.registerChannel(w,D)}}t.$U7b=i});var pi=this&&this.__param||function(oe,t){return function(y,N){t(y,N,oe)}};define(be[139],$e([1,0,65,137]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V7b=void 0;let i=class{constructor(w,D){return this.windowId=w,y.ProxyChannel.toService(D.getChannel("nativeHost"),{context:w,properties:(()=>{const h=new Map;return h.set("windowId",w),h})()})}};t.$V7b=i,t.$V7b=i=Qe([pi(1,N.$S7b)],i)}),define(be[66],$e([1,0,74,7]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0m=void 0;class i{constructor(){this.a=new Map}add(w,D){y.ok(N.$wf(w)),y.ok(N.$yf(D)),y.ok(!this.a.has(w),"There is already an extension with this id"),this.a.set(w,D)}knows(w){return this.a.has(w)}as(w){return this.a.get(w)||null}}t.$0m=new i}),define(be[140],$e([1,0,3,66]),function(oe,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$m=void 0,t.$$m={JSONContribution:"base.contributions.json"};function i(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class U{constructor(){this.b=new y.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,f){this.a[i(h)]=f,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const w=new U;N.$0m.add(t.$$m.JSONContribution,w)}),define(be[141],$e([1,0,9,17,18,3,7,15,134,140,66]),function(oe,t,y,N,i,U,w,D,h,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5v=t.$4v=t.$3v=t.$2v=t.$1v=t.$Zv=t.$Yv=t.$Xv=t.IconFontDefinition=t.IconContribution=t.$Wv=void 0,t.$Wv={IconContribution:"base.contributions.icons"};var L;(function($){function c(o,C){let R=o.defaults;for(;i.ThemeIcon.isThemeIcon(R);){const M=e.getIcon(R.id);if(!M)return;R=M.defaults}return R}$.getDefinition=c})(L||(t.IconContribution=L={}));var s;(function($){function c(C){return{weight:C.weight,style:C.style,src:C.src.map(R=>({format:R.format,location:R.location.toString()}))}}$.toJSONObject=c;function o(C){const R=M=>(0,w.$wf)(M)?M:void 0;if(C&&Array.isArray(C.src)&&C.src.every(M=>(0,w.$wf)(M.format)&&(0,w.$wf)(M.location)))return{weight:R(C.weight),style:R(C.style),src:C.src.map(M=>({format:M.format,location:D.URI.parse(M.location)}))}}$.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new U.$Ld,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,o,C,R){const M=this.b[c];if(M){if(C&&!M.description){M.description=C,this.d.properties[c].markdownDescription=`${C} $(${c})`;const j=this.e.enum.indexOf(c);j!==-1&&(this.e.enumDescriptions[j]=C),this.a.fire()}return M}const b={id:c,description:C,defaults:o,deprecationMessage:R};this.b[c]=b;const v={$ref:"#/definitions/icons"};return R&&(v.deprecationMessage=R),C&&(v.markdownDescription=`${C}: $(${c})`),this.d.properties[c]=v,this.e.enum.push(c),this.e.enumDescriptions.push(C||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const o=this.e.enum.indexOf(c);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,o){const C=this.f[c];return C||(this.f[c]=o,this.a.fire(),o)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(M,b)=>M.id.localeCompare(b.id),o=M=>{for(;i.ThemeIcon.isThemeIcon(M.defaults);)M=this.b[M.defaults.id];return`codicon codicon-${M?M.id:""}`},C=[];C.push("| preview     | identifier                        | default codicon ID                | description"),C.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const R=Object.keys(this.b).map(M=>this.b[M]);for(const M of R.filter(b=>!!b.description).sort(c))C.push(`|<i class="${o(M)}"></i>|${M.id}|${i.ThemeIcon.isThemeIcon(M.defaults)?M.defaults.id:M.id}|${M.description||""}|`);C.push("| preview     | identifier                        "),C.push("| ----------- | --------------------------------- |");for(const M of R.filter(b=>!i.ThemeIcon.isThemeIcon(b.defaults)).sort(c))C.push(`|<i class="${o(M)}"></i>|${M.id}|`);return C.join(`
`)}}const e=new a;d.$0m.add(t.$Wv.IconContribution,e);function u($,c,o,C){return e.registerIcon($,c,o,C)}t.$Xv=u;function l(){return e}t.$Yv=l;function m(){const $=(0,N.$Pj)();for(const c in $){const o="\\"+$[c].toString(16);e.registerIcon(c,{fontCharacter:o})}}m(),t.$Zv="vscode://schemas/icons";const n=d.$0m.as(f.$$m.JSONContribution);n.registerSchema(t.$Zv,e.getIconSchema());const r=new y.$4g(()=>n.notifySchemaChanged(t.$Zv),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$1v=u("widget-close",N.$Rj.close,(0,h.localize)(2,null)),t.$2v=u("goto-previous-location",N.$Rj.arrowUp,(0,h.localize)(3,null)),t.$3v=u("goto-next-location",N.$Rj.arrowDown,(0,h.localize)(4,null)),t.$4v=i.ThemeIcon.modify(N.$Rj.sync,"spin"),t.$5v=i.ThemeIcon.modify(N.$Rj.loading,"spin")}),define(be[142],$e([1,0,4,3,2,18,141]),function(oe,t,y,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cCb=t.$bCb=void 0;function D(f){const d=new i.$Pc,L=d.add(new N.$Ld),s=(0,w.$Yv)();return d.add(s.onDidChange(()=>L.fire())),f&&d.add(f.onDidProductIconThemeChange(()=>L.fire())),{dispose:()=>d.dispose(),onDidChange:L.event,getCSS(){const a=f?f.getProductIconTheme():new h,e={},u=m=>{const n=a.getIcon(m);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${m.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,y.$yP)(r.id)}; }`):`.codicon-${m.id}:before { content: '${n.fontCharacter}'; }`},l=[];for(const m of s.getIcons()){const n=u(m);n&&l.push(n)}for(const m in e){const n=e[m],r=n.weight?`font-weight: ${n.weight};`:"",$=n.style?`font-style: ${n.style};`:"",c=n.src.map(o=>`${(0,y.$xP)(o.location)} format('${o.format}')`).join(", ");l.push(`@font-face { src: ${c}; font-family: ${(0,y.$yP)(m)};${r}${$} font-display: block; }`)}return l.join(`
`)}}}t.$bCb=D;class h{getIcon(d){const L=(0,w.$Yv)();let s=d.defaults;for(;U.ThemeIcon.isThemeIcon(s);){const a=L.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$cCb=h}),define(be[143],$e([1,0,5]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1C=t.$ZC=t.$YC=t.$XC=t.$WC=t.$VC=t.$UC=t.$TC=void 0,t.$TC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(d){return!!d.workspaceUri}t.$UC=N;function i(d){return!!d.folderUri}t.$VC=i;function U(d){return!!d.fileUri}t.$WC=U;function w(d){const L=D(d),s=d.getValue("window.menuBarVisibility");return s==="default"||L==="native"&&s==="compact"||y.$j&&y.$m?"classic":s}t.$XC=w;function D(d){if(y.$o)return"custom";const L=d.getValue("window");if(L){if(y.$j&&L.nativeTabs===!0||y.$j&&L.nativeFullScreen===!1)return"native";const e=L.titleBarStyle;if(e==="native"||e==="custom")return e}return y.$k?"native":"custom"}t.$YC=D;function h(d){return!(!y.$i||y.$o||D(d)==="native")}t.$ZC=h;function f(d=0){return Math.pow(1.2,d)}t.$1C=f}),define(be[144],$e([1,0,16,29,143]),function(oe,t,y,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Z7b=t.$Y7b=t.$X7b=void 0;function U(h){N.$O.setZoomLevel(h),(0,y.$8N)((0,i.$1C)(h)),(0,y.$5N)(h)}t.$X7b=U;function w(){U((0,y.$6N)()+1)}t.$Y7b=w;function D(){U((0,y.$6N)()-1)}t.$Z7b=D}),define(be[145],$e([1,0,10,4,130,9,131,29,135,136,138,139,142,144,14,101,92]),function(oe,t,y,N,i,U,w,D,h,f,d,L,s,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const u=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class m{getHeight(W){return 22}getTemplateId(W){return M(W)?"process":C(W)?"machine":(0,h.$jm)(W)?"error":R(W)?"header":""}}class n{hasChildren(W){return(0,h.$jm)(W)?!1:M(W)?!!W.children?.length:!0}getChildren(W){return M(W)?W.children?W.children:[]:(0,h.$jm)(W)?[]:R(W)?W.processRoots.length>1?W.processRoots:[W.processRoots[0].rootProcess]:C(W)?[W.rootProcess]:[W.processes]}}class r{constructor(){this.templateId="header"}renderTemplate(W){const I=(0,N.$hP)(W,(0,N.$)(".row")),F=(0,N.$hP)(I,(0,N.$)(".nameLabel")),X=(0,N.$hP)(I,(0,N.$)(".cpu")),te=(0,N.$hP)(I,(0,N.$)(".memory")),re=(0,N.$hP)(I,(0,N.$)(".pid"));return{name:F,CPU:X,memory:te,PID:re}}renderElement(W,I,F,X){F.name.textContent=(0,y.localize)(0,null),F.CPU.textContent=(0,y.localize)(1,null),F.PID.textContent=(0,y.localize)(2,null),F.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(W){}}class ${constructor(){this.templateId="machine"}renderTemplate(W){const I=Object.create(null),F=(0,N.$hP)(W,(0,N.$)(".row"));return I.name=(0,N.$hP)(F,(0,N.$)(".nameLabel")),I}renderElement(W,I,F,X){F.name.textContent=W.element.name}disposeTemplate(W){}}class c{constructor(){this.templateId="error"}renderTemplate(W){const I=Object.create(null),F=(0,N.$hP)(W,(0,N.$)(".row"));return I.name=(0,N.$hP)(F,(0,N.$)(".nameLabel")),I}renderElement(W,I,F,X){F.name.textContent=W.element.errorMessage}disposeTemplate(W){}}class o{constructor(W,I,F){this.a=W,this.b=I,this.c=F,this.templateId="process"}renderTemplate(W){const I=(0,N.$hP)(W,(0,N.$)(".row")),F=(0,N.$hP)(I,(0,N.$)(".nameLabel")),X=(0,N.$hP)(I,(0,N.$)(".cpu")),te=(0,N.$hP)(I,(0,N.$)(".memory")),re=(0,N.$hP)(I,(0,N.$)(".pid"));return{name:F,CPU:X,PID:re,memory:te}}renderElement(W,I,F,X){const{element:te}=W,re=te.pid.toFixed(0);let ce=te.name;this.c.has(te.pid)&&(ce=this.c.get(te.pid)),F.name.textContent=ce,F.name.title=te.cmd,F.CPU.textContent=te.load.toFixed(0),F.PID.textContent=re,F.PID.parentElement.id=`pid-${re}`;const le=this.a==="win32"?te.mem:this.b*(te.mem/100);F.memory.textContent=(le/f.$Ck.MB).toFixed(0)}disposeTemplate(W){}}function C(z){return!!z.name&&!!z.rootProcess}function R(z){return!!z.processRoots}function M(z){return!!z.pid}class b{constructor(W,I){this.f=I,this.b=new Map;const F=new d.$U7b(W);this.c=new L.$V7b(W,F),this.k(I.styles),this.g(I),D.$M.on("vscode:pidToNameResponse",(X,te)=>{this.b=new Map;for(const[re,ce]of te)this.b.set(re,ce)}),D.$M.on("vscode:listProcessesResponse",async(X,te)=>{te.forEach((re,ce)=>{M(re.rootProcess)&&(re.rootProcess.name=ce===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:te}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(te),this.m(0)}),this.a=Date.now(),D.$M.send("vscode:pidToNameRequest"),D.$M.send("vscode:listProcesses")}g(W){document.onkeydown=I=>{const F=W.platform==="darwin"?I.metaKey:I.ctrlKey;F&&I.keyCode===87&&(I.stopPropagation(),I.preventDefault(),D.$M.send("vscode:closeProcessExplorer")),F&&I.keyCode===187&&(0,a.$Y7b)(),F&&I.keyCode===189&&(0,a.$Z7b)()}}async h(W){const I=document.getElementById("process-list");if(!I)return;const{totalmem:F}=await this.c.getOSStatistics(),X=[new o(this.f.platform,F,this.b),new r,new $,new c];this.d=new i.$CS("processExplorer",I,new m,X,new n,{identityProvider:{getId:te=>M(te)?te.pid.toString():(0,h.$jm)(te)?te.hostName:R(te)?"processes":C(te)?te.name:"header"}}),this.d.setInput({processes:{processRoots:W}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(te=>{const re=new e.$qO(te);if(re.keyCode===35&&re.altKey){const ce=this.n();Promise.all(ce.map(le=>this.c.killProcess(le,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(te=>{M(te.element)&&this.l(te.element,!0)}),I.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{I.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(W){const I=u.exec(W);return I&&I.groups.port!=="0"||W.indexOf("node ")>=0||W.indexOf("node.exe")>=0}j(W){const I={type:"node",request:"attach",name:`process ${W.pid}`};let F=u.exec(W.cmd);F?I.port=Number(F.groups.port):I.processId=String(W.pid),F=l.exec(W.cmd),F&&(I.port=Number(F.groups.port)),D.$M.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[I]})}k(W){const I=(0,N.$5O)(),F=[];W.listFocusBackground&&(F.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${W.listFocusBackground}; }`),F.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${W.listFocusBackground}; }`)),W.listFocusForeground&&F.push(`.monaco-list:focus .monaco-list-row.focused { color: ${W.listFocusForeground}; }`),W.listActiveSelectionBackground&&(F.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${W.listActiveSelectionBackground}; }`),F.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${W.listActiveSelectionBackground}; }`)),W.listActiveSelectionForeground&&F.push(`.monaco-list:focus .monaco-list-row.selected { color: ${W.listActiveSelectionForeground}; }`),W.listHoverBackground&&F.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${W.listHoverBackground}; }`),W.listHoverForeground&&F.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${W.listHoverForeground}; }`),W.listFocusOutline&&F.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${W.listFocusOutline}; outline-offset: -1px; }`),W.listHoverOutline&&F.push(`.monaco-list-row:hover { outline: 1px dashed ${W.listHoverOutline}; outline-offset: -1px; }`),W.scrollbarShadowColor&&F.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${W.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${W.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${W.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),W.scrollbarSliderBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${W.scrollbarSliderBackgroundColor};
				}
			`),W.scrollbarSliderHoverBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${W.scrollbarSliderHoverBackgroundColor};
				}
			`),W.scrollbarSliderActiveBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${W.scrollbarSliderActiveBackgroundColor};
				}
			`),I.textContent=F.join(`
`),W.color&&(document.body.style.color=W.color)}l(W,I){const F=[],X=Number(W.pid);I&&(F.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),F.push({label:(0,y.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),F.push({type:"separator"})),F.push({label:(0,y.localize)(6,null),click:()=>{const te=this.n();te?.includes(X)||(te.length=0,te.push(X));const re=te?.map(ce=>document.getElementById(`pid-${ce}`)).filter(ce=>!!ce);if(re){const ce=re.map(le=>le.innerText).filter(le=>!!le);this.c.writeClipboardText(ce.join(`
`))}}}),F.push({label:(0,y.localize)(7,null),click:()=>{const te=document.getElementById("process-list");te&&this.c.writeClipboardText(te.innerText)}}),W&&I&&this.i(W.cmd)&&(F.push({type:"separator"}),F.push({label:(0,y.localize)(8,null),click:()=>{this.j(W)}})),(0,w.$9S)(F)}m(W){setTimeout(()=>{const I=Date.now(),F=W+I-this.a;this.a=I,F>1e3?(D.$M.send("vscode:pidToNameRequest"),D.$M.send("vscode:listProcesses")):this.m(F)},200)}n(){return this.d?.getSelection()?.map(W=>{if(!(!W||!("pid"in W)))return W.pid}).filter(W=>!!W)}}function v(){const z=(0,N.$5O)();z.id="codiconStyles";const W=(0,s.$bCb)(void 0);function I(){z.textContent=W.getCSS()}const F=new U.$4g(I,0);W.onDidChange(()=>F.schedule()),F.schedule()}function j(z){const W=z.data.platform==="win32"?"windows":z.data.platform==="linux"?"linux":"mac";document.body.classList.add(W),v(),(0,a.$X7b)(z.data.zoomLevel),new b(z.windowId,z.data)}t.startup=j})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4a0e77678c0295b518151ae2d706436bab96ef4f/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
