/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],A=0,N=J.length;A<N;A++)e[A]=ne[J[A]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class A{static get(){const R=new Map,L=new Map,j=new Map,v=new Map;function u(d,S){d.has(S.detail)||d.set(S.detail,-S.timestamp)}function c(d,S){const w=d.get(S.detail);w&&(w>=0||d.set(S.detail,w+S.timestamp))}let b=[];typeof J=="function"&&typeof J.getStats=="function"&&(b=J.getStats().slice(0).sort((d,S)=>d.timestamp-S.timestamp));for(const d of b)switch(d.type){case 10:u(R,d);break;case 11:case 12:c(R,d);break;case 21:u(L,d);break;case 22:c(L,d);break;case 33:u(j,d);break;case 34:c(j,d);break;case 31:u(v,d);break;case 32:c(v,d);break}let O=0;j.forEach(d=>O+=d);function g(d){const S=[];return d.forEach((w,$)=>S.push([$,w])),S}return{amdLoad:g(R),amdInvoke:g(L),nodeRequire:g(j),nodeEval:g(v),nodeRequireTotal:O}}static toMarkdownTable(R,L){let j="";const v=[];return R.forEach((u,c)=>{v[c]=u.length}),L.forEach(u=>{u.forEach((c,b)=>{typeof c>"u"&&(c=u[b]="-");const O=c.toString().length;v[b]=Math.max(O,v[b])})}),R.forEach((u,c)=>{j+=`| ${u+" ".repeat(v[c]-u.toString().length)} `}),j+=`|
`,R.forEach((u,c)=>{j+=`| ${"-".repeat(v[c])} `}),j+=`|
`,L.forEach(u=>{u.forEach((c,b)=>{typeof c<"u"&&(j+=`| ${c+" ".repeat(v[b]-c.toString().length)} `)}),j+=`|
`}),j}}e.$S=A}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=void 0;function A(j){return(v,u,c)=>{let b=null,O=null;if(typeof c.value=="function"?(b="value",O=c.value):typeof c.get=="function"&&(b="get",O=c.get),!O)throw new Error("not supported");c[b]=j(O,u)}}function N(j,v,u){let c=null,b=null;if(typeof u.value=="function"?(c="value",b=u.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",b=u.get),!b)throw new Error("not supported");const O=`$memoize$${v}`;u[c]=function(...g){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,g)}),this[O]}}e.$eh=N;function R(j,v,u){return A((c,b)=>{const O=`$debounce$${b}`,g=`$debounce$result$${b}`;return function(...d){this[g]||(this[g]=u?u():void 0),clearTimeout(this[O]),v&&(this[g]=v(this[g],...d),d=[this[g]]),this[O]=setTimeout(()=>{c.apply(this,d),this[g]=u?u():void 0},j)}})}e.$fh=R;function L(j,v,u){return A((c,b)=>{const O=`$throttle$timer$${b}`,g=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,S=`$throttle$pending$${b}`;return function(...w){if(this[g]||(this[g]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),v&&(this[g]=v(this[g],...w)),this[S])return;const $=this[d]+j;$<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0):(this[S]=!0,this[O]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0},$-Date.now()))}})}e.$gh=L}),define(ne[71],re([0,1,9]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$4c=e.$3c=e.$2c=e.ok=void 0;function N(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=N;function R(u,c="Unreachable"){throw new Error(c)}e.$2c=R;function L(u){if(!u)throw new A.$ab("Assertion Failed")}e.$3c=L;function j(u){if(!u()){debugger;u(),(0,A.$Y)(new A.$ab("Assertion Failed"))}}e.$4c=j;function v(u,c){let b=0;for(;b<u.length-1;){const O=u[b],g=u[b+1];if(!c(O,g))return!1;b++}return!0}e.$5c=v}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var A;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(A||(e.ScanError=A={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function j(t,a=!1){let i=0;const n=t.length;let s="",r=0,l=16,k=0;function y(te){let ae=0,le=0;for(;ae<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,ae++}return ae<te&&(le=-1),le}function E(te){i=te,s="",r=0,l=16,k=0}function D(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return k=3,t.substring(te,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else k=3;return t.substring(te,ae)}function W(){let te="",ae=i;for(;;){if(i>=n){te+=t.substring(ae,i),k=2;break}const le=t.charCodeAt(i);if(le===34){te+=t.substring(ae,i),i++;break}if(le===92){if(te+=t.substring(ae,i),i++,i>=n){k=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=y(4);q>=0?te+=String.fromCharCode(q):k=4;break}default:k=5}ae=i;continue}if(le>=0&&le<=31)if(u(le)){te+=t.substring(ae,i),k=2;break}else k=6;i++}return te}function x(){if(s="",k=0,r=i,i>=n)return r=n,l=17;let te=t.charCodeAt(i);if(v(te)){do i++,s+=String.fromCharCode(te),te=t.charCodeAt(i);while(v(te));return l=15}if(u(te))return i++,s+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),l=14;switch(te){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,s=W(),l=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!u(t.charCodeAt(i));)i++;return s=t.substring(ae,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const le=n-1;let ie=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,k=1),s=t.substring(ae,i),l=13}return s+=String.fromCharCode(te),i++,l=16}case 45:if(s+=String.fromCharCode(te),i++,i===n||!c(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=D(),l=11;default:for(;i<n&&_(te);)i++,te=t.charCodeAt(i);if(r!==i){switch(s=t.substring(r,i),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(te),i++,l=16}}function _(te){if(v(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=x();while(te>=12&&te<=15);return te}return{setPosition:E,getPosition:()=>i,scan:a?ue:x,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>k}}e.$Lm=j;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function O(t,a){const i=[],n=new Object;let s;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(y,E,D,W){r.value=y,r.offset=E,r.length=D,r.type=W,r.colonOffset=void 0,s=r}try{I(t,{onObjectBegin:(y,E)=>{if(a<=y)throw n;s=void 0,l=a>y,i.push("")},onObjectProperty:(y,E,D)=>{if(a<E||(k(y,E,D,"property"),i[i.length-1]=y,a<=E+D))throw n},onObjectEnd:(y,E)=>{if(a<=y)throw n;s=void 0,i.pop()},onArrayBegin:(y,E)=>{if(a<=y)throw n;s=void 0,i.push(0)},onArrayEnd:(y,E)=>{if(a<=y)throw n;s=void 0,i.pop()},onLiteralValue:(y,E,D)=>{if(a<E||(k(y,E,D,P(y)),a<=E+D))throw n},onSeparator:(y,E,D)=>{if(a<=E)throw n;if(y===":"&&s&&s.type==="property")s.colonOffset=E,l=!1,s=void 0;else if(y===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==n)throw y}return{path:i,previousNode:s,isAtPropertyKey:l,matches:y=>{let E=0;for(let D=0;E<y.length&&D<i.length;D++)if(y[E]===i[D]||y[E]==="*")E++;else if(y[E]!=="**")return!1;return E===y.length}}}e.$Mm=O;function g(t,a=[],i=L.DEFAULT){let n=null,s=[];const r=[];function l(y){Array.isArray(s)?s.push(y):n!==null&&(s[n]=y)}return I(t,{onObjectBegin:()=>{const y={};l(y),r.push(s),s=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{s=r.pop()},onArrayBegin:()=>{const y=[];l(y),r.push(s),s=y,n=null},onArrayEnd:()=>{s=r.pop()},onLiteralValue:l,onError:(y,E,D)=>{a.push({error:y,offset:E,length:D})}},i),s[0]}e.$Nm=g;function d(t,a=[],i=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function r(y){return n.children.push(y),y}I(t,{onObjectBegin:y=>{n=r({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,E,D)=>{n=r({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:E,length:D,parent:n})},onObjectEnd:(y,E)=>{n.length=y+E-n.offset,n=n.parent,s(y+E)},onArrayBegin:(y,E)=>{n=r({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,E)=>{n.length=y+E-n.offset,n=n.parent,s(y+E)},onLiteralValue:(y,E,D)=>{r({type:P(y),offset:E,length:D,parent:n,value:y}),s(E+D)},onSeparator:(y,E,D)=>{n.type==="property"&&(y===":"?n.colonOffset=E:y===","&&s(E))},onError:(y,E,D)=>{a.push({error:y,offset:E,length:D})}},i);const k=n.children[0];return k&&delete k.parent,k}e.$Om=d;function S(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===n){i=r.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.$Pm=S;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.$Qm=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=$(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Rm=$;function h(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.$Sm=h;function f(t,a,i=!1){if(h(t,a,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=a;s++){const r=f(n[s],a,i);if(r)return r}return t}}e.$Tm=f;function I(t,a,i=L.DEFAULT){const n=j(t,!1);function s(Z){return Z?()=>Z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(Z){return Z?K=>Z(K,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(a.onObjectBegin),k=r(a.onObjectProperty),y=s(a.onObjectEnd),E=s(a.onArrayBegin),D=s(a.onArrayEnd),W=r(a.onLiteralValue),x=r(a.onSeparator),_=s(a.onComment),ue=r(a.onError),te=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function le(){for(;;){const Z=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Z){case 12:case 13:te?ie(10):_();break;case 16:ie(1);break;case 15:case 14:break;default:return Z}}}function ie(Z,K=[],U=[]){if(ue(Z),K.length+U.length>0){let z=n.getToken();for(;z!==17;){if(K.indexOf(z)!==-1){le();break}else if(U.indexOf(z)!==-1)break;z=le()}}}function q(Z){const K=n.getTokenValue();return Z?W(K):k(K),le(),!0}function G(){switch(n.getToken()){case 11:{let Z=0;try{Z=JSON.parse(n.getTokenValue()),typeof Z!="number"&&(ie(2),Z=0)}catch{ie(2)}W(Z);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return le(),!0}function T(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(x(":"),le(),X()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function M(){l(),le();let Z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Z||ie(4,[],[]),x(","),le(),n.getToken()===2&&ae)break}else Z&&ie(6,[],[]);T()||ie(4,[],[2,5]),Z=!0}return y(),n.getToken()!==2?ie(7,[2],[]):le(),!0}function B(){E(),le();let Z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Z||ie(4,[],[]),x(","),le(),n.getToken()===4&&ae)break}else Z&&ie(6,[],[]);X()||ie(4,[],[4,5]),Z=!0}return D(),n.getToken()!==4?ie(8,[4],[]):le(),!0}function X(){switch(n.getToken()){case 3:return B();case 1:return M();case 10:return q(!0);default:return G()}}return le(),n.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):X()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Um=I;function p(t,a){const i=j(t),n=[];let s,r=0,l;do switch(l=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:r!==l&&n.push(t.substring(r,l)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),r=i.getPosition();break}while(s!==17);return n.join("")}e.$Vm=p;function P(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Wm=P}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.rot=e.$Jl=void 0;function A(v,u,c){return Math.min(Math.max(v,u),c)}e.$Jl=A;function N(v,u){return(u+v%u)%u}e.rot=N;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Ll=R;class L{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ml=L;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nl=j}),function(){function J(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function j(u){L.push(u,Date.now())}function v(){const u=[];for(let c=0;c<L.length;c+=2)u.push({name:L[c],startTime:L[c+1]});return u}return{mark:j,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const j of performance.getEntriesByType("mark"))L.push({name:j.name,startTime:Math.round(R+j.startTime)});return L}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function A(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=A(N))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var N in A)(typeof exports=="object"?exports:J)[N]=A[N]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function A(N){if(e[N])return e[N].exports;var R=e[N]={i:N,l:!1,exports:{}};return J[N].call(R.exports,R,R.exports,A),R.l=!0,R.exports}return A.m=J,A.c=e,A.d=function(N,R,L){A.o(N,R)||Object.defineProperty(N,R,{enumerable:!0,get:L})},A.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},A.t=function(N,R){if(1&R&&(N=A(N)),8&R||4&R&&typeof N=="object"&&N&&N.__esModule)return N;var L=Object.create(null);if(A.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:N}),2&R&&typeof N!="string")for(var j in N)A.d(L,j,function(v){return N[v]}.bind(null,j));return L},A.n=function(N){var R=N&&N.__esModule?function(){return N.default}:function(){return N};return A.d(R,"a",R),R},A.o=function(N,R){return Object.prototype.hasOwnProperty.call(N,R)},A.p="",A(A.s=0)}([function(J,e,A){(function(N){var R;e=J.exports=U,R=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],u=e.src=[],c=0,b=c++;u[b]="0|[1-9]\\d*";var O=c++;u[O]="[0-9]+";var g=c++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var S=c++;u[S]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var w=c++;u[w]="(?:"+u[b]+"|"+u[g]+")";var $=c++;u[$]="(?:"+u[O]+"|"+u[g]+")";var h=c++;u[h]="(?:-("+u[w]+"(?:\\."+u[w]+")*))";var f=c++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var I=c++;u[I]="[0-9A-Za-z-]+";var p=c++;u[p]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var P=c++,t="v?"+u[d]+u[h]+"?"+u[p]+"?";u[P]="^"+t+"$";var a="[v=\\s]*"+u[S]+u[f]+"?"+u[p]+"?",i=c++;u[i]="^"+a+"$";var n=c++;u[n]="((?:<|>)?=?)";var s=c++;u[s]=u[O]+"|x|X|\\*";var r=c++;u[r]=u[b]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var k=c++;u[k]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var y=c++;u[y]="^"+u[n]+"\\s*"+u[l]+"$";var E=c++;u[E]="^"+u[n]+"\\s*"+u[k]+"$";var D=c++;u[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=c++;u[W]="(?:~>?)";var x=c++;u[x]="(\\s*)"+u[W]+"\\s+",v[x]=new RegExp(u[x],"g");var _=c++;u[_]="^"+u[W]+u[l]+"$";var ue=c++;u[ue]="^"+u[W]+u[k]+"$";var te=c++;u[te]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[te]+"\\s+",v[ae]=new RegExp(u[ae],"g");var le=c++;u[le]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[k]+"$";var q=c++;u[q]="^"+u[n]+"\\s*("+a+")$|^$";var G=c++;u[G]="^"+u[n]+"\\s*("+t+")$|^$";var T=c++;u[T]="(\\s*)"+u[n]+"\\s*("+a+"|"+u[l]+")",v[T]=new RegExp(u[T],"g");var M=c++;u[M]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var B=c++;u[B]="^\\s*("+u[k]+")\\s+-\\s+("+u[k]+")\\s*$";var X=c++;u[X]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)R(Z,u[Z]),v[Z]||(v[Z]=new RegExp(u[Z]));function K(V,Y){if(V instanceof U)return V;if(typeof V!="string"||V.length>L||!(Y?v[i]:v[P]).test(V))return null;try{return new U(V,Y)}catch{return null}}function U(V,Y){if(V instanceof U){if(V.loose===Y)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(V,Y);R("SemVer",V,Y),this.loose=Y;var ee=V.trim().match(Y?v[i]:v[P]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<j)return ye}return $e}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=K,e.valid=function(V,Y){var ee=K(V,Y);return ee?ee.version:null},e.clean=function(V,Y){var ee=K(V.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof U||(V=new U(V,this.loose)),this.compareMain(V)||this.comparePre(V)},U.prototype.compareMain=function(V){return V instanceof U||(V=new U(V,this.loose)),o(this.major,V.major)||o(this.minor,V.minor)||o(this.patch,V.patch)},U.prototype.comparePre=function(V){if(V instanceof U||(V=new U(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],$e=V.prerelease[Y];if(R("prerelease compare",Y,ee,$e),ee===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ee===void 0)return-1;if(ee!==$e)return o(ee,$e)}while(++Y)},U.prototype.inc=function(V,Y){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Y,ee,$e){typeof ee=="string"&&($e=ee,ee=void 0);try{return new U(V,ee).inc(Y,$e).version}catch{return null}},e.diff=function(V,Y){if(Q(V,Y))return null;var ee=K(V),$e=K(Y);if(ee.prerelease.length||$e.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return ye},e.compareIdentifiers=o;var z=/^[0-9]+$/;function o(V,Y){var ee=z.test(V),$e=z.test(Y);return ee&&$e&&(V=+V,Y=+Y),ee&&!$e?-1:$e&&!ee?1:V<Y?-1:V>Y?1:0}function m(V,Y,ee){return new U(V,ee).compare(new U(Y,ee))}function F(V,Y,ee){return m(V,Y,ee)>0}function C(V,Y,ee){return m(V,Y,ee)<0}function Q(V,Y,ee){return m(V,Y,ee)===0}function H(V,Y,ee){return m(V,Y,ee)!==0}function ce(V,Y,ee){return m(V,Y,ee)>=0}function oe(V,Y,ee){return m(V,Y,ee)<=0}function ge(V,Y,ee,$e){var ye;switch(Y){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=Q(V,ee,$e);break;case"!=":ye=H(V,ee,$e);break;case">":ye=F(V,ee,$e);break;case">=":ye=ce(V,ee,$e);break;case"<":ye=C(V,ee,$e);break;case"<=":ye=oe(V,ee,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(V,Y){if(V instanceof de){if(V.loose===Y)return V;V=V.value}if(!(this instanceof de))return new de(V,Y);R("comparator",V,Y),this.loose=Y,this.parse(V),this.semver===me?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Y){return o(Y,V)},e.major=function(V,Y){return new U(V,Y).major},e.minor=function(V,Y){return new U(V,Y).minor},e.patch=function(V,Y){return new U(V,Y).patch},e.compare=m,e.compareLoose=function(V,Y){return m(V,Y,!0)},e.rcompare=function(V,Y,ee){return m(Y,V,ee)},e.sort=function(V,Y){return V.sort(function(ee,$e){return e.compare(ee,$e,Y)})},e.rsort=function(V,Y){return V.sort(function(ee,$e){return e.rcompare(ee,$e,Y)})},e.gt=F,e.lt=C,e.eq=Q,e.neq=H,e.gte=ce,e.lte=oe,e.cmp=ge,e.Comparator=de;var me={};function fe(V,Y){if(V instanceof fe)return V.loose===Y?V:new fe(V.raw,Y);if(V instanceof de)return new fe(V.value,Y);if(!(this instanceof fe))return new fe(V,Y);if(this.loose=Y,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Y,ee,$e,ye,De,Se,Ae,Ie,Le,Ue,Oe,je){return((Y=he(ee)?"":he($e)?">="+ee+".0.0":he(ye)?">="+ee+"."+$e+".0":">="+Y)+" "+(Ae=he(Ie)?"":he(Le)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+Le+1)+".0":Oe?"<="+Ie+"."+Le+"."+Ue+"-"+Oe:"<="+Ae)).trim()}function be(V,Y){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==me&&V[ee].semver.prerelease.length>0){var $e=V[ee].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function Pe(V,Y,ee){try{Y=new fe(Y,ee)}catch{return!1}return Y.test(V)}function Fe(V,Y,ee,$e){var ye,De,Se,Ae,Ie;switch(V=new U(V,$e),Y=new fe(Y,$e),ee){case">":ye=F,De=oe,Se=C,Ae=">",Ie=">=";break;case"<":ye=C,De=ce,Se=F,Ae="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(V,Y,$e))return!1;for(var Le=0;Le<Y.set.length;++Le){var Ue=Y.set[Le],Oe=null,je=null;if(Ue.forEach(function(Ne){Ne.semver===me&&(Ne=new de(">=0.0.0")),Oe=Oe||Ne,je=je||Ne,ye(Ne.semver,Oe.semver,$e)?Oe=Ne:Se(Ne.semver,je.semver,$e)&&(je=Ne)}),Oe.operator===Ae||Oe.operator===Ie||(!je.operator||je.operator===Ae)&&De(V,je.semver)||je.operator===Ie&&Se(V,je.semver))return!1}return!0}de.prototype.parse=function(V){var Y=this.loose?v[q]:v[G],ee=V.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===me||(typeof V=="string"&&(V=new U(V,this.loose)),ge(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Y){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Y),Pe(this.value,ee,Y);if(V.operator==="")return ee=new fe(this.value,Y),Pe(V.semver,ee,Y);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ae=ge(this.semver,"<",V.semver,Y)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=ge(this.semver,">",V.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||De&&Se||Ae||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Y=this.loose;V=V.trim(),R("range",V,Y);var ee=Y?v[B]:v[M];V=V.replace(ee,we),R("hyphen replace",V),V=V.replace(v[T],"$1$2$3"),R("comparator trim",V,v[T]),V=(V=(V=V.replace(v[x],"$1~")).replace(v[ae],"$1^")).split(/\s+/).join(" ");var $e=Y?v[q]:v[G],ye=V.split(" ").map(function(De){return function(Se,Ae){return R("comp",Se),Se=function(Ie,Le){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,je){R("caret",Oe,je);var Ne=je?v[ie]:v[le];return Oe.replace(Ne,function(Me,ve,Ee,ke,Re){var ze;return R("caret",Oe,Me,ve,Ee,ke,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+" <"+(+ve+1)+".0.0"),R("caret return",ze),ze})}(Ue,Le)}).join(" ")}(Se,Ae),R("caret",Se),Se=function(Ie,Le){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,je){var Ne=je?v[ue]:v[_];return Oe.replace(Ne,function(Me,ve,Ee,ke,Re){var ze;return R("tilde",Oe,Me,ve,Ee,ke,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",ze),ze})}(Ue,Le)}).join(" ")}(Se,Ae),R("tildes",Se),Se=function(Ie,Le){return R("replaceXRanges",Ie,Le),Ie.split(/\s+/).map(function(Ue){return function(Oe,je){Oe=Oe.trim();var Ne=je?v[E]:v[y];return Oe.replace(Ne,function(Me,ve,Ee,ke,Re,ze){R("xRange",Oe,Me,ve,Ee,ke,Re,ze);var qe=he(Ee),Ce=qe||he(ke),Te=Ce||he(Re);return ve==="="&&Te&&(ve=""),qe?Me=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(ke=0),Te&&(Re=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,ke=0,Re=0):Te&&(ke=+ke+1,Re=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:ke=+ke+1),Me=ve+Ee+"."+ke+"."+Re):Ce?Me=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Me=">="+Ee+"."+ke+".0 <"+Ee+"."+(+ke+1)+".0"),R("xRange return",Me),Me})}(Ue,Le)}).join(" ")}(Se,Ae),R("xrange",Se),Se=function(Ie,Le){return R("replaceStars",Ie,Le),Ie.trim().replace(v[X],"")}(Se,Ae),R("stars",Se),Se}(De,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match($e)})),ye=ye.map(function(De){return new de(De,Y)})},fe.prototype.intersects=function(V,Y){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function($e){return V.set.some(function(ye){return ye.every(function(De){return $e.intersects(De,Y)})})})})},e.toComparators=function(V,Y){return new fe(V,Y).set.map(function(ee){return ee.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new U(V,this.loose));for(var Y=0;Y<this.set.length;Y++)if(be(this.set[Y],V))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(V,Y,ee){var $e=null,ye=null;try{var De=new fe(Y,ee)}catch{return null}return V.forEach(function(Se){De.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new U($e=Se,ee)))}),$e},e.minSatisfying=function(V,Y,ee){var $e=null,ye=null;try{var De=new fe(Y,ee)}catch{return null}return V.forEach(function(Se){De.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new U($e=Se,ee)))}),$e},e.validRange=function(V,Y){try{return new fe(V,Y).range||"*"}catch{return null}},e.ltr=function(V,Y,ee){return Fe(V,Y,"<",ee)},e.gtr=function(V,Y,ee){return Fe(V,Y,">",ee)},e.outside=Fe,e.prerelease=function(V,Y){var ee=K(V,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Y,ee){return V=new fe(V,ee),Y=new fe(Y,ee),V.intersects(Y)},e.coerce=function(V){if(V instanceof U)return V;if(typeof V!="string")return null;var Y=V.match(v[D]);return Y==null?null:K((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,A(1))},function(J,e){var A,N,R=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function v($){if(A===setTimeout)return setTimeout($,0);if((A===L||!A)&&setTimeout)return A=setTimeout,setTimeout($,0);try{return A($,0)}catch{try{return A.call(null,$,0)}catch{return A.call(this,$,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:L}catch{A=L}try{N=typeof clearTimeout=="function"?clearTimeout:j}catch{N=j}})();var u,c=[],b=!1,O=-1;function g(){b&&u&&(b=!1,u.length?c=u.concat(c):O=-1,c.length&&d())}function d(){if(!b){var $=v(g);b=!0;for(var h=c.length;h;){for(u=c,c=[];++O<h;)u&&u[O].run();O=-1,h=c.length}u=null,b=!1,function(f){if(N===clearTimeout)return clearTimeout(f);if((N===j||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(f);try{N(f)}catch{try{return N.call(null,f)}catch{return N.call(this,f)}}}($)}}function S($,h){this.fun=$,this.array=h}function w(){}R.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];c.push(new S($,h)),c.length!==1||b||v(d)},S.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=w,R.addListener=w,R.once=w,R.off=w,R.removeListener=w,R.removeAllListeners=w,R.emit=w,R.prependListener=w,R.prependOnceListener=w,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class N{constructor(v,u,c){this.level=v,this.key=u,this.value=c,this.forward=[]}}const R=void 0;class L{constructor(v,u=2**16){this.comparator=v,this[A]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new N(this.c,R,R)}get size(){return this.f}clear(){this.e=new N(this.c,R,R)}has(v){return!!L.g(this,v,this.comparator)}get(v){return L.g(this,v,this.comparator)?.value}set(v,u){return L.h(this,v,u,this.comparator)&&(this.f+=1),this}delete(v){const u=L.k(this,v,this.comparator);return u&&(this.f-=1),u}forEach(v,u){let c=this.e.forward[0];for(;c;)v.call(u,c.value,c.key,this),c=c.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this.e.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this.e.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this.e.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",u=this.e.forward[0];for(;u;)v+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return v}static g(v,u,c){let b=v.e;for(let O=v.d-1;O>=0;O--)for(;b.forward[O]&&c(b.forward[O].key,u)<0;)b=b.forward[O];if(b=b.forward[0],b&&c(b.key,u)===0)return b}static h(v,u,c,b){const O=[];let g=v.e;for(let d=v.d-1;d>=0;d--){for(;g.forward[d]&&b(g.forward[d].key,u)<0;)g=g.forward[d];O[d]=g}if(g=g.forward[0],g&&b(g.key,u)===0)return g.value=c,!1;{const d=L.j(v);if(d>v.d){for(let S=v.d;S<d;S++)O[S]=v.e;v.d=d}g=new N(d,u,c);for(let S=0;S<d;S++)g.forward[S]=O[S].forward[S],O[S].forward[S]=g;return!0}}static j(v,u=.5){let c=1;for(;Math.random()<u&&c<v.c;)c+=1;return c}static k(v,u,c){const b=[];let O=v.e;for(let g=v.d-1;g>=0;g--){for(;O.forward[g]&&c(O.forward[g].key,u)<0;)O=O.forward[g];b[g]=O}if(O=O.forward[0],!O||c(O.key,u)!==0)return!1;for(let g=0;g<v.d&&b[g].forward[g]===O;g++)b[g].forward[g]=O.forward[g];for(;v.d>0&&v.e.forward[v.d-1]===R;)v.d-=1;return!0}}e.$qr=L}),define(ne[45],re([0,1,9,2]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function R(p){const P=p;return P?typeof P.read=="function":!1}e.$Wd=R;function L(p){const P=p;return P?[P.on,P.pause,P.resume,P.destroy].every(t=>typeof t=="function"):!1}e.$Xd=L;function j(p){const P=p;return P?L(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.$Yd=j;function v(p,P){return new u(p,P)}e.$Zd=v;class u{constructor(P,t){this.e=P,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(P){if(!this.a.destroyed){if(this.a.flowing)this.g(P);else if(this.b.data.push(P),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(P){this.a.destroyed||(this.a.flowing?this.h(P):this.b.error.push(P))}end(P){this.a.destroyed||(typeof P<"u"&&this.write(P),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(P){this.c.data.slice(0).forEach(t=>t(P))}h(P){this.c.error.length===0?(0,A.$Y)(P):this.c.error.slice(0).forEach(t=>t(P))}i(){this.c.end.slice(0).forEach(P=>P())}on(P,t){if(!this.a.destroyed)switch(P){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(P,t){if(this.a.destroyed)return;let a;switch(P){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const P=this.e(this.b.data);this.g(P),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const P of this.b.error)this.h(P);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,P){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return P(t)}e.$1d=c;function b(p,P,t){const a=[];let i;for(;(i=p.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?P(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return p.read()}}}e.$2d=b;function O(p,P){return new Promise((t,a)=>{const i=[];g(p,{onData:n=>{P&&i.push(n)},onError:n=>{P?a(n):t(void 0)},onEnd:()=>{t(P?P(i):void 0)}})})}e.$3d=O;function g(p,P,t){p.on("error",a=>{t?.isCancellationRequested||P.onError(a)}),p.on("end",()=>{t?.isCancellationRequested||P.onEnd()}),p.on("data",a=>{t?.isCancellationRequested||P.onData(a)})}e.$4d=g;function d(p,P){return new Promise((t,a)=>{const i=new N.$Pc,n=[],s=k=>{if(n.push(k),n.length>P)return i.dispose(),p.pause(),t({stream:p,buffer:n,ended:!1})},r=k=>(i.dispose(),a(k)),l=()=>(i.dispose(),t({stream:p,buffer:n,ended:!0}));i.add((0,N.$Oc)(()=>p.removeListener("error",r))),p.on("error",r),i.add((0,N.$Oc)(()=>p.removeListener("end",l))),p.on("end",l),i.add((0,N.$Oc)(()=>p.removeListener("data",s))),p.on("data",s)})}e.$5d=d;function S(p,P){const t=v(P);return t.end(p),t}e.$6d=S;function w(){const p=v(()=>{throw new Error("not supported")});return p.end(),p}e.$7d=w;function $(p){let P=!1;return{read:()=>P?null:(P=!0,p)}}e.$8d=$;function h(p,P,t){const a=v(t);return g(p,{onData:i=>a.write(P.data(i)),onError:i=>a.error(P.error?P.error(i):i),onEnd:()=>a.end()}),a}e.$9d=h;function f(p,P,t){let a=!1;return{read:()=>{const i=P.read();return a?i:(a=!0,i!==null?t([p,i]):p)}}}e.$0d=f;function I(p,P,t){let a=!1;const i=v(t);return g(P,{onData:n=>a?i.write(n):(a=!0,i.write(t([p,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(p)),i.end()}}),i}e.$$d=I}),define(ne[14],re([0,1,164,45]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const R=typeof Buffer<"u",L=new A.$T(()=>new Uint8Array(256));let j,v;class u{static alloc(D){return R?new u(Buffer.allocUnsafe(D)):new u(new Uint8Array(D))}static wrap(D){return R&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new u(D)}static fromString(D,W){return!(W?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(D)):(j||(j=new TextEncoder),new u(j.encode(D)))}static fromByteArray(D){const W=u.alloc(D.length);for(let x=0,_=D.length;x<_;x++)W.buffer[x]=D[x];return W}static concat(D,W){if(typeof W>"u"){W=0;for(let ue=0,te=D.length;ue<te;ue++)W+=D[ue].byteLength}const x=u.alloc(W);let _=0;for(let ue=0,te=D.length;ue<te;ue++){const ae=D[ue];x.set(ae,_),_+=ae.byteLength}return x}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=u.alloc(this.byteLength);return D.set(this),D}toString(){return R?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(D,W){return new u(this.buffer.subarray(D,W))}set(D,W){if(D instanceof u)this.buffer.set(D.buffer,W);else if(D instanceof Uint8Array)this.buffer.set(D,W);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),W);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return g(this.buffer,D)}writeUInt32BE(D,W){d(this.buffer,D,W)}readUInt32LE(D){return S(this.buffer,D)}writeUInt32LE(D,W){w(this.buffer,D,W)}readUInt8(D){return $(this.buffer,D)}writeUInt8(D,W){h(this.buffer,D,W)}indexOf(D,W=0){return c(this.buffer,D instanceof u?D.buffer:D,W)}}e.$_d=u;function c(E,D,W=0){const x=D.byteLength,_=E.byteLength;if(x===0)return 0;if(x===1)return E.indexOf(D[0]);if(x>_-W)return-1;const ue=L.value;ue.fill(D.length);for(let ie=0;ie<D.length;ie++)ue[D[ie]]=D.length-ie-1;let te=W+D.length-1,ae=te,le=-1;for(;te<_;)if(E[te]===D[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(D.length-ae,ue[E[te]]),ae=D.length-1;return le}e.$ae=c;function b(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0}e.$be=b;function O(E,D,W){E[W+0]=D&255,D=D>>>8,E[W+1]=D&255}e.$ce=O;function g(E,D){return E[D]*2**24+E[D+1]*2**16+E[D+2]*2**8+E[D+3]}e.$de=g;function d(E,D,W){E[W+3]=D,D=D>>>8,E[W+2]=D,D=D>>>8,E[W+1]=D,D=D>>>8,E[W]=D}e.$ee=d;function S(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0|E[D+2]<<16>>>0|E[D+3]<<24>>>0}e.$fe=S;function w(E,D,W){E[W+0]=D&255,D=D>>>8,E[W+1]=D&255,D=D>>>8,E[W+2]=D&255,D=D>>>8,E[W+3]=D&255}e.$ge=w;function $(E,D){return E[D]}e.$he=$;function h(E,D,W){E[W]=D}e.$ie=h;function f(E){return N.$1d(E,D=>u.concat(D))}e.$je=f;function I(E){return N.$8d(E)}e.$ke=I;function p(E){return N.$3d(E,D=>u.concat(D))}e.$le=p;async function P(E){return E.ended?u.concat(E.buffer):u.concat([...E.buffer,await p(E.stream)])}e.$me=P;function t(E){return N.$6d(E,D=>u.concat(D))}e.$ne=t;function a(E){return N.$9d(E,{data:D=>typeof D=="string"?u.fromString(D):u.wrap(D)},D=>u.concat(D))}e.$oe=a;function i(E){return N.$Zd(D=>u.concat(D),E)}e.$pe=i;function n(E,D){return N.$0d(E,D,W=>u.concat(W))}e.$qe=n;function s(E,D){return N.$$d(E,D,W=>u.concat(W))}e.$re=s;function r(E){let D=0,W=0,x=0;const _=new Uint8Array(Math.floor(E.length/4*3)),ue=ae=>{switch(W){case 3:_[x++]=D|ae,W=0;break;case 2:_[x++]=D|ae>>>2,D=ae<<6,W=3;break;case 1:_[x++]=D|ae>>>4,D=ae<<4,W=2;break;default:D=ae<<2,W=1}};for(let ae=0;ae<E.length;ae++){const le=E.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ae]}`)}}const te=x;for(;W>0;)ue(0);return u.wrap(_).slice(0,te)}e.$se=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:E},D=!0,W=!1){const x=W?k:l;let _="";const ue=E.byteLength%3;let te=0;for(;te<E.byteLength-ue;te+=3){const ae=E[te+0],le=E[te+1],ie=E[te+2];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[(le<<2|ie>>>6)&63],_+=x[ie&63]}if(ue===1){const ae=E[te+0];_+=x[ae>>>2],_+=x[ae<<4&63],D&&(_+="==")}else if(ue===2){const ae=E[te+0],le=E[te+1];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[le<<2&63],D&&(_+="=")}return _}e.$te=y}),define(ne[41],re([0,1,29]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;function N(h){return R(h,0)}e.$Ai=N;function R(h,f){switch(typeof h){case"object":return h===null?L(349,f):Array.isArray(h)?u(h,f):c(h,f);case"string":return v(h,f);case"boolean":return j(h,f);case"number":return L(h,f);case"undefined":return L(937,f);default:return L(617,f)}}e.$Bi=R;function L(h,f){return(f<<5)-f+h|0}e.$Ci=L;function j(h,f){return L(h?433:863,f)}function v(h,f){f=L(149417,f);for(let I=0,p=h.length;I<p;I++)f=L(h.charCodeAt(I),f);return f}e.$Di=v;function u(h,f){return f=L(104579,f),h.reduce((I,p)=>R(p,I),f)}function c(h,f){return f=L(181387,f),Object.keys(h).sort().reduce((I,p)=>(I=v(p,I),R(h[p],I)),f)}class b{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=R(f,this.g),this.g}}e.$Ei=b;var O;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function g(h,f,I=32){const p=I-f,P=~((1<<p)-1);return(h<<f|(P&h)>>>p)>>>0}function d(h,f=0,I=h.byteLength,p=0){for(let P=0;P<I;P++)h[f+P]=p}function S(h,f,I="0"){for(;h.length<f;)h=I+h;return h}function w(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):S((h>>>0).toString(16),f/4)}e.$Fi=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const I=f.length;if(I===0)return;const p=this.p;let P=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=f.charCodeAt(0),i=0);;){let n=a;if(A.$4e(a))if(i+1<I){const s=f.charCodeAt(i+1);A.$5e(s)?(i++,n=A.$6e(a,s)):n=65533}else{t=a;break}else A.$5e(a)&&(n=65533);if(P=this.w(p,P,n),i++,i<I)a=f.charCodeAt(i);else break}this.r=P,this.u=t}w(f,I,p){return p<128?f[I++]=p:p<2048?(f[I++]=192|(p&1984)>>>6,f[I++]=128|(p&63)>>>0):p<65536?(f[I++]=224|(p&61440)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0):(f[I++]=240|(p&1835008)>>>18,f[I++]=128|(p&258048)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,I=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,g(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let p=this.h,P=this.l,t=this.m,a=this.n,i=this.o,n,s,r;for(let l=0;l<80;l++)l<20?(n=P&t|~P&a,s=1518500249):l<40?(n=P^t^a,s=1859775393):l<60?(n=P&t|P&a|t&a,s=2400959708):(n=P^t^a,s=3395469782),r=g(p,5)+n+i+s+f.getUint32(l*4,!1)&4294967295,i=a,a=t,t=g(P,30),P=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+P&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.$Gi=$}),define(ne[54],re([0,1,29]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(N||(N={})),function(R){const L="error",j="warning",v="warn",u="info",c="ignore";function b(g){return g?A.$Ze(L,g)?R.Error:A.$Ze(j,g)||A.$Ze(v,g)?R.Warning:A.$Ze(u,g)?R.Info:R.Ignore:R.Ignore}R.fromValue=b;function O(g){switch(g){case R.Error:return L;case R.Warning:return j;case R.Info:return u;default:return c}}R.toString=O}(N||(N={})),e.default=N}),define(ne[30],re([0,1,3]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,p])=>{f[I]=p&&typeof p=="object"?N(p):p}),f}e.$Xm=N;function R(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const p in I)if(L.call(I,p)){const P=I[p];typeof P=="object"&&!Object.isFrozen(P)&&!(0,A.$zf)(P)&&f.push(P)}}return h}e.$Ym=R;const L=Object.prototype.hasOwnProperty;function j(h,f){return v(h,f,new Set)}e.$Zm=j;function v(h,f,I){if((0,A.$Ff)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const P=[];for(const t of h)P.push(v(t,f,I));return P}if((0,A.$yf)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const P={};for(const t in h)L.call(h,t)&&(P[t]=v(h[t],f,I));return I.delete(h),P}return h}function u(h,f,I=!0){return(0,A.$yf)(h)?((0,A.$yf)(f)&&Object.keys(f).forEach(p=>{p in h?I&&((0,A.$yf)(h[p])&&(0,A.$yf)(f[p])?u(h[p],f[p],I):h[p]=f[p]):h[p]=f[p]}),h):f}e.$1m=u;function c(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let I,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(I=0;I<h.length;I++)if(!c(h[I],f[I]))return!1}else{const P=[];for(p in h)P.push(p);P.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!c(P,t))return!1;for(I=0;I<P.length;I++)if(!c(h[P[I]],f[P[I]]))return!1}return!0}e.$2m=c;function b(h){const f=new Set;return JSON.stringify(h,(I,p)=>{if((0,A.$yf)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$3m=b;function O(h,f){const I=Object.create(null);return!h||!f||Object.keys(f).forEach(P=>{const t=h[P],a=f[P];c(t,a)||(I[P]=a)}),I}e.$4m=O;function g(h,f){const I=f.toLowerCase(),p=Object.keys(h).find(P=>P.toLowerCase()===I);return p?h[p]:h[f]}e.$5m=g;function d(h,f){const I=Object.create(null);for(const[p,P]of Object.entries(h))f(p,P)&&(I[p]=P);return I}e.$6m=d;function S(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$7m=S;function w(h){const f=[];for(const I of S(h))typeof h[I]=="function"&&f.push(I);return f}e.$8m=w;function $(h,f){const I=P=>function(){const t=Array.prototype.slice.call(arguments,0);return f(P,t)},p={};for(const P of h)p[P]=I(P);return p}e.$9m=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=void 0;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(R){return A.test(R)}e.$bg=N,e.$cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(v){for(let u=0;u<v.length;u++)v[u]=Math.floor(Math.random()*256);return v};const L=new Uint8Array(16),j=[];for(let v=0;v<256;v++)j.push(v.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let u=0,c="";return c+=j[L[u++]],c+=j[L[u++]],c+=j[L[u++]],c+=j[L[u++]],c+="-",c+=j[L[u++]],c+=j[L[u++]],c+="-",c+=j[L[u++]],c+=j[L[u++]],c+="-",c+=j[L[u++]],c+=j[L[u++]],c+="-",c+=j[L[u++]],c+=j[L[u++]],c+=j[L[u++]],c+=j[L[u++]],c+=j[L[u++]],c+=j[L[u++]],c}}()}),define(ne[74],re([0,1,33]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(j){const v=j.replace(/\-/g,":").toLowerCase();return!N.has(v)}function L(){const j=(0,A.networkInterfaces)();for(const v in j){const u=j[v];if(u){for(const{mac:c}of u)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Im=L}),define(ne[75],re([0,1,33,46,28,74]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=void 0,e.$Jm=new class{c(c){return this.a||(this.a=N.$Sh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,b=0;const O=(0,A.networkInterfaces)();for(const g in O){const d=O[g];if(d)for(const{mac:S,internal:w}of d)w||(b+=1,this.c(S.toUpperCase())&&(c+=1))}this.b=b>0?c/b:0}return this.b}};let j;async function v(c){return j||(j=(async()=>await u(c)||R.$cg())()),j}e.$Km=v;async function u(c){try{const b=await new Promise((g,d)=>{J(["crypto"],g,d)}),O=(0,L.$Im)();return b.createHash("sha256").update(O,"utf8").digest("hex")}catch(b){c(b);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0;const N=60,R=N*60,L=R*24,j=L*7,v=L*30,u=L*365;function c(O,g,d,S){typeof O!="number"&&(O=O.getTime());const w=Math.round((new Date().getTime()-O)/1e3);if(w<-30)return(0,A.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,A.localize)(1,null);let $;return w<N?($=w,g?$===1?d?(0,A.localize)(2,null,$):(0,A.localize)(3,null,$):d?(0,A.localize)(4,null,$):(0,A.localize)(5,null,$):$===1?d?(0,A.localize)(6,null,$):(0,A.localize)(7,null,$):d?(0,A.localize)(8,null,$):(0,A.localize)(9,null,$)):w<R?($=Math.floor(w/N),g?$===1?d?(0,A.localize)(10,null,$):(0,A.localize)(11,null,$):d?(0,A.localize)(12,null,$):(0,A.localize)(13,null,$):$===1?d?(0,A.localize)(14,null,$):(0,A.localize)(15,null,$):d?(0,A.localize)(16,null,$):(0,A.localize)(17,null,$)):w<L?($=Math.floor(w/R),g?$===1?d?(0,A.localize)(18,null,$):(0,A.localize)(19,null,$):d?(0,A.localize)(20,null,$):(0,A.localize)(21,null,$):$===1?d?(0,A.localize)(22,null,$):(0,A.localize)(23,null,$):d?(0,A.localize)(24,null,$):(0,A.localize)(25,null,$)):w<j?($=Math.floor(w/L),g?$===1?(0,A.localize)(26,null,$):(0,A.localize)(27,null,$):$===1?(0,A.localize)(28,null,$):(0,A.localize)(29,null,$)):w<v?($=Math.floor(w/j),g?$===1?d?(0,A.localize)(30,null,$):(0,A.localize)(31,null,$):d?(0,A.localize)(32,null,$):(0,A.localize)(33,null,$):$===1?d?(0,A.localize)(34,null,$):(0,A.localize)(35,null,$):d?(0,A.localize)(36,null,$):(0,A.localize)(37,null,$)):w<u?($=Math.floor(w/v),g?$===1?d?(0,A.localize)(38,null,$):(0,A.localize)(39,null,$):d?(0,A.localize)(40,null,$):(0,A.localize)(41,null,$):$===1?d?(0,A.localize)(42,null,$):(0,A.localize)(43,null,$):d?(0,A.localize)(44,null,$):(0,A.localize)(45,null,$)):($=Math.floor(w/u),g?$===1?d?(0,A.localize)(46,null,$):(0,A.localize)(47,null,$):d?(0,A.localize)(48,null,$):(0,A.localize)(49,null,$):$===1?d?(0,A.localize)(50,null,$):(0,A.localize)(51,null,$):d?(0,A.localize)(52,null,$):(0,A.localize)(53,null,$))}e.$8l=c;function b(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$9l=b}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,78]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=void 0;function L(O,g){return g&&(O.stack||O.stacktrace)?R.localize(0,null,v(O),j(O.stack)||j(O.stacktrace)):v(O)}function j(O){return Array.isArray(O)?O.join(`
`):O}function v(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?R.localize(1,null,O.message):O.message||R.localize(2,null)}function u(O=null,g=!1){if(!O)return R.localize(3,null);if(Array.isArray(O)){const d=A.$Fb(O),S=u(d[0],g);return d.length>1?R.localize(4,null,S,d.length):S}if(N.$wf(O))return O;if(O.detail){const d=O.detail;if(d.error)return L(d.error,g);if(d.exception)return L(d.exception,g)}return O.stack?L(O,g):O.message?O.message:R.localize(5,null)}e.$xi=u;function c(O){const g=O;return g instanceof Error&&Array.isArray(g.actions)}e.$yi=c;function b(O,g){let d;return typeof O=="string"?d=new Error(O):d=O,d.actions=g,d}e.$zi=b}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;function N(R){switch(R){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}e.$op=N}),define(ne[55],re([0,1,13]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0;var N;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(N||(e.Source=N={}));var R;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function L(v,...u){const c=u.reduce((g,d)=>(g[d]=!0,g),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(g=>!c[g]).forEach(g=>{for(let d=0;d<b.length;d++)if(g.search(b[d])!==-1){delete v[g];break}})}e.$ul=L;function j(v){v&&(delete v.DEBUG,A.$j&&delete v.DYLD_LIBRARY_PATH,A.$k&&delete v.LD_PRELOAD)}e.$vl=j}),define(ne[81],re([0,1,11]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Rp=e.$Qp=e.$Pp=void 0;function N(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.$Pp=N;function R(c){const b=[];let O;try{const g=JSON.parse(c.arguments),d=g[g.length-1];d&&d.__$stack&&(g.pop(),O=d.__$stack),b.push(...g)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:O}}e.$Qp=R;function L(c){if(typeof c!="string")return L(R(c).stack);const b=c;if(b){const O=j(b),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(g&&g.length===4)return{uri:A.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$Rp=L;function j(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function v(c,b){const{args:O,stack:g}=R(c),d=typeof O[0]=="string"&&O.length===1;let S=j(g);S&&(S=`(${S.trim()})`);let w=[];if(typeof O[0]=="string"?S&&d?w=[`%c[${b}] %c${O[0]} %c${S}`,u("blue"),u(""),u("grey")]:w=[`%c[${b}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:w=[`%c[${b}]%`,u("blue"),...O],S&&!d&&w.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,w)}e.log=v;function u(c){return`color: ${c}`}}),define(ne[47],re([0,1,14,11]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function R(u){return JSON.stringify(u,j)}e.$hh=R;function L(u){let c=JSON.parse(u);return c=v(c),c}e.$ih=L;function j(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function v(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return N.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof A.$_d||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let b=0;b<u.length;++b)u[b]=v(u[b],c+1);else for(const b in u)Object.hasOwnProperty.call(u,b)&&(u[b]=v(u[b],c+1))}return u}e.$jh=v}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class j{constructor(g,d,S){this.id=g,this.dependencies=d,this.callback=S}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,d,S)=>{typeof g!="string"&&(S=d,d=g,g=null),(typeof d!="object"||!Array.isArray(d))&&(S=d,d=null),this.c.push(new j(g,d,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const d=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!d)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(g){return new Promise((d,S)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const $=()=>{w.removeEventListener("load",h),w.removeEventListener("error",f)},h=I=>{$(),d(this.c.pop())},f=I=>{$(),S(I)};w.addEventListener("load",h),w.addEventListener("error",f),this.f&&(g=this.f.createScriptURL(g)),w.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(w)})}i(g){return new Promise((d,S)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),d(this.c.pop())}catch(w){S(w)}})}async j(g){try{const d=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,$=L.URI.parse(g).fsPath,h=d.readFileSync($).toString(),f=w.wrap(h.replace(/^#!.*/,""));return new S.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function b(O,g,d){if(A.$R){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[O]&&(O=c[O]);const S=`${O}/${g}`;if(u.has(S))return u.get(S);let w;if(/^\w[\w\d+.-]*:\/\//.test(S))w=S;else{const I=`${d&&!R.$o?N.$0f:N.$9f}/${S}`;w=N.$ag.asBrowserUri(I).toString(!0)}const $=v.INSTANCE.load(w);return u.set(S,$),$}else return await new Promise((S,w)=>{J([O],S,w)})}e.$eC=b}),define(ne[83],re([0,1,33,16,24]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0;const L=/^\d+$/,j=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class O{constructor(P,t,a){this.exePath=P,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:P=!1}={}){const t=g({useAlternateBitness:p});if(!t)return null;const a=N.$hc(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const l of await R.Promises.readdir(a)){let k=-1;if(P){const E=l.indexOf("-");if(E<0)continue;const D=l.substring(0,E);if(!L.test(D)||l.substring(E+1)!=="preview")continue;k=parseInt(D,10)}else{if(!L.test(l))continue;k=parseInt(l,10)}if(k<=i)continue;const y=N.$hc(a,l,"pwsh.exe");await R.SymlinkSupport.existsFile(y)&&(n=y,i=k)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",r=P?" Preview":"";return new O(n,`PowerShell${r}${s}`,!0)}async function S({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const P=N.$hc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(P))if(t.test(i)){const n=N.$hc(P,i,"pwsh.exe");return new O(n,a)}return null}function w(){const p=N.$hc(A.homedir(),".dotnet","tools","pwsh.exe");return new O(p,".NET Core PowerShell Global Tool")}function $(){const p=N.$hc(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await S(),p&&(yield p),p=w(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$sl=f;async function I(){for await(const p of f())return p;return null}e.$tl=I}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(J,e,A,N,R,L,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function u(O=R.env){return O.comspec||"cmd.exe"}e.$wl=u;function c(O){let g=[],d=!1;const S=function(w){if(d){g.push(w);return}(!O.send(w,h=>{if(h&&console.error(h),d=!1,g.length>0){const f=g.slice(0);g=[],f.forEach(I=>S(I))}})||N.$i)&&(d=!0)};return{send:S}}e.$xl=c;var b;(function(O){async function g(d,S,w){if(A.$gc(d))return d;if(S===void 0&&(S=R.cwd()),A.$kc(d)!=="."||(w===void 0&&j.$wf(R.env.PATH)&&(w=R.env.PATH.split(A.$rc)),w===void 0||w.length===0))return A.$hc(S,d);async function h(f){if(await v.Promises.exists(f)){let I;try{I=await v.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(I=await v.Promises.lstat(f))}return I?!I.isDirectory():!1}return!1}for(const f of w){let I;if(A.$gc(f)?I=A.$hc(f,d):I=A.$hc(S,f,d),await h(I))return I;let p=I+".com";if(await h(p)||(p=I+".exe",await h(p)))return p}return A.$hc(S,d)}O.findExecutable=g})(b||(e.win32=b={}))}),define(ne[84],re([0,1,33,13,83,56]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=void 0;async function j(O,g){return O===1?N.$i?b():L.$wl(g):u(O,g)}e.$yl=j;let v=null;function u(O,g){if(N.$k&&O===2||N.$j&&O===3)return"/bin/bash";if(!v){let d;if(N.$i)d="/bin/bash";else{if(d=g.SHELL,!d)try{d=(0,A.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}v=d}return v}let c=null;async function b(){return c||(c=(await(0,R.$tl)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,A,N){var R=arguments.length,L=R<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,A):N,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,A,N);else for(var v=J.length-1;v>=0;v--)(j=J[v])&&(L=(R<3?j(L):R>3?j(e,A,L):j(e,A))||L);return R>3&&L&&Object.defineProperty(e,A,L),L};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,A,N,R,L,j,v,u,c,b,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.ProxyChannel=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.RequestInitiator=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0;var d;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(d||(d={}));function S(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(w||(w={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let M=0;for(let B=0;;B+=7){const X=T.read(1);if(M|=(X.buffer[0]&127)<<B,!(X.buffer[0]&128))return M}}const I=i(0);function p(T,M){if(M===0){T.write(I);return}let B=0;for(let Z=M;Z!==0;Z=Z>>>7)B++;const X=R.$_d.alloc(B);for(let Z=0;M!==0;Z++)X.buffer[Z]=M&127,M=M>>>7,M>0&&(X.buffer[Z]|=128);T.write(X)}class P{constructor(M){this.b=M,this.a=0}read(M){const B=this.b.slice(this.a,this.a+M);return this.a+=B.byteLength,B}}e.$kh=P;class t{constructor(){this.a=[]}get buffer(){return R.$_d.concat(this.a)}write(M){this.a.push(M)}}e.$lh=t;var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(a||(a={}));function i(T){const M=R.$_d.alloc(1);return M.writeUInt8(T,0),M}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},s=typeof Buffer<"u";function r(T,M){if(typeof M>"u")T.write(n.Undefined);else if(typeof M=="string"){const B=R.$_d.fromString(M);T.write(n.String),p(T,B.byteLength),T.write(B)}else if(s&&Buffer.isBuffer(M)){const B=R.$_d.wrap(M);T.write(n.Buffer),p(T,B.byteLength),T.write(B)}else if(M instanceof R.$_d)T.write(n.VSBuffer),p(T,M.byteLength),T.write(M);else if(Array.isArray(M)){T.write(n.Array),p(T,M.length);for(const B of M)r(T,B)}else if(typeof M=="number"&&(M|0)===M)T.write(n.Uint),p(T,M);else{const B=R.$_d.fromString(JSON.stringify(M));T.write(n.Object),p(T,B.byteLength),T.write(B)}}e.$mh=r;function l(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(f(T)).toString();case a.Buffer:return T.read(f(T)).buffer;case a.VSBuffer:return T.read(f(T));case a.Array:{const B=f(T),X=[];for(let Z=0;Z<B;Z++)X.push(l(T));return X}case a.Object:return JSON.parse(T.read(f(T)).toString());case a.Int:return f(T)}}e.$nh=l;class k{constructor(M,B,X=null,Z=1e3){this.h=M,this.j=B,this.k=X,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(M,B){this.b.set(M,B),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const B=this.o([M.type]);this.k?.logOutgoing(B,0,1,$(M.type));return}case 201:case 202:case 204:case 203:{const B=this.o([M.type,M.id],M.data);this.k?.logOutgoing(B,M.id,1,$(M.type),M.data);return}}}o(M,B=void 0){const X=new t;return r(X,M),r(X,B),this.p(X.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const B=new P(M),X=l(B),Z=l(B),K=X[0];switch(K){case 100:return this.k?.logIncoming(M.byteLength,X[1],1,`${S(K)}: ${X[2]}.${X[3]}`,Z),this.s({type:K,id:X[1],channelName:X[2],name:X[3],arg:Z});case 102:return this.k?.logIncoming(M.byteLength,X[1],1,`${S(K)}: ${X[2]}.${X[3]}`,Z),this.t({type:K,id:X[1],channelName:X[2],name:X[3],arg:Z});case 101:return this.k?.logIncoming(M.byteLength,X[1],1,`${S(K)}`),this.u({type:K,id:X[1]});case 103:return this.k?.logIncoming(M.byteLength,X[1],1,`${S(K)}`),this.u({type:K,id:X[1]})}}s(M){const B=this.b.get(M.channelName);if(!B){this.v(M);return}const X=new L.$Vd;let Z;try{Z=B.call(this.j,M.name,M.arg,X.token)}catch(z){Z=Promise.reject(z)}const K=M.id;Z.then(z=>{this.m({id:K,data:z,type:201})},z=>{z instanceof Error?this.m({id:K,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:K,data:z,type:203})}).finally(()=>{U.dispose(),this.d.delete(M.id)});const U=(0,c.$Oc)(()=>X.cancel());this.d.set(M.id,U)}t(M){const B=this.b.get(M.channelName);if(!B){this.v(M);return}const X=M.id,K=B.listen(this.j,M.name,M.arg)(U=>this.m({id:X,data:U,type:204}));this.d.set(M.id,K)}u(M){const B=this.d.get(M.id);B&&(B.dispose(),this.d.delete(M.id))}v(M){let B=this.g.get(M.channelName);B||(B=[],this.g.set(M.channelName,B));const X=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:M,timeoutTimer:X})}w(M){const B=this.g.get(M);if(B){for(const X of B)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Lc)(this.d.values()),this.d.clear()}}e.$oh=k;var y;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class E{constructor(M,B=null){this.l=M,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=B}getChannel(M){const B=this;return{call(X,Z,K){return B.a?Promise.reject(new v.$3):B.m(M,X,Z,K)},listen(X,Z){return B.a?u.Event.None:B.o(M,X,Z)}}}m(M,B,X,Z=L.CancellationToken.None){const K=this.g++,z={id:K,type:100,channelName:M,name:B,arg:X};if(Z.isCancellationRequested)return Promise.reject(new v.$3);let o;return new Promise((F,C)=>{if(Z.isCancellationRequested)return C(new v.$3);const Q=()=>{const ge=de=>{switch(de.type){case 201:this.f.delete(K),F(de.data);break;case 202:{this.f.delete(K);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,C(me);break}case 203:this.f.delete(K),C(de.data);break}};this.f.set(K,ge),this.p(z)};let H=null;this.b===h.Idle?Q():(H=(0,N.$Fg)(ge=>this.u()),H.then(()=>{H=null,Q()}));const ce=()=>{H?(H.cancel(),H=null):this.p({id:K,type:101}),C(new v.$3)},oe=Z.onCancellationRequested(ce);o=(0,c.$Nc)((0,c.$Oc)(ce),oe),this.d.add(o)}).finally(()=>{o.dispose(),this.d.delete(o)})}o(M,B,X){const Z=this.g++,U={id:Z,type:102,channelName:M,name:B,arg:X};let z=null;const o=new u.$Ld({onWillAddFirstListener:()=>{z=(0,N.$Fg)(F=>this.u()),z.then(()=>{z=null,this.d.add(o),this.p(U)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(o),this.p({id:Z,type:103}))}}),m=F=>o.fire(F.data);return this.f.set(Z,m),o.event}p(M){switch(M.type){case 100:case 102:{const B=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(B,M.id,0,`${S(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const B=this.q([M.type,M.id]);this.j?.logOutgoing(B,M.id,0,S(M.type));return}}}q(M,B=void 0){const X=new t;return r(X,M),r(X,B),this.r(X.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const B=new P(M),X=l(B),Z=l(B),K=X[0];switch(K){case 200:return this.j?.logIncoming(M.byteLength,0,0,$(K)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,X[1],0,$(K),Z),this.t({type:X[0],id:X[1],data:Z})}}t(M){if(M.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Lc)(this.d.values()),this.d.clear()}}e.$ph=E,pe([j.$eh],E.prototype,"onDidInitializePromise",null);class D{get connections(){const M=[];return this.f.forEach(B=>M.push(B)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new u.$Ld,this.onDidAddConnection=this.g.event,this.h=new u.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new c.$Pc,this.j.add(M(({protocol:B,onDidClientDisconnect:X})=>{const Z=u.Event.once(B.onMessage);this.j.add(Z(K=>{const U=new P(K),z=l(U),o=new k(B,z),m=new E(B);this.a.forEach((C,Q)=>o.registerChannel(Q,C));const F={channelServer:o,channelClient:m,ctx:z};this.f.add(F),this.g.fire(F),this.j.add(X(()=>{o.dispose(),m.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(M,B){const X=this;return{call(Z,K,U){let z;if((0,g.$Kf)(B)){const m=(0,A.$2b)(X.connections.filter(B));z=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,B))}else z=B.routeCall(X,Z,K);const o=z.then(m=>m.channelClient.getChannel(M));return x(o).call(Z,K,U)},listen(Z,K){if((0,g.$Kf)(B))return X.k(M,B,Z,K);const U=B.routeEvent(X,Z,K).then(z=>z.channelClient.getChannel(M));return x(U).listen(Z,K)}}}k(M,B,X,Z){const K=this;let U;const z=new u.$Ld({onWillAddFirstListener:()=>{U=new c.$Pc;const o=new u.$Rd,m=new Map,F=Q=>{const ce=Q.channelClient.getChannel(M).listen(X,Z),oe=o.add(ce);m.set(Q,oe)},C=Q=>{const H=m.get(Q);H&&(H.dispose(),m.delete(Q))};K.connections.filter(B).forEach(F),u.Event.filter(K.onDidAddConnection,B)(F,void 0,U),K.onDidRemoveConnection(C,void 0,U),o.event(z.fire,z,U),U.add(o)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return z.event}registerChannel(M,B){this.a.set(M,B);for(const X of this.f)X.channelServer.registerChannel(M,B)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$qh=D;class W{constructor(M,B,X=null){const Z=new t;r(Z,B),M.send(Z.buffer),this.a=new E(M,X),this.d=new k(M,B,X)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,B){this.d.registerChannel(M,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$rh=W;function x(T){return{call(M,B,X){return T.then(Z=>Z.call(M,B,X))},listen(M,B){const X=new u.$Ud;return T.then(Z=>X.input=Z.listen(M,B)),X.event}}}e.$sh=x;function _(T){let M=!1;return{call(B,X,Z){return M?T.call(B,X,Z):(0,N.$Sg)(0).then(()=>M=!0).then(()=>T.call(B,X,Z))},listen(B,X){if(M)return T.listen(B,X);const Z=new u.$Ud;return(0,N.$Sg)(0).then(()=>M=!0).then(()=>Z.input=T.listen(B,X)),Z.event}}}e.$th=_;class ue{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const B of M.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$uh=ue;var te;(function(T){function M(K,U,z){const o=K,m=z&&z.disableMarshalling,F=new Map;for(const C in o)X(C)&&F.set(C,u.Event.buffer(o[C],!0,void 0,U));return new class{listen(C,Q,H){const ce=F.get(Q);if(ce)return ce;if(Z(Q)){const oe=o[Q];if(typeof oe=="function")return oe.call(o,H)}throw new v.$_(`Event not found: ${Q}`)}call(C,Q,H){const ce=o[Q];if(typeof ce=="function"){if(!m&&Array.isArray(H))for(let ge=0;ge<H.length;ge++)H[ge]=(0,b.$jh)(H[ge]);let oe=ce.apply(o,H);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new v.$_(`Method not found: ${Q}`)}}}T.fromService=M;function B(K,U){const z=U&&U.disableMarshalling;return new Proxy({},{get(o,m){if(typeof m=="string")return U?.properties?.has(m)?U.properties.get(m):Z(m)?function(F){return K.listen(m,F)}:X(m)?K.listen(m):async function(...F){let C;U&&!(0,g.$Ff)(U.context)?C=[U.context,...F]:C=F;const Q=await K.call(m,C);return z?Q:(0,b.$jh)(Q)};throw new v.$_(`Property not found: ${String(m)}`)}})}T.toService=B;function X(K){return K[0]==="o"&&K[1]==="n"&&O.$Ye(K.charCodeAt(2))}function Z(K){return/^onDynamic/.test(K)&&O.$Ye(K.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const M=T.toString();if(M!=="[object Object]")return M}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function q(T,M,B,X,Z,K,U){U=ie(U);const z=ae[Z],o=z[X%z.length];let m=[`%c[${T}]%c[${String(M).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(K)?(m=m.concat(U),m.push(")")):m.push(U),console.log.apply(console,m)}class G{constructor(M,B){this.d=M,this.f=B,this.a=0,this.b=0}logOutgoing(M,B,X,Z,K){this.b+=M,q(this.d,this.b,M,B,X,Z,K)}logIncoming(M,B,X,Z,K){this.a+=M,q(this.f,this.a,M,B,X,Z,K)}}e.$vh=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0;class S extends d.$oh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>R.$_d.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Tp=S;class w{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$Ld,this.onDidProcessExit=this.h.event;const I=f&&f.timeout?f.timeout:6e4;this.b=new N.$Og(I),this.d=null,this.f=null}getChannel(h){const f=this;return{call(I,p,P){return f.k(h,I,p,P)},listen(I,p){return f.l(h,I,p)}}}k(h,f,I,p=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(v.$4());this.b.cancel();const P=this.n(h),t=(0,N.$Fg)(n=>P.call(f,I,n)),a=p.onCancellationRequested(()=>t.cancel()),i=(0,c.$Oc)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,I){if(!this.b)return u.Event.None;this.b.cancel();let p;const P=new u.$Ld({onWillAddFirstListener:()=>{p=this.n(h).listen(f,I)(P.fire,P),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return P.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,b.$Xm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,g.$vl)(f.env),this.d=(0,A.fork)(this.i,h,f);const I=new u.$Ld;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,j.$Pp)(s)){(0,j.log)(s,`IPC Library: ${this.j.serverName}`);return}I.fire(R.$_d.wrap(Buffer.from(s,"base64")))});const P=this.j.useQueue?(0,O.$xl)(this.d):this.d,t=s=>this.d&&this.d.connected&&P.send(s.buffer.toString("base64")),a=I.event,i={send:t,onMessage:a};this.f=new d.$ph(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,r)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,c.$Lc)(l)),this.c.clear(),s!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Up=w}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,A,N,R,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.StorageState=e.$So=e.StorageHint=void 0;var v;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function u(g){const d=g;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$So=u;var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class b extends R.$Qc{static{this.a=100}constructor(d,S=Object.create(null)){super(),this.r=d,this.s=S,this.b=this.B(new N.$Od),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new A.$Pg(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((S,w)=>this.w(w,S)),d.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(d,S){if(this.c===c.Closed)return;let w=!1;(0,j.$Ff)(S)?w=this.f.delete(d):this.f.get(d)!==S&&(this.f.set(d,S),w=!0),w&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,S){const w=this.f.get(d);return(0,j.$Ff)(w)?S:w}getBoolean(d,S){const w=this.get(d);return(0,j.$Ff)(w)?S:w==="true"}getNumber(d,S){const w=this.get(d);return(0,j.$Ff)(w)?S:parseInt(w,10)}getObject(d,S){const w=this.get(d);return(0,j.$Ff)(w)?S:(0,L.$ih)(w)}async set(d,S,w=!1){if(this.c===c.Closed)return;if((0,j.$Ff)(S))return this.delete(d,w);const $=(0,j.$yf)(S)||Array.isArray(S)?(0,L.$hh)(S):String(S);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:w}),this.D()}async delete(d,S=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:S}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$To=b;class O{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((S,w)=>this.a.set(w,S)),d.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$Uo=O}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.TokenType=void 0;var R;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...c){switch(c.length){case 1:return(0,N.localize)(0,null,c[0]);case 2:return(0,N.localize)(1,null,c[0],c[1]);case 3:return(0,N.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,N.localize)(3,null),v=(0,N.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,A.$6)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const O=this.d,g=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:g};this.g.push({offset:O,lexeme:g,additionalInfo:b}),this.f.push(d)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const O=this.c.substring(this.d,this.e),g=u.b.get(O);g?this.k(g):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,O=!1,g=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(v);return}const S=this.c.charCodeAt(b);if(O)O=!1;else if(S===47&&!g){b++;break}else S===91?g=!0:S===92?O=!0:S===93&&(g=!1);b++}for(;b<this.c.length&&u.a.has(this.c.charCodeAt(b));)b++;this.e=b;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Hi=u}),define(ne[109],re([0,1,77,52,15,16,35,17,11]),function(J,e,A,N,R,L,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,L.$kc)(R.$ag.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,L.$hc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,v.$tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,v.$tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,A.$9l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$hc)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.$tg)(u.URI.file((0,L.$hc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.$tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.$tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.$tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,L.$hc)(d,"argv.json")):(0,v.$tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,L.$hc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,L.$ic)(d):(0,L.$fc)((0,L.$hc)(R.$ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,L.$ic)(d)):u.URI.file((0,L.$hc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,L.$ic)(d);const S=j.env.VSCODE_EXTENSIONS;if(S)return S;const w=j.env.VSCODE_PORTABLE;return w?(0,L.$hc)(w,"extensions"):(0,v.$tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(S=>/^[^:/?#]+?:\/\//.test(S)?u.URI.parse(S):u.URI.file((0,L.$fc)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,L.$fc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$0l.test(d))}get extensionLogLevel(){const d=[];for(const S of this.args.log||[]){const w=e.$0l.exec(S);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,v.$tg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,L.$hc)(d,"policy.json")):(0,v.$tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,S,w){this.a=d,this.b=S,this.c=w,this.editSessionId=this.args.editSessionId}}e.$$l=c,pe([N.$eh],c.prototype,"appRoot",null),pe([N.$eh],c.prototype,"userHome",null),pe([N.$eh],c.prototype,"userDataPath",null),pe([N.$eh],c.prototype,"appSettingsHome",null),pe([N.$eh],c.prototype,"tmpDir",null),pe([N.$eh],c.prototype,"cacheHome",null),pe([N.$eh],c.prototype,"stateResource",null),pe([N.$eh],c.prototype,"userRoamingDataHome",null),pe([N.$eh],c.prototype,"userDataSyncHome",null),pe([N.$eh],c.prototype,"sync",null),pe([N.$eh],c.prototype,"machineSettingsResource",null),pe([N.$eh],c.prototype,"workspaceStorageHome",null),pe([N.$eh],c.prototype,"localHistoryHome",null),pe([N.$eh],c.prototype,"keyboardLayoutResource",null),pe([N.$eh],c.prototype,"argvResource",null),pe([N.$eh],c.prototype,"isExtensionDevelopment",null),pe([N.$eh],c.prototype,"untitledWorkspacesHome",null),pe([N.$eh],c.prototype,"builtinExtensionsPath",null),pe([N.$eh],c.prototype,"extensionsPath",null),pe([N.$eh],c.prototype,"extensionDevelopmentLocationURI",null),pe([N.$eh],c.prototype,"extensionDevelopmentKind",null),pe([N.$eh],c.prototype,"extensionTestsLocationURI",null),pe([N.$eh],c.prototype,"debugExtensionHost",null),pe([N.$eh],c.prototype,"logLevel",null),pe([N.$eh],c.prototype,"extensionLogLevel",null),pe([N.$eh],c.prototype,"serviceMachineIdResource",null),pe([N.$eh],c.prototype,"disableTelemetry",null),pe([N.$eh],c.prototype,"disableWorkspaceTrust",null),pe([N.$eh],c.prototype,"useInMemorySecretStorage",null),pe([N.$eh],c.prototype,"policyFile",null);function b(g,d){return O(g["inspect-extensions"],g["inspect-brk-extensions"],5870,d,g.debugId,g.extensionEnvironment)}e.$_l=b;function O(g,d,S,w,$,h){const I=Number(d||g)||(w?null:S),p=I?!!d:!1;let P;if(h)try{P=JSON.parse(h)}catch{}return{port:I,break:p,debugId:$,env:P}}e.$am=O}),function(){"use strict";function J(e,A,N){function R(j,v){const u=L(j,v),c=[u];return e.isAbsolute(u)||c.unshift(N),e.resolve(...c)}function L(j,v){process.env.VSCODE_DEV&&(v="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,v);const b=j["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(O,"AppData","Roaming")}break;case"darwin":c=e.join(A.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,v)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,A,N){return J(e,A,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),A=require("os");module.exports=J(e,A,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=void 0;class L extends N.$$l{constructor(c,b){super(c,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,R.getUserDataPath)(c,b.nameShort)},b)}}e.$bm=L;function j(u,c){return(0,N.$am)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$cm=j;function v(u,c){return(0,N.$am)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$dm=v}),define(ne[112],re([0,1,3,94]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;function R(j,v,u,c){try{L(j,v,u,c)}catch(b){j.error(b?.message??b)}return v}e.$pp=R;function L(j,v,u,c){const b=(O,g,d)=>{const S=O[g];if((0,A.$wf)(S)){const w=S,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const h=w.substr(1,$-2);let f=u[h];f===void 0&&c&&(f=c[h]);const I=typeof f=="string"?f:f?.message,p=c?.[h],P=typeof p=="string"?p:p?.message;if(!I){P||j.warn(`[${v.name}]: ${(0,N.localize)(0,null,h)}`);return}if(d&&(g==="title"||g==="category")&&P&&P!==I){const t={value:I,original:P};O[g]=t}else O[g]=I}}else if((0,A.$yf)(S))for(const w in S)S.hasOwnProperty(w)&&(w==="commands"?b(S,w,!0):b(S,w,d));else if(Array.isArray(S))for(let w=0;w<S.length;w++)b(S,w,d)};for(const O in v)v.hasOwnProperty(O)&&b(v,O)}}),define(ne[48],re([0,1,17,54,98,42]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||j.test(h)}e.$Do=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(j);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Eo=c;function b(h){if(!h)return null;const f=h.majorBase,I=h.majorMustEqual,p=h.minorBase;let P=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(f===0||(P=!1),a=!1);let i=0;if(h.preRelease){const n=v.exec(h.preRelease);if(n){const[,s,r,l]=n;i=Date.UTC(Number(s),Number(r)-1,Number(l))}}return{majorBase:f,majorMustEqual:I,minorBase:p,minorMustEqual:P,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:i}}e.$Fo=b;function O(h,f,I){let p;typeof h=="string"?p=b(c(h)):p=h;let P;f instanceof Date?P=f.getTime():typeof f=="string"&&(P=new Date(f).getTime());let t;if(typeof I=="string"?t=b(c(I)):t=I,!p||!t)return!1;const a=p.majorBase,i=p.minorBase,n=p.patchBase;let s=t.majorBase,r=t.minorBase,l=t.patchBase;const k=t.notBefore;let y=t.majorMustEqual,E=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?a>s?!0:a<s?!1:i>r?!0:i<r||P&&P<k?!1:n>=l:(a===1&&s===0&&(!y||!E||!D)&&(s=1,r=0,l=0,y=!0,E=!1,D=!1),a<s?!1:a>s?!y:i<r?!1:i>r?!E:n<l?!1:n>l?!D:!(P&&P<k))}e.$Go=O;function g(h,f,I,p,P){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([N.default.Error,R.localize(0,null)]),t;if(typeof p.name!="string")return t.push([N.default.Error,R.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([N.default.Error,R.localize(2,null,"version")]),t;if(!p.engines)return t.push([N.default.Error,R.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([N.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return t.push([N.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return t.push([N.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([N.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([N.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([N.default.Error,R.localize(9,null,"main")]),t;{const n=(0,A.$tg)(I,p.main);(0,A.$ng)(n,I)||t.push([N.default.Warning,R.localize(10,null,n.path,I.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([N.default.Error,R.localize(11,null,"browser")]),t;{const n=(0,A.$tg)(I,p.browser);(0,A.$ng)(n,I)||t.push([N.default.Warning,R.localize(12,null,n.path,I.path)])}}if(!L.valid(p.version))return t.push([N.default.Error,R.localize(13,null)]),t;const a=[];if(!d(h,f,p,P,a))for(const n of a)t.push([N.default.Error,n]);return t}e.$Ho=g;function d(h,f,I,p,P){return p||typeof I.main>"u"&&typeof I.browser>"u"?!0:w(h,f,I.engines.vscode,P)}e.$Io=d;function S(h,f,I){return h==="*"||w(f,I,h)}e.$Jo=S;function w(h,f,I,p=[]){const P=b(c(I));if(!P)return p.push(R.localize(14,null,I)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return p.push(R.localize(15,null,I)),!1}else if(!P.majorMustEqual)return p.push(R.localize(16,null,I)),!1;return O(h,f,P)?!0:(p.push(R.localize(17,null,h,I)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,I=h.length;f<I;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;async function R(L,j,v){let u=v&&v.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const b=(await j.readFile(L.serviceMachineIdResource)).value.toString();u=(0,N.$bg)(b)?b:null}catch{u=null}if(!u){u=(0,N.$cg)();try{await j.writeFile(L.serviceMachineIdResource,A.$_d.fromString(u))}catch{}}return v?.store("storage.serviceMachineId",u,-1,1),u}e.$4o=R}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class A{constructor(R,L=[],j=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=j}}e.$Jh=A}),define(ne[114],re([0,1,49]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.InstantiationType=void 0;const N=[];var R;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function L(v,u,c){u instanceof A.$Jh||(u=new A.$Jh(u,[],!!c)),N.push([v,u])}e.$or=L;function j(){return N}e.$pr=j}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class A{constructor(L,j){this.key=L,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$6p=A;class N{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const j of this.a.values())j.outgoing.size===0&&L.push(j);return L}insertEdge(L,j){const v=this.lookupOrInsertNode(L),u=this.lookupOrInsertNode(j);v.outgoing.set(u.key,u),u.incoming.set(v.key,v)}removeNode(L){const j=this.b(L);this.a.delete(j);for(const v of this.a.values())v.outgoing.delete(j),v.incoming.delete(j)}lookupOrInsertNode(L){const j=this.b(L);let v=this.a.get(j);return v||(v=new A(j,L),this.a.set(j,v)),v}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[j,v]of this.a)L.push(`${j}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,j]of this.a){const v=new Set([L]),u=this.c(j,v);if(u)return u}}c(L,j){for(const[v,u]of L.outgoing){if(j.has(v))return[...j,v].join(" -> ");j.add(v);const c=this.c(u,j);if(c)return c;j.delete(v)}}}e.$7p=N}),define(ne[25],re([0,1,3,11,10]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.ConfigurationTarget=e.$ii=e.$hi=e.$gi=void 0,e.$gi=(0,R.$Mh)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}e.$hi=L;function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}e.$ii=j;var v;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ji=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$ki=c;function b(h,f){const I=Object.create(null);for(const p in h)O(I,p,h[p],f);return I}e.$li=b;function O(h,f,I,p){const P=f.split("."),t=P.pop();let a=h;for(let i=0;i<P.length;i++){const n=P[i];let s=a[n];switch(typeof s){case"undefined":s=a[n]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${P.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}a=s}if(typeof a=="object"&&a!==null)try{a[t]=I}catch{p(`Ignoring ${f} as ${P.join(".")} is ${JSON.stringify(a)}`)}else p(`Ignoring ${f} as ${P.join(".")} is ${JSON.stringify(a)}`)}e.$mi=O;function g(h,f){const I=f.split(".");d(h,I)}e.$ni=g;function d(h,f){const I=f.shift();if(f.length===0){delete h[I];return}if(Object.keys(h).indexOf(I)!==-1){const p=h[I];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[I])}}function S(h,f,I){function p(a,i){let n=a;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const P=f.split("."),t=p(h,P);return typeof t>"u"?I:t}e.$oi=S;function w(h,f,I){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?A.$yf(h[p])&&A.$yf(f[p])?w(h[p],f[p],I):I&&(h[p]=f[p]):h[p]=f[p])})}e.$pi=w;function $(h){return h.replace(/[\[\]]/g,"")}e.$qi=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,A,N,R,L,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.ContextKeyExprType=e.$Ii=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",A.$j),u.set("isLinux",A.$k),u.set("isWindows",A.$i),u.set("isWeb",A.$o),u.set("isMacNative",A.$j&&!A.$o),u.set("isEdge",A.$G),u.set("isFirefox",A.$E),u.set("isChrome",A.$D),u.set("isSafari",A.$F);function c(z,o){if(u.get(z)!==void 0)throw(0,v.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,o)}e.$Ii=c;const b=Object.prototype.hasOwnProperty;var O;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const g={regexParsingWithErrorRecovery:!0},d=(0,j.localize)(0,null),S=(0,j.localize)(1,null),w=(0,j.localize)(2,null),$=(0,j.localize)(3,null),h=(0,j.localize)(4,null),f=(0,j.localize)(5,null),I=(0,j.localize)(6,null),p=(0,j.localize)(7,null);class P{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(o=g){this.k=o,this.d=new R.$Hi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(o){if(o===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(o).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const F=this.D(),C=F.type===17?f:void 0;throw this.h.push({message:h,offset:F.offset,lexeme:R.$Hi.getLexeme(F),additionalInfo:C}),P.c}return m}catch(m){if(m!==P.c)throw m;return}}l(){return this.m()}m(){const o=[this.o()];for(;this.y(16);){const m=this.o();o.push(m)}return o.length===1?o[0]:t.or(...o)}o(){const o=[this.s()];for(;this.y(15);){const m=this.s();o.push(m)}return o.length===1?o[0]:t.and(...o)}s(){if(this.y(2)){const o=this.D();switch(o.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),W.create(o.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",o)}}return this.t()}t(){const o=this.D();switch(o.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=o.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const Q=C.lexeme,H=Q.lastIndexOf("/"),ce=H===Q.length-1?void 0:this.w(Q.substring(H+1));let oe;try{oe=new RegExp(Q.substring(1,H),ce)}catch{throw this.B("REGEX",C)}return le.create(m,oe)}switch(C.type){case 10:case 19:{const Q=[C.lexeme];this.z();let H=this.D(),ce=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;Q.push(R.$Hi.getLexeme(H)),this.z(),H=this.D()}const oe=Q.join(""),ge=oe.lastIndexOf("/"),de=ge===oe.length-1?void 0:this.w(oe.substring(ge+1));let me;try{me=new RegExp(oe.substring(1,ge),de)}catch{throw this.B("REGEX",C)}return t.regex(m,me)}case 18:{const Q=C.lexeme;this.z();let H=null;if(!(0,N.$ze)(Q)){const ce=Q.indexOf("/"),oe=Q.lastIndexOf("/");if(ce!==oe&&ce>=0){const ge=Q.slice(ce+1,oe),de=Q[oe+1]==="i"?"i":"";try{H=new RegExp(ge,de)}catch{throw this.B("REGEX",C)}}}if(H===null)throw this.B("REGEX",C);return le.create(m,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const C=this.u();return t.notIn(m,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return t.equals(m,C);switch(C){case"true":return t.has(m);case"false":return t.not(m);default:return t.equals(m,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return t.notEquals(m,C);switch(C){case"true":return t.not(m);case"false":return t.has(m);default:return t.notEquals(m,C)}}case 5:return this.z(),te.create(m,this.u());case 6:return this.z(),ae.create(m,this.u());case 7:return this.z(),_.create(m,this.u());case 8:return this.z(),ue.create(m,this.u());case 13:return this.z(),t.in(m,this.u());default:return t.has(m)}}case 20:throw this.h.push({message:I,offset:o.offset,lexeme:"",additionalInfo:p}),P.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const o=this.D();switch(o.type){case 17:case 18:return this.z(),o.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(o){return o.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(o){return this.C(o)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(o,m){if(this.C(o))return this.z();throw this.B(m,this.D())}B(o,m,F){const C=(0,j.localize)(8,null,o,R.$Hi.getLexeme(m)),Q=m.offset,H=R.$Hi.getLexeme(m);return this.h.push({message:C,offset:Q,lexeme:H,additionalInfo:F}),P.c}C(o){return this.D().type===o}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ji=P;class t{static false(){return s.INSTANCE}static true(){return r.INSTANCE}static has(o){return l.create(o)}static equals(o,m){return k.create(o,m)}static notEquals(o,m){return D.create(o,m)}static regex(o,m){return le.create(o,m)}static in(o,m){return y.create(o,m)}static notIn(o,m){return E.create(o,m)}static not(o){return W.create(o)}static and(...o){return G.create(o,null,!0)}static or(...o){return T.create(o,null,!0)}static greater(o,m){return _.create(o,m)}static greaterEquals(o,m){return ue.create(o,m)}static smaller(o,m){return te.create(o,m)}static smallerEquals(o,m){return ae.create(o,m)}static{this.c=new P({regexParsingWithErrorRecovery:!1})}static deserialize(o){return o==null?void 0:this.c.parse(o)}}e.$Ki=t;function a(z){const o=new P({regexParsingWithErrorRecovery:!1});return z.map(m=>(o.parse(m),o.lexingErrors.length>0?o.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,j.localize)(9,null,F.additionalInfo):(0,j.localize)(10,null),offset:F.offset,length:F.lexeme.length})):o.parsingErrors.length>0?o.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$Li=a;function i(z,o){const m=z?z.substituteConstants():void 0,F=o?o.substituteConstants():void 0;return!m&&!F?!0:!m||!F?!1:m.equals(F)}e.$Mi=i;function n(z,o){return z.cmp(o)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return r.INSTANCE}}e.$Ni=s;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return s.INSTANCE}}e.$Oi=r;class l{static create(o,m=null){const F=u.get(o);return typeof F=="boolean"?F?r.INSTANCE:s.INSTANCE:new l(o,m)}constructor(o,m){this.key=o,this.c=m,this.type=2}cmp(o){return o.type!==this.type?this.type-o.type:B(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}substituteConstants(){const o=u.get(this.key);return typeof o=="boolean"?o?r.INSTANCE:s.INSTANCE:this}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Pi=l;class k{static create(o,m,F=null){if(typeof m=="boolean")return m?l.create(o,F):W.create(o,F);const C=u.get(o);return typeof C=="boolean"?m===(C?"true":"false")?r.INSTANCE:s.INSTANCE:new k(o,m,F)}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=4}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?r.INSTANCE:s.INSTANCE}return this}evaluate(o){return o.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(o){return o.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Qi=k;class y{static create(o,m){return new y(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=10,this.c=null}cmp(o){return o.type!==this.type?this.type-o.type:X(this.d,this.f,o.d,o.f)}equals(o){return o.type===this.type?this.d===o.d&&this.f===o.f:!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.f),F=o.getValue(this.d);return Array.isArray(m)?m.includes(F):typeof F=="string"&&typeof m=="object"&&m!==null?b.call(m,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(o){return o.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Ri=y;class E{static create(o,m){return new E(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=11,this.c=y.create(o,m)}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(o){return o.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Si=E;class D{static create(o,m,F=null){if(typeof m=="boolean")return m?W.create(o,F):l.create(o,F);const C=u.get(o);return typeof C=="boolean"?m===(C?"true":"false")?s.INSTANCE:r.INSTANCE:new D(o,m,F)}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=5}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?s.INSTANCE:r.INSTANCE}return this}evaluate(o){return o.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(o){return o.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Ti=D;class W{static create(o,m=null){const F=u.get(o);return typeof F=="boolean"?F?s.INSTANCE:r.INSTANCE:new W(o,m)}constructor(o,m){this.c=o,this.d=m,this.type=3}cmp(o){return o.type!==this.type?this.type-o.type:B(this.c,o.c)}equals(o){return o.type===this.type?this.c===o.c:!1}substituteConstants(){const o=u.get(this.c);return typeof o=="boolean"?o?s.INSTANCE:r.INSTANCE:this}evaluate(o){return!o.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(o){return o.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Ui=W;function x(z,o){if(typeof z=="string"){const m=parseFloat(z);isNaN(m)||(z=m)}return typeof z=="string"||typeof z=="number"?o(z):s.INSTANCE}class _{static create(o,m,F=null){return x(m,C=>new _(o,C,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=12}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Vi=_;class ue{static create(o,m,F=null){return x(m,C=>new ue(o,C,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=13}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Wi=ue;class te{static create(o,m,F=null){return x(m,C=>new te(o,C,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=14}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Xi=te;class ae{static create(o,m,F=null){return x(m,C=>new ae(o,C,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=15}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Yi=ae;class le{static create(o,m){return new le(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=7,this.c=null}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.d<o.d)return-1;if(this.d>o.d)return 1;const m=this.f?this.f.source:"",F=o.f?o.f.source:"";return m<F?-1:m>F?1:0}equals(o){if(o.type===this.type){const m=this.f?this.f.source:"",F=o.f?o.f.source:"";return this.d===o.d&&m===F}return!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const o=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${o}`}keys(){return[this.d]}map(o){return o.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Zi=le;class ie{static create(o){return new ie(o)}constructor(o){this.c=o,this.type=8}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(o){return new ie(this.c.map(o))}negate(){return this.c}}e.$1i=ie;function q(z){let o=null;for(let m=0,F=z.length;m<F;m++){const C=z[m].substituteConstants();if(z[m]!==C&&o===null){o=[];for(let Q=0;Q<m;Q++)o[Q]=z[Q]}o!==null&&(o[m]=C)}return o===null?z:o}class G{static create(o,m,F){return G.d(o,m,F)}constructor(o,m){this.expr=o,this.c=m,this.type=6}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const C=n(this.expr[m],o.expr[m]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=q(this.expr);return o===this.expr?this:G.create(o,this.c,!1)}evaluate(o){for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].evaluate(o))return!1;return!0}static d(o,m,F){const C=[];let Q=!1;for(const H of o)if(H){if(H.type===1){Q=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){C.push(...H.expr);continue}C.push(H)}if(C.length===0&&Q)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(n);for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];for(;C.length>1;){const H=C[C.length-1];if(H.type!==9)break;C.pop();const ce=C.pop(),oe=C.length===0,ge=T.create(H.expr.map(de=>G.create([de,ce],null,F)),null,oe);ge&&(C.push(ge),C.sort(n))}if(C.length===1)return C[0];if(F){for(let H=0;H<C.length;H++)for(let ce=H+1;ce<C.length;ce++)if(C[H].negate().equals(C[ce]))return s.INSTANCE;if(C.length===1)return C[0]}return new G(C,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new G(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());this.c=T.create(o,this,!0)}return this.c}}e.$2i=G;class T{static create(o,m,F){return T.d(o,m,F)}constructor(o,m){this.expr=o,this.c=m,this.type=9}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const C=n(this.expr[m],o.expr[m]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=q(this.expr);return o===this.expr?this:T.create(o,this.c,!1)}evaluate(o){for(let m=0,F=this.expr.length;m<F;m++)if(this.expr[m].evaluate(o))return!0;return!1}static d(o,m,F){let C=[],Q=!1;if(o){for(let H=0,ce=o.length;H<ce;H++){const oe=o[H];if(oe){if(oe.type===0){Q=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&Q)return s.INSTANCE;C.sort(n)}if(C.length!==0){if(C.length===1)return C[0];for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];if(F){for(let H=0;H<C.length;H++)for(let ce=H+1;ce<C.length;ce++)if(C[H].negate().equals(C[ce]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new T(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());for(;o.length>1;){const m=o.shift(),F=o.shift(),C=[];for(const Q of U(m))for(const H of U(F))C.push(G.create([Q,H],null,!1));o.unshift(T.create(C,null,!1))}this.c=T.create(o,this,!0)}return this.c}}e.$3i=T;class M extends l{static{this.d=[]}static all(){return M.d.values()}constructor(o,m,F){super(o,null),this.f=m,typeof F=="object"?M.d.push({...F,key:o}):F!==!0&&M.d.push({key:o,description:F,type:m!=null?typeof m:void 0})}bindTo(o){return o.createKey(this.key,this.f)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(o){return k.create(this.key,o)}notEqualsTo(o){return D.create(this.key,o)}}e.$4i=M,e.$5i=(0,L.$Mh)("contextKeyService");function B(z,o){return z<o?-1:z>o?1:0}function X(z,o,m,F){return z<m?-1:z>m?1:o<F?-1:o>F?1:0}function Z(z,o){if(z.type===0||o.type===1)return!0;if(z.type===9)return o.type===9?K(z.expr,o.expr):!1;if(o.type===9){for(const m of o.expr)if(Z(z,m))return!0;return!1}if(z.type===6){if(o.type===6)return K(o.expr,z.expr);for(const m of z.expr)if(Z(m,o))return!0;return!1}return z.equals(o)}e.$6i=Z;function K(z,o){let m=0,F=0;for(;m<z.length&&F<o.length;){const C=z[m].cmp(o[F]);if(C<0)return!1;C===0&&m++,F++}return m===z.length}function U(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0,e.$Fn=(0,A.$Mh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=void 0,e.$Th=(0,A.$Mh)("environmentService"),e.$Uh=(0,A.$Nh)(e.$Th)}),define(ne[21],re([0,1,92,10]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$2n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0,e.$On="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Pn=new RegExp(e.$On),e.$Qn="__web_extension",e.$Rn="skipWalkthrough",e.$Sn="extensionsSync",e.$Tn="dependecyOrPackExtensionInstall";function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Un=R;function L(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Vn=L;function j(f,I){switch(f){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Wn=j;function v(f,I){return I==="web"&&!f.includes("web")}e.$Xn=v;function u(f,I,p){return v(I,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:c(p).includes(f)}e.$Yn=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Zn=c;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$1n=b;var O;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var g;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var S;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$2n=(0,N.$Mh)("extensionGalleryService");var w;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(I,p){super(I),this.code=p,this.name=p}}e.$3n=h,e.$4n=(0,N.$Mh)("extensionManagementService"),e.$5n="extensionsIdentifiers/disabled",e.$6n="extensionsIdentifiers/enabled",e.$7n=(0,N.$Mh)("IGlobalExtensionEnablementService"),e.$8n=(0,N.$Mh)("IExtensionTipsService"),e.$9n=(0,A.localize)(0,null),e.$0n={value:e.$9n,original:"Extensions"},e.$$n={value:(0,A.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=void 0,e.$9o=(0,A.$Mh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((L,j)=>J(["node-vsce-sign"],async v=>L(v),j))),this.a}async verify(L,j,v){let u;try{u=await this.b()}catch{return!1}return u.verify(L,j,v)}}e.$0o=N}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;async function j(b,O,g,d,S,w){let $;try{await v(b,O,g,d,S,w)}catch(h){$=h}finally{$&&S.errorTransformer&&($=S.errorTransformer($)),typeof $<"u"&&g.error($),g.end()}}e.$Ep=j;async function v(b,O,g,d,S,w){u(w);const $=await b.open(O,{create:!1});try{u(w);let h=0,f=0,I=S&&typeof S.length=="number"?S.length:void 0,p=A.$_d.alloc(Math.min(S.bufferSize,typeof I=="number"?I:S.bufferSize)),P=S&&typeof S.position=="number"?S.position:0,t=0;do f=await b.read($,P,p.buffer,t,p.byteLength-t),P+=f,t+=f,h+=f,typeof I=="number"&&(I-=f),t===p.byteLength&&(await g.write(d(p)),p=A.$_d.alloc(Math.min(S.bufferSize,typeof I=="number"?I:S.bufferSize)),t=0);while(f>0&&(typeof I!="number"||I>0)&&u(w)&&c(h,S));if(t>0){let a=t;typeof I=="number"&&(a=Math.min(t,I)),g.write(d(p.slice(0,a)))}}catch(h){throw(0,L.$ik)(h)}finally{await b.close($)}}function u(b){if(b.isCancellationRequested)throw(0,N.$4)();return!0}function c(b,O){if(typeof O?.limits?.size=="number"&&b>O.limits.size)throw(0,L.$hk)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,A,N,R,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class v extends R.$Qc{constructor(){super(...arguments),this.a=this.B(new A.$Ld),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$Ld),this.onDidLogMessage=this.b.event,this.onDidError=A.Event.None,this.c=new Map,this.f=!1}async watch(c){const b=this.j(c),O=b.filter(d=>{const S=this.c.get(d.path);return S?!(0,N.$xj)(S.request.excludes,d.excludes)||!(0,N.$xj)(S.request.includes,d.includes):!0}),g=Array.from(this.c.values()).filter(({request:d})=>!b.find(S=>S.path===d.path&&(0,N.$xj)(S.excludes,d.excludes)&&(0,N.$xj)(S.includes,d.includes))).map(({request:d})=>d.path);O.length&&this.m(`Request to start watching: ${O.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const d of g)this.h(d);for(const d of O)this.g(d)}g(c){const b=new j.$1p(c,g=>this.a.fire(g),g=>this.b.fire(g),this.f),O={request:c,instance:b};this.c.set(c.path,O)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const b=this.c.get(c);b&&(this.c.delete(c),b.instance.dispose())}j(c){const b=new Map;for(const O of c){const g=L.$k?O.path:O.path.toLowerCase();b.set(g,O)}return Array.from(b.values())}async setVerboseLogging(c){this.f=c;for(const[,b]of this.c)b.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,b){return b?`[File Watcher (node.js)] ${c} (path: ${b.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$3p=v}),define(ne[118],re([0,1,62,117]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class R extends A.$Ip{constructor(j,v,u){super(j,v,u),this.s()}r(j){return j.add(new N.$3p)}}e.$4p=R}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;class j extends L.$Jp{constructor(u,c,b){super(u,c,b),this.s()}r(u){const c=u.add(new R.$Up(A.$ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:b,signal:O})=>this.t(`terminated by itself with code ${b}, signal: ${O}`))),N.ProxyChannel.toService((0,N.$th)(c.getChannel("watcher")))}}e.$Vp=j}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class A{constructor(...R){this.a=new Map;for(const[L,j]of R)this.set(L,j)}set(R,L){const j=this.a.get(R);return this.a.set(R,L),j}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$Kh=A}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,A,N,R,L,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;const b=!1;class O extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class g{constructor($=new u.$Kh,h=!1,f,I=b){this.f=$,this.g=h,this.h=f,this.i=I,this.o=new Set,this.f.set(v.$Lh,this),this._globalGraph=I?f?._globalGraph??new j.$7p(p=>p):void 0}createChild($){return new g($,this.g,this,this.i)}invokeFunction($,...h){const f=S.traceInvocation(this.i,$);let I=!1;try{return $({get:P=>{if(I)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(P,f);if(!t)throw new Error(`[invokeFunction] unknown service '${P}'`);return t}},...h)}finally{I=!0,f.stop()}}createInstance($,...h){let f,I;return $ instanceof L.$Jh?(f=S.traceCreation(this.i,$.ctor),I=this.j($.ctor,$.staticArguments.concat(h),f)):(f=S.traceCreation(this.i,$),I=this.j($,h,f)),f.stop(),I}j($,h=[],f){const I=v._util.getServiceDependencies($).sort((t,a)=>t.index-a.index),p=[];for(const t of I){const a=this.m(t.id,f);a||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const P=I.length>0?I[0].index:h.length;if(h.length!==P){console.trace(`[createInstance] First service dependency of ${$.name} at position ${P+1} conflicts with ${h.length} static arguments`);const t=P-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,P)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof L.$Jh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof L.$Jh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const I=new j.$7p(t=>t.id.toString());let p=0;const P=[{id:$,desc:h,_trace:f}];for(;P.length;){const t=P.pop();if(I.lookupOrInsertNode(t),p++>1e3)throw new O(I);for(const a of v._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${$} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof L.$Jh){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};I.insertEdge(t,n),P.push(n)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new O(I);break}for(const{data:a}of t){if(this.l(a.id)instanceof L.$Jh){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}I.removeNode(a)}}return this.l($)}s($,h,f=[],I,p){if(this.f.get($)instanceof L.$Jh)return this.t($,h,f,I,p);if(this.h)return this.h.s($,h,f,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],I,p){if(I){const P=new g(void 0,this.g,this,this.i);P.c=String($);const t=new Map,a=new A.$9g(()=>{const i=P.j(h,f,p);for(const[n,s]of t){const r=i[n];if(typeof r=="function")for(const l of s)r.apply(i,l)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=t.get(n);return l||(l=new c.$Zc,t.set(n,l)),(y,E,D)=>{const W=l.push([y,E,D]);return(0,R.$Oc)(W)}}if(n in i)return i[n];const s=a.value;let r=s[n];return typeof r!="function"||(r=r.bind(s),i[n]=r),r},set(i,n,s){return a.value[n]=s,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$8p=g;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new S(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation($,h){return $?new S(1,h.name):S.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new S(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;S.f+=$;let h=!1;function f(p,P){const t=[],a=new Array(p+1).join("	");for(const[i,n,s]of P.h)if(n&&s){h=!0,t.push(`${a}CREATES -> ${i}`);const r=f(p+1,s);r&&t.push(r)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];($>2||h)&&S.all.add(I.join(`
`))}}e.$9p=S});var se=this&&this.__param||function(J,e){return function(A,N){e(A,N,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,A,N,R,L,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=void 0;function u(b){return b.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$Jq=u,e.$Kq=(0,v.$Mh)("languagePackService");let c=class extends N.$Qc{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new A.$Vd;setTimeout(()=>O.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const S=g.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some($=>$.startsWith("lp-"))).map(w=>{const $=w.properties.localizedLanguages?.[0],h=u(w);return{...this.f(h,$,w),extensionId:w.identifier.id,galleryExtension:w}});return S.push(this.f("en","English")),S}f(O,g,d){const S=g??O;let w;if(S!==O&&(w=`(${O})`),O.toLowerCase()===R.$v.toLowerCase()&&(w??="",w+=(0,L.localize)(0,null)),d?.installCount){w??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),w+=` $(cloud-download) ${h}`}return{id:O,label:S,description:w}}};e.$Lq=c,e.$Lq=c=pe([se(0,j.$2n)],c)}),define(ne[6],re([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,A,N,R,L,j,v,u,c,b,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.log=e.$0i=e.LogLevel=e.$9i=e.$8i=e.$7i=void 0,e.$7i=(0,g.$Mh)("logService"),e.$8i=(0,g.$Mh)("loggerService");function d(){return new Date().toISOString()}function S(y){return(0,c.$Af)(y)}e.$9i=S;var w;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$0i=w.Info;function $(y,E,D){switch(E){case w.Trace:y.trace(D);break;case w.Debug:y.debug(D);break;case w.Info:y.info(D);break;case w.Warning:y.warn(D);break;case w.Error:y.error(D);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function h(y,E=!1){let D="";for(let W=0;W<y.length;W++){let x=y[W];if(x instanceof Error&&(x=(0,A.$xi)(x,E)),typeof x=="object")try{x=JSON.stringify(x)}catch{}D+=(W>0?" ":"")+x}return D}class f extends L.$Qc{constructor(){super(...arguments),this.b=e.$0i,this.c=this.B(new N.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$_i=f;class I extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...D){this.f(w.Trace)&&this.g(w.Trace,h([E,...D],!0))}debug(E,...D){this.f(w.Debug)&&this.g(w.Debug,h([E,...D]))}info(E,...D){this.f(w.Info)&&this.g(w.Info,h([E,...D]))}warn(E,...D){this.f(w.Warning)&&this.g(w.Warning,h([E,...D]))}error(E,...D){if(this.f(w.Error))if(E instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=E.stack,this.g(w.Error,h(W))}else this.g(w.Error,h([E,...D]))}flush(){}}e.$aj=I;class p extends f{constructor(E=e.$0i){super(),this.setLevel(E),this.g=!v.$i}trace(E,...D){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...D):console.log(`[main ${d()}]`,E,...D))}debug(E,...D){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...D):console.log(`[main ${d()}]`,E,...D))}info(E,...D){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...D):console.log(`[main ${d()}]`,E,...D))}warn(E,...D){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,E,...D):console.warn(`[main ${d()}]`,E,...D))}error(E,...D){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,E,...D):console.error(`[main ${d()}]`,E,...D))}dispose(){}flush(){}}e.$bj=p;class P extends f{constructor(E=e.$0i,D=!0){super(),this.g=D,this.setLevel(E)}trace(E,...D){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...D):console.log(E,...D))}debug(E,...D){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...D):console.log(E,...D))}info(E,...D){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...D):console.log(E,...D))}warn(E,...D){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...D):console.log(E,...D))}error(E,...D){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...D):console.error(E,...D))}dispose(){}flush(){}}e.$cj=P;class t extends f{constructor(E,D=e.$0i){super(),this.g=E,this.setLevel(D)}trace(E,...D){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...D])}debug(E,...D){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...D])}info(E,...D){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...D])}warn(E,...D){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...D])}error(E,...D){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...D])}h(E){return typeof E=="string"?E:(0,A.$xi)(E,this.f(w.Trace))}dispose(){}flush(){}}e.$dj=t;class a extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const D of this.g)D.setLevel(E);super.setLevel(E)}trace(E,...D){for(const W of this.g)W.trace(E,...D)}debug(E,...D){for(const W of this.g)W.debug(E,...D)}info(E,...D){for(const W of this.g)W.info(E,...D)}warn(E,...D){for(const W of this.g)W.warn(E,...D)}error(E,...D){for(const W of this.g)W.error(E,...D)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$ej=a;class i extends L.$Qc{constructor(E,D,W){if(super(),this.h=E,this.j=D,this.b=new j.$yc,this.c=this.B(new N.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Ld),this.onDidChangeVisibility=this.g.event,W)for(const x of W)this.b.set(x.resource,{logger:void 0,info:x})}m(E){return(0,c.$wf)(E)?[...this.b.values()].find(D=>D.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,D){const W=this.n(E),x=(0,c.$wf)(E)?E:D?.id??(0,R.$Ai)(W.toString()).toString(16);let _=this.b.get(W)?.logger;const ue=D?.logLevel==="always"?w.Trace:D?.logLevel;_||(_=this.s(W,ue??this.getLogLevel(W)??this.h,{...D,id:x}));const te={logger:_,info:{resource:W,id:x,logLevel:ue,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(te.info),this.b.set(W,te),_}n(E){return(0,c.$wf)(E)?(0,u.$tg)(this.j,`${E}.log`):E}setLogLevel(E,D){if(b.URI.isUri(E)){const W=E,x=D,_=this.b.get(W);_&&x!==_.info.logLevel&&(_.info.logLevel=x===this.h?void 0:x,_.logger?.setLevel(x),this.b.set(_.info.resource,_),this.f.fire([W,x]))}else{this.h=E;for(const[W,x]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&x.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,D){const W=this.m(E);W&&D!==!W.info.hidden&&(W.info.hidden=!D,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,D]))}getLogLevel(E){let D;return E&&(D=this.b.get(E)?.info.logLevel),D??this.h}registerLogger(E){const D=this.b.get(E.resource);D?D.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const D=this.b.get(E);D&&(D.logger&&D.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fj=i;class n{constructor(){this.onDidChangeLogLevel=new N.$Ld().event}setLevel(E){}getLevel(){return w.Info}trace(E,...D){}debug(E,...D){}info(E,...D){}warn(E,...D){}error(E,...D){}critical(E,...D){}dispose(){}flush(){}}e.$gj=n;class s extends n{}e.$hj=s;function r(y){if(y.verbose)return w.Trace;if(typeof y.logLevel=="string"){const E=k(y.logLevel.toLowerCase());if(E!==void 0)return E}return e.$0i}e.$ij=r;function l(y){switch(y){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$jj=l;function k(y){switch(y){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$kj=k,e.$lj=new O.$4i("logLevel",l(w.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,A,N,R,L,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class b extends j.$Qc{constructor(g,d){super(),this.a=g,this.b=d,this.c=this.B(new L.$Ld),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Ld),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Pg(0)),this.w=[],this.y=this.B(new N.$Pg(0))}watch(g,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(g,d):this.z(g,d)}n(g,d){const S={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,A.$Sb)(this.j,S);return this.r(),(0,j.$Oc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,R.$Y)(g))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$Kp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const d of this.j)(0,u.$Gp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const d of this.j)(0,u.$Gp)(d)&&g.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,d){const S={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,A.$Sb)(this.w,S);return this.C(),(0,j.$Oc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,R.$Y)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,u.$Kp)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,v.$fc)(g.fsPath)}}e.$Op=b}),define(ne[122],re([0,1,19,8,14,20,4,41,65,2,46,15,123,17,45,99,12,61,6,9]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;let p=class extends c.$Qc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new j.$Ld),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$Ld),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$Ld),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$Ld),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$Ld),this.onDidFilesChange=this.X.event,this.Y=this.B(new j.$Ld),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new N.$1g)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new c.$Pc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.X.fire(new $.$nk(n,!this.S(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.Y.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.$Oc)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.$Lc)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await N.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,d.$xg)(t))throw new $.$pk((0,w.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new I.$_;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async m(t){const a=await this.j(t);if((0,$.$ak)(a)||(0,$.$0j)(a)||(0,$.$bk)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,$.$ak)(a)||(0,$.$0j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(i){throw(0,$.$kk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$pk((0,w.localize)(2,null,this.qb(t)),1):(0,$.$ik)(i)}}async s(t,a){const i=await this.j(t),n=this.S(i),s=a?.resolveTo,r=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,k=await i.stat(t);let y;return this.t(i,t,k,void 0,!!l,(E,D)=>(y||(y=b.$Sh.forUris(()=>!n),y.set(t,!0),s&&y.fill(!0,s)),y.get(E.resource)||y.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&r?D===1:!1))}async t(t,a,i,n,s,r){const{providerExtUri:l}=this.R(t),k={resource:a,name:l.basename(a),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Ak)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&r(k,n)){try{const y=await t.readdir(a),E=await N.Promises.settled(y.map(async([D,W])=>{try{const x=l.joinPath(a,D),_=s?await t.stat(x):{type:W};return await this.t(t,x,_,y.length,s,r)}catch(x){return this.b.trace(x),null}}));k.children=(0,A.$Fb)(E)}catch(y){this.b.trace(y),k.children=[]}return k}return k}async resolveAll(t){return N.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.t(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(i){return i}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new $.$pk((0,w.localize)(3,null,this.qb(t)),3,a)}async createFile(t,a=R.$_d.fromString(""),i){await this.u(t,i);const n=await this.writeFile(t,a);return this.r.fire(new $.$mk(t,0,n)),n}async writeFile(t,a,i){const n=this.ob(await this.n(t),t),{providerExtUri:s}=this.R(n);let r=i;if((0,$.$dk)(n)&&!r?.atomic){const l=n.enforceAtomicWriteFile?.(t);l&&(r={...i,atomic:l})}try{await this.w(n,t,r)||await this.U(n,s.dirname(t));let k;if((0,$.$0j)(n)&&!(a instanceof R.$_d))if((0,S.$Xd)(a)){const y=await(0,S.$5d)(a,3);y.ended?k=R.$_d.concat(y.buffer):k=y}else k=(0,S.$2d)(a,y=>R.$_d.concat(y),3);else k=a;!(0,$.$ak)(n)||(0,$.$0j)(n)&&k instanceof R.$_d||(0,$.$0j)(n)&&(0,$.$dk)(n)&&r?.atomic?await this.fb(n,t,r,k):await this.bb(n,t,r,k instanceof R.$_d?(0,R.$ke)(k):k),this.r.fire(new $.$mk(t,4))}catch(l){throw new $.$pk((0,w.localize)(4,null,this.qb(t),(0,$.$ik)(l).toString()),(0,$.$lk)(l),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,i){const n=!!i?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.qb(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.qb(a)));if(!(t.capabilities&2))throw new Error((0,w.localize)(7,null,this.qb(a)));if(n)throw new Error((0,w.localize)(8,null,this.qb(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&$.FileType.Directory)throw new $.$pk((0,w.localize)(9,null,this.qb(a)),0,i);if(this.pb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$zk&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,$.$Ak)({mtime:i.mtime,size:r.size}))throw new $.$pk((0,w.localize)(10,null),3,i);return r}async readFile(t,a,i){const n=await this.m(t);return a?.atomic?this.z(n,t,a,i):this.C(n,t,a,i)}async z(t,a,i,n){return new Promise((s,r)=>{this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{try{const l=await this.C(t,a,i,n);s(l)}catch(l){r(l)}})})}async C(t,a,i,n){const s=await this.D(t,a,{...i,preferUnbuffered:!0},n);return{...s,value:await(0,R.$le)(s.value)}}async readFileStream(t,a,i){const n=await this.m(t);return this.D(n,t,a,i)}async D(t,a,i,n){const s=new L.$Vd(n);let r=i;(0,$.$ck)(t)&&t.enforceAtomicReadFile?.(a)&&(r={...i,atomic:!0});const l=this.J(a,r).then(y=>y,y=>{throw s.dispose(!0),y});let k;try{return typeof r?.etag=="string"&&r.etag!==$.$zk&&await l,r?.atomic&&(0,$.$ck)(t)||!((0,$.$ak)(t)||(0,$.$bk)(t))||(0,$.$0j)(t)&&r?.preferUnbuffered?k=this.I(t,a,r):(0,$.$bk)(t)?k=this.G(t,a,s.token,r):k=this.H(t,a,s.token,r),k.on("end",()=>s.dispose()),k.on("error",()=>s.dispose()),{...await l,value:k}}catch(y){throw k&&await(0,S.$3d)(k),this.F(y,a,r)}}F(t,a,i){const n=(0,w.localize)(11,null,this.qb(a),(0,$.$ik)(t).toString());return t instanceof $.$rk?new $.$rk(n,t.stat,i):t instanceof $.$qk?new $.$qk(n,t.fileOperationResult,t.size,t.options):new $.$pk(n,(0,$.$lk)(t),i)}G(t,a,i,n=Object.create(null)){const s=t.readFileStream(a,n,i);return(0,S.$9d)(s,{data:r=>r instanceof R.$_d?r:R.$_d.wrap(r),error:r=>this.F(r,a,n)},r=>R.$_d.concat(r))}H(t,a,i,n=Object.create(null)){const s=(0,R.$pe)();return(0,h.$Ep)(t,a,s,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>this.F(r,a,n)},i),s}I(t,a,i){const n=(0,S.$Zd)(s=>R.$_d.concat(s));return(async()=>{try{let s;i?.atomic&&(0,$.$ck)(t)?s=await t.readFile(a,{atomic:!0}):s=await t.readFile(a),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.L(a,s.byteLength,i),n.end(R.$_d.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async J(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new $.$pk((0,w.localize)(12,null,this.qb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==$.$zk&&a.etag===i.etag)throw new $.$rk((0,w.localize)(13,null),i,a);return this.L(t,i.size,a),i}L(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new $.$qk((0,w.localize)(14,null,this.qb(t)),7,a,i)}async canMove(t,a,i){return this.M(t,a,"move",i)}async canCopy(t,a,i){return this.M(t,a,"copy",i)}async M(t,a,i,n){if(t.toString()!==a.toString())try{const s=i==="move"?this.ob(await this.n(t),t):await this.m(t),r=this.ob(await this.n(a),a);await this.Q(s,t,r,a,i,n)}catch(s){return s}return!0}async move(t,a,i){const n=this.ob(await this.n(t),t),s=this.ob(await this.n(a),a),r=await this.N(n,t,s,a,"move",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$mk(t,r==="move"?2:3,l)),l}async copy(t,a,i){const n=await this.m(t),s=this.ob(await this.n(a),a),r=await this.N(n,t,s,a,"copy",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$mk(t,r==="copy"?3:2,l)),l}async N(t,a,i,n,s,r){if(a.toString()===n.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:k}=await this.Q(t,a,i,n,s,r);if(l&&!k&&r&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),s==="copy"){if(t===i&&(0,$.$$j)(t))await t.copy(a,n,{overwrite:r});else{const y=await this.resolve(a);y.isDirectory?await this.P(t,y,i,n):await this.O(t,a,i,n)}return s}else return t===i?(await t.rename(a,n,{overwrite:r}),s):(await this.N(t,a,i,n,"copy",r),await this.del(a,{recursive:!0}),"copy")}async O(t,a,i,n){if((0,$.$ak)(t)&&(0,$.$ak)(i))return this.hb(t,a,i,n);if((0,$.$ak)(t)&&(0,$.$0j)(i))return this.nb(t,a,i,n);if((0,$.$0j)(t)&&(0,$.$ak)(i))return this.lb(t,a,i,n);if((0,$.$0j)(t)&&(0,$.$0j)(i))return this.jb(t,a,i,n)}async P(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await N.Promises.settled(a.children.map(async s=>{const r=this.R(i).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.P(t,await this.resolve(s.resource),i,r):this.O(t,s.resource,i,r)}))}async Q(t,a,i,n,s,r){let l=!1;if(t===i){const{providerExtUri:y,isPathCaseSensitive:E}=this.R(t);if(E||(l=y.isEqual(a,n)),l&&s==="copy")throw new Error((0,w.localize)(15,null,this.qb(a),this.qb(n)));if(!l&&y.isEqualOrParent(n,a))throw new Error((0,w.localize)(16,null,this.qb(a),this.qb(n)))}const k=await this.exists(n);if(k&&!l){if(!r)throw new $.$pk((0,w.localize)(17,null,this.qb(a),this.qb(n)),4);if(t===i){const{providerExtUri:y}=this.R(t);if(y.isEqualOrParent(a,n))throw new Error((0,w.localize)(18,null,this.qb(a),this.qb(n)))}}return{exists:k,isSameResourceWithDifferentPathCase:l}}R(t){const a=this.S(t);return{providerExtUri:a?d.$jg:d.$lg,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.ob(await this.j(t),t);await this.U(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$mk(t,0,i)),i}async U(t,a){const i=[],{providerExtUri:n}=this.R(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&$.FileType.Directory))throw new Error((0,w.localize)(19,null,this.qb(a)));break}catch(s){if((0,$.$kk)(s)!==$.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(n.basename(a)),a=n.dirname(a)}for(let s=i.length-1;s>=0;s--){a=n.joinPath(a,i[s]);try{await t.mkdir(a)}catch(r){if((0,$.$kk)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.W(t,a)}catch(i){return i}return!0}async W(t,a){const i=this.ob(await this.j(t),t),n=!!a?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,w.localize)(20,null,this.qb(t)));const s=a?.atomic;if(s&&!(i.capabilities&65536))throw new Error((0,w.localize)(21,null,this.qb(t)));if(n&&s)throw new Error((0,w.localize)(22,null,this.qb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.pb(t,r);else throw new $.$pk((0,w.localize)(23,null,this.qb(t)),1);if(!!!a?.recursive){const k=await this.resolve(t);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,w.localize)(24,null,this.qb(t)))}return i}async del(t,a){const i=await this.W(t,a);let n=a;if((0,$.$ek)(i)&&!n?.atomic){const k=i.enforceAtomicDelete?.(t);k&&(n={...a,atomic:k})}const s=!!n?.useTrash,r=!!n?.recursive,l=n?.atomic??!1;await i.delete(t,{recursive:r,useTrash:s,atomic:l}),this.r.fire(new $.$mk(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.ob(await this.n(a),a);if(i===n&&this.R(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,$.$_j)(i))return i.cloneFile(t,a);await this.U(n,this.R(n).providerExtUri.dirname(a));const s=this.ab.queueFor(t,this.R(i).providerExtUri);return i===n&&(0,$.$$j)(i)?s.queue(()=>i.copy(t,a,{overwrite:!0})):s.queue(()=>this.O(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new c.$Pc;let n=!1,s=()=>{n=!0};return i.add((0,c.$Oc)(()=>s())),(async()=>{try{const r=await this.$(t,a);n?(0,c.$Lc)(r):s=()=>(0,c.$Lc)(r)}catch(r){this.b.error(r)}})(),i}async $(t,a){const i=await this.j(t),n=(0,v.$Ai)([this.R(i).providerExtUri.getComparisonKey(t),a]);let s=this.Z.get(n);return s||(s={count:0,disposable:i.watch(t,a)},this.Z.set(n,s)),s.count+=1,(0,c.$Oc)(()=>{s&&(s.count--,s.count===0&&((0,c.$Lc)(s.disposable),this.Z.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,c.$Lc)(t.disposable);this.Z.clear()}async bb(t,a,i,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{const s=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,S.$Xd)(n)||(0,S.$Yd)(n)?await this.cb(t,s,n):await this.db(t,s,n)}catch(r){throw(0,$.$ik)(r)}finally{await t.close(s)}})}async cb(t,a,i){let n=0,s;if((0,S.$Yd)(i)){if(i.buffer.length>0){const r=R.$_d.concat(i.buffer);await this.eb(t,a,r,r.byteLength,n,0),n+=r.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((r,l)=>{(0,S.$4d)(s,{onData:async k=>{s.pause();try{await this.eb(t,a,k,k.byteLength,n,0)}catch(y){return l(y)}n+=k.byteLength,setTimeout(()=>s.resume())},onError:k=>l(k),onEnd:()=>r()})})}async db(t,a,i){let n=0,s;for(;(s=i.read())!==null;)await this.eb(t,a,s,s.byteLength,n,0),n+=s.byteLength}async eb(t,a,i,n,s,r){let l=0;for(;l<n;){const k=await t.write(a,s+l,i.buffer,r+l,n-l);l+=k}}async fb(t,a,i,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(()=>this.gb(t,a,i,n))}async gb(t,a,i,n){let s;n instanceof R.$_d?s=n:(0,S.$Xd)(n)?s=await(0,R.$le)(n):(0,S.$Yd)(n)?s=await(0,R.$me)(n):s=(0,R.$je)(n),await t.writeFile(a,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async hb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ib(t,a,i,n))}async ib(t,a,i,n){let s,r;try{s=await t.open(a,{create:!1}),r=await i.open(n,{create:!0,unlock:!1});const l=R.$_d.alloc(this.a);let k=0,y=0,E=0;do E=await t.read(s,k,l.buffer,y,l.byteLength-y),await this.eb(i,r,l,E,k,y),k+=E,y+=E,y===l.byteLength&&(y=0);while(E>0)}catch(l){throw(0,$.$ik)(l)}finally{await N.Promises.settled([typeof s=="number"?t.close(s):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async jb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(t,a,i,n))}async kb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(t,a,i,n))}async mb(t,a,i,n){const s=await i.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.eb(i,s,R.$_d.wrap(r),r.byteLength,0,0)}catch(r){throw(0,$.$ik)(r)}finally{await i.close(s)}}async nb(t,a,i,n){const s=await(0,R.$le)(this.H(t,a,L.CancellationToken.None));await this.fb(i,n,void 0,s)}ob(t,a){if(t.capabilities&2048)throw new $.$pk((0,w.localize)(25,null,this.qb(a)),6);return t}pb(t,a){if((a.permissions??0)&$.FilePermission.Readonly)throw new $.$pk((0,w.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===O.Schemas.file?t.fsPath:t.toString(!0)}};e.$Fp=p,e.$Fp=p=pe([se(0,f.$7i)],p)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f,I,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0,(()=>{try{(0,N.gracefulify)(A)}catch(a){console.error(`Error enabling graceful-fs: ${(0,I.$xi)(a)}`)}})();class t extends f.$Op{static{this.I=!1}constructor(i,n){super(i,n),this.onDidChangeCapabilities=v.Event.None,this.N=new L.$yc(s=>g.$kg.getComparisonKey(s)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,O.$k&&(this.J|=1024)),this.J}async stat(i){try{const{stat:n,symbolicLink:s}=await S.SymlinkSupport.stat(this.H(i));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:$.FilePermission.Locked}}catch(n){throw this.eb(n)}}async L(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const n=await S.Promises.readdir(this.H(i),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,g.$tg)(i,r.name))).type:l=this.M(r),s.push([r.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.eb(n)}}M(i,n){let s;return n?.dangling?s=$.FileType.Unknown:i.isFile()?s=$.FileType.File:i.isDirectory()?s=$.FileType.Directory:s=$.FileType.Unknown,n&&(s|=$.FileType.SymbolicLink),s}async O(i){const n=this.H(i);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(i);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const r=new R.$Qg;return this.N.set(i,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.$Oc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(i)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(i)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(i,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(i)})`),s=await this.O(i));const r=this.H(i);return await S.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{s?.dispose()}}P(i){t.I&&this.a.trace(i)}readFileStream(i,n,s){const r=(0,d.$Zd)(l=>j.$_d.concat(l.map(k=>j.$_d.wrap(k))).buffer);return(0,h.$Ep)(this,i,r,l=>l.buffer,{...n,bufferSize:256*1024},s),r}async writeFile(i,n,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.Q(i,(0,g.$tg)((0,g.$sg)(i),`${(0,g.$qg)(i)}${s.atomic.postfix}`),n,s):this.R(i,n,s)}async Q(i,n,s,r){const l=new c.$Pc;try{l.add(await this.O(i)),l.add(await this.O(n)),await this.R(n,s,r,!0);try{await this.rename(n,i,{overwrite:!0})}catch(k){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async R(i,n,s,r){let l;try{const k=this.H(i);if(!s.create||!s.overwrite){if(await S.Promises.exists(k)){if(!s.overwrite)throw(0,$.$hk)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,$.$hk)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock},r),await this.write(l,0,n,0,n.byteLength)}catch(k){throw await this.fb(i,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.X=!0}static configureFlushOnWrite(i){t.X=i}async open(i,n,s){const r=this.H(i);let l;(0,$.$9j)(n)&&!s&&(l=await this.O(i));let k;try{if((0,$.$9j)(n)&&n.unlock)try{const{stat:E}=await S.SymlinkSupport.stat(r);E.mode&128||await S.Promises.chmod(r,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let y;if((0,$.$9j)(n)){if(O.$i)try{await S.Promises.truncate(r,0),y="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}y||(y="w")}else y="r";k=await S.Promises.open(r,y)}catch(y){throw l?.dispose(),(0,$.$9j)(n)?await this.fb(i,y):this.eb(y)}if(this.S.set(k,0),(0,$.$9j)(n)&&this.W.set(k,i),l){const y=this.U.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.U.set(k,l),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),y.dispose())}return k}async close(i){const n=this.U.get(i);try{if(this.S.delete(i),this.W.delete(i)&&t.X)try{await S.Promises.fdatasync(i)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await S.Promises.close(i)}catch(s){throw this.eb(s)}finally{n&&(this.U.get(i)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.U.delete(i)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,s,r,l){const k=this.Y(i,n);let y=null;try{y=(await S.Promises.read(i,s,r,l,k)).bytesRead}catch(E){throw this.eb(E)}finally{this.Z(i,k,y)}return y}Y(i,n){return n===this.S.get(i)?null:n}Z(i,n,s){const r=this.S.get(i);typeof r=="number"&&(typeof n=="number"||(typeof s=="number"?this.S.set(i,r+s):this.S.delete(i)))}async write(i,n,s,r,l){return(0,R.$0g)(()=>this.$(i,n,s,r,l),100,3)}async $(i,n,s,r,l){const k=this.Y(i,n);let y=null;try{y=(await S.Promises.write(i,s,r,l,k)).bytesWritten}catch(E){throw await this.fb(this.W.get(i),E)}finally{this.Z(i,k,y)}return y}async mkdir(i){try{await S.Promises.mkdir(this.H(i))}catch(n){throw this.eb(n)}}async delete(i,n){try{const s=this.H(i);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,b.$hc)((0,b.$kc)(s),`${(0,b.$lc)(s)}${n.atomic.postfix}`)),await S.Promises.rm(s,S.RimRafMode.MOVE,r)}else try{await S.Promises.unlink(s)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:y}=await S.SymlinkSupport.stat(s);l=k.isDirectory()&&!y}catch{}if(l)await S.Promises.rmdir(s);else throw r}else throw r}}catch(s){throw this.eb(s)}}async rename(i,n,s){const r=this.H(i),l=this.H(n);if(r!==l)try{await this.ab(i,n,"move",s.overwrite),await S.Promises.rename(r,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,w.localize)(2,null,(0,b.$lc)(r),(0,b.$lc)((0,b.$kc)(l)),k.toString()))),this.eb(k)}}async copy(i,n,s){const r=this.H(i),l=this.H(n);if(r!==l)try{await this.ab(i,n,"copy",s.overwrite),await S.Promises.copy(r,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,w.localize)(3,null,(0,b.$lc)(r),(0,b.$lc)((0,b.$kc)(l)),k.toString()))),this.eb(k)}}async ab(i,n,s,r){const l=this.H(i),k=this.H(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,u.$Uf)(l,k,!0)),y){if(s==="copy")throw(0,$.$hk)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const D=await this.L(i);if(!D)throw(0,$.$hk)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const W=await this.L(n);if(W){if(!r)throw(0,$.$hk)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);D.type&$.FileType.File&&W.type&$.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,n){return this.bb(i,n,!1)}async bb(i,n,s){const r=this.H(i),l=this.H(n),k=!!(this.capabilities&1024);if((0,u.$Uf)(r,l,!k))return;const y=new c.$Pc;try{y.add(await this.O(i)),y.add(await this.O(n)),s&&await S.Promises.mkdir((0,b.$kc)(l),{recursive:!0}),await S.Promises.copyFile(r,l)}catch(E){if(E.code==="ENOENT"&&!s)return this.bb(i,n,!0);throw this.eb(E)}finally{y.dispose()}}t(i,n,s){return new p.$Vp(r=>i(r),r=>n(r),s)}F(i,n,s){return new P.$4p(r=>i(r),r=>n(r),s)}eb(i){if(i instanceof $.$gk)return i;let n=i,s;switch(i.code){case"ENOENT":s=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=$.FileSystemProviderErrorCode.Unknown;break;default:s=$.FileSystemProviderErrorCode.Unknown}return(0,$.$hk)(n,s)}async fb(i,n){let s=this.eb(n);if(i&&s.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await S.SymlinkSupport.stat(this.H(i));r.mode&128||(s=(0,$.$hk)(n,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}e.$5p=t}),define(ne[126],re([0,1,2,6]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;class R extends A.$Qc{constructor(j,v=[]){super(),this.a=new N.$ej([j,...v]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...v){this.a.trace(j,...v)}debug(j,...v){this.a.debug(j,...v)}info(j,...v){this.a.info(j,...v)}warn(j,...v){this.a.warn(j,...v)}error(j,...v){this.a.error(j,...v)}flush(){this.a.flush()}}e.$tN=R}),define(ne[127],re([0,1,12,6]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function L(c,b,O,g,d){try{const S=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});S.setFlushOn(R.Trace);const w=await S.createAsyncRotatingLogger(c,b,O,g);return d?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function j(c,b,O){switch(b){case N.LogLevel.Trace:c.trace(O);break;case N.LogLevel.Debug:c.debug(O);break;case N.LogLevel.Info:c.info(O);break;case N.LogLevel.Warning:c.warn(O);break;case N.LogLevel.Error:c.error(O);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function v(c,b){switch(b){case N.LogLevel.Trace:c.setLevel(R.Trace);break;case N.LogLevel.Debug:c.setLevel(R.Debug);break;case N.LogLevel.Info:c.setLevel(R.Info);break;case N.LogLevel.Warning:c.setLevel(R.Warning);break;case N.LogLevel.Error:c.setLevel(R.Error);break;case N.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class u extends N.$aj{constructor(b,O,g,d,S){super(),this.m=[],this.setLevel(S),this.n=this.s(b,O,g,d),this.B(this.onDidChangeLogLevel(w=>{this.r&&v(this.r,w)}))}async s(b,O,g,d){const S=g?6:1,w=30/S*A.$Ck.MB,$=await L(b,O,w,S,d);if($){this.r=$,v(this.r,this.getLevel());for(const{level:h,message:f}of this.m)j(this.r,h,f);this.m=[]}}g(b,O){this.r?j(this.r,b,O):this.getLevel()<=b&&this.m.push({level:b,message:O})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$iN=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=void 0;class L extends N.$fj{s(v,u,c){return new R.$iN((0,A.$cg)(),v.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$jN=L}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=void 0,e.$_m=(0,L.$Mh)("policy");class j extends R.$Qc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new A.$Ld),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const b=Object.keys(this.f).length;return this.f={...c,...this.f},b!==Object.keys(this.f).length&&await this.j(c),N.Iterable.reduce(this.g.entries(),(O,[g,d])=>({...O,[g]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(c,[b,O])=>({...c,[b]:{definition:O,value:this.g.get(b)}}),{})}}e.$an=j;class v{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$bn=v}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,A,N,R,L,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;function c(O,g){const d=[];for(const S of new Set(R.Iterable.concat(O.keys(),g.keys())))O.get(S)!==g.get(S)&&d.push(S);return d}let b=class extends u.$an{constructor(g,d,S){super(),this.m=g,this.n=d,this.s=S,this.c=this.B(new A.$Pg(500));const w=N.Event.filter(d.onDidFilesChange,$=>$.affects(g));this.B(d.watch(g)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const d=await this.n.readFile(this.m),S=JSON.parse(d.value.toString());if(!(0,L.$yf)(S))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(S))this.f[w]&&g.set(w,S[w])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return g}async w(){const g=await this.u(),d=c(this.g,g);this.g=g,d.length>0&&this.h.fire(d)}};e.$Q7b=b,e.$Q7b=b=pe([se(1,j.$8j),se(2,v.$7i)],b)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,A,N,R,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;let v=class extends A.$an{constructor(c,b){super(),this.m=c,this.n=b,this.a=new N.$Lg,this.b=this.B(new L.$Rc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((b,O)=>{try{this.b.value=(0,R.createWatcher)(this.n,c,g=>{this.t(g),b()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),O(g)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const b in c){const O=c[b];O===void 0?this.g.delete(b):this.g.set(b,O)}this.h.fire(Object.keys(c))}};e.$P7b=v,e.$P7b=v=pe([se(0,j.$7i)],v)}),define(ne[32],re([0,1,10]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=void 0,e.$mj=(0,A.$Mh)("productService"),e.$nj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;class R{constructor(){this.a=new Map}add(j,v){A.ok(N.$wf(j)),A.ok(N.$yf(v)),A.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,v)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$0m=new R}),define(ne[131],re([0,1,4,36]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$$m={JSONContribution:"base.contributions.json"};function R(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class L{constructor(){this.b=new A.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[R(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new L;N.$0m.add(e.$$m.JSONContribution,j)}),define(ne[43],re([0,1,19,4,3,88,25,131,36]),function(J,e,A,N,R,L,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ConfigurationScope=e.$cn=e.EditPresentationTypes=void 0;var c;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$cn={Configuration:"base.contributions.configuration"};var b;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn="vscode://schemas/settings/resourceLanguage",e.$kn="vscode://schemas/settings/configurationDefaults";const O=u.$0m.as(v.$$m.JSONContribution);class g{constructor(){this.h=new Set,this.i=new N.$Ld,this.onDidSchemaChange=this.i.event,this.j=new N.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$jn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),O.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),O.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),O.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:s}of t)for(const r in n)if(a.add(r),e.$mn.test(r)){const l=this.a.get(r),k=l?.valuesSources??new Map;if(s)for(const W of Object.keys(n[r]))k.set(W,s);const y={...l?.value||{},...n[r]};this.a.set(r,{source:s,value:y,valuesSources:k});const E=(0,j.$qi)(r),D={type:"object",default:y,description:L.localize(1,null,E),$ref:e.$jn,defaultDefaultValue:y,source:R.$wf(s)?void 0:s,defaultValueSource:s};i.push(...w(r)),this.d[r]=D,this.b.properties[r]=D}else{this.a.set(r,{value:n[r],source:s});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const s in i){const r=this.a.get(s),l=R.$wf(n)?n:n?.id,k=R.$wf(r?.source)?r?.source:r?.source?.id;if(l===k)if(a.add(s),this.a.delete(s),e.$mn.test(s))delete this.d[s],delete this.b.properties[s];else{const y=this.d[s];y&&(this.w(s,y),this.r(s,y))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const s in n.properties){a.add(s);const r=this.d[s];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(t,a=!0,i,n,s=3,r){s=R.$Ff(t.scope)?s:t.scope;const l=t.properties;if(l)for(const y in l){const E=l[y];if(a&&I(y,E)){delete l[y];continue}if(E.source=i,E.defaultDefaultValue=l[y].default,this.w(y,E),e.$mn.test(y)?E.scope=void 0:(E.scope=R.$Ff(E.scope)?s:E.scope,E.restricted=R.$Ff(E.restricted)?!!n?.includes(y):E.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),r.add(y)}const k=t.allOf;if(k)for(const y of k)this.p(y,a,i,n,s,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const r in n)this.r(r,n[r]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$dn.properties[t]=a,a.scope){case 1:e.$en.properties[t]=a;break;case 2:e.$fn.properties[t]=a;break;case 6:e.$gn.properties[t]=a;break;case 3:e.$hn.properties[t]=a;break;case 4:e.$in.properties[t]=a;break;case 5:e.$in.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$dn.properties[t],a.scope){case 1:delete e.$en.properties[t];break;case 2:delete e.$fn.properties[t];break;case 6:delete e.$gn.properties[t];break;case 3:delete e.$hn.properties[t];break;case 4:case 5:delete e.$in.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$jn};this.w(a,i),e.$dn.properties[a]=i,e.$en.properties[a]=i,e.$fn.properties[a]=i,e.$gn.properties[a]=i,e.$hn.properties[a]=i,e.$in.properties[a]=i}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$jn};e.$dn.patternProperties[e.$ln]=t,e.$en.patternProperties[e.$ln]=t,e.$fn.patternProperties[e.$ln]=t,e.$gn.patternProperties[e.$ln]=t,e.$hn.patternProperties[e.$ln]=t,e.$in.patternProperties[e.$ln]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,s=i?.source;R.$Df(n)&&(n=a.defaultDefaultValue,s=void 0),R.$Df(n)&&(n=h(a.type)),a.default=n,a.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",S=new RegExp(d,"g");e.$ln=`^(${d})+$`,e.$mn=new RegExp(e.$ln);function w(P){const t=[];if(e.$mn.test(P)){let a=S.exec(P);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=S.exec(P)}}return(0,A.$Kb)(t)}e.$nn=w;function $(P){return P.reduce((t,a)=>`${t}[${a}]`,"")}e.$on=$;function h(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$pn=h;const f=new g;u.$0m.add(e.$cn.Configuration,f);function I(P,t){return P.trim()?e.$mn.test(P)?L.localize(7,null,P):f.getConfigurationProperties()[P]!==void 0?L.localize(8,null,P):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,P,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$qn=I;function p(){const P=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))P.push([a,t[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.$rn=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,A,N,R,L,j,v,u,c,b,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=void 0;function d(a){return Object.isFrozen(a)?a:v.$Ym(a)}class S{constructor(i={},n=[],s=[],r){this.b=i,this.c=n,this.d=s,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof S)return n;const s=new w("");return s.parseRaw(n),s.configurationModel});this.f=i.reduce((n,s)=>s===n?s:n.merge(s),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.$oi)(this.contents,i):this.contents}inspect(i,n){const s=this.rawConfiguration.getValue(i),r=n?this.rawConfiguration.getOverrideValue(i,n):void 0,l=n?this.rawConfiguration.override(n).getValue(i):s;return{value:s,override:r,merged:l}}getOverrideValue(i,n){const s=this.i(n);return s?i?(0,b.$oi)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const s of this.overrides)s.identifiers.includes(i)&&n.push(...s.keys);return A.$Kb(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return A.$Kb(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=v.$Xm(this.contents),s=v.$Xm(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of i)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(n,k.contents);for(const y of k.overrides){const[E]=s.filter(D=>A.$sb(D.identifiers,y.identifiers));E?(this.h(E.contents,y.contents),E.keys.push(...y.keys),E.keys=A.$Kb(E.keys)):s.push(v.$Xm(y))}for(const y of k.keys)r.indexOf(y)===-1&&r.push(y)}return new S(n,r,s,l.every(k=>k instanceof S)?void 0:l)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const r of A.$Kb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r];const k=n[r];k&&(typeof l=="object"&&typeof k=="object"?(l=v.$Xm(l),this.h(l,k)):l=k),s[r]=l}return new S(s,this.keys,this.overrides)}h(i,n){for(const s of Object.keys(n)){if(s in i&&u.$yf(i[s])&&u.$yf(n[s])){this.h(i[s],n[s]);continue}i[s]=v.$Xm(n[s])}}i(i){let n=null,s=null;const r=l=>{l&&(s?this.h(s,l):s=v.$Xm(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===i?n=l.contents:l.identifiers.includes(i)&&r(l.contents);return r(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,b.$ni)(this.contents,i),O.$mn.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>A.$sb(s.identifiers,(0,O.$nn)(i))),1))}j(i,n,s){(0,b.$mi)(this.contents,i,n,r=>console.error(r)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),O.$mn.test(i)&&this.overrides.push({identifiers:(0,O.$nn)(i),keys:Object.keys(this.contents[i]),contents:(0,b.$li)(this.contents[i],r=>console.error(r))})}}e.$sn=S;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!u.$Ff(i)){const s=this.g(i);this.parseRaw(s,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:s,keys:r,overrides:l,restricted:k,hasExcludedProperties:y}=this.h(i,n);this.b=new S(s,r,l,y?[i]:void 0),this.c=k||[]}g(i){let n={},s=null,r=[];const l=[],k=[];function y(D){Array.isArray(r)?r.push(D):s!==null&&(r[s]=D)}const E={onObjectBegin:()=>{const D={};y(D),l.push(r),r=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const D=[];y(D),l.push(r),r=D,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(D,W,x)=>{k.push({error:D,offset:W,length:x})}};if(i)try{R.$Um(i,E),n=r[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return n}h(i,n){const s=g.$0m.as(O.$cn.Configuration).getConfigurationProperties(),r=this.i(i,s,!0,n);i=r.raw;const l=(0,b.$li)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),k=Object.keys(i),y=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:l,keys:k,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(i,n,s,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:l};const k={},y=[];for(const E in i)if(O.$mn.test(E)&&s){const D=this.i(i[E],n,!1,r);k[E]=D.raw,l=l||D.hasExcludedProperties,y.push(...D.restricted)}else{const D=n[E],W=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&y.push(E),!r.exclude?.includes(E)&&(r.include?.includes(E)||(W===void 0||r.scopes===void 0||r.scopes.includes(W))&&!(r.skipRestricted&&D?.restricted))?k[E]=i[E]:l=!0}return{raw:k,restricted:y,hasExcludedProperties:l}}j(i,n){const s=[];for(const r of Object.keys(i))if(O.$mn.test(r)){const l={};for(const k in i[r])l[k]=i[r][k];s.push({identifiers:(0,O.$nn)(r),keys:Object.keys(l),contents:(0,b.$li)(l,n)})}return s}}e.$tn=w;class $ extends L.$Qc{constructor(i,n,s,r){super(),this.c=i,this.f=n,this.g=r,this.b=this.B(new N.$Ld),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$un=$;class h{constructor(i,n,s,r,l,k,y,E,D,W,x,_,ue){this.a=i,this.b=n,this.c=s,this.overrideIdentifiers=r,this.d=l,this.f=k,this.g=y,this.h=E,this.i=D,this.j=W,this.k=x,this.l=_,this.m=ue}get value(){return d(this.c)}n(i,n,s){const r=i.inspect(n,s);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,n,s,r,l=new S,k=new S,y=new j.$yc,E=new S,D=new j.$yc){this.c=i,this.d=n,this.f=s,this.g=r,this.h=l,this.i=k,this.j=y,this.l=E,this.m=D,this.a=null,this.b=new j.$yc,this.n=null}getValue(i,n,s){return this.q(i,n,s).getValue(i)}updateValue(i,n,s={}){let r;s.resource?(r=this.m.get(s.resource),r||(r=new S,this.m.set(s.resource,r))):r=this.l,n===void 0?r.removeValue(i):r.setValue(i,n),s.resource||(this.a=null)}inspect(i,n,s){const r=this.q(i,n,s),l=this.u(n.resource,s),k=n.resource?this.m.get(n.resource)||this.l:this.l,y=new Set;for(const E of r.overrides)for(const D of E.identifiers)r.getOverrideValue(i,D)!==void 0&&y.add(D);return new h(i,n,r.getValue(i),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,k)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const s=[];if(!n){const{added:r,updated:l,removed:k}=P(this.c,i);n=[...r,...l,...k]}for(const r of n)for(const l of(0,O.$nn)(r)){const k=this.c.getKeysForOverrideIdentifier(l),y=i.getKeysForOverrideIdentifier(l),E=[...y.filter(D=>k.indexOf(D)===-1),...k.filter(D=>y.indexOf(D)===-1),...k.filter(D=>!v.$2m(this.c.override(l).getValue(D),i.override(l).getValue(D)))];s.push([l,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:s,removed:r}=P(this.d,i),l=[...n,...s,...r];return l.length&&this.updatePolicyConfiguration(i),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=P(this.applicationConfiguration,i),k=[...n,...s,...r];return k.length&&this.updateApplicationConfiguration(i),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=P(this.localUserConfiguration,i),k=[...n,...s,...r];return k.length&&this.updateLocalUserConfiguration(i),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=P(this.remoteUserConfiguration,i),k=[...n,...s,...r];return k.length&&this.updateRemoteUserConfiguration(i),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=P(this.workspaceConfiguration,i),k=[...n,...s,...r];return k.length&&this.updateWorkspaceConfiguration(i),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(i,n){const s=this.p.get(i),{added:r,updated:l,removed:k,overrides:y}=P(s,n),E=[...r,...l,...k];return(E.length||!s)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:y}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:r,removed:l,overrides:k}=P(n,void 0);return{keys:[...s,...r,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,s){let r=this.r(n,s);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}r({resource:i},n){let s=this.s();if(n&&i){const r=n.getFolder(i);r&&(s=this.t(r.uri)||s);const l=this.m.get(i);l&&(s=s.merge(l))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const s=this.s(),r=this.j.get(i);r?(n=s.merge(r),this.b.set(i,n)):n=s}return n}u(i,n){if(n&&i){const s=n.getFolder(i);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:s,overrides:r,keys:l}=this.j.get(n);return i.push([n,{contents:s,overrides:r,keys:l}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(s=>i.add(s))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r))),[...n.values()]}static parse(i){const n=this.x(i.defaults),s=this.x(i.policy),r=this.x(i.application),l=this.x(i.user),k=this.x(i.workspace),y=i.folders.reduce((E,D)=>(E.set(c.URI.revive(D[0]),this.x(D[1])),E),new j.$yc);return new f(n,s,r,l,new S,k,y,new S,new j.$yc)}static x(i){return new S(i.contents,i.keys,i.overrides)}}e.$vn=f;function I(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const r of a)r.keys.forEach(l=>i.add(l)),r.overrides.forEach(([l,k])=>{const y=(0,j.$vc)(n,l,new Set);k.forEach(E=>y.add(E))});const s=[];return n.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...i.values()],overrides:s}}e.$wn=I;class p{constructor(i,n,s,r){this.change=i,this.f=n,this.g=s,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of i.keys)this.affectedKeys.add(l);for(const[,l]of i.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,n){const s=this.a+i,r=this.d.indexOf(s);if(r<0)return!1;const l=r+s.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!v.$2m(y,E)}return!0}}e.$xn=p;function P(a,i){const{added:n,removed:s,updated:r}=t(i?.rawConfiguration,a?.rawConfiguration),l=[],k=a?.getAllOverrideIdentifiers()||[],y=i?.getAllOverrideIdentifiers()||[];if(i){const E=y.filter(D=>!k.includes(D));for(const D of E)l.push([D,i.getKeysForOverrideIdentifier(D)])}if(a){const E=k.filter(D=>!y.includes(D));for(const D of E)l.push([D,a.getKeysForOverrideIdentifier(D)])}if(i&&a){for(const E of k)if(y.includes(E)){const D=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});l.push([E,[...D.added,...D.removed,...D.updated]])}}return{added:n,removed:s,updated:r,overrides:l}}function t(a,i){const n=a?i?a.keys.filter(l=>i.keys.indexOf(l)===-1):[...a.keys]:[],s=i?a?i.keys.filter(l=>a.keys.indexOf(l)===-1):[...i.keys]:[],r=[];if(a&&i){for(const l of i.keys)if(a.keys.indexOf(l)!==-1){const k=(0,b.$oi)(i.contents,l),y=(0,b.$oi)(a.contents,l);v.$2m(k,y)||r.push(l)}}return{added:n,removed:s,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,A,N,R,L,j,v,u,c,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=void 0;class g extends R.$Qc{constructor(){super(...arguments),this.a=this.B(new N.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new v.$sn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$0m.as(u.$cn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,O.$0m.as(u.$cn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new v.$sn;const $=O.$0m.as(u.$cn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const I of $){const p=f[I],P=h[I];p!==void 0?this.b.addValue(I,p):P?this.b.addValue(I,P.default):this.b.removeValue(I)}}}e.$yn=g;class d{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new v.$sn}async initialize(){return this.configurationModel}}e.$zn=d;let S=class extends R.$Qc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new N.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new v.$sn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],I=O.$0m.as(u.$cn.Configuration).getConfigurationProperties();for(const p of $){const P=I[p];if(!P){f.push(p);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.g.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}f.push(p),h[P.policy.name]={type:P.type}}}return(0,j.$Jf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=O.$0m.as(u.$cn.Configuration).getPolicyConfigurations(),f=(0,A.$Fb)($.map(I=>h.get(I)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=O.$0m.as(u.$cn.Configuration).getConfigurationProperties(),I=[],p=this.b.isEmpty();for(const P of $){const t=f[P]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(p?a!==void 0:!(0,L.$2m)(this.b.getValue(P),a))&&I.push([P,a])}else this.b.getValue(P)!==void 0&&I.push([P,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const P=this.b;this.b=new v.$sn;for(const t of P.keys)this.b.setValue(t,P.getValue(t));for(const[t,a]of I)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};e.$An=S,e.$An=S=pe([se(1,b.$_m),se(2,c.$7i)],S)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,A,N,R,L,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=void 0;class b extends R.$Qc{constructor(g,d,S,w){super(),this.j=g,this.h=this.B(new N.$Ld),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$yn),this.c=S instanceof c.$bn?new u.$zn:this.B(new u.$An(this.b,S,w)),this.f=this.B(new v.$un(this.j,{},L.$kg,d)),this.a=new v.$vn(this.b.configurationModel,this.c.configurationModel,new v.$sn,new v.$sn),this.g=this.B(new A.$4g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,d,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new v.$vn(g,d,new v.$sn,S)}getConfigurationData(){return this.a.toData()}getValue(g,d){const S=typeof g=="string"?g:void 0,w=(0,j.$hi)(g)?g:(0,j.$hi)(d)?d:{};return this.a.getValue(S,w,void 0)}updateValue(g,d,S,w){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const d=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(S,d,2)}n(g,d){const S=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(g,d);this.s(w,S,7)}r(g){const d=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(g);this.s(S,d,7)}s(g,d,S){const w=new v.$xn(g,{data:d},this.a);w.source=S,w.sourceConfig=this.t(S),this.h.fire(w)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Bn=b}),define(ne[67],re([0,1,15]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=void 0;function N(c){return c.scheme===A.Schemas.vscodeRemote?c.authority:void 0}e.$Qk=N;function R(c){if(!c)return;const b=c.indexOf("+");return b<0?c:c.substr(0,b)}e.$Rk=R;function L(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Sk=L;function j(c){const{host:b,port:O}=u(c);if(typeof O>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:O}}e.$Tk=j;function v(c,b){let{host:O,port:g}=u(c);return typeof g>"u"&&(g=b),{host:O,port:g}}e.$Uk=v;function u(c){const b=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const O=c.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const g=c.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.TargetPlatform=e.ExtensionType=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl="extensions.user.cache",e.$Sl="extensions.builtin.cache",e.$Tl="undefined_publisher",e.$Ul=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Vl=L,e.$Wl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(j||(e.ExtensionType=j={}));var v;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,I=typeof h=="string"?h:h.value;return A.$Ze(f,I)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Xl=u;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$Yl=c;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zl=b;function O(w){return g(w)}e.$1l=O;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$2l=g;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$3l=d;function S(w,$){if($){const h=`onResolveRemoteAuthority:${(0,R.$Rk)($)}`;return!!w.activationEvents?.includes(h)}return!1}e.$4l=S,e.$5l=(0,N.$Mh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;class L extends A.$Qc{constructor(v,u,c,b,O){super(),this.a=v,this.b=u,this.c=c,this.f=O,this.B(b.onDidInstallExtensions(g=>this.g(g))),this.B(b.onDidUninstallExtension(g=>this.h(g)))}g(v){for(const u of v)u.local&&this.invalidate(u.profileLocation)}h(v){v.error||this.invalidate(v.profileLocation)}async invalidate(v){if(v)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,v)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(v){try{await this.b.del(this.c.extUri.joinPath(v.cacheHome,N.$Rl))}catch(u){(0,R.$lk)(u)!==1&&this.f.error(u)}}}e.$yp=L}),define(ne[44],re([0,1,14,9,2,103,43,10,6,36]),function(J,e,A,N,R,L,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Ko=(0,v.$Mh)("requestService");class b{constructor(P){this.b=P}toJSON(){if(!this.a){const P=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?P[t]="*****":P[t]=this.b[t];this.a=P}return this.a}}class O extends R.$Qc{constructor(P){super(),this.b=0,this.a=P.createLogger("network",{name:(0,L.localize)(0,null),when:u.$lj.isEqualTo((0,u.$jj)(u.LogLevel.Trace)).serialize()})}async c(P,t,a){const i=`${P} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new b(t.headers??{}));try{const n=await a();return this.a.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${i} - error`,t.type,(0,N.$8)(n)),n}}}e.$Lo=O;function g(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Mo=g;function d(p){return p.res.statusCode===204}e.$No=d;async function S(p){return d(p)?null:(await(0,A.$le)(p.stream)).toString()}e.$Oo=S;async function w(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);return S(p)}e.$Po=w;async function $(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,A.$le)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Qo=$;function h(p){I(p)}e.$Ro=h;let f;function I(p){const P=c.$0m.as(j.$cn.Configuration),t=f;f={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},P.updateConfigurations({add:[f],remove:t?[t]:[]})}I(1)}),define(ne[135],re([0,1,20,15,12,44]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;let j=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,b=A.CancellationToken.None){if(u.scheme===N.Schemas.file||u.scheme===N.Schemas.vscodeRemote){await this.b.copy(u,c);return}const O={type:"GET",url:u.toString(!0)},g=await this.a.request(O,b);if(g.res.statusCode===200)await this.b.writeFile(c,g.stream);else{const d=await(0,L.$Po)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${d}`)}}};e.$IN=j,e.$IN=j=pe([se(0,L.$Ko),se(1,R.$8j)],j)}),define(ne[136],re([0,1,137,3]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;function R(j,v){return j.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:j.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function L(j,v,u={}){const c=(0,A.parse)(j),b=u.proxyUrl||R(c,v);if(!b)return null;const O=(0,A.parse)(b);if(!/^https?:$/.test(O.protocol||""))return null;const g={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,N.$Cf)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,S)=>{J(["http-proxy-agent"],d,S)}))(g):new(await new Promise((d,S)=>{J(["https-proxy-agent"],d,S)}))(g)}e.$Pq=L}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=void 0;let S;async function w(h,f,I,p){return I["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$Il)(p)&&!I["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$Il)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=g.Promises.withAsyncBody(async(P,t)=>{const a=new L.$Vd;let i=1e4;const n=h.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,d.$Jl)(n,1,120)*1e3);const s=setTimeout(()=>{a.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{P(await $(f,a.token))}catch(r){!(0,v.$2)(r)&&!a.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,j.$xi)(r)))):P({})}finally{clearTimeout(s),a.dispose()}})),S)}e.$Ol=w;async function $(h,f){const I=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",I);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const P=(0,c.$cg)().replace(/-/g,"").substr(0,12),t=new RegExp(P+"({.*})"+P),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",a);const i=await(0,b.$yl)(u.OS,a);return h.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(f.isCancellationRequested)return s(new v.$3);const r=(0,N.$lc)(i);let l,k;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${y} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,k=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${y} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${y} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const E=(0,A.spawn)(i,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(E.kill(),s(new v.$3))),E.on("error",x=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,j.$xi)(x)),s(x)});const D=[];E.stdout.on("data",x=>D.push(x));const W=[];E.stderr.on("data",x=>W.push(x)),E.on("close",(x,_)=>{const ue=Buffer.concat(D).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(W).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),x||_)return s(new Error((0,R.localize)(2,null,x,_)));const ae=t.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);I?ie.ELECTRON_RUN_AS_NODE=I:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,j.$xi)(ie)),s(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=void 0,e.$kN=(0,A.$Mh)("stateReadService"),e.$lN=(0,A.$Mh)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,A,N,R,L,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.$nN=e.$mN=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class b extends R.$Qc{constructor(S,w,$,h){super(),this.h=S,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new A.$Pg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.j.error(S)}}getItem(S,w){const $=this.a[S];return(0,L.$Ff)($)?w:$}setItem(S,w){this.setItems([{key:S,data:w}])}setItems(S){let w=!1;for(const{key:$,data:h}of S)this.a[$]!==h&&((0,L.$Ff)(h)?(0,L.$Df)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=h,w=!0));w&&this.r()}removeItem(S){(0,L.$Df)(this.a[S])||(this.a[S]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.m.writeFile(this.h,N.$_d.fromString(S),{atomic:{postfix:".vsctmp"}}),this.b=S}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$mN=b;let O=class extends R.$Qc{constructor(S,w,$,h){super(),this.a=this.B(new b(w.stateResource,S,$,h))}async init(){await this.a.init()}getItem(S,w){return this.a.getItem(S,w)}};e.$nN=O,e.$nN=O=pe([se(1,j.$Th),se(2,u.$7i),se(3,v.$8j)],O);class g extends O{setItem(S,w){this.a.setItem(S,w)}setItems(S){this.a.setItems(S)}removeItem(S){this.a.removeItem(S)}close(){return this.a.close()}}e.$oN=g}),define(ne[69],re([0,1,13,35,28]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=void 0;function L(u){if(A.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,c,b,O,g,d,S,w){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,R.$cg)()+Date.now(),$.commitHash=O,$.version=g,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,A.$h)(A.$t),$["common.nodePlatform"]=N.$bc,$["common.nodeArch"]=b,$["common.product"]=w||"desktop",S&&($["common.msftInternal"]=S);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),A.$l&&($["common.snap"]="true");const I=L(c);return I&&($["common.platformDetail"]=I),$}e.$_n=j;function v(u){const c=N.env.USERDNSDOMAIN;if(!c)return!1;const b=c.toLowerCase();return u.some(O=>b===O)}e.$ao=v}),define(ne[26],re([0,1,10]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=void 0,e.$$k=(0,A.$Mh)("telemetryService"),e.$_k=(0,A.$Mh)("customEndpointTelemetryService"),e.$al="telemetry.currentSessionDate",e.$bl="telemetry.firstSessionDate",e.$cl="telemetry.lastSessionDate",e.$dl="telemetry.machineId",e.$el="telemetry",e.$fl="telemetry.telemetryLevel",e.$gl="telemetry.enableCrashReporter",e.$hl="telemetry.enableTelemetry";var N;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,A,N,R,L,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;class c{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$bo=c;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$co=b,e.$do=new b;class O{async publicLog(s,r,l){}async publicLogError(s,r,l){}}e.$eo=O,e.$fo="telemetry",e.$go="extensionTelemetryLog",e.$ho={log:()=>null,flush:()=>Promise.resolve(null)};function g(n,s){return R.Event.debounce(s.onDidChangeConfiguration,(l,k)=>{const y=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,L.$ji)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$io=g;function d(n,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!n.enableTelemetry)}e.$jo=d;function S(n,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$ko=S;function w(n){const s=n.getValue(u.$fl),r=n.getValue(u.$gl);if(n.getValue(u.$hl)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$lo=w;function $(n){const s={},r={},l={};I(n,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const y=l[k];typeof y=="number"?r[k]=y:typeof y=="boolean"?r[k]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${y.length}`),s[k]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(s[k]=y)}return{properties:s,measurements:r}}e.$mo=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(n){if(!n)return"none";const s=(0,j.$Rk)(n);return h.has(s)?s:"other"}e.$no=f;function I(n,s,r=0,l){if(n)for(const k of Object.getOwnPropertyNames(n)){const y=n[k],E=l?l+k:k;Array.isArray(y)?s[E]=(0,A.$3m)(y):y instanceof Date?s[E]=y.toISOString():(0,N.$yf)(y)?r<2?I(y,s,r+1,E+"."):s[E]=(0,A.$3m)(y):s[E]=y}}function p(n,s){const r=n.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,v.$ao)(r)||l}e.$oo=p;function P(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$po=P;function t(n,s){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const l=[];for(const D of s)for(;;){const W=D.exec(n);if(!W)break;l.push([W.index,D.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(r="";;){const D=y.exec(n);if(!D)break;const W=l.some(([x,_])=>D.index<_&&x<y.lastIndex);!k.test(D[0])&&!W&&(r+=n.substring(E,D.index)+"<REDACTED: user-file-path>",E=y.lastIndex)}return E<n.length&&(r+=n.substr(E)),r}function a(n){if(!n)return n;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function i(n,s){return(0,A.$Zm)(n,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=t(l,s);for(const k of s)l=l.replace(k,"");return l=a(l),l}})}e.$qo=i}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(J,e,A,N,R,L,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;function b(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,A.$Ue)(i.id,n.id)===0}e.$ro=b;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const s=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,s,r)}static parse(n){const s=O.exec(n);return s&&s[1]&&s[2]?new g({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,r="undefined"){this.version=s,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$so=g;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const n=d.exec(i);return n&&n[1]?[$(n[1]),n[2]]:[$(i),void 0]}e.$to=S;function w(i,n){return`${i}.${n}`}e.$uo=w;function $(i){return i.toLowerCase()}e.$vo=$;function h(i,n){return $(w(i??R.$Tl,n))}e.$wo=h;function f(i,n){const s=[],r=l=>{for(const k of s)if(k.some(y=>b(n(y),n(l))))return k;return null};for(const l of i){const k=r(l);k?k.push(l):s.push([l])}return s}e.$xo=f;function I(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$yo=I;function p(i){return{id:new c.$bo(i.identifier.id),name:new c.$bo(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$zo=p,e.$Ao=new R.$Xl("pprice.better-merge");function P(i,n){const s=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&s.every(k=>!b(k.identifier,{id:l}))){const k=i.filter(y=>b(y.identifier,{id:l}));k.length===1&&(s.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$Bo=P;async function t(i,n){if(!L.$k)return!1;let s;try{s=(await i.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,v.$8)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const s=await t(i,n),r=(0,N.$Wn)(s?"alpine":L.$t,u.$cc);return n.debug("ComputeTargetPlatform:",r),r}e.$Co=a}),define(ne[140],re([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,A,N,R,L,j,v,u,c,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0;const g=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function S($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let w=class{constructor(h,f,I){this.a=h,this.b=f,this.d=I}get f(){}async listExtensions(h,f,I){let p=await this.b.getInstalled(1,I);const P=O.$Wl.map(a=>a.toLowerCase());if(f&&f!==""){if(P.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(n=>n.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),P.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(S(a.manifest,h)))}async installExtensions(h,f,I,p){const P=[];try{const t=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const a=[];let i=[];const n=(r,l,k)=>{i.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:k,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const r of h)if(r instanceof v.URI)a.push({vsix:r,installOptions:I});else{const[l,k]=(0,b.$to)(r);n(l,k,!1)}for(const r of f)if(r instanceof v.URI)a.push({vsix:r,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,k]=(0,b.$to)(r);n(l,k,!0)}const s=await this.b.getInstalled(1,I.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:r,installOptions:l})=>{try{const k=await this.g(r,l,p,s);k&&t.push(k)}catch(k){this.a.error(k),P.push(r.toString())}})),i.length&&(i=i.filter(({id:r,version:l})=>{const k=s.find(y=>(0,b.$ro)(y.identifier,{id:r}));if(k){if(!p&&(!l||l==="prerelease"&&k.preRelease))return this.a.info((0,u.localize)(5,null,r,k.manifest.version,r)),!1;if(l&&k.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${r}@${l}`)),!1}return!0}),i.length)){const r=await this.h(i);await Promise.all(i.map(async l=>{const k=r.get(l.id.toLowerCase());if(k)try{const y=await this.j(l,k,s);y&&t.push(y)}catch(y){this.a.error(y.message||y.stack||y),P.push(l.id)}else this.a.error(`${g(l.version?`${l.id}@${l.version}`:l.id)}
${d}`),P.push(l.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,N.$8)(t))),t}if(P.length)throw new Error((0,u.localize)(8,null,P.join(", ")))}async g(h,f,I,p){const P=await this.b.getManifest(h);if(!P)throw new Error("Invalid vsix");if(await this.l(P,I,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,L.$qg)(h))),P}catch(a){if((0,N.$2)(a))return this.a.info((0,u.localize)(10,null,(0,L.$qg)(h))),null;throw a}return null}async h(h){const f=new Map,I=h.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),P=[];for(const t of h)c.$Pn.test(t.id)&&P.push({...t,preRelease:I});if(P.length){const t=await this.d.getExtensions(P,{targetPlatform:p},A.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:h,version:f,installOptions:I},p,P){const t=await this.d.getManifest(p,A.CancellationToken.None);if(t&&!this.k(t))return null;const a=P.find(i=>(0,b.$ro)(i.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{I.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const i=await this.b.installFromGallery(p,{...I,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,i.manifest.version)),t}catch(i){if((0,N.$2)(i))return this.a.info((0,u.localize)(18,null,h)),null;throw i}}k(h){return!0}async l(h,f,I,p){if(!f){const P={id:(0,b.$wo)(h.publisher,h.name)},t=p.find(a=>(0,b.$ro)(P,a.identifier)&&(0,j.gt)(a.manifest.version,h.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,I){const p=async t=>{if(t instanceof v.URI){const a=await this.b.getManifest(t);return S(a)}return t},P=[];for(const t of h){const a=await p(t),n=(await this.b.getInstalled(void 0,I)).filter(s=>(0,b.$ro)(s.identifier,{id:a}));if(!n.length)throw new Error(`${this.m(a)}
${d}`);if(n.some(s=>s.type===0)){this.a.info((0,u.localize)(20,null,a));return}if(!f&&n.some(s=>s.isBuiltin)){this.a.info((0,u.localize)(21,null,a));return}this.a.info((0,u.localize)(22,null,a));for(const s of n)await this.b.uninstall(s,{profileLocation:I}),P.push(s);this.f?this.a.info((0,u.localize)(23,null,a,this.f)):this.a.info((0,u.localize)(24,null,a))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(I=>{f.forEach(p=>{if(p.identifier.id===I&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$$o=w,e.$$o=w=pe([se(1,c.$4n),se(2,c.$2n)],w)}),define(ne[141],re([0,1,4,2,31,27,37]),function(J,e,A,N,R,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;class v extends N.$Qc{constructor(c,b,O,g,d,S,w){super(),this.f=c,this.g=b,this.h=O,this.j=g,this.m=d,this.n=S,this.r=w,this.a=this.B(new A.$Ld),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$Yc),this.s().then(null,$=>w.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(b=>(this.c.set(b.id,(0,N.$Nc)(this.n.watch(this.m.extUri.dirname(b.extensionsResource)),this.n.watch(b.extensionsResource))),this.G(b.extensionsResource))))}catch(b){throw this.r.error(b),b}}async w(c){for(const b of c.extensions)this.I(this.L(b.identifier,b.version),c.profileLocation)}async y(c){for(const b of c.extensions){const O=this.L(b.identifier,b.version);c.error?this.J(O,c.profileLocation):this.I(O,c.profileLocation)}}async z(c){for(const b of c.extensions)this.J(this.L(b.identifier,b.version),c.profileLocation)}async C(c){const b=[],O=[];for(const g of c.extensions){const d=this.L(g.identifier,g.version);c.error?this.I(d,c.profileLocation):(this.J(d,c.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),O.push(this.f.scanInstalledExtensionAtLocation(g.location).then(S=>{S?b.push(S):this.r.info("Extension not found at the location",g.location.toString())},S=>this.r.error(S)))))}try{await Promise.all(O),b.length&&await this.H(b)}catch(g){this.r.error(g)}}D(c){for(const b of this.h.profiles)c.contains(b.extensionsResource,0,1)&&this.F(b.extensionsResource)}async F(c){const b=[],O=[],g=await this.j.scanProfileExtensions(c),d=new Set,S=new Set;for(const[w,$]of this.b)$.has(c)&&S.add(w);for(const w of g){const $=this.L(w.identifier,w.version);d.add($),S.has($)||(b.push(w.identifier),this.I($,c))}for(const w of S)if(!d.has(w)){const $=this.M(w);$&&(O.push($.identifier),this.J(w,c))}(b.length||O.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:c}:void 0,removed:O.length?{extensions:O,profileLocation:c}:void 0})}async G(c){const b=await this.j.scanProfileExtensions(c);for(const O of b)this.I(this.L(O.identifier,O.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.L(O.identifier,O.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,b){let O=this.b.get(c);O||this.b.set(c,O=new R.$zc(g=>this.m.extUri.getComparisonKey(g))),O.add(b)}J(c,b){const O=this.b.get(c);O&&O.delete(b),O?.size||this.b.delete(c)}L(c,b){return`${j.$Xl.toKey(c.id)}@${b}`}M(c){const[b,O]=(0,L.$to)(c);return O?{identifier:{id:b},version:O}:void 0}}e.$zp=v}),define(ne[142],re([0,1,113,39]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=void 0;async function R(L,j,v,u,c,b,O){const g={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${j.nameShort})`};if((0,N.$jo)(j,v)&&(0,N.$lo)(u)===3){const d=await(0,A.$4o)(v,c,b);g["X-Market-User-Id"]=d,g["VSCode-SessionId"]=O.machineId||d}return g}e.$5o=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let w=class extends d.$Lq{constructor(I,p,P,t){super(P),this.h=I,this.j=t,this.g=this.B(new $(p,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(I,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.j.warn(`No language pack found for ${p}`);return}const a=t.translations[I];return a?S.URI.file(a):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),p=Object.keys(I).map(P=>{const t=I[P];return{...this.f(P,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((P,t)=>P.label.localeCompare(t.label)),p}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const p=await this.g.getLanguagePacks();Object.keys(p).some(P=>p[P]&&p[P].extensions.some(t=>(0,O.$ro)(t.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),P=await this.g.update(p);return!(0,N.$sb)(Object.keys(I),Object.keys(P))}};e.$Mq=w,e.$Mq=w=pe([se(0,b.$4n),se(1,c.$Uh),se(2,b.$2n),se(3,g.$7i)],w);let $=class extends L.$Qc{constructor(I,p){super(),this.j=p,this.c={},this.f=(0,v.$hc)(I.userDataPath,"languagepacks.json"),this.g=new R.$Yg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(p=>{Object.keys(p).forEach(P=>delete p[P]),this.m(p,...I)}).then(()=>this.c)}m(I,...p){for(const P of p)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.n(I,P);Object.keys(I).forEach(P=>this.r(I[P]))}n(I,p){const P=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===j.Schemas.file&&h(a)){let i=I[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},I[a.languageId]=i);const n=i.extensions.filter(s=>(0,O.$ro)(s.extensionIdentifier,P))[0];n?n.version=p.manifest.version:i.extensions.push({extensionIdentifier:P,version:p.manifest.version});for(const s of a.translations)i.translations[s.id]=(0,v.$hc)(p.location.fsPath,s.path)}}r(I){if(I){const p=(0,A.createHash)("md5");for(const P of I.extensions)p.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);I.hash=p.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(p=I(P),P)).then(P=>{for(const a of Object.keys(P))P[a]||delete P[a];this.c=P,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>p,P=>this.j.error(P))})}};$=pe([se(0,c.$Uh),se(1,g.$7i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const I of f.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function u(b,O,g){const d=await(0,A.$eC)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,A.$eC)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new d.AppInsightsCore,$=new S.PostChannel,h={instrumentationKey:b,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(g){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[$.identifier]=f}return w.initialize(h,[]),w.addTelemetryInitializer(f=>{O&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),w}class c{constructor(O,g,d,S,w){this.e=O,this.f=g,this.g=d,this.h=w,this.c=j,this.d=v,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(g=>{O(g)},g=>{(0,N.$Y)(g),console.error(g)})}}log(O,g){if(!this.a)return;g=(0,R.$1m)(g,this.g),g=(0,L.$mo)(g);const d=this.f+"/"+O;try{this.i(S=>{S.pluginVersionString=g?.properties.version??"Unknown",S.track({name:d,baseData:{name:d,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$gN=c}),define(ne[145],re([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,I){this.k=f,this.l=I,this.d={},this.i=new A.$Pc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,L.$De)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$De)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(g.$fl)||p.affectsConfiguration(g.$hl)||p.affectsConfiguration(g.$gl))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$lo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const I=f.usage?3:f.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,I){this.g<f||(I=(0,N.$1m)(I,this.d),I=(0,d.$qo)(I,this.j),I=(0,N.$1m)(I,this.c),this.b.forEach(p=>p.log(h,I)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Sq=S,e.$Sq=S=pe([se(1,v.$gi),se(2,b.$mj)],S);function w(){const $=(0,j.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.$o?"":(0,j.localize)(3,null),I=(0,j.localize)(4,null),p=(0,j.localize)(5,null),P=(0,j.localize)(6,null),t=(0,j.localize)(7,null),a=`
|       | ${I} | ${p} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,j.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}O.$0m.as(u.$cn.Configuration).registerConfiguration({id:g.$el,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[g.$fl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$0m.as(u.$cn.Configuration).registerConfiguration({id:g.$el,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[g.$hl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${g.$fl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,A,N,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;async function j(b,O){const g=await O.request(b,N.CancellationToken.None),d=(await(0,A.$le)(g.stream)).toString(),S=g.res.statusCode??200;return{headers:g.res.headers,statusCode:S,responseData:d}}async function v(b){const O={method:b.type,headers:b.headers};return new Promise((d,S)=>{const w=R.request(b.url??"",O,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){S(h)})});w.write(b.data,$=>{$&&S($)}),w.end()})}async function u(b,O,g){const d=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),S={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:d};try{const w=b?await j(S,b):await v(S);g(w.statusCode,w.headers,w.responseData)}catch{g(0,{})}}class c extends L.$gN{constructor(O,g,d,S,w){const $={sendPOST:(h,f)=>{u(O,h,f)}};super(g,d,S,w,$)}}e.$hN=c}),define(ne[148],re([0,1,16,24]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b8b=void 0;async function R(L,j){const v=Object.create(null),u=(b,O)=>{const g=JSON.parse(b);v[O]=g};if(j){const b=[],O=await N.Promises.readdir(j);for(const d of O)try{(await N.Promises.stat((0,A.$hc)(j,d))).isDirectory()&&b.push(d)}catch{}const g=[];for(const d of b)(await N.Promises.readdir((0,A.$hc)(j,d))).filter(w=>w==="telemetry.json").length===1&&g.push(d);for(const d of g){const S=(await N.Promises.readFile((0,A.$hc)(j,d,"telemetry.json"))).toString();u(S,d)}}let c=(await N.Promises.readFile((0,A.$hc)(L,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await N.Promises.readFile((0,A.$hc)(L,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(v,null,4)}e.$b8b=R}),define(ne[149],re([0,1,13,75,26]),function(J,e,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;async function L(j,v){let u=j.getItem(R.$dl);return(typeof u!="string"||A.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,N.$Km)(v.error.bind(v))),u}e.$w7b=L}),define(ne[22],re([0,1,10]),function(J,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=void 0,e.$Ek=(0,A.$Mh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,A,N,R,L,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class c{static{this._clock=0}constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let b=class{constructor(g){this.g=g,this.c=new u.$Pc,this.f=2**16;const d=new Map,S=w=>{let $=d.get(w.scheme);return $===void 0&&($=g.hasProvider(w)&&!this.g.hasCapability(w,1024),d.set(w.scheme,$)),$};this.c.add(v.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new L.$ig(S),this.d=new j.$qr((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,L.$ug)(g));const d=this.d.get(g);return d?d.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new c(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((S,w)=>S[1].time<w[1].time?1:S[1].time>w[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let S=0;S<d;S++)this.d.set(g[S][0],g[S][1].touch())}};e.$rr=b,e.$rr=b=pe([se(0,R.$8j)],b),(0,N.$or)(A.$Ek,b,1)}),define(ne[151],re([0,1,4,2,12,46,31]),function(J,e,A,N,R,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=void 0;class v extends N.$Qc{constructor(c,b,O,g,d,S){super(),this.f=c,this.g=b,this.h=O,this.j=g,this.m=d,this.n=S,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new A.$Ld),this.onDidChangeFile=this.a.event,this.b=L.$Sh.forUris(()=>!(this.capabilities&1024)),this.c=new j.$zc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,b){return this.g.open(this.t(c),b)}close(c){return this.g.close(c)}read(c,b,O,g,d){return this.g.read(c,b,O,g,d)}write(c,b,O,g,d){return this.g.write(c,b,O,g,d)}watch(c,b){this.b.set(c,c);const O=this.g.watch(this.t(c),b);return(0,N.$Oc)(()=>{this.b.delete(c),O.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,b,O){return this.g.rename(this.t(c),this.t(b),O)}readFile(c,b){return this.g.readFile(this.t(c),b)}readFileStream(c,b,O){return this.g.readFileStream(this.t(c),b,O)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,b,O){return this.g.writeFile(this.t(c),b,O)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,b){return this.g.delete(this.t(c),b)}copy(c,b,O){if((0,R.$$j)(this.g))return this.g.copy(this.t(c),this.t(b),O);throw new Error("copy not supported")}cloneFile(c,b){if((0,R.$_j)(this.g))return this.g.cloneFile(this.t(c),this.t(b));throw new Error("clone not supported")}s(c){const b=[];for(const O of c){if(O.resource.scheme!==this.f)continue;const g=this.u(O.resource);this.b.findSubstr(g)&&b.push({resource:g,type:O.type})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$R7b=v}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,A,N,R,L,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.WorkbenchState=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,v.$Mh)("contextService");function c(n){const s=n;return typeof s?.id=="string"&&j.URI.isUri(s.uri)}e.$Wh=c;function b(n){return typeof n?.id=="string"&&!c(n)&&!g(n)}e.$Xh=b,e.$Yh={id:"ext-dev"},e.$Zh={id:"empty-window"};function O(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,N.$lc)(n)}:s?e.$Yh:e.$Zh;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$1h=O;function g(n){const s=n;return typeof s?.id=="string"&&j.URI.isUri(s.configPath)}e.$2h=g;function d(n){const s=n;if(s?.uri)return{id:s.id,uri:j.URI.revive(s.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$3h=d;var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function w(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$4h=w;function $(n){const s=n;return!!(s&&typeof s=="object"&&j.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$5h=$;class h{constructor(s,r,l,k,y){this.h=s,this.j=l,this.k=k,this.l=y,this.c=R.$Sh.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=R.$Sh.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$6h=h;class f{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.$tg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$7h=f;function I(n){return new f({uri:n,index:0,name:(0,L.$pg)(n)},{uri:n.toString()})}e.$8h=I,e.$9h="code-workspace",e.$0h=`.${e.$9h}`,e.$$h=[{name:(0,A.localize)(0,null),extensions:[e.$9h]}],e.$_h="workspace.json";function p(n,s){return L.$kg.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$ai=p;function P(n){let s;return j.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$bi=P,e.$ci="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$ci}e.$di=t;function a(n,s){return!p(n,s)&&!P(n)}e.$ei=a;function i(n){return(typeof n=="string"?(0,N.$mc)(n):(0,L.$rg)(n))===e.$0h}e.$fi=i}),define(ne[23],re([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.ProfileResourceType=void 0;var I;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function p(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&j.URI.isUri(s.location)&&j.URI.isUri(s.globalStorageHome)&&j.URI.isUri(s.settingsResource)&&j.URI.isUri(s.keybindingsResource)&&j.URI.isUri(s.tasksResource)&&j.URI.isUri(s.snippetsHome)&&j.URI.isUri(s.extensionsResource))}e.$Fk=p,e.$Gk=(0,b.$Mh)("IUserDataProfilesService");function P(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:j.URI.revive(n.location).with({scheme:s}),globalStorageHome:j.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:j.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:j.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:j.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:j.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:j.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:j.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Hk=P;function t(n,s,r,l,k,y){return{id:n,name:s,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:y&&k?.useDefaultFlags?.globalState?y.globalStorageHome:(0,L.$tg)(r,"globalStorage"),settingsResource:y&&k?.useDefaultFlags?.settings?y.settingsResource:(0,L.$tg)(r,"settings.json"),keybindingsResource:y&&k?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,L.$tg)(r,"keybindings.json"),tasksResource:y&&k?.useDefaultFlags?.tasks?y.tasksResource:(0,L.$tg)(r,"tasks.json"),snippetsHome:y&&k?.useDefaultFlags?.snippets?y.snippetsHome:(0,L.$tg)(r,"snippets"),extensionsResource:y&&k?.useDefaultFlags?.extensions?y.extensionsResource:(0,L.$tg)(r,"extensions.json"),cacheHome:(0,L.$tg)(l,n),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Ik=t;let a=class extends R.$Qc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,l,k){super(),this.t=s,this.u=r,this.w=l,this.y=k,this.f=!0,this.h=this.B(new N.$Ld),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Ld),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Ld),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Ld),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$yc,emptyWindows:new Map},this.profilesHome=(0,L.$tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,f.$wf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(t((0,L.$qg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.y.error(y)}const l=new d.$yc,k=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[E,D]of Object.entries(y.workspaces)){const W=j.URI.parse(E),x=r.find(_=>_.id===D);x&&l.set(W,x)}if(y.emptyWindows)for(const[E,D]of Object.entries(y.emptyWindows)){const W=r.find(x=>x.id===D);W&&k.set(E,W)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:l,emptyWindows:k}}return this.z}D(){const s=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",l=new RegExp(`${(0,h.$De)(r)}\\s(\\d+)`);let k=0;for(const E of this.profiles){const D=l.exec(E.name),W=D?parseInt(D[1]):0;k=W>k?W:k}const y=`${r} ${k+1}`;return this.createProfile((0,A.$Ai)((0,$.$cg)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,l){return this.createProfile((0,A.$Ai)((0,$.$cg)()).toString(16),s,r,l)}async createProfile(s,r,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(s,r,l);return k&&await this.setProfileForWorkspace(k,y),y}async F(s,r,l){if(!(0,f.$wf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const y=this.profiles.find(W=>W.name===r||W.id===s);if(y)return y;const E=t(s,r,(0,L.$tg)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(E.location);const D=[];return this.j.fire({profile:E,join(W){D.push(W)}}),await w.Promises.settled(D),this.I([E],[],[]),E}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=t(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:r,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$lk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s);return j.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(s){return(0,g.$Wh)(s)?s.uri:(0,g.$2h)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,l){const k=[...this.profiles,...s],y=[];this.s.profiles=[];for(let E of k)E.isDefault||r.some(D=>E.id===D.id)||(E=l.find(D=>E.id===D.id)??E,E.isTransient?this.s.profiles.push(E):y.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(y),this.z=void 0,this.J(s,r,l)}J(s,r,l){this.h.fire({added:s,removed:r,updated:l,all:this.profiles})}L(s,r,l){l=r?.isTransient?!0:l,l||this.L(s,void 0,!0);const k=this.G(s),y=l?this.s:this.C;j.URI.isUri(k)?(y.workspaces.delete(k),r&&y.workspaces.set(k,r)):(y.emptyWindows.delete(k),r&&y.emptyWindows.set(k,r)),l||this.M()}M(){const s={};for(const[l,k]of this.C.workspaces.entries())s[l.toString()]=k.id;const r={};for(const[l,k]of this.C.emptyWindows.entries())r[l.toString()]=k.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},l=this.D();if(s.workspaces)for(const[y,E]of Object.entries(s.workspaces)){const D=j.URI.parse(E);r[y]=this.w.extUri.isEqual(D,l.location)?l.id:this.w.extUri.basename(D)}const k={};if(s.emptyWindows)for(const[y,E]of Object.entries(s.emptyWindows)){const D=j.URI.parse(E);k[y]=this.w.extUri.isEqual(D,l.location)?l.id:this.w.extUri.basename(D)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Jk=a,e.$Jk=a=pe([se(0,u.$Th),se(1,c.$8j),se(2,S.$Ek),se(3,O.$7i)],a);class i extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Kk=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=void 0;let p=class extends v.$Qc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,r,l,k,y,E){super(),this.z=s,this.C=r,this.D=l,this.F=k,this.G=y,this.H=E,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$Ld),this.s=this.B(new j.$Ld),this.t=this.B(new j.$Ld),this.u=this.B(new j.$Ld),this.w=this.B(new j.$Ld),this.y=[],this.B((0,v.$Oc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const r=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,g.$Yn)(l,s.allTargetPlatforms,r))}async installFromGallery(s,r={}){try{const k=(await this.installGalleryExtensions([{extension:s,options:r}])).find(({identifier:y})=>(0,d.$ro)(y,s.identifier));if(k?.local)return k?.local;throw k?.error?k.error:t(new Error(`Unknown error while installing extension ${s.identifier.id}`))}catch(l){throw t(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new g.$3n(O.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(s.map(async({extension:k,options:y})=>{try{const E=await this.O(k,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);l.push({...E,options:y})}catch(E){r.push({identifier:k.identifier,operation:2,source:k,error:E})}})),l.length&&r.push(...await this.I(l));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!b.URI.isUri(k.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,d.$zo)(k.source),error:k.error}));return r}async uninstall(s,r={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.Q(s,r)}async toggleAppliationScope(s,r){if((0,S.$1l)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(s,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const y=(await this.getInstalled(1,k.extensionsResource)).find(E=>(0,d.$ro)(E.identifier,s.identifier));y?this.w.fire(y):this.u.fire({identifier:s.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(s,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.X(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const r=[];return await Promise.allSettled(s.map(async l=>{try{const k=await this.J(l);r.push(...k)}catch(k){r.push({identifier:{id:(0,d.$wo)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(r),r}async J({manifest:s,extension:r,options:l}){const k=l.isApplicationScoped||l.isBuiltin||(0,S.$1l)(s),y={...l,installOnlyNewlyAddedFromExtensionPack:b.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:k,profileLocation:k?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},E=te=>`${d.$so.create(te).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!b.URI.isUri(r)){const te=this.j.get(E(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const D=[],W=[],x=[],_=this.Z(s,r,y);b.URI.isUri(r)||this.j.set(E(r),{task:_,waitingTasks:[]}),this.n.fire({identifier:_.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",_.identifier.id),D.push({task:_,manifest:s});let ue=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const ae=await this.N(_.identifier,s,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),le=await this.getInstalled(void 0,y.profileLocation),ie={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[g.$Tn]:!0}};for(const{gallery:q,manifest:G}of(0,A.$Kb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!G.extensionDependencies?.some(B=>(0,d.$ro)({id:B},_.identifier));const T=E(q),M=this.j.get(T);if(M){if(this.L(_,M.task)){const B=M.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,_.identifier.id),M.waitingTasks.push(_),W.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,X=>X.some(Z=>(0,d.$ro)(Z.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,_.identifier.id),!X.find(K=>(0,d.$ro)(K.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!le.some(({identifier:B})=>(0,d.$ro)(B,q.identifier))){const B=this.Z(G,q,ie);this.j.set(T,{task:B,waitingTasks:[_]}),this.n.fire({identifier:B.identifier,source:q,profileLocation:y.profileLocation}),this.F.info("Installing extension:",B.identifier.id,_.identifier.id),D.push({task:B,manifest:G})}}}catch(ae){if(b.URI.isUri(_.source))(0,A.$Jb)(s.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",_.identifier.id,ae.message),(0,A.$Jb)(s.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",_.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),ae}const te=D.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===_&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const q=new Date().getTime();try{const G=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(G,ie.source,y,R.CancellationToken.None))),!b.URI.isUri(ie.source)){const T=ie.operation===3,M=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(a(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$zo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:M}),u.$o&&ie.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}x.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw b.URI.isUri(ie.source)||a(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$zo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:G}),this.F.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return W.length&&await this.M(W),x.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),x}catch(te){if(D.forEach(({task:ae})=>ae.cancel()),x.length)try{const ae=await Promise.allSettled(x.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:q}=x[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",q.id):this.F.warn("Rollback: Error while uninstalling extension",q.id,(0,L.$8)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,L.$8)(ae),x.map(({identifier:le})=>le.id))}return D.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:y.context,profileLocation:y.profileLocation,error:te}))}finally{for(const{task:te}of D)te.source&&!b.URI.isUri(te.source)&&this.j.delete(E(te.source))}}L(s,r){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===s&&(k.includes(r)||k.some(y=>this.L(y,r)))||l===r&&k[0]&&!this.L(s,k[0]))return!1;return!0}async M(s){const r=[],l=[],k=await Promise.allSettled(s);for(const y of k)y.status==="fulfilled"?r.push(y.value):l.push(y.reason);if(l.length)throw P(l);return r}async N(s,r,l,k,y){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,y),D=[],W=[],x=async(_,ue)=>{D.push(_);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=l?E.find(ie=>(0,d.$ro)(ie.identifier,_)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(q=>(0,d.$ro)({id:q},{id:ie}))||ae.every(q=>!(0,d.$ro)({id:q},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>D.every(q=>!(0,d.$ro)(q,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(q=>({id:q,preRelease:k})),R.CancellationToken.None);for(const q of ie){if(D.find(M=>(0,d.$ro)(M,q.identifier)))continue;const G=te.some(M=>(0,d.$ro)({id:M},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(M){if(G)throw M;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,L.$8)(M));continue}W.push({gallery:T.extension,manifest:T.manifest}),await x(T.extension.identifier,T.manifest)}}}};return await x(s,r),W}async O(s,r,l){let k;const y=await this.getExtensionsControlManifest();if(y.malicious.some(W=>(0,d.$ro)(s.identifier,W)))throw new g.$3n(O.localize(1,null,s.identifier.id),g.ExtensionManagementErrorCode.Malicious);const E=y.deprecated[s.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!k)throw new g.$3n(O.localize(2,null,s.identifier.id,E.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const W=await this.getTargetPlatform();throw new g.$3n(O.localize(3,null,s.identifier.id,this.G.nameLong,(0,g.$Un)(W)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(s,r,l),!k)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],R.CancellationToken.None))[0]?new g.$3n(O.localize(4,null,s.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$3n(O.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const D=await this.z.getManifest(k,R.CancellationToken.None);if(D===null)throw new g.$3n(`Missing manifest for extension ${k.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(D.version!==k.version)throw new g.$3n(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:D}}async P(s,r,l){const k=await this.getTargetPlatform();let y=null;return!r&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(y=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(s,l,k)&&(y=s),y||(r?y=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(s,l,k)),y}async Q(s,r){const l={...r,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=_=>`${_.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,y=this.m.get(k(s.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),y.waitUntilTaskIsFinished();const E=_=>{const ue=this.$(_,l);return this.m.set(k(ue.extension.identifier),ue),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped}),ue},D=(_,ue)=>{ue?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,ue.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$yo)(_),error:ue}),this.u.fire({identifier:_.identifier,error:ue?.code,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped})},W=[],x=[];try{W.push(E(s));const _=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const ue=this.U(s,_);for(const te of ue)this.m.has(k(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):W.push(E(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.R(W.map(ue=>ue.extension),_,s),await this.M(W.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,l,R.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}D(ue.extension)}catch(te){const ae=te instanceof g.$3n?te:new g.$3n((0,L.$8)(te),g.ExtensionManagementErrorCode.Internal);throw D(ue.extension,ae),ae}finally{x.push(ue)}}))}catch(_){const ue=_ instanceof g.$3n?_:new g.$3n((0,L.$8)(_),g.ExtensionManagementErrorCode.Internal);for(const te of W){try{te.cancel()}catch{}x.includes(te)||D(te.extension,ue)}throw ue}finally{for(const _ of W)this.m.delete(k(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(s,r,l){for(const k of s){const y=this.W(k,r);if(y.length){const E=y.filter(D=>!s.some(W=>(0,d.$ro)(W.identifier,D.identifier)));if(E.length)throw new Error(this.S(k,E,l))}}}S(s,r,l){return l===s?r.length===1?O.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(s,r,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const k=s.manifest.extensionPack?s.manifest.extensionPack:[];if(k.length){const y=r.filter(D=>!D.isBuiltin&&k.some(W=>(0,d.$ro)({id:W},D.identifier))),E=[];for(const D of y)E.push(...this.U(D,r,l));return[...y,...E]}return[]}W(s,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,d.$ro)({id:k},s.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const s=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$hp=p,e.$hp=p=pe([se(0,g.$2n),se(1,h.$$k),se(2,f.$Ek),se(3,w.$7i),se(4,$.$mj),se(5,I.$Gk)],p);function P(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$ip=P;function t(n){if(n instanceof g.$3n)return n;const s=new g.$3n(n.message,g.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$jp=t;function a(n,s,{extensionData:r,verificationStatus:l,duration:k,error:y,durationSinceUpdate:E}){let D,W;(0,c.$Ef)(l)&&(l===!0?l="Verified":(l===!1||(D=g.ExtensionManagementErrorCode.Signature,W=l),l="Unverified")),y&&(y instanceof g.$3n?(D=y.code,y.code===g.ExtensionManagementErrorCode.Signature&&(W=y.message)):D=g.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...r,verificationStatus:l,success:!y,duration:k,errorcode:D,errorcodeDetail:W,durationSinceUpdate:E})}class i{constructor(){this.d=new N.$Qg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Fg)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Fg)(s=>new Promise((r,l)=>{const k=s.onCancellationRequested(()=>{k.dispose(),l(new L.$3)})})),this.d.open()),this.g.cancel()}}e.$kp=i}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class I extends Error{constructor(i,n){super(i),this.code=n}}e.$lp=I,e.$mp=(0,O.$Mh)("IExtensionsProfileScannerService");let p=class extends R.$Qc{constructor(i,n,s,r,l,k){super(),this.j=i,this.m=n,this.n=s,this.r=r,this.s=l,this.t=k,this.b=this.B(new L.$Ld),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Ld),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Ld),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Ld),this.onDidRemoveExtensions=this.g.event,this.h=new j.$yc}scanProfileExtensions(i,n){return this.u(i,void 0,n)}async addExtensionsToProfile(i,n){const s=[],r=[];try{return await this.u(n,l=>{const k=[];for(const y of l)i.some(([E])=>(0,c.$ro)(E.identifier,y.identifier)&&E.manifest.version!==y.version)?s.push(y):k.push(y);for(const[y,E]of i){const D=k.findIndex(x=>(0,c.$ro)(x.identifier,y.identifier)&&x.version===y.manifest.version),W={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:E};D===-1?(r.push(W),k.push(W)):k.splice(D,1,W)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),k}),r.length&&this.c.fire({extensions:r,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(i,n){const s=[];return await this.u(n,r=>{const l=[];for(const k of r){const y=i.find(([E])=>(0,c.$ro)(E.identifier,k.identifier)&&E.manifest.version===k.version);y&&(k.metadata={...k.metadata,...y[1]},s.push(k)),l.push(k)}return l}),s}async removeExtensionFromProfile(i,n){const s=[];try{await this.u(n,r=>{const l=[];for(const k of r)(0,c.$ro)(k.identifier,i.identifier)?s.push(k):l.push(k);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:n}),r}}async u(i,n,s){return this.F(i).queue(async()=>{let r=[],l;try{const k=await this.m.readFile(i);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,b.$lk)(k)!==1)throw k;if(this.r.extUri.isEqual(i,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new I((0,$.$8)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(i);let k=!1;for(const y of l){P(y)||this.w(i);let E;if((0,w.$wf)(y.relativeLocation)&&y.relativeLocation)E=this.z(y.relativeLocation);else if((0,w.$wf)(y.location))E=this.z(y.location),k=!0,y.relativeLocation=y.location,y.location=E.toJSON();else{E=v.URI.revive(y.location);const D=this.y(E);D&&(k=!0,y.relativeLocation=D)}r.push({identifier:y.identifier,location:E,version:y.version,metadata:y.metadata})}k&&await this.m.writeFile(i,N.$_d.fromString(JSON.stringify(l)))}if(n){r=n(r);const k=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(i,N.$_d.fromString(JSON.stringify(k)))}return r})}w(i){const n=new I(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(i){return this.r.extUri.isEqual(this.r.extUri.dirname(i),this.j)?this.r.extUri.basename(i):void 0}z(i){return this.r.extUri.joinPath(this.j,i)}async D(){return this.C||(this.C=(async()=>{const i=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(i)).value.toString()}catch(l){if((0,b.$lk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",i.toString());let r;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(k=>P(k))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$_d.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",i.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,b.$lk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",i.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(i)}catch(l){(0,b.$lk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,b.$lk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(i){let n=this.h.get(i);return n||(n=new A.$Yg,this.h.set(i,n)),n}};e.$np=p,e.$np=p=pe([se(1,b.$8j),se(2,d.$Gk),se(3,S.$Ek),se(4,h.$$k),se(5,g.$7i)],p);function P(a){return(0,w.$yf)(a)&&(0,u.$1n)(a.identifier)&&(t(a.location)||(0,w.$wf)(a.location)&&a.location)&&((0,w.$Df)(a.relativeLocation)||(0,w.$wf)(a.relativeLocation))&&a.version&&(0,w.$wf)(a.version)}function t(a){return a?(0,w.$wf)(a.path)&&(0,w.$wf)(a.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,47,40,23,22,112]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f,I,p,P,t,a,i,n,s,r,l,k,y,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.Translations=void 0;var W;(function(ie){function q(G,T){if(G===T)return!0;const M=Object.keys(G),B=new Set;for(const X of Object.keys(T))B.add(X);if(M.length!==B.size)return!1;for(const X of M){if(G[X]!==T[X])return!1;B.delete(X)}return B.size===0}ie.equals=q})(W||(e.Translations=W={})),e.$qp=(0,i.$Mh)("IExtensionsScannerService");let x=class extends c.$Qc{constructor(q,G,T,M,B,X,Z,K,U,z,o,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=G,this.r=T,this.s=M,this.t=B,this.u=X,this.w=Z,this.y=K,this.z=U,this.C=z,this.D=o,this.F=m,this.g=this.B(new r.$Ld),this.onDidChangeCache=this.g.event,this.h=(0,d.$tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Co)(this.w,this.y)),this.G}async scanAllExtensions(q,G,T){const[M,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(G)]),X=T?await this.scanExtensionsUnderDevelopment(q,[...M,...B]):[];return this.L(M,B,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const G=[];G.push(this.M(!!q.useCache,q.language)),G.push(this.N(q.language,!!q.checkControlFile));const[T,M]=await Promise.all(G);return this.J([...T,...M],0,q,!1)}async scanUserExtensions(q){const G=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(G,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),B=q.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let X;try{X=await B.scanExtensions(M)}catch(Z){if(Z instanceof k.$lp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await B.scanExtensions(M);else throw Z}return X=await this.J(X,1,q,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(q,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===b.Schemas.file).map(async M=>{const B=await this.P(M,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(Z=>(Z.type=G.find(K=>(0,p.$ro)(K.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,B)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,G,T){const M=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanExtension(M);return!B||!T.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,G,T){const M=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(M);return this.J(B,G,T,!0)}async scanMetadata(q){const G=(0,d.$tg)(q,"package.json"),T=(await this.w.readFile(G)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,G){const T=(0,d.$tg)(q,"package.json"),M=(await this.w.readFile(T)).value.toString(),B=JSON.parse(M);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,B.__metadata={...B.__metadata,...G},await this.w.writeFile((0,d.$tg)(q,"package.json"),L.$_d.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$lp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$_d.fromString(JSON.stringify([])))}catch(G){(0,a.$lk)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$8)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,G,T,M){return T.includeAllVersions||(q=this.L(G===0?q:void 0,G===1?q:void 0,G==="development"?q:void 0,await this.getTargetPlatform(),M)),T.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,X)=>{const Z=O.$lc(B.location.fsPath),K=O.$lc(X.location.fsPath);return Z<K?-1:Z>K?1:0})}L(q,G,T,M,B){const X=(K,U,z)=>{if(K.isValid&&!U.isValid)return!1;if(K.isValid===U.isValid){if(B&&S.gt(K.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(S.eq(K.manifest.version,U.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===M)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${K.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${U.location.path}.`),!0},Z=new P.$Zl;return q?.forEach(K=>{const U=Z.get(K.identifier.id);(!U||X(U,K,!1))&&Z.set(K.identifier.id,K)}),G?.forEach(K=>{const U=Z.get(K.identifier.id);if(!U&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!U||X(U,K,!1))&&Z.set(K.identifier.id,K)}),T?.forEach(K=>{const U=Z.get(K.identifier.id);(!U||X(U,K,!0))&&Z.set(K.identifier.id,K),Z.set(K.identifier.id,K)}),[...Z.values()]}async M(q,G){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),B=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,G){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const M=G?await this.O():{},B=[],X=h.URI.file(O.$fc(O.$hc(b.$ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const U=M[K.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":B.push((0,d.$tg)(X,K.name));break;default:B.push(h.URI.file(U));break}}const Z=await Promise.all(B.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,A.$Fb)(Z)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,G,T,M,B,X,Z){const K=await this.f(B??g.$v),U=await this.Q(q),z=G&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,o=z?await this.Q(z):void 0;return new _(q,U,z,o,G,Z,T,M,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,K)}async Q(q){try{const G=await this.w.stat(q);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$rp=x,e.$rp=x=pe([se(4,y.$Gk),se(5,k.$mp),se(6,a.$8j),se(7,n.$7i),se(8,I.$Th),se(9,s.$mj),se(10,E.$Ek),se(11,i.$Lh)],x);class _{constructor(q,G,T,M,B,X,Z,K,U,z,o,m,F,C,Q){this.location=q,this.mtime=G,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=M,this.profile=B,this.profileScanOptions=X,this.type=Z,this.excludeObsolete=K,this.validate=U,this.productVersion=z,this.productDate=o,this.productCommit=m,this.devMode=F,this.language=C,this.translations=Q}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,G){return(0,d.$mg)(q.location,G.location)&&q.mtime===G.mtime&&(0,d.$mg)(q.applicationExtensionslocation,G.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&q.profile===G.profile&&R.$2m(q.profileScanOptions,G.profileScanOptions)&&q.type===G.type&&q.excludeObsolete===G.excludeObsolete&&q.validate===G.validate&&q.productVersion===G.productVersion&&q.productDate===G.productDate&&q.productCommit===G.productCommit&&q.devMode===G.devMode&&q.language===G.language&&W.equals(q.translations,G.translations)}}e.$sp=_;let ue=class extends c.$Qc{constructor(q,G,T,M,B){super(),this.f=q,this.g=G,this.h=T,this.j=M,this.m=B}async scanExtensions(q){const G=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(M)}catch{}return(0,$.$Jf)(T)?G:G.filter(M=>!T[p.$so.create(M).toString()])}async n(q){const G=await this.j.resolve(q.location);if(!G.children?.length)return[];const T=await Promise.all(G.children.map(async M=>{if(!M.isDirectory||q.type===1&&(0,d.$qg)(M.resource).indexOf(".")===0)return null;const B=new _(M.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,A.$Fb)(T).sort((M,B)=>M.location.path<B.location.path?-1:1)}async r(q){let G=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){G=G.filter(M=>!M.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,q);G.push(...T)}return G}async s(q,G,T){const M=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!M.length)return[];const B=await Promise.all(M.map(async X=>{if(G(X)){const Z=new _(X.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Z,X.metadata)}return null}));return(0,A.$Fb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,d.$tg)(q.location,"package.json"))){const G=await this.scanExtension(q);return G?[G]:[]}else return await this.scanExtensions(q)}catch(G){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$8)(G)),[]}}async scanExtension(q,G){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=P.$Tl),G=G??T.__metadata,delete T.__metadata;const M=(0,p.$wo)(T.publisher,T.name),B=G?.id?{id:M,uuid:G.id}:{id:M},X=G?.isSystem?0:q.type,Z=X===0||!!G?.isBuiltin;T=await this.t(q.location,T,_.createNlsConfiguration(q));const K={type:X,identifier:B,manifest:T,location:q.location,isBuiltin:Z,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,G){let T=!0;const M=(0,t.$Ho)(G.productVersion,G.productDate,G.location,q.manifest,q.isBuiltin);for(const[B,X]of M)B===w.default.Error&&(T=!1,this.m.error(this.z(G.location,X)));return q.isValid=T,q.validations=M,q}async scanExtensionManifest(q){const G=(0,d.$tg)(q,"package.json");let T;try{T=(await this.j.readFile(G)).value.toString()}catch(B){return(0,a.$lk)(B)!==1&&this.m.error(this.z(q,(0,f.localize)(0,null,G.path,B.message))),null}let M;try{M=JSON.parse(T)}catch{const X=[];(0,v.$Nm)(T,X);for(const Z of X)this.m.error(this.z(q,(0,f.localize)(1,null,G.path,Z.offset,Z.length,(0,u.$op)(Z.error))));return null}return(0,v.$Wm)(M)!=="object"?(this.m.error(this.z(q,(0,f.localize)(2,null,G.path))),null):M}async t(q,G,T){const M=await this.u(q,G,T);if(M)try{const B=[],X=await this.w(M.default,B);if(B.length>0)return B.forEach(K=>{this.m.error(this.z(q,(0,f.localize)(3,null,M.default?.path,(0,u.$op)(K.error))))}),G;if((0,v.$Wm)(M)!=="object")return this.m.error(this.z(q,(0,f.localize)(4,null,M.default?.path))),G;const Z=M.values||Object.create(null);return(0,D.$pp)(this.m,G,Z,X)}catch{}return G}async u(q,G,T){const M=(0,d.$tg)(q,"package.nls.json"),B=(U,z)=>{z.forEach(o=>{this.m.error(this.z(q,(0,f.localize)(5,null,U?.path,(0,u.$op)(o.error))))})},X=U=>{this.m.error(this.z(q,(0,f.localize)(6,null,U?.path)))},Z=`${G.publisher}.${G.name}`,K=T.translations[Z];if(K)try{const U=h.URI.file(K),z=(await this.j.readFile(U)).value.toString(),o=[],m=(0,v.$Nm)(z,o);return o.length>0?(B(U,o),{values:void 0,default:M}):(0,v.$Wm)(m)!=="object"?(X(U),{values:void 0,default:M}):{values:m.contents?m.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let z;try{z=await this.y(q,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const o=(await this.j.readFile(z.localized)).value.toString(),m=[],F=(0,v.$Nm)(o,m);return m.length>0?(B(z.localized,m),{values:void 0,default:z.original}):(0,v.$Wm)(F)!=="object"?(X(z.localized),{values:void 0,default:z.original}):{values:F,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(q,G){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,v.$Nm)(T,G)}catch{}}y(q,G){return new Promise((T,M)=>{const B=X=>{const Z=(0,d.$tg)(q,`package.nls.${X}.json`);this.j.exists(Z).then(K=>{K&&T({localized:Z,original:(0,d.$tg)(q,"package.nls.json")});const U=X.lastIndexOf("-");U===-1?T({localized:(0,d.$tg)(q,"package.nls.json"),original:null}):(X=X.substring(0,U),B(X))})};if(G.devMode||G.pseudo||!G.language)return T({localized:(0,d.$tg)(q,"package.nls.json"),original:null});B(G.language)})}z(q,G){return`[${q.path}]: ${G}`}};ue=pe([se(1,k.$mp),se(2,E.$Ek),se(3,a.$8j),se(4,n.$7i)],ue);let te=class extends ue{constructor(q,G,T,M,B,X,Z){super(G,M,B,X,Z),this.G=q,this.H=T,this.D=this.B(new N.$Pg(3e3)),this.F=this.B(new r.$Ld),this.onDidChangeCache=this.F.event}async scanExtensions(q){const G=this.M(q),T=await this.I(G);if(this.C=q,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(B=>(B.location=h.URI.revive(B.location),B));const M=await super.scanExtensions(q);return await this.J(G,{input:q,result:M}),M}async I(q){try{const G=await this.j.readFile(q),T=JSON.parse(G.value.toString());return{result:T.result,input:(0,l.$jh)(T.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",q.path,(0,j.$8)(G))}return null}async J(q,G){try{await this.j.writeFile(q,L.$_d.fromString(JSON.stringify(G)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,j.$8)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),G=await this.I(q);if(!G)return;const T=G.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$2m(M,T))try{this.m.info("Invalidating Cache",T,M),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const G=this.N(q);return this.h.extUri.joinPath(G.cacheHome,q.type===0?P.$Sl:P.$Rl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(q.location,G.extensionsResource))??this.G:this.H.defaultProfile}};te=pe([se(2,y.$Gk),se(3,k.$mp),se(4,E.$Ek),se(5,a.$8j),se(6,n.$7i)],te);function ae(ie,q){const G=(0,p.$uo)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new P.$Xl(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$tp=ae;class le extends x{constructor(q,G,T,M,B,X,Z,K,U,z,o,m){super(q,G,(0,d.$tg)(T,".vscode-oss-dev","extensions","control.json"),M,B,X,Z,K,U,z,o,m),this.R=(async()=>{if(g.$y)try{const F=await this.w.readFile(h.URI.file(g.$y));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$up=le}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,A,N,R,L,j,v,u,c,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;let g=class extends j.$Qc{constructor(S,w){super(),this.b=S,this.f=w,this.a=new N.$Xg(5)}async postUninstall(S){const w=this.g(S,"uninstall");w&&(this.f.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,S),this.f.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(S))}catch($){this.f.error("Error while removing extension storage path",S.identifier.id),this.f.error($)}}g(S,w){const $=`vscode:${w}`;if(S.location.scheme===v.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[$]=="string"){const h=S.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(S.identifier.id,S.manifest.version,`${$} should be a node script`),null):{script:(0,u.$hc)(S.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(S,w,$,h,f){return new Promise((I,p)=>{const P=this.j(S,w,$,f);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?p(i):I(void 0)};P.on("error",i=>{a((0,R.$xi)(i)||"Unknown")}),P.on("exit",(i,n)=>{a(i?`post-${w} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,P.kill(),p("timed out")},5e3))})}j(S,w,$,h){const f={silent:!0,execArgv:void 0},I=(0,A.fork)(S,[`--type=extension-post-${w}`,...$],f);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const p=L.Event.fromNodeEventEmitter(I.stdout,"data"),P=L.Event.fromNodeEventEmitter(I.stderr,"data");p(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,i)),P(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,i));const t=L.Event.any(L.Event.map(p,i=>({data:`%c${i}`,format:[""]})),L.Event.map(P,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),I}m(S){return(0,u.$hc)(this.b.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.$wp=g,e.$wp=g=pe([se(0,O.$Gk),se(1,b.$7i)],g)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,A,N,R,L,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;let b=class extends j.$np{constructor(g,d,S,w,$,h){super(c.URI.file(g.extensionsPath),d,S,w,$,h)}};e.$sN=b,e.$sN=b=pe([se(0,u.$Uh),se(1,v.$8j),se(2,N.$Gk),se(3,R.$Ek),se(4,L.$$k),se(5,A.$7i)],b)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,A,N,R,L,j,v,u,c,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;let g=class extends L.$up{constructor(S,w,$,h,f,I,p,P){super(A.URI.file(f.builtinExtensionsPath),A.URI.file(f.extensionsPath),f.userHome,S.defaultProfile,S,w,$,h,f,I,p,P)}};e.$t7b=g,e.$t7b=g=pe([se(0,O.$Gk),se(1,R.$mp),se(2,j.$8j),se(3,u.$7i),se(4,N.$Uh),se(5,c.$mj),se(6,b.$Ek),se(7,v.$Lh)],g)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,A,N,R,L,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo="__$__isNewStorageMarker",e.$Wo="__$__targetStorageMarker",e.$Xo=(0,u.$Mh)("storageService");var b;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var O;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var g;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function d(f){const I=f.get(e.$Wo);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$Yo=d;class S extends R.$Qc{static{this.a=60*1e3}constructor(I={flushInterval:S.a}){super(),this.m=I,this.b=this.B(new N.$Od),this.c=this.B(new N.$Od),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Ld),this.onWillSaveState=this.f.event,this.h=this.B(new A.$4g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Rc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,p,P){return N.Event.filter(this.b.event,t=>t.scope===I&&(p===void 0||t.key===p),P)}n(){this.j.value=(0,A.$8g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Lc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,p){const{key:P,external:t}=p;if(P===e.$Wo){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:P,target:this.J(I)[P],external:t})}w(I){this.f.fire({reason:I})}get(I,p,P){return this.P(p)?.get(I,P)}getBoolean(I,p,P){return this.P(p)?.getBoolean(I,P)}getNumber(I,p,P){return this.P(p)?.getNumber(I,P)}getObject(I,p,P){return this.P(p)?.getObject(I,P)}storeAll(I,p){this.y(()=>{for(const P of I)this.store(P.key,P.value,P.scope,P.target,p)})}store(I,p,P,t,a=!1){if((0,j.$Ff)(p)){this.remove(I,P,a);return}this.y(()=>{this.z(I,P,t),this.P(P)?.set(I,p,a)})}remove(I,p,P=!1){this.y(()=>{this.z(I,p,void 0),this.P(p)?.delete(I,P)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,p){const P=[],t=this.J(I);for(const a of Object.keys(t))t[a]===p&&P.push(a);return P}z(I,p,P,t=!1){const a=this.J(p);typeof P=="number"?a[I]!==P&&(a[I]=P,this.P(p)?.set(e.$Wo,JSON.stringify(a),t)):typeof a[I]=="number"&&(delete a[I],this.P(p)?.set(e.$Wo,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const p=this.P(I);return p?d(p):Object.create(null)}isNew(I){return this.getBoolean(e.$Vo,I)===!0}async flush(I=b.NONE){this.f.fire({reason:I});const p=this.P(-1),P=this.P(0),t=this.P(1);switch(I){case b.NONE:await A.Promises.settled([p?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await A.Promises.settled([p?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,P=this.P(1)?.items??new Map;return h(I,p,P,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,p){return this.w(b.NONE),(0,c.$Fk)(I)?this.R(I,p):this.S(I,p)}M(I,p){return!(I.id===p.id||w(p)&&w(I))}N(I,p,P){this.y(()=>{const t=new Set;for(const[a,i]of I)t.add(a),p.get(a)!==i&&this.u(P,{key:a,external:!0});for(const[a]of p.items)t.has(a)||this.u(P,{key:a,external:!0})})}}e.$Zo=S;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$1o=w;class $ extends S{constructor(){super(),this.U=this.B(new v.$To(new v.$Uo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$To(new v.$Uo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$To(new v.$Uo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$2o=$;async function h(f,I,p,P,t,a){const i=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,s=new Map;f.forEach((W,x)=>{n.set(x,W),s.set(x,i(W))});const r=new Map,l=new Map;I.forEach((W,x)=>{r.set(x,W),l.set(x,i(W))});const k=new Map,y=new Map;p.forEach((W,x)=>{k.set(x,W),y.set(x,i(W))}),console.group(P!==t?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const E=[];if(n.forEach((W,x)=>{E.push({key:x,value:W})}),console.table(E),console.groupEnd(),console.log(s),P!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];r.forEach((x,_)=>{W.push({key:_,value:x})}),console.table(W),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const D=[];k.forEach((W,x)=>{D.push({key:x,value:W})}),console.table(D),console.groupEnd(),console.log(y)}e.$3o=h}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f,I,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=void 0;const t=L.$o?"web":(0,O.$Wn)(L.$t,j.$cc),a="X-Market-Search-Activity-Id";var i;(function(o){o[o.None=0]="None",o[o.IncludeVersions=1]="IncludeVersions",o[o.IncludeFiles=2]="IncludeFiles",o[o.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",o[o.IncludeSharedAccounts=8]="IncludeSharedAccounts",o[o.IncludeVersionProperties=16]="IncludeVersionProperties",o[o.ExcludeNonValidated=32]="ExcludeNonValidated",o[o.IncludeInstallationTargets=64]="IncludeInstallationTargets",o[o.IncludeAssetUri=128]="IncludeAssetUri",o[o.IncludeStatistics=256]="IncludeStatistics",o[o.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",o[o.Unpublished=4096]="Unpublished",o[o.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...o){return String(o.reduce((m,F)=>m|F,0))}var s;(function(o){o[o.Tag=1]="Tag",o[o.ExtensionId=4]="ExtensionId",o[o.Category=5]="Category",o[o.ExtensionName=7]="ExtensionName",o[o.Target=8]="Target",o[o.Featured=9]="Featured",o[o.SearchText=10]="SearchText",o[o.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(m=y){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,F=this.d.pageSize){return new E({...this.d,pageNumber:m,pageSize:F})}withFilter(m,...F){const C=[...this.d.criteria,...F.length?F.map(Q=>({filterType:m,value:Q})):[{filterType:m}]];return new E({...this.d,criteria:C})}withSortBy(m){return new E({...this.d,sortBy:m})}withSortOrder(m){return new E({...this.d,sortOrder:m})}withFlags(...m){return new E({...this.d,flags:m.reduce((F,C)=>F|C,0)})}withAssetTypes(...m){return new E({...this.d,assetTypes:m})}withSource(m){return new E({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:F,pageSize:C,sortBy:Q,sortOrder:H,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:m,pageNumber:F,pageSize:C,sortBy:Q,sortOrder:H}],assetTypes:oe,flags:ce}}get searchText(){const m=this.d.criteria.filter(F=>F.filterType===s.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(o,m){const F=(o||[]).filter(C=>C.statisticName===m)[0];return F?F.value:0}function W(o){const m="Microsoft.VisualStudio.Code.Translation.";return o.files.filter(C=>C.assetType.indexOf(m)===0).reduce((C,Q)=>{const H=ue(o,Q.assetType);return H&&C.push([Q.assetType.substring(m.length),H]),C},[])}function x(o){if(o.properties){const m=o.properties.filter(Q=>Q.key===r.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=m.filter(Q=>F.test(Q.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return ue(o,r.Repository)}function _(o){return{uri:`${o.fallbackAssetUri}/${r.VSIX}?redirect=true${o.targetPlatform?`&targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${r.VSIX}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}}function ue(o,m){return o.files.filter(C=>C.assetType===m)[0]?{uri:`${o.assetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}:null}function te(o,m){const F=o.properties?o.properties.filter(Q=>Q.key===m):[],C=F.length>0&&F[0].value;return C?C.split(",").map(Q=>(0,g.$vo)(Q)):[]}function ae(o){const m=o.properties?o.properties.filter(F=>F.key===l.Engine):[];return m.length>0&&m[0].value||""}function le(o){const m=o.properties?o.properties.filter(F=>F.key===l.PreRelease):[];return m.length>0&&m[0].value==="true"}function ie(o){const m=o.properties?o.properties.filter(C=>C.key===l.LocalizedLanguages):[],F=m.length>0&&m[0].value||"";return F?F.split(","):[]}function q(o){return o.properties?.find(m=>m.key===l.SponsorLink)?.value}function G(o){return o.indexOf("preview")!==-1}function T(o){return o.targetPlatform?(0,O.$Vn)(o.targetPlatform):"undefined"}function M(o){const m=(0,A.$Kb)(o.versions.map(T)),F=!!o.tags?.includes(O.$Qn),C=m.indexOf("web");return F?C===-1&&m.push("web"):C!==-1&&m.splice(C,1),m}function B(o,m){const F=(0,O.$Zn)(m);for(let C=0;C<o.length;C++){const Q=o[C];if(Q.version===o[C-1]?.version){let H=C;const ce=T(Q);if(ce===m)for(;H>0&&o[H-1].version===Q.version;)H--;else if(F.includes(ce))for(;H>0&&o[H-1].version===Q.version&&T(o[H-1])!==m;)H--;H!==C&&(o.splice(C,1),o.splice(H,0,Q))}}return o}e.$6o=B;function X(o,m,F){o.telemetryData={index:m,querySource:F,queryActivityId:o.queryContext?.[a]}}function Z(o,m,F,C){const Q=o.versions[0],H={manifest:ue(m,r.Manifest),readme:ue(m,r.Details),changelog:ue(m,r.Changelog),license:ue(m,r.License),repository:x(m),download:_(m),icon:ue(m,r.Icon),signature:ue(m,r.Signature),coreTranslations:W(m)};return{identifier:{id:(0,g.$wo)(o.publisher.publisherName,o.extensionName),uuid:o.extensionId},name:o.extensionName,version:m.version,displayName:o.displayName,publisherId:o.publisher.publisherId,publisher:o.publisher.publisherName,publisherDisplayName:o.publisher.displayName,publisherDomain:o.publisher.domain?{link:o.publisher.domain,verified:!!o.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Q),description:o.shortDescription||"",installCount:D(o.statistics,"install"),rating:D(o.statistics,"averagerating"),ratingCount:D(o.statistics,"ratingcount"),categories:o.categories||[],tags:o.tags||[],releaseDate:Date.parse(o.releaseDate),lastUpdated:Date.parse(o.lastUpdated),allTargetPlatforms:F,assets:H,properties:{dependencies:te(m,l.Dependency),extensionPack:te(m,l.ExtensionPack),engine:ae(m),localizedLanguages:ie(m),targetPlatform:T(m),isPreReleaseVersion:le(m)},hasPreReleaseVersion:le(Q),hasReleaseVersion:!0,preview:G(o.flags),isSigned:!!H.signature,queryContext:C}}let K=class{constructor(m,F,C,Q,H,ce,oe,ge){this.k=F,this.l=C,this.n=Q,this.o=H,this.q=ce,this.u=oe,this.w=ge;const de=oe.extensionsGallery,me=de?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=me?de.servicePPEUrl:de?.serviceUrl,this.g=me?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$5o)(oe.version,oe,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,F,C){const Q=N.CancellationToken.isCancellationToken(F)?{}:F,H=N.CancellationToken.isCancellationToken(F)?F:C,ce=[],oe=[],ge=[],de=[];let me=!0;for(const we of m){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);ge.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),me=me&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new E().withPage(1,m.length);oe.length&&(fe=fe.withFilter(s.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(s.ExtensionName,...ce)),(Q.queryAllVersions||me)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),Q.source&&(fe=fe.withSource(Q.source));const{extensions:he}=await this.z(fe,{targetPlatform:Q.targetPlatform??t,includePreRelease:ge,versions:de,compatible:!!Q.compatible},H);return Q.source&&he.forEach((we,be)=>X(we,be,Q.source)),he}async getCompatibleExtension(m,F,C){if((0,O.$Xn)(m.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(m,F,C))return m;const Q=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,m.identifier.uuid),{extensions:H}=await this.z(Q,{targetPlatform:C,compatible:!0,includePreRelease:F},N.CancellationToken.None);return H[0]||null}async isExtensionCompatible(m,F,C){if(!(0,O.$Yn)(m.properties.targetPlatform,m.allTargetPlatforms,C)||!F&&m.properties.isPreReleaseVersion)return!1;let Q=m.properties.engine;if(!Q){const H=await this.getManifest(m,N.CancellationToken.None);if(!H)throw new Error("Manifest was not found");Q=H.engines.vscode}return(0,d.$Jo)(Q,this.u.version,this.u.date)}async y(m,F,C,Q,H){if(!(0,O.$Yn)(T(m),Q,H)||F!=="any"&&le(m)!==(F==="prerelease"))return!1;if(C)try{const ce=await this.E(m);if(!(0,d.$Jo)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,R.$8)(ce)),!1}return!0}async query(m,F){let C=m.text||"";const Q=m.pageSize??50;let H=new E().withPage(1,Q);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,he)=>(H=H.withFilter(s.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,he)=>(H=H.withFilter(s.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(s.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),H=H.withFilter(s.SearchText,C)),H=H.withSortBy(0)):m.ids?H=H.withFilter(s.ExtensionId,...m.ids):m.names?H=H.withFilter(s.ExtensionName,...m.names):H=H.withSortBy(4),typeof m.sortBy=="number"&&(H=H.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(H=H.withSortOrder(m.sortOrder)),m.source&&(H=H.withSource(m.source));const ce=async(me,fe)=>{const{extensions:he,total:we}=await this.z(me,{targetPlatform:t,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,Pe)=>X(be,(me.pageNumber-1)*me.pageSize+Pe,m.source)),{extensions:he,total:we}},{extensions:oe,total:ge}=await ce(H,F),de=async(me,fe)=>{if(fe.isCancellationRequested)throw new R.$3;const{extensions:he}=await ce(H.withPage(me+1),fe);return he};return{firstPage:oe,total:ge,pageSize:H.pageSize,getPage:de}}async z(m,F,C){const Q=m.flags;m.flags&i.IncludeLatestVersionOnly&&m.flags&i.IncludeVersions&&(m=m.withFlags(m.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(m.flags&i.IncludeLatestVersionOnly)&&!(m.flags&i.IncludeVersions)&&(m=m.withFlags(m.flags,i.IncludeLatestVersionOnly)),F.versions?.length&&(m=m.withFlags(m.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),m=m.withFlags(m.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:H,total:ce,context:oe}=await this.B(m,C);if(!(m.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const he of H){const we=await this.A(he,F,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],me=new Map;for(let fe=0;fe<H.length;fe++){const he=H[fe],we={id:(0,g.$wo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,v.$Cf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Fe=>(0,g.$ro)(Fe,we))?.includePreRelease;if(F.compatible&&(0,O.$Xn)(M(he),F.targetPlatform))continue;const Pe=await this.A(he,F,oe);!Pe||Pe.properties.isPreReleaseVersion&&(!be||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==F.targetPlatform&&Pe.hasPreReleaseVersion?me.set(he.extensionId,fe):de.push([fe,Pe])}if(me.size){const fe=new P.$Hd,he=new E().withFlags(Q&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,me.size).withFilter(s.ExtensionId,...me.keys()),{extensions:we}=await this.z(he,F,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:me.size});for(const be of we){const Pe=me.get(be.identifier.uuid);de.push([Pe,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(m,F,C){const Q={id:(0,g.$wo)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},H=F.versions?.find(de=>(0,g.$ro)(de,Q))?.version,ce=(0,v.$Cf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(de=>(0,g.$ro)(de,Q))?.includePreRelease,oe=M(m),ge=B(m.versions,F.targetPlatform);if(F.compatible&&(0,O.$Xn)(oe,F.targetPlatform))return null;for(let de=0;de<ge.length;de++){const me=ge[de];if(!(H&&me.version!==H)){if(await this.y(me,ce?"any":"release",F.compatible,oe,F.targetPlatform))return Z(m,me,oe,C);if(H&&me.version===H)return null}}return H||F.compatible?null:Z(m,m.versions[0],oe)}async B(m,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,i.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(i.Unpublished));const C=await this.j,Q=JSON.stringify(m.raw),H={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},ce=new P.$Hd;let oe,ge,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:H},F),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const me=await(0,h.$Qo)(oe);if(me){const fe=me.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(me){throw ge=me,me}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Q.length),duration:ce.elapsed(),success:!!oe&&(0,h.$Mo)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ge?(0,R.$2)(ge)?"canceled":(0,R.$8)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,F,C,Q){if(!this.isEnabled())return;const H=L.$o?this.x(`/itemName/${m}.${F}/version/${C}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${F}/${C}/stats?statType=${Q}`),ce=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:H,headers:ge},N.CancellationToken.None)}catch{}}async download(m,F,C){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Q=(0,g.$zo)(m),H=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:fe}),oe=C===2?"install":C===3?"update":"",ge=oe?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:m.assets.download,de=m.queryContext?.[a]?{[a]:m.queryContext[a]}:void 0,me=await this.D(ge,de?{headers:de}:void 0);await this.q.writeFile(F,me.stream),ce(new Date().getTime()-H)}async downloadSignatureArchive(m,F){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const C=await this.D(m.assets.signature);await this.q.writeFile(F,C.stream)}async getReadme(m,F){if(m.assets.readme){const C=await this.D(m.assets.readme,{},F);return await(0,h.$Po)(C)||""}return""}async getManifest(m,F){if(m.assets.manifest){const C=await this.D(m.assets.manifest,{},F),Q=await(0,h.$Po)(C);return Q?JSON.parse(Q):null}return null}async C(m,F){const C=ue(m,r.Manifest);if(!C)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},H=await this.D(C,{headers:Q});return await(0,h.$Qo)(H)}async getCoreTranslation(m,F){const C=m.assets.coreTranslations.filter(Q=>Q[0]===F.toUpperCase())[0];if(C){const Q=await this.D(C[1]),H=await(0,h.$Po)(Q);return H?JSON.parse(H):null}return null}async getChangelog(m,F){if(m.assets.changelog){const C=await this.D(m.assets.changelog,{},F);return await(0,h.$Po)(C)||""}return""}async getAllCompatibleVersions(m,F,C){let Q=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Q=Q.withFilter(s.ExtensionId,m.identifier.uuid):Q=Q.withFilter(s.ExtensionName,m.identifier.id);const{galleryExtensions:H}=await this.B(Q,N.CancellationToken.None);if(!H.length)return[];const ce=M(H[0]);if((0,O.$Xn)(ce,C))return[];const oe=[];await Promise.all(H[0].versions.map(async me=>{try{await this.y(me,F?"any":"release",!0,ce,C)&&oe.push(me)}catch{}}));const ge=[],de=new Set;for(const me of B(oe,C))de.has(me.version)||(de.add(me.version),ge.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:le(me)}));return ge}async D(m,F={},C=N.CancellationToken.None){const Q=await this.j,H={type:"GET"},ce={...Q,...F.headers||{}};F={...F,...H,headers:ce};const oe=m.uri,ge=m.fallbackUri,de={...F,url:oe};try{const me=await this.k.request(de,C);if(me.res.statusCode===200)return me;const fe=await(0,h.$Po)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${fe}`)}catch(me){if((0,R.$2)(me))throw me;const fe=(0,R.$8)(me);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...F,url:ge};return this.k.request(he,C)}}async E(m){let F=ae(m);if(!F){const C=await this.C(m,N.CancellationToken.None);if(!C)throw new Error("Manifest was not found");F=C.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,h.$Qo)(m),C=[],Q={},H=[];if(F){for(const ce of F.malicious)C.push({id:ce});if(F.migrateToPreRelease)for(const[ce,oe]of Object.entries(F.migrateToPreRelease))(!oe.engine||(0,d.$Jo)(oe.engine,this.u.version,this.u.date))&&(Q[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[ce,oe]of Object.entries(F.deprecated))oe&&(Q[ce.toLowerCase()]=(0,v.$Cf)(oe)?{}:oe);if(F.search)for(const ce of F.search)H.push(ce)}return{malicious:C,deprecated:Q,search:H}}};K=pe([se(1,h.$Ko),se(2,w.$7i),se(3,b.$Th),se(4,p.$$k),se(5,S.$8j),se(6,$.$mj),se(7,c.$gi)],K);let U=class extends K{constructor(m,F,C,Q,H,ce,oe,ge){super(m,F,C,Q,H,ce,oe,ge)}};e.$7o=U,e.$7o=U=pe([se(0,I.$Xo),se(1,h.$Ko),se(2,w.$7i),se(3,b.$Th),se(4,p.$$k),se(5,S.$8j),se(6,$.$mj),se(7,c.$gi)],U);let z=class extends K{constructor(m,F,C,Q,H,ce,oe){super(void 0,m,F,C,Q,H,ce,oe)}};e.$8o=z,e.$8o=z=pe([se(0,h.$Ko),se(1,w.$7i),se(2,b.$Th),se(3,p.$$k),se(4,S.$8j),se(5,$.$mj),se(6,c.$gi)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,A,N,R,L,j,v,u,c,b){"use strict";var O,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.$pN=void 0;let d=class extends u.$Jk{static{O=this}static{this.a="profileAssociationsMigration"}constructor(h,f,I,p,P){super(I,p,f,P),this.U=h,this.W=I}O(){return this.U.getItem(O.b,[]).map(f=>({...f,location:(0,c.$wf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):A.URI.revive(f.location)}))}Q(){const h=this.U.getItem(O.c,{});return this.U.getItem(O.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(A.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$pN=d,e.$pN=d=O=pe([se(0,j.$kN),se(1,v.$Ek),se(2,N.$Uh),se(3,R.$8j),se(4,L.$7i)],d);let S=g=class extends d{constructor(h,f,I,p,P){super(h,f,I,p,P),this.$=h}P(h){h.length?this.$.setItem(g.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(g.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(g.c,h):this.$.removeItem(g.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((P,{workspace:t,profile:a})=>(P[A.URI.revive(t).toString()]=A.URI.revive(a).toString(),P),{});this.$.setItem(g.c,{workspaces:p})}const I=super.Q();return this.$.getItem(g.a,!1)||(this.R(I),this.$.setItem(g.a,!0)),I}};e.$qN=S,e.$qN=S=g=pe([se(0,j.$lN),se(1,v.$Ek),se(2,N.$Uh),se(3,R.$8j),se(4,L.$7i)],S);let w=class extends S{constructor(h,f,I,p){super(new b.$oN(0,f,p,I),h,f,I,p)}async init(){return await this.$.init(),super.init()}};e.$rN=w,e.$rN=w=pe([se(0,v.$Ek),se(1,N.$Uh),se(2,R.$8j),se(3,L.$7i)],w)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,A,N,R,L,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.zip=e.$dp=e.$cp=void 0,e.$cp="end of central directory record signature not found";const b=new RegExp(e.$cp);class O extends Error{constructor(a,i){let n=i.message;switch(a){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=a,this.cause=i}}e.$dp=O;function g(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,n)=>i+n,a&61440)}function d(t){if(t instanceof O)return t;let a;return b.test(t.message)&&(a="CorruptZip"),new O(a,t)}function S(t,a,i,n,s,r){const l=R.$kc(a),k=R.$hc(n,l);if(!k.startsWith(n))return Promise.reject(new Error(v.localize(0,null,a)));const y=R.$hc(n,a);let E;return r.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(j.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((D,W)=>{if(!r.isCancellationRequested)try{E=(0,A.createWriteStream)(y,{mode:i}),E.once("close",()=>D()),E.once("error",W),t.once("error",W),t.pipe(E)}catch(x){W(x)}}))}function w(t,a,i,n){let s=(0,N.$Fg)(()=>Promise.resolve()),r=0;const l=n.onCancellationRequested(()=>{s.cancel(),t.close()});return new Promise((k,y)=>{const E=new N.$Mg,D=W=>{W.isCancellationRequested||(r++,t.readEntry())};t.once("error",y),t.once("close",()=>s.then(()=>{n.isCancellationRequested||t.entryCount===r?k():y(new O("Incomplete",new Error(v.localize(1,null,r,t.entryCount))))},y)),t.readEntry(),t.on("entry",W=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(W.fileName)){D(n);return}const x=W.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(x)){const te=R.$hc(a,x);s=(0,N.$Fg)(ae=>j.Promises.mkdir(te,{recursive:!0}).then(()=>D(ae)).then(void 0,y));return}const _=h(t,W),ue=g(W);s=(0,N.$Fg)(te=>E.queue(()=>_.then(ae=>S(ae,x,ue,a,i,te).then(()=>D(te)))).then(null,y))})}).finally(()=>l.dispose())}function $(t,a=!1){return new Promise((i,n)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(s,r)=>{s?n(d(s)):i((0,L.$Hf)(r))})})}function h(t,a){return new Promise((i,n)=>{t.openReadStream(a,(s,r)=>{s?n(d(s)):i((0,L.$Hf)(r))})})}function f(t,a){return new Promise((i,n)=>{const s=new c.ZipFile;a.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const r=(0,A.createWriteStream)(t);s.outputStream.pipe(r),s.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>i(t))})}e.zip=f;function I(t,a,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=$(t,!0);return i.overwrite&&(r=r.then(l=>j.Promises.rm(a).then(()=>l))),r.then(l=>w(l,a,{sourcePathRegex:s},n))}e.$fp=I;function p(t,a){return $(t).then(i=>new Promise((n,s)=>{i.on("entry",r=>{r.fileName===a&&h(i,r).then(l=>n(l),l=>s(l))}),i.once("close",()=>s(new Error(v.localize(2,null,a))))}))}function P(t,a){return p(t,a).then(i=>new Promise((n,s)=>{const r=[];i.once("error",s),i.on("data",l=>r.push(l)),i.on("end",()=>n(Buffer.concat(r)))}))}e.$gp=P}),define(ne[160],re([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;let p=class extends R.$Qc{static{I=this}static{this.c=".sigzip"}constructor(t,a,i,n,s,r){super(),this.h=a,this.j=i,this.m=n,this.n=s,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,i){await this.g;const n=(0,j.$tg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,n,r=>this.j.download(t,r,a))}catch(r){throw new S.$3n(r.message,S.ExtensionManagementErrorCode.Download)}let s=!1;if(i&&this.t(t)){const r=await this.u(t);try{s=await this.n.verify(n.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(l){const k=l;if(s=k.code,k.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${k.output}`),s===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new S.$3n(O.$cp,S.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${t.identifier.id}`),{location:n,verificationStatus:s}}t(t){if(!t.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,u.$Cf)(a)?a:!0}async u(t){await this.g;const a=(0,j.$tg)(this.extensionsDownloadDir,`${this.z(t)}${I.c}`);return await this.w(t,a,i=>this.j.downloadSignatureArchive(t,i)),a}async w(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==L.Schemas.file){await i(a);return}const n=(0,j.$tg)(this.extensionsDownloadDir,`.${(0,c.$cg)()}`);await this.h.exists(n)||await i(n);try{await b.Promises.rename(n.fsPath,a.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,N.$8)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],n=[];for(const l of t.children)if(l.name.endsWith(I.c))n.push(l.resource);else{const k=w.$so.parse(l.name);k&&i.push([k,l])}const s=(0,w.$xo)(i,([l])=>l),r=[];for(const l of s)l.sort((k,y)=>v.rcompare(k[0].version,y[0].version)),a.push(...l.slice(1).map(k=>k[1].resource)),r.push(l[0][1]);r.sort((l,k)=>l.mtime-k.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),a.push(...n),await A.Promises.settled(a.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.r.error(t)}}z(t){return this.f?w.$so.create(t).toString().toLowerCase():(0,c.$cg)()}};e.$vp=p,e.$vp=p=I=pe([se(0,d.$Uh),se(1,h.$8j),se(2,S.$2n),se(3,g.$gi),se(4,$.$9o),se(5,f.$7i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function R(L){return(0,A.$gp)(L,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$xp=R}),define(ne[162],re([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f,I,p,P,t,a,i,n,s,r,l,k,y,E,D,W,x,_,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=void 0,e.$Ap=(0,_.$Nh)(i.$4n);const q=".vsctmp";let G=class extends a.$hp{constructor(U,z,o,m,F,C,Q,H,ce,oe,ge,de){super(U,z,ge,o,oe,de),this.fb=F,this.gb=C,this.hb=Q,this.ib=ce,this.eb=new Map,this.rb=new b.$zc;const me=this.B(H.createInstance(k.$wp));this.bb=this.B(H.createInstance(T,he=>me.postUninstall(he))),this.cb=this.B(new E.$yp(de,ce,ge,this,this.F)),this.db=this.B(H.createInstance(l.$vp));const fe=this.B(new D.$zp(this,this.fb,de,C,ge,ce,o));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Co)(this.ib,this.F)),this.jb}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const z=await this.pb(U),o=await(0,I.zip)((0,d.$tg)(this.db.extensionsDownloadDir,(0,h.$cg)()).fsPath,z);return $.URI.file(o)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:z,cleanup:o}=await this.lb(U),m=g.$ic(z.fsPath);try{return await(0,y.$xp)(m)}finally{await o()}}getInstalled(U,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(U??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.bb.scanUserExtensionAtLocation(U)}async install(U,z={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:o,cleanup:m}=await this.lb(U);try{const F=await(0,y.$xp)(g.$ic(o.fsPath)),C=(0,n.$wo)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,W.$Jo)(F.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const H=(await this.I([{manifest:F,extension:o,options:z}])).find(({identifier:ce})=>(0,n.$ro)(ce,{id:C}));if(H?.local)return H.local;throw H?.error?H.error:(0,a.$jp)(new Error(`Unknown error while installing extension ${C}`))}finally{await m()}}async installFromLocation(U,z){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const o=await this.bb.scanUserExtensionAtLocation(U);if(!o)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.ub([[o,void 0]],z),this.F.info("Successfully installed extension",o.identifier.id,z.toString()),o}async installExtensionsFromProfile(U,z,o){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,z.toString(),o.toString());const m=(await this.bb.scanExtensions(1,z)).filter(F=>U.some(C=>(0,n.$ro)(C,F.identifier)));if(m.length){const F=await Promise.all(m.map(C=>this.bb.scanMetadata(C,z)));await this.ub(m.map((C,Q)=>[C,F[Q]]),o),this.F.info("Successfully installed extensions",m.map(C=>C.identifier.id),o.toString())}return m}async updateMetadata(U,z,o=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.pinned=z.pinned||void 0,U=await this.bb.updateMetadata(U,z,o),this.cb.invalidate(o),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[o]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:z,compatible:!0},R.CancellationToken.None);if(!o)throw new Error(p.localize(2,null));await this.bb.setUninstalled(U);try{await this.bb.removeUninstalledExtension(U)}catch(m){throw new Error(p.localize(3,null,(0,L.$xi)(m)))}return this.installFromGallery(o)}ab(U,z,o,m){return this.bb.copyExtension(U,z,o,m)}copyExtensions(U,z){return this.bb.copyExtensions(U,z)}markAsUninstalled(...U){return this.bb.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(U){this.F.error(U)}}async download(U,z,o){const{location:m}=await this.db.download(U,z,!o);return m}async lb(U){if(U.scheme===O.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const z=(0,d.$tg)(this.db.extensionsDownloadDir,(0,h.$cg)());return await this.hb.download(U,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(U,z,o){if($.URI.isUri(z))return new X(U,z,o,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=n.$so.create(z).toString();let F=this.eb.get(m);return F||(this.eb.set(m,F=new B(U,z,o,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),F.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),F}$(U,z){return new Z(U,z.profileLocation,this.gb)}async pb(U){const z=async m=>{let F=await f.Promises.readdir(m);F=F.map(H=>g.$hc(m,H));const C=await Promise.all(F.map(H=>f.Promises.stat(H)));let Q=Promise.resolve([]);return C.forEach((H,ce)=>{const oe=F[ce];H.isFile()&&(Q=Q.then(ge=>[...ge,oe])),H.isDirectory()&&(Q=Q.then(ge=>z(oe).then(de=>[...ge,...de])))}),Q};return(await z(U.location.fsPath)).map(m=>({path:`extension/${g.$jc(U.location.fsPath,m)}`,localPath:m}))}async qb({added:U,removed:z}){if(z){const o=U&&this.D.extUri.isEqual(z.profileLocation,U.profileLocation)?z.extensions.filter(m=>U.extensions.every(F=>!(0,n.$ro)(F,m))):z.extensions;for(const m of o)this.F.info("Extensions removed from another source",m.id,z.profileLocation.toString()),this.u.fire({identifier:m,profileLocation:z.profileLocation})}if(U){const m=(await this.bb.scanExtensions(1,U.profileLocation)).filter(F=>U.extensions.some(C=>(0,n.$ro)(C,F.identifier)));this.s.fire(m.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,U.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:U.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const U=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of U.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(U){if(!U.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const o of U.rawAdded){if(this.rb.has(o)||!this.D.extUri.isEqual(this.D.extUri.dirname(o),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(o,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(o).startsWith(".")||!(await this.ib.stat(o)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(o);m&&m.installedTimestamp===void 0&&(this.rb.add(o),z.push(m))}z.length&&(await this.ub(z.map(o=>[o,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(o=>o.identifier.id)))}async ub(U,z){const o=U.map(m=>m[0]);await this.vb(o),await this.gb.addExtensionsToProfile(U,z),this.s.fire(o.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:z})))}async vb(U){const z=await this.bb.getUninstalledExtensions();for(const o of U){const m=n.$so.create(o);z[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$Bp=G,e.$Bp=G=pe([se(0,i.$2n),se(1,ae.$$k),se(2,ue.$7i),se(3,t.$Uh),se(4,r.$qp),se(5,s.$mp),se(6,P.$Fn),se(7,_.$Lh),se(8,x.$8j),se(9,te.$mj),se(10,le.$Ek),se(11,ie.$Gk)],G);let T=class extends c.$Qc{constructor(U,z,o,m,F,C){super(),this.j=U,this.m=z,this.n=o,this.s=m,this.t=F,this.u=C,this.h=this.B(new v.$Ld),this.onExtract=this.h.event,this.c=(0,d.$tg)(this.n.userExtensionsLocation,".obsolete"),this.g=new A.$Yg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,z){const o={includeInvalid:!0,profileLocation:z};let m=[];return U===null||U===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},o,!1)):U===1&&m.push(...await this.n.scanUserExtensions(o)),m=U!==null?m.filter(F=>F.type===U):m,Promise.all(m.map(F=>this.F(F)))}async scanAllUserExtensions(U){const z=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(z.map(o=>this.F(o)))}async scanUserExtensionAtLocation(U){try{const z=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(U,z,o,m,F){const C=U.toString(),Q=$.URI.file(g.$hc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$cg)()}`)),H=$.URI.file(g.$hc(this.n.userExtensionsLocation.fsPath,C));let ce=await this.m.exists(H);if(ce&&m){try{await this.y(U.id,H,"removeExisting")}catch{throw new i.$3n(p.localize(4,null,H.fsPath,U.id),i.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${H.fsPath}`),await(0,I.$fp)(z,Q.fsPath,{sourcePath:"extension",overwrite:!0},F),this.u.info(`Extracted extension to ${H}:`,U.id)}catch(oe){let ge=i.ExtensionManagementErrorCode.Extract;throw oe instanceof I.$dp&&(oe.type==="CorruptZip"?ge=i.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(ge=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$3n(oe.message,ge)}await this.n.updateMetadata(Q,o);try{this.u.trace(`Started renaming the extension from ${Q.fsPath} to ${H.fsPath}`),await this.C(Q.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,j.$8)(oe)}. Deleted from extracted location`,Q),oe}this.h.fire(H)}catch(oe){try{await this.m.del(Q,{recursive:!0})}catch{}throw oe}return this.D(H,1)}async scanMetadata(U,z){return z?(await this.w(U,z))?.metadata:this.n.scanMetadata(U.location)}async w(U,z){return(await this.s.scanProfileExtensions(z)).find(m=>(0,n.$ro)(m.identifier,U.identifier))}async updateMetadata(U,z,o){return o?await this.s.updateMetadata([[U,z]],o):await this.n.updateMetadata(U.location,z),this.D(U.location,U.type,o)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const z=U.map(o=>n.$so.create(o));await this.z(o=>z.forEach(m=>{o[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(U){await this.z(z=>delete z[U.toString()])}async removeExtension(U,z){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,z)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(z=>delete z[n.$so.create(U).toString()])}async copyExtension(U,z,o,m){const F=await this.w(U,z),C=await this.w(U,o);return m={...F?.metadata,...m},C?await this.s.updateMetadata([[U,{...C.metadata,...m}]],o):await this.s.addExtensionsToProfile([[U,m]],o),this.D(U.location,U.type,o)}async copyExtensions(U,z){const o=await this.scanExtensions(1,U),m=await Promise.all(o.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,U)]));await this.s.addExtensionsToProfile(m,z)}async y(U,z,o){this.u.trace(`Deleting ${o} extension from disk`,U,z.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$Ai)((0,h.$cg)()).toString(16)}${q}`);await this.C(z.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${o} extension from disk`,U,z.fsPath)}async z(U){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,x.$lk)(m)!==1)throw m}let o={};if(z)try{o=JSON.parse(z)}catch{}return U&&(U(o),Object.keys(o).length?await this.m.writeFile(this.c,N.$_d.fromString(JSON.stringify(o))):await this.m.del(this.c)),o})}async C(U,z){try{await f.Promises.rename(U,z,2*60*1e3)}catch(o){throw new i.$3n(o.message||p.localize(5,null,U,z),o.code||i.ExtensionManagementErrorCode.Rename)}}async D(U,z,o){if(o){const F=(await this.n.scanUserExtensions({profileLocation:o})).find(C=>this.t.extUri.isEqual(C.location,U));if(F)return this.F(F)}else{const m=await this.n.scanExistingExtension(U,z,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(p.localize(6,null,U.path))}async F(U){const z=await this.m.resolve(U.location);let o,m;return z.children&&(o=z.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,m=z.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:o,changelogUrl:m,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),o=new Set;for(const F of z)U[n.$so.create(F).toString()]||o.add(F.identifier.id.toLowerCase());try{const F=(0,n.$xo)(z,C=>C.identifier);await A.Promises.settled(F.map(async C=>{const Q=C.sort((H,ce)=>S.rcompare(H.manifest.version,ce.manifest.version))[0];o.has(Q.identifier.id.toLowerCase())||await this.j(await this.F(Q))}))}catch(F){this.u.error(F)}const m=z.filter(F=>F.metadata&&U[n.$so.create(F).toString()]);await Promise.allSettled(m.map(F=>this.removeUninstalledExtension(F)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,x.$lk)(z)!==1&&this.u.error(z);return}if(U?.children)try{await Promise.allSettled(U.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(o){(0,x.$lk)(o)!==1&&this.u.error(o)}}}))}catch{}}};e.$Cp=T,e.$Cp=T=pe([se(1,x.$8j),se(2,r.$qp),se(3,s.$mp),se(4,le.$Ek),se(5,ue.$7i)],T);class M extends a.$kp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$Df)(this.options.operation)?this.l:this.options.operation}constructor(U,z,o,m,F,C,Q,H,ce){super(),this.identifier=U,this.source=z,this.options=o,this.m=m,this.n=F,this.o=C,this.p=Q,this.q=H,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[z,o]=await this.x(U);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,o]],this.j),z}async u({zipPath:U,key:z,metadata:o},m,F){let C=await this.v(z);return C||(this.s.trace("Extracting extension...",z.id),C=await this.m.extractUserExtension(z,U,o,m,F),this.s.info("Extracting extension completed.",z.id)),C}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(m=>n.$so.create(m).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class B extends M{constructor(U,z,o,m,F,C,Q,H,ce,oe){super(z.identifier,z,o,F,C,Q,H,ce,oe),this.y=z,this.z=m}async x(U){const o=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Q=>(0,n.$ro)(Q.identifier,this.y.identifier));o&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||o?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||o?.isMachineScoped,isBuiltin:this.options.isBuiltin||o?.isBuiltin,isSystem:o?.type===0?!0:void 0,updated:!!o,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$Cf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:o?.preRelease)};if(o?.manifest.version===this.y.version)return[await this.m.updateMetadata(o,m),m];const{location:F,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(F.fsPath),[await this.u({zipPath:F.fsPath,key:n.$so.create(this.y),metadata:m},!1,U),m]}catch(Q){try{await this.z.delete(F)}catch(H){this.s.warn("Error while deleting the downloaded file",F.toString(),(0,j.$8)(H))}throw Q}}async B(U){try{await(0,y.$xp)(U)}catch(z){throw new i.$3n((0,a.$ip)(z).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$Dp=B;class X extends M{constructor(U,z,o,m,F,C,Q,H,ce,oe){super({id:(0,n.$wo)(U.publisher,U.name)},z,o,F,C,Q,H,ce,oe),this.y=U,this.z=z,this.A=m}async h(U){const z=await super.h(U);return this.D(z,U),z}async x(U){const z=new n.$so(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Q=>(0,n.$ro)(this.identifier,Q.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this.l=3,z.equals(new n.$so(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&S.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Q=await this.v(z);if(Q)try{await this.m.removeExtension(Q,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$ic(this.z.fsPath),key:z,metadata:F},!0,U),F]}async D(U,z){try{let[o]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],z);if(o||([o]=await this.A.getExtensions([{id:U.identifier.id}],z)),o){const m={id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId,isPreReleaseVersion:o.properties.isPreReleaseVersion,preRelease:o.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,m,this.options.profileLocation)}}catch{}}}class Z extends a.$kp{constructor(U,z,o){super(),this.extension=U,this.j=z,this.k=o}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;let S=class extends O.$Lo{constructor(f,I,p,P){super(P),this.m=f,this.n=I,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,I){const{f:p,g:P}=this;let t;try{t=await(0,c.$Ol)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$8)(n)))}const a={...process.env,...t},i=f.agent?f.agent:await(0,g.$Pq)(f.url||"",a,{proxyUrl:p,strictSSL:P});return f.agent=i,f.strictSSL=P,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,I))}async resolveProxy(f){}};e.$Qq=S,e.$Qq=S=pe([se(0,v.$gi),se(1,u.$Uh),se(2,b.$7i),se(3,b.$8i)],S);async function w(h){return((0,A.parse)(h.url).protocol==="https:"?await new Promise((p,P)=>{J(["https"],p,P)}):await new Promise((p,P)=>{J(["http"],p,P)})).request}async function $(h,f){return N.Promises.withAsyncBody(async(I,p)=>{const P=(0,A.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await w(h),a={hostname:P.hostname,port:P.port?parseInt(P.port):P.protocol==="https:"?443:80,protocol:P.protocol,path:P.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,j.$Cf)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(a.auth=h.user+":"+h.password);const i=t(a,n=>{const s=(0,j.$Af)(h.followRedirects)?h.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)$({...h,url:n.headers.location,followRedirects:s-1},f).then(I,p);else{let r=n;!h.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,d.createGunzip)())),I({res:n,stream:(0,R.$oe)(r)})}});i.on("error",p),h.timeout&&i.setTimeout(h.timeout),h.isChromiumNetwork&&i.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&i.write(h.data),i.end(),f.onCancellationRequested(()=>{i.abort(),p(new L.$3)})})}e.$Rq=$}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,A,N,R,L,j,v,u,c,b,O,g,d,S,w,$,h,f,I,p,P,t,a,i,n,s,r,l,k,y,E,D,W,x,_,ue,te,ae,le,ie,q,G,T,M,B,X,Z,K,U,z,o,m,F,C,Q,H,ce,oe,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$Qc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Pe=be.get(_.$7i),Fe=be.get(r.$8j),V=be.get(h.$Uh),Y=be.get(m.$Gk);Pe.info("CLI main",this.b),this.g(Pe),await this.h(V,Fe,Y,he),await Promise.all(we.map(ee=>{(0,N.$Jg)(ee.flush(),1e3)}))})}async f(){const he=new D.$Kh,we={_serviceBrand:void 0,...le.default};he.set(ie.$mj,we);const be=new f.$bm(this.b,we);he.set(h.$Uh,be),await Promise.all([be.appSettingsHome.with({scheme:v.Schemas.file}).fsPath,be.extensionsPath].map(Ne=>Ne?g.Promises.mkdir(Ne,{recursive:!0}):void 0));const Pe=new ce.$jN((0,_.$ij)(be),be.logsHome);he.set(_.$8i,Pe);const Fe=this.B(Pe.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];Pe.getLogLevel()===_.LogLevel.Trace&&V.push(new _.$cj(Pe.getLogLevel()));const Y=this.B(new H.$tN(Fe,V));he.set(_.$7i,Y);const ee=this.B(new l.$Fp(Y));he.set(r.$8j,ee);const $e=this.B(new k.$5p(Y));ee.registerProvider(v.Schemas.file,$e);const ye=new o.$rr(ee);he.set(z.$Ek,ye);const De=new T.$nN(1,be,Y,ee),Se=new F.$pN(De,ye,be,ee,Y);he.set(m.$Gk,Se),ee.registerProvider(v.Schemas.vscodeUserData,new ge.$R7b(v.Schemas.file,$e,v.Schemas.vscodeUserData,Se,ye,Y));const Ae=c.$i&&we.win32RegValueName?this.B(new ae.$P7b(Y,we.win32RegValueName)):be.policyFile?this.B(new ue.$Q7b(be.policyFile,ee,Y)):new te.$bn;he.set(te.$_m,Ae);const Ie=this.B(new S.$Bn(Se.defaultProfile.settingsResource,ee,Ae,Y));he.set(d.$gi,Ie),await Promise.all([De.init(),Ie.initialize()]);let Le;try{Le=await(0,C.$w7b)(De,Y)}catch(Ne){Ne.code!=="ENOENT"&&Y.error(Ne)}Se.init(),he.set(z.$Ek,new o.$rr(ee));const Ue=new G.$Qq(Ie,be,Y,Pe);he.set(q.$Ko,Ue),he.set(w.$Fn,new y.$Jh($.$IN,void 0,!0)),he.set(a.$mp,new y.$Jh(Q.$sN,void 0,!0)),he.set(i.$qp,new y.$Jh(s.$t7b,void 0,!0)),he.set(P.$9o,new y.$Jh(P.$0o,void 0,!0)),he.set(n.$Ap,new y.$Jh(n.$Bp,void 0,!0)),he.set(p.$2n,new y.$Jh(I.$8o,void 0,!0)),he.set(W.$Kq,new y.$Jh(x.$Mq,void 0,!1));const Oe=[],je=(0,Z.$oo)(we,Ie);if((0,Z.$jo)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new K.$hN(Ue,je,"monacoworkbench",null,we.aiConfig.ariaKey));const Ne={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,M.$_n)((0,A.release)(),(0,A.hostname)(),process.arch,we.commit,we.version,Le,je),piiPaths:(0,Z.$po)(be)};he.set(B.$$k,new y.$Jh(X.$Sq,[Ne],!1))}else he.set(B.$$k,Z.$do);return[new E.$8p(he),Oe]}g(he){(0,L.setUnexpectedErrorHandler)(we=>{const be=(0,R.$xi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,L.$X)(we)||(0,L.$Y)(we)}),process.on("unhandledRejection",we=>(0,L.$Y)(we))}async h(he,we,be,Pe){let Fe;if(he.args.profile&&(Fe=be.profiles.find(Y=>Y.name===he.args.profile),!Fe))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Fe??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Pe.createInstance(t.$$o,new _.$cj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Pe.createInstance(t.$$o,new _.$cj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return Pe.createInstance(t.$$o,new _.$cj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Pe.createInstance(t.$$o,new _.$cj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$b8b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?O.URI.file((0,u.$gc)(we)?we:(0,u.$hc)((0,b.cwd)(),we)):we)}}async function me(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=me})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4a0e77678c0295b518151ae2d706436bab96ef4f/core/vs/code/node/cliProcessMain.js.map
