/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],O=0,N=te.length;O<N;O++)e[O]=oe[te[O]];return e};define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class O{static get(){const j=new Map,A=new Map,I=new Map,D=new Map;function C(c,g){c.has(g.detail)||c.set(g.detail,-g.timestamp)}function d(c,g){const p=c.get(g.detail);p&&(p>=0||c.set(g.detail,p+g.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((c,g)=>c.timestamp-g.timestamp));for(const c of P)switch(c.type){case 10:C(j,c);break;case 11:case 12:d(j,c);break;case 21:C(A,c);break;case 22:d(A,c);break;case 33:C(I,c);break;case 34:d(I,c);break;case 31:C(D,c);break;case 32:d(D,c);break}let E=0;I.forEach(c=>E+=c);function $(c){const g=[];return c.forEach((p,w)=>g.push([w,p])),g}return{amdLoad:$(j),amdInvoke:$(A),nodeRequire:$(I),nodeEval:$(D),nodeRequireTotal:E}}static toMarkdownTable(j,A){let I="";const D=[];return j.forEach((C,d)=>{D[d]=C.length}),A.forEach(C=>{C.forEach((d,P)=>{typeof d>"u"&&(d=C[P]="-");const E=d.toString().length;D[P]=Math.max(E,D[P])})}),j.forEach((C,d)=>{I+=`| ${C+" ".repeat(D[d]-C.toString().length)} `}),I+=`|
`,j.forEach((C,d)=>{I+=`| ${"-".repeat(D[d])} `}),I+=`|
`,A.forEach(C=>{C.forEach((d,P)=>{typeof d<"u"&&(I+=`| ${d+" ".repeat(D[P]-d.toString().length)} `)}),I+=`|
`}),I}}e.$S=O}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function O(p,w,h){const l=N(p,w);if(l!==-1)return p[l]}e.$db=O;function N(p,w,h=p.length-1){for(let l=h;l>=0;l--){const u=p[l];if(w(u))return l}return-1}e.$eb=N;function j(p,w){const h=A(p,w);return h===-1?void 0:p[h]}e.$fb=j;function A(p,w,h=0,l=p.length){let u=h,b=l;for(;u<b;){const S=Math.floor((u+b)/2);w(p[S])?u=S+1:b=S}return u-1}e.$gb=A;function I(p,w){const h=D(p,w);return h===p.length?void 0:p[h]}e.$hb=I;function D(p,w,h=0,l=p.length){let u=h,b=l;for(;u<b;){const S=Math.floor((u+b)/2);w(p[S])?b=S:u=S+1}return u}e.$ib=D;function C(p,w,h=0,l=p.length){const u=D(p,w,h,l);return u===p.length?-1:u}e.$jb=C;class d{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(d.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!w(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const h=A(this.e,w,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$kb=d;function P(p,w){if(p.length===0)return;let h=p[0];for(let l=1;l<p.length;l++){const u=p[l];w(u,h)>0&&(h=u)}return h}e.$lb=P;function E(p,w){if(p.length===0)return;let h=p[0];for(let l=1;l<p.length;l++){const u=p[l];w(u,h)>=0&&(h=u)}return h}e.$mb=E;function $(p,w){return P(p,(h,l)=>-w(h,l))}e.$nb=$;function c(p,w){if(p.length===0)return-1;let h=0;for(let l=1;l<p.length;l++){const u=p[l];w(u,p[h])>0&&(h=l)}return h}e.$ob=c;function g(p,w){for(const h of p){const l=w(h);if(l!==void 0)return l}}e.$pb=g}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function O(I,D){const C=Object.create(null);for(const d of I){const P=D(d);let E=C[P];E||(E=C[P]=[]),E.push(d)}return C}e.$I=O;function N(I,D){const C=[],d=[];for(const P of I)D.has(P)||C.push(P);for(const P of D)I.has(P)||d.push(P);return{removed:C,added:d}}e.$J=N;function j(I,D){const C=[],d=[];for(const[P,E]of I)D.has(P)||C.push(E);for(const[P,E]of D)I.has(P)||d.push(E);return{removed:C,added:d}}e.$K=j;function A(I,D){const C=new Set;for(const d of D)I.has(d)&&C.add(d);return C}e.$L=A}),define(oe[83],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=void 0;function O(I){return(D,C,d)=>{let P=null,E=null;if(typeof d.value=="function"?(P="value",E=d.value):typeof d.get=="function"&&(P="get",E=d.get),!E)throw new Error("not supported");d[P]=I(E,C)}}function N(I,D,C){let d=null,P=null;if(typeof C.value=="function"?(d="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(d="get",P=C.get),!P)throw new Error("not supported");const E=`$memoize$${D}`;C[d]=function(...$){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,$)}),this[E]}}e.$eh=N;function j(I,D,C){return O((d,P)=>{const E=`$debounce$${P}`,$=`$debounce$result$${P}`;return function(...c){this[$]||(this[$]=C?C():void 0),clearTimeout(this[E]),D&&(this[$]=D(this[$],...c),c=[this[$]]),this[E]=setTimeout(()=>{d.apply(this,c),this[$]=C?C():void 0},I)}})}e.$fh=j;function A(I,D,C){return O((d,P)=>{const E=`$throttle$timer$${P}`,$=`$throttle$result$${P}`,c=`$throttle$lastRun$${P}`,g=`$throttle$pending$${P}`;return function(...p){if(this[$]||(this[$]=C?C():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),D&&(this[$]=D(this[$],...p)),this[g])return;const w=this[c]+I;w<=Date.now()?(this[c]=Date.now(),d.apply(this,[this[$]]),this[$]=C?C():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[c]=Date.now(),d.apply(this,[this[$]]),this[$]=C?C():void 0},w-Date.now()))}})}e.$gh=A}),define(oe[8],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class O{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?u.isErrorNoTelemetry(t)?new u(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(a=>{a(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=O,e.$V=new O;function N(S){e.$V.setUnexpectedErrorHandler(S)}e.setUnexpectedErrorHandler=N;function j(S){if(!S||typeof S!="object")return!1;const t=S;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=j;function A(S){d(S)||e.$V.onUnexpectedError(S)}e.$Y=A;function I(S){d(S)||e.$V.onUnexpectedExternalError(S)}e.$Z=I;function D(S){if(S instanceof Error){const{name:t,message:a}=S,s=S.stacktrace||S.stack;return{$isError:!0,name:t,message:a,stack:s,noTelemetry:u.isErrorNoTelemetry(S)}}return S}e.$1=D;const C="Canceled";function d(S){return S instanceof P?!0:S instanceof Error&&S.name===C&&S.message===C}e.$2=d;class P extends Error{constructor(){super(C),this.name=this.message}}e.$3=P;function E(){const S=new Error(C);return S.name=S.message,S}e.$4=E;function $(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}e.$5=$;function c(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}e.$6=c;class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=g;function p(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}e.$8=p;class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=w;class h extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=h;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=l;class u extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof u)return t;const a=new u;return a.message=t.message,a.stack=t.stack,a}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=u;class b extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}e.$ab=b}),define(oe[18],ae([0,1,8,125]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function j(M,J=0){return M[M.length-(1+J)]}e.$qb=j;function A(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.$rb=A;function I(M,J,X=(se,le)=>se===le){if(M===J)return!0;if(!M||!J||M.length!==J.length)return!1;for(let se=0,le=M.length;se<le;se++)if(!X(M[se],J[se]))return!1;return!0}e.$sb=I;function D(M,J){const X=M.length-1;J<X&&(M[J]=M[X]),M.pop()}e.$tb=D;function C(M,J,X){return d(M.length,se=>X(M[se],J))}e.$ub=C;function d(M,J){let X=0,se=M-1;for(;X<=se;){const le=(X+se)/2|0,ue=J(le);if(ue<0)X=le+1;else if(ue>0)se=le-1;else return le}return-(X+1)}e.$vb=d;function P(M,J,X){if(M=M|0,M>=J.length)throw new TypeError("invalid index");const se=J[Math.floor(J.length*Math.random())],le=[],ue=[],he=[];for(const $e of J){const de=X($e,se);de<0?le.push($e):de>0?ue.push($e):he.push($e)}return M<le.length?P(M,le,X):M<le.length+he.length?he[0]:P(M-(le.length+he.length),ue,X)}e.$wb=P;function E(M,J){const X=[];let se;for(const le of M.slice(0).sort(J))!se||J(se[0],le)!==0?(se=[le],X.push(se)):se.push(le);return X}e.$xb=E;function*$(M,J){let X,se;for(const le of M)se!==void 0&&J(se,le)?X.push(le):(X&&(yield X),X=[le]),se=le;X&&(yield X)}e.$yb=$;function c(M,J){for(let X=0;X<=M.length;X++)J(X===0?void 0:M[X-1],X===M.length?void 0:M[X])}e.$zb=c;function g(M,J){for(let X=0;X<M.length;X++)J(X===0?void 0:M[X-1],M[X],X+1===M.length?void 0:M[X+1])}e.$Ab=g;function p(M,J,X){const se=[];function le($e,de,we){if(de===0&&we.length===0)return;const Ee=se[se.length-1];Ee&&Ee.start+Ee.deleteCount===$e?(Ee.deleteCount+=de,Ee.toInsert.push(...we)):se.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===M.length){le(ue,0,J.slice(he));break}if(he===J.length){le(ue,M.length-ue,[]);break}const $e=M[ue],de=J[he],we=X($e,de);we===0?(ue+=1,he+=1):we<0?(le(ue,1,[]),ue+=1):we>0&&(le(ue,0,[de]),he+=1)}return se}e.$Bb=p;function w(M,J,X){const se=p(M,J,X),le=[],ue=[];for(const he of se)le.push(...M.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:le,added:ue}}e.$Cb=w;function h(M,J,X){if(X===0)return[];const se=M.slice(0,X).sort(J);return u(M,J,se,X,M.length),se}e.top=h;function l(M,J,X,se,le){return X===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=M.length,de=M.slice(0,X).sort(J);for(let we=X,Ee=Math.min(X+se,$e);we<$e;we=Ee,Ee=Math.min(Ee+se,$e)){if(we>X&&await new Promise(De=>setTimeout(De)),le&&le.isCancellationRequested)throw new O.$3;u(M,J,de,we,Ee)}return de})().then(ue,he)})}e.$Eb=l;function u(M,J,X,se,le){for(const ue=X.length;se<le;se++){const he=M[se];if(J(he,X[ue-1])<0){X.pop();const $e=(0,N.$ib)(X,de=>J(he,de)<0);X.splice($e,0,he)}}}function b(M){return M.filter(J=>!!J)}e.$Fb=b;function S(M){let J=0;for(let X=0;X<M.length;X++)M[X]&&(M[J]=M[X],J+=1);M.length=J}e.$Gb=S;function t(M,J,X){M.splice(X,0,M.splice(J,1)[0])}e.$Hb=t;function a(M){return!Array.isArray(M)||M.length===0}e.$Ib=a;function s(M){return Array.isArray(M)&&M.length>0}e.$Jb=s;function n(M,J=X=>X){const X=new Set;return M.filter(se=>{const le=J(se);return X.has(le)?!1:(X.add(le),!0)})}e.$Kb=n;function i(M){const J=new Set;return X=>{const se=M(X);return J.has(se)?!1:(J.add(se),!0)}}e.$Lb=i;function r(M,J){return M.length>0?M[0]:J}e.$Mb=r;function o(M,J){return M.length>0?M[M.length-1]:J}e.$Nb=o;function v(M,J,X=(se,le)=>se===le){let se=0;for(let le=0,ue=Math.min(M.length,J.length);le<ue&&X(M[le],J[le]);le++)se++;return se}e.$Ob=v;function y(M){return[].concat(...M)}e.$Pb=y;function f(M,J){let X=typeof J=="number"?M:0;typeof J=="number"?X=M:(X=0,J=M);const se=[];if(X<=J)for(let le=X;le<J;le++)se.push(le);else for(let le=X;le>J;le--)se.push(le);return se}e.$Qb=f;function m(M,J,X){return M.reduce((se,le)=>(se[J(le)]=X?X(le):le,se),Object.create(null))}e.$Rb=m;function L(M,J){return M.push(J),()=>F(M,J)}e.$Sb=L;function F(M,J){const X=M.indexOf(J);if(X>-1)return M.splice(X,1),J}e.$Tb=F;function T(M,J,X){const se=M.slice(0,J),le=M.slice(J);return se.concat(X,le)}e.$Ub=T;function z(M,J){let X;if(typeof J=="number"){let se=J;X=()=>{const le=Math.sin(se++)*179426549;return le-Math.floor(le)}}else X=Math.random;for(let se=M.length-1;se>0;se-=1){const le=Math.floor(X()*(se+1)),ue=M[se];M[se]=M[le],M[le]=ue}}e.$Vb=z;function q(M,J){const X=M.indexOf(J);X>-1&&(M.splice(X,1),M.unshift(J))}e.$Wb=q;function _(M,J){const X=M.indexOf(J);X>-1&&(M.splice(X,1),M.push(J))}e.$Xb=_;function Q(M,J){for(const X of J)M.push(X)}e.$Yb=Q;function Z(M,J){return Array.isArray(M)?M.map(J):J(M)}e.$Zb=Z;function G(M){return Array.isArray(M)?M:[M]}e.$1b=G;function K(M){return M[Math.floor(Math.random()*M.length)]}e.$2b=K;function H(M,J,X){const se=W(M,J),le=M.length,ue=X.length;M.length=le+ue;for(let he=le-1;he>=se;he--)M[he+ue]=M[he];for(let he=0;he<ue;he++)M[he+se]=X[he]}e.$3b=H;function V(M,J,X,se){const le=W(M,J);let ue=M.splice(le,X);return ue===void 0&&(ue=[]),H(M,le,se),ue}e.$4b=V;function W(M,J){return J<0?Math.max(J+M.length,0):Math.min(J,M.length)}var ee;(function(M){function J(ue){return ue<0}M.isLessThan=J;function X(ue){return ue<=0}M.isLessThanOrEqual=X;function se(ue){return ue>0}M.isGreaterThan=se;function le(ue){return ue===0}M.isNeitherLessOrGreaterThan=le,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(M,J){return(X,se)=>J(M(X),M(se))}e.$5b=ne;function re(...M){return(J,X)=>{for(const se of M){const le=se(J,X);if(!ee.isNeitherLessOrGreaterThan(le))return le}return ee.neitherLessOrGreaterThan}}e.$6b=re;const Y=(M,J)=>M-J;e.$7b=Y;const B=(M,J)=>(0,e.$7b)(M?1:0,J?1:0);e.$8b=B;function k(M){return(J,X)=>-M(J,X)}e.$9b=k;class R{constructor(J){this.g=J,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(J){let X=this.c;for(;X<this.g.length&&J(this.g[X]);)X++;const se=X===this.c?null:this.g.slice(this.c,X);return this.c=X,se}takeFromEndWhile(J){let X=this.d;for(;X>=0&&J(this.g[X]);)X--;const se=X===this.d?null:this.g.slice(X+1,this.d+1);return this.d=X,se}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const J=this.g[this.c];return this.c++,J}removeLast(){const J=this.g[this.d];return this.d--,J}takeCount(J){const X=this.g.slice(this.c,this.c+J);return this.c+=J,X}}e.$0b=R;class U{static{this.empty=new U(J=>{})}constructor(J){this.iterate=J}forEach(J){this.iterate(X=>(J(X),!0))}toArray(){const J=[];return this.iterate(X=>(J.push(X),!0)),J}filter(J){return new U(X=>this.iterate(se=>J(se)?X(se):!0))}map(J){return new U(X=>this.iterate(se=>X(J(se))))}some(J){let X=!1;return this.iterate(se=>(X=J(se),!X)),X}findFirst(J){let X;return this.iterate(se=>J(se)?(X=se,!1):!0),X}findLast(J){let X;return this.iterate(se=>(J(se)&&(X=se),!0)),X}findLastMaxBy(J){let X,se=!0;return this.iterate(le=>((se||ee.isGreaterThan(J(le,X)))&&(se=!1,X=le),!0)),X}}e.$$b=U}),define(oe[127],ae([0,1,8]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$4c=e.$3c=e.$2c=e.ok=void 0;function N(C,d){if(!C)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=N;function j(C,d="Unreachable"){throw new Error(d)}e.$2c=j;function A(C){if(!C)throw new O.$ab("Assertion Failed")}e.$3c=A;function I(C){if(!C()){debugger;C(),(0,O.$Y)(new O.$ab("Assertion Failed"))}}e.$4c=I;function D(C,d){let P=0;for(;P<C.length-1;){const E=C[P],$=C[P+1];if(!d(E,$))return!1;P++}return!0}e.$5c=D}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function O(N){const j=this;let A=!1,I;return function(){return A||(A=!0,I=N.apply(j,arguments)),I}}e.$bb=O}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(N){function j(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}N.is=j;const A=Object.freeze([]);function I(){return A}N.empty=I;function*D(S){yield S}N.single=D;function C(S){return j(S)?S:D(S)}N.wrap=C;function d(S){return S||A}N.from=d;function*P(S){for(let t=S.length-1;t>=0;t--)yield S[t]}N.reverse=P;function E(S){return!S||S[Symbol.iterator]().next().done===!0}N.isEmpty=E;function $(S){return S[Symbol.iterator]().next().value}N.first=$;function c(S,t){for(const a of S)if(t(a))return!0;return!1}N.some=c;function g(S,t){for(const a of S)if(t(a))return a}N.find=g;function*p(S,t){for(const a of S)t(a)&&(yield a)}N.filter=p;function*w(S,t){let a=0;for(const s of S)yield t(s,a++)}N.map=w;function*h(...S){for(const t of S)for(const a of t)yield a}N.concat=h;function l(S,t,a){let s=a;for(const n of S)s=t(s,n);return s}N.reduce=l;function*u(S,t,a=S.length){for(t<0&&(t+=S.length),a<0?a+=S.length:a>S.length&&(a=S.length);t<a;t++)yield S[t]}N.slice=u;function b(S,t=Number.POSITIVE_INFINITY){const a=[];if(t===0)return[a,S];const s=S[Symbol.iterator]();for(let n=0;n<t;n++){const i=s.next();if(i.done)return[a,N.empty()];a.push(i.value)}return[a,{[Symbol.iterator](){return s}}]}N.consume=b})(O||(e.Iterable=O={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var j;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function I(t,a=!1){let s=0;const n=t.length;let i="",r=0,o=16,v=0;function y(q){let _=0,Q=0;for(;_<q;){const Z=t.charCodeAt(s);if(Z>=48&&Z<=57)Q=Q*16+Z-48;else if(Z>=65&&Z<=70)Q=Q*16+Z-65+10;else if(Z>=97&&Z<=102)Q=Q*16+Z-97+10;else break;s++,_++}return _<q&&(Q=-1),Q}function f(q){s=q,i="",r=0,o=16,v=0}function m(){const q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&d(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&d(t.charCodeAt(s)))for(s++;s<t.length&&d(t.charCodeAt(s));)s++;else return v=3,t.substring(q,s);let _=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&d(t.charCodeAt(s))){for(s++;s<t.length&&d(t.charCodeAt(s));)s++;_=s}else v=3;return t.substring(q,_)}function L(){let q="",_=s;for(;;){if(s>=n){q+=t.substring(_,s),v=2;break}const Q=t.charCodeAt(s);if(Q===34){q+=t.substring(_,s),s++;break}if(Q===92){if(q+=t.substring(_,s),s++,s>=n){v=2;break}switch(t.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const G=y(4);G>=0?q+=String.fromCharCode(G):v=4;break}default:v=5}_=s;continue}if(Q>=0&&Q<=31)if(C(Q)){q+=t.substring(_,s),v=2;break}else v=6;s++}return q}function F(){if(i="",v=0,r=s,s>=n)return r=n,o=17;let q=t.charCodeAt(s);if(D(q)){do s++,i+=String.fromCharCode(q),q=t.charCodeAt(s);while(D(q));return o=15}if(C(q))return s++,i+=String.fromCharCode(q),q===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),o=14;switch(q){case 123:return s++,o=1;case 125:return s++,o=2;case 91:return s++,o=3;case 93:return s++,o=4;case 58:return s++,o=6;case 44:return s++,o=5;case 34:return s++,i=L(),o=10;case 47:{const _=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!C(t.charCodeAt(s));)s++;return i=t.substring(_,s),o=12}if(t.charCodeAt(s+1)===42){s+=2;const Q=n-1;let Z=!1;for(;s<Q;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,Z=!0;break}s++}return Z||(s++,v=1),i=t.substring(_,s),o=13}return i+=String.fromCharCode(q),s++,o=16}case 45:if(i+=String.fromCharCode(q),s++,s===n||!d(t.charCodeAt(s)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=m(),o=11;default:for(;s<n&&T(q);)s++,q=t.charCodeAt(s);if(r!==s){switch(i=t.substring(r,s),i){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return i+=String.fromCharCode(q),s++,o=16}}function T(q){if(D(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let q;do q=F();while(q>=12&&q<=15);return q}return{setPosition:f,getPosition:()=>s,scan:a?z:F,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>v}}e.$Lm=I;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function C(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function E(t,a){const s=[],n=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(y,f,m,L){r.value=y,r.offset=f,r.length=m,r.type=L,r.colonOffset=void 0,i=r}try{u(t,{onObjectBegin:(y,f)=>{if(a<=y)throw n;i=void 0,o=a>y,s.push("")},onObjectProperty:(y,f,m)=>{if(a<f||(v(y,f,m,"property"),s[s.length-1]=y,a<=f+m))throw n},onObjectEnd:(y,f)=>{if(a<=y)throw n;i=void 0,s.pop()},onArrayBegin:(y,f)=>{if(a<=y)throw n;i=void 0,s.push(0)},onArrayEnd:(y,f)=>{if(a<=y)throw n;i=void 0,s.pop()},onLiteralValue:(y,f,m)=>{if(a<f||(v(y,f,m,S(y)),a<=f+m))throw n},onSeparator:(y,f,m)=>{if(a<=f)throw n;if(y===":"&&i&&i.type==="property")i.colonOffset=f,o=!1,i=void 0;else if(y===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(o=!0,s[s.length-1]=""),i=void 0}}})}catch(y){if(y!==n)throw y}return{path:s,previousNode:i,isAtPropertyKey:o,matches:y=>{let f=0;for(let m=0;f<y.length&&m<s.length;m++)if(y[f]===s[m]||y[f]==="*")f++;else if(y[f]!=="**")return!1;return f===y.length}}}e.$Mm=E;function $(t,a=[],s=A.DEFAULT){let n=null,i=[];const r=[];function o(y){Array.isArray(i)?i.push(y):n!==null&&(i[n]=y)}return u(t,{onObjectBegin:()=>{const y={};o(y),r.push(i),i=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const y=[];o(y),r.push(i),i=y,n=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:o,onError:(y,f,m)=>{a.push({error:y,offset:f,length:m})}},s),i[0]}e.$Nm=$;function c(t,a=[],s=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function r(y){return n.children.push(y),y}u(t,{onObjectBegin:y=>{n=r({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,f,m)=>{n=r({type:"property",offset:f,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:f,length:m,parent:n})},onObjectEnd:(y,f)=>{n.length=y+f-n.offset,n=n.parent,i(y+f)},onArrayBegin:(y,f)=>{n=r({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,f)=>{n.length=y+f-n.offset,n=n.parent,i(y+f)},onLiteralValue:(y,f,m)=>{r({type:S(y),offset:f,length:m,parent:n,value:y}),i(f+m)},onSeparator:(y,f,m)=>{n.type==="property"&&(y===":"?n.colonOffset=f:y===","&&i(f))},onError:(y,f,m)=>{a.push({error:y,offset:f,length:m})}},s);const v=n.children[0];return v&&delete v.parent,v}e.$Om=c;function g(t,a){if(!t)return;let s=t;for(const n of a)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===n){s=r.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}e.$Pm=g;function p(t){if(!t.parent||!t.parent.children)return[];const a=p(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;a.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&a.push(s)}return a}e.$Qm=p;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const a=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(a[s.children[0].value]=w(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Rm=w;function h(t,a,s=!1){return a>=t.offset&&a<t.offset+t.length||s&&a===t.offset+t.length}e.$Sm=h;function l(t,a,s=!1){if(h(t,a,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=a;i++){const r=l(n[i],a,s);if(r)return r}return t}}e.$Tm=l;function u(t,a,s=A.DEFAULT){const n=I(t,!1);function i(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(ne){return ne?re=>ne(re,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=i(a.onObjectBegin),v=r(a.onObjectProperty),y=i(a.onObjectEnd),f=i(a.onArrayBegin),m=i(a.onArrayEnd),L=r(a.onLiteralValue),F=r(a.onSeparator),T=i(a.onComment),z=r(a.onError),q=s&&s.disallowComments,_=s&&s.allowTrailingComma;function Q(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:q||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(ne){case 12:case 13:q?Z(10):T();break;case 16:Z(1);break;case 15:case 14:break;default:return ne}}}function Z(ne,re=[],Y=[]){if(z(ne),re.length+Y.length>0){let B=n.getToken();for(;B!==17;){if(re.indexOf(B)!==-1){Q();break}else if(Y.indexOf(B)!==-1)break;B=Q()}}}function G(ne){const re=n.getTokenValue();return ne?L(re):v(re),Q(),!0}function K(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(Z(2),ne=0)}catch{Z(2)}L(ne);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return Q(),!0}function H(){return n.getToken()!==10?(Z(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(F(":"),Q(),ee()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function V(){o(),Q();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||Z(4,[],[]),F(","),Q(),n.getToken()===2&&_)break}else ne&&Z(6,[],[]);H()||Z(4,[],[2,5]),ne=!0}return y(),n.getToken()!==2?Z(7,[2],[]):Q(),!0}function W(){f(),Q();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||Z(4,[],[]),F(","),Q(),n.getToken()===4&&_)break}else ne&&Z(6,[],[]);ee()||Z(4,[],[4,5]),ne=!0}return m(),n.getToken()!==4?Z(8,[4],[]):Q(),!0}function ee(){switch(n.getToken()){case 3:return W();case 1:return V();case 10:return G(!0);default:return K()}}return Q(),n.getToken()===17?s.allowEmptyContent?!0:(Z(4,[],[]),!1):ee()?(n.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}e.$Um=u;function b(t,a){const s=I(t),n=[];let i,r=0,o;do switch(o=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:r!==o&&n.push(t.substring(r,o)),a!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,a)),r=s.getPosition();break}while(i!==17);return n.join("")}e.$Vm=b;function S(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Wm=S}),define(oe[41],ae([0,1,35]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MS=e.$LS=e.$KS=e.$JS=void 0;function N(d,P,E){let $,c,g,p,w;if(P){for(p=P.offset,w=p+P.length,g=p;g>0&&!C(d,g-1);)g--;let o=w;for(;o<d.length&&!C(d,o);)o++;c=d.substring(g,o),$=I(c,E)}else c=d,$=0,g=0,p=0,w=d.length;const h=D(E,d);let l=!1,u=0,b;E.insertSpaces?b=A(" ",E.tabSize||4):b="	";const S=(0,O.$Lm)(c,!1);let t=!1;function a(){return h+A(b,$+u)}function s(){let o=S.scan();for(l=!1;o===15||o===14;)l=l||o===14,o=S.scan();return t=o===16||S.getTokenError()!==0,o}const n=[];function i(o,v,y){!t&&v<w&&y>p&&d.substring(v,y)!==o&&n.push({offset:v,length:y-v,content:o})}let r=s();if(r!==17){const o=S.getTokenOffset()+g,v=A(b,$);i(v,g,o)}for(;r!==17;){let o=S.getTokenOffset()+S.getTokenLength()+g,v=s(),y="";for(;!l&&(v===12||v===13);){const m=S.getTokenOffset()+g;i(" ",o,m),o=S.getTokenOffset()+S.getTokenLength()+g,y=v===12?a():"",v=s()}if(v===2)r!==1&&(u--,y=a());else if(v===4)r!==3&&(u--,y=a());else{switch(r){case 3:case 1:u++,y=a();break;case 5:case 12:y=a();break;case 13:l?y=a():y=" ";break;case 6:y=" ";break;case 10:if(v===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?y=" ":v!==5&&v!==17&&(t=!0);break;case 16:t=!0;break}l&&(v===12||v===13)&&(y=a())}const f=S.getTokenOffset()+g;i(y,o,f),r=v}return n}e.$JS=N;function j(d,P){const E=JSON.stringify(d,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.$KS=j;function A(d,P){let E="";for(let $=0;$<P;$++)E+=d;return E}function I(d,P){let E=0,$=0;const c=P.tabSize||4;for(;E<d.length;){const g=d.charAt(E);if(g===" ")$++;else if(g==="	")$+=c;else break;E++}return Math.floor($/c)}function D(d,P){for(let E=0;E<P.length;E++){const $=P.charAt(E);if($==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return d&&d.eol||`
`}e.$LS=D;function C(d,P){return`\r
`.indexOf(d.charAt(P))!==-1}e.$MS=C}),define(oe[85],ae([0,1,35,41]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RS=e.$QS=e.$PS=e.$OS=e.$NS=void 0;function j(d,P,E){return A(d,P,void 0,E)}e.$NS=j;function A(d,P,E,$,c){const g=P.slice(),p=[],w=(0,O.$Om)(d,p);let h,l;for(;g.length>0&&(l=g.pop(),h=(0,O.$Pm)(w,g),h===void 0&&E!==void 0);)typeof l=="string"?E={[l]:E}:E=[E];if(h)if(h.type==="object"&&typeof l=="string"&&Array.isArray(h.children)){const u=(0,O.$Pm)(h,[l]);if(u!==void 0)if(E===void 0){if(!u.parent)throw new Error("Malformed AST");const b=h.children.indexOf(u.parent);let S,t=u.parent.offset+u.parent.length;if(b>0){const a=h.children[b-1];S=a.offset+a.length}else S=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return I(d,{offset:S,length:t-S,content:""},$)}else return I(d,{offset:u.offset,length:u.length,content:JSON.stringify(E)},$);else{if(E===void 0)return[];const b=`${JSON.stringify(l)}: ${JSON.stringify(E)}`,S=c?c(h.children.map(a=>a.children[0].value)):h.children.length;let t;if(S>0){const a=h.children[S-1];t={offset:a.offset+a.length,length:0,content:","+b}}else h.children.length===0?t={offset:h.offset+1,length:0,content:b}:t={offset:h.offset+1,length:0,content:b+","};return I(d,t,$)}}else if(h.type==="array"&&typeof l=="number"&&Array.isArray(h.children))if(E!==void 0){const u=`${JSON.stringify(E)}`;let b;if(h.children.length===0||l===0)b={offset:h.offset+1,length:0,content:h.children.length===0?u:u+","};else{const S=l===-1||l>h.children.length?h.children.length:l,t=h.children[S-1];b={offset:t.offset+t.length,length:0,content:","+u}}return I(d,b,$)}else{const u=l,b=h.children[u];let S;if(h.children.length===1)S={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===u){const t=h.children[u-1],a=t.offset+t.length,s=h.offset+h.length;S={offset:a,length:s-2-a,content:""}}else S={offset:b.offset,length:h.children[u+1].offset-b.offset,content:""};return I(d,S,$)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${h.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return I(d,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},$)}}e.$OS=A;function I(d,P,E){let $=D(d,P),c=P.offset,g=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;c>0&&!(0,N.$MS)($,c-1);)c--;for(;g<$.length&&!(0,N.$MS)($,g);)g++}const p=(0,N.$JS)($,{offset:c,length:g-c},E);for(let h=p.length-1;h>=0;h--){const l=p[h];$=D($,l),c=Math.min(c,l.offset),g=Math.max(g,l.offset+l.length),g+=l.content.length-l.length}const w=d.length-($.length-g)-c;return[{offset:c,length:w,content:$.substring(c,g)}]}e.$PS=I;function D(d,P){return d.substring(0,P.offset)+P.content+d.substring(P.offset+P.length)}e.$QS=D;function C(d,P){const E=P.slice(0).sort((c,g)=>{const p=c.offset-g.offset;return p===0?c.length-g.length:p});let $=d.length;for(let c=E.length-1;c>=0;c--){const g=E[c];if(g.offset+g.length<=$)d=D(d,g);else throw new Error("Overlapping edit");$=g.offset}return d}e.$RS=C}),define(oe[86],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class O{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=O}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=void 0;class O{static{this.Undefined=new O(void 0)}constructor(A){this.element=A,this.next=O.Undefined,this.prev=O.Undefined}}class N{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let A=this.a;for(;A!==O.Undefined;){const I=A.next;A.prev=O.Undefined,A.next=O.Undefined,A=I}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,I){const D=new O(A);if(this.a===O.Undefined)this.a=D,this.b=D;else if(I){const d=this.b;this.b=D,D.prev=d,d.next=D}else{const d=this.a;this.a=D,D.next=d,d.prev=D}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(D))}}shift(){if(this.a!==O.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==O.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==O.Undefined&&A.next!==O.Undefined){const I=A.prev;I.next=A.next,A.next.prev=I}else A.prev===O.Undefined&&A.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):A.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):A.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==O.Undefined;)yield A.element,A=A.next}}e.$Zc=N}),define(oe[34],ae([0,1]),function(te,e){"use strict";var O,N,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.Touch=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=void 0;function A(l,u,b){let S=l.get(u);return S===void 0&&(S=b,l.set(u,S)),S}e.$vc=A;function I(l){const u=[];return l.forEach((b,S)=>{u.push(`${S} => ${b}`)}),`Map(${l.size}) {${u.join(", ")}}`}e.$wc=I;function D(l){const u=[];return l.forEach(b=>{u.push(b)}),`Set(${l.size}) {${u.join(", ")}}`}e.$xc=D;class C{constructor(u,b){this.uri=u,this.value=b}}function d(l){return Array.isArray(l)}class P{static{this.a=u=>u.toString()}constructor(u,b){if(this[O]="ResourceMap",u instanceof P)this.b=new Map(u.b),this.c=b??P.a;else if(d(u)){this.b=new Map,this.c=b??P.a;for(const[S,t]of u)this.set(S,t)}else this.b=new Map,this.c=u??P.a}set(u,b){return this.b.set(this.c(u),new C(u,b)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,b){typeof b<"u"&&(u=u.bind(b));for(const[S,t]of this.b)u(t.value,t.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}e.$yc=P;class E{constructor(u,b){this[N]="ResourceSet",!u||typeof u=="function"?this.a=new P(u):(this.a=new P(b),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,b){this.a.forEach((S,t)=>u.call(b,t,t,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zc=E;var $;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})($||(e.Touch=$={}));class c{constructor(){this[j]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,b=0){const S=this.a.get(u);if(S)return b!==0&&this.j(S,b),S.value}set(u,b,S=0){let t=this.a.get(u);if(t)t.value=b,S!==0&&this.j(t,S);else{switch(t={key:u,value:b,next:void 0,previous:void 0},S){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(u,t),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const b=this.a.get(u);if(b)return this.a.delete(u),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,b){const S=this.e;let t=this.b;for(;t;){if(b?u.bind(b)(t.value,t.key,this):u(t.value,t.key,this),this.e!==S)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const u=this,b=this.e;let S=this.b;const t={[Symbol.iterator](){return t},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:S.key,done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return t}values(){const u=this,b=this.e;let S=this.b;const t={[Symbol.iterator](){return t},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:S.value,done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return t}entries(){const u=this,b=this.e;let S=this.b;const t={[Symbol.iterator](){return t},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:[S.key,S.value],done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return t}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let b=this.b,S=this.size;for(;b&&S>u;)this.a.delete(b.key),b=b.next,S--;this.b=b,this.d=S,b&&(b.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const b=u.next,S=u.previous;if(!b||!S)throw new Error("Invalid list");b.previous=S,S.next=b}u.next=void 0,u.previous=void 0,this.e++}j(u,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(u===this.b)return;const S=u.next,t=u.previous;u===this.c?(t.next=void 0,this.c=t):(S.previous=t,t.next=S),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(b===2){if(u===this.c)return;const S=u.next,t=u.previous;u===this.b?(S.previous=void 0,this.b=S):(S.previous=t,t.next=S),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((b,S)=>{u.push([S,b])}),u}fromJSON(u){this.clear();for(const[b,S]of u)this.set(b,S)}}e.$Ac=c;class g extends c{constructor(u,b=1){super(),this.k=u,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,b=2){return super.get(u,b)}peek(u){return super.get(u,0)}set(u,b){return super.set(u,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bc=g;class p{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let b=this.a.get(u)||0;return b===0?!1:(b--,b===0?this.a.delete(u):this.a.set(u,b),!0)}has(u){return this.a.has(u)}}e.$Cc=p;class w{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[b,S]of u)this.set(b,S)}clear(){this.a.clear(),this.b.clear()}set(u,b){this.a.set(u,b),this.b.set(b,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const b=this.a.get(u);return b===void 0?!1:(this.a.delete(u),this.b.delete(b),!0)}forEach(u,b){this.a.forEach((S,t)=>{u.call(b,S,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Dc=w;class h{constructor(){this.a=new Map}add(u,b){let S=this.a.get(u);S||(S=new Set,this.a.set(u,S)),S.add(b)}delete(u,b){const S=this.a.get(u);S&&(S.delete(b),S.size===0&&this.a.delete(u))}forEach(u,b){const S=this.a.get(u);S&&S.forEach(b)}get(u){const b=this.a.get(u);return b||new Set}}e.$Ec=h}),define(oe[2],ae([0,1,18,126,34,84,59]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=void 0;const D=!1;let C=null;class d{constructor(){this.b=new Map}static{this.a=0}c(m){let L=this.b.get(m);return L||(L={parent:null,source:null,isSingleton:!1,value:m,idx:d.a++},this.b.set(m,L)),L}trackDisposable(m){const L=this.c(m);L.source||(L.source=new Error().stack)}setParent(m,L){const F=this.c(m);F.parent=L}markAsDisposed(m){this.b.delete(m)}markAsSingleton(m){this.c(m).isSingleton=!0}f(m,L){const F=L.get(m);if(F)return F;const T=m.parent?this.f(this.c(m.parent),L):m;return L.set(m,T),T}getTrackedDisposables(){const m=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,m).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(m=10,L){let F;if(L)F=L;else{const Q=new Map,Z=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,Q).isSingleton);if(Z.length===0)return;const G=new Set(Z.map(K=>K.value));if(F=Z.filter(K=>!(K.parent&&G.has(K.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(Q){function Z(K,H){for(;K.length>0&&H.some(V=>typeof V=="string"?V===K[0]:K[0].match(V));)K.shift()}const G=Q.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return Z(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const z=new j.$Ec;for(const Q of F){const Z=T(Q);for(let G=0;G<=Z.length;G++)z.add(Z.slice(0,G).join(`
`),Q)}F.sort((0,O.$5b)(Q=>Q.idx,O.$7b));let q="",_=0;for(const Q of F.slice(0,m)){_++;const Z=T(Q),G=[];for(let K=0;K<Z.length;K++){let H=Z[K];H=`(shared with ${z.get(Z.slice(0,K+1).join(`
`)).size}/${F.length} leaks) at ${H}`;const W=z.get(Z.slice(0,K).join(`
`)),ee=(0,N.$I)([...W].map(ne=>T(ne)[K]),ne=>ne);delete ee[Z[K]];for(const[ne,re]of Object.entries(ee))G.unshift(`    - stacktraces of ${re.length} other leaks continue with ${ne}`);G.unshift(H)}q+=`


==================== Leaking disposable ${_}/${F.length}: ${Q.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return F.length>m&&(q+=`


... and ${F.length-m} more leaking disposables

`),{leaks:F,details:q}}}e.$Fc=d;function P(f){C=f}if(e.$Gc=P,D){const f="__is_disposable_tracked__";P(new class{trackDisposable(m){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[f]||console.log(L)},3e3)}setParent(m,L){if(m&&m!==t.None)try{m[f]=!0}catch{}}markAsDisposed(m){if(m&&m!==t.None)try{m[f]=!0}catch{}}markAsSingleton(m){}})}function E(f){return C?.trackDisposable(f),f}e.$Hc=E;function $(f){C?.markAsDisposed(f)}e.$Ic=$;function c(f,m){C?.setParent(f,m)}function g(f,m){if(C)for(const L of f)C.setParent(L,m)}function p(f){return C?.markAsSingleton(f),f}e.$Jc=p;function w(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.$Kc=w;function h(f){if(I.Iterable.is(f)){const m=[];for(const L of f)if(L)try{L.dispose()}catch(F){m.push(F)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.$Lc=h;function l(f){for(const m of f)w(m)&&m.dispose();return[]}e.$Mc=l;function u(...f){const m=b(()=>h(f));return g(f,m),m}e.$Nc=u;function b(f){const m=E({dispose:(0,A.$bb)(()=>{$(m),f()})});return m}e.$Oc=b;class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return c(m,this),this.g?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}delete(m){if(m){if(m===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(m),m.dispose()}}deleteAndLeak(m){m&&this.f.has(m)&&(this.f.delete(m),c(m,null))}}e.$Pc=S;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new S,E(this),c(this.q,this)}dispose(){$(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}e.$Qc=t;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&c(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&c(m,null),m}}e.$Rc=a;class s{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Sc=s;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(m){let L=m;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,$(this))},this}}e.$Tc=n;class i{constructor(){this.a=new Map}acquire(m,...L){let F=this.a.get(m);F||(F={counter:0,object:this.b(m,...L)},this.a.set(m,F));const{object:T}=F,z=(0,A.$bb)(()=>{--F.counter===0&&(this.c(m,F.object),this.a.delete(m))});return F.counter++,{object:T,dispose:z}}}e.$Uc=i;class r{constructor(m){this.a=m}async acquire(m,...L){const F=this.a.acquire(m,...L);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$Vc=r;class o{constructor(m){this.object=m}dispose(){}}e.$Wc=o;function v(f){const m=new S;try{f(m)}finally{m.dispose()}}e.$Xc=v;class y{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get size(){return this.a.size}get(m){return this.a.get(m)}set(m,L,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(m)?.dispose(),this.a.set(m,L)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Yc=y}),define(oe[88],ae([0,1,34]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=e.$jl=void 0;const N=new O.$Bc(1e4);function j(d){return C(d,"NFC",N)}e.$jl=j;const A=new O.$Bc(1e4);function I(d){return C(d,"NFD",A)}e.$kl=I;const D=/[^\u0000-\u0080]/;function C(d,P,E){if(!d)return d;const $=E.get(d);if($)return $;let c;return D.test(d)?c=d.normalize(P):c=d,E.set(d,c),c}e.$ll=function(){const d=/[\u0300-\u036f]/g;return function(P){return I(P).replace(d,"")}}()}),function(){function te(j){const A=[];typeof j=="number"&&A.push("code/timeOrigin",j);function I(C){A.push(C,Date.now())}function D(){const C=[];for(let d=0;d<A.length;d+=2)C.push({name:A[d],startTime:A[d+1]});return C}return{mark:I,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const I of performance.getEntriesByType("mark"))A.push({name:I.name,startTime:Math.round(j+I.startTime)});return A}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function O(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=O(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var N in O)(typeof exports=="object"?exports:te)[N]=O[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function O(N){if(e[N])return e[N].exports;var j=e[N]={i:N,l:!1,exports:{}};return te[N].call(j.exports,j,j.exports,O),j.l=!0,j.exports}return O.m=te,O.c=e,O.d=function(N,j,A){O.o(N,j)||Object.defineProperty(N,j,{enumerable:!0,get:A})},O.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},O.t=function(N,j){if(1&j&&(N=O(N)),8&j||4&j&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(O.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&j&&typeof N!="string")for(var I in N)O.d(A,I,function(D){return N[D]}.bind(null,I));return A},O.n=function(N){var j=N&&N.__esModule?function(){return N.default}:function(){return N};return O.d(j,"a",j),j},O.o=function(N,j){return Object.prototype.hasOwnProperty.call(N,j)},O.p="",O(O.s=0)}([function(te,e,O){(function(N){var j;e=te.exports=Y,j=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],C=e.src=[],d=0,P=d++;C[P]="0|[1-9]\\d*";var E=d++;C[E]="[0-9]+";var $=d++;C[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=d++;C[c]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var g=d++;C[g]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var p=d++;C[p]="(?:"+C[P]+"|"+C[$]+")";var w=d++;C[w]="(?:"+C[E]+"|"+C[$]+")";var h=d++;C[h]="(?:-("+C[p]+"(?:\\."+C[p]+")*))";var l=d++;C[l]="(?:-?("+C[w]+"(?:\\."+C[w]+")*))";var u=d++;C[u]="[0-9A-Za-z-]+";var b=d++;C[b]="(?:\\+("+C[u]+"(?:\\."+C[u]+")*))";var S=d++,t="v?"+C[c]+C[h]+"?"+C[b]+"?";C[S]="^"+t+"$";var a="[v=\\s]*"+C[g]+C[l]+"?"+C[b]+"?",s=d++;C[s]="^"+a+"$";var n=d++;C[n]="((?:<|>)?=?)";var i=d++;C[i]=C[E]+"|x|X|\\*";var r=d++;C[r]=C[P]+"|x|X|\\*";var o=d++;C[o]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[h]+")?"+C[b]+"?)?)?";var v=d++;C[v]="[v=\\s]*("+C[i]+")(?:\\.("+C[i]+")(?:\\.("+C[i]+")(?:"+C[l]+")?"+C[b]+"?)?)?";var y=d++;C[y]="^"+C[n]+"\\s*"+C[o]+"$";var f=d++;C[f]="^"+C[n]+"\\s*"+C[v]+"$";var m=d++;C[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=d++;C[L]="(?:~>?)";var F=d++;C[F]="(\\s*)"+C[L]+"\\s+",D[F]=new RegExp(C[F],"g");var T=d++;C[T]="^"+C[L]+C[o]+"$";var z=d++;C[z]="^"+C[L]+C[v]+"$";var q=d++;C[q]="(?:\\^)";var _=d++;C[_]="(\\s*)"+C[q]+"\\s+",D[_]=new RegExp(C[_],"g");var Q=d++;C[Q]="^"+C[q]+C[o]+"$";var Z=d++;C[Z]="^"+C[q]+C[v]+"$";var G=d++;C[G]="^"+C[n]+"\\s*("+a+")$|^$";var K=d++;C[K]="^"+C[n]+"\\s*("+t+")$|^$";var H=d++;C[H]="(\\s*)"+C[n]+"\\s*("+a+"|"+C[o]+")",D[H]=new RegExp(C[H],"g");var V=d++;C[V]="^\\s*("+C[o]+")\\s+-\\s+("+C[o]+")\\s*$";var W=d++;C[W]="^\\s*("+C[v]+")\\s+-\\s+("+C[v]+")\\s*$";var ee=d++;C[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)j(ne,C[ne]),D[ne]||(D[ne]=new RegExp(C[ne]));function re(ce,ge){if(ce instanceof Y)return ce;if(typeof ce!="string"||ce.length>A||!(ge?D[s]:D[S]).test(ce))return null;try{return new Y(ce,ge)}catch{return null}}function Y(ce,ge){if(ce instanceof Y){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Y))return new Y(ce,ge);j("SemVer",ce,ge),this.loose=ge;var be=ce.trim().match(ge?D[s]:D[S]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Pe=+ke;if(Pe>=0&&Pe<I)return Pe}return ke}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=re,e.valid=function(ce,ge){var be=re(ce,ge);return be?be.version:null},e.clean=function(ce,ge){var be=re(ce.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ce){return j("SemVer.compare",this.version,this.loose,ce),ce instanceof Y||(ce=new Y(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Y.prototype.compareMain=function(ce){return ce instanceof Y||(ce=new Y(ce,this.loose)),k(this.major,ce.major)||k(this.minor,ce.minor)||k(this.patch,ce.patch)},Y.prototype.comparePre=function(ce){if(ce instanceof Y||(ce=new Y(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],ke=ce.prerelease[ge];if(j("prerelease compare",ge,be,ke),be===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(be===void 0)return-1;if(be!==ke)return k(be,ke)}while(++ge)},Y.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,be,ke){typeof be=="string"&&(ke=be,be=void 0);try{return new Y(ce,be).inc(ge,ke).version}catch{return null}},e.diff=function(ce,ge){if(J(ce,ge))return null;var be=re(ce),ke=re(ge);if(be.prerelease.length||ke.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return Pe},e.compareIdentifiers=k;var B=/^[0-9]+$/;function k(ce,ge){var be=B.test(ce),ke=B.test(ge);return be&&ke&&(ce=+ce,ge=+ge),be&&!ke?-1:ke&&!be?1:ce<ge?-1:ce>ge?1:0}function R(ce,ge,be){return new Y(ce,be).compare(new Y(ge,be))}function U(ce,ge,be){return R(ce,ge,be)>0}function M(ce,ge,be){return R(ce,ge,be)<0}function J(ce,ge,be){return R(ce,ge,be)===0}function X(ce,ge,be){return R(ce,ge,be)!==0}function se(ce,ge,be){return R(ce,ge,be)>=0}function le(ce,ge,be){return R(ce,ge,be)<=0}function ue(ce,ge,be,ke){var Pe;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce!==be;break;case"":case"=":case"==":Pe=J(ce,be,ke);break;case"!=":Pe=X(ce,be,ke);break;case">":Pe=U(ce,be,ke);break;case">=":Pe=se(ce,be,ke);break;case"<":Pe=M(ce,be,ke);break;case"<=":Pe=le(ce,be,ke);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(ce,ge){if(ce instanceof he){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof he))return new he(ce,ge);j("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(ce,ge){return k(ge,ce)},e.major=function(ce,ge){return new Y(ce,ge).major},e.minor=function(ce,ge){return new Y(ce,ge).minor},e.patch=function(ce,ge){return new Y(ce,ge).patch},e.compare=R,e.compareLoose=function(ce,ge){return R(ce,ge,!0)},e.rcompare=function(ce,ge,be){return R(ge,ce,be)},e.sort=function(ce,ge){return ce.sort(function(be,ke){return e.compare(be,ke,ge)})},e.rsort=function(ce,ge){return ce.sort(function(be,ke){return e.rcompare(be,ke,ge)})},e.gt=U,e.lt=M,e.eq=J,e.neq=X,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=he;var $e={};function de(ce,ge){if(ce instanceof de)return ce.loose===ge?ce:new de(ce.raw,ge);if(ce instanceof he)return new de(ce.value,ge);if(!(this instanceof de))return new de(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function we(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ee(ce,ge,be,ke,Pe,ze,Le,Ue,Me,ie,fe,me,pe){return((ge=we(be)?"":we(ke)?">="+be+".0.0":we(Pe)?">="+be+"."+ke+".0":">="+ge)+" "+(Ue=we(Me)?"":we(ie)?"<"+(+Me+1)+".0.0":we(fe)?"<"+Me+"."+(+ie+1)+".0":me?"<="+Me+"."+ie+"."+fe+"-"+me:"<="+Ue)).trim()}function De(ce,ge){for(var be=0;be<ce.length;be++)if(!ce[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ce.length;be++)if(j(ce[be].semver),ce[be].semver!==$e&&ce[be].semver.prerelease.length>0){var ke=ce[be].semver;if(ke.major===ge.major&&ke.minor===ge.minor&&ke.patch===ge.patch)return!0}return!1}return!0}function Ne(ce,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ce)}function Te(ce,ge,be,ke){var Pe,ze,Le,Ue,Me;switch(ce=new Y(ce,ke),ge=new de(ge,ke),be){case">":Pe=U,ze=le,Le=M,Ue=">",Me=">=";break;case"<":Pe=M,ze=se,Le=U,Ue="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ce,ge,ke))return!1;for(var ie=0;ie<ge.set.length;++ie){var fe=ge.set[ie],me=null,pe=null;if(fe.forEach(function(Se){Se.semver===$e&&(Se=new he(">=0.0.0")),me=me||Se,pe=pe||Se,Pe(Se.semver,me.semver,ke)?me=Se:Le(Se.semver,pe.semver,ke)&&(pe=Se)}),me.operator===Ue||me.operator===Me||(!pe.operator||pe.operator===Ue)&&ze(ce,pe.semver)||pe.operator===Me&&Le(ce,pe.semver))return!1}return!0}he.prototype.parse=function(ce){var ge=this.loose?D[G]:D[K],be=ce.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Y(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(ce){return j("Comparator.test",ce,this.loose),this.semver===$e||(typeof ce=="string"&&(ce=new Y(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ce,ge){if(!(ce instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ce.value,ge),Ne(this.value,be,ge);if(ce.operator==="")return be=new de(this.value,ge),Ne(ce.semver,be,ge);var ke=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),ze=this.semver.version===ce.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ue=ue(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=ue(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return ke||Pe||ze&&Le||Ue||Me},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),j("range",ce,ge);var be=ge?D[W]:D[V];ce=ce.replace(be,Ee),j("hyphen replace",ce),ce=ce.replace(D[H],"$1$2$3"),j("comparator trim",ce,D[H]),ce=(ce=(ce=ce.replace(D[F],"$1~")).replace(D[_],"$1^")).split(/\s+/).join(" ");var ke=ge?D[G]:D[K],Pe=ce.split(" ").map(function(ze){return function(Le,Ue){return j("comp",Le),Le=function(Me,ie){return Me.trim().split(/\s+/).map(function(fe){return function(me,pe){j("caret",me,pe);var Se=pe?D[Z]:D[Q];return me.replace(Se,function(Re,Ce,Oe,Ie,Ae){var Fe;return j("caret",me,Re,Ce,Oe,Ie,Ae),we(Ce)?Fe="":we(Oe)?Fe=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Ie)?Fe=Ce==="0"?">="+Ce+"."+Oe+".0 <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+".0 <"+(+Ce+1)+".0.0":Ae?(j("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=Ce==="0"?Oe==="0"?">="+Ce+"."+Oe+"."+Ie+Ae+" <"+Ce+"."+Oe+"."+(+Ie+1):">="+Ce+"."+Oe+"."+Ie+Ae+" <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+"."+Ie+Ae+" <"+(+Ce+1)+".0.0"):(j("no pr"),Fe=Ce==="0"?Oe==="0"?">="+Ce+"."+Oe+"."+Ie+" <"+Ce+"."+Oe+"."+(+Ie+1):">="+Ce+"."+Oe+"."+Ie+" <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+"."+Ie+" <"+(+Ce+1)+".0.0"),j("caret return",Fe),Fe})}(fe,ie)}).join(" ")}(Le,Ue),j("caret",Le),Le=function(Me,ie){return Me.trim().split(/\s+/).map(function(fe){return function(me,pe){var Se=pe?D[z]:D[T];return me.replace(Se,function(Re,Ce,Oe,Ie,Ae){var Fe;return j("tilde",me,Re,Ce,Oe,Ie,Ae),we(Ce)?Fe="":we(Oe)?Fe=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Ie)?Fe=">="+Ce+"."+Oe+".0 <"+Ce+"."+(+Oe+1)+".0":Ae?(j("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=">="+Ce+"."+Oe+"."+Ie+Ae+" <"+Ce+"."+(+Oe+1)+".0"):Fe=">="+Ce+"."+Oe+"."+Ie+" <"+Ce+"."+(+Oe+1)+".0",j("tilde return",Fe),Fe})}(fe,ie)}).join(" ")}(Le,Ue),j("tildes",Le),Le=function(Me,ie){return j("replaceXRanges",Me,ie),Me.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var Se=pe?D[f]:D[y];return me.replace(Se,function(Re,Ce,Oe,Ie,Ae,Fe){j("xRange",me,Re,Ce,Oe,Ie,Ae,Fe);var Be=we(Oe),qe=Be||we(Ie),We=qe||we(Ae);return Ce==="="&&We&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&We?(qe&&(Ie=0),We&&(Ae=0),Ce===">"?(Ce=">=",qe?(Oe=+Oe+1,Ie=0,Ae=0):We&&(Ie=+Ie+1,Ae=0)):Ce==="<="&&(Ce="<",qe?Oe=+Oe+1:Ie=+Ie+1),Re=Ce+Oe+"."+Ie+"."+Ae):qe?Re=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":We&&(Re=">="+Oe+"."+Ie+".0 <"+Oe+"."+(+Ie+1)+".0"),j("xRange return",Re),Re})}(fe,ie)}).join(" ")}(Le,Ue),j("xrange",Le),Le=function(Me,ie){return j("replaceStars",Me,ie),Me.trim().replace(D[ee],"")}(Le,Ue),j("stars",Le),Le}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(ke)})),Pe=Pe.map(function(ze){return new he(ze,ge)})},de.prototype.intersects=function(ce,ge){if(!(ce instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ke){return ce.set.some(function(Pe){return Pe.every(function(ze){return ke.intersects(ze,ge)})})})})},e.toComparators=function(ce,ge){return new de(ce,ge).set.map(function(be){return be.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Y(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(De(this.set[ge],ce))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ce,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(Le){ze.test(Le)&&(ke&&Pe.compare(Le)!==-1||(Pe=new Y(ke=Le,be)))}),ke},e.minSatisfying=function(ce,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(Le){ze.test(Le)&&(ke&&Pe.compare(Le)!==1||(Pe=new Y(ke=Le,be)))}),ke},e.validRange=function(ce,ge){try{return new de(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,be){return Te(ce,ge,"<",be)},e.gtr=function(ce,ge,be){return Te(ce,ge,">",be)},e.outside=Te,e.prerelease=function(ce,ge){var be=re(ce,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,ge,be){return ce=new de(ce,be),ge=new de(ge,be),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof Y)return ce;if(typeof ce!="string")return null;var ge=ce.match(D[m]);return ge==null?null:re((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,O(1))},function(te,e){var O,N,j=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function D(w){if(O===setTimeout)return setTimeout(w,0);if((O===A||!O)&&setTimeout)return O=setTimeout,setTimeout(w,0);try{return O(w,0)}catch{try{return O.call(null,w,0)}catch{return O.call(this,w,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:A}catch{O=A}try{N=typeof clearTimeout=="function"?clearTimeout:I}catch{N=I}})();var C,d=[],P=!1,E=-1;function $(){P&&C&&(P=!1,C.length?d=C.concat(d):E=-1,d.length&&c())}function c(){if(!P){var w=D($);P=!0;for(var h=d.length;h;){for(C=d,d=[];++E<h;)C&&C[E].run();E=-1,h=d.length}C=null,P=!1,function(l){if(N===clearTimeout)return clearTimeout(l);if((N===I||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(l);try{N(l)}catch{try{return N.call(null,l)}catch{return N.call(this,l)}}}(w)}}function g(w,h){this.fun=w,this.array=h}function p(){}j.nextTick=function(w){var h=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)h[l-1]=arguments[l];d.push(new g(w,h)),d.length!==1||P||D(c)},g.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=p,j.addListener=p,j.once=p,j.off=p,j.removeListener=p,j.removeAllListeners=p,j.emit=p,j.prependListener=p,j.prependOnceListener=p,j.listeners=function(w){return[]},j.binding=function(w){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(w){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(te,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class N{constructor(D,C,d){this.level=D,this.key=C,this.value=d,this.forward=[]}}const j=void 0;class A{constructor(D,C=2**16){this.comparator=D,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new N(this.c,j,j)}get size(){return this.f}clear(){this.e=new N(this.c,j,j)}has(D){return!!A.g(this,D,this.comparator)}get(D){return A.g(this,D,this.comparator)?.value}set(D,C){return A.h(this,D,C,this.comparator)&&(this.f+=1),this}delete(D){const C=A.k(this,D,this.comparator);return C&&(this.f-=1),C}forEach(D,C){let d=this.e.forward[0];for(;d;)D.call(C,d.value,d.key,this),d=d.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this.e.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this.e.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this.e.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",C=this.e.forward[0];for(;C;)D+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return D}static g(D,C,d){let P=D.e;for(let E=D.d-1;E>=0;E--)for(;P.forward[E]&&d(P.forward[E].key,C)<0;)P=P.forward[E];if(P=P.forward[0],P&&d(P.key,C)===0)return P}static h(D,C,d,P){const E=[];let $=D.e;for(let c=D.d-1;c>=0;c--){for(;$.forward[c]&&P($.forward[c].key,C)<0;)$=$.forward[c];E[c]=$}if($=$.forward[0],$&&P($.key,C)===0)return $.value=d,!1;{const c=A.j(D);if(c>D.d){for(let g=D.d;g<c;g++)E[g]=D.e;D.d=c}$=new N(c,C,d);for(let g=0;g<c;g++)$.forward[g]=E[g].forward[g],E[g].forward[g]=$;return!0}}static j(D,C=.5){let d=1;for(;Math.random()<C&&d<D.c;)d+=1;return d}static k(D,C,d){const P=[];let E=D.e;for(let $=D.d-1;$>=0;$--){for(;E.forward[$]&&d(E.forward[$].key,C)<0;)E=E.forward[$];P[$]=E}if(E=E.forward[0],!E||d(E.key,C)!==0)return!1;for(let $=0;$<D.d&&P[$].forward[$]===E;$++)P[$].forward[$]=E.forward[$];for(;D.d>0&&D.e.forward[D.d-1]===j;)D.d-=1;return!0}}e.$qr=A}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=O&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Hd=N}),define(oe[3],ae([0,1,8,84,2,87,60]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.Event=void 0;const D=!1,C=!1;var d;(function(y){y.None=()=>j.$Qc.None;function f(ue){if(C){const{onDidAddListener:he}=ue,$e=g.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function m(ue,he){return K(ue,()=>{},0,void 0,!0,void 0,he)}y.defer=m;function L(ue){return(he,$e=null,de)=>{let we=!1,Ee;return Ee=ue(De=>{if(!we)return Ee?Ee.dispose():we=!0,he.call($e,De)},null,de),we&&Ee.dispose(),Ee}}y.once=L;function F(ue,he,$e){return Z((de,we=null,Ee)=>ue(De=>de.call(we,he(De)),null,Ee),$e)}y.map=F;function T(ue,he,$e){return Z((de,we=null,Ee)=>ue(De=>{he(De),de.call(we,De)},null,Ee),$e)}y.forEach=T;function z(ue,he,$e){return Z((de,we=null,Ee)=>ue(De=>he(De)&&de.call(we,De),null,Ee),$e)}y.filter=z;function q(ue){return ue}y.signal=q;function _(...ue){return(he,$e=null,de)=>{const we=(0,j.$Nc)(...ue.map(Ee=>Ee(De=>he.call($e,De))));return G(we,de)}}y.any=_;function Q(ue,he,$e,de){let we=$e;return F(ue,Ee=>(we=he(we,Ee),we),de)}y.reduce=Q;function Z(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||f(de);const we=new u(de);return he?.add(we),we.event}function G(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function K(ue,he,$e=100,de=!1,we=!1,Ee,De){let Ne,Te,ce,ge=0,be;const ke={leakWarningThreshold:Ee,onWillAddFirstListener(){Ne=ue(ze=>{ge++,Te=he(Te,ze),de&&!ce&&(Pe.fire(Te),Te=void 0),be=()=>{const Le=Te;Te=void 0,ce=void 0,(!de||ge>1)&&Pe.fire(Le),ge=0},typeof $e=="number"?(clearTimeout(ce),ce=setTimeout(be,$e)):ce===void 0&&(ce=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};De||f(ke);const Pe=new u(ke);return De?.add(Pe),Pe.event}y.debounce=K;function H(ue,he=0,$e){return y.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}y.accumulate=H;function V(ue,he=(de,we)=>de===we,$e){let de=!0,we;return z(ue,Ee=>{const De=de||!he(Ee,we);return de=!1,we=Ee,De},$e)}y.latch=V;function W(ue,he,$e){return[y.filter(ue,he,$e),y.filter(ue,de=>!he(de),$e)]}y.split=W;function ee(ue,he=!1,$e=[],de){let we=$e.slice(),Ee=ue(Te=>{we?we.push(Te):Ne.fire(Te)});de&&de.add(Ee);const De=()=>{we?.forEach(Te=>Ne.fire(Te)),we=null},Ne=new u({onWillAddFirstListener(){Ee||(Ee=ue(Te=>Ne.fire(Te)),de&&de.add(Ee))},onDidAddFirstListener(){we&&(he?setTimeout(De):De())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Ne),Ne.event}y.buffer=ee;function ne(ue,he){return(de,we,Ee)=>{const De=he(new Y);return ue(function(Ne){const Te=De.evaluate(Ne);Te!==re&&de.call(we,Te)},void 0,Ee)}}y.chain=ne;const re=Symbol("HaltChainable");class Y{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:re),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const Ee=$e||!he(we,de);return $e=!1,de=we,Ee?we:re}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===re)break;return he}}function B(ue,he,$e=de=>de){const de=(...Ne)=>De.fire($e(...Ne)),we=()=>ue.on(he,de),Ee=()=>ue.removeListener(he,de),De=new u({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return De.event}y.fromNodeEventEmitter=B;function k(ue,he,$e=de=>de){const de=(...Ne)=>De.fire($e(...Ne)),we=()=>ue.addEventListener(he,de),Ee=()=>ue.removeEventListener(he,de),De=new u({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return De.event}y.fromDOMEventEmitter=k;function R(ue){return new Promise(he=>L(ue)(he))}y.toPromise=R;function U(ue){const he=new u;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}y.fromPromise=U;function M(ue,he){return he(void 0),ue($e=>he($e))}y.runAndSubscribe=M;function J(ue,he){let $e=null;function de(Ee){$e?.dispose(),$e=new j.$Pc,he(Ee,$e)}de(void 0);const we=ue(Ee=>de(Ee));return(0,j.$Oc)(()=>{we.dispose(),$e?.dispose()})}y.runAndSubscribeWithStore=J;class X{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||f(de),this.emitter=new u(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function se(ue,he){return new X(ue,he).emitter.event}y.fromObservable=se;function le(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}y.fromObservableLight=le})(d||(e.Event=d={}));class P{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${P.f++}`,P.all.add(this)}start(f){this.g=new I.$Hd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Jd=P;let E=-1;function $(y){const f=E;return E=y,{dispose(){E=f}}}e.$Kd=$;class c{constructor(f,m=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=m,this.g=0}dispose(){this.f?.clear()}check(f,m){const L=this.threshold;if(L<=0||m<L)return;this.f||(this.f=new Map);const F=this.f.get(f.value)||0;if(this.f.set(f.value,F+1),this.g-=1,this.g<=0){this.g=L*.5;let T,z=0;for(const[q,_]of this.f)(!T||z<_)&&(T=q,z=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${z}):`),console.warn(T)}return()=>{const T=this.f.get(f.value)||0;this.f.set(f.value,T-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class w{constructor(f){this.value=f,this.id=p++}}const h=2,l=(y,f)=>{if(y instanceof w)f(y);else for(let m=0;m<y.length;m++){const L=y[m];L&&f(L)}};class u{constructor(f){this.x=0,this.f=f,this.g=E>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(D){const f=this.t;queueMicrotask(()=>{l(f,m=>m.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,m,L)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Qc.None;if(this.m)return j.$Qc.None;m&&(f=f.bind(m));const F=new w(f);let T,z;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(F.stack=g.create(),T=this.g.check(F.stack,this.x+1)),D&&(F.stack=z??g.create()),this.t?this.t instanceof w?(this.u??=new S,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.x++;const q=(0,j.$Oc)(()=>{T?.(),this.y(F)});return L instanceof j.$Pc?L.add(q):Array.isArray(L)&&L.push(q),q},this.q}y(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const m=this.t,L=m.indexOf(f);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,m[L]=void 0;const F=this.u.current===this;if(this.x*h<=m.length){let T=0;for(let z=0;z<m.length;z++)m[z]?m[T++]=m[z]:F&&(this.u.end--,T<this.u.i&&this.u.i--);m.length=T}}z(f,m){if(!f)return;const L=this.f?.onListenerError||O.$Y;if(!L){f.value(m);return}try{f.value(m)}catch(F){L(F)}}A(f){const m=f.current.t;for(;f.i<f.end;)this.z(m[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof w)this.z(this.t,f);else{const m=this.u;m.enqueue(this,f,this.t.length),this.A(m)}this.j?.stop()}hasListeners(){return this.x>0}}e.$Ld=u;const b=()=>new S;e.$Md=b;class S{constructor(){this.i=-1,this.end=0}enqueue(f,m,L){this.i=0,this.end=L,this.current=f,this.value=m}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends u{async fireAsync(f,m,L){if(this.t)for(this.h||(this.h=new A.$Zc),l(this.t,F=>this.h.push([F.value,f]));this.h.size>0&&!m.isCancellationRequested;){const[F,T]=this.h.shift(),z=[],q={...T,token:m,waitUntil:_=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");L&&(_=L(_,F)),z.push(_)}};try{F(q)}catch(_){(0,O.$Y)(_);continue}Object.freeze(z),await Promise.allSettled(z).then(_=>{for(const Q of _)Q.status==="rejected"&&(0,O.$Y)(Q.reason)})}}}e.$Nd=t;class a extends u{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new A.$Zc,this.w=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.w(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.x&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Od=a;class s extends a{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Pd=s;class n extends u{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(m=>super.fire(m)),this.h=[]}))}}e.$Qd=n;class i{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const m={event:f,listener:null};this.h.push(m),this.g&&this.m(m);const L=()=>{this.g&&this.o(m);const F=this.h.indexOf(m);this.h.splice(F,1)};return(0,j.$Oc)((0,N.$bb)(L))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(m=>this.f.fire(m))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Rd=i;class r{constructor(f,m,L,F){this.f=new j.$Pc;const T=this.f.add(new i),z=this.f.add(new j.$Yc);function q(_){z.set(_,T.add(F(_)))}for(const _ of f)q(_);this.f.add(m(_=>{q(_)})),this.f.add(L(_=>{z.deleteAndDispose(_)})),this.event=T.event}dispose(){this.f.dispose()}}e.$Sd=r;class o{constructor(){this.f=[]}wrapEvent(f){return(m,L,F)=>f(T=>{const z=this.f[this.f.length-1];z?z.push(()=>m.call(L,T)):m.call(L,T)},void 0,F)}bufferEvents(f){const m=[];this.f.push(m);const L=f();return this.f.pop(),m.forEach(F=>F()),L}}e.$Td=o;class v{constructor(){this.f=!1,this.g=d.None,this.h=j.$Qc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Ud=v}),define(oe[26],ae([0,1,3]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.CancellationToken=void 0;const N=Object.freeze(function(D,C){const d=setTimeout(D.bind(C),0);return{dispose(){clearTimeout(d)}}});var j;(function(D){function C(d){return d===D.None||d===D.Cancelled||d instanceof A?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}D.isCancellationToken=C,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(j||(e.CancellationToken=j={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new O.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(C){this.f=void 0,this.g=void 0,this.g=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=j.Cancelled}dispose(C=!1){C&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=j.None}}e.$Vd=I}),define(oe[129],ae([0,1,26]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=void 0;class N{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new O.$Vd,C=this.b(D.token);return this.a={promise:C,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}e.$ue=N;class j{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const C=JSON.stringify(D);return this.b!==C&&(this.b=C,this.a=this.c(D)),this.a}}e.$ve=j;class A{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const C=this.b(D);return this.a.set(D,C),C}}e.$we=A}),define(oe[46],ae([0,1,8,2]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function j(b){const S=b;return S?typeof S.read=="function":!1}e.$Wd=j;function A(b){const S=b;return S?[S.on,S.pause,S.resume,S.destroy].every(t=>typeof t=="function"):!1}e.$Xd=A;function I(b){const S=b;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$Yd=I;function D(b,S){return new C(b,S)}e.$Zd=D;class C{constructor(S,t){this.e=S,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(t=>t(S))}h(S){this.c.error.length===0?(0,O.$Y)(S):this.c.error.slice(0).forEach(t=>t(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,t){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(S,t){if(this.a.destroyed)return;let a;switch(S){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const s=a.indexOf(t);s>=0&&a.splice(s,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(b,S){const t=[];let a;for(;(a=b.read())!==null;)t.push(a);return S(t)}e.$1d=d;function P(b,S,t){const a=[];let s;for(;(s=b.read())!==null&&a.length<t;)a.push(s);return s===null&&a.length>0?S(a):{read:()=>{if(a.length>0)return a.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return b.read()}}}e.$2d=P;function E(b,S){return new Promise((t,a)=>{const s=[];$(b,{onData:n=>{S&&s.push(n)},onError:n=>{S?a(n):t(void 0)},onEnd:()=>{t(S?S(s):void 0)}})})}e.$3d=E;function $(b,S,t){b.on("error",a=>{t?.isCancellationRequested||S.onError(a)}),b.on("end",()=>{t?.isCancellationRequested||S.onEnd()}),b.on("data",a=>{t?.isCancellationRequested||S.onData(a)})}e.$4d=$;function c(b,S){return new Promise((t,a)=>{const s=new N.$Pc,n=[],i=v=>{if(n.push(v),n.length>S)return s.dispose(),b.pause(),t({stream:b,buffer:n,ended:!1})},r=v=>(s.dispose(),a(v)),o=()=>(s.dispose(),t({stream:b,buffer:n,ended:!0}));s.add((0,N.$Oc)(()=>b.removeListener("error",r))),b.on("error",r),s.add((0,N.$Oc)(()=>b.removeListener("end",o))),b.on("end",o),s.add((0,N.$Oc)(()=>b.removeListener("data",i))),b.on("data",i)})}e.$5d=c;function g(b,S){const t=D(S);return t.end(b),t}e.$6d=g;function p(){const b=D(()=>{throw new Error("not supported")});return b.end(),b}e.$7d=p;function w(b){let S=!1;return{read:()=>S?null:(S=!0,b)}}e.$8d=w;function h(b,S,t){const a=D(t);return $(b,{onData:s=>a.write(S.data(s)),onError:s=>a.error(S.error?S.error(s):s),onEnd:()=>a.end()}),a}e.$9d=h;function l(b,S,t){let a=!1;return{read:()=>{const s=S.read();return a?s:(a=!0,s!==null?t([b,s]):b)}}}e.$0d=l;function u(b,S,t){let a=!1;const s=D(t);return $(S,{onData:n=>a?s.write(n):(a=!0,s.write(t([b,n]))),onError:n=>s.error(n),onEnd:()=>{a||(a=!0,s.write(b)),s.end()}}),s}e.$$d=u}),define(oe[15],ae([0,1,86,46]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const j=typeof Buffer<"u",A=new O.$T(()=>new Uint8Array(256));let I,D;class C{static alloc(m){return j?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return j&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,L){return!(L?.dontUseNodeBuffer||!1)&&j?new C(Buffer.from(m)):(I||(I=new TextEncoder),new C(I.encode(m)))}static fromByteArray(m){const L=C.alloc(m.length);for(let F=0,T=m.length;F<T;F++)L.buffer[F]=m[F];return L}static concat(m,L){if(typeof L>"u"){L=0;for(let z=0,q=m.length;z<q;z++)L+=m[z].byteLength}const F=C.alloc(L);let T=0;for(let z=0,q=m.length;z<q;z++){const _=m[z];F.set(_,T),T+=_.byteLength}return F}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return j?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(m,L){return new C(this.buffer.subarray(m,L))}set(m,L){if(m instanceof C)this.buffer.set(m.buffer,L);else if(m instanceof Uint8Array)this.buffer.set(m,L);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),L);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return $(this.buffer,m)}writeUInt32BE(m,L){c(this.buffer,m,L)}readUInt32LE(m){return g(this.buffer,m)}writeUInt32LE(m,L){p(this.buffer,m,L)}readUInt8(m){return w(this.buffer,m)}writeUInt8(m,L){h(this.buffer,m,L)}indexOf(m,L=0){return d(this.buffer,m instanceof C?m.buffer:m,L)}}e.$_d=C;function d(f,m,L=0){const F=m.byteLength,T=f.byteLength;if(F===0)return 0;if(F===1)return f.indexOf(m[0]);if(F>T-L)return-1;const z=A.value;z.fill(m.length);for(let Z=0;Z<m.length;Z++)z[m[Z]]=m.length-Z-1;let q=L+m.length-1,_=q,Q=-1;for(;q<T;)if(f[q]===m[_]){if(_===0){Q=q;break}q--,_--}else q+=Math.max(m.length-_,z[f[q]]),_=m.length-1;return Q}e.$ae=d;function P(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0}e.$be=P;function E(f,m,L){f[L+0]=m&255,m=m>>>8,f[L+1]=m&255}e.$ce=E;function $(f,m){return f[m]*2**24+f[m+1]*2**16+f[m+2]*2**8+f[m+3]}e.$de=$;function c(f,m,L){f[L+3]=m,m=m>>>8,f[L+2]=m,m=m>>>8,f[L+1]=m,m=m>>>8,f[L]=m}e.$ee=c;function g(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0|f[m+2]<<16>>>0|f[m+3]<<24>>>0}e.$fe=g;function p(f,m,L){f[L+0]=m&255,m=m>>>8,f[L+1]=m&255,m=m>>>8,f[L+2]=m&255,m=m>>>8,f[L+3]=m&255}e.$ge=p;function w(f,m){return f[m]}e.$he=w;function h(f,m,L){f[L]=m}e.$ie=h;function l(f){return N.$1d(f,m=>C.concat(m))}e.$je=l;function u(f){return N.$8d(f)}e.$ke=u;function b(f){return N.$3d(f,m=>C.concat(m))}e.$le=b;async function S(f){return f.ended?C.concat(f.buffer):C.concat([...f.buffer,await b(f.stream)])}e.$me=S;function t(f){return N.$6d(f,m=>C.concat(m))}e.$ne=t;function a(f){return N.$9d(f,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.$oe=a;function s(f){return N.$Zd(m=>C.concat(m),f)}e.$pe=s;function n(f,m){return N.$0d(f,m,L=>C.concat(L))}e.$qe=n;function i(f,m){return N.$$d(f,m,L=>C.concat(L))}e.$re=i;function r(f){let m=0,L=0,F=0;const T=new Uint8Array(Math.floor(f.length/4*3)),z=_=>{switch(L){case 3:T[F++]=m|_,L=0;break;case 2:T[F++]=m|_>>>2,m=_<<6,L=3;break;case 1:T[F++]=m|_>>>4,m=_<<4,L=2;break;default:m=_<<2,L=1}};for(let _=0;_<f.length;_++){const Q=f.charCodeAt(_);if(Q>=65&&Q<=90)z(Q-65);else if(Q>=97&&Q<=122)z(Q-97+26);else if(Q>=48&&Q<=57)z(Q-48+52);else if(Q===43||Q===45)z(62);else if(Q===47||Q===95)z(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${f[_]}`)}}const q=F;for(;L>0;)z(0);return C.wrap(T).slice(0,q)}e.$se=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:f},m=!0,L=!1){const F=L?v:o;let T="";const z=f.byteLength%3;let q=0;for(;q<f.byteLength-z;q+=3){const _=f[q+0],Q=f[q+1],Z=f[q+2];T+=F[_>>>2],T+=F[(_<<4|Q>>>4)&63],T+=F[(Q<<2|Z>>>6)&63],T+=F[Z&63]}if(z===1){const _=f[q+0];T+=F[_>>>2],T+=F[_<<4&63],m&&(T+="==")}else if(z===2){const _=f[q+0],Q=f[q+1];T+=F[_>>>2],T+=F[(_<<4|Q>>>4)&63],T+=F[Q<<2&63],m&&(T+="=")}return T}e.$te=y}),define(oe[27],ae([0,1,129,86]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vf=e.$uf=e.$tf=e.$sf=e.GraphemeBreakType=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=void 0;function j(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$ze=j;const A=/{(\d+)}/g;function I(ie,...fe){return fe.length===0?ie:ie.replace(A,function(me,pe){const Se=parseInt(pe,10);return isNaN(Se)||Se<0||Se>=fe.length?me:fe[Se]})}e.$Ae=I;const D=/{([^}]+)}/g;function C(ie,fe){return ie.replace(D,(me,pe)=>fe[pe]??me)}e.$Be=C;function d(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ce=d;function P(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$De=P;function E(ie,fe){let me=0;const pe=fe.charCodeAt(0);for(let Se=ie.length-1;Se>=0;Se--)ie.charCodeAt(Se)===pe&&me++;return me}e.$Ee=E;function $(ie,fe,me="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${me}`}e.$Fe=$;function c(ie,fe=" "){const me=g(ie,fe);return p(me,fe)}e.$Ge=c;function g(ie,fe){if(!ie||!fe)return ie;const me=fe.length;if(me===0||ie.length===0)return ie;let pe=0;for(;ie.indexOf(fe,pe)===pe;)pe=pe+me;return ie.substring(pe)}e.$He=g;function p(ie,fe){if(!ie||!fe)return ie;const me=fe.length,pe=ie.length;if(me===0||pe===0)return ie;let Se=pe,Re=-1;for(;Re=ie.lastIndexOf(fe,Se-1),!(Re===-1||Re+me!==Se);){if(Re===0)return"";Se=Re}return ie.substring(0,Se)}e.$Ie=p;function w(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Je=w;function h(ie){return ie.replace(/\*/g,"")}e.$Ke=h;function l(ie,fe,me={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=P(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(ie,pe)}e.$Le=l;function u(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Me=u;function b(ie){return ie.split(/\r\n|\r|\n/)}e.$Ne=b;function S(ie){for(let fe=0,me=ie.length;fe<me;fe++){const pe=ie.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Oe=S;function t(ie,fe=0,me=ie.length){for(let pe=fe;pe<me;pe++){const Se=ie.charCodeAt(pe);if(Se!==32&&Se!==9)return ie.substring(fe,pe)}return ie.substring(fe,me)}e.$Pe=t;function a(ie,fe=ie.length-1){for(let me=fe;me>=0;me--){const pe=ie.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Qe=a;function s(ie,fe,me){const pe=[];let Se=0;for(const Re of ie.matchAll(fe)){if(pe.push(ie.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return pe.push(ie.slice(Se)),Promise.all(pe).then(Re=>Re.join(""))}e.$Re=s;function n(ie,fe){return ie<fe?-1:ie>fe?1:0}e.$Se=n;function i(ie,fe,me=0,pe=ie.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){const Ie=ie.charCodeAt(me),Ae=fe.charCodeAt(Se);if(Ie<Ae)return-1;if(Ie>Ae)return 1}const Ce=pe-me,Oe=Re-Se;return Ce<Oe?-1:Ce>Oe?1:0}e.$Te=i;function r(ie,fe){return o(ie,fe,0,ie.length,0,fe.length)}e.$Ue=r;function o(ie,fe,me=0,pe=ie.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){let Ie=ie.charCodeAt(me),Ae=fe.charCodeAt(Se);if(Ie===Ae)continue;if(Ie>=128||Ae>=128)return i(ie.toLowerCase(),fe.toLowerCase(),me,pe,Se,Re);y(Ie)&&(Ie-=32),y(Ae)&&(Ae-=32);const Fe=Ie-Ae;if(Fe!==0)return Fe}const Ce=pe-me,Oe=Re-Se;return Ce<Oe?-1:Ce>Oe?1:0}e.$Ve=o;function v(ie){return ie>=48&&ie<=57}e.$We=v;function y(ie){return ie>=97&&ie<=122}e.$Xe=y;function f(ie){return ie>=65&&ie<=90}e.$Ye=f;function m(ie,fe){return ie.length===fe.length&&o(ie,fe)===0}e.$Ze=m;function L(ie,fe){const me=fe.length;return fe.length>ie.length?!1:o(ie,fe,0,me)===0}e.$1e=L;function F(ie,fe){const me=Math.min(ie.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(ie.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$2e=F;function T(ie,fe){const me=Math.min(ie.length,fe.length);let pe;const Se=ie.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(ie.charCodeAt(Se-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$3e=T;function z(ie){return 55296<=ie&&ie<=56319}e.$4e=z;function q(ie){return 56320<=ie&&ie<=57343}e.$5e=q;function _(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.$6e=_;function Q(ie,fe,me){const pe=ie.charCodeAt(me);if(z(pe)&&me+1<fe){const Se=ie.charCodeAt(me+1);if(q(Se))return _(pe,Se)}return pe}e.$7e=Q;function Z(ie,fe){const me=ie.charCodeAt(fe-1);if(q(me)&&fe>1){const pe=ie.charCodeAt(fe-2);if(z(pe))return _(pe,me)}return me}class G{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=Z(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=Q(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$8e=G;class K{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new G(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Te(Se,Ce)){me.setOffset(Re);break}Se=Ce}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,Se)){me.setOffset(Re);break}Se=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$9e=K;function H(ie,fe){return new K(ie,fe).nextGraphemeLength()}e.$0e=H;function V(ie,fe){return new K(ie,fe).prevGraphemeLength()}e.$$e=V;function W(ie,fe){fe>0&&q(ie.charCodeAt(fe))&&fe--;const me=fe+H(ie,fe);return[me-V(ie,me),me]}e.$_e=W;function ee(ie){const fe=new K(ie);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$af=ee;let ne;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Y(ie){return ne||(ne=re()),ne.test(ie)}e.$bf=Y;const B=/^[\t\n\r\x20-\x7E]*$/;function k(ie){return B.test(ie)}e.$cf=k,e.$df=/[\u2028\u2029]/;function R(ie){return e.$df.test(ie)}e.$ef=R;function U(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$ff=U;function M(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$gf=M;function J(ie,fe){if(ie.length<fe)return ie;const me=/\b/g;let pe=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return ie.substring(pe).replace(/^\s/,"")}e.$hf=J;const X=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function le(ie){return ie&&(ie=ie.replace(X,"").replace(se,"")),ie}e.$if=le,e.$jf=String.fromCharCode(65279);function ue(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$kf=ue;function he(ie){return ue(ie)?ie.substr(1):ie}e.$lf=he;function $e(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const me=fe.length,pe=ie.toLowerCase();let Se=0,Re=-1;for(;Se<me;){const Ce=pe.indexOf(fe[Se],Re+1);if(Ce<0)return!1;Re=Ce,Se++}return!0}e.$mf=$e;function de(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$nf=de;function we(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$of=we;function Ee(ie,fe=1){if(fe===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.$pf=Ee;function De(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$qf=De;function Ne(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.$rf=Ne;function Te(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let Se=1;for(;Se<=pe;)if(fe<me[3*Se])Se=2*Se;else if(fe>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(ie,fe){if(ie===0)return 0;const me=Pe(ie,fe);if(me!==void 0)return me;const pe=new G(fe,ie);return pe.prevCodePoint(),pe.offset}e.$sf=ke;function Pe(ie,fe){const me=new G(fe,ie);let pe=me.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!M(pe))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function ze(ie){return 127995<=ie&&ie<=127999}var Le;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={})),e.$tf="\xA0";class Ue{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$ve(fe=>{function me(Fe){const Be=new Map;for(let qe=0;qe<Fe.length;qe+=2)Be.set(Fe[qe],Fe[qe+1]);return Be}function pe(Fe,Be){const qe=new Map(Fe);for(const[We,_e]of Be)qe.set(We,_e);return qe}function Se(Fe,Be){if(!Fe)return Be;const qe=new Map;for(const[We,_e]of Fe)Be.has(We)&&qe.set(We,_e);return qe}const Re=this.c.value;let Ce=fe.filter(Fe=>!Fe.startsWith("_")&&Fe in Re);Ce.length===0&&(Ce=["_default"]);let Oe;for(const Fe of Ce){const Be=me(Re[Fe]);Oe=Se(Oe,Be)}const Ie=me(Re._common),Ae=pe(Ie,Oe);return new Ue(Ae)})}static getInstance(fe){return Ue.d.get(Array.from(fe))}static{this.e=new N.$T(()=>Object.keys(Ue.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$uf=Ue;class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(fe){return Me.e().has(fe)}static get codePoints(){return Me.e()}}e.$vf=Me}),define(oe[51],ae([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;function N(h){return j(h,0)}e.$Ai=N;function j(h,l){switch(typeof h){case"object":return h===null?A(349,l):Array.isArray(h)?C(h,l):d(h,l);case"string":return D(h,l);case"boolean":return I(h,l);case"number":return A(h,l);case"undefined":return A(937,l);default:return A(617,l)}}e.$Bi=j;function A(h,l){return(l<<5)-l+h|0}e.$Ci=A;function I(h,l){return A(h?433:863,l)}function D(h,l){l=A(149417,l);for(let u=0,b=h.length;u<b;u++)l=A(h.charCodeAt(u),l);return l}e.$Di=D;function C(h,l){return l=A(104579,l),h.reduce((u,b)=>j(b,u),l)}function d(h,l){return l=A(181387,l),Object.keys(h).sort().reduce((u,b)=>(u=D(b,u),j(h[b],u)),l)}class P{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=j(l,this.g),this.g}}e.$Ei=P;var E;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function $(h,l,u=32){const b=u-l,S=~((1<<b)-1);return(h<<l|(S&h)>>>b)>>>0}function c(h,l=0,u=h.byteLength,b=0){for(let S=0;S<u;S++)h[l+S]=b}function g(h,l,u="0"){for(;h.length<l;)h=u+h;return h}function p(h,l=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((h>>>0).toString(16),l/4)}e.$Fi=p;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const u=l.length;if(u===0)return;const b=this.p;let S=this.r,t=this.u,a,s;for(t!==0?(a=t,s=-1,t=0):(a=l.charCodeAt(0),s=0);;){let n=a;if(O.$4e(a))if(s+1<u){const i=l.charCodeAt(s+1);O.$5e(i)?(s++,n=O.$6e(a,i)):n=65533}else{t=a;break}else O.$5e(a)&&(n=65533);if(S=this.w(b,S,n),s++,s<u)a=l.charCodeAt(s);else break}this.r=S,this.u=t}w(l,u,b){return b<128?l[u++]=b:b<2048?(l[u++]=192|(b&1984)>>>6,l[u++]=128|(b&63)>>>0):b<65536?(l[u++]=224|(b&61440)>>>12,l[u++]=128|(b&4032)>>>6,l[u++]=128|(b&63)>>>0):(l[u++]=240|(b&1835008)>>>18,l[u++]=128|(b&258048)>>>12,l[u++]=128|(b&4032)>>>6,l[u++]=128|(b&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=w.g,u=this.q;for(let o=0;o<64;o+=4)l.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)l.setUint32(o,$(l.getUint32(o-12,!1)^l.getUint32(o-32,!1)^l.getUint32(o-56,!1)^l.getUint32(o-64,!1),1),!1);let b=this.h,S=this.l,t=this.m,a=this.n,s=this.o,n,i,r;for(let o=0;o<80;o++)o<20?(n=S&t|~S&a,i=1518500249):o<40?(n=S^t^a,i=1859775393):o<60?(n=S&t|S&a|t&a,i=2400959708):(n=S^t^a,i=3395469782),r=$(b,5)+n+s+i+l.getUint32(o*4,!1)&4294967295,s=a,a=t,t=$(S,30),S=b,b=r;this.h=this.h+b&4294967295,this.l=this.l+S&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+s&4294967295}}e.$Gi=w}),define(oe[89],ae([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(N||(N={})),function(j){const A="error",I="warning",D="warn",C="info",d="ignore";function P($){return $?O.$Ze(A,$)?j.Error:O.$Ze(I,$)||O.$Ze(D,$)?j.Warning:O.$Ze(C,$)?j.Info:j.Ignore:j.Ignore}j.fromValue=P;function E($){switch($){case j.Error:return A;case j.Warning:return I;case j.Info:return C;default:return d}}j.toString=E}(N||(N={})),e.default=N}),define(oe[130],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;class j{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const g=c.charCodeAt(0),p=this.b.charCodeAt(this.c);return g-p}value(){return this.b[this.c]}}e.$Oh=j;class A{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,N.$Te)(c,this.b,0,c.length,this.c,this.d):(0,N.$Ve)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ph=A;class I{constructor(c=!0,g=!0){this.f=c,this.g=g}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let g=c.length-1;g>=0;g--,this.c--){const p=this.b.charCodeAt(g);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,N.$Te)(c,this.b,0,c.length,this.d,this.e):(0,N.$Ve)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Qh=I;var D;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(D||(D={}));class C{constructor(c,g){this.f=c,this.g=g,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,N.$Ue)(c,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Ue)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,N.$Se)(c,this.c.query);if(this.d[this.e]===5)return(0,N.$Se)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Rh=C;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(P||(P={}));class E{static forUris(c=()=>!1,g=()=>!1){return new E(new C(c,g))}static forPaths(c=!1){return new E(new I(void 0,!c))}static forStrings(){return new E(new j)}static forConfigKeys(){return new E(new A)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,g){if(g){const p=g.slice(0);(0,O.$Vb)(p);for(const w of p)this.set(w,c)}else{const p=c.slice(0);(0,O.$Vb)(p);for(const w of p)this.set(w[0],w[1])}}set(c,g){const p=this.b.reset(c);let w;this.c||(this.c=new d,this.c.segment=p.value());const h=[];for(w=this.c;;){const u=p.cmp(w.segment);if(u>0)w.left||(w.left=new d,w.left.segment=p.value()),h.push([-1,w]),w=w.left;else if(u<0)w.right||(w.right=new d,w.right.segment=p.value()),h.push([1,w]),w=w.right;else if(p.hasNext())p.next(),w.mid||(w.mid=new d,w.mid.segment=p.value()),h.push([0,w]),w=w.mid;else break}const l=w.value;w.value=g,w.key=c;for(let u=h.length-1;u>=0;u--){const b=h[u][1];b.updateHeight();const S=b.balanceFactor();if(S<-1||S>1){const t=h[u][0],a=h[u+1][0];if(t===1&&a===1)h[u][1]=b.rotateLeft();else if(t===-1&&a===-1)h[u][1]=b.rotateRight();else if(t===1&&a===-1)b.right=h[u+1][1]=h[u+1][1].rotateRight(),h[u][1]=b.rotateLeft();else if(t===-1&&a===1)b.left=h[u+1][1]=h[u+1][1].rotateLeft(),h[u][1]=b.rotateRight();else throw new Error;if(u>0)switch(h[u-1][0]){case-1:h[u-1][1].left=h[u][1];break;case 1:h[u-1][1].right=h[u][1];break;case 0:h[u-1][1].mid=h[u][1];break}else this.c=h[0][1]}}return l}get(c){return this.d(c)?.value}d(c){const g=this.b.reset(c);let p=this.c;for(;p;){const w=g.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(g.hasNext())g.next(),p=p.mid;else break}return p}has(c){const g=this.d(c);return!(g?.value===void 0&&g?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,g){const p=this.b.reset(c),w=[];let h=this.c;for(;h;){const l=p.cmp(h.segment);if(l>0)w.push([-1,h]),h=h.left;else if(l<0)w.push([1,h]),h=h.right;else if(p.hasNext())p.next(),w.push([0,h]),h=h.mid;else break}if(h){if(g?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const l=this.f(h.right);if(l.key){const{key:u,value:b,segment:S}=l;this.e(l.key,!1),h.key=u,h.value=b,h.segment=S}}else{const l=h.left??h.right;if(w.length>0){const[u,b]=w[w.length-1];switch(u){case-1:b.left=l;break;case 0:b.mid=l;break;case 1:b.right=l;break}}else this.c=l}for(let l=w.length-1;l>=0;l--){const u=w[l][1];u.updateHeight();const b=u.balanceFactor();if(b>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),w[l][1]=u.rotateLeft()):b<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),w[l][1]=u.rotateRight()),l>0)switch(w[l-1][0]){case-1:w[l-1][1].left=w[l][1];break;case 1:w[l-1][1].right=w[l][1];break;case 0:w[l-1][1].mid=w[l][1];break}else this.c=w[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const g=this.b.reset(c);let p=this.c,w;for(;p;){const h=g.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(g.hasNext())g.next(),w=p.value||w,p=p.mid;else break}return p&&p.value||w}findSuperstr(c){return this.g(c,!1)}g(c,g){const p=this.b.reset(c);let w=this.c;for(;w;){const h=p.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else return w.mid?this.h(w.mid):g?w.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[g,p]of this)c(p,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const g=[];return this.j(c,g),g[Symbol.iterator]()}j(c,g){c&&(c.left&&this.j(c.left,g),c.value&&g.push([c.key,c.value]),c.mid&&this.j(c.mid,g),c.right&&this.j(c.right,g))}_isBalanced(){const c=g=>{if(!g)return!0;const p=g.balanceFactor();return p<-1||p>1?!1:c(g.left)&&c(g.right)};return c(this.c)}}e.$Sh=E}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=void 0;function O(S){return typeof S=="string"}e.$wf=O;function N(S){return Array.isArray(S)&&S.every(t=>O(t))}e.$xf=N;function j(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}e.$yf=j;function A(S){const t=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof t}e.$zf=A;function I(S){return typeof S=="number"&&!isNaN(S)}e.$Af=I;function D(S){return!!S&&typeof S[Symbol.iterator]=="function"}e.$Bf=D;function C(S){return S===!0||S===!1}e.$Cf=C;function d(S){return typeof S>"u"}e.$Df=d;function P(S){return!E(S)}e.$Ef=P;function E(S){return d(S)||S===null}e.$Ff=E;function $(S,t){if(!S)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Gf=$;function c(S){if(E(S))throw new Error("Assertion Failed: argument is undefined or null");return S}e.$Hf=c;function g(...S){const t=[];for(let a=0;a<S.length;a++){const s=S[a];if(E(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(s)}return t}e.$If=g;const p=Object.prototype.hasOwnProperty;function w(S){if(!j(S))return!1;for(const t in S)if(p.call(S,t))return!1;return!0}e.$Jf=w;function h(S){return typeof S=="function"}e.$Kf=h;function l(...S){return S.length>0&&S.every(h)}e.$Lf=l;function u(S,t){const a=Math.min(S.length,t.length);for(let s=0;s<a;s++)b(S[s],t[s])}e.$Mf=u;function b(S,t){if(O(t)){if(typeof S!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(S instanceof t)return}catch{}if(!E(S)&&S.constructor===t||t.length===1&&t.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Nf=b}),define(oe[30],ae([0,1,12]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const l=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([u,b])=>{l[u]=b&&typeof b=="object"?N(b):b}),l}e.$Xm=N;function j(h){if(!h||typeof h!="object")return h;const l=[h];for(;l.length>0;){const u=l.shift();Object.freeze(u);for(const b in u)if(A.call(u,b)){const S=u[b];typeof S=="object"&&!Object.isFrozen(S)&&!(0,O.$zf)(S)&&l.push(S)}}return h}e.$Ym=j;const A=Object.prototype.hasOwnProperty;function I(h,l){return D(h,l,new Set)}e.$Zm=I;function D(h,l,u){if((0,O.$Ff)(h))return h;const b=l(h);if(typeof b<"u")return b;if(Array.isArray(h)){const S=[];for(const t of h)S.push(D(t,l,u));return S}if((0,O.$yf)(h)){if(u.has(h))throw new Error("Cannot clone recursive data-structure");u.add(h);const S={};for(const t in h)A.call(h,t)&&(S[t]=D(h[t],l,u));return u.delete(h),S}return h}function C(h,l,u=!0){return(0,O.$yf)(h)?((0,O.$yf)(l)&&Object.keys(l).forEach(b=>{b in h?u&&((0,O.$yf)(h[b])&&(0,O.$yf)(l[b])?C(h[b],l[b],u):h[b]=l[b]):h[b]=l[b]}),h):l}e.$1m=C;function d(h,l){if(h===l)return!0;if(h==null||l===null||l===void 0||typeof h!=typeof l||typeof h!="object"||Array.isArray(h)!==Array.isArray(l))return!1;let u,b;if(Array.isArray(h)){if(h.length!==l.length)return!1;for(u=0;u<h.length;u++)if(!d(h[u],l[u]))return!1}else{const S=[];for(b in h)S.push(b);S.sort();const t=[];for(b in l)t.push(b);if(t.sort(),!d(S,t))return!1;for(u=0;u<S.length;u++)if(!d(h[S[u]],l[S[u]]))return!1}return!0}e.$2m=d;function P(h){const l=new Set;return JSON.stringify(h,(u,b)=>{if((0,O.$yf)(b)||Array.isArray(b)){if(l.has(b))return"[Circular]";l.add(b)}return b})}e.$3m=P;function E(h,l){const u=Object.create(null);return!h||!l||Object.keys(l).forEach(S=>{const t=h[S],a=l[S];d(t,a)||(u[S]=a)}),u}e.$4m=E;function $(h,l){const u=l.toLowerCase(),b=Object.keys(h).find(S=>S.toLowerCase()===u);return b?h[b]:h[l]}e.$5m=$;function c(h,l){const u=Object.create(null);for(const[b,S]of Object.entries(h))l(b,S)&&(u[b]=S);return u}e.$6m=c;function g(h){let l=[];for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.$7m=g;function p(h){const l=[];for(const u of g(h))typeof h[u]=="function"&&l.push(u);return l}e.$8m=p;function w(h,l){const u=S=>function(){const t=Array.prototype.slice.call(arguments,0);return l(S,t)},b={};for(const S of h)b[S]=u(S);return b}e.$9m=w}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(j){return O.test(j)}e.$bg=N,e.$cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(D){for(let C=0;C<D.length;C++)D[C]=Math.floor(Math.random()*256);return D};const A=new Uint8Array(16),I=[];for(let D=0;D<256;D++)I.push(D.toString(16).padStart(2,"0"));return function(){j(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let C=0,d="";return d+=I[A[C++]],d+=I[A[C++]],d+=I[A[C++]],d+=I[A[C++]],d+="-",d+=I[A[C++]],d+=I[A[C++]],d+="-",d+=I[A[C++]],d+=I[A[C++]],d+="-",d+=I[A[C++]],d+=I[A[C++]],d+="-",d+=I[A[C++]],d+=I[A[C++]],d+=I[A[C++]],d+=I[A[C++]],d+=I[A[C++]],d+=I[A[C++]],d}}()}),define(oe[131],ae([0,1,36]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(I){const D=I.replace(/\-/g,":").toLowerCase();return!N.has(D)}function A(){const I=(0,O.networkInterfaces)();for(const D in I){const C=I[D];if(C){for(const{mac:d}of C)if(j(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Im=A}),define(oe[132],ae([0,1,36,47,32,131]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=void 0,e.$Jm=new class{c(d){return this.a||(this.a=N.$Sh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,P=0;const E=(0,O.networkInterfaces)();for(const $ in E){const c=E[$];if(c)for(const{mac:g,internal:p}of c)p||(P+=1,this.c(g.toUpperCase())&&(d+=1))}this.b=P>0?d/P:0}return this.b}};let I;async function D(d){return I||(I=(async()=>await C(d)||j.$cg())()),I}e.$Km=D;async function C(d){try{const P=await new Promise(($,c)=>{te(["crypto"],$,c)}),E=(0,A.$Im)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){d(P);return}}}),define(oe[133],ae([0,1,268,15]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3S=void 0;class j extends O.Transform{constructor(I){if(super(),typeof I=="number")this.b=I,this.c=1;else{const D=Buffer.isBuffer(I)?I:Buffer.from(I);this.b=D.length===1?D[0]:D,this.c=D.length}}_transform(I,D,C){this.a?this.a=Buffer.concat([this.a,I]):this.a=I;let d=0;for(;d<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,N.$ae)(this.a,this.b,d);if(P===-1)break;this.push(this.a.slice(d,P+this.c)),d=P+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),C()}_flush(I){this.a&&this.push(this.a),I()}}e.$3S=j}),define(oe[134],ae([0,1,61]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.$fg=e.$eg=void 0;function N(D,C,d,P=1){let E=!1;return new Promise($=>{const c=setTimeout(()=>{if(!E)return E=!0,$(0)},d);j(D,C,P,g=>{if(!E)return E=!0,clearTimeout(c),$(g)})})}e.$eg=N;function j(D,C,d,P){if(C===0)return P(0);const E=new O.Socket;E.once("connect",()=>(I(E),j(D+d,C-1,d,P))),E.once("data",()=>{}),E.once("error",$=>(I(E),$.code!=="ECONNREFUSED"?j(D+d,C-1,d,P):P(D))),E.connect(D,"127.0.0.1")}e.$fg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(D,C,d,P="127.0.0.1"){let E=!1,$,c=1;const g=O.createServer({pauseOnConnect:!0});function p(w,h){E||(E=!0,g.removeAllListeners(),g.close(),$&&clearTimeout($),h(w))}return new Promise(w=>{$=setTimeout(()=>{p(0,w)},d),g.on("listening",()=>{p(D,w)}),g.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&c<C?(D++,c++,g.listen(D,P)):p(0,w)}),g.on("close",()=>{p(0,w)}),g.listen(D,P)})}e.$gg=A;function I(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(C){console.error(C)}}}),define(oe[135],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gT=void 0;function O(N){return!!N.parentPort}e.$gT=O}),define(oe[136],ae([13,10]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[62],ae([0,1,136]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0;const N=60,j=N*60,A=j*24,I=A*7,D=A*30,C=A*365;function d(E,$,c,g){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,O.localize)(0,null,d(new Date().getTime()+p*1e3,!1));if(!g&&p<30)return(0,O.localize)(1,null);let w;return p<N?(w=p,$?w===1?c?(0,O.localize)(2,null,w):(0,O.localize)(3,null,w):c?(0,O.localize)(4,null,w):(0,O.localize)(5,null,w):w===1?c?(0,O.localize)(6,null,w):(0,O.localize)(7,null,w):c?(0,O.localize)(8,null,w):(0,O.localize)(9,null,w)):p<j?(w=Math.floor(p/N),$?w===1?c?(0,O.localize)(10,null,w):(0,O.localize)(11,null,w):c?(0,O.localize)(12,null,w):(0,O.localize)(13,null,w):w===1?c?(0,O.localize)(14,null,w):(0,O.localize)(15,null,w):c?(0,O.localize)(16,null,w):(0,O.localize)(17,null,w)):p<A?(w=Math.floor(p/j),$?w===1?c?(0,O.localize)(18,null,w):(0,O.localize)(19,null,w):c?(0,O.localize)(20,null,w):(0,O.localize)(21,null,w):w===1?c?(0,O.localize)(22,null,w):(0,O.localize)(23,null,w):c?(0,O.localize)(24,null,w):(0,O.localize)(25,null,w)):p<I?(w=Math.floor(p/A),$?w===1?(0,O.localize)(26,null,w):(0,O.localize)(27,null,w):w===1?(0,O.localize)(28,null,w):(0,O.localize)(29,null,w)):p<D?(w=Math.floor(p/I),$?w===1?c?(0,O.localize)(30,null,w):(0,O.localize)(31,null,w):c?(0,O.localize)(32,null,w):(0,O.localize)(33,null,w):w===1?c?(0,O.localize)(34,null,w):(0,O.localize)(35,null,w):c?(0,O.localize)(36,null,w):(0,O.localize)(37,null,w)):p<C?(w=Math.floor(p/D),$?w===1?c?(0,O.localize)(38,null,w):(0,O.localize)(39,null,w):c?(0,O.localize)(40,null,w):(0,O.localize)(41,null,w):w===1?c?(0,O.localize)(42,null,w):(0,O.localize)(43,null,w):c?(0,O.localize)(44,null,w):(0,O.localize)(45,null,w)):(w=Math.floor(p/C),$?w===1?c?(0,O.localize)(46,null,w):(0,O.localize)(47,null,w):c?(0,O.localize)(48,null,w):(0,O.localize)(49,null,w):w===1?c?(0,O.localize)(50,null,w):(0,O.localize)(51,null,w):c?(0,O.localize)(52,null,w):(0,O.localize)(53,null,w))}e.$8l=d;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$9l=P}),define(oe[137],ae([13,10]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,137]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=void 0;function A(E,$){return $&&(E.stack||E.stacktrace)?j.localize(0,null,D(E),I(E.stack)||I(E.stacktrace)):D(E)}function I(E){return Array.isArray(E)?E.join(`
`):E}function D(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?j.localize(1,null,E.message):E.message||j.localize(2,null)}function C(E=null,$=!1){if(!E)return j.localize(3,null);if(Array.isArray(E)){const c=O.$Fb(E),g=C(c[0],$);return c.length>1?j.localize(4,null,g,c.length):g}if(N.$wf(E))return E;if(E.detail){const c=E.detail;if(c.error)return A(c.error,$);if(c.exception)return A(c.exception,$)}return E.stack?A(E,$):E.message?E.message:j.localize(5,null)}e.$xi=C;function d(E){const $=E;return $ instanceof Error&&Array.isArray($.actions)}e.$yi=d;function P(E,$){let c;return typeof E=="string"?c=new Error(E):c=E,c.actions=$,c}e.$zi=P}),define(oe[138],ae([13,10]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[139],ae([0,1,138]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;function N(j){switch(j){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$op=N}),define(oe[140],ae([13,10]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[6],ae([0,1,140]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let N=!1,j=!1,A=!1,I=!1,D=!1,C=!1,d=!1,P=!1,E=!1,$=!1,c,g=e.$f,p=e.$f,w,h;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?l=e.$g.vscode.process:typeof process<"u"&&(l=process);const u=typeof l?.versions?.electron=="string",b=u&&l?.type==="renderer";if(typeof navigator=="object"&&!b)h=navigator.userAgent,N=h.indexOf("Windows")>=0,j=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,$=h?.indexOf("Mobi")>=0,C=!0,c=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$f,g=c,p=navigator.language;else if(typeof l=="object"){N=l.platform==="win32",j=l.platform==="darwin",A=l.platform==="linux",I=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,d=u,E=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$f,g=e.$f;const v=l.env.VSCODE_NLS_CONFIG;if(v)try{const y=JSON.parse(v),f=y.availableLanguages["*"];c=y.locale,p=y.osLocale,g=f||e.$f,w=y._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var S;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(S||(e.Platform=S={}));function t(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let a=0;j?a=1:N?a=3:A&&(a=2),e.$i=N,e.$j=j,e.$k=A,e.$l=I,e.$m=D,e.$n=d,e.$o=C,e.$p=C&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=$,e.$s=E,e.$t=a,e.$u=h,e.$v=g;var s;(function(v){function y(){return e.$v}v.value=y;function f(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}v.isDefaultVariant=f;function m(){return e.$v==="en"}v.isDefault=m})(s||(e.Language=s={})),e.$w=c,e.$x=p,e.$y=w,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const v=[];e.$g.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let m=0,L=v.length;m<L;m++){const F=v[m];if(F.id===f.data.vscodeScheduleAsyncWork){v.splice(m,1),F.callback();return}}});let y=0;return f=>{const m=++y;v.push({id:m,callback:f}),e.$g.postMessage({vscodeScheduleAsyncWork:m},"*")}}return v=>setTimeout(v)})();var n;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=j||P?2:N?1:3;let i=!0,r=!1;function o(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,i=new Uint16Array(v.buffer)[0]===(2<<8)+1}return i}e.$C=o,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(oe[37],ae([0,1,6]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.env=e.cwd=void 0;let N;if(typeof O.$g.vscode<"u"&&typeof O.$g.vscode.process<"u"){const j=O.$g.vscode.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$bc=N.platform,e.$cc=N.arch}),define(oe[16],ae([0,1,37]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.sep=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=void 0;const N=65,j=97,A=90,I=122,D=46,C=47,d=92,P=58,E=63;class $ extends Error{constructor(a,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${i} of type ${s}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function c(t,a){if(t===null||typeof t!="object")throw new $(a,"Object",t)}function g(t,a){if(typeof t!="string")throw new $(a,"string",t)}const p=O.$bc==="win32";function w(t){return t===C||t===d}function h(t){return t===C}function l(t){return t>=N&&t<=A||t>=j&&t<=I}function u(t,a,s,n){let i="",r=0,o=-1,v=0,y=0;for(let f=0;f<=t.length;++f){if(f<t.length)y=t.charCodeAt(f);else{if(n(y))break;y=C}if(n(y)){if(!(o===f-1||v===1))if(v===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const m=i.lastIndexOf(s);m===-1?(i="",r=0):(i=i.slice(0,m),r=i.length-1-i.lastIndexOf(s)),o=f,v=0;continue}else if(i.length!==0){i="",r=0,o=f,v=0;continue}}a&&(i+=i.length>0?`${s}..`:"..",r=2)}else i.length>0?i+=`${s}${t.slice(o+1,f)}`:i=t.slice(o+1,f),r=f-o-1;o=f,v=0}else y===D&&v!==-1?++v:v=-1}return i}function b(t,a){c(a,"pathObject");const s=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return s?s===a.root?`${s}${n}`:`${s}${t}${n}`:n}e.$dc={resolve(...t){let a="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],g(r,"path"),r.length===0)continue}else a.length===0?r=O.cwd():(r=O.env[`=${a}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${a}\\`));const o=r.length;let v=0,y="",f=!1;const m=r.charCodeAt(0);if(o===1)w(m)&&(v=1,f=!0);else if(w(m))if(f=!0,w(r.charCodeAt(1))){let L=2,F=L;for(;L<o&&!w(r.charCodeAt(L));)L++;if(L<o&&L!==F){const T=r.slice(F,L);for(F=L;L<o&&w(r.charCodeAt(L));)L++;if(L<o&&L!==F){for(F=L;L<o&&!w(r.charCodeAt(L));)L++;(L===o||L!==F)&&(y=`\\\\${T}\\${r.slice(F,L)}`,v=L)}}}else v=1;else l(m)&&r.charCodeAt(1)===P&&(y=r.slice(0,2),v=2,o>2&&w(r.charCodeAt(2))&&(f=!0,v=3));if(y.length>0)if(a.length>0){if(y.toLowerCase()!==a.toLowerCase())continue}else a=y;if(n){if(a.length>0)break}else if(s=`${r.slice(v)}\\${s}`,n=f,f&&a.length>0)break}return s=u(s,!n,"\\",w),n?`${a}\\${s}`:`${a}${s}`||"."},normalize(t){g(t,"path");const a=t.length;if(a===0)return".";let s=0,n,i=!1;const r=t.charCodeAt(0);if(a===1)return h(r)?"\\":t;if(w(r))if(i=!0,w(t.charCodeAt(1))){let v=2,y=v;for(;v<a&&!w(t.charCodeAt(v));)v++;if(v<a&&v!==y){const f=t.slice(y,v);for(y=v;v<a&&w(t.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!w(t.charCodeAt(v));)v++;if(v===a)return`\\\\${f}\\${t.slice(y)}\\`;v!==y&&(n=`\\\\${f}\\${t.slice(y,v)}`,s=v)}}}else s=1;else l(r)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),s=2,a>2&&w(t.charCodeAt(2))&&(i=!0,s=3));let o=s<a?u(t.slice(s),!i,"\\",w):"";return o.length===0&&!i&&(o="."),o.length>0&&w(t.charCodeAt(a-1))&&(o+="\\"),n===void 0?i?`\\${o}`:o:i?`${n}\\${o}`:`${n}${o}`},isAbsolute(t){g(t,"path");const a=t.length;if(a===0)return!1;const s=t.charCodeAt(0);return w(s)||a>2&&l(s)&&t.charCodeAt(1)===P&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,s;for(let r=0;r<t.length;++r){const o=t[r];g(o,"path"),o.length>0&&(a===void 0?a=s=o:a+=`\\${o}`)}if(a===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&w(s.charCodeAt(0))){++i;const r=s.length;r>1&&w(s.charCodeAt(1))&&(++i,r>2&&(w(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<a.length&&w(a.charCodeAt(i));)i++;i>=2&&(a=`\\${a.slice(i)}`)}return e.$dc.normalize(a)},relative(t,a){if(g(t,"from"),g(a,"to"),t===a)return"";const s=e.$dc.resolve(t),n=e.$dc.resolve(a);if(s===n||(t=s.toLowerCase(),a=n.toLowerCase(),t===a))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===d;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===d;)r--;const o=r-i;let v=0;for(;v<a.length&&a.charCodeAt(v)===d;)v++;let y=a.length;for(;y-1>v&&a.charCodeAt(y-1)===d;)y--;const f=y-v,m=o<f?o:f;let L=-1,F=0;for(;F<m;F++){const z=t.charCodeAt(i+F);if(z!==a.charCodeAt(v+F))break;z===d&&(L=F)}if(F!==m){if(L===-1)return n}else{if(f>m){if(a.charCodeAt(v+F)===d)return n.slice(v+F+1);if(F===2)return n.slice(v+F)}o>m&&(t.charCodeAt(i+F)===d?L=F:F===2&&(L=3)),L===-1&&(L=0)}let T="";for(F=i+L+1;F<=r;++F)(F===r||t.charCodeAt(F)===d)&&(T+=T.length===0?"..":"\\..");return v+=L,T.length>0?`${T}${n.slice(v,y)}`:(n.charCodeAt(v)===d&&++v,n.slice(v,y))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.$dc.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const s=a.charCodeAt(2);if(s!==E&&s!==D)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(l(a.charCodeAt(0))&&a.charCodeAt(1)===P&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return t},dirname(t){g(t,"path");const a=t.length;if(a===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(a===1)return w(i)?t:".";if(w(i)){if(s=n=1,w(t.charCodeAt(1))){let v=2,y=v;for(;v<a&&!w(t.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&w(t.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!w(t.charCodeAt(v));)v++;if(v===a)return t;v!==y&&(s=n=v+1)}}}}else l(i)&&t.charCodeAt(1)===P&&(s=a>2&&w(t.charCodeAt(2))?3:2,n=s);let r=-1,o=!0;for(let v=a-1;v>=n;--v)if(w(t.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(s===-1)return".";r=s}return t.slice(0,r)},basename(t,a){a!==void 0&&g(a,"ext"),g(t,"path");let s=0,n=-1,i=!0,r;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(s=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let o=a.length-1,v=-1;for(r=t.length-1;r>=s;--r){const y=t.charCodeAt(r);if(w(y)){if(!i){s=r+1;break}}else v===-1&&(i=!1,v=r+1),o>=0&&(y===a.charCodeAt(o)?--o===-1&&(n=r):(o=-1,n=v))}return s===n?n=v:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=s;--r)if(w(t.charCodeAt(r))){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){g(t,"path");let a=0,s=-1,n=0,i=-1,r=!0,o=0;t.length>=2&&t.charCodeAt(1)===P&&l(t.charCodeAt(0))&&(a=n=2);for(let v=t.length-1;v>=a;--v){const y=t.charCodeAt(v);if(w(y)){if(!r){n=v+1;break}continue}i===-1&&(r=!1,i=v+1),y===D?s===-1?s=v:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:b.bind(null,"\\"),parse(t){g(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return w(i)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(w(i)){if(n=1,w(t.charCodeAt(1))){let L=2,F=L;for(;L<s&&!w(t.charCodeAt(L));)L++;if(L<s&&L!==F){for(F=L;L<s&&w(t.charCodeAt(L));)L++;if(L<s&&L!==F){for(F=L;L<s&&!w(t.charCodeAt(L));)L++;L===s?n=L:L!==F&&(n=L+1)}}}}else if(l(i)&&t.charCodeAt(1)===P){if(s<=2)return a.root=a.dir=t,a;if(n=2,w(t.charCodeAt(2))){if(s===3)return a.root=a.dir=t,a;n=3}}n>0&&(a.root=t.slice(0,n));let r=-1,o=n,v=-1,y=!0,f=t.length-1,m=0;for(;f>=n;--f){if(i=t.charCodeAt(f),w(i)){if(!y){o=f+1;break}continue}v===-1&&(y=!1,v=f+1),i===D?r===-1?r=f:m!==1&&(m=1):r!==-1&&(m=-1)}return v!==-1&&(r===-1||m===0||m===1&&r===v-1&&r===o+1?a.base=a.name=t.slice(o,v):(a.name=t.slice(o,r),a.base=t.slice(o,v),a.ext=t.slice(r,v))),o>0&&o!==n?a.dir=t.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(p){const t=/\\/g;return()=>{const a=O.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>O.cwd()})();e.$ec={resolve(...t){let a="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:S();g(i,"path"),i.length!==0&&(a=`${i}/${a}`,s=i.charCodeAt(0)===C)}return a=u(a,!s,"/",h),s?`/${a}`:a.length>0?a:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===C,s=t.charCodeAt(t.length-1)===C;return t=u(t,!a,"/",h),t.length===0?a?"/":s?"./":".":(s&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===C},join(...t){if(t.length===0)return".";let a;for(let s=0;s<t.length;++s){const n=t[s];g(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.$ec.normalize(a)},relative(t,a){if(g(t,"from"),g(a,"to"),t===a||(t=e.$ec.resolve(t),a=e.$ec.resolve(a),t===a))return"";const s=1,n=t.length,i=n-s,r=1,o=a.length-r,v=i<o?i:o;let y=-1,f=0;for(;f<v;f++){const L=t.charCodeAt(s+f);if(L!==a.charCodeAt(r+f))break;L===C&&(y=f)}if(f===v)if(o>v){if(a.charCodeAt(r+f)===C)return a.slice(r+f+1);if(f===0)return a.slice(r+f)}else i>v&&(t.charCodeAt(s+f)===C?y=f:f===0&&(y=0));let m="";for(f=s+y+1;f<=n;++f)(f===n||t.charCodeAt(f)===C)&&(m+=m.length===0?"..":"/..");return`${m}${a.slice(r+y)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===C;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===C){if(!n){s=i;break}}else n=!1;return s===-1?a?"/":".":a&&s===1?"//":t.slice(0,s)},basename(t,a){a!==void 0&&g(a,"ext"),g(t,"path");let s=0,n=-1,i=!0,r;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let o=a.length-1,v=-1;for(r=t.length-1;r>=0;--r){const y=t.charCodeAt(r);if(y===C){if(!i){s=r+1;break}}else v===-1&&(i=!1,v=r+1),o>=0&&(y===a.charCodeAt(o)?--o===-1&&(n=r):(o=-1,n=v))}return s===n?n=v:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===C){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){g(t,"path");let a=-1,s=0,n=-1,i=!0,r=0;for(let o=t.length-1;o>=0;--o){const v=t.charCodeAt(o);if(v===C){if(!i){s=o+1;break}continue}n===-1&&(i=!1,n=o+1),v===D?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||n===-1||r===0||r===1&&a===n-1&&a===s+1?"":t.slice(a,n)},format:b.bind(null,"/"),parse(t){g(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const s=t.charCodeAt(0)===C;let n;s?(a.root="/",n=1):n=0;let i=-1,r=0,o=-1,v=!0,y=t.length-1,f=0;for(;y>=n;--y){const m=t.charCodeAt(y);if(m===C){if(!v){r=y+1;break}continue}o===-1&&(v=!1,o=y+1),m===D?i===-1?i=y:f!==1&&(f=1):i!==-1&&(f=-1)}if(o!==-1){const m=r===0&&s?1:r;i===-1||f===0||f===1&&i===o-1&&i===r+1?a.base=a.name=t.slice(m,o):(a.name=t.slice(m,i),a.base=t.slice(m,o),a.ext=t.slice(i,o))}return r>0?a.dir=t.slice(0,r-1):s&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$ec.win32=e.$dc.win32=e.$dc,e.$ec.posix=e.$dc.posix=e.$ec,e.$fc=p?e.$dc.normalize:e.$ec.normalize,e.$gc=p?e.$dc.isAbsolute:e.$ec.isAbsolute,e.$hc=p?e.$dc.join:e.$ec.join,e.$ic=p?e.$dc.resolve:e.$ec.resolve,e.$jc=p?e.$dc.relative:e.$ec.relative,e.$kc=p?e.$dc.dirname:e.$ec.dirname,e.$lc=p?e.$dc.basename:e.$ec.basename,e.$mc=p?e.$dc.extname:e.$ec.extname,e.$nc=p?e.$dc.format:e.$ec.format,e.$oc=p?e.$dc.parse:e.$ec.parse,e.$pc=p?e.$dc.toNamespacedPath:e.$ec.toNamespacedPath,e.sep=p?e.$dc.sep:e.$ec.sep,e.$rc=p?e.$dc.delimiter:e.$ec.delimiter}),define(oe[48],ae([0,1,16,6,27,12]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function I(r){return r===47||r===92}e.$Of=I;function D(r){return r.replace(/[\\/]/g,O.$ec.sep)}e.$Pf=D;function C(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Qf=C;function d(r,o=O.$ec.sep){if(!r)return"";const v=r.length,y=r.charCodeAt(0);if(I(y)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let m=3;const L=m;for(;m<v&&!I(r.charCodeAt(m));m++);if(L!==m&&!I(r.charCodeAt(m+1))){for(m+=1;m<v;m++)if(I(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,o)}}return o}else if(h(y)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(I(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Rf=d;function P(r){if(!N.$i||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const y=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!(y===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Sf=P;const E=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,o=N.$i){const v=o?E:$;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&c.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Tf=g;function p(r,o,v){const y=r===o;return!v||y?y:!r||!o?!1:(0,j.$Ze)(r,o)}e.$Uf=p;function w(r,o,v,y=O.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,j.$1e)(r,o))return!1;if(o.length===r.length)return!0;let m=o.length;return o.charAt(o.length-1)===y&&m--,r.charAt(m)===y}return o.charAt(o.length-1)!==y&&(o+=y),r.indexOf(o)===0}e.$Vf=w;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Wf=h;function l(r,o){return N.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$gc)(r)||(r=(0,O.$hc)(o,r)),r=(0,O.$fc)(r),N.$i?(r=(0,j.$Ie)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,j.$Ie)(r,O.sep),r||(r=O.sep)),r}e.$Xf=l;function u(r){const o=(0,O.$fc)(r);return N.$i?r.length>3?!1:b(o)&&(r.length===2||o.charCodeAt(2)===92):o===O.$ec.sep}e.$Yf=u;function b(r,o=N.$i){return o?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Zf=b;function S(r,o=N.$i){return b(r,o)?r[0]:void 0}e.$1f=S;function t(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$2f=t;function a(r){const o=r.split(":");let v,y,f;for(const m of o){const L=Number(m);(0,A.$Af)(L)?y===void 0?y=L:f===void 0&&(f=L):v=v?[v,m].join(":"):m}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:y!==void 0?y:void 0,column:f!==void 0?f:y!==void 0?1:void 0}}e.$3f=a;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,o,v=8){let y="";for(let m=0;m<v;m++){let L;m===0&&N.$i&&!o&&(v===3||v===4)?L=n:L=s,y+=L.charAt(Math.floor(Math.random()*L.length))}let f;return o?f=`${o}-${y}`:f=y,r?(0,O.$hc)(r,f):f}e.$4f=i}),define(oe[141],ae([0,1,16]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0,e.$Jr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const E=(0,O.$mc)(P),$=N[E.toLowerCase()];return $!==void 0?$:I(P)}e.$Kr=A;function I(P){const E=(0,O.$mc)(P);return j[E.toLowerCase()]}e.$Lr=I;function D(P){for(const E in j)if(j[E]===P)return E}e.$Mr=D;const C=/^(.+)\/(.+?)(;.+)?$/;function d(P,E){const $=C.exec(P);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:E?void 0:P}e.$Nr=d}),define(oe[90],ae([0,1,6]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0;var N;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(N||(e.Source=N={}));var j;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function A(D,...C){const d=C.reduce(($,c)=>($[c]=!0,$),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter($=>!d[$]).forEach($=>{for(let c=0;c<P.length;c++)if($.search(P[c])!==-1){delete D[$];break}})}e.$ul=A;function I(D){D&&(delete D.DEBUG,O.$j&&delete D.DYLD_LIBRARY_PATH,O.$k&&delete D.LD_PRELOAD)}e.$vl=I}),define(oe[9],ae([0,1,16,6]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.$tc=e.URI=void 0;const j=/^\w[\w\d+.-]*$/,A=/^\//,I=/^\/\//;function D(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!j.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(n,i){return!n&&!i?"file":n}function d(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const P="",E="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(i){return i instanceof c?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,o,v,y,f=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=C(i,f),this.authority=r||P,this.path=d(this.scheme,o||P),this.query=v||P,this.fragment=y||P,D(this,f))}get fsPath(){return b(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:o,path:v,query:y,fragment:f}=i;return r===void 0?r=this.scheme:r===null&&(r=P),o===void 0?o=this.authority:o===null&&(o=P),v===void 0?v=this.path:v===null&&(v=P),y===void 0?y=this.query:y===null&&(y=P),f===void 0?f=this.fragment:f===null&&(f=P),r===this.scheme&&o===this.authority&&v===this.path&&y===this.query&&f===this.fragment?this:new w(r,o,v,y,f)}static parse(i,r=!1){const o=$.exec(i);return o?new w(o[2]||P,s(o[4]||P),s(o[5]||P),s(o[7]||P),s(o[9]||P),r):new w(P,P,P,P,P)}static file(i){let r=P;if(N.$i&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const o=i.indexOf(E,2);o===-1?(r=i.substring(2),i=E):(r=i.substring(2,o),i=i.substring(o)||E)}return new w("file",r,i,P,P)}static from(i,r){return new w(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return N.$i&&i.scheme==="file"?o=c.file(O.$dc.join(b(i,!0),...r)).path:o=O.$ec.join(i.path,...r),i.with({path:o})}toString(i=!1){return S(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof c)return i;{const r=new w(i);return r._formatted=i.external??null,r._fsPath=i._sep===p?i.fsPath??null:null,r}}else return i}}e.URI=c;function g(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$tc=g;const p=N.$i?1:void 0;class w extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(i=!1){return i?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(n,i,r){let o,v=-1;for(let y=0;y<n.length;y++){const f=n.charCodeAt(y);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||i&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(o+=encodeURIComponent(n.substring(v,y)),v=-1),o!==void 0&&(o+=n.charAt(y));else{o===void 0&&(o=n.substr(0,y));const m=h[f];m!==void 0?(v!==-1&&(o+=encodeURIComponent(n.substring(v,y)),v=-1),o+=m):v===-1&&(v=y)}}return v!==-1&&(o+=encodeURIComponent(n.substring(v))),o!==void 0?o:n}function u(n){let i;for(let r=0;r<n.length;r++){const o=n.charCodeAt(r);o===35||o===63?(i===void 0&&(i=n.substr(0,r)),i+=h[o]):i!==void 0&&(i+=n[r])}return i!==void 0?i:n}function b(n,i){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$uc=b;function S(n,i){const r=i?u:l;let o="",{scheme:v,authority:y,path:f,query:m,fragment:L}=n;if(v&&(o+=v,o+=":"),(y||v==="file")&&(o+=E,o+=E),y){let F=y.indexOf("@");if(F!==-1){const T=y.substr(0,F);y=y.substr(F+1),F=T.lastIndexOf(":"),F===-1?o+=r(T,!1,!1):(o+=r(T.substr(0,F),!1,!1),o+=":",o+=r(T.substr(F+1),!1,!0)),o+="@"}y=y.toLowerCase(),F=y.lastIndexOf(":"),F===-1?o+=r(y,!1,!0):(o+=r(y.substr(0,F),!1,!0),o+=y.substr(F))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const F=f.charCodeAt(1);F>=65&&F<=90&&(f=`/${String.fromCharCode(F+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const F=f.charCodeAt(0);F>=65&&F<=90&&(f=`${String.fromCharCode(F+32)}:${f.substr(2)}`)}o+=r(f,!0,!1)}return m&&(o+="?",o+=r(m,!1,!1)),L&&(o+="#",o+=i?L:l(L,!1,!1)),o}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(a)?n.replace(a,i=>t(i)):n}}),define(oe[142],ae([0,1,9]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Rp=e.$Qp=e.$Pp=void 0;function N(d){const P=d;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Pp=N;function j(d){const P=[];let E;try{const $=JSON.parse(d.arguments),c=$[$.length-1];c&&c.__$stack&&($.pop(),E=c.__$stack),P.push(...$)}catch{P.push("Unable to log remote console arguments",d.arguments)}return{args:P,stack:E}}e.$Qp=j;function A(d){if(typeof d!="string")return A(j(d).stack);const P=d;if(P){const E=I(P),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if($&&$.length===4)return{uri:O.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$Rp=A;function I(d){if(!d)return d;const P=d.indexOf(`
`);return P===-1?d:d.substring(0,P)}function D(d,P){const{args:E,stack:$}=j(d),c=typeof E[0]=="string"&&E.length===1;let g=I($);g&&(g=`(${g.trim()})`);let p=[];if(typeof E[0]=="string"?g&&c?p=[`%c[${P}] %c${E[0]} %c${g}`,C("blue"),C(""),C("grey")]:p=[`%c[${P}] %c${E[0]}`,C("blue"),C(""),...E.slice(1)]:p=[`%c[${P}]%`,C("blue"),...E],g&&!c&&p.push(g),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,p)}e.log=D;function C(d){return`color: ${d}`}}),define(oe[63],ae([0,1,15,9]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function j(C){return JSON.stringify(C,I)}e.$hh=j;function A(C){let d=JSON.parse(C);return d=D(d),d}e.$ih=A;function I(C,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function D(C,d=0){if(!C||d>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return N.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 17:return new Date(C.source)}if(C instanceof O.$_d||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=D(C[P],d+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=D(C[P],d+1))}return C}e.$jh=D}),define(oe[23],ae([0,1,8,6,9]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var A;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$5f="vscode-tkn",e.$6f="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${A.vscodeRemoteResource}`}set(P,E,$){this.a[P]=E,this.b[P]=$}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(w){return O.$Y(w),P}const E=P.authority;let $=this.a[E];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const c=this.b[E],g=this.c[E];let p=`path=${encodeURIComponent(P.path)}`;return typeof g=="string"&&(p+=`&${e.$6f}=${encodeURIComponent(g)}`),j.URI.from({scheme:N.$o?this.d:A.vscodeRemoteResource,authority:`${$}:${c}`,path:this.f,query:p})}}e.$7f=new I,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked",e.$_f="vscode-app";class D{static{this.a=e.$_f}asBrowserUri(P){const E=this.b(P,te);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===A.vscodeRemote?e.$7f.rewrite(P):P.scheme===A.file&&(N.$m||N.$p&&N.$g.origin===`${A.vscodeFileResource}://${D.a}`)?P.with({scheme:A.vscodeFileResource,authority:P.authority||D.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,te);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===A.vscodeFileResource?P.with({scheme:A.file,authority:P.authority!==D.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return j.URI.isUri(P)?P:j.URI.parse(E.toUrl(P))}}e.$ag=new D;var C;(function(d){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function $(g){let p;typeof g=="string"?p=new URL(g).searchParams:g instanceof URL?p=g.searchParams:j.URI.isUri(g)&&(p=new URL(g.toString(!0)).searchParams);const w=p?.get(E);if(w)return P.get(w)}d.getHeadersFromQuery=$;function c(g,p,w){if(!globalThis.crossOriginIsolated)return;const h=p&&w?"3":w?"2":"1";g instanceof URLSearchParams?g.set(E,h):g[E]=h}d.addSearchParam=c})(C||(e.COI=C={}))}),define(oe[143],ae([0,1,124,23,6,9]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class I{constructor($,c,g){this.id=$,this.dependencies=c,this.callback=g}}class D{static{this.INSTANCE=new D}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,c,g)=>{typeof $!="string"&&(g=c,c=$,$=null),(typeof c!="object"||!Array.isArray(c))&&(g=c,c=null),this.c.push(new I($,c,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const c=await(this.a?this.i($):this.b?this.h($):this.j($));if(!c)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h($){return new Promise((c,g)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const w=()=>{p.removeEventListener("load",h),p.removeEventListener("error",l)},h=u=>{w(),c(this.c.pop())},l=u=>{w(),g(u)};p.addEventListener("load",h),p.addEventListener("error",l),this.f&&($=this.f.createScriptURL($)),p.setAttribute("src",$),document.getElementsByTagName("head")[0].appendChild(p)})}i($){return new Promise((c,g)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),c(this.c.pop())}catch(p){g(p)}})}async j($){try{const c=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,w=A.URI.parse($).fsPath,h=c.readFileSync(w).toString(),l=p.wrap(h.replace(/^#!.*/,""));return new g.Script(l).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const C=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function P(E,$,c){if(O.$R){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[E]&&(E=d[E]);const g=`${E}/${$}`;if(C.has(g))return C.get(g);let p;if(/^\w[\w\d+.-]*:\/\//.test(g))p=g;else{const u=`${c&&!j.$o?N.$0f:N.$9f}/${g}`;p=N.$ag.asBrowserUri(u).toString(!0)}const w=D.INSTANCE.load(p);return C.set(g,w),w}else return await new Promise((g,p)=>{te([E],g,p)})}e.$eC=P}),define(oe[21],ae([0,1,48,23,16,6,27,9]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=e.DataUri=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function C(c){return(0,D.$uc)(c,!0)}e.$hg=C;class d{constructor(g){this.a=g}compare(g,p,w=!1){return g===p?0:(0,I.$Se)(this.getComparisonKey(g,w),this.getComparisonKey(p,w))}isEqual(g,p,w=!1){return g===p?!0:!g||!p?!1:this.getComparisonKey(g,w)===this.getComparisonKey(p,w)}getComparisonKey(g,p=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,p,w=!1){if(g.scheme===p.scheme){if(g.scheme===N.Schemas.file)return O.$Vf(C(g),C(p),this.a(g))&&g.query===p.query&&(w||g.fragment===p.fragment);if((0,e.$yg)(g.authority,p.authority))return O.$Vf(g.path,p.path,this.a(g),"/")&&g.query===p.query&&(w||g.fragment===p.fragment)}return!1}joinPath(g,...p){return D.URI.joinPath(g,...p)}basenameOrAuthority(g){return(0,e.$qg)(g)||g.authority}basename(g){return j.$ec.basename(g.path)}extname(g){return j.$ec.extname(g.path)}dirname(g){if(g.path.length===0)return g;let p;return g.scheme===N.Schemas.file?p=D.URI.file(j.$kc(C(g))).path:(p=j.$ec.dirname(g.path),g.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),p="/")),g.with({path:p})}normalizePath(g){if(!g.path.length)return g;let p;return g.scheme===N.Schemas.file?p=D.URI.file(j.$fc(C(g))).path:p=j.$ec.normalize(g.path),g.with({path:p})}relativePath(g,p){if(g.scheme!==p.scheme||!(0,e.$yg)(g.authority,p.authority))return;if(g.scheme===N.Schemas.file){const l=j.$jc(C(g),C(p));return A.$i?O.$Pf(l):l}let w=g.path||"/";const h=p.path||"/";if(this.a(g)){let l=0;for(const u=Math.min(w.length,h.length);l<u&&!(w.charCodeAt(l)!==h.charCodeAt(l)&&w.charAt(l).toLowerCase()!==h.charAt(l).toLowerCase());l++);w=h.substr(0,l)+w.substr(l)}return j.$ec.relative(w,h)}resolvePath(g,p){if(g.scheme===N.Schemas.file){const w=D.URI.file(j.$ic(C(g),p));return g.with({authority:w.authority,path:w.path})}return p=O.$Qf(p),g.with({path:j.$ec.resolve(g.path,p)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,p){return g===p||g!==void 0&&p!==void 0&&(0,I.$Ze)(g,p)}hasTrailingPathSeparator(g,p=j.sep){if(g.scheme===N.Schemas.file){const w=C(g);return w.length>O.$Rf(w).length&&w[w.length-1]===p}else{const w=g.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,p=j.sep){return(0,e.$zg)(g,p)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,p=j.sep){let w=!1;if(g.scheme===N.Schemas.file){const h=C(g);w=h!==void 0&&h.length===O.$Rf(h).length&&h[h.length-1]===p}else{p="/";const h=g.path;w=h.length===1&&h.charCodeAt(h.length-1)===47}return!w&&!(0,e.$zg)(g,p)?g.with({path:g.path+"/"}):g}}e.$ig=d,e.$jg=new d(()=>!1),e.$kg=new d(c=>c.scheme===N.Schemas.file?!A.$k:!0),e.$lg=new d(c=>!0),e.$mg=e.$jg.isEqual.bind(e.$jg),e.$ng=e.$jg.isEqualOrParent.bind(e.$jg),e.$og=e.$jg.getComparisonKey.bind(e.$jg),e.$pg=e.$jg.basenameOrAuthority.bind(e.$jg),e.$qg=e.$jg.basename.bind(e.$jg),e.$rg=e.$jg.extname.bind(e.$jg),e.$sg=e.$jg.dirname.bind(e.$jg),e.$tg=e.$jg.joinPath.bind(e.$jg),e.$ug=e.$jg.normalizePath.bind(e.$jg),e.$vg=e.$jg.relativePath.bind(e.$jg),e.$wg=e.$jg.resolvePath.bind(e.$jg),e.$xg=e.$jg.isAbsolutePath.bind(e.$jg),e.$yg=e.$jg.isEqualAuthority.bind(e.$jg),e.$zg=e.$jg.hasTrailingPathSeparator.bind(e.$jg),e.$Ag=e.$jg.removeTrailingPathSeparator.bind(e.$jg),e.$Bg=e.$jg.addTrailingPathSeparator.bind(e.$jg);function P(c,g){const p=[];for(let w=0;w<c.length;w++){const h=g(c[w]);c.some((l,u)=>u===w?!1:(0,e.$ng)(h,g(l)))||p.push(c[w])}return p}e.$Cg=P;var E;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function g(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(u=>{const[b,S]=u.split(":");b&&S&&w.set(b,S)});const l=p.path.substring(0,p.path.indexOf(";"));return l&&w.set(c.META_DATA_MIME,l),w}c.parseMetaData=g})(E||(e.DataUri=E={}));function $(c,g,p){if(g){let w=c.path;return w&&w[0]!==j.$ec.sep&&(w=j.$ec.sep+w),c.with({scheme:p,authority:g,path:w})}return c.with({scheme:p})}e.$Dg=$}),define(oe[5],ae([0,1,26,8,3,2,21,6,130]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.Promises=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=void 0;function d(k){return!!k&&typeof k.then=="function"}e.$Eg=d;function P(k){const R=new O.$Vd,U=k(R.token),M=new Promise((J,X)=>{const se=R.token.onCancellationRequested(()=>{se.dispose(),R.dispose(),X(new N.$3)});Promise.resolve(U).then(le=>{se.dispose(),R.dispose(),J(le)},le=>{se.dispose(),R.dispose(),X(le)})});return new class{cancel(){R.cancel()}then(J,X){return M.then(J,X)}catch(J){return this.then(void 0,J)}finally(J){return M.finally(J)}}}e.$Fg=P;function E(k,R,U){return new Promise((M,J)=>{const X=R.onCancellationRequested(()=>{X.dispose(),M(U)});k.then(M,J).finally(()=>X.dispose())})}e.$Gg=E;function $(k,R){return new Promise((U,M)=>{const J=R.onCancellationRequested(()=>{J.dispose(),M(new N.$3)});k.then(U,M).finally(()=>J.dispose())})}e.$Hg=$;async function c(k){let R=-1;const U=k.map((M,J)=>M.then(X=>(R=J,X)));try{return await Promise.race(U)}finally{k.forEach((M,J)=>{J!==R&&M.cancel()})}}e.$Ig=c;function g(k,R,U){let M;const J=setTimeout(()=>{M?.(void 0),U?.()},R);return Promise.race([k.finally(()=>clearTimeout(J)),new Promise(X=>M=X)])}e.$Jg=g;function p(k){return new Promise((R,U)=>{const M=k();d(M)?M.then(R,U):R(M)})}e.$Kg=p;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(R){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=R,!this.b){const U=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(U,U).then(M)})}return new Promise((U,M)=>{this.b.then(U,M)})}return this.a=R(),new Promise((U,M)=>{this.a.then(J=>{this.a=null,U(J)},J=>{this.a=null,M(J)})})}dispose(){this.f=!0}}e.$Lg=w;class h{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.$Mg=h;class l{constructor(){this.a=new Map}queue(R,U){const J=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(R)===J&&this.a.delete(R)});return this.a.set(R,J),J}}e.$Ng=l;const u=(k,R)=>{let U=!0;const M=setTimeout(()=>{U=!1,R()},k);return{isTriggered:()=>U,dispose:()=>{clearTimeout(M),U=!1}}},b=k=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,k())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class S{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,U=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((J,X)=>{this.d=J,this.f=X}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=U===C.$Id?b(M):u(U,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Og=S;class t{constructor(R){this.a=new S(R),this.b=new w}trigger(R,U){return this.a.trigger(()=>this.b.queue(R),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Pg=t;class a{constructor(){this.a=!1,this.b=new Promise((R,U)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Qg=a;class s extends a{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.$Rg=s;function n(k,R){return R?new Promise((U,M)=>{const J=setTimeout(()=>{X.dispose(),U()},k),X=R.onCancellationRequested(()=>{clearTimeout(J),X.dispose(),M(new N.$3)})}):P(U=>n(k,U))}e.$Sg=n;function i(k,R=0,U){const M=setTimeout(()=>{k(),U&&J.dispose()},R),J=(0,A.$Oc)(()=>{clearTimeout(M),U?.deleteAndLeak(J)});return U?.add(J),J}e.$Tg=i;function r(k){const R=[];let U=0;const M=k.length;function J(){return U<M?k[U++]():null}function X(se){se!=null&&R.push(se);const le=J();return le?le.then(X):Promise.resolve(R)}return Promise.resolve(null).then(X)}e.$Ug=r;function o(k,R=M=>!!M,U=null){let M=0;const J=k.length,X=()=>{if(M>=J)return Promise.resolve(U);const se=k[M++];return Promise.resolve(se()).then(ue=>R(ue)?Promise.resolve(ue):X())};return X()}e.$Vg=o;function v(k,R=M=>!!M,U=null){if(k.length===0)return Promise.resolve(U);let M=k.length;const J=()=>{M=-1;for(const X of k)X.cancel?.()};return new Promise((X,se)=>{for(const le of k)le.then(ue=>{--M>=0&&R(ue)?(J(),X(ue)):M===0&&X(U)}).catch(ue=>{--M>=0&&(J(),se(ue))})})}e.$Wg=v;class y{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new j.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((U,M)=>{this.f.push({factory:R,c:U,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const U=R.factory();U.then(R.c,R.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Xg=y;class f extends y{constructor(){super(1)}}e.$Yg=f;class m{constructor(){this.a=new K,this.b=0}queue(R){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,R())):this.a.run(this.b++,R())}}e.$Zg=m;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const R=new W;return this.b.add(R),R.p}g(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,U=I.$jg){const M=U.getComparisonKey(R);let J=this.a.get(M);if(!J){J=new f;const X=this.f++,se=j.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(M),this.h(),this.d?.deleteAndDispose(X),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$Yc),this.d.set(X,se),this.a.set(M,J)}return J}h(){this.g()&&this.j()}j(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$1g=L;class F{constructor(R,U){this.a=-1,typeof R=="function"&&typeof U=="number"&&this.setIfNotSet(R,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},U)}setIfNotSet(R,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},U))}}e.$2g=F;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,U){this.cancel(),this.a=setInterval(()=>{R()},U)}}e.$3g=T;class z{constructor(R,U){this.b=-1,this.a=R,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$4g=z;class q{constructor(R,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=R,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$5g=q;class _ extends z{constructor(R,U){super(R,U),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.$6g=_;class Q extends A.$Qc{constructor(R,U){super(),this.g=R,this.h=U,this.a=[],this.b=this.B(new A.$Rc),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of R)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$7g=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$8g=k=>{(0,D.$A)(()=>{if(R)return;const U=Date.now()+15;k(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.$8g=(k,R)=>{const U=requestIdleCallback(k,typeof R=="number"?{timeout:R}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(U))}}}}();class Z{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.$8g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$9g=Z;async function G(k,R,U){let M;for(let J=0;J<U;J++)try{return await k()}catch(X){M=X,await n(R)}throw M}e.$0g=G;class K{isRunning(R){return typeof R=="number"?this.a?.taskId===R:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(R,U,M){return this.a={taskId:R,cancel:()=>M?.(),promise:U},U.then(()=>this.d(R),()=>this.d(R)),U}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this.b)this.b.run=R;else{let U,M;const J=new Promise((X,se)=>{U=X,M=se});this.b={run:R,promise:J,promiseResolve:U,promiseReject:M}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$$g=K;class H{constructor(R,U=()=>Date.now()){this.d=R,this.f=U,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.$_g=H;var V;(function(k){k[k.Resolved=0]="Resolved",k[k.Rejected=1]="Rejected"})(V||(V={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((R,U)=>{this.a=R,this.b=U})}complete(R){return new Promise(U=>{this.a(R),this.d={outcome:0,value:R},U()})}error(R){return new Promise(U=>{this.b(R),this.d={outcome:1,value:R},U()})}cancel(){return this.error(new N.$3)}}e.$ah=W;var ee;(function(k){async function R(M){let J;const X=await Promise.all(M.map(se=>se.then(le=>le,le=>{J||(J=le)})));if(typeof J<"u")throw J;return X}k.settled=R;function U(M){return new Promise(async(J,X)=>{try{await M(J,X)}catch(se){X(se)}})}k.withAsyncBody=U})(ee||(e.Promises=ee={}));var ne;(function(k){k[k.Initial=0]="Initial",k[k.DoneOK=1]="DoneOK",k[k.DoneError=2]="DoneError"})(ne||(ne={}));class re{static fromArray(R){return new re(U=>{U.emitMany(R)})}static fromPromise(R){return new re(async U=>{U.emitMany(await R)})}static fromPromises(R){return new re(async U=>{await Promise.all(R.map(async M=>U.emitOne(await M)))})}static merge(R){return new re(async U=>{await Promise.all(R.map(async M=>{for await(const J of M)U.emitOne(J)}))})}static{this.EMPTY=re.fromArray([])}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new j.$Ld,queueMicrotask(async()=>{const U={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(R(U)),this.j()}catch(M){this.k(M)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.f.event)}while(!0)}}}static map(R,U){return new re(async M=>{for await(const J of R)M.emitOne(U(J))})}map(R){return re.map(this,R)}static filter(R,U){return new re(async M=>{for await(const J of R)U(J)&&M.emitOne(J)})}filter(R){return re.filter(this,R)}static coalesce(R){return re.filter(R,U=>!!U)}coalesce(){return re.coalesce(this)}static async toPromise(R){const U=[];for await(const M of R)U.push(M);return U}toPromise(){return re.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.$bh=re;class Y extends re{constructor(R,U){super(U),this.l=R}cancel(){this.l.cancel()}}e.$ch=Y;function B(k){const R=new O.$Vd,U=k(R.token);return new Y(R,async M=>{const J=R.token.onCancellationRequested(()=>{J.dispose(),R.dispose(),M.reject(new N.$3)});try{for await(const X of U){if(R.token.isCancellationRequested)return;M.emitOne(X)}J.dispose(),R.dispose()}catch(X){J.dispose(),R.dispose(),M.reject(X)}})}e.$dh=B}),define(oe[91],ae([0,1,18,5,48,34,16,6,27]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=void 0;function d(){return Object.create(null)}e.$oj=d,e.$pj="**",e.$qj="/";const P="[/\\\\]",E="[^/\\\\]",$=/\//g;function c(K,H){switch(K){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${H?`|${P}${E}+`:""})*?`}}function g(K,H){if(!K)return[];const V=[];let W=!1,ee=!1,ne="";for(const re of K){switch(re){case H:if(!W&&!ee){V.push(ne),ne="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=re}return ne&&V.push(ne),V}e.$rj=g;function p(K){if(!K)return"";let H="";const V=g(K,e.$qj);if(V.every(W=>W===e.$pj))H=".*";else{let W=!1;V.forEach((ee,ne)=>{if(ee===e.$pj){if(W)return;H+=c(2,ne===V.length-1)}else{let re=!1,Y="",B=!1,k="";for(const R of ee){if(R!=="}"&&re){Y+=R;continue}if(B&&(R!=="]"||!k)){let U;R==="-"?U=R:(R==="^"||R==="!")&&!k?U="^":R===e.$qj?U="":U=(0,C.$De)(R),k+=U;continue}switch(R){case"{":re=!0;continue;case"[":B=!0;continue;case"}":{const M=`(?:${g(Y,",").map(J=>p(J)).join("|")})`;H+=M,re=!1,Y="";break}case"]":{H+="["+k+"]",B=!1,k="";break}case"?":H+=E;continue;case"*":H+=c(1);continue;default:H+=(0,C.$De)(R)}}ne<V.length-1&&(V[ne+1]!==e.$pj||ne+2<V.length)&&(H+=P)}W=ee===e.$pj})}return H}const w=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Bc(1e4),a=function(){return!1},s=function(){return null};function n(K,H){if(!K)return s;let V;typeof K!="string"?V=K.pattern:V=K,V=V.trim();const W=`${V}_${!!H.trimForExclusions}`;let ee=t.get(W);if(ee)return i(ee,K);let ne;return w.test(V)?ee=o(V.substr(4),V):(ne=h.exec(r(V,H)))?ee=v(ne[1],V):(H.trimForExclusions?u:l).test(V)?ee=y(V,H):(ne=b.exec(r(V,H)))?ee=f(ne[1].substr(1),V,!0):(ne=S.exec(r(V,H)))?ee=f(ne[1],V,!1):ee=m(V),t.set(W,ee),i(ee,K)}function i(K,H){if(typeof H=="string")return K;const V=function(W,ee){return(0,j.$Vf)(W,H.base,!D.$k)?K((0,C.$He)(W.substr(H.base.length),I.sep),ee):null};return V.allBasenames=K.allBasenames,V.allPaths=K.allPaths,V.basenames=K.basenames,V.patterns=K.patterns,V}function r(K,H){return H.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function o(K,H){return function(V,W){return typeof V=="string"&&V.endsWith(K)?H:null}}function v(K,H){const V=`/${K}`,W=`\\${K}`,ee=function(re,Y){return typeof re!="string"?null:Y?Y===K?H:null:re===K||re.endsWith(V)||re.endsWith(W)?H:null},ne=[K];return ee.basenames=ne,ee.patterns=[H],ee.allBasenames=ne,ee}function y(K,H){const V=Z(K.slice(1,-1).split(",").map(Y=>n(Y,H)).filter(Y=>Y!==s),K),W=V.length;if(!W)return s;if(W===1)return V[0];const ee=function(Y,B){for(let k=0,R=V.length;k<R;k++)if(V[k](Y,B))return K;return null},ne=V.find(Y=>!!Y.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=V.reduce((Y,B)=>B.allPaths?Y.concat(B.allPaths):Y,[]);return re.length&&(ee.allPaths=re),ee}function f(K,H,V){const W=I.sep===I.$ec.sep,ee=W?K:K.replace($,I.sep),ne=I.sep+ee,re=I.$ec.sep+K;let Y;return V?Y=function(B,k){return typeof B=="string"&&(B===ee||B.endsWith(ne)||!W&&(B===K||B.endsWith(re)))?H:null}:Y=function(B,k){return typeof B=="string"&&(B===ee||!W&&B===K)?H:null},Y.allPaths=[(V?"*/":"./")+K],Y}function m(K){try{const H=new RegExp(`^${p(K)}$`);return function(V){return H.lastIndex=0,typeof V=="string"&&H.test(V)?K:null}}catch{return s}}function L(K,H,V){return!K||typeof H!="string"?!1:F(K)(H,void 0,V)}e.$sj=L;function F(K,H={}){if(!K)return a;if(typeof K=="string"||T(K)){const V=n(K,H);if(V===s)return a;const W=function(ee,ne){return!!V(ee,ne)};return V.allBasenames&&(W.allBasenames=V.allBasenames),V.allPaths&&(W.allPaths=V.allPaths),W}return _(K,H)}e.$tj=F;function T(K){const H=K;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$uj=T;function z(K){return K.allBasenames||[]}e.$vj=z;function q(K){return K.allPaths||[]}e.$wj=q;function _(K,H){const V=Z(Object.getOwnPropertyNames(K).map(Y=>Q(Y,K[Y],H)).filter(Y=>Y!==s)),W=V.length;if(!W)return s;if(!V.some(Y=>!!Y.requiresSiblings)){if(W===1)return V[0];const Y=function(R,U){let M;for(let J=0,X=V.length;J<X;J++){const se=V[J](R,U);if(typeof se=="string")return se;(0,N.$Eg)(se)&&(M||(M=[]),M.push(se))}return M?(async()=>{for(const J of M){const X=await J;if(typeof X=="string")return X}return null})():null},B=V.find(R=>!!R.allBasenames);B&&(Y.allBasenames=B.allBasenames);const k=V.reduce((R,U)=>U.allPaths?R.concat(U.allPaths):R,[]);return k.length&&(Y.allPaths=k),Y}const ee=function(Y,B,k){let R,U;for(let M=0,J=V.length;M<J;M++){const X=V[M];X.requiresSiblings&&k&&(B||(B=(0,I.$lc)(Y)),R||(R=B.substr(0,B.length-(0,I.$mc)(Y).length)));const se=X(Y,B,R,k);if(typeof se=="string")return se;(0,N.$Eg)(se)&&(U||(U=[]),U.push(se))}return U?(async()=>{for(const M of U){const J=await M;if(typeof J=="string")return J}return null})():null},ne=V.find(Y=>!!Y.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=V.reduce((Y,B)=>B.allPaths?Y.concat(B.allPaths):Y,[]);return re.length&&(ee.allPaths=re),ee}function Q(K,H,V){if(H===!1)return s;const W=n(K,V);if(W===s)return s;if(typeof H=="boolean")return W;if(H){const ee=H.when;if(typeof ee=="string"){const ne=(re,Y,B,k)=>{if(!k||!W(re,Y))return null;const R=ee.replace("$(basename)",()=>B),U=k(R);return(0,N.$Eg)(U)?U.then(M=>M?K:null):U?K:null};return ne.requiresSiblings=!0,ne}}return W}function Z(K,H){const V=K.filter(Y=>!!Y.basenames);if(V.length<2)return K;const W=V.reduce((Y,B)=>{const k=B.basenames;return k?Y.concat(k):Y},[]);let ee;if(H){ee=[];for(let Y=0,B=W.length;Y<B;Y++)ee.push(H)}else ee=V.reduce((Y,B)=>{const k=B.patterns;return k?Y.concat(k):Y},[]);const ne=function(Y,B){if(typeof Y!="string")return null;if(!B){let R;for(R=Y.length;R>0;R--){const U=Y.charCodeAt(R-1);if(U===47||U===92)break}B=Y.substr(R)}const k=W.indexOf(B);return k!==-1?ee[k]:null};ne.basenames=W,ne.patterns=ee,ne.allBasenames=W;const re=K.filter(Y=>!Y.basenames);return re.push(ne),re}function G(K,H){return(0,O.$sb)(K,H,(V,W)=>typeof V=="string"&&typeof W=="string"?V===W:typeof V!="string"&&typeof W!="string"?V.base===W.base&&V.pattern===W.pattern:!1)}e.$xj=G}),define(oe[92],ae([0,1,15,9]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function j(E){return E.toJSON()}class A{constructor($){this.a=$}transformIncoming($){const c=this.a.transformIncoming($);return c===$?$:j(N.URI.from(c))}transformOutgoing($){const c=this.a.transformOutgoing($);return c===$?$:j(N.URI.from(c))}transformOutgoingURI($){const c=this.a.transformOutgoing($);return c===$?$:N.URI.from(c)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Dm=A,e.$Em=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function I(E,$,c){if(!E||c>200)return null;if(typeof E=="object"){if(E instanceof N.URI)return $.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const p=I(E[g],$,c+1);p!==null&&(E[g]=p)}}return null}function D(E,$){const c=I(E,$,0);return c===null?E:c}e.$Fm=D;function C(E,$,c,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return c?N.URI.revive($.transformIncoming(E)):$.transformIncoming(E);if(E instanceof O.$_d)return null;for(const p in E)if(Object.hasOwnProperty.call(E,p)){const w=C(E[p],$,c,g+1);w!==null&&(E[p]=w)}}return null}function d(E,$){const c=C(E,$,!1,0);return c===null?E:c}e.$Gm=d;function P(E,$){const c=C(E,$,!0,0);return c===null?E:c}e.$Hm=P}),define(oe[31],ae([0,1,52,36,269,5,48,88,16,6,21,9]),function(te,e,O,N,j,A,I,D,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function c(Q,Z=$.UNLINK,G){if((0,I.$Yf)(Q))throw new Error("rimraf - will refuse to recursively delete root");return Z===$.UNLINK?p(Q):g(Q,G)}async function g(Q,Z=(0,I.$4f)((0,N.tmpdir)())){try{try{await O.promises.rename(Q,Z)}catch(G){return G.code==="ENOENT"?void 0:p(Q)}p(Z).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(Q){return(0,j.promisify)(O.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function w(Q){if((0,I.$Yf)(Q))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function h(Q,Z){return b(await(Z?l(Q):(0,j.promisify)(O.readdir)(Q)))}async function l(Q){try{return await(0,j.promisify)(O.readdir)(Q,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Z=[],G=await h(Q);for(const K of G){let H=!1,V=!1,W=!1;try{const ee=await e.Promises.lstat((0,C.$hc)(Q,K));H=ee.isFile(),V=ee.isDirectory(),W=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Z.push({name:K,isFile:()=>H,isDirectory:()=>V,isSymbolicLink:()=>W})}return Z}function u(Q){return b(O.readdirSync(Q))}e.readdirSync=u;function b(Q){return Q.map(Z=>typeof Z=="string"?d.$j?(0,D.$jl)(Z):Z:(Z.name=d.$j?(0,D.$jl)(Z.name):Z.name,Z))}async function S(Q){const Z=await h(Q),G=[];for(const K of Z)await a.existsDirectory((0,C.$hc)(Q,K))&&G.push(K);return G}function t(Q,Z=1e3){return new Promise(G=>{let K=!1;const H=setInterval(()=>{K||(K=!0,O.access(Q,V=>{K=!1,V&&(clearInterval(H),G(void 0))}))},Z)})}e.whenDeleted=t;var a;(function(Q){async function Z(H){let V;try{if(V=await e.Promises.lstat(H),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(d.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ee}throw W}}Q.stat=Z;async function G(H){try{const{stat:V,symbolicLink:W}=await Q.stat(H);return V.isFile()&&W?.dangling!==!0}catch{}return!1}Q.existsFile=G;async function K(H){try{const{stat:V,symbolicLink:W}=await Q.stat(H);return V.isDirectory()&&W?.dangling!==!0}catch{}return!1}Q.existsDirectory=K})(a||(e.SymlinkSupport=a={}));const s=new A.$1g;function n(Q,Z,G){return s.queueFor(E.URI.file(Q),P.$kg).queue(()=>{const K=y(G);return new Promise((H,V)=>o(Q,Z,K,W=>W?V(W):H()))})}let i=!0;function r(Q){i=Q}e.configureFlushOnWrite=r;function o(Q,Z,G,K){if(!i)return O.writeFile(Q,Z,{mode:G.mode,flag:G.flag},K);O.open(Q,G.flag,G.mode,(H,V)=>{if(H)return K(H);O.writeFile(V,Z,W=>{if(W)return O.close(V,()=>K(W));O.fdatasync(V,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),O.close(V,ne=>K(ne))))})})}function v(Q,Z,G){const K=y(G);if(!i)return O.writeFileSync(Q,Z,{mode:K.mode,flag:K.flag});const H=O.openSync(Q,K.flag,K.mode);try{O.writeFileSync(H,Z);try{O.fdatasyncSync(H)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{O.closeSync(H)}}e.writeFileSync=v;function y(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function f(Q,Z,G=6e4){if(Q!==Z)try{d.$i&&typeof G=="number"?await m(Q,Z,Date.now(),G):await(0,j.promisify)(O.rename)(Q,Z)}catch(K){if(Q.toLowerCase()!==Z.toLowerCase()&&K.code==="EXDEV"||Q.endsWith("."))await L(Q,Z,{preserveSymlinks:!1}),await c(Q,$.MOVE);else throw K}}async function m(Q,Z,G,K,H=0){try{return await(0,j.promisify)(O.rename)(Q,Z)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-G>=K)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${V}`),V;if(H===0){let W=!1;try{const{stat:ee}=await a.stat(Z);ee.isFile()||(W=!0)}catch{}if(W)throw V}return await(0,A.$Sg)(Math.min(100,H*10)),m(Q,Z,G,K,H+1)}}async function L(Q,Z,G){return T(Q,Z,{root:{source:Q,target:Z},options:G,handledSourcePaths:new Set})}const F=511;async function T(Q,Z,G){if(G.handledSourcePaths.has(Q))return;G.handledSourcePaths.add(Q);const{stat:K,symbolicLink:H}=await a.stat(Q);if(H){if(G.options.preserveSymlinks)try{return await _(Q,Z,G)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(H.dangling)return}return K.isDirectory()?z(Q,Z,K.mode&F,G):q(Q,Z,K.mode&F)}async function z(Q,Z,G,K){await e.Promises.mkdir(Z,{recursive:!0,mode:G});const H=await h(Q);for(const V of H)await T((0,C.$hc)(Q,V),(0,C.$hc)(Z,V),K)}async function q(Q,Z,G){await e.Promises.copyFile(Q,Z),await e.Promises.chmod(Z,G)}async function _(Q,Z,G){let K=await e.Promises.readlink(Q);(0,I.$Vf)(K,G.root.source,!d.$k)&&(K=(0,C.$hc)(G.root.target,K.substr(G.root.source.length+1))),await e.Promises.symlink(K,Z)}e.Promises=new class{get access(){return(0,j.promisify)(O.access)}get stat(){return(0,j.promisify)(O.stat)}get lstat(){return(0,j.promisify)(O.lstat)}get utimes(){return(0,j.promisify)(O.utimes)}get read(){return(Q,Z,G,K,H)=>new Promise((V,W)=>{O.read(Q,Z,G,K,H,(ee,ne,re)=>ee?W(ee):V({bytesRead:ne,buffer:re}))})}get readFile(){return(0,j.promisify)(O.readFile)}get write(){return(Q,Z,G,K,H)=>new Promise((V,W)=>{O.write(Q,Z,G,K,H,(ee,ne,re)=>ee?W(ee):V({bytesWritten:ne,buffer:re}))})}get appendFile(){return(0,j.promisify)(O.appendFile)}get fdatasync(){return(0,j.promisify)(O.fdatasync)}get truncate(){return(0,j.promisify)(O.truncate)}get copyFile(){return(0,j.promisify)(O.copyFile)}get open(){return(0,j.promisify)(O.open)}get close(){return(0,j.promisify)(O.close)}get symlink(){return(0,j.promisify)(O.symlink)}get readlink(){return(0,j.promisify)(O.readlink)}get chmod(){return(0,j.promisify)(O.chmod)}get mkdir(){return(0,j.promisify)(O.mkdir)}get unlink(){return(0,j.promisify)(O.unlink)}get rmdir(){return(0,j.promisify)(O.rmdir)}get realpath(){return(0,j.promisify)(O.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return S}get writeFile(){return n}get rm(){return c}get rename(){return f}get copy(){return L}}}),define(oe[144],ae([0,1,52,16,6,27,31]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0;function D($){if(j.$k)return $;const c=(0,N.$kc)($);if($===c)return $;const g=((0,N.$lc)($)||$).toLowerCase();try{const w=(0,I.readdirSync)(c).filter(h=>h.toLowerCase()===g);if(w.length===1){const h=D(c);if(h)return(0,N.$hc)(h,w[0])}else if(w.length>1){const h=w.indexOf(g);if(h>=0){const l=D(c);if(l)return(0,N.$hc)(l,w[h])}}}catch{}return null}e.$Wp=D;async function C($){if(j.$k)return $;const c=(0,N.$kc)($);if($===c)return $;const g=((0,N.$lc)($)||$).toLowerCase();try{const w=(await I.Promises.readdir(c)).filter(h=>h.toLowerCase()===g);if(w.length===1){const h=await C(c);if(h)return(0,N.$hc)(h,w[0])}else if(w.length>1){const h=w.indexOf(g);if(h>=0){const l=await C(c);if(l)return(0,N.$hc)(l,w[h])}}}catch{}return null}e.$Xp=C;async function d($){try{return await I.Promises.realpath($)}catch{const g=E($);return await I.Promises.access(g,O.constants.R_OK),g}}e.$Yp=d;function P($){try{return O.realpathSync($)}catch{const g=E($);return O.accessSync(g,O.constants.R_OK),g}}e.$Zp=P;function E($){return(0,A.$Ie)((0,N.$fc)($),N.sep)}}),define(oe[145],ae([0,1,16,6,37,90,12,31]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function C(E=j.env){return E.comspec||"cmd.exe"}e.$wl=C;function d(E){let $=[],c=!1;const g=function(p){if(c){$.push(p);return}(!E.send(p,h=>{if(h&&console.error(h),c=!1,$.length>0){const l=$.slice(0);$=[],l.forEach(u=>g(u))}})||N.$i)&&(c=!0)};return{send:g}}e.$xl=d;var P;(function(E){async function $(c,g,p){if(O.$gc(c))return c;if(g===void 0&&(g=j.cwd()),O.$kc(c)!=="."||(p===void 0&&I.$wf(j.env.PATH)&&(p=j.env.PATH.split(O.$rc)),p===void 0||p.length===0))return O.$hc(g,c);async function h(l){if(await D.Promises.exists(l)){let u;try{u=await D.Promises.stat(l)}catch(b){b.message.startsWith("EACCES")&&(u=await D.Promises.lstat(l))}return u?!u.isDirectory():!1}return!1}for(const l of p){let u;if(O.$gc(l)?u=O.$hc(l,c):u=O.$hc(g,l,c),await h(u))return u;let b=u+".com";if(await h(b)||(b=u+".exe",await h(b)))return b}return O.$hc(g,c)}E.findExecutable=$})(P||(e.win32=P={}))}),define(oe[146],ae([0,1,64,23]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;function j(I){return new Promise((D,C)=>{let d;const P=new Map;function E(c,g,p,w,h){const l=P.get(g);if(c===I||l){const u={name:$(p),cmd:p,pid:c,ppid:g,load:w,mem:h};P.set(c,u),c===I&&(d=u),l&&(l.children||(l.children=[]),l.children.push(u),l.children.length>1&&(l.children=l.children.sort((b,S)=>b.pid-S.pid)))}}function $(c){const g=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(w.exec(c))return"electron-crash-reporter";if(h.exec(c))return"winpty-agent";if(l.exec(c))return"conpty-agent";let b=u.exec(c);if(b&&b.length===2)return b[1]==="renderer"?"window":b[1]==="utility"?g.exec(c)?"utility-network-service":"utility-process":b[1]==="extensionHost"?"extension-host":b[1];const S=/[a-zA-Z-]+\.js/g;let t="";do b=S.exec(c),b&&(t+=b+" ");while(b);return t&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${t})`:p.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,p)=>{te(["@vscode/windows-process-tree"],g,p)}).then(g=>{g.getProcessList(I,p=>{if(!p){C(new Error(`Root process ${I} not found`));return}g.getProcessCpuUsage(p,w=>{const h=new Map;w.forEach(l=>{const u=c(l.commandLine||"");h.set(l.pid,{name:$(u),cmd:u,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),d=h.get(I),d?(h.forEach(l=>{const u=h.get(l.ppid);u&&(u.children||(u.children=[]),u.children.push(l))}),h.forEach(l=>{l.children&&(l.children=l.children.sort((u,b)=>u.pid-b.pid))}),D(d)):C(new Error(`Root process ${I} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let c=function(){let g=[d];const p=[];for(;g.length;){const h=g.shift();h&&(p.push(h.pid),h.children&&(g=g.concat(h.children)))}let w=JSON.stringify(N.$ag.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+p.join(" "),(0,O.exec)(w,{},(h,l,u)=>{if(h||u)C(h||new Error(u.toString()));else{const b=l.toString().split(`
`);for(let S=0;S<p.length;S++){const t=P.get(p[S]);t.load=parseFloat(b[S])}if(!d){C(new Error(`Root process ${I} not found`));return}D(d)}})};(0,O.exec)("which ps",{},(g,p,w)=>{if(g||w)if(process.platform!=="linux")C(g||new Error(w.toString()));else{const h=JSON.stringify(N.$ag.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(h,{},(l,u,b)=>{l||b?C(l||new Error(b.toString())):(A(u,E),c())})}else{const h=p.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,O.exec)(`${h} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,b,S)=>{u||S&&!S.includes("screen size is bogus")?C(u||new Error(S.toString())):(A(b,E),process.platform==="linux"?c():d?D(d):C(new Error(`Root process ${I} not found`)))})}})}})}e.$ur=j;function A(I,D){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=I.toString().split(`
`);for(const P of d){const E=C.exec(P.trim());E&&E.length===6&&D(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,O,N){var j=arguments.length,A=j<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,O):N,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,O,N);else for(var D=te.length-1;D>=0;D--)(I=te[D])&&(A=(j<3?I(A):j>3?I(e,O,A):I(e,O))||A);return j>3&&A&&Object.defineProperty(e,O,A),A};define(oe[42],ae([0,1,18,5,15,26,83,8,3,2,63,27,12]),function(te,e,O,N,j,A,I,D,C,d,P,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.ProxyChannel=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.RequestInitiator=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0;var c;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(c||(c={}));function g(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function w(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(h||(h={}));function l(H){let V=0;for(let W=0;;W+=7){const ee=H.read(1);if(V|=(ee.buffer[0]&127)<<W,!(ee.buffer[0]&128))return V}}const u=s(0);function b(H,V){if(V===0){H.write(u);return}let W=0;for(let ne=V;ne!==0;ne=ne>>>7)W++;const ee=j.$_d.alloc(W);for(let ne=0;V!==0;ne++)ee.buffer[ne]=V&127,V=V>>>7,V>0&&(ee.buffer[ne]|=128);H.write(ee)}class S{constructor(V){this.b=V,this.a=0}read(V){const W=this.b.slice(this.a,this.a+V);return this.a+=W.byteLength,W}}e.$kh=S;class t{constructor(){this.a=[]}get buffer(){return j.$_d.concat(this.a)}write(V){this.a.push(V)}}e.$lh=t;var a;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(a||(a={}));function s(H){const V=j.$_d.alloc(1);return V.writeUInt8(H,0),V}const n={Undefined:s(a.Undefined),String:s(a.String),Buffer:s(a.Buffer),VSBuffer:s(a.VSBuffer),Array:s(a.Array),Object:s(a.Object),Uint:s(a.Int)},i=typeof Buffer<"u";function r(H,V){if(typeof V>"u")H.write(n.Undefined);else if(typeof V=="string"){const W=j.$_d.fromString(V);H.write(n.String),b(H,W.byteLength),H.write(W)}else if(i&&Buffer.isBuffer(V)){const W=j.$_d.wrap(V);H.write(n.Buffer),b(H,W.byteLength),H.write(W)}else if(V instanceof j.$_d)H.write(n.VSBuffer),b(H,V.byteLength),H.write(V);else if(Array.isArray(V)){H.write(n.Array),b(H,V.length);for(const W of V)r(H,W)}else if(typeof V=="number"&&(V|0)===V)H.write(n.Uint),b(H,V);else{const W=j.$_d.fromString(JSON.stringify(V));H.write(n.Object),b(H,W.byteLength),H.write(W)}}e.$mh=r;function o(H){switch(H.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return H.read(l(H)).toString();case a.Buffer:return H.read(l(H)).buffer;case a.VSBuffer:return H.read(l(H));case a.Array:{const W=l(H),ee=[];for(let ne=0;ne<W;ne++)ee.push(o(H));return ee}case a.Object:return JSON.parse(H.read(l(H)).toString());case a.Int:return l(H)}}e.$nh=o;class v{constructor(V,W,ee=null,ne=1e3){this.h=V,this.j=W,this.k=ee,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(V,W){this.b.set(V,W),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const W=this.o([V.type]);this.k?.logOutgoing(W,0,1,w(V.type));return}case 201:case 202:case 204:case 203:{const W=this.o([V.type,V.id],V.data);this.k?.logOutgoing(W,V.id,1,w(V.type),V.data);return}}}o(V,W=void 0){const ee=new t;return r(ee,V),r(ee,W),this.p(ee.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const W=new S(V),ee=o(W),ne=o(W),re=ee[0];switch(re){case 100:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}: ${ee[2]}.${ee[3]}`,ne),this.s({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}: ${ee[2]}.${ee[3]}`,ne),this.t({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}`),this.u({type:re,id:ee[1]});case 103:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}`),this.u({type:re,id:ee[1]})}}s(V){const W=this.b.get(V.channelName);if(!W){this.v(V);return}const ee=new A.$Vd;let ne;try{ne=W.call(this.j,V.name,V.arg,ee.token)}catch(B){ne=Promise.reject(B)}const re=V.id;ne.then(B=>{this.m({id:re,data:B,type:201})},B=>{B instanceof Error?this.m({id:re,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:re,data:B,type:203})}).finally(()=>{Y.dispose(),this.d.delete(V.id)});const Y=(0,d.$Oc)(()=>ee.cancel());this.d.set(V.id,Y)}t(V){const W=this.b.get(V.channelName);if(!W){this.v(V);return}const ee=V.id,re=W.listen(this.j,V.name,V.arg)(Y=>this.m({id:ee,data:Y,type:204}));this.d.set(V.id,re)}u(V){const W=this.d.get(V.id);W&&(W.dispose(),this.d.delete(V.id))}v(V){let W=this.g.get(V.channelName);W||(W=[],this.g.set(V.channelName,W));const ee=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:V,timeoutTimer:ee})}w(V){const W=this.g.get(V);if(W){for(const ee of W)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Lc)(this.d.values()),this.d.clear()}}e.$oh=v;var y;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class f{constructor(V,W=null){this.l=V,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=W}getChannel(V){const W=this;return{call(ee,ne,re){return W.a?Promise.reject(new D.$3):W.m(V,ee,ne,re)},listen(ee,ne){return W.a?C.Event.None:W.o(V,ee,ne)}}}m(V,W,ee,ne=A.CancellationToken.None){const re=this.g++,B={id:re,type:100,channelName:V,name:W,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new D.$3);let k;return new Promise((U,M)=>{if(ne.isCancellationRequested)return M(new D.$3);const J=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(re),U(he.data);break;case 202:{this.f.delete(re);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,M($e);break}case 203:this.f.delete(re),M(he.data);break}};this.f.set(re,ue),this.p(B)};let X=null;this.b===h.Idle?J():(X=(0,N.$Fg)(ue=>this.u()),X.then(()=>{X=null,J()}));const se=()=>{X?(X.cancel(),X=null):this.p({id:re,type:101}),M(new D.$3)},le=ne.onCancellationRequested(se);k=(0,d.$Nc)((0,d.$Oc)(se),le),this.d.add(k)}).finally(()=>{k.dispose(),this.d.delete(k)})}o(V,W,ee){const ne=this.g++,Y={id:ne,type:102,channelName:V,name:W,arg:ee};let B=null;const k=new C.$Ld({onWillAddFirstListener:()=>{B=(0,N.$Fg)(U=>this.u()),B.then(()=>{B=null,this.d.add(k),this.p(Y)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(k),this.p({id:ne,type:103}))}}),R=U=>k.fire(U.data);return this.f.set(ne,R),k.event}p(V){switch(V.type){case 100:case 102:{const W=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(W,V.id,0,`${g(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const W=this.q([V.type,V.id]);this.j?.logOutgoing(W,V.id,0,g(V.type));return}}}q(V,W=void 0){const ee=new t;return r(ee,V),r(ee,W),this.r(ee.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const W=new S(V),ee=o(W),ne=o(W),re=ee[0];switch(re){case 200:return this.j?.logIncoming(V.byteLength,0,0,w(re)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ee[1],0,w(re),ne),this.t({type:ee[0],id:ee[1],data:ne})}}t(V){if(V.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Lc)(this.d.values()),this.d.clear()}}e.$ph=f,ye([I.$eh],f.prototype,"onDidInitializePromise",null);class m{get connections(){const V=[];return this.f.forEach(W=>V.push(W)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new C.$Ld,this.onDidAddConnection=this.g.event,this.h=new C.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new d.$Pc,this.j.add(V(({protocol:W,onDidClientDisconnect:ee})=>{const ne=C.Event.once(W.onMessage);this.j.add(ne(re=>{const Y=new S(re),B=o(Y),k=new v(W,B),R=new f(W);this.a.forEach((M,J)=>k.registerChannel(J,M));const U={channelServer:k,channelClient:R,ctx:B};this.f.add(U),this.g.fire(U),this.j.add(ee(()=>{k.dispose(),R.dispose(),this.f.delete(U),this.h.fire(U)}))}))}))}getChannel(V,W){const ee=this;return{call(ne,re,Y){let B;if((0,$.$Kf)(W)){const R=(0,O.$2b)(ee.connections.filter(W));B=R?Promise.resolve(R):C.Event.toPromise(C.Event.filter(ee.onDidAddConnection,W))}else B=W.routeCall(ee,ne,re);const k=B.then(R=>R.channelClient.getChannel(V));return F(k).call(ne,re,Y)},listen(ne,re){if((0,$.$Kf)(W))return ee.k(V,W,ne,re);const Y=W.routeEvent(ee,ne,re).then(B=>B.channelClient.getChannel(V));return F(Y).listen(ne,re)}}}k(V,W,ee,ne){const re=this;let Y;const B=new C.$Ld({onWillAddFirstListener:()=>{Y=new d.$Pc;const k=new C.$Rd,R=new Map,U=J=>{const se=J.channelClient.getChannel(V).listen(ee,ne),le=k.add(se);R.set(J,le)},M=J=>{const X=R.get(J);X&&(X.dispose(),R.delete(J))};re.connections.filter(W).forEach(U),C.Event.filter(re.onDidAddConnection,W)(U,void 0,Y),re.onDidRemoveConnection(M,void 0,Y),k.event(B.fire,B,Y),Y.add(k)},onDidRemoveLastListener:()=>{Y?.dispose(),Y=void 0}});return B.event}registerChannel(V,W){this.a.set(V,W);for(const ee of this.f)ee.channelServer.registerChannel(V,W)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$qh=m;class L{constructor(V,W,ee=null){const ne=new t;r(ne,W),V.send(ne.buffer),this.a=new f(V,ee),this.d=new v(V,W,ee)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,W){this.d.registerChannel(V,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$rh=L;function F(H){return{call(V,W,ee){return H.then(ne=>ne.call(V,W,ee))},listen(V,W){const ee=new C.$Ud;return H.then(ne=>ee.input=ne.listen(V,W)),ee.event}}}e.$sh=F;function T(H){let V=!1;return{call(W,ee,ne){return V?H.call(W,ee,ne):(0,N.$Sg)(0).then(()=>V=!0).then(()=>H.call(W,ee,ne))},listen(W,ee){if(V)return H.listen(W,ee);const ne=new C.$Ud;return(0,N.$Sg)(0).then(()=>V=!0).then(()=>ne.input=H.listen(W,ee)),ne.event}}}e.$th=T;class z{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const W of V.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await C.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$uh=z;var q;(function(H){function V(re,Y,B){const k=re,R=B&&B.disableMarshalling,U=new Map;for(const M in k)ee(M)&&U.set(M,C.Event.buffer(k[M],!0,void 0,Y));return new class{listen(M,J,X){const se=U.get(J);if(se)return se;if(ne(J)){const le=k[J];if(typeof le=="function")return le.call(k,X)}throw new D.$_(`Event not found: ${J}`)}call(M,J,X){const se=k[J];if(typeof se=="function"){if(!R&&Array.isArray(X))for(let ue=0;ue<X.length;ue++)X[ue]=(0,P.$jh)(X[ue]);let le=se.apply(k,X);return le instanceof Promise||(le=Promise.resolve(le)),le}throw new D.$_(`Method not found: ${J}`)}}}H.fromService=V;function W(re,Y){const B=Y&&Y.disableMarshalling;return new Proxy({},{get(k,R){if(typeof R=="string")return Y?.properties?.has(R)?Y.properties.get(R):ne(R)?function(U){return re.listen(R,U)}:ee(R)?re.listen(R):async function(...U){let M;Y&&!(0,$.$Ff)(Y.context)?M=[Y.context,...U]:M=U;const J=await re.call(R,M);return B?J:(0,P.$jh)(J)};throw new D.$_(`Property not found: ${String(R)}`)}})}H.toService=W;function ee(re){return re[0]==="o"&&re[1]==="n"&&E.$Ye(re.charCodeAt(2))}function ne(re){return/^onDynamic/.test(re)&&E.$Ye(re.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const _=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const V=H.toString();if(V!=="[object Object]")return V}return H}function Z(H){return Array.isArray(H)?H.map(Q):Q(H)}function G(H,V,W,ee,ne,re,Y){Y=Z(Y);const B=_[ne],k=B[ee%B.length];let R=[`%c[${H}]%c[${String(V).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(re)?(R=R.concat(Y),R.push(")")):R.push(Y),console.log.apply(console,R)}class K{constructor(V,W){this.d=V,this.f=W,this.a=0,this.b=0}logOutgoing(V,W,ee,ne,re){this.b+=V,G(this.d,this.b,V,W,ee,ne,re)}logIncoming(V,W,ee,ne,re){this.a+=V,G(this.f,this.a,V,W,ee,ne,re)}}e.$vh=K}),define(oe[65],ae([0,1,15,3,2,42]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=e.$xh=e.ProtocolConstants=e.$wh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var D;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let r=0;function o(y,f){if(!i.has(y)){const m=String(++r);i.set(y,m)}return i.get(y)}function v(y,f,m,L){if(!n.enableDiagnostics)return;const F=o(y,f);if(L instanceof O.$_d||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const T=O.$_d.alloc(L.byteLength);T.set(L),n.records.push({timestamp:Date.now(),id:F,label:f,type:m,buff:T})}else n.records.push({timestamp:Date.now(),id:F,label:f,type:m,data:L})}n.traceSocketEvent=v})(D||(e.SocketDiagnostics=D={}));var C;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C||(e.SocketCloseEventType=C={}));let d=null;function P(){return d||(d=O.$_d.alloc(0)),d}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,r){if(i===0)return P();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const f=this.a[0];return r&&(this.a.shift(),this.b-=i),f}if(this.a[0].byteLength>i){const f=this.a[0].slice(0,i);return r&&(this.a[0]=this.a[0].slice(i),this.b-=i),f}const o=O.$_d.alloc(i);let v=0,y=0;for(;i>0;){const f=this.a[y];if(f.byteLength>i){const m=f.slice(0,i);o.set(m,v),v+=i,r&&(this.a[y]=f.slice(i),this.b-=i),i-=i}else o.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):y++,i-=f.byteLength}return o}}e.$wh=E;var $;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})($||($={}));function c(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class p{constructor(i,r,o,v){this.type=i,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends j.$Qc{constructor(i){super(),this.f=this.B(new N.$Ld),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(o,v,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$_d.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(r,i.data)}g(i,r){const o=this.f===0;return this.d.push(i,r),this.f+=i.byteLength+r.byteLength,o}h(){const i=O.$_d.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,r){this.g(i,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class l extends j.$Qc{constructor(i){super(),this.f=new N.$Ld,this.onMessage=this.f.event,this.g=new N.$Ld,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new h(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new p(1,0,0,i))}}e.$xh=l;class u extends A.$rh{static fromSocket(i,r){return new u(new l(i),r)}get onDidDispose(){return this.b.onDidDispose}constructor(i,r,o=null){super(i,r,o),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$yh=u;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Ld({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$zh=b;class S{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,r=this.a;for(;r;)r=r.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let r=0,o=this.a;for(;o;)i[r++]=o.data,o=o.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const r=new S(i);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const i=Date.now();for(let r=0;r<a.a;r++)this.c[r]=i-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)i-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??a.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new j.$Pc,this.o=i.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new p(5,0,0,P());this.p.write(i),this.p.flush()}sendPause(){const i=new p(7,0,0,P());this.p.write(i)}sendResume(){const i=new p(8,0,0,P());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,r){this.a=!0,this.r.dispose(),this.r=new j.$Pc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new p(3,0,this.h,P());this.p.write(i);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const r=this.b.peek();if(r&&r.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,P())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const r=++this.c;this.h=this.g;const o=new p(1,r,this.h,i);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(i){const r=new p(2,0,0,i);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),r=Date.now()-i.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new p(3,0,this.h,P());this.p.write(i)}D(){this.h=this.g;const i=new p(9,0,this.h,P());this.p.write(i)}}e.$Ah=s}),define(oe[93],ae([0,1,64,5,15,26,142,8,3,2,30,145,90,42]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0;class g extends c.$oh{constructor(h){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",l=>j.$_d.wrap(Buffer.from(l,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Tp=g;class p{constructor(h,l){this.i=h,this.j=l,this.c=new Set,this.g=new Map,this.h=new C.$Ld,this.onDidProcessExit=this.h.event;const u=l&&l.timeout?l.timeout:6e4;this.b=new N.$Og(u),this.d=null,this.f=null}getChannel(h){const l=this;return{call(u,b,S){return l.k(h,u,b,S)},listen(u,b){return l.l(h,u,b)}}}k(h,l,u,b=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(D.$4());this.b.cancel();const S=this.n(h),t=(0,N.$Fg)(n=>S.call(l,u,n)),a=b.onCancellationRequested(()=>t.cancel()),s=(0,d.$Oc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{a.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,l,u){if(!this.b)return C.Event.None;this.b.cancel();let b;const S=new C.$Ld({onWillAddFirstListener:()=>{b=this.n(h).listen(l,u)(S.fire,S),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,P.$Xm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,$.$vl)(l.env),this.d=(0,O.fork)(this.i,h,l);const u=new C.$Ld;C.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,I.$Pp)(i)){(0,I.log)(i,`IPC Library: ${this.j.serverName}`);return}u.fire(j.$_d.wrap(Buffer.from(i,"base64")))});const S=this.j.useQueue?(0,E.$xl)(this.d):this.d,t=i=>this.d&&this.d.connected&&S.send(i.buffer.toString("base64")),a=u.event,s={send:t,onMessage:a};this.f=new c.$ph(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,d.$Lc)(o)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(h){let l=this.g.get(h);return l||(l=this.m.getChannel(h),this.g.set(h,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Up=p}),define(oe[147],ae([0,1,135,15,42,3,12,18]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iT=e.$hT=void 0;class C{constructor($){this.a=$,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",c=>N.$_d.wrap(c.data)),$.start()}send($){this.a.postMessage($.buffer)}disconnect(){this.a.close()}}class d extends j.$qh{static b($){(0,I.$Gf)((0,O.$gT)(process),"Electron Utility Process");const c=new A.$Ld;return process.parentPort.on("message",g=>{if($?.handledClientConnection(g))return;const p=(0,D.$Mb)(g.ports);p&&c.fire(p)}),A.Event.map(c.event,g=>({protocol:new C(g),onDidClientDisconnect:A.Event.fromNodeEventEmitter(g,"close")}))}constructor($){super(d.b($))}}e.$hT=d;function P(E,$,c){const g=p=>{p.data===$&&(E.removeListener("message",g),c())};E.on("message",g)}e.$iT=P}),define(oe[66],ae([0,1,5,3,2,63,12]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.StorageState=e.$So=e.StorageHint=void 0;var D;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function C($){const c=$;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$So=C;var d;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(d||(e.StorageState=d={}));class P extends j.$Qc{static{this.a=100}constructor(c,g=Object.create(null)){super(),this.r=c,this.s=g,this.b=this.B(new N.$Od),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new O.$Pg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach((g,p)=>this.w(p,g)),c.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(c,g){if(this.c===d.Closed)return;let p=!1;(0,I.$Ff)(g)?p=this.f.delete(c):this.f.get(c)!==g&&(this.f.set(c,g),p=!0),p&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,g){const p=this.f.get(c);return(0,I.$Ff)(p)?g:p}getBoolean(c,g){const p=this.get(c);return(0,I.$Ff)(p)?g:p==="true"}getNumber(c,g){const p=this.get(c);return(0,I.$Ff)(p)?g:parseInt(p,10)}getObject(c,g){const p=this.get(c);return(0,I.$Ff)(p)?g:(0,A.$ih)(p)}async set(c,g,p=!1){if(this.c===d.Closed)return;if((0,I.$Ff)(g))return this.delete(c,p);const w=(0,I.$yf)(g)||Array.isArray(g)?(0,A.$hh)(g):String(g);if(this.f.get(c)!==w)return this.f.set(c,w),this.j.set(c,w),this.h.delete(c),this.b.fire({key:c,external:p}),this.D()}async delete(c,g=!1){if(!(this.c===d.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:g}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===D.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===D.STORAGE_IN_MEMORY}}e.$To=P;class E{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach((g,p)=>this.a.set(p,g)),c.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Uo=E}),define(oe[148],ae([13,10]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[149],ae([13,10]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[150],ae([13,10]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[151],ae([13,10]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[152],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[153],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[154],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[155],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[156],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[157],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[158],ae([13,10]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[159],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[160],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[161],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[162],ae([13,10]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[163],ae([13,10]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[164],ae([13,10]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[165],ae([13,10]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[166],ae([13,10]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[167],ae([13,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[168],ae([13,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[169],ae([13,10]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[170],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[171],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[172],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[173],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[174],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[175],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[176],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[177],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[178],ae([13,10]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[179],ae([0,1,8,151]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.TokenType=void 0;var j;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(j||(e.TokenType=j={}));function A(...d){switch(d.length){case 1:return(0,N.localize)(0,null,d[0]);case 2:return(0,N.localize)(1,null,d[0],d[1]);case 3:return(0,N.localize)(2,null,d[0],d[1],d[2]);default:return}}const I=(0,N.localize)(3,null),D=(0,N.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,O.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,$=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:$};this.g.push({offset:E,lexeme:$,additionalInfo:P}),this.f.push(c)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),$=C.b.get(E);$?this.k($):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,$=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(D);return}const g=this.c.charCodeAt(P);if(E)E=!1;else if(g===47&&!$){P++;break}else g===91?$=!0:g===92?E=!0:g===93&&($=!1);P++}for(;P<this.c.length&&C.a.has(this.c.charCodeAt(P));)P++;this.e=P;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Hi=C}),define(oe[180],ae([0,1,62,83,23,16,37,21,9]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,A.$kc)(j.$ag.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,A.$hc)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,D.$tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,D.$tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,O.$9l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$hc)(this.userDataPath,"logs",c)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.$tg)(C.URI.file((0,A.$hc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.$tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.$tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.$tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=I.env.VSCODE_PORTABLE;return c?C.URI.file((0,A.$hc)(c,"argv.json")):(0,D.$tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,A.$hc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,A.$ic)(c):(0,A.$fc)((0,A.$hc)(j.$ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?C.URI.file((0,A.$ic)(c)):C.URI.file((0,A.$hc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,A.$ic)(c);const g=I.env.VSCODE_EXTENSIONS;if(g)return g;const p=I.env.VSCODE_PORTABLE;return p?(0,A.$hc)(p,"extensions"):(0,D.$tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(g=>/^[^:/?#]+?:\/\//.test(g)?C.URI.parse(g):C.URI.file((0,A.$fc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file((0,A.$fc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$0l.test(c))}get extensionLogLevel(){const c=[];for(const g of this.args.log||[]){const p=e.$0l.exec(g);p&&p[1]&&p[2]&&c.push([p[1],p[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,D.$tg)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=I.env.VSCODE_PORTABLE;return c?C.URI.file((0,A.$hc)(c,"policy.json")):(0,D.$tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,g,p){this.a=c,this.b=g,this.c=p,this.editSessionId=this.args.editSessionId}}e.$$l=d,ye([N.$eh],d.prototype,"appRoot",null),ye([N.$eh],d.prototype,"userHome",null),ye([N.$eh],d.prototype,"userDataPath",null),ye([N.$eh],d.prototype,"appSettingsHome",null),ye([N.$eh],d.prototype,"tmpDir",null),ye([N.$eh],d.prototype,"cacheHome",null),ye([N.$eh],d.prototype,"stateResource",null),ye([N.$eh],d.prototype,"userRoamingDataHome",null),ye([N.$eh],d.prototype,"userDataSyncHome",null),ye([N.$eh],d.prototype,"sync",null),ye([N.$eh],d.prototype,"machineSettingsResource",null),ye([N.$eh],d.prototype,"workspaceStorageHome",null),ye([N.$eh],d.prototype,"localHistoryHome",null),ye([N.$eh],d.prototype,"keyboardLayoutResource",null),ye([N.$eh],d.prototype,"argvResource",null),ye([N.$eh],d.prototype,"isExtensionDevelopment",null),ye([N.$eh],d.prototype,"untitledWorkspacesHome",null),ye([N.$eh],d.prototype,"builtinExtensionsPath",null),ye([N.$eh],d.prototype,"extensionsPath",null),ye([N.$eh],d.prototype,"extensionDevelopmentLocationURI",null),ye([N.$eh],d.prototype,"extensionDevelopmentKind",null),ye([N.$eh],d.prototype,"extensionTestsLocationURI",null),ye([N.$eh],d.prototype,"debugExtensionHost",null),ye([N.$eh],d.prototype,"logLevel",null),ye([N.$eh],d.prototype,"extensionLogLevel",null),ye([N.$eh],d.prototype,"serviceMachineIdResource",null),ye([N.$eh],d.prototype,"disableTelemetry",null),ye([N.$eh],d.prototype,"disableWorkspaceTrust",null),ye([N.$eh],d.prototype,"useInMemorySecretStorage",null),ye([N.$eh],d.prototype,"policyFile",null);function P($,c){return E($["inspect-extensions"],$["inspect-brk-extensions"],5870,c,$.debugId,$.extensionEnvironment)}e.$_l=P;function E($,c,g,p,w,h){const u=Number(c||$)||(p?null:g),b=u?!!c:!1;let S;if(h)try{S=JSON.parse(h)}catch{}return{port:u,break:b,debugId:w,env:S}}e.$am=E}),function(){"use strict";function te(e,O,N){function j(I,D){const C=A(I,D),d=[C];return e.isAbsolute(C)||d.unshift(N),e.resolve(...d)}function A(I,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,D);const P=I["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(E,"AppData","Roaming")}break;case"darwin":d=e.join(O.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,D)}return{getUserDataPath:j}}if(typeof define=="function")define(oe[181],ae([270,36,37]),function(e,O,N){return te(e,O,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=te(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[182],ae([0,1,36,180,181]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=void 0;class A extends N.$$l{constructor(d,P){super(d,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,j.getUserDataPath)(d,P.nameShort)},P)}}e.$bm=A;function I(C,d){return(0,N.$am)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,d,C.extensionEnvironment)}e.$cm=I;function D(C,d){return(0,N.$am)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,d,C.extensionEnvironment)}e.$dm=D}),define(oe[183],ae([0,1,12,154]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;function j(I,D,C,d){try{A(I,D,C,d)}catch(P){I.error(P?.message??P)}return D}e.$pp=j;function A(I,D,C,d){const P=(E,$,c)=>{const g=E[$];if((0,O.$wf)(g)){const p=g,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const h=p.substr(1,w-2);let l=C[h];l===void 0&&d&&(l=d[h]);const u=typeof l=="string"?l:l?.message,b=d?.[h],S=typeof b=="string"?b:b?.message;if(!u){S||I.warn(`[${D.name}]: ${(0,N.localize)(0,null,h)}`);return}if(c&&($==="title"||$==="category")&&S&&S!==u){const t={value:u,original:S};E[$]=t}else E[$]=u}}else if((0,O.$yf)(g))for(const p in g)g.hasOwnProperty(p)&&(p==="commands"?P(g,p,!0):P(g,p,c));else if(Array.isArray(g))for(let p=0;p<g.length;p++)P(g,p,c)};for(const E in D)D.hasOwnProperty(E)&&P(D,E)}}),define(oe[184],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=e.$L8b=void 0;class O{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$L8b=O;class N{constructor(A){this.a=A}listen(A,I){throw new Error(`Event not found: ${I}`)}call(A,I,D){switch(I){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(D[0])}throw new Error(`Call not found: ${I}`)}}e.$M8b=N}),define(oe[67],ae([0,1,21,89,158,53]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(h){return h=h.trim(),h==="*"||I.test(h)}e.$Do=C;function d(h){if(!C(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=h.match(I);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$Eo=d;function P(h){if(!h)return null;const l=h.majorBase,u=h.majorMustEqual,b=h.minorBase;let S=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(l===0||(S=!1),a=!1);let s=0;if(h.preRelease){const n=D.exec(h.preRelease);if(n){const[,i,r,o]=n;s=Date.UTC(Number(i),Number(r)-1,Number(o))}}return{majorBase:l,majorMustEqual:u,minorBase:b,minorMustEqual:S,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:s}}e.$Fo=P;function E(h,l,u){let b;typeof h=="string"?b=P(d(h)):b=h;let S;l instanceof Date?S=l.getTime():typeof l=="string"&&(S=new Date(l).getTime());let t;if(typeof u=="string"?t=P(d(u)):t=u,!b||!t)return!1;const a=b.majorBase,s=b.minorBase,n=b.patchBase;let i=t.majorBase,r=t.minorBase,o=t.patchBase;const v=t.notBefore;let y=t.majorMustEqual,f=t.minorMustEqual,m=t.patchMustEqual;return t.isMinimum?a>i?!0:a<i?!1:s>r?!0:s<r||S&&S<v?!1:n>=o:(a===1&&i===0&&(!y||!f||!m)&&(i=1,r=0,o=0,y=!0,f=!1,m=!1),a<i?!1:a>i?!y:s<r?!1:s>r?!f:n<o?!1:n>o?!m:!(S&&S<v))}e.$Go=E;function $(h,l,u,b,S){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([N.default.Error,j.localize(0,null)]),t;if(typeof b.name!="string")return t.push([N.default.Error,j.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([N.default.Error,j.localize(2,null,"version")]),t;if(!b.engines)return t.push([N.default.Error,j.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([N.default.Error,j.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!w(b.extensionDependencies))return t.push([N.default.Error,j.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!w(b.activationEvents))return t.push([N.default.Error,j.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([N.default.Error,j.localize(7,null,"activationEvents","main","browser")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([N.default.Warning,j.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([N.default.Error,j.localize(9,null,"main")]),t;{const n=(0,O.$tg)(u,b.main);(0,O.$ng)(n,u)||t.push([N.default.Warning,j.localize(10,null,n.path,u.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([N.default.Error,j.localize(11,null,"browser")]),t;{const n=(0,O.$tg)(u,b.browser);(0,O.$ng)(n,u)||t.push([N.default.Warning,j.localize(12,null,n.path,u.path)])}}if(!A.valid(b.version))return t.push([N.default.Error,j.localize(13,null)]),t;const a=[];if(!c(h,l,b,S,a))for(const n of a)t.push([N.default.Error,n]);return t}e.$Ho=$;function c(h,l,u,b,S){return b||typeof u.main>"u"&&typeof u.browser>"u"?!0:p(h,l,u.engines.vscode,S)}e.$Io=c;function g(h,l,u){return h==="*"||p(l,u,h)}e.$Jo=g;function p(h,l,u,b=[]){const S=P(d(u));if(!S)return b.push(j.localize(14,null,u)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return b.push(j.localize(15,null,u)),!1}else if(!S.majorMustEqual)return b.push(j.localize(16,null,u)),!1;return E(h,l,S)?!0:(b.push(j.localize(17,null,h,u)),!1)}function w(h){if(!Array.isArray(h))return!1;for(let l=0,u=h.length;l<u;l++)if(typeof h[l]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;async function j(A,I,D){let C=D&&D.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const P=(await I.readFile(A.serviceMachineIdResource)).value.toString();C=(0,N.$bg)(P)?P:null}catch{C=null}if(!C){C=(0,N.$cg)();try{await I.writeFile(A.serviceMachineIdResource,O.$_d.fromString(C))}catch{}}return D?.store("storage.serviceMachineId",C,-1,1),C}e.$4o=j}),define(oe[68],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class O{constructor(j,A=[],I=!1){this.ctor=j,this.staticArguments=A,this.supportsDelayedInstantiation=I}}e.$Jh=O}),define(oe[185],ae([0,1,68]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.InstantiationType=void 0;const N=[];var j;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function A(D,C,d){C instanceof O.$Jh||(C=new O.$Jh(C,[],!!d)),N.push([D,C])}e.$or=A;function I(){return N}e.$pr=I}),define(oe[186],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class O{constructor(A,I){this.key=A,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$6p=O;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const I of this.a.values())I.outgoing.size===0&&A.push(I);return A}insertEdge(A,I){const D=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(I);D.outgoing.set(C.key,C),C.incoming.set(D.key,D)}removeNode(A){const I=this.b(A);this.a.delete(I);for(const D of this.a.values())D.outgoing.delete(I),D.incoming.delete(I)}lookupOrInsertNode(A){const I=this.b(A);let D=this.a.get(I);return D||(D=new O(I,A),this.a.set(I,D)),D}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[I,D]of this.a)A.push(`${I}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,I]of this.a){const D=new Set([A]),C=this.c(I,D);if(C)return C}}c(A,I){for(const[D,C]of A.outgoing){if(I.has(D))return[...I,D].join(" -> ");I.add(D);const d=this.c(C,I);if(d)return d;I.delete(D)}}}e.$7p=N}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=e._util=void 0;var O;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(C){return C[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(O||(e._util=O={})),e.$Lh=j("instantiationService");function N(I,D,C){D[O.DI_TARGET]===D?D[O.DI_DEPENDENCIES].push({id:I,index:C}):(D[O.DI_DEPENDENCIES]=[{id:I,index:C}],D[O.DI_TARGET]=D)}function j(I){if(O.serviceIds.has(I))return O.serviceIds.get(I);const D=function(C,d,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(D,C,P)};return D.toString=()=>I,O.serviceIds.set(I,D),D}e.$Mh=j;function A(I){return I}e.$Nh=A}),define(oe[187],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=void 0,e.$i8b=(0,O.$Mh)("checksumService")}),define(oe[19],ae([0,1,12,9,4]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.ConfigurationTarget=e.$ii=e.$hi=e.$gi=void 0,e.$gi=(0,j.$Mh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}e.$hi=A;function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}e.$ii=I;var D;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(D||(e.ConfigurationTarget=D={}));function C(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ji=C;function d(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$ki=d;function P(h,l){const u=Object.create(null);for(const b in h)E(u,b,h[b],l);return u}e.$li=P;function E(h,l,u,b){const S=l.split("."),t=S.pop();let a=h;for(let s=0;s<S.length;s++){const n=S[s];let i=a[n];switch(typeof i){case"undefined":i=a[n]=Object.create(null);break;case"object":break;default:b(`Ignoring ${l} as ${S.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[t]=u}catch{b(`Ignoring ${l} as ${S.join(".")} is ${JSON.stringify(a)}`)}else b(`Ignoring ${l} as ${S.join(".")} is ${JSON.stringify(a)}`)}e.$mi=E;function $(h,l){const u=l.split(".");c(h,u)}e.$ni=$;function c(h,l){const u=l.shift();if(l.length===0){delete h[u];return}if(Object.keys(h).indexOf(u)!==-1){const b=h[u];typeof b=="object"&&!Array.isArray(b)&&(c(b,l),Object.keys(b).length===0&&delete h[u])}}function g(h,l,u){function b(a,s){let n=a;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const S=l.split("."),t=b(h,S);return typeof t>"u"?u:t}e.$oi=g;function p(h,l,u){Object.keys(l).forEach(b=>{b!=="__proto__"&&(b in h?O.$yf(h[b])&&O.$yf(l[b])?p(h[b],l[b],u):u&&(h[b]=l[b]):h[b]=l[b])})}e.$pi=p;function w(h){return h.replace(/[\[\]]/g,"")}e.$qi=w}),define(oe[94],ae([0,1,6,27,179,4,150,8]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.ContextKeyExprType=e.$Ii=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",O.$j),C.set("isLinux",O.$k),C.set("isWindows",O.$i),C.set("isWeb",O.$o),C.set("isMacNative",O.$j&&!O.$o),C.set("isEdge",O.$G),C.set("isFirefox",O.$E),C.set("isChrome",O.$D),C.set("isSafari",O.$F);function d(B,k){if(C.get(B)!==void 0)throw(0,D.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set(B,k)}e.$Ii=d;const P=Object.prototype.hasOwnProperty;var E;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const $={regexParsingWithErrorRecovery:!0},c=(0,I.localize)(0,null),g=(0,I.localize)(1,null),p=(0,I.localize)(2,null),w=(0,I.localize)(3,null),h=(0,I.localize)(4,null),l=(0,I.localize)(5,null),u=(0,I.localize)(6,null),b=(0,I.localize)(7,null);class S{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(k=$){this.k=k,this.d=new j.$Hi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(k){if(k===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(k).scan(),this.g=0,this.h=[];try{const R=this.l();if(!this.E()){const U=this.D(),M=U.type===17?l:void 0;throw this.h.push({message:h,offset:U.offset,lexeme:j.$Hi.getLexeme(U),additionalInfo:M}),S.c}return R}catch(R){if(R!==S.c)throw R;return}}l(){return this.m()}m(){const k=[this.o()];for(;this.y(16);){const R=this.o();k.push(R)}return k.length===1?k[0]:t.or(...k)}o(){const k=[this.s()];for(;this.y(15);){const R=this.s();k.push(R)}return k.length===1?k[0]:t.and(...k)}s(){if(this.y(2)){const k=this.D();switch(k.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const R=this.l();return this.A(1,w),R?.negate()}case 17:return this.z(),L.create(k.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",k)}}return this.t()}t(){const k=this.D();switch(k.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const R=this.l();return this.A(1,w),R}case 17:{const R=k.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const J=M.lexeme,X=J.lastIndexOf("/"),se=X===J.length-1?void 0:this.w(J.substring(X+1));let le;try{le=new RegExp(J.substring(1,X),se)}catch{throw this.B("REGEX",M)}return Q.create(R,le)}switch(M.type){case 10:case 19:{const J=[M.lexeme];this.z();let X=this.D(),se=0;for(let de=0;de<M.lexeme.length;de++)M.lexeme.charCodeAt(de)===40?se++:M.lexeme.charCodeAt(de)===41&&se--;for(;!this.E()&&X.type!==15&&X.type!==16;){switch(X.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let de=0;de<X.lexeme.length;de++)X.lexeme.charCodeAt(de)===40?se++:M.lexeme.charCodeAt(de)===41&&se--}if(se<0)break;J.push(j.$Hi.getLexeme(X)),this.z(),X=this.D()}const le=J.join(""),ue=le.lastIndexOf("/"),he=ue===le.length-1?void 0:this.w(le.substring(ue+1));let $e;try{$e=new RegExp(le.substring(1,ue),he)}catch{throw this.B("REGEX",M)}return t.regex(R,$e)}case 18:{const J=M.lexeme;this.z();let X=null;if(!(0,N.$ze)(J)){const se=J.indexOf("/"),le=J.lastIndexOf("/");if(se!==le&&se>=0){const ue=J.slice(se+1,le),he=J[le+1]==="i"?"i":"";try{X=new RegExp(ue,he)}catch{throw this.B("REGEX",M)}}}if(X===null)throw this.B("REGEX",M);return Q.create(R,X)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const M=this.u();return t.notIn(R,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return t.equals(R,M);switch(M){case"true":return t.has(R);case"false":return t.not(R);default:return t.equals(R,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return t.notEquals(R,M);switch(M){case"true":return t.not(R);case"false":return t.has(R);default:return t.notEquals(R,M)}}case 5:return this.z(),q.create(R,this.u());case 6:return this.z(),_.create(R,this.u());case 7:return this.z(),T.create(R,this.u());case 8:return this.z(),z.create(R,this.u());case 13:return this.z(),t.in(R,this.u());default:return t.has(R)}}case 20:throw this.h.push({message:u,offset:k.offset,lexeme:"",additionalInfo:b}),S.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const k=this.D();switch(k.type){case 17:case 18:return this.z(),k.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(k){return k.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(k){return this.C(k)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(k,R){if(this.C(k))return this.z();throw this.B(R,this.D())}B(k,R,U){const M=(0,I.localize)(8,null,k,j.$Hi.getLexeme(R)),J=R.offset,X=j.$Hi.getLexeme(R);return this.h.push({message:M,offset:J,lexeme:X,additionalInfo:U}),S.c}C(k){return this.D().type===k}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ji=S;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(k){return o.create(k)}static equals(k,R){return v.create(k,R)}static notEquals(k,R){return m.create(k,R)}static regex(k,R){return Q.create(k,R)}static in(k,R){return y.create(k,R)}static notIn(k,R){return f.create(k,R)}static not(k){return L.create(k)}static and(...k){return K.create(k,null,!0)}static or(...k){return H.create(k,null,!0)}static greater(k,R){return T.create(k,R)}static greaterEquals(k,R){return z.create(k,R)}static smaller(k,R){return q.create(k,R)}static smallerEquals(k,R){return _.create(k,R)}static{this.c=new S({regexParsingWithErrorRecovery:!1})}static deserialize(k){return k==null?void 0:this.c.parse(k)}}e.$Ki=t;function a(B){const k=new S({regexParsingWithErrorRecovery:!1});return B.map(R=>(k.parse(R),k.lexingErrors.length>0?k.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,I.localize)(9,null,U.additionalInfo):(0,I.localize)(10,null),offset:U.offset,length:U.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.$Li=a;function s(B,k){const R=B?B.substituteConstants():void 0,U=k?k.substituteConstants():void 0;return!R&&!U?!0:!R||!U?!1:R.equals(U)}e.$Mi=s;function n(B,k){return B.cmp(k)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return r.INSTANCE}}e.$Ni=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return i.INSTANCE}}e.$Oi=r;class o{static create(k,R=null){const U=C.get(k);return typeof U=="boolean"?U?r.INSTANCE:i.INSTANCE:new o(k,R)}constructor(k,R){this.key=k,this.c=R,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:W(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=C.get(this.key);return typeof k=="boolean"?k?r.INSTANCE:i.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Pi=o;class v{static create(k,R,U=null){if(typeof R=="boolean")return R?o.create(k,U):L.create(k,U);const M=C.get(k);return typeof M=="boolean"?R===(M?"true":"false")?r.INSTANCE:i.INSTANCE:new v(k,R,U)}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=C.get(this.c);if(typeof k=="boolean"){const R=k?"true":"false";return this.d===R?r.INSTANCE:i.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.$Qi=v;class y{static create(k,R){return new y(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const R=k.getValue(this.f),U=k.getValue(this.d);return Array.isArray(R)?R.includes(U):typeof U=="string"&&typeof R=="object"&&R!==null?P.call(R,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Ri=y;class f{static create(k,R){return new f(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=11,this.c=y.create(k,R)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Si=f;class m{static create(k,R,U=null){if(typeof R=="boolean")return R?L.create(k,U):o.create(k,U);const M=C.get(k);return typeof M=="boolean"?R===(M?"true":"false")?i.INSTANCE:r.INSTANCE:new m(k,R,U)}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=C.get(this.c);if(typeof k=="boolean"){const R=k?"true":"false";return this.d===R?i.INSTANCE:r.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ti=m;class L{static create(k,R=null){const U=C.get(k);return typeof U=="boolean"?U?i.INSTANCE:r.INSTANCE:new L(k,R)}constructor(k,R){this.c=k,this.d=R,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:W(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=C.get(this.c);return typeof k=="boolean"?k?i.INSTANCE:r.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$Ui=L;function F(B,k){if(typeof B=="string"){const R=parseFloat(B);isNaN(R)||(B=R)}return typeof B=="string"||typeof B=="number"?k(B):i.INSTANCE}class T{static create(k,R,U=null){return F(R,M=>new T(k,M,U))}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Vi=T;class z{static create(k,R,U=null){return F(R,M=>new z(k,M,U))}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Wi=z;class q{static create(k,R,U=null){return F(R,M=>new q(k,M,U))}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Xi=q;class _{static create(k,R,U=null){return F(R,M=>new _(k,M,U))}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Yi=_;class Q{static create(k,R){return new Q(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const R=this.f?this.f.source:"",U=k.f?k.f.source:"";return R<U?-1:R>U?1:0}equals(k){if(k.type===this.type){const R=this.f?this.f.source:"",U=k.f?k.f.source:"";return this.d===k.d&&R===U}return!1}substituteConstants(){return this}evaluate(k){const R=k.getValue(this.d);return this.f?this.f.test(R):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Zi=Q;class Z{static create(k){return new Z(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(k){return new Z(this.c.map(k))}negate(){return this.c}}e.$1i=Z;function G(B){let k=null;for(let R=0,U=B.length;R<U;R++){const M=B[R].substituteConstants();if(B[R]!==M&&k===null){k=[];for(let J=0;J<R;J++)k[J]=B[J]}k!==null&&(k[R]=M)}return k===null?B:k}class K{static create(k,R,U){return K.d(k,R,U)}constructor(k,R){this.expr=k,this.c=R,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let R=0,U=this.expr.length;R<U;R++){const M=n(this.expr[R],k.expr[R]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].equals(k.expr[R]))return!1;return!0}return!1}substituteConstants(){const k=G(this.expr);return k===this.expr?this:K.create(k,this.c,!1)}evaluate(k){for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].evaluate(k))return!1;return!0}static d(k,R,U){const M=[];let J=!1;for(const X of k)if(X){if(X.type===1){J=!0;continue}if(X.type===0)return i.INSTANCE;if(X.type===6){M.push(...X.expr);continue}M.push(X)}if(M.length===0&&J)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let X=1;X<M.length;X++)M[X-1].equals(M[X])&&(M.splice(X,1),X--);if(M.length===1)return M[0];for(;M.length>1;){const X=M[M.length-1];if(X.type!==9)break;M.pop();const se=M.pop(),le=M.length===0,ue=H.create(X.expr.map(he=>K.create([he,se],null,U)),null,le);ue&&(M.push(ue),M.sort(n))}if(M.length===1)return M[0];if(U){for(let X=0;X<M.length;X++)for(let se=X+1;se<M.length;se++)if(M[X].negate().equals(M[se]))return i.INSTANCE;if(M.length===1)return M[0]}return new K(M,R)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const R of this.expr)k.push(...R.keys());return k}map(k){return new K(this.expr.map(R=>R.map(k)),null)}negate(){if(!this.c){const k=[];for(const R of this.expr)k.push(R.negate());this.c=H.create(k,this,!0)}return this.c}}e.$2i=K;class H{static create(k,R,U){return H.d(k,R,U)}constructor(k,R){this.expr=k,this.c=R,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let R=0,U=this.expr.length;R<U;R++){const M=n(this.expr[R],k.expr[R]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].equals(k.expr[R]))return!1;return!0}return!1}substituteConstants(){const k=G(this.expr);return k===this.expr?this:H.create(k,this.c,!1)}evaluate(k){for(let R=0,U=this.expr.length;R<U;R++)if(this.expr[R].evaluate(k))return!0;return!1}static d(k,R,U){let M=[],J=!1;if(k){for(let X=0,se=k.length;X<se;X++){const le=k[X];if(le){if(le.type===0){J=!0;continue}if(le.type===1)return r.INSTANCE;if(le.type===9){M=M.concat(le.expr);continue}M.push(le)}}if(M.length===0&&J)return i.INSTANCE;M.sort(n)}if(M.length!==0){if(M.length===1)return M[0];for(let X=1;X<M.length;X++)M[X-1].equals(M[X])&&(M.splice(X,1),X--);if(M.length===1)return M[0];if(U){for(let X=0;X<M.length;X++)for(let se=X+1;se<M.length;se++)if(M[X].negate().equals(M[se]))return r.INSTANCE;if(M.length===1)return M[0]}return new H(M,R)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const R of this.expr)k.push(...R.keys());return k}map(k){return new H(this.expr.map(R=>R.map(k)),null)}negate(){if(!this.c){const k=[];for(const R of this.expr)k.push(R.negate());for(;k.length>1;){const R=k.shift(),U=k.shift(),M=[];for(const J of Y(R))for(const X of Y(U))M.push(K.create([J,X],null,!1));k.unshift(H.create(M,null,!1))}this.c=H.create(k,this,!0)}return this.c}}e.$3i=H;class V extends o{static{this.d=[]}static all(){return V.d.values()}constructor(k,R,U){super(k,null),this.f=R,typeof U=="object"?V.d.push({...U,key:k}):U!==!0&&V.d.push({key:k,description:U,type:R!=null?typeof R:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return v.create(this.key,k)}notEqualsTo(k){return m.create(this.key,k)}}e.$4i=V,e.$5i=(0,A.$Mh)("contextKeyService");function W(B,k){return B<k?-1:B>k?1:0}function ee(B,k,R,U){return B<R?-1:B>R?1:k<U?-1:k>U?1:0}function ne(B,k){if(B.type===0||k.type===1)return!0;if(B.type===9)return k.type===9?re(B.expr,k.expr):!1;if(k.type===9){for(const R of k.expr)if(ne(B,R))return!0;return!1}if(B.type===6){if(k.type===6)return re(k.expr,B.expr);for(const R of B.expr)if(ne(R,k))return!0;return!1}return B.equals(k)}e.$6i=ne;function re(B,k){let R=0,U=0;for(;R<B.length&&U<k.length;){const M=B[R].cmp(k[U]);if(M<0)return!1;M===0&&R++,U++}return R===B.length}function Y(B){return B.type===9?B.expr:[B]}}),define(oe[95],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.ID=void 0,e.ID="diagnosticsService",e.$im=(0,O.$Mh)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}e.$jm=N;class j{async getPerformanceInfo(I,D){return{}}async getSystemInfo(I,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,D){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$km=j}),define(oe[96],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0,e.$Fn=(0,O.$Mh)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=void 0,e.$Th=(0,O.$Mh)("environmentService"),e.$Uh=(0,O.$Nh)(e.$Th)}),define(oe[29],ae([0,1,153,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$2n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0,e.$On="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Pn=new RegExp(e.$On),e.$Qn="__web_extension",e.$Rn="skipWalkthrough",e.$Sn="extensionsSync",e.$Tn="dependecyOrPackExtensionInstall";function j(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Un=j;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Vn=A;function I(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Wn=I;function D(l,u){return u==="web"&&!l.includes("web")}e.$Xn=D;function C(l,u,b){return D(u,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:d(b).includes(l)}e.$Yn=C;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Zn=d;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$1n=P;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var $;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})($||(e.SortOrder=$={}));var c;(function(l){l.Install="install",l.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var g;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$2n=(0,N.$Mh)("extensionGalleryService");var p;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var w;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class h extends Error{constructor(u,b){super(u),this.code=b,this.name=b}}e.$3n=h,e.$4n=(0,N.$Mh)("extensionManagementService"),e.$5n="extensionsIdentifiers/disabled",e.$6n="extensionsIdentifiers/enabled",e.$7n=(0,N.$Mh)("IGlobalExtensionEnablementService"),e.$8n=(0,N.$Mh)("IExtensionTipsService"),e.$9n=(0,O.localize)(0,null),e.$0n={value:e.$9n,original:"Extensions"},e.$$n={value:(0,O.localize)(1,null),original:"Preferences"}}),define(oe[188],ae([0,1,3,2,30,9,92,29]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=void 0;function C(w,h){return w?A.URI.revive(h?h.transformIncoming(w):w):void 0}function d(w,h){return h?h.transformOutgoingURI(w):w}function P(w,h){h=h||I.$Em;const l=w.manifest;return{...(0,I.$Hm)({...w,manifest:void 0},h),manifest:l}}function E(w,h){return w?.profileLocation?(0,I.$Hm)(w,h??I.$Em):w}function $(w,h){return h?(0,j.$Zm)(w,l=>l instanceof A.URI?h.transformOutgoingURI(l):void 0):w}class c{constructor(h,l){this.a=h,this.b=l,this.onInstallExtension=O.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,l){const u=this.b(h);switch(l){case"onInstallExtension":return O.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,b=>b.map(S=>({...S,local:S.local?$(S.local,u):S.local,profileLocation:S.profileLocation?d(S.profileLocation,u):S.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,b=>$(b,u))}throw new Error("Invalid listen")}async call(h,l,u){const b=this.b(h);switch(l){case"zip":{const S=P(u[0],b),t=await this.a.zip(S);return d(t,b)}case"unzip":return this.a.unzip(C(u[0],b));case"install":return this.a.install(C(u[0],b),E(u[1],b));case"installFromLocation":return this.a.installFromLocation(C(u[0],b),C(u[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(u[0],C(u[1],b),C(u[2],b));case"getManifest":return this.a.getManifest(C(u[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],E(u[1],b));case"installGalleryExtensions":{const S=u[0];return this.a.installGalleryExtensions(S.map(({extension:t,options:a})=>({extension:t,options:E(a,b)??{}})))}case"uninstall":return this.a.uninstall(P(u[0],b),E(u[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(u[0],b));case"getInstalled":return(await this.a.getInstalled(u[0],C(u[1],b))).map(t=>$(t,b));case"toggleAppliationScope":{const S=await this.a.toggleAppliationScope(P(u[0],b),C(u[1],b));return $(S,b)}case"copyExtensions":return this.a.copyExtensions(C(u[0],b),C(u[1],b));case"updateMetadata":{const S=await this.a.updateMetadata(P(u[0],b),u[1],C(u[2],b));return $(S,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1],u[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$_o=c;class g extends N.$Qc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new O.$Ld),this.f=this.B(new O.$Ld),this.g=this.B(new O.$Ld),this.h=this.B(new O.$Ld),this.j=this.B(new O.$Ld),this.B(this.m.listen("onInstallExtension")(l=>this.n(this.c,{...l,source:this.r(l.source)?A.URI.revive(l.source):l.source,profileLocation:A.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(l=>this.n(this.f,l.map(u=>({...u,local:u.local?P(u.local,null):u.local,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(l=>this.n(this.g,{...l,profileLocation:A.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(l=>this.n(this.h,{...l,profileLocation:A.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(l=>this.j.fire(P(l,null))))}n(h,l){h.fire(l)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const l=await this.getTargetPlatform();return h.allTargetPlatforms.some(u=>(0,D.$Yn)(u,h.allTargetPlatforms,l))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(l=>A.URI.revive(l)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,l){return Promise.resolve(this.m.call("install",[h,l])).then(u=>P(u,null))}installFromLocation(h,l){return Promise.resolve(this.m.call("installFromLocation",[h,l])).then(u=>P(u,null))}async installExtensionsFromProfile(h,l,u){return(await this.m.call("installExtensionsFromProfile",[h,l,u])).map(S=>P(S,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,l){return Promise.resolve(this.m.call("installFromGallery",[h,l])).then(u=>P(u,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(u=>({...u,local:u.local?P(u.local,null):u.local,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))}uninstall(h,l){return Promise.resolve(this.m.call("uninstall",[h,l]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(l=>P(l,null))}getInstalled(h=null,l){return Promise.resolve(this.m.call("getInstalled",[h,l])).then(u=>u.map(b=>P(b,null)))}updateMetadata(h,l,u){return Promise.resolve(this.m.call("updateMetadata",[h,l,u])).then(b=>P(b,null))}toggleAppliationScope(h,l){return this.m.call("toggleAppliationScope",[h,l]).then(u=>P(u,null))}copyExtensions(h,l){return this.m.call("copyExtensions",[h,l])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,l,u){const b=await this.m.call("download",[h,l,u]);return A.URI.revive(b)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$ap=g;class p{constructor(h){this.a=h}listen(h,l){throw new Error("Invalid listen")}call(h,l,u){switch(l){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$bp=p}),define(oe[97],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=void 0,e.$9o=(0,O.$Mh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,I)=>te(["node-vsce-sign"],async D=>A(D),I))),this.a}async verify(A,I,D){let C;try{C=await this.b()}catch{return!1}return C.verify(A,I,D)}}e.$0o=N}),define(oe[98],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oVb=e.RecommendationsNotificationResult=e.$nVb=e.RecommendationSource=void 0;var N;(function(I){I[I.FILE=1]="FILE",I[I.WORKSPACE=2]="WORKSPACE",I[I.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function j(I){switch(I){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$nVb=j;var A;(function(I){I.Ignored="ignored",I.Cancelled="cancelled",I.TooMany="toomany",I.IncompatibleWindow="incompatibleWindow",I.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$oVb=(0,O.$Mh)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,9,160,4,6,23]),function(te,e,O,N,j,A,I,D,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileKind=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileOperationResult=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileChangeType=e.$mk=e.FileOperation=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileSystemProviderErrorCode=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$9j=e.$8j=void 0,e.$8j=(0,C.$Mh)("fileService");function E(W){return W.create===!0}e.$9j=E;var $;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var c;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var g;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function p(W){return!!(W.capabilities&2)}e.$0j=p;function w(W){return!!(W.capabilities&8)}e.$$j=w;function h(W){return!!(W.capabilities&131072)}e.$_j=h;function l(W){return!!(W.capabilities&4)}e.$ak=l;function u(W){return!!(W.capabilities&16)}e.$bk=u;function b(W){return p(W)?!!(W.capabilities&16384):!1}e.$ck=b;function S(W){return p(W)?!!(W.capabilities&32768):!1}e.$dk=S;function t(W){return!!(W.capabilities&65536)}e.$ek=t;function a(W){return!!(W.capabilities&2048)}e.$fk=a;var s;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create(ee,ne){const re=new n(ee.toString(),ne);return o(re,ne),re}constructor(ee,ne){super(ee),this.code=ne}}e.$gk=n;function i(W,ee){return n.create(W,ee)}e.$hk=i;function r(W){return W||i((0,D.localize)(0,null),s.Unknown)}e.$ik=r;function o(W,ee){return W.name=ee?`${ee} (FileSystemError)`:"FileSystemError",W}e.$jk=o;function v(W){if(!W)return s.Unknown;if(W instanceof n)return W.code;const ee=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ee)return s.Unknown;switch(ee[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$kk=v;function y(W){if(W instanceof z)return W.fileOperationResult;switch(v(W)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$lk=y;var f;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(f||(e.FileOperation=f={}));class m{constructor(ee,ne,re){this.resource=ee,this.operation=ne,this.target=re}isOperation(ee){return this.operation===ee}}e.$mk=m;var L;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class F{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const Y of ee){const B=re.get(Y.type);switch(B?B.push([Y.resource,Y]):re.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,B]of re)switch(Y){case 1:this.a=O.$Sh.forUris(()=>ne),this.a.fill(B);break;case 0:this.b=O.$Sh.forUris(()=>ne),this.b.fill(B);break;case 2:this.c=O.$Sh.forUris(()=>ne),this.c.fill(B);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...re){if(!ee)return!1;const Y=re.length>0;return!!((!Y||re.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!Y||re.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!Y||re.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$nk=F;function T(W,ee,ne){return!W||!ee||W===ee||ee.length>W.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,j.$1e)(W,ee):W.indexOf(ee)===0)}e.$ok=T;class z extends Error{constructor(ee,ne,re){super(ee),this.fileOperationResult=ne,this.options=re}}e.$pk=z;class q extends z{constructor(ee,ne,re,Y){super(ee,ne,Y),this.fileOperationResult=ne,this.size=re}}e.$qk=q;class _ extends z{constructor(ee,ne,re){super(ee,2,re),this.stat=ne}}e.$rk=_;var Q;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$sk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$uk="files.associations",e.$vk="files.exclude",e.$wk="files.readonlyInclude",e.$xk="files.readonlyExclude",e.$yk="files.readonlyFromPermissions";var Z;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$zk="";function G(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.$Ak=G;async function K(W,ee){if(!ee.hasProvider(I.URI.from({scheme:W.scheme})))return new Promise(ne=>{const re=ee.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===W.scheme&&Y.added&&(re.dispose(),ne())})})}e.$Bk=K;class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(ee){return(0,A.$Af)(ee)||(ee=0),ee<H.KB?(0,D.localize)(1,null,ee.toFixed(0)):ee<H.MB?(0,D.localize)(2,null,(ee/H.KB).toFixed(2)):ee<H.GB?(0,D.localize)(3,null,(ee/H.MB).toFixed(2)):ee<H.TB?(0,D.localize)(4,null,(ee/H.GB).toFixed(2)):(0,D.localize)(5,null,(ee/H.TB).toFixed(2))}}e.$Ck=H;function V(W){const ee=typeof W=="string"||W?.scheme===P.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===P.Schemas.file?1024*H.MB:ee?10*H.MB:d.$o?50*H.MB:1024*H.MB}e.$Dk=V});var x=this&&this.__param||function(te,e){return function(O,N){e(O,N,te)}};define(oe[189],ae([0,1,69,46,11]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=void 0;let A=class{constructor(D){this.a=D}async checksum(D){const C=(await this.a.readFileStream(D)).value;return new Promise((d,P)=>{const E=(0,O.createHash)("md5");(0,N.$4d)(C,{onData:$=>E.update($.buffer),onError:$=>P($),onEnd:()=>d(E.digest("base64").replace(/=+$/,""))})})}};e.$j8b=A,e.$j8b=A=ye([x(0,j.$8j)],A)}),define(oe[190],ae([0,1,15,38,8,3,2,46,9,32,11]),function(te,e,O,N,j,A,I,D,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0,e.$bN="localFilesystem";class E extends I.$Qc{constructor(c,g){super(),this.a=c,this.b=g,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$Ld),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$Ld),this.onDidWatchError=this.g.event,this.h=(0,d.$cg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,g){const{buffer:p}=await this.a.call("readFile",[c,g]);return p}readFileStream(c,g,p){const w=(0,D.$Zd)(l=>O.$_d.concat(l.map(u=>O.$_d.wrap(u))).buffer),h=new I.$Pc;return h.add(this.a.listen("readFileStream",[c,g])(l=>{if(l instanceof O.$_d)w.write(l.buffer);else{if(l==="end")w.end();else{let u;if(l instanceof Error)u=l;else{const b=l;u=(0,P.$hk)(b.message??(0,N.$xi)(b),b.code??P.FileSystemProviderErrorCode.Unknown)}w.error(u),w.end()}h.dispose()}})),h.add(p.onCancellationRequested(()=>{w.error((0,j.$4)()),w.end(),h.dispose()})),w}writeFile(c,g,p){return this.a.call("writeFile",[c,O.$_d.wrap(g),p])}open(c,g){return this.a.call("open",[c,g])}close(c){return this.a.call("close",[c])}async read(c,g,p,w,h){const[l,u]=await this.a.call("read",[c,g,h]);return p.set(l.buffer.slice(0,u),w),u}write(c,g,p,w,h){return this.a.call("write",[c,g,O.$_d.wrap(p),w,h])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,g){return this.a.call("delete",[c,g])}rename(c,g,p){return this.a.call("rename",[c,g,p])}copy(c,g,p){return this.a.call("copy",[c,g,p])}cloneFile(c,g){return this.a.call("cloneFile",[c,g])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const g=c;this.f.fire(g.map(p=>({resource:C.URI.revive(p.resource),type:p.type})))}else{const g=c;this.g.fire(g)}}))}watch(c,g){const p=(0,d.$cg)();return this.a.call("watch",[this.h,p,c,g]),(0,I.$Oc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$cN=E}),define(oe[99],ae([0,1,15,8,161,11]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;async function I(P,E,$,c,g,p){let w;try{await D(P,E,$,c,g,p)}catch(h){w=h}finally{w&&g.errorTransformer&&(w=g.errorTransformer(w)),typeof w<"u"&&$.error(w),$.end()}}e.$Ep=I;async function D(P,E,$,c,g,p){C(p);const w=await P.open(E,{create:!1});try{C(p);let h=0,l=0,u=g&&typeof g.length=="number"?g.length:void 0,b=O.$_d.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),S=g&&typeof g.position=="number"?g.position:0,t=0;do l=await P.read(w,S,b.buffer,t,b.byteLength-t),S+=l,t+=l,h+=l,typeof u=="number"&&(u-=l),t===b.byteLength&&(await $.write(c(b)),b=O.$_d.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),t=0);while(l>0&&(typeof u!="number"||u>0)&&C(p)&&d(h,g));if(t>0){let a=t;typeof u=="number"&&(a=Math.min(t,u)),$.write(c(b.slice(0,a)))}}catch(h){throw(0,A.$ik)(h)}finally{await P.close(w)}}function C(P){if(P.isCancellationRequested)throw(0,N.$4)();return!0}function d(P,E){if(typeof E?.limits?.size=="number"&&P>E.limits.size)throw(0,A.$hk)((0,j.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[54],ae([0,1,91,2,16,6,9,11]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=void 0;function C(h){return h.recursive===!0}e.$Gp=C;class d extends N.$Qc{static{this.a=5}constructor(l,u,b,S){super(),this.h=l,this.j=u,this.m=b,this.n=S,this.c=this.B(new N.$Rc),this.f=void 0,this.g=0}s(){const l=new N.$Pc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(u=>this.h(u))),l.add(this.b.onDidLogMessage(u=>this.j(u))),l.add(this.b.onDidError(u=>this.t(u)))}t(l){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Hp=d;class P extends d{constructor(l,u,b){super(l,u,b,{type:"node.js",restartOnError:!1})}}e.$Ip=P;class E extends d{constructor(l,u,b){super(l,u,b,{type:"universal",restartOnError:!0})}}e.$Jp=E;function $(h){return h.map(l=>({type:l.type,resource:I.URI.revive(l.resource)}))}e.$Kp=$;function c(h){const l=new w;for(const u of h)l.processEvent(u);return l.coalesce()}e.$Lp=c;function g(h,l){return typeof l=="string"&&!l.startsWith(O.$pj)&&!(0,j.$gc)(l)?{base:h,pattern:l}:l}e.$Mp=g;function p(h,l){const u=[];for(const b of l)u.push((0,O.$tj)(g(h,b)));return u}e.$Np=p;class w{constructor(){this.a=new Set,this.b=new Map}c(l){return A.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const u=this.b.get(this.c(l));let b=!1;if(u){const S=u.type,t=l.type;u.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?b=!0:S===1&&t===2?(this.b.delete(this.c(l)),this.a.delete(u)):S===2&&t===1?u.type=0:S===1&&t===0||(u.type=t)}else b=!0;b&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],u=[];return Array.from(this.a).filter(b=>b.type!==2?(l.push(b),!1):!0).sort((b,S)=>b.resource.fsPath.length-S.resource.fsPath.length).filter(b=>u.some(S=>(0,D.$ok)(b.resource.fsPath,S,!A.$k))?!1:(u.push(b.resource.fsPath),!0)).concat(l)}}}),define(oe[191],ae([0,1,52,5,26,48,2,88,16,6,9,144,31,54]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class g extends I.$Qc{static{this.a=100}static{this.b=75}constructor(h,l,u,b){super(),this.m=h,this.n=l,this.r=u,this.s=b,this.c=this.B(new N.$7g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.n(S))),this.f=this.B(new N.$6g(S=>this.z(S),g.b)),this.g=(0,c.$Np)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,c.$Np)(this.m.path,this.m.includes):void 0,this.j=new j.$Vd,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await $.Promises.stat(h);this.B(await this.w(h,l.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let l=h.path;try{l=await $.Promises.realpath(h.path),h.path===l&&(l=await(0,E.$Xp)(h.path)??h.path),h.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${l})`)}catch{}return l}async w(h,l){if(d.$j&&(0,A.$Vf)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Qc.None;const u=new j.$Vd(this.j.token),b=new I.$Pc;try{const S=(0,C.$lc)(h),t=(0,O.watch)(h);b.add((0,I.$Oc)(()=>{t.removeAllListeners(),t.close()})),this.G(`Started watching: '${h}'`);const a=new Set;if(l)try{for(const n of await $.Promises.readdir(h))a.add(n)}catch(n){this.D(n)}const s=new Map;b.add((0,I.$Oc)(()=>{for(const[,n]of s)n.dispose();s.clear()})),t.on("error",(n,i)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),t.on("change",(n,i)=>{if(u.token.isCancellationRequested)return;this.G(`[raw] ["${n}"] ${i}`);let r="";if(i&&(r=i.toString(),d.$j&&(r=(0,D.$jl)(r))),!(!r||n!=="change"&&n!=="rename"))if(l)if(n==="rename"){s.get(r)?.dispose();const o=setTimeout(async()=>{if(s.delete(r),r===S&&!await $.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.C((0,C.$hc)(h,r));if(u.token.isCancellationRequested)return;let y;v?a.has(r)?y=0:(y=1,a.add(r)):(a.delete(r),y=2),this.y({resource:P.URI.file((0,C.$hc)(this.m.path,r)),type:y})},g.a);s.set(r,(0,I.$Oc)(()=>clearTimeout(o)))}else{let o;a.has(r)?o=0:(o=1,a.add(r)),this.y({resource:P.URI.file((0,C.$hc)(this.m.path,r)),type:o})}else if(n==="rename"||r!==S){const o=setTimeout(async()=>{const v=await $.Promises.exists(h);u.token.isCancellationRequested||(v?(this.y({resource:P.URI.file(this.m.path),type:0},!0),b.add(await this.w(h,!1))):(this.y({resource:P.URI.file(this.m.path),type:2},!0),this.f.flush(),this.dispose()))},g.a);b.clear(),b.add((0,I.$Oc)(()=>clearTimeout(o)))}else this.y({resource:P.URI.file(this.m.path),type:0},!0)})}catch(S){await $.Promises.exists(h)&&!u.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${S.toString()})`)}return(0,I.$Oc)(()=>{u.dispose(!0),b.dispose()})}y(h,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!l&&this.g.some(u=>u(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(u=>u(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const l=(0,c.$Lp)(h);if(l.length>0){if(this.s)for(const b of l)this.G(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(d.$k)return $.Promises.exists(h);try{const l=(0,C.$lc)(h);return(await $.Promises.readdir((0,C.$kc)(h))).some(b=>b===l)}catch(l){return this.G(l),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$1p=g;async function p(w,h,l,u,b=512){const S=await $.Promises.open(w,"r"),t=Buffer.allocUnsafe(b),a=new j.$Vd(u);let s,n=!1;const i={path:w,excludes:[],recursive:!1},r=new g(i,o=>{(async()=>{for(const{type:v}of o)if(v===0){if(n)return;n=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:y}=await $.Promises.read(S,t,0,b,null);if(!y||a.token.isCancellationRequested)break;h(t.slice(0,y))}}catch(y){s=new Error(y),a.dispose(!0)}finally{n=!1}}})()});return await r.ready,l(),new Promise((o,v)=>{a.token.onCancellationRequested(async()=>{r.dispose();try{await $.Promises.close(S)}catch(y){s=new Error(y)}s?v(s):o()})})}e.$2p=p}),define(oe[192],ae([0,1,3,91,2,6,191]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class D extends j.$Qc{constructor(){super(...arguments),this.a=this.B(new O.$Ld),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$Ld),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(d){const P=this.j(d),E=P.filter(c=>{const g=this.c.get(c.path);return g?!(0,N.$xj)(g.request.excludes,c.excludes)||!(0,N.$xj)(g.request.includes,c.includes):!0}),$=Array.from(this.c.values()).filter(({request:c})=>!P.find(g=>g.path===c.path&&(0,N.$xj)(g.excludes,c.excludes)&&(0,N.$xj)(g.includes,c.includes))).map(({request:c})=>c.path);E.length&&this.m(`Request to start watching: ${E.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const c of $)this.h(c);for(const c of E)this.g(c)}g(d){const P=new I.$1p(d,$=>this.a.fire($),$=>this.b.fire($),this.f),E={request:d,instance:P};this.c.set(d.path,E)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const P=this.c.get(d);P&&(this.c.delete(d),P.instance.dispose())}j(d){const P=new Map;for(const E of d){const $=A.$k?E.path:E.path.toLowerCase();P.set($,E)}return Array.from(P.values())}async setVerboseLogging(d){this.f=d;for(const[,P]of this.c)P.instance.setVerboseLogging(d)}m(d){this.f&&this.b.fire({type:"trace",message:this.n(d)})}n(d,P){return P?`[File Watcher (node.js)] ${d} (path: ${P.request.path})`:`[File Watcher (node.js)] ${d}`}}e.$3p=D}),define(oe[193],ae([0,1,54,192]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class j extends O.$Ip{constructor(I,D,C){super(I,D,C),this.s()}r(I){return I.add(new N.$3p)}}e.$4p=j}),define(oe[194],ae([0,1,23,42,93,54]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;class I extends A.$Jp{constructor(C,d,P){super(C,d,P),this.s()}r(C){const d=C.add(new j.$Up(O.$ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(d.onDidProcessExit(({code:P,signal:E})=>this.t(`terminated by itself with code ${P}, signal: ${E}`))),N.ProxyChannel.toService((0,N.$th)(d.getChannel("watcher")))}}e.$Vp=I}),define(oe[70],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class O{constructor(...j){this.a=new Map;for(const[A,I]of j)this.set(A,I)}set(j,A){const I=this.a.get(j);return this.a.set(j,A),I}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$Kh=O}),define(oe[195],ae([0,1,5,8,2,68,186,4,70,87]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;const P=!1;class E extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class ${constructor(w=new C.$Kh,h=!1,l,u=P){this.f=w,this.g=h,this.h=l,this.i=u,this.o=new Set,this.f.set(D.$Lh,this),this._globalGraph=u?l?._globalGraph??new I.$7p(b=>b):void 0}createChild(w){return new $(w,this.g,this,this.i)}invokeFunction(w,...h){const l=g.traceInvocation(this.i,w);let u=!1;try{return w({get:S=>{if(u)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(S,l);if(!t)throw new Error(`[invokeFunction] unknown service '${S}'`);return t}},...h)}finally{u=!0,l.stop()}}createInstance(w,...h){let l,u;return w instanceof A.$Jh?(l=g.traceCreation(this.i,w.ctor),u=this.j(w.ctor,w.staticArguments.concat(h),l)):(l=g.traceCreation(this.i,w),u=this.j(w,h,l)),l.stop(),u}j(w,h=[],l){const u=D._util.getServiceDependencies(w).sort((t,a)=>t.index-a.index),b=[];for(const t of u){const a=this.m(t.id,l);a||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(a)}const S=u.length>0?u[0].index:h.length;if(h.length!==S){console.trace(`[createInstance] First service dependency of ${w.name} at position ${S+1} conflicts with ${h.length} static arguments`);const t=S-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,S)}return Reflect.construct(w,h.concat(b))}k(w,h){if(this.f.get(w)instanceof A.$Jh)this.f.set(w,h);else if(this.h)this.h.k(w,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const h=this.f.get(w);return!h&&this.h?this.h.l(w):h}m(w,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const l=this.l(w);return l instanceof A.$Jh?this.q(w,l,h.branch(w,!0)):(h.branch(w,!1),l)}q(w,h,l){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,h,l)}finally{this.o.delete(w)}}r(w,h,l){const u=new I.$7p(t=>t.id.toString());let b=0;const S=[{id:w,desc:h,_trace:l}];for(;S.length;){const t=S.pop();if(u.lookupOrInsertNode(t),b++>1e3)throw new E(u);for(const a of D._util.getServiceDependencies(t.desc.ctor)){const s=this.l(a.id);if(s||this.u(`[createInstance] ${w} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),s instanceof A.$Jh){const n={id:a.id,desc:s,_trace:t._trace.branch(a.id,!0)};u.insertEdge(t,n),S.push(n)}}}for(;;){const t=u.roots();if(t.length===0){if(!u.isEmpty())throw new E(u);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.$Jh){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}u.removeNode(a)}}return this.l(w)}s(w,h,l=[],u,b){if(this.f.get(w)instanceof A.$Jh)return this.t(w,h,l,u,b);if(this.h)return this.h.s(w,h,l,u,b);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(w,h,l=[],u,b){if(u){const S=new $(void 0,this.g,this,this.i);S.c=String(w);const t=new Map,a=new O.$9g(()=>{const s=S.j(h,l,b);for(const[n,i]of t){const r=s[n];if(typeof r=="function")for(const o of i)r.apply(s,o)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new d.$Zc,t.set(n,o)),(y,f,m)=>{const L=o.push([y,f,m]);return(0,j.$Oc)(L)}}if(n in s)return s[n];const i=a.value;let r=i[n];return typeof r!="function"||(r=r.bind(i),s[n]=r),r},set(s,n,i){return a.value[n]=i,!0},getPrototypeOf(s){return h.prototype}})}else return this.j(h,l,b)}u(w,h){if(h&&console.warn(w),this.g)throw new Error(w)}}e.$8p=$;var c;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(c||(c={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,h){return w?new g(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(w,h){return w?new g(1,h.name):g.c}static{this.f=0}constructor(w,h){this.type=w,this.name=h,this.g=Date.now(),this.h=[]}branch(w,h){const l=new g(3,w.toString());return this.h.push([w,h,l]),l}stop(){const w=Date.now()-this.g;g.f+=w;let h=!1;function l(b,S){const t=[],a=new Array(b+1).join("	");for(const[s,n,i]of S.h)if(n&&i){h=!0,t.push(`${a}CREATES -> ${s}`);const r=l(b+1,i);r&&t.push(r)}else t.push(`${a}uses -> ${s}`);return t.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(w>2||h)&&g.all.add(u.join(`
`))}}e.$9p=g}),define(oe[71],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=e.$S7b=void 0,e.$S7b=(0,O.$Mh)("mainProcessService");class N{constructor(A,I){this.a=A,this.b=I}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,I){this.a.registerChannel(A,I)}}e.$T7b=N}),define(oe[72],ae([0,1,26,2,6,163,29,4]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=void 0;function C(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Jq=C,e.$Kq=(0,D.$Mh)("languagePackService");let d=class extends N.$Qc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new O.$Vd;setTimeout(()=>E.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=$.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(w=>w.startsWith("lp-"))).map(p=>{const w=p.properties.localizedLanguages?.[0],h=C(p);return{...this.f(h,w,p),extensionId:p.identifier.id,galleryExtension:p}});return g.push(this.f("en","English")),g}f(E,$,c){const g=$??E;let p;if(g!==E&&(p=`(${E})`),E.toLowerCase()===j.$v.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),c?.installCount){p??="";const w=c.installCount;let h;w>1e6?h=`${Math.floor(w/1e5)/10}M`:w>1e3?h=`${Math.floor(w/1e3)}K`:h=String(w),p+=` $(cloud-download) ${h}`}return{id:E,label:g,description:p}}};e.$Lq=d,e.$Lq=d=ye([x(0,I.$2n)],d)}),define(oe[196],ae([0,1,2,72]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;let j=class extends O.$Qc{constructor(I){super(),this.a=I,this.b()}b(){this.a.update()}};e.$f8b=j,e.$f8b=j=ye([x(0,N.$Kq)],j)}),define(oe[7],ae([0,1,38,3,51,2,34,6,21,12,9,94,4]),function(te,e,O,N,j,A,I,D,C,d,P,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.log=e.$0i=e.LogLevel=e.$9i=e.$8i=e.$7i=void 0,e.$7i=(0,$.$Mh)("logService"),e.$8i=(0,$.$Mh)("loggerService");function c(){return new Date().toISOString()}function g(y){return(0,d.$Af)(y)}e.$9i=g;var p;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$0i=p.Info;function w(y,f,m){switch(f){case p.Trace:y.trace(m);break;case p.Debug:y.debug(m);break;case p.Info:y.info(m);break;case p.Warning:y.warn(m);break;case p.Error:y.error(m);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=w;function h(y,f=!1){let m="";for(let L=0;L<y.length;L++){let F=y[L];if(F instanceof Error&&(F=(0,O.$xi)(F,f)),typeof F=="object")try{F=JSON.stringify(F)}catch{}m+=(L>0?" ":"")+F}return m}class l extends A.$Qc{constructor(){super(...arguments),this.b=e.$0i,this.c=this.B(new N.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$_i=l;class u extends l{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...m){this.f(p.Trace)&&this.g(p.Trace,h([f,...m],!0))}debug(f,...m){this.f(p.Debug)&&this.g(p.Debug,h([f,...m]))}info(f,...m){this.f(p.Info)&&this.g(p.Info,h([f,...m]))}warn(f,...m){this.f(p.Warning)&&this.g(p.Warning,h([f,...m]))}error(f,...m){if(this.f(p.Error))if(f instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=f.stack,this.g(p.Error,h(L))}else this.g(p.Error,h([f,...m]))}flush(){}}e.$aj=u;class b extends l{constructor(f=e.$0i){super(),this.setLevel(f),this.g=!D.$i}trace(f,...m){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...m):console.log(`[main ${c()}]`,f,...m))}debug(f,...m){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...m):console.log(`[main ${c()}]`,f,...m))}info(f,...m){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...m):console.log(`[main ${c()}]`,f,...m))}warn(f,...m){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,f,...m):console.warn(`[main ${c()}]`,f,...m))}error(f,...m){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,f,...m):console.error(`[main ${c()}]`,f,...m))}dispose(){}flush(){}}e.$bj=b;class S extends l{constructor(f=e.$0i,m=!0){super(),this.g=m,this.setLevel(f)}trace(f,...m){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...m):console.log(f,...m))}debug(f,...m){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...m):console.log(f,...m))}info(f,...m){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...m):console.log(f,...m))}warn(f,...m){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...m):console.log(f,...m))}error(f,...m){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...m):console.error(f,...m))}dispose(){}flush(){}}e.$cj=S;class t extends l{constructor(f,m=e.$0i){super(),this.g=f,this.setLevel(m)}trace(f,...m){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...m])}debug(f,...m){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...m])}info(f,...m){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...m])}warn(f,...m){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...m])}error(f,...m){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...m])}h(f){return typeof f=="string"?f:(0,O.$xi)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$dj=t;class a extends l{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const m of this.g)m.setLevel(f);super.setLevel(f)}trace(f,...m){for(const L of this.g)L.trace(f,...m)}debug(f,...m){for(const L of this.g)L.debug(f,...m)}info(f,...m){for(const L of this.g)L.info(f,...m)}warn(f,...m){for(const L of this.g)L.warn(f,...m)}error(f,...m){for(const L of this.g)L.error(f,...m)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$ej=a;class s extends A.$Qc{constructor(f,m,L){if(super(),this.h=f,this.j=m,this.b=new I.$yc,this.c=this.B(new N.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Ld),this.onDidChangeVisibility=this.g.event,L)for(const F of L)this.b.set(F.resource,{logger:void 0,info:F})}m(f){return(0,d.$wf)(f)?[...this.b.values()].find(m=>m.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,m){const L=this.n(f),F=(0,d.$wf)(f)?f:m?.id??(0,j.$Ai)(L.toString()).toString(16);let T=this.b.get(L)?.logger;const z=m?.logLevel==="always"?p.Trace:m?.logLevel;T||(T=this.s(L,z??this.getLogLevel(L)??this.h,{...m,id:F}));const q={logger:T,info:{resource:L,id:F,logLevel:z,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId,when:m?.when}};return this.registerLogger(q.info),this.b.set(L,q),T}n(f){return(0,d.$wf)(f)?(0,C.$tg)(this.j,`${f}.log`):f}setLogLevel(f,m){if(P.URI.isUri(f)){const L=f,F=m,T=this.b.get(L);T&&F!==T.info.logLevel&&(T.info.logLevel=F===this.h?void 0:F,T.logger?.setLevel(F),this.b.set(T.info.resource,T),this.f.fire([L,F]))}else{this.h=f;for(const[L,F]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,m){const L=this.m(f);L&&m!==!L.info.hidden&&(L.info.hidden=!m,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,m]))}getLogLevel(f){let m;return f&&(m=this.b.get(f)?.info.logLevel),m??this.h}registerLogger(f){const m=this.b.get(f.resource);m?m.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const m=this.b.get(f);m&&(m.logger&&m.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[m.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fj=s;class n{constructor(){this.onDidChangeLogLevel=new N.$Ld().event}setLevel(f){}getLevel(){return p.Info}trace(f,...m){}debug(f,...m){}info(f,...m){}warn(f,...m){}error(f,...m){}critical(f,...m){}dispose(){}flush(){}}e.$gj=n;class i extends n{}e.$hj=i;function r(y){if(y.verbose)return p.Trace;if(typeof y.logLevel=="string"){const f=v(y.logLevel.toLowerCase());if(f!==void 0)return f}return e.$0i}e.$ij=r;function o(y){switch(y){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$jj=o;function v(y){switch(y){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$kj=v,e.$lj=new E.$4i("logLevel",o(p.Info))}),define(oe[197],ae([0,1,5,8,2,23,16,21,31,14,7]),function(te,e,O,N,j,A,I,D,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=void 0;let E=class extends j.$Qc{constructor(c,g){super(),this.a=c,this.b=g,this.B(new O.$4g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,D.$qg)(this.a.logsHome),g=(0,D.$sg)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,h=(await C.Promises.readdir(g)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==c),l=h.slice(0,Math.max(0,h.length-9));l.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${l.join(", ")}'`),await Promise.all(l.map(u=>C.Promises.rm((0,I.$hc)(g,u)))))}catch(c){(0,N.$Y)(c)}}};e.$g8b=E,e.$g8b=E=ye([x(0,d.$Th),x(1,P.$7i)],E)}),define(oe[198],ae([0,1,18,5,8,3,2,16,54,7]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class P extends I.$Qc{constructor($,c){super(),this.a=$,this.b=c,this.c=this.B(new A.$Ld),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Ld),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Pg(0)),this.w=[],this.y=this.B(new N.$Pg(0))}watch($,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n($,c):this.z($,c)}n($,c){const g={path:this.H($),excludes:c.excludes,includes:c.includes,recursive:c.recursive},p=(0,O.$Sb)(this.j,g);return this.r(),(0,I.$Oc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,j.$Y)($))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,C.$Kp)(c)),c=>this.G(c),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const c of this.j)(0,C.$Gp)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const c of this.j)(0,C.$Gp)(c)&&$.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,c){const g={path:this.H($),excludes:c.excludes,includes:c.includes,recursive:!1},p=(0,O.$Sb)(this.w,g);return this.C(),(0,I.$Oc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,j.$Y)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,C.$Kp)($)),$=>this.G($),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,D.$fc)($.fsPath)}}e.$Op=P}),define(oe[199],ae([0,1,18,5,15,26,3,51,59,2,47,23,100,21,46,159,11,99,7,8]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;let b=class extends d.$Qc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new I.$Ld),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$Ld),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$Ld),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$Ld),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$Ld),this.onDidFilesChange=this.X.event,this.Y=this.B(new I.$Ld),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new N.$1g)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${t}`);const s=new d.$Pc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),s.add(a.onDidChangeFile(n=>this.X.fire(new w.$nk(n,!this.S(a))))),typeof a.onDidWatchError=="function"&&s.add(a.onDidWatchError(n=>this.Y.fire(new Error(n)))),s.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,d.$Oc)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,d.$Lc)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(s){a.push(s)}}),!this.h.has(t)&&await N.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&a)}listCapabilities(){return C.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,c.$xg)(t))throw new w.$pk((0,p.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const s=new u.$_;throw s.message=(0,p.localize)(1,null,t.toString()),s}return a}async m(t){const a=await this.j(t);if((0,w.$ak)(a)||(0,w.$0j)(a)||(0,w.$bk)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,w.$ak)(a)||(0,w.$0j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(s){throw(0,w.$kk)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.$pk((0,p.localize)(2,null,this.qb(t)),1):(0,w.$ik)(s)}}async s(t,a){const s=await this.j(t),n=this.S(s),i=a?.resolveTo,r=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,v=await s.stat(t);let y;return this.t(s,t,v,void 0,!!o,(f,m)=>(y||(y=P.$Sh.forUris(()=>!n),y.set(t,!0),i&&y.fill(!0,i)),y.get(f.resource)||y.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&r?m===1:!1))}async t(t,a,s,n,i,r){const{providerExtUri:o}=this.R(t),v={resource:a,name:o.basename(a),isFile:(s.type&w.FileType.File)!==0,isDirectory:(s.type&w.FileType.Directory)!==0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&w.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Ak)({mtime:s.mtime,size:s.size}),children:void 0};if(v.isDirectory&&r(v,n)){try{const y=await t.readdir(a),f=await N.Promises.settled(y.map(async([m,L])=>{try{const F=o.joinPath(a,m),T=i?await t.stat(F):{type:L};return await this.t(t,F,T,y.length,i,r)}catch(F){return this.b.trace(F),null}}));v.children=(0,O.$Fb)(f)}catch(y){this.b.trace(y),v.children=[]}return v}return v}async resolveAll(t){return N.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),s=await a.stat(t);return this.t(a,t,s,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(s){return s}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new w.$pk((0,p.localize)(3,null,this.qb(t)),3,a)}async createFile(t,a=j.$_d.fromString(""),s){await this.u(t,s);const n=await this.writeFile(t,a);return this.r.fire(new w.$mk(t,0,n)),n}async writeFile(t,a,s){const n=this.ob(await this.n(t),t),{providerExtUri:i}=this.R(n);let r=s;if((0,w.$dk)(n)&&!r?.atomic){const o=n.enforceAtomicWriteFile?.(t);o&&(r={...s,atomic:o})}try{await this.w(n,t,r)||await this.U(n,i.dirname(t));let v;if((0,w.$0j)(n)&&!(a instanceof j.$_d))if((0,g.$Xd)(a)){const y=await(0,g.$5d)(a,3);y.ended?v=j.$_d.concat(y.buffer):v=y}else v=(0,g.$2d)(a,y=>j.$_d.concat(y),3);else v=a;!(0,w.$ak)(n)||(0,w.$0j)(n)&&v instanceof j.$_d||(0,w.$0j)(n)&&(0,w.$dk)(n)&&r?.atomic?await this.fb(n,t,r,v):await this.bb(n,t,r,v instanceof j.$_d?(0,j.$ke)(v):v),this.r.fire(new w.$mk(t,4))}catch(o){throw new w.$pk((0,p.localize)(4,null,this.qb(t),(0,w.$ik)(o).toString()),(0,w.$lk)(o),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,s){const n=!!s?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.qb(a)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,p.localize)(6,null,this.qb(a)));if(!(t.capabilities&2))throw new Error((0,p.localize)(7,null,this.qb(a)));if(n)throw new Error((0,p.localize)(8,null,this.qb(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&w.FileType.Directory)throw new w.$pk((0,p.localize)(9,null,this.qb(a)),0,s);if(this.pb(a,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.$zk&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,w.$Ak)({mtime:s.mtime,size:r.size}))throw new w.$pk((0,p.localize)(10,null),3,s);return r}async readFile(t,a,s){const n=await this.m(t);return a?.atomic?this.z(n,t,a,s):this.C(n,t,a,s)}async z(t,a,s,n){return new Promise((i,r)=>{this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{try{const o=await this.C(t,a,s,n);i(o)}catch(o){r(o)}})})}async C(t,a,s,n){const i=await this.D(t,a,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,j.$le)(i.value)}}async readFileStream(t,a,s){const n=await this.m(t);return this.D(n,t,a,s)}async D(t,a,s,n){const i=new A.$Vd(n);let r=s;(0,w.$ck)(t)&&t.enforceAtomicReadFile?.(a)&&(r={...s,atomic:!0});const o=this.J(a,r).then(y=>y,y=>{throw i.dispose(!0),y});let v;try{return typeof r?.etag=="string"&&r.etag!==w.$zk&&await o,r?.atomic&&(0,w.$ck)(t)||!((0,w.$ak)(t)||(0,w.$bk)(t))||(0,w.$0j)(t)&&r?.preferUnbuffered?v=this.I(t,a,r):(0,w.$bk)(t)?v=this.G(t,a,i.token,r):v=this.H(t,a,i.token,r),v.on("end",()=>i.dispose()),v.on("error",()=>i.dispose()),{...await o,value:v}}catch(y){throw v&&await(0,g.$3d)(v),this.F(y,a,r)}}F(t,a,s){const n=(0,p.localize)(11,null,this.qb(a),(0,w.$ik)(t).toString());return t instanceof w.$rk?new w.$rk(n,t.stat,s):t instanceof w.$qk?new w.$qk(n,t.fileOperationResult,t.size,t.options):new w.$pk(n,(0,w.$lk)(t),s)}G(t,a,s,n=Object.create(null)){const i=t.readFileStream(a,n,s);return(0,g.$9d)(i,{data:r=>r instanceof j.$_d?r:j.$_d.wrap(r),error:r=>this.F(r,a,n)},r=>j.$_d.concat(r))}H(t,a,s,n=Object.create(null)){const i=(0,j.$pe)();return(0,h.$Ep)(t,a,i,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>this.F(r,a,n)},s),i}I(t,a,s){const n=(0,g.$Zd)(i=>j.$_d.concat(i));return(async()=>{try{let i;s?.atomic&&(0,w.$ck)(t)?i=await t.readFile(a,{atomic:!0}):i=await t.readFile(a),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.L(a,i.byteLength,s),n.end(j.$_d.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async J(t,a){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new w.$pk((0,p.localize)(12,null,this.qb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==w.$zk&&a.etag===s.etag)throw new w.$rk((0,p.localize)(13,null),s,a);return this.L(t,s.size,a),s}L(t,a,s){if(typeof s?.limits?.size=="number"&&a>s.limits.size)throw new w.$qk((0,p.localize)(14,null,this.qb(t)),7,a,s)}async canMove(t,a,s){return this.M(t,a,"move",s)}async canCopy(t,a,s){return this.M(t,a,"copy",s)}async M(t,a,s,n){if(t.toString()!==a.toString())try{const i=s==="move"?this.ob(await this.n(t),t):await this.m(t),r=this.ob(await this.n(a),a);await this.Q(i,t,r,a,s,n)}catch(i){return i}return!0}async move(t,a,s){const n=this.ob(await this.n(t),t),i=this.ob(await this.n(a),a),r=await this.N(n,t,i,a,"move",!!s),o=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$mk(t,r==="move"?2:3,o)),o}async copy(t,a,s){const n=await this.m(t),i=this.ob(await this.n(a),a),r=await this.N(n,t,i,a,"copy",!!s),o=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$mk(t,r==="copy"?3:2,o)),o}async N(t,a,s,n,i,r){if(a.toString()===n.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:v}=await this.Q(t,a,s,n,i,r);if(o&&!v&&r&&await this.del(n,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(n)),i==="copy"){if(t===s&&(0,w.$$j)(t))await t.copy(a,n,{overwrite:r});else{const y=await this.resolve(a);y.isDirectory?await this.P(t,y,s,n):await this.O(t,a,s,n)}return i}else return t===s?(await t.rename(a,n,{overwrite:r}),i):(await this.N(t,a,s,n,"copy",r),await this.del(a,{recursive:!0}),"copy")}async O(t,a,s,n){if((0,w.$ak)(t)&&(0,w.$ak)(s))return this.hb(t,a,s,n);if((0,w.$ak)(t)&&(0,w.$0j)(s))return this.nb(t,a,s,n);if((0,w.$0j)(t)&&(0,w.$ak)(s))return this.lb(t,a,s,n);if((0,w.$0j)(t)&&(0,w.$0j)(s))return this.jb(t,a,s,n)}async P(t,a,s,n){await s.mkdir(n),Array.isArray(a.children)&&await N.Promises.settled(a.children.map(async i=>{const r=this.R(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.P(t,await this.resolve(i.resource),s,r):this.O(t,i.resource,s,r)}))}async Q(t,a,s,n,i,r){let o=!1;if(t===s){const{providerExtUri:y,isPathCaseSensitive:f}=this.R(t);if(f||(o=y.isEqual(a,n)),o&&i==="copy")throw new Error((0,p.localize)(15,null,this.qb(a),this.qb(n)));if(!o&&y.isEqualOrParent(n,a))throw new Error((0,p.localize)(16,null,this.qb(a),this.qb(n)))}const v=await this.exists(n);if(v&&!o){if(!r)throw new w.$pk((0,p.localize)(17,null,this.qb(a),this.qb(n)),4);if(t===s){const{providerExtUri:y}=this.R(t);if(y.isEqualOrParent(a,n))throw new Error((0,p.localize)(18,null,this.qb(a),this.qb(n)))}}return{exists:v,isSameResourceWithDifferentPathCase:o}}R(t){const a=this.S(t);return{providerExtUri:a?c.$jg:c.$lg,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.ob(await this.j(t),t);await this.U(a,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new w.$mk(t,0,s)),s}async U(t,a){const s=[],{providerExtUri:n}=this.R(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&w.FileType.Directory))throw new Error((0,p.localize)(19,null,this.qb(a)));break}catch(i){if((0,w.$kk)(i)!==w.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(a)),a=n.dirname(a)}for(let i=s.length-1;i>=0;i--){a=n.joinPath(a,s[i]);try{await t.mkdir(a)}catch(r){if((0,w.$kk)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.W(t,a)}catch(s){return s}return!0}async W(t,a){const s=this.ob(await this.j(t),t),n=!!a?.useTrash;if(n&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.qb(t)));const i=a?.atomic;if(i&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.qb(t)));if(n&&i)throw new Error((0,p.localize)(22,null,this.qb(t)));let r;try{r=await s.stat(t)}catch{}if(r)this.pb(t,r);else throw new w.$pk((0,p.localize)(23,null,this.qb(t)),1);if(!!!a?.recursive){const v=await this.resolve(t);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,p.localize)(24,null,this.qb(t)))}return s}async del(t,a){const s=await this.W(t,a);let n=a;if((0,w.$ek)(s)&&!n?.atomic){const v=s.enforceAtomicDelete?.(t);v&&(n={...a,atomic:v})}const i=!!n?.useTrash,r=!!n?.recursive,o=n?.atomic??!1;await s.delete(t,{recursive:r,useTrash:i,atomic:o}),this.r.fire(new w.$mk(t,1))}async cloneFile(t,a){const s=await this.j(t),n=this.ob(await this.n(a),a);if(s===n&&this.R(s).providerExtUri.isEqual(t,a))return;if(s===n&&(0,w.$_j)(s))return s.cloneFile(t,a);await this.U(n,this.R(n).providerExtUri.dirname(a));const i=this.ab.queueFor(t,this.R(s).providerExtUri);return s===n&&(0,w.$$j)(s)?i.queue(()=>s.copy(t,a,{overwrite:!0})):i.queue(()=>this.O(s,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const s=new d.$Pc;let n=!1,i=()=>{n=!0};return s.add((0,d.$Oc)(()=>i())),(async()=>{try{const r=await this.$(t,a);n?(0,d.$Lc)(r):i=()=>(0,d.$Lc)(r)}catch(r){this.b.error(r)}})(),s}async $(t,a){const s=await this.j(t),n=(0,D.$Ai)([this.R(s).providerExtUri.getComparisonKey(t),a]);let i=this.Z.get(n);return i||(i={count:0,disposable:s.watch(t,a)},this.Z.set(n,i)),i.count+=1,(0,d.$Oc)(()=>{i&&(i.count--,i.count===0&&((0,d.$Lc)(i.disposable),this.Z.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,d.$Lc)(t.disposable);this.Z.clear()}async bb(t,a,s,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{const i=await t.open(a,{create:!0,unlock:s?.unlock??!1});try{(0,g.$Xd)(n)||(0,g.$Yd)(n)?await this.cb(t,i,n):await this.db(t,i,n)}catch(r){throw(0,w.$ik)(r)}finally{await t.close(i)}})}async cb(t,a,s){let n=0,i;if((0,g.$Yd)(s)){if(s.buffer.length>0){const r=j.$_d.concat(s.buffer);await this.eb(t,a,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((r,o)=>{(0,g.$4d)(i,{onData:async v=>{i.pause();try{await this.eb(t,a,v,v.byteLength,n,0)}catch(y){return o(y)}n+=v.byteLength,setTimeout(()=>i.resume())},onError:v=>o(v),onEnd:()=>r()})})}async db(t,a,s){let n=0,i;for(;(i=s.read())!==null;)await this.eb(t,a,i,i.byteLength,n,0),n+=i.byteLength}async eb(t,a,s,n,i,r){let o=0;for(;o<n;){const v=await t.write(a,i+o,s.buffer,r+o,n-o);o+=v}}async fb(t,a,s,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(()=>this.gb(t,a,s,n))}async gb(t,a,s,n){let i;n instanceof j.$_d?i=n:(0,g.$Xd)(n)?i=await(0,j.$le)(n):(0,g.$Yd)(n)?i=await(0,j.$me)(n):i=(0,j.$je)(n),await t.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async hb(t,a,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.ib(t,a,s,n))}async ib(t,a,s,n){let i,r;try{i=await t.open(a,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const o=j.$_d.alloc(this.a);let v=0,y=0,f=0;do f=await t.read(i,v,o.buffer,y,o.byteLength-y),await this.eb(s,r,o,f,v,y),v+=f,y+=f,y===o.byteLength&&(y=0);while(f>0)}catch(o){throw(0,w.$ik)(o)}finally{await N.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async jb(t,a,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.kb(t,a,s,n))}async kb(t,a,s,n){return s.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,a,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.mb(t,a,s,n))}async mb(t,a,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.eb(s,i,j.$_d.wrap(r),r.byteLength,0,0)}catch(r){throw(0,w.$ik)(r)}finally{await s.close(i)}}async nb(t,a,s,n){const i=await(0,j.$le)(this.H(t,a,A.CancellationToken.None));await this.fb(s,n,void 0,i)}ob(t,a){if(t.capabilities&2048)throw new w.$pk((0,p.localize)(25,null,this.qb(a)),6);return t}pb(t,a){if((a.permissions??0)&w.FilePermission.Readonly)throw new w.$pk((0,p.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};e.$Fp=b,e.$Fp=b=ye([x(0,l.$7i)],b)}),define(oe[200],ae([0,1,52,271,5,34,15,3,48,2,16,6,21,46,31,162,11,99,198,38,194,193]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0,(()=>{try{(0,N.gracefulify)(O)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.$xi)(a)}`)}})();class t extends l.$Op{static{this.I=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=D.Event.None,this.N=new A.$yc(i=>$.$kg.getComparisonKey(i)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:n,symbolicLink:i}=await g.SymlinkSupport.stat(this.H(s));return{type:this.M(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:w.FilePermission.Locked}}catch(n){throw this.eb(n)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await g.Promises.readdir(this.H(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,$.$tg)(s,r.name))).type:o=this.M(r),i.push([r.name,o])}catch(o){this.a.trace(o)}})),i}catch(n){throw this.eb(n)}}M(s,n){let i;return n?.dangling?i=w.FileType.Unknown:s.isFile()?i=w.FileType.File:s.isDirectory()?i=w.FileType.Directory:i=w.FileType.Unknown,n&&(i|=w.FileType.SymbolicLink),i}async O(s){const n=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const r=new j.$Qg;return this.N.set(s,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,d.$Oc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(s)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),i=await this.O(s));const r=this.H(s);return await g.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{i?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,n,i){const r=(0,c.$Zd)(o=>I.$_d.concat(o.map(v=>I.$_d.wrap(v))).buffer);return(0,h.$Ep)(this,s,r,o=>o.buffer,{...n,bufferSize:256*1024},i),r}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.Q(s,(0,$.$tg)((0,$.$sg)(s),`${(0,$.$qg)(s)}${i.atomic.postfix}`),n,i):this.R(s,n,i)}async Q(s,n,i,r){const o=new d.$Pc;try{o.add(await this.O(s)),o.add(await this.O(n)),await this.R(n,i,r,!0);try{await this.rename(n,s,{overwrite:!0})}catch(v){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async R(s,n,i,r){let o;try{const v=this.H(s);if(!i.create||!i.overwrite){if(await g.Promises.exists(v)){if(!i.overwrite)throw(0,w.$hk)((0,p.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,w.$hk)((0,p.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(s,{create:!0,unlock:i.unlock},r),await this.write(o,0,n,0,n.byteLength)}catch(v){throw await this.fb(s,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.X=!0}static configureFlushOnWrite(s){t.X=s}async open(s,n,i){const r=this.H(s);let o;(0,w.$9j)(n)&&!i&&(o=await this.O(s));let v;try{if((0,w.$9j)(n)&&n.unlock)try{const{stat:f}=await g.SymlinkSupport.stat(r);f.mode&128||await g.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let y;if((0,w.$9j)(n)){if(E.$i)try{await g.Promises.truncate(r,0),y="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}y||(y="w")}else y="r";v=await g.Promises.open(r,y)}catch(y){throw o?.dispose(),(0,w.$9j)(n)?await this.fb(s,y):this.eb(y)}if(this.S.set(v,0),(0,w.$9j)(n)&&this.W.set(v,s),o){const y=this.U.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.U.set(v,o),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),y.dispose())}return v}async close(s){const n=this.U.get(s);try{if(this.S.delete(s),this.W.delete(s)&&t.X)try{await g.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await g.Promises.close(s)}catch(i){throw this.eb(i)}finally{n&&(this.U.get(s)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.U.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,r,o){const v=this.Y(s,n);let y=null;try{y=(await g.Promises.read(s,i,r,o,v)).bytesRead}catch(f){throw this.eb(f)}finally{this.Z(s,v,y)}return y}Y(s,n){return n===this.S.get(s)?null:n}Z(s,n,i){const r=this.S.get(s);typeof r=="number"&&(typeof n=="number"||(typeof i=="number"?this.S.set(s,r+i):this.S.delete(s)))}async write(s,n,i,r,o){return(0,j.$0g)(()=>this.$(s,n,i,r,o),100,3)}async $(s,n,i,r,o){const v=this.Y(s,n);let y=null;try{y=(await g.Promises.write(s,i,r,o,v)).bytesWritten}catch(f){throw await this.fb(this.W.get(s),f)}finally{this.Z(s,v,y)}return y}async mkdir(s){try{await g.Promises.mkdir(this.H(s))}catch(n){throw this.eb(n)}}async delete(s,n){try{const i=this.H(s);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,P.$hc)((0,P.$kc)(i),`${(0,P.$lc)(i)}${n.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:y}=await g.SymlinkSupport.stat(i);o=v.isDirectory()&&!y}catch{}if(o)await g.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.eb(i)}}async rename(s,n,i){const r=this.H(s),o=this.H(n);if(r!==o)try{await this.ab(s,n,"move",i.overwrite),await g.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,P.$lc)(r),(0,P.$lc)((0,P.$kc)(o)),v.toString()))),this.eb(v)}}async copy(s,n,i){const r=this.H(s),o=this.H(n);if(r!==o)try{await this.ab(s,n,"copy",i.overwrite),await g.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,P.$lc)(r),(0,P.$lc)((0,P.$kc)(o)),v.toString()))),this.eb(v)}}async ab(s,n,i,r){const o=this.H(s),v=this.H(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,C.$Uf)(o,v,!0)),y){if(i==="copy")throw(0,w.$hk)((0,p.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const m=await this.L(s);if(!m)throw(0,w.$hk)((0,p.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(n);if(L){if(!r)throw(0,w.$hk)((0,p.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);m.type&w.FileType.File&&L.type&w.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.bb(s,n,!1)}async bb(s,n,i){const r=this.H(s),o=this.H(n),v=!!(this.capabilities&1024);if((0,C.$Uf)(r,o,!v))return;const y=new d.$Pc;try{y.add(await this.O(s)),y.add(await this.O(n)),i&&await g.Promises.mkdir((0,P.$kc)(o),{recursive:!0}),await g.Promises.copyFile(r,o)}catch(f){if(f.code==="ENOENT"&&!i)return this.bb(s,n,!0);throw this.eb(f)}finally{y.dispose()}}t(s,n,i){return new b.$Vp(r=>s(r),r=>n(r),i)}F(s,n,i){return new S.$4p(r=>s(r),r=>n(r),i)}eb(s){if(s instanceof w.$gk)return s;let n=s,i;switch(s.code){case"ENOENT":i=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=w.FileSystemProviderErrorCode.Unknown;break;default:i=w.FileSystemProviderErrorCode.Unknown}return(0,w.$hk)(n,i)}async fb(s,n){let i=this.eb(n);if(s&&i.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(s));r.mode&128||(i=(0,w.$hk)(n,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$5p=t}),define(oe[101],ae([0,1,3,2,4,7]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=e.$I8b=void 0,e.$I8b=(0,j.$Mh)("sharedProcessLifecycleService");let I=class extends N.$Qc{constructor(C){super(),this.b=C,this.a=this.B(new O.$Ld),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$J8b=I,e.$J8b=I=ye([x(0,A.$7i)],I)}),define(oe[201],ae([0,1,9,3,7,2]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0;class I extends j.$fj{constructor(E,$,c,g,p){super($,c,g),this.r=E,this.t=p,this.B(p.listen("onDidChangeLogLevel",E)(w=>{(0,j.$9i)(w)?super.setLogLevel(w):super.setLogLevel(O.URI.revive(w[0]),w[1])})),this.B(p.listen("onDidChangeVisibility",E)(([w,h])=>super.setVisibility(O.URI.revive(w),h))),this.B(p.listen("onDidChangeLoggers",E)(({added:w,removed:h})=>{for(const l of w)super.registerLogger({...l,resource:O.URI.revive(l.resource)});for(const l of h)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new j.$dj({log:(E,$)=>{this.t.call("consoleLog",[E,$])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,$){super.setLogLevel(E,$),this.t.call("setLogLevel",[E,$])}setVisibility(E,$){super.setVisibility(E,$),this.t.call("setVisibility",[this.n(E),$])}s(E,$,c){return new D(this.t,E,$,c,this.r)}static setLogLevel(E,$,c){return E.call("setLogLevel",[$,c])}}e.$3q=I;class D extends j.$aj{constructor(E,$,c,g,p){super(g?.logLevel==="always"),this.r=E,this.s=$,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[$,g,p]).then(()=>{this.u(this.n),this.m=!0})}g(E,$){const c=[[E,$]];this.m?this.u(c):this.n.push(...c)}u(E){this.r.call("log",[this.s,E])}}class C{constructor(E,$){this.a=E,this.b=$}listen(E,$){const c=this.b(E);switch($){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(p=>this.c(p,c)),removed:[...g.removed].map(p=>this.c(p,c))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,g=>[c.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,g=>(0,j.$9i)(g)?g:[c.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${$}`)}async call(E,$,c){const g=this.b(E);switch($){case"setLogLevel":return(0,j.$9i)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(O.URI.revive(g.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,g)))}throw new Error(`Call not found: ${$}`)}c(E,$){return{...E,resource:$.transformOutgoingURI(E.resource)}}}e.$4q=C;class d extends A.$Qc{constructor(E,$){super(),$.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(c=>$.call("setLogLevel",[c]))),$.call("getRegisteredLoggers").then(c=>{for(const g of c)E.registerLogger({...g,resource:O.URI.revive(g.resource)})}),this.B($.listen("onDidChangeVisibility")(([c,g])=>E.setVisibility(O.URI.revive(c),g))),this.B($.listen("onDidChangeLoggers")(({added:c,removed:g})=>{for(const p of c)E.registerLogger({...p,resource:O.URI.revive(p.resource)});for(const p of g)E.deregisterLogger(p.resource)}))}}e.$5q=d}),define(oe[202],ae([0,1,2,7]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;class j extends O.$Qc{constructor(I,D=[]){super(),this.a=new N.$ej([I,...D]),this.B(I.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...D){this.a.trace(I,...D)}debug(I,...D){this.a.debug(I,...D)}info(I,...D){this.a.info(I,...D)}warn(I,...D){this.a.warn(I,...D)}error(I,...D){this.a.error(I,...D)}flush(){this.a.flush()}}e.$tN=j}),define(oe[55],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=void 0,e.$D6b=(0,O.$Mh)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=void 0,e.$_m=(0,A.$Mh)("policy");class I extends j.$Qc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$Ld),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const P=Object.keys(this.f).length;return this.f={...d,...this.f},P!==Object.keys(this.f).length&&await this.j(d),N.Iterable.reduce(this.g.entries(),(E,[$,c])=>({...E,[$]:c}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(d,[P,E])=>({...d,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.$an=I;class D{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$bn=D}),define(oe[203],ae([0,1,3,2,56]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=void 0;class A{constructor(C){this.b=C,this.a=new N.$Pc}listen(C,d){switch(d){case"onDidChange":return O.Event.map(this.b.onDidChange,P=>P.reduce((E,$)=>({...E,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(C,d,P){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$r7b=A;class I extends j.$an{constructor(C,d){super(),this.a=d;for(const P in C){const{definition:E,value:$}=C[P];this.f[P]=E,$!==void 0&&this.g.set(P,$)}this.a.listen("onDidChange")(P=>{for(const E in P){const $=P[E];$===null?this.g.delete(E):this.g.set(E,$)}this.h.fire(Object.keys(P))})}async j(C){const d=await this.a.call("updatePolicyDefinitions",C);for(const P in d)this.g.set(P,d[P])}}e.$s7b=I}),define(oe[102],ae([0,1,6,37]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let j;if(typeof O.$g.vscode<"u"&&typeof O.$g.vscode.context<"u"){const A=O.$g.vscode.context.configuration();if(A)j=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(j=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(j,{nameShort:`${j.nameShort} Dev`,nameLong:`${j.nameLong} Dev`,dataFolderName:`${j.dataFolderName}-dev`,serverDataFolderName:j.serverDataFolderName?`${j.serverDataFolderName}-dev`:void 0}),!j.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(j,{version:A.version})}}else j={},Object.keys(j).length===0&&Object.assign(j,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=j}),define(oe[24],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=void 0,e.$mj=(0,O.$Mh)("productService"),e.$nj="vscode://schemas/vscode-product"}),define(oe[204],ae([0,1,5,8,2,16,31,7,24]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=void 0;let d=class extends j.$Qc{constructor(E,$,c){super(),this.b=$,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new O.$4g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),c=(0,A.$kc)(E),g=(0,A.$lc)(E),p=await I.Promises.readdir(c);await Promise.all(p.map(async w=>{if(w===g)return;const h=(0,A.$hc)(c,w),l=await I.Promises.stat(h);if(l.isDirectory()&&$-l.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),I.Promises.rm(h)}))}catch($){(0,N.$Y)($)}}};e.$d8b=d,e.$d8b=d=ye([x(1,C.$mj),x(2,D.$7i)],d)}),define(oe[205],ae([0,1,5,8,2,16,31,14,7,24]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;let P=class extends j.$Qc{constructor($,c,g){super(),this.b=$,this.c=c,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$4g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),c=JSON.parse(await I.Promises.readFile((0,A.$hc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const l of Object.keys(c)){const u=c[l];$[`${u.hash}.${l}`]=!0}const g=(0,A.$hc)(this.b.userDataPath,"clp");if(!await I.Promises.exists(g))return;const w=await I.Promises.readdir(g);for(const l of w){if($[l]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${l}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${l}`),await I.Promises.rm((0,A.$hc)(g,l))}const h=Date.now();for(const l of Object.keys($)){const u=(0,A.$hc)(g,l),b=await I.Promises.readdir(u);for(const S of b){if(S==="tcf.json")continue;const t=(0,A.$hc)(u,S),a=await I.Promises.stat(t);a.isDirectory()&&h-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$hc)(l,S)}`),await I.Promises.rm(t))}}}catch($){(0,N.$Y)($)}}};e.$e8b=P,e.$e8b=P=ye([x(0,D.$Uh),x(1,C.$7i),x(2,d.$mj)],P)}),define(oe[206],ae([0,1,16,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$NE=void 0,e.$NE=(0,N.$Mh)("IV8InspectProfilingService");var j;(function(A){function I(C){return!!(C.samples&&C.timeDeltas)}A.isValidProfile=I;function D(C,d="noAbsolutePaths"){for(const P of C.nodes)P.callFrame&&P.callFrame.url&&((0,O.$gc)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,O.$hc)(d,(0,O.$lc)(P.callFrame.url)));return C}A.rewriteAbsolutePaths=D})(j||(e.Utils=j={}))}),define(oe[207],ae([0,1,32]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const D=await(await new Promise((d,P)=>{te(["v8-inspect-profiler"],d,P)})).startProfiling({port:A.port,checkForPaused:!0}),C=(0,O.$cg)();return this.a.set(C,D),C}async stopProfiling(A){const I=this.a.get(A);if(!I)throw new Error(`UNKNOWN session '${A}'`);const D=await I.stop();return this.a.delete(A),D.profile}}e.$y8b=N}),define(oe[40],ae([0,1,127,12]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;class j{constructor(){this.a=new Map}add(I,D){O.ok(N.$wf(I)),O.ok(N.$yf(D)),O.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,D)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$0m=new j}),define(oe[103],ae([0,1,3,40]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$$m={JSONContribution:"base.contributions.json"};function j(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this.b=new O.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,d){this.a[j(C)]=d,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const I=new A;N.$0m.add(e.$$m.JSONContribution,I)}),define(oe[49],ae([0,1,18,3,12,149,19,103,40]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ConfigurationScope=e.$cn=e.EditPresentationTypes=void 0;var d;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$cn={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn="vscode://schemas/settings/resourceLanguage",e.$kn="vscode://schemas/settings/configurationDefaults";const E=C.$0m.as(D.$$m.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$Ld,this.onDidSchemaChange=this.i.event,this.j=new N.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$jn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const s=new Set;this.n(t,a,s),E.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const a=new Set;this.o(t,a),E.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const s=new Set;this.o(a,s),this.n(t,!1,s),E.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const s=[];for(const{overrides:n,source:i}of t)for(const r in n)if(a.add(r),e.$mn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(i)for(const L of Object.keys(n[r]))v.set(L,i);const y={...o?.value||{},...n[r]};this.a.set(r,{source:i,value:y,valuesSources:v});const f=(0,I.$qi)(r),m={type:"object",default:y,description:A.localize(1,null,f),$ref:e.$jn,defaultDefaultValue:y,source:j.$wf(i)?void 0:i,defaultValueSource:i};s.push(...p(r)),this.d[r]=m,this.b.properties[r]=m}else{this.a.set(r,{value:n[r],source:i});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(s)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:s,source:n}of t)for(const i in s){const r=this.a.get(i),o=j.$wf(n)?n:n?.id,v=j.$wf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(i),this.a.delete(i),e.$mn.test(i))delete this.d[i],delete this.b.properties[i];else{const y=this.d[i];y&&(this.w(i,y),this.r(i,y))}}this.u()}deltaConfiguration(t){let a=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,s){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,a){const s=n=>{if(n.properties)for(const i in n.properties){a.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,a=!0,s,n,i=3,r){i=j.$Ff(t.scope)?i:t.scope;const o=t.properties;if(o)for(const y in o){const f=o[y];if(a&&u(y,f)){delete o[y];continue}if(f.source=s,f.defaultDefaultValue=o[y].default,this.w(y,f),e.$mn.test(y)?f.scope=void 0:(f.scope=j.$Ff(f.scope)?i:f.scope,f.restricted=j.$Ff(f.restricted)?!!n?.includes(y):f.restricted),o[y].hasOwnProperty("included")&&!o[y].included){this.f[y]=o[y],delete o[y];continue}else this.d[y]=o[y],o[y].policy?.name&&this.e.set(o[y].policy.name,y);!o[y].deprecationMessage&&o[y].markdownDeprecationMessage&&(o[y].deprecationMessage=o[y].markdownDeprecationMessage),r.add(y)}const v=t.allOf;if(v)for(const y of v)this.p(y,a,s,n,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=s=>{const n=s.properties;if(n)for(const r in n)this.r(r,n[r]);s.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$dn.properties[t]=a,a.scope){case 1:e.$en.properties[t]=a;break;case 2:e.$fn.properties[t]=a;break;case 6:e.$gn.properties[t]=a;break;case 3:e.$hn.properties[t]=a;break;case 4:e.$in.properties[t]=a;break;case 5:e.$in.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$dn.properties[t],a.scope){case 1:delete e.$en.properties[t];break;case 2:delete e.$fn.properties[t];break;case 6:delete e.$gn.properties[t];break;case 3:delete e.$hn.properties[t];break;case 4:case 5:delete e.$in.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$jn};this.w(a,s),e.$dn.properties[a]=s,e.$en.properties[a]=s,e.$fn.properties[a]=s,e.$gn.properties[a]=s,e.$hn.properties[a]=s,e.$in.properties[a]=s}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$jn};e.$dn.patternProperties[e.$ln]=t,e.$en.patternProperties[e.$ln]=t,e.$fn.patternProperties[e.$ln]=t,e.$gn.patternProperties[e.$ln]=t,e.$hn.patternProperties[e.$ln]=t,e.$in.patternProperties[e.$ln]=t,this.i.fire()}w(t,a){const s=this.a.get(t);let n=s?.value,i=s?.source;j.$Df(n)&&(n=a.defaultDefaultValue,i=void 0),j.$Df(n)&&(n=h(a.type)),a.default=n,a.defaultValueSource=i}}const c="\\[([^\\]]+)\\]",g=new RegExp(c,"g");e.$ln=`^(${c})+$`,e.$mn=new RegExp(e.$ln);function p(S){const t=[];if(e.$mn.test(S)){let a=g.exec(S);for(;a?.length;){const s=a[1].trim();s&&t.push(s),a=g.exec(S)}}return(0,O.$Kb)(t)}e.$nn=p;function w(S){return S.reduce((t,a)=>`${t}[${a}]`,"")}e.$on=w;function h(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$pn=h;const l=new $;C.$0m.add(e.$cn.Configuration,l);function u(S,t){return S.trim()?e.$mn.test(S)?A.localize(7,null,S):l.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,S,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$qn=u;function b(){const S=[],t=l.getConfigurationProperties();for(const a of Object.keys(t))S.push([a,t[a].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.$rn=b}),define(oe[73],ae([0,1,18,3,35,2,34,30,12,9,19,49,40]),function(te,e,O,N,j,A,I,D,C,d,P,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=void 0;function c(a){return Object.isFrozen(a)?a:D.$Ym(a)}class g{constructor(s={},n=[],i=[],r){this.b=s,this.c=n,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof g)return n;const i=new p("");return i.parseRaw(n),i.configurationModel});this.f=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,P.$oi)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,o=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:r,merged:o}}getOverrideValue(s,n){const i=this.i(n);return i?s?(0,P.$oi)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return O.$Kb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return O.$Kb(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=D.$Xm(this.contents),i=D.$Xm(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of s)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(n,v.contents);for(const y of v.overrides){const[f]=i.filter(m=>O.$sb(m.identifiers,y.identifiers));f?(this.h(f.contents,y.contents),f.keys.push(...y.keys),f.keys=O.$Kb(f.keys)):i.push(D.$Xm(y))}for(const y of v.keys)r.indexOf(y)===-1&&r.push(y)}return new g(n,r,i,o.every(v=>v instanceof g)?void 0:o)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of O.$Kb([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r];const v=n[r];v&&(typeof o=="object"&&typeof v=="object"?(o=D.$Xm(o),this.h(o,v)):o=v),i[r]=o}return new g(i,this.keys,this.overrides)}h(s,n){for(const i of Object.keys(n)){if(i in s&&C.$yf(s[i])&&C.$yf(n[i])){this.h(s[i],n[i]);continue}s[i]=D.$Xm(n[i])}}i(s){let n=null,i=null;const r=o=>{o&&(i?this.h(i,o):i=D.$Xm(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===s?n=o.contents:o.identifiers.includes(s)&&r(o.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,P.$ni)(this.contents,s),E.$mn.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>O.$sb(i.identifiers,(0,E.$nn)(s))),1))}j(s,n,i){(0,P.$mi)(this.contents,s,n,r=>console.error(r)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),E.$mn.test(s)&&this.overrides.push({identifiers:(0,E.$nn)(s),keys:Object.keys(this.contents[s]),contents:(0,P.$li)(this.contents[s],r=>console.error(r))})}}e.$sn=g;class p{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!C.$Ff(s)){const i=this.g(s);this.parseRaw(i,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:i,keys:r,overrides:o,restricted:v,hasExcludedProperties:y}=this.h(s,n);this.b=new g(i,r,o,y?[s]:void 0),this.c=v||[]}g(s){let n={},i=null,r=[];const o=[],v=[];function y(m){Array.isArray(r)?r.push(m):i!==null&&(r[i]=m)}const f={onObjectBegin:()=>{const m={};y(m),o.push(r),r=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const m=[];y(m),o.push(r),r=m,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:y,onError:(m,L,F)=>{v.push({error:m,offset:L,length:F})}};if(s)try{j.$Um(s,f),n=r[0]||{}}catch(m){console.error(`Error while parsing settings file ${this.f}: ${m}`),this.d=[m]}return n}h(s,n){const i=$.$0m.as(E.$cn.Configuration).getConfigurationProperties(),r=this.i(s,i,!0,n);s=r.raw;const o=(0,P.$li)(s,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(s),y=this.j(s,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:o,keys:v,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(s,n,i,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:o};const v={},y=[];for(const f in s)if(E.$mn.test(f)&&i){const m=this.i(s[f],n,!1,r);v[f]=m.raw,o=o||m.hasExcludedProperties,y.push(...m.restricted)}else{const m=n[f],L=m?typeof m.scope<"u"?m.scope:3:void 0;m?.restricted&&y.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(L===void 0||r.scopes===void 0||r.scopes.includes(L))&&!(r.skipRestricted&&m?.restricted))?v[f]=s[f]:o=!0}return{raw:v,restricted:y,hasExcludedProperties:o}}j(s,n){const i=[];for(const r of Object.keys(s))if(E.$mn.test(r)){const o={};for(const v in s[r])o[v]=s[r][v];i.push({identifiers:(0,E.$nn)(r),keys:Object.keys(o),contents:(0,P.$li)(o,n)})}return i}}e.$tn=p;class w extends A.$Qc{constructor(s,n,i,r){super(),this.c=s,this.f=n,this.g=r,this.b=this.B(new N.$Ld),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&i.isEqual(o.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$un=w;class h{constructor(s,n,i,r,o,v,y,f,m,L,F,T,z){this.a=s,this.b=n,this.c=i,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=y,this.h=f,this.i=m,this.j=L,this.k=F,this.l=T,this.m=z}get value(){return c(this.c)}n(s,n,i){const r=s.inspect(n,i);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(s,n,i,r,o=new g,v=new g,y=new I.$yc,f=new g,m=new I.$yc){this.c=s,this.d=n,this.f=i,this.g=r,this.h=o,this.i=v,this.j=y,this.l=f,this.m=m,this.a=null,this.b=new I.$yc,this.n=null}getValue(s,n,i){return this.q(s,n,i).getValue(s)}updateValue(s,n,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new g,this.m.set(i.resource,r))):r=this.l,n===void 0?r.removeValue(s):r.setValue(s,n),i.resource||(this.a=null)}inspect(s,n,i){const r=this.q(s,n,i),o=this.u(n.resource,i),v=n.resource?this.m.get(n.resource)||this.l:this.l,y=new Set;for(const f of r.overrides)for(const m of f.identifiers)r.getOverrideValue(s,m)!==void 0&&y.add(m);return new h(s,n,r.getValue(s),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,o||void 0,v)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:r,updated:o,removed:v}=S(this.c,s);n=[...r,...o,...v]}for(const r of n)for(const o of(0,E.$nn)(r)){const v=this.c.getKeysForOverrideIdentifier(o),y=s.getKeysForOverrideIdentifier(o),f=[...y.filter(m=>v.indexOf(m)===-1),...v.filter(m=>y.indexOf(m)===-1),...v.filter(m=>!D.$2m(this.c.override(o).getValue(m),s.override(o).getValue(m)))];i.push([o,f])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:r}=S(this.d,s),o=[...n,...i,...r];return o.length&&this.updatePolicyConfiguration(s),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:r,overrides:o}=S(this.applicationConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateApplicationConfiguration(s),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:o}=S(this.localUserConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateLocalUserConfiguration(s),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:o}=S(this.remoteUserConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateRemoteUserConfiguration(s),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:r,overrides:o}=S(this.workspaceConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateWorkspaceConfiguration(s),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(s,n){const i=this.p.get(s),{added:r,updated:o,removed:v,overrides:y}=S(i,n),f=[...r,...o,...v];return(f.length||!i)&&this.updateFolderConfiguration(s,n),{keys:f,overrides:y}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:r,removed:o,overrides:v}=S(n,void 0);return{keys:[...i,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,i){let r=this.r(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}r({resource:s},n){let i=this.s();if(n&&s){const r=n.getFolder(s);r&&(i=this.t(r.uri)||i);const o=this.m.get(s);o&&(i=i.merge(o))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const i=this.s(),r=this.j.get(s);r?(n=i.merge(r),this.b.set(s,n)):n=i}return n}u(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:i,overrides:r,keys:o}=this.j.get(n);return s.push([n,{contents:i,overrides:r,keys:o}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.x(s.defaults),i=this.x(s.policy),r=this.x(s.application),o=this.x(s.user),v=this.x(s.workspace),y=s.folders.reduce((f,m)=>(f.set(d.URI.revive(m[0]),this.x(m[1])),f),new I.$yc);return new l(n,i,r,o,new g,v,y,new g,new I.$yc)}static x(s){return new g(s.contents,s.keys,s.overrides)}}e.$vn=l;function u(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const s=new Set,n=new Map;for(const r of a)r.keys.forEach(o=>s.add(o)),r.overrides.forEach(([o,v])=>{const y=(0,I.$vc)(n,o,new Set);v.forEach(f=>y.add(f))});const i=[];return n.forEach((r,o)=>i.push([o,[...r.values()]])),{keys:[...s.values()],overrides:i}}e.$wn=u;class b{constructor(s,n,i,r){this.change=s,this.f=n,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of s.keys)this.affectedKeys.add(o);for(const[,o]of s.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(s,n){const i=this.a+s,r=this.d.indexOf(i);if(r<0)return!1;const o=r+i.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,f=this.g.getValue(s,n,this.h);return!D.$2m(y,f)}return!0}}e.$xn=b;function S(a,s){const{added:n,removed:i,updated:r}=t(s?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],y=s?.getAllOverrideIdentifiers()||[];if(s){const f=y.filter(m=>!v.includes(m));for(const m of f)o.push([m,s.getKeysForOverrideIdentifier(m)])}if(a){const f=v.filter(m=>!y.includes(m));for(const m of f)o.push([m,a.getKeysForOverrideIdentifier(m)])}if(s&&a){for(const f of v)if(y.includes(f)){const m=t({contents:a.getOverrideValue(void 0,f)||{},keys:a.getKeysForOverrideIdentifier(f)},{contents:s.getOverrideValue(void 0,f)||{},keys:s.getKeysForOverrideIdentifier(f)});o.push([f,[...m.added,...m.removed,...m.updated]])}}return{added:n,removed:i,updated:r,overrides:o}}function t(a,s){const n=a?s?a.keys.filter(o=>s.keys.indexOf(o)===-1):[...a.keys]:[],i=s?a?s.keys.filter(o=>a.keys.indexOf(o)===-1):[...s.keys]:[],r=[];if(a&&s){for(const o of s.keys)if(a.keys.indexOf(o)!==-1){const v=(0,P.$oi)(s.contents,o),y=(0,P.$oi)(a.contents,o);D.$2m(v,y)||r.push(o)}}return{added:n,removed:i,updated:r}}}),define(oe[208],ae([0,1,18,3,2,30,12,73,49,7,56,40]),function(te,e,O,N,j,A,I,D,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=void 0;class $ extends j.$Qc{constructor(){super(...arguments),this.a=this.B(new N.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new D.$sn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$0m.as(C.$cn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:h})=>this.c(Array.from(w),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,h){this.h(w,E.$0m.as(C.$cn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new D.$sn;const w=E.$0m.as(C.$cn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,h){const l=this.f();for(const u of w){const b=l[u],S=h[u];b!==void 0?this.b.addValue(u,b):S?this.b.addValue(u,S.default):this.b.removeValue(u)}}}e.$yn=$;class c{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new D.$sn}async initialize(){return this.configurationModel}}e.$zn=c;let g=class extends j.$Qc{get configurationModel(){return this.b}constructor(w,h,l){super(),this.c=w,this.f=h,this.g=l,this.a=this.B(new N.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new D.$sn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const h={},l=[],u=E.$0m.as(C.$cn.Configuration).getConfigurationProperties();for(const b of w){const S=u[b];if(!S){l.push(b);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.g.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}l.push(b),h[S.policy.name]={type:S.type}}}return(0,I.$Jf)(h)||await this.f.updatePolicyDefinitions(h),l}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const h=E.$0m.as(C.$cn.Configuration).getPolicyConfigurations(),l=(0,O.$Fb)(w.map(u=>h.get(u)));this.m(l,!0)}m(w,h){this.g.trace("PolicyConfiguration#update",w);const l=E.$0m.as(C.$cn.Configuration).getConfigurationProperties(),u=[],b=this.b.isEmpty();for(const S of w){const t=l[S]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(b?a!==void 0:!(0,A.$2m)(this.b.getValue(S),a))&&u.push([S,a])}else this.b.getValue(S)!==void 0&&u.push([S,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const S=this.b;this.b=new D.$sn;for(const t of S.keys)this.b.setValue(t,S.getValue(t));for(const[t,a]of u)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};e.$An=g,e.$An=g=ye([x(1,P.$_m),x(2,d.$7i)],g)}),define(oe[209],ae([0,1,5,3,2,21,19,73,208,56]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=void 0;class P extends j.$Qc{constructor($,c,g,p){super(),this.j=$,this.h=this.B(new N.$Ld),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new C.$yn),this.c=g instanceof d.$bn?new C.$zn:this.B(new C.$An(this.b,g,p)),this.f=this.B(new D.$un(this.j,{},A.$kg,c)),this.a=new D.$vn(this.b.configurationModel,this.c.configurationModel,new D.$sn,new D.$sn),this.g=this.B(new O.$4g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:h})=>this.n(w,h))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,c,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new D.$vn($,c,new D.$sn,g)}getConfigurationData(){return this.a.toData()}getValue($,c){const g=typeof $=="string"?$:void 0,p=(0,I.$hi)($)?$:(0,I.$hi)(c)?c:{};return this.a.getValue(g,p,void 0)}updateValue($,c,g,p){return Promise.reject(new Error("not supported"))}inspect($){return this.a.inspect($,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.m($)}m($){const c=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration($);this.s(g,c,2)}n($,c){const g=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration($,c);this.s(p,g,7)}r($){const c=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration($);this.s(g,c,7)}s($,c,g){const p=new D.$xn($,{data:c},this.a);p.source=g,p.sourceConfig=this.t(g),this.h.fire(p)}t($){switch($){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Bn=P}),define(oe[210],ae([0,1,15,3,2,65]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkb=e.$lkb=e.$kkb=e.$jkb=void 0;const I=(d,P,E)=>{const $=new Uint8Array(16);for(let p=0;p<16;p++)$[p]=Math.round(Math.random()*256);const c=(0,O.$te)(O.$_d.wrap($));return[`GET ws://localhost${d}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$jkb=I,e.$kkb=O.$_d.fromString(`\r
\r
`);async function D(d,P,E,$,c){d.write(O.$_d.fromString((0,e.$jkb)(P,E,$)));const g=new j.$Pc;try{return await new Promise((p,w)=>{let h;g.add(d.onData(l=>{h?h=O.$_d.concat([h,l],h.byteLength+l.byteLength):h=l;const u=h.indexOf(e.$kkb);if(u===-1)return;p(d),d.pauseData();const b=h.slice(u+e.$kkb.byteLength);b.byteLength&&c.onData.fire(b)})),g.add(d.onClose(l=>w(l??new Error("socket closed")))),g.add(d.onEnd(()=>w(new Error("socket ended"))))})}catch(p){throw d.dispose(),p}finally{g.dispose()}}e.$lkb=D;class C extends j.$Qc{constructor(P,E){super(),this.g=P,this.a=this.B(new N.$Od),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$Ld),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event($=>this.a.fire($))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,E){A.SocketDiagnostics.traceSocketEvent(this,this.g,P,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$mkb=C}),define(oe[211],ae([0,1,8,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.RemoteAuthorityResolverErrorCode=e.$Nk=e.$Mk=e.RemoteConnectionType=e.$Lk=void 0,e.$Lk=(0,N.$Mh)("remoteAuthorityResolverService");var j;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(j||(e.RemoteConnectionType=j={}));class A{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Mk=A;class I{constructor(E,$){this.host=E,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nk=I;var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(D||(e.RemoteAuthorityResolverErrorCode=D={}));class C extends O.$_{static isNotAvailable(E){return E instanceof C&&E._code===D.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof C&&E._code===D.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof C&&E._code===D.NoResolverFound}static isInvalidAuthority(E){return E instanceof C&&E._code===D.InvalidAuthority}static isHandled(E){return E instanceof C&&E.isHandled}constructor(E,$=D.Unknown,c){super(E),this._message=E,this._code=$,this._detail=c,this.isHandled=$===D.NotAvailable&&c===!0,Object.setPrototypeOf(this,C.prototype)}}e.$Ok=C;function d(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$Pk=d}),define(oe[74],ae([0,1,23]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=void 0;function N(d){return d.scheme===O.Schemas.vscodeRemote?d.authority:void 0}e.$Qk=N;function j(d){if(!d)return;const P=d.indexOf("+");return P<0?d:d.substr(0,P)}e.$Rk=j;function A(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$Sk=A;function I(d){const{host:P,port:E}=C(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$Tk=I;function D(d,P){let{host:E,port:$}=C(d);return typeof $>"u"&&($=P),{host:E,port:$}}e.$Uk=D;function C(d){const P=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const $=d.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:d,port:void 0}}}),define(oe[44],ae([0,1,27,4,74]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.TargetPlatform=e.ExtensionType=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl="extensions.user.cache",e.$Sl="extensions.builtin.cache",e.$Tl="undefined_publisher",e.$Ul=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Vl=A,e.$Wl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(I||(e.ExtensionType=I={}));var D;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(D||(e.TargetPlatform=D={}));class C{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,h){if(typeof w>"u"||w===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof w=="string"||typeof h=="string"){const l=typeof w=="string"?w:w.value,u=typeof h=="string"?h:h.value;return O.$Ze(l,u)}return w._lower===h._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Xl=C;class d{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const h of w)this.add(h)}add(w){this.c.add(C.toKey(w))}delete(w){return this.c.delete(C.toKey(w))}has(w){return this.c.has(C.toKey(w))}}e.$Yl=d;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(C.toKey(w))}get(w){return this.c.get(C.toKey(w))}has(w){return this.c.has(C.toKey(w))}set(w,h){this.c.set(C.toKey(w),h)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zl=P;function E(p){return $(p)}e.$1l=E;function $(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$2l=$;function c(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$3l=c;function g(p,w){if(w){const h=`onResolveRemoteAuthority:${(0,j.$Rk)(w)}`;return!!p.activationEvents?.includes(h)}return!1}e.$4l=g,e.$5l=(0,N.$Mh)("IBuiltinExtensionsScannerService")}),define(oe[212],ae([0,1,2,44,11]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;class A extends O.$Qc{constructor(D,C,d,P,E){super(),this.a=D,this.b=C,this.c=d,this.f=E,this.B(P.onDidInstallExtensions($=>this.g($))),this.B(P.onDidUninstallExtension($=>this.h($)))}g(D){for(const C of D)C.local&&this.invalidate(C.profileLocation)}h(D){D.error||this.invalidate(D.profileLocation)}async invalidate(D){if(D)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,D)&&await this.j(C);else await this.j(this.a.defaultProfile)}async j(D){try{await this.b.del(this.c.extUri.joinPath(D.cacheHome,N.$Rl))}catch(C){(0,j.$lk)(C)!==1&&this.f.error(C)}}}e.$yp=A}),define(oe[213],ae([0,1,5,15,26,8,3,2,100,60,32,65,211,74]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.PersistentConnectionEventType=e.$2k=e.$1k=e.$Zk=e.ConnectionType=void 0;const g=30*1e3;var p;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function w(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(B){const k=new j.$Vd;return setTimeout(()=>k.cancel(),B),k.token}function l(B,k){if(B.isCancellationRequested||k.isCancellationRequested)return j.CancellationToken.Cancelled;const R=new j.$Vd;return B.onCancellationRequested(()=>R.cancel()),k.onCancellationRequested(()=>R.cancel()),R.token}class u{get didTimeout(){return this.c==="timedout"}constructor(k){this.c="pending",this.d=new D.$Pc,this.promise=new Promise((R,U)=>{this.f=R,this.g=U}),k.isCancellationRequested?this.h():this.d.add(k.onCancellationRequested(()=>this.h()))}registerDisposable(k){this.c==="pending"?this.d.add(k):k.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const k=new Error("Time limit reached");return k.code="ETIMEDOUT",k.syscall="connect",k}resolve(k){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(k))}reject(k){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(k))}}function b(B,k){const R=new u(k);return R.registerDisposable(B.onControlMessage(U=>{const M=JSON.parse(U.toString()),J=V(M);J?R.reject(J):R.resolve(M)})),R.promise}function S(B,k,R,U,M,J,X,se){const le=new u(se),ue=d.$Hd.create(!1);return B.info(`Creating a socket (${X})...`),C.mark(`code/willCreateSocket/${J}`),k.connect(R,U,M,X).then(he=>{le.didTimeout?(C.mark(`code/didCreateSocketError/${J}`),B.info(`Creating a socket (${X}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(C.mark(`code/didCreateSocketOK/${J}`),B.info(`Creating a socket (${X}) was successful after ${ue.elapsed()} ms.`),le.resolve(he))},he=>{C.mark(`code/didCreateSocketError/${J}`),B.info(`Creating a socket (${X}) returned an error after ${ue.elapsed()} ms.`),B.error(he),le.reject(he)}),le.promise}function t(B,k){const R=new u(k);return B.then(U=>{R.didTimeout||R.resolve(U)},U=>{R.didTimeout||R.reject(U)}),R.promise}async function a(B,k,R,U){const M=re(B,k);B.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let J;try{J=await S(B.logService,B.remoteSocketFactoryService,B.connectTo,(0,c.$Sk)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,w(k),`renderer-${w(k)}-${B.reconnectionToken}`,U)}catch(he){throw B.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),B.logService.error(he),he}B.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let X,se;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(J,null),X=B.reconnectionProtocol,se=!1):(X=new E.$Ah({socket:J}),se=!0),B.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const le=await t(B.signService.createNewMessage((0,P.$cg)()),U),ue={type:"auth",auth:B.connectionToken||"00000000000000000000",data:le.data};X.sendControl(N.$_d.fromString(JSON.stringify(ue)));try{const he=await b(X,l(U,h(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(B.logService.trace(`${M} 4/6. received SignRequest control message.`),!await t(B.signService.validate(le,he.signedData),U)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await t(B.signService.sign(he.data),U),we={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:k};return R&&(we.args=R),B.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(N.$_d.fromString(JSON.stringify(we))),{protocol:X,ownsProtocol:se}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(B.logService.error(`${M} the handshake timed out. Error:`),B.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${M} received error control message when negotiating connection. Error:`),B.logService.error(he)),se&&H(X),he}}async function s(B,k,R,U){const M=Date.now(),J=re(B,k),{protocol:X,ownsProtocol:se}=await a(B,k,R,U),le=new u(U);return le.registerDisposable(X.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=V(he);$e?(B.logService.error(`${J} received error control message when negotiating connection. Error:`),B.logService.error($e),se&&H(X),le.reject($e)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${Y(M)}!`),le.resolve({protocol:X,firstMessage:he}))})),le.promise}async function n(B,k){const{protocol:R}=await s(B,1,void 0,k);return{protocol:R}}async function i(B,k,R){const{protocol:U,firstMessage:M}=await s(B,2,k,R),J=M&&M.debugPort;return{protocol:U,debugPort:J}}async function r(B,k,R){const U=Date.now(),M=re(B,3),{protocol:J}=await a(B,3,k,R);return B.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${Y(U)}!`),J}async function o(B,k,R){const{connectTo:U,connectionToken:M}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,connectTo:U,connectionToken:M,reconnectionToken:k,reconnectionProtocol:R,remoteSocketFactoryService:B.remoteSocketFactoryService,signService:B.signService,logService:B.logService}}async function v(B,k,R){return f(B,async U=>{const{protocol:M}=await n(U,j.CancellationToken.None);return new G(B,k,R,U.reconnectionToken,M)})}e.$Zk=v;async function y(B,k){return f(B,async R=>{const{protocol:U,debugPort:M}=await i(R,k,j.CancellationToken.None);return new K(B,k,R.reconnectionToken,U,M)})}e.$1k=y;async function f(B,k){for(let U=1;;U++)try{const M=(0,P.$cg)(),J=await o(B,M,null);return await k(J)}catch(M){if(U<5)B.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(M);else throw B.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(M),Z.triggerPermanentFailure(0,0,$.$Ok.isHandled(M)),M}}async function m(B,k,R){const U=await o(B,(0,P.$cg)(),null);return await r(U,{host:k,port:R},j.CancellationToken.None)}e.$2k=m;function L(B){return(0,O.$Fg)(k=>new Promise((R,U)=>{const M=setTimeout(R,B*1e3);k.onCancellationRequested(()=>{clearTimeout(M),R()})}))}var F;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class T{constructor(k,R){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.type=0}}e.$3k=T;class z{constructor(k,R,U,M){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.durationSeconds=U,this.c=M,this.type=1}skipWait(){this.c.cancel()}}e.$4k=z;class q{constructor(k,R,U){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=U,this.type=2}}e.$5k=q;class _{constructor(k,R,U){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=U,this.type=4}}e.$6k=_;class Q{constructor(k,R,U,M){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=U,this.handled=M,this.type=3}}e.$7k=Q;class Z extends D.$Qc{static triggerPermanentFailure(k,R,U){this._permanentFailure=!0,this.f=k,this.g=R,this.h=U,this.j.forEach(M=>M.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(k=>k.y())}static debugPauseSocketWriting(){this.j.forEach(k=>k.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Z._permanentFailure}constructor(k,R,U,M,J){super(),this.t=k,this.u=R,this.reconnectionToken=U,this.protocol=M,this.w=J,this.m=this.B(new I.$Ld),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new _(this.reconnectionToken,0,0)),this.B(M.onSocketClose(X=>{const se=ne(this.t,this.reconnectionToken,!0);X?X.type===0?(this.u.logService.info(`${se} received socket close event (hadError: ${X.hadError}).`),X.error&&this.u.logService.error(X.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this.u.logService.error(X.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(M.onSocketTimeout(X=>{const se=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this.y()})),Z.j.push(this),this.B((0,D.$Oc)(()=>{const X=Z.j.indexOf(this);X>=0&&Z.j.splice(X,1)})),this.n&&this.D(Z.f,Z.g,Z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const k=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${k} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const M=U<R.length?R[U]:R[R.length-1];try{if(M>0){const X=L(M);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,X)),this.u.logService.info(`${k} waiting for ${M} seconds before reconnecting...`);try{await X}catch{}}if(this.n){this.u.logService.error(`${k} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this.u.logService.info(`${k} resolving connection...`);const J=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${k} connecting to ${J.connectTo}...`),await this.G(J,h(g)),this.u.logService.info(`${k} reconnected!`),this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${k} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this.u.logService.error(`${k} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if($.$Ok.isTemporarilyNotAvailable(J)){this.u.logService.info(`${k} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${k} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,A.$2)(J)){this.u.logService.info(`${k} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof $.$Ok){this.u.logService.error(`${k} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,$.$Ok.isHandled(J));break}this.u.logService.error(`${k} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this.n&&!this.s)}C(k,R,U){this.w?Z.triggerPermanentFailure(k,R,U):this.D(k,R,U)}D(k,R,U){this.m.fire(new Q(this.reconnectionToken,k,R,U)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8k=Z;class G extends Z{constructor(k,R,U,M,J){super(1,k,M,J,!0),this.client=this.B(new E.$yh(J,{remoteAuthority:R,clientId:U},k.ipcLogger))}async G(k,R){await n(k,R)}}e.$9k=G;class K extends Z{constructor(k,R,U,M,J){super(2,k,U,M,!1),this.H=R,this.debugPort=J}async G(k,R){await i(k,this.H,R)}}e.$0k=K;function H(B){try{B.acceptDisconnect();const k=B.getSocket();B.dispose(),k.dispose()}catch(k){(0,A.$Y)(k)}}function V(B){if(B&&B.type==="error"){const k=new Error(`Connection error: ${B.reason}`);return k.code="VSCODE_CONNECTION_ERROR",k}return null}function W(B,k){for(;B.length<k;)B+=" ";return B}function ee(B,k){return`[remote-connection][${W(w(B),13)}][${k.substr(0,5)}\u2026]`}function ne(B,k,R){return`${ee(B,k)}[${R?"reconnect":"initial"}]`}function re(B,k){return`${ne(k,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.connectTo}]`}function Y(B){return`${Date.now()-B} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk=(0,N.$Mh)("remoteSocketFactoryService");class j{constructor(){this.a={}}register(I,D){return this.a[I]??=[],this.a[I].push(D),(0,O.$Oc)(()=>{const C=this.a[I]?.indexOf(D);typeof C=="number"&&C>=0&&this.a[I]?.splice(C,1)})}b(I){return(this.a[I.type]||[]).find(C=>C.supports(I))}connect(I,D,C,d){const P=this.b(I);if(!P)throw new Error(`No socket factory found for ${I}`);return P.connect(I,D,C,d)}}e.$Wk=j}),define(oe[214],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=e.$v8b=void 0,e.$v8b=(0,O.$Mh)("sharedProcessTunnelService"),e.$w8b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,164]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=e.$F8b=e.$E8b=e.$D8b=e.$C8b=e.TunnelStates=e.$B8b=e.$A8b=void 0,e.$A8b=(0,O.$Mh)("IRemoteTunnelService"),e.$B8b={active:!1};var j;(function(A){A.disconnected=I=>({type:"disconnected",onTokenFailed:I}),A.connected=(I,D)=>({type:"connected",info:I,serviceInstallFailed:D}),A.connecting=I=>({type:"connecting",progress:I}),A.uninitialized={type:"uninitialized"}})(j||(e.TunnelStates=j={})),e.$C8b="remote.tunnels.access",e.$D8b=e.$C8b+".hostNameOverride",e.$E8b=e.$C8b+".preventSleep",e.$F8b="remoteTunnelService",e.$G8b=(0,N.localize)(0,null)}),define(oe[57],ae([0,1,15,8,2,166,49,4,7,40]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Ko=(0,D.$Mh)("requestService");class P{constructor(S){this.b=S}toJSON(){if(!this.a){const S=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?S[t]="*****":S[t]=this.b[t];this.a=S}return this.a}}class E extends j.$Qc{constructor(S){super(),this.b=0,this.a=S.createLogger("network",{name:(0,A.localize)(0,null),when:C.$lj.isEqualTo((0,C.$jj)(C.LogLevel.Trace)).serialize()})}async c(S,t,a){const s=`${S} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new P(t.headers??{}));try{const n=await a();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,N.$8)(n)),n}}}e.$Lo=E;function $(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.$Mo=$;function c(b){return b.res.statusCode===204}e.$No=c;async function g(b){return c(b)?null:(await(0,O.$le)(b.stream)).toString()}e.$Oo=g;async function p(b){if(!$(b))throw new Error("Server returned "+b.res.statusCode);return g(b)}e.$Po=p;async function w(b){if(!$(b))throw new Error("Server returned "+b.res.statusCode);if(c(b))return null;const t=(await(0,O.$le)(b.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Qo=w;function h(b){u(b)}e.$Ro=h;let l;function u(b){const S=d.$0m.as(I.$cn.Configuration),t=l;l={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[l],remove:t?[t]:[]})}u(1)}),define(oe[215],ae([0,1,26,23,11,57]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;let I=class{constructor(C,d){this.a=C,this.b=d}async download(C,d,P=O.CancellationToken.None){if(C.scheme===N.Schemas.file||C.scheme===N.Schemas.vscodeRemote){await this.b.copy(C,d);return}const E={type:"GET",url:C.toString(!0)},$=await this.a.request(E,P);if($.res.statusCode===200)await this.b.writeFile(d,$.stream);else{const c=await(0,A.$Po)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${c}`)}}};e.$IN=I,e.$IN=I=ye([x(0,A.$Ko),x(1,j.$8j)],I)}),define(oe[216],ae([0,1,15,26]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;class j{constructor(D){this.a=D}listen(D,C){throw new Error("Invalid listen")}call(D,C,d,P=N.CancellationToken.None){switch(C){case"request":return this.a.request(d[0],P).then(async({res:E,stream:$})=>{const c=await(0,O.$le)($);return[{statusCode:E.statusCode,headers:E.headers},c]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.$Nq=j;class A{constructor(D){this.a=D}async request(D,C){const[d,P]=await this.a.call("request",[D],C);return{res:d,stream:(0,O.$ne)(P)}}async resolveProxy(D){return this.a.call("resolveProxy",[D])}}e.$Oq=A}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=e.$16b=void 0,e.$16b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$26b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$36b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[218],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(j){try{const A=await this.c();if(A){const I=String(O.a++);return this.b.set(I,A),{id:I,data:A.createNewMessage(j)}}}catch{}return{id:"",data:j}}async validate(j,A){if(!j.id)return!0;const I=this.b.get(j.id);if(!I)return!1;this.b.delete(j.id);try{return I.validate(A)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(j){try{return await this.d(j)}catch{}return j}}e.$22b=O}),define(oe[106],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=void 0,e.$Xk="signService",e.$Yk=(0,O.$Mh)(e.$Xk)}),define(oe[219],ae([0,1,218]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=void 0;class N extends O.$22b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(I=>new I.signer().sign(A))}h(){return new Promise((A,I)=>te(["vsda"],A,I))}}e.$O7b=N}),define(oe[75],ae([0,1,3,2]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SCb=e.$RCb=e.$QCb=e.$PCb=void 0;class j extends N.$Qc{constructor(E,$,c){super(),this.a=E,this.b=$,this.c=c}async getItems(){const E={profile:this.b,workspace:this.c},$=await this.a.call("getItems",E);return new Map($)}updateItems(E){const $={profile:this.b,workspace:this.c};return E.insert&&($.insert=Array.from(E.insert.entries())),E.delete&&($.delete=Array.from(E.delete.values())),this.a.call("updateItems",$)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class A extends j{constructor(E,$){super(E,$,void 0),this.f=this.B(new O.$Ld),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class I extends A{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$PCb=I;class D extends A{constructor(E,$){super(E,$)}async close(){this.dispose()}}e.$QCb=D;class C extends j{constructor(E,$){super(E,void 0,$),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$RCb=C;class d{constructor(E){this.a=E}isUsed(E){const $={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",$)}}e.$SCb=d}),define(oe[107],ae([0,1,6,37,32]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=void 0;function A(C){if(O.$t===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function I(C,d,P,E,$,c,g,p){const w=Object.create(null);w["common.machineId"]=c,w.sessionID=(0,j.$cg)()+Date.now(),w.commitHash=E,w.version=$,w["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,O.$h)(O.$t),w["common.nodePlatform"]=N.$bc,w["common.nodeArch"]=P,w["common.product"]=p||"desktop",g&&(w["common.msftInternal"]=g);let h=0;const l=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),O.$l&&(w["common.snap"]="true");const u=A(d);return u&&(w["common.platformDetail"]=u),w}e.$_n=I;function D(C){const d=N.env.USERDNSDOMAIN;if(!d)return!1;const P=d.toLowerCase();return C.some(E=>P===E)}e.$ao=D}),define(oe[22],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=void 0,e.$$k=(0,O.$Mh)("telemetryService"),e.$_k=(0,O.$Mh)("customEndpointTelemetryService"),e.$al="telemetry.currentSessionDate",e.$bl="telemetry.firstSessionDate",e.$cl="telemetry.lastSessionDate",e.$dl="telemetry.machineId",e.$el="telemetry",e.$fl="telemetry.telemetryLevel",e.$gl="telemetry.enableCrashReporter",e.$hl="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var j;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(oe[220],ae([0,1,36,5,35,23,16,6,9,132,31,146,95,11,24,22]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=e.$vr=void 0;const w=new Map;async function h(t,a){const s=`${t}::${a.join(":")}`,n=w.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function y(m,L,F,T){const z=L.substring(m.length+1);return N.Promises.withAsyncBody(async q=>{let _;try{_=await P.Promises.readdir(L,{withFileTypes:!0})}catch{q();return}if(T.count>=v){T.count+=_.length,T.maxReached=!0,q();return}let Q=_.length;if(Q===0){q();return}let Z=_;T.count+_.length>v&&(T.maxReached=!0,Q=v-T.count,Z=_.slice(0,Q)),T.count+=_.length;for(const G of Z)if(G.isDirectory()){if(F.includes(G.name)||await y(m,(0,I.$hc)(L,G.name),F,T),--Q===0){q();return}}else{const K=G.name.lastIndexOf(".");if(K>=0){const H=G.name.substring(K+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of i)H.relativePathPattern?.test(z)!==!1&&H.filePattern.test(G.name)&&o.set(H.tag,(o.get(H.tag)??0)+1);if(--Q===0){q();return}}})}const f=N.Promises.withAsyncBody(async m=>{const L={count:0,maxReached:!1};await y(t,t,a,L);const F=await b(t);m({configFiles:l(o),fileTypes:l(r),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:F})});return w.set(s,f),f}e.$vr=h;function l(t){return Array.from(t.entries(),([a,s])=>({name:a,count:s})).sort((a,s)=>s.count-a.count)}function u(){const t={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/c.$Ck.GB).toFixed(2)}GB (${(O.freemem()/c.$Ck.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Jm.value()*100)}%`},a=O.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.$wr=u;async function b(t){try{const a=new Map,s=(0,I.$hc)(t,".vscode","launch.json"),n=await P.Promises.readFile(s),i=[],r=(0,j.$Nm)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,j.$Wm)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return l(a)}catch{return[]}}e.$xr=b;let S=class{constructor(a,s){this.c=a,this.d=s}f(a){const s=[];return s.push(`OS Version:       ${a.os}`),s.push(`CPUs:             ${a.cpus}`),s.push(`Memory (System):  ${a.memory}`),s.push(`VM:               ${a.vmHint}`),s.join(`
`)}g(a){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const n=O.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(O.totalmem()/c.$Ck.GB).toFixed(2)}GB (${(O.freemem()/c.$Ck.GB).toFixed(2)}GB free)`),D.$i||s.push(`Load (avg):       ${O.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(d.$Jm.value()*100)}%`),s.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${a.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(a,s){return Promise.all([(0,E.$ur)(a.mainPID),this.k(a)]).then(async n=>{let[i,r]=n,o=this.m(a,i);return s.forEach(v=>{if((0,$.$jm)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[y];let m=`${f.fileCount} files`;f.maxFilesReached&&(m=`more than ${m}`),r+=`|    Folder (${y}): ${m}`,r+=this.h(f)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,s){const{memory:n,vmHint:i,os:r,cpus:o}=u(),v={os:r,memory:n,cpus:o,vmHint:i,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:s};return D.$i||(v.load=`${O.loadavg().map(y=>Math.round(y)).join(", ")}`),D.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,s){const n=[];return(0,E.$ur)(a.mainPID).then(async i=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,i)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),s.forEach(r=>{if((0,$.$jm)(r))n.push(`
${r.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${r.hostName}`),n.push(this.f(r.machineInfo)),r.processes&&n.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),n.push(`Folder (${o}): ${y}`),n.push(this.h(v))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const s=[];let i=0;const r=(f,m)=>{const L=` ${f}(${m})`;i+L.length>60?(s.push(o),o="|                 ",i=o.length):i+=L.length,o+=L};let o="|      File types:";const v=10,y=a.fileTypes.length>v?v:a.fileTypes.length;for(let f=0;f<y;f++){const m=a.fileTypes[f];r(m.name,m.count)}if(s.push(o),a.configFiles.length>=0&&(o="|      Conf files:",i=0,a.configFiles.forEach(f=>{r(f.name,f.count)}),s.push(o)),a.launchConfigFiles.length>0){let f="|      Launch Configs:";a.launchConfigFiles.forEach(m=>{const L=m.count>1?` ${m.name}(${m.count})`:` ${m.name}`;f+=L}),s.push(f)}return s.join(`
`)}j(a){const s=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const s=[],n=[];return a.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const o=C.URI.revive(r);if(o.scheme===A.Schemas.file){const v=o.fsPath;n.push(h(v,["node_modules",".git"]).then(y=>{let f=`${y.fileCount} files`;y.maxFilesReached&&(f=`more than ${f}`),s.push(`|    Folder (${(0,I.$lc)(v)}): ${f}`),s.push(this.h(y))}).catch(y=>{s.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else s.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(a,s){const n=new Map;a.windows.forEach(r=>n.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>n.set(r,o));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.n(a.mainPID,n,i,s,0),i.join(`
`)}n(a,s,n,i,r){const o=r===0;let v;o?v=i.pid===a?`${this.d.applicationName} main`:"remote agent":s.has(i.pid)?v=s.get(i.pid):v=`${"  ".repeat(r)} ${i.name}`;const y=process.platform==="win32"?i.mem:O.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(y/c.$Ck.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(i.children)&&i.children.forEach(f=>this.n(a,s,n,f,r+1))}async getWorkspaceFileExtensions(a){const s=new Set;for(const{uri:n}of a.folders){const i=C.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const r=i.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(v=>s.add(v.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(a){for(const{uri:s}of a.folders){const n=C.URI.revive(s);if(n.scheme!==A.Schemas.file)continue;const i=n.fsPath;try{const r=await h(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$yr=S,e.$yr=S=ye([x(0,p.$$k),x(1,g.$mj)],S)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=e.$66b=void 0;class O{constructor(A){this.b=A}listen(A,I){throw new Error(`Event not found: ${I}`)}call(A,I,{eventName:D,data:C}){return this.b.forEach(d=>d.log(D,C)),Promise.resolve(null)}}e.$66b=O;class N{constructor(A){this.b=A}log(A,I){return this.b.call("log",{eventName:A,data:I}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$76b=N}),define(oe[45],ae([0,1,30,12,3,19,74,107,22]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;class d{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$bo=d;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$co=P,e.$do=new P;class E{async publicLog(i,r,o){}async publicLogError(i,r,o){}}e.$eo=E,e.$fo="telemetry",e.$go="extensionTelemetryLog",e.$ho={log:()=>null,flush:()=>Promise.resolve(null)};function $(n,i){return j.Event.debounce(i.onDidChangeConfiguration,(o,v)=>{const y=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:y}},1e3,!0)(o=>{o.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.$ji)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$io=$;function c(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry)}e.$jo=c;function g(n,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$ko=g;function p(n){const i=n.getValue(C.$fl),r=n.getValue(C.$gl);if(n.getValue(C.$hl)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$lo=p;function w(n){const i={},r={},o={};u(n,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const y=o[v];typeof y=="number"?r[v]=y:typeof y=="boolean"?r[v]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${y.length}`),i[v]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(i[v]=y)}return{properties:i,measurements:r}}e.$mo=w;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(n){if(!n)return"none";const i=(0,I.$Rk)(n);return h.has(i)?i:"other"}e.$no=l;function u(n,i,r=0,o){if(n)for(const v of Object.getOwnPropertyNames(n)){const y=n[v],f=o?o+v:v;Array.isArray(y)?i[f]=(0,O.$3m)(y):y instanceof Date?i[f]=y.toISOString():(0,N.$yf)(y)?r<2?u(y,i,r+1,f+"."):i[f]=(0,O.$3m)(y):i[f]=y}}function b(n,i){const r=n.msftInternalDomains||[],o=i.getValue("telemetry.internalTesting");return(0,D.$ao)(r)||o}e.$oo=b;function S(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$po=S;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const o=[];for(const m of i)for(;;){const L=m.exec(n);if(!L)break;o.push([L.index,m.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const m=y.exec(n);if(!m)break;const L=o.some(([F,T])=>m.index<T&&F<y.lastIndex);!v.test(m[0])&&!L&&(r+=n.substring(f,m.index)+"<REDACTED: user-file-path>",f=y.lastIndex)}return f<n.length&&(r+=n.substr(f)),r}function a(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function s(n,i){return(0,O.$Zm)(n,r=>{if(r instanceof d||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=t(o,i);for(const v of i)o=o.replace(v,"");return o=a(o),o}})}e.$qo=s}),define(oe[33],ae([0,1,27,29,44,6,9,8,37,45]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;function P(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,O.$Ue)(s.id,n.id)===0}e.$ro=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new $(n.identifier,i,r)}static parse(n){const i=E.exec(n);return i&&i[1]&&i[2]?new $({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof $?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$so=$;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const n=c.exec(s);return n&&n[1]?[w(n[1]),n[2]]:[w(s),void 0]}e.$to=g;function p(s,n){return`${s}.${n}`}e.$uo=p;function w(s){return s.toLowerCase()}e.$vo=w;function h(s,n){return w(p(s??j.$Tl,n))}e.$wo=h;function l(s,n){const i=[],r=o=>{for(const v of i)if(v.some(y=>P(n(y),n(o))))return v;return null};for(const o of s){const v=r(o);v?v.push(o):i.push([o])}return i}e.$xo=l;function u(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$yo=u;function b(s){return{id:new d.$bo(s.identifier.id),name:new d.$bo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$zo=b,e.$Ao=new j.$Xl("pprice.better-merge");function S(s,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&i.every(v=>!P(v.identifier,{id:o}))){const v=s.filter(y=>P(y.identifier,{id:o}));v.length===1&&(i.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$Bo=S;async function t(s,n){if(!A.$k)return!1;let i;try{i=(await s.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,D.$8)(o))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(s,n){const i=await t(s,n),r=(0,N.$Wn)(i?"alpine":A.$t,C.$cc);return n.debug("ComputeTargetPlatform:",r),r}e.$Co=a}),define(oe[221],ae([0,1,18,2,21,9,11,24,5,3,16,6,37,33]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$84b=e.$74b=void 0;let g=class extends N.$Qc{constructor(u,b){super(),this.b=u,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,S])=>this.a.set(S.configPath,S))}getConfigBasedTips(u){return this.f(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(u){const b=[];for(const[S,t]of this.a)if(!(t.configScheme&&t.configScheme!==u.scheme))try{const a=(await this.b.readFile((0,j.$tg)(u,S))).value.toString();for(const[s,n]of Object.entries(t.recommendations))(!n.contentPattern||new RegExp(n.contentPattern,"mig").test(a))&&b.push({extensionId:s,extensionName:n.name,configName:t.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})}catch{}return b}};e.$74b=g,e.$74b=g=ye([x(0,I.$8j),x(1,D.$mj)],g);const p="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class h extends g{constructor(u,b,S,t,a,s,n,i){super(n,i),this.r=u,this.s=b,this.t=S,this.u=t,this.w=a,this.z=s,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],y=[],f=[];Object.entries(o.recommendations).forEach(([m,L])=>{L.important?o.important?v.push({extensionId:m,extensionName:L.name,isExtensionPack:!!L.isExtensionPack}):y.push({extensionId:m,extensionName:L.name,isExtensionPack:!!L.isExtensionPack}):f.push({extensionId:m,extensionName:L.name,isExtensionPack:!!L.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),y.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:y}),f.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:f})}),(0,C.$Tg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const u=await this.O(this.g),b=await this.O(this.h);return[...u,...b]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const u=await this.O(this.g),b=await this.O(this.h),S=await this.u.getInstalled();this.m=this.D(u,S),this.n=this.D(b,S)}D(u,b){const S=new Map;u.forEach(i=>S.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:a}=this.N([...S.keys()],b);for(const i of t){const r=S.get(i);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of a){const r=S.get(i);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const s=this.L(),n=new Map;for(const i of a){const r=S.get(i);if(r&&(!s[r.exeName]||!s[r.exeName].includes(r.extensionId))){let o=n.get(r.exeName);o||(o=[],n.set(r.exeName,o)),o.push(r)}}return n}F(){if(this.m.size===0)return;const[u,b]=[...this.m.entries()][0];this.H(b).then(S=>{switch(S){case"reacted":this.M(b[0].exeName,b);break;case"ignored":this.m.delete(u);break;case"incompatibleWindow":{const t=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B(new N.$Rc);t.value=(0,C.$Tg)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const u=this.I(),b=Date.now()-u,S=7*24*60*60*1e3;if(b<S){const s=this.B(new N.$Rc);s.value=(0,C.$Tg)(()=>{s.dispose(),this.G()},S-b);return}const[t,a]=[...this.n.entries()][0];this.H(a).then(s=>{switch(s){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(a[0].exeName,a);const n=this.B(new N.$Rc);n.value=(0,C.$Tg)(()=>{n.dispose(),this.G()},S);break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const n=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(n(()=>this.G()));break}case"toomany":{const n=this.B(new N.$Rc);n.value=(0,C.$Tg)(()=>{n.dispose(),this.G()},60*60*1e3);break}}})}async H(u){const b=await this.u.getInstalled(1),S=u.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(a=>b.every(s=>!(0,c.$ro)(s.identifier,{id:a})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:S,source:3,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}I(){let u=this.w.getNumber(w,-1);return u||(u=Date.now(),this.J(u)),u}J(u){this.w.store(w,u,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(u,b){const S=this.L();S[u]=b.map(({extensionId:t})=>t.toLowerCase()),this.w.store(p,JSON.stringify(S),-1,0)}N(u,b){const S=[],t=[],a=b.reduce((s,n)=>(s.add(n.identifier.id.toLowerCase()),s),new Set);return u.forEach(s=>{a.has(s.toLowerCase())?S.push(s):t.push(s)}),{installed:S,uninstalled:t}}async O(u){const b=[],S=new Map;for(const t of u.keys()){const a=u.get(t);if(!a||!(0,O.$Jb)(a.recommendations))continue;const s=[];E.$i?a.windowsPath&&s.push(a.windowsPath.replace("%USERPROFILE%",()=>$.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>$.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>$.env.ProgramFiles).replace("%APPDATA%",()=>$.env.APPDATA).replace("%WINDIR%",()=>$.env.WINDIR)):(s.push((0,P.$hc)("/usr/local/bin",t)),s.push((0,P.$hc)("/usr/bin",t)),s.push((0,P.$hc)(this.r.fsPath,t)));for(const n of s){let i=S.get(n);if(i===void 0&&(i=await this.b.exists(A.URI.file(n)),S.set(n,i)),i)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:y}of a.recommendations)b.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:t,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:y})}}return b}}e.$84b=h}),define(oe[222],ae([0,1,26,33]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EVb=void 0;async function j(A,I,D,C,d){try{const P=await A.getExtensionsControlManifest();if(!P.deprecated)return;const E=await A.getInstalled(1);for(const[$,c]of Object.entries(P.deprecated)){if(!c?.extension)continue;const{id:g,autoMigrate:p,preRelease:w}=c.extension;if(!p)continue;const h=E.find(u=>(0,N.$ro)(u.identifier,{id:$}));if(!h)continue;const l=(await I.getExtensions([{id:g,preRelease:w}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!l){d.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{d.info(`Migrating '${h.identifier.id}' extension to '${g}' extension...`);const u=!C.getDisabledExtensions().some(S=>(0,N.$ro)(S,h.identifier));await A.uninstall(h),d.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let b=E.find(S=>(0,N.$ro)(S.identifier,{id:g}));(!b||!b.isPreReleaseVersion&&u)&&(b=await A.installFromGallery(l,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${b.identifier.id}'`),u||(await C.disableExtension(b.identifier),d.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),p.storage&&(D.addToMigrationList((0,N.$uo)(h.manifest.publisher,h.manifest.name),(0,N.$uo)(b.manifest.publisher,b.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${h.identifier.id}' extension to '${g}' extension.`)}catch(u){d.error(u)}}}catch(P){d.error(P)}}e.$EVb=j}),define(oe[223],ae([0,1,3,2,34,33,44]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;class D extends N.$Qc{constructor(d,P,E,$,c,g,p){super(),this.f=d,this.g=P,this.h=E,this.j=$,this.m=c,this.n=g,this.r=p,this.a=this.B(new O.$Ld),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$Yc),this.s().then(null,w=>p.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(P=>(this.c.set(P.id,(0,N.$Nc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(d){for(const P of d.extensions)this.I(this.L(P.identifier,P.version),d.profileLocation)}async y(d){for(const P of d.extensions){const E=this.L(P.identifier,P.version);d.error?this.J(E,d.profileLocation):this.I(E,d.profileLocation)}}async z(d){for(const P of d.extensions)this.J(this.L(P.identifier,P.version),d.profileLocation)}async C(d){const P=[],E=[];for(const $ of d.extensions){const c=this.L($.identifier,$.version);d.error?this.I(c,d.profileLocation):(this.J(c,d.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),E.push(this.f.scanInstalledExtensionAtLocation($.location).then(g=>{g?P.push(g):this.r.info("Extension not found at the location",$.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),P.length&&await this.H(P)}catch($){this.r.error($)}}D(d){for(const P of this.h.profiles)d.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(d){const P=[],E=[],$=await this.j.scanProfileExtensions(d),c=new Set,g=new Set;for(const[p,w]of this.b)w.has(d)&&g.add(p);for(const p of $){const w=this.L(p.identifier,p.version);c.add(w),g.has(w)||(P.push(p.identifier),this.I(w,d))}for(const p of g)if(!c.has(p)){const w=this.M(p);w&&(E.push(w.identifier),this.J(p,d))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:d}:void 0,removed:E.length?{extensions:E,profileLocation:d}:void 0})}async G(d){const P=await this.j.scanProfileExtensions(d);for(const E of P)this.I(this.L(E.identifier,E.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,P){let E=this.b.get(d);E||this.b.set(d,E=new j.$zc($=>this.m.extUri.getComparisonKey($))),E.add(P)}J(d,P){const E=this.b.get(d);E&&E.delete(P),E?.size||this.b.delete(d)}L(d,P){return`${I.$Xl.toKey(d.id)}@${P}`}M(d){const[P,E]=(0,A.$to)(d);return E?{identifier:{id:P},version:E}:void 0}}e.$zp=D}),define(oe[224],ae([0,1,43,45]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=void 0;async function j(A,I,D,C,d,P,E){const $={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,N.$jo)(I,D)&&(0,N.$lo)(C)===3){const c=await(0,O.$4o)(D,d,P);$["X-Market-User-Id"]=c,$["VSCode-SessionId"]=E.machineId||c}return $}e.$5o=j}),define(oe[225],ae([0,1,69,18,5,2,23,16,31,14,29,33,7,72,9]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let p=class extends c.$Lq{constructor(u,b,S,t){super(S),this.h=u,this.j=t,this.g=this.B(new w(b,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(u,b){const t=(await this.g.getLanguagePacks())[b];if(!t){this.j.warn(`No language pack found for ${b}`);return}const a=t.translations[u];return a?g.URI.file(a):void 0}async getInstalledLanguages(){const u=await this.g.getLanguagePacks(),b=Object.keys(u).map(S=>{const t=u[S];return{...this.f(S,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((S,t)=>S.label.localeCompare(t.label)),b}async m(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",u.identifier.id),await this.update())}async n(u){const b=await this.g.getLanguagePacks();Object.keys(b).some(S=>b[S]&&b[S].extensions.some(t=>(0,E.$ro)(t.extensionIdentifier,u.identifier)))&&(this.j.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),S=await this.g.update(b);return!(0,N.$sb)(Object.keys(u),Object.keys(S))}};e.$Mq=p,e.$Mq=p=ye([x(0,P.$4n),x(1,d.$Uh),x(2,P.$2n),x(3,$.$7i)],p);let w=class extends A.$Qc{constructor(u,b){super(),this.j=b,this.c={},this.f=(0,D.$hc)(u.userDataPath,"languagepacks.json"),this.g=new j.$Yg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(u){return this.s(b=>{Object.keys(b).forEach(S=>delete b[S]),this.m(b,...u)}).then(()=>this.c)}m(u,...b){for(const S of b)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.n(u,S);Object.keys(u).forEach(S=>this.r(u[S]))}n(u,b){const S=b.identifier,t=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const a of t)if(b.location.scheme===I.Schemas.file&&h(a)){let s=u[a.languageId];s||(s={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},u[a.languageId]=s);const n=s.extensions.filter(i=>(0,E.$ro)(i.extensionIdentifier,S))[0];n?n.version=b.manifest.version:s.extensions.push({extensionIdentifier:S,version:b.manifest.version});for(const i of a.translations)s.translations[i.id]=(0,D.$hc)(b.location.fsPath,i.path)}}r(u){if(u){const b=(0,O.createHash)("md5");for(const S of u.extensions)b.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);u.hash=b.digest("hex")}}s(u=()=>null){return this.g.queue(()=>{let b=null;return C.Promises.readFile(this.f,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(b=u(S),S)).then(S=>{for(const a of Object.keys(S))S[a]||delete S[a];this.c=S,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),C.Promises.writeFile(this.f,t)}).then(()=>b,S=>this.j.error(S))})}};w=ye([x(0,d.$Uh),x(1,$.$7i)],w);function h(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const u of l.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(oe[226],ae([0,1,143,8,30,45]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function C(P,E,$){const c=await(0,O.$eC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,O.$eC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new c.AppInsightsCore,w=new g.PostChannel,h={instrumentationKey:P,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if($){h.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:$};h.extensionConfig[w.identifier]=l}return p.initialize(h,[]),p.addTelemetryInitializer(l=>{E&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),p}class d{constructor(E,$,c,g,p){this.e=E,this.f=$,this.g=c,this.h=p,this.c=I,this.d=D,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then($=>{E($)},$=>{(0,N.$Y)($),console.error($)})}}log(E,$){if(!this.a)return;$=(0,j.$1m)($,this.g),$=(0,A.$mo)($);const c=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=$?.properties.version??"Unknown",g.track({name:c,baseData:{name:c,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$gN=d}),define(oe[109],ae([0,1,2,167,14,7,24,45]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v4b=void 0;let C=class extends O.$Qc{constructor(P,E,$,c,g=""){super(),this.b=g;const p=E.getLogger(D.$fo);if(p)this.a=this.B(p);else{const h=(0,D.$ko)(c,$)?" (Not Sent)":"",l=()=>(0,D.$jo)(c,$)&&P.getLevel()===A.LogLevel.Trace;this.a=this.B(E.createLogger(D.$fo,{name:(0,N.localize)(0,null,h),hidden:!l()})),this.B(P.onDidChangeLogLevel(()=>E.setVisibility(D.$fo,l()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,E){this.a.trace(`${this.b}telemetry/${P}`,(0,D.$mo)(E))}};e.$v4b=C,e.$v4b=C=ye([x(0,A.$7i),x(1,A.$8i),x(2,j.$Th),x(3,I.$mj)],C)}),define(oe[110],ae([0,1,2,30,6,27,168,19,49,102,24,40,22,45]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,l,u){this.k=l,this.l=u,this.d={},this.i=new O.$Pc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,A.$De)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$De)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration($.$fl)||b.affectsConfiguration($.$hl)||b.affectsConfiguration($.$gl))&&this.m()}))}setExperimentProperty(h,l){this.d[h]=l}m(){let h=(0,c.$lo)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const u=l.usage?3:l.error?2:0;h=Math.min(h,u)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,l,u){this.g<l||(u=(0,N.$1m)(u,this.d),u=(0,c.$qo)(u,this.j),u=(0,N.$1m)(u,this.c),this.b.forEach(b=>b.log(h,u)))}publicLog(h,l){this.n(h,3,l)}publicLog2(h,l){this.publicLog(h,l)}publicLogError(h,l){this.h&&this.n(h,2,l)}publicLogError2(h,l){this.publicLogError(h,l)}};e.$Sq=g,e.$Sq=g=ye([x(1,D.$gi),x(2,P.$mj)],g);function p(){const w=(0,I.localize)(0,null,d.default.nameLong),h=d.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=j.$o?"":(0,I.localize)(3,null),u=(0,I.localize)(4,null),b=(0,I.localize)(5,null),S=(0,I.localize)(6,null),t=(0,I.localize)(7,null),a=`
|       | ${u} | ${b} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,I.localize)(8,null);return`
${w} ${h} ${l}

&nbsp;

${t}
${a}

&nbsp;

${s}
`}E.$0m.as(C.$cn.Configuration).registerConfiguration({id:$.$el,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[$.$fl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$0m.as(C.$cn.Configuration).registerConfiguration({id:$.$el,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[$.$hl]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,I.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,I.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${$.$fl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[227],ae([0,1,15,26,272,226]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;async function I(P,E){const $=await E.request(P,N.CancellationToken.None),c=(await(0,O.$le)($.stream)).toString(),g=$.res.statusCode??200;return{headers:$.res.headers,statusCode:g,responseData:c}}async function D(P){const E={method:P.type,headers:P.headers};return new Promise((c,g)=>{const p=j.request(P.url??"",E,w=>{w.on("data",function(h){c({headers:w.headers,statusCode:w.statusCode??200,responseData:h.toString()})}),w.on("error",function(h){g(h)})});p.write(P.data,w=>{w&&g(w)}),p.end()})}async function C(P,E,$){const c=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:c};try{const p=P?await I(g,P):await D(g);$(p.statusCode,p.headers,p.responseData)}catch{$(0,{})}}class d extends A.$gN{constructor(E,$,c,g,p){const w={sendPOST:(h,l)=>{C(E,h,l)}};super($,c,g,p,w)}}e.$hN=d}),define(oe[228],ae([0,1,23,93,19,14,7,24,22,108,109,110]),function(te,e,O,N,j,A,I,D,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=void 0;let $=class{constructor(g,p,w,h,l,u){this.b=g,this.c=p,this.d=w,this.e=h,this.f=l,this.g=u,this.a=new Map}h(g){if(!this.a.has(g.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const w=[g.id,JSON.stringify(p),g.aiKey],l=new N.$Up(O.$ag.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new d.$76b(l),new P.$v4b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new E.$Sq({appenders:u,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,p,w){this.h(g).publicLog(p,w)}publicLogError(g,p,w){this.h(g).publicLogError(p,w)}};e.$k8b=$,e.$k8b=$=ye([x(0,j.$gi),x(1,C.$$k),x(2,I.$7i),x(3,I.$8i),x(4,A.$Th),x(5,D.$mj)],$)}),define(oe[76],ae([0,1,3,19,4,7]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.ProvidedOnAutoForward=e.$4u=e.TunnelPrivacyId=e.TunnelProtocol=e.$3u=e.$2u=void 0,e.$2u=(0,j.$Mh)("tunnelService"),e.$3u=(0,j.$Mh)("sharedTunnelsService");var I;(function(w){w.Http="http",w.Https="https"})(I||(e.TunnelProtocol=I={}));var D;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(D||(e.TunnelPrivacyId=D={}));function C(w){return!!w.forwardPort}e.$4u=C;var d;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function P(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(h)return{address:h[1],port:+h[2]}}e.$5u=P,e.$6u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(w){return e.$6u.indexOf(w)>=0}e.$7u=E,e.$8u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(w){return e.$8u.indexOf(w)>=0}e.$9u=$;function c(w,h,l,u){if(l===1)return!1;if(l===2&&$(h)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(b?.length===4&&parseInt(b[1])>=18)return!1}return w<1024}e.$0u=c;class g{constructor(h,l,u){this.remoteAddress=h,this.localAddress=l,this.b=u,this.a=new O.$Ld,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$$u=g;let p=class{constructor(h,l){this.j=h,this.k=l,this.a=new O.$Ld,this.onTunnelOpened=this.a.event,this.b=new O.$Ld,this.onTunnelClosed=this.b.event,this.c=new O.$Ld,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const h=this.k.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.h=h.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const h=[],l=Array.from(this.e.values());for(const u of l){const b=Array.from(u.values());for(const S of b){const t=await S.value;t&&typeof t!="string"&&h.push(t)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:l}of h.values())await l.then(u=>typeof u!="string"?u?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,l,u,b,S){this.p(h,l,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:l,localAddress:u,privacy:b,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,l){($(h)||E(h))&&(h=e.$6u[0]);const u=this.r(h,l);if(u)return++u.refcount,u.value}openTunnel(h,l,u,b,S,t=!1,a,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${u} on local port ${S}.`);const n=this.f??h;if(!n)return;if(l||(l="localhost"),b||(b=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.s(n,l,u,b,S,t,a,s);return i?i.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(l,u),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(l,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==l||r.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}n(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const l=this.e.get(h.tunnelRemoteHost);if(l){const u=l.get(h.tunnelRemotePort);u&&(u.refcount--,await this.o(h.tunnelRemoteHost,h.tunnelRemotePort,u))}}}}async o(h,l,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${l}.`);const b=u.value.then(async S=>{S&&typeof S!="string"&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(l),b}}async closeTunnel(h,l){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${l} `);const u=this.e.get(h);if(u&&u.has(l)){const b=u.get(l);b.refcount=0,await this.o(h,l,b)}}p(h,l,u){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(l,{refcount:1,value:u})}async q(h,l){const u=this.e.get(h);if(u){const b=u.get(l),S=b?await b.value:void 0;(!S||typeof S=="string")&&u.delete(l),u.size===0&&this.e.delete(h)}}r(h,l){const u=[h];E(h)?(u.push(...e.$6u),u.push(...e.$8u)):$(h)&&u.push(...e.$8u);const b=u.map(S=>this.e.get(S));for(const S of b){const t=S?.get(l);if(t)return t}}canTunnel(h){return!!P(h)}t(h,l,u,b,S,t,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${u} on local port ${b}.`);const s=u;this.i.add(s);const n=b===void 0?u:b,i={elevationRequired:S?this.isPortPrivileged(n):!1},r={remoteAddress:{host:l,port:u},localAddressPort:b,privacy:t,public:t?t!==D.Private:void 0,protocol:a},o=h.forwardPort(r,i);return o?(this.p(l,u,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),o}};e.$_u=p,e.$_u=p=ye([x(0,A.$7i),x(1,N.$gi)],p)}),define(oe[229],ae([0,1,7,76,2,8,5]),function(te,e,O,N,j,A,I){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$x8b=void 0;class C extends j.$Qc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new I.$ah),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let d=class extends j.$Qc{static{D=this}static{this.a=0}constructor(E,$){super(),this.f=E,this.g=$,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++D.a)}}async startTunnel(E,$,c,g,p,w,h){const l=new C,u=await Promise.resolve(this.f.openTunnel(E,l,c,g,p,w,h));if(!u||typeof u=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${g} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this.c.has($))throw this.c.delete($),l.dispose(),await u.dispose(),(0,A.$4)();return l.setTunnel(u),this.b.set($,l),this.g.info(`[SharedProcessTunnelService] Created tunnel ${$}: ${u.localAddress} (local) to ${c}:${g} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(E,$){const c=this.b.get(E);c&&c.setAddress($)}async destroyTunnel(E){const $=this.b.get(E);if($){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await $.dispose();return}this.c.add(E)}};e.$x8b=d,e.$x8b=d=D=ye([x(0,N.$3u),x(1,O.$7i)],d)}),define(oe[28],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=void 0,e.$Ek=(0,O.$Mh)("IUriIdentityService")}),define(oe[230],ae([0,1,28,185,11,21,128,3,2]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class d{static{this._clock=0}constructor($){this.uri=$,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let P=class{constructor($){this.g=$,this.c=new C.$Pc,this.f=2**16;const c=new Map,g=p=>{let w=c.get(p.scheme);return w===void 0&&(w=$.hasProvider(p)&&!this.g.hasCapability(p,1024),c.set(p.scheme,w)),w};this.c.add(D.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(p=>{c.delete(p.scheme)})),this.extUri=new A.$ig(g),this.d=new I.$qr((p,w)=>this.extUri.compare(p,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,A.$ug)($));const c=this.d.get($);return c?c.touch().uri.with({fragment:$.fragment}):(this.d.set($,new d($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((g,p)=>g[1].time<p[1].time?1:g[1].time>p[1].time?-1:0);d._clock=0,this.d.clear();const c=this.f*.5;for(let g=0;g<c;g++)this.d.set($[g][0],$[g][1].touch())}};e.$rr=P,e.$rr=P=ye([x(0,j.$8j)],P),(0,N.$or)(O.$Ek,P,1)}),define(oe[231],ae([0,1,3,2,11,47,34]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=void 0;class D extends N.$Qc{constructor(d,P,E,$,c,g){super(),this.f=d,this.g=P,this.h=E,this.j=$,this.m=c,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$Ld),this.onDidChangeFile=this.a.event,this.b=A.$Sh.forUris(()=>!(this.capabilities&1024)),this.c=new I.$zc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,P){return this.g.open(this.t(d),P)}close(d){return this.g.close(d)}read(d,P,E,$,c){return this.g.read(d,P,E,$,c)}write(d,P,E,$,c){return this.g.write(d,P,E,$,c)}watch(d,P){this.b.set(d,d);const E=this.g.watch(this.t(d),P);return(0,N.$Oc)(()=>{this.b.delete(d),E.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,P,E){return this.g.rename(this.t(d),this.t(P),E)}readFile(d,P){return this.g.readFile(this.t(d),P)}readFileStream(d,P,E){return this.g.readFileStream(this.t(d),P,E)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,P,E){return this.g.writeFile(this.t(d),P,E)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,P){return this.g.delete(this.t(d),P)}copy(d,P,E){if((0,j.$$j)(this.g))return this.g.copy(this.t(d),this.t(P),E);throw new Error("copy not supported")}cloneFile(d,P){if((0,j.$_j)(this.g))return this.g.cloneFile(this.t(d),this.t(P));throw new Error("clone not supported")}s(d){const P=[];for(const E of d){if(E.resource.scheme!==this.f)continue;const $=this.u(E.resource);this.b.findSubstr($)&&P.push({resource:$,type:E.type})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$R7b=D}),define(oe[77],ae([0,1,85]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wCb=e.$vCb=e.edit=void 0;function N(I,D,C,d){const P=(0,O.$OS)(I,D,C,d)[0];return P&&(I=I.substring(0,P.offset)+P.content+I.substring(P.offset+P.length)),I}e.edit=N;function j(I,D,C){let d=C;for(;d>=0;){if(I.charAt(d)===D.charAt(D.length-1)&&D.length===1)return d+1;if(d--,D.length===2&&d>=0&&I.charAt(d)===D.charAt(0))return d+2}return 0}e.$vCb=j;function A(I,D,C){let d=C;for(;d>=0;)if(I.charAt(d)===D.charAt(D.length-1)&&D.length===1||(d++,D.length===2&&d>=0&&I.charAt(d)===D.charAt(1)))return d;return I.length-1}e.$wCb=A}),define(oe[232],ae([0,1,30,53,12]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d3b=void 0;function A(c,g,p,w,h,l){const u=[],b=[],S=[];if(!g){const q=c.filter(({identifier:_})=>h.every(Q=>Q.toLowerCase()!==_.id.toLowerCase()));return{local:{added:u,removed:b,updated:S},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}c=c.map(E),g=g.map(E),p=p?p.map(E):null;const t=new Map,a=q=>{q.uuid&&t.set(q.id.toLowerCase(),q.uuid)};c.forEach(({identifier:q})=>a(q)),g.forEach(({identifier:q})=>a(q)),p?.forEach(({identifier:q})=>a(q)),w?.forEach(({identifier:q})=>a(q)),l?.forEach(q=>a(q));const s=q=>{const _=q.identifier.uuid||t.get(q.identifier.id.toLowerCase());return _?`uuid:${_}`:`id:${q.identifier.id.toLowerCase()}`},n=(q,_)=>(q.set(s(_),_),q),i=c.reduce(n,new Map),r=g.reduce(n,new Map),o=g.reduce((q,_)=>n(q,(0,O.$Xm)(_)),new Map),v=p?p.reduce(n,new Map):null,y=w.reduce(n,new Map),f=h.reduce((q,_)=>{const Q=t.get(_.toLowerCase());return q.add(Q?`uuid:${Q}`:`id:${_.toLowerCase()}`)},new Set),m=l?l.reduce((q,{id:_,uuid:Q})=>(Q=Q??t.get(_.toLowerCase()),q.add(Q?`uuid:${Q}`:`id:${_.toLowerCase()}`)),new Set):null,L=I(i,r,f,!1);if(L.added.size>0||L.removed.size>0||L.updated.size>0){const q=I(v,i,f,!1),_=I(v,r,f,!0),Q=(Z,G,K,H)=>{let V,W,ee;return G.installed?(V=H.pinned,ee=H.preRelease,V&&(W=H.version)):(V=K.pinned,ee=K.preRelease,V&&(W=K.version)),V===void 0&&(V=G.pinned,V&&(W=G.version)),ee===void 0&&(ee=G.preRelease),{...H,installed:G.installed||K.installed,pinned:V,preRelease:ee,version:W??(K.version&&(!G.installed||N.gt(K.version,G.version))?K.version:G.version),state:C(G,K,v?.get(Z))}};for(const Z of _.removed.values()){const G=i.get(Z);if(!G)continue;const K=(0,j.$Hf)(v?.get(Z)),H=m&&!m.has(Z)&&K.installed;G.installed&&H?b.push(G.identifier):o.set(Z,G)}for(const Z of _.added.values()){const G=(0,j.$Hf)(r.get(Z)),K=i.get(Z);if(K){if(L.updated.has(Z)){const H=Q(Z,K,G,G);D(K,G,!1,!1)||S.push($(H,Z)),o.set(Z,H)}}else G.installed&&u.push($(G,Z))}for(const Z of _.updated.values()){const G=(0,j.$Hf)(r.get(Z)),K=(0,j.$Hf)(v?.get(Z)),H=i.get(Z);if(H)if(m&&!m.has(Z)&&K.installed&&H.installed&&!G.installed)b.push(H.identifier);else{const W=Q(Z,H,G,G);S.push($(W,Z)),o.set(Z,W)}else G.installed&&u.push($(G,Z))}for(const Z of q.added.values())_.added.has(Z)||o.set(Z,(0,j.$Hf)(i.get(Z)));for(const Z of q.updated.values()){if(_.removed.has(Z)||_.updated.has(Z))continue;const G=(0,j.$Hf)(i.get(Z)),K=(0,j.$Hf)(r.get(Z));o.set(Z,Q(Z,G,K,G))}for(const Z of q.removed.values())_.updated.has(Z)||_.removed.has(Z)||y.has(Z)||(0,j.$Hf)(r.get(Z)).installed&&m&&(m.has(Z)||!(0,j.$Hf)(v?.get(Z)).installed||o.delete(Z))}const F=[],T=I(r,o,new Set,!0),z=T.added.size>0||T.updated.size>0||T.removed.size>0;return z&&o.forEach((q,_)=>F.push($(q,_))),{local:{added:u,removed:b,updated:S},remote:z?{added:[...T.added].map(q=>o.get(q)),updated:[...T.updated].map(q=>o.get(q)),removed:[...T.removed].map(q=>r.get(q)),all:F}:null}}e.$d3b=A;function I(c,g,p,w){const h=c?[...c.keys()].filter(t=>!p.has(t)):[],l=[...g.keys()].filter(t=>!p.has(t)),u=l.filter(t=>!h.includes(t)).reduce((t,a)=>(t.add(a),t),new Set),b=h.filter(t=>!l.includes(t)).reduce((t,a)=>(t.add(a),t),new Set),S=new Set;for(const t of h){if(b.has(t))continue;const a=c.get(t),s=g.get(t);(!s||!D(a,s,w,!0))&&S.add(t)}return{added:u,removed:b,updated:S}}function D(c,g,p,w){return!(c.disabled!==g.disabled||!!c.isApplicationScoped!=!!g.isApplicationScoped||w&&c.installed!==g.installed||c.installed&&g.installed&&(c.preRelease!==g.preRelease||c.pinned!==g.pinned||g.pinned&&c.version!==g.version)||!P(c.state,g.state)||p&&c.version!==g.version)}function C(c,g,p){const w=c.state,h=g.state,l=p?.state;if(!g.version||w&&N.gt(c.version,g.version))return w;if(h&&N.gt(g.version,c.version)||!w)return h;if(!h)return w;const u=(0,O.$Xm)(w),b=l?d(l,h):{added:Object.keys(h).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set},S=l?d(l,w):{added:Object.keys(w).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set};for(const t of[...b.added.values(),...b.updated.values()])u[t]=h[t];for(const t of b.removed.values())S.updated.has(t)||delete u[t];return u}function d(c,g){const p=Object.keys(c),w=Object.keys(g),h=w.filter(b=>!p.includes(b)).reduce((b,S)=>(b.add(S),b),new Set),l=p.filter(b=>!w.includes(b)).reduce((b,S)=>(b.add(S),b),new Set),u=new Set;for(const b of p){if(l.has(b))continue;const S=c[b],t=g[b];(0,O.$2m)(S,t)||u.add(b)}return{added:h,removed:l,updated:u}}function P(c={},g={}){const{added:p,removed:w,updated:h}=d(c,g);return p.size===0&&w.size===0&&h.size===0}function E(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function $(c,g){const p={...c,identifier:{id:c.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete p.disabled,c.installed||delete p.installed,c.state||delete p.state,c.isApplicationScoped||delete p.isApplicationScoped,p}}),define(oe[111],ae([0,1,18,19,4]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uEb=e.$tEb=void 0,e.$tEb=(0,j.$Mh)("IIgnoredExtensionsManagementService");let A=class{constructor(D){this.a=D}hasToNeverSyncExtension(D){return this.b().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.b().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,C){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==D&&P!==`-${D}`),C&&d.push(D.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(D,C){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==D&&P!==`-${D}`),C&&d.push(`-${D.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(D){const C=D.filter($=>$.isMachineScoped).map($=>$.identifier.id.toLowerCase()),d=this.b().map($=>$.toLowerCase()),P=[],E=[];if(Array.isArray(d))for(const $ of d)$.startsWith("-")?E.push($.substring(1)):P.push($);return(0,O.$Kb)([...C,...P].filter($=>!E.includes($)))}b(){let D=this.a.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.a.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.$uEb=A,e.$uEb=A=ye([x(0,N.$gi)],A)}),define(oe[233],ae([0,1,18,35,30,94,77]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=void 0;function D(b){return(0,N.$Nm)(b)||[]}async function C(b,S,t,a,s){const n=D(b),i=D(S),r=t?D(t):null,o=[...n,...i,...r||[]].map(Q=>Q.key),v=await s.resolveUserBindings(o),y=P(n,i,r,v);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const f=$(n),m=$(i),L=r?$(r):null,F=g(f,m,v),T=L?g(L,f,v):{added:[...f.keys()].reduce((Q,Z)=>(Q.add(Z),Q),new Set),removed:new Set,updated:new Set},z=L?g(L,m,v):{added:[...m.keys()].reduce((Q,Z)=>(Q.add(Z),Q),new Set),removed:new Set,updated:new Set},q=d(F,T,z);let _=b;for(const Q of q.removed.values())q.conflicts.has(Q)||(_=l(_,Q,a));for(const Q of q.added.values()){if(q.conflicts.has(Q))continue;const Z=m.get(Q);if(Z.some(G=>G.command!==`-${Q}`&&y.conflicts.has(v[G.key]))){q.conflicts.add(Q);continue}_=h(_,Z,a)}for(const Q of q.updated.values()){if(q.conflicts.has(Q))continue;const Z=m.get(Q);if(Z.some(G=>G.command!==`-${Q}`&&y.conflicts.has(v[G.key]))){q.conflicts.add(Q);continue}_=u(_,Q,Z,a)}return{mergeContent:_,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$j3b=C;function d(b,S,t){const a=new Set,s=new Set,n=new Set,i=new Set;for(const r of S.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(S.updated.has(r)?i.add(r):s.add(r));for(const r of S.added.values())i.has(r)||t.added.has(r)&&b.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(S.added.has(r)?b.updated.has(r)&&i.add(r):a.add(r));for(const r of S.updated.values())i.has(r)||t.updated.has(r)&&b.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(S.updated.has(r)?b.updated.has(r)&&i.add(r):n.add(r));return{added:a,removed:s,updated:n,conflicts:i}}function P(b,S,t,a){const s=new Set,n=E(b,a),i=E(S,a),r=t?E(t,a):null,o=c(n,i);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const v=r?c(r,n):{added:[...n.keys()].reduce((T,z)=>(T.add(z),T),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const y=r?c(r,i):{added:[...i.keys()].reduce((T,z)=>(T.add(z),T),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:f,removed:m,updated:L,conflicts:F}=d(o,v,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:m,updated:L,conflicts:F}}function E(b,S){const t=new Map;for(const a of b){const s=S[a.key];let n=t.get(s);n||(n=[],t.set(s,n)),n.push(a)}return t}function $(b){const S=new Map;for(const t of b){const a=t.command[0]==="-"?t.command.substring(1):t.command;let s=S.get(a);s||(s=[],S.set(a,s)),s.push(t)}return S}function c(b,S){const t=[...b.keys()],a=[...S.keys()],s=a.filter(r=>!t.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),n=t.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=new Set;for(const r of t){if(n.has(r))continue;const o=b.get(r).map(y=>({...y,key:r})),v=S.get(r).map(y=>({...y,key:r}));(0,O.$sb)(o,v,(y,f)=>w(y,f))||i.add(r)}return{added:s,removed:n,updated:i}}function g(b,S,t){const a=[...b.keys()],s=[...S.keys()],n=s.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),i=a.filter(o=>!s.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(i.has(o))continue;const v=b.get(o).map(f=>({...f,key:t[f.key]})),y=S.get(o).map(f=>({...f,key:t[f.key]}));p(v,y)||r.add(o)}return{added:n,removed:i,updated:r}}function p(b,S){return!(!(0,O.$sb)(b.filter(({command:t})=>t[0]!=="-"),S.filter(({command:t})=>t[0]!=="-"),(t,a)=>w(t,a))||!(0,O.$sb)(b.filter(({command:t})=>t[0]==="-"),S.filter(({command:t})=>t[0]==="-"),(t,a)=>w(t,a)))}function w(b,S){if(b.command!==S.command||b.key!==S.key)return!1;const t=A.$Ki.deserialize(b.when),a=A.$Ki.deserialize(S.when);return!(t&&!a||!t&&a||t&&a&&!t.equals(a)||!j.$2m(b.args,S.args))}function h(b,S,t){for(const a of S)b=I.edit(b,[-1],a,t);return b}function l(b,S,t){const a=D(b);for(let s=a.length-1;s>=0;s--)(a[s].command===S||a[s].command===`-${S}`)&&(b=I.edit(b,[s],void 0,t));return b}function u(b,S,t,a){const s=D(b),n=s.findIndex(i=>i.command===S||i.command===`-${S}`);for(let i=s.length-1;i>=0;i--)(s[i].command===S||s[i].command===`-${S}`)&&(b=I.edit(b,[i],void 0,a));for(let i=t.length-1;i>=0;i--)b=I.edit(b,[n],t[i],a);return b}}),define(oe[234],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r3b=e.$q3b=void 0;function O(A,I,D){const C={},d={},P=new Set;if(!I)return{local:{added:C,updated:d,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const E=N(A,I);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:C,updated:d,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const $=N(D,A),c=N(D,I),g={},p={},w=new Set,h=new Set;for(const l of $.removed.values())c.updated.has(l)?C[l]=I[l]:w.add(l);for(const l of c.removed.values())h.has(l)||($.updated.has(l)?h.add(l):P.add(l));for(const l of $.updated.values())h.has(l)||(c.updated.has(l)?E.updated.has(l)&&h.add(l):p[l]=A[l]);for(const l of c.updated.values())h.has(l)||($.updated.has(l)?E.updated.has(l)&&h.add(l):A[l]!==void 0&&(d[l]=I[l]));for(const l of $.added.values())h.has(l)||(c.added.has(l)?E.updated.has(l)&&h.add(l):g[l]=A[l]);for(const l of c.added.values())h.has(l)||($.added.has(l)?E.updated.has(l)&&h.add(l):C[l]=I[l]);return{local:{added:C,removed:[...P.values()],updated:d},remote:{added:g,removed:[...w.values()],updated:p},conflicts:[...h.values()]}}e.$q3b=O;function N(A,I){const D=A?Object.keys(A):[],C=I?Object.keys(I):[],d=C.filter($=>!D.includes($)).reduce(($,c)=>($.add(c),$),new Set),P=D.filter($=>!C.includes($)).reduce(($,c)=>($.add(c),$),new Set),E=new Set;for(const $ of D){if(P.has($))continue;const c=A[$],g=I[$];c!==g&&E.add($)}return{added:d,removed:P,updated:E}}function j(A,I){const{added:D,removed:C,updated:d}=N(A,I);return D.size===0&&C.size===0&&d.size===0}e.$r3b=j}),define(oe[235],ae([0,1,30]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$4b=void 0;function N(A,I,D,C){const d={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!I){const $=A.filter(({id:c})=>!C.includes(c));return $.length?P.added=$:P=null,{local:d,remote:P}}const E=j(A,I,C);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const $=j(D,A,C),c=j(D,I,C);for(const g of c.removed){const p=A.find(w=>w.id===g);p&&d.removed.push(p)}for(const g of c.added){const p=I.find(w=>w.id===g);$.added.includes(g)?E.updated.includes(g)&&d.updated.push(p):d.added.push(p)}for(const g of c.updated)d.updated.push(I.find(p=>p.id===g));for(const g of $.added)c.added.includes(g)||P.added.push(A.find(p=>p.id===g));for(const g of $.updated)c.removed.includes(g)||c.updated.includes(g)||P.updated.push(A.find(p=>p.id===g));for(const g of $.removed){const p=I.find(w=>w.id===g);p&&P.removed.push(p)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:d,remote:P}}e.$$4b=N;function j(A,I,D){A=A?A.filter(({id:c})=>!D.includes(c)):[],I=I.filter(({id:c})=>!D.includes(c));const C=A.map(({id:c})=>c),d=I.map(({id:c})=>c),P=d.filter(c=>!C.includes(c)),E=C.filter(c=>!d.includes(c)),$=[];for(const{id:c,name:g,shortName:p,icon:w,useDefaultFlags:h}of A){if(E.includes(c))continue;const l=I.find(u=>u.id===c);(!l||l.name!==g||l.shortName!==p||l.icon!==w||!(0,O.$2m)(l.useDefaultFlags,h))&&$.push(c)}return{added:P,removed:E,updated:$}}}),define(oe[25],ae([0,1,18,12,174,49,29,4,103,40]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgb=e.$Ggb=e.$Fgb=e.$Egb=e.$Dgb=e.$Cgb=e.$Bgb=e.$Agb=e.$zgb=e.$ygb=e.$xgb=e.MergeState=e.Change=e.SyncStatus=e.$wgb=e.$vgb=e.$ugb=e.UserDataSyncErrorCode=e.$tgb=e.$sgb=e.$rgb=e.$qgb=e.$pgb=e.$ogb=e.$ngb=e.$mgb=e.$lgb=e.SyncResource=e.$kgb=e.$jgb=e.$igb=e.$hgb=e.$ggb=e.$fgb=void 0;function P(){const i=d.$0m.as(A.$cn.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.$fgb=P;function E(){const i=d.$0m.as(A.$cn.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(y=>!!i[y].ignoreSync),o=Object.keys(i).filter(y=>i[y].scope===2||i[y].scope===6),v=P();return(0,O.$Kb)([...r,...o,...v])}e.$ggb=E,e.$hgb="settingsSync",e.$igb="settingsSync.keybindingsPerPlatform";function $(){const i="vscode://schemas/ignoredSettings",r=d.$0m.as(A.$cn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,j.localize)(0,null),type:"object",properties:{[e.$igb]:{type:"boolean",description:(0,j.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,j.localize)(2,null),items:[{type:"string",pattern:I.$On,errorMessage:(0,j.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,j.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=d.$0m.as(C.$$m.JSONContribution),v=()=>{const y=P(),f=E(),m=Object.keys(A.$dn.properties).filter(T=>!f.includes(T)),L=f.filter(T=>!y.includes(T)),F={items:{type:"string",enum:[...m,...L.map(T=>`-${T}`)]}};o.registerSchema(i,F)};return r.onDidUpdateConfiguration(()=>v())}e.$jgb=$;function c(i){return i&&(0,N.$yf)(i)&&(0,N.$wf)(i.id)&&Array.isArray(i.scopes)}e.$kgb=c;var g;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$lgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(i,...r){return i?[i,...r]:r}e.$mgb=p;function w(i,r,o,v){return v.joinPath(o.userDataSyncHome,...p(i,r,`lastSync${r}.json`))}e.$ngb=w,e.$ogb=(0,D.$Mh)("IUserDataSyncStoreManagementService"),e.$pgb=(0,D.$Mh)("IUserDataSyncStoreService"),e.$qgb=(0,D.$Mh)("IUserDataSyncLocalStoreService"),e.$rgb="x-operation-id",e.$sgb="X-Execution-Id";function h(i){const r={};return r[e.$sgb]=i,r}e.$tgb=h;var l;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(l||(e.UserDataSyncErrorCode=l={}));class u extends Error{constructor(r,o,v,y){super(r),this.code=o,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$ugb=u;class b extends u{constructor(r,o,v,y,f){super(r,v,void 0,f),this.url=o,this.serverCode=y}}e.$vgb=b;class S extends u{constructor(r,o){super(r,o)}}e.$wgb=S,function(i){function r(o){if(o instanceof i)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new i(o.message,v[1],y,f)}return new i(o.message,"Unknown")}i.toUserDataSyncError=r}(u||(e.$ugb=u={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var a;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(a||(e.Change=a={}));var s;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(s||(e.MergeState=s={})),e.$xgb="sync.store.url.type";function n(i){return`sync.enable.${i}`}e.$ygb=n,e.$zgb=(0,D.$Mh)("IUserDataSyncEnablementService"),e.$Agb=(0,D.$Mh)("IUserDataSyncService"),e.$Bgb=(0,D.$Mh)("IUserDataSyncResourceProviderService"),e.$Cgb=(0,D.$Mh)("IUserDataAutoSyncService"),e.$Dgb=(0,D.$Mh)("IUserDataSyncUtilService"),e.$Egb=(0,D.$Mh)("IUserDataSyncLogService"),e.$Fgb="userDataSync",e.$Ggb="vscode-userdata-sync",e.$Hgb="preview"}),define(oe[236],ae([0,1,30,25]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PDb=void 0;function j(I,D,C,d,P){if(!D)return{remote:{added:Object.keys(I),removed:[],updated:[],all:Object.keys(I).length>0?I:null},local:{added:{},removed:[],updated:{}}};const E=A(I,D);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const $=C?A(C,D):{added:Object.keys(D).reduce((l,u)=>(l.add(u),l),new Set),removed:new Set,updated:new Set},c=C?A(C,I):{added:Object.keys(I).reduce((l,u)=>(l.add(u),l),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},p=O.$Xm(D),w=!C;for(const l of c.added.values())l!==N.$xgb&&w&&$.added.has(l)||(p[l]=I[l]);for(const l of c.updated.values())p[l]=I[l];for(const l of c.removed.values())d.unregistered.includes(l)||delete p[l];for(const l of $.added.values()){const u=D[l];if(d.machine.includes(l)){P.info(`GlobalState: Skipped adding ${l} in local storage because it is declared as machine scoped.`);continue}if(C&&c.added.has(l))continue;const b=I[l];b&&b.value===u.value||l===N.$xgb&&w&&c.added.has(l)||(b?g.updated[l]=u:g.added[l]=u)}for(const l of $.updated.values()){const u=D[l];if(d.machine.includes(l)){P.info(`GlobalState: Skipped updating ${l} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(l)||c.removed.has(l))continue;const b=I[l];b&&b.value===u.value||(g.updated[l]=u)}for(const l of $.removed.values()){if(d.machine.includes(l)){P.trace(`GlobalState: Skipped removing ${l} in local storage because it is declared as machine scoped.`);continue}c.updated.has(l)||c.removed.has(l)||g.removed.push(l)}const h=A(D,p);return{local:g,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:p}}}e.$PDb=j;function A(I,D){const C=Object.keys(I),d=Object.keys(D),P=d.filter(c=>!C.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),E=C.filter(c=>!d.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),$=new Set;for(const c of C){if(E.has(c))continue;const g=I[c],p=D[c];O.$2m(g,p)||$.add(c)}return{added:P,removed:E,updated:$}}}),define(oe[237],ae([0,1,18,35,85,41,30,77,25]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CCb=e.$BCb=e.$ACb=e.$zCb=e.$yCb=e.$xCb=void 0;function d(o,v,y){let f=[];y?f=E(y):f=P(v);const m=[],L=[...(0,C.$fgb)()];if(Array.isArray(f))for(const F of f)F.startsWith("-")?L.push(F.substring(1)):m.push(F);return(0,O.$Kb)([...o,...m].filter(F=>!L.includes(F)))}e.$xCb=d;function P(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,N.$Nm)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function $(o,v){const y=(0,N.$Nm)(o)||{};let f="{}";for(const m of Object.keys(y)){const L=(0,j.$OS)(f,[m],y[m],v);f=(0,j.$RS)(f,L)}return f}e.$yCb=$;function c(o,v,y,f){if(y.length){const m=r(v),L=(0,N.$Nm)(v)||{},F=(0,N.$Nm)(o);if(!F)return o;const T=[];for(const z of y){const q=L[z],_=F[z];q===void 0?o=D.edit(o,[z],void 0,f):_!==void 0?o=D.edit(o,[z],q,f):T.push(t(z,m))}T.sort((z,q)=>z.startOffset-q.startOffset),T.forEach(z=>o=l(z.setting.key,v,o,f))}return o}e.$zCb=c;function g(o,v,y,f,m,L){const F=c(o,v,f,L),T=y!==F,z=y!==v;if(!T&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!z)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(z&&!T)return{conflictsSettings:[],localContent:c(v,o,f,L),remoteContent:null,hasConflicts:!1};if(y===null&&w(o)){const R=p(o,v,f)?null:c(v,o,f,L);return{conflictsSettings:[],localContent:R,remoteContent:null,hasConflicts:!1}}let q=o,_=v;const Q=(0,N.$Nm)(o),Z=(0,N.$Nm)(v),G=y?(0,N.$Nm)(y):null,K=f.reduce((R,U)=>(R.add(U),R),new Set),H=h(Q,Z,K),V=h(G,Q,K),W=h(G,Z,K),ee=new Map,ne=new Set,re=R=>{ne.add(R);const U=m.filter(({key:M})=>M===R)[0];U?(q=D.edit(q,[R],U.value,L),_=D.edit(_,[R],U.value,L)):ee.set(R,{key:R,localValue:Q[R],remoteValue:Z[R]})};for(const R of V.removed.values())W.updated.has(R)?re(R):_=D.edit(_,[R],void 0,L);for(const R of W.removed.values())ne.has(R)||(V.updated.has(R)?re(R):q=D.edit(q,[R],void 0,L));for(const R of V.updated.values())ne.has(R)||(W.updated.has(R)?H.updated.has(R)&&re(R):_=D.edit(_,[R],Q[R],L));for(const R of W.updated.values())ne.has(R)||(V.updated.has(R)?H.updated.has(R)&&re(R):q=D.edit(q,[R],Z[R],L));for(const R of V.added.values())ne.has(R)||(W.added.has(R)?H.updated.has(R)&&re(R):_=l(R,q,_,L));for(const R of W.added.values())ne.has(R)||(V.added.has(R)?H.updated.has(R)&&re(R):q=l(R,_,q,L));const Y=ee.size>0||!p(q,_,f),B=Y||!p(q,o,[]),k=Y||!p(_,v,[]);return{localContent:B?q:null,remoteContent:k?_:null,conflictsSettings:[...ee.values()],hasConflicts:Y}}e.$ACb=g;function p(o,v,y){if(o===v)return!0;const f=(0,N.$Nm)(o),m=(0,N.$Nm)(v),L=y.reduce((z,q)=>(z.add(q),z),new Set),F=r(o).filter(z=>!(z.setting&&L.has(z.setting.key))),T=r(v).filter(z=>!(z.setting&&L.has(z.setting.key)));if(F.length!==T.length)return!1;for(let z=0;z<F.length;z++){const q=F[z],_=T[z];if(q.setting&&_.setting){if(q.setting.key!==_.setting.key||!I.$2m(f[q.setting.key],m[q.setting.key]))return!1}else if(!q.setting&&!_.setting){if(q.value!==_.value)return!1}else return!1}return!0}function w(o){return o?r(o).length===0:!0}e.$BCb=w;function h(o,v,y){const f=o?Object.keys(o).filter(z=>!y.has(z)):[],m=Object.keys(v).filter(z=>!y.has(z)),L=m.filter(z=>!f.includes(z)).reduce((z,q)=>(z.add(q),z),new Set),F=f.filter(z=>!m.includes(z)).reduce((z,q)=>(z.add(q),z),new Set),T=new Set;if(o)for(const z of f){if(F.has(z))continue;const q=o[z],_=v[z];I.$2m(q,_)||T.add(z)}return{added:L,removed:F,updated:T}}function l(o,v,y,f){const m=(0,N.$Nm)(v),L=r(v),F=r(y),T=u(o,L,F);return b(y,o,m[o],T,F,f)}e.$CCb=l;function u(o,v,y){const f=v.findIndex(L=>L.setting?.key===o),m=v[f-1];if(m){if(m.setting){const F=t(m.setting.key,y);if(F)return{index:y.indexOf(F),insertAfter:!0}}else{const F=a(f,v);if(F){const T=t(F.setting.key,y);if(T){const z=s(y.indexOf(T),y),q=n(v,F,v[f]);if(z){const _=n(y,T,z),Q=i(q,_);return Q?{index:y.indexOf(Q),insertAfter:!0}:{index:y.indexOf(z),insertAfter:!1}}else{const _=n(y,T,y[y.length-1]),Q=i(q,_);return Q?{index:y.indexOf(Q),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const L=v[f+1];if(L)if(L.setting){const F=t(L.setting.key,y);if(F)return{index:y.indexOf(F),insertAfter:!1}}else{const F=s(f,v);if(F){const T=t(F.setting.key,y);if(T){const z=a(y.indexOf(T),y),q=n(v,v[f],F);if(z){const _=n(y,z,T),Q=i(q.reverse(),_.reverse());return Q?{index:y.indexOf(Q),insertAfter:!1}:{index:y.indexOf(z),insertAfter:!0}}else{const _=n(y,y[0],T),Q=i(q.reverse(),_.reverse());return Q?{index:y.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function b(o,v,y,f,m,L){let F;return f.index===-1?F=(0,j.$OS)(o,[v],y,L):F=S(o,v,y,f,m,L).map(T=>(0,j.$PS)(o,T,L)[0]),(0,j.$RS)(o,F)}function S(o,v,y,f,m,L){const F=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,T=(0,A.$LS)(L,o),z=m[f.index];if(f.insertAfter){const q=[];if(z.setting)q.push({offset:z.endOffset,length:0,content:","+F});else{const _=s(f.index,m),Q=a(f.index,m),Z=Q?.setting?.commaOffset;Q&&Z===void 0&&q.push({offset:Q.endOffset,length:0,content:","});const G=Z!==void 0&&Z>z.endOffset;q.push({offset:G?Z+1:z.endOffset,length:0,content:_?T+F+",":T+F})}return q}else{if(z.setting)return[{offset:z.startOffset,length:0,content:F+","}];const q=(m[f.index-1]&&!m[f.index-1].setting?T:"")+F+(s(f.index,m)?",":"")+T;return[{offset:z.startOffset,length:0,content:q}]}}function t(o,v){return v.filter(y=>y.setting?.key===o)[0]}function a(o,v){for(let y=o-1;y>=0;y--)if(v[y].setting)return v[y]}function s(o,v){for(let y=o+1;y<v.length;y++)if(v[y].setting)return v[y]}function n(o,v,y){const f=o.indexOf(v),m=o.indexOf(y);return o.filter((L,F)=>f<F&&F<m)}function i(o,v){if(o.length&&v.length){let y=0;for(;y<v.length&&y<o.length;y++)if(o[y].value!==v[y].value)return v[y-1];return v[y-1]}}function r(o){const v=[];let y=-1,f,m;const L={onObjectBegin:F=>{y++},onObjectProperty:(F,T,z)=>{y===0&&(f=T,m=F)},onObjectEnd:(F,T)=>{y--,y===0&&v.push({startOffset:f,endOffset:F+T,value:o.substring(f,F+T),setting:{key:m,commaOffset:void 0}})},onArrayBegin:(F,T)=>{y++},onArrayEnd:(F,T)=>{y--,y===0&&v.push({startOffset:f,endOffset:F+T,value:o.substring(f,F+T),setting:{key:m,commaOffset:void 0}})},onLiteralValue:(F,T,z)=>{y===0&&v.push({startOffset:f,endOffset:T+z,value:o.substring(f,T+z),setting:{key:m,commaOffset:void 0}})},onSeparator:(F,T,z)=>{if(y===0&&F===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const _=v[q];_&&v.splice(q,1,{startOffset:_.startOffset,endOffset:_.endOffset,value:_.value,setting:{key:_.setting.key,commaOffset:T}})}},onComment:(F,T)=>{y===0&&v.push({startOffset:F,endOffset:F+T,value:o.substring(F,F+T)})}};return(0,N.$Um)(o,L),v}}),define(oe[78],ae([0,1,3,2,4,25]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iCb=e.$hCb=void 0,e.$hCb=(0,j.$Mh)("IUserDataSyncAccountService");let I=class extends N.$Qc{get account(){return this.a}constructor(C,d){super(),this.g=C,this.h=d,this.b=this.B(new O.$Ld),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$Ld),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.$iCb=I,e.$iCb=I=ye([x(0,A.$pgb),x(1,A.$Egb)],I)}),define(oe[238],ae([0,1,2,9]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r8b=e.$q8b=e.$p8b=e.$o8b=e.$n8b=e.$m8b=e.$l8b=void 0;class j{constructor($){this.a=$}listen($,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$l8b=j;class A{constructor($){this.a=$}listen($,c){throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$m8b=A;class I{constructor($){this.a=$}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings($){return this.a.call("resolveUserKeybindings",[$])}async resolveFormattingOptions($){return this.a.call("resolveFormattingOptions",[$])}}e.$n8b=I;class D{constructor($){this.a=$}listen($,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call($,c,g){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$o8b=D;class C{constructor($){this.a=$}listen($,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$p8b=C;class d{constructor($){this.a=$}listen($,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$q8b=d;class P extends O.$Qc{constructor($){super(),this.a=$,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch($){return this.a.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.a.call("getPreviousUserDataSyncStore");return this.b($)}b($){return{url:N.URI.revive($.url),type:$.type,defaultUrl:N.URI.revive($.defaultUrl),insidersUrl:N.URI.revive($.insidersUrl),stableUrl:N.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}}e.$r8b=P}),define(oe[239],ae([0,1,21,175,14,7,25]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vEb=void 0;let D=class extends A.$_i{constructor(d,P){super(),this.g=this.B(d.createLogger((0,O.$tg)(P.logsHome,`${I.$Fgb}.log`),{id:I.$Fgb,name:(0,N.localize)(0,null)}))}trace(d,...P){this.g.trace(d,...P)}debug(d,...P){this.g.debug(d,...P)}info(d,...P){this.g.info(d,...P)}warn(d,...P){this.g.warn(d,...P)}error(d,...P){this.g.error(d,...P)}flush(){this.g.flush()}};e.$vEb=D,e.$vEb=D=ye([x(0,A.$8i),x(1,j.$Th)],D)}),define(oe[112],ae([0,1,7,4,24]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S8b=e.$R8b=void 0,e.$R8b=(0,N.$Mh)("voiceRecognitionService");let A=class{constructor(D,C){this.a=D,this.b=C}async transcribe(D,C){const d=process.env.VSCODE_VOICE_MODULE_PATH;if(!d||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${D.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const P=Date.now();try{const E=te.__$__nodeRequire(d),$=new AbortController;C.onCancellationRequested(()=>$.abort());const c=await E.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:D},{language:"en",signal:$.signal});return this.a.info(`[voice] transcribe(${D.length}): Text "${c}", took ${Date.now()-P}ms)`),c}catch(E){throw this.a.error(`[voice] transcribe(${D.length}): Failed width "${E}", took ${Date.now()-P}ms)`),E}}};e.$S8b=A,e.$S8b=A=ye([x(0,O.$7i),x(1,j.$mj)],A)}),define(oe[240],ae([0,1,2,112,7,26,5]),function(te,e,O,N,j,A,I){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$T8b=void 0;let C=class extends O.$Qc{static{D=this}static{this.a=!!process.env.VSCODE_VOICE_USE_SLIDING_WINDOW}constructor(c,g,p){super(),this.b=c,this.c=g,this.f=p,this.g()}g(){this.B(this.b(c=>{this.f.info(`[voice] transcriber: new connection (sliding window: ${D.a})`),D.a?this.B(new P(c,this.c,this.f)):this.B(new E(c,this.c,this.f))}))}};e.$T8b=C,e.$T8b=C=D=ye([x(1,N.$R8b),x(2,j.$7i)],C);class d extends O.$Qc{static{this.a=30*16e3*16*1/8}constructor(c,g,p){super(),this.b=c,this.c=g,this.f=p,this.g()}g(){const c=new A.$Vd;this.B((0,O.$Oc)(()=>c.dispose(!0)));const g=w=>{w.data instanceof Float32Array&&this.h(w.data,c.token)};this.b.on("message",g),this.B((0,O.$Oc)(()=>this.b.off("message",g))),this.b.start();let p=!1;this.b.on("close",()=>{this.f.info("[voice] transcriber: closed connection"),p=!0,this.dispose()}),this.B((0,O.$Oc)(()=>{p||this.b.close()}))}j(c){const g=new Float32Array(c.reduce((w,h)=>w+h.length,0));let p=0;for(const w of c)g.set(w,p),p+=w.length;return g}}class P extends d{constructor(){super(...arguments),this.m=this.B(new I.$Yg),this.n=[],this.r=new Float32Array(0)}async h(c,g){if(c.length>0)this.f.info("[voice] transcriber: voice detected, storing in buffer"),this.r=this.r?this.j([this.r,c]):c;else{this.f.info("[voice] transcriber: silence detected, transcribing window...");const p=this.r.slice(0);this.r=new Float32Array(0),this.m.queue(()=>this.t(p,g))}}async t(c,g){if(!g.isCancellationRequested){if(c.length>d.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}if(c.length!==0){const p=await this.c.transcribe(c,g);p&&this.n.push(p)}g.isCancellationRequested||this.b.postMessage(this.n.join(" "))}}dispose(){super.dispose(),this.r=new Float32Array(0)}}class E extends d{constructor(){super(...arguments),this.m=new I.$Zg,this.n=void 0,this.r=0,this.s=""}async h(c,g){const p=this.n?this.j([this.n,c]):c;if(p.length>d.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.n=p,this.m.queue(()=>this.u(g))}async u(c){if(c.isCancellationRequested)return;const g=this.n?.slice(0);if(!g)return;let p;g.length===this.r?(this.f.info("[voice] transcriber: silence detected, reusing previous transcription result"),p=this.s):(this.f.info("[voice] transcriber: voice detected, transcribing everything..."),p=await this.c.transcribe(g,c)),this.s=p,this.r=g.length,!c.isCancellationRequested&&this.b.postMessage(p)}dispose(){super.dispose(),this.n=void 0}}}),define(oe[241],ae([0,1,5,3,2]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;class A extends j.$Qc{constructor({onDidOpenWindow:D,onDidFocusWindow:C,getActiveWindowId:d}){super(),this.a=this.B(new j.$Pc),N.Event.latch(N.Event.any(D,C))(this.f,this,this.a),this.b=(0,O.$Fg)(()=>d()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(D){this.b&&(this.b.cancel(),this.b=void 0),this.c=D}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$p7b=A}),define(oe[113],ae([0,1,178,16,47,21,9,4,23]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.WorkbenchState=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,D.$Mh)("contextService");function d(n){const i=n;return typeof i?.id=="string"&&I.URI.isUri(i.uri)}e.$Wh=d;function P(n){return typeof n?.id=="string"&&!d(n)&&!$(n)}e.$Xh=P,e.$Yh={id:"ext-dev"},e.$Zh={id:"empty-window"};function E(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,N.$lc)(n)}:i?e.$Yh:e.$Zh;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$1h=E;function $(n){const i=n;return typeof i?.id=="string"&&I.URI.isUri(i.configPath)}e.$2h=$;function c(n){const i=n;if(i?.uri)return{id:i.id,uri:I.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$3h=c;var g;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$4h=p;function w(n){const i=n;return!!(i&&typeof i=="object"&&I.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$5h=w;class h{constructor(i,r,o,v,y){this.h=i,this.j=o,this.k=v,this.l=y,this.c=j.$Sh.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=j.$Sh.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$6h=h;class l{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.$tg)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$7h=l;function u(n){return new l({uri:n,index:0,name:(0,A.$pg)(n)},{uri:n.toString()})}e.$8h=u,e.$9h="code-workspace",e.$0h=`.${e.$9h}`,e.$$h=[{name:(0,O.localize)(0,null),extensions:[e.$9h]}],e.$_h="workspace.json";function b(n,i){return A.$kg.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$ai=b;function S(n){let i;return I.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===C.Schemas.tmp}e.$bi=S,e.$ci="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$ci}e.$di=t;function a(n,i){return!b(n,i)&&!S(n)}e.$ei=a;function s(n){return(typeof n=="string"?(0,N.$mc)(n):(0,A.$rg)(n))===e.$0h}e.$fi=s}),define(oe[17],ae([0,1,51,3,2,21,9,169,14,11,4,7,113,34,28,5,32,27,12]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.ProfileResourceType=void 0;var u;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function b(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&I.URI.isUri(i.location)&&I.URI.isUri(i.globalStorageHome)&&I.URI.isUri(i.settingsResource)&&I.URI.isUri(i.keybindingsResource)&&I.URI.isUri(i.tasksResource)&&I.URI.isUri(i.snippetsHome)&&I.URI.isUri(i.extensionsResource))}e.$Fk=b,e.$Gk=(0,P.$Mh)("IUserDataProfilesService");function S(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:I.URI.revive(n.location).with({scheme:i}),globalStorageHome:I.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:I.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:I.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:I.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:I.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:I.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:I.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Hk=S;function t(n,i,r,o,v,y){return{id:n,name:i,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:y&&v?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$tg)(r,"globalStorage"),settingsResource:y&&v?.useDefaultFlags?.settings?y.settingsResource:(0,A.$tg)(r,"settings.json"),keybindingsResource:y&&v?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$tg)(r,"keybindings.json"),tasksResource:y&&v?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$tg)(r,"tasks.json"),snippetsHome:y&&v?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$tg)(r,"snippets"),extensionsResource:y&&v?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$tg)(r,"extensions.json"),cacheHome:(0,A.$tg)(o,n),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Ik=t;let a=class extends j.$Qc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,r,o,v){super(),this.t=i,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new N.$Ld),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Ld),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Ld),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Ld),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$yc,emptyWindows:new Map},this.profilesHome=(0,A.$tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),r=[i];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,l.$wf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(t((0,A.$qg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},i))}}catch(y){this.y.error(y)}const o=new c.$yc,v=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[f,m]of Object.entries(y.workspaces)){const L=I.URI.parse(f),F=r.find(T=>T.id===m);F&&o.set(L,F)}if(y.emptyWindows)for(const[f,m]of Object.entries(y.emptyWindows)){const L=r.find(F=>F.id===m);L&&v.set(f,L)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const i=t("__default__profile__",(0,D.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",o=new RegExp(`${(0,h.$De)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const m=o.exec(f.name),L=m?parseInt(m[1]):0;v=L>v?L:v}const y=`${r} ${v+1}`;return this.createProfile((0,O.$Ai)((0,w.$cg)()).toString(16),y,{transient:!0},i)}async createNamedProfile(i,r,o){return this.createProfile((0,O.$Ai)((0,w.$cg)()).toString(16),i,r,o)}async createProfile(i,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(i,r,o);return v&&await this.setProfileForWorkspace(v,y),y}async F(i,r,o){if(!(0,l.$wf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const y=this.profiles.find(L=>L.name===r||L.id===i);if(y)return y;const f=t(i,r,(0,A.$tg)(this.profilesHome,i),this.g,o,this.defaultProfile);await this.u.createFolder(f.location);const m=[];return this.j.fire({profile:f,join(L){m.push(L)}}),await p.Promises.settled(m),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=t(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,d.$lk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(i,o)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.G(i);return I.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(i){return(0,$.$Wh)(i)?i.uri:(0,$.$2h)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location)))}I(i,r,o){const v=[...this.profiles,...i],y=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some(m=>f.id===m.id)||(f=o.find(m=>f.id===m.id)??f,f.isTransient?this.s.profiles.push(f):y.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(y),this.z=void 0,this.J(i,r,o)}J(i,r,o){this.h.fire({added:i,removed:r,updated:o,all:this.profiles})}L(i,r,o){o=r?.isTransient?!0:o,o||this.L(i,void 0,!0);const v=this.G(i),y=o?this.s:this.C;I.URI.isUri(v)?(y.workspaces.delete(v),r&&y.workspaces.set(v,r)):(y.emptyWindows.delete(v),r&&y.emptyWindows.set(v,r)),o||this.M()}M(){const i={};for(const[o,v]of this.C.workspaces.entries())i[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:i,emptyWindows:r}),this.z=void 0}N(i){const r={},o=this.D();if(i.workspaces)for(const[y,f]of Object.entries(i.workspaces)){const m=I.URI.parse(f);r[y]=this.w.extUri.isEqual(m,o.location)?o.id:this.w.extUri.basename(m)}const v={};if(i.emptyWindows)for(const[y,f]of Object.entries(i.emptyWindows)){const m=I.URI.parse(f);v[y]=this.w.extUri.isEqual(m,o.location)?o.id:this.w.extUri.basename(m)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Jk=a,e.$Jk=a=ye([x(0,C.$Th),x(1,d.$8j),x(2,g.$Ek),x(3,E.$7i)],a);class s extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Kk=s}),define(oe[242],ae([0,1,5,2,17]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z8b=void 0;let A=class extends N.$Qc{constructor(D){super(),this.B(new O.$4g(()=>{D.cleanUp()},10*1e3)).schedule()}};e.$z8b=A,e.$z8b=A=ye([x(0,j.$Gk)],A)}),define(oe[243],ae([0,1,18,5,26,8,3,2,6,12,9,152,29,33,44,7,24,22,28,17]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=void 0;let b=class extends D.$Qc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,r,o,v,y,f){super(),this.z=i,this.C=r,this.D=o,this.F=v,this.G=y,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$Ld),this.s=this.B(new I.$Ld),this.t=this.B(new I.$Ld),this.u=this.B(new I.$Ld),this.w=this.B(new I.$Ld),this.y=[],this.B((0,D.$Oc)(()=>{this.j.forEach(({task:m})=>m.cancel()),this.m.forEach(m=>m.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,$.$Yn)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const v=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:y})=>(0,c.$ro)(y,i.identifier));if(v?.local)return v?.local;throw v?.error?v.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(o){throw t(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new $.$3n(E.localize(0,null),$.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(i.map(async({extension:v,options:y})=>{try{const f=await this.O(v,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);o.push({...f,options:y})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!P.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,c.$zo)(v.source),error:v.error}));return r}async uninstall(i,r={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.Q(i,r)}async toggleAppliationScope(i,r){if((0,g.$1l)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(i,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const y=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,c.$ro)(f.identifier,i.identifier));y?this.w.fire(y):this.u.fire({identifier:i.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(i,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.X(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const r=[];return await Promise.allSettled(i.map(async o=>{try{const v=await this.J(o);r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$wo)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:i,extension:r,options:o}){const v=o.isApplicationScoped||o.isBuiltin||(0,g.$1l)(i),y={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},f=q=>`${c.$so.create(q).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const q=this.j.get(f(r));if(q)return this.F.info("Extensions is already requested to install",r.identifier.id),await q.task.waitUntilTaskIsFinished(),[]}const m=[],L=[],F=[],T=this.Z(i,r,y);P.URI.isUri(r)||this.j.set(f(r),{task:T,waitingTasks:[]}),this.n.fire({identifier:T.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",T.identifier.id),m.push({task:T,manifest:i});let z=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const _=await this.N(T.identifier,i,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),Q=await this.getInstalled(void 0,y.profileLocation),Z={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[$.$Tn]:!0}};for(const{gallery:G,manifest:K}of(0,O.$Kb)(_,({gallery:H})=>H.identifier.id)){z=z||!!K.extensionDependencies?.some(W=>(0,c.$ro)({id:W},T.identifier));const H=f(G),V=this.j.get(H);if(V){if(this.L(T,V.task)){const W=V.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,T.identifier.id),V.waitingTasks.push(T),L.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ne=>(0,c.$ro)(ne.identifier,W)))).then(ee=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,T.identifier.id),!ee.find(re=>(0,c.$ro)(re.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!Q.some(({identifier:W})=>(0,c.$ro)(W,G.identifier))){const W=this.Z(K,G,Z);this.j.set(H,{task:W,waitingTasks:[T]}),this.n.fire({identifier:W.identifier,source:G,profileLocation:y.profileLocation}),this.F.info("Installing extension:",W.identifier.id,T.identifier.id),m.push({task:W,manifest:K})}}}catch(_){if(P.URI.isUri(T.source))(0,O.$Jb)(i.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,_.message),(0,O.$Jb)(i.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,_.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),_}const q=m.reduce((_,{task:Q,manifest:Z})=>(_.set(Q.identifier.id.toLowerCase(),{task:Q,manifest:Z}),_),new Map);for(;q.size;){let _;const Q=[...q.values()].filter(({manifest:Z})=>!Z.extensionDependencies?.some(G=>q.has(G.toLowerCase())));Q.length?_=q.size===1?Q:Q.filter(({task:Z})=>!(Z===T&&!z)):(this.F.info("Found extensions with circular dependencies",Q.map(({task:Z})=>Z.identifier.id)),_=[...q.values()]),await this.M(_.map(async({task:Z})=>{const G=new Date().getTime();try{const K=await Z.run();if(await this.M(this.y.map(H=>H.postInstall(K,Z.source,y,j.CancellationToken.None))),!P.URI.isUri(Z.source)){const H=Z.operation===3,V=H?void 0:(new Date().getTime()-Z.source.lastUpdated)/1e3;if(a(this.C,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$zo)(Z.source),verificationStatus:Z.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:V}),C.$o&&Z.operation!==3)try{await this.z.reportStatistic(K.manifest.publisher,K.manifest.name,K.manifest.version,"install")}catch{}}F.push({local:K,identifier:Z.identifier,operation:Z.operation,source:Z.source,context:Z.options.context,profileLocation:Z.profileLocation,applicationScoped:K.isApplicationScoped})}catch(K){throw P.URI.isUri(Z.source)||a(this.C,Z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$zo)(Z.source),verificationStatus:Z.verificationStatus,duration:new Date().getTime()-G,error:K}),this.F.error("Error while installing the extension:",Z.identifier.id),K}finally{q.delete(Z.identifier.id.toLowerCase())}}))}return L.length&&await this.M(L),F.forEach(({identifier:_})=>this.F.info("Extension installed successfully:",_.id)),F}catch(q){if(m.forEach(({task:_})=>_.cancel()),F.length)try{const _=await Promise.allSettled(F.map(({local:Q})=>this.$(Q,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let Q=0;Q<_.length;Q++){const Z=_[Q],{identifier:G}=F[Q];Z.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",G.id):this.F.warn("Rollback: Error while uninstalling extension",G.id,(0,A.$8)(Z.reason))}}catch(_){this.F.warn("Error while rolling back extensions",(0,A.$8)(_),F.map(({identifier:Q})=>Q.id))}return m.map(({task:_})=>({identifier:_.identifier,operation:2,source:_.source,context:y.context,profileLocation:y.profileLocation,error:q}))}finally{for(const{task:q}of m)q.source&&!P.URI.isUri(q.source)&&this.j.delete(f(q.source))}}L(i,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===i&&(v.includes(r)||v.some(y=>this.L(y,r)))||o===r&&v[0]&&!this.L(i,v[0]))return!1;return!0}async M(i){const r=[],o=[],v=await Promise.allSettled(i);for(const y of v)y.status==="fulfilled"?r.push(y.value):o.push(y.reason);if(o.length)throw S(o);return r}async N(i,r,o,v,y){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,y),m=[],L=[],F=async(T,z)=>{m.push(T);const q=z.extensionDependencies||[],_=[...q];if(z.extensionPack){const Q=o?f.find(Z=>(0,c.$ro)(Z.identifier,T)):void 0;for(const Z of z.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(G=>(0,c.$ro)({id:G},{id:Z}))||_.every(G=>!(0,c.$ro)({id:G},{id:Z}))&&_.push(Z)}if(_.length){const Q=_.filter(Z=>m.every(G=>!(0,c.$ro)(G,{id:Z})));if(Q.length){const Z=await this.z.getExtensions(Q.map(G=>({id:G,preRelease:v})),j.CancellationToken.None);for(const G of Z){if(m.find(V=>(0,c.$ro)(V,G.identifier)))continue;const K=q.some(V=>(0,c.$ro)({id:V},G.identifier));let H;try{H=await this.O(G,!1,v)}catch(V){if(K)throw V;this.F.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,A.$8)(V));continue}L.push({gallery:H.extension,manifest:H.manifest}),await F(H.extension.identifier,H.manifest)}}}};return await F(i,r),L}async O(i,r,o){let v;const y=await this.getExtensionsControlManifest();if(y.malicious.some(L=>(0,c.$ro)(i.identifier,L)))throw new $.$3n(E.localize(1,null,i.identifier.id),$.ExtensionManagementErrorCode.Malicious);const f=y.deprecated[i.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},j.CancellationToken.None))[0],!v)throw new $.$3n(E.localize(2,null,i.identifier.id,f.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const L=await this.getTargetPlatform();throw new $.$3n(E.localize(3,null,i.identifier.id,this.G.nameLong,(0,$.$Un)(L)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(i,r,o),!v)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],j.CancellationToken.None))[0]?new $.$3n(E.localize(4,null,i.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$3n(E.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const m=await this.z.getManifest(v,j.CancellationToken.None);if(m===null)throw new $.$3n(`Missing manifest for extension ${v.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(m.version!==v.version)throw new $.$3n(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:m}}async P(i,r,o){const v=await this.getTargetPlatform();let y=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(y=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},j.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(i,o,v)&&(y=i),y||(r?y=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:v,compatible:!0},j.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(i,o,v)),y}async Q(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.m.get(v(i.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),y.waitUntilTaskIsFinished();const f=T=>{const z=this.$(T,o);return this.m.set(v(z.extension.identifier),z),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),z},m=(T,z)=>{z?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),z.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,z.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$yo)(T),error:z}),this.u.fire({identifier:T.identifier,error:z?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},L=[],F=[];try{L.push(f(i));const T=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const z=this.U(i,T);for(const q of z)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):L.push(f(q))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.R(L.map(z=>z.extension),T,i),await this.M(L.map(async z=>{try{if(await z.run(),await this.M(this.y.map(q=>q.postUninstall(z.extension,o,j.CancellationToken.None))),z.extension.identifier.uuid)try{await this.z.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}m(z.extension)}catch(q){const _=q instanceof $.$3n?q:new $.$3n((0,A.$8)(q),$.ExtensionManagementErrorCode.Internal);throw m(z.extension,_),_}finally{F.push(z)}}))}catch(T){const z=T instanceof $.$3n?T:new $.$3n((0,A.$8)(T),$.ExtensionManagementErrorCode.Internal);for(const q of L){try{q.cancel()}catch{}F.includes(q)||m(q.extension,z)}throw z}finally{for(const T of L)this.m.delete(v(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}R(i,r,o){for(const v of i){const y=this.W(v,r);if(y.length){const f=y.filter(m=>!i.some(L=>(0,c.$ro)(L.identifier,m.identifier)));if(f.length)throw new Error(this.S(v,f,o))}}}S(i,r,o){return o===i?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const v=i.manifest.extensionPack?i.manifest.extensionPack:[];if(v.length){const y=r.filter(m=>!m.isBuiltin&&v.some(L=>(0,c.$ro)({id:L},m.identifier))),f=[];for(const m of y)f.push(...this.U(m,r,o));return[...y,...f]}return[]}W(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,c.$ro)({id:v},i.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const i=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$hp=b,e.$hp=b=ye([x(0,$.$2n),x(1,h.$$k),x(2,l.$Ek),x(3,p.$7i),x(4,w.$mj),x(5,u.$Gk)],b);function S(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$ip=S;function t(n){if(n instanceof $.$3n)return n;const i=new $.$3n(n.message,$.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.$jp=t;function a(n,i,{extensionData:r,verificationStatus:o,duration:v,error:y,durationSinceUpdate:f}){let m,L;(0,d.$Ef)(o)&&(o===!0?o="Verified":(o===!1||(m=$.ExtensionManagementErrorCode.Signature,L=o),o="Unverified")),y&&(y instanceof $.$3n?(m=y.code,y.code===$.ExtensionManagementErrorCode.Signature&&(L=y.message)):m=$.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:o,success:!y,duration:v,errorcode:m,errorcodeDetail:L,durationSinceUpdate:f})}class s{constructor(){this.d=new N.$Qg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Fg)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Fg)(i=>new Promise((r,o)=>{const v=i.onCancellationRequested(()=>{v.dispose(),o(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$kp=s}),define(oe[50],ae([0,1,5,15,2,3,34,9,29,33,11,4,7,17,28,12,8,22]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class u extends Error{constructor(s,n){super(s),this.code=n}}e.$lp=u,e.$mp=(0,E.$Mh)("IExtensionsProfileScannerService");let b=class extends j.$Qc{constructor(s,n,i,r,o,v){super(),this.j=s,this.m=n,this.n=i,this.r=r,this.s=o,this.t=v,this.b=this.B(new A.$Ld),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Ld),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Ld),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Ld),this.onDidRemoveExtensions=this.g.event,this.h=new I.$yc}scanProfileExtensions(s,n){return this.u(s,void 0,n)}async addExtensionsToProfile(s,n){const i=[],r=[];try{return await this.u(n,o=>{const v=[];for(const y of o)s.some(([f])=>(0,d.$ro)(f.identifier,y.identifier)&&f.manifest.version!==y.version)?i.push(y):v.push(y);for(const[y,f]of s){const m=v.findIndex(F=>(0,d.$ro)(F.identifier,y.identifier)&&F.version===y.manifest.version),L={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:f};m===-1?(r.push(L),v.push(L)):v.splice(m,1,L)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),v}),r.length&&this.c.fire({extensions:r,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:o,profileLocation:n}),o}}async updateMetadata(s,n){const i=[];return await this.u(n,r=>{const o=[];for(const v of r){const y=s.find(([f])=>(0,d.$ro)(f.identifier,v.identifier)&&f.manifest.version===v.version);y&&(v.metadata={...v.metadata,...y[1]},i.push(v)),o.push(v)}return o}),i}async removeExtensionFromProfile(s,n){const i=[];try{await this.u(n,r=>{const o=[];for(const v of r)(0,d.$ro)(v.identifier,s.identifier)?i.push(v):o.push(v);return i.length&&this.f.fire({extensions:i,profileLocation:n}),o}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:n}),r}}async u(s,n,i){return this.F(s).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(s);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,P.$lk)(v)!==1)throw v;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&i?.bailOutWhenFileNotFound)throw new u((0,w.$8)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(s);let v=!1;for(const y of o){S(y)||this.w(s);let f;if((0,p.$wf)(y.relativeLocation)&&y.relativeLocation)f=this.z(y.relativeLocation);else if((0,p.$wf)(y.location))f=this.z(y.location),v=!0,y.relativeLocation=y.location,y.location=f.toJSON();else{f=D.URI.revive(y.location);const m=this.y(f);m&&(v=!0,y.relativeLocation=m)}r.push({identifier:y.identifier,location:f,version:y.version,metadata:y.metadata})}v&&await this.m.writeFile(s,N.$_d.fromString(JSON.stringify(o)))}if(n){r=n(r);const v=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(s,N.$_d.fromString(JSON.stringify(v)))}return r})}w(s){const n=new u(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(s)).value.toString()}catch(o){if((0,P.$lk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const o=JSON.parse(i);Array.isArray(o)&&o.every(v=>S(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$_d.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,P.$lk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(s)}catch(o){(0,P.$lk)(o)!==1&&this.t.error(o)}try{await this.m.del(n)}catch(o){(0,P.$lk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(s){let n=this.h.get(s);return n||(n=new O.$Yg,this.h.set(s,n)),n}};e.$np=b,e.$np=b=ye([x(1,P.$8j),x(2,c.$Gk),x(3,g.$Ek),x(4,h.$$k),x(5,$.$7i)],b);function S(a){return(0,p.$yf)(a)&&(0,C.$1n)(a.identifier)&&(t(a.location)||(0,p.$wf)(a.location)&&a.location)&&((0,p.$Df)(a.relativeLocation)||(0,p.$wf)(a.relativeLocation))&&a.version&&(0,p.$wf)(a.version)}function t(a){return a?(0,p.$wf)(a.path)&&(0,p.$wf)(a.scheme):!1}}),define(oe[79],ae([0,1,18,5,30,15,8,35,139,2,23,16,6,21,53,89,12,9,155,14,33,44,67,11,4,7,24,3,63,50,17,28,183]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S,t,a,s,n,i,r,o,v,y,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.Translations=void 0;var L;(function(Z){function G(K,H){if(K===H)return!0;const V=Object.keys(K),W=new Set;for(const ee of Object.keys(H))W.add(ee);if(V.length!==W.size)return!1;for(const ee of V){if(K[ee]!==H[ee])return!1;W.delete(ee)}return W.size===0}Z.equals=G})(L||(e.Translations=L={})),e.$qp=(0,s.$Mh)("IExtensionsScannerService");let F=class extends d.$Qc{constructor(G,K,H,V,W,ee,ne,re,Y,B,k,R){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=K,this.r=H,this.s=V,this.t=W,this.u=ee,this.w=ne,this.y=re,this.z=Y,this.C=B,this.D=k,this.F=R,this.g=this.B(new r.$Ld),this.onDidChangeCache=this.g.event,this.h=(0,c.$tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(z,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,b.$Co)(this.w,this.y)),this.G}async scanAllExtensions(G,K,H){const[V,W]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(K)]),ee=H?await this.scanExtensionsUnderDevelopment(G,[...V,...W]):[];return this.L(V,W,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const K=[];K.push(this.M(!!G.useCache,G.language)),K.push(this.N(G.language,!!G.checkControlFile));const[H,V]=await Promise.all(K);return this.J([...H,...V],0,G,!1)}async scanUserExtensions(G){const K=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const H=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(K,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,H),W=G.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ee;try{ee=await W.scanExtensions(V)}catch(ne){if(ne instanceof v.$lp&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ee=await W.scanExtensions(V);else throw ne}return ee=await this.J(ee,1,G,!0),this.y.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(G,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===P.Schemas.file).map(async V=>{const W=await this.P(V,!1,1,!0,G.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(ne=>(ne.type=K.find(re=>(0,b.$ro)(re.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,W)))}))).flat();return this.J(H,"development",G,!0)}return[]}async scanExistingExtension(G,K,H){const V=await this.P(G,!1,K,!0,H.language,!0,void 0),W=await this.n.scanExtension(V);return!W||!H.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(G,K,H){const V=await this.P(G,!1,K,!0,H.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(V);return this.J(W,K,H,!0)}async scanMetadata(G){const K=(0,c.$tg)(G,"package.json"),H=(await this.w.readFile(K)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(G,K){const H=(0,c.$tg)(G,"package.json"),V=(await this.w.readFile(H)).value.toString(),W=JSON.parse(V);K.isMachineScoped=K.isMachineScoped||void 0,K.isBuiltin=K.isBuiltin||void 0,W.__metadata={...W.__metadata,...K},await this.w.writeFile((0,c.$tg)(G,"package.json"),A.$_d.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof v.$lp&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$_d.fromString(JSON.stringify([])))}catch(K){(0,a.$lk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$8)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,K,H,V){return H.includeAllVersions||(G=this.L(K===0?G:void 0,K===1?G:void 0,K==="development"?G:void 0,await this.getTargetPlatform(),V)),H.includeInvalid||(G=G.filter(W=>W.isValid)),G.sort((W,ee)=>{const ne=E.$lc(W.location.fsPath),re=E.$lc(ee.location.fsPath);return ne<re?-1:ne>re?1:0})}L(G,K,H,V,W){const ee=(re,Y,B)=>{if(re.isValid&&!Y.isValid)return!1;if(re.isValid===Y.isValid){if(W&&g.gt(re.manifest.version,Y.manifest.version))return this.y.debug(`Skipping extension ${Y.location.path} with lower version ${Y.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(g.eq(re.manifest.version,Y.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${Y.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===V)return this.y.debug(`Skipping extension ${Y.location.path} from different target platform ${Y.targetPlatform}`),!1}}return B?this.y.warn(`Overwriting user extension ${re.location.path} with ${Y.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${Y.location.path}.`),!0},ne=new S.$Zl;return G?.forEach(re=>{const Y=ne.get(re.identifier.id);(!Y||ee(Y,re,!1))&&ne.set(re.identifier.id,re)}),K?.forEach(re=>{const Y=ne.get(re.identifier.id);if(!Y&&G&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!Y||ee(Y,re,!1))&&ne.set(re.identifier.id,re)}),H?.forEach(re=>{const Y=ne.get(re.identifier.id);(!Y||ee(Y,re,!0))&&ne.set(re.identifier.id,re),ne.set(re.identifier.id,re)}),[...ne.values()]}async M(G,K){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),W=await(G&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",W.length),W}async N(G,K){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const V=K?await this.O():{},W=[],ee=h.URI.file(E.$fc(E.$hc(P.$ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of H){const Y=V[re.name]||"marketplace";switch(Y){case"disabled":break;case"marketplace":W.push((0,c.$tg)(ee,re.name));break;default:W.push(h.URI.file(Y));break}}const ne=await Promise.all(W.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,G,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,O.$Fb)(ne)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,K,H,V,W,ee,ne){const re=await this.f(W??$.$v),Y=await this.Q(G),B=K&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,k=B?await this.Q(B):void 0;return new T(G,Y,B,k,K,ne,H,V,ee,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,re)}async Q(G){try{const K=await this.w.stat(G);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$rp=F,e.$rp=F=ye([x(4,y.$Gk),x(5,v.$mp),x(6,a.$8j),x(7,n.$7i),x(8,u.$Th),x(9,i.$mj),x(10,f.$Ek),x(11,s.$Lh)],F);class T{constructor(G,K,H,V,W,ee,ne,re,Y,B,k,R,U,M,J){this.location=G,this.mtime=K,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=V,this.profile=W,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=re,this.validate=Y,this.productVersion=B,this.productDate=k,this.productCommit=R,this.devMode=U,this.language=M,this.translations=J}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,K){return(0,c.$mg)(G.location,K.location)&&G.mtime===K.mtime&&(0,c.$mg)(G.applicationExtensionslocation,K.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&G.profile===K.profile&&j.$2m(G.profileScanOptions,K.profileScanOptions)&&G.type===K.type&&G.excludeObsolete===K.excludeObsolete&&G.validate===K.validate&&G.productVersion===K.productVersion&&G.productDate===K.productDate&&G.productCommit===K.productCommit&&G.devMode===K.devMode&&G.language===K.language&&L.equals(G.translations,K.translations)}}e.$sp=T;let z=class extends d.$Qc{constructor(G,K,H,V,W){super(),this.f=G,this.g=K,this.h=H,this.j=V,this.m=W}async scanExtensions(G){const K=G.profile?await this.r(G):await this.n(G);let H={};if(G.excludeObsolete&&G.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(V)}catch{}return(0,w.$Jf)(H)?K:K.filter(V=>!H[b.$so.create(V).toString()])}async n(G){const K=await this.j.resolve(G.location);if(!K.children?.length)return[];const H=await Promise.all(K.children.map(async V=>{if(!V.isDirectory||G.type===1&&(0,c.$qg)(V.resource).indexOf(".")===0)return null;const W=new T(V.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(W)}));return(0,O.$Fb)(H).sort((V,W)=>V.location.path<W.location.path?-1:1)}async r(G){let K=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){K=K.filter(V=>!V.metadata?.isApplicationScoped);const H=await this.s(G.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,G);K.push(...H)}return K}async s(G,K,H){const V=await this.g.scanProfileExtensions(G,H.profileScanOptions);if(!V.length)return[];const W=await Promise.all(V.map(async ee=>{if(K(ee)){const ne=new T(ee.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,O.$Fb)(W)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,c.$tg)(G.location,"package.json"))){const K=await this.scanExtension(G);return K?[K]:[]}else return await this.scanExtensions(G)}catch(K){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,I.$8)(K)),[]}}async scanExtension(G,K){try{let H=await this.scanExtensionManifest(G.location);if(H){H.publisher||(H.publisher=S.$Tl),K=K??H.__metadata,delete H.__metadata;const V=(0,b.$wo)(H.publisher,H.name),W=K?.id?{id:V,uuid:K.id}:{id:V},ee=K?.isSystem?0:G.type,ne=ee===0||!!K?.isBuiltin;H=await this.t(G.location,H,T.createNlsConfiguration(G));const re={type:ee,identifier:W,manifest:H,location:G.location,isBuiltin:ne,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return G.validate?this.validate(re,G):re}}catch(H){G.type!==0&&this.m.error(H)}return null}validate(G,K){let H=!0;const V=(0,t.$Ho)(K.productVersion,K.productDate,K.location,G.manifest,G.isBuiltin);for(const[W,ee]of V)W===p.default.Error&&(H=!1,this.m.error(this.z(K.location,ee)));return G.isValid=H,G.validations=V,G}async scanExtensionManifest(G){const K=(0,c.$tg)(G,"package.json");let H;try{H=(await this.j.readFile(K)).value.toString()}catch(W){return(0,a.$lk)(W)!==1&&this.m.error(this.z(G,(0,l.localize)(0,null,K.path,W.message))),null}let V;try{V=JSON.parse(H)}catch{const ee=[];(0,D.$Nm)(H,ee);for(const ne of ee)this.m.error(this.z(G,(0,l.localize)(1,null,K.path,ne.offset,ne.length,(0,C.$op)(ne.error))));return null}return(0,D.$Wm)(V)!=="object"?(this.m.error(this.z(G,(0,l.localize)(2,null,K.path))),null):V}async t(G,K,H){const V=await this.u(G,K,H);if(V)try{const W=[],ee=await this.w(V.default,W);if(W.length>0)return W.forEach(re=>{this.m.error(this.z(G,(0,l.localize)(3,null,V.default?.path,(0,C.$op)(re.error))))}),K;if((0,D.$Wm)(V)!=="object")return this.m.error(this.z(G,(0,l.localize)(4,null,V.default?.path))),K;const ne=V.values||Object.create(null);return(0,m.$pp)(this.m,K,ne,ee)}catch{}return K}async u(G,K,H){const V=(0,c.$tg)(G,"package.nls.json"),W=(Y,B)=>{B.forEach(k=>{this.m.error(this.z(G,(0,l.localize)(5,null,Y?.path,(0,C.$op)(k.error))))})},ee=Y=>{this.m.error(this.z(G,(0,l.localize)(6,null,Y?.path)))},ne=`${K.publisher}.${K.name}`,re=H.translations[ne];if(re)try{const Y=h.URI.file(re),B=(await this.j.readFile(Y)).value.toString(),k=[],R=(0,D.$Nm)(B,k);return k.length>0?(W(Y,k),{values:void 0,default:V}):(0,D.$Wm)(R)!=="object"?(ee(Y),{values:void 0,default:V}):{values:R.contents?R.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let B;try{B=await this.y(G,H)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const k=(await this.j.readFile(B.localized)).value.toString(),R=[],U=(0,D.$Nm)(k,R);return R.length>0?(W(B.localized,R),{values:void 0,default:B.original}):(0,D.$Wm)(U)!=="object"?(ee(B.localized),{values:void 0,default:B.original}):{values:U,default:B.original}}catch{return{values:void 0,default:B.original}}}}async w(G,K){if(G)try{const H=(await this.j.readFile(G)).value.toString();return(0,D.$Nm)(H,K)}catch{}}y(G,K){return new Promise((H,V)=>{const W=ee=>{const ne=(0,c.$tg)(G,`package.nls.${ee}.json`);this.j.exists(ne).then(re=>{re&&H({localized:ne,original:(0,c.$tg)(G,"package.nls.json")});const Y=ee.lastIndexOf("-");Y===-1?H({localized:(0,c.$tg)(G,"package.nls.json"),original:null}):(ee=ee.substring(0,Y),W(ee))})};if(K.devMode||K.pseudo||!K.language)return H({localized:(0,c.$tg)(G,"package.nls.json"),original:null});W(K.language)})}z(G,K){return`[${G.path}]: ${K}`}};z=ye([x(1,v.$mp),x(2,f.$Ek),x(3,a.$8j),x(4,n.$7i)],z);let q=class extends z{constructor(G,K,H,V,W,ee,ne){super(K,V,W,ee,ne),this.G=G,this.H=H,this.D=this.B(new N.$Pg(3e3)),this.F=this.B(new r.$Ld),this.onDidChangeCache=this.F.event}async scanExtensions(G){const K=this.M(G),H=await this.I(K);if(this.C=G,H&&H.input&&T.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),H.result.map(W=>(W.location=h.URI.revive(W.location),W));const V=await super.scanExtensions(G);return await this.J(K,{input:G,result:V}),V}async I(G){try{const K=await this.j.readFile(G),H=JSON.parse(K.value.toString());return{result:H.result,input:(0,o.$jh)(H.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",G.path,(0,I.$8)(K))}return null}async J(G,K){try{await this.j.writeFile(G,A.$_d.fromString(JSON.stringify(K)))}catch(H){this.m.debug("Error while writing the extension cache file:",G.path,(0,I.$8)(H))}}async L(){if(!this.C)return;const G=this.M(this.C),K=await this.I(G);if(!K)return;const H=K.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$2m(V,H))try{this.m.info("Invalidating Cache",H,V),await this.j.del(G),this.F.fire()}catch(W){this.m.error(W)}}M(G){const K=this.N(G);return this.h.extUri.joinPath(K.cacheHome,G.type===0?S.$Sl:S.$Rl)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(G.location,K.extensionsResource))??this.G:this.H.defaultProfile}};q=ye([x(2,y.$Gk),x(3,v.$mp),x(4,f.$Ek),x(5,a.$8j),x(6,n.$7i)],q);function _(Z,G){const K=(0,b.$uo)(Z.manifest.publisher,Z.manifest.name);return{id:K,identifier:new S.$Xl(K),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:G,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,...Z.manifest}}e.$tp=_;class Q extends F{constructor(G,K,H,V,W,ee,ne,re,Y,B,k,R){super(G,K,(0,c.$tg)(H,".vscode-oss-dev","extensions","control.json"),V,W,ee,ne,re,Y,B,k,R),this.R=(async()=>{if($.$y)try{const U=await this.w.readFile(h.URI.file($.$y));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(G){return this.R}}e.$up=Q}),define(oe[244],ae([0,1,64,5,38,3,2,23,16,31,7,17]),function(te,e,O,N,j,A,I,D,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;let $=class extends I.$Qc{constructor(g,p){super(),this.b=g,this.f=p,this.a=new N.$Xg(5)}async postUninstall(g){const p=this.g(g,"uninstall");p&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(w)}}));try{await d.Promises.rm(this.m(g))}catch(w){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(w)}}g(g,p){const w=`vscode:${p}`;if(g.location.scheme===D.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[w]=="string"){const h=g.manifest.scripts[w].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${w} should be a node script`),null):{script:(0,C.$hc)(g.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(g,p,w,h,l){return new Promise((u,b)=>{const S=this.j(g,p,w,l);let t;const a=s=>{t&&(clearTimeout(t),t=null),s?b(s):u(void 0)};S.on("error",s=>{a((0,j.$xi)(s)||"Unknown")}),S.on("exit",(s,n)=>{a(s?`post-${p} process exited with code ${s}`:void 0)}),h&&(t=setTimeout(()=>{t=null,S.kill(),b("timed out")},5e3))})}j(g,p,w,h){const l={silent:!0,execArgv:void 0},u=(0,O.fork)(g,[`--type=extension-post-${p}`,...w],l);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const b=A.Event.fromNodeEventEmitter(u.stdout,"data"),S=A.Event.fromNodeEventEmitter(u.stderr,"data");b(s=>this.f.info(h.identifier.id,h.manifest.version,`post-${p}`,s)),S(s=>this.f.error(h.identifier.id,h.manifest.version,`post-${p}`,s));const t=A.Event.any(A.Event.map(b,s=>({data:`%c${s}`,format:[""]})),A.Event.map(S,s=>({data:`%c${s}`,format:["color: red"]})));return A.Event.debounce(t,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100)(s=>{console.group(h.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),u}m(g){return(0,C.$hc)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$wp=$,e.$wp=$=ye([x(0,E.$Gk),x(1,P.$7i)],$)}),define(oe[245],ae([0,1,7,17,28,22,50,11,14,9]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;let P=class extends I.$np{constructor($,c,g,p,w,h){super(d.URI.file($.extensionsPath),c,g,p,w,h)}};e.$sN=P,e.$sN=P=ye([x(0,C.$Uh),x(1,D.$8j),x(2,N.$Gk),x(3,j.$Ek),x(4,A.$$k),x(5,O.$7i)],P)}),define(oe[246],ae([0,1,9,14,50,79,11,4,7,24,28,17]),function(te,e,O,N,j,A,I,D,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;let $=class extends A.$up{constructor(g,p,w,h,l,u,b,S){super(O.URI.file(l.builtinExtensionsPath),O.URI.file(l.extensionsPath),l.userHome,g.defaultProfile,g,p,w,h,l,u,b,S)}};e.$t7b=$,e.$t7b=$=ye([x(0,E.$Gk),x(1,j.$mp),x(2,I.$8j),x(3,C.$7i),x(4,N.$Uh),x(5,d.$mj),x(6,P.$Ek),x(7,D.$Lh)],$)}),define(oe[20],ae([0,1,5,3,2,100,12,66,4,17]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo="__$__isNewStorageMarker",e.$Wo="__$__targetStorageMarker",e.$Xo=(0,C.$Mh)("storageService");var P;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var E;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var $;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function c(l){const u=l.get(e.$Wo);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.$Yo=c;class g extends j.$Qc{static{this.a=60*1e3}constructor(u={flushInterval:g.a}){super(),this.m=u,this.b=this.B(new N.$Od),this.c=this.B(new N.$Od),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Ld),this.onWillSaveState=this.f.event,this.h=this.B(new O.$4g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Rc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(u,b,S){return N.Event.filter(this.b.event,t=>t.scope===u&&(b===void 0||t.key===b),S)}n(){this.j.value=(0,O.$8g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Lc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(u,b){const{key:S,external:t}=b;if(S===e.$Wo){switch(u){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:S,target:this.J(u)[S],external:t})}w(u){this.f.fire({reason:u})}get(u,b,S){return this.P(b)?.get(u,S)}getBoolean(u,b,S){return this.P(b)?.getBoolean(u,S)}getNumber(u,b,S){return this.P(b)?.getNumber(u,S)}getObject(u,b,S){return this.P(b)?.getObject(u,S)}storeAll(u,b){this.y(()=>{for(const S of u)this.store(S.key,S.value,S.scope,S.target,b)})}store(u,b,S,t,a=!1){if((0,I.$Ff)(b)){this.remove(u,S,a);return}this.y(()=>{this.z(u,S,t),this.P(S)?.set(u,b,a)})}remove(u,b,S=!1){this.y(()=>{this.z(u,b,void 0),this.P(b)?.delete(u,S)})}y(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,b){const S=[],t=this.J(u);for(const a of Object.keys(t))t[a]===b&&S.push(a);return S}z(u,b,S,t=!1){const a=this.J(b);typeof S=="number"?a[u]!==S&&(a[u]=S,this.P(b)?.set(e.$Wo,JSON.stringify(a),t)):typeof a[u]=="number"&&(delete a[u],this.P(b)?.set(e.$Wo,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(u){switch(u){case-1:return this.I;case 0:return this.G;default:return this.D}}L(u){const b=this.P(u);return b?c(b):Object.create(null)}isNew(u){return this.getBoolean(e.$Vo,u)===!0}async flush(u=P.NONE){this.f.fire({reason:u});const b=this.P(-1),S=this.P(0),t=this.P(1);switch(u){case P.NONE:await O.Promises.settled([b?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await O.Promises.settled([b?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.P(-1)?.items??new Map,b=this.P(0)?.items??new Map,S=this.P(1)?.items??new Map;return h(u,b,S,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(u){return await this.flush(),this.P(u)?.optimize()}async switch(u,b){return this.w(P.NONE),(0,d.$Fk)(u)?this.R(u,b):this.S(u,b)}M(u,b){return!(u.id===b.id||p(b)&&p(u))}N(u,b,S){this.y(()=>{const t=new Set;for(const[a,s]of u)t.add(a),b.get(a)!==s&&this.u(S,{key:a,external:!0});for(const[a]of b.items)t.has(a)||this.u(S,{key:a,external:!0})})}}e.$Zo=g;function p(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.$1o=p;class w extends g{constructor(){super(),this.U=this.B(new D.$To(new D.$Uo,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new D.$To(new D.$Uo,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new D.$To(new D.$Uo,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(u=>this.u(1,u))),this.B(this.W.onDidChangeStorage(u=>this.u(0,u))),this.B(this.U.onDidChangeStorage(u=>this.u(-1,u)))}P(u){switch(u){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(u){return!1}}e.$2o=w;async function h(l,u,b,S,t,a){const s=L=>{try{return JSON.parse(L)}catch{return L}},n=new Map,i=new Map;l.forEach((L,F)=>{n.set(F,L),i.set(F,s(L))});const r=new Map,o=new Map;u.forEach((L,F)=>{r.set(F,L),o.set(F,s(L))});const v=new Map,y=new Map;b.forEach((L,F)=>{v.set(F,L),y.set(F,s(L))}),console.group(S!==t?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const f=[];if(n.forEach((L,F)=>{f.push({key:F,value:L})}),console.table(f),console.groupEnd(),console.log(i),S!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];r.forEach((F,T)=>{L.push({key:T,value:F})}),console.table(L),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const m=[];v.forEach((L,F)=>{m.push({key:F,value:L})}),console.table(m),console.groupEnd(),console.log(y)}e.$3o=h}),define(oe[114],ae([0,1,3,2,12,29,33,20]),function(te,e,O,N,j,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gCb=e.$fCb=void 0;let C=class extends N.$Qc{constructor(E,$){super(),this.a=new O.$Ld,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(E)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B($.onDidInstallExtensions(c=>c.forEach(({local:g,operation:p})=>{g&&p===4&&this.f(g.identifier)})))}async enableExtension(E,$){return this.f(E)?(this.a.fire({extensions:[E],source:$}),!0):!1}async disableExtension(E,$){return this.c(E)?(this.a.fire({extensions:[E],source:$}),!0):!1}getDisabledExtensions(){return this.h(A.$5n)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const $=this.getDisabledExtensions();return $.every(c=>!(0,I.$ro)(c,E))?($.push(E),this.g($),!0):!1}f(E){const $=this.getDisabledExtensions();for(let c=0;c<$.length;c++){const g=$[c];if((0,I.$ro)(g,E))return $.splice(c,1),this.g($),!0}return!1}g(E){this.j(A.$5n,E)}h(E){return this.b.get(E,0)}j(E,$){this.b.set(E,$,0)}};e.$fCb=C,e.$fCb=C=ye([x(0,D.$Xo),x(1,A.$4n)],C);class d extends N.$Qc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new O.$Ld),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new N.$Pc))($=>this.f($)))}get(E,$){let c;return $===0?((0,j.$Ff)(this.a[E])&&(this.a[E]=this.g(E,$)),c=this.a[E]):c=this.g(E,$),JSON.parse(c)}set(E,$,c){const g=JSON.stringify($.map(({id:w,uuid:h})=>({id:w,uuid:h})));this.g(E,c)!==g&&(c===0&&($.length?this.a[E]=g:delete this.a[E]),this.h(E,$.length?g:void 0,c))}f(E){if(!(0,j.$Ff)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const c=this.get(E.key,E.scope);delete this.a[E.key];const g=this.get(E.key,E.scope),p=c.filter(h=>!g.some(l=>(0,I.$ro)(h,l))),w=g.filter(h=>!c.some(l=>(0,I.$ro)(l,h)));(p.length||w.length)&&this.b.fire([...p,...w])}}g(E,$){return this.c.get(E,$,"[]")}h(E,$,c){$?this.c.store(E,$,c,1):this.c.remove(E,c)}}e.$gCb=d}),define(oe[247],ae([0,1,18,26,8,6,37,12,9,19,14,29,33,67,11,7,24,57,224,20,22,60]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=void 0;const t=A.$o?"web":(0,E.$Wn)(A.$t,I.$cc),a="X-Market-Search-Activity-Id";var s;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function n(...k){return String(k.reduce((R,U)=>R|U,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class f{constructor(R=y){this.d=R}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(R,U=this.d.pageSize){return new f({...this.d,pageNumber:R,pageSize:U})}withFilter(R,...U){const M=[...this.d.criteria,...U.length?U.map(J=>({filterType:R,value:J})):[{filterType:R}]];return new f({...this.d,criteria:M})}withSortBy(R){return new f({...this.d,sortBy:R})}withSortOrder(R){return new f({...this.d,sortOrder:R})}withFlags(...R){return new f({...this.d,flags:R.reduce((U,M)=>U|M,0)})}withAssetTypes(...R){return new f({...this.d,assetTypes:R})}withSource(R){return new f({...this.d,source:R})}get raw(){const{criteria:R,pageNumber:U,pageSize:M,sortBy:J,sortOrder:X,flags:se,assetTypes:le}=this.d;return{filters:[{criteria:R,pageNumber:U,pageSize:M,sortBy:J,sortOrder:X}],assetTypes:le,flags:se}}get searchText(){const R=this.d.criteria.filter(U=>U.filterType===i.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(R=>String(R.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function m(k,R){const U=(k||[]).filter(M=>M.statisticName===R)[0];return U?U.value:0}function L(k){const R="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(M=>M.assetType.indexOf(R)===0).reduce((M,J)=>{const X=z(k,J.assetType);return X&&M.push([J.assetType.substring(R.length),X]),M},[])}function F(k){if(k.properties){const R=k.properties.filter(J=>J.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=R.filter(J=>U.test(J.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return z(k,r.Repository)}function T(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function z(k,R){return k.files.filter(M=>M.assetType===R)[0]?{uri:`${k.assetUri}/${R}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${R}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function q(k,R){const U=k.properties?k.properties.filter(J=>J.key===R):[],M=U.length>0&&U[0].value;return M?M.split(",").map(J=>(0,$.$vo)(J)):[]}function _(k){const R=k.properties?k.properties.filter(U=>U.key===o.Engine):[];return R.length>0&&R[0].value||""}function Q(k){const R=k.properties?k.properties.filter(U=>U.key===o.PreRelease):[];return R.length>0&&R[0].value==="true"}function Z(k){const R=k.properties?k.properties.filter(M=>M.key===o.LocalizedLanguages):[],U=R.length>0&&R[0].value||"";return U?U.split(","):[]}function G(k){return k.properties?.find(R=>R.key===o.SponsorLink)?.value}function K(k){return k.indexOf("preview")!==-1}function H(k){return k.targetPlatform?(0,E.$Vn)(k.targetPlatform):"undefined"}function V(k){const R=(0,O.$Kb)(k.versions.map(H)),U=!!k.tags?.includes(E.$Qn),M=R.indexOf("web");return U?M===-1&&R.push("web"):M!==-1&&R.splice(M,1),R}function W(k,R){const U=(0,E.$Zn)(R);for(let M=0;M<k.length;M++){const J=k[M];if(J.version===k[M-1]?.version){let X=M;const se=H(J);if(se===R)for(;X>0&&k[X-1].version===J.version;)X--;else if(U.includes(se))for(;X>0&&k[X-1].version===J.version&&H(k[X-1])!==R;)X--;X!==M&&(k.splice(M,1),k.splice(X,0,J))}}return k}e.$6o=W;function ee(k,R,U){k.telemetryData={index:R,querySource:U,queryActivityId:k.queryContext?.[a]}}function ne(k,R,U,M){const J=k.versions[0],X={manifest:z(R,r.Manifest),readme:z(R,r.Details),changelog:z(R,r.Changelog),license:z(R,r.License),repository:F(R),download:T(R),icon:z(R,r.Icon),signature:z(R,r.Signature),coreTranslations:L(R)};return{identifier:{id:(0,$.$wo)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:R.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(J),description:k.shortDescription||"",installCount:m(k.statistics,"install"),rating:m(k.statistics,"averagerating"),ratingCount:m(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:U,assets:X,properties:{dependencies:q(R,o.Dependency),extensionPack:q(R,o.ExtensionPack),engine:_(R),localizedLanguages:Z(R),targetPlatform:H(R),isPreReleaseVersion:Q(R)},hasPreReleaseVersion:Q(J),hasReleaseVersion:!0,preview:K(k.flags),isSigned:!!X.signature,queryContext:M}}let re=class{constructor(R,U,M,J,X,se,le,ue){this.k=U,this.l=M,this.n=J,this.o=X,this.q=se,this.u=le,this.w=ue;const he=le.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,l.$5o)(le.version,le,this.n,this.w,this.q,R,this.o)}x(R=""){return`${this.d}${R}`}isEnabled(){return!!this.d}async getExtensions(R,U,M){const J=N.CancellationToken.isCancellationToken(U)?{}:U,X=N.CancellationToken.isCancellationToken(U)?U:M,se=[],le=[],ue=[],he=[];let $e=!0;for(const Ee of R){Ee.uuid?le.push(Ee.uuid):se.push(Ee.id);const De=!!(Ee.version||Ee.preRelease);ue.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:De}),Ee.version&&he.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),$e=$e&&!!Ee.hasPreRelease&&!De}if(!le.length&&!se.length)return[];let de=new f().withPage(1,R.length);le.length&&(de=de.withFilter(i.ExtensionId,...le)),se.length&&(de=de.withFilter(i.ExtensionName,...se)),(J.queryAllVersions||$e)&&(de=de.withFlags(de.flags,s.IncludeVersions)),J.source&&(de=de.withSource(J.source));const{extensions:we}=await this.z(de,{targetPlatform:J.targetPlatform??t,includePreRelease:ue,versions:he,compatible:!!J.compatible},X);return J.source&&we.forEach((Ee,De)=>ee(Ee,De,J.source)),we}async getCompatibleExtension(R,U,M){if((0,E.$Xn)(R.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(R,U,M))return R;const J=new f().withFlags(s.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,R.identifier.uuid),{extensions:X}=await this.z(J,{targetPlatform:M,compatible:!0,includePreRelease:U},N.CancellationToken.None);return X[0]||null}async isExtensionCompatible(R,U,M){if(!(0,E.$Yn)(R.properties.targetPlatform,R.allTargetPlatforms,M)||!U&&R.properties.isPreReleaseVersion)return!1;let J=R.properties.engine;if(!J){const X=await this.getManifest(R,N.CancellationToken.None);if(!X)throw new Error("Manifest was not found");J=X.engines.vscode}return(0,c.$Jo)(J,this.u.version,this.u.date)}async y(R,U,M,J,X){if(!(0,E.$Yn)(H(R),J,X)||U!=="any"&&Q(R)!==(U==="prerelease"))return!1;if(M)try{const se=await this.E(R);if(!(0,c.$Jo)(se,this.u.version,this.u.date))return!1}catch(se){return this.l.error(`Error while getting the engine for the version ${R.version}.`,(0,j.$8)(se)),!1}return!0}async query(R,U){let M=R.text||"";const J=R.pageSize??50;let X=new f().withPage(1,J);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(X=X.withFilter(i.Category,we||de),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(X=X.withFilter(i.Tag,we||de),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),X=X.withFilter(i.SearchText,M)),X=X.withSortBy(0)):R.ids?X=X.withFilter(i.ExtensionId,...R.ids):R.names?X=X.withFilter(i.ExtensionName,...R.names):X=X.withSortBy(4),typeof R.sortBy=="number"&&(X=X.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(X=X.withSortOrder(R.sortOrder)),R.source&&(X=X.withSource(R.source));const se=async($e,de)=>{const{extensions:we,total:Ee}=await this.z($e,{targetPlatform:t,compatible:!1,includePreRelease:!!R.includePreRelease},de);return we.forEach((De,Ne)=>ee(De,($e.pageNumber-1)*$e.pageSize+Ne,R.source)),{extensions:we,total:Ee}},{extensions:le,total:ue}=await se(X,U),he=async($e,de)=>{if(de.isCancellationRequested)throw new j.$3;const{extensions:we}=await se(X.withPage($e+1),de);return we};return{firstPage:le,total:ue,pageSize:X.pageSize,getPage:he}}async z(R,U,M){const J=R.flags;R.flags&s.IncludeLatestVersionOnly&&R.flags&s.IncludeVersions&&(R=R.withFlags(R.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(R.flags&s.IncludeLatestVersionOnly)&&!(R.flags&s.IncludeVersions)&&(R=R.withFlags(R.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(R=R.withFlags(R.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),R=R.withFlags(R.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:X,total:se,context:le}=await this.B(R,M);if(!(R.flags&s.IncludeLatestVersionOnly)){const de=[];for(const we of X){const Ee=await this.A(we,U,le);Ee&&de.push(Ee)}return{extensions:de,total:se}}const he=[],$e=new Map;for(let de=0;de<X.length;de++){const we=X[de],Ee={id:(0,$.$wo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},De=(0,D.$Cf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Te=>(0,$.$ro)(Te,Ee))?.includePreRelease;if(U.compatible&&(0,E.$Xn)(V(we),U.targetPlatform))continue;const Ne=await this.A(we,U,le);!Ne||Ne.properties.isPreReleaseVersion&&(!De||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==U.targetPlatform&&Ne.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Ne])}if($e.size){const de=new S.$Hd,we=new f().withFlags(J&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,$e.size).withFilter(i.ExtensionId,...$e.keys()),{extensions:Ee}=await this.z(we,U,M);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const De of Ee){const Ne=$e.get(De.identifier.uuid);he.push([Ne,De])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:se}}async A(R,U,M){const J={id:(0,$.$wo)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},X=U.versions?.find(he=>(0,$.$ro)(he,J))?.version,se=(0,D.$Cf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(he=>(0,$.$ro)(he,J))?.includePreRelease,le=V(R),ue=W(R.versions,U.targetPlatform);if(U.compatible&&(0,E.$Xn)(le,U.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(X&&$e.version!==X)){if(await this.y($e,se?"any":"release",U.compatible,le,U.targetPlatform))return ne(R,$e,le,M);if(X&&$e.version===X)return null}}return X||U.compatible?null:ne(R,R.versions[0],le)}async B(R,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,s.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(s.Unpublished));const M=await this.j,J=JSON.stringify(R.raw),X={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},se=new S.$Hd;let le,ue,he=0;try{if(le=await this.k.request({type:"POST",url:this.g&&R.criteria.some(de=>de.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:X},U),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,h.$Qo)(le);if($e){const de=$e.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return he=Ee&&Ee.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[a]:le.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(J.length),duration:se.elapsed(),success:!!le&&(0,h.$Mo)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:ue?(0,j.$2)(ue)?"canceled":(0,j.$8)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(R,U,M,J){if(!this.isEnabled())return;const X=A.$o?this.x(`/itemName/${R}.${U}/version/${M}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${R}/extensions/${U}/${M}/stats?statType=${J}`),se=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:se};try{await this.k.request({type:"POST",url:X,headers:ue},N.CancellationToken.None)}catch{}}async download(R,U,M){this.l.trace("ExtensionGalleryService#download",R.identifier.id);const J=(0,$.$zo)(R),X=new Date().getTime(),se=de=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:de}),le=M===2?"install":M===3?"update":"",ue=le?{uri:`${R.assets.download.uri}${C.URI.parse(R.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${R.assets.download.fallbackUri}${C.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:R.assets.download,he=R.queryContext?.[a]?{[a]:R.queryContext[a]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(U,$e.stream),se(new Date().getTime()-X)}async downloadSignatureArchive(R,U){if(!R.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const M=await this.D(R.assets.signature);await this.q.writeFile(U,M.stream)}async getReadme(R,U){if(R.assets.readme){const M=await this.D(R.assets.readme,{},U);return await(0,h.$Po)(M)||""}return""}async getManifest(R,U){if(R.assets.manifest){const M=await this.D(R.assets.manifest,{},U),J=await(0,h.$Po)(M);return J?JSON.parse(J):null}return null}async C(R,U){const M=z(R,r.Manifest);if(!M)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},X=await this.D(M,{headers:J});return await(0,h.$Qo)(X)}async getCoreTranslation(R,U){const M=R.assets.coreTranslations.filter(J=>J[0]===U.toUpperCase())[0];if(M){const J=await this.D(M[1]),X=await(0,h.$Po)(J);return X?JSON.parse(X):null}return null}async getChangelog(R,U){if(R.assets.changelog){const M=await this.D(R.assets.changelog,{},U);return await(0,h.$Po)(M)||""}return""}async getAllCompatibleVersions(R,U,M){let J=new f().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?J=J.withFilter(i.ExtensionId,R.identifier.uuid):J=J.withFilter(i.ExtensionName,R.identifier.id);const{galleryExtensions:X}=await this.B(J,N.CancellationToken.None);if(!X.length)return[];const se=V(X[0]);if((0,E.$Xn)(se,M))return[];const le=[];await Promise.all(X[0].versions.map(async $e=>{try{await this.y($e,U?"any":"release",!0,se,M)&&le.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of W(le,M))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:Q($e)}));return ue}async D(R,U={},M=N.CancellationToken.None){const J=await this.j,X={type:"GET"},se={...J,...U.headers||{}};U={...U,...X,headers:se};const le=R.uri,ue=R.fallbackUri,he={...U,url:le};try{const $e=await this.k.request(he,M);if($e.res.statusCode===200)return $e;const de=await(0,h.$Po)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,j.$2)($e))throw $e;const de=(0,j.$8)($e);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:de});const we={...U,url:ue};return this.k.request(we,M)}}async E(R){let U=_(R);if(!U){const M=await this.C(R,N.CancellationToken.None);if(!M)throw new Error("Manifest was not found");U=M.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const R=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,h.$Qo)(R),M=[],J={},X=[];if(U){for(const se of U.malicious)M.push({id:se});if(U.migrateToPreRelease)for(const[se,le]of Object.entries(U.migrateToPreRelease))(!le.engine||(0,c.$Jo)(le.engine,this.u.version,this.u.date))&&(J[se.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[se,le]of Object.entries(U.deprecated))le&&(J[se.toLowerCase()]=(0,D.$Cf)(le)?{}:le);if(U.search)for(const se of U.search)X.push(se)}return{malicious:M,deprecated:J,search:X}}};re=ye([x(1,h.$Ko),x(2,p.$7i),x(3,P.$Th),x(4,b.$$k),x(5,g.$8j),x(6,w.$mj),x(7,d.$gi)],re);let Y=class extends re{constructor(R,U,M,J,X,se,le,ue){super(R,U,M,J,X,se,le,ue)}};e.$7o=Y,e.$7o=Y=ye([x(0,u.$Xo),x(1,h.$Ko),x(2,p.$7i),x(3,P.$Th),x(4,b.$$k),x(5,g.$8j),x(6,w.$mj),x(7,d.$gi)],Y);let B=class extends re{constructor(R,U,M,J,X,se,le){super(void 0,R,U,M,J,X,se,le)}};e.$8o=B,e.$8o=B=ye([x(0,h.$Ko),x(1,p.$7i),x(2,P.$Th),x(3,b.$$k),x(4,g.$8j),x(5,w.$mj),x(6,d.$gi)],B)}),define(oe[80],ae([0,1,4,3,2,20,33,24,18,7,12]),function(te,e,O,N,j,A,I,D,C,d,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=void 0,e.$Pu=(0,O.$Mh)("IExtensionStorageService");const $=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends j.$Qc{static{E=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,I.$vo)(p.id)}@${p.version}`}static c(p){const w=$.exec(p);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(p,w){const h=await p.getInstalled(),l=[];for(const[u,b]of E.f(w)){const S=h.find(t=>(0,I.$ro)(t.identifier,{id:u}))?.manifest.version;for(const t of b)S!==t&&l.push(E.b({id:u,version:t}))}for(const u of l)w.remove(u,0)}static f(p){const w=new Map,h=p.keys(0,1);for(const l of h){const u=E.c(l);if(u){let b=w.get(u.id.toLowerCase());b||w.set(u.id.toLowerCase(),b=[]),b.push(u.version)}}return w}constructor(p,w,h){super(),this.j=p,this.m=w,this.n=h,this.g=this.B(new N.$Ld),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new j.$Pc))(l=>this.r(l)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const w=E.c(p.key);if(w){if(this.j.get(p.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let h=this.h.get(w.id.toLowerCase());h||this.h.set(w.id.toLowerCase(),h=[]),h.push(w.version),this.g.fire()}return}}s(p){if((0,P.$wf)(p))return p;const w=p.manifest?p.manifest.publisher:p.publisher,h=p.manifest?p.manifest.name:p.name;return(0,I.$uo)(w,h)}getExtensionState(p,w){const h=this.s(p),l=this.getExtensionStateRaw(p,w);if(l)try{return JSON.parse(l)}catch(u){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${w}): ${u}`)}}getExtensionStateRaw(p,w){const h=this.s(p),l=this.j.get(h,w?0:1);return l&&l?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${w}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(p,w,h){const l=this.s(p);w===void 0?this.j.remove(l,h?0:1):this.j.store(l,JSON.stringify(w),h?0:1,1)}setKeysForSync(p,w){this.j.store(E.b(p),JSON.stringify(w),0,1)}getKeysForSync(p){const w=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],h=this.j.get(E.b(p),0),l=h?JSON.parse(h):void 0;return l&&w?(0,C.$Kb)([...l,...w]):l||w}addToMigrationList(p,w){if(p!==w){const h=this.t.filter(l=>!l.includes(p)&&!l.includes(w));h.push([p,w]),this.t=h}}getSourceExtensionToMigrate(p){const w=this.t.find(([,h])=>p===h);return w?w[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(p);if(Array.isArray(w))return w}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Qu=c,e.$Qu=c=E=ye([x(0,A.$Xo),x(1,D.$mj),x(2,d.$7i)],c)}),define(oe[248],ae([0,1,29,11,24,14,98,55,20,22,221]),function(te,e,O,N,j,A,I,D,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=void 0;let E=class extends P.$84b{constructor(c,g,p,w,h,l,u,b){super(c.userHome,h,g,p,w,l,u,b)}};e.$O8b=E,e.$O8b=E=ye([x(0,A.$Uh),x(1,d.$$k),x(2,O.$4n),x(3,C.$Xo),x(4,D.$D6b),x(5,I.$oVb),x(6,N.$8j),x(7,j.$mj)],E)}),define(oe[249],ae([0,1,105,3,22,14,2,7,16,64,24,6,5,101,19,165,36,20,12,133,21]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K8b=void 0;const S=[O.$D8b,O.$E8b],t="remoteTunnelSession",a="remoteTunnelIsService";let s=class extends I.$Qc{constructor(o,v,y,f,m,L,F){super(),this.y=o,this.z=v,this.C=y,this.D=L,this.F=F,this.f=new N.$Ld,this.onDidTokenFailed=this.f.event,this.g=new N.$Ld,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$Ld,this.onDidChangeMode=this.h.event,this.n=O.$B8b,this.w=!1,this.I=(T,z)=>{z?this.j.error(T):this.j.info(T)},this.j=this.B(f.createLogger((0,b.$tg)(y.logsHome,`${O.$F8b}.log`),{id:O.$F8b,name:O.$G8b})),this.t=new $.$Og(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,D.$jj)(T)))),this.B(m.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(L.onDidChangeConfiguration(T=>{S.some(z=>T.affectsConfiguration(z))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){i(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$j?o=this.C.appRoot:o=(0,C.$kc)((0,C.$kc)(this.C.appRoot)),this.u=(0,C.$hc)(o,"bin",`${this.z.tunnelApplicationName}${E.$i?".exe":""}`)}return this.u}async startTunnel(o){if(i(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(O.$B8b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const y=(z,q)=>{q?this.j.error(z):o+=z,!this.C.isBuilt&&z.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,p.localize)(0,null)))},f=this.O("status",["status"],y);this.r=f;try{if(await f,this.r!==f)return;const z=JSON.parse(o.trim().split(`
`).find(q=>q.startsWith("{")));if(v=z.service_installed,this.j.info(z.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!z.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(z){this.j.error(z),this.G(O.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const m=this.n.active?this.n.session:void 0;if(m&&m.token){const z=m.token;this.G(O.TunnelStates.connecting((0,p.localize)(1,null,m.accountLabel,m.providerId)));const q=(Q,Z)=>{Q=Q.replaceAll(z,"*".repeat(4)),y(Q,Z)},_=this.O("login",["user","login","--provider",m.providerId,"--access-token",z,"--log",(0,D.$jj)(this.j.getLevel())],q);this.r=_;try{if(await _,this.r!==_)return}catch(Q){this.j.error(Q),this.r=void 0,this.f.fire(m),this.G(O.TunnelStates.disconnected(m));return}}const L=this.Q();L?this.G(O.TunnelStates.connecting((0,p.localize)(2,null,L))):this.G(O.TunnelStates.connecting((0,p.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,D.$jj)(this.j.getLevel())];L?F.push("--name",L):F.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!v&&(T=await this.M(F)===!1),this.N(m,F,T)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch(y){this.j.error(y),v=1}if(v!==0){const y=(0,p.localize)(4,null);return this.j.warn(y),this.G(O.TunnelStates.connecting(y)),!1}return!0}async N(o,v,y){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const m=this.O("tunnel",v,(L,F)=>{F?this.j.error(L):this.j.info(L),L.includes("Connected to an existing tunnel process")&&(f=!0);const T=L.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const z={link:T[1],domain:T[2],tunnelName:T[4],isAttached:f};this.G(O.TunnelStates.connected(z,y))}else L.match(/error refreshing token/)&&(m.cancel(),this.f.fire(o),this.G(O.TunnelStates.disconnected(o)))});this.r=m,m.finally(()=>{m===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$B8b,this.G(O.TunnelStates.disconnected()))})}O(o,v,y=this.I){return(0,$.$Fg)(f=>new Promise((m,L)=>{f.isCancellationRequested&&m(-1);let F;const T=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{F&&(this.j.info(`${o} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),F=(0,d.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,C.$hc)(this.C.appRoot,"cli"),stdio:T});else{y(`Running tunnel CLI
`,!1);const z=this.J();y(`${o} Spawning: ${z} tunnel ${v.join(" ")}
`,!1),F=(0,d.spawn)(z,["tunnel",...v],{cwd:(0,w.homedir)(),stdio:T})}F.stdout.pipe(new u.$3S(`
`)).on("data",z=>{if(F){const q=z.toString();y(q,!1)}}),F.stderr.pipe(new u.$3S(`
`)).on("data",z=>{if(F){const q=z.toString();y(q,!0)}}),F.on("exit",z=>{F&&(y(`${o} exit(${F.pid}): + ${z} `,!1),F=void 0,m(z||0))}),F.on("error",z=>{F&&(y(`${o} error(${F.pid}): + ${z} `,!0),F=void 0,L())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$E8b)}Q(){let o=this.D.getValue(O.$D8b)||(0,w.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(t,-1),v=this.F.getBoolean(a,-1,!1);if(o){const y=JSON.parse(o);if(y&&(0,l.$wf)(y.accountLabel)&&(0,l.$wf)(y.sessionId)&&(0,l.$wf)(y.providerId))return{active:!0,session:y,asService:v};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(o){this.j.error("Problems restoring session from storage",o)}return O.$B8b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(t,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(a,-1)}};e.$K8b=s,e.$K8b=s=ye([x(0,j.$$k),x(1,P.$mj),x(2,A.$Uh),x(3,D.$8i),x(4,c.$I8b),x(5,g.$gi),x(6,h.$Xo)],s);function n(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const i=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&n(r.session,o.session):!0}),define(oe[250],ae([0,1,5,2,23,21,66,20,75,17]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P8b=void 0;class P extends D.$Zo{constructor($,c,g,p){super(),this.bb=$,this.cb=c,this.db=g,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Pc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Pc),this.ab=this.hb(this.bb)}fb(){const $=this.B(new C.$PCb(this.db.getChannel("storage"))),c=this.B(new I.$To($));return this.B(c.onDidChangeStorage(g=>this.u(-1,g))),c}gb($){this.X.clear(),this.W=$;let c;if((0,D.$1o)($))c=this.U;else{const g=this.X.add(new C.$QCb(this.db.getChannel("storage"),$));c=this.X.add(new I.$To(g))}return this.X.add(c.onDidChangeStorage(g=>this.u(0,g))),c}hb($){this.$.clear(),this.Z=$?.id;let c;if($){const g=this.$.add(new C.$RCb(this.db.getChannel("storage"),$));c=this.$.add(new I.$To(g)),this.$.add(c.onDidChangeStorage(p=>this.u(1,p)))}return c}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P($){switch($){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q($){switch($){case-1:return this.s.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$tg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:j.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(D.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R($){if(!this.M(this.W,$))return;const c=this.Y,g=c.items;c!==this.U&&await c.close(),this.Y=this.gb($),await this.Y.init(),this.N(g,this.Y,0)}async S($,c){const g=this.ab,p=g?.items??new Map;await g?.close(),this.ab=this.hb($),await this.ab.init(),this.N(p,this.ab,1)}hasScope($){return(0,d.$Fk)($)?this.W.id===$.id:this.Z===$.id}}e.$P8b=P}),define(oe[251],ae([0,1,3,2,17,92]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=void 0;class I{constructor(d,P){this.a=d,this.b=P}listen(d,P){const E=this.b(d);switch(P){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(c=>(0,A.$Fm)({...c},E)),added:$.added.map(c=>(0,A.$Fm)({...c},E)),removed:$.removed.map(c=>(0,A.$Fm)({...c},E)),updated:$.updated.map(c=>(0,A.$Fm)({...c},E))}))}throw new Error(`Invalid listen ${P}`)}async call(d,P,E){const $=this.b(d);switch(P){case"createProfile":{const c=await this.a.createProfile(E[0],E[1],E[2]);return(0,A.$Fm)({...c},$)}case"updateProfile":{let c=(0,j.$Hk)((0,A.$Gm)(E[0],$),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,E[1]),(0,A.$Fm)({...c},$)}case"removeProfile":{const c=(0,j.$Hk)((0,A.$Gm)(E[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${P}`)}}e.$zN=I;class D extends N.$Qc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,P,E){super(),this.profilesHome=P,this.f=E,this.a=[],this.b=this.B(new O.$Ld),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map($=>(0,j.$Hk)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const c=$.added.map(w=>(0,j.$Hk)(w,this.profilesHome.scheme)),g=$.removed.map(w=>(0,j.$Hk)(w,this.profilesHome.scheme)),p=$.updated.map(w=>(0,j.$Hk)(w,this.profilesHome.scheme));this.a=$.all.map(w=>(0,j.$Hk)(w,this.profilesHome.scheme)),this.b.fire({added:c,removed:g,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,P,E){const $=await this.f.call("createNamedProfile",[d,P,E]);return(0,j.$Hk)($,this.profilesHome.scheme)}async createProfile(d,P,E,$){const c=await this.f.call("createProfile",[d,P,E,$]);return(0,j.$Hk)(c,this.profilesHome.scheme)}async createTransientProfile(d){const P=await this.f.call("createTransientProfile",[d]);return(0,j.$Hk)(P,this.profilesHome.scheme)}async setProfileForWorkspace(d,P){await this.f.call("setProfileForWorkspace",[d,P])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,P){const E=await this.f.call("updateProfile",[d,P]);return(0,j.$Hk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$AN=D}),define(oe[58],ae([0,1,2,66,4,20,3,75,17]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VCb=e.$UCb=e.$TCb=void 0,e.$TCb=(0,j.$Mh)("IUserDataProfileStorageService");let d=class extends O.$Qc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async g=>this.b(g))}async updateStorageData(c,g,p){return this.withProfileScopedStorageService(c,async w=>this.c(w,g,p))}async withProfileScopedStorageService(c,g){if(this.a.hasScope(c))return g(this.a);const p=await this.g(c),w=new E(p);try{await w.initialize();const h=await g(w);return await w.flush(),h}finally{w.dispose(),await this.f(p)}}b(c){const g=new Map,p=w=>{for(const h of c.keys(0,w))g.set(h,{value:c.get(h,0),target:w})};return p(0),p(1),g}c(c,g,p){c.storeAll(Array.from(g.entries()).map(([w,h])=>({key:w,value:h,scope:0,target:p})),!0)}async f(c){try{await c.close()}finally{(0,O.$Kc)(c)&&c.dispose()}}};e.$UCb=d,e.$UCb=d=ye([x(0,A.$Xo)],d);class P extends d{constructor(c,g,p,w){super(p),this.j=c;const h=c.getChannel("profileStorageListener"),l=this.B(new O.$Rc);this.h=this.B(new I.$Ld({onWillAddFirstListener:()=>{l.value=h.listen("onDidChange")(u=>{w.trace("profile storage changes",u),this.h.fire({targetChanges:u.targetChanges.map(b=>(0,C.$Hk)(b,g.profilesHome.scheme)),valueChanges:u.valueChanges.map(b=>({...b,profile:(0,C.$Hk)(b.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>l.value=void 0})),this.onDidChange=this.h.event}async g(c){const g=this.j.getChannel("storage");return(0,A.$1o)(c)?new D.$PCb(g):new D.$QCb(g,c)}}e.$VCb=P;class E extends A.$Zo{constructor(c){super({flushInterval:100}),this.s=this.B(new N.$To(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[252],ae([0,1,20,7,17,71,58]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=void 0;let D=class extends I.$VCb{constructor(d,P,E,$){super(d,P,E,$)}};e.$u8b=D,e.$u8b=D=ye([x(0,A.$S7b),x(1,j.$Gk),x(2,O.$Xo),x(3,N.$7i)],D)}),define(oe[39],ae([0,1,18,5,15,26,3,35,2,27,12,170,19,14,11,7,43,20,22,28,25,17]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ODb=e.$NDb=e.$MDb=e.$LDb=e.$KDb=e.$JDb=e.$IDb=void 0;function t(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$IDb=t;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$JDb=a;function s(v,y){return`${(0,d.$of)(v)}${y.isDefault?"":` (${y.name})`}`}e.$KDb=s;let n=class extends C.$Qc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,f,m,L,F,T,z,q,_,Q,Z,G){super(),this.syncResource=y,this.collection=f,this.G=m,this.H=L,this.I=F,this.J=T,this.L=z,this.M=q,this.N=_,this.O=Q,this.P=Z,this.c=null,this.m="idle",this.n=this.B(new I.$Ld),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new I.$Ld),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Pg(50)),this.w=this.B(new I.$Ld),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=s(y.syncResource,y.profile),this.h=G.extUri,this.f=this.h.joinPath(L.userDataSyncHome,...(0,b.$mgb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,b.$Hgb),this.y=(0,b.$ngb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,L,this.h),this.j=(0,w.$4o)(L,m,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const f=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,f={}){await this.U(y,!0,this.ob(),f)}async preview(y,f,m={}){return this.U(y,!1,f,m)}async apply(y,f={}){try{this.F={...f};const m=await this.ab(y);return this.S(m),this.c}finally{this.F={}}}async U(y,f,m,L){try{if(this.F={...L},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const T=await this.getLastSyncUserData(),z=await this.X(y,T);return F=await this.Y(z,T,f,m),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(y){const f=this.kb(y);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const m=await this.getLastSyncUserData(),L=await this.X(null,m),F=await this.W(L),T=await this.qb({ref:L.ref,syncData:f},m,F,this.ob(),A.CancellationToken.None),z=[];for(const q of T){const _=await this.sb(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:Q}=await this.sb(q,q.previewResource,q.remoteContent,A.CancellationToken.None);z.push([q,{..._,remoteChange:Q!==0?Q:2}])}await this.tb(L,m,z,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(y){const f=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===f}async X(y,f){if(f){const m=y?y[this.resource]:void 0;if(f.ref===m||m===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y(y,f,m,L){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new b.$ugb((0,E.localize)(0,null,this.resource,this.pb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(y,f,m,L)}catch(F){if(F instanceof b.$ugb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,f,m,L);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y(y,f,m,L)}throw F}}async Z(y,f,m,L){try{const F=await this.W(y),T=!F&&f===null&&this.gb()!==void 0,z=m&&!T;this.c||(this.c=(0,N.$Fg)(_=>this.eb(y,f,F,z,L,_)));let q=await this.c;if(m&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const _ of q.resourcePreviews)q=await this.accept(_.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":m?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(y){return await this.$(y,async f=>{const m=await this.rb(f,A.CancellationToken.None);await this.G.writeFile(f.previewResource,j.$_d.fromString(m?.content||""));const L=m&&!m.hasConflicts?await this.sb(f,f.previewResource,void 0,A.CancellationToken.None):void 0;return f.acceptResult=L,f.mergeState=m.hasConflicts?"conflict":L?"accepted":"preview",f.localChange=L?L.localChange:m.localChange,f.remoteChange=L?L.remoteChange:m.remoteChange,f}),this.c}async accept(y,f){return await this.$(y,async m=>{const L=await this.sb(m,y,f,A.CancellationToken.None);return m.acceptResult=L,m.mergeState="accepted",m.localChange=L.localChange,m.remoteChange=L.remoteChange,m}),this.c}async discard(y){return await this.$(y,async f=>{const m=await this.rb(f,A.CancellationToken.None);return await this.G.writeFile(f.previewResource,j.$_d.fromString(m.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=m.localChange,f.remoteChange=m.remoteChange,f}),this.c}async $(y,f){if(!this.c)return;let m=await this.c;const L=m.resourcePreviews.findIndex(({localResource:F,remoteResource:T,previewResource:z})=>this.h.isEqual(F,y)||this.h.isEqual(T,y)||this.h.isEqual(z,y));L!==-1&&(this.c=(0,N.$Fg)(async F=>{const T=[...m.resourcePreviews];return T[L]=await f(T[L]),{...m,resourcePreviews:T}}),m=await this.c,this.cb(m.resourcePreviews),m.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(y){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(m=>[m,m.acceptResult]),y),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const f=y.filter(({mergeState:m})=>m==="conflict");(0,O.$sb)(this.s,f,(m,L)=>this.h.isEqual(m.previewResource,L.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const f=this.c?await this.c:null;if(f)for(const m of f.resourcePreviews){if(this.h.isEqual(m.acceptedResource,y))return m.acceptResult?m.acceptResult.content:null;if(this.h.isEqual(m.remoteResource,y))return m.remoteContent;if(this.h.isEqual(m.localResource,y))return m.localContent;if(this.h.isEqual(m.baseResource,y))return m.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(y){(0,g.$lk)(y)!==1&&this.O.error(y)}}async eb(y,f,m,L,F,T){const z=await this.qb(y,f,m,F,T),q=[];for(const _ of z){const Q=_.previewResource.with({scheme:b.$Ggb,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)q.push({..._,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Z=L?await this.rb(_,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(_.previewResource,j.$_d.fromString(Z?.content||""));const G=Z&&!Z.hasConflicts?await this.sb(_,_.previewResource,void 0,T):void 0;q.push({..._,acceptResult:G,mergeState:Z?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:Z?Z.localChange:_.localChange,remoteChange:G?G.remoteChange:Z?Z.remoteChange:_.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:f,resourcePreviews:q,isLastSyncFromCurrentMachine:m}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse(y),m=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!m&&f.version!==m,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;let L,F=1;for(;L===void 0&&F++<6;)try{const T=await this.hb();T&&(T.ref===f.ref?L=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof g.$pk&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof b.$ugb)throw T;this.O.error(T,F)}}if(L===void 0)try{const T=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);L=T===null?null:this.kb(T),await this.ib({ref:f.ref,syncData:L})}catch(T){if(T instanceof b.$ugb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return L===void 0?null:{...f,syncData:L}}async fb(y,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const m=this.M.getResourceSyncStateVersion(this.resource),L={ref:y.ref,version:m,...f};this.I.store(this.z,JSON.stringify(L),-1,1),await this.ib(y)}gb(){return this.I.get(this.z,-1)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const f=y?JSON.parse(y):void 0;if(t(f))return f}catch(f){this.O.error(f)}}async ib(y){await this.G.writeFile(this.y,j.$_d.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),f=JSON.parse(y.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch(y){y instanceof g.$pk&&y.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,-1)}async getRemoteUserData(y){const{ref:f,content:m}=await this.lb(y);let L=null;return m!==null&&(L=this.kb(m)),{ref:f,syncData:L}}kb(y){try{const f=JSON.parse(y);if(a(f))return f}catch(f){this.O.error(f)}throw new b.$ugb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(y){const f=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb(y,f){const m=await this.j,L={version:this.pb,machineId:m,content:y};try{return f=await this.J.writeResource(this.resource,JSON.stringify(L),f,this.collection,this.F),{ref:f,syncData:L}}catch(F){throw F instanceof b.$ugb&&F.code==="TooLarge"&&(F=new b.$ugb(F.message,F.code,this.resource)),F}}async nb(y){const f={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(b.$hgb)}};e.$LDb=n,e.$LDb=n=ye([x(2,g.$8j),x(3,c.$Th),x(4,h.$Xo),x(5,b.$pgb),x(6,b.$qgb),x(7,b.$zgb),x(8,l.$$k),x(9,b.$Egb),x(10,$.$gi),x(11,u.$Ek)],n);let i=class extends n{constructor(y,f,m,L,F,T,z,q,_,Q,Z,G,K){super(f,m,L,F,T,z,q,_,Q,Z,G,K),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,f,m){try{f?await this.G.writeFile(this.r,j.$_d.fromString(y),m?void 0:f):await this.G.createFile(this.r,j.$_d.fromString(y),{overwrite:m})}catch(L){throw L instanceof g.$pk&&L.fileOperationResult===1||L instanceof g.$pk&&L.fileOperationResult===3?new b.$ugb(L.message,"LocalPreconditionFailed"):L}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof g.$pk&&y.fileOperationResult===1))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$MDb=i,e.$MDb=i=ye([x(3,g.$8j),x(4,c.$Th),x(5,h.$Xo),x(6,b.$pgb),x(7,b.$qgb),x(8,b.$zgb),x(9,l.$$k),x(10,b.$Egb),x(11,$.$gi),x(12,u.$Ek)],i);let r=class extends i{constructor(y,f,m,L,F,T,z,q,_,Q,Z,G,K,H){super(y,f,m,L,F,T,z,q,_,Q,Z,K,H),this.zb=G,this.Bb=void 0}Ab(y,f){const m=[],L=(0,D.$Nm)(y,m,{allowEmptyContent:!0,allowTrailingComma:!0});return m.length>0||!(0,P.$Df)(L)&&f!==Array.isArray(L)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$NDb=r,e.$NDb=r=ye([x(3,g.$8j),x(4,c.$Th),x(5,h.$Xo),x(6,b.$pgb),x(7,b.$qgb),x(8,b.$zgb),x(9,l.$$k),x(10,b.$Egb),x(11,b.$Dgb),x(12,$.$gi),x(13,u.$Ek)],r);let o=class{constructor(y,f,m,L,F,T,z){this.resource=y,this.g=f,this.h=m,this.j=L,this.k=F,this.l=T,this.d=z.extUri,this.f=(0,b.$ngb)(void 0,this.resource,m,this.d)}async initialize({ref:y,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const m=this.m(f);if(m)try{await this.o({ref:y,syncData:m})}catch(L){this.j.error(L)}}m(y){try{const f=JSON.parse(y);if(a(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const m={ref:y.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(m),-1,1),await this.k.writeFile(this.f,j.$_d.fromString(JSON.stringify(y)))}};e.$ODb=o,e.$ODb=o=ye([x(1,S.$Gk),x(2,c.$Th),x(3,p.$7i),x(4,g.$8j),x(5,h.$Xo),x(6,u.$Ek)],o)}),define(oe[115],ae([0,1,5,26,8,3,41,2,27,19,14,114,29,33,80,44,11,4,70,7,20,22,28,17,39,232,111,25,58]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S,t,a,s,n,i,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i3b=e.$h3b=e.$g3b=e.$f3b=e.$e3b=void 0;async function v(T,z){const q=JSON.parse(T.content);if(T.version===1||T.version===2){const _=(await z.getInstalled(0)).filter(Q=>Q.isBuiltin);for(const Q of q)T.version===1&&(Q.enabled===!1&&(Q.disabled=!0),delete Q.enabled),T.version===2&&_.every(Z=>!(0,c.$ro)(Z.identifier,Q.identifier))&&(Q.installed=!0)}return q}function y(T){return JSON.parse(T.content)}e.$e3b=y;function f(T,z){return T.sort((q,_)=>!q.identifier.uuid&&_.identifier.uuid?-1:q.identifier.uuid&&!_.identifier.uuid?1:(0,C.$Se)(q.identifier.id,_.identifier.id)),z?(0,I.$KS)(T,{}):JSON.stringify(T)}e.$f3b=f;let m=class extends s.$LDb{constructor(z,q,_,Q,Z,G,K,H,V,W,ee,ne,re,Y,B,k,R){super({syncResource:"extensions",profile:z},q,Q,_,Z,G,K,ne,re,W,ee,B),this.Cb=H,this.Db=V,this.Eb=R,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Ggb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Ggb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Ggb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Ggb,authority:"accepted"}),this.Bb=this.Eb.createInstance(L),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,U=>U.some(({local:M})=>!!M)),A.Event.filter(this.Cb.onDidUninstallExtension,U=>!U.error),A.Event.filter(k.onDidChange,U=>U.valueChanges.some(({profile:M,changes:J})=>this.syncResource.profile.id===M.id&&J.some(X=>X.key===$.$5n))),Y.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(z,q){const _=z.syncData?await v(z.syncData,this.Cb):null,Q=q?.skippedExtensions??[],Z=q?.builtinExtensions??null,G=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);_?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:W}=(0,n.$d3b)(K,_,G,Q,H,Z),ee={local:V,remote:W,content:this.Hb(K,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:W!==null?2:0},ne=this.Ob(K,!1);return[{skippedExtensions:Q,builtinExtensions:Z,baseResource:this.xb,baseContent:G?this.Ob(G,!1):ne,localResource:this.yb,localContent:ne,localExtensions:K,remoteResource:this.zb,remoteExtensions:_,remoteContent:_?this.Ob(_,!1):null,previewResource:this.wb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.Ab}]}async ub(z){const q=z.syncData?await v(z.syncData,this.Cb):null,{localExtensions:_,ignoredExtensions:Q}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Z}=(0,n.$d3b)(_,q,q,z.skippedExtensions||[],Q,z.builtinExtensions||[]);return Z!==null}Hb(z,q,_,Q){const Z=[...q,..._],G=new Set,K=H=>{G.add(H.id.toLowerCase()),H.uuid&&G.add(H.uuid)};Z.forEach(({identifier:H})=>K(H)),Q.forEach(K);for(const H of z)G.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&G.has(H.identifier.uuid)||Z.push(H);return this.Ob(Z,!1)}async rb(z,q){return{...z.previewResult,hasConflicts:!1}}async sb(z,q,_,Q){if(this.h.isEqual(q,this.yb))return this.Kb(z);if(this.h.isEqual(q,this.zb))return this.Lb(z);if(this.h.isEqual(q,this.wb))return z.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(z){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(q),Q=(0,n.$d3b)(z.localExtensions,null,null,z.skippedExtensions,_,z.builtinExtensions),{local:Z,remote:G}=Q;return{content:z.localContent,local:Z,remote:G,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?2:0,remoteChange:G!==null?2:0}}async Lb(z){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(q),Q=z.remoteContent?JSON.parse(z.remoteContent):null;if(Q!==null){const Z=(0,n.$d3b)(z.localExtensions,Q,z.localExtensions,[],_,z.builtinExtensions),{local:G,remote:K}=Z;return{content:z.remoteContent,local:G,remote:K,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:z.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(z,q,_,Q){let{skippedExtensions:Z,builtinExtensions:G,localExtensions:K}=_[0][0];const{local:H,remote:V,localChange:W,remoteChange:ee}=_[0][1];if(W===0&&ee===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),W!==0&&(await this.nb(JSON.stringify(K)),Z=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,Z,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const ne=JSON.stringify(V.all);z=await this.mb(ne,Q?null:z.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(re=>re.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(re=>re.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(re=>re.identifier.id))}.`:""}`)}q?.ref!==z.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(K,G),await this.fb(z,{skippedExtensions:Z,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${Z.length?` Skipped: ${JSON.stringify(Z.map(ne=>ne.identifier.id))}.`:""}`))}Nb(z,q){const _=new Set,Q=[];for(const Z of z)_.add(Z.identifier.id.toLowerCase()),Z.installed||Q.push(Z.identifier);if(q)for(const Z of q)_.has(Z.id.toLowerCase())||Q.push(Z);return Q}async resolveContent(z){if(this.h.isEqual(this.zb,z)||this.h.isEqual(this.xb,z)||this.h.isEqual(this.yb,z)||this.h.isEqual(this.Ab,z)){const q=await this.db(z);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(z,q){return f(z,q)}async hasLocalData(){try{const{localExtensions:z}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(z.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$g3b=m,e.$g3b=m=ye([x(2,P.$Th),x(3,w.$8j),x(4,b.$Xo),x(5,r.$pgb),x(6,r.$qgb),x(7,$.$4n),x(8,i.$tEb),x(9,r.$Egb),x(10,d.$gi),x(11,r.$zgb),x(12,S.$$k),x(13,g.$Pu),x(14,t.$Ek),x(15,o.$TCb),x(16,h.$Lh)],m);let L=class{constructor(z,q,_,Q,Z,G){this.a=z,this.b=q,this.c=_,this.d=Q,this.f=Z,this.g=G}async getLocalExtensions(z){const q=await this.a.getInstalled(void 0,z.extensionsResource),_=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(z,async(Z,G)=>{const K=Z.getDisabledExtensions();return q.map(H=>{const{identifier:V,isBuiltin:W,manifest:ee,preRelease:ne,pinned:re,isApplicationScoped:Y}=H,B={identifier:V,preRelease:ne,version:ee.version,pinned:!!re};Y&&!(0,p.$1l)(ee)&&(B.isApplicationScoped=Y),K.some(k=>(0,c.$ro)(k,V))&&(B.disabled=!0),W||(B.installed=!0);try{const k=G.getKeysForSync({id:V.id,version:ee.version});if(k){const R=G.getExtensionState(H,!0)||{};B.state=Object.keys(R).reduce((U,M)=>(k.includes(M)&&(U[M]=R[M]),U),{})}}catch(k){this.g.info(`${(0,s.$KDb)("extensions",z)}: Error while parsing extension state`,(0,j.$8)(k))}return B})}),ignoredExtensions:_}}async updateLocalExtensions(z,q,_,Q,Z){const G=(0,s.$KDb)("extensions",Z),K=[],H=new Map,V=[],W=[],ee=await this.a.getInstalled(void 0,Z.extensionsResource);if((z.length||_.length)&&await this.j(Z,async(Y,B)=>{await O.Promises.settled([...z,..._].map(async k=>{const R=ee.find(J=>(0,c.$ro)(J.identifier,k.identifier));if(R&&R.isBuiltin){k.state&&R.manifest.version===k.version&&this.h(k.state,R,R.manifest.version,B),Y.getDisabledExtensions().some(X=>(0,c.$ro)(X,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${G}: Disabling extension...`,k.identifier.id),await Y.disableExtension(k.identifier),this.g.info(`${G}: Disabled extension`,k.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,k.identifier.id),await Y.enableExtension(k.identifier),this.g.info(`${G}: Enabled extension`,k.identifier.id))),V.push(k.identifier);return}const U=k.pinned?k.version:void 0,M=(await this.c.getExtensions([{...k.identifier,version:U,preRelease:U?void 0:k.preRelease}],N.CancellationToken.None))[0];if(k.state&&(R?R.manifest.version===k.version:M)&&this.h(k.state,R||M,R?.manifest.version,B),M)try{Y.getDisabledExtensions().some(X=>(0,c.$ro)(X,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${G}: Disabling extension...`,k.identifier.id,M.version),await Y.disableExtension(M.identifier),this.g.info(`${G}: Disabled extension`,k.identifier.id,M.version)):(this.g.trace(`${G}: Enabling extension...`,k.identifier.id,M.version),await Y.enableExtension(M.identifier),this.g.info(`${G}: Enabled extension`,k.identifier.id,M.version))),(!R||R.preRelease!==k.preRelease||R.pinned!==k.pinned||U&&R.manifest.version!==U)&&(await this.a.canInstall(M)?(K.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:k.pinned&&!!k.version,installPreReleaseVersion:k.preRelease,profileLocation:Z.extensionsResource,isApplicationScoped:k.isApplicationScoped,context:{[$.$Rn]:!0,[$.$Sn]:!0}}}),H.set(M.identifier.id.toLowerCase(),k)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),W.push(k)))}catch(J){W.push(k),this.g.error(J),this.g.info(`${G}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else W.push(k),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}))}),q.length){const Y=ee.filter(({identifier:B,isBuiltin:k})=>!k&&q.some(R=>(0,c.$ro)(B,R)));await O.Promises.settled(Y.map(async B=>{this.g.trace(`${G}: Uninstalling local extension...`,B.identifier.id),await this.a.uninstall(B,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Z.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,B.identifier.id),V.push(B.identifier)}))}const ne=await this.a.installGalleryExtensions(K);for(const{identifier:Y,local:B,error:k,source:R}of ne){const U=R;if(B)this.g.info(`${G}: Installed extension.`,Y.id,U.version),V.push(Y);else{const M=H.get(Y.id.toLowerCase());M&&(W.push(M),this.g.info(`${G}: Skipped synchronizing extension`,U.displayName||U.identifier.id)),k instanceof $.$3n&&[$.ExtensionManagementErrorCode.Incompatible,$.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(k.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):k&&this.g.error(k)}}const re=[];for(const Y of Q)V.some(B=>(0,c.$ro)(B,Y.identifier))||re.push(Y);for(const Y of W)re.some(B=>(0,c.$ro)(B.identifier,Y.identifier))||re.push(Y);return re}h(z,q,_,Q){const Z=Q.getExtensionState(q,!0)||{},G=_?Q.getKeysForSync({id:q.identifier.id,version:_}):void 0;G?G.forEach(K=>{Z[K]=z[K]}):Object.keys(z).forEach(K=>Z[K]=z[K]),Q.setExtensionState(q,Z,!0)}async j(z,q){return this.b.withProfileScopedStorageService(z,async _=>{const Q=new D.$Pc,Z=this.f.createChild(new l.$Kh([b.$Xo,_])),G=Q.add(Z.createInstance(E.$fCb)),K=Q.add(Z.createInstance(g.$Qu));try{return await q(G,K)}finally{Q.dispose()}})}};e.$h3b=L,e.$h3b=L=ye([x(0,$.$4n),x(1,o.$TCb),x(2,$.$2n),x(3,i.$tEb),x(4,h.$Lh),x(5,r.$Egb)],L);let F=class extends s.$ODb{constructor(z,q,_,Q,Z,G,K,H){super("extensions",Q,Z,G,_,K,H),this.p=z,this.q=q}async t(z){return z.syncData?await v(z.syncData,this.p):null}u(z,q){const _=[],Q=[],Z=[];for(const G of z){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const K=q.find(H=>(0,c.$ro)(H.identifier,G.identifier));K?(_.push(K),G.disabled&&Z.push(G.identifier)):G.installed&&(Q.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&Z.push(G.identifier))}return{installedExtensions:_,newExtensions:Q,disabledExtensions:Z,remoteExtensions:z}}};e.$i3b=F,e.$i3b=F=ye([x(0,$.$4n),x(1,i.$tEb),x(2,w.$8j),x(3,a.$Gk),x(4,P.$Th),x(5,u.$7i),x(6,b.$Xo),x(7,t.$Ek)],F)}),define(oe[116],ae([0,1,15,8,3,35,41,6,32,19,14,11,7,43,20,22,28,39,77,236,25,17,58,4]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UDb=e.$TDb=e.$SDb=e.$RDb=e.$QDb=void 0;const s="globalState.argv.",n=["locale"];function i(m,L){const F=m.storage?Object.keys(m.storage).sort():[],T={};return F.forEach(z=>T[z]=m.storage[z]),m.storage=T,L?(0,I.$KS)(m,{}):JSON.stringify(m)}e.$QDb=i;const r=1;let o=class extends h.$LDb{constructor(L,F,T,z,q,_,Q,Z,G,K,H,V,W,ee){super({syncResource:"globalState",profile:L},F,z,Z,V,q,_,G,K,Q,H,W),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:b.$Ggb,authority:"base"}),this.xb=this.vb.with({scheme:b.$Ggb,authority:"local"}),this.yb=this.vb.with({scheme:b.$Ggb,authority:"remote"}),this.zb=this.vb.with({scheme:b.$Ggb,authority:"accepted"}),this.Ab=ee.createInstance(v),this.B(z.watch(this.h.dirname(this.H.argvResource))),this.B(j.Event.any(j.Event.filter(z.onDidFilesChange,ne=>ne.contains(this.H.argvResource)),j.Event.filter(T.onDidChange,ne=>!!(ne.targetChanges.some(re=>this.syncResource.profile.id===re.id)||ne.valueChanges.some(({profile:re,changes:Y})=>this.syncResource.profile.id===re.id&&Y.some(B=>B.target===0)))))(()=>this.Q()))}async qb(L,F,T){const z=L.syncData?JSON.parse(L.syncData.content):null;F=F===null&&T?L:F;const q=F&&F.syncData?JSON.parse(F.syncData.content):null,_=await this.Ab.getLocalGlobalState(this.syncResource.profile);z?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Jb(q),{local:Z,remote:G}=(0,u.$PDb)(_.storage,z?z.storage:null,q?q.storage:null,Q,this.O),K={content:null,local:Z,remote:G,localChange:Object.keys(Z.added).length>0||Object.keys(Z.updated).length>0||Z.removed.length>0?2:0,remoteChange:G.all!==null?2:0},H=i(_,!1);return[{baseResource:this.wb,baseContent:q?i(q,!1):H,localResource:this.xb,localContent:H,localUserData:_,remoteResource:this.yb,remoteContent:z?i(z,!1):null,previewResource:this.vb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.zb,storageKeys:Q}]}async ub(L){const F=L.syncData?JSON.parse(L.syncData.content):null;if(F===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),z=await this.Jb(F),{remote:q}=(0,u.$PDb)(T.storage,F.storage,F.storage,z,this.O);return q.all!==null}async rb(L,F){return{...L.previewResult,hasConflicts:!1}}async sb(L,F,T,z){if(this.h.isEqual(F,this.xb))return this.Gb(L);if(this.h.isEqual(F,this.yb))return this.Hb(L);if(this.h.isEqual(F,this.vb))return L.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(L){return{content:L.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(L.localUserData.storage),removed:[],updated:[],all:L.localUserData.storage},localChange:0,remoteChange:2}}async Hb(L){if(L.remoteContent!==null){const F=JSON.parse(L.remoteContent),{local:T,remote:z}=(0,u.$PDb)(L.localUserData.storage,F.storage,null,L.storageKeys,this.O);return{content:L.remoteContent,local:T,remote:z,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:z!==null?2:0}}else return{content:L.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(L,F,T,z){const{localUserData:q}=T[0][0],{local:_,remote:Q,localChange:Z,remoteChange:G}=T[0][1];if(Z===0&&G===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Z!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(_,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const K=JSON.stringify({storage:Q.all});L=await this.mb(K,z?null:L.ref),this.O.info(`${this.D}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}F?.ref!==L.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(L),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(L){if(this.h.isEqual(this.yb,L)||this.h.isEqual(this.wb,L)||this.h.isEqual(this.xb,L)||this.h.isEqual(this.zb,L)){const F=await this.db(L);return F&&i(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:L}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(L).length>1||L[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(L){const F=await this.Bb.readStorageData(this.syncResource.profile),T=[],z=[];for(const[Q,Z]of F)Z.target===0?T.push(Q):Z.target===1&&z.push(Q);const q=[...T,...z],_=L?.storage?Object.keys(L.storage).filter(Q=>!Q.startsWith(s)&&!q.includes(Q)&&F.get(Q)!==void 0):[];if(!D.$o){const Q=[...b.$lgb.map(Z=>(0,b.$ygb)(Z)),b.$xgb];_.push(...Q),z.push(...Q)}return{user:T,machine:z,unregistered:_}}};e.$RDb=o,e.$RDb=o=ye([x(2,t.$TCb),x(3,E.$8j),x(4,b.$pgb),x(5,b.$qgb),x(6,b.$Egb),x(7,P.$Th),x(8,b.$zgb),x(9,p.$$k),x(10,d.$gi),x(11,g.$Xo),x(12,w.$Ek),x(13,a.$Lh)],o);let v=class{constructor(L,F,T,z){this.a=L,this.b=F,this.c=T,this.d=z}async getLocalGlobalState(L){const F={};if(L.isDefault){const z=await this.f(),q=(0,A.$Nm)(z);for(const _ of n)q[_]!==void 0&&(F[`${s}${_}`]={version:1,value:q[_]})}const T=await this.c.readStorageData(L);for(const[z,q]of T)q.value&&q.target===0&&(F[z]={version:1,value:q.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const L=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),L.value.toString()}catch(L){this.d.debug((0,N.$8)(L))}return"{}"}async writeLocalGlobalState({added:L,removed:F,updated:T},z){const q=(0,h.$KDb)("globalState",z),_={},Q=new Map,Z=await this.c.readStorageData(z),G=(K,H)=>{for(const V of K){if(V.startsWith(s)){_[V.substring(s.length)]=H?H[V].value:void 0;continue}if(H){const W=H[V];W.value!==Z.get(V)?.value&&Q.set(V,W.value)}else Z.get(V)!==void 0&&Q.set(V,void 0)}};if(G(Object.keys(L),L),G(Object.keys(T),T),G(F),Object.keys(_).length){this.d.trace(`${q}: Updating locale...`);const K=await this.f();let H=K;for(const V of Object.keys(_))H=(0,l.edit)(H,[V],_[V],{});K!==H&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$_d.fromString(H)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}Q.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(z,Q,0),this.d.info(`${q}: Updated global state`,[...Q.keys()]))}};e.$SDb=v,e.$SDb=v=ye([x(0,E.$8j),x(1,P.$Th),x(2,t.$TCb),x(3,b.$Egb)],v);let y=class extends h.$ODb{constructor(L,F,T,z,q,_){super("globalState",T,z,q,F,L,_)}async o(L){const F=L.syncData?JSON.parse(L.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},z={};for(const q of Object.keys(F.storage))q.startsWith(s)?T[q.substring(s.length)]=F.storage[q].value:this.l.get(q,0)===void 0&&(z[q]=F.storage[q].value);if(Object.keys(T).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const _ of Object.keys(T))q=(0,l.edit)(q,[_],T[_],{});await this.k.writeFile(this.h.argvResource,O.$_d.fromString(q))}if(Object.keys(z).length){const q=[];for(const _ of Object.keys(z))q.push({key:_,value:z[_],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$TDb=y,e.$TDb=y=ye([x(0,g.$Xo),x(1,E.$8j),x(2,S.$Gk),x(3,P.$Th),x(4,b.$Egb),x(5,w.$Ek)],y);let f=class{constructor(L,F,T,z,q){this.a=L,this.b=F,this.c=T,this.d=z,this.f=q}getSyncStoreType(L){return this.h(L)?.storage[b.$xgb]?.value}async sync(L){const F=(0,b.$tgb)((0,C.$cg)());try{return await this.g(L,F)}catch(T){if(T instanceof b.$ugb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(L,F)}throw T}}async g(L,F){const T=await this.a.readResource("globalState",null,void 0,F),z=this.h(T)||{storage:{}};z.storage[b.$xgb]={value:L,version:r};const q=await(0,c.$4o)(this.c,this.d,this.b),_={version:r,machineId:q,content:i(z,!1)};await this.a.writeResource("globalState",JSON.stringify(_),T.ref,void 0,F)}h({content:L}){if(!L)return null;const F=JSON.parse(L);if((0,h.$JDb)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$UDb=f,e.$UDb=f=ye([x(1,g.$Xo),x(2,P.$Th),x(3,E.$8j),x(4,$.$7i)],f)}),define(oe[117],ae([0,1,18,15,3,35,6,12,171,19,14,11,20,22,28,17,39,233,25]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m3b=e.$l3b=e.$k3b=void 0;function u(t,a,s){try{const n=JSON.parse(t);if(!a)return(0,D.$Df)(n.all)?null:n.all;switch(I.OS){case 2:return(0,D.$Df)(n.mac)?null:n.mac;case 3:return(0,D.$Df)(n.linux)?null:n.linux;case 1:return(0,D.$Df)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}e.$k3b=u;let b=class extends w.$NDb{constructor(a,s,n,i,r,o,v,y,f,m,L,F,T){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},s,y,f,m,n,i,v,F,r,L,o,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:l.$Ggb,authority:"base"}),this.Gb=this.Eb.with({scheme:l.$Ggb,authority:"local"}),this.Hb=this.Eb.with({scheme:l.$Ggb,authority:"remote"}),this.Ib=this.Eb.with({scheme:l.$Ggb,authority:"accepted"}),this.B(j.Event.filter(o.onDidChangeConfiguration,z=>z.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,s,n,i){const r=a.syncData?u(a.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;s=s===null&&n?a:s;const o=s?this.Ob(s):null,v=await this.vb(),y=await this.Cb();let f=null,m=!1,L=!1,F=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new l.$ugb((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==q||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const _=await(0,h.$j3b)(q,r,o,y,this.zb);_.hasChanges&&(f=_.mergeContent,F=_.hasConflicts,m=F||_.mergeContent!==q,L=F||_.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),L=!0);const T={content:F?o:f,localChange:m?v?2:1:0,remoteChange:L?2:0,hasConflicts:F},z=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:z,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(a){const s=this.Ob(a);if(s===null)return!0;const n=await this.vb(),i=n?n.value.toString():"",r=await this.Cb(),o=await(0,h.$j3b)(i||"[]",s,s,r,this.zb);return o.hasConflicts||o.mergeContent!==s}async rb(a,s){return a.previewResult}async sb(a,s,n,i){if(this.h.isEqual(s,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(s,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(s,this.Eb))return n===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(a,s,n,i){const{fileContent:r}=n[0][0];let{content:o,localChange:v,remoteChange:y}=n[0][1];if(v===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new l.$ugb((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,i),this.O.info(`${this.D}: Updated local keybindings`)),y!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(f,i?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}s?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const s=(0,A.$Nm)(a.value.toString());if((0,O.$Jb)(s))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:u(a.syncData.content,this.Qb(),this.O)}Pb(a,s){let n={};try{n=JSON.parse(s||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete n.all:n.all=a,I.OS){case 2:n.mac=a;break;case 3:n.linux=a;break;case 1:n.windows=a;break}return JSON.stringify(n)}Qb(){return!!this.P.getValue(l.$igb)}};e.$l3b=b,e.$l3b=b=ye([x(2,l.$pgb),x(3,l.$qgb),x(4,l.$Egb),x(5,d.$gi),x(6,l.$zgb),x(7,E.$8j),x(8,P.$Th),x(9,$.$Xo),x(10,l.$Dgb),x(11,c.$$k),x(12,g.$Ek)],b);let S=class extends w.$ODb{constructor(a,s,n,i,r,o){super("keybindings",s,n,i,a,r,o)}async o(a){const s=a.syncData?this.p(a.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$_d.fromString(s)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,A.$Nm)(a.value.toString());return!(0,O.$Jb)(s)}catch(a){return a.fileOperationResult===1}}p(a){try{return u(a,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$m3b=S,e.$m3b=S=ye([x(0,E.$8j),x(1,p.$Gk),x(2,P.$Th),x(3,l.$Egb),x(4,$.$Xo),x(5,g.$Ek)],S)}),define(oe[118],ae([0,1,15,3,172,19,73,14,29,11,20,22,28,17,39,237,25]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p3b=e.$o3b=e.$n3b=void 0;function h(S){return S&&S.settings&&typeof S.settings=="string"&&Object.keys(S).length===1}function l(S){const t=JSON.parse(S);return h(t)?t:{settings:S}}e.$n3b=l;let u=class extends g.$NDb{constructor(t,a,s,n,i,r,o,v,y,f,m,L,F,T){super(t.settingsResource,{syncResource:"settings",profile:t},a,s,n,i,r,o,m,L,v,y,f,T),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Ggb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Ggb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Ggb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Ggb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const a=await this.getLastSyncUserData(),s=await this.X(t,a),n=this.Lb(s),i=new I.$tn(w.$hgb);return n?.settings&&i.parse(n.settings),i.configurationModel.getValue(w.$hgb)||{}}async qb(t,a,s){const n=await this.vb(),i=await this.Cb(),r=this.Lb(t);a=a===null&&s?t:a;const o=a?this.Lb(a):null,v=await this.Pb();let y=null,f=!1,m=!1,L=!1;if(r){let q=n?n.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const _=(0,p.$ACb)(q,r.settings,o?o.settings:null,v,[],i);y=_.localContent||_.remoteContent,f=_.localContent!==null,m=_.remoteContent!==null,L=_.hasConflicts}else n&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),y=n.value.toString().trim()||"{}",this.Qb(y),m=!0);const F=n?n.value.toString():null,T=o?.settings??null,z={content:L?T:y,localChange:f?2:0,remoteChange:m?2:0,hasConflicts:L};return[{fileContent:n,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:F,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async ub(t){const a=this.Lb(t);if(a===null)return!0;const s=await this.vb(),n=s?s.value.toString().trim():"",i=await this.Pb(),r=await this.Cb();return(0,p.$ACb)(n||"{}",a.settings,a.settings,i,[],r).remoteContent!==null}async rb(t,a){const s=await this.Cb(),n=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,p.$zCb)(t.previewResult.content,"{}",n,s):null}}async sb(t,a,s,n){const i=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:t.fileContent?(0,p.$zCb)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:t.remoteContent!==null?(0,p.$zCb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,p.$zCb)(s,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(t,a,s,n){const{fileContent:i}=s[0][0];let{content:r,localChange:o,remoteChange:v}=s[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(r,i,n),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const y=await this.Cb(),f=this.Lb(t),m=await this.Pb(r);r=(0,p.$zCb)(r,f?f.settings:"{}",m,y),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(r)),n?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,p.$BCb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let a=await super.db(t);if(a){const s=await this.Cb(),n=await this.Pb();a=(0,p.$zCb)(a,"{}",n,s)}return a}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return l(t)}catch(a){this.O.error(a)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const s=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,n=>n.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,n=>!n.error))(()=>{s.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,p.$xCb)(a,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new w.$ugb((0,j.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$o3b=u,e.$o3b=u=ye([x(2,d.$8j),x(3,D.$Th),x(4,P.$Xo),x(5,w.$pgb),x(6,w.$qgb),x(7,w.$Egb),x(8,w.$Dgb),x(9,A.$gi),x(10,w.$zgb),x(11,E.$$k),x(12,C.$4n),x(13,$.$Ek)],u);let b=class extends g.$ODb{constructor(t,a,s,n,i,r){super("settings",a,s,n,t,i,r)}async o(t){const a=t.syncData?this.p(t.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$_d.fromString(a.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$BCb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return l(t)}catch(a){this.j.error(a)}return null}};e.$p3b=b,e.$p3b=b=ye([x(0,d.$8j),x(1,c.$Gk),x(2,D.$Th),x(3,w.$Egb),x(4,P.$Xo),x(5,$.$Ek)],b)}),define(oe[119],ae([0,1,15,3,30,19,14,11,20,22,28,17,39,234,25]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u3b=e.$t3b=e.$s3b=void 0;function p(l){return JSON.parse(l.content)}e.$s3b=p;let w=class extends $.$LDb{constructor(u,b,S,t,a,s,n,i,r,o,v,y){super({syncResource:"snippets",profile:u},b,t,S,a,s,n,o,v,i,r,y),this.pb=1,this.vb=u.snippetsHome,this.B(this.G.watch(S.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(u,b,S){const t=await this.Hb(),a=this.Gb(t),s=u.syncData?this.Fb(u.syncData):null;b=b===null&&S?u:b;const n=b&&b.syncData?this.Fb(b.syncData):null;s?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,c.$q3b)(a,s,n);return this.Bb(i,t,s||{},n||{})}async ub(u){const b=u.syncData?this.Fb(u.syncData):null;if(b===null)return!0;const S=await this.Hb(),t=this.Gb(S),a=(0,c.$q3b)(t,b,b);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(u,b){return u.previewResult}async sb(u,b,S,t){if(this.h.isEqualOrParent(b,this.g.with({scheme:g.$Ggb,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(b,this.g.with({scheme:g.$Ggb,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(b,this.g))return S===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:S,localChange:S===null?u.fileContent!==null?3:0:2,remoteChange:S===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async tb(u,b,S,t){const a=S.map(([s,n])=>({...s,acceptResult:n}));a.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:s})=>s!==0)&&(await this.Cb(a),await this.Db(a,t)),a.some(({remoteChange:s})=>s!==0)&&(u=await this.Eb(a,u,t)),b?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:s}of a)try{await this.G.del(s)}catch{}}Bb(u,b,S,t){const a=new Map;for(const s of Object.keys(u.local.added)){const n={content:u.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"remote"}),remoteContent:S[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"accepted"})})}for(const s of Object.keys(u.local.updated)){const n={content:u.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"remote"}),remoteContent:S[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"accepted"})})}for(const s of u.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"accepted"})})}for(const s of Object.keys(u.remote.added)){const n={content:u.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"accepted"})})}for(const s of Object.keys(u.remote.updated)){const n={content:u.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"remote"}),remoteContent:S[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"accepted"})})}for(const s of u.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"remote"}),remoteContent:S[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"accepted"})})}for(const s of u.conflicts){const n={content:t[s]??null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:S[s]?2:1},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"local"}),fileContent:b[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"remote"}),remoteContent:S[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"accepted"})})}for(const s of Object.keys(b))if(!a.has(s)){const n={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=b[s]?b[s].value.toString():null;a.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"local"}),fileContent:b[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"remote"}),remoteContent:S[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:g.$Ggb,authority:"accepted"})})}return[...a.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:g.$Ggb,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$Ggb,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$Ggb,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$Ggb,authority:"accepted"}))?this.db(u):null}async hasLocalData(){try{const u=await this.Hb();if(Object.keys(u).length)return!0}catch{}return!1}async Cb(u){const b={};for(const S of u)S.fileContent&&(b[this.h.basename(S.localResource)]=S.fileContent);await this.nb(JSON.stringify(this.Gb(b)))}async Db(u,b){for(const{fileContent:S,acceptResult:t,localResource:a,remoteResource:s,localChange:n}of u)if(n!==0){const i=s?this.h.basename(s):this.h.basename(a),r=this.h.joinPath(this.vb,i);n===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):n===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$_d.fromString(t.content),{overwrite:b}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$_d.fromString(t.content),b?void 0:S),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(u,b,S){const t=b.syncData?this.Fb(b.syncData):{},a=(0,j.$Xm)(t);for(const{acceptResult:s,localResource:n,remoteResource:i,remoteChange:r}of u)if(r!==0){const o=n?this.h.basename(n):this.h.basename(i);r===3?delete a[o]:a[o]=s.content}return(0,c.$r3b)(t,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),b=await this.mb(JSON.stringify(a),S?null:b.ref),this.O.info(`${this.D}: Updated remote snippets`)),b}Fb(u){return p(u)}Gb(u){const b={};for(const S of Object.keys(u))b[S]=u[S].value.toString();return b}async Hb(){const u={};let b;try{b=await this.G.resolve(this.vb)}catch(S){if(S instanceof D.$pk&&S.fileOperationResult===1)return u;throw S}for(const S of b.children||[]){const t=S.resource,a=this.h.extname(t);if(a===".json"||a===".code-snippets"){const s=this.h.relativePath(this.vb,t),n=await this.G.readFile(t);u[s]=n}}return u}};e.$t3b=w,e.$t3b=w=ye([x(2,I.$Th),x(3,D.$8j),x(4,C.$Xo),x(5,g.$pgb),x(6,g.$qgb),x(7,g.$Egb),x(8,A.$gi),x(9,g.$zgb),x(10,d.$$k),x(11,P.$Ek)],w);let h=class extends $.$ODb{constructor(u,b,S,t,a,s){super("snippets",b,S,t,u,a,s)}async o(u){const b=u.syncData?JSON.parse(u.syncData.content):null;if(!b){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(b)){const a=b[t];if(a){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(s,O.$_d.fromString(a)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(u)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};e.$u3b=h,e.$u3b=h=ye([x(0,D.$8j),x(1,E.$Gk),x(2,I.$Th),x(3,g.$Egb),x(4,C.$Xo),x(5,P.$Ek)],h)}),define(oe[120],ae([0,1,15,19,14,11,20,22,28,17,39,25]),function(te,e,O,N,j,A,I,D,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3b=e.$w3b=e.$v3b=void 0;function $(w,h){try{return JSON.parse(w).tasks??null}catch(l){return h.error(l),null}}e.$v3b=$;let c=class extends P.$MDb{constructor(h,l,u,b,S,t,a,s,n,i,r,o){super(h.tasksResource,{syncResource:"tasks",profile:h},l,s,n,i,u,b,a,r,S,t,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$Ggb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$Ggb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$Ggb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$Ggb,authority:"accepted"})}async qb(h,l,u,b){const S=h.syncData?$(h.syncData.content,this.O):null;l=l===null&&u?h:l;const t=l?.syncData?$(l.syncData.content,this.O):null,a=await this.vb();let s=null,n=!1,i=!1,r=!1;if(h.syncData){const y=a?a.value.toString():null;if(!t||t!==y||t!==S){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=p(y,S,t);s=f.content,r=f.hasConflicts,n=f.hasLocalChanged,i=f.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=a.value.toString(),i=!0);const o={content:r?t:s,localChange:n?a?2:1:0,remoteChange:i?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:S,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(h){const l=h?.syncData?$(h.syncData.content,this.O):null;if(l===null)return!0;const u=await this.vb(),b=u?u.value.toString():null,S=p(b,l,l);return S.hasLocalChanged||S.hasRemoteChanged}async rb(h,l){return h.previewResult}async sb(h,l,u,b){if(this.h.isEqual(l,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(l,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(l,this.Ab))return u===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async tb(h,l,u,b){const{fileContent:S}=u[0][0],{content:t,localChange:a,remoteChange:s}=u[0][1];if(a===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),S&&await this.nb(JSON.stringify(this.Kb(S.value.toString()))),t?await this.wb(t,S,b):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),s!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const n=JSON.stringify(this.Kb(t));h=await this.mb(n,b?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}l?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$w3b=c,e.$w3b=c=ye([x(2,E.$pgb),x(3,E.$qgb),x(4,E.$Egb),x(5,N.$gi),x(6,E.$zgb),x(7,A.$8j),x(8,j.$Th),x(9,I.$Xo),x(10,D.$$k),x(11,C.$Ek)],c);let g=class extends P.$ODb{constructor(h,l,u,b,S,t){super("tasks",l,u,b,h,S,t),this.c=this.g.defaultProfile.tasksResource}async o(h){const l=h.syncData?$(h.syncData.content,this.j):null;if(!l){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$_d.fromString(l)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$x3b=g,e.$x3b=g=ye([x(0,A.$8j),x(1,d.$Gk),x(2,j.$Th),x(3,E.$Egb),x(4,I.$Xo),x(5,C.$Ek)],g);function p(w,h,l){if(w===null&&h===null&&l===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=l!==w,b=l!==h;return!u&&!b?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!b?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:b&&!u?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[121],ae([0,1,41,19,14,11,20,22,28,17,39,235,25]),function(te,e,O,N,j,A,I,D,C,d,P,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b5b=e.$a5b=e.$_4b=void 0;let c=class extends P.$LDb{constructor(h,l,u,b,S,t,a,s,n,i,r,o,v){super({syncResource:"profiles",profile:h},l,b,S,t,a,s,r,o,n,i,v),this.vb=u,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:$.$Ggb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$Ggb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$Ggb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$Ggb,authority:"accepted"}),this.B(u.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?p(h.syncData):null}async getRemoteSyncedProfiles(h){const l=await this.getLastSyncUserData(),u=await this.X(h,l);return u?.syncData?p(u.syncData):null}async qb(h,l,u){if(!this.vb.isEnabled())throw new $.$ugb("Cannot sync profiles because they are disabled","LocalError");const b=h.syncData?p(h.syncData):null,S=l?.syncData?p(l.syncData):null,t=this.Db(),{local:a,remote:s}=(0,E.$$4b)(t,b,S,[]),n={local:a,remote:s,content:S?this.Eb(S):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:s!==null?2:0},i=g(t,!1);return[{baseResource:this.baseResource,baseContent:S?this.Eb(S):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:b?this.Eb(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const l=h?.syncData?p(h.syncData):null,u=this.Db(),{remote:b}=(0,E.$$4b)(u,l,l,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async rb(h,l){return{...h.previewResult,hasConflicts:!1}}async sb(h,l,u,b){if(this.h.isEqual(l,this.localResource))return this.Ab(h);if(this.h.isEqual(l,this.remoteResource))return this.Bb(h);if(this.h.isEqual(l,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async Ab(h){const l=this.Db(),u=(0,E.$$4b)(l,null,null,[]),{local:b,remote:S}=u;return{content:h.localContent,local:b,remote:S,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:S!==null?2:0}}async Bb(h){const l=h.remoteContent?JSON.parse(h.remoteContent):null,u=[],b=[];for(const S of this.Db()){const t=l?.find(a=>a.id===S.id);t&&(u.push({id:S.id,name:S.name,collection:t.collection}),b.push(S))}if(l!==null){const S=(0,E.$$4b)(b,l,u,[]),{local:t,remote:a}=S;return{content:h.remoteContent,local:t,remote:a,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,l,u,b){const{local:S,remote:t,localChange:a,remoteChange:s}=u[0][1];a===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const n=u[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new $.$ugb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb(g(this.Db(),!1));const i=[];for(const r of S.added)i.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of S.removed)i.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of S.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?i.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(s!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],r=n.length+(t?.added.length??0)<=20;if(r)for(const o of t?.added||[]){const v=await this.J.createCollection(this.F);i.push(v),n.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of t?.removed||[])n.splice(n.findIndex(({id:v})=>o.id===v),1);for(const o of t?.updated||[]){const v=n.find(({id:y})=>o.id===y);v&&n.splice(n.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{h=await this.updateRemoteProfiles(n,b?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(o=>o.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(o=>o.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(o=>o.name))}.`:""}`)}catch(o){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of i)await this.J.deleteCollection(v,this.F)}throw o}for(const o of t?.removed||[])await this.J.deleteCollection(o.collection,this.F)}l?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,l){return this.mb(this.Eb(h),l)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const l=await this.db(h);return l&&(0,O.$KS)(JSON.parse(l),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((l,u)=>l.name.localeCompare(u.name)))}};e.$_4b=c,e.$_4b=c=ye([x(2,d.$Gk),x(3,A.$8j),x(4,j.$Th),x(5,I.$Xo),x(6,$.$pgb),x(7,$.$qgb),x(8,$.$Egb),x(9,N.$gi),x(10,$.$zgb),x(11,D.$$k),x(12,C.$Ek)],c);function g(w,h){const l=[...w].sort((u,b)=>u.name.localeCompare(b.name)).map(u=>({id:u.id,name:u.name}));return h?(0,O.$KS)(l,{}):JSON.stringify(l)}e.$a5b=g;function p(w){return JSON.parse(w.content)}e.$b5b=p}),define(oe[253],ae([0,1,3,2,6,14,20,22,25]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y4b=void 0;const d="sync.enable";let P=class extends N.$Qc{constructor($,c,g,p){super(),this.c=$,this.f=c,this.g=g,this.h=p,this.a=new O.$Ld,this.onDidChangeEnablement=this.a.event,this.b=new O.$Ld,this.onDidChangeResourceEnablement=this.b.event,this.B($.onDidChangeValue(-1,void 0,this.B(new N.$Pc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement($){$&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:$}),this.c.store(d,$,-1,1))}isResourceEnabled($){return this.c.getBoolean((0,C.$ygb)($),-1,!0)}setResourceEnablement($,c){if(this.isResourceEnabled($)!==c){const g=(0,C.$ygb)($);this.j(g,c)}}getResourceSyncStateVersion($){}j($,c){this.c.store($,c,-1,j.$o?0:1)}m($){if(d===$.key){this.a.fire(this.isEnabled());return}const c=C.$lgb.filter(g=>(0,C.$ygb)(g)===$.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$Y4b=P,e.$Y4b=P=ye([x(0,I.$Xo),x(1,D.$$k),x(2,A.$Th),x(3,C.$ogb)],P)}),define(oe[254],ae([0,1,5,15,62,2,21,19,14,11,17,25]),function(te,e,O,N,j,A,I,D,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$04b=void 0;let $=class extends A.$Qc{constructor(g,p,w,h,l){super(),this.a=g,this.b=p,this.c=w,this.f=h,this.g=l,this.h()}async h(){for(const p of this.g.profiles)for(const w of E.$lgb)try{await this.m(this.j(w,p.isDefault?void 0:p.id))}catch(h){this.f.error(h)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,d.$lk)(p)!==1&&this.f.error(p);return}if(g.children){for(const p of g.children)if(p.isDirectory&&!this.g.profiles.some(w=>w.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs(g,p,w){const h=this.j(g,p,w);try{const l=await this.b.resolve(h);if(l.children)return l.children.filter(b=>b.isFile&&!b.name.startsWith("lastSync")).sort().reverse().map(b=>({ref:b.name,created:this.n(b)}))}catch(l){if((0,d.$lk)(l)!==1)throw l}return[]}async resolveResourceContent(g,p,w,h){const l=this.j(g,w,h),u=(0,I.$tg)(l,p);try{return(await this.b.readFile(u)).value.toString()}catch(b){return this.f.error(b),null}}async writeResource(g,p,w,h,l){const u=this.j(g,h,l),b=(0,I.$tg)(u,`${(0,j.$9l)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(b,N.$_d.fromString(p))}catch(S){this.f.error(S)}}j(g,p,w=this.a.userDataSyncHome){return(0,I.$tg)(w,...p?[p,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const p=await this.b.resolve(g);if(p.children){const w=p.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let l=w.filter(b=>Date.now()-this.n(b)>h);const u=w.length-l.length;u<10&&(l=l.slice(10-u)),await O.Promises.settled(l.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(p){this.f.error(p)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$04b=$,e.$04b=$=ye([x(0,C.$Th),x(1,d.$8j),x(2,D.$gi),x(3,E.$Egb),x(4,P.$Gk)],$)}),define(oe[81],ae([0,1,3,2,6,27,176,14,11,4,24,43,20,25]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$egb=e.$dgb=e.$cgb=void 0,e.$cgb=(0,d.$Mh)("IUserDataSyncMachinesService");const p="sync.currentMachineName",w="Safari",h="Chrome",l="Edge",u="Firefox",b="Android";function S(s){switch(s){case w:case h:case l:case u:case b:case(0,j.$h)(0):return!0}return!1}e.$dgb=S;function t(){return j.$F?w:j.$D?h:j.$G?l:j.$E?u:j.$H?b:(0,j.$h)(j.$o?0:j.$t)}let a=class extends N.$Qc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(n,i,r,o,v,y){super(),this.h=r,this.j=o,this.m=v,this.n=y,this.c=this.B(new O.$Ld),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$4o)(n,i,r)}async getMachines(n){const i=await this.f;return(await this.s(n)).machines.map(o=>({...o,isCurrent:o.id===i}))}async addCurrentMachine(n){const i=await this.f,r=await this.s(n);r.machines.some(({id:o})=>o===i)||(r.machines.push({id:i,name:this.r(r.machines),platform:t()}),await this.t(r))}async removeCurrentMachine(n){const i=await this.f,r=await this.s(n),o=r.machines.filter(({id:v})=>v!==i);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(n,i,r){const o=await this.s(r),v=o.machines.find(({id:y})=>y===n);if(v){v.name=i,await this.t(o);const y=await this.f;n===y&&this.h.store(p,i,-1,1)}}async setEnablements(n){const i=await this.s();for(const[r,o]of n){const v=i.machines.find(y=>y.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(i)}r(n){const i=this.h.get(p,-1);if(i)return i;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,o=new RegExp(`${(0,A.$De)(r)}\\s#(\\d+)`);let v=0;for(const y of n){const f=o.exec(y.name),m=f?parseInt(f[1]):0;v=m>v?m:v}return`${r} #${v+1}`}async s(n){this.g=await this.u(n);const i=this.w(this.g);if(i.version!==g.a)throw new Error((0,I.localize)(0,null,this.n.nameLong));return i}async t(n){const i=JSON.stringify(n),r=await this.j.writeResource(g.b,i,this.g?.ref||null);this.g={ref:r,content:i},this.c.fire()}async u(n){if(this.g){const i=n&&n.latest?n.latest[g.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(i){this.m.error(i)}return{version:g.a,machines:[]}}};e.$egb=a,e.$egb=a=g=ye([x(0,D.$Th),x(1,C.$8j),x(2,$.$Xo),x(3,c.$pgb),x(4,c.$Egb),x(5,P.$mj)],a)}),define(oe[255],ae([0,1,5,62,38,8,3,2,6,21,9,173,24,20,22,25,78,81]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d5b=void 0;const l="sync.disableMachineEventually",u="sync.sessionId",b="sync.storeUrl",S="sync.productQuality";let t=class extends D.$Qc{get n(){const n=this.H.get(b,-1);return n?P.URI.parse(n):void 0}set n(n){n?this.H.store(b,n.toString(),-1,1):this.H.remove(b,-1)}get s(){return this.H.get(S,-1)}set s(n){n?this.H.store(S,n,-1,1):this.H.remove(S,-1)}constructor(n,i,r,o,v,y,f,m,L,F){super(),this.u=i,this.w=r,this.y=o,this.z=v,this.C=y,this.D=f,this.F=m,this.G=L,this.H=F,this.a=this.B(new D.$Rc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new I.$Ld),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$Pg(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=n.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,d.$mg)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(I.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:n,message:i}=this.L();n?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$9l)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(n,i,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(u,-1),n?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),i)this.M(!1);else throw o}}M(n){this.y.isEnabled()!==n&&(this.y.setEnablement(n),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(n){if(!n){this.b=0;return}const i=p.$ugb.toUserDataSyncError(n);i instanceof p.$wgb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?C.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(l,!0,-1,1),await(0,O.$Sg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(l,-1,!1)}R(){this.H.remove(l,-1)}async triggerSync(n,i,r){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...n),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$d5b=t,e.$d5b=t=ye([x(0,$.$mj),x(1,p.$ogb),x(2,p.$pgb),x(3,p.$zgb),x(4,p.$Agb),x(5,p.$Egb),x(6,w.$hCb),x(7,g.$$k),x(8,h.$cgb),x(9,c.$Xo)],t);class a extends D.$Qc{static{this.a="Interval"}constructor(n,i,r,o,v,y,f,m,L){super(),this.m=n,this.n=i,this.r=r,this.s=o,this.u=v,this.w=y,this.y=f,this.z=m,this.C=L,this.b=this.B(new D.$Rc),this.c=this.B(new I.$Ld),this.onDidStartSync=this.c.event,this.f=this.B(new I.$Ld),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,D.$Oc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,O.$Tg)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(n,i){const r=(0,O.$Fg)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,A.$2)(v))return}return this.H(n,i,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$mg)(this.m,this.r.userDataSyncStore?.url)}async G(){const n=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!n&&(!(0,d.$mg)(i.defaultUrl,n.defaultUrl)||!(0,d.$mg)(i.insidersUrl,n.insidersUrl)||!(0,d.$mg)(i.stableUrl,n.stableUrl))}async H(n,i,r){this.y.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let o;try{await this.I(i,r)}catch(v){if(this.y.error(v),o=v,p.$ugb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,r),o=void 0}catch(y){this.y.error(y),o=y}}this.f.fire(o)}async I(n,i){if(this.h=await this.u.createSyncTask(this.g,n),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$wgb((0,E.localize)(0,null),"DefaultServiceChanged"):new p.$wgb((0,E.localize)(1,null),"ServiceChanged"):new p.$wgb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(u,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$wgb((0,E.localize)(3,null),"DefaultServiceChanged"):new p.$wgb((0,E.localize)(4,null),"ServiceChanged"):new p.$wgb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const v=o.find(f=>f.isCurrent);if(v?.disabled)throw new p.$wgb((0,E.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new p.$wgb((0,j.$xi)(f),f instanceof p.$ugb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(u,this.g.session,-1,1),!i.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}}),define(oe[256],ae([0,1,9,177,14,11,43,20,28,25,17,39,119,118,117,19,120,115,116,4,121,41,27]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S,t){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$O5b=void 0;let s=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,r,o,v,y,f,m,L,F,T){this.e=i,this.f=r,this.g=o,this.h=y,this.i=f,this.j=m,this.k=L,this.l=F,this.n=T,this.d=v.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const r=this.L(i.content,"profiles");return(0,b.$b5b)(r)}return[]}async getLocalSyncedProfiles(i){const r=await this.f.getAllResourceRefs("profiles",void 0,i);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,i);if(o){const v=this.L(o,"profiles");return(0,b.$b5b)(v)}}return[]}async getLocalSyncedMachines(i){const r=await this.f.getAllResourceRefs("machines",void 0,i);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,i);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,r){return(await this.e.getAllResourceRefs(i,r?.collection)).map(({created:v,ref:y})=>({created:v,uri:this.J({remote:!0,syncResource:i,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(i,r,o){return(await this.f.getAllResourceRefs(i,r?.collection,o)).map(({created:y,ref:f})=>({created:y,uri:this.J({remote:!1,syncResource:i,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:i}){const r=this.K(i),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:i}){const r=this.K(i);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(i,o);case"keybindings":return this.u(i,o);case"tasks":return this.w(i,o);case"snippets":return this.y(i,o);case"globalState":return this.D(i,o);case"extensions":return this.A(i,o);case"profiles":return this.G(i,o);case"workspaceState":return[]}}async getMachineId({uri:i}){const r=this.K(i);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,I.$4o)(this.h,this.j,this.i)}}async resolveContent(i){const r=this.K(i);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(i,r,o,v,y){if(i){const{content:f}=await this.M(r,v,o);return f}return this.f.resolveResourceContent(r,v,o,y)}q(i,r,o){const v=this.L(r,i);switch(i){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(i,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(i){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,r){const o=this.d.joinPath(i,"settings.json"),v=r?r.settingsResource:this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}t(i,r){switch(r){case"settings.json":return(0,c.$n3b)(i.content).settings}return null}u(i,r){const o=this.d.joinPath(i,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}v(i,r){switch(r){case"keybindings.json":return(0,g.$k3b)(i.content,!!this.l.getValue(d.$igb),this.g)}return null}w(i,r){const o=this.d.joinPath(i,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}x(i,r){switch(r){case"tasks.json":return(0,w.$v3b)(i.content,this.g)}return null}async y(i,r){const o=await this.resolveContent(i);if(o){const v=this.L(o,"snippets");if(v){const y=(0,$.$s3b)(v),f=[];for(const m of Object.keys(y)){const L=this.d.joinPath(i,m),F=r?this.d.joinPath(r.snippetsHome,m):this.d.joinPath(i,a.a);f.push({resource:L,comparableResource:F})}return f}}return[]}z(i,r){return(0,$.$s3b)(i)[r]||null}A(i,r){const o=this.d.joinPath(i,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}B(i,r){switch(r){case"extensions.json":return(0,h.$f3b)((0,h.$e3b)(i),!0)}return null}async C(i){const{localExtensions:r}=await this.n.createInstance(h.$h3b).getLocalExtensions(i);return(0,h.$f3b)(r,!0)}D(i,r){const o=this.d.joinPath(i,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,a.a);return[{resource:o,comparableResource:v}]}E(i,r){switch(r){case"globalState.json":return(0,l.$QDb)(JSON.parse(i.content),!0)}return null}async F(i){const r=await this.n.createInstance(l.$SDb).getLocalGlobalState(i);return(0,l.$QDb)(r,!0)}G(i,r){const o=this.d.joinPath(i,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(i,r){switch(r){case"profiles.json":return(0,S.$KS)(JSON.parse(i.content),{})}return null}async I(i){return(0,b.$a5b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(i){const r=i.remote?a.b:a.c,o=[];return i.location&&(o.push(`scheme:${i.location.scheme}`),o.push(`authority:${i.location.authority}`),o.push((0,t.$Ge)(i.location.path,"/"))),o.push(`syncResource:${i.syncResource}`),o.push(`profile:${i.profile}`),i.collection&&o.push(`collection:${i.collection}`),i.ref&&o.push(`ref:${i.ref}`),i.node&&o.push(i.node),this.d.joinPath(O.URI.from({scheme:d.$Ggb,authority:r,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...o)}K(i){if(i.scheme!==d.$Ggb)return;const r=[];for(;i.path!=="/";)r.unshift(this.d.basename(i)),i=this.d.dirname(i);if(r.length<2)return;const o=i.authority===a.b;let v,y;const f=[];let m,L,F,T,z;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?y=q.substring(10):q.startsWith("syncResource:")?m=q.substring(13):q.startsWith("profile:")?L=q.substring(8):q.startsWith("collection:")?F=q.substring(11):q.startsWith("ref:")?T=q.substring(4):m?z=q:f.push(q)}return{remote:o,syncResource:m,profile:L,collection:F,ref:T,node:z,location:v&&y!==void 0?this.d.joinPath(O.URI.from({scheme:v,authority:y,query:i.query,fragment:i.fragment,path:"/"}),...f):void 0}}L(i,r){try{const o=JSON.parse(i);if((0,E.$JDb)(o))return o}catch(o){this.g.error(o)}throw new d.$ugb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(i,r,o){const v=await this.e.resolveResourceContent(i,r,o);return{ref:r,content:v}}};e.$O5b=s,e.$O5b=s=a=ye([x(0,d.$pgb),x(1,d.$qgb),x(2,d.$Egb),x(3,C.$Ek),x(4,j.$Th),x(5,D.$Xo),x(6,A.$8j),x(7,P.$Gk),x(8,p.$gi),x(9,u.$Lh)],s)}),define(oe[257],ae([0,1,18,5,26,38,3,2,21,12,32,19,29,11,4,20,22,17,115,116,117,118,119,120,121,25]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S,t,a,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c5b=void 0;const i="sync.lastSyncTime";let r=class extends D.$Qc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(m,L,F,T,z,q,_,Q,Z,G,K){super(),this.C=m,this.D=L,this.F=F,this.G=T,this.H=z,this.I=q,this.J=_,this.L=Q,this.M=Z,this.N=G,this.O=K,this.f="uninitialized",this.g=this.B(new I.$Ld),this.onDidChangeStatus=this.g.event,this.h=this.B(new I.$Ld),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new I.$Ld),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new I.$Ld),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new I.$Ld),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new I.$Ld),this.onDidResetLocal=this.w.event,this.y=this.B(new I.$Ld),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,D.$Oc)(()=>this.bb()))}async createSyncTask(m,L){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),T=(0,P.$cg)();try{const Q=(0,n.$tgb)(T);L&&(Q["Cache-Control"]="no-cache"),m=await this.D.manifest(m,Q)}catch(Q){const Z=n.$ugb.toUserDataSyncError(Q);throw y(Z,T,this.F,this.I),Z}const z=!1,q=this;let _;return{manifest:m,async run(){if(z)throw new Error("Can run a task only once");_=(0,N.$Fg)(Q=>q.P(m,!1,T,Q)),await _.finally(()=>_=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),q.$()},stop(){return _?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new n.$ugb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const m=new Date().getTime(),L=(0,P.$cg)(),F=(0,n.$tgb)(L);let T;try{T=await this.D.manifest(null,F)}catch(_){const Q=n.$ugb.toUserDataSyncError(_);throw y(Q,L,this.F,this.I),Q}await this.resetLocal();const z=this,q=new j.$Vd;return{id:L,async merge(){return z.P(T,!0,L,q.token)},async apply(){try{try{await z.R(T,L,q.token)}catch(_){if(n.$ugb.toUserDataSyncError(_).code==="MethodNotFound")z.H.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.H.info("Applying manual sync again..."),await z.R(T,L,q.token);else throw _}}catch(_){throw z.H.error(_),_}z.H.info(`Sync done. Took ${new Date().getTime()-m}ms`),z.$()},async stop(){q.cancel(),await z.U(),await z.resetLocal()}}}async P(m,L,F,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(z,m,L,F,T));const q=z.enabled.find(_=>_.resource==="profiles");if(q){const _=await q.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(_,m,L,F,T)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(m,L,F,T,z){for(const q of m){if(z.isCancellationRequested)return;const _=this.M.profiles.find(Z=>Z.id===q.id);if(!_){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const Q=this.getOrCreateActiveProfileSynchronizer(_,q);this.n.push(...await this.S(Q,L,F,T,z))}for(const[q,_]of this.z.entries())this.M.profiles.some(Q=>Q.id===_[0].profile.id)||(_[1].dispose(),this.z.delete(q))}async R(m,L,F){const T=this.ab();for(const Z of T){if(F.isCancellationRequested)return;await Z.apply(L,F)}const z=T.find(Z=>Z.profile.isDefault);if(!z)return;const q=z.enabled.find(Z=>Z.resource==="profiles");if(!q)return;const Q=(await q.getRemoteSyncedProfiles(m?.latest??null)||[]).filter(Z=>T.every(G=>G.profile.id!==Z.id));Q.length&&await this.Q(Q,m,!1,L,F)}async S(m,L,F,T,z){return(await m.sync(L,F,T,z)).map(([_,Q])=>({profile:m.profile,syncResource:_,error:Q}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(m=>m.stop()))}async resolveContent(m){const L=await this.N.resolveContent(m);if(L)return L;for(const F of this.ab())for(const T of F.enabled){const z=await T.resolveContent(m);if(z)return z}return null}async replace(m){this.cb();const L=this.N.resolveUserDataSyncResource(m);if(!L)return;const F=await this.resolveContent(m.uri);F&&await this.W(L.profile,async T=>{if(L.syncResource===T.resource)return await T.replace(F),!0})}async accept(m,L,F,T){this.cb(),await this.W(m.profile,async z=>{if(m.syncResource===z.resource)return await z.accept(L,F),T&&await z.apply((0,d.$Cf)(T)?!1:T.force,(0,n.$tgb)((0,P.$cg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async L=>{if(L.resource!=="globalState"&&await L.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async L=>{if(await L.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(m){this.H.error(m)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(i,-1);for(const[m]of this.z.values())try{await m.resetLocal()}catch(L){this.H.error(L)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const m=await this.N.getRemoteSyncedProfiles(),L=m.map(q=>q.collection),F=await this.D.getAllCollections(),T=F.filter(q=>!L.includes(q));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const z=m.filter(q=>F.includes(q.collection));if(z.length!==m.length){const q=this.G.createInstance(s.$_4b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(z,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(m){this.cb();const L=await this.D.getActivityData();await this.C.writeFile(m,L)}async extractActivityData(m,L){const F=(await this.C.readFile(m)).value.toString(),T=JSON.parse(F);if(T.resources)for(const z in T.resources)for(const q of T.resources[z])await this.O.writeResource(z,q.content,new Date(q.created*1e3),void 0,L);if(T.collections)for(const z in T.collections)for(const q in T.collections[z].resources)for(const _ of T.collections[z].resources?.[q]??[])await this.O.writeResource(q,_.content,new Date(_.created*1e3),z,L)}async W(m,L){const F=new D.$Pc;try{const T=this.z.get(m.id);if(T){const Z=await this.X(T[0],L,F);return(0,d.$Df)(Z)?null:Z}if(m.isDefault){const Z=F.add(this.G.createInstance(o,m,void 0)),G=await this.X(Z,L,F);return(0,d.$Df)(G)?null:G}if(this.M.isEnabled())return null;const z=F.add(this.G.createInstance(s.$_4b,m,void 0)),q=await this.D.manifest(null),Q=(await z.getRemoteSyncedProfiles(q?.latest??null)||[]).find(Z=>Z.id===m.id);if(Q){const Z=F.add(this.G.createInstance(o,m,Q.collection)),G=await this.X(Z,L,F);return(0,d.$Df)(G)?null:G}return null}finally{F.dispose()}}async X(m,L,F){const T=[...m.enabled,...m.disabled.reduce((z,q)=>(q!=="workspaceState"&&z.push(F.add(m.createSynchronizer(q))),z),[])];for(const z of T){const q=await L(z);if(!(0,d.$Df)(q))return q}}Y(m){const L=this.f;this.f!==m&&(this.f=m,this.g.fire(m),L==="hasConflicts"&&this.$())}Z(){const m=this.ab().map(L=>L.conflicts).flat();(0,O.$sb)(this.j,m,(L,F)=>L.profile.id===F.profile.id&&L.syncResource===F.syncResource&&(0,O.$sb)(L.conflicts,F.conflicts,(T,z)=>(0,C.$mg)(T.previewResource,z.previewResource)))||(this.j=m,this.m.fire(m))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(m,L){let F=this.z.get(m.id);if(F&&F[0].collection!==L?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete(m.id)),!F){const T=new D.$Pc,z=T.add(this.G.createInstance(o,m,L?.collection));T.add(z.onDidChangeStatus(q=>this.Y(q))),T.add(z.onDidChangeConflicts(q=>this.Z())),T.add(z.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(m.id,F=[z,T])}return F[0]}ab(){const m=[];for(const[L]of this.z.values())m.push(L);return m}bb(){this.z.forEach(([,m])=>m.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$c5b=r,e.$c5b=r=ye([x(0,c.$8j),x(1,n.$pgb),x(2,n.$ogb),x(3,g.$Lh),x(4,n.$Egb),x(5,w.$$k),x(6,p.$Xo),x(7,n.$zgb),x(8,h.$Gk),x(9,n.$Bgb),x(10,n.$qgb)],r);let o=class extends D.$Qc{get enabled(){return this.f.sort((m,L)=>m[1]-L[1]).map(([m])=>m)}get disabled(){return n.$lgb.filter(m=>!this.r.isResourceEnabled(m))}get status(){return this.g}get conflicts(){return this.m}constructor(m,L,F,T,z,q,_,Q,Z,G){super(),this.profile=m,this.collection=L,this.r=F,this.t=T,this.u=z,this.w=q,this.y=_,this.z=Q,this.C=Z,this.D=G,this.f=[],this.g="idle",this.h=this.B(new I.$Ld),this.onDidChangeStatus=this.h.event,this.j=this.B(new I.$Ld),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new I.$Ld),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([K,H])=>this.F(K,H))),this.B((0,D.$Oc)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of n.$lgb)F.isResourceEnabled(K)&&this.G(K)}F(m,L){L?this.G(m):this.H(m)}G(m){if(this.f.some(([z])=>z.resource===m))return;if(m==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(m==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||m==="workspaceState")return;if(m!=="profiles"&&this.profile.useDefaultFlags?.[m]){this.z.debug(`Skipping syncing ${m} in ${this.profile.name} because it is already synced by default profile`);return}const L=new D.$Pc,F=L.add(this.createSynchronizer(m));L.add(F.onDidChangeStatus(()=>this.L())),L.add(F.onDidChangeConflicts(()=>this.M())),L.add(F.onDidChangeLocal(()=>this.j.fire(m)));const T=this.N(m);this.f.push([F,T,L])}H(m){const L=this.f.findIndex(([F])=>F.resource===m);if(L!==-1){const[[F,,T]]=this.f.splice(L,1);T.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,z=>this.z.error(z))}}createSynchronizer(m){switch(m){case"settings":return this.t.createInstance(S.$o3b,this.profile,this.collection);case"keybindings":return this.t.createInstance(b.$l3b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$t3b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$w3b,this.profile,this.collection);case"globalState":return this.t.createInstance(u.$RDb,this.profile,this.collection);case"extensions":return this.t.createInstance(l.$g3b,this.profile,this.collection);case"profiles":return this.t.createInstance(s.$_4b,this.profile,this.collection)}}async sync(m,L,F,T){if(T.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const q=[],_=(0,n.$tgb)(F),Q=(this.collection?m?.collections?.[this.collection]?.latest:m?.latest)??null,Z=L?await this.I(Q):{};for(const G of z){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(L){const K=await G.preview(Q,Z,_);if(K)for(const H of K.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await G.merge(H.previewResource)}else await G.sync(Q,_)}catch(K){const H=n.$ugb.toUserDataSyncError(K);if(y(H,F,this.w,this.y),v(K))throw H;this.z.error(K),this.z.error(`${G.resource}: ${(0,A.$xi)(K)}`),q.push([G.resource,H])}}return q}finally{this.L()}}async apply(m,L){const F=(0,n.$tgb)(m);for(const T of this.enabled){if(L.isCancellationRequested)return;try{await T.apply(!1,F)}catch(z){const q=n.$ugb.toUserDataSyncError(z);if(y(q,m,this.w,this.y),v(z))throw q;this.z.error(z),this.z.error(`${T.resource}: ${(0,A.$xi)(z)}`)}}}async stop(){for(const m of this.enabled)try{m.status!=="idle"&&await m.stop()}catch(L){this.z.error(L)}}async resetLocal(){for(const m of this.enabled)try{await m.resetLocal()}catch(L){this.z.error(`${m.resource}: ${(0,A.$xi)(L)}`),this.z.error(L)}}async I(m){if(!this.profile.isDefault)return{};const L=this.D.getValue(n.$hgb),F=this.enabled.find(T=>T instanceof S.$o3b);if(F){const T=await F.getRemoteUserDataSyncConfiguration(m);return{...L,...T}}return L}J(m){this.g!==m&&(this.g=m,this.h.fire(m))}L(){return this.M(),this.enabled.some(m=>m.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(m=>m.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const m=this.enabled.filter(L=>L.status==="hasConflicts").filter(L=>L.conflicts.conflicts.length>0).map(L=>L.conflicts);(0,O.$sb)(this.m,m,(L,F)=>L.syncResource===F.syncResource&&(0,O.$sb)(L.conflicts,F.conflicts,(T,z)=>(0,C.$mg)(T.previewResource,z.previewResource)))||(this.m=m,this.n.fire(m))}N(m){switch(m){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=ye([x(2,n.$zgb),x(3,g.$Lh),x(4,$.$2n),x(5,n.$ogb),x(6,w.$$k),x(7,n.$Egb),x(8,h.$Gk),x(9,E.$gi)],o);function v(f){if(f instanceof n.$ugb)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(f,m,L,F){F.publicLog2("sync/error",{code:f.code,serverCode:f instanceof n.$vgb?String(f.serverCode):void 0,url:f instanceof n.$vgb?f.url:void 0,resource:f.resource,executionId:m,service:L.userDataSyncStore.url.toString()})}}),define(oe[258],ae([0,1,3,2,9,17,25]),function(te,e,O,N,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=e.$s8b=void 0;function D($,c){return{...$,profile:(0,A.$Hk)($.profile,c.profilesHome.scheme)}}function C($){return{created:$.created,uri:j.URI.revive($.uri)}}class d{constructor(c,g,p){this.c=c,this.d=g,this.f=p,this.a=new Map,this.b=new O.$Ld}listen(c,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(c,g,p){try{return await this.g(c,g,p)}catch(w){throw this.f.error(w),w}}async g(c,g,p){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(j.URI.revive(p[0]));case"accept":return this.c.accept(D(p[0],this.d),j.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(C(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(j.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(j.URI.revive(p[0]),j.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const w=g.substring(11),h=p[0],l=this.h(h);switch(p=p.slice(1),w){case"merge":return l.merge();case"apply":return l.apply().then(()=>this.a.delete(this.j(l.id)));case"stop":return l.stop().finally(()=>this.a.delete(this.j(l.id)))}}throw new Error("Invalid call")}h(c){const g=this.a.get(this.j(c));if(!g)throw new Error(`Manual sync taks not found: ${c}`);return g}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$s8b=d;let P=class extends N.$Qc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new O.$Ld),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$Ld),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$Ld),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$Ld),this.onSyncErrors=this.m.event,this.a={call(p,w,h){return c.call(p,w,h).then(null,l=>{throw I.$ugb.toUserDataSyncError(l)})},listen(p,w){return c.listen(p,w)}},this.a.call("_getInitialData").then(([p,w,h])=>{this.s(p),this.t(w),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(l=>this.s(l))),this.B(this.a.listen("onDidChangeLastSyncTime")(l=>this.u(l)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(w=>({...w,error:I.$ugb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),g=this;return new E(c,{async call(w,h,l){return g.a.call(`manualSync/${w}`,[c,...Array.isArray(h)?h:[h]],l)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,g,p,w){return this.a.call("accept",[c,g,p,w])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,g){return this.a.call("extractActivityData",[c,g])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map(g=>({syncResource:g.syncResource,profile:(0,A.$Hk)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(p=>({...p,baseResource:j.URI.revive(p.baseResource),localResource:j.URI.revive(p.localResource),remoteResource:j.URI.revive(p.remoteResource),previewResource:j.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$t8b=P,e.$t8b=P=ye([x(1,A.$Gk)],P);class E extends N.$Qc{constructor(c,g){super(),this.id=c,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[259],ae([0,1,5,26,8,3,2,141,6,21,12,9,32,19,14,11,24,57,43,20,25]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HDb=e.$GDb=e.$FDb=e.$EDb=e.$DDb=void 0;const S="configurationSync.store",t="sync.previous.store",a="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",i=100,r=1e3*60*5;let o=class extends I.$Qc{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.$xgb,-1)}set c(F){this.h.store(b.$xgb,F,-1,C.$o?0:1)}constructor(F,T,z){super(),this.f=F,this.g=T,this.h=z,this.a=this.B(new A.$Ld),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new I.$Pc);this.B(A.Event.filter(z.onDidChangeValue(-1,b.$xgb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[S]),this.a.fire()}m(F){if(F&&(F=C.$o&&F.web?{...F,...F.web}:F,(0,P.$wf)(F.url)&&(0,P.$yf)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(T=>Array.isArray(F.authenticationProviders[T].scopes)))){const T=F,z=!!T.canSwitch,q=T.url===T.insidersUrl?"insiders":"stable",_=(z?this.c:void 0)||q,Q=_==="insiders"?T.insidersUrl:_==="stable"?T.stableUrl:T.url;return{url:E.URI.parse(Q),type:_,defaultType:q,defaultUrl:E.URI.parse(T.url),stableUrl:E.URI.parse(T.stableUrl),insidersUrl:E.URI.parse(T.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(T.authenticationProviders).reduce((Z,G)=>(Z.push({id:G,scopes:T.authenticationProviders[G].scopes}),Z),[])}}}};e.$DDb=o,e.$DDb=o=ye([x(0,w.$mj),x(1,c.$gi),x(2,u.$Xo)],o);let v=class extends o{constructor(F,T,z){super(F,T,z);const q=this.h.get(t,-1);q&&(this.n=JSON.parse(q));const _=this.f[S];_?this.h.store(t,JSON.stringify(_),-1,1):this.h.remove(t,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$EDb=v,e.$EDb=v=ye([x(0,w.$mj),x(1,c.$gi),x(2,u.$Xo)],v);let y=class extends I.$Qc{get donotMakeRequestsUntil(){return this.j}constructor(F,T,z,q,_,Q,Z){super(),this.n=z,this.r=q,this.s=Z,this.g=this.B(new A.$Ld),this.onTokenFailed=this.g.event,this.h=this.B(new A.$Ld),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$Ld),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,l.$4o)(_,Q,Z).then(G=>{const K={"X-Client-Name":`${T.applicationName}${C.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(K["X-Client-Commit"]=T.commit),K}),this.f=new m(i,r,this.n,this.r),this.u(),this.B((0,I.$Oc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,T){this.b={token:F,type:T}}t(F){this.a=F?(0,d.$tg)(F,"v1"):void 0}u(){const F=this.s.getNumber(a,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,O.$Fg)(T=>(0,O.$Sg)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$tg)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const z=await this.D(T,{type:"GET",headers:F},[],N.CancellationToken.None);return(await(0,h.$Qo)(z))?.map(({id:q})=>q)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$tg)(this.a,"collection").toString();F={...F},F["Content-Type"]=D.$Jr.text;const z=await this.D(T,{type:"POST",headers:F},[],N.CancellationToken.None),q=await(0,h.$Po)(z);if(!q)throw new b.$vgb("Server did not return the collection id",T,"NoCollection",z.res.statusCode,z.res.headers[b.$rgb]);return q}async deleteCollection(F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=F?(0,d.$tg)(this.a,"collection",F).toString():(0,d.$tg)(this.a,"collection").toString();T={...T},await this.D(z,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async getAllResourceRefs(F,T){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.z(this.a,T,F),q={},_=await this.D(z.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,h.$Qo)(_)||[]).map(({url:Z,created:G})=>({ref:(0,d.$vg)(z,z.with({path:Z})),created:G*1e3}))}async resolveResourceContent(F,T,z,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,d.$tg)(this.z(this.a,z,F),T).toString();q={...q},q["Cache-Control"]="no-cache";const Q=await this.D(_,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,h.$Po)(Q)}async deleteResource(F,T,z){if(!this.a)throw new Error("No settings sync store url configured.");const q=T!==null?(0,d.$tg)(this.z(this.a,z,F),T).toString():this.z(this.a,z,F).toString(),_={};await this.D(q,{type:"DELETE",headers:_},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,d.$tg)(this.a,"resource").toString(),T={"Content-Type":D.$Jr.text};await this.D(F,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async readResource(F,T,z,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,d.$tg)(this.z(this.a,z,F),"latest").toString();q={...q},q["Cache-Control"]="no-cache",T&&(q["If-None-Match"]=T.ref);const Q=await this.D(_,{type:"GET",headers:q},[304],N.CancellationToken.None);let Z=null;if(Q.res.statusCode===304&&(Z=T),Z===null){const G=Q.res.headers.etag;if(!G)throw new b.$vgb("Server did not return the ref",_,"NoRef",Q.res.statusCode,Q.res.headers[b.$rgb]);const K=await(0,h.$Po)(Q);if(!K&&Q.res.statusCode===304)throw new b.$vgb("Empty response",_,"EmptyResponse",Q.res.statusCode,Q.res.headers[b.$rgb]);Z={ref:G,content:K}}return Z}async writeResource(F,T,z,q,_={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=this.z(this.a,q,F).toString();_={..._},_["Content-Type"]=D.$Jr.text,z&&(_["If-Match"]=z);const Z=await this.D(Q,{type:"POST",data:T,headers:_},[],N.CancellationToken.None),G=Z.res.headers.etag;if(!G)throw new b.$vgb("Server did not return the ref",Q,"NoRef",Z.res.statusCode,Z.res.headers[b.$rgb]);return G}async manifest(F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,d.$tg)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",F&&(T["If-None-Match"]=F.ref);const q=await this.D(z,{type:"GET",headers:T},[304],N.CancellationToken.None);let _=null;if(q.res.statusCode===304&&(_=F),!_){const Z=q.res.headers.etag;if(!Z)throw new b.$vgb("Server did not return the ref",z,"NoRef",q.res.statusCode,q.res.headers[b.$rgb]);const G=await(0,h.$Po)(q);if(!G&&q.res.statusCode===304)throw new b.$vgb("Empty response",z,"EmptyResponse",q.res.statusCode,q.res.headers[b.$rgb]);G&&(_={...JSON.parse(G),ref:Z})}const Q=this.s.get(s,-1);return Q&&_&&Q!==_.session&&this.C(),_===null&&Q&&this.C(),_&&this.s.store(s,_.session,-1,1),_}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,d.$tg)(this.a,"download").toString(),T={},z=await this.D(F,{type:"GET",headers:T},[],N.CancellationToken.None);if(!(0,h.$Mo)(z))throw new b.$vgb("Server returned "+z.res.statusCode,F,"EmptyResponse",z.res.statusCode,z.res.headers[b.$rgb]);if((0,h.$No)(z))throw new b.$vgb("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[b.$rgb]);return z.stream}z(F,T,z){return T?(0,d.$tg)(F,"collection",T,"resource",z):(0,d.$tg)(F,"resource",z)}C(){this.s.remove(s,-1),this.s.remove(n,-1)}async D(F,T,z,q){if(!this.b)throw new b.$vgb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new b.$vgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const _=await this.c;T.headers={...T.headers||{},..._,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:F,type:T.type,headers:{...T.headers,authorization:void 0}});let Q;try{Q=await this.f.request(F,T,q)}catch(V){if(!(V instanceof b.$vgb)){let W="RequestFailed";const ee=(0,j.$8)(V).toLowerCase();ee.includes("xhr timeout")?W="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?W="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?W="RequestPathNotEscaped":ee.includes("headers must be an object")?W="RequestHeadersNotObject":(0,j.$2)(V)&&(W="RequestCanceled"),V=new b.$vgb(`Connection refused for the request '${F}'.`,F,W,void 0,void 0)}throw this.r.info("Request failed",F),V}const Z=Q.res.headers[b.$rgb],G={url:F,status:Q.res.statusCode,"execution-id":T.headers[b.$sgb],"operation-id":Z},K=(0,h.$Mo)(Q)||Q.res.statusCode&&z.includes(Q.res.statusCode);let H="";if(K?this.r.trace("Request succeeded",G):(H=await(0,h.$Oo)(Q)||"",this.r.info("Request failed",G,H)),Q.res.statusCode===401||Q.res.statusCode===403){if(this.b=void 0,Q.res.statusCode===401)throw this.g.fire("Unauthorized"),new b.$vgb(`${T.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",Q.res.statusCode,Z);if(Q.res.statusCode===403)throw this.g.fire("Forbidden"),new b.$vgb(`${T.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",Q.res.statusCode,Z)}if(this.h.fire(),Q.res.statusCode===404)throw new b.$vgb(`${T.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",Q.res.statusCode,Z);if(Q.res.statusCode===405)throw new b.$vgb(`${T.type} request '${F}' failed because the requested endpoint is not found (405). ${H}`,F,"MethodNotFound",Q.res.statusCode,Z);if(Q.res.statusCode===409)throw new b.$vgb(`${T.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",Q.res.statusCode,Z);if(Q.res.statusCode===410)throw new b.$vgb(`${T.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",Q.res.statusCode,Z);if(Q.res.statusCode===412)throw new b.$vgb(`${T.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",Q.res.statusCode,Z);if(Q.res.statusCode===413)throw new b.$vgb(`${T.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",Q.res.statusCode,Z);if(Q.res.statusCode===426)throw new b.$vgb(`${T.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",Q.res.statusCode,Z);if(Q.res.statusCode===429){const V=Q.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new b.$vgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",Q.res.statusCode,Z)):new b.$vgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",Q.res.statusCode,Z)}if(!K)throw new b.$vgb("Server returned "+Q.res.statusCode,F,"Unknown",Q.res.statusCode,Z);return Q}F(F){let T=this.s.get(n,-1);T===void 0&&(T=(0,$.$cg)(),this.s.store(n,T,-1,1)),F["X-Machine-Session-Id"]=T;const z=this.s.get(s,-1);z!==void 0&&(F["X-User-Session-Id"]=z)}};e.$FDb=y,e.$FDb=y=ye([x(1,w.$mj),x(2,h.$Ko),x(3,b.$Egb),x(4,g.$Th),x(5,p.$8j),x(6,u.$Xo)],y);let f=class extends y{constructor(F,T,z,q,_,Q,Z){super(F.userDataSyncStore?.url,T,z,q,_,Q,Z),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$GDb=f,e.$GDb=f=ye([x(0,b.$ogb),x(1,w.$mj),x(2,h.$Ko),x(3,b.$Egb),x(4,g.$Th),x(5,p.$8j),x(6,u.$Xo)],f);class m{constructor(F,T,z,q){this.c=F,this.d=T,this.f=z,this.g=q,this.a=[],this.b=void 0}request(F,T,z){if(this.h()&&this.i(),T.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.$vgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(T,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$HDb=m}),define(oe[260],ae([0,1,3,55,24,20,22,255,25,78,81]),function(te,e,O,N,j,A,I,D,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=void 0;let E=class extends D.$d5b{constructor(c,g,p,w,h,l,u,b,S,t,a){super(c,g,p,w,h,u,b,S,t,a),this.B(O.Event.debounce(O.Event.any(O.Event.map(l.onDidFocusWindow,()=>"windowFocus"),O.Event.map(l.onDidOpenWindow,()=>"windowOpen")),(s,n)=>s?[...s,n]:[n],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$N8b=E,e.$N8b=E=ye([x(0,j.$mj),x(1,C.$ogb),x(2,C.$pgb),x(3,C.$zgb),x(4,C.$Agb),x(5,N.$D6b),x(6,C.$Egb),x(7,d.$hCb),x(8,I.$$k),x(9,P.$cgb),x(10,A.$Xo)],E)}),define(oe[261],ae([0,1,69,23,6,21]),function(te,e,O,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=e.$e6b=e.$d6b=e.$c6b=void 0,e.$c6b=128/4;function I(d){function P(){let E=d.scheme===N.Schemas.file?(0,A.$hg)(d):d.toString();return j.$k||(E=E.toLowerCase()),(0,O.createHash)("md5").update(E).digest("hex")}return{id:P(),configPath:d}}e.$d6b=I;function D(d,P){function E(){if(d.scheme!==N.Schemas.file)return(0,O.createHash)("md5").update(d.toString()).digest("hex");if(!P)return;let c;return j.$k?c=P.ino:j.$j?c=P.birthtime.getTime():j.$i&&(typeof P.birthtimeMs=="number"?c=Math.floor(P.birthtimeMs):c=P.birthtime.getTime()),(0,O.createHash)("md5").update(d.fsPath).update(c?String(c):"").digest("hex")}const $=E();if(typeof $=="string")return{id:$,uri:d}}e.$e6b=D;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$f6b=C}),define(oe[262],ae([0,1,5,8,2,16,31,14,7,75,113,261,55,71,23]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h8b=void 0;let p=class extends j.$Qc{constructor(h,l,u,b){super(),this.a=h,this.b=l,this.c=u,this.f=b,this.B(new O.$4g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,l=await I.Promises.readdir(h),u=new d.$SCb(this.f.getChannel("storage"));await Promise.all(l.map(async b=>{const S=(0,A.$hc)(h,b);b.length===E.$c6b||b===P.$Yh.id||(await this.c.getWindows()).some(s=>s.workspace?.id===b)||await u.isUsed(S)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${b} as it seems to be an unused empty workspace.`),await I.Promises.rm(S))}))}catch(h){(0,N.$Y)(h)}}};e.$h8b=p,e.$h8b=p=ye([x(0,D.$Uh),x(1,C.$7i),x(2,$.$D6b),x(3,c.$S7b)],p)}),define(oe[82],ae([0,1,52,5,16,12,31,148,273,274]),function(te,e,O,N,j,A,I,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.zip=e.$dp=e.$cp=void 0,e.$cp="end of central directory record signature not found";const P=new RegExp(e.$cp);class E extends Error{constructor(a,s){let n=s.message;switch(a){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=a,this.cause=s}}e.$dp=E;function $(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(s=>a&s).reduce((s,n)=>s+n,a&61440)}function c(t){if(t instanceof E)return t;let a;return P.test(t.message)&&(a="CorruptZip"),new E(a,t)}function g(t,a,s,n,i,r){const o=j.$kc(a),v=j.$hc(n,o);if(!v.startsWith(n))return Promise.reject(new Error(D.localize(0,null,a)));const y=j.$hc(n,a);let f;return r.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(I.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((m,L)=>{if(!r.isCancellationRequested)try{f=(0,O.createWriteStream)(y,{mode:s}),f.once("close",()=>m()),f.once("error",L),t.once("error",L),t.pipe(f)}catch(F){L(F)}}))}function p(t,a,s,n){let i=(0,N.$Fg)(()=>Promise.resolve()),r=0;const o=n.onCancellationRequested(()=>{i.cancel(),t.close()});return new Promise((v,y)=>{const f=new N.$Mg,m=L=>{L.isCancellationRequested||(r++,t.readEntry())};t.once("error",y),t.once("close",()=>i.then(()=>{n.isCancellationRequested||t.entryCount===r?v():y(new E("Incomplete",new Error(D.localize(1,null,r,t.entryCount))))},y)),t.readEntry(),t.on("entry",L=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(L.fileName)){m(n);return}const F=L.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const q=j.$hc(a,F);i=(0,N.$Fg)(_=>I.Promises.mkdir(q,{recursive:!0}).then(()=>m(_)).then(void 0,y));return}const T=h(t,L),z=$(L);i=(0,N.$Fg)(q=>f.queue(()=>T.then(_=>g(_,F,z,a,s,q).then(()=>m(q)))).then(null,y))})}).finally(()=>o.dispose())}function w(t,a=!1){return new Promise((s,n)=>{(0,C.open)(t,a?{lazyEntries:!0}:void 0,(i,r)=>{i?n(c(i)):s((0,A.$Hf)(r))})})}function h(t,a){return new Promise((s,n)=>{t.openReadStream(a,(i,r)=>{i?n(c(i)):s((0,A.$Hf)(r))})})}function l(t,a){return new Promise((s,n)=>{const i=new d.ZipFile;a.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const r=(0,O.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>s(t))})}e.zip=l;function u(t,a,s={},n){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=w(t,!0);return s.overwrite&&(r=r.then(o=>I.Promises.rm(a).then(()=>o))),r.then(o=>p(o,a,{sourcePathRegex:i},n))}e.$fp=u;function b(t,a){return w(t).then(s=>new Promise((n,i)=>{s.on("entry",r=>{r.fileName===a&&h(s,r).then(o=>n(o),o=>i(o))}),s.once("close",()=>i(new Error(D.localize(2,null,a))))}))}function S(t,a){return b(t,a).then(s=>new Promise((n,i)=>{const r=[];s.once("error",i),s.on("data",o=>r.push(o)),s.on("end",()=>n(Buffer.concat(r)))}))}e.$gp=S}),define(oe[263],ae([0,1,5,8,2,23,21,53,12,32,31,82,19,14,29,33,97,11,7]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;let b=class extends j.$Qc{static{u=this}static{this.c=".sigzip"}constructor(t,a,s,n,i,r){super(),this.h=a,this.j=s,this.m=n,this.n=i,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,s){await this.g;const n=(0,I.$tg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,n,r=>this.j.download(t,r,a))}catch(r){throw new g.$3n(r.message,g.ExtensionManagementErrorCode.Download)}let i=!1;if(s&&this.t(t)){const r=await this.u(t);try{i=await this.n.verify(n.fsPath,r.fsPath,this.r.getLevel()===l.LogLevel.Trace)}catch(o){const v=o;if(i=v.code,v.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${v.output}`),i===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$3n(E.$cp,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return i===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:n,verificationStatus:i}}t(t){if(!t.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,C.$Cf)(a)?a:!0}async u(t){await this.g;const a=(0,I.$tg)(this.extensionsDownloadDir,`${this.z(t)}${u.c}`);return await this.w(t,a,s=>this.j.downloadSignatureArchive(t,s)),a}async w(t,a,s){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await s(a);return}const n=(0,I.$tg)(this.extensionsDownloadDir,`.${(0,d.$cg)()}`);await this.h.exists(n)||await s(n);try{await P.Promises.rename(n.fsPath,a.fsPath,2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,N.$8)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],s=[],n=[];for(const o of t.children)if(o.name.endsWith(u.c))n.push(o.resource);else{const v=p.$so.parse(o.name);v&&s.push([v,o])}const i=(0,p.$xo)(s,([o])=>o),r=[];for(const o of i)o.sort((v,y)=>D.rcompare(v[0].version,y[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...n),await O.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(t){this.r.error(t)}}z(t){return this.f?p.$so.create(t).toString().toLowerCase():(0,d.$cg)()}};e.$vp=b,e.$vp=b=u=ye([x(0,c.$Uh),x(1,h.$8j),x(2,g.$2n),x(3,$.$gi),x(4,w.$9o),x(5,l.$7i)],b)}),define(oe[264],ae([0,1,82,157]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function j(A){return(0,O.$gp)(A,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$xp=j}),define(oe[122],ae([0,1,5,15,26,38,8,3,51,2,34,23,16,21,53,12,9,32,31,82,156,96,14,243,29,33,50,79,263,244,264,212,223,67,11,4,7,24,22,28,17]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S,t,a,s,n,i,r,o,v,y,f,m,L,F,T,z,q,_,Q,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=void 0,e.$Ap=(0,T.$Nh)(s.$4n);const G=".vsctmp";let K=class extends a.$hp{constructor(Y,B,k,R,U,M,J,X,se,le,ue,he){super(Y,B,ue,k,le,he),this.fb=U,this.gb=M,this.hb=J,this.ib=se,this.eb=new Map,this.rb=new P.$zc;const $e=this.B(X.createInstance(v.$wp));this.bb=this.B(X.createInstance(H,we=>$e.postUninstall(we))),this.cb=this.B(new f.$yp(he,se,ue,this,this.F)),this.db=this.B(X.createInstance(o.$vp));const de=this.B(new m.$zp(this,this.fb,he,M,ue,se,k));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Co)(this.ib,this.F)),this.jb}async zip(Y){this.F.trace("ExtensionManagementService#zip",Y.identifier.id);const B=await this.pb(Y),k=await(0,u.zip)((0,c.$tg)(this.db.extensionsDownloadDir,(0,h.$cg)()).fsPath,B);return w.URI.file(k)}async unzip(Y){return this.F.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:B,cleanup:k}=await this.lb(Y),R=$.$ic(B.fsPath);try{return await(0,y.$xp)(R)}finally{await k()}}getInstalled(Y,B=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Y??null,B)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Y){return this.bb.scanUserExtensionAtLocation(Y)}async install(Y,B={}){this.F.trace("ExtensionManagementService#install",Y.toString());const{location:k,cleanup:R}=await this.lb(Y);try{const U=await(0,y.$xp)($.$ic(k.fsPath)),M=(0,n.$wo)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,L.$Jo)(U.engines.vscode,this.G.version,this.G.date))throw new Error(b.localize(0,null,M,this.G.version));const X=(await this.I([{manifest:U,extension:k,options:B}])).find(({identifier:se})=>(0,n.$ro)(se,{id:M}));if(X?.local)return X.local;throw X?.error?X.error:(0,a.$jp)(new Error(`Unknown error while installing extension ${M}`))}finally{await R()}}async installFromLocation(Y,B){this.F.trace("ExtensionManagementService#installFromLocation",Y.toString());const k=await this.bb.scanUserExtensionAtLocation(Y);if(!k)throw new Error(`Cannot find a valid extension from the location ${Y.toString()}`);return await this.ub([[k,void 0]],B),this.F.info("Successfully installed extension",k.identifier.id,B.toString()),k}async installExtensionsFromProfile(Y,B,k){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Y,B.toString(),k.toString());const R=(await this.bb.scanExtensions(1,B)).filter(U=>Y.some(M=>(0,n.$ro)(M,U.identifier)));if(R.length){const U=await Promise.all(R.map(M=>this.bb.scanMetadata(M,B)));await this.ub(R.map((M,J)=>[M,U[J]]),k),this.F.info("Successfully installed extensions",R.map(M=>M.identifier.id),k.toString())}return R}async updateMetadata(Y,B,k=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Y.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.pinned=B.pinned||void 0,Y=await this.bb.updateMetadata(Y,B,k),this.cb.invalidate(k),this.w.fire(Y),Y}async reinstallFromGallery(Y){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Y.identifier.id),!this.z.isEnabled())throw new Error(b.localize(1,null));const B=await this.getTargetPlatform(),[k]=await this.z.getExtensions([{...Y.identifier,preRelease:Y.preRelease}],{targetPlatform:B,compatible:!0},j.CancellationToken.None);if(!k)throw new Error(b.localize(2,null));await this.bb.setUninstalled(Y);try{await this.bb.removeUninstalledExtension(Y)}catch(R){throw new Error(b.localize(3,null,(0,A.$xi)(R)))}return this.installFromGallery(k)}ab(Y,B,k,R){return this.bb.copyExtension(Y,B,k,R)}copyExtensions(Y,B){return this.bb.copyExtensions(Y,B)}markAsUninstalled(...Y){return this.bb.setUninstalled(...Y)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Y){this.F.error(Y)}}async download(Y,B,k){const{location:R}=await this.db.download(Y,B,!k);return R}async lb(Y){if(Y.scheme===E.Schemas.file)return{location:Y,async cleanup(){}};this.F.trace("Downloading extension from",Y.toString());const B=(0,c.$tg)(this.db.extensionsDownloadDir,(0,h.$cg)());return await this.hb.download(Y,B),this.F.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.ib.del(B)}catch(R){this.F.error(R)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Y,B,k){if(w.URI.isUri(B))return new ee(Y,B,k,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const R=n.$so.create(B).toString();let U=this.eb.get(R);return U||(this.eb.set(R,U=new W(Y,B,k,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),U.waitUntilTaskIsFinished().finally(()=>this.eb.delete(R))),U}$(Y,B){return new ne(Y,B.profileLocation,this.gb)}async pb(Y){const B=async R=>{let U=await l.Promises.readdir(R);U=U.map(X=>$.$hc(R,X));const M=await Promise.all(U.map(X=>l.Promises.stat(X)));let J=Promise.resolve([]);return M.forEach((X,se)=>{const le=U[se];X.isFile()&&(J=J.then(ue=>[...ue,le])),X.isDirectory()&&(J=J.then(ue=>B(le).then(he=>[...ue,...he])))}),J};return(await B(Y.location.fsPath)).map(R=>({path:`extension/${$.$jc(Y.location.fsPath,R)}`,localPath:R}))}async qb({added:Y,removed:B}){if(B){const k=Y&&this.D.extUri.isEqual(B.profileLocation,Y.profileLocation)?B.extensions.filter(R=>Y.extensions.every(U=>!(0,n.$ro)(U,R))):B.extensions;for(const R of k)this.F.info("Extensions removed from another source",R.id,B.profileLocation.toString()),this.u.fire({identifier:R,profileLocation:B.profileLocation})}if(Y){const R=(await this.bb.scanExtensions(1,Y.profileLocation)).filter(U=>Y.extensions.some(M=>(0,n.$ro)(M,U.identifier)));this.s.fire(R.map(U=>(this.F.info("Extensions added from another source",U.identifier.id,Y.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:Y.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(B=>this.rb.add(B)));const Y=await this.ib.resolve(this.fb.userExtensionsLocation);for(const B of Y.children??[])B.isDirectory&&this.rb.add(B.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(B=>this.tb(B)))}async tb(Y){if(!Y.affects(this.fb.userExtensionsLocation,1))return;const B=[];for(const k of Y.rawAdded){if(this.rb.has(k)||!this.D.extUri.isEqual(this.D.extUri.dirname(k),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(k,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(k).startsWith(".")||!(await this.ib.stat(k)).isDirectory)continue;const R=await this.bb.scanUserExtensionAtLocation(k);R&&R.installedTimestamp===void 0&&(this.rb.add(k),B.push(R))}B.length&&(await this.ub(B.map(k=>[k,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",B.map(k=>k.identifier.id)))}async ub(Y,B){const k=Y.map(R=>R[0]);await this.vb(k),await this.gb.addExtensionsToProfile(Y,B),this.s.fire(k.map(R=>({local:R,identifier:R.identifier,operation:1,profileLocation:B})))}async vb(Y){const B=await this.bb.getUninstalledExtensions();for(const k of Y){const R=n.$so.create(k);B[R.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",R.id),await this.bb.setInstalled(R),this.F.info("Removed the extension from uninstalled list:",R.id))}}};e.$Bp=K,e.$Bp=K=ye([x(0,s.$2n),x(1,_.$$k),x(2,z.$7i),x(3,t.$Uh),x(4,r.$qp),x(5,i.$mp),x(6,S.$Fn),x(7,T.$Lh),x(8,F.$8j),x(9,q.$mj),x(10,Q.$Ek),x(11,Z.$Gk)],K);let H=class extends d.$Qc{constructor(Y,B,k,R,U,M){super(),this.j=Y,this.m=B,this.n=k,this.s=R,this.t=U,this.u=M,this.h=this.B(new D.$Ld),this.onExtract=this.h.event,this.c=(0,c.$tg)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$Yg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Y,B){const k={includeInvalid:!0,profileLocation:B};let R=[];return Y===null||Y===0?R.push(...await this.n.scanAllExtensions({includeInvalid:!0},k,!1)):Y===1&&R.push(...await this.n.scanUserExtensions(k)),R=Y!==null?R.filter(U=>U.type===Y):R,Promise.all(R.map(U=>this.F(U)))}async scanAllUserExtensions(Y){const B=await this.n.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(B.map(k=>this.F(k)))}async scanUserExtensionAtLocation(Y){try{const B=await this.n.scanExistingExtension(Y,1,{includeInvalid:!0});if(B)return await this.F(B)}catch(B){this.u.error(B)}return null}async extractUserExtension(Y,B,k,R,U){const M=Y.toString(),J=w.URI.file($.$hc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$cg)()}`)),X=w.URI.file($.$hc(this.n.userExtensionsLocation.fsPath,M));let se=await this.m.exists(X);if(se&&R){try{await this.y(Y.id,X,"removeExisting")}catch{throw new s.$3n(b.localize(4,null,X.fsPath,Y.id),s.ExtensionManagementErrorCode.Delete)}se=!1}if(!se)try{try{this.u.trace(`Started extracting the extension from ${B} to ${X.fsPath}`),await(0,u.$fp)(B,J.fsPath,{sourcePath:"extension",overwrite:!0},U),this.u.info(`Extracted extension to ${X}:`,Y.id)}catch(le){let ue=s.ExtensionManagementErrorCode.Extract;throw le instanceof u.$dp&&(le.type==="CorruptZip"?ue=s.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(ue=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$3n(le.message,ue)}await this.n.updateMetadata(J,k);try{this.u.trace(`Started renaming the extension from ${J.fsPath} to ${X.fsPath}`),await this.C(J.fsPath,X.fsPath),this.u.info("Renamed to",X.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.u.info(`Rename failed because of ${(0,I.$8)(le)}. Deleted from extracted location`,J),le}this.h.fire(X)}catch(le){try{await this.m.del(J,{recursive:!0})}catch{}throw le}return this.D(X,1)}async scanMetadata(Y,B){return B?(await this.w(Y,B))?.metadata:this.n.scanMetadata(Y.location)}async w(Y,B){return(await this.s.scanProfileExtensions(B)).find(R=>(0,n.$ro)(R.identifier,Y.identifier))}async updateMetadata(Y,B,k){return k?await this.s.updateMetadata([[Y,B]],k):await this.n.updateMetadata(Y.location,B),this.D(Y.location,Y.type,k)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Y){const B=Y.map(k=>n.$so.create(k));await this.z(k=>B.forEach(R=>{k[R.toString()]=!0,this.u.info("Marked extension as uninstalled",R.toString())}))}async setInstalled(Y){await this.z(B=>delete B[Y.toString()])}async removeExtension(Y,B){if(this.t.extUri.isEqualOrParent(Y.location,this.n.userExtensionsLocation))return this.y(Y.identifier.id,Y.location,B)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.z(B=>delete B[n.$so.create(Y).toString()])}async copyExtension(Y,B,k,R){const U=await this.w(Y,B),M=await this.w(Y,k);return R={...U?.metadata,...R},M?await this.s.updateMetadata([[Y,{...M.metadata,...R}]],k):await this.s.addExtensionsToProfile([[Y,R]],k),this.D(Y.location,Y.type,k)}async copyExtensions(Y,B){const k=await this.scanExtensions(1,Y),R=await Promise.all(k.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,Y)]));await this.s.addExtensionsToProfile(R,B)}async y(Y,B,k){this.u.trace(`Deleting ${k} extension from disk`,Y,B.fsPath);const R=this.t.extUri.joinPath(this.t.extUri.dirname(B),`${this.t.extUri.basename(B)}.${(0,C.$Ai)((0,h.$cg)()).toString(16)}${G}`);await this.C(B.fsPath,R.fsPath),await this.m.del(R,{recursive:!0}),this.u.info(`Deleted ${k} extension from disk`,Y,B.fsPath)}async z(Y){return this.g.queue(async()=>{let B;try{B=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(R){if((0,F.$lk)(R)!==1)throw R}let k={};if(B)try{k=JSON.parse(B)}catch{}return Y&&(Y(k),Object.keys(k).length?await this.m.writeFile(this.c,N.$_d.fromString(JSON.stringify(k))):await this.m.del(this.c)),k})}async C(Y,B){try{await l.Promises.rename(Y,B,2*60*1e3)}catch(k){throw new s.$3n(k.message||b.localize(5,null,Y,B),k.code||s.ExtensionManagementErrorCode.Rename)}}async D(Y,B,k){if(k){const U=(await this.n.scanUserExtensions({profileLocation:k})).find(M=>this.t.extUri.isEqual(M.location,Y));if(U)return this.F(U)}else{const R=await this.n.scanExistingExtension(Y,B,{includeInvalid:!0});if(R)return this.F(R)}throw new Error(b.localize(6,null,Y.path))}async F(Y){const B=await this.m.resolve(Y.location);let k,R;return B.children&&(k=B.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,R=B.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:k,changelogUrl:R,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated,pinned:!!Y.metadata?.pinned}}async G(){const Y=await this.getUninstalledExtensions();if(Object.keys(Y).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Y));const B=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const U of B)Y[n.$so.create(U).toString()]||k.add(U.identifier.id.toLowerCase());try{const U=(0,n.$xo)(B,M=>M.identifier);await O.Promises.settled(U.map(async M=>{const J=M.sort((X,se)=>g.rcompare(X.manifest.version,se.manifest.version))[0];k.has(J.identifier.id.toLowerCase())||await this.j(await this.F(J))}))}catch(U){this.u.error(U)}const R=B.filter(U=>U.metadata&&Y[n.$so.create(U).toString()]);await Promise.allSettled(R.map(U=>this.removeUninstalledExtension(U)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Y;try{Y=await this.m.resolve(this.n.userExtensionsLocation)}catch(B){(0,F.$lk)(B)!==1&&this.u.error(B);return}if(Y?.children)try{await Promise.allSettled(Y.children.map(async B=>{if(!(!B.isDirectory||!B.name.endsWith(G))){this.u.trace("Deleting the temporarily deleted folder",B.resource.toString());try{await this.m.del(B.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",B.resource.toString())}catch(k){(0,F.$lk)(k)!==1&&this.u.error(k)}}}))}catch{}}};e.$Cp=H,e.$Cp=H=ye([x(1,F.$8j),x(2,r.$qp),x(3,i.$mp),x(4,Q.$Ek),x(5,z.$7i)],H);class V extends a.$kp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Df)(this.options.operation)?this.l:this.options.operation}constructor(Y,B,k,R,U,M,J,X,se){super(),this.identifier=Y,this.source=B,this.options=k,this.m=R,this.n=U,this.o=M,this.p=J,this.q=X,this.s=se,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Y){const[B,k]=await this.x(Y);return this.j=B.isBuiltin||B.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[B,k]],this.j),B}async u({zipPath:Y,key:B,metadata:k},R,U){let M=await this.v(B);return M||(this.s.trace("Extracting extension...",B.id),M=await this.m.extractUserExtension(B,Y,k,R,U),this.s.info("Extracting extension completed.",B.id)),M}async v(Y){return await this.w(Y)?(this.s.trace("Removing the extension from uninstalled list:",Y.id),await this.m.setInstalled(Y),this.s.info("Removed the extension from uninstalled list:",Y.id),(await this.m.scanAllUserExtensions(!0)).find(R=>n.$so.create(R).equals(Y))):void 0}async w(Y){return!!(await this.m.getUninstalledExtensions())[Y.toString()]}}class W extends V{constructor(Y,B,k,R,U,M,J,X,se,le){super(B.identifier,B,k,U,M,J,X,se,le),this.y=B,this.z=R}async x(Y){const k=(await this.m.scanExtensions(null,this.options.profileLocation)).find(J=>(0,n.$ro)(J.identifier,this.y.identifier));k&&(this.l=3);const R={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$Cf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.y.version)return[await this.m.updateMetadata(k,R),R];const{location:U,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(U.fsPath),[await this.u({zipPath:U.fsPath,key:n.$so.create(this.y),metadata:R},!1,Y),R]}catch(J){try{await this.z.delete(U)}catch(X){this.s.warn("Error while deleting the downloaded file",U.toString(),(0,I.$8)(X))}throw J}}async B(Y){try{await(0,y.$xp)(Y)}catch(B){throw new s.$3n((0,a.$ip)(B).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$Dp=W;class ee extends V{constructor(Y,B,k,R,U,M,J,X,se,le){super({id:(0,n.$wo)(Y.publisher,Y.name)},B,k,U,M,J,X,se,le),this.y=Y,this.z=B,this.A=R}async h(Y){const B=await super.h(Y);return this.D(B,Y),B}async x(Y){const B=new n.$so(this.identifier,this.y.version),R=(await this.m.scanExtensions(1,this.options.profileLocation)).find(J=>(0,n.$ro)(this.identifier,J.identifier)),U={isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(R)if(this.l=3,B.equals(new n.$so(R.identifier,R.manifest.version)))try{await this.m.removeExtension(R,"existing")}catch{throw new Error(b.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(R.manifest.version,this.y.version)&&await this.m.setUninstalled(R);else{const J=await this.v(B);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(b.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:$.$ic(this.z.fsPath),key:B,metadata:U},!0,Y),U]}async D(Y,B){try{let[k]=await this.A.getExtensions([{id:Y.identifier.id,version:Y.manifest.version}],B);if(k||([k]=await this.A.getExtensions([{id:Y.identifier.id}],B)),k){const R={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Y,R,this.options.profileLocation)}}catch{}}}class ne extends a.$kp{constructor(Y,B,k){super(),this.extension=Y,this.j=B,this.k=k}async h(Y){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[265],ae([0,1,2,29,80,222,122,7,20]),function(te,e,O,N,j,A,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=void 0;let d=class extends O.$Qc{constructor(E,$,c,g,p,w){super(),E.cleanUp(),(0,A.$EVb)(E,$,c,g,w),j.$Qu.removeOutdatedExtensionVersions(E,p)}};e.$H8b=d,e.$H8b=d=ye([x(0,I.$Ap),x(1,N.$2n),x(2,j.$Pu),x(3,N.$7n),x(4,C.$Xo),x(5,D.$7i)],d)}),define(oe[123],ae([0,1,69,61,36,275,15,8,3,2,16,6,32,42,65]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;class p{traceSocketEvent(f,m){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,m)}constructor(f,m=""){this.f=!0,this.debugLabel=m,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,D.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const m=L=>{this.traceSocketEvent("read",L),f(I.$_d.wrap(L))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(f){const m=L=>{f({type:0,hadError:L,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(f){const m=()=>{f()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,D.$Y)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,D.$Y)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Bh=p;var w;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var h;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(h||(h={}));class l extends d.$Qc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,m){this.socket.traceSocketEvent(f,m)}constructor(f,m,L,F){super(),this.f=this.B(new C.$Ld),this.g=this.B(new C.$Ld),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:L?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new u(this,m,L,F,this.f,(T,z)=>this.m(T,z))),this.B(this.a.onError(T=>{console.error(T),(0,D.$Y)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new g.$wh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let m=0;for(;m<f.byteLength;)this.a.writeMessage(f.slice(m,Math.min(m+262144,f.byteLength)),{compressed:!0,opcode:2}),m+=262144}m(f,{compressed:m,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let F=2;f.byteLength<126?F+=0:f.byteLength<2**16?F+=2:F+=8;const T=I.$_d.alloc(F),z=m?64:0,q=L&15;if(T.writeUInt8(128|z|q,0),f.byteLength<126)T.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){T.writeUInt8(126,1);let _=1;T.writeUInt8(f.byteLength>>>8&255,++_),T.writeUInt8(f.byteLength>>>0&255,++_)}else{T.writeUInt8(127,1);let _=1;T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(f.byteLength>>>24&255,++_),T.writeUInt8(f.byteLength>>>16&255,++_),T.writeUInt8(f.byteLength>>>8&255,++_),T.writeUInt8(f.byteLength>>>0&255,++_)}this.socket.write(I.$_d.concat([T,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),L=m.readUInt8(0),F=(L&128)>>>7,T=(L&64)>>>6,z=L&15,q=m.readUInt8(1),_=(q&128)>>>7,Q=q&127;this.j.state=2,this.j.readLen=2+(_?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),L=m.readUInt8(1),F=(L&128)>>>7;let T=L&127,z=1;T===126?T=m.readUInt8(++z)*2**8+m.readUInt8(++z):T===127&&(T=m.readUInt8(++z)*0+m.readUInt8(++z)*0+m.readUInt8(++z)*0+m.readUInt8(++z)*0+m.readUInt8(++z)*2**24+m.readUInt8(++z)*2**16+m.readUInt8(++z)*2**8+m.readUInt8(++z));let q=0;F&&(q=m.readUInt8(++z)*2**24+m.readUInt8(++z)*2**16+m.readUInt8(++z)*2**8+m.readUInt8(++z)),this.j.state=3,this.j.readLen=T,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),t(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(m,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(m,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Ch=l;class u extends d.$Qc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$_d.alloc(0)}constructor(f,m,L,F,T,z){super(),this.n=f,this.r=T,this.s=z,this.a=this.B(new C.$Ld),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.$Ld),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new C.$Ld),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,m?(this.b=this.B(new b(this.n,F,L,{windowBits:15})),this.f=this.B(new S(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(f,m){this.g.push({data:f,options:m}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:m}=this.g.shift();if(this.f&&m.compressed){const L=await this.w(this.f,f);this.s(L,m)}else this.s(f,{...m,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,m){return new Promise((L,F)=>{f.write(m),f.flush(T=>L(T))})}acceptFrame(f,m,L){this.h.push({data:f,isCompressed:m,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const m=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(m)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,m,L){return new Promise((F,T)=>{f.write(m),L&&f.write(I.$_d.fromByteArray([0,0,255,255])),f.flush(z=>F(z))})}}class b extends d.$Qc{get recordedInflateBytes(){return this.j?I.$_d.concat(this.f):I.$_d.alloc(0)}constructor(f,m,L,F){super(),this.h=f,this.j=m,this.a=this.B(new C.$Ld),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(F),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(I.$_d.wrap(T))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=I.$_d.concat(this.g);this.g.length=0,f(m)})}}class S extends d.$Qc{constructor(f,m){super(),this.g=f,this.a=this.B(new C.$Ld),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(I.$_d.wrap(L))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=I.$_d.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),f(m)})}}function t(y,f){if(f===0)return;const m=y.byteLength>>>2;for(let _=0;_<m;_++){const Q=y.readUInt32BE(_*4);y.writeUInt32BE(Q^f,_*4)}const L=m*4,F=y.byteLength-L,T=f>>>24&255,z=f>>>16&255,q=f>>>8&255;F>=1&&y.writeUInt8(y.readUInt8(L)^T,L),F>=2&&y.writeUInt8(y.readUInt8(L+1)^z,L+1),F>=3&&y.writeUInt8(y.readUInt8(L+2)^q,L+2)}e.$Dh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function s(){const y=(0,$.$cg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const f=process.platform!=="darwin"&&e.$Dh?e.$Dh:(0,j.tmpdir)(),m=(0,P.$hc)(f,`vscode-ipc-${y}.sock`);return i(m),m}e.$Eh=s;function n(y,f,m){const L=(0,O.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${m}-${f}-sock`;const F=m.substr(0,4),T=f.substr(0,6),z=L.substr(0,8);let q;return process.platform!=="darwin"&&e.$Dh&&!process.env.VSCODE_PORTABLE?q=(0,P.$hc)(e.$Dh,`vscode-${z}-${F}-${T}.sock`):q=(0,P.$hc)(y,`${F}-${T}.sock`),i(q),q}e.$Fh=n;function i(y){const f=a[E.$t];typeof f=="number"&&y.length>=f&&console.warn(`WARNING: IPC handle "${y}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends c.$qh{static b(f){const m=C.Event.fromNodeEventEmitter(f,"connection");return C.Event.map(m,L=>({protocol:new g.$xh(new p(L,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(L,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Gh=r;function o(y){return new Promise((f,m)=>{const L=(0,N.createServer)();L.on("error",m),L.listen(y,()=>{L.removeListener("error",m),f(new r(L))})})}e.$Hh=o;function v(y,f){return new Promise((m,L)=>{const F=(0,N.createConnection)(y,()=>{F.removeListener("error",L),m(g.$yh.fromSocket(new p(F,`ipc-client${f}`),f))});F.once("error",L)})}e.$Ih=v}),define(oe[266],ae([0,1,61,123,210]),function(te,e,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=void 0,e.$Q8b=new class{supports(A){return!0}connect({host:A,port:I},D,C,d){return new Promise((P,E)=>{const $=O.createConnection({host:A,port:I},()=>{$.removeListener("error",E),$.write((0,j.$jkb)(D,C,d));const c=g=>{g.toString().indexOf(`\r
\r
`)>=0&&($.off("data",c),P(new N.$Bh($,d)))};$.on("data",c)});$.setNoDelay(!0),$.once("error",E)})}}}),define(oe[267],ae([0,1,61,36,134,123,5,2,6,19,7,24,213,104,106,76,15]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=e.$L7b=e.$K7b=e.$J7b=void 0;async function h(t,a,s,n,i){let r;for(let o=3;o&&(r?.dispose(),r=await new l(t,a,s,n,i).waitForReady(),!(i&&j.$fg[i]||!j.$fg[r.tunnelLocalPort]));o--);return r}class l extends D.$Qc{constructor(a,s,n,i,r){super(),this.m=s,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=O.createServer(),this.c=new I.$Qg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,s=(0,p.$9u)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,j.$gg)(a,2,1e3,s),i=null;return this.b.listen(n,this.m),await this.c.wait(),i=this.b.address(),i||(n=0,this.b.listen(n,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(a){a.pause();const s=(0,p.$7u)(this.tunnelRemoteHost)||(0,p.$9u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,$.$2k)(this.a,s,this.tunnelRemotePort),i=n.getSocket(),r=n.readEntireBuffer();n.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),i.end()}),a.on("close",()=>i.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),i instanceof A.$Bh?i.socket.destroy():i.end()}),i instanceof A.$Bh?this.t(a,i):this.s(a,i),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),i.end()})}s(a,s){s.onClose(()=>a.destroy()),s.onEnd(()=>a.end()),s.onData(n=>a.write(n.buffer)),a.on("data",n=>s.write(w.$_d.wrap(n))),a.resume()}t(a,s){const n=s.socket;n.on("end",()=>a.end()),n.on("close",()=>a.end()),n.on("error",()=>{a.destroy()}),n.pipe(a),a.pipe(n)}}e.$J7b=l;let u=class extends p.$_u{constructor(a,s,n,i,r){super(s,r),this.u=a,this.v=n,this.w=i}isPortPrivileged(a){return(0,p.$0u)(a,this.l,C.OS,N.release())}s(a,s,n,i,r,o,v,y){const f=this.r(s,n);if(f)return++f.refcount,f.value;if((0,p.$4u)(a))return this.t(a,s,n,r,o,v,y);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${r}.`);const m={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=h(m,i,s,n,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,n,L),L}}};e.$K7b=u,e.$K7b=u=ye([x(0,c.$Vk),x(1,P.$7i),x(2,g.$Yk),x(3,E.$mj),x(4,d.$gi)],u);let b=class extends u{constructor(a,s,n,i,r){super(a,s,n,i,r)}};e.$L7b=b,e.$L7b=b=ye([x(0,c.$Vk),x(1,P.$7i),x(2,g.$Yk),x(3,E.$mj),x(4,d.$gi)],b);let S=class extends D.$Qc{constructor(a,s,n,i,r){super(),this.b=a,this.c=s,this.f=n,this.g=i,this.h=r,this.a=new Map}async openTunnel(a,s,n,i,r,o,v,y,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${i} on local port ${o}.`),!this.a.has(a)){const m=new b(this.b,this.c,this.g,this.f,this.h);this.B(m),this.a.set(a,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(s,n,i,r,o,v,y,f)}};e.$M7b=S,e.$M7b=S=ye([x(0,c.$Vk),x(1,P.$7i),x(2,E.$mj),x(3,g.$Yk),x(4,d.$gi)],S)}),define(oe[276],ae([0,1,36,38,8,2,23,9,18,3,42,147,204,205,196,197,262,187,189,19,209,95,220,96,215,14,114,247,29,97,188,122,98,11,199,200,68,4,195,70,72,225,7,201,102,24,57,20,107,22,108,109,110,45,228,80,111,25,78,254,238,239,81,253,257,258,259,58,252,241,106,219,76,267,214,229,28,230,6,231,190,207,206,79,246,17,50,203,56,251,227,242,105,256,265,10,202,101,249,245,216,184,55,260,248,71,250,104,266,182,112,240,217]),function(te,e,O,N,j,A,I,D,C,d,P,E,$,c,g,p,w,h,l,u,b,S,t,a,s,n,i,r,o,v,y,f,m,L,F,T,z,q,_,Q,Z,G,K,H,V,W,ee,ne,re,Y,B,k,R,U,M,J,X,se,le,ue,he,$e,de,we,Ee,De,Ne,Te,ce,ge,be,ke,Pe,ze,Le,Ue,Me,ie,fe,me,pe,Se,Re,Ce,Oe,Ie,Ae,Fe,Be,qe,We,_e,ut,vt,Et,St,kt,ft,Ct,Pt,Rt,Dt,Ot,It,Lt,dt,jt,gt,At,Nt,$t,Ft,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Mt extends A.$Qc{constructor(ve){super(),this.f=ve,this.a=this.B(new E.$hT(this)),this.b=void 0,this.c=this.B(new d.$Ld),this.g()}g(){let ve=!1;const je=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,E.$iT)(process.parentPort,it.$16b.exit,je)}async init(){const ve=await this.h();(0,se.$jgb)(),ve.invokeFunction(je=>{const Qe=je.get(K.$7i),Ve=je.get(Y.$$k),Ke=je.get(Ie.$Gk);Qe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(Qe),this.n(Ve,Ke),this.B(Ke.onDidChangeProfiles(()=>this.n(Ve,Ke)))}),this.B((0,A.$Nc)(ve.createInstance($.$d8b,this.f.codeCachePath),ve.createInstance(c.$e8b),ve.createInstance(w.$h8b),ve.createInstance(p.$g8b),ve.createInstance(g.$f8b),ve.createInstance(Et.$H8b),ve.createInstance(_e.$z8b),ve.createInstance(Ft.$T8b,this.c.event)))}async h(){const ve=new Q.$Kh,je={_serviceBrand:void 0,...V.default};ve.set(W.$mj,je);const Qe=new P.$uh(He=>He==="main"),Ve=new dt.$T7b(this.a,Qe);ve.set(dt.$S7b,Ve);const Ke=this.f.policiesData?new Fe.$s7b(this.f.policiesData,Ve.getChannel("policy")):new Be.$bn;ve.set(Be.$_m,Ke);const Ge=new Nt.$bm(this.f.args,je);ve.set(n.$Uh,Ge);const xe=new H.$3q(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:D.URI.revive(He.resource)})),Ve.getChannel("logger"));ve.set(K.$8i,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ct=this.B(new K.$cj(st.getLevel())),Je=this.B(new kt.$tN(st,[ct]));ve.set(K.$7i,Je),this.b=this.B(new ft.$J8b(Je)),ve.set(ft.$I8b,this.b);const Xe=this.B(new F.$Fp(Je));ve.set(L.$8j,Xe);const lt=this.B(new T.$5p(Je));Xe.registerProvider(I.Schemas.file,lt);const rt=new ie.$rr(Xe);ve.set(Me.$Ek,rt);const Ye=this.B(new qe.$AN(this.f.profiles.all,D.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ve.set(Ie.$Gk,Ye);const ht=this.B(new me.$R7b(I.Schemas.file,this.B(new pe.$cN(Ve.getChannel(pe.$bN),{pathCaseSensitive:fe.$k})),I.Schemas.vscodeUserData,Ye,rt,Je));Xe.registerProvider(I.Schemas.vscodeUserData,ht);const Ze=this.B(new b.$Bn(Ye.defaultProfile.settingsResource,Xe,Ke,Je));ve.set(u.$gi,Ze);const et=new jt.$P8b(void 0,{defaultProfile:Ye.defaultProfile,currentProfile:Ye.defaultProfile},Ve,Ge);ve.set(ne.$Xo,et),this.B((0,A.$Oc)(()=>et.flush())),await Promise.all([Ze.initialize(),et.initialize()]);const bt=new Rt.$Oq(Ve.getChannel("request"));ve.set(ee.$Ko,bt),ve.set(h.$i8b,new z.$Jh(l.$j8b,void 0,!1)),ve.set(Re.$NE,new z.$Jh(Se.$y8b,void 0,!1));const wt=P.ProxyChannel.toService(Ve.getChannel("nativeHost"));ve.set(Ot.$D6b,wt),ve.set(a.$Fn,new z.$Jh(s.$IN,void 0,!0));const Tt=this.B(new ge.$p7b(wt)),zt=new P.$uh(He=>Tt.getActiveClientId().then(at=>He===at));ve.set(m.$oVb,new Dt.$L8b(this.a.getChannel("extensionRecommendationNotification",zt)));let ot;const tt=[],yt=(0,U.$oo)(je,Ze);if((0,U.$jo)(je,Ge)){const He=new k.$v4b(Je,xe,Ge,je);if(tt.push(He),!(0,U.$ko)(je,Ge)&&je.aiConfig?.ariaKey){const at=new We.$hN(bt,yt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,A.$Oc)(()=>at.flush())),tt.push(at)}ot=new R.$Sq({appenders:tt,commonProperties:(0,re.$_n)((0,O.release)(),(0,O.hostname)(),process.arch,je.commit,je.version,this.f.machineId,yt),sendErrorTelemetry:!0,piiPaths:(0,U.$po)(Ge)},Ze,je)}else{ot=U.$do;const He=U.$ho;tt.push(He)}this.a.registerChannel("telemetryAppender",new B.$66b(tt)),ve.set(Y.$$k,ot);const Ut=new M.$k8b(Ze,ot,Je,xe,Ge,je);ve.set(Y.$_k,Ut),ve.set(Ae.$mp,new z.$Jh(Pt.$sN,void 0,!0)),ve.set(Ce.$qp,new z.$Jh(Oe.$t7b,void 0,!0)),ve.set(v.$9o,new z.$Jh(v.$0o,void 0,!0)),ve.set(f.$Ap,new z.$Jh(f.$Bp,void 0,!0)),ve.set(o.$2n,new z.$Jh(r.$7o,void 0,!0)),ve.set(o.$8n,new z.$Jh(Lt.$O8b,void 0,!1)),ve.set(Z.$Kq,new z.$Jh(G.$Mq,void 0,!1)),ve.set(S.$im,new z.$Jh(t.$yr,void 0,!1)),ve.set(le.$hCb,new z.$Jh(le.$iCb,void 0,!0)),ve.set(se.$Egb,new z.$Jh($e.$vEb,void 0,!0)),ve.set(se.$Dgb,new he.$n8b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ve.set(o.$7n,new z.$Jh(i.$fCb,void 0,!1)),ve.set(X.$tEb,new z.$Jh(X.$uEb,void 0,!0)),ve.set(J.$Pu,new z.$Jh(J.$Qu)),ve.set(se.$ogb,new z.$Jh(Ne.$EDb,void 0,!0)),ve.set(se.$pgb,new z.$Jh(Ne.$GDb,void 0,!0)),ve.set(de.$cgb,new z.$Jh(de.$egb,void 0,!0)),ve.set(se.$qgb,new z.$Jh(ue.$04b,void 0,!1)),ve.set(se.$zgb,new z.$Jh(we.$Y4b,void 0,!0)),ve.set(se.$Agb,new z.$Jh(Ee.$c5b,void 0,!1)),ve.set(Te.$TCb,new z.$Jh(ce.$u8b,void 0,!0)),ve.set(se.$Bgb,new z.$Jh(vt.$O5b,void 0,!0)),ve.set(be.$Yk,new z.$Jh(ke.$O7b,void 0,!1));const pt=new gt.$Wk;return ve.set(gt.$Vk,pt),pt.register(0,At.$Q8b),ve.set(Pe.$3u,new z.$Jh(ze.$M7b)),ve.set(Le.$v8b,new z.$Jh(Ue.$x8b)),ve.set(ut.$A8b,new z.$Jh(Ct.$K8b)),ve.set($t.$R8b,new z.$Jh($t.$S8b)),new _.$8p(ve)}j(ve){const je=this.B(new A.$Pc),Qe=new y.$_o(ve.get(o.$4n),()=>null);this.a.registerChannel("extensions",Qe);const Ve=P.ProxyChannel.fromService(ve.get(Z.$Kq),je);this.a.registerChannel("languagePacks",Ve);const Ke=P.ProxyChannel.fromService(ve.get(S.$im),je);this.a.registerChannel("diagnostics",Ke);const Ge=new y.$bp(ve.get(o.$8n));this.a.registerChannel("extensionTipsService",Ge);const xe=P.ProxyChannel.fromService(ve.get(h.$i8b),je);this.a.registerChannel("checksum",xe);const st=P.ProxyChannel.fromService(ve.get(Re.$NE),je);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$o8b(ve.get(de.$cgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=P.ProxyChannel.fromService(ve.get(Y.$_k),je);this.a.registerChannel("customEndpointTelemetry",Je);const Xe=new he.$p8b(ve.get(le.$hCb));this.a.registerChannel("userDataSyncAccount",Xe);const lt=new he.$q8b(ve.get(se.$ogb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new De.$s8b(ve.get(se.$Agb),ve.get(Ie.$Gk),ve.get(K.$7i));this.a.registerChannel("userDataSync",rt);const Ye=this.B(ve.get(q.$Lh).createInstance(It.$N8b)),ht=new he.$l8b(Ye);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(ve.get(se.$Bgb),je));const Ze=P.ProxyChannel.fromService(ve.get(Le.$v8b),je);this.a.registerChannel(Le.$w8b,Ze);const et=P.ProxyChannel.fromService(ve.get(ut.$A8b),je);this.a.registerChannel("remoteTunnel",et)}m(ve){process.on("uncaughtException",je=>(0,j.$Y)(je)),process.on("unhandledRejection",je=>(0,j.$Y)(je)),(0,j.setUnexpectedErrorHandler)(je=>{const Qe=(0,N.$xi)(je,!0);Qe&&ve.error(`[uncaught exception in sharedProcess]: ${Qe}`)})}n(ve,je){ve.publicLog2("profilesInfo",{count:je.profiles.length})}handledClientConnection(ve){if(ve.data!==it.$36b.response)return!1;const je=(0,C.$Mb)(ve.ports);return je?(this.c.fire(je),!0):!1}}async function mt(nt){const ve=new Mt(nt);process.parentPort.postMessage(it.$16b.ipcReady),await ve.init(),process.parentPort.postMessage(it.$16b.initDone)}e.main=mt,process.parentPort.once("message",nt=>{mt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4a0e77678c0295b518151ae2d706436bab96ef4f/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
