/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],w=0,M=be.length;w<M;w++)e[w]=Ae[be[w]];return e};define(Ae[65],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=void 0;function w(A){return(h,E,g)=>{let P=null,k=null;if(typeof g.value=="function"?(P="value",k=g.value):typeof g.get=="function"&&(P="get",k=g.get),!k)throw new Error("not supported");g[P]=A(k,E)}}function M(A,h,E){let g=null,P=null;if(typeof E.value=="function"?(g="value",P=E.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(g="get",P=E.get),!P)throw new Error("not supported");const k=`$memoize$${h}`;E[g]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,a)}),this[k]}}e.$eh=M;function C(A,h,E){return w((g,P)=>{const k=`$debounce$${P}`,a=`$debounce$result$${P}`;return function(...b){this[a]||(this[a]=E?E():void 0),clearTimeout(this[k]),h&&(this[a]=h(this[a],...b),b=[this[a]]),this[k]=setTimeout(()=>{g.apply(this,b),this[a]=E?E():void 0},A)}})}e.$fh=C;function F(A,h,E){return w((g,P)=>{const k=`$throttle$timer$${P}`,a=`$throttle$result$${P}`,b=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...f){if(this[a]||(this[a]=E?E():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),h&&(this[a]=h(this[a],...f)),this[m])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),g.apply(this,[this[a]]),this[a]=E?E():void 0):(this[m]=!0,this[k]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),g.apply(this,[this[a]]),this[a]=E?E():void 0},t-Date.now()))}})}e.$gh=F}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$bM=w,e.$cM=new w("id#")}),define(Ae[115],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var F;(function(r){r.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function A(r,s=!1){let i=0;const o=r.length;let y="",$=0,S=16,I=0;function u(W){let O=0,N=0;for(;O<W;){const ee=r.charCodeAt(i);if(ee>=48&&ee<=57)N=N*16+ee-48;else if(ee>=65&&ee<=70)N=N*16+ee-65+10;else if(ee>=97&&ee<=102)N=N*16+ee-97+10;else break;i++,O++}return O<W&&(N=-1),N}function d(W){i=W,y="",$=0,S=16,I=0}function l(){const W=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&g(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&g(r.charCodeAt(i)))for(i++;i<r.length&&g(r.charCodeAt(i));)i++;else return I=3,r.substring(W,i);let O=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&g(r.charCodeAt(i))){for(i++;i<r.length&&g(r.charCodeAt(i));)i++;O=i}else I=3;return r.substring(W,O)}function R(){let W="",O=i;for(;;){if(i>=o){W+=r.substring(O,i),I=2;break}const N=r.charCodeAt(i);if(N===34){W+=r.substring(O,i),i++;break}if(N===92){if(W+=r.substring(O,i),i++,i>=o){I=2;break}switch(r.charCodeAt(i++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const X=u(4);X>=0?W+=String.fromCharCode(X):I=4;break}default:I=5}O=i;continue}if(N>=0&&N<=31)if(E(N)){W+=r.substring(O,i),I=2;break}else I=6;i++}return W}function B(){if(y="",I=0,$=i,i>=o)return $=o,S=17;let W=r.charCodeAt(i);if(h(W)){do i++,y+=String.fromCharCode(W),W=r.charCodeAt(i);while(h(W));return S=15}if(E(W))return i++,y+=String.fromCharCode(W),W===13&&r.charCodeAt(i)===10&&(i++,y+=`
`),S=14;switch(W){case 123:return i++,S=1;case 125:return i++,S=2;case 91:return i++,S=3;case 93:return i++,S=4;case 58:return i++,S=6;case 44:return i++,S=5;case 34:return i++,y=R(),S=10;case 47:{const O=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<o&&!E(r.charCodeAt(i));)i++;return y=r.substring(O,i),S=12}if(r.charCodeAt(i+1)===42){i+=2;const N=o-1;let ee=!1;for(;i<N;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,ee=!0;break}i++}return ee||(i++,I=1),y=r.substring(O,i),S=13}return y+=String.fromCharCode(W),i++,S=16}case 45:if(y+=String.fromCharCode(W),i++,i===o||!g(r.charCodeAt(i)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=l(),S=11;default:for(;i<o&&V(W);)i++,W=r.charCodeAt(i);if($!==i){switch(y=r.substring($,i),y){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return y+=String.fromCharCode(W),i++,S=16}}function V(W){if(h(W)||E(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let W;do W=B();while(W>=12&&W<=15);return W}return{setPosition:d,getPosition:()=>i,scan:s?j:B,getToken:()=>S,getTokenValue:()=>y,getTokenOffset:()=>$,getTokenLength:()=>i-$,getTokenError:()=>I}}e.$Lm=A;function h(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function E(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function k(r,s){const i=[],o=new Object;let y;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function I(u,d,l,R){$.value=u,$.offset=d,$.length=l,$.type=R,$.colonOffset=void 0,y=$}try{v(r,{onObjectBegin:(u,d)=>{if(s<=u)throw o;y=void 0,S=s>u,i.push("")},onObjectProperty:(u,d,l)=>{if(s<d||(I(u,d,l,"property"),i[i.length-1]=u,s<=d+l))throw o},onObjectEnd:(u,d)=>{if(s<=u)throw o;y=void 0,i.pop()},onArrayBegin:(u,d)=>{if(s<=u)throw o;y=void 0,i.push(0)},onArrayEnd:(u,d)=>{if(s<=u)throw o;y=void 0,i.pop()},onLiteralValue:(u,d,l)=>{if(s<d||(I(u,d,l,p(u)),s<=d+l))throw o},onSeparator:(u,d,l)=>{if(s<=d)throw o;if(u===":"&&y&&y.type==="property")y.colonOffset=d,S=!1,y=void 0;else if(u===","){const R=i[i.length-1];typeof R=="number"?i[i.length-1]=R+1:(S=!0,i[i.length-1]=""),y=void 0}}})}catch(u){if(u!==o)throw u}return{path:i,previousNode:y,isAtPropertyKey:S,matches:u=>{let d=0;for(let l=0;d<u.length&&l<i.length;l++)if(u[d]===i[l]||u[d]==="*")d++;else if(u[d]!=="**")return!1;return d===u.length}}}e.$Mm=k;function a(r,s=[],i=F.DEFAULT){let o=null,y=[];const $=[];function S(u){Array.isArray(y)?y.push(u):o!==null&&(y[o]=u)}return v(r,{onObjectBegin:()=>{const u={};S(u),$.push(y),y=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{y=$.pop()},onArrayBegin:()=>{const u=[];S(u),$.push(y),y=u,o=null},onArrayEnd:()=>{y=$.pop()},onLiteralValue:S,onError:(u,d,l)=>{s.push({error:u,offset:d,length:l})}},i),y[0]}e.$Nm=a;function b(r,s=[],i=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function $(u){return o.children.push(u),u}v(r,{onObjectBegin:u=>{o=$({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,d,l)=>{o=$({type:"property",offset:d,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:d,length:l,parent:o})},onObjectEnd:(u,d)=>{o.length=u+d-o.offset,o=o.parent,y(u+d)},onArrayBegin:(u,d)=>{o=$({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,d)=>{o.length=u+d-o.offset,o=o.parent,y(u+d)},onLiteralValue:(u,d,l)=>{$({type:p(u),offset:d,length:l,parent:o,value:u}),y(d+l)},onSeparator:(u,d,l)=>{o.type==="property"&&(u===":"?o.colonOffset=d:u===","&&y(d))},onError:(u,d,l)=>{s.push({error:u,offset:d,length:l})}},i);const I=o.children[0];return I&&delete I.parent,I}e.$Om=b;function m(r,s){if(!r)return;let i=r;for(const o of s)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let y=!1;for(const $ of i.children)if(Array.isArray($.children)&&$.children[0].value===o){i=$.children[1],y=!0;break}if(!y)return}else{const y=o;if(i.type!=="array"||y<0||!Array.isArray(i.children)||y>=i.children.length)return;i=i.children[y]}return i}e.$Pm=m;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;s.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&s.push(i)}return s}e.$Qm=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const i of r.children){const o=i.children[1];o&&(s[i.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Rm=t;function n(r,s,i=!1){return s>=r.offset&&s<r.offset+r.length||i&&s===r.offset+r.length}e.$Sm=n;function c(r,s,i=!1){if(n(r,s,i)){const o=r.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=s;y++){const $=c(o[y],s,i);if($)return $}return r}}e.$Tm=c;function v(r,s,i=F.DEFAULT){const o=A(r,!1);function y(Ee){return Ee?()=>Ee(o.getTokenOffset(),o.getTokenLength()):()=>!0}function $(Ee){return Ee?ce=>Ee(ce,o.getTokenOffset(),o.getTokenLength()):()=>!0}const S=y(s.onObjectBegin),I=$(s.onObjectProperty),u=y(s.onObjectEnd),d=y(s.onArrayBegin),l=y(s.onArrayEnd),R=$(s.onLiteralValue),B=$(s.onSeparator),V=y(s.onComment),j=$(s.onError),W=i&&i.disallowComments,O=i&&i.allowTrailingComma;function N(){for(;;){const Ee=o.scan();switch(o.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:W||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(Ee){case 12:case 13:W?ee(10):V();break;case 16:ee(1);break;case 15:case 14:break;default:return Ee}}}function ee(Ee,ce=[],$e=[]){if(j(Ee),ce.length+$e.length>0){let ie=o.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){N();break}else if($e.indexOf(ie)!==-1)break;ie=N()}}}function X(Ee){const ce=o.getTokenValue();return Ee?R(ce):I(ce),N(),!0}function ye(){switch(o.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(o.getTokenValue()),typeof Ee!="number"&&(ee(2),Ee=0)}catch{ee(2)}R(Ee);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return N(),!0}function De(){return o.getToken()!==10?(ee(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(B(":"),N(),le()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){S(),N();let Ee=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||ee(4,[],[]),B(","),N(),o.getToken()===2&&O)break}else Ee&&ee(6,[],[]);De()||ee(4,[],[2,5]),Ee=!0}return u(),o.getToken()!==2?ee(7,[2],[]):N(),!0}function Y(){d(),N();let Ee=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||ee(4,[],[]),B(","),N(),o.getToken()===4&&O)break}else Ee&&ee(6,[],[]);le()||ee(4,[],[4,5]),Ee=!0}return l(),o.getToken()!==4?ee(8,[4],[]):N(),!0}function le(){switch(o.getToken()){case 3:return Y();case 1:return Pe();case 10:return X(!0);default:return ye()}}return N(),o.getToken()===17?i.allowEmptyContent?!0:(ee(4,[],[]),!1):le()?(o.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Um=v;function D(r,s){const i=A(r),o=[];let y,$=0,S;do switch(S=i.getPosition(),y=i.scan(),y){case 12:case 13:case 17:$!==S&&o.push(r.substring($,S)),s!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,s)),$=i.getPosition();break}while(y!==17);return o.join("")}e.$Vm=D;function p(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$Wm=p}),function(be,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,me){for(var ke=0;ke<me.length;ke++){var re=me[ke];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ve,re.key,re)}}function w(ve,me,ke){return me&&e(ve.prototype,me),ke&&e(ve,ke),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function M(ve,me){if(ve){if(typeof ve=="string")return C(ve,me);var ke=Object.prototype.toString.call(ve).slice(8,-1);if(ke==="Object"&&ve.constructor&&(ke=ve.constructor.name),ke==="Map"||ke==="Set")return Array.from(ve);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return C(ve,me)}}function C(ve,me){(me==null||me>ve.length)&&(me=ve.length);for(var ke=0,re=new Array(me);ke<me;ke++)re[ke]=ve[ke];return re}function F(ve,me){var ke=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(ke)return(ke=ke.call(ve)).next.bind(ke);if(Array.isArray(ve)||(ke=M(ve))||me&&ve&&typeof ve.length=="number"){ke&&(ve=ke);var re=0;return function(){return re>=ve.length?{done:!0}:{done:!1,value:ve[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function h(ve){be.defaults=ve}var E=/[&<>"']/,g=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(me){return a[me]};function m(ve,me){if(me){if(E.test(ve))return ve.replace(g,b)}else if(P.test(ve))return ve.replace(k,b);return ve}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(f,function(me,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var n=/(^|[^\[])\^/g;function c(ve,me){ve=typeof ve=="string"?ve:ve.source,me=me||"";var ke={replace:function(he,se){return se=se.source||se,se=se.replace(n,"$1"),ve=ve.replace(he,se),ke},getRegex:function(){return new RegExp(ve,me)}};return ke}var v=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(ve,me,ke){if(ve){var re;try{re=decodeURIComponent(t(ke)).replace(v,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}me&&!D.test(ke)&&(ke=y(me,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var r={},s=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ve,me){r[" "+ve]||(s.test(ve)?r[" "+ve]=ve+"/":r[" "+ve]=u(ve,"/",!0)),ve=r[" "+ve];var ke=ve.indexOf(":")===-1;return me.substring(0,2)==="//"?ke?me:ve.replace(i,"$1")+me:me.charAt(0)==="/"?ke?me:ve.replace(o,"$1")+me:ve+me}var $={exec:function(){}};function S(ve){for(var me=1,ke,re;me<arguments.length;me++){ke=arguments[me];for(re in ke)Object.prototype.hasOwnProperty.call(ke,re)&&(ve[re]=ke[re])}return ve}function I(ve,me){var ke=ve.replace(/\|/g,function(se,oe,de){for(var Ie=!1,L=oe;--L>=0&&de[L]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=ke.split(/ \|/),he=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>me)re.splice(me);else for(;re.length<me;)re.push("");for(;he<re.length;he++)re[he]=re[he].trim().replace(/\\\|/g,"|");return re}function u(ve,me,ke){var re=ve.length;if(re===0)return"";for(var he=0;he<re;){var se=ve.charAt(re-he-1);if(se===me&&!ke)he++;else if(se!==me&&ke)he++;else break}return ve.slice(0,re-he)}function d(ve,me){if(ve.indexOf(me[1])===-1)return-1;for(var ke=ve.length,re=0,he=0;he<ke;he++)if(ve[he]==="\\")he++;else if(ve[he]===me[0])re++;else if(ve[he]===me[1]&&(re--,re<0))return he;return-1}function l(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ve,me){if(me<1)return"";for(var ke="";me>1;)me&1&&(ke+=ve),me>>=1,ve+=ve;return ke+ve}function B(ve,me,ke,re){var he=me.href,se=me.title?m(me.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){re.state.inLink=!0;var de={type:"link",raw:ke,href:he,title:se,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,de}return{type:"image",raw:ke,href:he,title:se,text:m(oe)}}function V(ve,me){var ke=ve.match(/^(\s+)(?:```)/);if(ke===null)return me;var re=ke[1];return me.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=re.length?he.slice(re.length):he}).join(`
`)}var j=function(){function ve(ke){this.options=ke||be.defaults}var me=ve.prototype;return me.space=function(re){var he=this.rules.block.newline.exec(re);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},me.code=function(re){var he=this.rules.block.code.exec(re);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:u(se,`
`)}}},me.fences=function(re){var he=this.rules.block.fences.exec(re);if(he){var se=he[0],oe=V(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},me.heading=function(re){var he=this.rules.block.heading.exec(re);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=u(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},me.hr=function(re){var he=this.rules.block.hr.exec(re);if(he)return{type:"hr",raw:he[0]}},me.blockquote=function(re){var he=this.rules.block.blockquote.exec(re);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},me.list=function(re){var he=this.rules.block.list.exec(re);if(he){var se,oe,de,Ie,L,K,G,Q,J,x,ae,Fe,je=he[1].trim(),Qe=je.length>1,He={type:"list",raw:"",ordered:Qe,start:Qe?+je.slice(0,-1):"",loose:!1,items:[]};je=Qe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Qe?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Fe=!1,!(!(he=_e.exec(re))||this.rules.block.hr.test(re)));){if(se=he[0],re=re.substring(se.length),Q=he[2].split(`
`,1)[0],J=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Q.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Q.slice(Ie),Ie+=he[1].length),K=!1,!Q&&/^ *$/.test(J)&&(se+=J+`
`,re=re.substring(J.length+1),Fe=!0),!Fe)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(x=re.split(`
`,1)[0],Q=x,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Ye.test(Q)||xe.test(re)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ae+=`
`+Q.slice(Ie);else if(!K)ae+=`
`+Q;else break;!K&&!Q.trim()&&(K=!0),se+=x+`
`,re=re.substring(x.length+1)}He.loose||(G?He.loose=!0:/\n *\n *$/.test(se)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(de=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:se,task:!!oe,checked:de,loose:!1,text:ae}),He.raw+=se}He.items[He.items.length-1].raw=se.trimRight(),He.items[He.items.length-1].text=ae.trimRight(),He.raw=He.raw.trimRight();var ze=He.items.length;for(L=0;L<ze;L++){this.lexer.state.top=!1,He.items[L].tokens=this.lexer.blockTokens(He.items[L].text,[]);var st=He.items[L].tokens.filter(function(Z){return Z.type==="space"}),_=st.every(function(Z){for(var pe=Z.raw.split(""),Be=0,Ne=F(pe),Ze;!(Ze=Ne()).done;){var rt=Ze.value;if(rt===`
`&&(Be+=1),Be>1)return!0}return!1});!He.loose&&st.length&&_&&(He.loose=!0,He.items[L].loose=!0)}return He}},me.html=function(re){var he=this.rules.block.html.exec(re);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},me.def=function(re){var he=this.rules.block.def.exec(re);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},me.table=function(re){var he=this.rules.block.table.exec(re);if(he){var se={type:"table",header:I(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,de,Ie,L,K;for(de=0;de<oe;de++)/^ *-+: *$/.test(se.align[de])?se.align[de]="right":/^ *:-+: *$/.test(se.align[de])?se.align[de]="center":/^ *:-+ *$/.test(se.align[de])?se.align[de]="left":se.align[de]=null;for(oe=se.rows.length,de=0;de<oe;de++)se.rows[de]=I(se.rows[de],se.header.length).map(function(G){return{text:G}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(K=se.rows[Ie],L=0;L<K.length;L++)K[L].tokens=this.lexer.inline(K[L].text);return se}}},me.lheading=function(re){var he=this.rules.block.lheading.exec(re);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},me.paragraph=function(re){var he=this.rules.block.paragraph.exec(re);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},me.text=function(re){var he=this.rules.block.text.exec(re);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},me.escape=function(re){var he=this.rules.inline.escape.exec(re);if(he)return{type:"escape",raw:he[0],text:m(he[1])}},me.tag=function(re){var he=this.rules.inline.tag.exec(re);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]):he[0]}},me.link=function(re){var he=this.rules.inline.link.exec(re);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=u(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var de=d(he[2],"()");if(de>-1){var Ie=he[0].indexOf("!")===0?5:4,L=Ie+he[1].length+de;he[2]=he[2].substring(0,de),he[0]=he[0].substring(0,L).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);Q&&(K=Q[1],G=Q[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(se)?K=K.slice(1):K=K.slice(1,-1)),B(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},me.reflink=function(re,he){var se;if((se=this.rules.inline.reflink.exec(re))||(se=this.rules.inline.nolink.exec(re))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var de=se[0].charAt(0);return{type:"text",raw:de,text:de}}return B(se,oe,se[0],this.lexer)}},me.emStrong=function(re,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=oe[1]||oe[2]||"";if(!de||de&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,L,K,G=Ie,Q=0,J=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,he=he.slice(-1*re.length+Ie);(oe=J.exec(he))!=null;)if(L=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!L){if(K=L.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){Q+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+Q),Math.min(Ie,K)%2){var x=re.slice(1,Ie+oe.index+K);return{type:"em",raw:re.slice(0,Ie+oe.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ae=re.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:re.slice(0,Ie+oe.index+K+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},me.codespan=function(re){var he=this.rules.inline.code.exec(re);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),de=/^ /.test(se)&&/ $/.test(se);return oe&&de&&(se=se.substring(1,se.length-1)),se=m(se,!0),{type:"codespan",raw:he[0],text:se}}},me.br=function(re){var he=this.rules.inline.br.exec(re);if(he)return{type:"br",raw:he[0]}},me.del=function(re){var he=this.rules.inline.del.exec(re);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},me.autolink=function(re,he){var se=this.rules.inline.autolink.exec(re);if(se){var oe,de;return se[2]==="@"?(oe=m(this.options.mangle?he(se[1]):se[1]),de="mailto:"+oe):(oe=m(se[1]),de=oe),{type:"link",raw:se[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},me.url=function(re,he){var se;if(se=this.rules.inline.url.exec(re)){var oe,de;if(se[2]==="@")oe=m(this.options.mangle?he(se[0]):se[0]),de="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=m(se[0]),se[1]==="www."?de="http://"+oe:de=oe}return{type:"link",raw:se[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},me.inlineText=function(re,he){var se=this.rules.inline.text.exec(re);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):m(se[0]):se[0]:oe=m(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ve}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=c(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=c(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=c(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=c(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=c(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=S({},W),W.gfm=S({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=c(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=S({},W.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:c(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=c(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=c(W._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=c(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=c(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=c(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=c(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=c(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=c(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=c(O.reflink).replace("label",O._label).replace("ref",W._label).getRegex(),O.nolink=c(O.nolink).replace("ref",W._label).getRegex(),O.reflinkSearch=c(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=S({},O),O.pedantic=S({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=S({},O.normal,{escape:c(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=c(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=S({},O.gfm,{br:c(O.br).replace("{2,}","*").getRegex(),text:c(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(ve){var me="",ke,re,he=ve.length;for(ke=0;ke<he;ke++)re=ve.charCodeAt(ke),Math.random()>.5&&(re="x"+re.toString(16)),me+="&#"+re+";";return me}var X=function(){function ve(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||be.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:W.normal,inline:O.normal};this.options.pedantic?(re.block=W.pedantic,re.inline=O.pedantic):this.options.gfm&&(re.block=W.gfm,this.options.breaks?re.inline=O.breaks:re.inline=O.gfm),this.tokenizer.rules=re}ve.lex=function(re,he){var se=new ve(he);return se.lex(re)},ve.lexInline=function(re,he){var se=new ve(he);return se.inlineTokens(re)};var me=ve.prototype;return me.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},me.blockTokens=function(re,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,Q,J){return Q+"    ".repeat(J.length)});for(var oe,de,Ie,L;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=re.slice(1),J=void 0;se.options.extensions.startBlock.forEach(function(x){J=x.call({lexer:this},Q),typeof J=="number"&&J>=0&&(G=Math.min(G,J))}),G<1/0&&G>=0&&(Ie=re.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){de=he[he.length-1],L&&de.type==="paragraph"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe),L=Ie.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&de.type==="text"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe);continue}if(re){var K="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},me.inline=function(re,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:re,tokens:he}),he},me.inlineTokens=function(re,he){var se=this;he===void 0&&(he=[]);var oe,de,Ie,L=re,K,G,Q;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)J.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,K.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(re,L,Q)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(re,ee)){re=re.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,ee))){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Fe=re.slice(1),je=void 0;se.options.extensions.startInline.forEach(function(Qe){je=Qe.call({lexer:this},Fe),typeof je=="number"&&je>=0&&(ae=Math.min(ae,je))}),ae<1/0&&ae>=0&&(Ie=re.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,N)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),G=!0,de=he[he.length-1],de&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(re){var x="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},w(ve,null,[{key:"rules",get:function(){return{block:W,inline:O}}}]),ve}(),ye=function(){function ve(ke){this.options=ke||be.defaults}var me=ve.prototype;return me.code=function(re,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(re,oe);de!=null&&de!==re&&(se=!0,re=de)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+m(oe,!0)+'">'+(se?re:m(re,!0))+`</code></pre>
`:"<pre><code>"+(se?re:m(re,!0))+`</code></pre>
`},me.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},me.html=function(re){return re},me.heading=function(re,he,se,oe){if(this.options.headerIds){var de=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+de+'">'+re+"</h"+he+`>
`}return"<h"+he+">"+re+"</h"+he+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(re,he,se){var oe=he?"ol":"ul",de=he&&se!==1?' start="'+se+'"':"";return"<"+oe+de+`>
`+re+"</"+oe+`>
`},me.listitem=function(re){return"<li>"+re+`</li>
`},me.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(re){return"<p>"+re+`</p>
`},me.table=function(re,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+he+`</table>
`},me.tablerow=function(re){return`<tr>
`+re+`</tr>
`},me.tablecell=function(re,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+re+("</"+se+`>
`)},me.strong=function(re){return"<strong>"+re+"</strong>"},me.em=function(re){return"<em>"+re+"</em>"},me.codespan=function(re){return"<code>"+re+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(re){return"<del>"+re+"</del>"},me.link=function(re,he,se){if(re=p(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<a href="'+m(re)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},me.image=function(re,he,se){if(re=p(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<img src="'+re+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},me.text=function(re){return re},ve}(),De=function(){function ve(){}var me=ve.prototype;return me.strong=function(re){return re},me.em=function(re){return re},me.codespan=function(re){return re},me.del=function(re){return re},me.html=function(re){return re},me.text=function(re){return re},me.link=function(re,he,se){return""+se},me.image=function(re,he,se){return""+se},me.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var me=ve.prototype;return me.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(re,he){var se=re,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[re];do oe++,se=re+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[re]=oe,this.seen[se]=0),se},me.slug=function(re,he){he===void 0&&(he={});var se=this.serialize(re);return this.getNextSafeSlug(se,he.dryrun)},ve}(),Y=function(){function ve(ke){this.options=ke||be.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Pe}ve.parse=function(re,he){var se=new ve(he);return se.parse(re)},ve.parseInline=function(re,he){var se=new ve(he);return se.parseInline(re)};var me=ve.prototype;return me.parse=function(re,he){he===void 0&&(he=!0);var se="",oe,de,Ie,L,K,G,Q,J,x,ae,Fe,je,Qe,He,_e,Ye,xe,it,tt,ze=re.length;for(oe=0;oe<ze;oe++){if(ae=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){se+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(J="",Q="",L=ae.header.length,de=0;de<L;de++)Q+=this.renderer.tablecell(this.parseInline(ae.header[de].tokens),{header:!0,align:ae.align[de]});for(J+=this.renderer.tablerow(Q),x="",L=ae.rows.length,de=0;de<L;de++){for(G=ae.rows[de],Q="",K=G.length,Ie=0;Ie<K;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ae.align[Ie]});x+=this.renderer.tablerow(Q)}se+=this.renderer.table(J,x);continue}case"blockquote":{x=this.parse(ae.tokens),se+=this.renderer.blockquote(x);continue}case"list":{for(Fe=ae.ordered,je=ae.start,Qe=ae.loose,L=ae.items.length,x="",de=0;de<L;de++)_e=ae.items[de],Ye=_e.checked,xe=_e.task,He="",_e.task&&(it=this.renderer.checkbox(Ye),Qe?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(_e.tokens,Qe),x+=this.renderer.listitem(He,xe,Ye);se+=this.renderer.list(x,Fe,je);continue}case"html":{se+=this.renderer.html(ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(x=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<ze&&re[oe+1].type==="text";)ae=re[++oe],x+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);se+=he?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},me.parseInline=function(re,he){he=he||this.renderer;var se="",oe,de,Ie,L=re.length;for(oe=0;oe<L;oe++){if(de=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(Ie=this.options.extensions.renderers[de.type].call({parser:this},de),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){se+=Ie||"";continue}switch(de.type){case"escape":{se+=he.text(de.text);break}case"html":{se+=he.html(de.text);break}case"link":{se+=he.link(de.href,de.title,this.parseInline(de.tokens,he));break}case"image":{se+=he.image(de.href,de.title,de.text);break}case"strong":{se+=he.strong(this.parseInline(de.tokens,he));break}case"em":{se+=he.em(this.parseInline(de.tokens,he));break}case"codespan":{se+=he.codespan(de.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(de.tokens,he));break}case"text":{se+=he.text(de.text);break}default:{var K='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return se},ve}();function le(ve,me,ke){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof me=="function"&&(ke=me,me=null),me=S({},le.defaults,me||{}),l(me),ke){var re=me.highlight,he;try{he=X.lex(ve,me)}catch(L){return ke(L)}var se=function(K){var G;if(!K)try{me.walkTokens&&le.walkTokens(he,me.walkTokens),G=Y.parse(he,me)}catch(Q){K=Q}return me.highlight=re,K?ke(K):ke(null,G)};if(!re||re.length<3||(delete me.highlight,!he.length))return se();var oe=0;le.walkTokens(he,function(L){L.type==="code"&&(oe++,setTimeout(function(){re(L.text,L.lang,function(K,G){if(K)return se(K);G!=null&&G!==L.text&&(L.text=G,L.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function de(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+m(L.message+"",!0)+"</pre>";throw L}try{var Ie=X.lex(ve,me);if(me.walkTokens){if(me.async)return Promise.all(le.walkTokens(Ie,me.walkTokens)).then(function(){return Y.parse(Ie,me)}).catch(de);le.walkTokens(Ie,me.walkTokens)}return Y.parse(Ie,me)}catch(L){de(L)}}le.options=le.setOptions=function(ve){return S(le.defaults,ve),h(le.defaults),le},le.getDefaults=A,le.defaults=be.defaults,le.use=function(){for(var ve=arguments.length,me=new Array(ve),ke=0;ke<ve;ke++)me[ke]=arguments[ke];var re=S.apply(void 0,[{}].concat(me)),he=le.defaults.extensions||{renderers:{},childTokens:{}},se;me.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var L=he.renderers?he.renderers[Ie.name]:null;L?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),Q=0;Q<K;Q++)G[Q]=arguments[Q];var J=Ie.renderer.apply(this,G);return J===!1&&(J=L.apply(this,G)),J}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=le.defaults.renderer||new ye,L=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Fe=0;Fe<x;Fe++)ae[Fe]=arguments[Fe];var je=oe.renderer[Q].apply(Ie,ae);return je===!1&&(je=J.apply(Ie,ae)),je}};for(var K in oe.renderer)L(K);re.renderer=Ie}(),oe.tokenizer&&function(){var Ie=le.defaults.tokenizer||new j,L=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Fe=0;Fe<x;Fe++)ae[Fe]=arguments[Fe];var je=oe.tokenizer[Q].apply(Ie,ae);return je===!1&&(je=J.apply(Ie,ae)),je}};for(var K in oe.tokenizer)L(K);re.tokenizer=Ie}(),oe.walkTokens){var de=le.defaults.walkTokens;re.walkTokens=function(Ie){var L=[];return L.push(oe.walkTokens.call(this,Ie)),de&&(L=L.concat(de.call(this,Ie))),L}}se&&(re.extensions=he),le.setOptions(re)})},le.walkTokens=function(ve,me){for(var ke=[],re=function(){var de=se.value;switch(ke=ke.concat(me.call(le,de)),de.type){case"table":{for(var Ie=F(de.header),L;!(L=Ie()).done;){var K=L.value;ke=ke.concat(le.walkTokens(K.tokens,me))}for(var G=F(de.rows),Q;!(Q=G()).done;)for(var J=Q.value,x=F(J),ae;!(ae=x()).done;){var Fe=ae.value;ke=ke.concat(le.walkTokens(Fe.tokens,me))}break}case"list":{ke=ke.concat(le.walkTokens(de.items,me));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[de.type]?le.defaults.extensions.childTokens[de.type].forEach(function(je){ke=ke.concat(le.walkTokens(de[je],me))}):de.tokens&&(ke=ke.concat(le.walkTokens(de.tokens,me)))}},he=F(ve),se;!(se=he()).done;)re();return ke},le.parseInline=function(ve,me){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");me=S({},le.defaults,me||{}),l(me);try{var ke=X.lexInline(ve,me);return me.walkTokens&&le.walkTokens(ke,me.walkTokens),Y.parseInline(ke,me)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+m(re.message+"",!0)+"</pre>";throw re}},le.Parser=Y,le.parser=Y.parse,le.Renderer=ye,le.TextRenderer=De,le.Lexer=X,le.lexer=X.lex,le.Tokenizer=j,le.Slugger=Pe,le.parse=le;var Ee=le.options,ce=le.setOptions,$e=le.use,ie=le.walkTokens,z=le.parseInline,q=le,ue=Y.parse,we=X.lex;be.Lexer=X,be.Parser=Y,be.Renderer=ye,be.Slugger=Pe,be.TextRenderer=De,be.Tokenizer=j,be.getDefaults=A,be.lexer=we,be.marked=le,be.options=Ee,be.parse=q,be.parseInline=z,be.parser=ue,be.setOptions=ce,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.rot=e.$Jl=void 0;function w(h,E,g){return Math.min(Math.max(h,E),g)}e.$Jl=w;function M(h,E){return(E+h%E)%E}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Ll=C;class F{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ml=F;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const g=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nl=A}),function(){function be(C){const F=[];typeof C=="number"&&F.push("code/timeOrigin",C);function A(E){F.push(E,Date.now())}function h(){const E=[];for(let g=0;g<F.length;g+=2)E.push({name:F[g],startTime:F[g+1]});return E}return{mark:A,getMarks:h}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))F.push({name:A.name,startTime:Math.round(C+A.startTime)});return F}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=w(M))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var M in w)(typeof exports=="object"?exports:be)[M]=w[M]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return be[M].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=be,w.c=e,w.d=function(M,C,F){w.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:F})},w.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},w.t=function(M,C){if(1&C&&(M=w(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var F=Object.create(null);if(w.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)w.d(F,A,function(h){return M[h]}.bind(null,A));return F},w.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return w.d(C,"a",C),C},w.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},w.p="",w(w.s=0)}([function(be,e,w){(function(M){var C;e=be.exports=$e,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,h=e.re=[],E=e.src=[],g=0,P=g++;E[P]="0|[1-9]\\d*";var k=g++;E[k]="[0-9]+";var a=g++;E[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;E[b]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var m=g++;E[m]="("+E[k]+")\\.("+E[k]+")\\.("+E[k]+")";var f=g++;E[f]="(?:"+E[P]+"|"+E[a]+")";var t=g++;E[t]="(?:"+E[k]+"|"+E[a]+")";var n=g++;E[n]="(?:-("+E[f]+"(?:\\."+E[f]+")*))";var c=g++;E[c]="(?:-?("+E[t]+"(?:\\."+E[t]+")*))";var v=g++;E[v]="[0-9A-Za-z-]+";var D=g++;E[D]="(?:\\+("+E[v]+"(?:\\."+E[v]+")*))";var p=g++,r="v?"+E[b]+E[n]+"?"+E[D]+"?";E[p]="^"+r+"$";var s="[v=\\s]*"+E[m]+E[c]+"?"+E[D]+"?",i=g++;E[i]="^"+s+"$";var o=g++;E[o]="((?:<|>)?=?)";var y=g++;E[y]=E[k]+"|x|X|\\*";var $=g++;E[$]=E[P]+"|x|X|\\*";var S=g++;E[S]="[v=\\s]*("+E[$]+")(?:\\.("+E[$]+")(?:\\.("+E[$]+")(?:"+E[n]+")?"+E[D]+"?)?)?";var I=g++;E[I]="[v=\\s]*("+E[y]+")(?:\\.("+E[y]+")(?:\\.("+E[y]+")(?:"+E[c]+")?"+E[D]+"?)?)?";var u=g++;E[u]="^"+E[o]+"\\s*"+E[S]+"$";var d=g++;E[d]="^"+E[o]+"\\s*"+E[I]+"$";var l=g++;E[l]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=g++;E[R]="(?:~>?)";var B=g++;E[B]="(\\s*)"+E[R]+"\\s+",h[B]=new RegExp(E[B],"g");var V=g++;E[V]="^"+E[R]+E[S]+"$";var j=g++;E[j]="^"+E[R]+E[I]+"$";var W=g++;E[W]="(?:\\^)";var O=g++;E[O]="(\\s*)"+E[W]+"\\s+",h[O]=new RegExp(E[O],"g");var N=g++;E[N]="^"+E[W]+E[S]+"$";var ee=g++;E[ee]="^"+E[W]+E[I]+"$";var X=g++;E[X]="^"+E[o]+"\\s*("+s+")$|^$";var ye=g++;E[ye]="^"+E[o]+"\\s*("+r+")$|^$";var De=g++;E[De]="(\\s*)"+E[o]+"\\s*("+s+"|"+E[S]+")",h[De]=new RegExp(E[De],"g");var Pe=g++;E[Pe]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var Y=g++;E[Y]="^\\s*("+E[I]+")\\s+-\\s+("+E[I]+")\\s*$";var le=g++;E[le]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)C(Ee,E[Ee]),h[Ee]||(h[Ee]=new RegExp(E[Ee]));function ce(J,x){if(J instanceof $e)return J;if(typeof J!="string"||J.length>F||!(x?h[i]:h[p]).test(J))return null;try{return new $e(J,x)}catch{return null}}function $e(J,x){if(J instanceof $e){if(J.loose===x)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof $e))return new $e(J,x);C("SemVer",J,x),this.loose=x;var ae=J.trim().match(x?h[i]:h[p]);if(!ae)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var je=+Fe;if(je>=0&&je<A)return je}return Fe}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(J,x){var ae=ce(J,x);return ae?ae.version:null},e.clean=function(J,x){var ae=ce(J.trim().replace(/^[=v]+/,""),x);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(J){return C("SemVer.compare",this.version,this.loose,J),J instanceof $e||(J=new $e(J,this.loose)),this.compareMain(J)||this.comparePre(J)},$e.prototype.compareMain=function(J){return J instanceof $e||(J=new $e(J,this.loose)),z(this.major,J.major)||z(this.minor,J.minor)||z(this.patch,J.patch)},$e.prototype.comparePre=function(J){if(J instanceof $e||(J=new $e(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var x=0;do{var ae=this.prerelease[x],Fe=J.prerelease[x];if(C("prerelease compare",x,ae,Fe),ae===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ae===void 0)return-1;if(ae!==Fe)return z(ae,Fe)}while(++x)},$e.prototype.inc=function(J,x){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,x,ae,Fe){typeof ae=="string"&&(Fe=ae,ae=void 0);try{return new $e(J,ae).inc(x,Fe).version}catch{return null}},e.diff=function(J,x){if(ve(J,x))return null;var ae=ce(J),Fe=ce(x);if(ae.prerelease.length||Fe.prerelease.length){for(var je in ae)if((je==="major"||je==="minor"||je==="patch")&&ae[je]!==Fe[je])return"pre"+je;return"prerelease"}for(var je in ae)if((je==="major"||je==="minor"||je==="patch")&&ae[je]!==Fe[je])return je},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(J,x){var ae=ie.test(J),Fe=ie.test(x);return ae&&Fe&&(J=+J,x=+x),ae&&!Fe?-1:Fe&&!ae?1:J<x?-1:J>x?1:0}function q(J,x,ae){return new $e(J,ae).compare(new $e(x,ae))}function ue(J,x,ae){return q(J,x,ae)>0}function we(J,x,ae){return q(J,x,ae)<0}function ve(J,x,ae){return q(J,x,ae)===0}function me(J,x,ae){return q(J,x,ae)!==0}function ke(J,x,ae){return q(J,x,ae)>=0}function re(J,x,ae){return q(J,x,ae)<=0}function he(J,x,ae,Fe){var je;switch(x){case"===":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),je=J===ae;break;case"!==":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),je=J!==ae;break;case"":case"=":case"==":je=ve(J,ae,Fe);break;case"!=":je=me(J,ae,Fe);break;case">":je=ue(J,ae,Fe);break;case">=":je=ke(J,ae,Fe);break;case"<":je=we(J,ae,Fe);break;case"<=":je=re(J,ae,Fe);break;default:throw new TypeError("Invalid operator: "+x)}return je}function se(J,x){if(J instanceof se){if(J.loose===x)return J;J=J.value}if(!(this instanceof se))return new se(J,x);C("comparator",J,x),this.loose=x,this.parse(J),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(J,x){return z(x,J)},e.major=function(J,x){return new $e(J,x).major},e.minor=function(J,x){return new $e(J,x).minor},e.patch=function(J,x){return new $e(J,x).patch},e.compare=q,e.compareLoose=function(J,x){return q(J,x,!0)},e.rcompare=function(J,x,ae){return q(x,J,ae)},e.sort=function(J,x){return J.sort(function(ae,Fe){return e.compare(ae,Fe,x)})},e.rsort=function(J,x){return J.sort(function(ae,Fe){return e.rcompare(ae,Fe,x)})},e.gt=ue,e.lt=we,e.eq=ve,e.neq=me,e.gte=ke,e.lte=re,e.cmp=he,e.Comparator=se;var oe={};function de(J,x){if(J instanceof de)return J.loose===x?J:new de(J.raw,x);if(J instanceof se)return new de(J.value,x);if(!(this instanceof de))return new de(J,x);if(this.loose=x,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function L(J,x,ae,Fe,je,Qe,He,_e,Ye,xe,it,tt,ze){return((x=Ie(ae)?"":Ie(Fe)?">="+ae+".0.0":Ie(je)?">="+ae+"."+Fe+".0":">="+x)+" "+(_e=Ie(Ye)?"":Ie(xe)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+xe+1)+".0":tt?"<="+Ye+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function K(J,x){for(var ae=0;ae<J.length;ae++)if(!J[ae].test(x))return!1;if(x.prerelease.length){for(ae=0;ae<J.length;ae++)if(C(J[ae].semver),J[ae].semver!==oe&&J[ae].semver.prerelease.length>0){var Fe=J[ae].semver;if(Fe.major===x.major&&Fe.minor===x.minor&&Fe.patch===x.patch)return!0}return!1}return!0}function G(J,x,ae){try{x=new de(x,ae)}catch{return!1}return x.test(J)}function Q(J,x,ae,Fe){var je,Qe,He,_e,Ye;switch(J=new $e(J,Fe),x=new de(x,Fe),ae){case">":je=ue,Qe=re,He=we,_e=">",Ye=">=";break;case"<":je=we,Qe=ke,He=ue,_e="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(J,x,Fe))return!1;for(var xe=0;xe<x.set.length;++xe){var it=x.set[xe],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,ze=ze||st,je(st.semver,tt.semver,Fe)?tt=st:He(st.semver,ze.semver,Fe)&&(ze=st)}),tt.operator===_e||tt.operator===Ye||(!ze.operator||ze.operator===_e)&&Qe(J,ze.semver)||ze.operator===Ye&&He(J,ze.semver))return!1}return!0}se.prototype.parse=function(J){var x=this.loose?h[X]:h[ye],ae=J.match(x);if(!ae)throw new TypeError("Invalid comparator: "+J);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(J){return C("Comparator.test",J,this.loose),this.semver===oe||(typeof J=="string"&&(J=new $e(J,this.loose)),he(J,this.operator,this.semver,this.loose))},se.prototype.intersects=function(J,x){if(!(J instanceof se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new de(J.value,x),G(this.value,ae,x);if(J.operator==="")return ae=new de(this.value,x),G(J.semver,ae,x);var Fe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Qe=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),_e=he(this.semver,"<",J.semver,x)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ye=he(this.semver,">",J.semver,x)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Fe||je||Qe&&He||_e||Ye},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(J){var x=this.loose;J=J.trim(),C("range",J,x);var ae=x?h[Y]:h[Pe];J=J.replace(ae,L),C("hyphen replace",J),J=J.replace(h[De],"$1$2$3"),C("comparator trim",J,h[De]),J=(J=(J=J.replace(h[B],"$1~")).replace(h[O],"$1^")).split(/\s+/).join(" ");var Fe=x?h[X]:h[ye],je=J.split(" ").map(function(Qe){return function(He,_e){return C("comp",He),He=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?h[ee]:h[N];return tt.replace(st,function(_,Z,pe,Be,Ne){var Ze;return C("caret",tt,_,Z,pe,Be,Ne),Ie(Z)?Ze="":Ie(pe)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(Be)?Ze=Z==="0"?">="+Z+"."+pe+".0 <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+".0 <"+(+Z+1)+".0.0":Ne?(C("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=Z==="0"?pe==="0"?">="+Z+"."+pe+"."+Be+Ne+" <"+Z+"."+pe+"."+(+Be+1):">="+Z+"."+pe+"."+Be+Ne+" <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+"."+Be+Ne+" <"+(+Z+1)+".0.0"):(C("no pr"),Ze=Z==="0"?pe==="0"?">="+Z+"."+pe+"."+Be+" <"+Z+"."+pe+"."+(+Be+1):">="+Z+"."+pe+"."+Be+" <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+"."+Be+" <"+(+Z+1)+".0.0"),C("caret return",Ze),Ze})}(it,xe)}).join(" ")}(He,_e),C("caret",He),He=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?h[j]:h[V];return tt.replace(st,function(_,Z,pe,Be,Ne){var Ze;return C("tilde",tt,_,Z,pe,Be,Ne),Ie(Z)?Ze="":Ie(pe)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(Be)?Ze=">="+Z+"."+pe+".0 <"+Z+"."+(+pe+1)+".0":Ne?(C("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=">="+Z+"."+pe+"."+Be+Ne+" <"+Z+"."+(+pe+1)+".0"):Ze=">="+Z+"."+pe+"."+Be+" <"+Z+"."+(+pe+1)+".0",C("tilde return",Ze),Ze})}(it,xe)}).join(" ")}(He,_e),C("tildes",He),He=function(Ye,xe){return C("replaceXRanges",Ye,xe),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?h[d]:h[u];return tt.replace(st,function(_,Z,pe,Be,Ne,Ze){C("xRange",tt,_,Z,pe,Be,Ne,Ze);var rt=Ie(pe),gt=rt||Ie(Be),yt=gt||Ie(Ne);return Z==="="&&yt&&(Z=""),rt?_=Z===">"||Z==="<"?"<0.0.0":"*":Z&&yt?(gt&&(Be=0),yt&&(Ne=0),Z===">"?(Z=">=",gt?(pe=+pe+1,Be=0,Ne=0):yt&&(Be=+Be+1,Ne=0)):Z==="<="&&(Z="<",gt?pe=+pe+1:Be=+Be+1),_=Z+pe+"."+Be+"."+Ne):gt?_=">="+pe+".0.0 <"+(+pe+1)+".0.0":yt&&(_=">="+pe+"."+Be+".0 <"+pe+"."+(+Be+1)+".0"),C("xRange return",_),_})}(it,xe)}).join(" ")}(He,_e),C("xrange",He),He=function(Ye,xe){return C("replaceStars",Ye,xe),Ye.trim().replace(h[le],"")}(He,_e),C("stars",He),He}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Qe){return!!Qe.match(Fe)})),je=je.map(function(Qe){return new se(Qe,x)})},de.prototype.intersects=function(J,x){if(!(J instanceof de))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Fe){return J.set.some(function(je){return je.every(function(Qe){return Fe.intersects(Qe,x)})})})})},e.toComparators=function(J,x){return new de(J,x).set.map(function(ae){return ae.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new $e(J,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],J))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(J,x,ae){var Fe=null,je=null;try{var Qe=new de(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Fe&&je.compare(He)!==-1||(je=new $e(Fe=He,ae)))}),Fe},e.minSatisfying=function(J,x,ae){var Fe=null,je=null;try{var Qe=new de(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Fe&&je.compare(He)!==1||(je=new $e(Fe=He,ae)))}),Fe},e.validRange=function(J,x){try{return new de(J,x).range||"*"}catch{return null}},e.ltr=function(J,x,ae){return Q(J,x,"<",ae)},e.gtr=function(J,x,ae){return Q(J,x,">",ae)},e.outside=Q,e.prerelease=function(J,x){var ae=ce(J,x);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(J,x,ae){return J=new de(J,ae),x=new de(x,ae),J.intersects(x)},e.coerce=function(J){if(J instanceof $e)return J;if(typeof J!="string")return null;var x=J.match(h[l]);return x==null?null:ce((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,w(1))},function(be,e){var w,M,C=be.exports={};function F(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function h(t){if(w===setTimeout)return setTimeout(t,0);if((w===F||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:F}catch{w=F}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var E,g=[],P=!1,k=-1;function a(){P&&E&&(P=!1,E.length?g=E.concat(g):k=-1,g.length&&b())}function b(){if(!P){var t=h(a);P=!0;for(var n=g.length;n;){for(E=g,g=[];++k<n;)E&&E[k].run();k=-1,n=g.length}E=null,P=!1,function(c){if(M===clearTimeout)return clearTimeout(c);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(c);try{M(c)}catch{try{return M.call(null,c)}catch{return M.call(this,c)}}}(t)}}function m(t,n){this.fun=t,this.array=n}function f(){}C.nextTick=function(t){var n=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)n[c-1]=arguments[c];g.push(new m(t,n)),g.length!==1||P||h(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=f,C.addListener=f,C.once=f,C.off=f,C.removeListener=f,C.removeAllListeners=f,C.emit=f,C.prependListener=f,C.prependOnceListener=f,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function C(D){const p=D;return p?typeof p.read=="function":!1}e.$Wd=C;function F(D){const p=D;return p?[p.on,p.pause,p.resume,p.destroy].every(r=>typeof r=="function"):!1}e.$Xd=F;function A(D){const p=D;return p?F(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.$Yd=A;function h(D,p){return new E(D,p)}e.$Zd=h;class E{constructor(p,r){this.e=p,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(r=>r(p))}h(p){this.c.error.length===0?(0,w.$Y)(p):this.c.error.slice(0).forEach(r=>r(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,r){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(p,r){if(this.a.destroyed)return;let s;switch(p){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(r);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(D,p){const r=[];let s;for(;(s=D.read())!==null;)r.push(s);return p(r)}e.$1d=g;function P(D,p,r){const s=[];let i;for(;(i=D.read())!==null&&s.length<r;)s.push(i);return i===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return D.read()}}}e.$2d=P;function k(D,p){return new Promise((r,s)=>{const i=[];a(D,{onData:o=>{p&&i.push(o)},onError:o=>{p?s(o):r(void 0)},onEnd:()=>{r(p?p(i):void 0)}})})}e.$3d=k;function a(D,p,r){D.on("error",s=>{r?.isCancellationRequested||p.onError(s)}),D.on("end",()=>{r?.isCancellationRequested||p.onEnd()}),D.on("data",s=>{r?.isCancellationRequested||p.onData(s)})}e.$4d=a;function b(D,p){return new Promise((r,s)=>{const i=new M.$Pc,o=[],y=I=>{if(o.push(I),o.length>p)return i.dispose(),D.pause(),r({stream:D,buffer:o,ended:!1})},$=I=>(i.dispose(),s(I)),S=()=>(i.dispose(),r({stream:D,buffer:o,ended:!0}));i.add((0,M.$Oc)(()=>D.removeListener("error",$))),D.on("error",$),i.add((0,M.$Oc)(()=>D.removeListener("end",S))),D.on("end",S),i.add((0,M.$Oc)(()=>D.removeListener("data",y))),D.on("data",y)})}e.$5d=b;function m(D,p){const r=h(p);return r.end(D),r}e.$6d=m;function f(){const D=h(()=>{throw new Error("not supported")});return D.end(),D}e.$7d=f;function t(D){let p=!1;return{read:()=>p?null:(p=!0,D)}}e.$8d=t;function n(D,p,r){const s=h(r);return a(D,{onData:i=>s.write(p.data(i)),onError:i=>s.error(p.error?p.error(i):i),onEnd:()=>s.end()}),s}e.$9d=n;function c(D,p,r){let s=!1;return{read:()=>{const i=p.read();return s?i:(s=!0,i!==null?r([D,i]):D)}}}e.$0d=c;function v(D,p,r){let s=!1;const i=h(r);return a(p,{onData:o=>s?i.write(o):(s=!0,i.write(r([D,o]))),onError:o=>i.error(o),onEnd:()=>{s||(s=!0,i.write(D)),i.end()}}),i}e.$$d=v}),define(Ae[25],Re([1,0,48,118]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const C=typeof Buffer<"u",F=new w.$T(()=>new Uint8Array(256));let A,h;class E{static alloc(l){return C?new E(Buffer.allocUnsafe(l)):new E(new Uint8Array(l))}static wrap(l){return C&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new E(l)}static fromString(l,R){return!(R?.dontUseNodeBuffer||!1)&&C?new E(Buffer.from(l)):(A||(A=new TextEncoder),new E(A.encode(l)))}static fromByteArray(l){const R=E.alloc(l.length);for(let B=0,V=l.length;B<V;B++)R.buffer[B]=l[B];return R}static concat(l,R){if(typeof R>"u"){R=0;for(let j=0,W=l.length;j<W;j++)R+=l[j].byteLength}const B=E.alloc(R);let V=0;for(let j=0,W=l.length;j<W;j++){const O=l[j];B.set(O,V),V+=O.byteLength}return B}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=E.alloc(this.byteLength);return l.set(this),l}toString(){return C?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(l,R){return new E(this.buffer.subarray(l,R))}set(l,R){if(l instanceof E)this.buffer.set(l.buffer,R);else if(l instanceof Uint8Array)this.buffer.set(l,R);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),R);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return a(this.buffer,l)}writeUInt32BE(l,R){b(this.buffer,l,R)}readUInt32LE(l){return m(this.buffer,l)}writeUInt32LE(l,R){f(this.buffer,l,R)}readUInt8(l){return t(this.buffer,l)}writeUInt8(l,R){n(this.buffer,l,R)}indexOf(l,R=0){return g(this.buffer,l instanceof E?l.buffer:l,R)}}e.$_d=E;function g(d,l,R=0){const B=l.byteLength,V=d.byteLength;if(B===0)return 0;if(B===1)return d.indexOf(l[0]);if(B>V-R)return-1;const j=F.value;j.fill(l.length);for(let ee=0;ee<l.length;ee++)j[l[ee]]=l.length-ee-1;let W=R+l.length-1,O=W,N=-1;for(;W<V;)if(d[W]===l[O]){if(O===0){N=W;break}W--,O--}else W+=Math.max(l.length-O,j[d[W]]),O=l.length-1;return N}e.$ae=g;function P(d,l){return d[l+0]<<0>>>0|d[l+1]<<8>>>0}e.$be=P;function k(d,l,R){d[R+0]=l&255,l=l>>>8,d[R+1]=l&255}e.$ce=k;function a(d,l){return d[l]*2**24+d[l+1]*2**16+d[l+2]*2**8+d[l+3]}e.$de=a;function b(d,l,R){d[R+3]=l,l=l>>>8,d[R+2]=l,l=l>>>8,d[R+1]=l,l=l>>>8,d[R]=l}e.$ee=b;function m(d,l){return d[l+0]<<0>>>0|d[l+1]<<8>>>0|d[l+2]<<16>>>0|d[l+3]<<24>>>0}e.$fe=m;function f(d,l,R){d[R+0]=l&255,l=l>>>8,d[R+1]=l&255,l=l>>>8,d[R+2]=l&255,l=l>>>8,d[R+3]=l&255}e.$ge=f;function t(d,l){return d[l]}e.$he=t;function n(d,l,R){d[R]=l}e.$ie=n;function c(d){return M.$1d(d,l=>E.concat(l))}e.$je=c;function v(d){return M.$8d(d)}e.$ke=v;function D(d){return M.$3d(d,l=>E.concat(l))}e.$le=D;async function p(d){return d.ended?E.concat(d.buffer):E.concat([...d.buffer,await D(d.stream)])}e.$me=p;function r(d){return M.$6d(d,l=>E.concat(l))}e.$ne=r;function s(d){return M.$9d(d,{data:l=>typeof l=="string"?E.fromString(l):E.wrap(l)},l=>E.concat(l))}e.$oe=s;function i(d){return M.$Zd(l=>E.concat(l),d)}e.$pe=i;function o(d,l){return M.$0d(d,l,R=>E.concat(R))}e.$qe=o;function y(d,l){return M.$$d(d,l,R=>E.concat(R))}e.$re=y;function $(d){let l=0,R=0,B=0;const V=new Uint8Array(Math.floor(d.length/4*3)),j=O=>{switch(R){case 3:V[B++]=l|O,R=0;break;case 2:V[B++]=l|O>>>2,l=O<<6,R=3;break;case 1:V[B++]=l|O>>>4,l=O<<4,R=2;break;default:l=O<<2,R=1}};for(let O=0;O<d.length;O++){const N=d.charCodeAt(O);if(N>=65&&N<=90)j(N-65);else if(N>=97&&N<=122)j(N-97+26);else if(N>=48&&N<=57)j(N-48+52);else if(N===43||N===45)j(62);else if(N===47||N===95)j(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${d[O]}`)}}const W=B;for(;R>0;)j(0);return E.wrap(V).slice(0,W)}e.$se=$;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:d},l=!0,R=!1){const B=R?I:S;let V="";const j=d.byteLength%3;let W=0;for(;W<d.byteLength-j;W+=3){const O=d[W+0],N=d[W+1],ee=d[W+2];V+=B[O>>>2],V+=B[(O<<4|N>>>4)&63],V+=B[(N<<2|ee>>>6)&63],V+=B[ee&63]}if(j===1){const O=d[W+0];V+=B[O>>>2],V+=B[O<<4&63],l&&(V+="==")}else if(j===2){const O=d[W+0],N=d[W+1];V+=B[O>>>2],V+=B[(O<<4|N>>>4)&63],V+=B[N<<2&63],l&&(V+="=")}return V}e.$te=u}),define(Ae[119],Re([1,0,28,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.FuzzyScore=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.or=void 0;function C(...se){return function(oe,de){for(let Ie=0,L=se.length;Ie<L;Ie++){const K=se[Ie](oe,de);if(K)return K}return null}}e.or=C,e.$zj=F.bind(void 0,!1),e.$Aj=F.bind(void 0,!0);function F(se,oe,de){if(!de||de.length<oe.length)return null;let Ie;return se?Ie=M.$1e(de,oe):Ie=de.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const de=oe.toLowerCase().indexOf(se.toLowerCase());return de===-1?null:[{start:de,end:de+se.length}]}e.$Bj=A;function h(se,oe){return E(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$Cj=h;function E(se,oe,de,Ie){if(de===se.length)return[];if(Ie===oe.length)return null;if(se[de]===oe[Ie]){let L=null;return(L=E(se,oe,de+1,Ie+1))?n({start:Ie,end:Ie+1},L):null}return E(se,oe,de,Ie+1)}function g(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$Dj=P;function k(se){return 48<=se&&se<=57}function a(se){return se===32||se===9||se===10||se===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>b.add(se.charCodeAt(0)));function m(se){return a(se)||b.has(se)}function f(se,oe){return se===oe||m(se)&&m(oe)}function t(se){return g(se)||P(se)||k(se)}function n(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function c(se,oe){for(let de=oe;de<se.length;de++){const Ie=se.charCodeAt(de);if(P(Ie)||k(Ie)||de>0&&!t(se.charCodeAt(de-1)))return de}return se.length}function v(se,oe,de,Ie){if(de===se.length)return[];if(Ie===oe.length)return null;if(se[de]!==oe[Ie].toLowerCase())return null;{let L=null,K=Ie+1;for(L=v(se,oe,de+1,Ie+1);!L&&(K=c(oe,K))<oe.length;)L=v(se,oe,de+1,K),K++;return L===null?null:n({start:Ie,end:Ie+1},L)}}function D(se){let oe=0,de=0,Ie=0,L=0,K=0;for(let ae=0;ae<se.length;ae++)K=se.charCodeAt(ae),P(K)&&oe++,g(K)&&de++,t(K)&&Ie++,k(K)&&L++;const G=oe/se.length,Q=de/se.length,J=Ie/se.length,x=L/se.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:J,numericPercent:x}}function p(se){const{upperPercent:oe,lowerPercent:de}=se;return de===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:de,alphaPercent:Ie,numericPercent:L}=se;return de>.2&&oe<.8&&Ie>.6&&L<.2}function s(se){let oe=0,de=0,Ie=0,L=0;for(let K=0;K<se.length;K++)Ie=se.charCodeAt(K),P(Ie)&&oe++,g(Ie)&&de++,a(Ie)&&L++;return(oe===0||de===0)&&L===0?se.length<=30:oe<=5}function i(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(se)||oe.length>60)return null;const de=D(oe);if(!r(de)){if(!p(de))return null;oe=oe.toLowerCase()}let Ie=null,L=0;for(se=se.toLowerCase();L<oe.length&&(Ie=v(se,oe,0,L))===null;)L=c(oe,L+1);return Ie}e.$Ej=i;function o(se,oe,de=!1){if(!oe||oe.length===0)return null;let Ie=null,L=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();L<oe.length&&(Ie=y(se,oe,0,L,de))===null;)L=$(oe,L+1);return Ie}e.$Fj=o;function y(se,oe,de,Ie,L){if(de===se.length)return[];if(Ie===oe.length)return null;if(f(se.charCodeAt(de),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=y(se,oe,de+1,Ie+1,L),!L)for(;!K&&(G=$(oe,G))<oe.length;)K=y(se,oe,de+1,G,L),G++;return K?se.charCodeAt(de)!==oe.charCodeAt(Ie)?K:n({start:Ie,end:Ie+1},K):null}else return null}function $(se,oe){for(let de=oe;de<se.length;de++)if(m(se.charCodeAt(de))||de>0&&m(se.charCodeAt(de-1)))return de;return se.length}const S=C(e.$Aj,i,A),I=C(e.$Aj,i,h),u=new w.$Bc(1e4);function d(se,oe,de=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=u.get(se);Ie||(Ie=new RegExp(M.$Je(se),"i"),u.set(se,Ie));const L=Ie.exec(oe);return L?[{start:L.index,end:L.index+L[0].length}]:de?I(se,oe):S(se,oe)}e.$Gj=d;function l(se,oe){const de=ue(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?B(de):null}e.$Hj=l;function R(se,oe,de,Ie,L,K){const G=Math.min(13,se.length);for(;de<G;de++){const Q=ue(se,oe,de,Ie,L,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,K]}e.$Ij=R;function B(se){if(typeof se>"u")return[];const oe=[],de=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const L=se[Ie]+de,K=oe[oe.length-1];K&&K.end===L?K.end=L+1:oe.push({start:L,end:L+1})}return oe}e.$Jj=B;const V=128;function j(){const se=[],oe=[];for(let de=0;de<=V;de++)oe[de]=0;for(let de=0;de<=V;de++)se.push(oe.slice(0));return se}function W(se){const oe=[];for(let de=0;de<=se;de++)oe[de]=0;return oe}const O=W(2*V),N=W(2*V),ee=j(),X=j(),ye=j(),De=!1;function Pe(se,oe,de,Ie,L){function K(Q,J,x=" "){for(;Q.length<J;)Q=x+Q;return Q}let G=` |   |${Ie.split("").map(Q=>K(Q,3)).join("|")}
`;for(let Q=0;Q<=de;Q++)Q===0?G+=" |":G+=`${oe[Q-1]}|`,G+=se[Q].slice(0,L+1).map(J=>K(J.toString(),3)).join("|")+`
`;return G}function Y(se,oe,de,Ie){se=se.substr(oe),de=de.substr(Ie),console.log(Pe(X,se,se.length,de,de.length)),console.log(Pe(ye,se,se.length,de,de.length)),console.log(Pe(ee,se,se.length,de,de.length))}function le(se,oe){if(oe<0||oe>=se.length)return!1;const de=se.codePointAt(oe);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$gf(de)}}function Ee(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(se,oe,de){return oe[se]!==de[se]}function $e(se,oe,de,Ie,L,K,G=!1){for(;oe<de&&L<K;)se[oe]===Ie[L]&&(G&&(O[oe]=L),oe+=1),L+=1;return oe===de}e.$Kj=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var z;(function(se){se.Default=[-100,0];function oe(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}se.isDefault=oe})(z||(e.FuzzyScore=z={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,de){this.firstMatchCanBeWeak=oe,this.boostFullMatch=de}}e.$Lj=q;function ue(se,oe,de,Ie,L,K,G=q.default){const Q=se.length>V?V:se.length,J=Ie.length>V?V:Ie.length;if(de>=Q||K>=J||Q-de>J-K||!$e(oe,de,Q,L,K,J,!0))return;we(Q,J,de,K,oe,L);let x=1,ae=1,Fe=de,je=K;const Qe=[!1];for(x=1,Fe=de;Fe<Q;x++,Fe++){const it=O[Fe],tt=N[Fe],ze=Fe+1<Q?N[Fe+1]:J;for(ae=it-K+1,je=it;je<ze;ae++,je++){let st=Number.MIN_SAFE_INTEGER,_=!1;je<=tt&&(st=ve(se,oe,Fe,de,Ie,L,je,J,K,ee[x-1][ae-1]===0,Qe));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,Z=st+X[x-1][ae-1]);const pe=je>it,Be=pe?X[x][ae-1]+(ee[x][ae-1]>0?-5:0):0,Ne=je>it+1&&ee[x][ae-1]>0,Ze=Ne?X[x][ae-2]+(ee[x][ae-2]>0?-5:0):0;if(Ne&&(!pe||Ze>=Be)&&(!_||Ze>=Z))X[x][ae]=Ze,ye[x][ae]=3,ee[x][ae]=0;else if(pe&&(!_||Be>=Z))X[x][ae]=Be,ye[x][ae]=2,ee[x][ae]=0;else if(_)X[x][ae]=Z,ye[x][ae]=1,ee[x][ae]=ee[x-1][ae-1]+1;else throw new Error("not possible")}}if(De&&Y(se,de,Ie,K),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ae--;const He=[X[x][ae],K];let _e=0,Ye=0;for(;x>=1;){let it=ae;do{const tt=ye[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&oe[de+x-1]===L[K+ae-1]&&!ce(it+K-1,Ie,L)&&_e+1>ee[x][it]&&(it=ae),it===ae?_e++:_e=1,Ye||(Ye=it),x--,ae=it-1,He.push(ae)}J===Q&&G.boostFullMatch&&(He[0]+=2);const xe=Ye-Q;return He[0]-=xe,He}e.$Mj=ue;function we(se,oe,de,Ie,L,K){let G=se-1,Q=oe-1;for(;G>=de&&Q>=Ie;)L[G]===K[Q]&&(N[G]=Q,G--),Q--}function ve(se,oe,de,Ie,L,K,G,Q,J,x,ae){if(oe[de]!==K[G])return Number.MIN_SAFE_INTEGER;let Fe=1,je=!1;return G===de-Ie?Fe=se[de]===L[G]?7:5:ce(G,L,K)&&(G===0||!ce(G-1,L,K))?(Fe=se[de]===L[G]?7:5,je=!0):le(K,G)&&(G===0||!le(K,G-1))?Fe=5:(le(K,G-1)||Ee(K,G-1))&&(Fe=5,je=!0),Fe>1&&de===Ie&&(ae[0]=!0),je||(je=ce(G,L,K)||le(K,G-1)||Ee(K,G-1)),de===Ie?G>J&&(Fe-=je?3:5):x?Fe+=je?2:0:Fe+=je?0:1,G+1===Q&&(Fe-=je?3:5),Fe}function me(se,oe,de,Ie,L,K,G){return re(se,oe,de,Ie,L,K,!0,G)}e.$Nj=me;function ke(se,oe,de,Ie,L,K,G){return re(se,oe,de,Ie,L,K,!1,G)}e.$Oj=ke;function re(se,oe,de,Ie,L,K,G,Q){let J=ue(se,oe,de,Ie,L,K,Q);if(J&&!G)return J;if(se.length>=3){const x=Math.min(7,se.length-1);for(let ae=de+1;ae<x;ae++){const Fe=he(se,ae);if(Fe){const je=ue(Fe,Fe.toLowerCase(),de,Ie,L,K,Q);je&&(je[0]-=3,(!J||je[0]>J[0])&&(J=je))}}}return J}function he(se,oe){if(oe+1>=se.length)return;const de=se[oe],Ie=se[oe+1];if(de!==Ie)return se.slice(0,oe)+Ie+de+se.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const F="error",A="warning",h="warn",E="info",g="ignore";function P(a){return a?w.$Ze(F,a)?C.Error:w.$Ze(A,a)||w.$Ze(h,a)?C.Warning:w.$Ze(E,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function k(a){switch(a){case C.Error:return F;case C.Warning:return A;case C.Info:return E;default:return g}}C.toString=k}(M||(M={})),e.default=M}),define(Ae[120],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(Ae[49],Re([1,0,18,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const m=b.charCodeAt(0),f=this.b.charCodeAt(this.c);return m-f}value(){return this.b[this.c]}}e.$Oh=C;class F{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,M.$Te)(b,this.b,0,b.length,this.c,this.d):(0,M.$Ve)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ph=F;class A{constructor(b=!0,m=!0){this.f=b,this.g=m}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let m=b.length-1;m>=0;m--,this.c--){const f=this.b.charCodeAt(m);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,M.$Te)(b,this.b,0,b.length,this.d,this.e):(0,M.$Ve)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Qh=A;var h;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(h||(h={}));class E{constructor(b,m){this.f=b,this.g=m,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,M.$Ue)(b,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Ue)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,M.$Se)(b,this.c.query);if(this.d[this.e]===5)return(0,M.$Se)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Rh=E;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(P||(P={}));class k{static forUris(b=()=>!1,m=()=>!1){return new k(new E(b,m))}static forPaths(b=!1){return new k(new A(void 0,!b))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new F)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,m){if(m){const f=m.slice(0);(0,w.$Vb)(f);for(const t of f)this.set(t,b)}else{const f=b.slice(0);(0,w.$Vb)(f);for(const t of f)this.set(t[0],t[1])}}set(b,m){const f=this.b.reset(b);let t;this.c||(this.c=new g,this.c.segment=f.value());const n=[];for(t=this.c;;){const v=f.cmp(t.segment);if(v>0)t.left||(t.left=new g,t.left.segment=f.value()),n.push([-1,t]),t=t.left;else if(v<0)t.right||(t.right=new g,t.right.segment=f.value()),n.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),n.push([0,t]),t=t.mid;else break}const c=t.value;t.value=m,t.key=b;for(let v=n.length-1;v>=0;v--){const D=n[v][1];D.updateHeight();const p=D.balanceFactor();if(p<-1||p>1){const r=n[v][0],s=n[v+1][0];if(r===1&&s===1)n[v][1]=D.rotateLeft();else if(r===-1&&s===-1)n[v][1]=D.rotateRight();else if(r===1&&s===-1)D.right=n[v+1][1]=n[v+1][1].rotateRight(),n[v][1]=D.rotateLeft();else if(r===-1&&s===1)D.left=n[v+1][1]=n[v+1][1].rotateLeft(),n[v][1]=D.rotateRight();else throw new Error;if(v>0)switch(n[v-1][0]){case-1:n[v-1][1].left=n[v][1];break;case 1:n[v-1][1].right=n[v][1];break;case 0:n[v-1][1].mid=n[v][1];break}else this.c=n[0][1]}}return c}get(b){return this.d(b)?.value}d(b){const m=this.b.reset(b);let f=this.c;for(;f;){const t=m.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(m.hasNext())m.next(),f=f.mid;else break}return f}has(b){const m=this.d(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,m){const f=this.b.reset(b),t=[];let n=this.c;for(;n;){const c=f.cmp(n.segment);if(c>0)t.push([-1,n]),n=n.left;else if(c<0)t.push([1,n]),n=n.right;else if(f.hasNext())f.next(),t.push([0,n]),n=n.mid;else break}if(n){if(m?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const c=this.f(n.right);if(c.key){const{key:v,value:D,segment:p}=c;this.e(c.key,!1),n.key=v,n.value=D,n.segment=p}}else{const c=n.left??n.right;if(t.length>0){const[v,D]=t[t.length-1];switch(v){case-1:D.left=c;break;case 0:D.mid=c;break;case 1:D.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const v=t[c][1];v.updateHeight();const D=v.balanceFactor();if(D>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),t[c][1]=v.rotateLeft()):D<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),t[c][1]=v.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this.b.reset(b);let f=this.c,t;for(;f;){const n=m.cmp(f.segment);if(n>0)f=f.left;else if(n<0)f=f.right;else if(m.hasNext())m.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(b){return this.g(b,!1)}g(b,m){const f=this.b.reset(b);let t=this.c;for(;t;){const n=f.cmp(t.segment);if(n>0)t=t.left;else if(n<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):m?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[m,f]of this)b(f,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const m=[];return this.j(b,m),m[Symbol.iterator]()}j(b,m){b&&(b.left&&this.j(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this.j(b.mid,m),b.right&&this.j(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const f=m.balanceFactor();return f<-1||f>1?!1:b(m.left)&&b(m.right)};return b(this.c)}}e.$Sh=k}),define(Ae[40],Re([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Sj=e.ThemeColor=void 0;var M;(function(A){function h(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=h})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Sj=C;var F;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(c){const v=h.exec(c.id);if(!v)return E(w.$Rj.error);const[,D,p]=v,r=["codicon","codicon-"+D];return p&&r.push("codicon-modifier-"+p.substring(1)),r}A.asClassNameArray=E;function g(c){return E(c).join(" ")}A.asClassName=g;function P(c){return"."+E(c).join(".")}A.asCSSSelector=P;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||M.isThemeColor(c.color))}A.isThemeIcon=k;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(c){const v=a.exec(c);if(!v)return;const[,D]=v;return{id:D}}A.fromString=b;function m(c){return{id:c}}A.fromId=m;function f(c,v){let D=c.id;const p=D.lastIndexOf("~");return p!==-1&&(D=D.substring(0,p)),v&&(D=`${D}~${v}`),{id:D}}A.modify=f;function t(c){const v=c.id.lastIndexOf("~");if(v!==-1)return c.id.substring(v+1)}A.getModifier=t;function n(c,v){return c.id===v.id&&c.color?.id===v.color?.id}A.isEqual=n})(F||(e.ThemeIcon=F={}))}),define(Ae[121],Re([1,0,119,15,40]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=void 0;const F="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),h=new RegExp(`(\\\\)?${A.source}`,"g");function E(n){return n.replace(h,(c,v)=>v?c:`\\${c}`)}e.$Tj=E;const g=new RegExp(`\\\\${A.source}`,"g");function P(n){return n.replace(g,c=>`\\${c}`)}e.$Uj=P;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(n){return n.indexOf(F)===-1?n:n.replace(k,(c,v,D,p)=>D?c:v||p||"")}e.$Vj=a;function b(n){return n?n.replace(/\$\((.*?)\)/g,(c,v)=>` ${v} `).trim():""}e.$Wj=b;const m=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(n){m.lastIndex=0;let c="";const v=[];let D=0;for(;;){const p=m.lastIndex,r=m.exec(n),s=n.substring(p,r?.index);if(s.length>0){c+=s;for(let i=0;i<s.length;i++)v.push(D)}if(!r)break;D+=r[0].length}return{text:c,iconOffsets:v}}e.$Xj=f;function t(n,c,v=!1){const{text:D,iconOffsets:p}=c;if(!p||p.length===0)return(0,w.$Gj)(n,D,v);const r=(0,M.$He)(D," "),s=D.length-r.length,i=(0,w.$Gj)(n,r,v);if(i)for(const o of i){const y=p[o.start+s]+s;o.start+=y,o.end+=y}return i}e.$Yj=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return w.test(C)}e.$bg=M,e.$cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(h){for(let E=0;E<h.length;E++)h[E]=Math.floor(Math.random()*256);return h};const F=new Uint8Array(16),A=[];for(let h=0;h<256;h++)A.push(h.toString(16).padStart(2,"0"));return function(){C(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let E=0,g="";return g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+="-",g+=A[F[E++]],g+=A[F[E++]],g+="-",g+=A[F[E++]],g+=A[F[E++]],g+="-",g+=A[F[E++]],g+=A[F[E++]],g+="-",g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g}}()}),define(Ae[122],Re([1,0,18,66,36]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=e.$Ts=e.$Ss=e.$Rs=void 0;function F(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Rs=F;function A(k,a,b){const m={id:(0,C.$cg)(),name:k,uri:a,data:b};return{asString:async()=>"",asFile:()=>m,value:void 0}}e.$Ss=A;class h{constructor(){this.a=new Map}get size(){let a=0;for(const b of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const b=[...this.a.keys()];return M.Iterable.some(this,([m,f])=>f.asFile())&&b.push("files"),P(E(a),b)}get(a){return this.a.get(this.b(a))?.[0]}append(a,b){const m=this.a.get(a);m?m.push(b):this.a.set(this.b(a),[b])}replace(a,b){this.a.set(this.b(a),[b])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,b]of this.a)for(const m of b)yield[a,m]}b(a){return E(a)}}e.$Ts=h;function E(k){return k.toLowerCase()}function g(k,a){return P(E(k),a.map(E))}e.$Us=g;function P(k,a){if(k==="*/*")return a.length>0;if(a.includes(k))return!0;const b=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[m,f,t]=b;return t==="*"?a.some(n=>n.startsWith(f+"/")):!1}e.$Vs=Object.freeze({create:k=>(0,w.$Kb)(k.map(a=>a.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Vs.split(k).filter(a=>!a.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0,e.$Wr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class M{constructor(h){if(this.e=null,this.f=!1,this.open=h.open,this.close=h.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(h.notIn))for(let E=0,g=h.notIn.length;E<g;E++)switch(h.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(h){switch(h){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(h,E){if(h.getTokenCount()===0)return!0;const g=h.findTokenIndexAtOffset(E-2),P=h.getStandardTokenType(g);return this.isOK(P)}g(h,E){for(let g=h;g<=E;g++){const P=String.fromCharCode(g);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$it=M;class C{constructor(h){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of h)F(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),F(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),F(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),F(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&F(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$jt=C;function F(A,h,E){A.has(h)?A.get(h).push(E):A.set(h,[E])}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7=e.$x7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const A=this.a.get(F);return this.a.delete(F),A}}addDragOperationTransfer(F,A){this.a.set(F,A)}}e.$x7=w;class M{constructor(F){this.identifier=F}}e.$y7=M}),define(Ae[126],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=void 0;class F extends M.$Qc{constructor(a,b="",m="",f=!0,t){super(),this.h=this.B(new w.$Ld),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=b,this.u=m,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,b){this.C&&await this.C(a)}}e.$ri=F;class A extends M.$Qc{constructor(){super(...arguments),this.f=this.B(new w.$Ld),this.onWillRun=this.f.event,this.m=this.B(new w.$Ld),this.onDidRun=this.m.event}async run(a,b){if(!a.enabled)return;this.f.fire({action:a});let m;try{await this.u(a,b)}catch(f){m=f}this.m.fire({action:a,error:m})}async u(a,b){await a.run(b)}}e.$si=A;class h{constructor(){this.id=h.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let b=[];for(const m of a)m.length&&(b.length?b=[...b,new h,...m]:b=m);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$ti=h;class E{get actions(){return this.a}constructor(a,b,m,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=b,this.class=f,this.a=m}async run(){}}e.$ui=E;class g extends F{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.$vi=g;function P(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...a)=>k.run(...a),tooltip:k.label}}e.$wi=P}),define(Ae[128],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=void 0;const M=60,C=M*60,F=C*24,A=F*7,h=F*30,E=F*365;function g(k,a,b,m){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,w.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!m&&f<30)return(0,w.localize)(1,null);let t;return f<M?(t=f,a?t===1?b?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):b?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?b?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):b?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):f<C?(t=Math.floor(f/M),a?t===1?b?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):b?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?b?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):b?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):f<F?(t=Math.floor(f/C),a?t===1?b?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):b?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?b?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):b?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):f<A?(t=Math.floor(f/F),a?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):f<h?(t=Math.floor(f/A),a?t===1?b?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):b?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?b?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):b?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):f<E?(t=Math.floor(f/h),a?t===1?b?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):b?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?b?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):b?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(f/E),a?t===1?b?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):b?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?b?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):b?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$8l=g;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$9l=P}),define(Ae[130],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,130]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=void 0;function F(k,a){return a&&(k.stack||k.stacktrace)?C.localize(0,null,h(k),A(k.stack)||A(k.stacktrace)):h(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function h(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function E(k=null,a=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const b=w.$Fb(k),m=E(b[0],a);return b.length>1?C.localize(4,null,m,b.length):m}if(M.$wf(k))return k;if(k.detail){const b=k.detail;if(b.error)return F(b.error,a);if(b.exception)return F(b.exception,a)}return k.stack?F(k,a):k.message?k.message:C.localize(5,null)}e.$xi=E;function g(k){const a=k;return a instanceof Error&&Array.isArray(a.actions)}e.$yi=g;function P(k,a){let b;return typeof k=="string"?b=new Error(k):b=k,b.actions=a,b}e.$zi=P}),define(Ae[131],Re([1,0,48,19]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=void 0;const C=new w.$T(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),F=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function h(I,u,d=!1){const l=I||"",R=u||"",B=C.value.collator.compare(l,R);return C.value.collatorIsNumeric&&B===0&&l!==R?l<R?-1:1:B}e.$_p=h;function E(I,u){const d=F.value.collator;return I=I||"",u=u||"",D(d,I,u)}e.$aq=E;function g(I,u){const d=F.value.collator;return I=I||"",u=u||"",i(I,u)||D(d,I,u)}e.$bq=g;function P(I,u){const d=F.value.collator;return I=I||"",u=u||"",s(I,u)||D(d,I,u)}e.$cq=P;function k(I,u){return I=I||"",u=u||"",I===u?0:I<u?-1:1}e.$dq=k;function a(I,u){const[d,l]=c(I),[R,B]=c(u);let V=C.value.collator.compare(l,B);if(V===0){if(C.value.collatorIsNumeric&&l!==B)return l<B?-1:1;if(V=C.value.collator.compare(d,R),C.value.collatorIsNumeric&&V===0&&d!==R)return d<R?-1:1}return V}e.$eq=a;function b(I,u){I=I||"",u=u||"";const d=v(I),l=v(u),R=F.value.collator,B=A.value.collator;return D(B,d,l)||D(R,I,u)}e.$fq=b;function m(I,u){I=I||"",u=u||"";const d=v(I),l=v(u),R=F.value.collator,B=A.value.collator;return D(B,d,l)||i(I,u)||D(R,I,u)}e.$gq=m;function f(I,u){I=I||"",u=u||"";const d=v(I),l=v(u),R=F.value.collator,B=A.value.collator;return D(B,d,l)||s(I,u)||D(R,I,u)}e.$hq=f;function t(I,u){I=I||"",u=u||"";const d=v(I).toLowerCase(),l=v(u).toLowerCase();return d!==l?d<l?-1:1:I!==u?I<u?-1:1:0}e.$iq=t;const n=/^(.*?)(\.([^.]*))?$/;function c(I,u=!1){const d=I?n.exec(I):[];let l=[d&&d[1]||"",d&&d[3]||""];return u&&(!l[0]&&l[1]||l[0]&&l[0].charAt(0)===".")&&(l=[l[0]+"."+l[1],""]),l}function v(I){const u=I?n.exec(I):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function D(I,u,d){const l=I.compare(u,d);return l!==0?l:u.length!==d.length?u.length<d.length?-1:1:0}function p(I){const u=I.charAt(0);return u.toLocaleUpperCase()!==u}function r(I){const u=I.charAt(0);return u.toLocaleLowerCase()!==u}function s(I,u){return p(I)&&r(u)?-1:r(I)&&p(u)?1:0}function i(I,u){return r(I)&&p(u)?-1:p(I)&&r(u)?1:0}function o(I,u,d=!1){return d||(I=I&&I.toLowerCase(),u=u&&u.toLowerCase()),I===u?0:I<u?-1:1}function y(I,u,d=!1){const l=I.split(M.sep),R=u.split(M.sep),B=l.length-1,V=R.length-1;let j,W;for(let O=0;;O++){if(j=B===O,W=V===O,j&&W)return h(l[O],R[O],d);if(j)return-1;if(W)return 1;const N=o(l[O],R[O],d);if(N!==0)return N}}e.$jq=y;function $(I,u,d){const l=I.toLowerCase(),R=u.toLowerCase(),B=S(I,u,d);if(B)return B;const V=l.endsWith(d),j=R.endsWith(d);if(V!==j)return V?-1:1;const W=h(l,R);return W!==0?W:l.localeCompare(R)}e.$kq=$;function S(I,u,d){const l=I.toLowerCase(),R=u.toLowerCase(),B=l.startsWith(d),V=R.startsWith(d);if(B!==V)return B?-1:1;if(B&&V){if(l.length<R.length)return-1;if(l.length>R.length)return 1}return 0}e.$lq=S}),define(Ae[42],Re([1,0,19,22,15,16]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function A($){return $===47||$===92}e.$Of=A;function h($){return $.replace(/[\\/]/g,w.$ec.sep)}e.$Pf=h;function E($){return $.indexOf("/")===-1&&($=h($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Qf=E;function g($,S=w.$ec.sep){if(!$)return"";const I=$.length,u=$.charCodeAt(0);if(A(u)){if(A($.charCodeAt(1))&&!A($.charCodeAt(2))){let l=3;const R=l;for(;l<I&&!A($.charCodeAt(l));l++);if(R!==l&&!A($.charCodeAt(l+1))){for(l+=1;l<I;l++)if(A($.charCodeAt(l)))return $.slice(0,l+1).replace(/[\\/]/g,S)}}return S}else if(n(u)&&$.charCodeAt(1)===58)return A($.charCodeAt(2))?$.slice(0,2)+S:$.slice(0,2);let d=$.indexOf("://");if(d!==-1){for(d+=3;d<I;d++)if(A($.charCodeAt(d)))return $.slice(0,d+1)}return""}e.$Rf=g;function P($){if(!M.$i||!$||$.length<5)return!1;let S=$.charCodeAt(0);if(S!==92||(S=$.charCodeAt(1),S!==92))return!1;let I=2;const u=I;for(;I<$.length&&(S=$.charCodeAt(I),S!==92);I++);return!(u===I||(S=$.charCodeAt(I+1),isNaN(S)||S===92))}e.$Sf=P;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m($,S=M.$i){const I=S?k:a;return!(!$||$.length===0||/^\s+$/.test($)||(I.lastIndex=0,I.test($))||S&&b.test($)||$==="."||$===".."||S&&$[$.length-1]==="."||S&&$.length!==$.trim().length||$.length>255)}e.$Tf=m;function f($,S,I){const u=$===S;return!I||u?u:!$||!S?!1:(0,C.$Ze)($,S)}e.$Uf=f;function t($,S,I,u=w.sep){if($===S)return!0;if(!$||!S||S.length>$.length)return!1;if(I){if(!(0,C.$1e)($,S))return!1;if(S.length===$.length)return!0;let l=S.length;return S.charAt(S.length-1)===u&&l--,$.charAt(l)===u}return S.charAt(S.length-1)!==u&&(S+=u),$.indexOf(S)===0}e.$Vf=t;function n($){return $>=65&&$<=90||$>=97&&$<=122}e.$Wf=n;function c($,S){return M.$i&&$.endsWith(":")&&($+=w.sep),(0,w.$gc)($)||($=(0,w.$hc)(S,$)),$=(0,w.$fc)($),M.$i?($=(0,C.$Ie)($,w.sep),$.endsWith(":")&&($+=w.sep)):($=(0,C.$Ie)($,w.sep),$||($=w.sep)),$}e.$Xf=c;function v($){const S=(0,w.$fc)($);return M.$i?$.length>3?!1:D(S)&&($.length===2||S.charCodeAt(2)===92):S===w.$ec.sep}e.$Yf=v;function D($,S=M.$i){return S?n($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$Zf=D;function p($,S=M.$i){return D($,S)?$[0]:void 0}e.$1f=p;function r($,S,I){return S.length>$.length?-1:$===S?0:(I&&($=$.toLowerCase(),S=S.toLowerCase()),$.indexOf(S))}e.$2f=r;function s($){const S=$.split(":");let I,u,d;for(const l of S){const R=Number(l);(0,F.$Af)(R)?u===void 0?u=R:d===void 0&&(d=R):I=I?[I,l].join(":"):l}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:u!==void 0?u:void 0,column:d!==void 0?d:u!==void 0?1:void 0}}e.$3f=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y($,S,I=8){let u="";for(let l=0;l<I;l++){let R;l===0&&M.$i&&!S&&(I===3||I===4)?R=o:R=i,u+=R.charAt(Math.floor(Math.random()*R.length))}let d;return S?d=`${S}-${u}`:d=u,$?(0,w.$hc)($,d):d}e.$4f=y}),define(Ae[67],Re([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0,e.$Jr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(P){const k=(0,w.$mc)(P),a=M[k.toLowerCase()];return a!==void 0?a:A(P)}e.$Kr=F;function A(P){const k=(0,w.$mc)(P);return C[k.toLowerCase()]}e.$Lr=A;function h(P){for(const k in C)if(C[k]===P)return k}e.$Mr=h;const E=/^(.+)\/(.+?)(;.+)?$/;function g(P,k){const a=E.exec(P);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:k?void 0:P}e.$Nr=g}),define(Ae[68],Re([1,0,25,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function C(E){return JSON.stringify(E,A)}e.$hh=C;function F(E){let g=JSON.parse(E);return g=h(g),g}e.$ih=F;function A(E,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function h(E,g=0){if(!E||g>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return M.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof w.$_d||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let P=0;P<E.length;++P)E[P]=h(E[P],g+1);else for(const P in E)Object.hasOwnProperty.call(E,P)&&(E[P]=h(E[P],g+1))}return E}e.$jh=h}),define(Ae[12],Re([1,0,9,22,2]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var F;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.$5f="vscode-tkn",e.$6f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${F.vscodeRemoteResource}`}set(P,k,a){this.a[P]=k,this.b[P]=a}setConnectionToken(P,k){this.c[P]=k}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return w.$Y(t),P}const k=P.authority;let a=this.a[k];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const b=this.b[k],m=this.c[k];let f=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(f+=`&${e.$6f}=${encodeURIComponent(m)}`),C.URI.from({scheme:M.$o?this.d:F.vscodeRemoteResource,authority:`${a}:${b}`,path:this.f,query:f})}}e.$7f=new A,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked",e.$_f="vscode-app";class h{static{this.a=e.$_f}asBrowserUri(P){const k=this.b(P,be);return this.uriToBrowserUri(k)}uriToBrowserUri(P){return P.scheme===F.vscodeRemote?e.$7f.rewrite(P):P.scheme===F.file&&(M.$m||M.$p&&M.$g.origin===`${F.vscodeFileResource}://${h.a}`)?P.with({scheme:F.vscodeFileResource,authority:P.authority||h.a,query:null,fragment:null}):P}asFileUri(P){const k=this.b(P,be);return this.uriToFileUri(k)}uriToFileUri(P){return P.scheme===F.vscodeFileResource?P.with({scheme:F.file,authority:P.authority!==h.a?P.authority:null,query:null,fragment:null}):P}b(P,k){return C.URI.isUri(P)?P:C.URI.parse(k.toUrl(P))}}e.$ag=new h;var E;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const k="vscode-coi";function a(m){let f;typeof m=="string"?f=new URL(m).searchParams:m instanceof URL?f=m.searchParams:C.URI.isUri(m)&&(f=new URL(m.toString(!0)).searchParams);const t=f?.get(k);if(t)return P.get(t)}g.getHeadersFromQuery=a;function b(m,f,t){if(!globalThis.crossOriginIsolated)return;const n=f&&t?"3":t?"2":"1";m instanceof URLSearchParams?m.set(k,n):m[k]=n}g.addSearchParam=b})(E||(e.COI=E={}))}),define(Ae[23],Re([1,0,42,12,19,22,15,2]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=e.DataUri=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function E(b){return(0,h.$uc)(b,!0)}e.$hg=E;class g{constructor(m){this.a=m}compare(m,f,t=!1){return m===f?0:(0,A.$Se)(this.getComparisonKey(m,t),this.getComparisonKey(f,t))}isEqual(m,f,t=!1){return m===f?!0:!m||!f?!1:this.getComparisonKey(m,t)===this.getComparisonKey(f,t)}getComparisonKey(m,f=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,f,t=!1){if(m.scheme===f.scheme){if(m.scheme===M.Schemas.file)return w.$Vf(E(m),E(f),this.a(m))&&m.query===f.query&&(t||m.fragment===f.fragment);if((0,e.$yg)(m.authority,f.authority))return w.$Vf(m.path,f.path,this.a(m),"/")&&m.query===f.query&&(t||m.fragment===f.fragment)}return!1}joinPath(m,...f){return h.URI.joinPath(m,...f)}basenameOrAuthority(m){return(0,e.$qg)(m)||m.authority}basename(m){return C.$ec.basename(m.path)}extname(m){return C.$ec.extname(m.path)}dirname(m){if(m.path.length===0)return m;let f;return m.scheme===M.Schemas.file?f=h.URI.file(C.$kc(E(m))).path:(f=C.$ec.dirname(m.path),m.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),f="/")),m.with({path:f})}normalizePath(m){if(!m.path.length)return m;let f;return m.scheme===M.Schemas.file?f=h.URI.file(C.$fc(E(m))).path:f=C.$ec.normalize(m.path),m.with({path:f})}relativePath(m,f){if(m.scheme!==f.scheme||!(0,e.$yg)(m.authority,f.authority))return;if(m.scheme===M.Schemas.file){const c=C.$jc(E(m),E(f));return F.$i?w.$Pf(c):c}let t=m.path||"/";const n=f.path||"/";if(this.a(m)){let c=0;for(const v=Math.min(t.length,n.length);c<v&&!(t.charCodeAt(c)!==n.charCodeAt(c)&&t.charAt(c).toLowerCase()!==n.charAt(c).toLowerCase());c++);t=n.substr(0,c)+t.substr(c)}return C.$ec.relative(t,n)}resolvePath(m,f){if(m.scheme===M.Schemas.file){const t=h.URI.file(C.$ic(E(m),f));return m.with({authority:t.authority,path:t.path})}return f=w.$Qf(f),m.with({path:C.$ec.resolve(m.path,f)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,f){return m===f||m!==void 0&&f!==void 0&&(0,A.$Ze)(m,f)}hasTrailingPathSeparator(m,f=C.sep){if(m.scheme===M.Schemas.file){const t=E(m);return t.length>w.$Rf(t).length&&t[t.length-1]===f}else{const t=m.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,f=C.sep){return(0,e.$zg)(m,f)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,f=C.sep){let t=!1;if(m.scheme===M.Schemas.file){const n=E(m);t=n!==void 0&&n.length===w.$Rf(n).length&&n[n.length-1]===f}else{f="/";const n=m.path;t=n.length===1&&n.charCodeAt(n.length-1)===47}return!t&&!(0,e.$zg)(m,f)?m.with({path:m.path+"/"}):m}}e.$ig=g,e.$jg=new g(()=>!1),e.$kg=new g(b=>b.scheme===M.Schemas.file?!F.$k:!0),e.$lg=new g(b=>!0),e.$mg=e.$jg.isEqual.bind(e.$jg),e.$ng=e.$jg.isEqualOrParent.bind(e.$jg),e.$og=e.$jg.getComparisonKey.bind(e.$jg),e.$pg=e.$jg.basenameOrAuthority.bind(e.$jg),e.$qg=e.$jg.basename.bind(e.$jg),e.$rg=e.$jg.extname.bind(e.$jg),e.$sg=e.$jg.dirname.bind(e.$jg),e.$tg=e.$jg.joinPath.bind(e.$jg),e.$ug=e.$jg.normalizePath.bind(e.$jg),e.$vg=e.$jg.relativePath.bind(e.$jg),e.$wg=e.$jg.resolvePath.bind(e.$jg),e.$xg=e.$jg.isAbsolutePath.bind(e.$jg),e.$yg=e.$jg.isEqualAuthority.bind(e.$jg),e.$zg=e.$jg.hasTrailingPathSeparator.bind(e.$jg),e.$Ag=e.$jg.removeTrailingPathSeparator.bind(e.$jg),e.$Bg=e.$jg.addTrailingPathSeparator.bind(e.$jg);function P(b,m){const f=[];for(let t=0;t<b.length;t++){const n=m(b[t]);b.some((c,v)=>v===t?!1:(0,e.$ng)(n,m(c)))||f.push(b[t])}return f}e.$Cg=P;var k;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[D,p]=v.split(":");D&&p&&t.set(D,p)});const c=f.path.substring(0,f.path.indexOf(";"));return c&&t.set(b.META_DATA_MIME,c),t}b.parseMetaData=m})(k||(e.DataUri=k={}));function a(b,m,f){if(m){let t=b.path;return t&&t[0]!==C.$ec.sep&&(t=C.$ec.sep+t),b.with({scheme:f,authority:m,path:t})}return b.with({scheme:f})}e.$Dg=a}),define(Ae[13],Re([1,0,21,9,5,6,23,22,120]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.Promises=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=void 0;function g(z){return!!z&&typeof z.then=="function"}e.$Eg=g;function P(z){const q=new w.$Vd,ue=z(q.token),we=new Promise((ve,me)=>{const ke=q.token.onCancellationRequested(()=>{ke.dispose(),q.dispose(),me(new M.$3)});Promise.resolve(ue).then(re=>{ke.dispose(),q.dispose(),ve(re)},re=>{ke.dispose(),q.dispose(),me(re)})});return new class{cancel(){q.cancel()}then(ve,me){return we.then(ve,me)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$Fg=P;function k(z,q,ue){return new Promise((we,ve)=>{const me=q.onCancellationRequested(()=>{me.dispose(),we(ue)});z.then(we,ve).finally(()=>me.dispose())})}e.$Gg=k;function a(z,q){return new Promise((ue,we)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),we(new M.$3)});z.then(ue,we).finally(()=>ve.dispose())})}e.$Hg=a;async function b(z){let q=-1;const ue=z.map((we,ve)=>we.then(me=>(q=ve,me)));try{return await Promise.race(ue)}finally{z.forEach((we,ve)=>{ve!==q&&we.cancel()})}}e.$Ig=b;function m(z,q,ue){let we;const ve=setTimeout(()=>{we?.(void 0),ue?.()},q);return Promise.race([z.finally(()=>clearTimeout(ve)),new Promise(me=>we=me)])}e.$Jg=m;function f(z){return new Promise((q,ue)=>{const we=z();g(we)?we.then(q,ue):q(we)})}e.$Kg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const ue=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(ue,ue).then(we)})}return new Promise((ue,we)=>{this.b.then(ue,we)})}return this.a=q(),new Promise((ue,we)=>{this.a.then(ve=>{this.a=null,ue(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$Lg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Mg=n;class c{constructor(){this.a=new Map}queue(q,ue){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$Ng=c;const v=(z,q)=>{let ue=!0;const we=setTimeout(()=>{ue=!1,q()},z);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(we),ue=!1}}},D=z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class p{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,ue=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,me)=>{this.d=ve,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=ue===E.$Id?D(we):v(ue,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Og=p;class r{constructor(q){this.a=new p(q),this.b=new t}trigger(q,ue){return this.a.trigger(()=>this.b.queue(q),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Pg=r;class s{constructor(){this.a=!1,this.b=new Promise((q,ue)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Qg=s;class i extends s{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Rg=i;function o(z,q){return q?new Promise((ue,we)=>{const ve=setTimeout(()=>{me.dispose(),ue()},z),me=q.onCancellationRequested(()=>{clearTimeout(ve),me.dispose(),we(new M.$3)})}):P(ue=>o(z,ue))}e.$Sg=o;function y(z,q=0,ue){const we=setTimeout(()=>{z(),ue&&ve.dispose()},q),ve=(0,F.$Oc)(()=>{clearTimeout(we),ue?.deleteAndLeak(ve)});return ue?.add(ve),ve}e.$Tg=y;function $(z){const q=[];let ue=0;const we=z.length;function ve(){return ue<we?z[ue++]():null}function me(ke){ke!=null&&q.push(ke);const re=ve();return re?re.then(me):Promise.resolve(q)}return Promise.resolve(null).then(me)}e.$Ug=$;function S(z,q=we=>!!we,ue=null){let we=0;const ve=z.length,me=()=>{if(we>=ve)return Promise.resolve(ue);const ke=z[we++];return Promise.resolve(ke()).then(he=>q(he)?Promise.resolve(he):me())};return me()}e.$Vg=S;function I(z,q=we=>!!we,ue=null){if(z.length===0)return Promise.resolve(ue);let we=z.length;const ve=()=>{we=-1;for(const me of z)me.cancel?.()};return new Promise((me,ke)=>{for(const re of z)re.then(he=>{--we>=0&&q(he)?(ve(),me(he)):we===0&&me(ue)}).catch(he=>{--we>=0&&(ve(),ke(he))})})}e.$Wg=I;class u{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((ue,we)=>{this.f.push({factory:q,c:ue,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const ue=q.factory();ue.then(q.c,q.e),ue.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Xg=u;class d extends u{constructor(){super(1)}}e.$Yg=d;class l{constructor(){this.a=new ye,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Zg=l;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new Y;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,ue=A.$jg){const we=ue.getComparisonKey(q);let ve=this.a.get(we);if(!ve){ve=new d;const me=this.f++,ke=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$Yc),this.d.set(me,ke),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$1g=R;class B{constructor(q,ue){this.a=-1,typeof q=="function"&&typeof ue=="number"&&this.setIfNotSet(q,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},ue)}setIfNotSet(q,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},ue))}}e.$2g=B;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,ue){this.cancel(),this.a=setInterval(()=>{q()},ue)}}e.$3g=V;class j{constructor(q,ue){this.b=-1,this.a=q,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$4g=j;class W{constructor(q,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=q,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$5g=W;class O extends j{constructor(q,ue){super(q,ue),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$6g=O;class N extends F.$Qc{constructor(q,ue){super(),this.g=q,this.h=ue,this.a=[],this.b=this.B(new F.$Rc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of q)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$7g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$8g=z=>{(0,h.$A)(()=>{if(q)return;const ue=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$8g=(z,q)=>{const ue=requestIdleCallback(z,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ue))}}}}();class ee{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(ue){this.g=ue}finally{this.d=!0}},this.b=(0,e.$8g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$9g=ee;async function X(z,q,ue){let we;for(let ve=0;ve<ue;ve++)try{return await z()}catch(me){we=me,await o(q)}throw we}e.$0g=X;class ye{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,ue,we){return this.a={taskId:q,cancel:()=>we?.(),promise:ue},ue.then(()=>this.d(q),()=>this.d(q)),ue}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let ue,we;const ve=new Promise((me,ke)=>{ue=me,we=ke});this.b={run:q,promise:ve,promiseResolve:ue,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$$g=ye;class De{constructor(q,ue=()=>Date.now()){this.d=q,this.f=ue,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$_g=De;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class Y{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,ue)=>{this.a=q,this.b=ue})}complete(q){return new Promise(ue=>{this.a(q),this.d={outcome:0,value:q},ue()})}error(q){return new Promise(ue=>{this.b(q),this.d={outcome:1,value:q},ue()})}cancel(){return this.error(new M.$3)}}e.$ah=Y;var le;(function(z){async function q(we){let ve;const me=await Promise.all(we.map(ke=>ke.then(re=>re,re=>{ve||(ve=re)})));if(typeof ve<"u")throw ve;return me}z.settled=q;function ue(we){return new Promise(async(ve,me)=>{try{await we(ve,me)}catch(ke){me(ke)}})}z.withAsyncBody=ue})(le||(e.Promises=le={}));var Ee;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(Ee||(Ee={}));class ce{static fromArray(q){return new ce(ue=>{ue.emitMany(q)})}static fromPromise(q){return new ce(async ue=>{ue.emitMany(await q)})}static fromPromises(q){return new ce(async ue=>{await Promise.all(q.map(async we=>ue.emitOne(await we)))})}static merge(q){return new ce(async ue=>{await Promise.all(q.map(async we=>{for await(const ve of we)ue.emitOne(ve)}))})}static{this.EMPTY=ce.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$Ld,queueMicrotask(async()=>{const ue={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(ue)),this.j()}catch(we){this.k(we)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,ue){return new ce(async we=>{for await(const ve of q)we.emitOne(ue(ve))})}map(q){return ce.map(this,q)}static filter(q,ue){return new ce(async we=>{for await(const ve of q)ue(ve)&&we.emitOne(ve)})}filter(q){return ce.filter(this,q)}static coalesce(q){return ce.filter(q,ue=>!!ue)}coalesce(){return ce.coalesce(this)}static async toPromise(q){const ue=[];for await(const we of q)ue.push(we);return ue}toPromise(){return ce.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$bh=ce;class $e extends ce{constructor(q,ue){super(ue),this.l=q}cancel(){this.l.cancel()}}e.$ch=$e;function ie(z){const q=new w.$Vd,ue=z(q.token);return new $e(q,async we=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),we.reject(new M.$3)});try{for await(const me of ue){if(q.token.isCancellationRequested)return;we.emitOne(me)}ve.dispose(),q.dispose()}catch(me){ve.dispose(),q.dispose(),we.reject(me)}})}e.$dh=ie}),define(Ae[37],Re([1,0,18,13,42,28,19,22,15]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=void 0;function g(){return Object.create(null)}e.$oj=g,e.$pj="**",e.$qj="/";const P="[/\\\\]",k="[^/\\\\]",a=/\//g;function b(ye,De){switch(ye){case 0:return"";case 1:return`${k}*?`;default:return`(?:${P}|${k}+${P}${De?`|${P}${k}+`:""})*?`}}function m(ye,De){if(!ye)return[];const Pe=[];let Y=!1,le=!1,Ee="";for(const ce of ye){switch(ce){case De:if(!Y&&!le){Pe.push(Ee),Ee="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":le=!0;break;case"]":le=!1;break}Ee+=ce}return Ee&&Pe.push(Ee),Pe}e.$rj=m;function f(ye){if(!ye)return"";let De="";const Pe=m(ye,e.$qj);if(Pe.every(Y=>Y===e.$pj))De=".*";else{let Y=!1;Pe.forEach((le,Ee)=>{if(le===e.$pj){if(Y)return;De+=b(2,Ee===Pe.length-1)}else{let ce=!1,$e="",ie=!1,z="";for(const q of le){if(q!=="}"&&ce){$e+=q;continue}if(ie&&(q!=="]"||!z)){let ue;q==="-"?ue=q:(q==="^"||q==="!")&&!z?ue="^":q===e.$qj?ue="":ue=(0,E.$De)(q),z+=ue;continue}switch(q){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${m($e,",").map(ve=>f(ve)).join("|")})`;De+=we,ce=!1,$e="";break}case"]":{De+="["+z+"]",ie=!1,z="";break}case"?":De+=k;continue;case"*":De+=b(1);continue;default:De+=(0,E.$De)(q)}}Ee<Pe.length-1&&(Pe[Ee+1]!==e.$pj||Ee+2<Pe.length)&&(De+=P)}Y=le===e.$pj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,n=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new F.$Bc(1e4),s=function(){return!1},i=function(){return null};function o(ye,De){if(!ye)return i;let Pe;typeof ye!="string"?Pe=ye.pattern:Pe=ye,Pe=Pe.trim();const Y=`${Pe}_${!!De.trimForExclusions}`;let le=r.get(Y);if(le)return y(le,ye);let Ee;return t.test(Pe)?le=S(Pe.substr(4),Pe):(Ee=n.exec($(Pe,De)))?le=I(Ee[1],Pe):(De.trimForExclusions?v:c).test(Pe)?le=u(Pe,De):(Ee=D.exec($(Pe,De)))?le=d(Ee[1].substr(1),Pe,!0):(Ee=p.exec($(Pe,De)))?le=d(Ee[1],Pe,!1):le=l(Pe),r.set(Y,le),y(le,ye)}function y(ye,De){if(typeof De=="string")return ye;const Pe=function(Y,le){return(0,C.$Vf)(Y,De.base,!h.$k)?ye((0,E.$He)(Y.substr(De.base.length),A.sep),le):null};return Pe.allBasenames=ye.allBasenames,Pe.allPaths=ye.allPaths,Pe.basenames=ye.basenames,Pe.patterns=ye.patterns,Pe}function $(ye,De){return De.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function S(ye,De){return function(Pe,Y){return typeof Pe=="string"&&Pe.endsWith(ye)?De:null}}function I(ye,De){const Pe=`/${ye}`,Y=`\\${ye}`,le=function(ce,$e){return typeof ce!="string"?null:$e?$e===ye?De:null:ce===ye||ce.endsWith(Pe)||ce.endsWith(Y)?De:null},Ee=[ye];return le.basenames=Ee,le.patterns=[De],le.allBasenames=Ee,le}function u(ye,De){const Pe=ee(ye.slice(1,-1).split(",").map($e=>o($e,De)).filter($e=>$e!==i),ye),Y=Pe.length;if(!Y)return i;if(Y===1)return Pe[0];const le=function($e,ie){for(let z=0,q=Pe.length;z<q;z++)if(Pe[z]($e,ie))return ye;return null},Ee=Pe.find($e=>!!$e.allBasenames);Ee&&(le.allBasenames=Ee.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(le.allPaths=ce),le}function d(ye,De,Pe){const Y=A.sep===A.$ec.sep,le=Y?ye:ye.replace(a,A.sep),Ee=A.sep+le,ce=A.$ec.sep+ye;let $e;return Pe?$e=function(ie,z){return typeof ie=="string"&&(ie===le||ie.endsWith(Ee)||!Y&&(ie===ye||ie.endsWith(ce)))?De:null}:$e=function(ie,z){return typeof ie=="string"&&(ie===le||!Y&&ie===ye)?De:null},$e.allPaths=[(Pe?"*/":"./")+ye],$e}function l(ye){try{const De=new RegExp(`^${f(ye)}$`);return function(Pe){return De.lastIndex=0,typeof Pe=="string"&&De.test(Pe)?ye:null}}catch{return i}}function R(ye,De,Pe){return!ye||typeof De!="string"?!1:B(ye)(De,void 0,Pe)}e.$sj=R;function B(ye,De={}){if(!ye)return s;if(typeof ye=="string"||V(ye)){const Pe=o(ye,De);if(Pe===i)return s;const Y=function(le,Ee){return!!Pe(le,Ee)};return Pe.allBasenames&&(Y.allBasenames=Pe.allBasenames),Pe.allPaths&&(Y.allPaths=Pe.allPaths),Y}return O(ye,De)}e.$tj=B;function V(ye){const De=ye;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$uj=V;function j(ye){return ye.allBasenames||[]}e.$vj=j;function W(ye){return ye.allPaths||[]}e.$wj=W;function O(ye,De){const Pe=ee(Object.getOwnPropertyNames(ye).map($e=>N($e,ye[$e],De)).filter($e=>$e!==i)),Y=Pe.length;if(!Y)return i;if(!Pe.some($e=>!!$e.requiresSiblings)){if(Y===1)return Pe[0];const $e=function(q,ue){let we;for(let ve=0,me=Pe.length;ve<me;ve++){const ke=Pe[ve](q,ue);if(typeof ke=="string")return ke;(0,M.$Eg)(ke)&&(we||(we=[]),we.push(ke))}return we?(async()=>{for(const ve of we){const me=await ve;if(typeof me=="string")return me}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const z=Pe.reduce((q,ue)=>ue.allPaths?q.concat(ue.allPaths):q,[]);return z.length&&($e.allPaths=z),$e}const le=function($e,ie,z){let q,ue;for(let we=0,ve=Pe.length;we<ve;we++){const me=Pe[we];me.requiresSiblings&&z&&(ie||(ie=(0,A.$lc)($e)),q||(q=ie.substr(0,ie.length-(0,A.$mc)($e).length)));const ke=me($e,ie,q,z);if(typeof ke=="string")return ke;(0,M.$Eg)(ke)&&(ue||(ue=[]),ue.push(ke))}return ue?(async()=>{for(const we of ue){const ve=await we;if(typeof ve=="string")return ve}return null})():null},Ee=Pe.find($e=>!!$e.allBasenames);Ee&&(le.allBasenames=Ee.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(le.allPaths=ce),le}function N(ye,De,Pe){if(De===!1)return i;const Y=o(ye,Pe);if(Y===i)return i;if(typeof De=="boolean")return Y;if(De){const le=De.when;if(typeof le=="string"){const Ee=(ce,$e,ie,z)=>{if(!z||!Y(ce,$e))return null;const q=le.replace("$(basename)",()=>ie),ue=z(q);return(0,M.$Eg)(ue)?ue.then(we=>we?ye:null):ue?ye:null};return Ee.requiresSiblings=!0,Ee}}return Y}function ee(ye,De){const Pe=ye.filter($e=>!!$e.basenames);if(Pe.length<2)return ye;const Y=Pe.reduce(($e,ie)=>{const z=ie.basenames;return z?$e.concat(z):$e},[]);let le;if(De){le=[];for(let $e=0,ie=Y.length;$e<ie;$e++)le.push(De)}else le=Pe.reduce(($e,ie)=>{const z=ie.patterns;return z?$e.concat(z):$e},[]);const Ee=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const ue=$e.charCodeAt(q-1);if(ue===47||ue===92)break}ie=$e.substr(q)}const z=Y.indexOf(ie);return z!==-1?le[z]:null};Ee.basenames=Y,Ee.patterns=le,Ee.allBasenames=Y;const ce=ye.filter($e=>!$e.basenames);return ce.push(Ee),ce}function X(ye,De){return(0,w.$sb)(ye,De,(Pe,Y)=>typeof Pe=="string"&&typeof Y=="string"?Pe===Y:typeof Pe!="string"&&typeof Y!="string"?Pe.base===Y.base&&Pe.pattern===Y.pattern:!1)}e.$xj=X}),define(Ae[50],Re([1,0,9,121,23,15,2]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.MarkdownStringTextNewlineStyle=void 0;var h;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(h||(e.MarkdownStringTextNewlineStyle=h={}));class E{constructor(n="",c=!1){if(this.value=n,typeof this.value!="string")throw(0,w.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(n,c=0){return this.value+=a(this.supportThemeIcons?(0,M.$Tj)(n):n).replace(/([ \t]+)/g,(v,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,c){return this.value+="\n```",this.value+=n,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(n,c,v){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(n),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(n,c){const v=new RegExp((0,F.$De)(c),"g");return n.replace(v,(D,p)=>n.charAt(p-1)!=="\\"?`\\${D}`:D)}}e.$Zj=E;function g(t){return P(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$1j=g;function P(t){return t instanceof E?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$2j=P;function k(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,C.$mg)(A.URI.from(t.baseUri),A.URI.from(n.baseUri)))}e.$3j=k;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$4j=a;function b(t){return t.replace(/"/g,"&quot;")}e.$5j=b;function m(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$6j=m;function f(t){const n=[],c=t.split("|").map(D=>D.trim());t=c[0];const v=c[1];if(v){const D=/height=(\d+)/.exec(v),p=/width=(\d+)/.exec(v),r=D?D[1]:"",s=p?p[1]:"",i=isFinite(parseInt(s)),o=isFinite(parseInt(r));i&&n.push(`width="${s}"`),o&&n.push(`height="${r}"`)}return{href:t,dimensions:n}}e.$7j=f}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=void 0;function E(o,y){const{os:$,tildify:S,relative:I}=y;if(I){const l=g(o,I,$);if(typeof l=="string")return l}let u=o.fsPath;if($===1&&!F.$i?u=u.replace(/\//g,"\\"):$!==1&&F.$i&&(u=u.replace(/\\/g,"/")),$!==1&&S?.userHome){const l=S.userHome.fsPath;let R;o.scheme!==S.userHome.scheme&&o.path.startsWith(C.$ec.sep)?R=S.userHome.with({path:o.path}).fsPath:R=o.fsPath,u=a(R,l,$)}return($===1?C.$dc:C.$ec).normalize(P(u,$===1))}e.$jv=E;function g(o,y,$){const S=$===1?C.$dc:C.$ec,I=$===3?A.$jg:A.$lg,u=y.getWorkspace(),d=(0,w.$Mb)(u.folders);if(!d)return;o.scheme!==d.uri.scheme&&o.path.startsWith(C.$ec.sep)&&(o=d.uri.with({path:o.path}));const l=y.getWorkspaceFolder(o);if(!l)return;let R;if(I.isEqual(l.uri,o)?R="":R=I.relativePath(l.uri,o)??"",R&&(R=S.normalize(R)),u.folders.length>1&&!y.noPrefix){const B=l.name?l.name:I.basenameOrAuthority(l.uri);R=R?`${B} \u2022 ${R}`:B}return R}function P(o,y=F.$i){return(0,M.$Zf)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$kv=P;let k=Object.create(null);function a(o,y,$=F.OS){if($===1||!o||!y)return o;let S=k.original===y?k.normalized:void 0;S||(S=y,F.$i&&(S=(0,M.$Pf)(S)),S=`${(0,h.$Ie)(S,C.$ec.sep)}${C.$ec.sep}`,k={original:y,normalized:S});let I=o;return F.$i&&(I=(0,M.$Pf)(I)),($===3?I.startsWith(S):(0,h.$1e)(I,S))?`~/${I.substr(S.length)}`:o}e.$lv=a;function b(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$mv=b;const m="\u2026",f="\\\\",t="~";function n(o,y=C.sep){const $=new Array(o.length);let S=!1;for(let I=0;I<o.length;I++){const u=o[I];if(u===""){$[I]=`.${y}`;continue}if(!u){$[I]=u;continue}S=!0;let d="",l=u;l.indexOf(f)===0?(d=l.substr(0,l.indexOf(f)+f.length),l=l.substr(l.indexOf(f)+f.length)):l.indexOf(y)===0?(d=l.substr(0,l.indexOf(y)+y.length),l=l.substr(l.indexOf(y)+y.length)):l.indexOf(t)===0&&(d=l.substr(0,l.indexOf(t)+t.length),l=l.substr(l.indexOf(t)+t.length));const R=l.split(y);for(let B=1;S&&B<=R.length;B++)for(let V=R.length-B;S&&V>=0;V--){S=!1;let j=R.slice(V,V+B).join(y);for(let W=0;!S&&W<o.length;W++)if(W!==I&&o[W]&&o[W].indexOf(j)>-1){const O=V+B===R.length,N=V>0&&o[W].indexOf(y)>-1?y+j:j,ee=o[W].endsWith(N);S=!O||ee}if(!S){let W="";(R[0].endsWith(":")||d!=="")&&(V===1&&(V=0,B++,j=R[0]+y+j),V>0&&(W=R[0]+y),W=d+W),V>0&&(W=W+m+y),W=W+j,V+B<R.length&&(W=W+y+m),$[I]=W}}S&&($[I]=u)}return $}e.$nv=n;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function v(o,y=Object.create(null)){const $=[];let S=!1,I="";for(const u of o)if(u==="$"||S&&u==="{")I&&$.push({value:I,type:c.TEXT}),I="",S=!0;else if(u==="}"&&S){const d=y[I];if(typeof d=="string")d.length&&$.push({value:d,type:c.VARIABLE});else if(d){const l=$[$.length-1];(!l||l.type!==c.SEPARATOR)&&$.push({value:d.label,type:c.SEPARATOR})}I="",S=!1}else I+=u;return I&&!S&&$.push({value:I,type:c.TEXT}),$.filter((u,d)=>{if(u.type===c.SEPARATOR){const l=$[d-1],R=$[d+1];return[l,R].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.$ov=v;function D(o,y){return F.$j||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):o.replace(/&&|&/g,$=>$==="&"?"&&":"&")}e.$pv=D;function p(o,y){return F.$j||y?o.replace(/\(&&\w\)|&&/g,""):F.$i?o.replace(/&&|&/g,$=>$==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$qv=p;function r(o){return o.replace(/&/g,"&&")}e.$rv=r;function s(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const $=i(o.substring(0,y));return{name:$.name,parentPath:$.parentPath+o.substring(y)}}}return i(o)}e.$sv=s;function i(o){const y=o.indexOf("/")!==-1?C.$ec:C.$dc,$=y.basename(o),S=y.dirname(o);return $.length?{name:$,parentPath:S}:{name:S,parentPath:""}}}),define(Ae[132],Re([1,0,25,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=void 0;function C(k){return k.toJSON()}class F{constructor(a){this.a=a}transformIncoming(a){const b=this.a.transformIncoming(a);return b===a?a:C(M.URI.from(b))}transformOutgoing(a){const b=this.a.transformOutgoing(a);return b===a?a:C(M.URI.from(b))}transformOutgoingURI(a){const b=this.a.transformOutgoing(a);return b===a?a:M.URI.from(b)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Dm=F,e.$Em=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,a,b){if(!k||b>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return a.transformOutgoing(k);for(const m in k)if(Object.hasOwnProperty.call(k,m)){const f=A(k[m],a,b+1);f!==null&&(k[m]=f)}}return null}function h(k,a){const b=A(k,a,0);return b===null?k:b}e.$Fm=h;function E(k,a,b,m){if(!k||m>200)return null;if(typeof k=="object"){if(k.$mid===1)return b?M.URI.revive(a.transformIncoming(k)):a.transformIncoming(k);if(k instanceof w.$_d)return null;for(const f in k)if(Object.hasOwnProperty.call(k,f)){const t=E(k[f],a,b,m+1);t!==null&&(k[f]=t)}}return null}function g(k,a){const b=E(k,a,!1,0);return b===null?k:b}e.$Gm=g;function P(k,a){const b=E(k,a,!0,0);return b===null?k:b}e.$Hm=P}),define(Ae[133],Re([1,0,37,19]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iE=void 0;function C(F,A,h,E,g,P){if(Array.isArray(F)){let k=0;for(const a of F){const b=C(a,A,h,E,g,P);if(b===10)return b;b>k&&(k=b)}return k}else{if(typeof F=="string")return E?F==="*"?5:F===h?10:0:0;if(F){const{language:k,pattern:a,scheme:b,hasAccessToAllModels:m,notebookType:f}=F;if(!E&&!m)return 0;f&&g&&(A=g);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(k)if(k===h)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(f)if(f===P)t=10;else if(f==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(a){let n;if(typeof a=="string"?n=a:n={...a,base:(0,M.$fc)(a.base)},n===A.fsPath||(0,w.$sj)(n,A.fsPath))t=10;else return 0}return t}else return 0}}e.$iE=C}),define(Ae[91],Re([1,0,25,22]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I0=e.$H0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function F(k){for(let a=0,b=k.length;a<b;a+=4){const m=k[a+0],f=k[a+1],t=k[a+2],n=k[a+3];k[a+0]=n,k[a+1]=t,k[a+2]=f,k[a+3]=m}}function A(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$C()||F(a),w.$_d.wrap(a)}function h(k){const a=k.buffer;if(M.$C()||F(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const b=new Uint8Array(a.byteLength);return b.set(a),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function E(k){const a=new Uint32Array(g(k));let b=0;if(a[b++]=k.id,k.type==="full")a[b++]=1,a[b++]=k.data.length,a.set(k.data,b),b+=k.data.length;else{a[b++]=2,a[b++]=k.deltas.length;for(const m of k.deltas)a[b++]=m.start,a[b++]=m.deleteCount,m.data?(a[b++]=m.data.length,a.set(m.data,b),b+=m.data.length):a[b++]=0}return A(a)}e.$H0=E;function g(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const b of k.deltas)b.data&&(a+=b.data.length)}return a}function P(k){const a=h(k);let b=0;const m=a[b++];if(a[b++]===1){const c=a[b++],v=a.subarray(b,b+c);return b+=c,{id:m,type:"full",data:v}}const t=a[b++],n=[];for(let c=0;c<t;c++){const v=a[b++],D=a[b++],p=a[b++];let r;p>0&&(r=a.subarray(b,b+p),b+=p),n[c]={start:v,deleteCount:D,data:r}}return{id:m,type:"delta",deltas:n}}e.$I0=P}),define(Ae[134],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,123,136,134]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class k{constructor(Z,pe,Be,Ne){this.id=Z,this.name=pe,this.defaultValue=Be,this.schema=Ne}applyUpdate(Z,pe){return b(Z,pe)}compute(Z,pe,Be){return Be}}class a{constructor(Z,pe){this.newValue=Z,this.didChange=pe}}e.ApplyUpdateResult=a;function b(_,Z){if(typeof _!="object"||typeof Z!="object"||!_||!Z)return new a(Z,_!==Z);if(Array.isArray(_)||Array.isArray(Z)){const Be=Array.isArray(_)&&Array.isArray(Z)&&w.$sb(_,Z);return new a(Z,!Be)}let pe=!1;for(const Be in Z)if(Z.hasOwnProperty(Be)){const Ne=b(_[Be],Z[Be]);Ne.didChange&&(_[Be]=Ne.newValue,pe=!0)}return new a(_,pe)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,pe){return b(Z,pe)}validate(Z){return this.defaultValue}}class f{constructor(Z,pe,Be,Ne){this.id=Z,this.name=pe,this.defaultValue=Be,this.schema=Ne}applyUpdate(Z,pe){return b(Z,pe)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,pe,Be){return Be}}function t(_,Z){return typeof _>"u"?Z:_==="false"?!1:!!_}e.boolean=t;class n extends f{constructor(Z,pe,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(Z,pe,Be,Ne)}validate(Z){return t(Z,this.defaultValue)}}function c(_,Z,pe,Be){if(typeof _>"u")return Z;let Ne=parseInt(_,10);return isNaN(Ne)?Z:(Ne=Math.max(pe,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=c;class v extends f{static clampedInt(Z,pe,Be,Ne){return c(Z,pe,Be,Ne)}constructor(Z,pe,Be,Ne,Ze,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Ne,rt.maximum=Ze),super(Z,pe,Be,rt),this.minimum=Ne,this.maximum=Ze}validate(Z){return v.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function D(_,Z,pe,Be){if(typeof _>"u")return Z;const Ne=p.float(_,Z);return p.clamp(Ne,pe,Be)}e.clampedFloat=D;class p extends f{static clamp(Z,pe,Be){return Z<pe?pe:Z>Be?Be:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z>"u")return pe;const Be=parseFloat(Z);return isNaN(Be)?pe:Be}constructor(Z,pe,Be,Ne,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Be),super(Z,pe,Be,Ze),this.validationFn=Ne}validate(Z){return this.validationFn(p.float(Z,this.defaultValue))}}class r extends f{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(Z,pe,Be,Ne)}validate(Z){return r.string(Z,this.defaultValue)}}function s(_,Z,pe,Be){return typeof _!="string"?Z:Be&&_ in Be?Be[_]:pe.indexOf(_)===-1?Z:_}e.stringSet=s;class i extends f{constructor(Z,pe,Be,Ne,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ne,Ze.default=Be),super(Z,pe,Be,Ze),this.c=Ne}validate(Z){return s(Z,this.defaultValue,this.c)}}class o extends k{constructor(Z,pe,Be,Ne,Ze,rt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Ze,gt.default=Ne),super(Z,pe,Be,gt),this.c=Ze,this.d=rt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function y(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",tags:["accessibility"],description:h.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,Be){return Be===0?Z.accessibilitySupport:Be}}class S extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:h.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function u(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(d||(e.TextEditorCursorStyle=d={}));function l(_){switch(_){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function R(_){switch(_){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class B extends m{constructor(){super(140)}compute(Z,pe,Be){const Ne=["monaco-editor"];return pe.get(39)&&Ne.push(pe.get(39)),Z.extraEditorClassName&&Ne.push(Z.extraEditorClassName),pe.get(73)==="default"?Ne.push("mouse-default"):pe.get(73)==="copy"&&Ne.push("mouse-copy"),pe.get(110)&&Ne.push("showUnused"),pe.get(138)&&Ne.push("showDeprecated"),Ne.join(" ")}}class V extends n{constructor(){super(37,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(Z,pe,Be){return Be&&Z.emptySelectionClipboard}}class j extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:h.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:h.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class W extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?W.OFF:Z==="true"?W.ON:Z:Z?W.ON:W.OFF}}e.EditorFontLigatures=W;class O extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:h.localize(22,null)},{type:"string",description:h.localize(23,null)}],description:h.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?O.OFF:Z==="true"?O.TRANSLATE:Z:Z?O.TRANSLATE:O.OFF}compute(Z,pe,Be){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends m{constructor(){super(50)}compute(Z,pe,Be){return Z.fontInfo}}class ee extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(25,null)})}validate(Z){const pe=p.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(Z,pe,Be){return Z.fontInfo.fontSize}}class X extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:h.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(v.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class ye extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[h.localize(28,null),h.localize(29,null),h.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:h.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:h.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:h.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Be,description:h.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Be,description:h.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Be,description:h.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Be,description:h.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Be,description:h.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends k{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:h.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:h.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:h.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:h.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:h.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:v.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:v.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class Y extends m{constructor(){super(143)}compute(Z,pe,Be){return Y.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,Be=Math.floor(Z.paddingTop/Z.lineHeight);let Ne=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ne=Math.max(Ne,pe-1));const Ze=(Be+Z.viewLineCount+Ne)/(Z.pixelRatio*Z.height),rt=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Ze,minimapLineCount:rt}}static c(Z,pe){const Be=Z.outerWidth,Ne=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const rt=pe.stableMinimapLayoutInput,gt=rt&&Z.outerHeight===rt.outerHeight&&Z.lineHeight===rt.lineHeight&&Z.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===rt.pixelRatio&&Z.scrollBeyondLastLine===rt.scrollBeyondLastLine&&Z.paddingTop===rt.paddingTop&&Z.paddingBottom===rt.paddingBottom&&Z.minimap.enabled===rt.minimap.enabled&&Z.minimap.side===rt.minimap.side&&Z.minimap.size===rt.minimap.size&&Z.minimap.showSlider===rt.minimap.showSlider&&Z.minimap.renderCharacters===rt.minimap.renderCharacters&&Z.minimap.maxColumn===rt.minimap.maxColumn&&Z.minimap.scale===rt.minimap.scale&&Z.verticalScrollbarWidth===rt.verticalScrollbarWidth&&Z.isViewportWrapping===rt.isViewportWrapping,yt=Z.lineHeight,Pt=Z.typicalHalfwidthCharacterWidth,Zt=Z.scrollBeyondLastLine,qt=Z.minimap.renderCharacters;let bt=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const jt=Z.minimap.maxColumn,Ft=Z.minimap.size,Ut=Z.minimap.side,At=Z.verticalScrollbarWidth,Rt=Z.viewLineCount,Ot=Z.remainingWidth,Bt=Z.isViewportWrapping,Kt=qt?2:3;let Wt=Math.floor(Ze*Ne);const at=Wt/Ze;let ut=!1,Ht=!1,Ct=Kt*bt,Dt=bt/Ze,ht=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:ge,extraLinesBeyondLastLine:H,desiredRatio:Le,minimapLineCount:Ue}=Y.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Zt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ne,lineHeight:yt,pixelRatio:Ze});if(Rt/Ue>1)ut=!0,Ht=!0,bt=1,Ct=1,Dt=bt/Ze;else{let We=!1,et=bt+1;if(Ft==="fit"){const pt=Math.ceil((ge+Rt+H)*Ct);Bt&&gt&&Ot<=pe.stableFitRemainingWidth?(We=!0,et=pe.stableFitMaxMinimapScale):We=pt>Wt}if(Ft==="fill"||We){ut=!0;const pt=bt;Ct=Math.min(yt*Ze,Math.max(1,Math.floor(1/Le))),Bt&&gt&&Ot<=pe.stableFitRemainingWidth&&(et=pe.stableFitMaxMinimapScale),bt=Math.min(et,Math.max(1,Math.floor(Ct/Kt))),bt>pt&&(ht=Math.min(2,bt/pt)),Dt=bt/Ze/ht,Wt=Math.ceil(Math.max(Me,ge+Rt+H)*Ct),Bt?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=Ot,pe.stableFitMaxMinimapScale=bt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const St=Math.floor(jt*Dt),Tt=Math.min(St,Math.max(0,Math.floor((Ot-At-2)*Dt/(Pt+Dt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Ze*Tt);const qe=Et/Ze;Et=Math.floor(Et*ht);const Nt=qt?1:2,Ce=Ut==="left"?0:Be-Tt-At;return{renderMinimap:Nt,minimapLeft:Ce,minimapWidth:Tt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ht,minimapScale:bt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(Z,pe){const Be=pe.outerWidth|0,Ne=pe.outerHeight|0,Ze=pe.lineHeight|0,rt=pe.lineNumbersDigitCount|0,gt=pe.typicalHalfwidthCharacterWidth,yt=pe.maxDigitWidth,Pt=pe.pixelRatio,Zt=pe.viewLineCount,qt=Z.get(135),bt=qt==="inherit"?Z.get(134):qt,jt=bt==="inherit"?Z.get(130):bt,Ft=Z.get(133),Ut=pe.isDominatedByLongLines,At=Z.get(57),Rt=Z.get(67).renderType!==0,Ot=Z.get(68),Bt=Z.get(104),Kt=Z.get(83),Wt=Z.get(72),at=Z.get(102),ut=at.verticalScrollbarSize,Ht=at.verticalHasArrows,Ct=at.arrowSize,Dt=at.horizontalScrollbarSize,ht=Z.get(43),St=Z.get(109)!=="never";let Tt=Z.get(65);ht&&St&&(Tt+=16);let Et=0;if(Rt){const dt=Math.max(rt,Ot);Et=Math.round(dt*yt)}let qe=0;At&&(qe=Ze*pe.glyphMarginDecorationLaneCount);let Nt=0,Ce=Nt+qe,Me=Ce+Et,ge=Me+Tt;const H=Be-qe-Et-Tt;let Le=!1,Ue=!1,Ge=-1;bt==="inherit"&&Ut?(Le=!0,Ue=!0):jt==="on"||jt==="bounded"?Ue=!0:jt==="wordWrapColumn"&&(Ge=Ft);const We=Y.c({outerWidth:Be,outerHeight:Ne,lineHeight:Ze,typicalHalfwidthCharacterWidth:gt,pixelRatio:Pt,scrollBeyondLastLine:Bt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:Wt,verticalScrollbarWidth:ut,viewLineCount:Zt,remainingWidth:H,isViewportWrapping:Ue},pe.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Nt+=We.minimapWidth,Ce+=We.minimapWidth,Me+=We.minimapWidth,ge+=We.minimapWidth);const et=H-We.minimapWidth,pt=Math.max(1,Math.floor((et-ut-2)/gt)),vt=Ht?Ct:0;return Ue&&(Ge=Math.max(1,pt),jt==="bounded"&&(Ge=Math.min(Ge,Ft))),{width:Be,height:Ne,glyphMarginLeft:Nt,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ce,lineNumbersWidth:Et,decorationsLeft:Me,decorationsWidth:Tt,contentLeft:ge,contentWidth:et,minimap:We,viewportColumn:pt,isWordWrapMinified:Le,isViewportWrapping:Ue,wrappingColumn:Ge,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Dt,overviewRuler:{top:vt,width:ut,height:Ne-2*vt,right:0}}}}e.EditorLayoutInfoComputer=Y;class le extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[h.localize(47,null),h.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:h.localize(49,null)}})}validate(Z){return s(Z,"simple",["simple","advanced"])}compute(Z,pe,Be){return pe.get(2)===2?"advanced":Be}}class Ee extends k{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:h.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class ce extends k{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:h.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:h.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:h.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:h.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends k{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:h.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[h.localize(56,null),h.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),h.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),h.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:h.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:h.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:h.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):v.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,pe,Be){return Be<0?v.clampedInt(-Be*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class z extends p{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>p.clamp(Z,0,150),{markdownDescription:h.localize(63,null)})}compute(Z,pe,Be){return Z.fontInfo.lineHeight}}class q extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:h.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:h.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:Z.size,description:h.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:h.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:h.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:h.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:h.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(pe.scale,1,1,3),maxColumn:v.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class we extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:v.clampedInt(pe.top,0,0,1e3),bottom:v.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends k{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:h.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:h.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class me extends m{constructor(){super(141)}compute(Z,pe,Be){return Z.pixelRatio}}class ke extends k{constructor(){const Z={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[h.localize(79,null),h.localize(80,null),h.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Z.strings,description:h.localize(82,null)},comments:{anyOf:pe,default:Z.comments,description:h.localize(83,null)},other:{anyOf:pe,default:Z.other,description:h.localize(84,null)}},default:Z,markdownDescription:h.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Pt=Z?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:pe,comments:Be,strings:Ne}=Z,Ze=["on","inline","off"];let rt,gt,yt;return typeof pe=="boolean"?rt=pe?"on":"off":rt=s(pe,this.defaultValue.other,Ze),typeof Be=="boolean"?gt=Be?"on":"off":gt=s(Be,this.defaultValue.comments,Ze),typeof Ne=="boolean"?yt=Ne?"on":"off":yt=s(Ne,this.defaultValue.strings,Ze),{other:rt,comments:gt,strings:yt}}}var re;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class he extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(86,null),h.localize(87,null),h.localize(88,null),h.localize(89,null)],default:"on",description:h.localize(90,null)})}validate(Z){let pe=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(pe=4,Be=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:Be}}}function se(_){const Z=_.get(97);return Z==="editable"?_.get(90):Z!=="on"}e.filterValidationDecorations=se;class oe extends k{constructor(){const Z=[],pe={type:"number",description:h.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:h.localize(92,null),format:"color-hex"}}}]},default:Z,description:h.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const pe=[];for(const Be of Z)if(typeof Be=="number")pe.push({column:v.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;pe.push({column:v.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return pe.sort((Be,Ne)=>Be.column-Ne.column),pe}return this.defaultValue}}class de extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ie(_,Z){if(typeof _!="string")return Z;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class L extends k{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(94,null),h.localize(95,null),h.localize(96,null)],default:"auto",description:h.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(98,null),h.localize(99,null),h.localize(100,null)],default:"auto",description:h.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:h.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:h.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:h.localize(104,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,Be=v.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=v.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:v.clampedInt(pe.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:v.clampedInt(pe.verticalSliderSize,Ne,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:h.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:h.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:h.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:h.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:h.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:h.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:h.localize(111,null)}})}applyUpdate(Z,pe){let Be=!1;pe.allowedCharacters&&Z&&(M.$2m(Z.allowedCharacters,pe.allowedCharacters)||(Z={...Z,allowedCharacters:pe.allowedCharacters},Be=!0)),pe.allowedLocales&&Z&&(M.$2m(Z.allowedLocales,pe.allowedLocales)||(Z={...Z,allowedLocales:pe.allowedLocales},Be=!0));const Ne=super.applyUpdate(Z,pe);return Be?new a(Ne.newValue,!0):Ne}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,pe){if(typeof Z!="object"||!Z)return pe;const Be={};for(const[Ne,Ze]of Object.entries(Z))Ze===!0&&(Be[Ne]=!0);return Be}}class G extends k{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:h.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[h.localize(113,null),h.localize(114,null)],description:h.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:h.localize(116,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends k{constructor(){const Z={enabled:F.$Wr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Wr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:h.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:h.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends k{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(119,null),h.localize(120,null),h.localize(121,null)],default:Z.bracketPairs,description:h.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(123,null),h.localize(124,null),h.localize(125,null)],default:Z.bracketPairsHorizontal,description:h.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:h.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:h.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[h.localize(129,null),h.localize(130,null),h.localize(131,null)],default:Z.highlightActiveIndentation,description:h.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,Z,pe){const Be=pe.indexOf(_);return Be===-1?Z:pe[Be]}class ae extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(133,null),h.localize(134,null)],default:Z.insertMode,description:h.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:h.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:h.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:h.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[h.localize(139,null),h.localize(140,null),h.localize(141,null),h.localize(142,null)],default:Z.selectionMode,markdownDescription:h.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:h.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:h.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:h.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:h.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:h.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:h.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(180,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Fe extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:h.localize(182,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[h.localize(183,null),h.localize(184,null),h.localize(185,null),h.localize(186,null)],description:h.localize(187,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,pe,Be){return pe.get(2)===2?0:Be}}class He extends m{constructor(){super(144)}compute(Z,pe,Be){const Ne=pe.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class _e extends k{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:h.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:h.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[h.localize(190,null),h.localize(191,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends k{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:h.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:h.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[h.localize(194,null),h.localize(195,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:xe,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new n(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(196,null)})),acceptSuggestionOnEnter:ze(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(197,null),""],markdownDescription:h.localize(198,null)})),accessibilitySupport:ze(new $),accessibilityPageSize:ze(new v(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",h.localize(200,null))),ariaRequired:ze(new n(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new n(8,"screenReaderAnnounceInlineSuggestion",!0,{description:h.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new i(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(202,null),h.localize(203,null),""],description:h.localize(204,null)})),autoClosingComments:ze(new i(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(205,null),h.localize(206,null),""],description:h.localize(207,null)})),autoClosingDelete:ze(new i(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(208,null),""],description:h.localize(209,null)})),autoClosingOvertype:ze(new i(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(210,null),""],description:h.localize(211,null)})),autoClosingQuotes:ze(new i(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(212,null),h.localize(213,null),""],description:h.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[h.localize(215,null),h.localize(216,null),h.localize(217,null),h.localize(218,null),h.localize(219,null)],description:h.localize(220,null)})),automaticLayout:ze(new n(13,"automaticLayout",!1)),autoSurround:ze(new i(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(221,null),h.localize(222,null),h.localize(223,null),""],description:h.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new J),stickyTabStops:ze(new n(115,"stickyTabStops",!1,{description:h.localize(225,null)})),codeLens:ze(new n(17,"codeLens",!0,{description:h.localize(226,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:h.localize(227,null)})),codeLensFontSize:ze(new v(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(228,null)})),colorDecorators:ze(new n(20,"colorDecorators",!0,{description:h.localize(229,null)})),colorDecoratorActivatedOn:ze(new i(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[h.localize(230,null),h.localize(231,null),h.localize(232,null)],description:h.localize(233,null)})),colorDecoratorsLimit:ze(new v(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:h.localize(234,null)})),columnSelection:ze(new n(22,"columnSelection",!1,{description:h.localize(235,null)})),comments:ze(new S),contextmenu:ze(new n(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new n(25,"copyWithSyntaxHighlighting",!0,{description:h.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:h.localize(237,null)})),cursorSmoothCaretAnimation:ze(new i(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[h.localize(238,null),h.localize(239,null),h.localize(240,null)],description:h.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:h.localize(242,null)})),cursorSurroundingLines:ze(new v(29,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(243,null)})),cursorSurroundingLinesStyle:ze(new i(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(244,null),h.localize(245,null)],markdownDescription:h.localize(246,null)})),cursorWidth:ze(new v(31,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(247,null)})),disableLayerHinting:ze(new n(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new n(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new n(34,"domReadOnly",!1)),dragAndDrop:ze(new n(35,"dragAndDrop",!0,{description:h.localize(248,null)})),emptySelectionClipboard:ze(new V),dropIntoEditor:ze(new _e),stickyScroll:ze(new ce),experimentalWhitespaceRendering:ze(new i(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[h.localize(249,null),h.localize(250,null),h.localize(251,null)],description:h.localize(252,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new p(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:h.localize(253,null)})),find:ze(new j),fixedOverflowWidgets:ze(new n(42,"fixedOverflowWidgets",!1)),folding:ze(new n(43,"folding",!0,{description:h.localize(254,null)})),foldingStrategy:ze(new i(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),foldingHighlight:ze(new n(45,"foldingHighlight",!0,{description:h.localize(258,null)})),foldingImportsByDefault:ze(new n(46,"foldingImportsByDefault",!1,{description:h.localize(259,null)})),foldingMaximumRegions:ze(new v(47,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new n(48,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(261,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new W),fontSize:ze(new ee),fontWeight:ze(new X),fontVariations:ze(new O),formatOnPaste:ze(new n(55,"formatOnPaste",!1,{description:h.localize(263,null)})),formatOnType:ze(new n(56,"formatOnType",!1,{description:h.localize(264,null)})),glyphMargin:ze(new n(57,"glyphMargin",!0,{description:h.localize(265,null)})),gotoLocation:ze(new ye),hideCursorInOverviewRuler:ze(new n(59,"hideCursorInOverviewRuler",!1,{description:h.localize(266,null)})),hover:ze(new De),inDiffEditor:ze(new n(61,"inDiffEditor",!1)),letterSpacing:ze(new p(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>p.clamp(_,-5,20),{description:h.localize(267,null)})),lightbulb:ze(new Ee),lineDecorationsWidth:ze(new ie),lineHeight:ze(new z),lineNumbers:ze(new he),lineNumbersMinChars:ze(new v(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new n(69,"linkedEditing",!1,{description:h.localize(268,null)})),links:ze(new n(70,"links",!0,{description:h.localize(269,null)})),matchBrackets:ze(new i(71,"matchBrackets","always",["always","near","never"],{description:h.localize(270,null)})),minimap:ze(new q),mouseStyle:ze(new i(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new p(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:h.localize(271,null)})),mouseWheelZoom:ze(new n(75,"mouseWheelZoom",!1,{markdownDescription:h.localize(272,null)})),multiCursorMergeOverlapping:ze(new n(76,"multiCursorMergeOverlapping",!0,{description:h.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[h.localize(274,null),h.localize(275,null)],markdownDescription:h.localize(276,null)})),multiCursorPaste:ze(new i(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(277,null),h.localize(278,null)],markdownDescription:h.localize(279,null)})),multiCursorLimit:ze(new v(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:h.localize(280,null)})),occurrencesHighlight:ze(new n(80,"occurrencesHighlight",!0,{description:h.localize(281,null)})),overviewRulerBorder:ze(new n(81,"overviewRulerBorder",!0,{description:h.localize(282,null)})),overviewRulerLanes:ze(new v(82,"overviewRulerLanes",3,0,3)),padding:ze(new we),pasteAs:ze(new Ye),parameterHints:ze(new ve),peekWidgetDefaultFocus:ze(new i(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(283,null),h.localize(284,null)],description:h.localize(285,null)})),definitionLinkOpensInPeek:ze(new n(87,"definitionLinkOpensInPeek",!1,{description:h.localize(286,null)})),quickSuggestions:ze(new ke),quickSuggestionsDelay:ze(new v(89,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(287,null)})),readOnly:ze(new n(90,"readOnly",!1)),readOnlyMessage:ze(new de),renameOnType:ze(new n(92,"renameOnType",!1,{description:h.localize(288,null),markdownDeprecationMessage:h.localize(289,null)})),renderControlCharacters:ze(new n(93,"renderControlCharacters",!0,{description:h.localize(290,null),restricted:!0})),renderFinalNewline:ze(new i(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:h.localize(291,null)})),renderLineHighlight:ze(new i(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(292,null)],description:h.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new n(96,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(294,null)})),renderValidationDecorations:ze(new i(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new i(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(295,null),h.localize(296,null),h.localize(297,null),""],description:h.localize(298,null)})),revealHorizontalRightPadding:ze(new v(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new n(100,"roundedSelection",!0,{description:h.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new L),scrollBeyondLastColumn:ze(new v(103,"scrollBeyondLastColumn",4,0,1073741824,{description:h.localize(300,null)})),scrollBeyondLastLine:ze(new n(104,"scrollBeyondLastLine",!0,{description:h.localize(301,null)})),scrollPredominantAxis:ze(new n(105,"scrollPredominantAxis",!0,{description:h.localize(302,null)})),selectionClipboard:ze(new n(106,"selectionClipboard",!0,{description:h.localize(303,null),included:C.$k})),selectionHighlight:ze(new n(107,"selectionHighlight",!0,{description:h.localize(304,null)})),selectOnLineNumbers:ze(new n(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new i(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[h.localize(305,null),h.localize(306,null),h.localize(307,null)],description:h.localize(308,null)})),showUnused:ze(new n(110,"showUnused",!0,{description:h.localize(309,null)})),showDeprecated:ze(new n(138,"showDeprecated",!0,{description:h.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new i(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(311,null),h.localize(312,null),h.localize(313,null),h.localize(314,null)],description:h.localize(315,null)})),smartSelect:ze(new Fe),smoothScrolling:ze(new n(113,"smoothScrolling",!1,{description:h.localize(316,null)})),stopRenderingLineAfter:ze(new v(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ae),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new n(147,"inlineCompletionsAccessibilityVerbose",!1,{description:h.localize(317,null)})),suggestFontSize:ze(new v(118,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new v(119,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new n(120,"suggestOnTriggerCharacters",!0,{description:h.localize(320,null)})),suggestSelection:ze(new i(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(321,null),h.localize(322,null),h.localize(323,null)],description:h.localize(324,null)})),tabCompletion:ze(new i(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(325,null),h.localize(326,null),h.localize(327,null)],description:h.localize(328,null)})),tabIndex:ze(new v(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new i(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(329,null),h.localize(330,null),h.localize(331,null)],description:h.localize(332,null)})),useShadowDOM:ze(new n(126,"useShadowDOM",!0)),useTabStops:ze(new n(127,"useTabStops",!0,{description:h.localize(333,null)})),wordBreak:ze(new i(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[h.localize(334,null),h.localize(335,null)],description:h.localize(336,null)})),wordSeparators:ze(new r(129,"wordSeparators",A.$Xr,{description:h.localize(337,null)})),wordWrap:ze(new i(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(338,null),h.localize(339,null),h.localize(340,null),h.localize(341,null)],description:h.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new v(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(343,null)})),wordWrapOverride1:ze(new i(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new i(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new B),defaultColorDecorators:ze(new n(145,"defaultColorDecorators",!1,{markdownDescription:h.localize(344,null)})),pixelRatio:ze(new me),tabFocusMode:ze(new n(142,"tabFocusMode",!1,{markdownDescription:h.localize(345,null)})),layoutInfo:ze(new Y),wrappingInfo:ze(new He),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new le)}}),define(Ae[137],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function F(...g){switch(g.length){case 1:return(0,M.localize)(0,null,g[0]);case 2:return(0,M.localize)(1,null,g[0],g[1]);case 3:return(0,M.localize)(2,null,g[0],g[1],g[2]);default:return}}const A=(0,M.localize)(3,null),h=(0,M.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const k=this.d,a=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:a};this.g.push({offset:k,lexeme:a,additionalInfo:P}),this.f.push(b)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const k=this.c.substring(this.d,this.e),a=E.b.get(k);a?this.k(a):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,k=!1,a=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(h);return}const m=this.c.charCodeAt(P);if(k)k=!1;else if(m===47&&!a){P++;break}else m===91?a=!0:m===92?k=!0:m===93&&(a=!1);P++}for(;P<this.c.length&&E.a.has(this.c.charCodeAt(P));)P++;this.e=P;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Hi=E}),define(Ae[169],Re([1,0,23,29,141,276]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,h=/^-(\d{4})(\d{2})(\d{2})$/;function E(n){return n=n.trim(),n==="*"||A.test(n)}e.$Do=E;function g(n){if(!E(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=n.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Eo=g;function P(n){if(!n)return null;const c=n.majorBase,v=n.majorMustEqual,D=n.minorBase;let p=n.minorMustEqual;const r=n.patchBase;let s=n.patchMustEqual;n.hasCaret&&(c===0||(p=!1),s=!1);let i=0;if(n.preRelease){const o=h.exec(n.preRelease);if(o){const[,y,$,S]=o;i=Date.UTC(Number(y),Number($)-1,Number(S))}}return{majorBase:c,majorMustEqual:v,minorBase:D,minorMustEqual:p,patchBase:r,patchMustEqual:s,isMinimum:n.hasGreaterEquals,notBefore:i}}e.$Fo=P;function k(n,c,v){let D;typeof n=="string"?D=P(g(n)):D=n;let p;c instanceof Date?p=c.getTime():typeof c=="string"&&(p=new Date(c).getTime());let r;if(typeof v=="string"?r=P(g(v)):r=v,!D||!r)return!1;const s=D.majorBase,i=D.minorBase,o=D.patchBase;let y=r.majorBase,$=r.minorBase,S=r.patchBase;const I=r.notBefore;let u=r.majorMustEqual,d=r.minorMustEqual,l=r.patchMustEqual;return r.isMinimum?s>y?!0:s<y?!1:i>$?!0:i<$||p&&p<I?!1:o>=S:(s===1&&y===0&&(!u||!d||!l)&&(y=1,$=0,S=0,u=!0,d=!1,l=!1),s<y?!1:s>y?!u:i<$?!1:i>$?!d:o<S?!1:o>S?!l:!(p&&p<I))}e.$Go=k;function a(n,c,v,D,p){const r=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return r.push([M.default.Error,C.localize(0,null)]),r;if(typeof D.name!="string")return r.push([M.default.Error,C.localize(1,null,"name")]),r;if(typeof D.version!="string")return r.push([M.default.Error,C.localize(2,null,"version")]),r;if(!D.engines)return r.push([M.default.Error,C.localize(3,null,"engines")]),r;if(typeof D.engines.vscode!="string")return r.push([M.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof D.extensionDependencies<"u"&&!t(D.extensionDependencies))return r.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof D.activationEvents<"u"){if(!t(D.activationEvents))return r.push([M.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof D.main>"u"&&typeof D.browser>"u")return r.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&r.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return r.push([M.default.Error,C.localize(9,null,"main")]),r;{const o=(0,w.$tg)(v,D.main);(0,w.$ng)(o,v)||r.push([M.default.Warning,C.localize(10,null,o.path,v.path)])}}if(typeof D.browser<"u"){if(typeof D.browser!="string")return r.push([M.default.Error,C.localize(11,null,"browser")]),r;{const o=(0,w.$tg)(v,D.browser);(0,w.$ng)(o,v)||r.push([M.default.Warning,C.localize(12,null,o.path,v.path)])}}if(!F.valid(D.version))return r.push([M.default.Error,C.localize(13,null)]),r;const s=[];if(!b(n,c,D,p,s))for(const o of s)r.push([M.default.Error,o]);return r}e.$Ho=a;function b(n,c,v,D,p){return D||typeof v.main>"u"&&typeof v.browser>"u"?!0:f(n,c,v.engines.vscode,p)}e.$Io=b;function m(n,c,v){return n==="*"||f(c,v,n)}e.$Jo=m;function f(n,c,v,D=[]){const p=P(g(v));if(!p)return D.push(C.localize(14,null,v)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return D.push(C.localize(15,null,v)),!1}else if(!p.majorMustEqual)return D.push(C.localize(16,null,v)),!1;return k(n,c,p)?!0:(D.push(C.localize(17,null,n,v)),!1)}function t(n){if(!Array.isArray(n))return!1;for(let c=0,v=n.length;c<v;c++)if(typeof n[c]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class w{constructor(C,F=[],A=!1){this.ctor=C,this.staticArguments=F,this.supportsDelayedInstantiation=A}}e.$Jh=w}),define(Ae[70],Re([1,0,69]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.InstantiationType=void 0;const M=[];var C;(function(h){h[h.Eager=0]="Eager",h[h.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function F(h,E,g){E instanceof w.$Jh||(E=new w.$Jh(E,[],!!g)),M.push([h,E])}e.$or=F;function A(){return M}e.$pr=A}),define(Ae[170],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class w{constructor(F,A){this.key=F,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$6p=w;class M{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const A of this.a.values())A.outgoing.size===0&&F.push(A);return F}insertEdge(F,A){const h=this.lookupOrInsertNode(F),E=this.lookupOrInsertNode(A);h.outgoing.set(E.key,E),E.incoming.set(h.key,h)}removeNode(F){const A=this.b(F);this.a.delete(A);for(const h of this.a.values())h.outgoing.delete(A),h.incoming.delete(A)}lookupOrInsertNode(F){const A=this.b(F);let h=this.a.get(A);return h||(h=new w(A,F),this.a.set(A,h)),h}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[A,h]of this.a)F.push(`${A}
	(-> incoming)[${[...h.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...h.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,A]of this.a){const h=new Set([F]),E=this.c(A,h);if(E)return E}}c(F,A){for(const[h,E]of F.outgoing){if(A.has(h))return[...A,h].join(" -> ");A.add(h);const g=this.c(E,A);if(g)return g;A.delete(h)}}}e.$7p=M}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function h(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=h})(w||(e._util=w={})),e.$Lh=C("instantiationService");function M(A,h,E){h[w.DI_TARGET]===h?h[w.DI_DEPENDENCIES].push({id:A,index:E}):(h[w.DI_DEPENDENCIES]=[{id:A,index:E}],h[w.DI_TARGET]=h)}function C(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const h=function(E,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(h,E,P)};return h.toString=()=>A,w.serviceIds.set(A,h),h}e.$Mh=C;function F(A){return A}e.$Nh=F}),define(Ae[43],Re([1,0,16,2,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.ConfigurationTarget=e.$ii=e.$hi=e.$gi=void 0,e.$gi=(0,C.$Mh)("configurationService");function F(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof M.URI)}e.$hi=F;function A(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof M.URI)}e.$ii=A;var h;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(h||(e.ConfigurationTarget=h={}));function E(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ji=E;function g(n){return n.applicationValue!==void 0||n.userValue!==void 0||n.userLocalValue!==void 0||n.userRemoteValue!==void 0||n.workspaceValue!==void 0||n.workspaceFolderValue!==void 0}e.$ki=g;function P(n,c){const v=Object.create(null);for(const D in n)k(v,D,n[D],c);return v}e.$li=P;function k(n,c,v,D){const p=c.split("."),r=p.pop();let s=n;for(let i=0;i<p.length;i++){const o=p[i];let y=s[o];switch(typeof y){case"undefined":y=s[o]=Object.create(null);break;case"object":break;default:D(`Ignoring ${c} as ${p.slice(0,i+1).join(".")} is ${JSON.stringify(y)}`);return}s=y}if(typeof s=="object"&&s!==null)try{s[r]=v}catch{D(`Ignoring ${c} as ${p.join(".")} is ${JSON.stringify(s)}`)}else D(`Ignoring ${c} as ${p.join(".")} is ${JSON.stringify(s)}`)}e.$mi=k;function a(n,c){const v=c.split(".");b(n,v)}e.$ni=a;function b(n,c){const v=c.shift();if(c.length===0){delete n[v];return}if(Object.keys(n).indexOf(v)!==-1){const D=n[v];typeof D=="object"&&!Array.isArray(D)&&(b(D,c),Object.keys(D).length===0&&delete n[v])}}function m(n,c,v){function D(s,i){let o=s;for(const y of i){if(typeof o!="object"||o===null)return;o=o[y]}return o}const p=c.split("."),r=D(n,p);return typeof r>"u"?v:r}e.$oi=m;function f(n,c,v){Object.keys(c).forEach(D=>{D!=="__proto__"&&(D in n?w.$yf(n[D])&&w.$yf(c[D])?f(n[D],c[D],v):v&&(n[D]=c[D]):n[D]=c[D])})}e.$pi=f;function t(n){return n.replace(/[\[\]]/g,"")}e.$qi=t}),define(Ae[32],Re([1,0,22,15,168,4,138,9]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.ContextKeyExprType=e.$Ii=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",w.$j),E.set("isLinux",w.$k),E.set("isWindows",w.$i),E.set("isWeb",w.$o),E.set("isMacNative",w.$j&&!w.$o),E.set("isEdge",w.$G),E.set("isFirefox",w.$E),E.set("isChrome",w.$D),E.set("isSafari",w.$F);function g(ie,z){if(E.get(ie)!==void 0)throw(0,h.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(ie,z)}e.$Ii=g;const P=Object.prototype.hasOwnProperty;var k;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const a={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),m=(0,A.localize)(1,null),f=(0,A.localize)(2,null),t=(0,A.localize)(3,null),n=(0,A.localize)(4,null),c=(0,A.localize)(5,null),v=(0,A.localize)(6,null),D=(0,A.localize)(7,null);class p{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=a){this.k=z,this.d=new C.$Hi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const ue=this.D(),we=ue.type===17?c:void 0;throw this.h.push({message:n,offset:ue.offset,lexeme:C.$Hi.getLexeme(ue),additionalInfo:we}),p.c}return q}catch(q){if(q!==p.c)throw q;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const q=this.o();z.push(q)}return z.length===1?z[0]:r.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const q=this.s();z.push(q)}return z.length===1?z[0]:r.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,t),q?.negate()}case 17:return this.z(),R.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const q=this.l();return this.A(1,t),q}case 17:{const q=z.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,me=ve.lastIndexOf("/"),ke=me===ve.length-1?void 0:this.w(ve.substring(me+1));let re;try{re=new RegExp(ve.substring(1,me),ke)}catch{throw this.B("REGEX",we)}return N.create(q,re)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let me=this.D(),ke=0;for(let de=0;de<we.lexeme.length;de++)we.lexeme.charCodeAt(de)===40?ke++:we.lexeme.charCodeAt(de)===41&&ke--;for(;!this.E()&&me.type!==15&&me.type!==16;){switch(me.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let de=0;de<me.lexeme.length;de++)me.lexeme.charCodeAt(de)===40?ke++:we.lexeme.charCodeAt(de)===41&&ke--}if(ke<0)break;ve.push(C.$Hi.getLexeme(me)),this.z(),me=this.D()}const re=ve.join(""),he=re.lastIndexOf("/"),se=he===re.length-1?void 0:this.w(re.substring(he+1));let oe;try{oe=new RegExp(re.substring(1,he),se)}catch{throw this.B("REGEX",we)}return r.regex(q,oe)}case 18:{const ve=we.lexeme;this.z();let me=null;if(!(0,M.$ze)(ve)){const ke=ve.indexOf("/"),re=ve.lastIndexOf("/");if(ke!==re&&ke>=0){const he=ve.slice(ke+1,re),se=ve[re+1]==="i"?"i":"";try{me=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(me===null)throw this.B("REGEX",we);return N.create(q,me)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const we=this.u();return r.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return r.equals(q,we);switch(we){case"true":return r.has(q);case"false":return r.not(q);default:return r.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return r.notEquals(q,we);switch(we){case"true":return r.not(q);case"false":return r.has(q);default:return r.notEquals(q,we)}}case 5:return this.z(),W.create(q,this.u());case 6:return this.z(),O.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),j.create(q,this.u());case 13:return this.z(),r.in(q,this.u());default:return r.has(q)}}case 20:throw this.h.push({message:v,offset:z.offset,lexeme:"",additionalInfo:D}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,q){if(this.C(z))return this.z();throw this.B(q,this.D())}B(z,q,ue){const we=(0,A.localize)(8,null,z,C.$Hi.getLexeme(q)),ve=q.offset,me=C.$Hi.getLexeme(q);return this.h.push({message:we,offset:ve,lexeme:me,additionalInfo:ue}),p.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ji=p;class r{static false(){return y.INSTANCE}static true(){return $.INSTANCE}static has(z){return S.create(z)}static equals(z,q){return I.create(z,q)}static notEquals(z,q){return l.create(z,q)}static regex(z,q){return N.create(z,q)}static in(z,q){return u.create(z,q)}static notIn(z,q){return d.create(z,q)}static not(z){return R.create(z)}static and(...z){return ye.create(z,null,!0)}static or(...z){return De.create(z,null,!0)}static greater(z,q){return V.create(z,q)}static greaterEquals(z,q){return j.create(z,q)}static smaller(z,q){return W.create(z,q)}static smallerEquals(z,q){return O.create(z,q)}static{this.c=new p({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Ki=r;function s(ie){const z=new p({regexParsingWithErrorRecovery:!1});return ie.map(q=>(z.parse(q),z.lexingErrors.length>0?z.lexingErrors.map(ue=>({errorMessage:ue.additionalInfo?(0,A.localize)(9,null,ue.additionalInfo):(0,A.localize)(10,null),offset:ue.offset,length:ue.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ue=>({errorMessage:ue.additionalInfo?`${ue.message}. ${ue.additionalInfo}`:ue.message,offset:ue.offset,length:ue.lexeme.length})):[]))}e.$Li=s;function i(ie,z){const q=ie?ie.substituteConstants():void 0,ue=z?z.substituteConstants():void 0;return!q&&!ue?!0:!q||!ue?!1:q.equals(ue)}e.$Mi=i;function o(ie,z){return ie.cmp(z)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return $.INSTANCE}}e.$Ni=y;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return y.INSTANCE}}e.$Oi=$;class S{static create(z,q=null){const ue=E.get(z);return typeof ue=="boolean"?ue?$.INSTANCE:y.INSTANCE:new S(z,q)}constructor(z,q){this.key=z,this.c=q,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:Y(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=E.get(this.key);return typeof z=="boolean"?z?$.INSTANCE:y.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Pi=S;class I{static create(z,q,ue=null){if(typeof q=="boolean")return q?S.create(z,ue):R.create(z,ue);const we=E.get(z);return typeof we=="boolean"?q===(we?"true":"false")?$.INSTANCE:y.INSTANCE:new I(z,q,ue)}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?$.INSTANCE:y.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.$Qi=I;class u{static create(z,q){return new u(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:le(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.f),ue=z.getValue(this.d);return Array.isArray(q)?q.includes(ue):typeof ue=="string"&&typeof q=="object"&&q!==null?P.call(q,ue):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.$Ri=u;class d{static create(z,q){return new d(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=11,this.c=u.create(z,q)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Si=d;class l{static create(z,q,ue=null){if(typeof q=="boolean")return q?R.create(z,ue):S.create(z,ue);const we=E.get(z);return typeof we=="boolean"?q===(we?"true":"false")?y.INSTANCE:$.INSTANCE:new l(z,q,ue)}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?y.INSTANCE:$.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ti=l;class R{static create(z,q=null){const ue=E.get(z);return typeof ue=="boolean"?ue?y.INSTANCE:$.INSTANCE:new R(z,q)}constructor(z,q){this.c=z,this.d=q,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:Y(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=E.get(this.c);return typeof z=="boolean"?z?y.INSTANCE:$.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Ui=R;function B(ie,z){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?z(ie):y.INSTANCE}class V{static create(z,q,ue=null){return B(q,we=>new V(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Vi=V;class j{static create(z,q,ue=null){return B(q,we=>new j(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Wi=j;class W{static create(z,q,ue=null){return B(q,we=>new W(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Xi=W;class O{static create(z,q,ue=null){return B(q,we=>new O(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Yi=O;class N{static create(z,q){return new N(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const q=this.f?this.f.source:"",ue=z.f?z.f.source:"";return q<ue?-1:q>ue?1:0}equals(z){if(z.type===this.type){const q=this.f?this.f.source:"",ue=z.f?z.f.source:"";return this.d===z.d&&q===ue}return!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Zi=N;class ee{static create(z){return new ee(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new ee(this.c.map(z))}negate(){return this.c}}e.$1i=ee;function X(ie){let z=null;for(let q=0,ue=ie.length;q<ue;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&z===null){z=[];for(let ve=0;ve<q;ve++)z[ve]=ie[ve]}z!==null&&(z[q]=we)}return z===null?ie:z}class ye{static create(z,q,ue){return ye.d(z,q,ue)}constructor(z,q){this.expr=z,this.c=q,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=X(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].evaluate(z))return!1;return!0}static d(z,q,ue){const we=[];let ve=!1;for(const me of z)if(me){if(me.type===1){ve=!0;continue}if(me.type===0)return y.INSTANCE;if(me.type===6){we.push(...me.expr);continue}we.push(me)}if(we.length===0&&ve)return $.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];for(;we.length>1;){const me=we[we.length-1];if(me.type!==9)break;we.pop();const ke=we.pop(),re=we.length===0,he=De.create(me.expr.map(se=>ye.create([se,ke],null,ue)),null,re);he&&(we.push(he),we.sort(o))}if(we.length===1)return we[0];if(ue){for(let me=0;me<we.length;me++)for(let ke=me+1;ke<we.length;ke++)if(we[me].negate().equals(we[ke]))return y.INSTANCE;if(we.length===1)return we[0]}return new ye(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new ye(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());this.c=De.create(z,this,!0)}return this.c}}e.$2i=ye;class De{static create(z,q,ue){return De.d(z,q,ue)}constructor(z,q){this.expr=z,this.c=q,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=X(this.expr);return z===this.expr?this:De.create(z,this.c,!1)}evaluate(z){for(let q=0,ue=this.expr.length;q<ue;q++)if(this.expr[q].evaluate(z))return!0;return!1}static d(z,q,ue){let we=[],ve=!1;if(z){for(let me=0,ke=z.length;me<ke;me++){const re=z[me];if(re){if(re.type===0){ve=!0;continue}if(re.type===1)return $.INSTANCE;if(re.type===9){we=we.concat(re.expr);continue}we.push(re)}}if(we.length===0&&ve)return y.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];if(ue){for(let me=0;me<we.length;me++)for(let ke=me+1;ke<we.length;ke++)if(we[me].negate().equals(we[ke]))return $.INSTANCE;if(we.length===1)return we[0]}return new De(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new De(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());for(;z.length>1;){const q=z.shift(),ue=z.shift(),we=[];for(const ve of $e(q))for(const me of $e(ue))we.push(ye.create([ve,me],null,!1));z.unshift(De.create(we,null,!1))}this.c=De.create(z,this,!0)}return this.c}}e.$3i=De;class Pe extends S{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,q,ue){super(z,null),this.f=q,typeof ue=="object"?Pe.d.push({...ue,key:z}):ue!==!0&&Pe.d.push({key:z,description:ue,type:q!=null?typeof q:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return I.create(this.key,z)}notEqualsTo(z){return l.create(this.key,z)}}e.$4i=Pe,e.$5i=(0,F.$Mh)("contextKeyService");function Y(ie,z){return ie<z?-1:ie>z?1:0}function le(ie,z,q,ue){return ie<q?-1:ie>q?1:z<ue?-1:z>ue?1:0}function Ee(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ce(ie.expr,z.expr):!1;if(z.type===9){for(const q of z.expr)if(Ee(ie,q))return!0;return!1}if(ie.type===6){if(z.type===6)return ce(z.expr,ie.expr);for(const q of ie.expr)if(Ee(q,z))return!0;return!1}return ie.equals(z)}e.$6i=Ee;function ce(ie,z){let q=0,ue=0;for(;q<ie.length&&ue<z.length;){const we=ie[q].cmp(z[ue]);if(we<0)return!1;we===0&&q++,ue++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[171],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=void 0,e.$Th=(0,w.$Mh)("environmentService"),e.$Uh=(0,w.$Nh)(e.$Th)}),define(Ae[92],Re([1,0,140,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$2n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0,e.$On="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Pn=new RegExp(e.$On),e.$Qn="__web_extension",e.$Rn="skipWalkthrough",e.$Sn="extensionsSync",e.$Tn="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Un=C;function F(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Vn=F;function A(c,v){switch(c){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Wn=A;function h(c,v){return v==="web"&&!c.includes("web")}e.$Xn=h;function E(c,v,D){return h(v,D)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===D?!0:g(D).includes(c)}e.$Yn=E;function g(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Zn=g;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$1n=P;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var a;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var m;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$2n=(0,M.$Mh)("extensionGalleryService");var f;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class n extends Error{constructor(v,D){super(v),this.code=D,this.name=D}}e.$3n=n,e.$4n=(0,M.$Mh)("extensionManagementService"),e.$5n="extensionsIdentifiers/disabled",e.$6n="extensionsIdentifiers/enabled",e.$7n=(0,M.$Mh)("IGlobalExtensionEnablementService"),e.$8n=(0,M.$Mh)("IExtensionTipsService"),e.$9n=(0,w.localize)(0,null),e.$0n={value:e.$9n,original:"Extensions"},e.$$n={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,49,19,15,16,2,142,4,22,12]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileKind=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileOperationResult=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileChangeType=e.$mk=e.FileOperation=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileSystemProviderErrorCode=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$9j=e.$8j=void 0,e.$8j=(0,E.$Mh)("fileService");function k(Y){return Y.create===!0}e.$9j=k;var a;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var b;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var m;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function f(Y){return!!(Y.capabilities&2)}e.$0j=f;function t(Y){return!!(Y.capabilities&8)}e.$$j=t;function n(Y){return!!(Y.capabilities&131072)}e.$_j=n;function c(Y){return!!(Y.capabilities&4)}e.$ak=c;function v(Y){return!!(Y.capabilities&16)}e.$bk=v;function D(Y){return f(Y)?!!(Y.capabilities&16384):!1}e.$ck=D;function p(Y){return f(Y)?!!(Y.capabilities&32768):!1}e.$dk=p;function r(Y){return!!(Y.capabilities&65536)}e.$ek=r;function s(Y){return!!(Y.capabilities&2048)}e.$fk=s;var i;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class o extends Error{static create(le,Ee){const ce=new o(le.toString(),Ee);return S(ce,Ee),ce}constructor(le,Ee){super(le),this.code=Ee}}e.$gk=o;function y(Y,le){return o.create(Y,le)}e.$hk=y;function $(Y){return Y||y((0,h.localize)(0,null),i.Unknown)}e.$ik=$;function S(Y,le){return Y.name=le?`${le} (FileSystemError)`:"FileSystemError",Y}e.$jk=S;function I(Y){if(!Y)return i.Unknown;if(Y instanceof o)return Y.code;const le=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!le)return i.Unknown;switch(le[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$kk=I;function u(Y){if(Y instanceof j)return Y.fileOperationResult;switch(I(Y)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$lk=u;var d;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class l{constructor(le,Ee,ce){this.resource=le,this.operation=Ee,this.target=ce}isOperation(le){return this.operation===le}}e.$mk=l;var R;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class B{constructor(le,Ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const $e of le){const ie=ce.get($e.type);switch(ie?ie.push([$e.resource,$e]):ce.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ce)switch($e){case 1:this.a=w.$Sh.forUris(()=>Ee),this.a.fill(ie);break;case 0:this.b=w.$Sh.forUris(()=>Ee),this.b.fill(ie);break;case 2:this.c=w.$Sh.forUris(()=>Ee),this.c.fill(ie);break}}contains(le,...Ee){return this.d(le,{includeChildren:!1},...Ee)}affects(le,...Ee){return this.d(le,{includeChildren:!0},...Ee)}d(le,Ee,...ce){if(!le)return!1;const $e=ce.length>0;return!!((!$e||ce.includes(1))&&(this.a?.get(le)||Ee.includeChildren&&this.a?.findSuperstr(le))||(!$e||ce.includes(0))&&(this.b?.get(le)||Ee.includeChildren&&this.b?.findSuperstr(le))||(!$e||ce.includes(2))&&(this.c?.findSubstr(le)||Ee.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$nk=B;function V(Y,le,Ee){return!Y||!le||Y===le||le.length>Y.length?!1:(le.charAt(le.length-1)!==M.sep&&(le+=M.sep),Ee?(0,C.$1e)(Y,le):Y.indexOf(le)===0)}e.$ok=V;class j extends Error{constructor(le,Ee,ce){super(le),this.fileOperationResult=Ee,this.options=ce}}e.$pk=j;class W extends j{constructor(le,Ee,ce,$e){super(le,Ee,$e),this.fileOperationResult=Ee,this.size=ce}}e.$qk=W;class O extends j{constructor(le,Ee,ce){super(le,2,ce),this.stat=Ee}}e.$rk=O;var N;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.$sk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$uk="files.associations",e.$vk="files.exclude",e.$wk="files.readonlyInclude",e.$xk="files.readonlyExclude",e.$yk="files.readonlyFromPermissions";var ee;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$zk="";function X(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.$Ak=X;async function ye(Y,le){if(!le.hasProvider(A.URI.from({scheme:Y.scheme})))return new Promise(Ee=>{const ce=le.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===Y.scheme&&$e.added&&(ce.dispose(),Ee())})})}e.$Bk=ye;class De{static{this.KB=1024}static{this.MB=De.KB*De.KB}static{this.GB=De.MB*De.KB}static{this.TB=De.GB*De.KB}static formatSize(le){return(0,F.$Af)(le)||(le=0),le<De.KB?(0,h.localize)(1,null,le.toFixed(0)):le<De.MB?(0,h.localize)(2,null,(le/De.KB).toFixed(2)):le<De.GB?(0,h.localize)(3,null,(le/De.MB).toFixed(2)):le<De.TB?(0,h.localize)(4,null,(le/De.GB).toFixed(2)):(0,h.localize)(5,null,(le/De.TB).toFixed(2))}}e.$Ck=De;function Pe(Y){const le=typeof Y=="string"||Y?.scheme===P.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===P.Schemas.file?1024*De.MB:le?10*De.MB:g.$o?50*De.MB:1024*De.MB}e.$Dk=Pe}),define(Ae[71],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class w{constructor(...C){this.a=new Map;for(const[F,A]of C)this.set(F,A)}set(C,F){const A=this.a.get(C);return this.a.set(C,F),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Kh=w}),define(Ae[172],Re([1,0,13,9,6,69,170,4,71,173]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;const P=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new E.$Kh,n=!1,c,v=P){this.f=t,this.g=n,this.h=c,this.i=v,this.o=new Set,this.f.set(h.$Lh,this),this._globalGraph=v?c?._globalGraph??new A.$7p(D=>D):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...n){const c=m.traceInvocation(this.i,t);let v=!1;try{return t({get:p=>{if(v)throw(0,M.$6)("service accessor is only valid during the invocation of its target method");const r=this.m(p,c);if(!r)throw new Error(`[invokeFunction] unknown service '${p}'`);return r}},...n)}finally{v=!0,c.stop()}}createInstance(t,...n){let c,v;return t instanceof F.$Jh?(c=m.traceCreation(this.i,t.ctor),v=this.j(t.ctor,t.staticArguments.concat(n),c)):(c=m.traceCreation(this.i,t),v=this.j(t,n,c)),c.stop(),v}j(t,n=[],c){const v=h._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),D=[];for(const r of v){const s=this.m(r.id,c);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),D.push(s)}const p=v.length>0?v[0].index:n.length;if(n.length!==p){console.trace(`[createInstance] First service dependency of ${t.name} at position ${p+1} conflicts with ${n.length} static arguments`);const r=p-n.length;r>0?n=n.concat(new Array(r)):n=n.slice(0,p)}return Reflect.construct(t,n.concat(D))}k(t,n){if(this.f.get(t)instanceof F.$Jh)this.f.set(t,n);else if(this.h)this.h.k(t,n);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const n=this.f.get(t);return!n&&this.h?this.h.l(t):n}m(t,n){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof F.$Jh?this.q(t,c,n.branch(t,!0)):(n.branch(t,!1),c)}q(t,n,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,n,c)}finally{this.o.delete(t)}}r(t,n,c){const v=new A.$7p(r=>r.id.toString());let D=0;const p=[{id:t,desc:n,_trace:c}];for(;p.length;){const r=p.pop();if(v.lookupOrInsertNode(r),D++>1e3)throw new k(v);for(const s of h._util.getServiceDependencies(r.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),i instanceof F.$Jh){const o={id:s.id,desc:i,_trace:r._trace.branch(s.id,!0)};v.insertEdge(r,o),p.push(o)}}}for(;;){const r=v.roots();if(r.length===0){if(!v.isEmpty())throw new k(v);break}for(const{data:s}of r){if(this.l(s.id)instanceof F.$Jh){const o=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,o)}v.removeNode(s)}}return this.l(t)}s(t,n,c=[],v,D){if(this.f.get(t)instanceof F.$Jh)return this.t(t,n,c,v,D);if(this.h)return this.h.s(t,n,c,v,D);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}t(t,n,c=[],v,D){if(v){const p=new a(void 0,this.g,this,this.i);p.c=String(t);const r=new Map,s=new w.$9g(()=>{const i=p.j(n,c,D);for(const[o,y]of r){const $=i[o];if(typeof $=="function")for(const S of y)$.apply(i,S)}return r.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let S=r.get(o);return S||(S=new g.$Zc,r.set(o,S)),(u,d,l)=>{const R=S.push([u,d,l]);return(0,C.$Oc)(R)}}if(o in i)return i[o];const y=s.value;let $=y[o];return typeof $!="function"||($=$.bind(y),i[o]=$),$},set(i,o,y){return s.value[o]=y,!0},getPrototypeOf(i){return n.prototype}})}else return this.j(n,c,D)}u(t,n){if(n&&console.warn(t),this.g)throw new Error(t)}}e.$8p=a;var b;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(b||(b={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,n){return t?new m(2,n.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(t,n){return t?new m(1,n.name):m.c}static{this.f=0}constructor(t,n){this.type=t,this.name=n,this.g=Date.now(),this.h=[]}branch(t,n){const c=new m(3,t.toString());return this.h.push([t,n,c]),c}stop(){const t=Date.now()-this.g;m.f+=t;let n=!1;function c(D,p){const r=[],s=new Array(D+1).join("	");for(const[i,o,y]of p.h)if(o&&y){n=!0,r.push(`${s}CREATES -> ${i}`);const $=c(D+1,y);$&&r.push($)}else r.push(`${s}uses -> ${i}`);return r.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(t>2||n)&&m.all.add(v.join(`
`))}}e.$9p=m}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.log=e.$0i=e.LogLevel=e.$9i=e.$8i=e.$7i=void 0,e.$7i=(0,a.$Mh)("logService"),e.$8i=(0,a.$Mh)("loggerService");function b(){return new Date().toISOString()}function m(u){return(0,g.$Af)(u)}e.$9i=m;var f;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$0i=f.Info;function t(u,d,l){switch(d){case f.Trace:u.trace(l);break;case f.Debug:u.debug(l);break;case f.Info:u.info(l);break;case f.Warning:u.warn(l);break;case f.Error:u.error(l);break;case f.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=t;function n(u,d=!1){let l="";for(let R=0;R<u.length;R++){let B=u[R];if(B instanceof Error&&(B=(0,w.$xi)(B,d)),typeof B=="object")try{B=JSON.stringify(B)}catch{}l+=(R>0?" ":"")+B}return l}class c extends F.$Qc{constructor(){super(...arguments),this.b=e.$0i,this.c=this.B(new M.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==f.Off&&this.b<=d}}e.$_i=c;class v extends c{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...l){this.f(f.Trace)&&this.g(f.Trace,n([d,...l],!0))}debug(d,...l){this.f(f.Debug)&&this.g(f.Debug,n([d,...l]))}info(d,...l){this.f(f.Info)&&this.g(f.Info,n([d,...l]))}warn(d,...l){this.f(f.Warning)&&this.g(f.Warning,n([d,...l]))}error(d,...l){if(this.f(f.Error))if(d instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=d.stack,this.g(f.Error,n(R))}else this.g(f.Error,n([d,...l]))}flush(){}}e.$aj=v;class D extends c{constructor(d=e.$0i){super(),this.setLevel(d),this.g=!h.$i}trace(d,...l){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,d,...l):console.log(`[main ${b()}]`,d,...l))}debug(d,...l){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,d,...l):console.log(`[main ${b()}]`,d,...l))}info(d,...l){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,d,...l):console.log(`[main ${b()}]`,d,...l))}warn(d,...l){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,d,...l):console.warn(`[main ${b()}]`,d,...l))}error(d,...l){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,d,...l):console.error(`[main ${b()}]`,d,...l))}dispose(){}flush(){}}e.$bj=D;class p extends c{constructor(d=e.$0i,l=!0){super(),this.g=l,this.setLevel(d)}trace(d,...l){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...l):console.log(d,...l))}debug(d,...l){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...l):console.log(d,...l))}info(d,...l){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...l):console.log(d,...l))}warn(d,...l){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...l):console.log(d,...l))}error(d,...l){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...l):console.error(d,...l))}dispose(){}flush(){}}e.$cj=p;class r extends c{constructor(d,l=e.$0i){super(),this.g=d,this.setLevel(l)}trace(d,...l){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(d),...l])}debug(d,...l){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(d),...l])}info(d,...l){this.f(f.Info)&&this.g.log(f.Info,[this.h(d),...l])}warn(d,...l){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(d),...l])}error(d,...l){this.f(f.Error)&&this.g.log(f.Error,[this.h(d),...l])}h(d){return typeof d=="string"?d:(0,w.$xi)(d,this.f(f.Trace))}dispose(){}flush(){}}e.$dj=r;class s extends c{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const l of this.g)l.setLevel(d);super.setLevel(d)}trace(d,...l){for(const R of this.g)R.trace(d,...l)}debug(d,...l){for(const R of this.g)R.debug(d,...l)}info(d,...l){for(const R of this.g)R.info(d,...l)}warn(d,...l){for(const R of this.g)R.warn(d,...l)}error(d,...l){for(const R of this.g)R.error(d,...l)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.$ej=s;class i extends F.$Qc{constructor(d,l,R){if(super(),this.h=d,this.j=l,this.b=new A.$yc,this.c=this.B(new M.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Ld),this.onDidChangeVisibility=this.g.event,R)for(const B of R)this.b.set(B.resource,{logger:void 0,info:B})}m(d){return(0,g.$wf)(d)?[...this.b.values()].find(l=>l.info.id===d):this.b.get(d)}getLogger(d){return this.m(d)?.logger}createLogger(d,l){const R=this.n(d),B=(0,g.$wf)(d)?d:l?.id??(0,C.$Ai)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const j=l?.logLevel==="always"?f.Trace:l?.logLevel;V||(V=this.s(R,j??this.getLogLevel(R)??this.h,{...l,id:B}));const W={logger:V,info:{resource:R,id:B,logLevel:j,name:l?.name,hidden:l?.hidden,extensionId:l?.extensionId,when:l?.when}};return this.registerLogger(W.info),this.b.set(R,W),V}n(d){return(0,g.$wf)(d)?(0,E.$tg)(this.j,`${d}.log`):d}setLogLevel(d,l){if(P.URI.isUri(d)){const R=d,B=l,V=this.b.get(R);V&&B!==V.info.logLevel&&(V.info.logLevel=B===this.h?void 0:B,V.logger?.setLevel(B),this.b.set(V.info.resource,V),this.f.fire([R,B]))}else{this.h=d;for(const[R,B]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,l){const R=this.m(d);R&&l!==!R.info.hidden&&(R.info.hidden=!l,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,l]))}getLogLevel(d){let l;return d&&(l=this.b.get(d)?.info.logLevel),l??this.h}registerLogger(d){const l=this.b.get(d.resource);l?l.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const l=this.b.get(d);l&&(l.logger&&l.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[l.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fj=i;class o{constructor(){this.onDidChangeLogLevel=new M.$Ld().event}setLevel(d){}getLevel(){return f.Info}trace(d,...l){}debug(d,...l){}info(d,...l){}warn(d,...l){}error(d,...l){}critical(d,...l){}dispose(){}flush(){}}e.$gj=o;class y extends o{}e.$hj=y;function $(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const d=I(u.logLevel.toLowerCase());if(d!==void 0)return d}return e.$0i}e.$ij=$;function S(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$jj=S;function I(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$kj=I,e.$lj=new k.$4i("logLevel",S(f.Info))}),define(Ae[174],Re([1,0,6,14]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;class C extends w.$Qc{constructor(A,h=[]){super(),this.a=new M.$ej([A,...h]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...h){this.a.trace(A,...h)}debug(A,...h){this.a.debug(A,...h)}info(A,...h){this.a.info(A,...h)}warn(A,...h){this.a.warn(A,...h)}error(A,...h){this.a.error(A,...h)}flush(){this.a.flush()}}e.$tN=C}),define(Ae[94],Re([1,0,29,143,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function g(m,f){return f-m}E.compare=g;const P=Object.create(null);P[E.Error]=(0,M.localize)(0,null),P[E.Warning]=(0,M.localize)(1,null),P[E.Info]=(0,M.localize)(2,null);function k(m){return P[m]||""}E.toString=k;function a(m){switch(m){case w.default.Error:return E.Error;case w.default.Warning:return E.Warning;case w.default.Info:return E.Info;case w.default.Ignore:return E.Hint}}E.fromSeverity=a;function b(m){switch(m){case E.Error:return w.default.Error;case E.Warning:return w.default.Warning;case E.Info:return w.default.Info;case E.Hint:return w.default.Ignore}}E.toSeverity=b}(A||(e.MarkerSeverity=A={}));var h;(function(E){const g="";function P(a){return k(a,!0)}E.makeKey=P;function k(a,b){const m=[g];return a.source?m.push(a.source.replace("\xA6","\\\xA6")):m.push(g),a.code?typeof a.code=="string"?m.push(a.code.replace("\xA6","\\\xA6")):m.push(a.code.value.replace("\xA6","\\\xA6")):m.push(g),a.severity!==void 0&&a.severity!==null?m.push(A.toString(a.severity)):m.push(g),a.message&&b?m.push(a.message.replace("\xA6","\\\xA6")):m.push(g),a.startLineNumber!==void 0&&a.startLineNumber!==null?m.push(a.startLineNumber.toString()):m.push(g),a.startColumn!==void 0&&a.startColumn!==null?m.push(a.startColumn.toString()):m.push(g),a.endLineNumber!==void 0&&a.endLineNumber!==null?m.push(a.endLineNumber.toString()):m.push(g),a.endColumn!==void 0&&a.endColumn!==null?m.push(a.endColumn.toString()):m.push(g),m.push(g),m.join("\xA6")}E.makeKeyOptionalMessage=k})(h||(e.IMarkerData=h={})),e.$5s=(0,C.$Mh)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Su=e.Severity=void 0,e.Severity=M.default,e.$Su=(0,C.$Mh)("notificationService");var F;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var h;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(h||(e.NotificationsFilter=h={}));class E{constructor(){this.progress=new g,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$Tu=E;class g{infinite(){}done(){}total(k){}worked(k){}}e.$Uu=g}),define(Ae[95],Re([1,0,15,2,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4T=e.$3T=e.$2T=e.$1T=e.$ZT=void 0,e.$ZT=(0,C.$Mh)("openerService");function F(g,P){return M.URI.isUri(g)?(0,w.$Ze)(g.scheme,P):(0,w.$1e)(g,P+":")}e.$1T=F;function A(g,...P){return P.some(k=>F(g,k))}e.$2T=A;function h(g,P){return g.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$3T=h;function E(g){let P;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return k&&(P={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},g=g.with({fragment:""})),{selection:P,uri:g}}e.$4T=E}),define(Ae[176],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=void 0,e.$mj=(0,w.$Mh)("productService"),e.$nj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,w,M){var C=arguments.length,F=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,w):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(be,e,w,M);else for(var h=be.length-1;h>=0;h--)(A=be[h])&&(F=(C<3?A(F):C>3?A(e,w,F):A(e,w))||F);return C>3&&F&&Object.defineProperty(e,w,F),F},Ve=this&&this.__param||function(be,e){return function(w,M){e(w,M,be)}};define(Ae[72],Re([1,0,13,21,6,4]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.$Yu=e.$Xu=e.$Wu=e.ProgressLocation=e.$Vu=void 0,e.$Vu=(0,F.$Mh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Wu=Object.freeze({total(){},worked(){},done(){}});class h{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(k,a){this.c=k,this.report=a?.async?this.e.bind(this):this.d.bind(this)}d(k){this.a=k,this.c(this.a)}e(k){Promise.resolve(this.b).finally(()=>{this.a=k;const a=this.c(this.a);this.b=Promise.resolve(a).finally(()=>this.b=void 0)})}}e.$Xu=h;let E=class extends C.$Qc{constructor(k,a){super(),this.a=new w.$ah,a.withProgress(k,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,C.$Oc)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$Yu=E,e.$Yu=E=Ke([Ve(1,e.$Vu)],E);class g extends C.$Qc{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new C.$Pc)}start(k){this.stop();const a=++this.a,b=new M.$Vd;return this.f=setTimeout(()=>{a===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,C.$Oc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Oc)(()=>b.cancel())),this.b.add((0,C.$Oc)(()=>this.c?this.c.done():void 0)),{id:a,token:b.token,stop:()=>this.h(a),isCurrent:()=>this.a===a}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$Zu=g,e.$1u=(0,F.$Mh)("editorProgressService")}),define(Ae[30],Re([1,0,51,16]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;class C{constructor(){this.a=new Map}add(A,h){w.ok(M.$wf(A)),w.ok(M.$yf(h)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,h)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$0m=new C}),define(Ae[73],Re([1,0,5,30]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$$m={JSONContribution:"base.contributions.json"};function C(h){return h.length>0&&h.charAt(h.length-1)==="#"?h.substring(0,h.length-1):h}class F{constructor(){this.b=new w.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,g){this.a[C(E)]=g,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new F;M.$0m.add(e.$$m.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,137,43,73,30]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ConfigurationScope=e.$cn=e.EditPresentationTypes=void 0;var g;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$cn={Configuration:"base.contributions.configuration"};var P;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn="vscode://schemas/settings/resourceLanguage",e.$kn="vscode://schemas/settings/configurationDefaults";const k=E.$0m.as(h.$$m.JSONContribution);class a{constructor(){this.h=new Set,this.i=new M.$Ld,this.onDidSchemaChange=this.i.event,this.j=new M.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$jn,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const i=new Set;this.n(r,s,i),k.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(r){const s=new Set;this.o(r,s),k.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const i=new Set;this.o(s,i),this.n(r,!1,i),k.registerSchema(e.$jn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const i=[];for(const{overrides:o,source:y}of r)for(const $ in o)if(s.add($),e.$mn.test($)){const S=this.a.get($),I=S?.valuesSources??new Map;if(y)for(const R of Object.keys(o[$]))I.set(R,y);const u={...S?.value||{},...o[$]};this.a.set($,{source:y,value:u,valuesSources:I});const d=(0,A.$qi)($),l={type:"object",default:u,description:F.localize(1,null,d),$ref:e.$jn,defaultDefaultValue:u,source:C.$wf(y)?void 0:y,defaultValueSource:y};i.push(...f($)),this.d[$]=l,this.b.properties[$]=l}else{this.a.set($,{value:o[$],source:y});const S=this.d[$];S&&(this.w($,S),this.r($,S))}this.m(i)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:i,source:o}of r)for(const y in i){const $=this.a.get(y),S=C.$wf(o)?o:o?.id,I=C.$wf($?.source)?$?.source:$?.source?.id;if(S===I)if(s.add(y),this.a.delete(y),e.$mn.test(y))delete this.d[y],delete this.b.properties[y];else{const u=this.d[y];u&&(this.w(y,u),this.r(y,u))}}this.u()}deltaConfiguration(r){let s=!1;const i=new Set;r.removedDefaults&&(this.l(r.removedDefaults,i),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,i),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,i),r.addedConfigurations&&this.n(r.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,i){r.forEach(o=>{this.p(o,s,o.extensionInfo,o.restrictedProperties,void 0,i),this.c.push(o),this.q(o)})}o(r,s){const i=o=>{if(o.properties)for(const y in o.properties){s.add(y);const $=this.d[y];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>i(y))};for(const o of r){i(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(r,s=!0,i,o,y=3,$){y=C.$Ff(r.scope)?y:r.scope;const S=r.properties;if(S)for(const u in S){const d=S[u];if(s&&v(u,d)){delete S[u];continue}if(d.source=i,d.defaultDefaultValue=S[u].default,this.w(u,d),e.$mn.test(u)?d.scope=void 0:(d.scope=C.$Ff(d.scope)?y:d.scope,d.restricted=C.$Ff(d.restricted)?!!o?.includes(u):d.restricted),S[u].hasOwnProperty("included")&&!S[u].included){this.f[u]=S[u],delete S[u];continue}else this.d[u]=S[u],S[u].policy?.name&&this.e.set(S[u].policy.name,u);!S[u].deprecationMessage&&S[u].markdownDeprecationMessage&&(S[u].deprecationMessage=S[u].markdownDeprecationMessage),$.add(u)}const I=r.allOf;if(I)for(const u of I)this.p(u,s,i,o,y,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=i=>{const o=i.properties;if(o)for(const $ in o)this.r($,o[$]);i.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$dn.properties[r]=s,s.scope){case 1:e.$en.properties[r]=s;break;case 2:e.$fn.properties[r]=s;break;case 6:e.$gn.properties[r]=s;break;case 3:e.$hn.properties[r]=s;break;case 4:e.$in.properties[r]=s;break;case 5:e.$in.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$dn.properties[r],s.scope){case 1:delete e.$en.properties[r];break;case 2:delete e.$fn.properties[r];break;case 6:delete e.$gn.properties[r];break;case 3:delete e.$hn.properties[r];break;case 4:case 5:delete e.$in.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,i={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$jn};this.w(s,i),e.$dn.properties[s]=i,e.$en.properties[s]=i,e.$fn.properties[s]=i,e.$gn.properties[s]=i,e.$hn.properties[s]=i,e.$in.properties[s]=i}}v(){const r={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$jn};e.$dn.patternProperties[e.$ln]=r,e.$en.patternProperties[e.$ln]=r,e.$fn.patternProperties[e.$ln]=r,e.$gn.patternProperties[e.$ln]=r,e.$hn.patternProperties[e.$ln]=r,e.$in.patternProperties[e.$ln]=r,this.i.fire()}w(r,s){const i=this.a.get(r);let o=i?.value,y=i?.source;C.$Df(o)&&(o=s.defaultDefaultValue,y=void 0),C.$Df(o)&&(o=n(s.type)),s.default=o,s.defaultValueSource=y}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.$ln=`^(${b})+$`,e.$mn=new RegExp(e.$ln);function f(p){const r=[];if(e.$mn.test(p)){let s=m.exec(p);for(;s?.length;){const i=s[1].trim();i&&r.push(i),s=m.exec(p)}}return(0,w.$Kb)(r)}e.$nn=f;function t(p){return p.reduce((r,s)=>`${r}[${s}]`,"")}e.$on=t;function n(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$pn=n;const c=new a;E.$0m.add(e.$cn.Configuration,c);function v(p,r){return p.trim()?e.$mn.test(p)?F.localize(7,null,p):c.getConfigurationProperties()[p]!==void 0?F.localize(8,null,p):r.policy?.name&&c.getPolicyConfigurations().get(r.policy?.name)!==void 0?F.localize(9,null,p,r.policy?.name,c.getPolicyConfigurations().get(r.policy?.name)):null:F.localize(6,null)}e.$qn=v;function D(){const p=[],r=c.getConfigurationProperties();for(const s of Object.keys(r))p.push([s,r[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.$rn=D}),define(Ae[177],Re([1,0,18,5,115,6,28,24,16,2,43,96,30]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=void 0;function b(s){return Object.isFrozen(s)?s:h.$Ym(s)}class m{constructor(i={},o=[],y=[],$){this.b=i,this.c=o,this.d=y,this.raw=$,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof m)return o;const y=new f("");return y.parseRaw(o),y.configurationModel});this.f=i.reduce((o,y)=>y===o?y:o.merge(y),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,P.$oi)(this.contents,i):this.contents}inspect(i,o){const y=this.rawConfiguration.getValue(i),$=o?this.rawConfiguration.getOverrideValue(i,o):void 0,S=o?this.rawConfiguration.override(o).getValue(i):y;return{value:y,override:$,merged:S}}getOverrideValue(i,o){const y=this.i(o);return y?i?(0,P.$oi)(y,i):y:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const y of this.overrides)y.identifiers.includes(i)&&o.push(...y.keys);return w.$Kb(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return w.$Kb(i)}override(i){let o=this.a.get(i);return o||(o=this.g(i),this.a.set(i,o)),o}merge(...i){const o=h.$Xm(this.contents),y=h.$Xm(this.overrides),$=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const I of i)if(S.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const u of I.overrides){const[d]=y.filter(l=>w.$sb(l.identifiers,u.identifiers));d?(this.h(d.contents,u.contents),d.keys.push(...u.keys),d.keys=w.$Kb(d.keys)):y.push(h.$Xm(u))}for(const u of I.keys)$.indexOf(u)===-1&&$.push(u)}return new m(o,$,y,S.every(I=>I instanceof m)?void 0:S)}g(i){const o=this.i(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const $ of w.$Kb([...Object.keys(this.contents),...Object.keys(o)])){let S=this.contents[$];const I=o[$];I&&(typeof S=="object"&&typeof I=="object"?(S=h.$Xm(S),this.h(S,I)):S=I),y[$]=S}return new m(y,this.keys,this.overrides)}h(i,o){for(const y of Object.keys(o)){if(y in i&&E.$yf(i[y])&&E.$yf(o[y])){this.h(i[y],o[y]);continue}i[y]=h.$Xm(o[y])}}i(i){let o=null,y=null;const $=S=>{S&&(y?this.h(y,S):y=h.$Xm(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===i?o=S.contents:S.identifiers.includes(i)&&$(S.contents);return $(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,o){this.j(i,o,!0)}setValue(i,o){this.j(i,o,!1)}removeValue(i){const o=this.keys.indexOf(i);o!==-1&&(this.keys.splice(o,1),(0,P.$ni)(this.contents,i),k.$mn.test(i)&&this.overrides.splice(this.overrides.findIndex(y=>w.$sb(y.identifiers,(0,k.$nn)(i))),1))}j(i,o,y){(0,P.$mi)(this.contents,i,o,$=>console.error($)),y=y||this.keys.indexOf(i)===-1,y&&this.keys.push(i),k.$mn.test(i)&&this.overrides.push({identifiers:(0,k.$nn)(i),keys:Object.keys(this.contents[i]),contents:(0,P.$li)(this.contents[i],$=>console.error($))})}}e.$sn=m;class f{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,o){if(!E.$Ff(i)){const y=this.g(i);this.parseRaw(y,o)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,o){this.a=i;const{contents:y,keys:$,overrides:S,restricted:I,hasExcludedProperties:u}=this.h(i,o);this.b=new m(y,$,S,u?[i]:void 0),this.c=I||[]}g(i){let o={},y=null,$=[];const S=[],I=[];function u(l){Array.isArray($)?$.push(l):y!==null&&($[y]=l)}const d={onObjectBegin:()=>{const l={};u(l),S.push($),$=l,y=null},onObjectProperty:l=>{y=l},onObjectEnd:()=>{$=S.pop()},onArrayBegin:()=>{const l=[];u(l),S.push($),$=l,y=null},onArrayEnd:()=>{$=S.pop()},onLiteralValue:u,onError:(l,R,B)=>{I.push({error:l,offset:R,length:B})}};if(i)try{C.$Um(i,d),o=$[0]||{}}catch(l){console.error(`Error while parsing settings file ${this.f}: ${l}`),this.d=[l]}return o}h(i,o){const y=a.$0m.as(k.$cn.Configuration).getConfigurationProperties(),$=this.i(i,y,!0,o);i=$.raw;const S=(0,P.$li)(i,d=>console.error(`Conflict in settings file ${this.f}: ${d}`)),I=Object.keys(i),u=this.j(i,d=>console.error(`Conflict in settings file ${this.f}: ${d}`));return{contents:S,keys:I,overrides:u,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}i(i,o,y,$){let S=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:S};const I={},u=[];for(const d in i)if(k.$mn.test(d)&&y){const l=this.i(i[d],o,!1,$);I[d]=l.raw,S=S||l.hasExcludedProperties,u.push(...l.restricted)}else{const l=o[d],R=l?typeof l.scope<"u"?l.scope:3:void 0;l?.restricted&&u.push(d),!$.exclude?.includes(d)&&($.include?.includes(d)||(R===void 0||$.scopes===void 0||$.scopes.includes(R))&&!($.skipRestricted&&l?.restricted))?I[d]=i[d]:S=!0}return{raw:I,restricted:u,hasExcludedProperties:S}}j(i,o){const y=[];for(const $ of Object.keys(i))if(k.$mn.test($)){const S={};for(const I in i[$])S[I]=i[$][I];y.push({identifiers:(0,k.$nn)($),keys:Object.keys(S),contents:(0,P.$li)(S,o)})}return y}}e.$tn=f;class t extends F.$Qc{constructor(i,o,y,$){super(),this.c=i,this.f=o,this.g=$,this.b=this.B(new M.$Ld),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&y.isEqual(S.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$un=t;class n{constructor(i,o,y,$,S,I,u,d,l,R,B,V,j){this.a=i,this.b=o,this.c=y,this.overrideIdentifiers=$,this.d=S,this.f=I,this.g=u,this.h=d,this.i=l,this.j=R,this.k=B,this.l=V,this.m=j}get value(){return b(this.c)}n(i,o,y){const $=i.inspect(o,y);return{get value(){return b($.value)},get override(){return b($.override)},get merged(){return b($.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(i,o,y,$,S=new m,I=new m,u=new A.$yc,d=new m,l=new A.$yc){this.c=i,this.d=o,this.f=y,this.g=$,this.h=S,this.i=I,this.j=u,this.l=d,this.m=l,this.a=null,this.b=new A.$yc,this.n=null}getValue(i,o,y){return this.q(i,o,y).getValue(i)}updateValue(i,o,y={}){let $;y.resource?($=this.m.get(y.resource),$||($=new m,this.m.set(y.resource,$))):$=this.l,o===void 0?$.removeValue(i):$.setValue(i,o),y.resource||(this.a=null)}inspect(i,o,y){const $=this.q(i,o,y),S=this.u(o.resource,y),I=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const d of $.overrides)for(const l of d.identifiers)$.getOverrideValue(i,l)!==void 0&&u.add(l);return new n(i,o,$.getValue(i),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,S||void 0,I)}keys(i){const o=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,o){this.j.set(i,o),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const y=[];if(!o){const{added:$,updated:S,removed:I}=p(this.c,i);o=[...$,...S,...I]}for(const $ of o)for(const S of(0,k.$nn)($)){const I=this.c.getKeysForOverrideIdentifier(S),u=i.getKeysForOverrideIdentifier(S),d=[...u.filter(l=>I.indexOf(l)===-1),...I.filter(l=>u.indexOf(l)===-1),...I.filter(l=>!h.$2m(this.c.override(S).getValue(l),i.override(S).getValue(l)))];y.push([S,d])}return this.updateDefaultConfiguration(i),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:y,removed:$}=p(this.d,i),S=[...o,...y,...$];return S.length&&this.updatePolicyConfiguration(i),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:y,removed:$,overrides:S}=p(this.applicationConfiguration,i),I=[...o,...y,...$];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:S}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:y,removed:$,overrides:S}=p(this.localUserConfiguration,i),I=[...o,...y,...$];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:S}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:y,removed:$,overrides:S}=p(this.remoteUserConfiguration,i),I=[...o,...y,...$];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:S}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:y,removed:$,overrides:S}=p(this.workspaceConfiguration,i),I=[...o,...y,...$];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:S}}compareAndUpdateFolderConfiguration(i,o){const y=this.p.get(i),{added:$,updated:S,removed:I,overrides:u}=p(y,o),d=[...$,...S,...I];return(d.length||!y)&&this.updateFolderConfiguration(i,o),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(i){const o=this.p.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:y,updated:$,removed:S,overrides:I}=p(o,void 0);return{keys:[...y,...$,...S],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,o,y){let $=this.r(o,y);return o.overrideIdentifier&&($=$.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&($=$.merge(this.d)),$}r({resource:i},o){let y=this.s();if(o&&i){const $=o.getFolder(i);$&&(y=this.t($.uri)||y);const S=this.m.get(i);S&&(y=y.merge(S))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let o=this.b.get(i);if(!o){const y=this.s(),$=this.j.get(i);$?(o=y.merge($),this.b.set(i,o)):o=y}return o}u(i,o){if(o&&i){const y=o.getFolder(i);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,o)=>{const{contents:y,overrides:$,keys:S}=this.j.get(o);return i.push([o,{contents:y,overrides:$,keys:S}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(o=>i.add(o)),this.userConfiguration.keys.forEach(o=>i.add(o)),this.i.keys.forEach(o=>i.add(o)),this.j.forEach(o=>o.keys.forEach(y=>i.add(y))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>i.add(y))),[...i.values()]}w(i){const o=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(i).forEach($=>o.add($))),[...o.values()]}static parse(i){const o=this.x(i.defaults),y=this.x(i.policy),$=this.x(i.application),S=this.x(i.user),I=this.x(i.workspace),u=i.folders.reduce((d,l)=>(d.set(g.URI.revive(l[0]),this.x(l[1])),d),new A.$yc);return new c(o,y,$,S,new m,I,u,new m,new A.$yc)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.$vn=c;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,o=new Map;for(const $ of s)$.keys.forEach(S=>i.add(S)),$.overrides.forEach(([S,I])=>{const u=(0,A.$vc)(o,S,new Set);I.forEach(d=>u.add(d))});const y=[];return o.forEach(($,S)=>y.push([S,[...$.values()]])),{keys:[...i.values()],overrides:y}}e.$wn=v;class D{constructor(i,o,y,$){this.change=i,this.f=o,this.g=y,this.h=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of i.keys)this.affectedKeys.add(S);for(const[,S]of i.overrides)for(const I of S)this.affectedKeys.add(I);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(i,o){const y=this.a+i,$=this.d.indexOf(y);if($<0)return!1;const S=$+y.length;if(S>=this.d.length)return!1;const I=this.d.charCodeAt(S);if(I!==this.b&&I!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.f?.workspace):void 0,d=this.g.getValue(i,o,this.h);return!h.$2m(u,d)}return!0}}e.$xn=D;function p(s,i){const{added:o,removed:y,updated:$}=r(i?.rawConfiguration,s?.rawConfiguration),S=[],I=s?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const d=u.filter(l=>!I.includes(l));for(const l of d)S.push([l,i.getKeysForOverrideIdentifier(l)])}if(s){const d=I.filter(l=>!u.includes(l));for(const l of d)S.push([l,s.getKeysForOverrideIdentifier(l)])}if(i&&s){for(const d of I)if(u.includes(d)){const l=r({contents:s.getOverrideValue(void 0,d)||{},keys:s.getKeysForOverrideIdentifier(d)},{contents:i.getOverrideValue(void 0,d)||{},keys:i.getKeysForOverrideIdentifier(d)});S.push([d,[...l.added,...l.removed,...l.updated]])}}return{added:o,removed:y,updated:$,overrides:S}}function r(s,i){const o=s?i?s.keys.filter(S=>i.keys.indexOf(S)===-1):[...s.keys]:[],y=i?s?i.keys.filter(S=>s.keys.indexOf(S)===-1):[...i.keys]:[],$=[];if(s&&i){for(const S of i.keys)if(s.keys.indexOf(S)!==-1){const I=(0,P.$oi)(i.contents,S),u=(0,P.$oi)(s.contents,S);h.$2m(I,u)||$.push(S)}}return{added:o,removed:y,updated:$}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.RemoteAuthorityResolverErrorCode=e.$Nk=e.$Mk=e.RemoteConnectionType=e.$Lk=void 0,e.$Lk=(0,M.$Mh)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class F{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Mk=F;class A{constructor(k,a){this.host=k,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nk=A;var h;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(h||(e.RemoteAuthorityResolverErrorCode=h={}));class E extends w.$_{static isNotAvailable(k){return k instanceof E&&k._code===h.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof E&&k._code===h.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof E&&k._code===h.NoResolverFound}static isInvalidAuthority(k){return k instanceof E&&k._code===h.InvalidAuthority}static isHandled(k){return k instanceof E&&k.isHandled}constructor(k,a=h.Unknown,b){super(k),this._message=k,this._code=a,this._detail=b,this.isHandled=a===h.NotAvailable&&b===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Ok=E;function g(P){const k=P.indexOf("+");return k===-1?P:P.substring(0,k)}e.$Pk=g}),define(Ae[52],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=void 0;function M(g){return g.scheme===w.Schemas.vscodeRemote?g.authority:void 0}e.$Qk=M;function C(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$Rk=C;function F(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Sk=F;function A(g){const{host:P,port:k}=E(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:k}}e.$Tk=A;function h(g,P){let{host:k,port:a}=E(g);return typeof a>"u"&&(a=P),{host:k,port:a}}e.$Uk=h;function E(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const a=g.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:g,port:void 0}}}),define(Ae[20],Re([1,0,15,4,52]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.TargetPlatform=e.ExtensionType=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl="extensions.user.cache",e.$Sl="extensions.builtin.cache",e.$Tl="undefined_publisher",e.$Ul=["ui","workspace","web"];function F(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$Vl=F,e.$Wl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var h;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(h||(e.TargetPlatform=h={}));class E{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,n){if(typeof t>"u"||t===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof t=="string"||typeof n=="string"){const c=typeof t=="string"?t:t.value,v=typeof n=="string"?n:n.value;return w.$Ze(c,v)}return t._lower===n._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Xl=E;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const n of t)this.add(n)}add(t){this.c.add(E.toKey(t))}delete(t){return this.c.delete(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}}e.$Yl=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(E.toKey(t))}get(t){return this.c.get(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}set(t,n){this.c.set(E.toKey(t),n)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zl=P;function k(f){return a(f)}e.$1l=k;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$2l=a;function b(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$3l=b;function m(f,t){if(t){const n=`onResolveRemoteAuthority:${(0,C.$Rk)(t)}`;return!!f.activationEvents?.includes(n)}return!1}e.$4l=m,e.$5l=(0,M.$Mh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ME=e.$LE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,h){this.a.set(A,h)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const h=Object.create(null);for(const E of A){const g=this.readActivationEvents(E);g.length>0&&(h[M.$Xl.toKey(E.identifier)]=g)}return h}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const h=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return h;for(const E in A.contributes){const g=this.a.get(E);if(!g)continue;const P=A.contributes[E],k=Array.isArray(P)?P:[P];try{g(k,h)}catch(a){(0,w.$Y)(a)}}return h}}e.$LE=C,e.$ME=new C}),define(Ae[178],Re([1,0,22,74,36]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=void 0;function F(E){if(w.$t===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,g,P,k,a,b,m,f){const t=Object.create(null);t["common.machineId"]=b,t.sessionID=(0,C.$cg)()+Date.now(),t.commitHash=k,t.version=a,t["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$h)(w.$t),t["common.nodePlatform"]=M.$bc,t["common.nodeArch"]=P,t["common.product"]=f||"desktop",m&&(t["common.msftInternal"]=m);let n=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),w.$l&&(t["common.snap"]="true");const v=F(g);return v&&(t["common.platformDetail"]=v),t}e.$_n=A;function h(E){const g=M.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return E.some(k=>P===k)}e.$ao=h}),define(Ae[179],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=void 0,e.$$k=(0,w.$Mh)("telemetryService"),e.$_k=(0,w.$Mh)("customEndpointTelemetryService"),e.$al="telemetry.currentSessionDate",e.$bl="telemetry.firstSessionDate",e.$cl="telemetry.lastSessionDate",e.$dl="telemetry.machineId",e.$el="telemetry",e.$fl="telemetry.telemetryLevel",e.$gl="telemetry.enableCrashReporter",e.$hl="telemetry.enableTelemetry";var M;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[53],Re([1,0,24,16,5,43,52,178,179]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0;class g{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$bo=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$co=P,e.$do=new P;class k{async publicLog(y,$,S){}async publicLogError(y,$,S){}}e.$eo=k,e.$fo="telemetry",e.$go="extensionTelemetryLog",e.$ho={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,y){return C.Event.debounce(y.onDidChangeConfiguration,(S,I)=>{const u=S?new Set([...S.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:u}},1e3,!0)(S=>{S.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,F.$ji)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$io=a;function b(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry)}e.$jo=b;function m(o,y){return y.extensionTestsLocationURI?!0:!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$ko=m;function f(o){const y=o.getValue(E.$fl),$=o.getValue(E.$gl);if(o.getValue(E.$hl)===!1||$===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$lo=f;function t(o){const y={},$={},S={};v(o,S);for(let I in S){I=I.length>150?I.substr(I.length-149):I;const u=S[I];typeof u=="number"?$[I]=u:typeof u=="boolean"?$[I]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${u.length}`),y[I]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(y[I]=u)}return{properties:y,measurements:$}}e.$mo=t;const n=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const y=(0,A.$Rk)(o);return n.has(y)?y:"other"}e.$no=c;function v(o,y,$=0,S){if(o)for(const I of Object.getOwnPropertyNames(o)){const u=o[I],d=S?S+I:I;Array.isArray(u)?y[d]=(0,w.$3m)(u):u instanceof Date?y[d]=u.toISOString():(0,M.$yf)(u)?$<2?v(u,y,$+1,d+"."):y[d]=(0,w.$3m)(u):y[d]=u}}function D(o,y){const $=o.msftInternalDomains||[],S=y.getValue("telemetry.internalTesting");return(0,h.$ao)($)||S}e.$oo=D;function p(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$po=p;function r(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let $=o;const S=[];for(const l of y)for(;;){const R=l.exec(o);if(!R)break;S.push([R.index,l.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for($="";;){const l=u.exec(o);if(!l)break;const R=S.some(([B,V])=>l.index<V&&B<u.lastIndex);!I.test(l[0])&&!R&&($+=o.substring(d,l.index)+"<REDACTED: user-file-path>",d=u.lastIndex)}return d<o.length&&($+=o.substr(d)),$}function s(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const $ of y)if($.regex.test(o))return`<REDACTED: ${$.label}>`;return o}function i(o,y){return(0,w.$Zm)(o,$=>{if($ instanceof g||Object.hasOwnProperty.call($,"isTrustedTelemetryValue"))return $.value;if(typeof $=="string"){let S=$.replaceAll("%20"," ");S=r(S,y);for(const I of y)S=S.replace(I,"");return S=s(S),S}})}e.$qo=i}),define(Ae[180],Re([1,0,15,92,20,22,2,9,74,53]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;function P(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,w.$Ue)(i.id,o.id)===0}e.$ro=P;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const y=o.manifest?o.manifest.version:o.version,$=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,y,$)}static parse(o){const y=k.exec(o);return y&&y[1]&&y[2]?new a({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,$="undefined"){this.version=y,this.targetPlatform=$,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$so=a;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const o=b.exec(i);return o&&o[1]?[t(o[1]),o[2]]:[t(i),void 0]}e.$to=m;function f(i,o){return`${i}.${o}`}e.$uo=f;function t(i){return i.toLowerCase()}e.$vo=t;function n(i,o){return t(f(i??C.$Tl,o))}e.$wo=n;function c(i,o){const y=[],$=S=>{for(const I of y)if(I.some(u=>P(o(u),o(S))))return I;return null};for(const S of i){const I=$(S);I?I.push(S):y.push([S])}return y}e.$xo=c;function v(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$yo=v;function D(i){return{id:new g.$bo(i.identifier.id),name:new g.$bo(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$zo=D,e.$Ao=new C.$Xl("pprice.better-merge");function p(i,o){const y=[],$=o.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const S=$.shift();if(S&&y.every(I=>!P(I.identifier,{id:S}))){const I=i.filter(u=>P(u.identifier,{id:S}));I.length===1&&(y.push(I[0]),$.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$Bo=p;async function r(i,o){if(!F.$k)return!1;let y;try{y=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){o.debug("Error while getting the os-release file.",(0,h.$8)(S))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,o){const y=await r(i,o),$=(0,M.$Wn)(y?"alpine":F.$t,E.$cc);return o.debug("ComputeTargetPlatform:",$),$}e.$Co=s}),define(Ae[181],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=e.$er=e.$dr=e.$cr=void 0;function w(E){return[...E.entries()]}e.$cr=w;function M(E){return E?[...E.entries()]:[]}e.$dr=M;function C(E){return new Map(E)}e.$er=C;function F(E){return new Map(E??[])}e.$fr=F;function A(E){return Array.from(E.entries()).map(g=>[g[0],w(g[1].map),M(g[1].descriptionMap)])}e.$gr=A;function h(E){return new Map(E.map(g=>[g[0],{map:C(g[1]),descriptionMap:F(g[2])}]))}e.$hr=h}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,F,A=5){const h=F(E=>{const g=typeof E=="string"?E:E.data;let P=this.a.get(C);if(P){P.data.push(g);return}const k=setTimeout(()=>this.flushBuffer(C),A);P={data:[g],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),h.dispose()}},this.a.set(C,P)});return h}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const F=this.a.get(C);F&&(this.a.delete(C),this.b(C,F.data.join("")))}}e.$Ckb=w}),define(Ae[183],Re([1,0,13,89,40,5,16,2,144,73,30]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.IconFontDefinition=e.IconContribution=e.$Wv=void 0,e.$Wv={IconContribution:"base.contributions.icons"};var k;(function(D){function p(r,s){let i=r.defaults;for(;C.ThemeIcon.isThemeIcon(i);){const o=m.getIcon(i.id);if(!o)return;i=o.defaults}return i}D.getDefinition=p})(k||(e.IconContribution=k={}));var a;(function(D){function p(s){return{weight:s.weight,style:s.style,src:s.src.map(i=>({format:i.format,location:i.location.toString()}))}}D.toJSONObject=p;function r(s){const i=o=>(0,A.$wf)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,A.$wf)(o.format)&&(0,A.$wf)(o.location)))return{weight:i(s.weight),style:i(s.style),src:s.src.map(o=>({format:o.format,location:h.URI.parse(o.location)}))}}D.fromJSONObject=r})(a||(e.IconFontDefinition=a={}));class b{constructor(){this.a=new F.$Ld,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,r,s,i){const o=this.b[p];if(o){if(s&&!o.description){o.description=s,this.d.properties[p].markdownDescription=`${s} $(${p})`;const S=this.e.enum.indexOf(p);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return o}const y={id:p,description:s,defaults:r,deprecationMessage:i};this.b[p]=y;const $={$ref:"#/definitions/icons"};return i&&($.deprecationMessage=i),s&&($.markdownDescription=`${s}: $(${p})`),this.d.properties[p]=$,this.e.enum.push(p),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const r=this.e.enum.indexOf(p);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,r){const s=this.f[p];return s||(this.f[p]=r,this.a.fire(),r)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(o,y)=>o.id.localeCompare(y.id),r=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(o=>this.b[o]);for(const o of i.filter(y=>!!y.description).sort(p))s.push(`|<i class="${r(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of i.filter(y=>!C.ThemeIcon.isThemeIcon(y.defaults)).sort(p))s.push(`|<i class="${r(o)}"></i>|${o.id}|`);return s.join(`
`)}}const m=new b;P.$0m.add(e.$Wv.IconContribution,m);function f(D,p,r,s){return m.registerIcon(D,p,r,s)}e.$Xv=f;function t(){return m}e.$Yv=t;function n(){const D=(0,M.$Pj)();for(const p in D){const r="\\"+D[p].toString(16);m.registerIcon(p,{fontCharacter:r})}}n(),e.$Zv="vscode://schemas/icons";const c=P.$0m.as(g.$$m.JSONContribution);c.registerSchema(e.$Zv,m.getIconSchema());const v=new w.$4g(()=>c.notifySchemaChanged(e.$Zv),200);m.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.$1v=f("widget-close",M.$Rj.close,(0,E.localize)(2,null)),e.$2v=f("goto-previous-location",M.$Rj.arrowUp,(0,E.localize)(3,null)),e.$3v=f("goto-next-location",M.$Rj.arrowDown,(0,E.localize)(4,null)),e.$4v=C.ThemeIcon.modify(M.$Rj.sync,"spin"),e.$5v=C.ThemeIcon.modify(M.$Rj.loading,"spin")}),define(Ae[184],Re([1,0,5,43,4,14]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.ProvidedOnAutoForward=e.$4u=e.TunnelPrivacyId=e.TunnelProtocol=e.$3u=e.$2u=void 0,e.$2u=(0,C.$Mh)("tunnelService"),e.$3u=(0,C.$Mh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var h;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(h||(e.TunnelPrivacyId=h={}));function E(t){return!!t.forwardPort}e.$4u=E;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(n)return{address:n[1],port:+n[2]}}e.$5u=P,e.$6u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$6u.indexOf(t)>=0}e.$7u=k,e.$8u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$8u.indexOf(t)>=0}e.$9u=a;function b(t,n,c,v){if(c===1)return!1;if(c===2&&a(n)){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(D?.length===4&&parseInt(D[1])>=18)return!1}return t<1024}e.$0u=b;class m{constructor(n,c,v){this.remoteAddress=n,this.localAddress=c,this.b=v,this.a=new w.$Ld,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$$u=m;let f=class{constructor(n,c){this.j=n,this.k=c,this.a=new w.$Ld,this.onTunnelOpened=this.a.event,this.b=new w.$Ld,this.onTunnelClosed=this.b.event,this.c=new w.$Ld,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const n=this.k.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.h=n.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const n=[],c=Array.from(this.e.values());for(const v of c){const D=Array.from(v.values());for(const p of D){const r=await p.value;r&&typeof r!="string"&&n.push(r)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(v=>typeof v!="string"?v?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,v,D,p){this.p(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:v,privacy:D,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(a(n)||k(n))&&(n=e.$6u[0]);const v=this.r(n,c);if(v)return++v.refcount,v.value}openTunnel(n,c,v,D,p,r=!1,s,i){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${v} on local port ${p}.`);const o=this.f??n;if(!o)return;if(c||(c="localhost"),D||(D=this.l),this.f&&this.i.has(v)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,c,v,D,p,r,s,i);return y?y.then($=>{if($){if(typeof $=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,v),$}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,v);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n($);return($.tunnelRemoteHost!==c||$.tunnelRemotePort!==v)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&$.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const v=c.get(n.tunnelRemotePort);v&&(v.refcount--,await this.o(n.tunnelRemoteHost,n.tunnelRemotePort,v))}}}}async o(n,c,v){if(v.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const D=v.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),D}}async closeTunnel(n,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const v=this.e.get(n);if(v&&v.has(c)){const D=v.get(c);D.refcount=0,await this.o(n,c,D)}}p(n,c,v){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:v})}async q(n,c){const v=this.e.get(n);if(v){const D=v.get(c),p=D?await D.value:void 0;(!p||typeof p=="string")&&v.delete(c),v.size===0&&this.e.delete(n)}}r(n,c){const v=[n];k(n)?(v.push(...e.$6u),v.push(...e.$8u)):a(n)&&v.push(...e.$8u);const D=v.map(p=>this.e.get(p));for(const p of D){const r=p?.get(c);if(r)return r}}canTunnel(n){return!!P(n)}t(n,c,v,D,p,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${v} on local port ${D}.`);const i=v;this.i.add(i);const o=D===void 0?v:D,y={elevationRequired:p?this.isPortPrivileged(o):!1},$={remoteAddress:{host:c,port:v},localAddressPort:D,privacy:r,public:r?r!==h.Private:void 0,protocol:s},S=n.forwardPort($,y);return S?(this.p(c,v,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(i)})):this.i.delete(i),S}};e.$_u=f,e.$_u=f=Ke([Ve(0,F.$7i),Ve(1,M.$gi)],f)}),define(Ae[185],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$av=void 0,e.$av=(0,w.$Mh)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[186],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=void 0;function M(E){return E.scheme!==w.Schemas.file&&E.scheme!==w.Schemas.vscodeRemote}e.$EJ=M;function C(E){if(E.folders.length)return E.folders.every(g=>M(g.uri))?E.folders[0].uri:void 0;if(E.configuration&&M(E.configuration))return E.configuration}e.$FJ=C;function F(E){return C(E)?.scheme}e.$GJ=F;function A(E){return C(E)?.authority}e.$HJ=A;function h(E){return C(E)!==void 0}e.$IJ=h}),define(Ae[54],Re([1,0,145,19,49,23,2,4,12]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.WorkbenchState=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,h.$Mh)("contextService");function g(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.uri)}e.$Wh=g;function P(o){return typeof o?.id=="string"&&!g(o)&&!a(o)}e.$Xh=P,e.$Yh={id:"ext-dev"},e.$Zh={id:"empty-window"};function k(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$lc)(o)}:y?e.$Yh:e.$Zh;const $=o;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}e.$1h=k;function a(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.configPath)}e.$2h=a;function b(o){const y=o;if(y?.uri)return{id:y.id,uri:A.URI.revive(y.uri)};const $=o;if($?.configPath)return{id:$.id,configPath:A.URI.revive($.configPath)};if(o?.id)return{id:o.id}}e.$3h=b;var m;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function f(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$4h=f;function t(o){const y=o;return!!(y&&typeof y=="object"&&A.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$5h=t;class n{constructor(y,$,S,I,u){this.h=y,this.j=S,this.k=I,this.l=u,this.c=C.$Sh.forUris(this.l,()=>!0),this.folders=$}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=C.$Sh.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$6h=n;class c{constructor(y,$){this.raw=$,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,F.$tg)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$7h=c;function v(o){return new c({uri:o,index:0,name:(0,F.$pg)(o)},{uri:o.toString()})}e.$8h=v,e.$9h="code-workspace",e.$0h=`.${e.$9h}`,e.$$h=[{name:(0,w.localize)(0,null),extensions:[e.$9h]}],e.$_h="workspace.json";function D(o,y){return F.$kg.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$ai=D;function p(o){let y;return A.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===E.Schemas.tmp}e.$bi=p,e.$ci="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(o){return o.id===e.$ci}e.$di=r;function s(o,y){return!D(o,y)&&!p(o)}e.$ei=s;function i(o){return(typeof o=="string"?(0,M.$mc)(o):(0,F.$rg)(o))===e.$0h}e.$fi=i}),define(Ae[55],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const F=this.c++;return this.b.set(F,C),this.e(),F}get(C,F){return this.b.has(C)?this.b.get(C)[F]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$xbc=w}),define(Ae[39],Re([1,0,12,23,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=void 0;class F{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new M.$ig(h=>{const E=this.b.get(h.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(h,E){E===null?this.b.delete(h.scheme):this.b.set(h.scheme,E)}isFreeScheme(h){return!this.b.has(h)&&!this.a.has(h)}getCapabilities(h){return this.b.get(h)}}e.$zbc=F,e.$Abc=(0,C.$Mh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=void 0,e.$mM=(0,w.$Mh)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;let A=class extends C.$tN{constructor(E,g,P){const k=P.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",a=P.remote.isRemote?(0,w.localize)(0,null):E?(0,w.localize)(1,null):(0,w.localize)(2,null);super(g.createLogger(k,{name:a}))}};e.$Gdc=A,e.$Gdc=A=Ke([Ve(1,M.$8i),Ve(2,F.$mM)],A)}),define(Ae[188],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0;class M{constructor(A,h,E){this.h=new Map,this.a=A,this.b=h,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new w.$4g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of g.values())P.complete()}catch(P){for(const k of g.values())k.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,h){let E=this.f[A];return typeof E>"u"&&(E=h),E}update(A,h){this.f[A]=h;const E=this.h.get(A);if(E!==void 0)return E.p;const g=new w.$ah;return this.h.set(A,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$3bc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,h){super(A.identifier.value,!0,h),this.j=A}}e.$4bc=C}),define(Ae[189],Re([1,0,5,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class C{constructor(A){this.c=A,this.a=new w.$Ld,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$Ld,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,h,E,g){const k=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(h.value,E,g);this.b.fire(k)}$acceptDirtyStateChanged(A,h){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(h)}$acceptModelSaved(A){const h=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(h.apiNotebook)}}e.$pdc=C}),define(Ae[17],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=void 0,e.$9L=(0,w.$Mh)("IExtHostRpcService");class M{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$0L=M}),define(Ae[190],Re([1,0,20,5]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=void 0;class C{#e;constructor(A,h){this.b=new M.$Ld,this.onDidChange=this.b.event,this.a=w.$Xl.toKey(A.identifier),this.#e=h,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,h){return this.#e.store(this.a,A,h)}delete(A){return this.#e.delete(this.a,A)}}e.$ccc=C}),define(Ae[56],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0,e.$Kbc=(0,w.$Mh)("IURITransformerService");class M{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Lbc=M}),define(Ae[191],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcb=e.$jcb=void 0;class M{constructor(){this.buffers=[]}add(E){let g=this.buffers.indexOf(E);return g<0&&(g=this.buffers.length,this.buffers.push(E)),g}}function C(h,E){if(E.serializeBuffersForPostMessage){const g=new M,k=JSON.stringify(h,(b,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(m)};if(ArrayBuffer.isView(m)){const f=F(m);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(m.buffer),view:{type:f,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),a=g.buffers.map(b=>{const m=new Uint8Array(b);return w.$_d.wrap(m)});return{message:k,buffers:a}}else return{message:JSON.stringify(h),buffers:[]}}e.$jcb=C;function F(h){switch(h.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(h,E){const g=E.map(a=>{const b=new ArrayBuffer(a.byteLength);return new Uint8Array(b).set(a.buffer),b}),P=E.length?(a,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:f}=m,t=g[f];if(m.view)switch(m.view.type){case 1:return new Int8Array(t,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(h,P),arrayBuffers:g}}e.$kcb=A}),define(Ae[99],Re([1,0,159,16,2,6,4,30,38,12,41,127,29]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$D=e.$0D=e.$9D=e.EditorsOrder=e.$8D=e.CloseDirection=e.$7D=e.$6D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.EditorInputCapabilities=e.$WD=e.SaveReason=e.Verbosity=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$OD=e.$ND=e.$MD=e.$LD=e.$KD=void 0,e.$KD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$LD={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$MD="workbench.editor.sidebysideEditor",e.$ND="workbench.editors.textDiffEditor",e.$OD="workbench.editors.binaryResourceDiffEditor";var b;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var m;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function f(ce){const $e=ce;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$PD=f;function t(ce,$e,ie){for(const z of ie.visibleEditorPanes)if(z.group.id===$e&&ce.matches(z.input))return z.getViewState()}e.$QD=t;function n(ce){if($(ce))return!1;const $e=ce;return C.URI.isUri($e?.resource)}e.$RD=n;function c(ce){if($(ce))return!1;const $e=ce;return $e?.original!==void 0&&$e.modified!==void 0}e.$SD=c;function v(ce){if($(ce)||c(ce))return!1;const $e=ce;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$TD=v;function D(ce){if($(ce))return!1;const $e=ce;return $e?$e.resource===void 0||$e.resource.scheme===g.Schemas.untitled||$e.forceUntitled===!0:!1}e.$UD=D;function p(ce){if($(ce))return!1;const $e=ce;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$VD=p;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class i{constructor(){this.a=new Map}registerSource($e,ie){let z=this.a.get($e);return z||(z={source:$e,label:ie},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$WD=new i;var o;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends F.$Qc{}e.$XD=y;function $(ce){return ce instanceof y}e.$YD=$;function S(ce){const $e=ce;return C.URI.isUri($e?.preferredResource)}function I(ce){const $e=ce;return $($e?.primary)&&$($e?.secondary)}e.$ZD=I;function u(ce){const $e=ce;return $($e?.modified)&&$($e?.original)}e.$1D=u;function d(ce,$e,ie,z,q){return Ee(z,[(0,k.$wi)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ue={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor($e,ue)}}),(0,k.$wi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$2D=d;function l(ce){return $(ce?.editor)}e.$3D=l;function R(ce){const $e=ce;return l(ce)&&$e?.group!==void 0}e.$4D=R;function B(ce){const $e=ce;return typeof $e?.groupId=="number"&&$($e.editor)}e.$5D=B;var V;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var j;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var W;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class O{getOriginalUri($e,ie){if(!$e)return;if(p($e))return e.$7D.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:ue}=this.a($e);if(q&&ue){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:ue}}if(c($e)||v($e)||p($e))return;const z=S($e)?$e.preferredResource:$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}a($e){return I($e)||v($e)?{primary:$e.primary,secondary:$e.secondary}:u($e)||c($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if(p($e))return e.$7D.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:ue}=this.a($e);if(q&&ue){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:ue}}if(c($e)||v($e)||p($e))return;const z=$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(z=>$e.scheme===z))return $e}else if(ie===$e.scheme)return $e}}var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function ee(ce,$e,ie,z){if(!ce.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ie===N.MOUSE||ie===N.KEYBOARD;case"mouse":return ie===N.MOUSE;case"keyboard":return ie===N.KEYBOARD}return!1}e.$6D=ee,e.$7D=new O;var X;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class ye{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$Lh);for(const[z,q]of this.c)this.e(z,q,ie);this.c.clear()}e($e,ie,z){const q=z.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,M.$Hf)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,F.$Oc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}h.$0m.add(e.$KD.EditorFactory,new ye);async function De(ce,$e,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async z=>{const q=C.URI.revive(z.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",z);return}let we=z.exists,ve=z.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(q)).isDirectory?E.FileType.Directory:E.FileType.Unknown,we=!0}catch(ke){ie.error(ke),we=!1}if(!we&&z.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",z);return}if(ve===E.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",z);return}const me={...z.options,pinned:!0};return we?{resource:q,options:me}:{resource:q,options:me,forceUntitled:!0}}))}e.$8D=De;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function Y(ce){const $e=ce;if(!$e)return!1;const ie=$e;if(ie.modified)return Y(ie.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$9D=Y;function le(ce){return(0,P.$yi)(ce)}e.$0D=le;function Ee(ce,$e,ie){const z=(0,P.$zi)(ce,$e);return z.forceMessage=ie?.forceMessage,z.forceSeverity=ie?.forceSeverity,z.allowDialog=ie?.allowDialog,z}e.$$D=Ee}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,24,89,183]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=e.$gE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$fE=e.$eE=e.ViewContentGroups=e.$dE=e.$cE=e.ViewContainerLocation=e.Extensions=e.$bE=void 0,e.$bE=(0,k.$Xv)("default-view-icon",P.$Rj.window,(0,M.localize)(0,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var b;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$cE=[0,1,2];function m(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$dE=m;class f extends F.$Qc{constructor(){super(...arguments),this.c=this.B(new w.$Ld),this.onDidRegister=this.c.event,this.f=this.B(new w.$Ld),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Pb)([...this.g.values()])}registerViewContainer(i,o,y){const $=this.get(i.id);if($)return $;const S=i;return S.openCommandActionDescriptor=y?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,A.$vc)(this.g,o,[]).push(S),y?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:o}),S}deregisterViewContainer(i){for(const o of this.g.keys()){const y=this.g.get(o),$=y?.indexOf(i);if($!==-1){y?.splice($,1),y.length===0&&this.g.delete(o),this.f.fire({viewContainer:i,viewContainerLocation:o});return}}}get(i){return this.all.filter(o=>o.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(y=>y?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(o=>this.getViewContainerLocation(o)===i)}}h.$0m.add(a.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function n(s,i){const o=s.group??t.More,y=i.group??t.More;return o!==y?o.localeCompare(y):(s.order??5)-(i.order??5)}class c extends F.$Qc{constructor(){super(...arguments),this.c=this.B(new w.$Ld),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$Ld),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$Ld),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$Ld),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Ec}registerViews(i,o){this.registerViews2([{views:i,viewContainer:o}])}registerViews2(i){i.forEach(({views:o,viewContainer:y})=>this.r(o,y)),this.c.fire(i)}deregisterViews(i,o){const y=this.s(i,o);y.length&&this.f.fire({views:y,viewContainer:o})}moveViews(i,o){for(const y of this.m.keys())if(y!==o){const $=this.s(i,y);$.length&&(this.r($,o),this.g.fire({views:$,from:y,to:o}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const o of this.j){const y=(this.m.get(o)||[]).filter($=>$.id===i)[0];if(y)return y}return null}getViewContainer(i){for(const o of this.j)if((this.m.get(o)||[]).filter($=>$.id===i)[0])return o;return null}registerViewWelcomeContent(i,o){return this.n.add(i,o),this.h.fire(i),(0,F.$Oc)(()=>{this.n.delete(i,o),this.h.fire(i)})}registerViewWelcomeContent2(i,o){const y=new Map;for(const[$,S]of o)this.n.add(i,S),y.set($,(0,F.$Oc)(()=>{this.n.delete(i,S),this.h.fire(i)}));return this.h.fire(i),y}getViewWelcomeContent(i){const o=[];return this.n.forEach(i,y=>o.push(y)),o.sort(n)}r(i,o){let y=this.m.get(o);y||(y=[],this.m.set(o,y),this.j.push(o));for(const $ of i){if(this.getView($.id)!==null)throw new Error((0,M.localize)(1,null,$.id));y.push($)}}s(i,o){const y=this.m.get(o);if(!y)return[];const $=[],S=[];for(const I of y)i.includes(I)?$.push(I):S.push(I);return $.length&&(S.length?this.m.set(o,S):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),$}}h.$0m.add(a.ViewsRegistry,new c),e.$eE=(0,C.$Mh)("viewsService"),e.$fE=(0,C.$Mh)("viewDescriptorService");var v;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(v||(e.ViewVisibilityState=v={}));var D;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(D||(e.TreeItemCollapsibleState=D={}));class p{constructor(i,o){this.c=!1,this.d=!1,(0,g.$1m)(this,i),this.d=!!o,this.resolve=async y=>{if(o&&!this.c){const $=await o(y);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}y.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$gE=p;class r extends Error{constructor(i){super((0,M.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$hE=r}),define(Ae[193],Re([1,0,5,13,161]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcb=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new w.$Ld,this.n=new w.$Ld,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(h){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=h}onEvent(h){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=h}onRequest(h){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=h}sendResponse(h){h.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${h.command}`)):this.s("response",h)}sendRequest(h,E,g,P){const k={command:h};if(E&&Object.keys(E).length>0&&(k.arguments=E),this.s("request",k),typeof P=="number"){const a=setTimeout(()=>{clearTimeout(a);const b=this.f.get(k.seq);if(b){this.f.delete(k.seq);const m={type:"response",seq:0,request_seq:k.seq,success:!1,command:h,message:(0,C.localize)(0,null,P,h)};b(m)}},P)}return g&&this.f.set(k.seq,g),k.seq}acceptMessage(h){this.j?this.j(h):(this.k.push(h),this.k.length===1&&this.q())}o(h,E){return h.type!=="event"||E.type!=="event"}async q(){let h;for(;this.k.length;){if((!h||this.o(this.k[0],h))&&await(0,M.$Sg)(0),h=this.k.shift(),!h)return;switch(h.type){case"event":this.i?.(h);break;case"request":this.g?.(h);break;case"response":{const E=h,g=this.f.get(E.request_seq);g&&(this.f.delete(E.request_seq),g(E));break}}}}s(h,E){E.type=h,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const h=new Map;this.f.forEach((E,g)=>h.set(g,E)),await(0,M.$Sg)(500),h.forEach((E,g)=>{E({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Pcb=F}),define(Ae[194],Re([1,0,162,32,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$XG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$WG=e.MemoryRangeType=e.$VG=e.State=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0,e.$TF="workbench.view.debug",e.$UF="workbench.debug.variablesView",e.$VF="workbench.debug.watchExpressionsView",e.$WF="workbench.debug.callStackView",e.$XF="workbench.debug.loadedScriptsView",e.$YF="workbench.debug.breakPointsView",e.$ZF="workbench.debug.disassemblyView",e.$1F="workbench.panel.repl",e.$2F="workbench.panel.repl.view",e.$3F=new M.$4i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$4F=new M.$4i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$5F=new M.$4i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$6F="debugUx",e.$7F=new M.$4i(e.$6F,"default",{type:"string",description:w.localize(3,null)}),e.$8F=new M.$4i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$9F=new M.$4i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$0F=new M.$4i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$$F=new M.$4i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$_F=new M.$4i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$aG=new M.$4i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$bG=new M.$4i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$cG=new M.$4i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$dG=new M.$4i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$eG=new M.$4i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$fG=new M.$4i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$gG=new M.$4i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$hG=new M.$4i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$iG=new M.$4i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$jG=new M.$4i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$kG=new M.$4i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$lG=new M.$4i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$mG=new M.$4i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$nG=new M.$4i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$oG=new M.$4i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$pG=new M.$4i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$qG=new M.$4i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$rG=new M.$4i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$sG=new M.$4i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$tG=new M.$4i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$uG=new M.$4i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$vG=new M.$4i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$wG=new M.$4i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$xG=new M.$4i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$yG=new M.$4i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$zG=new M.$4i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$AG=new M.$4i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$BG=new M.$4i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$CG=new M.$4i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$DG=new M.$4i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$EG=new M.$4i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$FG=new M.$4i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$GG=new M.$4i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$HG=new M.$4i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$IG=new M.$4i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$JG=new M.$4i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$KG=new M.$4i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$LG=new M.$4i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$MG=new M.$4i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$NG=new M.$4i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$OG=new M.$4i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$PG=new M.$4i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const F=a=>w.localize(51,null,a);e.$QG=F,e.$RG="editor.contrib.debug",e.$SG="editor.contrib.breakpoint",e.$TG="debug",e.$UG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(A||(e.State=A={}));function h(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$VG=h;var E;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$WG="vscode-debug-memory";var g;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$XG=(0,C.$Mh)("debugService");var k;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[195],Re([1,0,15,2,19,24,12,44,21,18]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=void 0;const P=/{([^}]+)}/g;function k(I,u,d){return I.replace(P,function(l,R){return u&&R.length>0&&R[0]!=="_"?l:d&&d.hasOwnProperty(R)?d[R]:l})}e.$iF=k;function a(I){const u={};for(const d of Object.keys(I))d.startsWith("!")||(u[d]=I[d]);return u}e.$jF=a;function b(I){return I.configuration.request==="attach"&&!m(I)&&(!I.parentSession||b(I.parentSession))}e.$kF=b;function m(I){let u=I.configuration.type;if(u)return u==="vslsShare"&&(u=I.configuration.adapterProxy.configuration.type),(0,w.$Ze)(u,"extensionhost")||(0,w.$Ze)(u,"pwa-extensionhost")?I:I.parentSession?m(I.parentSession):void 0}e.$lF=m;function f(I){return I.type&&(I.label||I.program||I.runtime)}e.$mF=f;function t(I,u,d){let l,R=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=B.exec(I);){const j=V.index+1,W=j+V[0].length;if(j<=u&&W>=d){l=V[0],R=j;break}}if(l){const j=/\w+/g;let W=null;for(;(W=j.exec(l))&&!(W.index+1+R+W[0].length>=d););W&&(l=l.substring(0,j.lastIndex))}return l?{start:R,end:R+l.length-1}:{start:0,end:0}}e.$nF=t;async function n(I,u,d,l){if(I.evaluatableExpressionProvider.has(u)){const R=I.evaluatableExpressionProvider.ordered(u),B=(0,g.$Fb)(await Promise.all(R.map(async V=>{try{return await V.provideEvaluatableExpression(u,d,l??E.CancellationToken.None)}catch{return}})));if(B.length>0){let V=B[0].expression;const j=B[0].range;return V||(V=u.getLineContent(d.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:V}}}else{const R=u.getLineContent(d.lineNumber),{start:B,end:V}=t(R,d.column,d.column),j=R.substring(B-1,V);return{matchingExpression:j,range:new h.$ms(d.lineNumber,B,d.lineNumber,B+j.length)}}return null}e.$oF=n;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(I){return!!(I&&I.match(c))}e.$pF=v;function D(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(v(I.path))return M.URI.parse(I.path);if((0,C.$gc)(I.path))return M.URI.file(I.path)}return I.path}function p(I){if(typeof I.path=="object"){const u=M.URI.revive(I.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return I.path}function r(I,u){const d=u?D:p,l=(0,F.$Xm)(I);return i(l,(R,B)=>{R&&B&&(B.path=d(B))}),l}e.$qF=r;function s(I,u){const d=u?D:p,l=(0,F.$Xm)(I);return i(l,(R,B)=>{!R&&B&&(B.path=d(B))}),l}e.$rF=s;function i(I,u){switch(I.type){case"event":{const d=I;switch(d.event){case"output":u(!1,d.body.source);break;case"loadedSource":u(!1,d.body.source);break;case"breakpoint":u(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=I;switch(d.command){case"setBreakpoints":u(!0,d.arguments.source);break;case"breakpointLocations":u(!0,d.arguments.source);break;case"source":u(!0,d.arguments.source);break;case"gotoTargets":u(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(l=>u(!1,l));break;default:break}break}case"response":{const d=I;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(l=>u(!1,l.source));break;case"loadedSources":d.body.sources.forEach(l=>u(!1,l));break;case"scopes":d.body.scopes.forEach(l=>u(!1,l.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(l=>u(!1,l.source));break;case"setBreakpoints":d.body.breakpoints.forEach(l=>u(!1,l.source));break;case"disassemble":d.body?.instructions.forEach(R=>u(!1,R.location));break;default:break}break}}}function o(I){return I.filter(u=>!u.presentation?.hidden).sort((u,d)=>u.presentation?d.presentation?u.presentation.group?d.presentation.group?u.presentation.group!==d.presentation.group?u.presentation.group.localeCompare(d.presentation.group):y(u.presentation.order,d.presentation.order):-1:d.presentation.group?1:y(u.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.$sF=o;function y(I,u){return typeof I!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:I-u}async function $(I,u){const d=I.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(d!=="none"&&(await u.saveAll(),d==="allEditorsInActiveGroup")){const l=u.activeEditorPane;l&&l.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:l.input,groupId:l.group.id})}await I.reloadConfiguration()}e.$tF=$;const S=(I,u)=>!I||!u?I===u:I.name===u.name&&I.path===u.path&&I.sourceReference===u.sourceReference;e.$uF=S}),define(Ae[75],Re([1,0,25,37,66,67,12,19,22,32]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jI=e.$iI=e.$hI=e.$gI=e.CellStatusbarAlignment=e.$fI=e.$eI=e.$dI=e.NotebookEditorPriority=e.$cI=e.$bI=e.$aI=e.$_H=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$$H=e.$0H=e.$9H=e.$8H=e.CellKind=e.$7H=e.$6H=e.$5H=void 0,e.$5H="workbench.editor.notebook",e.$6H="workbench.editor.notebookTextDiffEditor",e.$7H="workbench.editor.interactive";var P;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(P||(e.CellKind=P={})),e.$8H=["application/json","application/javascript","text/html","image/svg+xml",F.$Jr.latex,F.$Jr.markdown,"image/png","image/jpeg",F.$Jr.text],e.$9H=[F.$Jr.latex,F.$Jr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Jr.text],e.$0H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$$H="_notAvailable";var k;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var a;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var b;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var m;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(m||(e.NotebookRendererMatch=m={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var n;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var c;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var v;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ee.join("")}]+`),ye=7;function De($e,ie){const z=ie.toString(ye),ue=`${z.length<ee.length?ee[z.length-1]:"z"}${z}s${(0,w.$te)(w.$_d.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:ue})}N.generate=De;function Pe($e){if($e.scheme!==N.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const z=parseInt($e.fragment.substring(0,ie).replace(X,""),ye),q=(0,w.$se)($e.fragment.substring(ie+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:q,fragment:null})}}N.parse=Pe;function Y($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=Y;function le($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const z=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:z,notebook:$e.with({scheme:q||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=le;function Ee($e,ie,z){return N.generate($e,ie).with({scheme:z})}N.generateCellPropertyUri=Ee;function ce($e,ie){if($e.scheme===ie)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=ce})(v||(e.CellUri=v={}));const D=N=>E.$i?N.replace(/\//g,"\\"):N;class p{constructor(ee=[],X=e.$8H){this.e=X,this.d=[...new Set(ee)].map(ye=>({pattern:ye,matches:M.$tj(D(ye))}))}sort(ee){const X=new Map(C.Iterable.map(ee,De=>[De,D(De)]));let ye=[];for(const{matches:De}of this.d)for(const[Pe,Y]of X)if(De(Y)){ye.push(Pe),X.delete(Pe);break}return X.size&&(ye=ye.concat([...X.keys()].sort((De,Pe)=>this.e.indexOf(De)-this.e.indexOf(Pe)))),ye}prioritize(ee,X){const ye=this.f(ee);if(ye===-1){this.d.unshift({pattern:ee,matches:M.$tj(D(ee))});return}const De=new Set(X.map(Y=>this.f(Y,ye)));De.delete(-1);const Pe=Array.from(De).sort();this.d.splice(ye+1,0,...Pe.map(Y=>this.d[Y]));for(let Y=Pe.length-1;Y>=0;Y--)this.d.splice(Pe[Y],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,X=this.d.length){const ye=D(ee);for(let De=0;De<X;De++)if(this.d[De].matches(ye))return De;return-1}}e.$_H=p;function r(N,ee,X,ye=(De,Pe)=>De===Pe){const De=[];function Pe(Ee,ce,$e){if(ce===0&&$e.length===0)return;const ie=De[De.length-1];ie&&ie.start+ie.deleteCount===Ee?(ie.deleteCount+=ce,ie.toInsert.push(...$e)):De.push({start:Ee,deleteCount:ce,toInsert:$e})}let Y=0,le=0;for(;;){if(Y===N.length){Pe(Y,0,ee.slice(le));break}if(le===ee.length){Pe(Y,N.length-Y,[]);break}const Ee=N[Y],ce=ee[le];if(ye(Ee,ce)){Y+=1,le+=1;continue}X(ce)?(Pe(Y,1,[]),Y+=1):(Pe(Y,0,[ce]),le+=1)}return De}e.$aI=r,e.$bI=new g.$4i("notebookEditorCursorAtBoundary","none"),e.$cI=new g.$4i("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function i(N){const ee=N;return!!((typeof ee.include=="string"||M.$uj(ee.include))&&(typeof ee.exclude=="string"||M.$uj(ee.exclude)))}e.$dI=i;function o(N,ee,X){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ee)>=0||N.viewType===ee)return!0;if(N.filenamePattern){const ye=i(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,De=i(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(M.$sj(ye,(0,h.$lc)(X.fsPath).toLowerCase()))return!(De&&M.$sj(De,(0,h.$lc)(X.fsPath).toLowerCase()))}return!1}e.$eI=o,e.$fI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var y;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class ${static{this.d="notebook/"}static create(ee){return`${$.d}${ee}`}static parse(ee){if(ee.startsWith($.d))return ee.substring($.d.length)}}e.$gI=$;function S(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$hI=S;const I=new TextDecoder;function u(N){const ee=[];let X=!1;for(const Y of N)(ee.length===0||X)&&(ee.push(Y),X=!0);let ye=R(ee);const De=w.$_d.concat(ee.map(Y=>w.$_d.wrap(Y))),Pe=O(De);return ye=ye||Pe.byteLength!==De.byteLength,{data:Pe,didCompression:ye}}e.$iI=u,e.$jI=`${String.fromCharCode(27)}[A`;const d=e.$jI.split("").map(N=>N.charCodeAt(0)),l=10;function R(N){let ee=!1;return N.forEach((X,ye)=>{if(ye===0||X.length<e.$jI.length)return;const De=N[ye-1],Pe=X.subarray(0,e.$jI.length);if(Pe[0]===d[0]&&Pe[1]===d[1]&&Pe[2]===d[2]){const Y=De.lastIndexOf(l);if(Y===-1)return;ee=!0,N[ye-1]=De.subarray(0,Y),N[ye]=X.subarray(e.$jI.length)}}),ee}function B(N){let ee=N;do N=ee,ee=N.replace(/[^\n]\x08/gm,"");while(ee.length<N.length);return N}function V(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ee=N.match(/^(.*)\r+/m)[1];let X=N.match(/\r+(.*)$/m)[1];X=X+ee.slice(X.length,ee.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return N}const j="\b".charCodeAt(0),W="\r".charCodeAt(0);function O(N){return!N.buffer.includes(j)&&!N.buffer.includes(W)?N:w.$_d.fromString(V(B(I.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,9,50,28,67,15,16,2,36,20,38,97,75]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m){"use strict";var f,t,n,c,v,D,p,r,s,i,o,y,$,S,I,u,d,l;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$XL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.TestRunProfileKind=e.TestResultState=e.$EL=e.$DL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$CL=e.$BL=e.$AL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$zL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.ColorThemeKind=e.$tL=e.$sL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$rL=e.DebugConsoleMode=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$lL=e.$kL=e.FileChangeType=e.$jL=e.$iL=e.$hL=e.$gL=e.InlineCompletionTriggerKind=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.ConfigurationTarget=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$VK=e.ViewBadge=e.ProgressLocation=e.$UK=e.$TK=e.TaskScope=e.ShellQuoting=e.$SK=e.$RK=e.$QK=e.TaskPanelKind=e.TaskRevealKind=e.$PK=e.TerminalLocation=e.$OK=e.$NK=e.$MK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$LK=e.$KK=e.$JK=e.$IK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$HK=e.StatusBarAlignment=e.ViewColumn=e.$GK=e.$FK=e.$EK=e.$DK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$CK=e.$BK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.LanguageStatusSeverity=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.CodeActionTriggerKind=e.$pK=e.$oK=e.SymbolTag=e.SymbolKind=e.$nK=e.DocumentHighlightKind=e.$mK=e.$lK=e.$kK=e.$jK=e.DiagnosticSeverity=e.DiagnosticTag=e.$iK=e.$hK=e.FileEditType=e.$gK=e.$fK=e.$eK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(U){return Object.assign(U,{apply:function(...ne){if(ne.length===0)return Reflect.construct(U,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(U,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(U,[]);{const[Se,...Je]=ne;return Reflect.construct(U,Je,Se.constructor)}}})}var B;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var V;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let j=f=class{static from(...T){let ne=T;return new f(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$0J=j,e.$0J=j=f=Ke([R],j);let W=t=class{static Min(...T){if(T.length===0)throw new TypeError;let ne=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isBefore(ne)&&(ne=Je)}return ne}static Max(...T){if(T.length===0)throw new TypeError;let ne=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isAfter(ne)&&(ne=Je)}return ne}static isPosition(T){if(!T)return!1;if(T instanceof t)return!0;const{line:ne,character:Se}=T;return typeof ne=="number"&&typeof Se=="number"}static of(T){if(T instanceof t)return T;if(this.isPosition(T))return new t(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,ne){if(T<0)throw(0,M.$5)("line must be non-negative");if(ne<0)throw(0,M.$5)("character must be non-negative");this.c=T,this.e=ne}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,ne=0){if(T===null||ne===null)throw(0,M.$5)();let Se;return typeof T>"u"?Se=0:typeof T=="number"?Se=T:(Se=typeof T.lineDelta=="number"?T.lineDelta:0,ne=typeof T.characterDelta=="number"?T.characterDelta:0),Se===0&&ne===0?this:new t(this.line+Se,this.character+ne)}with(T,ne=this.character){if(T===null||ne===null)throw(0,M.$5)();let Se;return typeof T>"u"?Se=this.line:typeof T=="number"?Se=T:(Se=typeof T.line=="number"?T.line:this.line,ne=typeof T.character=="number"?T.character:this.character),Se===this.line&&ne===this.character?this:new t(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$$J=W,e.$$J=W=t=Ke([R],W);let O=n=class{static isRange(T){return T instanceof n?!0:T?W.isPosition(T.start)&&W.isPosition(T.end):!1}static of(T){if(T instanceof n)return T;if(this.isRange(T))return new n(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,ne,Se,Je){let Xe,ot;if(typeof T=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(Xe=new W(T,ne),ot=new W(Se,Je)):W.isPosition(T)&&W.isPosition(ne)&&(Xe=W.of(T),ot=W.of(ne)),!Xe||!ot)throw new Error("Invalid arguments");Xe.isBefore(ot)?(this.c=Xe,this.e=ot):(this.c=ot,this.e=Xe)}contains(T){return n.isRange(T)?this.contains(T.start)&&this.contains(T.end):W.isPosition(T)?!(W.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const ne=W.Max(T.start,this.c),Se=W.Min(T.end,this.e);if(!ne.isAfter(Se))return new n(ne,Se)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const ne=W.Min(T.start,this.c),Se=W.Max(T.end,this.end);return new n(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,ne=this.end){if(T===null||ne===null)throw(0,M.$5)();let Se;return T?W.isPosition(T)?Se=T:(Se=T.start||this.start,ne=T.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new n(Se,ne)}toJSON(){return[this.start,this.end]}};e.$_J=O,e.$_J=O=n=Ke([R],O);let N=c=class extends O{static isSelection(T){return T instanceof c?!0:T?O.isRange(T)&&W.isPosition(T.anchor)&&W.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,ne,Se,Je){let Xe,ot;if(typeof T=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(Xe=new W(T,ne),ot=new W(Se,Je)):W.isPosition(T)&&W.isPosition(ne)&&(Xe=W.of(T),ot=W.of(ne)),!Xe||!ot)throw new Error("Invalid arguments");super(Xe,ot),this.f=Xe,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$aK=N,e.$aK=N=c=Ke([R],N);const ee=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,M.$5)("connectionToken")};class X{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ne,Se){if(typeof T!="string"||T.length===0)throw(0,M.$5)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.$5)("port");typeof Se<"u"&&ee(Se),this.host=T,this.port=Math.round(ne),this.connectionToken=Se}}e.$bK=X;class ye{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ne){this.makeConnection=T,this.connectionToken=ne,typeof ne<"u"&&ee(ne)}}e.$cK=ye;class De extends Error{static NotAvailable(T,ne){return new De(T,b.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(T){return new De(T,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,ne=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(T),this._message=T,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$dK=De;var Pe;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var Y;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let le=v=class{static isTextEdit(T){return T instanceof v?!0:T?O.isRange(T)&&typeof T.newText=="string":!1}static replace(T,ne){return new v(T,ne)}static insert(T,ne){return v.replace(new O(T,T),ne)}static delete(T){return v.replace(T,"")}static setEndOfLine(T){const ne=new v(new O(new W(0,0),new W(0,0)),"");return ne.newEol=T,ne}get range(){return this.c}set range(T){if(T&&!O.isRange(T))throw(0,M.$5)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,M.$5)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,M.$5)("newEol");this.f=T}constructor(T,ne){this.c=T,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$eK=le,e.$eK=le=v=Ke([R],le);let Ee=D=class{static isNotebookCellEdit(T){return T instanceof D?!0:T?Yt.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,ne){return new D(T,ne)}static insertCells(T,ne){return new D(new Yt(T,T),ne)}static deleteCells(T){return new D(T,[])}static updateCellMetadata(T,ne){const Se=new D(new Yt(T,T),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(T){const ne=new D(new Yt(0,0),[]);return ne.newNotebookMetadata=T,ne}constructor(T,ne){this.range=T,this.newCells=ne}};e.$fK=Ee,e.$fK=Ee=D=Ke([R],Ee);class ce{static isSnippetTextEdit(T){return T instanceof ce?!0:T?O.isRange(T.range)&&z.isSnippetString(T.snippet):!1}static replace(T,ne){return new ce(T,ne)}static insert(T,ne){return ce.replace(new O(T,T),ne)}constructor(T,ne){this.range=T,this.snippet=ne}}e.$gK=ce;var $e;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,ne,Se,Je){this.c.push({_type:1,from:T,to:ne,options:Se,metadata:Je})}createFile(T,ne,Se){this.c.push({_type:1,from:void 0,to:T,options:ne,metadata:Se})}deleteFile(T,ne,Se){this.c.push({_type:1,from:T,to:void 0,options:ne,metadata:Se})}e(T,ne,Se){this.c.push({_type:3,metadata:Se,uri:T,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(T,ne,Se,Je){const Xe=ne.start,ot=ne.end;(Xe!==ot||Se.length>0)&&this.c.push({_type:5,uri:T,index:Xe,count:ot-Xe,cells:Se,metadata:Je})}g(T,ne,Se,Je){this.c.push({_type:3,metadata:Je,uri:T,edit:{editType:3,index:ne,metadata:Se}})}replace(T,ne,Se,Je){this.c.push({_type:2,uri:T,edit:new le(ne,Se),metadata:Je})}insert(T,ne,Se,Je){this.replace(T,new O(ne,ne),Se,Je)}delete(T,ne,Se){this.replace(T,ne,"",Se)}has(T){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===T.toString())}set(T,ne){if(ne)for(const Se of ne){if(!Se)continue;let Je,Xe;Array.isArray(Se)?(Je=Se[0],Xe=Se[1]):Je=Se,Ee.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(T,Je.range.start,Je.newCellMetadata,Xe):Je.newNotebookMetadata?this.e(T,Je.newNotebookMetadata,Xe):this.f(T,Je.range,Je.newCells,Xe):ce.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:T,range:Je.range,edit:Je.snippet,metadata:Xe}):this.c.push({_type:2,uri:T,edit:Je,metadata:Xe})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===T.toString()&&(this.c[Se]=void 0);break}}(0,w.$Gb)(this.c)}}get(T){const ne=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===T.toString()&&ne.push(Se.edit);return ne}entries(){const T=new F.$yc;for(const ne of this.c)if(ne._type===2){let Se=T.get(ne.uri);Se||(Se=[ne.uri,[]],T.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$hK=ie,e.$hK=ie=Ke([R],ie);let z=p=class{static isSnippetString(T){return T instanceof p?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=p.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,ne=this.e++){if(typeof T=="function"){const Se=new p;Se.e=this.e,T(Se),this.e=Se.e,T=Se.value}else T=p.c(T);return this.value+="${",this.value+=ne,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,ne=this.e++){const Se=T.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(T,ne){if(typeof ne=="function"){const Se=new p;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$iK=z,e.$iK=z=p=Ke([R],z);var q;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ue;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let we=r=class{static isLocation(T){return T instanceof r?!0:T?O.isRange(T.range)&&g.URI.isUri(T.uri):!1}constructor(T,ne){if(this.uri=T,ne)if(O.isRange(ne))this.range=O.of(ne);else if(W.isPosition(ne))this.range=new O(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$jK=we,e.$jK=we=r=Ke([R],we);let ve=class{static is(T){return T?typeof T.message=="string"&&T.location&&O.isRange(T.location.range)&&g.URI.isUri(T.location.uri):!1}constructor(T,ne){this.location=T,this.message=ne}static isEqual(T,ne){return T===ne?!0:!T||!ne?!1:T.message===ne.message&&T.location.range.isEqual(ne.location.range)&&T.location.uri.toString()===ne.location.uri.toString()}};e.$kK=ve,e.$kK=ve=Ke([R],ve);let me=class{constructor(T,ne,Se=ue.Error){if(!O.isRange(T))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=T,this.message=ne,this.severity=Se}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,ne){return T===ne?!0:!T||!ne?!1:T.message===ne.message&&T.severity===ne.severity&&T.code===ne.code&&T.severity===ne.severity&&T.source===ne.source&&T.range.isEqual(ne.range)&&(0,w.$sb)(T.tags,ne.tags)&&(0,w.$sb)(T.relatedInformation,ne.relatedInformation,ve.isEqual)}};e.$lK=me,e.$lK=me=Ke([R],me);let ke=class{constructor(T,ne){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=ne}};e.$mK=ke,e.$mK=ke=Ke([R],ke);var re;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let he=class{constructor(T,ne=re.Text){this.range=T,this.kind=ne}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$nK=he,e.$nK=he=Ke([R],he);var se;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(U){U[U.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let de=s=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,ne,Se,Je,Xe){this.name=T,this.kind=ne,this.containerName=Xe,typeof Se=="string"&&(this.containerName=Se),Je instanceof we?this.location=Je:Se instanceof O&&(this.location=new we(Je,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$oK=de,e.$oK=de=s=Ke([R],de);let Ie=i=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(i.validate)}constructor(T,ne,Se,Je,Xe){this.name=T,this.detail=ne,this.kind=Se,this.range=Je,this.selectionRange=Xe,this.children=[],i.validate(this)}};e.$pK=Ie,e.$pK=Ie=i=Ke([R],Ie);var L;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(L||(e.CodeActionTriggerKind=L={}));let K=class{constructor(T,ne){this.title=T,this.kind=ne}};e.$qK=K,e.$qK=K=Ke([R],K);let G=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$rK=G,e.$rK=G=o=Ke([R],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let Q=class{constructor(T,ne){if(this.range=T,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$sK=Q,e.$sK=Q=Ke([R],Q);class J{constructor(T,ne,Se,Je,Xe,ot){this.kind=T,this.name=ne,this.detail=Se,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$tK=J;class x{constructor(T,ne){this.fromRanges=ne,this.from=T}}e.$uK=x;class ae{constructor(T,ne){this.fromRanges=ne,this.to=T}}e.$vK=ae;var Fe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let je=class{constructor(T,ne){this.range=T,this.command=ne}get isResolved(){return!!this.command}};e.$wK=je,e.$wK=je=Ke([R],je);let Qe=y=class{#e;static isMarkdownString(T){return T instanceof y?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,ne=!1){this.#e=new C.$Zj(T,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,ne){return this.#e.appendCodeblock(ne??"",T),this}};e.$xK=Qe,e.$xK=Qe=y=Ke([R],Qe);let He=class{constructor(T,ne){this.label=T,this.documentation=ne}};e.$yK=He,e.$yK=He=Ke([R],He);let _e=class{constructor(T,ne){this.label=T,this.documentation=ne,this.parameters=[]}};e.$zK=_e,e.$zK=_e=Ke([R],_e);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$AK=Ye,e.$AK=Ye=Ke([R],Ye);var xe;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(T){this.value=T}};e.$BK=tt,e.$BK=tt=Ke([R],tt);let ze=class{constructor(T,ne,Se){this.position=T,this.label=ne,this.kind=Se}};e.$CK=ze,e.$CK=ze=Ke([R],ze);var st;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var _;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(_||(e.CompletionItemKind=_={}));var Z;(function(U){U[U.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let pe=class{constructor(T,ne){this.label=T,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&_[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$DK=pe,e.$DK=pe=Ke([R],pe);let Be=class{constructor(T=[],ne=!1){this.items=T,this.isIncomplete=ne}};e.$EK=Be,e.$EK=Be=Ke([R],Be);let Ne=class{constructor(T,ne,Se){this.insertText=T,this.range=ne,this.command=Se}};e.$FK=Ne,e.$FK=Ne=Ke([R],Ne);let Ze=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$GK=Ze,e.$GK=Ze=Ke([R],Ze);var rt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var gt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(gt||(e.StatusBarAlignment=gt={}));function yt(U,T){return`${k.$Xl.toKey(U)}.${T}`}e.$HK=yt;var Pt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Zt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Zt||(e.TextDocumentSaveReason=Zt={}));var qt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(qt||(e.TextEditorRevealType=qt={}));var bt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(bt||(e.TextEditorSelectionChangeKind=bt={}));var jt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Ft;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Ft||(e.DecorationRangeBehavior=Ft={})),function(U){function T(ne){switch(ne){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=T}(bt||(e.TextEditorSelectionChangeKind=bt={}));var Ut;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ut||(e.SyntaxTokenType=Ut={})),function(U){function T(ne){switch(ne){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=T}(Ut||(e.SyntaxTokenType=Ut={}));let At=class{constructor(T,ne){if(ne&&!g.URI.isUri(ne))throw(0,M.$5)("target");if(!O.isRange(T)||T.isEmpty)throw(0,M.$5)("range");this.range=T,this.target=ne}};e.$IK=At,e.$IK=At=Ke([R],At);let Rt=class{constructor(T,ne,Se,Je){this.red=T,this.green=ne,this.blue=Se,this.alpha=Je}};e.$JK=Rt,e.$JK=Rt=Ke([R],Rt);let Ot=class{constructor(T,ne){if(ne&&!(ne instanceof Rt))throw(0,M.$5)("color");if(!O.isRange(T)||T.isEmpty)throw(0,M.$5)("range");this.range=T,this.color=ne}};e.$KK=Ot,e.$KK=Ot=Ke([R],Ot);let Bt=class{constructor(T){if(!T||typeof T!="string")throw(0,M.$5)("label");this.label=T}};e.$LK=Bt,e.$LK=Bt=Ke([R],Bt);var Kt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Wt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var at;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(T,ne,Se){if(this.startIndex=T,this.length=ne,this.tooltip=Se,typeof T!="number"||T<0)throw(0,M.$5)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$5)("tooltip")}}e.$MK=ut;class Ht{constructor(T){this.uri=T}}e.$NK=Ht;class Ct{constructor(T){this.terminalCommand=T}}e.$OK=Ct;var Dt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class ht{constructor(T){if(this.options=T,typeof T!="object")throw(0,M.$5)("options")}}e.$PK=ht;var St;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var Tt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let Et=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(T){switch(T){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(T,ne){if(this.label=ne,typeof T!="string"||typeof ne!="string")throw(0,M.$5)("name");this.c=T}get id(){return this.c}};e.$QK=Et,e.$QK=Et=$=Ke([R],Et);function qe(U){let T="";for(let ne=0;ne<U.length;ne++)T+=U[ne].replace(/,/g,",,")+",";return T}let Nt=class{constructor(T,ne,Se){if(typeof T!="string")throw(0,M.$5)("process");this.e=[],this.c=T,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,M.$5)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)T.push(ne);return qe(T)}};e.$RK=Nt,e.$RK=Nt=Ke([R],Nt);let Ce=class{constructor(T,ne,Se){if(this.f=[],Array.isArray(ne)){if(!T)throw(0,M.$5)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$5)("command");this.e=T,this.f=ne,this.g=Se}else{if(typeof T!="string")throw(0,M.$5)("commandLine");this.c=T,this.g=ne}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,M.$5)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$5)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)T.push(typeof ne=="string"?ne:ne.value);return qe(T)}};e.$SK=Ce,e.$SK=Ce=Ke([R],Ce);var Me;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Me||(e.ShellQuoting=Me={}));var ge;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(ge||(e.TaskScope=ge={}));class H{constructor(T){this.c=T}computeId(){return"customExecution"+(0,P.$cg)()}set callback(T){this.c=T}get callback(){return this.c}}e.$TK=H;let Le=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,ne,Se,Je,Xe,ot){this.j=!1,this.k=this.definition=T;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=Se,this.execution=Je,lt=Xe,this.j=!0):ne===ge.Global||ne===ge.Workspace?(this.target=ne,this.m=this.name=Se,this.t=this.source=Je,this.execution=Xe,lt=ot):(this.target=ne,this.m=this.name=Se,this.t=this.source=Je,this.execution=Xe,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Nt?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof H?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,P.$cg)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,M.$5)("Kind can't be undefined or null");this.z(),this.k=T}get scope(){return this.l}set target(T){this.z(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,M.$5)("name");this.z(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.z(),this.n=T;const ne=this.k.type;(S.g===ne||S.e===ne||S.f===ne||S.c===ne)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.z(),this.o=T,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.z(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,M.$5)("source must be a string of length > 0");this.z(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.z(),this.u=T}get detail(){return this.y}set detail(T){T===null&&(T=void 0),this.y=T}get presentationOptions(){return this.w}set presentationOptions(T){T==null&&(T=Object.create(null)),this.z(),this.w=T}get runOptions(){return this.x}set runOptions(T){T==null&&(T=Object.create(null)),this.z(),this.x=T}};e.$UK=Le,e.$UK=Le=S=Ke([R],Le);var Ue;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Ue||(e.ProgressLocation=Ue={}));var Ge;(function(U){function T(ne){const Se=ne;return(0,E.$Af)(Se.value)?Se.tooltip&&!(0,E.$wf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=T})(Ge||(e.ViewBadge=Ge={}));let We=I=class{static isTreeItem(T,ne){const Se=T;if(Se.checkboxState!==void 0){const Je=(0,E.$Af)(Se.checkboxState)?Se.checkboxState:(0,E.$yf)(Se.checkboxState)&&(0,E.$Af)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Xe=!(0,E.$Af)(Se.checkboxState)&&(0,E.$yf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==pt.Checked&&Je!==pt.Unchecked||Xe!==void 0&&!(0,E.$wf)(Xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(T instanceof I)return!0;if(Se.label!==void 0&&!(0,E.$wf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,E.$wf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,E.$wf)(Se.iconPath)&&!g.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,E.$wf)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,E.$wf)(Je.light)&&!g.URI.isUri(Je.light)&&!(0,E.$wf)(Je.dark)&&!g.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,E.$wf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!g.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,E.$wf)(Se.tooltip)&&!(Se.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<et.None&&Se.collapsibleState>et.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,E.$wf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(T,ne=et.None){this.collapsibleState=ne,g.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$VK=We,e.$VK=We=I=Ke([R],We);var et;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(et||(e.TreeItemCollapsibleState=et={}));var pt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$WK=vt,e.$WK=vt=Ke([R],vt);class dt extends vt{}e.$XK=dt;class ft extends dt{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$YK=ft;class mt{constructor(T,ne,Se,Je){this.name=T,this.uri=ne,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$ZK=mt;let gi=class{#e=new Map;constructor(T){for(const[ne,Se]of T??[]){const Je=this.#e.get(this.#t(ne));Je?Je.push(Se):this.#e.set(this.#t(ne),[Se])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,ne){this.#e.set(this.#t(T),[ne])}forEach(T,ne){for(const[Se,Je]of this.#e)for(const Xe of Je)T.call(ne,Xe,Se,this)}*[Symbol.iterator](){for(const[T,ne]of this.#e)for(const Se of ne)yield[T,Se]}#t(T){return T.toLowerCase()}};e.$1K=gi,e.$1K=gi=Ke([R],gi);let Jt=class{constructor(T){this.insertText=T}};e.$2K=Jt,e.$2K=Jt=Ke([R],Jt);let Ei=class{constructor(T,ne){this.label=ne,this.insertText=T}};e.$3K=Ei,e.$3K=Ei=Ke([R],Ei);let Vt=class{constructor(T,ne){this.id=T,this.color=ne}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$4K=Vt,e.$4K=Vt=Ke([R],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let mi=class{constructor(T){this.id=T}};e.$5K=mi,e.$5K=mi=Ke([R],mi);var It;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let Di=class{get base(){return this.c}set base(T){this.c=T,this.e=g.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,ne){if(typeof T!="string"&&(!T||!g.URI.isUri(T)&&!g.URI.isUri(T.uri)))throw(0,M.$5)("base");if(typeof ne!="string")throw(0,M.$5)("pattern");typeof T=="string"?this.baseUri=g.URI.file(T):g.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$6K=Di,e.$6K=Di=Ke([R],Di);const Vi=new WeakMap;function kt(U,T){Vi.set(U,T)}e.$7K=kt;let ti=class{constructor(T,ne,Se,Je){this.enabled=typeof T=="boolean"?T:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$cg)()),this.c}};e.$8K=ti,e.$8K=ti=Ke([R],ti);let $i=class extends ti{constructor(T,ne,Se,Je,Xe){if(super(ne,Se,Je,Xe),T===null)throw(0,M.$5)("location");this.location=T}};e.$9K=$i,e.$9K=$i=Ke([R],$i);let si=class extends ti{constructor(T,ne,Se,Je,Xe){super(ne,Se,Je,Xe),this.functionName=T}};e.$0K=si,e.$0K=si=Ke([R],si);let ki=class extends ti{constructor(T,ne,Se,Je,Xe,ot,lt){if(super(Je,Xe,ot,lt),!ne)throw(0,M.$5)("dataId");this.label=T,this.dataId=ne,this.canPersist=Se}};e.$$K=ki,e.$$K=ki=Ke([R],ki);let Si=class{constructor(T,ne,Se){this.command=T,this.args=ne||[],this.options=Se}};e.$_K=Si,e.$_K=Si=Ke([R],Si);let Mt=class{constructor(T,ne){this.port=T,this.host=ne}};e.$aL=Mt,e.$aL=Mt=Ke([R],Mt);let pi=class{constructor(T){this.path=T}};e.$bL=pi,e.$bL=pi=Ke([R],pi);let Ii=class{constructor(T){this.implementation=T}};e.$cL=Ii,e.$cL=Ii=Ke([R],Ii);let oi=class{constructor(T,ne,Se){this.session=T,this.threadId=ne,this.frameId=Se}};e.$dL=oi,e.$dL=oi=Ke([R],oi);let ai=class{constructor(T,ne){this.session=T,this.threadId=ne}};e.$eL=ai,e.$eL=ai=Ke([R],ai);let ct=class{constructor(T,ne){this.range=T,this.expression=ne}};e.$fL=ct,e.$fL=ct=Ke([R],ct);var qi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Xt=class{constructor(T,ne){this.range=T,this.text=ne}};e.$gL=Xt,e.$gL=Xt=Ke([R],Xt);let ii=class{constructor(T,ne,Se=!0){this.range=T,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$hL=ii,e.$hL=ii=Ke([R],ii);let vi=class{constructor(T,ne){this.range=T,this.expression=ne}};e.$iL=vi,e.$iL=vi=Ke([R],vi);let Ci=class{constructor(T,ne){this.frameId=T,this.stoppedLocation=ne}};e.$jL=Ci,e.$jL=Ci=Ke([R],Ci);var Ki;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=u=class extends Error{static FileExists(T){return new u(T,a.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(T){return new u(T,a.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(T){return new u(T,a.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(T){return new u(T,a.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(T){return new u(T,a.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(T){return new u(T,a.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(T,ne=a.FileSystemProviderErrorCode.Unknown,Se){super(g.URI.isUri(T)?T.toString(!0):T),this.code=Se?.name??"Unknown",(0,a.$jk)(this,ne),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$kL=Pi,e.$kL=Pi=u=Ke([R],Pi);let bi=class{constructor(T,ne,Se){this.start=T,this.end=ne,this.kind=Se}};e.$lL=bi,e.$lL=bi=Ke([R],bi);var Ji;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Hi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Hi||(e.CommentState=Hi={}));var wi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(T,ne=[]){this.tokenTypes=T,this.tokenModifiers=ne}}e.$mL=Ri;function cn(U){return typeof U>"u"||(0,E.$xf)(U)}class Mi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let ne=0,Se=T.tokenTypes.length;ne<Se;ne++)this.j.set(T.tokenTypes[ne],ne);for(let ne=0,Se=T.tokenModifiers.length;ne<Se;ne++)this.k.set(T.tokenModifiers[ne],ne)}}push(T,ne,Se,Je,Xe){if(typeof T=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.n(T,ne,Se,Je,Xe);if(O.isRange(T)&&typeof ne=="string"&&cn(Se))return this.m(T,ne,Se);throw(0,M.$5)()}m(T,ne,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const Je=T.start.line,Xe=T.start.character,ot=T.end.character-T.start.character,lt=this.j.get(ne);let zt=0;if(Se)for(const Qt of Se){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Qt);zt|=1<<xt>>>0}this.n(Je,Xe,ot,lt,zt)}n(T,ne,Se,Je,Xe){if(this.f&&(T<this.c||T===this.c&&ne<this.e)){this.f=!1;const zt=this.g.length/5|0;let Qt=0,xt=0;for(let ei=0;ei<zt;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Qt,Bi+=xt):ri+=Qt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Qt=ri,xt=Bi}}let ot=T,lt=ne;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Xe,this.c=T,this.e=ne}static o(T){const ne=[],Se=T.length/5|0;for(let lt=0;lt<Se;lt++)ne[lt]=lt;ne.sort((lt,zt)=>{const Qt=T[5*lt],xt=T[5*zt];if(Qt===xt){const ei=T[5*lt+1],ri=T[5*zt+1];return ei-ri}return Qt-xt});const Je=new Uint32Array(T.length);let Xe=0,ot=0;for(let lt=0;lt<Se;lt++){const zt=5*ne[lt],Qt=T[zt+0],xt=T[zt+1],ei=T[zt+2],ri=T[zt+3],Bi=T[zt+4],wn=Qt-Xe,Mn=wn===0?xt-ot:xt,Wi=5*lt;Je[Wi+0]=wn,Je[Wi+1]=Mn,Je[Wi+2]=ei,Je[Wi+3]=ri,Je[Wi+4]=Bi,Xe=Qt,ot=xt}return Je}build(T){return this.f?new ni(new Uint32Array(this.g),T):new ni(Mi.o(this.g),T)}}e.$nL=Mi;class ni{constructor(T,ne){this.resultId=ne,this.data=T}}e.$oL=ni;class un{constructor(T,ne,Se){this.start=T,this.deleteCount=ne,this.data=Se}}e.$pL=un;class ln{constructor(T,ne){this.resultId=ne,this.edits=T}}e.$qL=ln;var Gi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Vt("arrow-left")}}constructor(){}};e.$rL=fi,e.$rL=fi=Ke([R],fi);var Qi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var ui;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Xi{static validate(T){if(typeof T.badge=="string"){let ne=(0,h.$0e)(T.badge,0);if(ne<T.badge.length&&(ne+=(0,h.$0e)(T.badge,ne)),T.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Vt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,ne,Se){this.badge=T,this.tooltip=ne,this.color=Se}}e.$sL=Xi;let Li=class{constructor(T){this.kind=T}};e.$tL=Li,e.$tL=Li=Ke([R],Li);var Yi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class Yt{static isNotebookRange(T){return T instanceof Yt?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,ne){if(T<0)throw(0,M.$5)("start must be positive");if(ne<0)throw(0,M.$5)("end must be positive");T<=ne?(this.c=T,this.e=ne):(this.c=ne,this.e=T)}with(T){let ne=this.c,Se=this.e;return T.start!==void 0&&(ne=T.start),T.end!==void 0&&(Se=T.end),ne===this.c&&Se===this.e?this:new Yt(ne,Se)}}e.$uL=Yt;class yi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(ne=>yi.isNotebookCellData(ne))}static isNotebookCellData(T){return!0}constructor(T,ne,Se,Je,Xe,ot,lt){this.kind=T,this.value=ne,this.languageId=Se,this.mime=Je,this.outputs=Xe??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$vL=yi;class hn{constructor(T){this.cells=T}}e.$wL=hn;class Gt{static isNotebookCellOutputItem(T){return T instanceof Gt?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const ne={name:T.name,message:T.message,stack:T.stack};return Gt.json(ne,"application/vnd.code.notebook.error")}static stdout(T){return Gt.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return Gt.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,ne="application/octet-stream"){return new Gt(T,ne)}static#e=new TextEncoder;static text(T,ne=A.$Jr.text){const Se=Gt.#e.encode(String(T));return new Gt(Se,ne)}static json(T,ne="text/x-json"){const Se=JSON.stringify(T,void 0,"	");return Gt.text(Se,ne)}constructor(T,ne){this.data=T,this.mime=ne;const Se=(0,A.$Nr)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$xL=Gt;class li{static isNotebookCellOutput(T){return T instanceof li?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,ne=!1){const Se=new Set,Je=new Set;for(let Xe=0;Xe<T.length;Xe++){const ot=T[Xe],lt=(0,A.$Nr)(ot.mime);if(!Se.has(lt)||(0,m.$hI)(lt)){Se.add(lt);continue}Je.add(Xe),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?T:T.filter((Xe,ot)=>!Je.has(ot))}constructor(T,ne,Se){this.items=li.ensureUniqueMimeTypes(T,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,P.$cg)(),this.metadata=ne??Se)}}e.$yL=li;var Ti;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Oe;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Oe||(e.NotebookCellExecutionState=Oe={}));var _t;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Fi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Fi||(e.NotebookEditorRevealType=Fi={}));class $t{constructor(T,ne){this.text=T,this.alignment=ne}}e.$zL=$t;var _i;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(_i||(e.NotebookControllerAffinity=_i={}));var xi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class en{constructor(T,ne=[]){this.uri=T,this.provides=(0,w.$1b)(ne)}}e.$AL=en;class dn{constructor(T){this.label=T}}e.$BL=dn;let hi=class{constructor(T,ne){this.label=T,this.timestamp=ne}};e.$CL=hi,e.$CL=hi=Ke([R],hi);var tn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(T,ne){this.ranges=T,this.wordPattern=ne}}e.$DL=sn;class fn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$EL=fn;var on;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(T=void 0,ne=void 0,Se=void 0,Je=!1){this.include=T,this.exclude=ne,this.profile=Se,this.continuous=Je}};e.$FL=Oi,e.$FL=Oi=Ke([R],Oi);let Ni=d=class{static diff(T,ne,Se){const Je=new d(T);return Je.expectedOutput=ne,Je.actualOutput=Se,Je}constructor(T){this.message=T}};e.$GL=Ni,e.$GL=Ni=d=Ke([R],Ni);let zi=class{constructor(T){this.id=T}};e.$HL=zi,e.$HL=zi=Ke([R],zi);let di=class{constructor(T,ne){this.covered=T,this.total=ne}};e.$IL=di,e.$IL=di=Ke([R],di);let ji=l=class{static fromDetails(T,ne){const Se=new di(0,0),Je=new di(0,0),Xe=new di(0,0);for(const lt of ne)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const zt of lt.branches)Je.total+=1,Je.covered+=zt.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=lt.executionCount>0?1:0;const ot=new l(T,Se,Je.total>0?Je:void 0,Xe.total>0?Xe:void 0);return ot.detailedCoverage=ne,ot}constructor(T,ne,Se,Je){this.uri=T,this.statementCoverage=ne,this.branchCoverage=Se,this.functionCoverage=Je}};e.$JL=ji,e.$JL=ji=l=Ke([R],ji);let Ui=class{constructor(T,ne,Se=[]){this.executionCount=T,this.location=ne,this.branches=Se}};e.$KL=Ui,e.$KL=Ui=Ke([R],Ui);let te=class{constructor(T,ne){this.executionCount=T,this.location=ne}};e.$LL=te,e.$LL=te=Ke([R],te);let fe=class{constructor(T,ne){this.executionCount=T,this.location=ne}};e.$ML=fe,e.$ML=fe=Ke([R],fe);var Te;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Te||(e.ExternalUriOpenerPriority=Te={}));var nt;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(nt||(e.WorkspaceTrustState=nt={}));var wt;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Lt{constructor(T,ne,Se,Je,Xe,ot){this.kind=T,this.name=ne,this.detail=Se,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$NL=Lt;class yn{constructor(T){this.uri=T}}e.$OL=yn;class En{constructor(T,ne){this.original=T,this.modified=ne}}e.$PL=En;class Dn{constructor(T,ne,Se,Je){this.base=T,this.input1=ne,this.input2=Se,this.result=Je}}e.$QL=Dn;class kn{constructor(T,ne){this.uri=T,this.viewType=ne}}e.$RL=kn;class Sn{constructor(T){this.viewType=T}}e.$SL=Sn;class In{constructor(T,ne){this.uri=T,this.notebookType=ne}}e.$TL=In;class Cn{constructor(T,ne,Se){this.original=T,this.modified=ne,this.notebookType=Se}}e.$UL=Cn;class Pn{constructor(){}}e.$VL=Pn;class An{constructor(T,ne){this.uri=T,this.inputBoxUri=ne}}e.$WL=An;var gn;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var vn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Rn{constructor(T,ne){this.role=T,this.content=ne}}e.$XL=Rn;var bn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(Ae[100],Re([1,0,51,12,15,277,136,7,18]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=e.$$L=void 0;const g=new Map;function P(m,f){f?g.set(m,f):g.delete(m)}e.$$L=P;function k(m){return g.get(m)}class a extends F.$Ou{constructor(f,t,n,c,v,D,p,r){super(t,n,c,v),this.c=f,this.m=D,this.q=p,this.notebook=r,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,E.$sb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===M.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?h.EndOfLine.LF:h.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,n){return f.y(t,n)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,w.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,w.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const n=this.g,c=t.start.line,v=t.end.line,D=[];D.push(this.f[c].substring(t.start.character));for(let p=c+1;p<v;p++)D.push(this.f[p]);return D.push(this.f[v].substring(0,t.end.character)),D.join(n)}t(f){let t;if(f instanceof h.$$J?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),n=this.f[t.index].length;return new h.$$J(t.index,Math.min(t.remainder,n))}w(f){if(!(f instanceof h.$_J))throw new Error("Invalid argument");const t=this.x(f.start),n=this.x(f.end);return t===f.start&&n===f.end?f:new h.$_J(t.line,t.character,n.line,n.character)}x(f){if(!(f instanceof h.$$J))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:n}=f,c=!1;if(t<0)t=0,n=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,n=this.f[t].length,c=!0;else{const v=this.f[t].length;n<0?(n=0,c=!0):n>v&&(n=v,c=!0)}return c?new h.$$J(t,n):f}y(f,t){const n=this.x(f);if(!t)t=k(this.m);else if((0,C.$Me)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$2r)(n.character+1,(0,A.$Zr)(t),this.f[n.line],0);if(c)return new h.$_J(n.line,c.startColumn-1,n.line,c.endColumn-1)}}e.$_L=a;class b{constructor(f,t,n){this.a=f,this.b=t,this.c=n}get lineNumber(){return this.a}get text(){return this.b}get range(){return new h.$_J(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new h.$_J(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$aM=b}),define(Ae[196],Re([1,0,7,17,5]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;let F=class{constructor(h){this.a=new w.$tL(w.ColorThemeKind.Dark),this.b=new C.$Ld}get activeColorTheme(){return this.a}$onColorThemeChange(h){let E;switch(h){case"light":E=w.ColorThemeKind.Light;break;case"hcDark":E=w.ColorThemeKind.HighContrast;break;case"hcLight":E=w.ColorThemeKind.HighContrastLight;break;default:E=w.ColorThemeKind.Dark}this.a=new w.$tL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$$cc=F,e.$$cc=F=Ke([Ve(0,M.$9L)],F)}),define(Ae[197],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$lI=(0,w.$Mh)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1I=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(F){F.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var M;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,h,E=A.parent){if(A._isRoot)return new C([h]);const g=[A.id];for(let P=E;P&&P.id!==h;P=P.parent)g.push(P.id);return g.push(h),new C(g.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const h=A.indexOf("\0");return h===-1?A:A.slice(0,h)}static fromString(A){return new C(A.split("\0"))}static join(A,h){return new C([...A.path,h])}static joinToString(A,h){return A.toString()+"\0"+h}static parentId(A){const h=A.lastIndexOf("\0");return h===-1?void 0:A.slice(0,h)}static localId(A){const h=A.lastIndexOf("\0");return h===-1?A:A.slice(h+1)}static isChild(A,h){return h.startsWith(A)&&h[A.length]==="\0"}static compare(A,h){return A===h?0:C.isChild(A,h)?2:C.isChild(h,A)?3:1}constructor(A,h=A.length){if(this.path=A,this.d=h,A.length===0||h<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let h=0;h<A.d&&h<this.d;h++)if(A.path[h]!==this.path[h])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$1I=C}),define(Ae[57],Re([1,0,2,44,45]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$7I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$6I=e.$5I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$4I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$3I=e.$2I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var A;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var h;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.$2I=[2,4,8,16,32,64];const E=I=>"runId"in I;e.$3I=E;var g;(function(I){I.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),I.deserialize=u=>({range:M.$ms.lift(u.range),uri:w.URI.revive(u.uri)})})(g||(e.IRichLocation=g={}));var P;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(P||(e.TestMessageType=P={}));var k;(function(I){I.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.serialize(u.location)}),I.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.deserialize(u.location)})})(k||(e.ITestErrorMessage=k={}));const a=(I,u)=>`${u?"s":"e"}${I}`;e.$4I=a;var b;(function(I){I.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.serialize(u.location)}),I.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.deserialize(u.location)})})(b||(e.ITestOutputMessage=b={}));var m;(function(I){I.serialize=u=>u.type===0?k.serialize(u):b.serialize(u),I.deserialize=u=>u.type===0?k.deserialize(u):b.deserialize(u)})(m||(e.ITestMessage=m={}));var f;(function(I){I.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),I.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(m.serialize)}),I.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(m.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",n=(I,u)=>I+t+u;e.$5I=n;const c=I=>{const u=I.indexOf(t);return{ctrlId:I.slice(0,u),tagId:I.slice(u+1)}};e.$6I=c;var v;(function(I){I.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),I.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?w.URI.revive(u.uri):void 0,range:u.range?M.$ms.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(v||(e.ITestItem=v={}));var D;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(D||(e.TestItemExpandState=D={}));var p;(function(I){I.serialize=u=>({expand:u.expand,item:v.serialize(u.item)}),I.deserialize=u=>({controllerId:C.$1I.root(u.item.extId),expand:u.expand,item:v.deserialize(u.item)})})(p||(e.InternalTestItem=p={}));var r;(function(I){I.serialize=u=>{let d;return u.item&&(d={},u.item.label!==void 0&&(d.label=u.item.label),u.item.tags!==void 0&&(d.tags=u.item.tags),u.item.busy!==void 0&&(d.busy=u.item.busy),u.item.uri!==void 0&&(d.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(d.range=u.item.range?.toJSON()),u.item.description!==void 0&&(d.description=u.item.description),u.item.error!==void 0&&(d.error=u.item.error),u.item.sortText!==void 0&&(d.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:d}},I.deserialize=u=>{let d;return u.item&&(d={},u.item.label!==void 0&&(d.label=u.item.label),u.item.tags!==void 0&&(d.tags=u.item.tags),u.item.busy!==void 0&&(d.busy=u.item.busy),u.item.range!==void 0&&(d.range=u.item.range?M.$ms.lift(u.item.range):null),u.item.description!==void 0&&(d.description=u.item.description),u.item.error!==void 0&&(d.error=u.item.error),u.item.sortText!==void 0&&(d.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:d}}})(r||(e.ITestItemUpdate=r={}));const s=(I,u)=>{u.expand!==void 0&&(I.expand=u.expand),u.item!==void 0&&(I.item=I.item?Object.assign(I.item,u.item):u.item)};e.$7I=s;var i;(function(I){I.serializeWithoutMessages=u=>({...p.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serializeWithoutMessages)}),I.serialize=u=>({...p.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serialize)}),I.deserialize=u=>({...p.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.deserialize),retired:!0})})(i||(e.TestResultItem=i={}));var o;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var $;(function(I){I.deserialize=u=>u.op===0?{op:u.op,item:p.deserialize(u.item)}:u.op===1?{op:u.op,item:r.deserialize(u.item)}:u.op===2?{op:u.op,uri:w.URI.revive(u.uri),docv:u.docv}:u,I.serialize=u=>u.op===0?{op:u.op,item:p.serialize(u.item)}:u.op===1?{op:u.op,item:r.serialize(u.item)}:u})($||(e.TestsDiffOp=$={}));class S{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const d=this.p();for(const l of u)switch(l.op){case 0:this.k(p.deserialize(l.item),d);break;case 1:this.l(r.deserialize(l.item),d);break;case 3:this.m(l.itemId,d);break;case 5:this.o(l.itemId);break;case 4:this.updatePendingRoots(l.amount);break;case 6:this.d.set(l.tag.id,l.tag);break;case 7:this.d.delete(l.id);break}d.complete?.()}k(u,d){const l=C.$1I.parentId(u.item.extId)?.toString();let R;if(!l)R=this.q(u),this.g.add(R),this.f.set(u.item.extId,R);else if(this.f.has(l)){const B=this.f.get(l);B.children.add(u.item.extId),R=this.q(u,B),this.f.set(u.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return d.add?.(R),u.expand===2&&this.h++,R}l(u,d){const l=this.f.get(u.extId);if(l)return u.expand!==void 0&&(l.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$7I)(l,u),d.update?.(l),l}m(u,d){const l=this.f.get(u);if(!l)return;const R=C.$1I.parentId(l.item.extId)?.toString();R?this.f.get(R).children.delete(l.item.extId):this.g.delete(l);const B=[[u]];for(;B.length;)for(const V of B.pop()){const j=this.f.get(V);j&&(B.push(j.children),this.f.delete(V),d.remove?.(j,j!==l),j.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$8I=S}),define(Ae[76],Re([1,0,13,5,6,51,57,45]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.TestItemEventOp=void 0;var E;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const g=(c,v)=>c===v,k=Object.entries({range:(c,v)=>c===v?!0:!c||!v?!1:c.equalsRange(v),busy:g,label:g,description:g,error:g,sortText:g,tags:(c,v)=>!(c.length!==v.length||c.some(D=>!v.includes(D)))}),a=(c,v)=>{let D;for(const[p,r]of k)r(c[p],v[p])||(D?D[p]=v[p]:D={[p]:v[p]});return D};class b extends C.$Qc{get root(){return this.s.root}constructor(v){super(),this.s=v,this.f=this.B(new w.$4g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Ld),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(v){this.h=v;for(const D of this.tree.values())this.I(D)}get resolveHandler(){return this.h}collectDiff(){const v=this.m;return this.m=[],v}pushDiff(v){switch(v.op){case 2:{for(const D of this.m)if(D.op===2&&D.uri===v.uri){D.docv=v.docv;return}break}case 1:{const D=this.m[this.m.length-1];if(D){if(D.op===1&&D.item.extId===v.item.extId){(0,A.$7I)(D.item,v.item);return}if(D.op===0&&D.item.item.extId===v.item.extId){(0,A.$7I)(D.item,v.item);return}}break}}this.m.push(v),this.f.isScheduled()||this.f.schedule()}expand(v,D){const p=this.tree.get(v);if(p){if((p.expandLevels===void 0||D>p.expandLevels)&&(p.expandLevels=D),p.expand===1){const r=this.L(p);return r.isOpen()?this.J(p,D-1):r.wait().then(()=>this.J(p,D-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.J(p,D-1)):this.J(p,D-1)}}dispose(){for(const v of this.tree.values())this.s.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(v,D){switch(D.op){case 3:this.N(h.$1I.joinToString(v.fullId,D.id));break;case 0:this.y(D.item,v);break;case 5:for(const p of D.ops)this.u(v,p);break;case 1:this.z(D.new,D.old,v.fullId.toString());break;case 2:this.I(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:D.update}});break;case 6:this.w(v.actual.uri);break;default:(0,F.$2c)(D)}}w(v){v&&this.pushDiff({op:2,uri:v,docv:this.s.getDocumentVersion(v)})}y(v,D){const p=h.$1I.fromExtHostTestItem(v,this.root.id,D?.actual),r=this.s.getApiFor(v);r.parent&&r.parent!==D?.actual&&this.s.getChildren(r.parent).delete(v.id);let s=this.tree.get(p.toString());if(!s){s={fullId:p,actual:v,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},v.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(v,D),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(v)}}),this.H(v,s,D);return}if(s.actual===v){this.G(v,s,D);return}if(s.actual.uri?.toString()!==v.uri?.toString())return this.N(p.toString()),this.y(v,D);const i=this.s.getChildren(s.actual),o=s.actual,y=a(this.s.toITestItem(o),this.s.toITestItem(v));this.s.getApiFor(o).listener=void 0,s.actual=v,s.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(v.tags,o.tags,p.toString()),delete y.tags),this.u(s,{op:4,update:y})),this.H(v,s,D);for(const[$,S]of i)this.s.getChildren(v).get(S.id)||this.N(h.$1I.joinToString(p,S.id));this.w(s.actual.uri)}z(v,D,p){const r=new Set(D.map(s=>s.id));for(const s of v)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:p,item:{tags:v.map(s=>(0,A.$5I)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(v){const D=this.j.get(v.id);D?D.refCount++:(this.j.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$5I)(this.s.controllerId,v.id)}}))}D(v){const D=this.j.get(v);D&&!--D.refCount&&(this.j.delete(v),this.pushDiff({op:7,id:(0,A.$5I)(this.s.controllerId,v)}))}F(v,D){this.s.getApiFor(v).parent=D&&D.actual!==this.root?D.actual:void 0}G(v,D,p){this.F(v,p);const r=this.s.getApiFor(v);r.parent=p?.actual,r.listener=s=>this.u(D,s),this.I(D)}H(v,D,p){this.G(v,D,p);for(const[r,s]of this.s.getChildren(v))this.y(s,D)}I(v){let D;this.h?v.resolveBarrier?D=v.resolveBarrier.isOpen()?3:2:D=v.actual.canResolveChildren?1:0:D=0,D!==v.expand&&(v.expand=D,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:D}}),D===1&&v.expandLevels!==void 0&&this.L(v))}J(v,D){if(D<0)return;const p=[];for(const[r,s]of this.s.getChildren(v.actual)){const i=this.expand(h.$1I.joinToString(v.fullId,s.id),D);(0,w.$Eg)(i)&&p.push(i)}if(p.length)return Promise.all(p).then(()=>{})}L(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this.h){const s=new w.$Qg;return s.open(),s}v.expand=2,this.M(v);const D=v.resolveBarrier=new w.$Qg,p=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(v.actual===this.root?void 0:v.actual)}catch(s){p(s)}return(0,w.$Eg)(r)?r.catch(p).then(()=>{D.open(),this.I(v)}):(D.open(),this.I(v)),v.resolveBarrier}M(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}N(v){const D=this.tree.get(v);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const p=[D];for(;p.length;){const r=p.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,i]of this.s.getChildren(r.actual))p.push(this.tree.get(h.$1I.joinToString(r.fullId,i.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.g.fire(v)}}e.$YL=b;class m extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.$ZL=m;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$1L=f;class t extends Error{constructor(v,D,p){super(`TestItem with ID "${v}" is from controller "${D}" and cannot be added as a child of an item from controller "${p}".`)}}e.$2L=t;const n=(c,v,D)=>{let p=new Map;return{get size(){return p.size},forEach(r,s){for(const i of p.values())r.call(s,i,this)},[Symbol.iterator](){return p.entries()},replace(r){const s=new Map,i=new Set(p.keys()),o={op:5,ops:[]};for(const y of r){if(!(y instanceof D))throw new f(y.id);const $=v(y).controllerId;if($!==c.controllerId)throw new t(y.id,$,c.controllerId);if(s.has(y.id))throw new m(y.id);s.set(y.id,y),i.delete(y.id),o.ops.push({op:0,item:y})}for(const y of i.keys())o.ops.push({op:3,id:y});c.listener?.(o),p=s},add(r){if(!(r instanceof D))throw new f(r.id);p.set(r.id,r),c.listener?.({op:0,item:r})},delete(r){p.delete(r)&&c.listener?.({op:3,id:r})},get(r){return p.get(r)},toJSON(){return Array.from(p.values())}}};e.$3L=n}),define(Ae[101],Re([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=void 0;const M=new WeakMap,C=(A,h)=>{const E={controllerId:h};return M.set(A,E),E};e.$4L=C;const F=A=>{const h=M.get(A);if(!h)throw new w.$1L(A?.id||"<unknown>");return h};e.$5L=F}),define(Ae[77],Re([1,0,12,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tob=e.$Sob=e.$Rob=e.$Qob=e.$Pob=void 0,e.$Pob="vscode-cdn.net",e.$Qob=`vscode-resource.${e.$Pob}`,e.$Rob=`'self' https://*.${e.$Pob}`;function C(h,E){return h.scheme===w.Schemas.http||h.scheme===w.Schemas.https?h:(E&&E.authority&&E.isRemote&&h.scheme===w.Schemas.file&&(h=M.URI.from({scheme:w.Schemas.vscodeRemote,authority:E.authority,path:h.path})),M.URI.from({scheme:w.Schemas.https,authority:`${h.scheme}+${F(h.authority)}.${e.$Qob}`,path:h.path,fragment:h.fragment,query:h.query}))}e.$Sob=C;function F(h){return h.replace(/./g,E=>{const g=E.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?E:"-"+g.toString(16).padStart(4,"0")})}function A(h){return h.replace(/-([0-9a-f]{4})/g,(E,g)=>String.fromCharCode(parseInt(g,16)))}e.$Tob=A}),define(Ae[198],Re([1,0,5,6,77]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class F{constructor(h,E,g){this.d=h,this.e=E,this.f=g,this.a=0,this.b=new M.$Pc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const P=E.getVisibleTextEditors();for(const k of this.c.values())P.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(h=>h.inset.dispose()),this.b.dispose()}createWebviewEditorInset(h,E,g,P,k){let a;for(const v of this.e.getVisibleTextEditors(!0))if(v.value===h){a=v;break}if(!a)throw new Error("not a visible editor");const b=this,m=this.a++,f=new w.$Ld,t=new w.$Ld,n=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(v){return(0,C.$Sob)(v,b.f)}get cspSource(){return C.$Rob}set options(v){this.b=v,b.d.$setOptions(m,v)}get options(){return this.b}set html(v){this.a=v,b.d.$setHtml(m,v)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(v){return b.d.$postMessage(m,v)}},c=new class{constructor(){this.editor=h,this.line=E,this.height=g,this.webview=n,this.onDidDispose=t.event}dispose(){b.c.has(m)&&(b.c.delete(m),b.d.$disposeEditorInset(m),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(m,a.id,a.value.document.uri,E+1,g,P||{},k.identifier,k.extensionLocation),this.c.set(m,{editor:h,inset:c,onDidReceiveMessage:f}),c}$onDidDispose(h){const E=this.c.get(h);E&&E.inset.dispose()}$onDidReceiveMessage(h,E){this.c.get(h)?.onDidReceiveMessage.fire(E)}}e.$Icc=F}),define(Ae[199],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.VariableKind=e.$UM=void 0,e.$UM=(0,w.$Mh)("configurationResolverService");var M;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,h){super(h),this.variable=A}}e.$VM=C}),define(Ae[200],Re([1,0,19,74,16,24,22,90,165,199,15]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,m,f,t){this.h=new Map,this.a=b,this.b=m,this.g=f,t&&(this.c=t.then(n=>this.i(n)))}i(b){if(A.$i){const m=Object.create(null);return Object.keys(b).forEach(f=>{m[f.toLowerCase()]=b[f]}),m}return b}resolveWithEnvironment(b,m,f){return this.l({env:this.i(b),userHome:void 0},m?m.uri:void 0,f)}async resolveAsync(b,m){const f={env:await this.c,userHome:await this.g};return this.l(f,b?b.uri:void 0,m)}async j(b,m,f,t){const n=F.$Xm(m);A.$i&&n.windows?Object.keys(n.windows).forEach(v=>n[v]=n.windows[v]):A.$j&&n.osx?Object.keys(n.osx).forEach(v=>n[v]=n.osx[v]):A.$k&&n.linux&&Object.keys(n.linux).forEach(v=>n[v]=n.linux[v]),delete n.windows,delete n.osx,delete n.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,b?b.uri:void 0,n,f,t)}async resolveAnyAsync(b,m,f){return this.j(b,m,f)}async resolveAnyMap(b,m,f){const t=new Map;return{newConfig:await this.j(b,m,f,t),resolvedVariables:t}}resolveWithInteractionReplace(b,m,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,m)}async l(b,m,f,t,n){if(C.$wf(f))return this.m(b,m,f,t,n);if(Array.isArray(f))return Promise.all(f.map(c=>this.l(b,m,c,t,n)));if(C.$yf(f)){const c=Object.create(null),v=await Promise.all(Object.keys(f).map(async D=>[await this.m(b,m,D,t,n),await this.l(b,m,f[D],t,n)]));for(const[D,p]of v)c[D]=p;return c}return f}m(b,m,f,t,n){return(0,P.$Re)(f,k.VARIABLE_REGEXP,async(c,v)=>{if(v.includes(k.VARIABLE_LHS))return c;let D=await this.o(b,c,v,m,t);return n?.set(v,D),D!==c&&C.$wf(D)&&D.match(k.VARIABLE_REGEXP)&&(D=await this.m(b,m,D,t,n)),D})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,m,f,t,n){let c;const v=f.split(":");v.length>1&&(f=v[0],c=v[1]);const D=s=>{const i=this.a.getFilePath();if(i)return(0,h.$kv)(i);throw new g.$VM(s,(0,E.localize)(0,null,m))},p=s=>{const i=D(s);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,h.$kv)(o)}throw new g.$VM(s,(0,E.localize)(1,null,m,w.$lc(i)))},r=s=>{if(c){const i=this.a.getFolderUri(c);if(i)return i;throw new g.$VM(s,(0,E.localize)(2,null,m,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$VM(s,(0,E.localize)(3,null,m)):new g.$VM(s,(0,E.localize)(4,null,m))};switch(f){case"env":if(c){if(b.env){const s=b.env[A.$i?c.toLowerCase():c];if(C.$wf(s))return s}return""}throw new g.$VM(g.VariableKind.Env,(0,E.localize)(5,null,m));case"config":if(c){const s=this.a.getConfigurationValue(t,c);if(C.$Ff(s))throw new g.$VM(g.VariableKind.Config,(0,E.localize)(6,null,m,c));if(C.$yf(s))throw new g.$VM(g.VariableKind.Config,(0,E.localize)(7,null,m,c));return s}throw new g.$VM(g.VariableKind.Config,(0,E.localize)(8,null,m));case"command":return this.p(g.VariableKind.Command,m,c,n,"command");case"input":return this.p(g.VariableKind.Input,m,c,n,"input");case"extensionInstallFolder":if(c){const s=await this.a.getExtension(c);if(!s)throw new g.$VM(g.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,m,c));return this.n(s.extensionLocation)}throw new g.$VM(g.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,m));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,h.$kv)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,h.$kv)(this.n(r(g.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,h.$kv)(w.$lc(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new g.$VM(g.VariableKind.UserHome,(0,E.localize)(11,null,m))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$VM(g.VariableKind.LineNumber,(0,E.localize)(12,null,m))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$VM(g.VariableKind.SelectedText,(0,E.localize)(13,null,m))}case"file":return D(g.VariableKind.File);case"fileWorkspaceFolder":return p(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?w.$jc(this.n(r(g.VariableKind.RelativeFile)),D(g.VariableKind.RelativeFile)):D(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=w.$kc(D(g.VariableKind.RelativeFileDirname));if(t||c){const i=w.$jc(this.n(r(g.VariableKind.RelativeFileDirname)),s);return i.length===0?".":i}return s}case"fileDirname":return w.$kc(D(g.VariableKind.FileDirname));case"fileExtname":return w.$mc(D(g.VariableKind.FileExtname));case"fileBasename":return w.$lc(D(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=w.$lc(D(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-w.$mc(s).length)}case"fileDirnameBasename":return w.$lc(w.$kc(D(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||m}case"execInstallFolder":{const s=this.a.getAppRoot();return s||m}case"pathSeparator":return w.sep;default:try{const s=c?`${f}:${c}`:f;return this.p(g.VariableKind.Unknown,m,s,n,void 0)}catch{return m}}}}p(b,m,f,t,n){if(f&&t){const c=n===void 0?t[f]:t[n+":"+f];if(typeof c=="string")return c;throw new g.$VM(b,(0,E.localize)(14,null,m))}return m}}e.$0M=k}),define(Ae[102],Re([1,0,4,99]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_B=e.$$B=e.OpenEditorContext=e.GroupsOrder=e.$0B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9B=void 0,e.$9B=(0,w.$Mh)("editorGroupsService");var C;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var F;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var A;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var h;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(h||(e.GroupsArrangement=h={}));var E;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function g(m){const f=m;return(0,M.$YD)(f?.editor)&&(0,M.$YD)(f?.replacement)}e.$0B=g;var P;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var k;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function a(m){const f=m;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$$B=a;function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_B=b}),define(Ae[201],Re([1,0,4,102]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.$cC=e.$bC=e.$aC=void 0,e.$aC=(0,w.$Mh)("editorService"),e.$bC=-1,e.$cC=-2;function C(F){const A=F;return typeof F=="number"||(0,M.$$B)(A)}e.$dC=C}),define(Ae[8],Re([1,0,18,25,122,202,50,28,116,68,67,24,16,2,44,78,94,101,99,75,45,57,201,7]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$8L=e.$7L=e.MarkdownString=e.$6L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Ce){function Me(H){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:Ge,positionColumn:We}=H,et=new s.$$J(Le-1,Ue-1),pt=new s.$$J(Ge-1,We-1);return new s.$aK(et,pt)}Ce.to=Me;function ge(H){const{anchor:Le,active:Ue}=H;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ce.from=ge})(i||(e.Selection=i={}));var o;(function(Ce){function Me(H){if(!H)return;const{start:Le,end:Ue}=H;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ce.from=Me;function ge(H){if(!H)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:Ge,endColumn:We}=H;return new s.$_J(Le-1,Ue-1,Ge-1,We-1)}Ce.to=ge})(o||(e.Range=o={}));var y;(function(Ce){function Me(ge){switch(ge){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Me})(y||(e.TokenType=y={}));var $;(function(Ce){function Me(H){return new s.$$J(H.lineNumber-1,H.column-1)}Ce.to=Me;function ge(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=ge})($||(e.Position=$={}));var S;(function(Ce){function Me(Le,Ue,Ge){return(0,w.$Fb)((0,w.$1b)(Le).map(We=>ge(We,Ue,Ge)))}Ce.from=Me;function ge(Le,Ue,Ge){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ge?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:H(Le.scheme,Ue),pattern:st.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ge?.isBuiltin}}function H(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(S||(e.DocumentSelector=S={}));var I;(function(Ce){function Me(H){switch(H){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function ge(H){switch(H){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(I||(e.DiagnosticTag=I={}));var u;(function(Ce){function Me(H){let Le;return H.code&&((0,a.$wf)(H.code)||(0,a.$Af)(H.code)?Le=String(H.code):Le={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Le,severity:l.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(d.from),tags:Array.isArray(H.tags)?(0,w.$Fb)(H.tags.map(I.from)):void 0}}Ce.from=Me;function ge(H){const Le=new s.$lK(o.to(H),H.message,l.to(H.severity));return Le.source=H.source,Le.code=(0,a.$wf)(H.code)?H.code:H.code?.value,Le.relatedInformation=H.relatedInformation&&H.relatedInformation.map(d.to),Le.tags=H.tags&&(0,w.$Fb)(H.tags.map(I.to)),Le}Ce.to=ge})(u||(e.Diagnostic=u={}));var d;(function(Ce){function Me(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Me;function ge(H){return new s.$kK(new s.$jK(H.resource,o.to(H)),H.message)}Ce.to=ge})(d||(e.DiagnosticRelatedInformation=d={}));var l;(function(Ce){function Me(H){switch(H){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Me;function ge(H){switch(H){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=ge})(l||(e.DiagnosticSeverity=l={}));var R;(function(Ce){function Me(H){return typeof H=="number"&&H>=s.ViewColumn.One?H-1:H===s.ViewColumn.Beside?r.$cC:r.$bC}Ce.from=Me;function ge(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(R||(e.ViewColumn=R={}));function B(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!B(Ce[0])}e.$6L=V;var j;(function(Ce){function Me(We){return We.map(Ce.from)}Ce.fromMany=Me;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let et;if(ge(We)){const{language:ft,value:mt}=We;et={value:"```"+ft+`
`+mt+"\n```\n"}}else s.$xK.isMarkdownString(We)?et={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?et={value:We}:et={value:""};const pt=Object.create(null);et.uris=pt;const vt=ft=>{try{let mt=b.URI.parse(ft,!0);mt=mt.with({query:Le(mt.query,pt)}),pt[ft]=mt}catch{}return""},dt=new E.marked.Renderer;return dt.link=vt,dt.image=ft=>typeof ft=="string"?vt(A.$7j(ft).href):"",(0,E.marked)(et.value,{renderer:dt}),et}Ce.from=H;function Le(We,et){if(!We)return We;let pt;try{pt=(0,g.$ih)(We)}catch{}if(!pt)return We;let vt=!1;return pt=(0,k.$Zm)(pt,dt=>{if(b.URI.isUri(dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ft]=dt,vt=!0,ft}else return}),vt?JSON.stringify(pt):We}function Ue(We){const et=new s.$xK(We.value,We.supportThemeIcons);return et.isTrusted=We.isTrusted,et.supportHtml=We.supportHtml,et.baseUri=We.baseUri?b.URI.from(We.baseUri):void 0,et}Ce.to=Ue;function Ge(We){if(We)return typeof We=="string"?We:Ce.from(We)}Ce.fromStrict=Ge})(j||(e.MarkdownString=j={}));function W(Ce){return V(Ce)?Ce.map(Me=>({range:o.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?j.fromMany(Me.hoverMessage):Me.hoverMessage?j.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:o.from(Me)}))}e.$7L=W;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$8L=O;var N;(function(Ce){function Me(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?O(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Me})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ee;(function(Ce){function Me(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}Ce.from=Me})(ee||(e.ThemableDecorationRenderOptions=ee={}));var X;(function(Ce){function Me(ge){if(typeof ge>"u")return ge;switch(ge){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})(X||(e.DecorationRangeBehavior=X={}));var ye;(function(Ce){function Me(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?X.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ee.from(ge.light):void 0,dark:ge.dark?ee.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}Ce.from=Me})(ye||(e.DecorationRenderOptions=ye={}));var De;(function(Ce){function Me(H){return{text:H.newText,eol:H.newEol&&Ye.from(H.newEol),range:o.from(H.range)}}Ce.from=Me;function ge(H){const Le=new s.$eK(o.to(H.range),H.text);return Le.newEol=typeof H.eol>"u"?void 0:Ye.to(H.eol),Le}Ce.to=ge})(De||(e.TextEdit=De={}));var Pe;(function(Ce){function Me(H,Le){const Ue={edits:[]};if(H instanceof s.$hK){const Ge=new h.$zc;for(const We of H._allEntries())We._type===1&&b.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of H._allEntries())if(We._type===1){let et;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?et={type:"base64",value:(0,M.$te)(M.$_d.wrap(We.options.contents))}:et={type:"dataTransferItem",id:We.options.contents._itemId}),Ue.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:et},metadata:We.metadata})}else We._type===2?Ue.edits.push({resource:We.uri,textEdit:De.from(We.edit),versionId:Ge.has(We.uri)?void 0:Le?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Ue.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Le?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ue.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ue.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Le?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(gt.from)}})}return Ue}Ce.from=Me;function ge(H){const Le=new s.$hK,Ue=new h.$yc;for(const Ge of H.edits)if(Ge.textEdit){const We=Ge,et=b.URI.revive(We.resource),pt=o.to(We.textEdit.range),vt=We.textEdit.text,dt=We.textEdit.insertAsSnippet;let ft;dt?ft=s.$gK.replace(pt,new s.$iK(vt)):ft=s.$eK.replace(pt,vt);const mt=Ue.get(et);mt?mt.push(ft):Ue.set(et,[ft])}else Le.renameFile(b.URI.revive(Ge.oldResource),b.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of Ue)Le.set(Ge,We);return Le}Ce.to=ge})(Pe||(e.WorkspaceEdit=Pe={}));var Y;(function(Ce){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function ge(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ce.from=ge;function H(Le){for(const Ue in Me)if(Me[Ue]===Le)return Number(Ue);return s.SymbolKind.Property}Ce.to=H})(Y||(e.SymbolKind=Y={}));var le;(function(Ce){function Me(H){switch(H){case s.SymbolTag.Deprecated:return 1}}Ce.from=Me;function ge(H){switch(H){case 1:return s.SymbolTag.Deprecated}}Ce.to=ge})(le||(e.SymbolTag=le={}));var Ee;(function(Ce){function Me(H){return{name:H.name,kind:Y.from(H.kind),tags:H.tags&&H.tags.map(le.from),containerName:H.containerName,location:q.from(H.location)}}Ce.from=Me;function ge(H){const Le=new s.$oK(H.name,Y.to(H.kind),H.containerName,q.to(H.location));return Le.tags=H.tags&&H.tags.map(le.to),Le}Ce.to=ge})(Ee||(e.WorkspaceSymbol=Ee={}));var ce;(function(Ce){function Me(H){const Le={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:Y.from(H.kind),tags:H.tags?.map(le.from)??[]};return H.children&&(Le.children=H.children.map(Me)),Le}Ce.from=Me;function ge(H){const Le=new s.$pK(H.name,H.detail,Y.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,w.$Jb)(H.tags)&&(Le.tags=H.tags.map(le.to)),H.children&&(Le.children=H.children.map(ge)),Le}Ce.to=ge})(ce||(e.DocumentSymbol=ce={}));var $e;(function(Ce){function Me(H){const Le=new s.$tK(Y.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Le._sessionId=H._sessionId,Le._itemId=H._itemId,Le}Ce.to=Me;function ge(H,Le,Ue){if(Le=Le??H._sessionId,Ue=Ue??H._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:H.name,detail:H.detail,kind:Y.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(le.from)}}Ce.from=ge})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Me(ge){return new s.$uK($e.to(ge.from),ge.fromRanges.map(H=>o.to(H)))}Ce.to=Me})(ie||(e.CallHierarchyIncomingCall=ie={}));var z;(function(Ce){function Me(ge){return new s.$vK($e.to(ge.to),ge.fromRanges.map(H=>o.to(H)))}Ce.to=Me})(z||(e.CallHierarchyOutgoingCall=z={}));var q;(function(Ce){function Me(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Ce.from=Me;function ge(H){return new s.$jK(b.URI.revive(H.uri),o.to(H.range))}Ce.to=ge})(q||(e.location=q={}));var ue;(function(Ce){function Me(H){const Le=H,Ue=H;return{originSelectionRange:Le.originSelectionRange?o.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:o.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?o.from(Le.targetSelectionRange):void 0}}Ce.from=Me;function ge(H){return{targetUri:b.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Ce.to=ge})(ue||(e.DefinitionLink=ue={}));var we;(function(Ce){function Me(H){return{range:o.from(H.range),contents:j.fromMany(H.contents)}}Ce.from=Me;function ge(H){return new s.$mK(H.contents.map(j.to),o.to(H.range))}Ce.to=ge})(we||(e.Hover=we={}));var ve;(function(Ce){function Me(H){return{range:o.from(H.range),expression:H.expression}}Ce.from=Me;function ge(H){return new s.$fL(o.to(H.range),H.expression)}Ce.to=ge})(ve||(e.EvaluatableExpression=ve={}));var me;(function(Ce){function Me(H){if(H instanceof s.$gL)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof s.$hL)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof s.$iL)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function ge(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Ce.to=ge})(me||(e.InlineValue=me={}));var ke;(function(Ce){function Me(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Ce.from=Me;function ge(H){return new s.$jL(H.frameId,o.to(H.stoppedLocation))}Ce.to=ge})(ke||(e.InlineValueContext=ke={}));var re;(function(Ce){function Me(H){return{range:o.from(H.range),kind:H.kind}}Ce.from=Me;function ge(H){return new s.$nK(o.to(H.range),H.kind)}Ce.to=ge})(re||(e.DocumentHighlight=re={}));var he;(function(Ce){function Me(ge){switch(ge){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Me})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Me(ge){return{triggerKind:he.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Me})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Me(H){switch(H){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function ge(H){switch(H){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=ge})(oe||(e.CompletionItemTag=oe={}));var de;(function(Ce){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ge(Ue){return Me.get(Ue)??9}Ce.from=ge;const H=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(Ue){return H.get(Ue)??s.CompletionItemKind.Property}Ce.to=Le})(de||(e.CompletionItemKind=de={}));var Ie;(function(Ce){function Me(ge,H){const Le=new s.$DK(ge.label);return Le.insertText=ge.insertText,Le.kind=de.to(ge.kind),Le.tags=ge.tags?.map(oe.to),Le.detail=ge.detail,Le.documentation=A.$2j(ge.documentation)?j.to(ge.documentation):ge.documentation,Le.sortText=ge.sortText,Le.filterText=ge.filterText,Le.preselect=ge.preselect,Le.commitCharacters=ge.commitCharacters,m.$ms.isIRange(ge.range)?Le.range=o.to(ge.range):typeof ge.range=="object"&&(Le.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Le.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Le.insertText=new s.$iK(ge.insertText):(Le.insertText=ge.insertText,Le.textEdit=Le.range instanceof s.$_J?new s.$eK(Le.range,Le.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Le.additionalTextEdits=ge.additionalTextEdits.map(Ue=>De.to(Ue))),Le.command=H&&ge.command?H.fromInternal(ge.command):void 0,Le}Ce.to=Me})(Ie||(e.CompletionItem=Ie={}));var L;(function(Ce){function Me(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:j.fromStrict(H.documentation)}}Ce.from=Me;function ge(H){return{label:H.label,documentation:A.$2j(H.documentation)?j.to(H.documentation):H.documentation}}Ce.to=ge})(L||(e.ParameterInformation=L={}));var K;(function(Ce){function Me(H){return{label:H.label,documentation:j.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(L.from):[],activeParameter:H.activeParameter}}Ce.from=Me;function ge(H){return{label:H.label,documentation:A.$2j(H.documentation)?j.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(L.to):[],activeParameter:H.activeParameter}}Ce.to=ge})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.from):[]}}Ce.from=Me;function ge(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.to):[]}}Ce.to=ge})(G||(e.SignatureHelp=G={}));var Q;(function(Ce){function Me(ge,H){const Le=new s.$CK($.to(H.position),typeof H.label=="string"?H.label:H.label.map(J.to.bind(void 0,ge)),H.kind&&x.to(H.kind));return Le.textEdits=H.textEdits&&H.textEdits.map(De.to),Le.tooltip=A.$2j(H.tooltip)?j.to(H.tooltip):H.tooltip,Le.paddingLeft=H.paddingLeft,Le.paddingRight=H.paddingRight,Le}Ce.to=Me})(Q||(e.InlayHint=Q={}));var J;(function(Ce){function Me(ge,H){const Le=new s.$BK(H.label);return Le.tooltip=A.$2j(H.tooltip)?j.to(H.tooltip):H.tooltip,f.Command.is(H.command)&&(Le.command=ge.fromInternal(H.command)),H.location&&(Le.location=q.to(H.location)),Le}Ce.to=Me})(J||(e.InlayHintLabelPart=J={}));var x;(function(Ce){function Me(H){return H}Ce.from=Me;function ge(H){return H}Ce.to=ge})(x||(e.InlayHintKind=x={}));var ae;(function(Ce){function Me(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Me;function ge(H){let Le;if(H.url)try{Le=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new s.$IK(o.to(H.range),Le)}Ce.to=ge})(ae||(e.DocumentLink=ae={}));var Fe;(function(Ce){function Me(H){const Le=new s.$LK(H.label);return H.textEdit&&(Le.textEdit=De.to(H.textEdit)),H.additionalTextEdits&&(Le.additionalTextEdits=H.additionalTextEdits.map(Ue=>De.to(Ue))),Le}Ce.to=Me;function ge(H){return{label:H.label,textEdit:H.textEdit?De.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Le=>De.from(Le)):void 0}}Ce.from=ge})(Fe||(e.ColorPresentation=Fe={}));var je;(function(Ce){function Me(H){return new s.$JK(H[0],H[1],H[2],H[3])}Ce.to=Me;function ge(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=ge})(je||(e.Color=je={}));var Qe;(function(Ce){function Me(H){return{range:o.from(H.range)}}Ce.from=Me;function ge(H){return new s.$sK(o.to(H.range))}Ce.to=ge})(Qe||(e.SelectionRange=Qe={}));var He;(function(Ce){function Me(ge){switch(ge){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(He||(e.TextDocumentSaveReason=He={}));var _e;(function(Ce){function Me(H){switch(H){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function ge(H){switch(H){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=ge})(_e||(e.TextEditorLineNumbersStyle=_e={}));var Ye;(function(Ce){function Me(H){if(H===s.EndOfLine.CRLF)return 1;if(H===s.EndOfLine.LF)return 0}Ce.from=Me;function ge(H){if(H===1)return s.EndOfLine.CRLF;if(H===0)return s.EndOfLine.LF}Ce.to=ge})(Ye||(e.EndOfLine=Ye={}));var xe;(function(Ce){function Me(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(xe||(e.ProgressLocation=xe={}));var it;(function(Ce){function Me(H){const Le={start:H.start+1,end:H.end+1};return H.kind&&(Le.kind=tt.from(H.kind)),Le}Ce.from=Me;function ge(H){const Le={start:H.start-1,end:H.end-1};return H.kind&&(Le.kind=tt.to(H.kind)),Le}Ce.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Me(H){if(H)switch(H){case s.FoldingRangeKind.Comment:return f.$bt.Comment;case s.FoldingRangeKind.Imports:return f.$bt.Imports;case s.FoldingRangeKind.Region:return f.$bt.Region}}Ce.from=Me;function ge(H){if(H)switch(H.value){case f.$bt.Comment.value:return s.FoldingRangeKind.Comment;case f.$bt.Imports.value:return s.FoldingRangeKind.Imports;case f.$bt.Region.value:return s.FoldingRangeKind.Region}}Ce.to=ge})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Me(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.$LD.id:void 0}}Ce.from=Me})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Me(Ue){return Ue instanceof s.$6K?Ue.toJSON():typeof Ue=="string"?Ue:ge(Ue)||H(Ue)?new s.$6K(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ce.from=Me;function ge(Ue){const Ge=Ue;return Ge?b.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function H(Ue){const Ge=Ue;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new s.$6K(b.URI.revive(Ue.baseUri),Ue.pattern)}Ce.to=Le})(st||(e.GlobPattern=st={}));var _;(function(Ce){function Me(ge){if(ge){if(Array.isArray(ge))return ge.map(Me);if(typeof ge=="string")return ge;{const H=ge;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Me})(_||(e.LanguageSelector=_={}));var Z;(function(Ce){function Me(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Le=>Array.isArray(Le)&&Le.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&b.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ge=>Ge instanceof s.$_J)))}Ce.is=Me;function ge(H){return{documents:H.documents.map(Le=>Le.map(Ue=>({uri:b.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ge=>o.from(Ge))})))}}Ce.from=ge})(Z||(e.MappedEditsContext=Z={}));var pe;(function(Ce){function Me(H){return{start:H.start,end:H.end}}Ce.from=Me;function ge(H){return new s.$uL(H.start,H.end)}Ce.to=ge})(pe||(e.NotebookRange=pe={}));var Be;(function(Ce){function Me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Me;function ge(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=ge})(Be||(e.NotebookCellExecutionSummary=Be={}));var Ne;(function(Ce){function Me(ge){if(ge===v.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ge===v.NotebookCellExecutionState.Pending)return;if(ge===v.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Me})(Ne||(e.NotebookCellExecutionState=Ne={}));var Ze;(function(Ce){function Me(H){switch(H){case s.NotebookCellKind.Markup:return v.CellKind.Markup;case s.NotebookCellKind.Code:default:return v.CellKind.Code}}Ce.from=Me;function ge(H){switch(H){case v.CellKind.Markup:return s.NotebookCellKind.Markup;case v.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=ge})(Ze||(e.NotebookCellKind=Ze={}));var rt;(function(Ce){function Me(H){const Le={metadata:H.metadata??Object.create(null),cells:[]};for(const Ue of H.cells)s.$vL.validate(Ue),Le.cells.push(gt.from(Ue));return Le}Ce.from=Me;function ge(H){const Le=new s.$wL(H.cells.map(gt.to));return(0,a.$Jf)(H.metadata)||(Le.metadata=H.metadata),Le}Ce.to=ge})(rt||(e.NotebookData=rt={}));var gt;(function(Ce){function Me(H){return{cellKind:Ze.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Be.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Pt.from):[]}}Ce.from=Me;function ge(H){return new s.$vL(Ze.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Pt.to):void 0,H.metadata,H.internalMetadata?Be.to(H.internalMetadata):void 0)}Ce.to=ge})(gt||(e.NotebookCellData=gt={}));var yt;(function(Ce){function Me(H){return{mime:H.mime,valueBytes:M.$_d.wrap(H.data)}}Ce.from=Me;function ge(H){return new s.$xL(H.valueBytes.buffer,H.mime)}Ce.to=ge})(yt||(e.NotebookCellOutputItem=yt={}));var Pt;(function(Ce){function Me(H){return{outputId:H.id,items:H.items.map(yt.from),metadata:H.metadata}}Ce.from=Me;function ge(H){const Le=H.items.map(yt.to);return new s.$yL(Le,H.outputId,H.metadata)}Ce.to=ge})(Pt||(e.NotebookCellOutput=Pt={}));var Zt;(function(Ce){function Me(Le){return H(Le)?{include:st.from(Le.include)??void 0,exclude:st.from(Le.exclude)??void 0}:st.from(Le)??void 0}Ce.from=Me;function ge(Le){return H(Le)?{include:st.to(Le.include),exclude:st.to(Le.exclude)}:st.to(Le)}Ce.to=ge;function H(Le){const Ue=Le;return Ue?!(0,a.$Ff)(Ue.include)&&!(0,a.$Ff)(Ue.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var qt;(function(Ce){function Me(ge,H,Le){const Ue=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Ue,Le),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Me})(qt||(e.NotebookStatusBarItem=qt={}));var bt;(function(Ce){function Me(ge,H,Le){const Ue=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:H.toInternal(Ue,Le),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Me})(bt||(e.NotebookKernelSourceAction=bt={}));var jt;(function(Ce){function Me(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Me})(jt||(e.NotebookDocumentContentOptions=jt={}));var Ft;(function(Ce){function Me(H){return{uri:H.uri,provides:H.provides}}Ce.from=Me;function ge(H){return new s.$AL(b.URI.revive(H.uri),H.provides)}Ce.to=ge})(Ft||(e.NotebookRendererScript=Ft={}));var Ut;(function(Ce){function Me(H){return{message:j.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Ce.from=Me;function ge(H){const Le=new s.$GL(typeof H.message=="string"?H.message:j.to(H.message));return Le.actualOutput=H.actual,Le.expectedOutput=H.expected,Le.contextValue=H.contextValue,Le.location=H.location?q.to(H.location):void 0,Le}Ce.to=ge})(Ut||(e.TestMessage=Ut={}));var At;(function(Ce){Ce.namespace=p.$5I,Ce.denamespace=p.$6I})(At||(e.TestTag=At={}));var Rt;(function(Ce){function Me(H){const Le=(0,n.$5L)(H).controllerId;return{extId:D.$1I.fromExtHostTestItem(H,Le).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Ue=>At.namespace(Le,Ue.id)),range:m.$ms.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&j.fromStrict(H.error)||null}}Ce.from=Me;function ge(H){return{parent:void 0,error:void 0,id:D.$1I.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Le=>{const{tagId:Ue}=At.denamespace(Le);return new s.$HL(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=ge})(Rt||(e.TestItem=Rt={})),function(Ce){function Me(H){return{id:H.id}}Ce.from=Me;function ge(H){return new s.$HL(H.id)}Ce.to=ge}(At||(e.TestTag=At={}));var Ot;(function(Ce){const Me=(H,Le)=>{const Ue=[];for(const[We,et]of Le)D.$1I.compare(et.item.extId,We)===2&&(Le.delete(We),Ue.push(et));const Ge={...Rt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(et=>et.type===0).map(Ut.to)})),children:Ue.map(We=>Me(We,Le))};for(const We of Ge.children)We.parent=Ge;return Ge};function ge(H){const Le=[],Ue=new Map;for(const Ge of H.items){Ue.set(Ge.item.extId,Ge);const We=D.$1I.root(Ge.item.extId);H.request.targets.some(et=>et.controllerId===We&&et.testIds.includes(Ge.item.extId))&&Le.push(Ge)}return{completedAt:H.completedAt,results:Le.map(Ge=>Me(Ge,Ue))}}Ce.to=ge})(Ot||(e.TestResults=Ot={}));var Bt;(function(Ce){function Me(Ue){return{covered:Ue.covered,total:Ue.covered}}function ge(Ue){return"line"in Ue?$.from(Ue):o.from(Ue)}function H(Ue){return"branches"in Ue?{count:Ue.executionCount,location:ge(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ge(Ge.location)})):void 0}:{type:0,count:Ue.executionCount,location:ge(Ue.location)}}Ce.fromDetailed=H;function Le(Ue){return{uri:Ue.uri,statement:Me(Ue.statementCoverage),branch:Ue.branchCoverage&&Me(Ue.branchCoverage),function:Ue.functionCoverage&&Me(Ue.functionCoverage),details:Ue.detailedCoverage?.map(H)}}Ce.fromFile=Le})(Bt||(e.TestCoverage=Bt={}));var Kt;(function(Ce){function Me(ge){switch(ge){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Me})(Kt||(e.CodeActionTriggerKind=Kt={}));var Wt;(function(Ce){function Me(H){const Le=new s.$NL(Y.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Le._sessionId=H._sessionId,Le._itemId=H._itemId,Le}Ce.to=Me;function ge(H,Le,Ue){if(Le=Le??H._sessionId,Ue=Ue??H._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:Y.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(le.from)}}Ce.from=ge})(Wt||(e.TypeHierarchyItem=Wt={}));var at;(function(Ce){function Me(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Me})(at||(e.ViewBadge=at={}));var ut;(function(Ce){function Me(Ue,Ge,We){const et=Ge.fileData;return et?new s.$YK(new s.$ZK(et.name,b.URI.revive(et.uri),et.id,(0,F.$bb)(()=>We(et.id)))):Ue===P.$Jr.uriList&&Ge.uriListData?new s.$XK(Le(Ge.uriListData)):new s.$XK(Ge.asString)}Ce.to=Me;async function ge(Ue,Ge){const We=await Ge.asString();if(Ue===P.$Jr.uriList)return{asString:We,fileData:void 0,uriListData:H(We)};const et=Ge.asFile();return{asString:We,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=ge;function H(Ue){return C.$Vs.split(Ue).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return b.URI.parse(Ge)}catch{}return Ge})}function Le(Ue){return C.$Vs.create(Ue.map(Ge=>typeof Ge=="string"?Ge:b.URI.revive(Ge)))}})(ut||(e.DataTransferItem=ut={}));var Ht;(function(Ce){function Me(H,Le){const Ue=H.items.map(([Ge,We])=>[Ge,ut.to(Ge,We,Le)]);return new s.$1K(Ue)}Ce.toDataTransfer=Me;async function ge(H){const Le={items:[]},Ue=[];for(const[Ge,We]of H)Ue.push((async()=>{Le.items.push([Ge,await ut.from(Ge,We)])})());return await Promise.all(Ue),Le}Ce.from=ge})(Ht||(e.DataTransfer=Ht={}));var Ct;(function(Ce){function Me(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Me;function ge(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=ge})(Ct||(e.ChatReplyFollowup=Ct={}));var Dt;(function(Ce){function Me(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Ct.from(ge)}Ce.from=Me})(Dt||(e.ChatFollowup=Dt={}));var ht;(function(Ce){function Me(H){const Le=new s.$XL(St.to(H.role),H.content);return Le.name=H.name,Le}Ce.to=Me;function ge(H){return{role:St.from(H.role),content:H.content,name:H.name}}Ce.from=ge})(ht||(e.ChatMessage=ht={}));var St;(function(Ce){function Me(H){switch(H){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Me;function ge(H){switch(H){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=ge})(St||(e.ChatMessageRole=St={}));var Tt;(function(Ce){function Me(H){return{level:Et.to(H.level),value:H.value,description:H.description}}Ce.to=Me;function ge(H){return{level:Et.from(H.level),value:H.value,description:H.description}}Ce.from=ge})(Tt||(e.ChatVariable=Tt={}));var Et;(function(Ce){function Me(H){switch(H){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Me;function ge(H){switch(H){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=ge})(Et||(e.ChatVariableLevel=Et={}));var qe;(function(Ce){function Me(ge){switch(ge){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Me})(qe||(e.InteractiveEditorResponseFeedbackKind=qe={}));var Nt;(function(Ce){function Me(ge,H,Le){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:H.toInternal(ge,Le)}Ce.from=Me})(Nt||(e.TerminalQuickFix=Nt={}))}),define(Ae[203],Re([1,0,2,9,7,8,173]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;class h{constructor(g,P,k,a={timeout:1500,errors:3}){this.c=g,this.d=P,this.f=k,this.g=a,this.a=new A.$Zc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(P,k,a)=>{const m={dispose:this.a.push([P,k,g])};return Array.isArray(a)&&a.push(m),m}}async $participateInSave(g,P){const k=w.URI.revive(g);let a=!1;const b=setTimeout(()=>a=!0,this.g.timeout),m=[];try{for(const f of[...this.a]){if(a)break;const t=this.d.getDocument(k),n=await this.h(f,{document:t,reason:F.TextDocumentSaveReason.to(P)});m.push(n)}}finally{clearTimeout(b)}return m}h([g,P,k],a){const b=this.b.get(g);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(k,g,P,a).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,P,k,a){const b=[],m=Date.now(),{document:f,reason:t}=a,{version:n}=f,c=Object.freeze({document:f,reason:t,waitUntil(v){if(Object.isFrozen(b))throw(0,M.$6)("waitUntil can not be called async");b.push(Promise.resolve(v))}});try{P.apply(k,[c])}catch(v){return Promise.reject(v)}return Object.freeze(b),new Promise((v,D)=>{const p=setTimeout(()=>D(new Error("timeout")),this.g.timeout);return Promise.all(b).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(p),v(r)}).catch(r=>{clearTimeout(p),D(r)})}).then(v=>{const D={edits:[]};for(const p of v)if(Array.isArray(p)&&p.every(r=>r instanceof C.$eK))for(const{newText:r,newEol:s,range:i}of p)D.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:i&&F.Range.from(i),text:r,eol:s&&F.EndOfLine.from(s)}});if(D.edits.length!==0)return n===f.version?this.f.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.$Tbc=h}),define(Ae[204],Re([1,0,12,2,8,7,75]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=void 0;class h{constructor(k,a,b,m){this.start=k,this.deletedCount=a,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new F.$uL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(k,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,a,b){this.notebook=k,this.h=a,this.j=b,this.handle=b.handle,this.uri=M.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return k.g},set mime(m){k.g=m},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(b)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,a,b){const m=b.map(C.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===k);if(f&&(a||(f.items.length=0),f.items.push(...m),f.items.length>1&&f.items.every(t=>A.$hI(t.mime)))){const t=new Map,n=[];f.items.forEach(c=>{let v;t.has(c.mime)?v=t.get(c.mime):(v=[],t.set(c.mime,v),n.push(c.mime)),v.push(c.data)}),f.items.length=0,n.forEach(c=>{const v=A.$iI(t.get(c));f.items.push({mime:c,data:v.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$7cc=E;class g{static{this.a=0}constructor(k,a,b,m,f){this.k=k,this.l=a,this.m=b,this.uri=m,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,a={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===w.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(b){return b=k.n(b),k.b[b].apiCell},getCells(b){return(b?k.p(b):k.b).map(f=>f.apiCell)},save(){return k.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,a,b){this.g=k.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},f=[];for(const n of k.rawEvents)n.kind===A.NotebookCellsChangeType.ModelChange?this.r(n.changes,!1,m.contentChanges):n.kind===A.NotebookCellsChangeType.Move?this.s(n.index,n.length,n.newIdx,m.contentChanges):n.kind===A.NotebookCellsChangeType.Output?(this.t(n.index,n.outputs),f.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===A.NotebookCellsChangeType.OutputItem?(this.u(n.index,n.outputId,n.append,n.outputItems),f.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(n.index,n.language),f.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document})):n.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document}):n.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(n.index,n.mime):n.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(n.index,n.metadata),f.push({cell:this.b[n.index].apiCell,metadata:this.b[n.index].apiCell.metadata})):n.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(n.index,n.internalMetadata),f.push({cell:this.b[n.index].apiCell,executionSummary:this.b[n.index].apiCell.executionSummary}));const t=new Map;for(let n=0;n<f.length;n++){const c=f[n],v=t.get(c.cell);if(v===void 0){const D=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,D-1)}else m.cellChanges[v]={...m.cellChanges[v],...c}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let a=k.start|0,b=k.end|0;return a<0&&(a=0),b>this.b.length&&(b=this.b.length),k.with({start:a,end:b})}p(k){k=this.o(k);const a=[];for(let b=k.start;b<k.end;b++)a.push(this.b[b]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,a,b){if(this.j)return;const m=[],f=[],t=[];if(k.reverse().forEach(n=>{const v=n[2].map(r=>{const s=new E(this,this.l,r);return a||f.push(E.asModelAddData(this.apiNotebook,r)),s}),D=new h(n[0],n[1],[],v),p=this.b.splice(n[0],n[1],...v);for(const r of p)t.push(r.uri),D.deletedItems.push(r.apiCell);m.push(D)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),b)for(const n of m)b.push(n.asApiEvent())}s(k,a,b,m){const f=this.b.splice(k,a);this.b.splice(b,0,...f);const t=[new h(k,a,f.map(n=>n.apiCell),[]),new h(b,0,[],f)];for(const n of t)m.push(n.asApiEvent())}t(k,a){this.b[k].setOutputs(a)}u(k,a,b,m){this.b[k].setOutputItems(a,b,m)}v(k,a){const b=this.b[k];b.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(b.uri,a)}w(k,a){const b=this.b[k];b.apiCell.mime=a}x(k,a){this.b[k].setMetadata(a)}y(k,a){this.b[k].setInternalMetadata(a)}getCellFromApiCell(k){return this.b.find(a=>a.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(a=>a.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$8cc=g}),define(Ae[205],Re([1,0,5,2,8,7]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;class A{constructor(E,g,P,k={timeout:1500,errors:3}){this.b=E,this.c=g,this.d=P,this.f=k,this.a=new w.$Nd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(g,P,k)=>{const a=function(m){g.call(P,m)};return a.extension=E,this.a.event(a,void 0,k)}}async $participateInSave(E,g,P){const k=M.URI.revive(E),a=this.c.getNotebookDocument(k);if(!a)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},P,async(f,t)=>{const n=Date.now(),c=await await Promise.resolve(f);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof F.$hK?b.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(b.length===0)return!0;const m={edits:[]};for(const f of b){const{edits:t}=C.WorkspaceEdit.from(f);m.edits=m.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(m)}}e.$vdc=A}),define(Ae[103],Re([1,0,9,8,7]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(h,E,g,P,k,a){this.id=h,this.f=E,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=P,this.c=a}get apiEditor(){if(!this.e){const h=this;this.e={get notebook(){return h.notebookData.apiNotebook},get selection(){return h.a[0]},set selection(E){this.selections=[E]},get selections(){return h.a},set selections(E){if(!Array.isArray(E)||!E.every(C.$uL.isNotebookRange))throw(0,w.$5)("selections");h.a=E,h.g(E)},get visibleRanges(){return h.b},revealRange(E,g){h.f.$tryRevealRange(h.id,M.NotebookRange.from(E),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return h.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(h){this.d=h}_acceptVisibleRanges(h){this.b=h}_acceptSelections(h){this.a=h}g(h){this.f.$trySetSelections(this.id,h.map(M.NotebookRange.from))}_acceptViewColumn(h){this.c=h}}e.$9cc=F}),define(Ae[206],Re([1,0,9,5,14,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;let A=class{constructor(E,g){this.c=E,this.d=g,this.a=new M.$Ld({onListenerError:w.$Z}),this.b=new M.$Ld({onListenerError:w.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,g);const P=this.d.getEditorById(E);g.visibleRanges&&P._acceptVisibleRanges(g.visibleRanges.ranges.map(F.NotebookRange.to)),g.selections&&P._acceptSelections(g.selections.selections.map(F.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const g in E)this.d.getEditorById(g)._acceptViewColumn(F.ViewColumn.to(E[g]))}};e.$odc=A,e.$odc=A=Ke([Ve(0,C.$7i)],A)}),define(Ae[207],Re([1,0,8,72,152,21,65,9]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class E{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,b,m){const f=this.b++,{title:t,location:n,cancellable:c}=b,v={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(f,{location:w.ProgressLocation.from(n),title:t,source:v,cancellable:c},a.isUnderDevelopment?void 0:a.identifier.value).catch(h.$Z),this.d(f,m,!!c)}d(a,b,m){let f;m&&(f=new F.$Vd,this.c.set(a,f));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),f?.dispose()};let n;try{n=b(new P(this.a,a),m&&f?f.token:F.CancellationToken.None)}catch(c){throw t(a),c}return n.then(c=>t(a),c=>t(a)),n}$acceptProgressCanceled(a){const b=this.c.get(a);b&&(b.cancel(),this.c.delete(a))}}e.$scc=E;function g(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class P extends M.$Xu{constructor(a,b){super(m=>this.throttledReport(m)),this.f=a,this.g=b}throttledReport(a){this.f.$progressReport(this.g,a)}}Ke([(0,A.$gh)(100,(k,a)=>g(k,a),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,44,101,45,76,57,8,2]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=e.$iM=void 0;const g=(v,D,p,r)=>{let s=D;return{enumerable:!0,configurable:!1,get(){return s},set(i){if(!p(s,i)){const o=s;s=i,v.listener?.(r(i,o))}}}},P=(v,D)=>v===D,k={range:(v,D)=>v===D?!0:!v||!D?!1:v.isEqual(D),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(v,D)=>!(v.length!==D.length||v.some(p=>!D.find(r=>p.id===r.id)))},a=v=>D=>({op:4,update:v(D)}),b=(v,D)=>({range:(()=>{let p;const r=a(s=>({range:w.$ms.lift(h.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return p},set(s){v.listener?.({op:6}),k.range(p,s)||(p=s,v.listener?.(r(s)))}}})(),label:g(v,D,k.label,a(p=>({label:p}))),description:g(v,void 0,k.description,a(p=>({description:p}))),sortText:g(v,void 0,k.sortText,a(p=>({sortText:p}))),canResolveChildren:g(v,!1,k.canResolveChildren,p=>({op:2,state:p})),busy:g(v,!1,k.busy,a(p=>({busy:p}))),error:g(v,void 0,k.error,a(p=>({error:h.MarkdownString.fromStrict(p)||null}))),tags:g(v,[],k.tags,(p,r)=>({op:1,new:p.map(h.TestTag.from),old:r.map(h.TestTag.from)}))}),m=v=>{const D=C.$1I.fromString(v.extId),p=new t(D.controllerId,D.localId,v.label,E.URI.revive(v.uri)||void 0);return p.range=h.Range.to(v.range||void 0),p.description=v.description||void 0,p.sortText=v.sortText||void 0,p.tags=v.tags.map(r=>h.TestTag.to({id:(0,A.$6I)(r).tagId})),p},f=v=>{let D;for(const p of v.tests){const r=m(p.item);(0,M.$5L)(r).parent=D,D=r}return D};e.$iM=f;class t{constructor(D,p,r,s){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const i=(0,M.$4L)(this,D);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof n?void 0:i.parent}},children:{value:(0,F.$3L)(i,M.$5L,t),enumerable:!0,writable:!1},...b(i,r)})}}e.$jM=t;class n extends t{constructor(D,p){super(D,D,p,void 0),this._isRoot=!0}}e.$kM=n;class c extends F.$YL{constructor(D,p,r){super({controllerId:D,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:M.$5L,getChildren:s=>s.children,root:new n(D,p),toITestItem:h.TestItem.from})}}e.$lM=c}),define(Ae[105],Re([1,0,51,9,88,8,7]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=e.$dM=void 0;class h{static{this.c=new C.$bM("TextEditorDecorationType")}constructor(a,b,m){const f=h.c.nextId();a.$registerTextEditorDecorationType(b.identifier,f,F.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.$dM=h;class E{constructor(a,b){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,b){this.k();let m=null;if(a instanceof A.$$J)m=new A.$_J(a,a);else if(a instanceof A.$_J)m=a;else throw new Error("Unrecognized location");this.l(m,b,!1)}insert(a,b){this.k(),this.l(new A.$_J(a,a),b,!0)}delete(a){this.k();let b=null;if(a instanceof A.$_J)b=a;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(a,b,m){const f=this.c.validateRange(a);this.g.push({range:f,text:b,forceMoveMarkers:m})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,M.$5)("endOfLine");this.h=a}}class g{constructor(a,b,m,f){this.c=a,this.d=b,this._accept(m),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(n){t.m(n)},get indentSize(){return t.g},set indentSize(n){t.o(n)},get insertSpaces(){return t.h},set insertSpaces(n){t.q(n)},get cursorStyle(){return t.j},set cursorStyle(n){t.s(n)},get lineNumbers(){return t.k},set lineNumbers(n){t.t(n)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const b=Math.floor(a);return b>0?b:null}if(typeof a=="string"){const b=parseInt(a,10);return isNaN(b)?null:b>0?b:null}return null}m(a){const b=this.l(a);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const b=Math.floor(a);return b>0?b:null}if(typeof a=="string"){const b=parseInt(a,10);return isNaN(b)?null:b>0?b:null}return null}o(a){const b=this.n(a);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const b=this.p(a);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(a)})))}assign(a){const b={};let m=!1;if(typeof a.tabSize<"u"){const f=this.l(a.tabSize);f==="auto"?(m=!0,b.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,m=!0,b.tabSize=f)}if(typeof a.indentSize<"u"){const f=this.n(a.indentSize);f==="tabSize"?(m=!0,b.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,m=!0,b.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this.p(a.insertSpaces);f==="auto"?(m=!0,b.insertSpaces=f):this.h!==f&&(this.h=f,m=!0,b.insertSpaces=f)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,m=!0,b.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,m=!0,b.lineNumbers=F.TextEditorLineNumbersStyle.from(a.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(a,b){b.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(m)})}}e.$eM=g;class P{constructor(a,b,m,f,t,n,c,v){this.id=a,this.j=b,this.k=m,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,n,m),this.e=c,this.f=v;const D=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw new M.$7("document")},get selection(){return D.c&&D.c[0]},set selection(p){if(!(p instanceof A.$aK))throw(0,M.$5)("selection");D.c=[p],D.l()},get selections(){return D.c},set selections(p){if(!Array.isArray(p)||p.some(r=>!(r instanceof A.$aK)))throw(0,M.$5)("selections");D.c=p,D.l()},get visibleRanges(){return D.e},set visibleRanges(p){throw new M.$7("visibleRanges")},get options(){return D.d.value},set options(p){D.g||D.d.assign(p)},get viewColumn(){return D.f},set viewColumn(p){throw new M.$7("viewColumn")},edit(p,r={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(f.value,r);return p(s),D.m(s)},insertSnippet(p,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=D.c.map(o=>F.Range.from(o));else if(r instanceof A.$$J){const{lineNumber:o,column:y}=F.Position.from(r);i=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(r instanceof A.$_J)i=[F.Range.from(r)];else{i=[];for(const o of r)if(o instanceof A.$_J)i.push(F.Range.from(o));else{const{lineNumber:y,column:$}=F.Position.from(o);i.push({startLineNumber:y,startColumn:$,endLineNumber:y,endColumn:$})}}return b.$tryInsertSnippet(a,f.value.version,p.value,i,s)},setDecorations(p,r){const s=r.length===0;s&&!D.h.has(p.key)||(s?D.h.delete(p.key):D.h.add(p.key),D.n(()=>{if(F.$6L(r))return b.$trySetDecorations(a,p.key,F.$7L(r));{const i=new Array(4*r.length);for(let o=0,y=r.length;o<y;o++){const $=r[o];i[4*o]=$.start.line+1,i[4*o+1]=$.start.character+1,i[4*o+2]=$.end.line+1,i[4*o+3]=$.end.character+1}return b.$trySetDecorationsFast(a,p.key,i)}}))},revealRange(p,r){D.n(()=>b.$tryRevealRange(a,F.Range.from(p),r||A.TextEditorRevealType.Default))},show(p){b.$tryShowEditor(a,F.ViewColumn.from(p))},hide(){b.$tryHideEditor(a)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,w.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,w.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,w.ok)(!this.g),this.f=a}_acceptSelections(a){(0,w.ok)(!this.g),this.c=a}async l(){const a=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const b=a.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(t=>t.range);m.sort((t,n)=>t.end.line===n.end.line?t.end.character===n.end.character?t.start.line===n.start.line?t.start.character-n.start.character:t.start.line-n.start.line:t.end.character-n.end.character:t.end.line-n.end.line);for(let t=0,n=m.length-1;t<n;t++){const c=m[t].end;if(m[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=b.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,f,{setEndOfLine:typeof b.setEndOfLine=="number"?F.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$fM=P}),define(Ae[208],Re([1,0,4,171]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=void 0,e.$sJ=(0,w.$Nh)(M.$Th)}),define(Ae[106],Re([1,0,20,5,19,6]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$73b=e.$63b=e.$53b=e.$43b=e.$33b=e.$23b=void 0;class A{constructor(n,c){this.versionId=n,this.removedDueToLooping=c}}e.$23b=A;class h{static isHostExtension(n,c,v){if(c.getExtensionDescription(n))return!1;const D=v.getExtensionDescription(n);return D?!!((D.main||D.browser)&&D.api==="none"):!1}constructor(n,c){this.j=n,this.c=new M.$Ld,this.onDidChange=this.c.event,this.d=0,this.e=c,this.k()}k(){this.e.sort(m),this.f=new w.$Zl,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const c=this.j.readActivationEvents(n);if(Array.isArray(c))for(let v of c)v==="onUri"&&(v=`onUri:${w.$Xl.toKey(n.identifier)}`),this.h.has(v)||this.h.set(v,[]),this.h.get(v).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,c){this.e=f(this.e,c),this.e=this.e.concat(n);const v=h.l(this.e);return this.e=f(this.e,v.map(D=>D.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,v)}static l(n){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,i){this.addNode(s),this.addNode(i),this.c.has(s)?this.c.get(s).push(i):this.c.set(s,[i])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,i){const o=c.getArcs(s);for(let y=0;y<o.length;y++)if(!i.has(o[y]))return!1;return!0}getNodes(){return this.e}},v=new w.$Zl;for(const s of n)if(v.set(s.identifier,s),s.extensionDependencies)for(const i of s.extensionDependencies)c.addArc(w.$Xl.toKey(s.identifier),w.$Xl.toKey(i));const D=new Set;c.getNodes().filter(s=>c.getArcs(s).length===0).forEach(s=>D.add(s));const p=c.getNodes().filter(s=>!D.has(s));let r;do{r=!1;for(let s=0;s<p.length;s++){const i=p[s];c.hasOnlyGoodArcs(i,D)&&(p.splice(s,1),s--,D.add(i),r=!0)}}while(r);return p.map(s=>v.get(s))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const c=this.h.get(n);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const c=this.f.get(n);return c||void 0}getExtensionDescriptionByUUID(n){for(const c of this.g)if(c.uuid===n)return c}getExtensionDescriptionByIdOrUUID(n,c){return this.getExtensionDescription(n)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$33b=h;class E{constructor(n,c){this.versionId=n,this.extensions=c}}e.$43b=E,e.$53b={readActivationEvents:t=>t.activationEvents};class g{constructor(n){this.d=new a,this.c=new h(n,[])}async acquireLock(n){const c=await this.d.acquire(n);return new P(this,c)}deltaExtensions(n,c,v){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,v)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,c){return this.c.getExtensionDescriptionByIdOrUUID(n,c)}}e.$63b=g;class P extends F.$Qc{constructor(n,c){super(),this.f=n,this.c=!1,this.B(c)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$73b=P;class k{constructor(n){this.name=n,this.promise=new Promise((c,v)=>{this.c=c})}resolve(n){this.c(n)}}class a{constructor(){this.c=[],this.d=!1}async acquire(n){const c=new k(n);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let c=!0;const v=setTimeout(()=>{c&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),D=()=>{c&&(clearTimeout(v),c=!1,this.d=!1,this.e())};n.resolve((0,F.$Oc)(D))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function m(t,n){const c=t.isBuiltin?0:t.isUnderDevelopment?2:1,v=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(c!==v)return c-v;const D=C.$ec.basename(t.extensionLocation.path),p=C.$ec.basename(n.extensionLocation.path);return D<p?-1:D>p?1:0}function f(t,n){const c=new w.$Yl(n);return t.filter(v=>!c.has(v.identifier))}}),define(Ae[79],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$7l=e.$6l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var F;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function A(g){const P=w.$_d.alloc(1);switch(g){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$6l=A;function h(g,P){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$7l=h;var E;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=e.$nM=void 0;let b=class extends k.$Qc{constructor(n,c){super(),this.s=n,this.t=c,this.a=this.B(new M.$Ld),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Ld),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:E.$go,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(v=>{(0,C.$9i)(v)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(n,c,v){const D=this.getTelemetryDetails(),p=new m(c,v,n,this.n,this.j,this.getBuiltInCommonProperties(n),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled}),r=this.r.get(n.identifier.value)??[];return this.r.set(n.identifier.value,[...r,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(n,c,v){this.f=n,this.g=c,this.c=v??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(n){const c=Object.create(null);switch(c["common.extname"]=`${n.publisher}.${n.name}`,c["common.extversion"]=n.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,h.$Rk)((0,E.$no)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(n){this.h=this.getTelemetryConfiguration(),this.f=n;const c=this.getTelemetryDetails();this.r.forEach((v,D)=>{const p=v.filter(r=>!r.isDisposed);p.length===0?this.r.delete(D):this.r.set(D,p)}),this.r.forEach(v=>{for(const D of v)D.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(n,c){const D=this.r.get(n.value)?.filter(r=>!r.isDisposed);if(!D)return this.r.delete(n.value),!1;let p=!1;for(const r of D)r.ignoreUnhandledExtHostErrors||(r.logError(c),p=!0);return p}};e.$nM=b,e.$nM=b=Ke([Ve(0,F.$mM),Ve(1,C.$8i)],b);class m{static validateSender(n){if(typeof n!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof n.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof n.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof n.flush<"u"&&typeof n.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(n,c,v,D,p,r,s){this.g=v,this.h=D,this.i=p,this.j=r,this.a=new M.$Ld,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=n,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(n,c){this.e&&(this.d={isUsageEnabled:n,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(n){let c="properties"in n?n.properties??{}:n;return c=(0,E.$qo)(c,[]),this.c&&(c=(0,g.$1m)(c,this.c)),this.b||(c=(0,g.$1m)(c,this.j)),"properties"in n?n.properties=c:n=c,n}k(n,c){this.f&&(this.g.publisher==="vscode"?n=this.g.name+"/"+n:n=this.g.identifier.value+"/"+n,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(n,c),this.h.trace(n,c))}logUsage(n,c){this.d.isUsageEnabled&&this.k(n,c)}logError(n,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof n=="string")this.k(n,c);else{const v={name:n.name,message:n.message,stack:n.stack,cause:n.cause},D=(0,E.$qo)(v,[]),p=new Error(D.message,{cause:D.cause});p.stack=D.stack,p.name=D.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(p,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const n=this,c={logUsage:n.logUsage.bind(n),get isUsageEnabled(){return n.d.isUsageEnabled},get isErrorsEnabled(){return n.d.isErrorsEnabled},logError:n.logError.bind(n),dispose:n.dispose.bind(n),onDidChangeEnableStates:n.a.event.bind(n)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let n=this.f;this.f=void 0,Promise.resolve(n.flush()).then(n=void 0),this.e=void 0}else this.f=void 0}}e.$oM=m;function f(t){const n=Date.now()-new Date(t).getTime();return isNaN(n)?!1:n<1e3*60*60*24}e.$pM=f,e.$qM=(0,w.$Mh)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,180,98,20,4]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.ActivationKind=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.ExtensionHostStartup=e.$5E=e.$4E=e.$3E=e.$2E=void 0,e.$2E=Object.freeze({identifier:new A.$Xl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$3E="extensions.webWorker",e.$4E=(0,h.$Mh)("extensionService");class E{constructor(p){this.dependency=p}}e.$5E=E;var g;(function(D){D[D.EagerAutoStart=1]="EagerAutoStart",D[D.EagerManualStart=2]="EagerManualStart",D[D.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(p,r,s){this.c=p,this.d=r.slice(0),this.e=s.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$ME.createActivationEventsMap(this.d)}}set(p,r,s){if(this.c>p)throw new Error(`ExtensionHostExtensions: invalid versionId ${p} (current: ${this.c})`);const i=[],o=[],y=[],$=[],S=k(this.d),I=k(r),u=(V,j)=>V.extensionLocation.toString()===j.extensionLocation.toString()||V.isBuiltin===j.isBuiltin||V.isUserBuiltin===j.isUserBuiltin||V.isUnderDevelopment===j.isUnderDevelopment;for(const V of this.d){const j=I.get(V.identifier);if(!j){i.push(V.identifier),S.delete(V.identifier);continue}if(!u(V,j)){i.push(V.identifier),S.delete(V.identifier);continue}}for(const V of r){const j=S.get(V.identifier);if(!j){o.push(V);continue}if(!u(j,V)){i.push(j.identifier),S.delete(j.identifier);continue}}const d=new A.$Yl(this.e),l=new A.$Yl(s);for(const V of this.e)l.has(V)||y.push(V);for(const V of s)d.has(V)||$.push(V);const R=F.$ME.createActivationEventsMap(o),B={versionId:p,toRemove:i,toAdd:o,addActivationEvents:R,myToRemove:y,myToAdd:$};return this.delta(B),B}delta(p){if(this.c>=p.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:i,myToAdd:o}=p,y=new A.$Yl(r),$=new A.$Yl(i);for(let S=0;S<this.d.length;S++)y.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)$.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of o)this.e.push(S);return p}containsExtension(p){for(const r of this.e)if(A.$Xl.equals(r,p))return!0;return!1}}e.$6E=P;function k(D){const p=new A.$Zl;for(const r of D)p.set(r.identifier,r);return p}function a(D,p){return D.enabledApiProposals?D.enabledApiProposals.includes(p):!1}e.$7E=a;function b(D,p){if(!a(D,p))throw new Error(`Extension '${D.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${D.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${D.identifier.value}`)}e.$8E=b;class m{constructor(p,r,s,i){this.codeLoadingTime=p,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=i}}e.$9E=m;class f{constructor(p,r){this.description=p,this.value=r}}e.$0E=f;var t;(function(D){D[D.Normal=0]="Normal",D[D.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function n(D){return{type:D.isBuiltin?0:1,isBuiltin:D.isBuiltin||D.isUserBuiltin,identifier:{id:(0,C.$wo)(D.publisher,D.name),uuid:D.uuid},manifest:D,location:D.extensionLocation,targetPlatform:D.targetPlatform,validations:[],isValid:!0}}e.$$E=n;function c(D,p){return{identifier:new A.$Xl((0,C.$uo)(D.manifest.publisher,D.manifest.name)),isBuiltin:D.type===0,isUserBuiltin:D.type===1&&D.isBuiltin,isUnderDevelopment:!!p,extensionLocation:D.location,...D.manifest,uuid:D.identifier.uuid,targetPlatform:D.targetPlatform}}e.$_E=c;class v{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$aF=v}),define(Ae[209],Re([1,0,9,106,20,26,14,13]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=e.$Xbc=e.$Wbc=e.$Vbc=e.$Ubc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(n,c,v,D){this.startup=n,this.codeLoadingTime=c,this.activateCallTime=v,this.activateResolvedTime=D}}e.$Ubc=E;class g{constructor(n){this.a=n,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(n,c){return n===-1||c===-1?-1:c-n}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Vbc=g;class P{constructor(n,c,v,D,p,r){this.activationFailed=n,this.activationFailedError=c,this.activationTimes=v,this.module=D,this.exports=p,this.subscriptions=r}}e.$Wbc=P;class k extends P{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xbc=k;class a extends P{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ybc=a;class b extends P{constructor(n){super(!0,n,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(n,c,v,D){this.g=D,this.a=n,this.b=c,this.c=v,this.d=new C.$Zl,this.f=Object.create(null)}dispose(){for(const[n,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const n=[];for(const[c,v]of this.d)n.push(v.wait());await Promise.all(n)}isActivated(n){const c=this.d.get(n);return!!(c&&c.value)}getActivatedExtension(n){const c=this.d.get(n);if(!c||!c.value)throw new Error(`Extension '${n.value}' is not known or not activated`);return c.value}async activateByEvent(n,c){if(this.f[n])return;const v=this.a.getExtensionDescriptionsForActivationEvent(n);await this.h(v.map(D=>({id:D.identifier,reason:{startup:c,extensionId:D.identifier,activationEvent:n}}))),this.f[n]=!0}activateById(n,c){const v=this.a.getExtensionDescription(n);if(!v)throw new Error(`Extension '${n}' is not known`);return this.h([{id:v.identifier,reason:c}])}async h(n){const c=n.filter(v=>!this.isActivated(v.id)).map(v=>this.j(v));await Promise.all(c.map(v=>v.wait()))}j(n){if(this.d.has(n.id))return this.d.get(n.id);if(this.l(n.id))return this.k(n,null,[],null);const c=this.a.getExtensionDescription(n.id);if(!c){const p=new Error(`Cannot activate unknown extension '${n.id.value}'`),r=this.k(n,null,[],new b(p));return this.c.onExtensionActivationError(n.id,p,new F.$5E(n.id.value)),r}const v=[],D=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const p of D){if(this.m(p))continue;const r=this.d.get(p);if(r){v.push(r);continue}if(this.l(p)){v.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:n.reason}));continue}const s=this.a.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;v.push(this.j({id:s.identifier,reason:n.reason}));continue}const i=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${p}'`),y=this.k(n,c.displayName,[],new b(o));return this.c.onExtensionActivationError(c.identifier,o,new F.$5E(p)),y}return this.k(n,c.displayName,v,null)}k(n,c,v,D){const p=new f(n.id,c,n.reason,v,D,this.c,this.g);return this.d.set(n.id,p),p}l(n){return M.$33b.isHostExtension(n,this.a,this.b)}m(n){const c=this.b.getExtensionDescription(n);return c?!c.main&&!c.browser:!1}};e.$Zbc=m,e.$Zbc=m=Ke([Ve(3,A.$7i)],m);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(n,c,v,D,p,r,s){this.c=n,this.d=c,this.f=v,this.g=D,this.h=p,this.j=r,this.k=s,this.a=new h.$Qg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let n=0;n<this.g.length;n++){const c=this.g[n];if(c.value&&!c.value.activationFailed){this.g.splice(n,1),n--;continue}if(c.value&&c.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);v.detail=c.value.activationFailedError,this.h=new b(v),this.j.onExtensionActivationError(this.c,v,null);return}}this.g.length>0&&await Promise.race(this.g.map(n=>n.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(n){const c=new Error;if(n&&n.name&&(c.name=n.name),n&&n.message?c.message=`Activating extension '${this.c.value}' failed: ${n.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${n}.`,n&&n.stack&&(c.stack=n.stack),this.h=new b(c),this.b&&w.$2(n))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(n)}}};f=Ke([Ve(6,A.$7i)],f)}),define(Ae[210],Re([1,0,156,23,2,5,6,192,13,7,16,18,8,50,21,125,26]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;function n(D,p){if((0,P.$wf)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let r;return Array.isArray(D.highlights)&&(r=D.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:D.label,highlights:r}}}class c extends A.$Qc{constructor(p,r,s){super(),this.f=p,this.g=r,this.h=s,this.a=new Map,this.b=new f.$x7;function i(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:o=>i(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>i(y)?this.r(y):y):o})}registerTreeDataProvider(p,r,s){const i=this.createTreeView(p,{treeDataProvider:r},s);return{dispose:()=>i.dispose()}}createTreeView(p,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],o=r.dragAndDropController?.dragMimeTypes??[],y=!!r.dragAndDropController?.handleDrag,$=!!r.dragAndDropController?.handleDrop,S=this.m(p,r,s),I={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:$,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(p,I),d={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,t.$8E)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,t.$8E)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(l){(0,b.$2j)(l)&&(0,t.$8E)(s,"treeViewMarkdownMessage"),S.message=l},get title(){return S.title},set title(l){S.title=l},get description(){return S.description},set description(l){S.description=l},get badge(){return S.badge},set badge(l){l!==void 0&&g.ViewBadge.isViewBadge(l)?S.badge={value:Math.floor(Math.abs(l.value)),tooltip:l.tooltip}:l===void 0&&(S.badge=void 0)},reveal:(l,R)=>S.reveal(l,R),dispose:async()=>{await u,this.a.delete(p),S.dispose()}};return this.B(d),d}$getChildren(p,r){const s=this.a.get(p);return s?s.getChildren(r):Promise.reject(new h.$hE(p))}async $handleDrop(p,r,s,i,o,y,$,S){const I=this.a.get(p);if(!I)return Promise.reject(new h.$hE(p));const u=a.DataTransfer.toDataTransfer(s,async d=>(await this.f.$resolveDropFileData(p,r,d)).buffer);return $===p&&S&&await this.j(u,I,S,o,y),I.onDrop(u,i,o)}async j(p,r,s,i,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach(($,S)=>{$&&p.set(S,$)});else if(o&&r.handleDrag){const $=r.handleDrag(s,p,i);this.b.addDragOperationTransfer(o,$),await $}return p}async $handleDrag(p,r,s,i){const o=this.a.get(p);if(!o)return Promise.reject(new h.$hE(p));const y=await this.j(new g.$1K,o,r,i,s);if(!(!y||i.isCancellationRequested))return a.DataTransfer.from(y)}async $hasResolve(p){const r=this.a.get(p);if(!r)throw new h.$hE(p);return r.hasResolve}$resolve(p,r,s){const i=this.a.get(p);if(!i)throw new h.$hE(p);return i.resolveTreeItem(r,s)}$setExpanded(p,r,s){const i=this.a.get(p);if(!i)throw new h.$hE(p);i.setExpanded(r,s)}$setSelectionAndFocus(p,r,s){const i=this.a.get(p);if(!i)throw new h.$hE(p);i.setSelectionAndFocus(r,s)}$setVisible(p,r){const s=this.a.get(p);if(!s){if(!r)return;throw new h.$hE(p)}s.setVisible(r)}$changeCheckboxState(p,r){const s=this.a.get(p);if(!s)throw new h.$hE(p);s.setCheckboxState(r)}m(p,r,s){const i=this.B(new v(p,r,this.f,this.g.converter,this.h,s));return this.a.set(p,i),i}r(p){const r=this.a.get(p.$treeViewId);return r&&"$treeItemHandle"in p?r.getExtensionElement(p.$treeItemHandle):r&&"$focusedTreeItem"in p&&p.$focusedTreeItem?r.focusedElement:null}}e.$zcc=c;class v extends A.$Qc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(p=>this.getExtensionElement(p)).filter(p=>!(0,P.$Ff)(p))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(p,r,s,i,o,y){if(super(),this.I=p,this.J=s,this.L=i,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$Ld),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$Ld),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$Ld),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$Ld),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$Ld),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$Ld),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$Ld),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$Vd,y.contributes&&y.contributes.views)for(const u in y.contributes.views)for(const d of y.contributes.views[u])d.id===p&&(this.P=d.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let $,S;const I=F.Event.debounce(this.F.event,(u,d)=>(u||(u={message:!1,elements:[]}),d.element!==!1&&($||($=new Promise(l=>S=l),this.G=this.G.then(()=>$)),Array.isArray(d.element)?u.elements.push(...d.element):u.elements.push(d.element)),d.message&&(u.message=!0),u),200,!0);this.B(I(({message:u,elements:d})=>{d.length&&(this.H=this.H.then(()=>{const l=S;return $=null,this.$(d).then(()=>l())})),u&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(p){const r=p?this.getExtensionElement(p):void 0;if(p&&!r)return this.M.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.X(p);return s||(s=await this.Y(r)),s?s.map(i=>i.item):void 0}getExtensionElement(p){return this.j.get(p)}reveal(p,r){r=r||{select:!0,focus:!1};const s=(0,P.$Ff)(r.select)?!0:r.select,i=(0,P.$Ff)(r.focus)?!1:r.focus,o=(0,P.$Ff)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.G.then(()=>this.S(p)).then(y=>this.W(p,y[y.length-1]).then($=>this.J.$reveal(this.I,{item:$.item,parentChain:y.map(S=>S.item)},{select:s,focus:i,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:s,focus:i,expand:o})}get message(){return this.O}set message(p){this.O=p,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(p){this.P=p,this.J.$setTitle(this.I,p,this.Q)}get description(){return this.Q}set description(p){this.Q=p,this.J.$setTitle(this.I,this.P,p)}get badge(){return this.R}set badge(p){this.R?.value===p?.value&&this.R?.tooltip===p?.tooltip||(this.R=a.ViewBadge.from(p),this.J.$setBadge(this.I,p))}setExpanded(p,r){const s=this.getExtensionElement(p);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(p,r){const s=!(0,k.$sb)(this.s,p);this.s=p;const i=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),i&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(p){p!==this.r&&(this.r=p,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(p){const r=(await Promise.all(p.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,r,s){const i=[];for(const o of p){const y=this.getExtensionElement(o);y&&i.push(y)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,r,s){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.g?.handleDrop))return(0,E.$Kg)(()=>this.g?.handleDrop?this.g.handleDrop(i,p,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(p);if(s){const i=this.m.get(s);if(i){const o=await this.f.resolveTreeItem(i.extensionItem,s,r)??i.extensionItem;return this.hb(o),i.item.tooltip=this.eb(o.tooltip),i.item.command=this.fb(i.disposableStore,o.command),i.item}}}S(p){return this.U(p).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}U(p){const r=this.m.get(p);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,E.$Kg)(()=>this.f.getParent(p))}W(p,r){const s=this.m.get(p);return s?Promise.resolve(s):(0,E.$Kg)(()=>this.f.getTreeItem(p)).then(i=>this.kb(p,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const o=this.getExtensionElement(i);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.N.identifier.value}`)}))}X(p){if(p){let r;if(typeof p=="string"){const s=this.getExtensionElement(p);r=s?this.m.get(s):void 0}else r=p;return r&&r.children||void 0}return this.h}async Y(p){this.rb(p);const r=new m.$Vd(this.Z.token);try{const s=p?this.m.get(p):void 0,i=await this.f.getChildren(p);if(r.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Fb)(i||[]).map(async y=>{const $=await this.f.getTreeItem(y);return $&&!r.token.isCancellationRequested?this.db(y,$,s):null}));return r.token.isCancellationRequested?void 0:(0,k.$Fb)(o)}finally{r.dispose()}}$(p){if(p.some(s=>!s))return this.Z.dispose(!0),this.Z=new m.$Vd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(p);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(p){const r=new Set,s=p.map(o=>this.m.get(o));for(const o of s)if(o&&!r.has(o.item.handle)){let y=o;for(;y&&y.parent&&s.findIndex($=>y&&y.parent&&$&&$.item.handle===y.parent.item.handle)===-1;){const $=this.j.get(y.parent.item.handle);y=$?this.m.get($):void 0}y&&!y.parent&&r.add(o.item.handle)}const i=[];return r.forEach(o=>{const y=this.j.get(o);if(y){const $=this.m.get(y);$&&(!$.parent||!r.has($.parent.item.handle))&&i.push(o)}}),i}bb(p){const r={};return Promise.all(p.map(s=>this.cb(s).then(i=>{i&&(r[s]=i.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(p){const r=this.getExtensionElement(p);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,E.$Kg)(()=>this.f.getTreeItem(r)).then(i=>{if(i){const o=this.ib(r,i,s.parent);return this.pb(r,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}db(p,r,s){const i=this.ib(p,r,s);if(r.id&&this.j.has(i.item.handle))throw new Error((0,w.localize)(0,null,r.id));return this.ob(p,i),this.qb(i,s),i}eb(p){return g.$xK.isMarkdownString(p)?a.MarkdownString.from(p):p}fb(p,r){return r?{...this.L.toInternal(r,p),originalId:r.command}:void 0}gb(p){if(p.checkboxState===void 0)return;let r,s,i;return typeof p.checkboxState=="number"?r=p.checkboxState:(r=p.checkboxState.state,s=p.checkboxState.tooltip,i=p.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:i}}hb(p){if(!g.$VK.isTreeItem(p,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(p,r,s){this.hb(r);const i=this.B(new A.$Pc),o=this.kb(p,r,s),y=this.lb(r);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:n(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(i,r.command),contextValue:r.contextValue,icon:y,iconDark:this.mb(r)||y,themeIcon:this.jb(r),collapsibleState:(0,P.$Ff)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}jb(p){return p.iconPath instanceof g.$4K?p.iconPath:void 0}kb(p,{id:r,label:s,resourceUri:i},o,y){if(r)return`${v.b}/${r}`;const $=n(s,this.N),S=o?o.item.handle:v.a;let I=$?$.label:i?(0,M.$qg)(i):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const u=this.m.has(p)?this.m.get(p).item.handle:void 0,d=this.X(o)||[];let l,R=0;do{if(l=`${S}/${R}:${I}`,y||!this.j.has(l)||u===l)break;R++}while(R<=d.length);return l}lb(p){if(p.iconPath&&!(p.iconPath instanceof g.$4K))return typeof p.iconPath=="string"||C.URI.isUri(p.iconPath)?this.nb(p.iconPath):this.nb(p.iconPath.light)}mb(p){if(p.iconPath&&!(p.iconPath instanceof g.$4K)&&p.iconPath.dark)return this.nb(p.iconPath.dark)}nb(p){return C.URI.isUri(p)?p:C.URI.file(p)}ob(p,r){this.j.set(r.item.handle,p),this.m.set(p,r)}pb(p,r,s,i){this.j.delete(r.item.handle),this.m.delete(p),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(p,r);const o=this.X(i)||[],y=o.filter($=>$.item.handle===s.item.handle)[0];y&&o.splice(o.indexOf(y),1,r)}qb(p,r){r?(r.children||(r.children=[]),r.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}rb(p){if(p){const r=this.m.get(p);if(r){if(r.children)for(const s of r.children){const i=this.j.get(s.item.handle);i&&this.sb(i)}r.children=void 0}}else this.tb()}sb(p){const r=this.m.get(p);if(r){if(r.children)for(const s of r.children){const i=this.j.get(s.item.handle);i&&this.sb(i)}this.m.delete(p),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(p=>p.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[211],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[212],Re([1,0,166,9,29,92,73,30,20,211,176,98]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=void 0;const a=h.$0m.as(A.$$m.JSONContribution);class b{constructor(p,r,s){this.a=p,this.b=r,this.c=s}d(p,r){this.a({type:p,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(C.default.Error,p)}warn(p){this.d(C.default.Warning,p)}info(p){this.d(C.default.Info,p)}}e.$VE=b;class m{static a(p){const r=new E.$Yl;for(let s=0,i=p.length;s<i;s++)r.add(p[s].description.identifier);return r}static compute(p,r){if(!p||!p.length)return new m(r,[]);if(!r||!r.length)return new m([],p);const s=this.a(p),i=this.a(r),o=r.filter($=>!s.has($.description.identifier)),y=p.filter($=>!i.has($.description.identifier));return new m(o,y)}constructor(p,r){this.added=p,this.removed=r}}e.$WE=m;class f{constructor(p,r){this.name=p,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=m.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,M.$Y)(p)}}}e.$XE=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},n="vscode://schemas/vscode-extensions";e.$YE={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$Wl},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$On}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$On}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const r=new f(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,r),p.activationEventsGenerator&&k.$ME.register(p.extensionPoint,p.activationEventsGenerator),e.$YE.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,a.registerSchema(n,e.$YE),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$ZE=c;const v={ExtensionsRegistry:"ExtensionsRegistry"};h.$0m.add(v.ExtensionsRegistry,new c),e.$1E=h.$0m.as(v.ExtensionsRegistry),a.registerSchema(n,e.$YE),a.registerSchema(P.$nj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[213],Re([1,0,163,16,24,212,32,5]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var g;(function(a){function b(m,f,t){if(!m)return;const n=M.$wf(m.type)?m.type:void 0;if(!n||n.length===0){t.error(w.localize(3,null));return}const c=[];if(Array.isArray(m.required))for(const v of m.required)M.$wf(v)&&c.push(v);return{extensionId:f.value,taskType:n,required:c,properties:m.properties?C.$Xm(m.properties):{},when:m.when?A.$Ki.deserialize(m.when):void 0}}a.from=b})(g||(g={}));const P=F.$1E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,b)=>{for(const m of a)m.type&&b.push(`onTaskType:${m.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:E}});class k{constructor(){this.d=new h.$Ld,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,m)=>{P.setHandler((f,t)=>{this.c=void 0;try{for(const n of t.removed){const c=n.value;for(const v of c)this.a&&v.type&&this.a[v.type]&&delete this.a[v.type]}for(const n of t.added){const c=n.value;for(const v of c){const D=g.from(v,n.description.identifier,n.collector);D&&(this.a[D.taskType]=D)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const m of this.all()){const f={type:"object",additionalProperties:!1};m.required.length>0&&(f.required=m.required.slice(0)),m.properties!==void 0?f.properties=C.$Xm(m.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[m.taskType]},b.push(f)}this.c={oneOf:b}}return this.c}}e.$IF=new k}),define(Ae[214],Re([1,0,164,16,23,24,32,213]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$SF=e.JsonSchemaVersion=e.ExecutionEngine=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$MF=e.ShellQuoting=e.$LF=e.$KF=e.$JF=void 0,e.$JF="settings",e.$KF=new A.$4i("taskRunning",!1,w.localize(0,null)),e.$LF={value:w.localize(1,null),original:"Tasks"};var E;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$MF="$customized",function(O){function N(ee){if(!ee)return O.Strong;switch(ee.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(E||(e.ShellQuoting=E={}));var g;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var P;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(P||(e.RevealKind=P={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(P||(e.RevealKind=P={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(k||(e.RevealProblemKind=k={}));var a;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(a||(e.PanelKind=a={})),function(O){function N(ee){switch(ee.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(a||(e.PanelKind=a={}));var b;(function(O){O.defaults={echo:!0,reveal:P.Always,revealProblems:k.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var m;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(O){function N(X){switch(X.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function ee(X){switch(X){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ee}(m||(e.RuntimeType=m={}));var f;(function(O){function N(ee){return M.$wf(ee)?ee:ee.value}O.value=N})(f||(e.CommandString=f={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(X){return X===O.Clean._id||X===O.Build._id||X===O.Rebuild._id||X===O.Test._id}O.is=N;function ee(X){if(X!==void 0)return M.$wf(X)?N(X)?{_id:X,isDefault:!1}:void 0:X}O.from=ee})(t||(e.TaskGroup=t={}));var n;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(n||(e.TaskScope=n={}));var c;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(ee){switch(ee){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(c||(e.TaskSourceKind=c={}));var v;(function(O){O.parallel="parallel",O.sequence="sequence"})(v||(e.DependsOrder=v={}));var D;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(D||(e.RunOnOptions=D={}));var p;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(p||(e.RunOptions=p={}));class r{constructor(N,ee,X,ye,De,Pe){this._label="",this._id=N,ee&&(this._label=ee),X&&(this.type=X),this.runOptions=ye,this.configurationProperties=De,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ee=!1){if(N===void 0)return!1;if(M.$wf(N))return N===this._label||N===this.configurationProperties.identifier||ee&&N===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$NF=r;class s extends r{constructor(N,ee,X,ye,De,Pe,Y,le){super(N,X,void 0,Y,le,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case m.Shell:ee="shell";break;case m.Process:ee="process";break;case m.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$JF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const X={type:e.$MF,folder:N,id:ee};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$qg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$OF=s;class i extends r{constructor(N,ee,X,ye,De,Pe,Y){super(N,X,ye,Pe,Y,ee),this._source=ee,this.configures=De}static is(N){return N instanceof i}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$qg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$JF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const X={type:e.$MF,folder:N,id:ee};return JSON.stringify(X)}}e.$PF=i;class o extends r{constructor(N,ee,X,ye,De,Pe,Y,le,Ee){super(N,X,ye,le,Ee,ee),this.defines=De,this.hasDefinedMatchers=Y,this.command=Pe,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$QF=o;class y extends r{constructor(N,ee,X,ye,De,Pe){super(N,X,ye,De,Pe,ee),this._source=ee}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new y(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$RF=y;var $;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(O){O._default=O.Terminal}($||(e.ExecutionEngine=$={}));var S;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class I{constructor(N){this.c=new Map;for(let ee=0;ee<N.length;ee++)this.c.set(N[ee].uri.toString(),ee)}compare(N,ee){const X=N.getWorkspaceFolder(),ye=ee.getWorkspaceFolder();if(X&&ye){let De=this.c.get(X.uri.toString());De=De===void 0?0:De+1;let Pe=this.c.get(ye.uri.toString());return Pe=Pe===void 0?0:Pe+1,De===Pe?N._label.localeCompare(ee._label):De-Pe}else return!X&&ye?-1:X&&!ye?1:0}}e.$SF=I;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u||(e.TaskEventKind=u={}));var d;(function(O){O.SingleRun="singleRun",O.Background="background"})(d||(e.TaskRunType=d={}));var l;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(l||(e.TaskRunSource=l={}));var R;(function(O){function N(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function ee(le,Ee,ce){return{...N(le),kind:"start",terminalId:Ee,resolvedVariables:ce}}O.start=ee;function X(le,Ee,ce){return{...N(le),kind:"processStarted",terminalId:Ee,processId:ce}}O.processStarted=X;function ye(le,Ee,ce){return{...N(le),kind:"processEnded",terminalId:Ee,exitCode:ce}}O.processEnded=ye;function De(le,Ee,ce){return{...N(le),kind:"terminated",exitReason:ce,terminalId:Ee}}O.terminated=De;function Pe(le,Ee,ce){return{...N(Ee),kind:le,terminalId:ce}}O.general=Pe;function Y(){return{kind:"changed"}}O.changed=Y})(R||(e.TaskEvent=R={}));var B;(function(O){function N(X){const ye=Object.keys(X).sort();let De="";for(const Pe of ye){let Y=X[Pe];Y instanceof Object?Y=N(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),De+=Pe+","+Y+","}return De}function ee(X){const De={_key:N(X),type:X.taskType};return Object.assign(De,X),De}O.create=ee})(B||(e.KeyedTaskIdentifier=B={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var W;(function(O){function N(ee,X){const ye=h.$IF.get(ee.type);if(ye===void 0){const le=F.$Xm(ee);return delete le._key,B.create(le)}const De=Object.create(null);De.type=ye.taskType;const Pe=new Set;ye.required.forEach(le=>Pe.add(le));const Y=ye.properties;for(const le of Object.keys(Y)){const Ee=ee[le];if(Ee!=null)De[le]=Ee;else if(Pe.has(le)){const ce=Y[le];if(ce.default!==void 0)De[le]=F.$Xm(ce.default);else switch(ce.type){case"boolean":De[le]=!1;break;case"number":case"integer":De[le]=0;break;case"string":De[le]="";break;default:X.error(w.localize(2,null,JSON.stringify(ee,void 0,0),le));return}}}return B.create(De)}O.createTaskIdentifier=N})(W||(e.TaskDefinition=W={}))}),define(Ae[215],Re([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93b=e.$83b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,h)=>{this.b=A,this.d=h,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$Y)(A))}then(A,h){return this.j().then(A,h)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$83b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new w.$3}}e.$93b=C}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=void 0;class w{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++w.count}}e.$fv=w;const M=[];function C(h){const E=new w(h);return M[E.nid]=E,E}e.$gv=C;function F(h){return M[h].sid}e.$hv=F;class A{constructor(E){this.value=E}}e.$iv=A}),define(Ae[3],Re([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$8J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$7J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var F;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var h;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(h||(e.WebviewMessageArrayBufferViewType=h={}));var E;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var P;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$7J=k;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var b;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var m;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$8J={MainThreadAuthentication:(0,w.$gv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$gv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$gv)("MainThreadChatProvider"),MainThreadChatAgents:(0,w.$gv)("MainThreadChatAgents"),MainThreadChatVariables:(0,w.$gv)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$gv)("MainThreadClipboard"),MainThreadCommands:(0,w.$gv)("MainThreadCommands"),MainThreadComments:(0,w.$gv)("MainThreadComments"),MainThreadConfiguration:(0,w.$gv)("MainThreadConfiguration"),MainThreadConsole:(0,w.$gv)("MainThreadConsole"),MainThreadDebugService:(0,w.$gv)("MainThreadDebugService"),MainThreadDecorations:(0,w.$gv)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$gv)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$gv)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$gv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$gv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$gv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$gv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$gv)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$gv)("MainThreadErrors"),MainThreadTreeViews:(0,w.$gv)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$gv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$gv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$gv)("MainThreadLanguages"),MainThreadLogger:(0,w.$gv)("MainThreadLogger"),MainThreadMessageService:(0,w.$gv)("MainThreadMessageService"),MainThreadOutputService:(0,w.$gv)("MainThreadOutputService"),MainThreadProgress:(0,w.$gv)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$gv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$gv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$gv)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$gv)("MainThreadSecretState"),MainThreadStorage:(0,w.$gv)("MainThreadStorage"),MainThreadTelemetry:(0,w.$gv)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$gv)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$gv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$gv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$gv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$gv)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$gv)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$gv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$gv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$gv)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$gv)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$gv)("MainThreadExtensionService"),MainThreadSCM:(0,w.$gv)("MainThreadSCM"),MainThreadSearch:(0,w.$gv)("MainThreadSearch"),MainThreadShare:(0,w.$gv)("MainThreadShare"),MainThreadTask:(0,w.$gv)("MainThreadTask"),MainThreadWindow:(0,w.$gv)("MainThreadWindow"),MainThreadLabelService:(0,w.$gv)("MainThreadLabelService"),MainThreadNotebook:(0,w.$gv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$gv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$gv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$gv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$gv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$gv)("MainThreadInteractive"),MainThreadChat:(0,w.$gv)("MainThreadChat"),MainThreadInlineChat:(0,w.$gv)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$gv)("MainThreadTheming"),MainThreadTunnelService:(0,w.$gv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$gv)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$gv)("MainThreadTimeline"),MainThreadTesting:(0,w.$gv)("MainThreadTesting"),MainThreadLocalization:(0,w.$gv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$gv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$gv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$gv)("MainThreadIssueReporter")},e.$9J={ExtHostCommands:(0,w.$gv)("ExtHostCommands"),ExtHostConfiguration:(0,w.$gv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$gv)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$gv)("ExtHostDebugService"),ExtHostDecorations:(0,w.$gv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$gv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$gv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$gv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$gv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$gv)("ExtHostEditors"),ExtHostTreeViews:(0,w.$gv)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$gv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$gv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$gv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$gv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$gv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$gv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$gv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$gv)("ExtHostStatusBar"),ExtHostShare:(0,w.$gv)("ExtHostShare"),ExtHostExtensionService:(0,w.$gv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$gv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$gv)("ExtHostTerminalService"),ExtHostSCM:(0,w.$gv)("ExtHostSCM"),ExtHostSearch:(0,w.$gv)("ExtHostSearch"),ExtHostTask:(0,w.$gv)("ExtHostTask"),ExtHostWorkspace:(0,w.$gv)("ExtHostWorkspace"),ExtHostWindow:(0,w.$gv)("ExtHostWindow"),ExtHostWebviews:(0,w.$gv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$gv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$gv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$gv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$gv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$gv)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$gv)("ExtHostProgress"),ExtHostComments:(0,w.$gv)("ExtHostComments"),ExtHostSecretState:(0,w.$gv)("ExtHostSecretState"),ExtHostStorage:(0,w.$gv)("ExtHostStorage"),ExtHostUrls:(0,w.$gv)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$gv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$gv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$gv)("ExtHostOutputService"),ExtHosLabelService:(0,w.$gv)("ExtHostLabelService"),ExtHostNotebook:(0,w.$gv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$gv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$gv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$gv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$gv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$gv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$gv)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$gv)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$gv)("ExtHostChat"),ExtHostChatAgents:(0,w.$gv)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$gv)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$gv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$gv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$gv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$gv)("ExtHostTheming"),ExtHostTunnelService:(0,w.$gv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$gv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$gv)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$gv)("ExtHostTimeline"),ExtHostTesting:(0,w.$gv)("ExtHostTesting"),ExtHostTelemetry:(0,w.$gv)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$gv)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$gv)("ExtHostIssueReporter")}}),define(Ae[216],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$8J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,h,E){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(A);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(h,E)??[]}getRelatedInformation(A,h,E){return this.c.$getAiRelatedInformation(h,E)}registerRelatedInformationProvider(A,h,E){const g=this.b;return this.b++,this.a.set(g,E),this.c.$registerAiRelatedInformationProvider(g,h),new M.$0J(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Adc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=e.$Dbc=void 0,e.$Dbc=(0,w.$Mh)("IExtHostApiDeprecationService");let A=class{constructor(E,g){this.c=g,this.a=new Set,this.b=E.getProxy(C.$8J.MainThreadTelemetry)}report(E,g,P){const k=this.d(E,g);this.a.has(k)||(this.a.add(k),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:E}))}d(E,g){return`${E}-${g.identifier.value}`}};e.$Ebc=A,e.$Ebc=A=Ke([Ve(0,F.$9L),Ve(1,M.$7i)],A),e.$Fbc=Object.freeze(new class{report(h,E,g){}})}),define(Ae[217],Re([1,0,5,3,7,20]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class A{constructor(g){this.b=new Map,this.c=[],this.d=new w.$Ld,this.onDidChangeSessions=this.d.event,this.f=new h,this.g=new h,this.a=g.getProxy(M.$8J.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,P,k,a={}){const b=F.$Xl.toKey(g.identifier),m=[...k].sort().join(" ");return await this.f.getOrCreate(`${b} ${P} ${m}`,async()=>{await this.a.$ensureProvider(P);const f=g.displayName||g.name;return this.a.$getSession(P,k,b,f,a)})}async getSessions(g,P,k){const a=F.$Xl.toKey(g.identifier),b=[...k].sort().join(" ");return await this.g.getOrCreate(`${a} ${b}`,async()=>{await this.a.$ensureProvider(P);const m=g.displayName||g.name;return this.a.$getSessions(P,k,a,m)})}async removeSession(g,P){const k=this.b.get(g);return k?k.provider.removeSession(P):this.a.$removeSession(g,P)}registerAuthenticationProvider(g,P,k,a){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:P,provider:k,options:a??{supportsMultipleAccounts:!1}}),this.c.find(m=>m.id===g)||this.c.push({id:g,label:P});const b=k.onDidChangeSessions(m=>{this.a.$sendDidChangeSessions(g,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this.a.$registerAuthenticationProvider(g,P,a?.supportsMultipleAccounts??!1),new C.$0J(()=>{b.dispose(),this.b.delete(g);const m=this.c.findIndex(f=>f.id===g);m>-1&&this.c.splice(m),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,P,k){const a=this.b.get(g);if(a)return Promise.resolve(a.provider.createSession(P,k));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,P){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,P){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return this.d.fire({provider:{id:g,label:P}}),Promise.resolve()}}e.$_cc=A;class h{constructor(){this.a=new Map}getOrCreate(g,P){const k=this.a.get(g);if(k)return k;const a=P().finally(()=>this.a.delete(g));return this.a.set(g,a),a}}}),define(Ae[218],Re([1,0,3,17,8]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;let F=class{constructor(h,E){this.a=h.getProxy(w.$8J.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>E.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(h,E,g){const P=C.WorkspaceEdit.from(h,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,g?.isRefactoring??!1)}};e.$fdc=F,e.$fdc=F=Ke([Ve(0,M.$9L)],F)}),define(Ae[219],Re([1,0,13,5,66,6,59,146,3,8]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class P{static{this.a=0}constructor(b,m){this.extension=b,this.provider=m,this.handle=P.a++}}class k{static{this.a=0}constructor(b,m){this.i=m,this.b=new Map,this.e=new Map,this.g=new M.$Ld,this.onDidPerformUserAction=this.g.event,this.h=b.getProxy(E.$8J.MainThreadChat)}registerChatProvider(b,m,f){const t=new P(b,f);return this.b.set(t.handle,t),this.h.$registerChatProvider(t.handle,m),(0,F.$Oc)(()=>{this.h.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,m){const f=C.Iterable.find(this.e.keys(),t=>this.e.get(t)===b)??0;typeof f=="number"&&this.h.$transferChatSession(f,m)}addChatRequest(b){this.h.$addRequest(b)}sendInteractiveRequestToProvider(b,m){this.h.$sendRequestToProvider(b,m)}async $prepareChat(b,m,f){const t=this.b.get(b);if(!t)return;const n=await t.provider.prepareSession(m,f);if(!n)return;const c=k.a++;return this.e.set(c,n),{id:c,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $resolveRequest(b,m,f,t){const n=this.b.get(b);if(!n)return;const c=this.e.get(m);if(!c||!n.provider.resolveRequest)return;const v=await n.provider.resolveRequest(c,f,t);if(v)return{message:typeof v.message=="string"?v.message:g.ChatReplyFollowup.from(v.message)}}async $provideWelcomeMessage(b,m){const f=this.b.get(b);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(m);if(t)return t.map(n=>typeof n=="string"?n:n.map(c=>g.ChatReplyFollowup.from(c)))}async $provideFollowups(b,m,f){const t=this.b.get(b);if(!t)return;const n=this.e.get(m);return!n||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(n,f))?.map(v=>g.ChatFollowup.from(v))}$removeRequest(b,m,f){const t=this.b.get(b);if(!t)return;const n=this.e.get(m);n&&t.provider.removeRequest&&t.provider.removeRequest(n,f)}async $provideReply(b,m,f,t){const n=this.b.get(b);if(!n)return;const c=this.e.get(m);if(!c)return;const v={session:c,message:typeof f.message=="string"?f.message:g.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))v.variables[o]=f.variables[o].map(g.ChatVariable.to);const D=A.$Hd.create(!1);let p;const r={report:o=>{if(!t.isCancellationRequested)if(typeof p>"u"&&(p=D.elapsed()),"responseId"in o)this.h.$acceptResponseProgress(b,m,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const y=Promise.all([this.h.$acceptResponseProgress(b,m,{placeholder:o.placeholder}),o.resolvedContent]);(0,w.$Gg)(y,t).then($=>{if(!$)return;const[S,I]=$;this.h.$acceptResponseProgress(b,m,I,S??void 0)})}else"content"in o?this.h.$acceptResponseProgress(b,m,{content:typeof o.content=="string"?o.content:g.MarkdownString.from(o.content)}):"documents"in o?this.h.$acceptResponseProgress(b,m,{documents:o.documents.map(y=>({uri:y.uri,version:y.version,ranges:y.ranges.map($=>g.Range.from($))}))}):this.h.$acceptResponseProgress(b,m,o)}};let s;try{s=await n.provider.provideResponseWithProgress(v,r,t),s||(s={errorDetails:{message:(0,h.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,h.localize)(1,null,o.message),responseIsIncomplete:!0}},this.i.error(o)}try{if(c.saveState&&this.e.has(m)){const o=c.saveState();this.h.$acceptChatState(m,o)}}catch(o){this.i.warn(o)}const i={firstProgress:p??0,totalElapsed:D.elapsed()};return{errorDetails:s.errorDetails,timings:i}}async $provideSlashCommands(b,m,f){const t=this.b.get(b);if(!t)return;const n=this.e.get(m);return!n||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(n,f))?.map(v=>({...v,kind:g.CompletionItemKind.from(v.kind)}))}$releaseSession(b){this.e.delete(b)}async $onDidPerformUserAction(b){this.g.fire(b)}}e.$tdc=k}),define(Ae[220],Re([1,0,13,6,72,3,8,7]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class E{static{this.a=0}constructor(k,a,b){this.d=a,this.e=b,this.b=new Map,this.c=k.getProxy(F.$8J.MainThreadChatAgents)}registerAgent(k,a,b,m){const f=E.a++;return this.b.set(f,{extension:k,agent:b}),this.c.$registerAgent(f,a,m),(0,M.$Oc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(k,a,b,m,f){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let n=!1;function c(){if(n)throw new Error("Only valid while executing the command")}const v=new w.$ah;f.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,v.p);const D=t.agent({role:h.ChatMessageRole.User,content:b},{history:m.history.map(A.ChatMessage.to)},new C.$Xu(p=>{c(),this.c.$handleProgressChunk(a,{content:g(p.message)?p.message:p.message.value})}),f);try{return await(0,w.$Gg)(Promise.resolve(D).then(p=>{if(p&&"followUp"in p)return{followUp:p?.followUp?.map(s=>A.ChatFollowup.from(s))}}),f)}finally{n=!0,v.complete()}}}e.$Cdc=E;function g(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[221],Re([1,0,6,3,8,72,20]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class h{static{this.a=1}constructor(g,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Zl,this.b=g.getProxy(M.$8J.MainThreadChatProvider)}registerProvider(g,P,k,a){const b=h.a++;return this.c.set(b,{extension:g,provider:k}),this.b.$registerProvider(b,P,{extension:g,displayName:a.name??g.value}),(0,w.$Oc)(()=>{this.b.$unregisterProvider(b),this.c.delete(b)})}async $provideChatResponse(g,P,k,a,b){const m=this.c.get(g);if(!m)return;const f=new F.$Xu(async t=>{if(b.isCancellationRequested){this.d.warn(`[CHAT](${m.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return m.provider.provideChatResponse(k.map(C.ChatMessage.to),a,f,b)}allowListExtensionWhile(g,P){this.f.set(g,P),P.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,P){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k.f.has(g)},async makeRequest(a,b,m,f){if(!k.f.has(g))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;k.e.set(t,m);try{await k.b.$fetchResponse(g,P,t,a.map(C.ChatMessage.from),b,f)}finally{k.e.delete(t)}}}}async $handleResponseFragment(g,P){this.e.get(g)?.report(P)}}e.$ydc=h}),define(Ae[222],Re([1,0,6,3,9,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(M.$8J.MainThreadChatVariables)}async $resolveVariable(E,g,P){const k=this.b.get(E);if(k)try{const a=await k.resolver.resolve(k.data.name,{message:g},P);if(a)return a.map(F.ChatVariable.from)}catch(a){(0,C.$Z)(a)}}registerVariableResolver(E,g,P,k){const a=A.a++;return this.b.set(a,{extension:E.identifier,data:{name:g,description:P},resolver:k}),this.c.$registerVariable(a,{name:g,description:P}),(0,w.$Oc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$zdc=A}),define(Ae[223],Re([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;class M{constructor(F){const A=F.getProxy(w.$8J.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(h){return A.$writeText(h)}})}}e.$Ibc=M}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,68,44,278,2,6,4,17,104,25,46,41,59,53,58]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=void 0;let s=class{#e;#t;#i;constructor(I,u,d){this.b=new Map,this.c=new Map,this.#e=I.getProxy(A.$8J.MainThreadCommands),this.d=u,this.#i=d,this.#t=I.getProxy(A.$8J.MainThreadTelemetry),this.converter=new i(this,l=>{const R=this.c.get(l);return R?.result===y.Void?R:void 0},u),this.f=[{processArgument(l){return(0,g.$jh)(l)}},{processArgument(l){return(0,F.$Zm)(l,function(R){if(P.$ms.isIRange(R))return C.Range.to(R);if(k.$ls.isIPosition(R))return C.Position.to(R);if(P.$ms.isIRange(R.range)&&a.URI.isUri(R.uri))return C.location.to(R);if(R instanceof n.$_d)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const u=this.registerCommand(!1,I.id,async(...d)=>{const l=I.args.map((B,V)=>{if(!B.validate(d[V]))throw new Error(`Invalid argument '${B.name}' when running '${I.id}', received: ${typeof d[V]=="object"?JSON.stringify(d[V],null,"	"):d[V]} `);return B.convert(d[V])}),R=await this.executeCommand(I.internalId,...l);return I.result.convert(R,d,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new M.$0J(()=>{u.dispose(),this.c.delete(I.id)})}registerCommand(I,u,d,l,R,B){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:d,thisArg:l,description:R,extension:B}),I&&this.#e.$registerCommand(u),new M.$0J(()=>{this.b.delete(u)&&I&&this.#e.$unregisterCommand(u)})}executeCommand(I,...u){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,u,!0)}async g(I,u,d){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,u,!1);{let l=!1;const R=(0,F.$Zm)(u,function(B){if(B instanceof M.$$J)return C.Position.from(B);if(B instanceof M.$_J)return C.Range.from(B);if(B instanceof M.$jK)return C.location.from(B);if(M.$uL.isNotebookRange(B))return C.NotebookRange.from(B);if(B instanceof ArrayBuffer)return l=!0,n.$_d.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return l=!0,n.$_d.wrap(B);if(B instanceof n.$_d)return l=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(I,l?new c.$iv(R):R,d);return(0,g.$jh)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(I,u,!1);throw B}}}async h(I,u,d){const l=this.b.get(I);if(!l)throw new Error("Unknown command");const{callback:R,thisArg:B,description:V}=l;if(V)for(let W=0;W<V.args.length;W++)try{(0,w.$Nf)(u[W],V.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed.Illegal argument '${V.args[W].name}' - ${V.args[W].description} `)}const j=D.$Hd.create();try{return await R.apply(B,u)}catch(W){if(I===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...u);O&&(I=O.command)}if(this.d.error(W,I,l.extension?.identifier),!d)throw W;if(l.extension?.identifier){const O=this.#i.onExtensionError(l.extension.identifier,W);this.d.trace("forwarded error to extension?",O,l.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.$xi)(W)),this.id=I,this.source=l.extension?.displayName??l.extension?.name}}}finally{this.j(l,I,j.elapsed())}}j(I,u,d){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new p.$bo(u),duration:d})}$executeContributedCommand(I,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const d=this.b.get(I);return d?(u=u.map(l=>this.f.reduce((R,B)=>B.processArgument(R,d.extension?.identifier),l)),this.h(I,u,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(u=>(I&&(u=u.filter(d=>d[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const I=Object.create(null);for(const[u,d]of this.b){const{description:l}=d;l&&(I[u]=l)}return Promise.resolve(I)}};e.$rM=s,e.$rM=s=Ke([Ve(0,f.$9L),Ve(1,E.$7i),Ve(2,r.$qM)],s),e.$sM=(0,m.$Mh)("IExtHostCommands");class i{constructor(I,u,d){this.d=I,this.f=u,this.g=d,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,u){if(!I)return;const d={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return d;const l=this.f(I.command);if(l)d.id=l.internalId,d.arguments=l.args.map((R,B)=>R.convert(I.arguments&&I.arguments[B]));else if((0,h.$Jb)(I.arguments)){const R=`${I.command} /${++this.c}`;this.b.set(R,I),u.add((0,b.$Oc)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),d.$ident=R,d.id=this.delegatingCommandId,d.arguments=[R],this.g.trace("CommandsConverter#CREATE",I.command,R)}return d}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const u=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$tM=i;class o{static{this.Uri=new o("uri","Uri of a text document",I=>a.URI.isUri(I),I=>I)}static{this.Position=new o("position","A position in a text document",I=>M.$$J.isPosition(I),C.Position.from)}static{this.Range=new o("range","A range in a text document",I=>M.$_J.isRange(I),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",I=>M.$aK.isSelection(I),C.Selection.from)}static{this.Number=new o("number","",I=>typeof I=="number",I=>I)}static{this.String=new o("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=o.Arr(o.String)}static Arr(I){return new o(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,u=>Array.isArray(u)&&u.every(d=>I.validate(d)),u=>u.map(d=>I.convert(d)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",I=>I instanceof M.$tK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",I=>I instanceof M.$NL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",I=>I instanceof t.$jM,C.TestItem.from)}constructor(I,u,d,l){this.name=I,this.description=u,this.validate=d,this.convert=l}optional(){return new o(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,u){return new o(I??this.name,u??this.description,this.validate,this.convert)}}e.$uM=o;class y{static{this.Void=new y("no result",I=>I)}constructor(I,u){this.description=I,this.convert=u}}e.$vM=y;class ${constructor(I,u,d,l,R){this.id=I,this.internalId=u,this.description=d,this.args=l,this.result=R}}e.$wM=$}),define(Ae[224],Re([1,0,18,12,2,78,91,32,95,31,8,7]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;const a=[new g.$wM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of DocumentHighlight-instances.",m(P.DocumentHighlight.to))),new g.$wM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$uM.Uri],new g.$vM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,n)=>{if((0,w.$Ib)(t))return;class c extends k.$oK{static to(D){const p=new c(D.name,P.SymbolKind.to(D.kind),D.containerName||"",new k.$jK(n[0],P.Range.to(D.range)));return p.detail=D.detail,p.range=p.location.range,p.selectionRange=P.Range.to(D.selectionRange),p.children=D.children?D.children.map(c.to):[],p}}return t.map(c.to)})),new g.$wM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$uM.Uri,new g.$uM("options","Formatting options",t=>!0,t=>t)],new g.$vM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$wM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$uM.Uri,g.$uM.Range,new g.$uM("options","Formatting options",t=>!0,t=>t)],new g.$vM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$wM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$uM.Uri,g.$uM.Position,new g.$uM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$uM("options","Formatting options",t=>!0,t=>t)],new g.$vM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$wM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$wM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$wM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$wM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$wM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of Location-instances.",m(P.location.to))),new g.$wM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of Hover-instances.",m(P.Hover.to))),new g.$wM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$uM.Uri,new g.$uM("position","A position in a text document",t=>Array.isArray(t)&&t.every(n=>k.$$J.isPosition(n)),t=>t.map(P.Position.from))],new g.$vM("A promise that resolves to an array of ranges.",t=>t.map(n=>{let c;for(const v of n.reverse())c=new k.$sK(P.Range.to(v),c);return c}))),new g.$wM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$uM.String.with("query","Search string")],new g.$vM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new g.$wM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new g.$wM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$uM.CallHierarchyItem],new g.$vM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new g.$wM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$uM.CallHierarchyItem],new g.$vM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new g.$wM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new g.$wM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$uM.Uri,g.$uM.Position,g.$uM.String.with("newName","The new symbol name")],new g.$vM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new g.$wM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$uM.Uri,g.$uM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$vM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new g.$wM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$uM.Uri],new g.$vM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$mL(t.tokenTypes,t.tokenModifiers)})),new g.$wM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$uM.Uri],new g.$vM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,A.$I0)(t);if(n.type==="full")return new k.$oL(n.data,void 0)})),new g.$wM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$uM.Uri,g.$uM.Range.optional()],new g.$vM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$mL(t.tokenTypes,t.tokenModifiers)})),new g.$wM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$uM.Uri,g.$uM.Range],new g.$vM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,A.$I0)(t);if(n.type==="full")return new k.$oL(n.data,void 0)})),new g.$wM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$uM.Uri,g.$uM.Position,g.$uM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$uM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$vM("A promise that resolves to a CompletionList-instance.",(t,n,c)=>{if(!t)return new k.$EK([]);const v=t.suggestions.map(D=>P.CompletionItem.to(D,c));return new k.$EK(v,t.incomplete)})),new g.$wM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$uM.Uri,g.$uM.Position,g.$uM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$vM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new g.$wM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$uM.Uri,g.$uM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$vM("A promise that resolves to an array of CodeLens-instances.",(t,n,c)=>m(v=>new k.$wK(P.Range.to(v.range),v.command&&c.fromInternal(v.command)))(t))),new g.$wM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$uM.Uri,new g.$uM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$_J.isRange(t),t=>k.$aK.isSelection(t)?P.Selection.from(t):P.Range.from(t)),g.$uM.String.with("kind","Code action kind to return code actions for").optional(),g.$uM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$vM("A promise that resolves to an array of Command-instances.",(t,n,c)=>m(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(v.command)}else{const D=new k.$qK(v.title,v.kind?new k.$rK(v.kind):void 0);return v.edit&&(D.edit=P.WorkspaceEdit.to(v.edit)),v.command&&(D.command=c.fromInternal(v.command)),D.isPreferred=v.isPreferred,D}})(t))),new g.$wM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$uM.Uri],new g.$vM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(n=>new k.$KK(P.Range.to(n.range),P.Color.to(n.color))):[])),new g.$wM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$uM("color","The color to show and insert",t=>t instanceof k.$JK,P.Color.from),new g.$uM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new g.$vM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new g.$wM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$uM.Uri,g.$uM.Range],new g.$vM("A promise that resolves to an array of Inlay objects",(t,n,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new g.$wM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$uM.Uri],new g.$vM("A promise that resolves to an array of FoldingRange objects",(t,n)=>{if(t)return t.map(P.FoldingRange.to)})),new g.$wM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$vM("A promise that resolves to an array of NotebookContentProvider static info objects.",m(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(n=>P.NotebookExclusiveDocumentPattern.to(n))})))),new g.$wM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$uM.Uri,g.$uM.Range,new g.$uM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$_J,t=>P.InlineValueContext.from(t))],new g.$vM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new g.$wM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$uM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,E.$2T)(t,M.Schemas.http,M.Schemas.https),t=>t),new g.$uM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),g.$uM.String.with("label","").optional()],g.$vM.Void),new g.$wM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$uM.Uri.with("resource","Resource to open"),g.$uM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.$uM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],g.$vM.Void),new g.$wM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$uM.Uri.with("left","Left-hand side resource of the diff editor"),g.$uM.Uri.with("right","Right-hand side resource of the diff editor"),g.$uM.String.with("title","Human readable title for the diff editor").optional(),new g.$uM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],g.$vM.Void),new g.$wM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$uM.Uri,g.$uM.Position],new g.$vM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$wM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$uM.TypeHierarchyItem],new g.$vM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$wM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$uM.TypeHierarchyItem],new g.$vM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$wM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$uM.TestItem],g.$vM.Void),new g.$wM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$uM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$vM.Void),new g.$wM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$uM.String.with("name","The context key name"),new g.$uM("value","The context key value",()=>!0,t=>t)],g.$vM.Void),new g.$wM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$uM.Uri,g.$uM.StringArray,new g.$uM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new g.$vM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class b{static register(n){a.forEach(n.registerApiCommand,n),this.a(n)}static a(n){n.registerCommand(!1,"_validateWhenClauses",h.$Li)}}e.$Hbc=b;function m(t){return n=>{if(Array.isArray(n))return n.map(t)}}function f(t){if(!Array.isArray(t))return;const n=[];for(const c of t)F.$0s(c)?n.push(P.DefinitionLink.to(c)):n.push(P.location.to(c));return n}}),define(Ae[225],Re([1,0,13,65,5,6,2,78,20,8,7,3,26]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;function b(m,f,t){const n=m.getProxy(k.$8J.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$Zl,f.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===6){const S=this.b.get($.handle);return S?S.value:$}else if($&&$.$mid===7){const S=this.b.get($.commentControlHandle);if(!S)return $;const I=S.getCommentThread($.commentThreadHandle);return I?I.value:$}else if($&&($.$mid===9||$.$mid===8)){const S=this.b.get($.thread.commentControlHandle);if(!S)return $;const I=S.getCommentThread($.thread.commentThreadHandle);return I?$.$mid===8?I.value:{thread:I.value,text:$.text}:$}else if($&&$.$mid===10){const S=this.b.get($.thread.commentControlHandle);if(!S)return $;const I=S.getCommentThread($.thread.commentThreadHandle);if(!I)return $;const u=$.commentUniqueId,d=I.getCommentByUniqueId(u);return d||$}else if($&&$.$mid===11){const S=this.b.get($.thread.commentControlHandle);if(!S)return $;const I=S.getCommentThread($.thread.commentThreadHandle);if(!I)return $;const u=$.text,d=$.commentUniqueId,l=I.getCommentByUniqueId(d);return l?(typeof l.body=="string"?l.body=u:l.body=new P.$xK(u),l):$}return $}})}createCommentController($,S,I){const u=c.a++,d=new D($,u,S,I);this.b.set(d.handle,d);const l=this.c.get($.identifier)||[];return l.push(d),this.c.set($.identifier,l),d.value}$createCommentThreadTemplate($,S,I){const u=this.b.get($);u&&u.$createCommentThreadTemplate(S,I)}async $updateCommentThreadTemplate($,S,I){const u=this.b.get($);u&&u.$updateCommentThreadTemplate(S,I)}$deleteCommentThread($,S){this.b.get($)?.$deleteCommentThread(S)}$provideCommentingRanges($,S,I){const u=this.b.get($);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const d=t.getDocument(A.URI.revive(S));return(0,w.$Kg)(async()=>{const l=await u.commentingRangeProvider.provideCommentingRanges(d,I);let R;return Array.isArray(l)?R={ranges:l,fileComments:!1}:l?R={ranges:l.ranges||[],fileComments:l.fileComments||!1}:R=l??void 0,R}).then(l=>{let R;return l&&(R={ranges:l.ranges.map(B=>g.Range.from(B)),fileComments:l.fileComments}),R})}$toggleReaction($,S,I,u,d){const l=this.b.get($);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,w.$Kg)(()=>{const R=l.getCommentThread(S);if(R){const B=R.getCommentByUniqueId(u.uniqueIdInThread);if(l!==void 0&&B&&l.reactionHandler)return l.reactionHandler(B,s(d))}return Promise.resolve(void 0)})}}class v{static{this.a=0}set threadId($){this.n=$}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range($){($===void 0!=(this.p===void 0)||!$||!this.p||!$.isEqual(this.p))&&(this.p=$,this.b.range=$,this.c.fire())}get range(){return this.p}set canReply($){this.d!==$&&(this.d=$,this.b.canReply=$,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label($){this.e=$,this.b.label=$,this.c.fire()}get contextValue(){return this.f}set contextValue($){this.f=$,this.b.contextValue=$,this.c.fire()}get comments(){return this.q}set comments($){this.q=$,this.b.comments=$,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState($){this.g=$,this.b.collapsibleState=$,this.c.fire()}get state(){return this.h}set state($){this.h=$,this.b.state=$,this.c.fire()}get isDisposed(){return this.j}constructor($,S,I,u,d,l,R,B){this.m=S,this.n=I,this.o=u,this.p=d,this.q=l,this.extensionDescription=R,this.r=B,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Ld,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Rc,this.l.value=new F.$Pc,this.n===void 0&&(this.n=`${$}.${this.handle}`),n.$createCommentThread(S,this.handle,this.n,this.o,g.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l,this.i.push({dispose:()=>{n.$deleteCommentThread(S,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(j){V.range=j},get comments(){return V.comments},set comments(j){V.comments=j},get collapsibleState(){return V.collapsibleState},set collapsibleState(j){V.collapsibleState=j},get canReply(){return V.canReply},set canReply(j){V.canReply=j},get contextValue(){return V.contextValue},set contextValue(j){V.contextValue=j},get label(){return V.label},set label(j){V.label=j},get state(){return V.state},set state(j){V.state=j},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Pc);const $=I=>Object.prototype.hasOwnProperty.call(this.b,I),S={};$("range")&&(S.range=g.Range.from(this.p)),$("label")&&(S.label=this.label),$("contextValue")&&(S.contextValue=this.contextValue??null),$("comments")&&(S.comments=this.q.map(I=>p(this,I,this.k,this.extensionDescription))),$("collapsibleState")&&(S.collapseState=i(this.g)),$("canReply")&&(S.canReply=this.canReply),$("state")&&(S.state=o(this.h)),$("isTemplate")&&(S.isTemplate=this.r),this.b={},n.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId($){for(const S of this.k){const I=S[0],u=S[1];if($===u)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach($=>$.dispose())}}Ke([(0,M.$fh)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class D{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider($){this.b=$,n.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler($){this.c=$,n.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!$})}get options(){return this.d}set options($){this.d=$,n.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor($,S,I,u){this.f=$,this.g=S,this.h=I,this.i=u,this.a=new Map,n.$registerCommentController(this.handle,I,u,this.f.identifier.value);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(l){d.options=l},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(l){d.commentingRangeProvider=l},get reactionHandler(){return d.reactionHandler},set reactionHandler(l){d.reactionHandler=l},createCommentThread(l,R,B){return d.createCommentThread(l,R,B).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{n.$unregisterCommentController(this.handle)}})}createCommentThread($,S,I){S===void 0&&(0,a.$8E)(this.f,"fileComments");const u=new v(this.id,this.handle,void 0,$,S,I,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate($,S){const I=new v(this.id,this.handle,void 0,A.URI.revive($),g.Range.to(S),[],this.f,!0);return I.collapsibleState=h.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate($,S){const I=this.a.get($);I&&(I.range=g.Range.to(S))}$deleteCommentThread($){this.a.get($)?.dispose(),this.a.delete($)}getCommentThread($){return this.a.get($)}dispose(){this.a.forEach($=>{$.dispose()}),this.e.forEach($=>$.dispose())}}function p(y,$,S,I){let u=S.get($);return u||(u=++y.commentHandle,S.set($,u)),$.state!==void 0&&(0,a.$8E)(I,"commentsDraftState"),{mode:$.mode,contextValue:$.contextValue,uniqueIdInThread:u,body:typeof $.body=="string"?$.body:g.MarkdownString.from($.body),userName:$.author.name,userIconPath:$.author.iconPath,label:$.label,commentReactions:$.reactions?$.reactions.map(d=>r(d)):void 0,state:$.state,timestamp:$.timestamp?.toJSON()}}function r(y){return{label:y.label,iconPath:y.iconPath?g.$8L(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function s(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?A.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function i(y){if(y!==void 0)switch(y){case P.CommentThreadCollapsibleState.Expanded:return h.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return h.CommentThreadCollapsibleState.Collapsed}return h.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case P.CommentThreadState.Unresolved:return h.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return h.CommentThreadState.Resolved}return h.CommentThreadState.Unresolved}return new c}e.$Jbc=b}),define(Ae[226],Re([1,0,24,3,27,17]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;let A=class{constructor(P,k){this.a=P.getProxy(M.$8J.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,k){const a=this,b=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){a.e(P,k,b,arguments)}})}e(P,k,a,b){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:E(b,this.b)}),this.c&&this.f(P,a,b)}};e.$Fdc=A,e.$Fdc=A=Ke([Ve(0,F.$9L),Ve(1,C.$mM)],A);const h=1e5;function E(g,P){const k=[];if(g.length)for(let a=0;a<g.length;a++){let b=g[a];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}k.push(b)}if(P){const a=new Error().stack;a&&k.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,w.$3m)(k);return a.length>h?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=void 0;let b=class{static{a=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(M.$8J.MainThreadDecorations)}registerFileDecorationProvider(f,t){const n=a.c++;this.f.set(n,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(n,t.identifier.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(n,null);return}const D=(0,E.$1b)(v);if(D.length<=a.d){this.g.$onDidChange(n,D);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,D.length);const p=D.map(i=>({uri:i,rank:(0,g.$Ee)(i.path,"/")})),r=(0,E.$xb)(p,(i,o)=>i.rank-o.rank||(0,g.$Se)(i.uri.path,o.uri.path)),s=[];e:for(const i of r){let o;for(const y of i){const $=(0,P.$kc)(y.uri.path);if(o!==$&&(o=$,s.push(y.uri)>=a.d))break e}}this.g.$onDidChange(n,s)});return new C.$0J(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(f,t,n){if(!this.f.has(f))return Object.create(null);const c=Object.create(null),{provider:v,extensionDescription:D}=this.f.get(f);return await Promise.all(t.map(async p=>{try{const{uri:r,id:s}=p,i=await Promise.resolve(v.provideFileDecoration(w.URI.revive(r),n));if(!i)return;try{C.$sL.validate(i),i.badge&&typeof i.badge!="string"&&(0,k.$8E)(D,"codiconDecoration"),c[s]=[i.propagate,i.tooltip,i.badge,i.color]}catch(o){this.h.warn(`INVALID decoration from extension '${D.identifier.value}': ${o}`)}}catch(r){this.h.error(r)}})),c}};e.$Kcc=b,e.$Kcc=b=a=Ke([Ve(0,A.$9L),Ve(1,h.$7i)],b),e.$Lcc=(0,F.$Mh)("IExtHostDecorations")}),define(Ae[227],Re([1,0,147,94,2,3,7,8,5,14,28,39]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0;class b{#e;#t;#i;constructor(t,n,c,v,D,p,r,s){this.d=t,this.e=n,this.f=c,this.g=v,this.h=D,this.c=!1,this.f=Math.max(v,c),this.#i=new P.$yc(i=>p.getComparisonKey(i)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,n){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!n){this.delete(t);return}this.#i.set(t,n.slice()),c=[t]}else if(Array.isArray(t)){c=[];let p;t=[...t].sort(b.k);for(const r of t){const[s,i]=r;if((!p||s.toString()!==p.toString())&&(p&&this.#i.get(p).length===0&&this.#i.delete(p),p=s,c.push(s),this.#i.set(s,[])),i)this.#i.get(s)?.push(...i);else{const o=this.#i.get(s);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const v=[];let D=0;for(const p of c){let r=[];const s=this.#i.get(p);if(s)if(s.length>this.g){r=[];const i=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const y of s)if(y.severity===i[o]&&r.push({...h.Diagnostic.from(y),modelVersionId:this.h(p)})===this.g)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,w.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(i=>({...h.Diagnostic.from(i),modelVersionId:this.h(p)}));if(v.push([p,r]),D+=r.length,D>this.f)break}this.#e.$changeMany(this.e,v)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,n){this.j();for(const[c,v]of this)t.call(n,c,v,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const n=this.#i.get(t);return Array.isArray(n)?Object.freeze(n.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,n){return t[0].toString()<n[0].toString()?-1:t[0].toString()>n[0].toString()?1:0}}e.$Bbc=b;let m=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const n=new P.$yc;for(const c of t)n.set(c,c);return{uris:Object.freeze(Array.from(n.values()))}}constructor(t,n,c,v){this.j=n,this.k=c,this.l=v,this.g=new Map,this.h=new E.$Pd({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,a._mapper),this.f=t.getProxy(F.$8J.MainThreadDiagnostics)}createDiagnosticCollection(t,n){const{g:c,f:v,h:D,j:p,k:r,l:s}=this,i=new class{$changeMany($,S){v.$changeMany($,S),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,$,S.length===0?"CLEARING":S)}$clear($){v.$clear($),p.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,$)}dispose(){v.dispose()}};let o;if(!n)n="_generated_diagnostic_collection_name_#"+a.c++,o=n;else if(!c.has(n))o=n;else{this.j.warn(`DiagnosticCollection with name '${n}' does already exist.`);do o=n+a.c++;while(c.has(o))}return new class extends b{constructor(){super(n,o,a.e,a.d,$=>s.getDocument($)?.version,r.extUri,i,D),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const n=new Map,c=[];for(const v of this.g.values())v.forEach((D,p)=>{let r=n.get(D.toString());typeof r>"u"&&(r=c.length,n.set(D.toString(),r),c.push([D,[]])),c[r][1]=c[r][1].concat(...p)});return c}}m(t){let n=[];for(const c of this.g.values())c.has(t)&&(n=n.concat(c.get(t)));return n}$acceptMarkersChange(t){if(!this.n){const n="_generated_mirror",c=new b(n,n,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,v=>{},this.k.extUri,void 0,this.h);this.g.set(n,c),this.n=c}for(const[n,c]of t)this.n.set(C.URI.revive(n),c.map(h.Diagnostic.to))}};e.$Cbc=m,e.$Cbc=m=a=Ke([Ve(1,g.$7i),Ve(2,k.$Abc)],m)}),define(Ae[228],Re([1,0,2,3,26]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class F{constructor(h){this.a=h.getProxy(M.$8J.MainThreadDialogs)}showOpenDialog(h,E){return E?.allowUIResources&&(0,C.$8E)(h,"showLocal"),this.a.$showOpenDialog(E).then(g=>g?g.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(h){return this.a.$showSaveDialog(h).then(E=>E?w.URI.revive(E):void 0)}}e.$Rbc=F}),define(Ae[229],Re([1,0,9,2,7,3,12,21,15]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class g{static{this.a=0}constructor(k,a,b){this.d=a,this.e=b,this.b=new Map,this.c=k.getProxy(F.$8J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const b=g.a++;this.b.set(b,a),this.c.$registerTextContentProvider(b,k);let m;return typeof a.onDidChange=="function"&&(m=a.onDidChange(f=>{if(f.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(b,f).then(t=>{if(!t&&typeof t!="string")return;const n=this.d.getDocument(f);if(!n)return;const c=(0,E.$Ne)(t);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(f,t)},w.$Y)})),new C.$0J(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(k,a){const b=this.b.get(k);return b?Promise.resolve(b.provideTextDocumentContent(M.URI.revive(a),h.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$Sbc=g}),define(Ae[230],Re([1,0,5,6,2,3,100,8,16,24,7,9]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;class a{constructor(m,f){this.a=new w.$Ld({onListenerError:k.$Z}),this.b=new w.$Ld({onListenerError:k.$Z}),this.c=new w.$Ld({onListenerError:k.$Z}),this.d=new w.$Ld({onListenerError:k.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Pc,this.h=new Map,this.f=m.getProxy(F.$8J.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const n of t)this.b.fire(n.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const n of t)this.a.fire(n.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(m){if(!m)return;const f=this.g.getDocument(m);if(f)return f}getDocument(m){const f=this.getDocumentData(m);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return f.document}ensureDocumentData(m){const f=this.g.getDocument(m);if(f)return Promise.resolve(f);let t=this.h.get(m.toString());return t||(t=this.f.$tryOpenDocument(m).then(n=>{this.h.delete(m.toString());const c=C.URI.revive(n);return(0,E.$Hf)(this.g.getDocument(c))},n=>(this.h.delete(m.toString()),Promise.reject(n))),this.h.set(m.toString(),t)),t}createDocumentData(m){return this.f.$tryCreateDocument(m).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged(m,f){const t=C.URI.revive(m),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");this.b.fire(n.document),n._acceptLanguageId(f),this.a.fire(n.document)}$acceptModelSaved(m){const f=C.URI.revive(m),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(m,f){const t=C.URI.revive(m),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(f),this.c.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,f,t){const n=C.URI.revive(m),c=this.g.getDocument(n);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(f);let v;f.isUndoing?v=P.TextDocumentChangeReason.Undo:f.isRedoing&&(v=P.TextDocumentChangeReason.Redo),this.c.fire((0,g.$Ym)({document:c.document,contentChanges:f.changes.map(D=>({range:h.Range.to(D.range),rangeOffset:D.rangeOffset,rangeLength:D.rangeLength,text:D.text})),reason:v}))}setWordDefinitionFor(m,f){(0,A.$$L)(m,f)}}e.$ybc=a}),define(Ae[60],Re([1,0,51,5,6,2,4,3,100,17,105,8,14,28,12,66,48]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=void 0;class n{constructor(D){this.value=D,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(D,p){this.h=D,this.i=p,this.a=null,this.b=new Map,this.c=new b.$yc,this.d=new M.$Ld,this.e=new M.$Ld,this.f=new M.$Ld,this.g=new M.$Ld,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const p=[],r=[],s=[];if(D.removedDocuments)for(const i of D.removedDocuments){const o=F.URI.revive(i),y=this.c.get(o);y?.unref()&&(this.c.delete(o),p.push(y.value))}if(D.addedDocuments)for(const i of D.addedDocuments){const o=F.URI.revive(i.uri);let y=this.c.get(o);if(y&&o.scheme!==m.Schemas.vscodeNotebookCell&&o.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new n(new E.$_L(this.h.getProxy(h.$8J.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(o,y),r.push(y.value)),y.ref()}if(D.removedEditors)for(const i of D.removedEditors){const o=this.b.get(i);this.b.delete(i),o&&s.push(o)}if(D.addedEditors)for(const i of D.addedEditors){const o=F.URI.revive(i.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const y=this.c.get(o).value,$=new P.$fM(i.id,this.h.getProxy(h.$8J.MainThreadTextEditors),this.i,new t.$T(()=>y.document),i.selections.map(k.Selection.to),i.options,i.visibleRanges.map(S=>k.Range.to(S)),typeof i.editorPosition=="number"?k.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,$)}D.newActiveEditor!==void 0&&(w.ok(D.newActiveEditor===null||this.b.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this.a=D.newActiveEditor),(0,C.$Lc)(p),(0,C.$Lc)(s),D.removedDocuments&&this.e.fire(p),D.addedDocuments&&this.d.fire(r),(D.removedEditors||D.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),D.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(D){return this.c.get(D)?.value}allDocuments(){return f.Iterable.map(this.c.values(),D=>D.value)}getEditor(D){return this.b.get(D)}activeEditor(D){if(!this.a)return;const p=this.b.get(this.a);return D?p:p?.value}allEditors(){return[...this.b.values()]}};e.$gM=c,e.$gM=c=Ke([Ve(0,g.$9L),Ve(1,a.$7i)],c),e.$hM=(0,A.$Mh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,16,231]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=void 0,e.$Pcc=(0,A.$Mh)("IExtHostEditorTabs");class k{constructor(t,n,c){this.e=c,this.d=n,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,n={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(n)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new h.$OL(C.URI.revive(this.b.input.uri));case 2:return new h.$PL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new h.$QL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new h.$RL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new h.$SL(this.b.input.viewType);case 4:return new h.$TL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new h.$UL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new h.$VL;case 9:return new h.$WL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,n){this.c=[],this.d="",this.b=t,this.e=n;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,n={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(n)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const n=this.c.find(c=>c.tabId===t.tabDto.id);if(!n)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),n.acceptDtoUpdate(t.tabDto),n}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new F.$Ld,this.c=new F.$Ld,this.e=[],this.a=t.getProxy(M.$8J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,n={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,g.$Hf)(t.e.find(D=>D.groupId===c)?.apiObject)},close:async(c,v)=>{const D=Array.isArray(c)?c:[c];return D.length?m(D[0])?this.j(D,v):this.i(D,v):!0}};this.f=Object.freeze(n)}return this.f}$acceptEditorTabModel(t){const n=new Set(this.e.map(i=>i.groupId)),c=new Set(t.map(i=>i.groupId)),v=(0,P.$J)(n,c),D=this.e.filter(i=>v.removed.includes(i.groupId)).map(i=>i.apiObject),p=[],r=[];this.e=t.map(i=>{const o=new a(i,()=>this.d);return v.added.includes(o.groupId)?p.push(o.apiObject):r.push(o.apiObject),o});const s=(0,g.$Hf)(t.find(i=>i.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:p,closed:D,changed:r}))}$acceptTabGroupUpdate(t){const n=this.e.find(c=>c.groupId===t.groupId);if(!n)throw new Error("Update Group IPC call received before group creation.");n.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[n.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const n=this.e.find(v=>v.groupId===t.groupId);if(!n)throw new Error("Update Tabs IPC call received before group creation.");const c=n.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const n of this.e)for(const c of n.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(n=>n.apiObject===t)}async i(t,n){const c=[];for(const v of t){const D=this.g(v);if(!D)throw new Error("Tab close: Invalid tab not found!");c.push(D.tabId)}return this.a.$closeTab(c,n)}async j(t,n){const c=[];for(const v of t){const D=this.h(v);if(!D)throw new Error("Group close: Invalid group not found!");c.push(D.groupId)}return this.a.$closeGroup(c,n)}};e.$Qcc=b,e.$Qcc=b=Ke([Ve(0,E.$9L)],b);function m(f){return f.tabs!==void 0}}),define(Ae[232],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$8J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,h,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(A);if(!g)throw new Error("Embedding vector provider not found");const P=await g.provideEmbeddingVector(h,E);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,h,E){const g=this.b;return this.b++,this.a.set(g,E),this.c.$registerAiEmbeddingVectorProvider(h,g),new M.$0J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Bdc=C}),define(Ae[233],Re([1,0,2,3,6,7,8,279,15,25,26,50]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class a{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let n,c,v=14,D=14;for(const p of f){let r=n?(0,E.$2e)(n,p):0;for(r===0?c=1:c=D;r<p.length;r++)r+1===p.length?(v=D,D=9):D+=1,t.push([c,p.toUpperCase().charCodeAt(r),D]),t.push([c,p.toLowerCase().charCodeAt(r),D]),c=D;n=p,D=v}t.push([9,58,10]),t.push([10,47,12]),this.b=new h.$KY(t)}}provideDocumentLinks(f){this.c();const t=[],n=h.$LY.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this.b);for(const c of n){const v=A.DocumentLink.to(c);v.target&&t.push(v)}return t}}class b{constructor(f,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(M.$8J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,n,c={}){if(b.j(n),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const v=this.h++;this.b.add(t),this.d.add(t),this.c.set(v,n);let D=2;c.isCaseSensitive&&(D+=1024),c.isReadonly&&(D+=2048),typeof n.copy=="function"&&(D+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,P.$8E)(f,"fsChunks"),D+=4);let p;c.isReadonly&&(0,k.$2j)(c.isReadonly)&&((0,P.$8E)(f,"readonlyMessage"),p={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(v,t,D,p).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=n.onDidChangeFile(s=>{const i=[];for(const o of s){const{uri:y,type:$}=o;if(y.scheme!==t)continue;let S;switch($){case F.FileChangeType.Changed:S=0;break;case F.FileChangeType.Created:S=1;break;case F.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:y,type:S})}this.a.$onFileSystemChange(v,i)});return(0,C.$Oc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:n,mtime:c,size:v,permissions:D}=f;return{type:t,ctime:n,mtime:c,size:v,permissions:D}}$stat(f,t){return Promise.resolve(this.l(f).stat(w.URI.revive(t))).then(n=>b.k(n))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(w.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(w.URI.revive(t))).then(n=>g.$_d.wrap(n))}$writeFile(f,t,n,c){return Promise.resolve(this.l(f).writeFile(w.URI.revive(t),n.buffer,c))}$delete(f,t,n){return Promise.resolve(this.l(f).delete(w.URI.revive(t),n))}$rename(f,t,n,c){return Promise.resolve(this.l(f).rename(w.URI.revive(t),w.URI.revive(n),c))}$copy(f,t,n,c){const v=this.l(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(w.URI.revive(t),w.URI.revive(n),c))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(w.URI.revive(t)))}$watch(f,t,n,c){const v=this.l(f).watch(w.URI.revive(n),c);this.f.set(t,v)}$unwatch(f,t){const n=this.f.get(t);n&&(n.dispose(),this.f.delete(t))}$open(f,t,n){const c=this.l(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(w.URI.revive(t),n))}$close(f,t){const n=this.l(f);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(t))}$read(f,t,n,c){const v=this.l(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const D=g.$_d.alloc(c);return Promise.resolve(v.read(t,n,D.buffer,0,c)).then(p=>D.slice(0,p))}$write(f,t,n,c){const v=this.l(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,n,c.buffer,0,c.byteLength))}l(f){const t=this.c.get(f);if(!t){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return t}}e.$mcc=b}),define(Ae[62],Re([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=e.$5bc=void 0;let m=b=class{constructor(t,n){this.b=new Map,this.c=new P.$1g,this.a=t.getProxy(w.$8J.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(v){try{let D;const p=c.b.get(v.scheme);return p?(await c.a.$ensureActivation(v.scheme),D=await p.impl.stat(v)):D=await c.a.$stat(v),{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions===M.FilePermission.Readonly?1:void 0}}catch(D){b.e(D)}},async readDirectory(v){try{const D=c.b.get(v.scheme);return D?(await c.a.$ensureActivation(v.scheme),(await D.impl.readDirectory(v)).slice()):await c.a.$readdir(v)}catch(D){return b.e(D)}},async createDirectory(v){try{const D=c.b.get(v.scheme);return D&&!D.isReadonly?(await c.a.$ensureActivation(v.scheme),await c.d(D.impl,D.extUri,v)):await c.a.$mkdir(v)}catch(D){return b.e(D)}},async readFile(v){try{const D=c.b.get(v.scheme);return D?(await c.a.$ensureActivation(v.scheme),(await D.impl.readFile(v)).slice()):(await c.a.$readFile(v)).buffer}catch(D){return b.e(D)}},async writeFile(v,D){try{const p=c.b.get(v.scheme);return p&&!p.isReadonly?(await c.a.$ensureActivation(v.scheme),await c.d(p.impl,p.extUri,p.extUri.dirname(v)),await c.c.queueFor(v).queue(()=>Promise.resolve(p.impl.writeFile(v,D,{create:!0,overwrite:!0})))):await c.a.$writeFile(v,F.$_d.wrap(D))}catch(p){return b.e(p)}},async delete(v,D){try{const p=c.b.get(v.scheme);return p&&!p.isReadonly?(await c.a.$ensureActivation(v.scheme),await p.impl.delete(v,{recursive:!1,...D})):await c.a.$delete(v,{recursive:!1,useTrash:!1,atomic:!1,...D})}catch(p){return b.e(p)}},async rename(v,D,p){try{return await c.a.$rename(v,D,{overwrite:!1,...p})}catch(r){return b.e(r)}},async copy(v,D,p){try{return await c.a.$copy(v,D,{overwrite:!1,...p})}catch(r){return b.e(r)}},isWritableFileSystem(v){const D=n.getCapabilities(v);if(typeof D=="number")return!(D&2048)}})}async d(t,n,c){const v=[];for(;!n.isEqual(c,n.dirname(c));)try{if(!((await t.stat(c)).type&M.FileType.Directory))throw C.$kL.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(D){if(M.$kk(D)!==M.FileSystemProviderErrorCode.FileNotFound)throw D;v.push(n.basename(c)),c=n.dirname(c)}for(let D=v.length-1;D>=0;D--){c=n.joinPath(c,v[D]);try{await t.createDirectory(c)}catch(p){if(M.$kk(p)!==M.FileSystemProviderErrorCode.FileExists)throw p}}}static e(t){if(t instanceof C.$kL)throw t;if(t instanceof M.$gk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$kL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$kL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$kL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$kL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$kL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$kL.Unavailable(t.message);default:throw new C.$kL(t.message,t.name)}if(!(t instanceof Error))throw new C.$kL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$kL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$kL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$kL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$kL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$kL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$kL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$kL.Unavailable(t.message);default:throw new C.$kL(t.message,t.name)}}addFileSystemProvider(t,n,c){return this.b.set(t,{impl:n,extUri:c?.isCaseSensitive?k.$jg:k.$lg,isReadonly:!!c?.isReadonly}),(0,g.$Oc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$jg}};e.$5bc=m,e.$5bc=m=b=Ke([Ve(0,h.$9L),Ve(1,E.$Abc)],m),e.$6bc=(0,A.$Mh)("IExtHostConsumerFileSystem")}),define(Ae[234],Re([1,0,5,37,2,3,8,7,48]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class g{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(b,m,f,t,n,c,v,D){this.a=new w.$Ld,this.b=new w.$Ld,this.c=new w.$Ld;const p=this.h(b,f,n);this.g=0,c&&(this.g+=1),v&&(this.g+=2),D&&(this.g+=4);const r=(0,M.$tj)(n),s=typeof n=="string",i=t(o=>{if(!c)for(const y of o.created){const $=C.URI.revive(y);r($.fsPath)&&(!s||m.getWorkspaceFolder($))&&this.a.fire($)}if(!v)for(const y of o.changed){const $=C.URI.revive(y);r($.fsPath)&&(!s||m.getWorkspaceFolder($))&&this.b.fire($)}if(!D)for(const y of o.deleted){const $=C.URI.revive(y);r($.fsPath)&&(!s||m.getWorkspaceFolder($))&&this.c.fire($)}});this.d=h.$0J.from(p,this.a,this.b,this.c,i)}h(b,m,f){const t=h.$0J.from();if(typeof f=="string")return t;const n=b.getProxy(F.$8J.MainThreadFileSystem);let c=!1;(f.pattern.includes(M.$pj)||f.pattern.includes(M.$qj))&&(c=!0);const v=Math.random();return n.$watch(m.identifier.value,v,f.baseUri,{recursive:c,excludes:[]}),h.$0J.from({dispose:()=>n.$unwatch(v)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class P{constructor(b){this.a=b,this.b=new E.$T(()=>this.a.created.map(C.URI.revive)),this.c=new E.$T(()=>this.a.changed.map(C.URI.revive)),this.d=new E.$T(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(b,m,f){this.j=b,this.k=m,this.l=f,this.a=new w.$Ld,this.b=new w.$Ld,this.c=new w.$Ld,this.d=new w.$Ld,this.g=new w.$Nd,this.h=new w.$Nd,this.i=new w.$Nd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,m,f,t,n,c){return new g(this.j,b,m,this.a.event,A.GlobPattern.from(f),t,n,c)}$onFileEvent(b){this.a.fire(new P(b))}$onDidRunFileOperation(b,m){switch(b){case 2:this.b.fire(Object.freeze({files:m.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(f=>C.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(f=>C.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,m){return(f,t,n)=>{const c=function(D){f.call(t,D)};return c.extension=b,m.event(c,void 0,n)}}async $onWillRunFileOperation(b,m,f,t){switch(b){case 2:return await this.n(this.g,{files:m.map(n=>({oldUri:C.URI.revive(n.source),newUri:C.URI.revive(n.target)}))},f,t);case 1:return await this.n(this.i,{files:m.map(n=>C.URI.revive(n.target))},f,t);case 0:case 3:return await this.n(this.h,{files:m.map(n=>C.URI.revive(n.target))},f,t)}}async n(b,m,f,t){const n=new Set,c=[];if(await b.fireAsync(m,t,async(D,p)=>{const r=Date.now(),s=await Promise.resolve(D);s instanceof h.$hK&&(c.push([p.extension,s]),n.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-r>f&&this.k.warn("SLOW file-participant",p.extension.identifier)}),t.isCancellationRequested||c.length===0)return;const v={edits:[]};for(const[,D]of c){const{edits:p}=A.WorkspaceEdit.from(D,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});v.edits=v.edits.concat(p)}return{edit:v,extensionNames:Array.from(n)}}}e.$ncc=k}),define(Ae[235],Re([1,0,6,2,3,8,7,31]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class E{static{this.a=0}constructor(a,b){this.extension=a,this.provider=b,this.handle=E.a++}}class g{constructor(a){this.session=a,this.responses=[]}}class P{static{this.a=0}constructor(a,b,m,f){this.f=m,this.g=f,this.b=new Map,this.d=new Map,this.e=a.getProxy(C.$8J.MainThreadInlineChat),b.registerApiCommand(new h.$wM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new h.$uM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?F.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?F.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?F.Position.from(t.position):void 0}})],h.$vM.Void))}registerProvider(a,b,m){const f=new E(a,b);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,m.label,a.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function"),(0,w.$Oc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(a,b,m,f){const t=this.b.get(a);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(b)),c=F.Selection.to(m),v=await t.provider.prepareInteractiveEditorSession({document:n,selection:c},f);if(!v)return;if(v.wholeRange&&!v.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const D=P.a++;return this.d.set(D,new g(v)),{id:D,placeholder:v.placeholder,slashCommands:v.slashCommands?.map(p=>({command:p.command,detail:p.detail,refer:p.refer,executeImmediately:p.executeImmediately})),wholeRange:F.Range.from(v.wholeRange),message:v.message}}async $provideResponse(a,b,m,f){const t=this.b.get(a);if(!t)return;const n=this.d.get(b.id);if(!n)return;const c={prompt:m.prompt,selection:F.Selection.to(m.selection),wholeRange:F.Range.to(m.wholeRange),attempt:m.attempt,live:m.live};let v=!1;const D={report:async s=>{if(!m.live)throw new Error("Progress reporting is only supported for live sessions");v||f.isCancellationRequested||!s.message&&!s.edits||await this.e.$handleProgressChunk(m.requestId,{message:s.message,edits:s.edits?.map(F.TextEdit.from)})}},p=t.provider.provideInteractiveEditorResponse(n.session,c,D,f);Promise.resolve(p).finally(()=>v=!0);const r=await p;if(r){const s=n.responses.push(r)-1,i={wholeRange:F.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r))return{...i,id:s,type:"message",message:F.MarkdownString.from(r.contents)};const{edits:o}=r;if(o instanceof A.$hK)return{...i,id:s,type:"bulkEdit",edits:F.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...i,id:s,type:"editorEdit",edits:o.map(F.TextEdit.from)}}}$handleFeedback(a,b,m,f){const t=this.b.get(a),n=this.d.get(b),c=n?.responses[m];if(t&&c){const v=F.InteractiveEditorResponseFeedbackKind.to(f);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,c,v)}}$releaseSession(a,b){}static h(a){return typeof a=="object"&&typeof a.contents=="object"}}e.$udc=P}),define(Ae[236],Re([1,0,2,31]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class C{constructor(A,h,E,g,P){this.a=h,this.b=E,this.c=g;const k=new M.$wM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$uM("showOptions","Show Options",a=>!0,a=>a),new M.$uM("resource","Interactive resource Uri",a=>!0,a=>a),new M.$uM("controllerId","Notebook controller Id",a=>!0,a=>a),new M.$uM("title","Interactive editor title",a=>!0,a=>a)],new M.$vM("Notebook and input URI",a=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const b=this.a.getEditorById(a.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri),notebookEditor:b.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,h,E,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:h,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,h){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$qdc=C}),define(Ae[237],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(w.$8J.MainThreadIssueReporter)}async $getIssueReporterUri(A,h){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const g=await E.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(A,h){const E=A.identifier.value;return this.a.set(E,h),this.b.$registerIssueUriRequestHandler(E),new M.$0J(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$wdc=C}),define(Ae[238],Re([1,0,6,3]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$8J.MainThreadLabelService)}$registerResourceLabelFormatter(A){const h=this.b++;return this.a.$registerResourceLabelFormatter(h,A),(0,w.$Oc)(()=>{this.a.$unregisterResourceLabelFormatter(h)})}}e.$Jcc=C}),define(Ae[239],Re([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,55,59,9,13,26,149]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;class i{constructor(L,K){this.d=L,this.e=K}async provideDocumentSymbols(L,K){const G=this.d.getDocument(L),Q=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Ib)(Q))return Q[0]instanceof F.$pK?Q.map(C.DocumentSymbol.from):i.f(Q)}static f(L){L=L.slice(0).sort((Q,J)=>{let x=Q.location.range.start.compareTo(J.location.range.start);return x===0&&(x=J.location.range.end.compareTo(Q.location.range.end)),x});const K=[],G=[];for(const Q of L){const J={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(J),K.push(J);break}const x=G[G.length-1];if(g.$ms.containsRange(x.range,J.range)&&!g.$ms.equalsRange(x.range,J.range)){x.children?.push(J),G.push(J);break}G.pop()}}return K}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(L,K,G){this.g=L,this.h=K,this.j=G,this.e=new c.$xbc("CodeLens"),this.f=new Map}async provideCodeLenses(L,K){const G=this.g.getDocument(L),Q=await this.j.provideCodeLenses(G,K);if(!Q||K.isCancellationRequested)return;const J=this.e.add(Q),x=new f.$Pc;this.f.set(J,x);const ae={cacheId:J,lenses:[]};for(let Fe=0;Fe<Q.length;Fe++)ae.lenses.push({cacheId:[J,Fe],range:C.Range.from(Q[Fe].range),command:this.h.toInternal(Q[Fe].command,x)});return ae}async resolveCodeLens(L,K){const G=L.cacheId&&this.e.get(...L.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,K),Q||(Q=G),K.isCancellationRequested)return;const J=L.cacheId&&this.f.get(L.cacheId[0]);if(J)return L.command=this.h.toInternal(Q.command??o.d,J),L}releaseCodeLenses(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}}function y(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class ${constructor(L,K){this.d=L,this.e=K}async provideDefinition(L,K,G){const Q=this.d.getDocument(L),J=C.Position.to(K),x=await this.e.provideDefinition(Q,J,G);return y(x)}}class S{constructor(L,K){this.d=L,this.e=K}async provideDeclaration(L,K,G){const Q=this.d.getDocument(L),J=C.Position.to(K),x=await this.e.provideDeclaration(Q,J,G);return y(x)}}class I{constructor(L,K){this.d=L,this.e=K}async provideImplementation(L,K,G){const Q=this.d.getDocument(L),J=C.Position.to(K),x=await this.e.provideImplementation(Q,J,G);return y(x)}}class u{constructor(L,K){this.d=L,this.e=K}async provideTypeDefinition(L,K,G){const Q=this.d.getDocument(L),J=C.Position.to(K),x=await this.e.provideTypeDefinition(Q,J,G);return y(x)}}class d{constructor(L,K){this.d=L,this.e=K}async provideHover(L,K,G){const Q=this.d.getDocument(L),J=C.Position.to(K),x=await this.e.provideHover(Q,J,G);if(!(!x||(0,P.$Ib)(x.contents)))return x.range||(x.range=Q.getWordRangeAtPosition(J)),x.range||(x.range=new F.$_J(J,J)),C.Hover.from(x)}}class l{constructor(L,K){this.d=L,this.e=K}async provideEvaluatableExpression(L,K,G){const Q=this.d.getDocument(L),J=C.Position.to(K),x=await this.e.provideEvaluatableExpression(Q,J,G);if(x)return C.EvaluatableExpression.from(x)}}class R{constructor(L,K){this.d=L,this.e=K}async provideInlineValues(L,K,G,Q){const J=this.d.getDocument(L),x=await this.e.provideInlineValues(J,C.Range.to(K),C.InlineValueContext.to(G),Q);if(Array.isArray(x))return x.map(ae=>C.InlineValue.from(ae))}}class B{constructor(L,K){this.d=L,this.e=K}async provideDocumentHighlights(L,K,G){const Q=this.d.getDocument(L),J=C.Position.to(K),x=await this.e.provideDocumentHighlights(Q,J,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class V{constructor(L,K){this.d=L,this.e=K}async provideLinkedEditingRanges(L,K,G){const Q=this.d.getDocument(L),J=C.Position.to(K),x=await this.e.provideLinkedEditingRanges(Q,J,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Fb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class j{constructor(L,K){this.d=L,this.e=K}async provideReferences(L,K,G,Q){const J=this.d.getDocument(L),x=C.Position.to(K),ae=await this.e.provideReferences(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.location.from)}}class W{static{this.d=1e3}constructor(L,K,G,Q,J,x,ae){this.g=L,this.h=K,this.j=G,this.k=Q,this.l=J,this.m=x,this.n=ae,this.e=new c.$xbc("CodeAction"),this.f=new Map}async provideCodeActions(L,K,G,Q){const J=this.g.getDocument(L),x=a.$os.isISelection(K)?C.Selection.to(K):C.Range.to(K),ae=[];for(const Ye of this.j.getDiagnostics(L))if(x.intersection(Ye.range)&&ae.push(Ye)>W.d)break;const Fe={diagnostics:ae,only:G.only?new F.$rK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},je=await this.k.provideCodeActions(J,x,Fe,Q);if(!(0,P.$Jb)(je)||Q.isCancellationRequested)return;const Qe=this.e.add(je),He=new f.$Pc;this.f.set(Qe,He);const _e=[];for(let Ye=0;Ye<je.length;Ye++){const xe=je[Ye];xe&&(W.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,He)})):(Fe.only&&(xe.kind?Fe.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Qe,Ye],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,He),diagnostics:xe.diagnostics&&xe.diagnostics.map(C.Diagnostic.from),edit:xe.edit&&C.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,r.$7E)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Qe,actions:_e}}async resolveCodeAction(L,K){const[G,Q]=L,J=this.e.get(G,Q);if(!J||W.o(J))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(J,K)??J;let ae;x.edit&&(ae=C.WorkspaceEdit.from(x.edit,void 0));let Fe;if(x.command){const je=this.f.get(G);je&&(Fe=this.h.toInternal(x.command,je))}return{edit:ae,command:Fe}}releaseCodeActions(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}static o(L){return typeof L.command=="string"&&typeof L.title=="string"}}class O{static toInternalProviderId(L,K){return L+"."+K}constructor(L,K,G,Q,J){this.d=L,this.e=K,this.f=G,this.g=Q,this.h=J}async prepareDocumentPaste(L,K,G,Q){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(L),x=K.map(je=>C.Range.to(je)),ae=C.DataTransfer.toDataTransfer(G,()=>{throw new D.$9});if(await this.f.prepareDocumentPaste(J,x,ae,Q),Q.isCancellationRequested)return;const Fe=Array.from(ae).filter(([,je])=>!(je instanceof F.$XK));return C.DataTransfer.from(Fe)}async providePasteEdits(L,K,G,Q,J){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ae=G.map(Qe=>C.Range.to(Qe)),Fe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,L,Qe)).buffer),je=await this.f.provideDocumentPasteEdits(x,ae,Fe,J);if(je)return{label:je.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class N{constructor(L,K){this.d=L,this.e=K}async provideDocumentFormattingEdits(L,K,G){const Q=this.d.getDocument(L),J=await this.e.provideDocumentFormattingEdits(Q,K,G);if(Array.isArray(J))return J.map(C.TextEdit.from)}}class ee{constructor(L,K){this.d=L,this.e=K}async provideDocumentRangeFormattingEdits(L,K,G,Q){const J=this.d.getDocument(L),x=C.Range.to(K),ae=await this.e.provideDocumentRangeFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(L,K,G,Q){(0,k.$Gf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(L),x=K.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class X{constructor(L,K){this.d=L,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(L,K,G,Q,J){const x=this.d.getDocument(L),ae=C.Position.to(K),Fe=await this.e.provideOnTypeFormattingEdits(x,ae,G,Q,J);if(Array.isArray(Fe))return Fe.map(C.TextEdit.from)}}class ye{constructor(L,K){this.e=L,this.f=K,this.d=new c.$xbc("WorkspaceSymbols")}async provideWorkspaceSymbols(L,K){const G=await this.e.provideWorkspaceSymbols(L,K);if(!(0,P.$Jb)(G))return{symbols:[]};const Q=this.d.add(G),J={cacheId:Q,symbols:[]};for(let x=0;x<G.length;x++){const ae=G[x];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}J.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Q,x]})}return J}async resolveWorkspaceSymbol(L,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!L.cacheId)return L;const G=this.d.get(...L.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,K);return Q&&(0,M.$1m)(L,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(L){this.d.delete(L)}}class De{static supportsResolving(L){return typeof L.prepareRename=="function"}constructor(L,K,G){this.d=L,this.e=K,this.f=G}async provideRenameEdits(L,K,G,Q){const J=this.d.getDocument(L),x=C.Position.to(K);try{const ae=await this.e.provideRenameEdits(J,x,G,Q);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Fe=De.g(ae);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(L,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(L),J=C.Position.to(K);try{const x=await this.e.prepareRename(Q,J,G);let ae,Fe;if(F.$_J.isRange(x)?(ae=x,Fe=Q.getText(x)):(0,k.$yf)(x)&&(ae=x.range,Fe=x.placeholder),!ae||!Fe)return;if(ae.start.line>J.line||ae.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Fe}}catch(x){const ae=De.g(x);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(x)}}static g(L){return typeof L=="string"?L:L instanceof Error&&typeof L.message=="string"?L.message:void 0}}class Pe{constructor(L,K){this.resultId=L,this.tokens=K}}class Y{constructor(L,K){this.f=L,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(L,K,G){const Q=this.f.getDocument(L),J=K!==0?this.d.get(K):null;let x=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,J.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return J&&this.d.delete(K),x?(x=Y.h(x),this.o(Y.n(J,x),x)):null}async releaseDocumentSemanticColoring(L){this.d.delete(L)}static h(L){return Y.j(L)?Y.k(L)?L:new F.$oL(new Uint32Array(L.data),L.resultId):Y.l(L)?Y.m(L)?L:new F.$qL(L.edits.map(K=>new F.$pL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),L.resultId):L}static j(L){return L&&!!L.data}static k(L){return L.data instanceof Uint32Array}static l(L){return L&&Array.isArray(L.edits)}static m(L){for(const K of L.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(L,K){if(!Y.j(K)||!L||!L.tokens)return K;const G=L.tokens,Q=G.length,J=K.data,x=J.length;let ae=0;const Fe=Math.min(Q,x);for(;ae<Fe&&G[ae]===J[ae];)ae++;if(ae===Q&&ae===x)return new F.$qL([],K.resultId);let je=0;const Qe=Fe-ae;for(;je<Qe&&G[Q-je-1]===J[x-je-1];)je++;return new F.$qL([{start:ae,deleteCount:Q-ae-je,data:J.subarray(ae,x-je)}],K.resultId)}o(L,K){if(Y.j(L)){const G=this.e++;return this.d.set(G,new Pe(L.resultId,L.data)),(0,t.$H0)({id:G,type:"full",data:L.data})}if(Y.l(L)){const G=this.e++;return Y.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(L.resultId)),(0,t.$H0)({id:G,type:"delta",deltas:(L.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class le{constructor(L,K){this.d=L,this.e=K}async provideDocumentRangeSemanticTokens(L,K,G){const Q=this.d.getDocument(L),J=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(K),G);return J?this.f(J):null}f(L){return(0,t.$H0)({id:0,type:"full",data:L.data})}}class Ee{static supportsResolving(L){return typeof L.resolveCompletionItem=="function"}constructor(L,K,G,Q,J){this.f=L,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new c.$xbc("CompletionItem"),this.e=new Map}async provideCompletionItems(L,K,G,Q){const J=this.f.getDocument(L),x=C.Position.to(K),ae=J.getWordRangeAtPosition(x)||new F.$_J(x,x),Fe=ae.with({end:x}),je=new v.$Hd,Qe=await this.h.provideCompletionItems(J,x,Q,C.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const He=Array.isArray(Qe)?new F.$EK(Qe):Qe,_e=Ee.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Ye=new f.$Pc;this.e.set(_e,Ye);const xe=[],it={x:_e,b:xe,a:{replace:C.Range.from(ae),insert:C.Range.from(Fe)},c:He.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<He.items.length;tt++){const ze=He.items[tt],st=this.l(ze,[_e,tt],Fe,ae);xe.push(st)}return it}async resolveCompletionItem(L,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...L);if(!G)return;const Q=this.l(G,L),J=await this.h.resolveCompletionItem(G,K);if(!J)return;const x=this.l(J,L);return(Q.h!==x.h||Q.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==x.n||Q.o!==x.o||!(0,M.$2m)(Q.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,K,G,Q){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const x=this.g.toInternal(L.command,J),ae={x:K,a:L.label,b:L.kind!==void 0?C.CompletionItemKind.from(L.kind):void 0,m:L.tags&&L.tags.map(C.CompletionItemTag.from),c:L.detail,d:typeof L.documentation>"u"?void 0:C.MarkdownString.fromStrict(L.documentation),e:L.sortText!==L.label?L.sortText:void 0,f:L.filterText!==L.label?L.filterText:void 0,g:L.preselect||void 0,i:L.keepWhitespace?1:0,k:L.commitCharacters?.join(""),l:L.additionalTextEdits&&L.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};L.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=L.textEdit.newText):typeof L.insertText=="string"?ae.h=L.insertText:L.insertText instanceof F.$iK&&(ae.h=L.insertText.value,ae.i|=4);let Fe;return L.textEdit?Fe=L.textEdit.range:L.range&&(Fe=L.range),F.$_J.isRange(Fe)?ae.j=C.Range.from(Fe):Fe&&(!G?.isEqual(Fe.inserting)||!Q?.isEqual(Fe.replacing))&&(ae.j={insert:C.Range.from(Fe.inserting),replace:C.Range.from(Fe.replacing)}),ae}}class ce{async provideInlineCompletions(L,K,G,Q){}disposeCompletions(L){}handleDidShowCompletionItem(L,K,G){}handlePartialAccept(L,K,G){}}class $e extends ce{constructor(L,K,G,Q){super(),this.f=L,this.g=K,this.h=G,this.j=Q,this.d=new ie,this.e=(0,r.$7E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$7E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(L,K,G,Q){const J=this.g.getDocument(L),x=C.Position.to(K),ae=await this.h.provideInlineCompletionItems(J,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ae||Q.isCancellationRequested)return;const Fe=Array.isArray(ae)?ae:ae.items,je=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Qe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Fe}),items:Fe.map((Ye,xe)=>{let it;Ye.command&&(He||(He=new f.$Pc),it=this.j.toInternal(Ye.command,He));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?C.Range.from(Ye.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:je.map(Ye=>(He||(He=new f.$Pc),this.j.toInternal(Ye,He))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(L){this.d.disposeReferenceId(L)?.dispose()}handleDidShowCompletionItem(L,K,G){const Q=this.d.get(L)?.items[K];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(L,K,G){const Q=this.d.get(L)?.items[K];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(L){const K=this.e++;return this.d.set(K,L),K}disposeReferenceId(L){const K=this.d.get(L);return this.d.delete(L),K}get(L){return this.d.get(L)}}class z{constructor(L,K){this.e=L,this.f=K,this.d=new c.$xbc("SignatureHelp")}async provideSignatureHelp(L,K,G,Q){const J=this.e.getDocument(L),x=C.Position.to(K),ae=this.g(G),Fe=await this.f.provideSignatureHelp(J,x,Q,ae);if(Fe){const je=this.d.add([Fe]);return{...C.SignatureHelp.from(Fe),id:je}}}g(L){let K;if(L.activeSignatureHelp){const G=C.SignatureHelp.to(L.activeSignatureHelp),Q=this.d.get(L.activeSignatureHelp.id,0);Q?(K=Q,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...L,activeSignatureHelp:K}}releaseSignatureHelp(L){this.d.delete(L)}}class q{constructor(L,K,G,Q,J){this.f=L,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new c.$xbc("InlayHints"),this.e=new Map}async provideInlayHints(L,K,G){const Q=this.f.getDocument(L),J=C.Range.to(K),x=await this.h.provideInlayHints(Q,J,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ae=this.d.add(x);this.e.set(ae,new f.$Pc);const Fe={hints:[],cacheId:ae};for(let je=0;je<x.length;je++)this.l(x[je],J)&&Fe.hints.push(this.m(x[je],[ae,je]));return this.j.trace(`[InlayHints] ${Fe.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Fe}async resolveInlayHint(L,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...L);if(!G)return;const Q=await this.h.resolveInlayHint(G,K);if(Q&&this.l(Q))return this.m(Q,L)}releaseHints(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,K){return L.label.length===0||Array.isArray(L.label)&&L.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",L),!1):!(K&&!K.contains(L.position))}m(L,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(L.tooltip),position:C.Position.from(L.position),textEdits:L.textEdits&&L.textEdits.map(C.TextEdit.from),kind:L.kind&&C.InlayHintKind.from(L.kind),paddingLeft:L.paddingLeft,paddingRight:L.paddingRight};return typeof L.label=="string"?Q.label=L.label:Q.label=L.label.map(J=>{const x={label:J.value};return x.tooltip=C.MarkdownString.fromStrict(J.tooltip),F.$jK.isLocation(J.location)&&(x.location=C.location.from(J.location)),J.command&&(x.command=this.g.toInternal(J.command,G)),x}),Q}}class ue{constructor(L,K){this.e=L,this.f=K,this.d=new c.$xbc("DocumentLink")}async provideLinks(L,K){const G=this.e.getDocument(L),Q=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(Q)||Q.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ue.g).map(C.DocumentLink.from)};{const J=this.d.add(Q),x={links:[],cacheId:J};for(let ae=0;ae<Q.length;ae++){if(!ue.g(Q[ae]))continue;const Fe=C.DocumentLink.from(Q[ae]);Fe.cacheId=[J,ae],x.links.push(Fe)}return x}}}static g(L){return L.target&&L.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(L,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...L);if(!G)return;const Q=await this.f.resolveDocumentLink(G,K);if(!(!Q||!ue.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(L){this.d.delete(L)}}class we{constructor(L,K){this.d=L,this.e=K}async provideColors(L,K){const G=this.d.getDocument(L),Q=await this.e.provideDocumentColors(G,K);return Array.isArray(Q)?Q.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(L,K,G){const Q=this.d.getDocument(L),J=C.Range.to(K.range),x=C.Color.to(K.color),ae=await this.e.provideColorPresentations(x,{document:Q,range:J},G);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class ve{constructor(L,K){this.d=L,this.e=K}async provideFoldingRanges(L,K,G){const Q=this.d.getDocument(L),J=await this.e.provideFoldingRanges(Q,K,G);if(Array.isArray(J))return J.map(C.FoldingRange.from)}}class me{constructor(L,K,G){this.d=L,this.e=K,this.f=G}async provideSelectionRanges(L,K,G){const Q=this.d.getDocument(L),J=K.map(C.Position.to),x=await this.e.provideSelectionRanges(Q,J,G);if(!(0,P.$Jb)(x))return[];if(x.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Fe=0;Fe<J.length;Fe++){const je=[];ae.push(je);let Qe=J[Fe],He=x[Fe];for(;;){if(!He.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(C.SelectionRange.from(He)),!He.parent)break;Qe=He.range,He=He.parent}}return ae}}class ke{constructor(L,K){this.f=L,this.g=K,this.d=new n.$bM(""),this.e=new Map}async prepareSession(L,K,G){const Q=this.f.getDocument(L),J=C.Position.to(K),x=await this.g.prepareCallHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Fe=>this.h(ae,Fe)):[this.h(ae,x)]}async provideCallsTo(L,K,G){const Q=this.j(L,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(J)return J.map(x=>({from:this.h(L,x.from),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(L,K,G){const Q=this.j(L,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(J)return J.map(x=>({to:this.h(L,x.to),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(L){this.e.delete(L)}h(L,K){const G=this.e.get(L),Q=C.CallHierarchyItem.from(K,L,G.size.toString(36));return G.set(Q._itemId,K),Q}j(L,K){return this.e.get(L)?.get(K)}}class re{constructor(L,K){this.f=L,this.g=K,this.d=new n.$bM(""),this.e=new Map}async prepareSession(L,K,G){const Q=this.f.getDocument(L),J=C.Position.to(K),x=await this.g.prepareTypeHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Fe=>this.h(ae,Fe)):[this.h(ae,x)]}async provideSupertypes(L,K,G){const Q=this.j(L,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(Q,G);if(J)return J.map(x=>this.h(L,x))}async provideSubtypes(L,K,G){const Q=this.j(L,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(Q,G);if(J)return J.map(x=>this.h(L,x))}releaseSession(L){this.e.delete(L)}h(L,K){const G=this.e.get(L),Q=C.TypeHierarchyItem.from(K,L,G.size.toString(36));return G.set(Q._itemId,K),Q}j(L,K){return this.e.get(L)?.get(K)}}class he{static toInternalProviderId(L,K){return L+"."+K}constructor(L,K,G,Q,J){this.d=L,this.e=K,this.f=G,this.g=Q,this.h=J}async provideDocumentOnDropEdits(L,K,G,Q,J){const x=this.e.getDocument(K),ae=C.Position.to(G),Fe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,L,Qe)).buffer),je=await this.f.provideDocumentDropEdits(x,ae,Fe,J);if(je)return{label:je.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class se{constructor(L,K){this.d=L,this.e=K}async provideMappedEdits(L,K,G,Q){const J=w.URI.revive(L),x=this.d.getDocument(J),ae=G.documents.map(Qe=>Qe.map(He=>({uri:w.URI.revive(He.uri),version:He.version,ranges:He.ranges.map(_e=>C.Range.to(_e))}))),Fe={documents:ae,selections:ae[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(x,K,Fe,Q);return je?C.WorkspaceEdit.from(je):null}}class oe{constructor(L,K){this.adapter=L,this.extension=K}}class de{static{this.d=0}constructor(L,K,G,Q,J,x,ae,Fe){this.g=K,this.h=G,this.j=Q,this.k=J,this.l=x,this.m=ae,this.n=Fe,this.f=new Map,this.e=L.getProxy(h.$8J.MainThreadLanguageFeatures)}o(L,K){return C.DocumentSelector.from(L,this.g,K)}p(L){return new F.$0J(()=>{this.f.delete(L),this.e.$unregister(L)})}q(){return de.d++}async s(L,K,G,Q,J,x=!1){const ae=this.f.get(L);if(!ae||!(ae.adapter instanceof K))return Q;const Fe=Date.now();x||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const je=G(ae.adapter,ae.extension);return Promise.resolve(je).catch(Qe=>{(0,D.$2)(Qe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ae.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Fe}ms`)}),b.CancellationToken.isCancellationToken(J)?(0,p.$Hg)(je,J):je}t(L,K){const G=this.q();return this.f.set(G,new oe(L,K)),G}static u(L){return L.displayName||L.name}registerDocumentSymbolProvider(L,K,G,Q){const J=this.t(new i(this.h,G),L),x=Q&&Q.label||de.u(L);return this.e.$registerDocumentSymbolProvider(J,this.o(K,L),x),this.p(J)}$provideDocumentSymbols(L,K,G){return this.s(L,i,Q=>Q.provideDocumentSymbols(w.URI.revive(K),G),void 0,G)}registerCodeLensProvider(L,K,G){const Q=this.q(),J=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new o(this.h,this.j.converter,G),L)),this.e.$registerCodeLensSupport(Q,this.o(K,L),J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeCodeLenses(Fe=>this.e.$emitCodeLensEvent(J));x=F.$0J.from(x,ae)}return x}$provideCodeLenses(L,K,G){return this.s(L,o,Q=>Q.provideCodeLenses(w.URI.revive(K),G),void 0,G)}$resolveCodeLens(L,K,G){return this.s(L,o,Q=>Q.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(L,K){this.s(L,o,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(L,K,G){const Q=this.t(new $(this.h,G),L);return this.e.$registerDefinitionSupport(Q,this.o(K,L)),this.p(Q)}$provideDefinition(L,K,G,Q){return this.s(L,$,J=>J.provideDefinition(w.URI.revive(K),G,Q),[],Q)}registerDeclarationProvider(L,K,G){const Q=this.t(new S(this.h,G),L);return this.e.$registerDeclarationSupport(Q,this.o(K,L)),this.p(Q)}$provideDeclaration(L,K,G,Q){return this.s(L,S,J=>J.provideDeclaration(w.URI.revive(K),G,Q),[],Q)}registerImplementationProvider(L,K,G){const Q=this.t(new I(this.h,G),L);return this.e.$registerImplementationSupport(Q,this.o(K,L)),this.p(Q)}$provideImplementation(L,K,G,Q){return this.s(L,I,J=>J.provideImplementation(w.URI.revive(K),G,Q),[],Q)}registerTypeDefinitionProvider(L,K,G){const Q=this.t(new u(this.h,G),L);return this.e.$registerTypeDefinitionSupport(Q,this.o(K,L)),this.p(Q)}$provideTypeDefinition(L,K,G,Q){return this.s(L,u,J=>J.provideTypeDefinition(w.URI.revive(K),G,Q),[],Q)}registerHoverProvider(L,K,G,Q){const J=this.t(new d(this.h,G),L);return this.e.$registerHoverProvider(J,this.o(K,L)),this.p(J)}$provideHover(L,K,G,Q){return this.s(L,d,J=>J.provideHover(w.URI.revive(K),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(L,K,G,Q){const J=this.t(new l(this.h,G),L);return this.e.$registerEvaluatableExpressionProvider(J,this.o(K,L)),this.p(J)}$provideEvaluatableExpression(L,K,G,Q){return this.s(L,l,J=>J.provideEvaluatableExpression(w.URI.revive(K),G,Q),void 0,Q)}registerInlineValuesProvider(L,K,G,Q){const J=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new R(this.h,G),L);this.e.$registerInlineValuesProvider(x,this.o(K,L),J);let ae=this.p(x);if(J!==void 0){const Fe=G.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(J));ae=F.$0J.from(ae,Fe)}return ae}$provideInlineValues(L,K,G,Q,J){return this.s(L,R,x=>x.provideInlineValues(w.URI.revive(K),G,Q,J),void 0,J)}registerDocumentHighlightProvider(L,K,G){const Q=this.t(new B(this.h,G),L);return this.e.$registerDocumentHighlightProvider(Q,this.o(K,L)),this.p(Q)}$provideDocumentHighlights(L,K,G,Q){return this.s(L,B,J=>J.provideDocumentHighlights(w.URI.revive(K),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(L,K,G){const Q=this.t(new V(this.h,G),L);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(K,L)),this.p(Q)}$provideLinkedEditingRanges(L,K,G,Q){return this.s(L,V,async J=>{const x=await J.provideLinkedEditingRanges(w.URI.revive(K),G,Q);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?de.w(x.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(L,K,G){const Q=this.t(new j(this.h,G),L);return this.e.$registerReferenceSupport(Q,this.o(K,L)),this.p(Q)}$provideReferences(L,K,G,Q,J){return this.s(L,j,x=>x.provideReferences(w.URI.revive(K),G,Q,J),void 0,J)}registerCodeActionProvider(L,K,G,Q){const J=new f.$Pc,x=this.t(new W(this.h,this.j.converter,this.k,G,this.l,L,this.m),L);return this.e.$registerQuickFixSupport(x,this.o(K,L),{providedKinds:Q?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Q?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,J)}))},de.u(L),!!G.resolveCodeAction),J.add(this.p(x)),J}$provideCodeActions(L,K,G,Q,J){return this.s(L,W,x=>x.provideCodeActions(w.URI.revive(K),G,Q,J),void 0,J)}$resolveCodeAction(L,K,G){return this.s(L,W,Q=>Q.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(L,K){this.s(L,W,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(L,K,G){const Q=this.t(new N(this.h,G),L);return this.e.$registerDocumentFormattingSupport(Q,this.o(K,L),L.identifier,L.displayName||L.name),this.p(Q)}$provideDocumentFormattingEdits(L,K,G,Q){return this.s(L,N,J=>J.provideDocumentFormattingEdits(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(L,K,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",J=this.t(new ee(this.h,G),L);return this.e.$registerRangeFormattingSupport(J,this.o(K,L),L.identifier,L.displayName||L.name,Q),this.p(J)}$provideDocumentRangeFormattingEdits(L,K,G,Q,J){return this.s(L,ee,x=>x.provideDocumentRangeFormattingEdits(w.URI.revive(K),G,Q,J),void 0,J)}$provideDocumentRangesFormattingEdits(L,K,G,Q,J){return this.s(L,ee,x=>x.provideDocumentRangesFormattingEdits(w.URI.revive(K),G,Q,J),void 0,J)}registerOnTypeFormattingEditProvider(L,K,G,Q){const J=this.t(new X(this.h,G),L);return this.e.$registerOnTypeFormattingSupport(J,this.o(K,L),Q,L.identifier),this.p(J)}$provideOnTypeFormattingEdits(L,K,G,Q,J,x){return this.s(L,X,ae=>ae.provideOnTypeFormattingEdits(w.URI.revive(K),G,Q,J,x),void 0,x)}registerWorkspaceSymbolProvider(L,K){const G=this.t(new ye(K,this.l),L);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(L,K,G){return this.s(L,ye,Q=>Q.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(L,K,G){return this.s(L,ye,Q=>Q.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(L,K){this.s(L,ye,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(L,K,G){const Q=this.t(new De(this.h,G,this.l),L);return this.e.$registerRenameSupport(Q,this.o(K,L),De.supportsResolving(G)),this.p(Q)}$provideRenameEdits(L,K,G,Q,J){return this.s(L,De,x=>x.provideRenameEdits(w.URI.revive(K),G,Q,J),void 0,J)}$resolveRenameLocation(L,K,G,Q){return this.s(L,De,J=>J.resolveRenameLocation(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(L,K,G,Q){const J=this.t(new Y(this.h,G),L),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(K,L),Q,x);let ae=this.p(J);if(x){const Fe=G.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));ae=F.$0J.from(ae,Fe)}return ae}$provideDocumentSemanticTokens(L,K,G,Q){return this.s(L,Y,J=>J.provideDocumentSemanticTokens(w.URI.revive(K),G,Q),null,Q)}$releaseDocumentSemanticTokens(L,K){this.s(L,Y,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(L,K,G,Q){const J=this.t(new le(this.h,G),L);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(K,L),Q),this.p(J)}$provideDocumentRangeSemanticTokens(L,K,G,Q){return this.s(L,le,J=>J.provideDocumentRangeSemanticTokens(w.URI.revive(K),G,Q),null,Q)}registerCompletionItemProvider(L,K,G,Q){const J=this.t(new Ee(this.h,this.j.converter,G,this.m,L),L);return this.e.$registerCompletionsProvider(J,this.o(K,L),Q,Ee.supportsResolving(G),L.identifier),this.p(J)}$provideCompletionItems(L,K,G,Q,J){return this.s(L,Ee,x=>x.provideCompletionItems(w.URI.revive(K),G,Q,J),void 0,J)}$resolveCompletionItem(L,K,G){return this.s(L,Ee,Q=>Q.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(L,K){this.s(L,Ee,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(L,K,G,Q){const J=new $e(L,this.h,G,this.j.converter),x=this.t(J,L);return this.e.$registerInlineCompletionsSupport(x,this.o(K,L),J.supportsHandleEvents,m.$Xl.toKey(L.identifier.value),Q?.yieldTo?.map(ae=>m.$Xl.toKey(ae))||[]),this.p(x)}$provideInlineCompletions(L,K,G,Q,J){return this.s(L,ce,x=>x.provideInlineCompletions(w.URI.revive(K),G,Q,J),void 0,J)}$handleInlineCompletionDidShow(L,K,G,Q){this.s(L,ce,async J=>{J.handleDidShowCompletionItem(K,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(L,K,G,Q){this.s(L,ce,async J=>{J.handlePartialAccept(K,G,Q)},void 0,void 0)}$freeInlineCompletionsList(L,K){this.s(L,ce,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(L,K,G,Q){const J=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,x=this.t(new z(this.h,G),L);return this.e.$registerSignatureHelpProvider(x,this.o(K,L),J),this.p(x)}$provideSignatureHelp(L,K,G,Q,J){return this.s(L,z,x=>x.provideSignatureHelp(w.URI.revive(K),G,Q,J),void 0,J)}$releaseSignatureHelp(L,K){this.s(L,z,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(L,K,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new q(this.h,this.j.converter,G,this.l,L),L);this.e.$registerInlayHintsProvider(J,this.o(K,L),typeof G.resolveInlayHint=="function",Q,de.u(L));let x=this.p(J);if(Q!==void 0){const ae=G.onDidChangeInlayHints(Fe=>this.e.$emitInlayHintsEvent(Q));x=F.$0J.from(x,ae)}return x}$provideInlayHints(L,K,G,Q){return this.s(L,q,J=>J.provideInlayHints(w.URI.revive(K),G,Q),void 0,Q)}$resolveInlayHint(L,K,G){return this.s(L,q,Q=>Q.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(L,K){this.s(L,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(L,K,G){const Q=this.t(new ue(this.h,G),L);return this.e.$registerDocumentLinkProvider(Q,this.o(K,L),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(L,K,G){return this.s(L,ue,Q=>Q.provideLinks(w.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(L,K,G){return this.s(L,ue,Q=>Q.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(L,K){this.s(L,ue,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(L,K,G){const Q=this.t(new we(this.h,G),L);return this.e.$registerDocumentColorProvider(Q,this.o(K,L)),this.p(Q)}$provideDocumentColors(L,K,G){return this.s(L,we,Q=>Q.provideColors(w.URI.revive(K),G),[],G)}$provideColorPresentations(L,K,G,Q){return this.s(L,we,J=>J.provideColorPresentations(w.URI.revive(K),G,Q),void 0,Q)}registerFoldingRangeProvider(L,K,G){const Q=this.q(),J=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new ve(this.h,G),L)),this.e.$registerFoldingRangeProvider(Q,this.o(K,L),L.identifier,J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));x=F.$0J.from(x,ae)}return x}$provideFoldingRanges(L,K,G,Q){return this.s(L,ve,J=>J.provideFoldingRanges(w.URI.revive(K),G,Q),void 0,Q)}registerSelectionRangeProvider(L,K,G){const Q=this.t(new me(this.h,G,this.l),L);return this.e.$registerSelectionRangeProvider(Q,this.o(K,L)),this.p(Q)}$provideSelectionRanges(L,K,G,Q){return this.s(L,me,J=>J.provideSelectionRanges(w.URI.revive(K),G,Q),[],Q)}registerCallHierarchyProvider(L,K,G){const Q=this.t(new ke(this.h,G),L);return this.e.$registerCallHierarchyProvider(Q,this.o(K,L)),this.p(Q)}$prepareCallHierarchy(L,K,G,Q){return this.s(L,ke,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(L,K,G,Q){return this.s(L,ke,J=>J.provideCallsTo(K,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(L,K,G,Q){return this.s(L,ke,J=>J.provideCallsFrom(K,G,Q),void 0,Q)}$releaseCallHierarchy(L,K){this.s(L,ke,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(L,K,G){const Q=this.t(new re(this.h,G),L);return this.e.$registerTypeHierarchyProvider(Q,this.o(K,L)),this.p(Q)}$prepareTypeHierarchy(L,K,G,Q){return this.s(L,re,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(L,K,G,Q){return this.s(L,re,J=>J.provideSupertypes(K,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(L,K,G,Q){return this.s(L,re,J=>J.provideSubtypes(K,G,Q),void 0,Q)}$releaseTypeHierarchy(L,K){this.s(L,re,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(L,K,G,Q){const J=this.q();this.f.set(J,new oe(new he(this.e,this.h,G,J,L),L));const x=(0,r.$7E)(L,"dropMetadata")&&Q?he.toInternalProviderId(L.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(K,L),x,(0,r.$7E)(L,"dropMetadata")?Q:void 0),this.p(J)}$provideDocumentOnDropEdits(L,K,G,Q,J,x){return this.s(L,he,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(K,w.URI.revive(G),Q,J,x)),void 0,void 0)}registerMappedEditsProvider(L,K,G){const Q=this.t(new se(this.h,G),L);return this.e.$registerMappedEditsProvider(Q,this.o(K,L)),this.p(Q)}$provideMappedEdits(L,K,G,Q,J){return this.s(L,se,x=>Promise.resolve(x.provideMappedEdits(K,G,Q,J)),null,J)}registerDocumentPasteEditProvider(L,K,G,Q){const J=this.q();this.f.set(J,new oe(new O(this.e,this.h,G,J,L),L));const x=O.toInternalProviderId(L.identifier.value,Q.id);return this.e.$registerPasteEditProvider(J,this.o(K,L),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(L,K,G,Q,J){return this.s(L,O,x=>x.prepareDocumentPaste(w.URI.revive(K),G,Q,J),void 0,J)}$providePasteEdits(L,K,G,Q,J,x){return this.s(L,O,ae=>ae.providePasteEdits(K,w.URI.revive(G),Q,J,x),void 0,x)}static w(L){return{pattern:L.source,flags:L.flags}}static y(L){return{decreaseIndentPattern:de.w(L.decreaseIndentPattern),increaseIndentPattern:de.w(L.increaseIndentPattern),indentNextLinePattern:L.indentNextLinePattern?de.w(L.indentNextLinePattern):void 0,unIndentedLinePattern:L.unIndentedLinePattern?de.w(L.unIndentedLinePattern):void 0}}static z(L){return{beforeText:de.w(L.beforeText),afterText:L.afterText?de.w(L.afterText):void 0,previousLineText:L.previousLineText?de.w(L.previousLineText):void 0,action:L.action}}static B(L){return L.map(de.z)}static C(L){return{open:L.open,close:L.close,notIn:L.notIn?L.notIn.map(K=>F.SyntaxTokenType.toString(K)):void 0}}static D(L){return L.map(de.C)}setLanguageConfiguration(L,K,G){const{wordPattern:Q}=G;if(Q&&(0,E.$Me)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(K,Q):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",L,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",L,"Do not use.");const J=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?de.w(G.wordPattern):void 0,indentationRules:G.indentationRules?de.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?de.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?de.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(J,K,x),this.p(J)}$setWordDefinitions(L){for(const K of L)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Gbc=de}),define(Ae[240],Re([1,0,3,8,7,29,13,6]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class E{constructor(P,k,a,b){this.c=k,this.d=a,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(w.$8J.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,k){await this.a.$changeLanguage(P,k);const a=this.c.getDocumentData(P);if(!a)throw new Error(`document '${P.toString()}' NOT found`);return a.document}async tokenAtPosition(P,k){const a=P.version,b=M.Position.from(k),m=await this.a.$tokensAtPosition(P.uri,b),f={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(k)??new C.$_J(k.line,k.character,k.line,k.character)};if(!m)return f;const t={range:M.Range.to(m.range),type:M.TokenType.to(m.type)};return!t.range.contains(k)||a!==P.version?f:t}createLanguageStatusItem(P,k,a){const b=this.f++,m=this.a,f=this.g,t=`${P.identifier.value}/${k}`;if(f.has(t))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);f.add(t);const n={selector:a,id:k,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const v=new h.$Pc,D=()=>{if(c?.dispose(),!f.has(t)){console.warn(`LanguageStatusItem (${k}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Tg)(()=>{v.clear(),this.a.$setLanguageStatus(b,{id:t,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:M.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?F.default.Error:n.severity===C.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,v),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},p={dispose(){v.dispose(),c?.dispose(),m.$removeLanguageStatus(b),f.delete(t)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,D()},get selector(){return n.selector},set selector(r){n.selector=r,D()},get text(){return n.text},set text(r){n.text=r,D()},get detail(){return n.detail},set detail(r){n.detail=r,D()},get severity(){return n.severity},set severity(r){n.severity=r,D()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,D()},get command(){return n.command},set command(r){n.command=r,D()},get busy(){return n.busy},set busy(r){n.busy=r,D()}};return D(),p}}e.$occ=E}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;let P=class{constructor(a,b,m){this.f=m,this.d=new Map,this.a=b.getProxy(h.$8J.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===w.$f}getMessage(a,b){const{message:m,args:f,comment:t}=b;if(this.c)return(0,M.$Be)(m,f??{});let n=m;t&&t.length>0&&(n+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(a)?.contents[n];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${n}`),(0,M.$Be)(c??m,f??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let b;const m=await this.g(a);if(!m){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(m),t=JSON.parse(f);b=a.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${a.identifier.value} from ${m}: ${f.message}`);return}b&&this.d.set(a.identifier.value,{contents:b,uri:m})}async g(a){if(a.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return C.URI.revive(b)}return a.l10n?C.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$dcc=P,e.$dcc=P=Ke([Ve(0,E.$mM),Ve(1,g.$9L),Ve(2,A.$7i)],P),e.$ecc=(0,F.$Mh)("IExtHostLocalizationService")}),define(Ae[241],Re([1,0,14,3,27,17,2,68]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;let E=class extends w.$fj{constructor(k,a){super(a.logLevel,a.logsLocation,a.loggers.map(b=>(0,h.$jh)(b))),this.r=k.getProxy(M.$8J.MainThreadLogger)}$setLogLevel(k,a){a?this.setLogLevel(A.URI.revive(a),k):this.setLogLevel(k)}setVisibility(k,a){super.setVisibility(k,a),this.r.$setVisibility(k,a)}s(k,a,b){return new g(this.r,k,a,b)}};e.$Edc=E,e.$Edc=E=Ke([Ve(0,F.$9L),Ve(1,C.$mM)],E);class g extends w.$aj{constructor(k,a,b,m){super(m?.logLevel==="always"),this.r=k,this.s=a,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(a,m).then(()=>{this.u(this.n),this.m=!0})}g(k,a){const b=[[k,a]];this.m?this.u(b):this.n.push(...b)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0,e.$fcc=(0,M.$Mh)("IExtHostManagedSockets");let h=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(w.$8J.MainThreadManagedSockets)}setFactory(k,a){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(k,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const a=++this.b,b=await this.c.makeConnection(),m=new C.$Pc;return this.d.set(a,new g(a,b,m)),m.add((0,C.$Oc)(()=>this.d.delete(a))),m.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),m.dispose()})),m.add(b.onDidClose(f=>{this.a.$onDidManagedSocketClose(a,f?.stack??f?.message),m.dispose()})),m.add(b.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(a,A.$_d.wrap(f)))),a}$remoteSocketWrite(k,a){this.d.get(k)?.actual.send(a.buffer)}$remoteSocketEnd(k){const a=this.d.get(k);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$gcc=h,e.$gcc=h=Ke([Ve(0,F.$9L)],h);class E{constructor(k,a){this.socketFactoryId=k,this.makeConnection=a}}class g extends C.$Qc{constructor(k,a,b){super(),this.socketId=k,this.actual=a,this.B(b)}}}),define(Ae[242],Re([1,0,3,14,26]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;function F(h){return h&&h.title}let A=class{constructor(E,g){this.b=g,this.a=E.getProxy(w.$8J.MainThreadMessageService)}showMessage(E,g,P,k,a){const b={source:{identifier:E.identifier,label:E.displayName||E.name}};let m;typeof k=="string"||F(k)?m=[k,...a]:(b.modal=k?.modal,b.useCustom=k?.useCustom,b.detail=k?.detail,m=a),b.useCustom&&(0,C.$8E)(E,"resolvers");const f=[];for(let t=0;t<m.length;t++){const n=m[t];if(typeof n=="string")f.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:c,isCloseAffordance:v}=n;f.push({title:c,isCloseAffordance:!!v,handle:t})}else this.b.warn("Invalid message item:",n)}return this.a.$showMessage(g,P,b,f).then(t=>{if(typeof t=="number")return m[t]})}};e.$pcc=A,e.$pcc=A=Ke([Ve(1,M.$7i)],A)}),define(Ae[243],Re([1,0,151,25,5,6,28,15,16,2,38,55,3,31,8,7,46,204,103,9,24,12]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(i=>i.apiEditor)}constructor(i,o,y,$,S){this.q=y,this.r=$,this.s=S,this.f=new Map,this.g=new A.$yc,this.h=new Map,this.j=new C.$Ld({onListenerError:v.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Ld({onListenerError:v.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Ld({onListenerError:v.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Ld({onListenerError:v.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$xbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=i.getProxy(a.$8J.MainThreadNotebook),this.c=i.getProxy(a.$8J.MainThreadNotebookDocuments),this.d=i.getProxy(a.$8J.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const u=I.notebookEditor?.notebookUri,d=I.cell.handle,R=this.g.get(u)?.getCell(d);if(R)return R.apiCell}if(I&&I.$mid===14){const u=I.uri,d=this.g.get(u);if(d)return d.apiNotebook}return I}}),r.A(o)}getEditorById(i){const o=this.h.get(i);if(!o)throw new Error(`unknown text editor: ${i}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(i){for(const[o,y]of this.h)if(y.apiEditor===i)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(i,o){const y=this.g.get(i);if(!y&&!o)throw new Error(`NO notebook document for '${i}'`);return y}static t(i,o){if(!o)return;const y=o.filenamePattern.map($=>m.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:i.identifier,providerDisplayName:i.displayName||i.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(i,o,y){const $=r.a++,S=typeof y.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set($,y),this.b.$registerNotebookCellStatusBarItemProvider($,S,o);let I;return S!==void 0&&(I=y.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(S))),new f.$0J(()=>{this.f.delete($),this.b.$unregisterNotebookCellStatusBarItemProvider($,S),I?.dispose()})}async createNotebookDocument(i){const o=await this.c.$tryCreateNotebook({viewType:i.viewType,content:i.content&&m.NotebookData.from(i.content)});return g.URI.revive(o)}async openNotebookDocument(i){const o=this.g.get(i);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(i),$=this.g.get(g.URI.revive(y));return(0,E.$Hf)($?.apiNotebook)}async showNotebookDocument(i,o){g.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let y;typeof o=="object"?y={position:m.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(m.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const $=await this.d.$tryShowNotebookDocument(i.uri,i.notebookType,y),S=$&&this.h.get($)?.apiEditor;if(S)return S;throw $?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(i,o,y,$){const S=this.f.get(i),I=g.URI.revive(o),u=this.g.get(I);if(!u||!S)return;const d=u.getCellFromIndex(y);if(!d)return;const l=await S.provideCellStatusBarItems(d.apiCell,$);if(!l)return;const R=new F.$Pc,B=this.p.add([R]),j=(Array.isArray(l)?l:[l]).map(W=>m.NotebookStatusBarItem.from(W,this.i,R));return{cacheId:B,items:j}}$releaseNotebookCellStatusBarItems(i){this.p.delete(i)}registerNotebookSerializer(i,o,y,$,S){if((0,h.$ze)(o))throw new Error("viewType cannot be empty or just whitespace");const I=this.u++;return this.w.set(I,{viewType:o,serializer:y,options:$}),this.b.$registerNotebookSerializer(I,{id:i.identifier,location:i.extensionLocation},o,m.NotebookDocumentContentOptions.from($),r.t(i,S)),(0,F.$Oc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(i,o,y){const $=this.w.get(i);if(!$)throw new Error("NO serializer found");const S=await $.serializer.deserializeNotebook(o.buffer,y);return new t.$iv(m.NotebookData.from(S))}async $notebookToData(i,o,y){const $=this.w.get(i);if(!$)throw new Error("NO serializer found");const S=await $.serializer.serializeNotebook(m.NotebookData.to(o.value),y);return M.$_d.wrap(S)}async $saveNotebook(i,o,y,$,S){const I=g.URI.revive(o),u=this.w.get(i);if(!u)throw new Error("NO serializer found");const d=this.g.get(I);if(!d)throw new Error("Document NOT found");if(d.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new P.$pk((0,w.localize)(0,null,this.y(I)),6);await this.x(I,$);const l={metadata:(0,D.$6m)(d.apiNotebook.metadata,W=>!(u.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of d.apiNotebook.getCells()){const O=new f.$vL(W.kind,W.document.getText(),W.document.languageId,W.mime,u.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);O.metadata=(0,D.$6m)(W.metadata,N=>!(u.options?.transientCellMetadata??{})[N]),l.cells.push(O)}const R=await u.serializer.serializeNotebook(l,S);await this.s.value.writeFile(I,R);const B=this.s.getFileSystemProviderExtUri(I.scheme),V=await this.s.value.stat(I);return{name:B.basename(I),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$Ak({mtime:V.mtime,size:V.size}),children:void 0}}async x(i,o){const y=await this.s.value.stat(i);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$zk&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==P.$Ak({mtime:o.mtime,size:y.size}))throw new P.$pk((0,w.localize)(1,null),3,o)}y(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString()}z(i,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const $=new c.$9cc(o,this.d,i,y.visibleRanges.map(m.NotebookRange.to),y.selections.map(m.NotebookRange.to),typeof y.viewColumn=="number"?m.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,$)}$acceptDocumentAndEditorsDelta(i){if(i.value.removedDocuments)for(const y of i.value.removedDocuments){const $=g.URI.revive(y),S=this.g.get($);S&&(S.dispose(),this.g.delete($),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(S.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===$.toString()&&this.h.delete(I.id)}if(i.value.addedDocuments){const y=[];for(const $ of i.value.addedDocuments){const S=g.URI.revive($.uri);if(this.g.has(S))throw new Error(`adding EXISTING notebook ${S} `);const I=new n.$8cc(this.c,this.q,this.r,S,$);y.push(...$.cells.map(u=>n.$7cc.asModelAddData(I.apiNotebook,u))),this.g.get(S)?.dispose(),this.g.set(S,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(I.apiNotebook)}}if(i.value.addedEditors)for(const y of i.value.addedEditors){if(this.h.has(y.id))return;const $=g.URI.revive(y.documentUri),S=this.g.get($);S&&this.z(S,y.id,y)}const o=[];if(i.value.removedEditors)for(const y of i.value.removedEditors){const $=this.h.get(y);$&&(this.h.delete(y),this.k?.id===$.id&&(this.k=void 0),o.push($))}if(i.value.visibleEditors){this.l=i.value.visibleEditors.map($=>this.h.get($)).filter($=>!!$);const y=new Set;this.l.forEach($=>y.add($.id));for(const $ of this.h.values()){const S=y.has($.id);$._acceptVisibility(S)}this.l=[...this.h.values()].map($=>$).filter($=>$.visible),this.o.fire(this.visibleNotebookEditors)}i.value.newActiveEditor===null?this.k=void 0:i.value.newActiveEditor&&(this.h.get(i.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${i.value.newActiveEditor}`),this.k=this.h.get(i.value.newActiveEditor)),i.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(i){const o=b.$uM.String.with("notebookType","A notebook type"),y=new b.$wM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new b.$uM("data","Bytes to convert to data",S=>S instanceof Uint8Array,S=>M.$_d.wrap(S))],new b.$vM("Notebook Data",S=>m.NotebookData.to(S.value))),$=new b.$wM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new b.$uM("NotebookData","Notebook data to convert to bytes",S=>!0,S=>new t.$iv(m.NotebookData.from(S)))],new b.$vM("Bytes",S=>S.buffer));i.registerApiCommand(y),i.registerApiCommand($)}}e.$0cc=r}),define(Ae[244],Re([1,0,18,13,21,5,6,28,2,20,14,55,3,31,8,7,77,197,26,46]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=e.$ldc=void 0;let D=class{constructor(S,I,u,d,l){this.m=I,this.n=u,this.o=d,this.q=l,this.b=new h.$yc,this.c=new h.$yc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new k.$xbc("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new F.$Ld,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=S.getProxy(a.$8J.MainThreadNotebookKernels);const R=new b.$wM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$uM("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const V=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:V}}else if(B&&"notebookEditor"in B){const V=this.n.getIdByEditor(B.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return B})],b.$vM.Void);this.o.registerApiCommand(R)}createNotebookController(S,I,u,d,l,R){for(const Ee of this.j.values())if(Ee.controller.id===I&&g.$Xl.equals(S.identifier,Ee.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const B=this.k++,V=this;this.q.trace(`NotebookController[${B}], CREATED by ${S.identifier.value}, ${I}`);const j=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${S.identifier}'`);let W=!1;const O=new F.$Ld,N=new F.$Ld,ee={id:y(S.identifier,I),notebookType:u,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:d||S.identifier.value,preloads:R?R.map(m.NotebookRendererScript.from):[]};let X=l??j,ye;this.a.$addKernel(B,ee).catch(Ee=>{console.log(Ee),W=!0});let De=0;const Pe=()=>{if(W)return;const Ee=++De;Promise.resolve().then(()=>{Ee===De&&this.a.$updateKernel(B,ee)})},Y=new h.$yc,le={get id(){return I},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return ee.label},set label(Ee){ee.label=Ee??S.displayName??S.name,Pe()},get detail(){return ee.detail??""},set detail(Ee){ee.detail=Ee,Pe()},get description(){return ee.description??""},set description(Ee){ee.description=Ee,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(Ee){ee.supportedLanguages=Ee,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(Ee){ee.supportsExecutionOrder=Ee,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(Ee){X=Ee??j},get interruptHandler(){return ye},set interruptHandler(Ee){ye=Ee,ee.supportsInterrupt=!!Ee,Pe()},createNotebookCellExecution(Ee){if(W)throw new Error("notebook controller is DISPOSED");if(!Y.has(Ee.notebook.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.notebook.uri.toString()}`);return V._createNotebookCellExecution(Ee,y(S.identifier,this.id))},createNotebookExecution(Ee){if((0,c.$8E)(S,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!Y.has(Ee.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.uri.toString()}`);return V._createNotebookExecution(Ee,y(S.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${B}], DISPOSED`),W=!0,this.j.delete(B),O.dispose(),N.dispose(),this.a.$removeKernel(B))},updateNotebookAffinity(Ee,ce){ce===f.NotebookControllerAffinity2.Hidden&&(0,c.$8E)(S,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(B,Ee.uri,ce)},onDidReceiveMessage:N.event,postMessage(Ee,ce){return(0,c.$8E)(S,"notebookMessaging"),V.a.$postMessage(B,ce&&V.n.getIdByEditor(ce),Ee)},asWebviewUri(Ee){return(0,c.$8E)(S,"notebookMessaging"),(0,t.$Sob)(Ee,V.m.remote)}};return this.j.set(B,{extensionId:S.identifier,controller:le,onDidReceiveMessage:N,onDidChangeSelection:O,associatedNotebooks:Y}),le}getIdByController(S){for(const[I,u]of this.j)if(u.controller===S)return y(u.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,I){const u=this.f++,d=this;this.q.trace(`NotebookControllerDetectionTask[${u}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(u,I);const l={dispose:()=>{this.e.delete(u),d.a.$removeKernelDetectionTask(u)}};return this.e.set(u,l),l}registerKernelSourceActionProvider(S,I,u){const d=this.h++,l=typeof u.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,R=this;this.g.set(d,u),this.q.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,I);let B;return l!==void 0&&(B=u.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(l))),{dispose:()=>{this.g.delete(d),R.a.$removeKernelSourceActionProvider(d,d),B?.dispose()}}}async $provideKernelSourceActions(S,I){const u=this.g.get(S);if(u){const d=new A.$Pc;return this.i.add([d]),(await u.provideNotebookKernelSourceActions(I)??[]).map(R=>m.NotebookKernelSourceAction.from(R,this.o.converter,d))}return[]}$acceptNotebookAssociation(S,I,u){const d=this.j.get(S);if(d){const l=this.n.getNotebookDocument(E.URI.revive(I));u?d.associatedNotebooks.set(l.uri,!0):d.associatedNotebooks.delete(l.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,l.uri.toString(),u),d.onDidChangeSelection.fire({selected:u,notebook:l.apiNotebook})}}async $executeCells(S,I,u){const d=this.j.get(S);if(!d)return;const l=this.n.getNotebookDocument(E.URI.revive(I)),R=[];for(const B of u){const V=l.getCell(B);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,l.uri.toString(),R.length),await d.controller.executeHandler.call(d.controller,R,l.apiNotebook,d.controller)}catch(B){this.q.error(`NotebookController[${S}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(S,I,u){const d=this.j.get(S);if(!d)return;const l=this.n.getNotebookDocument(E.URI.revive(I));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,l.apiNotebook);else for(const R of u){const B=l.getCell(R);B&&this.b.get(B.uri)?.cancel()}if(d.controller.interruptHandler){const R=this.c.get(l.uri);u.length&&Array.isArray(R)&&R.length&&R.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(S,I,u){const d=this.j.get(S);if(!d)return;const l=this.n.getEditorById(I);d.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:u}))}$cellExecutionChanged(S,I,u){const l=this.n.getNotebookDocument(E.URI.revive(S)).getCell(I);if(l){const R=u?m.NotebookCellExecutionState.to(u):f.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:l.apiCell,state:R})}}_createNotebookCellExecution(S,I){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const l=new r(I,d,this.a);this.b.set(d.uri,l);const R=l.onDidChangeState(()=>{l.state===p.Resolved&&(l.dispose(),R.dispose(),this.b.delete(d.uri))});return l.asApiObject()}_createNotebookExecution(S,I){const u=this.n.getNotebookDocument(S.uri),d=S.getCells().find(B=>{const V=u.getCellFromApiCell(B);return V&&this.b.has(V.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(u.uri))throw new Error(`duplicate notebook execution for ${u.uri}`);const l=new i(I,u,this.a),R=l.onDidChangeState(()=>{l.state===s.Resolved&&(l.dispose(),R.dispose(),this.c.delete(u.uri))});return this.c.set(u.uri,[l,R]),l.asApiObject()}};e.$ldc=D,e.$ldc=D=Ke([Ve(4,P.$7i)],D);var p;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(p||(p={}));class r extends A.$Qc{static{this.a=0}get state(){return this.f}constructor(S,I,u){super(),this.m=I,this.n=u,this.b=r.a++,this.c=new F.$Ld,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new C.$Vd),this.h=new o(10,d=>this.s(d)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const I=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new v.$iv(I))}t(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let I=this.m;if(S&&(I=this.m.notebook.getCellFromApiCell(S)),!I)throw new Error("INVALID cell");return I.handle}y(S){return S.map(I=>{const u=f.$yL.ensureUniqueMimeTypes(I.items,!0);return u===I.items?m.NotebookCellOutput.from(I):m.NotebookCellOutput.from({items:u,id:I.id,metadata:I.metadata})})}async z(S,I,u){const d=this.w(I),l=this.y((0,w.$1b)(S));return this.r({editType:n.CellExecutionUpdateType.Output,cellHandle:d,append:u,outputs:l})}async C(S,I,u){return S=f.$yL.ensureUniqueMimeTypes((0,w.$1b)(S),!0),this.r({editType:n.CellExecutionUpdateType.OutputItems,items:S.map(m.NotebookCellOutputItem.from),outputId:I.id,append:u})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(u){S.j=u,S.s([{editType:n.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(u){if(S.f===p.Resolved||S.f===p.Started)throw new Error("Cannot call start again");S.f=p.Started,S.c.fire(),S.s({editType:n.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,d){if(S.f===p.Resolved)throw new Error("Cannot call resolve twice");S.f=p.Resolved,S.c.fire(),S.h.flush(),S.n.$completeExecution(S.b,new v.$iv({runEndTime:d,lastRunSuccess:u}))},clearOutput(u){return S.t(),S.z([],u,!1)},appendOutput(u,d){return S.t(),S.z(u,d,!0)},replaceOutput(u,d){return S.t(),S.z(u,d,!1)},appendOutputItems(u,d){return S.t(),S.C(u,d,!0)},replaceOutputItems(u,d){return S.t(),S.C(u,d,!1)}})}}var s;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(s||(s={}));class i extends A.$Qc{static{this.a=0}get state(){return this.f}constructor(S,I,u){super(),this.h=I,this.j=u,this.b=i.a++,this.c=new F.$Ld,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new C.$Vd),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(S,I){this.e=S,this.f=I,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new M.$ah,this.b=Date.now(),(0,M.$Sg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>S.complete())}}function y($,S){return`${$.value}/${S}`}e.$mdc=y}),define(Ae[245],Re([1,0,5,3,103]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class F{constructor(h,E){this.c=E,this.a=new Map,this.b=h.getProxy(M.$8J.MainThreadNotebookRenderers)}$postRendererMessage(h,E,g){const P=this.c.getEditorById(h);this.a.get(E)?.fire({editor:P.apiEditor,message:g})}createRendererMessaging(h,E){if(!h.contributes?.notebookRenderer?.some(P=>P.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(P,k,a)=>this.d(E).event(P,k,a),postMessage:(P,k)=>{C.$9cc.apiEditorsToExtHost.has(P)&&([P,k]=[k,P]);const a=k&&C.$9cc.apiEditorsToExtHost.get(k);return this.b.$postMessage(a?.id,E,P)}}}d(h){let E=this.a.get(h);return E||(E=new w.$Ld({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(h)}}),this.a.set(h,E),E)}}e.$ndc=F}),define(Ae[246],Re([1,0,6,16,2,26,3]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class h{constructor(g){this.b=new Map,this.a=g.getProxy(A.$8J.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,P,k){if((0,F.$8E)(g,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,k),this.a.$registerProfileContentHandler(P,k.name,k.description,g.identifier.value),(0,w.$Oc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(g,P,k,a){const b=this.b.get(g);if(!b)throw new Error(`Unknown handler with id: ${g}`);return b.saveProfile(P,k,a)}async $readProfile(g,P,k){const a=this.b.get(g);if(!a)throw new Error(`Unknown handler with id: ${g}`);return a.readProfile((0,M.$wf)(P)?P:C.URI.revive(P),k)}}e.$rdc=h}),define(Ae[247],Re([1,0,2,3,13,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class A{static{this.a=0}constructor(E,g){this.d=g,this.c=new Map,this.b=E.getProxy(M.$8J.MainThreadQuickDiff)}$provideOriginalResource(E,g,P){const k=w.URI.revive(g),a=this.c.get(E);return a?(0,C.$Kg)(()=>a.provideOriginalResource(k,P)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(E,g,P,k){const a=A.a++;return this.c.set(a,g),this.b.$registerQuickDiffProvider(a,F.DocumentSelector.from(E,this.d),P,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$sdc=A}),define(Ae[248],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;function m(f,t,n){const c=f.getProxy(F.$8J.MainThreadQuickOpen);class v{constructor(S,I){this.e=new Map,this.f=0,this.a=S,this.b=I}showQuickPick(S,I,u,d=w.CancellationToken.None){this.c=void 0;const l=Promise.resolve(I),R=++this.f,B=c.$show(R,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},d),V={},j=B.then(()=>V);return Promise.race([j,l]).then(W=>{if(W===V)return;const O=(0,a.$7E)(S,"quickPickItemTooltip");return l.then(N=>{const ee=[];for(let X=0;X<N.length;X++){const ye=N[X];if(typeof ye=="string")ee.push({label:ye,handle:X});else if(ye.kind===h.QuickPickItemKind.Separator)ee.push({type:"separator",label:ye.label});else{ye.tooltip&&!O&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const De=ye.iconPath?i(ye.iconPath):void 0;ee.push({label:ye.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:O?b.MarkdownString.fromStrict(ye.tooltip):void 0,handle:X})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=X=>{u.onDidSelectItem(N[X])}),c.$setItems(R,ee),B.then(X=>{if(typeof X=="number")return N[X];if(Array.isArray(X))return X.map(ye=>N[ye])})})}).then(void 0,W=>{if(!(0,E.$2)(W))return c.$setError(R,W),Promise.reject(W)})}$onItemSelected(S){this.c?.(S)}showInput(S,I=w.CancellationToken.None){return this.d=S?.validateInput,c.$input(S,typeof this.d=="function",I).then(void 0,u=>{if(!(0,E.$2)(u))return Promise.reject(u)})}async $validateInput(S){if(!this.d)return;const I=await this.d(S);if(!I||typeof I=="string")return I;let u;switch(I.severity){case h.InputBoxValidationSeverity.Info:u=P.default.Info;break;case h.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case h.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=I.message?P.default.Error:P.default.Ignore;break}return{content:I.message,severity:u}}async showWorkspaceFolderPick(S,I=w.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!u)return;const d=await this.a.getWorkspaceFolders2();if(d)return d.find(l=>l.uri.toString()===u.uri.toString())}createQuickPick(S){const I=new o(S,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(S){const I=new y(S,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(S,I){this.e.get(S)?._fireDidChangeValue(I)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,I){const u=this.e.get(S);u instanceof o&&u._fireDidChangeActive(I)}$onDidChangeSelection(S,I){const u=this.e.get(S);u instanceof o&&u._fireDidChangeSelection(I)}$onDidTriggerButton(S,I){this.e.get(S)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(S,I,u){const d=this.e.get(S);d instanceof o&&d._fireDidTriggerItemButton(I,u)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class D{static{this.a=1}constructor(S,I){this.x=S,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Ld,this.q=new M.$Ld,this.r=new M.$Ld,this.s=new M.$Ld,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((I,u)=>{const d=I===h.$rL.Back?-1:u;this.o.set(d,I)}),this.z({buttons:S.map((I,u)=>({...i(I.iconPath),tooltip:I.tooltip,handle:I===h.$rL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const I=this.o.get(S);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Lc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(S){if(!this.v){for(const I of Object.keys(S)){const u=S[I];this.u[I]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function p($){if($ instanceof h.$4K)return{id:$.id};const S=s($),I=r($);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof I=="string"?A.URI.file(I):I}}function r($){return typeof $=="object"&&"light"in $?$.light:$}function s($){return typeof $=="object"&&"dark"in $?$.dark:$}function i($){const S=p($);let I,u;return"id"in S?u=k.ThemeIcon.asClassName(S):I=S,{iconPath:I,iconClass:u}}class o extends D{constructor(S,I){super(S.identifier,I),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Ld,this.L=[],this.M=new M.$Ld,this.N=new M.$Ld,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((d,l)=>{this.C.set(l,d),this.D.set(d,l)});const I=(0,a.$7E)(this.O,"quickPickItemTooltip"),u=[];for(let d=0;d<S.length;d++){const l=S[d];if(l.kind===h.QuickPickItemKind.Separator)u.push({type:"separator",label:l.label});else{l.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=l.iconPath?i(l.iconPath):void 0;u.push({handle:d,label:l.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,tooltip:I?b.MarkdownString.fromStrict(l.tooltip):void 0,buttons:l.buttons?.map((B,V)=>({...i(B.iconPath),tooltip:B.tooltip,handle:V}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(S){const I=(0,g.$Fb)(S.map(u=>this.C.get(u)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(S){const I=(0,g.$Fb)(S.map(u=>this.C.get(u)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(S,I){const u=this.C.get(S);if(!u||!u.buttons||!u.buttons.length)return;const d=u.buttons[I];d&&this.N.fire({button:d,item:u})}}class y extends D{constructor(S,I){super(S.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:P.default.Error}):this.z({validationMessage:S.message,severity:S.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new v(t,n)}e.$tcc=m}),define(Ae[249],Re([1,0,2,5,65,6,13,3,18,131,14,20,40,8,26,12]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=void 0;function n(d){if(d)return typeof d.iconPath=="string"?w.URI.file(d.iconPath):w.URI.isUri(d.iconPath)||a.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function c(d){if(d.icon){if(w.URI.isUri(d.icon))return d.icon;if(a.ThemeIcon.isThemeIcon(d.icon))return d.icon;{const l=d.icon;return{light:l.light,dark:l.dark}}}else return}function v(d,l){if(!d.iconPath&&!l.iconPath)return 0;if(d.iconPath){if(!l.iconPath)return 1}else return-1;const R=typeof d.iconPath=="string"?d.iconPath:w.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,B=typeof l.iconPath=="string"?l.iconPath:w.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,g.$jq)(R,B)}function D(d,l){let R=0;if(d.strikeThrough!==l.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==l.faded)return d.faded?1:-1;if(d.tooltip!==l.tooltip)return(d.tooltip||"").localeCompare(l.tooltip||"");if(R=v(d,l),R!==0)return R;if(d.light&&l.light)R=v(d.light,l.light);else{if(d.light)return 1;if(l.light)return-1}if(R!==0)return R;if(d.dark&&l.dark)R=v(d.dark,l.dark);else{if(d.dark)return 1;if(l.dark)return-1}return R}function p(d,l){if(d.command!==l.command)return d.command<l.command?-1:1;if(d.title!==l.title)return d.title<l.title?-1:1;if(d.tooltip!==l.tooltip){if(d.tooltip!==void 0&&l.tooltip!==void 0)return d.tooltip<l.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(d.arguments===l.arguments)return 0;if(d.arguments)if(l.arguments){if(d.arguments.length!==l.arguments.length)return d.arguments.length-l.arguments.length}else return 1;else return-1;for(let R=0;R<d.arguments.length;R++){const B=d.arguments[R],V=l.arguments[R];if(B!==V)return B<V?-1:1}return 0}function r(d,l){let R=(0,g.$jq)(d.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(R!==0)return R;if(d.command&&l.command)R=p(d.command,l.command);else{if(d.command)return 1;if(l.command)return-1}if(R!==0)return R;if(d.decorations&&l.decorations)R=D(d.decorations,l.decorations);else{if(d.decorations)return 1;if(l.decorations)return-1}return R}function s(d,l){for(let R=0;R<d.length;R++)if(d[R]!==l[R])return!1;return!0}function i(d,l){return d.command===l.command&&d.title===l.title&&d.tooltip===l.tooltip&&(d.arguments&&l.arguments?s(d.arguments,l.arguments):d.arguments===l.arguments)}function o(d,l){return(0,E.$sb)(d,l,i)}function y(d,l){return d===l?!0:!d||!l?!1:d.id===l.id&&d.label===l.label&&d.upstream?.id===l.upstream?.id&&d.upstream?.label===l.upstream?.label}class ${#e;#t;get value(){return this.d}set value(l){l=l??"",this.#e.$setInputBoxValue(this.l,l),this.n(l)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(l){this.#e.$setInputBoxPlaceholder(this.l,l),this.f=l}get validateInput(){return(0,m.$8E)(this.k,"scmValidation"),this.g}set validateInput(l){if((0,m.$8E)(this.k,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=l,this.#e.$setValidationProviderIsEnabled(this.l,!!l)}get enabled(){return this.h}set enabled(l){l=!!l,this.h!==l&&(this.h=l,this.#e.$setInputBoxEnablement(this.l,l))}get visible(){return this.j}set visible(l){l=!!l,this.j!==l&&(this.j=l,this.#e.$setInputBoxVisibility(this.l,l))}get document(){return(0,m.$8E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(l,R,B,V,j){this.k=l,this.l=V,this.m=j,this.d="",this.e=new M.$Ld,this.f="",this.h=!0,this.j=!0,this.#t=R,this.#e=B}showValidationMessage(l,R){(0,m.$8E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,l,R)}$onInputBoxValueChange(l){this.n(l)}n(l){this.d=l,this.e.fire(l)}}e.$ucc=$;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(l){this.v=l,this.q.$updateGroupLabel(this.t,this.handle,l)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(l){this.p=l,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(l){this.f=[...l],this.k.fire()}constructor(l,R,B,V,j){this.q=l,this.s=R,this.t=B,this.u=V,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Ld,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Ld,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(l){return this.g.get(l)}$executeResourceCommand(l,R){const B=this.h.get(l);return B?(0,A.$Kg)(()=>this.s.executeCommand(B.command,...B.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this.f].sort(r),B=(0,E.$Bb)(this.o,l,r).map(W=>{const O=W.toInsert.map(N=>{const ee=this.e++;this.g.set(ee,N);const X=N.resourceUri;let ye;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const q=new F.$Pc;ye=this.s.converter.toInternal(N.command,q),this.j.set(ee,q)}else this.h.set(ee,N.command);const De=n(N.decorations),Pe=N.decorations&&n(N.decorations.light)||De,Y=N.decorations&&n(N.decorations.dark)||De,le=[Pe,Y],Ee=N.decorations&&N.decorations.tooltip||"",ce=N.decorations&&!!N.decorations.strikeThrough,$e=N.decorations&&!!N.decorations.faded,ie=N.contextValue||"";return{rawResource:[ee,X,le,Ee,ce,$e,ie,ye],handle:ee}});return{start:W.start,deleteCount:W.deleteCount,toInsert:O}}),V=B.map(({start:W,deleteCount:O,toInsert:N})=>[W,O,N.map(ee=>ee.rawResource)]),j=B.reverse();for(const{start:W,deleteCount:O,toInsert:N}of j){const ee=N.map(ye=>ye.handle),X=this.n.splice(W,O,...ee);for(const ye of X)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=l,V}dispose(){this.l=!0,this.m.fire()}}class I{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(l){this.g!==l&&(this.g=l,this.#e.$updateSourceControl(this.x,{count:l}))}get quickDiffProvider(){return this.h}set quickDiffProvider(l){this.h=l;let R;(0,m.$7E)(this.y,"quickDiffProvider")&&(R=l?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!l,quickDiffLabel:R})}get historyProvider(){return(0,m.$8E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(l){(0,m.$8E)(this.y,"scmHistoryProvider"),this.j=l,this.k.value=new F.$Pc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!l}),l&&(this.k.value.add(l.onDidChangeCurrentHistoryItemGroup(()=>{y(this.l,l?.currentHistoryItemGroup)||(this.l=l?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(l.onDidChangeActionButton(()=>{(0,m.$8E)(this.y,"scmActionButton"),this.m.value=new F.$Pc;const R=l.actionButton!==void 0?{command:this.z.converter.toInternal(l.actionButton.command,this.m.value),description:l.actionButton.description,enabled:l.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,R??null)})))}get commitTemplate(){return this.n}set commitTemplate(l){l!==this.n&&(this.n=l,this.#e.$updateSourceControl(this.x,{commitTemplate:l}))}get acceptInputCommand(){return this.p}set acceptInputCommand(l){this.o.value=new F.$Pc,this.p=l;const R=this.z.converter.toInternal(l,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:R})}get actionButton(){return(0,m.$8E)(this.y,"scmActionButton"),this.s}set actionButton(l){(0,m.$8E)(this.y,"scmActionButton"),this.q.value=new F.$Pc,this.s=l;const R=l!==void 0?{command:this.z.converter.toInternal(l.command,this.q.value),secondaryCommands:l.secondaryCommands?.map(B=>B.map(V=>this.z.converter.toInternal(V,this.q.value))),description:l.description,enabled:l.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:R??null})}get statusBarCommands(){return this.u}set statusBarCommands(l){if(this.u&&l&&o(this.u,l))return;this.t.value=new F.$Pc,this.u=l;const R=(l||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:R})}get selected(){return this.v}constructor(l,R,B,V,j,W,O){this.y=l,this.z=V,this.A=j,this.B=W,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Rc,this.m=new F.$Rc,this.n=void 0,this.o=new F.$Rc,this.p=void 0,this.q=new F.$Rc,this.t=new F.$Rc,this.u=void 0,this.v=!1,this.w=new M.$Ld,this.onDidChangeSelection=this.w.event,this.x=I.d++,this.D=new Map,this.E=new Set,this.#e=B;const N=w.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${j}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new $(l,R,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,j,W,O,N)}createResourceGroup(l,R){const B=new S(this.#e,this.z,this.x,l,R),V=M.Event.once(B.onDidDispose)(()=>this.D.delete(B));return this.D.set(B,V),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const l=[],R=[];for(const[B,V]of this.D){V.dispose();const j=B.onDidUpdateResourceStates(()=>{this.E.add(B),this.eventuallyUpdateResourceStates()});M.Event.once(B.onDidDispose)(()=>{this.E.delete(B),j.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),l.push([B.handle,B.id,B.label,B.features]);const W=B._takeResourceStateSnapshot();W.length>0&&R.push([B.handle,W]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,l,R),this.D.clear()}eventuallyUpdateResourceStates(){const l=[];this.E.forEach(R=>{const B=R._takeResourceStateSnapshot();B.length!==0&&l.push([R.handle,B])}),l.length>0&&this.#e.$spliceResourceStates(this.x,l),this.E.clear()}getResourceGroup(l){return this.e.get(l)}setSelectionState(l){this.v=l,this.w.fire(l)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(l=>l.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,C.$fh)(100)],I.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$fh)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(l,R,B,V){this.l=R,this.m=B,this.n=V,this.g=new Map,this.h=new k.$Zl,this.j=new M.$Ld,this.e=l.getProxy(h.$8J.MainThreadSCM),this.f=l.getProxy(h.$8J.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const W=this.g.get(j.sourceControlHandle);if(!W)return j;const O=W.getResourceGroup(j.groupHandle);return O?O.getResourceState(j.handle):j}else if(j&&j.$mid===4){const W=this.g.get(j.sourceControlHandle);return W?W.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const W=this.g.get(j.handle);return W||j}return j}})}createSourceControl(l,R,B,V){this.n.trace("ExtHostSCM#createSourceControl",l.identifier.value,R,B,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const j=t.d++,W=new I(l,this.m,this.e,this.l,R,B,V);this.g.set(j,W);const O=this.h.get(l.identifier)||[];return O.push(W),this.h.set(l.identifier,O),W}getLastInputBox(l){this.n.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const R=this.h.get(l.identifier),B=R&&R[R.length-1];return B&&B.inputBox}$provideOriginalResource(l,R,B){const V=w.URI.revive(R);this.n.trace("ExtHostSCM#$provideOriginalResource",l,V.toString());const j=this.g.get(l);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Kg)(()=>j.quickDiffProvider.provideOriginalResource(V,B)).then(W=>W||null)}$onInputBoxValueChange(l,R){this.n.trace("ExtHostSCM#$onInputBoxValueChange",l);const B=this.g.get(l);return B&&B.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(l,R,B,V){this.n.trace("ExtHostSCM#$executeResourceCommand",l,R,B);const j=this.g.get(l);if(!j)return Promise.resolve(void 0);const W=j.getResourceGroup(R);return W?W.$executeResourceCommand(B,V):Promise.resolve(void 0)}$validateInput(l,R,B){this.n.trace("ExtHostSCM#$validateInput",l);const V=this.g.get(l);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Kg)(()=>V.inputBox.validateInput(R,B)).then(j=>{if(!j)return Promise.resolve(void 0);const W=b.MarkdownString.fromStrict(j.message);return W?Promise.resolve([W,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this.g.get(l)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=l,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(l,R,B){return await this.g.get(l)?.historyProvider?.resolveHistoryItemGroupBase(R,B)??void 0}async $resolveHistoryItemGroupCommonAncestor(l,R,B,V){return await this.g.get(l)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(R,B,V)??void 0}async $provideHistoryItems(l,R,B,V){return(await this.g.get(l)?.historyProvider?.provideHistoryItems(R,B,V))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:c(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(l,R,B){return await this.g.get(l)?.historyProvider?.provideHistoryItemChanges(R,B)??void 0}};e.$vcc=u,e.$vcc=u=t=Ke([Ve(3,P.$7i)],u)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;class F{constructor(h){this.b=new M.$Ld,this.onDidChangePassword=this.b.event,this.a=h.getProxy(w.$8J.MainThreadSecretState)}async $onDidChangePassword(h){this.b.fire(h)}get(h,E){return this.a.$getPassword(h,E)}store(h,E,g){return this.a.$setPassword(h,E,g)}delete(h,E){return this.a.$deletePassword(h,E)}}e.$acc=F,e.$bcc=(0,C.$Mh)("IExtHostSecretState")}),define(Ae[250],Re([1,0,3,8,2]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class F{static{this.a=0}constructor(h,E){this.d=E,this.c=new Map,this.b=h.getProxy(w.$8J.MainThreadShare)}async $provideShare(h,E,g){return await this.c.get(h)?.provideShare({selection:M.Range.to(E.selection),resourceUri:C.URI.revive(E.resourceUri)},g)??void 0}registerShareProvider(h,E){const g=F.a++;return this.c.set(g,E),this.b.$registerShareProvider(g,M.DocumentSelector.from(h,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$xdc=F}),define(Ae[251],Re([1,0,7,3,153,6,8,16]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$5K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$5K("statusBarItem.warningForeground")]])}#e;#t;constructor(a,b,m,f,t,n=w.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new F.$Pc,this.#e=a,this.#t=b,t&&f){this.c=(0,w.$HK)(f.identifier,t);const v=m.get(this.c);v&&(n=v.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,c=v.priority,this.j=!0,this.name=v.name,this.text=v.text,this.tooltip=v.tooltip,this.command=v.command,this.accessibilityInformation=v.accessibilityInformation)}else this.c=String(E.a++);this.e=f,this.f=t,this.g=n,this.h=this.u(c)}u(a){if((0,h.$Af)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!E.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new F.$Pc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let b;this.m?b=this.m:b=(0,C.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=E.b.get(this.o.id));const f=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,b,this.k,f,this.r?.internal,m,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$wcc=E;class g{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const b={message:a};return this.b.unshift(b),this.c(),new w.$0J(()=>{const m=this.b.indexOf(b);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(a,b){this.e=new Map,this.a=a.getProxy(M.$8J.MainThreadStatusBar),this.b=b,this.c=new g(this)}$acceptStaticEntries(a){for(const b of a)this.e.set(b.entryId,b)}createStatusBarEntry(a,b,m,f){return new E(this.a,this.b,this.e,a,b,m,f)}setStatusBarMessage(a,b){const m=this.c.setMessage(a);let f;return typeof b=="number"?f=setTimeout(()=>m.dispose(),b):typeof b<"u"&&b.then(()=>m.dispose(),()=>m.dispose()),new w.$0J(()=>{m.dispose(),clearTimeout(f)})}}e.$xcc=P}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=void 0;class F{constructor(h,E){this.c=E,this.b=new M.$Ld,this.onDidChangeStorage=this.b.event,this.a=h.getProxy(w.$8J.MainThreadStorage)}registerExtensionStorageKeysToSync(h,E){this.a.$registerExtensionStorageKeysToSync(h,E)}async initializeExtensionStorage(h,E,g){const P=await this.a.$initializeExtensionStorage(h,E);let k;return P&&(k=this.d(h,E,P)),k||g}setValue(h,E,g){return this.a.$setValue(h,E,g)}$acceptValue(h,E,g){const P=this.d(h,E,g);P&&this.b.fire({shared:h,key:E,value:P})}d(h,E,g){try{return JSON.parse(g)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${h}): ${P}`)}}}e.$1bc=F,e.$2bc=(0,C.$Mh)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=void 0,e.$7bc=(0,w.$Mh)("IExtensionStoragePaths");let h=class{constructor(g,P,k){this.d=P,this.f=k,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(g){return A.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,P=await this.g(g);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(g){if(this.c)return A.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return A.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$8bc=h,e.$8bc=h=Ke([Ve(0,M.$mM),Ve(1,C.$7i),Ve(2,F.$6bc)],h)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,155,9,181,21,36,182,40,13,8,31]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=e.$0bc=e.$9bc=void 0,e.$9bc=(0,C.$Mh)("IExtHostTerminalService");class v{constructor(u,d,l,R){this.l=u,this._id=d,this.m=l,this.n=R,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(V=>this.f=V);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(V,j=!0){B.q(),B.l.$sendText(B._id,V,j)},show(V){B.q(),B.l.$show(B._id,V)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(u,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:y(u.iconPath)??void 0,color:f.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:d?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:d?.useShellEnvironment??void 0,location:d?.location||this.o(u.location,d?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,d,l,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:l,color:f.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.o(u,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,d){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in u?{viewColumn:n.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,d){this.h=Object.freeze({code:u,reason:d})}setDimensions(u,d){return u===this.d&&d===this.g||u===0||d===0?!1:(this.d=u,this.g=d,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(d=>{d!==u&&(this.b=Promise.resolve(u))})}}e.$0bc=v;class D{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new w.$Ld,this.onProcessData=this.a.event,this.b=new w.$Ld,this.d=new w.$Ld,this.onDidChangeProperty=this.d.event,this.f=new w.$Ld,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${d}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,d){this.g.setDimensions?.({columns:u,rows:d})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(d=>this.a.fire(d)),this.g.onDidClose?.((d=void 0)=>{this.f.fire(d===void 0?void 0:d)}),this.g.onDidOverrideDimensions?.(d=>{d&&this.d.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this.g.onDidChangeName?.(d=>{this.d.fire({type:"title",value:d})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let p=1,r=class extends h.$Qc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,d,l){super(),this.Q=d,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new h.$Rc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$Ld,this.onDidCloseTerminal=this.H.event,this.I=new w.$Ld,this.onDidOpenTerminal=this.I.event,this.J=new w.$Ld,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$Ld,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$Ld,this.onDidChangeTerminalState=this.M.event,this.N=new w.$Ld,this.onDidChangeShell=this.N.event,this.O=new w.$Ld({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$Ld({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=l.getProxy(M.$8J.MainThreadTerminalService),this.y=new m.$Ckb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:R=>{const B=V=>{const j=V;return this.W(j.instanceId)?.value};switch(R?.$mid){case 15:return B(R);default:{if(Array.isArray(R))for(let V=0;V<R.length&&R[V].$mid===15;V++)R[V]=B(R[V]);return R}}}}),this.B({dispose:()=>{for(const[R,B]of this.g)B.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,d){const l=new v(this.a,(0,b.$cg)(),u,u.name),R=new D(u.pty);return l.createExtensionTerminal(u.location,this.R(u,d).resolvedExtHostIdentifier,y(u.iconPath),$(u.color)).then(B=>{const V=this.S(B,R);this.h[B]=V}),this.f.push(l),l.value}R(u,d){if(d=d||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const l=u.location.parentTerminal;if(l){const R=this.f.find(B=>B.value===l);R&&(d.resolvedExtHostIdentifier=R._id)}}else u.location&&typeof u.location!="object"?d.location=u.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(u,d){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const R=new D(d),B=this.S(u,R);this.h[u]=B}async $acceptActiveTerminalChanged(u){const d=this.b;if(u===null){this.b=void 0,d!==this.b&&this.J.fire(this.b);return}const l=this.W(u);l&&(this.b=l,d!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,d){const l=this.W(u);l&&this.O.fire({terminal:l.value,data:d})}async $acceptTerminalDimensions(u,d,l){const R=this.W(u);R&&R.setDimensions(d,l)&&this.L.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(u,d){const l=this.W(u);l&&this.P.fire({terminal:l.value,...d})}async $acceptTerminalMaximumDimensions(u,d,l){this.g.get(u)?.resize(d,l)}async $acceptTerminalTitleChange(u,d){const l=this.W(u);l&&(l.name=d)}async $acceptTerminalClosed(u,d,l){const R=this.Y(this.f,u);if(R!==null){const B=this.f.splice(R,1)[0];B.setExitStatus(d,l),this.H.fire(B.value)}}$acceptTerminalOpened(u,d,l,R){if(d){const j=this.Y(this.f,d);if(j!==null){this.f[j]._id=u,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const B={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:F.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new v(this.a,u,B,l);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(u,d){this.W(u)?._setProcessId(d)}async $startExtensionTerminal(u,d){const l=this.W(u);if(!l)return{message:(0,g.localize)(0,null,u)};l.isOpen||await new Promise(B=>{const V=this.onDidOpenTerminal(async j=>{j===l.value&&(V.dispose(),B())})});const R=this.g.get(u);R?R.startSendingEvents(d):this.j[u]={initialDimensions:d}}S(u,d){const l=new h.$Pc;l.add(d.onProcessReady(B=>this.a.$sendProcessReady(u,B.pid,B.cwd,B.windowsPty))),l.add(d.onDidChangeProperty(B=>this.a.$sendProcessProperty(u,B))),this.y.startBuffering(u,d.onProcessData),l.add(d.onProcessExit(B=>this.U(u,B))),this.g.set(u,d);const R=this.j[u];return R&&d instanceof D&&(d.startSendingEvents(R.initialDimensions),delete this.j[u]),l}$acceptProcessAckDataEvent(u,d){this.g.get(u)?.acknowledgeDataEvent(d)}$acceptProcessInput(u,d){this.g.get(u)?.input(d)}$acceptTerminalInteraction(u){const d=this.W(u);d?.setInteractedWith()&&this.M.fire(d.value)}$acceptTerminalSelection(u,d){this.W(u)?.setSelection(d)}$acceptProcessResize(u,d,l){try{this.g.get(u)?.resize(d,l)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(u,d){this.g.get(u)?.shutdown(d)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(d=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(d=>this.a.$sendProcessProperty(u,{type:"cwd",value:d}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new E.$0J(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,d,l){if(this.C.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this.C.set(d,l),this.a.$registerProfileProvider(d,u.identifier.value),new E.$0J(()=>{this.C.delete(d),this.a.$unregisterProfileProvider(d)})}registerTerminalQuickFixProvider(u,d,l){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,l),this.a.$registerQuickFixProvider(u,d),new E.$0J(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,d){const l=new a.$Vd().token;if(l.isCancellationRequested)return;const R=this.D.get(u);if(!R)return;const B=await R.provideTerminalQuickFixes(d,l);if(B===null||Array.isArray(B)&&B.length===0)return;const V=new h.$Pc;if(this.w.value=V,!Array.isArray(B))return B?n.TerminalQuickFix.from(B,this.Q.converter,V):void 0;const j=[];for(const W of B){const O=n.TerminalQuickFix.from(W,this.Q.converter,V);O&&j.push(O)}return j}async $createContributedProfileTerminal(u,d){const l=new a.$Vd().token;let R=await this.C.get(u)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,d);return}this.createTerminalFromOptions(R.options,d)}}async $provideLinks(u,d){const l=this.W(u);if(!l)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const B=new a.$Vd;this.G.set(u,B);const V=[],j={terminal:l.value,line:d},W=[];for(const ee of this.z)W.push(t.Promises.withAsyncBody(async X=>{B.token.onCancellationRequested(()=>X({provider:ee,links:[]}));const ye=await ee.provideTerminalLinks(j,B.token)||[];B.token.isCancellationRequested||X({provider:ee,links:ye})}));const O=await Promise.all(W);if(B.token.isCancellationRequested)return[];const N=new Map;for(const ee of O)ee&&ee.links.length>0&&V.push(...ee.links.map(X=>{const ye={id:p++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return N.set(ye.id,{provider:ee.provider,link:X}),ye}));return this.F.set(u,N),V}$activateLink(u,d){const l=this.F.get(u)?.get(d);l&&l.provider.handleTerminalLink(l.link)}U(u,d){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const l=this.h[u];l&&(l.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,d)}W(u){return this.X(this.f,u)}X(u,d){const l=this.Y(u,d);return l!==null?u[l]:null}Y(u,d){const l=u.findIndex(R=>R._id===d);return l===-1?null:l}getEnvironmentVariableCollection(u){let d=this.n.get(u.identifier.value);return d||(d=new s,this.$(u.identifier.value,d)),d.getScopedEnvironmentVariableCollection(void 0)}Z(u,d){const l=(0,k.$cr)(d.map),R=(0,k.$dr)(d.descriptionMap);this.a.$setEnvironmentVariableCollection(u,d.persistent,l.length===0?void 0:l,R)}$initEnvironmentVariableCollections(u){u.forEach(d=>{const l=d[0],R=new s(d[1]);this.$(l,R)})}$acceptDefaultProfile(u,d){const l=this.s;this.s=u,this.u=d,l?.path!==u.path&&this.N.fire(u.path)}$(u,d){this.n.set(u,d),d.onDidChangeCollection(()=>{this.Z(u,d)})}};e.$$bc=r,e.$$bc=r=Ke([Ve(1,c.$sM),Ve(2,A.$9L)],r);class s{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$Ld,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const d=this.h(u);let l=this.a.get(d);return l||(l=new i(this,u),this.a.set(d,l),l.onDidChangeCollection(()=>this.d.fire())),l}replace(u,d,l,R){this.f(u,{value:d,type:E.EnvironmentVariableMutatorType.Replace,options:l??{applyAtProcessCreation:!0},scope:R})}append(u,d,l,R){this.f(u,{value:d,type:E.EnvironmentVariableMutatorType.Append,options:l??{applyAtProcessCreation:!0},scope:R})}prepend(u,d,l,R){this.f(u,{value:d,type:E.EnvironmentVariableMutatorType.Prepend,options:l??{applyAtProcessCreation:!0},scope:R})}f(u,d){if(d.options&&d.options.applyAtProcessCreation===!1&&!d.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const l=this.g(u,d.scope),R=this.map.get(l),B=d.options?{applyAtProcessCreation:d.options.applyAtProcessCreation??!1,applyAtShellIntegration:d.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==d.value||R.type!==d.type||R.options?.applyAtProcessCreation!==B.applyAtProcessCreation||R.options?.applyAtShellIntegration!==B.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index){const V=this.g(u,d.scope),j={variable:u,...d,options:B};this.map.set(V,j),this.d.fire()}}get(u,d){const l=this.g(u,d),R=this.map.get(l);return R?S(R):void 0}g(u,d){const l=this.h(d);return l.length?`${u}:::${l}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const d=new Map;for(const[l,R]of this.map)this.h(R.scope)===this.h(u)&&d.set(R.variable,S(R));return d}delete(u,d){const l=this.g(u,d);this.map.delete(l),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[d,l]of this.map)l.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(d);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,d){const l=this.h(d),R=this.descriptionMap.get(l);if(!R||R.description!==u){let B;typeof u=="string"?B=u:B=u?.value.split(`

`)[0];const V={description:B,scope:d};this.descriptionMap.set(l,V),this.d.fire()}}getDescription(u){const d=this.h(u);return this.descriptionMap.get(d)?.description}k(u){const d=this.h(u);this.descriptionMap.delete(d)}}class i{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,d){this.b=u,this.d=d,this.a=new w.$Ld}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,d,l){this.b.replace(u,d,l,this.d)}append(u,d,l){this.b.append(u,d,l,this.d)}prepend(u,d,l){this.b.prepend(u,d,l,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,d){this.b.getVariableMap(this.d).forEach((l,R)=>u.call(d,R,l,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends r{constructor(u,d){super(!1,u,d)}createTerminal(u,d,l){throw new P.$0}createTerminalFromOptions(u,d){throw new P.$0}};e.$_bc=o,e.$_bc=o=Ke([Ve(0,c.$sM),Ve(1,A.$9L)],o);function y(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function $(I){return f.ThemeColor.isThemeColor(I)?I:void 0}function S(I){const u={...I};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[252],Re([1,0,281,13,25,21,5,202,93,6,24,16,36,3,17,104,8,7,45,76,57,26]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=e.$hdc=e.$gdc=void 0;let r=class{constructor(j,W,O){this.k=O,this.d=new A.$Ld,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=j.getProxy(b.$8J.MainThreadTesting),this.j=new l(this.g),this.h=new y(this.g),W.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const ee=N,X=ee.tests[ee.tests.length-1].item.extId;return this.f.get(c.$1I.root(X))?.collection.tree.get(X)?.actual??(0,f.$iM)(N)}case 18:{const{extId:ee,message:X}=N;return{test:this.f.get(c.$1I.root(ee))?.collection.tree.get(ee)?.actual,message:t.TestMessage.to(X)}}default:return N}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await W.executeCommand("_testing.getExplorerSelection"),ee=X=>{const ye=this.f.get(c.$1I.root(X));if(ye)return c.$1I.isRoot(X)?ye.controller:ye.collection.tree.get(X)?.actual};return{include:N?.include.map(ee).filter(k.$Ef)||[],exclude:N?.exclude.map(ee).filter(k.$Ef)||[]}})}createTestController(j,W,O,N){if(this.f.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const ee=new g.$Pc,X=ee.add(new f.$lM(W,O,this.k));X.root.label=O;const ye=new Map,De=this.g,Pe={items:X.root.children,get label(){return O},set label(le){O=le,X.root.label=le,De.$updateController(W,{label:O})},get refreshHandler(){return N},set refreshHandler(le){N=le,De.$updateController(W,{canRefresh:!!le})},get id(){return W},createRunProfile:(le,Ee,ce,$e,ie,z)=>{let q=(0,E.$Ai)(le);for(;ye.has(q);)q++;return new R(this.g,ye,W,q,le,Ee,ce,$e,ie,z)},createTestItem(le,Ee,ce){return new f.$jM(W,le,Ee,ce)},createTestRun:(le,Ee,ce=!0)=>this.h.createTestRun(j,W,X,le,Ee,ce),invalidateTestResults:le=>{if(le===void 0)this.g.$markTestRetired(void 0);else{const Ee=le instanceof Array?le:[le];this.g.$markTestRetired(Ee.map(ce=>c.$1I.fromExtHostTestItem(ce,W).toString()))}},set resolveHandler(le){X.resolveHandler=le},get resolveHandler(){return X.resolveHandler},dispose:()=>{ee.dispose()}};De.$registerTestController(W,O,!!N),ee.add((0,g.$Oc)(()=>De.$unregisterTestController(W)));const Y={controller:Pe,collection:X,profiles:ye,extension:j};return this.f.set(W,Y),ee.add((0,g.$Oc)(()=>this.f.delete(W))),ee.add(X.onDidGenerateDiff(le=>De.$publishDiff(W,le.map(D.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(j,W=F.CancellationToken.None){const O=$(j);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(ee=>c.$1I.fromExtHostTestItem(ee,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:B[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:j.exclude?.map(ee=>ee.id)},W)}$syncTests(){for(const{collection:j}of this.f.values())j.flushDiff();return Promise.resolve()}$provideFileCoverage(j,W,O){return(0,w.$pb)(this.h.trackers,ee=>ee.id===j?ee.getCoverage(W):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(j,W,O,N){return(0,w.$pb)(this.h.trackers,X=>X.id===j?X.getCoverage(W):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(j,W){this.f.get(j)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(j,W){await this.f.get(j)?.controller.refreshHandler?.(W)}$publishTestResults(j){this.results=Object.freeze(j.map(W=>(0,P.$Ym)(t.TestResults.to(W))).concat(this.results).sort((W,O)=>O.completedAt-W.completedAt).slice(0,32)),this.d.fire()}async $expandTest(j,W){const O=this.f.get(c.$1I.fromString(j).controllerId)?.collection;O&&(await O.expand(j,W<0?1/0:W),O.flushDiff())}$acceptDiff(j){this.j.applyDiff(j.map(D.TestsDiffOp.deserialize))}async $runControllerTests(j,W){return Promise.all(j.map(O=>this.l(O,!1,W)))}async $startContinuousRun(j,W){const O=new F.$Vd(W),N=await Promise.all(j.map(ee=>this.l(ee,!0,O.token)));return!W.isCancellationRequested&&!N.some(ee=>ee.error)&&await new Promise(ee=>W.onCancellationRequested(ee)),O.dispose(!0),N}async l(j,W,O){const N=this.f.get(j.controllerId);if(!N)return{};const{collection:ee,profiles:X,extension:ye}=N,De=X.get(j.profileId);if(!De)return{};const Pe=j.testIds.map(ce=>ee.tree.get(ce)).filter(k.$Ef),Y=j.excludeExtIds.map(ce=>N.collection.tree.get(ce)).filter(k.$Ef).filter(ce=>Pe.some($e=>$e.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const le=new n.$FL(Pe.some(ce=>ce.actual instanceof f.$kM)?void 0:Pe.map(ce=>ce.actual),Y.map(ce=>ce.actual),De,W),Ee=(0,D.$3I)(j)&&this.h.prepareForMainThreadTestRun(le,S.fromInternal(j,N.collection),ye,O);try{return await De.runHandler(le,O),{}}catch(ce){return{error:String(ce)}}finally{Ee&&(Ee.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(Ee.onEnd),Ee.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.h.cancelAllRuns():this.h.cancelRunById(j)}};e.$gdc=r,e.$gdc=r=Ke([Ve(0,m.$9L)],r);const s=1e4;var i;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(i||(i={}));class o extends g.$Qc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(j,W,O,N){super(),this.s=j,this.u=W,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Ld),this.onEnd=this.m.event,this.j=this.B(new F.$Vd(N));const ee=this.B(new M.$4g(()=>this.y(),s));this.B(this.j.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(j){return this.g.get(j)?.coverage}createRun(j){const W=this.s.id,O=this.s.controllerId,N=(0,a.$cg)(),ee=new I(this.u,W,N),X=Y=>(le,...Ee)=>{if(De){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.s.isIncluded(le)&&(this.C(le),Y(le,...Ee))},ye=(Y,le)=>{const Ee=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(Ee.some(ce=>ce.contextValue!==void 0)&&(0,p.$8E)(this.w,"testMessageContextValue"),Y.uri&&Y.range){const ce={range:t.Range.from(Y.range),uri:Y.uri};for(const $e of Ee)$e.location=$e.location||ce}this.u.$appendTestMessagesInRun(W,N,c.$1I.fromExtHostTestItem(Y,O).toString(),Ee)};let De=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:j,get coverageProvider(){return ee.coverageProvider},set coverageProvider(Y){ee.coverageProvider=Y},enqueued:X(Y=>{this.u.$updateTestStateInRun(W,N,c.$1I.fromExtHostTestItem(Y,O).toString(),1)}),skipped:X(Y=>{this.u.$updateTestStateInRun(W,N,c.$1I.fromExtHostTestItem(Y,O).toString(),5)}),started:X(Y=>{this.u.$updateTestStateInRun(W,N,c.$1I.fromExtHostTestItem(Y,O).toString(),2)}),errored:X((Y,le,Ee)=>{ye(Y,le),this.u.$updateTestStateInRun(W,N,c.$1I.fromExtHostTestItem(Y,O).toString(),6,Ee)}),failed:X((Y,le,Ee)=>{ye(Y,le),this.u.$updateTestStateInRun(W,N,c.$1I.fromExtHostTestItem(Y,O).toString(),4,Ee)}),passed:X((Y,le)=>{this.u.$updateTestStateInRun(W,N,c.$1I.fromExtHostTestItem(Y,this.s.controllerId).toString(),3,le)}),appendOutput:(Y,le,Ee)=>{De||(Ee&&(this.s.isIncluded(Ee)?this.C(Ee):Ee=void 0),this.u.$appendOutputToRun(W,N,C.$_d.fromString(Y),le&&t.location.from(le),Ee&&c.$1I.fromExtHostTestItem(Ee,O).toString()))},end:()=>{De||(De=!0,this.u.$finishedTestRunTask(W,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:ee}),this.u.$startedTestRunTask(W,{id:N,name:j,running:!0}),Pe}y(){for(const{run:j}of this.g.values())j.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(j){if(!(j instanceof f.$jM))throw new v.$1L(j.id);if(this.h.has(c.$1I.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const W=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(j);if(W.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),j===O))break;j=j.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.d.values()}constructor(j){this.f=j,this.d=new Map}prepareForMainThreadTestRun(j,W,O,N){return this.g(j,W,O,N)}cancelRunById(j){for(const W of this.d.values())if(W.id===j){W.cancel();return}}cancelAllRuns(){for(const j of this.d.values())j.cancel()}createTestRun(j,W,O,N,ee,X){const ye=this.d.get(N);if(ye)return ye.createRun(ee);const De=S.fromPublic(W,O,N,X),Pe=$(N);this.f.$startedExtensionTestRun({controllerId:W,continuous:!!N.continuous,profile:Pe&&{group:B[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(le=>c.$1I.fromExtHostTestItem(le,O.root.id).toString())??[],id:De.id,include:N.include?.map(le=>c.$1I.fromExtHostTestItem(le,O.root.id).toString())??[O.root.id],persist:X});const Y=this.g(N,De,j);return A.Event.once(Y.onEnd)(()=>{this.f.$finishedExtensionTestRun(De.id),Y.dispose()}),Y.createRun(ee)}g(j,W,O,N){const ee=new o(W,this.f,O,N);return this.d.set(j,ee),A.Event.once(ee.onEnd)(()=>this.d.delete(j)),ee}}e.$hdc=y;const $=V=>{if(V.profile){if(!(V.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class S{static fromPublic(j,W,O,N){return new S(j,(0,a.$cg)(),O.include?.map(ee=>c.$1I.fromExtHostTestItem(ee,j).toString())??[j],O.exclude?.map(ee=>c.$1I.fromExtHostTestItem(ee,j).toString())??[],N,W)}static fromInternal(j,W){return new S(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,W)}constructor(j,W,O,N,ee,X){this.controllerId=j,this.id=W,this.isPersisted=ee,this.colllection=X,this.d=O.map(ye=>ye+"\0"),this.f=N.map(ye=>ye+"\0")}isIncluded(j){const W=c.$1I.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const O of this.f)if(W===O||W.startsWith(O))return!1;for(const O of this.d)if(W===O||W.startsWith(O))return!0;return!1}}e.$idc=S;class I{set coverageProvider(j){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");j&&(this.d=j,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(j,W,O){this.g=j,this.h=W,this.j=O}async provideFileCoverage(j){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(j))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(W){throw this.f=void 0,W}}async resolveFileCoverage(j,W){const O=await this.f;let N=O?.[j];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[j]=await this.d.resolveFileCoverage?.(N,W)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.d.add(j)}update(j){Object.assign(j.revived,t.TestItem.toPlain(j.item)),this.d.has(j)||this.f.add(j)}remove(j){if(this.d.has(j)){this.d.delete(j);return}this.f.delete(j);const W=c.$1I.parentId(j.item.extId);if(W&&this.h.has(W.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{d:j,f:W,g:O}=this;return{get added(){return[...j].map(N=>N.revived)},get updated(){return[...W].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends D.$8I{constructor(){super(...arguments),this.s=new A.$Ld,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}q(j,W){return{...j,revived:t.TestItem.toPlain(j.item),depth:W?W.depth+1:0,children:new Set}}p(){return new u(this.s)}}class l{constructor(j){this.f=j}checkout(){this.d||(this.d=this.g());const j=this.d;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(W=>W.revived)},dispose:(0,h.$bb)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(j){return this.d?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.d?.tests.apply(j)}g(){const j=new d;return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}class R{#e;#t;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(j){j!==this.h&&(this.h=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.g}set isDefault(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?t.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.d}set configureHandler(j){j!==this.d&&(this.d=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}constructor(j,W,O,N,ee,X,ye,De=!1,Pe=void 0,Y=!1){this.controllerId=O,this.profileId=N,this.f=ee,this.kind=X,this.runHandler=ye,this.g=De,this._tag=Pe,this.h=Y,this.#e=j,this.#t=W,W.set(N,this);const le=B[X];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:le,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:Y})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$jdc=R;const B={[n.TestRunProfileKind.Coverage]:8,[n.TestRunProfileKind.Debug]:4,[n.TestRunProfileKind.Run]:2}}),define(Ae[253],Re([1,0,18,9,5,3,105,8,7]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class g{constructor(k,a){this.i=a,this.a=new C.$Ld({onListenerError:M.$Z}),this.b=new C.$Ld({onListenerError:M.$Z}),this.c=new C.$Ld({onListenerError:M.$Z}),this.d=new C.$Ld({onListenerError:M.$Z}),this.f=new C.$Ld({onListenerError:M.$Z}),this.g=new C.$Ld({onListenerError:M.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(F.$8J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const a=this.i.allEditors();return k?a:a.map(b=>b.value)}async showTextDocument(k,a,b){let m;typeof a=="number"?m={position:h.ViewColumn.from(a),preserveFocus:b}:typeof a=="object"?m={position:h.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?h.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:m={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(k.uri,m),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,a){return new A.$dM(this.h,k,a).value}$acceptEditorPropertiesChanged(k,a){const b=this.i.getEditor(k);if(!b)throw new Error("unknown text editor");if(a.options&&b._acceptOptions(a.options),a.selections){const m=a.selections.selections.map(h.Selection.to);b._acceptSelections(m)}if(a.visibleRanges){const m=w.$Fb(a.visibleRanges.map(h.Range.to));b._acceptVisibleRanges(m)}if(a.options&&this.b.fire({textEditor:b.value,options:{...a.options,lineNumbers:h.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const m=E.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map(h.Selection.to);this.a.fire({textEditor:b.value,selections:f,kind:m})}if(a.visibleRanges){const m=w.$Fb(a.visibleRanges.map(h.Range.to));this.c.fire({textEditor:b.value,visibleRanges:m})}}$acceptEditorPositionData(k){for(const a in k){const b=this.i.getEditor(a);if(!b)throw new Error("Unknown text editor");const m=h.ViewColumn.to(k[a]);b.value.viewColumn!==m&&(b._acceptViewColumn(m),this.d.fire({textEditor:b.value,viewColumn:m}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$ycc=g}),define(Ae[254],Re([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=void 0,e.$adc=(0,M.$Mh)("IExtHostTimeline");class P{constructor(b,m){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.$8J.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&E.$Xl.equals(t,this.b.get(f.source)?.extension)){const n=f.uri===void 0?void 0:w.URI.revive(f.uri);return this.c.get(f.source)?.get(k(n))?.get(f.handle)}else return;return f}})}async $getTimeline(b,m,f,t){return this.b.get(b)?.provider.provideTimeline(w.URI.revive(m),f,t)}registerTimelineProvider(b,m,f,t){const n=new F.$Pc,c=this.d(m.id,t,n).bind(this);let v;m.onDidChange&&(v=m.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:m.id}),this));const D=this.c;return this.f({...m,scheme:b,onDidChange:void 0,async provideTimeline(p,r,s){r?.resetCache&&(n.clear(),D.get(m.id)?.clear());const i=await m.provideTimeline(p,r,s);if(i==null)return;const o=c(p,r);return{...i,source:m.id,items:i.items.map(o)}},dispose(){for(const p of D.values())p.get(m.id)?.clear();v?.dispose(),n.dispose()}},f)}d(b,m,f){return(t,n)=>{let c;if(n?.cacheResults){let v=this.c.get(b);v===void 0&&(v=new Map,this.c.set(b,v));const D=k(t);c=v.get(D),c===void 0&&(c=new Map,v.set(D,c))}return v=>{const{iconPath:D,...p}=v,r=`${b}|${v.id??v.timestamp}`;c?.set(r,v);let s,i,o;v.iconPath&&(D instanceof A.$4K?o={id:D.id,color:D.color}:w.URI.isUri(D)?(s=D,i=D):{light:s,dark:i}=D);let y;return A.$xK.isMarkdownString(p.tooltip)?y=h.MarkdownString.from(p.tooltip):(0,g.$wf)(p.tooltip)?y=p.tooltip:A.$xK.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=h.MarkdownString.from(p.detail)):(0,g.$wf)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=p.detail),{...p,id:p.id??void 0,handle:r,source:b,command:v.command?m.toInternal(v.command,f):void 0,icon:s,iconDark:i,themeIcon:o,tooltip:y,accessibilityInformation:v.accessibilityInformation}}}}f(b,m){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:m}),(0,F.$Oc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$bdc=P;function k(a){return a?.toString()}}),define(Ae[86],Re([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pvb=e.$Ovb=e.TunnelDtoConverter=void 0;class b extends E.$$u{}var m;(function(t){function n(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:v.protocol}}t.fromApiTunnel=n;function c(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==E.TunnelPrivacyId.ConstantPrivate&&v.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}t.fromServiceTunnel=c})(m||(e.TunnelDtoConverter=m={})),e.$Ovb=(0,A.$Mh)("IExtHostTunnelService");let f=class extends C.$Qc{constructor(n,c,v){super(),this.s=v,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Ld,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=n.getProxy(g.$8J.MainThreadTunnelService)}async openTunnel(n,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const v=await this.a.$openTunnel(c,n.displayName);if(v){const D=new b(v.remoteAddress,v.localAddress,()=>this.a.$closeTunnel(v.remoteAddress));return this.B(D),D}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(n,c){const v=this.u();return this.r.set(v,{selector:n,provider:c}),this.a.$registerPortsAttributesProvider(n,v),new a.$0J(()=>{this.r.delete(v),this.a.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(n,c,v,D,p){const r=[];for(const i of n){const o=this.r.get(i);if(!o)return[];r.push(...await Promise.all(c.map(async y=>{let $;try{$=await o.provider.providePortAttributes({port:y,pid:v,commandLine:D},p)}catch{$=await o.provider.providePortAttributes(y,v,D,p)}return{providedAttributes:$,port:y}})))}const s=r.filter(i=>!!i.providedAttributes);return s.length>0?s.map(i=>({autoForwardAction:i.providedAttributes.autoForwardAction,port:i.port})):[]}async $registerCandidateFinder(n){}registerTunnelProvider(n,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(D,p)=>await n.provideTunnel(D,p,new w.$Vd().token)??void 0;const v=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(v),Promise.resolve((0,C.$Oc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(n,c){if(n){n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.f=n.showCandidatePort,this.a.$setCandidateFilter());const v=n.tunnelFactory??(c?this.w(c):void 0);if(v){this.b=v;let D=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&D.length===0&&(D=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const p=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:D}:void 0;this.a.$setTunnelProvider(p)}}else this.b=void 0;return(0,C.$Oc)(()=>{this.b=void 0})}w(n){}async $closeTunnel(n,c){if(this.g.has(n.host)){const v=this.g.get(n.host);v.has(n.port)&&(c&&v.get(n.port).disposeListener.dispose(),await v.get(n.port).tunnel.dispose(),v.delete(n.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(n,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this.b(n,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const D=await v;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),D===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(n.remoteAddress.host)||this.g.set(n.remoteAddress.host,new Map);const p=this.B(D.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(D.remoteAddress))));return this.g.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:D,disposeListener:p}),m.fromApiTunnel(D)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(v){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),v instanceof Error)return v.message}}async $applyCandidateFilter(n){const c=await Promise.all(n.map(D=>this.f(D.host,D.port,D.detail??""))),v=n.filter((D,p)=>c[p]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(D=>D.port).join(", ")} to ${v.map(D=>D.port).join(", ")}`),v}};e.$Pvb=f,e.$Pvb=f=Ke([Ve(0,k.$9L),Ve(1,P.$mM),Ve(2,h.$7i)],f)}),define(Ae[255],Re([1,0,6,12,2,3]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(F.$8J.MainThreadUriOpeners)}registerExternalUriOpener(E,g,P,k){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const a=k.schemes.find(b=>!A.a.has(b));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(g,P),this.b.$registerUriOpener(g,k.schemes,E,k.label),(0,w.$Oc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(E,g,P){const k=this.c.get(E);if(!k)throw new Error(`Unknown opener with id: ${E}`);const a=C.URI.revive(g);return k.canOpenExternalUri(a,P)}async $openUri(E,g,P){const k=this.c.get(E);if(!k)throw new Error(`Unknown opener id: '${E}'`);return k.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},P)}}e.$kdc=A}),define(Ae[256],Re([1,0,3,2,6,9,20]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class h{static{this.a=0}constructor(g){this.c=new A.$Yl,this.d=new Map,this.b=g.getProxy(w.$8J.MainThreadUrls)}registerUriHandler(g,P){const k=g.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const a=h.a++;return this.c.add(k),this.d.set(a,P),this.b.$registerUriHandler(a,k,g.displayName||g.name),(0,C.$Oc)(()=>{this.c.delete(k),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(g,P){const k=this.d.get(g);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(P))}catch(a){(0,F.$Y)(a)}return Promise.resolve(void 0)}async createAppUri(g){return M.URI.revive(await this.b.$createAppUri(g))}}e.$Acc=h}),define(Ae[64],Re([1,0,5,6,12,24,2,169,191,77,3]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=e.$Dcc=e.$Ccc=e.$Bcc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(D,p,r,s,i,o,y){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$Ld,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$Ld,this._onDidDispose=this.#h.event,this.#e=D,this.#t=p,this.#r=r,this.#l=s,this.#u=i,this.#n=o,this.#c=a(o),this.#d=b(o),this.#i=y}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(D){return this.#a=!0,(0,g.$Sob)(D,this.#l)}get cspSource(){const D=this.#n.extensionLocation;if(D.scheme===C.Schemas.https||D.scheme===C.Schemas.http){let p=D.toString();return p.endsWith("/")||(p+="/"),p+" "+g.$Rob}return g.$Rob}get html(){return this.a(),this.#s}set html(D){this.a(),this.#s!==D&&(this.#s=D,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(D)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(D)))}get options(){return this.a(),this.#r}set options(D){this.a(),F.$2m(this.#r,D)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,D)),this.#r=D}async postMessage(D){if(this.#o)return!1;const p=(0,E.$jcb)(D,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,p.message,...p.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(D){if(!this.#d)return D;const p=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return D.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,y,$,S)=>{const I=A.URI.from({scheme:y||"file",path:decodeURIComponent($)}),u=(0,g.$Sob)(I,{isRemote:p,authority:r}).toString();return`${i}${u}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,y,$,S)=>{const I=A.URI.from({scheme:y||"file",path:decodeURIComponent($)}),u=(0,g.$Sob)(I,{isRemote:p,authority:r}).toString();return`${i}${u}${S}`})}}e.$Bcc=k;function a(v){try{const D=(0,h.$Fo)((0,h.$Eo)(v.engines.vscode));return!!D&&D.majorBase>=1&&D.minorBase>=57}catch{return!1}}e.$Ccc=a;function b(v){try{const D=(0,h.$Fo)((0,h.$Eo)(v.engines.vscode));return D?D.majorBase<1||D.majorBase===1&&D.minorBase<60:!1}catch{return!1}}class m extends M.$Qc{constructor(D,p,r,s,i){super(),this.c=p,this.f=r,this.g=s,this.h=i,this.b=new Map,this.a=D.getProxy(P.$8J.MainThreadWebviews)}dispose(){super.dispose();for(const D of this.b.values())D.dispose();this.b.clear()}$onMessage(D,p,r){const s=this.j(D);if(s){const{message:i}=(0,E.$kcb)(p,r.value);s._onMessageEmitter.fire(i)}}$onMissingCsp(D,p){this.g.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(D,p,r){const s=new k(D,this.a,n(p),this.c,this.f,r,this.h);this.b.set(D,s);const i=s._onDidDispose(()=>{i.dispose(),this.deleteWebview(D)});return s}deleteWebview(D){this.b.delete(D)}j(D){return this.b.get(D)}}e.$Dcc=m;function f(v){return{id:v.identifier,location:v.extensionLocation}}e.$Ecc=f;function t(v,D,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||c(v,D)}}e.$Fcc=t;function n(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(D=>A.URI.from(D))}}function c(v,D){return[...(D?.getWorkspaceFolders()||[]).map(p=>p.uri),v.extensionLocation]}}),define(Ae[257],Re([1,0,21,93,6,12,23,2,8,64,55,3,7]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;class b{constructor(s,i){this.document=s,this.b=i,this.a=1,this.c=new P.$xbc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,i){await this.f(s).undo(),i||this.disposeBackup()}async redo(s,i){await this.f(s).redo(),i||this.disposeBackup()}disposeEdits(s){for(const i of s)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=p(this.document.uri)+this.a++;return(0,A.$tg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const i=this.c.get(s,0);if(!i)throw new Error("No edit found");return i}}class m{constructor(){this.a=new Map}get(s,i){return this.a.get(this.b(s,i))}add(s,i,o){const y=this.b(s,i.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${s} resource:${i.uri}`);const $=new b(i,o);return this.a.set(y,$),$}delete(s,i){const o=this.b(s,i.uri);this.a.delete(o)}b(s,i){return`${s}@@@${i}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,i,o){return this.b(0,s,i,o)}addCustomProvider(s,i,o){return this.b(1,s,i,o)}get(s){return this.a.get(s)}b(s,i,o,y){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:s,extension:o,provider:y}),new a.$0J(()=>this.a.delete(i))}}class n{constructor(s,i,o,y,$){this.d=i,this.f=o,this.g=y,this.h=$,this.b=new t,this.c=new m,this.a=s.getProxy(k.$8J.MainThreadCustomEditors)}registerCustomEditorProvider(s,i,o,y){const $=new C.$Pc;return v(o)?($.add(this.b.addTextProvider(i,s,o)),this.a.$registerTextEditorProvider((0,g.$Ecc)(s),i,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,g.$Ccc)(s))):($.add(this.b.addCustomProvider(i,s,o)),c(o)&&$.add(o.onDidChangeCustomDocument(S=>{const I=this.i(i,S.document.uri);if(D(S)){const u=I.addEdit(S);this.a.$onDidEdit(S.document.uri,i,u,S.label)}else this.a.$onContentChange(S.document.uri,i)})),this.a.$registerCustomEditorProvider((0,g.$Ecc)(s),i,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,g.$Ccc)(s))),a.$0J.from($,new a.$0J(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(s,i,o,y,$){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${i}'`);const I=h.URI.revive(s),u=await S.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:y?.buffer},$);let d;return c(S.provider)&&this.f&&(d=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(i,u,d),{editable:c(S.provider)}}async $disposeCustomDocument(s,i){const o=this.b.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const y=h.URI.revive(s),{document:$}=this.i(i,y);this.c.delete(i,$),$.dispose()}async $resolveCustomEditor(s,i,o,y,$,S){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const u=E.ViewColumn.to($),d=this.g.createNewWebview(i,y.contentOptions,I.extension),l=this.h.createNewWebviewPanel(i,o,y.title,u,y.options,d,y.active),R=h.URI.revive(s);switch(I.type){case 1:{const{document:B}=this.i(o,R);return I.provider.resolveCustomEditor(B,l,S)}case 0:{const B=this.d.getDocument(R);return I.provider.resolveCustomTextEditor(B,l,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,i,o){this.i(i,s).disposeEdits(o)}async $onMoveCustomEditor(s,i,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const $=this.h.getWebviewPanel(s);if(!$)throw new Error("No webview found");const S=h.URI.revive(i),I=this.d.getDocument(S);await y.provider.moveCustomTextEditor(I,$,w.CancellationToken.None)}async $undo(s,i,o,y){return this.i(i,s).undo(o,y)}async $redo(s,i,o,y){return this.i(i,s).redo(o,y)}async $revert(s,i,o){const y=this.i(i,s);await this.j(i).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(s,i,o){const y=this.i(i,s);await this.j(i).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(s,i,o,y){const $=this.i(i,s);return this.j(i).saveCustomDocumentAs($.document,h.URI.revive(o),y)}async $backup(s,i,o){const y=this.i(i,s),S=await this.j(i).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(S),S.id}i(s,i){const o=this.c.get(s,h.URI.revive(i));if(!o)throw new Error("No custom document found");return o}j(s){const o=this.b.get(s)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$edc=n;function c(r){return!!r.onDidChangeCustomDocument}function v(r){return typeof r.resolveCustomTextEditor=="function"}function D(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function p(r){const s=r.scheme===F.Schemas.file||r.scheme===F.Schemas.untitled?r.fsPath:r.toString();return(0,M.$Ai)(s)+""}}),define(Ae[258],Re([1,0,5,6,2,36,8,64,3,7]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class P extends M.$Qc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(m,f,t,n){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$Ld),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$Ld),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=f,this.#l=t,this.#i=n.viewType,this.#u=n.panelOptions,this.#r=n.viewColumn,this.#n=n.title,this.#a=n.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(m){this.c(),this.#n!==m&&(this.#n=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#s}set iconPath(m){this.c(),this.#s!==m&&(this.#s=m,this.#t.$setIconPath(this.#e,C.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(m){this.#c||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#a=m.active,this.#o=m.visible,this.#r=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:A.ViewColumn.from(m),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends M.$Qc{static c(){return(0,F.$cg)()}constructor(m,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=m.getProxy(E.$8J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,f,t,n,c={}){const v=typeof n=="object"?n.viewColumn:n,D={viewColumn:A.ViewColumn.from(v),preserveFocus:typeof n=="object"&&!!n.preserveFocus},p=(0,h.$Ccc)(m),r=k.c();this.f.$createWebviewPanel((0,h.$Ecc)(m),r,f,{title:t,panelOptions:a(c),webviewOptions:(0,h.$Fcc)(m,this.m,c),serializeBuffersForPostMessage:p},D);const s=this.j.createNewWebview(r,c,m);return this.createNewWebviewPanel(r,f,t,v,c,s,!0)}$onDidChangeWebviewPanelViewStates(m){const f=Object.keys(m);f.sort((t,n)=>{const c=m[t],v=m[n];return c.active?1:v.active?-1:+c.visible-+v.visible});for(const t of f){const n=this.getWebviewPanel(t);if(!n)continue;const c=m[t];n._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:m}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,h.$Ccc)(m)}),new g.$0J(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(m,f,t,n){const c=this.h.get(f);if(!c)throw new Error(`No serializer found for '${f}'`);const{serializer:v,extension:D}=c,p=this.j.createNewWebview(m,t.webviewOptions,D),r=this.createNewWebviewPanel(m,f,t.title,n,t.panelOptions,p,t.active);await v.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(m,f,t,n,c,v,D){const p=new P(m,this.f,v,{viewType:f,title:t,viewColumn:n,panelOptions:c,active:D});return this.g.set(m,p),p}getWebviewPanel(m){return this.g.get(m)}}e.$ddc=k;function a(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ae[259],Re([1,0,5,6,64,8,3,7]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class E extends M.$Qc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,a,b,m,f,t){super(),this.#u=!1,this.#a=this.B(new w.$Ld),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$Ld),this.onDidDispose=this.#c.event,this.#i=b,this.#s=m,this.#e=k,this.#t=a,this.#l=f,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=F.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(k,a){this.d=a,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$8J.MainThreadWebviewViews)}registerWebviewViewProvider(k,a,b,m){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:b,extension:k}),this.a.$registerWebviewViewProvider((0,C.$Ecc)(k),a,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Ccc)(k)}),new h.$0J(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(k,a,b,m,f){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:n,extension:c}=t,v=this.d.createNewWebview(k,{},c),D=new E(k,this.a,a,b,v,!0);this.c.set(k,D),await n.resolveWebviewView(D,{state:m},f)}async $onDidChangeWebviewViewVisibility(k,a){this.e(k)._setVisible(a)}async $disposeWebviewView(k){const a=this.e(k);this.c.delete(k),a.dispose(),this.d.deleteWebview(k)}e(k){const a=this.c.get(k);if(!a)throw new Error("No webview found");return a}}e.$cdc=g}),define(Ae[108],Re([1,0,5,3,2,12,15,4,17,26]),function(be,e,w,M,C,F,A,h,E,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;let k=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(b){const m=this.d;return{get focused(){return m.focused},get active(){return(0,g.$8E)(b,"windowActivity"),m.active}}}constructor(b){this.c=new w.$Ld,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=b.getProxy(M.$8J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:f})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,m){m!==this.d[b]&&(this.d={...this.d,[b]:m},this.c.fire(this.d))}openUri(b,m){let f;if(typeof b=="string"){f=b;try{b=C.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$ze)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,f,m)}async asExternalUri(b,m){if((0,A.$ze)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(b,m);return C.URI.from(f)}};e.$Gcc=k,e.$Gcc=k=P=Ke([Ve(0,E.$9L)],k),e.$Hcc=(0,h.$Mh)("IExtHostWindow")}),define(Ae[260],Re([1,0,226,27,17]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;let F=class extends w.$Fdc{constructor(h,E){super(h,E)}f(h,E,g){E.apply(console,g)}};e.$Mfc=F,e.$Mfc=F=Ke([Ve(0,C.$9L),Ve(1,M.$mM)],F)}),define(Ae[261],Re([1,0,13,25,21,9,5,6,132,215,46]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$_3b=e.ResponsiveState=e.RequestInitiator=e.$$3b=e.$03b=void 0;function a(l,R){try{return JSON.stringify(l,R)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class f{constructor(R,B){this.jsonString=R,this.referencedBuffers=B}}function t(l,R=null,B=!1){const V=[];return{jsonString:(B?a:JSON.stringify)(l,(W,O)=>{if(typeof O>"u")return m;if(typeof O=="object"){if(O instanceof M.$_d){const N=V.push(O)-1;return{[b]:N}}if(R)return R(W,O)}return O}),referencedBuffers:V}}e.$03b=t;function n(l,R,B){return JSON.parse(l,(V,j)=>{if(j){const W=j[b];if(typeof W=="number")return R[W];if(B&&j.$mid===1)return B.transformIncoming(j)}return j})}e.$$3b=n;function c(l,R){return JSON.stringify(l,R)}function v(l){return l?(R,B)=>B&&B.$mid===1?l.transformOutgoing(B):B:null}var D;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));var p;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(p||(e.ResponsiveState=p={}));const r=()=>{},s=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends h.$Qc{static{k=s}static{this.a=3*1e3}constructor(R,B=null,V=null){super(),this[k]=!0,this.b=this.B(new A.$Ld),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=B,this.g=V,this.h=v(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,W=P.$fv.count;j<W;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$4g(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(R=>{const B=this.w[R];delete this.w[R],B.resolveErr(F.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(R){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(R){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(R){this.y!==R&&(this.y=R,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(R){return this.g?(0,E.$Gm)(R,this.g):R}getProxy(R){const{nid:B,sid:V}=R;return this.s[B]||(this.s[B]=this.J(B,V)),this.s[B]}J(R,B){const V={get:(j,W)=>(typeof W=="string"&&!j[W]&&W.charCodeAt(0)===36&&(j[W]=(...O)=>this.U(R,W,O)),W===i?B:j[W])};return new Proxy(Object.create(null),V)}set(R,B){return this.m[R.nid]=B,B}assertRegistered(R){for(let B=0,V=R.length;B<V;B++){const j=R[B];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(R){if(this.j)return;const B=R.byteLength,V=$.read(R,0),j=V.readUInt8(),W=V.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:N,args:ee}=I.deserializeRequestJSONArgs(V);this.g&&(ee=(0,E.$Gm)(ee,this.g)),this.M(B,W,O,N,ee,j===2);break}case 3:case 4:{let{rpcId:O,method:N,args:ee}=I.deserializeRequestMixedArgs(V);this.g&&(ee=(0,E.$Gm)(ee,this.g)),this.M(B,W,O,N,ee,j===4);break}case 5:{this.f?.logIncoming(B,W,0,"ack"),this.G(W);break}case 6:{this.N(B,W);break}case 7:{this.O(B,W,void 0);break}case 9:{let O=I.deserializeReplyOKJSON(V);this.g&&(O=(0,E.$Gm)(O,this.g)),this.O(B,W,O);break}case 10:{const O=I.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(B,W,O);break}case 8:{const O=I.deserializeReplyOKVSBuffer(V);this.O(B,W,O);break}case 11:{let O=I.deserializeReplyErrError(V);this.g&&(O=(0,E.$Gm)(O,this.g)),this.P(B,W,O);break}case 12:{this.P(B,W,void 0);break}default:console.error("received unexpected message"),console.error(R)}}M(R,B,V,j,W,O){this.f?.logIncoming(R,B,1,`receiveRequest ${(0,P.$hv)(V)}.${j}(`,W);const N=String(B);let ee,X;if(O){const De=new C.$Vd;W.push(De.token),ee=this.Q(V,j,W),X=()=>De.cancel()}else ee=this.Q(V,j,W),X=r;this.u[N]=X;const ye=I.serializeAcknowledged(B);this.f?.logOutgoing(ye.byteLength,B,1,"ack"),this.c.send(ye),ee.then(De=>{delete this.u[N];const Pe=I.serializeReplyOK(B,De,this.h);this.f?.logOutgoing(Pe.byteLength,B,1,"reply:",De),this.c.send(Pe)},De=>{delete this.u[N];const Pe=I.serializeReplyErr(B,De);this.f?.logOutgoing(Pe.byteLength,B,1,"replyErr:",De),this.c.send(Pe)})}N(R,B){this.f?.logIncoming(R,B,1,"receiveCancel");const V=String(B);this.u[V]?.()}O(R,B,V){this.f?.logIncoming(R,B,0,"receiveReply:",V);const j=String(B);if(!this.w.hasOwnProperty(j))return;const W=this.w[j];delete this.w[j],W.resolveOk(V)}P(R,B,V){this.f?.logIncoming(R,B,0,"receiveReplyErr:",V);const j=String(B);if(!this.w.hasOwnProperty(j))return;const W=this.w[j];delete this.w[j];let O;V&&(V.$isError?(O=new Error,O.name=V.name,O.message=V.message,O.stack=V.stack):O=V),W.resolveErr(O)}Q(R,B,V){try{return Promise.resolve(this.S(R,B,V))}catch(j){return Promise.reject(j)}}S(R,B,V){const j=this.m[R];if(!j)throw new Error("Unknown actor "+(0,P.$hv)(R));const W=j[B];if(typeof W!="function")throw new Error("Unknown method "+B+" on actor "+(0,P.$hv)(R));return W.apply(j,V)}U(R,B,V){if(this.j)return new g.$93b;let j=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(j=V.pop()),j&&j.isCancellationRequested)return Promise.reject(F.$4());const W=I.serializeRequestArguments(V,this.h),O=++this.t,N=String(O),ee=new g.$83b,X=new h.$Pc;j&&X.add(j.onCancellationRequested(()=>{const De=I.serializeCancel(O);this.f?.logOutgoing(De.byteLength,O,0,"cancel"),this.c.send(I.serializeCancel(O))})),this.w[N]=new y(ee,X),this.F(O);const ye=I.serializeRequest(O,R,B,W,!!j);return this.f?.logOutgoing(ye.byteLength,O,0,`request: ${(0,P.$hv)(R)}.${B}(`,V),this.c.send(ye),ee}}e.$_3b=o;class y{constructor(R,B){this.a=R,this.b=B}resolveOk(R){this.a.resolveOk(R),this.b.dispose()}resolveErr(R){this.a.resolveErr(R),this.b.dispose()}}class ${static alloc(R,B,V){const j=new $(M.$_d.alloc(V+1+4),0);return j.writeUInt8(R),j.writeUInt32(B),j}static read(R,B){return new $(R,B)}get buffer(){return this.a}constructor(R,B){this.a=R,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+R);return this.b+=R,B}static sizeMixedArray(R){let B=0;B+=1;for(let V=0,j=R.length;V<j;V++){const W=R[V];switch(B+=1,W.type){case 1:B+=this.sizeLongString(W.value);break;case 2:B+=this.sizeVSBuffer(W.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(W.value);for(let O=0;O<W.buffers.length;++O)B+=this.sizeVSBuffer(W.buffers[O]);break;case 4:break}}return B}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let B=0,V=R.length;B<V;B++){const j=R[B];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let W=0;W<j.buffers.length;++W)this.writeBuffer(j.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const B=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:B[V]=this.readLongString();break;case 2:B[V]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),O=this.readLongString(),N=[];for(let ee=0;ee<W;++ee)N.push(this.readVSBuffer());B[V]=new P.$iv(n(O,N,null));break}case 4:B[V]=void 0;break}return B}}var S;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(S||(S={}));class I{static a(R){for(let B=0,V=R.length;B<V;B++)if(R[B]instanceof M.$_d||R[B]instanceof P.$iv||typeof R[B]>"u")return!0;return!1}static serializeRequestArguments(R,B){if(this.a(R)){const V=[];for(let j=0,W=R.length;j<W;j++){const O=R[j];if(O instanceof M.$_d)V[j]={type:2,value:O};else if(typeof O>"u")V[j]={type:4};else if(O instanceof P.$iv){const{jsonString:N,referencedBuffers:ee}=t(O.value,B);V[j]={type:3,value:M.$_d.fromString(N),buffers:ee}}else V[j]={type:1,value:M.$_d.fromString(c(O,B))}}return{type:1,args:V}}return{type:0,args:c(R,B)}}static serializeRequest(R,B,V,j,W){switch(j.type){case 0:return this.b(R,B,V,j.args,W);case 1:return this.c(R,B,V,j.args,W)}}static b(R,B,V,j,W){const O=M.$_d.fromString(V),N=M.$_d.fromString(j);let ee=0;ee+=$.sizeUInt8(),ee+=$.sizeShortString(O),ee+=$.sizeLongString(N);const X=$.alloc(W?2:1,R,ee);return X.writeUInt8(B),X.writeShortString(O),X.writeLongString(N),X.buffer}static deserializeRequestJSONArgs(R){const B=R.readUInt8(),V=R.readShortString(),j=R.readLongString();return{rpcId:B,method:V,args:JSON.parse(j)}}static c(R,B,V,j,W){const O=M.$_d.fromString(V);let N=0;N+=$.sizeUInt8(),N+=$.sizeShortString(O),N+=$.sizeMixedArray(j);const ee=$.alloc(W?4:3,R,N);return ee.writeUInt8(B),ee.writeShortString(O),ee.writeMixedArray(j),ee.buffer}static deserializeRequestMixedArgs(R){const B=R.readUInt8(),V=R.readShortString(),j=R.readMixedArray(),W=new Array(j.length);for(let O=0,N=j.length;O<N;O++){const ee=j[O];typeof ee=="string"?W[O]=JSON.parse(ee):W[O]=ee}return{rpcId:B,method:V,args:W}}static serializeAcknowledged(R){return $.alloc(5,R,0).buffer}static serializeCancel(R){return $.alloc(6,R,0).buffer}static serializeReplyOK(R,B,V){if(typeof B>"u")return this.d(R);if(B instanceof M.$_d)return this.e(R,B);if(B instanceof P.$iv){const{jsonString:j,referencedBuffers:W}=t(B.value,V,!0);return this.g(R,j,W)}else return this.f(R,a(B,V))}static d(R){return $.alloc(7,R,0).buffer}static e(R,B){let V=0;V+=$.sizeVSBuffer(B);const j=$.alloc(8,R,V);return j.writeVSBuffer(B),j.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,B){const V=M.$_d.fromString(B);let j=0;j+=$.sizeLongString(V);const W=$.alloc(9,R,j);return W.writeLongString(V),W.buffer}static g(R,B,V){const j=M.$_d.fromString(B);let W=0;W+=$.sizeUInt32,W+=$.sizeLongString(j);for(const N of V)W+=$.sizeVSBuffer(N);const O=$.alloc(10,R,W);O.writeUInt32(V.length),O.writeLongString(j);for(const N of V)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(R){const B=R.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(R,B){const V=R.readUInt32(),j=R.readLongString(),W=[];for(let O=0;O<V;++O)W.push(R.readVSBuffer());return new P.$iv(n(j,W,B))}static serializeReplyErr(R,B){const V=B?a(F.$1(B),null):void 0;if(typeof V!="string")return this.h(R);const j=M.$_d.fromString(V);let W=0;W+=$.sizeLongString(j);const O=$.alloc(11,R,W);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(R){const B=R.readLongString();return JSON.parse(B)}static h(R){return $.alloc(12,R,0).buffer}}var u;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var d;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(d||(d={}))}),define(Ae[262],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;const w=function(F){const A=h=>{globalThis.removeEventListener("message",A);const E=h.data;Object.defineProperties(globalThis,{postMessage:{value(g,P){E.postMessage(g,P)}},onmessage:{get(){return E.onmessage},set(g){E.onmessage=g}}}),E.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),E.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(F,A,h){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${w})('${A}'))`,g=new Blob([E],{type:"application/javascript"}),P=URL.createObjectURL(g),k=new MessageChannel,a=P,b={type:"_newWorker",id:a,port:k.port2,url:P,options:h};F(b,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{F({type:"_terminateWorker",id:a}),URL.revokeObjectURL(P),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(m){k.port1.onmessage=m}},onmessageerror:{get(){return k.port1.onmessageerror},set(m){k.port1.onmessageerror=m}}}),k.port1.addEventListener("messageerror",m=>{const f=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(f)}),k.port1.addEventListener("message",m=>{const f=new MessageEvent("message",{data:m.data});this.dispatchEvent(f)}),k.port1.start()}}e.$Ofc=M}),define(Ae[263],Re([1,0,5,30,32,4]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.$qJ=e.OutputChannelUpdateMode=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=void 0,e.$gJ="text/x-code-output",e.$hJ="output",e.$iJ="Log",e.$jJ="text/x-code-log-output",e.$kJ="log",e.$lJ="workbench.panel.output",e.$mJ=new C.$4i("inOutput",!1),e.$nJ=new C.$4i("activeLogOutput",!1),e.$oJ=new C.$4i("outputView.scrollLock",!1),e.$pJ=(0,F.$Mh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$qJ={OutputChannels:"workbench.contributions.outputChannels"};class h{constructor(){this.a=new Map,this.b=new w.$Ld,this.onDidRegisterChannel=this.b.event,this.c=new w.$Ld,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(P=>g.push(P)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}M.$0m.add(e.$qJ.OutputChannels,new h),e.$rJ=new C.$4i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,20,14,263,62,27,39,129,25,16,38,5,6]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=e.$qcc=void 0;class n extends A.$aj{get disposed(){return this.n}constructor(p,r,s,i,o){super(),this.id=p,this.name=r,this.r=s,this.s=i,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.m;this.r.flush(),this.s.$update(this.id,h.OutputChannelUpdateMode.Clear,p)}replace(p){const r=this.m;this.info(p),this.s.$update(this.id,h.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(p,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof p=="boolean"?p:r))}hide(){this.s.$close(this.id)}g(p,r){this.m+=a.$_d.fromString(r).byteLength,(0,A.log)(this.r,p,r),this.visible&&(this.r.flush(),this.s.$update(this.id,h.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends n{appendLine(p){this.append(p)}}let v=class{constructor(p,r,s,i,o,y){this.i=r,this.j=s,this.k=i,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(w.$8J.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,k.$9l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(p,r,s){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const i=typeof r=="object"&&r.log,o=(0,b.$wf)(r)?r:void 0;if((0,b.$wf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const $=this.i.environment.extensionLogLevel?.find(([I])=>F.$Xl.equals(s.identifier,I))?.[1];$&&(y=(0,A.$kj)($));const S=i?this.o(p,y,s):this.n(p,o,s);return S.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),i?this.r(p,y??this.m.getLevel(),S):this.q(p,S)}async n(p,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,o=this.k.extUri.joinPath(i,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(p,o,r,s.identifier.value);return new n($,p,y,this.a,s)}async o(p,r,s){const i=await this.p(s),o=p.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(i,`${o}.log`),$=`${s.identifier.value}.${o}`,S=this.l.createLogger(y,{id:$,name:p,logLevel:r,extensionId:s.identifier.value});return new c($,p,S,this.a,s)}p(p){let r=this.d.get(p.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(i){if((0,m.$kk)(i)!==m.FileSystemProviderErrorCode.FileExists)throw i}return s})())}return r}q(p,r){let s=!1;const i=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return p},append(o){i(),r.then(y=>y.append(o))},appendLine(o){i(),r.then(y=>y.appendLine(o))},clear(){i(),r.then(o=>o.clear())},replace(o){i(),r.then(y=>y.replace(o))},show(o,y){i(),r.then($=>$.show(o,y))},hide(){i(),r.then(o=>o.hide())},dispose(){s=!0,r.then(o=>o.dispose())}}}r(p,r,s){const i=new t.$Pc,o=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},y=i.add(new f.$Ld);function $(S){r=S,y.fire(S)}return s.then(S=>{i.add(S),S.logLevel!==r&&$(S.logLevel),i.add(S.onDidChangeLogLevel(I=>$(I)))}),{...this.q(p,s),get logLevel(){return r},onDidChangeLogLevel:y.event,trace(S,...I){o(),s.then(u=>u.trace(S,...I))},debug(S,...I){o(),s.then(u=>u.debug(S,...I))},info(S,...I){o(),s.then(u=>u.info(S,...I))},warn(S,...I){o(),s.then(u=>u.warn(S,...I))},error(S,...I){o(),s.then(u=>u.error(S,...I))},dispose(){i.dispose()}}}};e.$qcc=v,e.$qcc=v=Ke([Ve(0,C.$9L),Ve(1,g.$mM),Ve(2,E.$6bc),Ve(3,P.$Abc),Ve(4,A.$8i),Ve(5,A.$7i)],v),e.$rcc=(0,M.$Mh)("IExtHostOutputService")}),define(Ae[264],Re([1,0,4,13]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=void 0,e.$lm=(0,w.$Mh)("remoteAgentService"),e.$mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let F=1/0;for(let h=0;h<this.maxSampleCount;h++){const E=await C.getRoundTripTime();if(E===void 0)return;F=Math.min(F,E/2),await(0,M.$Sg)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(F):A=this.initial.reduce((h,E)=>h+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:F,average:this.average.reduce((h,E)=>h+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[265],Re([1,0,42,12,19,22,23,2,4,186,54,208,264]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=void 0,e.$JJ=(0,E.$Mh)("pathService");let m=b=class{constructor(t,n,c,v){this.d=t,this.e=n,this.f=c,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const D=await this.e.getEnvironment();return this.c=D?.userHome??t})()}hasValidBasename(t,n,c){return typeof n=="string"||typeof n>"u"?this.a.then(v=>this.h(t,v,n)):this.h(t,n,c)}h(t,n,c){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,w.$Tf)(c??(0,A.$qg)(t),n===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,n){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const c=(0,g.$GJ)(n.getWorkspace());if(c)return c;const v=n.getWorkspace().folders[0];if(v)return v.uri.scheme;const D=n.getWorkspace().configuration;return D?D.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$dc:C.$ec)}async fileURI(t){let n="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(n=t.substring(2),t="/"):(n=t.substring(2,v),t=t.substring(v)||"/")}return h.URI.from({scheme:M.Schemas.file,authority:n,path:t,query:"",fragment:""})}};e.$KJ=m,e.$KJ=m=b=Ke([Ve(1,a.$lm),Ve(2,k.$sJ),Ve(3,P.$Vh)],m)}),define(Ae[110],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$tI=e.$sI=void 0;class w{constructor(A,h){this.line=A,this.character=h}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,h){return new w(0,0)}with(A){return new w(0,0)}}e.$sI=w;class M{constructor(A,h,E,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,h),this.end=new w(E,g)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$tI=M;var C;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,110,13]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.SearchErrorCode=e.$II=e.$HI=e.SearchSortOrder=e.ViewMode=e.$GI=e.$FI=e.$EI=e.$DI=e.SearchCompletionExitCode=e.$CI=e.$BI=e.$AI=e.QueryType=e.SearchProviderType=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$uI="workbench.view.search",e.$vI="workbench.panel.search",e.$wI="workbench.view.search",e.$xI="search-result",e.$yI="search.exclude";const a="\u27EA ",b=" characters skipped \u27EB",m=(a.length+b.length+5)*2;e.$zI=(0,h.$Mh)("searchService");var f;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(t||(e.QueryType=t={}));function n(Y){return!!Y.preview}e.$AI=n;function c(Y){return!!Y.resource}e.$BI=c;function v(Y){return!!Y.message}e.$CI=v;var D;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(D||(e.SearchCompletionExitCode=D={}));class p{constructor(le){this.resource=le,this.results=[]}}e.$DI=p;class r{constructor(le,Ee,ce,$e){this.ranges=Ee,this.webviewIndex=$e;const ie=Array.isArray(Ee)?Ee:[Ee];if(ce&&ce.matchLines===1&&s(ie)){le=(0,A.$pf)(le,ce.matchLines);let z="",q=0,ue=0;const we=Math.floor(ce.charsPerLine/5),ve=[];for(const me of ie){const ke=Math.max(me.startColumn-we,0),re=me.startColumn+ce.charsPerLine;if(ke>ue+we+m){const he=a+(ke-ue)+b;z+=he+le.slice(ke,re),q+=ke-(ue+he.length)}else z+=le.slice(ue,re);ve.push(new o(0,me.startColumn-q,me.endColumn-q)),ue=re}this.preview={text:z,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const z=Array.isArray(Ee)?Ee[0].startLineNumber:Ee.startLineNumber;this.preview={text:le,matches:(0,w.$Zb)(Ee,q=>new i(q.startLineNumber-z,q.startColumn,q.endLineNumber-z,q.endColumn))}}}}e.$EI=r;function s(Y){const le=Y[0].startLineNumber;for(const Ee of Y)if(Ee.startLineNumber!==le||Ee.endLineNumber!==le)return!1;return!0}class i{constructor(le,Ee,ce,$e){this.startLineNumber=le,this.startColumn=Ee,this.endLineNumber=ce,this.endColumn=$e}}e.$FI=i;class o extends i{constructor(le,Ee,ce){super(le,Ee,le,ce)}}e.$GI=o;var y;(function(Y){Y.List="list",Y.Tree="tree"})(y||(e.ViewMode=y={}));var $;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function S(Y,le=!0){const Ee=Y&&Y.files&&Y.files.exclude,ce=le&&Y&&Y.search&&Y.search.exclude;if(!Ee&&!ce)return;if(!Ee||!ce)return Ee||ce;let $e=Object.create(null);return $e=C.$1m($e,C.$Xm(Ee)),$e=C.$1m($e,C.$Xm(ce),!0),$e}e.$HI=S;function I(Y,le){return Y.excludePattern&&M.$sj(Y.excludePattern,le)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&M.$sj(Y.includePattern,le)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(Ee=>{const ce=Ee.folder.fsPath;if(F.$Vf(le,ce)){const $e=E.$jc(ce,le);return!Ee.includePattern||!!M.$sj(Ee.includePattern,$e)}else return!1}):!1:!0}e.$II=I;var u;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class d extends Error{constructor(le,Ee){super(le),this.code=Ee}}e.$JI=d;function l(Y){const le=Y.message;if((0,g.$2)(Y))return new d(le,u.canceled);try{const Ee=JSON.parse(le);return new d(Ee.message,Ee.code)}catch{return new d(le,u.other)}}e.$KI=l;function R(Y){const le={message:Y.message,code:Y.code};return new Error(JSON.stringify(le))}e.$LI=R;function B(Y){return Y.type==="error"?!0:Y.type==="success"}e.$MI=B;function V(Y){return Y.type==="success"}e.$NI=V;function j(Y){return!!Y.path}e.$OI=j;function W(Y,le){const Ee=Y.searchPath?Y.searchPath:Y.relativePath;return(0,A.$mf)(Ee,le)}e.$PI=W;class O{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$QI=O;function N(Y,le){const Ee={...Y||{},...le||{}};return Object.keys(Ee).filter(ce=>{const $e=Ee[ce];return typeof $e=="boolean"&&$e})}e.$RI=N;class ee{constructor(le,Ee){this.c=null,this.a={...le.excludePattern||{},...Ee.excludePattern||{}},this.b=M.$tj(this.a);let ce=le.includePattern;Ee.includePattern&&(ce?ce={...ce,...Ee.includePattern}:ce=Ee.includePattern),ce&&(this.c=M.$tj(ce))}matchesExcludesSync(le,Ee,ce){return!!(this.b&&this.b(le,Ee,ce))}includedInQuerySync(le,Ee,ce){return!(this.b&&this.b(le,Ee,ce)||this.c&&!this.c(le,Ee,ce))}includedInQuery(le,Ee,ce){const $e=this.b(le,Ee,ce),ie=()=>this.c?!!this.c(le,Ee,ce):!0;return(0,k.$Eg)($e)?$e.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return X(this.a)}}e.$SI=ee;function X(Y){for(const le in Y)if(typeof Y[le]!="boolean")return!0;return!1}function ye(Y){if(!Y)return;let le;return Ee=>(le||(le=(Y()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),le.then(ce=>!!ce[Ee]))}e.$TI=ye;function De(Y){if(!Y)return;let le;return Ee=>{if(!le){const ce=Y();le=ce?Pe(ce):{}}return!!le[Ee]}}e.$UI=De;function Pe(Y){const le={};for(const Ee of Y)le[Ee]=!0;return le}}),define(Ae[33],Re([1,0,18,13,21,5,6,49,12,117,23,15,2,158,4,14,175,54,39,27,17,8,7,56,47,3]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=void 0;function y(B,V,j){return new P.$ig(W=>u(W,j)).isEqual(B,V)}function $(B,V,j){return y(B.uri,V.uri,j)?0:(0,k.$Se)(B.uri.toString(),V.uri.toString())}function S(B,V,j){return B.index!==V.index?B.index<V.index?-1:1:y(B.uri,V.uri,j)?(0,k.$Se)(B.name,V.name):(0,k.$Se)(B.uri.toString(),V.uri.toString())}function I(B,V,j,W){const O=B.slice(0).sort((ee,X)=>j(ee,X,W)),N=V.slice(0).sort((ee,X)=>j(ee,X,W));return(0,w.$Cb)(O,N,(ee,X)=>j(ee,X,W))}function u(B,V){const j=V.getCapabilities(B.scheme);return!(j&&j&1024)}class d extends n.$6h{static toExtHostWorkspace(V,j,W,O){if(!V)return{workspace:null,added:[],removed:[]};const{id:N,name:ee,folders:X,configuration:ye,transient:De,isUntitled:Pe}=V,Y=[],le=j;j?X.forEach((ie,z)=>{const q=a.URI.revive(ie.uri),ue=d.o(W||j,q,O);ue?(ue.name=ie.name,ue.index=ie.index,Y.push(ue)):Y.push({uri:q,name:ie.name,index:z})}):Y.push(...X.map(({uri:ie,name:z,index:q})=>({uri:a.URI.revive(ie),name:z,index:q}))),Y.sort((ie,z)=>ie.index<z.index?-1:1);const Ee=new d(N,ee,Y,!!De,ye?a.URI.revive(ye):null,!!Pe,ie=>u(ie,O)),{added:ce,removed:$e}=I(le?le.workspaceFolders:[],Ee.workspaceFolders,$,O);return{workspace:Ee,added:ce,removed:$e}}static o(V,j,W){for(let O=0;O<V.folders.length;O++){const N=V.workspaceFolders[O];if(y(N.uri,j,W))return N}}constructor(V,j,W,O,N,ee,X){super(V,W.map(ye=>new n.$7h(ye)),O,N,X),this.t=j,this.u=ee,this.q=[],this.s=h.$Sh.forUris(X),W.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,j){return j&&this.s.get(V)&&(V=(0,P.$sg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let l=class{constructor(V,j,W,O,N){this.c=new F.$Ld,this.onDidChangeWorkspace=this.c.event,this.g=new F.$Ld,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$Nd,this.B=new Map,this.h=O,this.s=W,this.t=N,this.j=new g.$Ll,this.k=new M.$Qg,this.o=V.getProxy(o.$8J.MainThreadWorkspace),this.q=V.getProxy(o.$8J.MainThreadMessageService);const ee=j.workspace;this.l=ee?new d(ee.id,ee.name,[],!!ee.transient,ee.configuration?a.URI.revive(ee.configuration):null,!!ee.isUntitled,X=>u(X,W)):void 0}$initializeWorkspace(V,j){this.v=j,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:E.Schemas.untitled,path:(0,P.$qg)((0,P.$sg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,j,W,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{a.URI.isUri(Pe.uri)&&!N.some(Y=>y(Y.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,P.$pg)(Pe.uri)})}),this.n||[j,W].some(Pe=>typeof Pe!="number"||Pe<0)||W===0&&N.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(j+W>ee.length)return!1;const X=ee.slice(0);X.splice(j,W,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$pg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<X.length;Pe++){const Y=X[Pe];if(X.some((le,Ee)=>Ee!==Pe&&y(Y.uri,le.uri,this.s)))return!1}X.forEach((Pe,Y)=>Pe.index=Y);const{added:ye,removed:De}=I(ee,X,S,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,j,W,N).then(void 0,Y=>{this.n=void 0;const le={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,Pe,Y.toString()),le,[])})}return this.y(X),!0}getWorkspaceFolder(V,j){if(this.x)return this.x.getWorkspaceFolder(V,j)}async getWorkspaceFolder2(V,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,j)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,j){let W,O="";if(typeof V=="string"?(W=a.URI.file(V),O=V):typeof V<"u"&&(W=V,O=V.fsPath),!W)return O;const N=this.getWorkspaceFolder(W,!0);if(!N)return O;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let ee=(0,P.$vg)(N.uri,W);return j&&N.name&&(ee=`${N.name}/${ee}`),ee}y(V){this.x&&(this.n=d.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:j,added:W,removed:O}=d.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:O}))}findFiles(V,j,W,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ee;if(j===null?ee=!1:j&&(typeof j=="string"?ee=j:ee=j.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:ye}=R(p.GlobPattern.from(V));return this.o.$startFileSearch(X??null,ye??null,ee??null,W??null,N).then(De=>Array.isArray(De)?De.map(Pe=>a.URI.revive(Pe)):[])}async findTextInFiles(V,j,W,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),X=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:ye,folder:De}=R(p.GlobPattern.from(j.include)),Pe=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,Y={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:X,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:ye,excludePattern:Pe},le=!1;if(this.u[ee]=Ee=>{if(le)return;const ce=a.URI.revive(Ee.resource);Ee.results.forEach($e=>{(0,i.$AI)($e)?W({uri:ce,preview:{text:$e.preview.text,matches:(0,w.$Zb)($e.preview.matches,ie=>new r.$_J(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$Zb)($e.ranges,ie=>new r.$_J(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):W({uri:ce,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(V,De??null,Y,ee,N);return delete this.u[ee],Ee||{}}catch(Ee){throw delete this.u[ee],Ee}}$handleTextSearchResult(V,j){this.u[j]?.(V)}async save(V){const j=await this.o.$save(V,{saveAs:!1});return a.URI.revive(j)}async saveAs(V){const j=await this.o.$save(V,{saveAs:!0});return a.URI.revive(j)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,j){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,j);const W=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,W),(0,A.$Oc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(V,j){this.h.info("Getting edit session identifier for workspaceFolder",V);const W=await this.resolveWorkspaceFolder(a.URI.revive(V));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const O=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(W,j);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(V,j,W,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(a.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const ee=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!ee),!ee)return;const X=await ee.provideEditSessionIdentityMatch?.(j,W,O);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(V){return(j,W,O)=>{const N=function(X){j.call(W,X)};return N.extension=V,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(V,j,W){const O=await this.resolveWorkspaceFolder(a.URI.revive(V));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},j,async(N,ee)=>{const X=Date.now();await Promise.resolve(N),Date.now()-X>W&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(V,j){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,j);const W=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerCanonicalUriProvider(O,W),(0,A.$Oc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(V,j,W){const O=this.B.get(V.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(a.URI.revive(V),j,W);if(N)return N}async $provideCanonicalUri(V,j,W){return this.provideCanonicalUri(a.URI.revive(V),{targetScheme:j},W)}};e.$Mbc=l,e.$Mbc=l=Ke([Ve(0,D.$9L),Ve(1,v.$mM),Ve(2,c.$Abc),Ve(3,f.$7i),Ve(4,s.$Kbc)],l),e.$Nbc=(0,m.$Mh)("IExtHostWorkspace");function R(B){let V,j;return B&&(typeof B=="string"?V=B:(V=B.pattern,j=a.URI.revive(B.baseUri))),{includePattern:V,folder:j}}}),define(Ae[34],Re([1,0,24,5,33,3,7,177,96,16,13,4,17,14,2]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=e.$Obc=void 0;function f(s,i){if(i){const o=i.split(".");let y=s;for(let $=0;y&&$<o.length;$++)y=y[o[$]];return y}}function t(s){return s instanceof m.URI}function n(s){return s&&s.uri instanceof m.URI&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function v(s){return s&&s.uri instanceof m.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function D(s){if(t(s))return{resource:s};if(n(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(c(s))return{overrideIdentifier:s.languageId};if(v(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(i,o,y){this.a=i.getProxy(F.$8J.MainThreadConfiguration),this.c=o,this.b=y,this.d=new P.$Qg,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new r(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(i,o))}};e.$Obc=p,e.$Obc=p=Ke([Ve(0,a.$9L),Ve(1,C.$Nbc),Ve(2,b.$7i)],p);class r{constructor(i,o,y,$){this.a=new M.$Ld,this.b=i,this.f=$,this.c=o,this.e=h.$vn.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=h.$vn.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(i,o,y){const $=D(o)||{},S=this.g(i?f(this.e.getValue(void 0,$,this.c.workspace),i):this.e.getValue(void 0,$,this.c.workspace));i&&this.h(i,$,y?.identifier);function I(d){if(d==null)return null;if(typeof d=="boolean")return d?2:5;switch(d){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(d){return typeof f(S,d)<"u"},get:(d,l)=>{this.h(i?`${i}.${d}`:d,$,y?.identifier);let R=f(S,d);if(typeof R>"u")R=l;else{let B;const V=(j,W)=>{if((0,g.$yf)(j)){let O;const N=()=>{B=B||(0,w.$Xm)(S),O=O||f(B,W)};return new Proxy(j,{get:(ee,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return N(),()=>O;if(B)return O=O||f(B,W),O[X];const ye=ee[X];return typeof X=="string"?V(ye,`${W}.${X}`):ye},set:(ee,X,ye)=>(N(),O&&(O[X]=ye),!0),deleteProperty:(ee,X)=>(N(),O&&delete O[X],!0),defineProperty:(ee,X,ye)=>(N(),O&&Object.defineProperty(O,X,ye),!0)})}return Array.isArray(j)?(0,w.$Xm)(j):j};R=V(R,d)}return R},update:(d,l,R,B)=>{d=i?`${i}.${d}`:d;const V=I(R);return l!==void 0?this.b.$updateConfigurationOption(V,d,l,$,B):this.b.$removeConfigurationOption(V,d,$,B)},inspect:d=>{d=i?`${i}.${d}`:d;const l=this.e.inspect(d,$,this.c.workspace);if(l)return{key:d,defaultValue:(0,w.$Xm)(l.policy?.value??l.default?.value),globalValue:(0,w.$Xm)(l.user?.value??l.application?.value),workspaceValue:(0,w.$Xm)(l.workspace?.value),workspaceFolderValue:(0,w.$Xm)(l.workspaceFolder?.value),defaultLanguageValue:(0,w.$Xm)(l.default?.override),globalLanguageValue:(0,w.$Xm)(l.user?.override??l.application?.override),workspaceLanguageValue:(0,w.$Xm)(l.workspace?.override),workspaceFolderLanguageValue:(0,w.$Xm)(l.workspaceFolder?.override),languageIds:(0,w.$Xm)(l.overrideIdentifiers)}}};return typeof S=="object"&&(0,w.$1m)(u,S,!1),Object.freeze(u)}g(i){const o=y=>(0,g.$yf)(y)?new Proxy(y,{get:($,S)=>o($[S]),set:($,S,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:($,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:($,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(i)}h(i,o,y){const $=E.$mn.test(i)?4:this.d.get(i),S=y?`[${y.value}] `:"";if($===4){typeof o?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){o?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,o){const y=new h.$xn(i,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:($,S)=>y.affectsConfiguration($,D(S))})}k(i){return i.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$Pbc=r,e.$Qbc=(0,k.$Mh)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,13,5,3,7,33,60,34,21,63,17,27,4,12,22,14,80,214,9]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=e.$Mcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var p;(function(V){function j(O){if(O!=null)return O}V.from=j;function W(O){if(O!=null)return O}V.to=W})(p||(p={}));var r;(function(V){function j(O){if(O!=null)return O}V.from=j;function W(O){if(O!=null)return O}V.to=W})(r||(r={}));var s;(function(V){function j(O){if(O!=null)return O}V.from=j;function W(O){if(O!=null)return O}V.to=W})(s||(s={}));var i;(function(V){function j(N){if(N){const ee=N;return ee&&!!ee.process}else return!1}V.is=j;function W(N){if(N==null)return;const ee={process:N.process,args:N.args};return N.options&&(ee.options=s.from(N.options)),ee}V.from=W;function O(N){if(N!=null)return new A.$RK(N.process,N.args,N.options)}V.to=O})(i||(i={}));var o;(function(V){function j(O){if(O!=null)return O}V.from=j;function W(O){if(O!=null)return O}V.to=W})(o||(o={}));var y;(function(V){function j(N){if(N){const ee=N;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}V.is=j;function W(N){if(N==null)return;const ee={};return N.commandLine!==void 0?ee.commandLine=N.commandLine:(ee.command=N.command,ee.args=N.args),N.options&&(ee.options=o.from(N.options)),ee}V.from=W;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$SK(N.commandLine,N.options):new A.$SK(N.command,N.args?N.args:[],N.options)}V.to=O})(y||(y={}));var $;(function(V){function j(N){if(N){const ee=N;return ee&&ee.customExecution==="customExecution"}else return!1}V.is=j;function W(N){return{customExecution:"customExecution"}}V.from=W;function O(N,ee){return ee.get(N)}V.to=O})($||(e.CustomExecutionDTO=$={}));var S;(function(V){function j(W,O){let N;return W.scope!==void 0&&typeof W.scope!="number"?N=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=v.$JF),{id:W._id,workspaceFolder:N}}V.from=j})(S||(e.TaskHandleDTO=S={}));var I;(function(V){function j(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}V.from=j})(I||(I={}));var u;(function(V){function j(N,ee){if(N==null)return[];const X=[];for(const ye of N){const De=W(ye,ee);De&&X.push(De)}return X}V.fromMany=j;function W(N,ee){if(N==null)return;let X;N.execution instanceof A.$RK?X=i.from(N.execution):N.execution instanceof A.$SK?X=y.from(N.execution):N.execution&&N.execution instanceof A.$TK&&(X=$.from(N.execution));const ye=p.from(N.definition);let De;return N.scope?typeof N.scope=="number"?De=N.scope:De=N.scope.uri:De=A.TaskScope.Workspace,!ye||!De?void 0:{_id:N._id,definition:ye,name:N.name,source:{extensionId:ee.identifier.value,label:N.source,scope:De},execution:X,isBackground:N.isBackground,group:I.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}V.from=W;async function O(N,ee,X){if(N==null)return;let ye;i.is(N.execution)?ye=i.to(N.execution):y.is(N.execution)?ye=y.to(N.execution):$.is(N.execution)&&(ye=$.to(N._id,X));const De=p.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await ee.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!De||!Pe)return;const Y=new A.$UK(De,Pe,N.name,N.source.label,ye,N.problemMatchers);return N.isBackground!==void 0&&(Y.isBackground=N.isBackground),N.group!==void 0&&(Y.group=A.$QK.from(N.group._id),Y.group&&N.group.isDefault&&(Y.group=new A.$QK(Y.group.id,Y.group.label),N.group.isDefault===!0&&(Y.group.isDefault=N.group.isDefault))),N.presentationOptions&&(Y.presentationOptions=r.to(N.presentationOptions)),N._id&&(Y._id=N._id),N.detail&&(Y.detail=N.detail),Y}V.to=O})(u||(e.TaskDTO=u={}));var d;(function(V){function j(O){return O}V.from=j;function W(O){if(O)return Object.assign(Object.create(null),O)}V.to=W})(d||(d={}));class l{#e;constructor(j,W,O){this._id=W,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let R=class{constructor(j,W,O,N,ee,X,ye,De){this.q=new C.$Ld,this.r=new C.$Ld,this.s=new C.$Ld,this.t=new C.$Ld,this.a=j.getProxy(F.$8J.MainThreadTask),this.b=O,this.c=N,this.d=ee,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,W,O){if(!O)return new A.$0J(()=>{});const N=this.w();return this.j.set(N,{type:W,provider:O,extension:j}),this.a.$registerTaskProvider(N,W),new A.$0J(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(j,W){this.a.$registerTaskSystem(j,W)}fetchTasks(j){return this.a.$fetchTasks(d.from(j)).then(async W=>{const O=[];for(const N of W){const ee=await u.to(N,this.b,this.m);ee&&O.push(ee)}return O})}get taskExecutions(){const j=[];return this.k.forEach(W=>j.push(W)),j}terminateTask(j){if(!(j instanceof l))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,W,O){const N=this.m.get(j.id);N&&(this.o.set(j.id,N),this.e.attachPtyToTerminal(W,await N.callback(O))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const W=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const W=await this.y(j.id);this.s.fire({execution:W,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const W=await this.y(j.id);this.t.fire({execution:W,exitCode:j.exitCode})}$provideTasks(j,W){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const N=[],ee=(0,M.$Kg)(()=>O.provider.provideTasks(P.CancellationToken.None)).then(X=>this.u(W,N,O,X));return new Promise(X=>{ee.then(ye=>{Promise.all(N).then(()=>{X(ye)})})})}async $resolveTask(j,W){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(W.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await u.to(W,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ee=await O.provider.resolveTask(N,P.CancellationToken.None);if(!ee)return;this.z(ee,O);const X=u.from(ee,O.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(X.execution)&&await this.x(X,ee,!0),await this.v(X)}w(){return this.h++}async x(j,W,O){const N=await this.a.$createTaskId(j);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,W.execution)),this.m.set(N,W.execution)}async y(j,W){if(typeof j=="string"){const ee=this.l.get(j);if(!ee)throw new D.$_("Unexpected: The specified task is missing an execution");return ee}const O=this.l.get(j.id);if(O)return O;const N=new Promise((ee,X)=>{function ye(De,Pe,Y){Y?ee(new l(De,Pe.id,Y)):X("Unexpected: Task does not exist.")}W?ye(this,j,W):u.to(j.task,this.b,this.m).then(De=>ye(this,j,De))});return this.l.set(j.id,N),N.then(ee=>(this.k.set(j.id,ee),ee),ee=>Promise.reject(ee))}z(j,W){j._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$Mcc=R,e.$Mcc=R=Ke([Ve(0,a.$9L),Ve(1,b.$mM),Ve(2,h.$Nbc),Ve(3,E.$hM),Ve(4,g.$Qbc),Ve(5,k.$9bc),Ve(6,n.$7i),Ve(7,c.$Dbc)],R);let B=class extends R{constructor(j,W,O,N,ee,X,ye,De){super(j,W,O,N,ee,X,ye,De),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(j,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const O=u.from(W,j);if(O===void 0)throw new Error("Task is not valid");if($.is(O.execution))await this.x(O,W,!1);else throw new D.$0;const N=await this.y(await this.a.$getTaskExecution(O),W);return this.a.$executeTask(O).catch(ee=>{throw new Error(ee)}),N}u(j,W,O,N){const ee=[];if(N)for(const X of N){this.z(X,O),(!X.definition||!j[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=u.from(X,O.extension);ye&&$.is(ye.execution)?(ee.push(ye),W.push(this.x(ye,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:O.extension}}async v(j){if($.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,W,O){}};e.$Ncc=B,e.$Ncc=B=Ke([Ve(0,a.$9L),Ve(1,b.$mM),Ve(2,h.$Nbc),Ve(3,E.$hM),Ve(4,g.$Qbc),Ve(5,k.$9bc),Ve(6,n.$7i),Ve(7,c.$Dbc)],B),e.$Occ=(0,m.$Mh)("IExtHostTask")}),define(Ae[266],Re([1,0,19,21,41,37,23,59,47]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class g{constructor(a,b,m){this.k=a,this.l=b,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&F.$tj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&F.$tj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const b=this.k.folderQueries||[];return new Promise((m,f)=>{const t=n=>{this.f++,a(n)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(n=>{const c=n.toString(),v=w.$lc(c);this.j&&this.j(c,v)||this.v(t,{base:n,basename:v})}),Promise.all(b.map(n=>this.p(n,t))).then(n=>{m({limitHit:this.e,stats:n[0]||void 0})},n=>{f(new Error((0,C.$xi)(n)))})})}async p(a,b){const m=new M.$Vd,f=this.q(a),t=this.r(),n=new E.$SI(this.k,a),c=!n.hasSiblingExcludeClauses();let v;try{this.h.add(m),v=h.$Hd.create();const D=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,m.token),p=v.elapsed(),r=h.$Hd.create();return this.g&&!this.e||(D&&D.forEach(s=>{const i=w.$ec.relative(a.folder.path,s.path);if(c){const o=w.$lc(s.path);this.v(b,{base:a.folder,relativePath:i,basename:o});return}this.s(t,a.folder,i,b)}),this.g&&!this.e)?null:(this.u(t,n,b),{providerTime:p,postProcessTime:r.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(a){const b=(0,E.$RI)(this.k.includePattern,a.includePattern),m=(0,E.$RI)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:m,includes:b,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},b,m,f){if(m===this.a){const n=w.$lc(this.a);this.v(f,{base:b,relativePath:this.a,basename:n})}function t(n){const c=w.$lc(n),v=w.$kc(n);let D=a[v];D||(D=a[v]=[],t(v)),D.push({base:b,relativePath:n,basename:c})}t(m)}u({rootEntries:a,pathToEntries:b},m,f){const t=this,n=this.a;function c(v){const D=(0,E.$UI)(()=>v.map(p=>p.basename));for(let p=0,r=v.length;p<r;p++){const s=v[p],{relativePath:i,basename:o}=s;if(m.matchesExcludesSync(i,o,n!==o?D:void 0))continue;const y=b[i];if(y)c(y);else{if(i===n)continue;t.v(f,s)}if(t.e)break}}c(a)}v(a,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(b))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,b,m,f){const t=this.c(a.cacheKey),n=new g(a,b,t&&t.token);let c=0;const v=D=>{c+=D.length,m(D.map(p=>this.d(p)))};return this.e(n,P.a,v,f).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:D.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new M.$Vd),this.b.get(a)}d(a){return a.relativePath?{resource:A.$tg(a.base,a.relativePath)}:{resource:a.base}}e(a,b,m,f){const t=f.onCancellationRequested(()=>{a.cancel()}),n=v=>{v&&(c.push(v),b>0&&c.length>=b&&(m(c),c=[]))};let c=[];return a.search(n).then(v=>(c.length&&m(c),t.dispose(),v),v=>(c.length&&m(c),t.dispose(),Promise.reject(v)))}}e.$Ycc=P}),define(Ae[267],Re([1,0,18,231,37,90,28,12,19,23,15,16,2,282,167,43,14,54,102,265,47]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=void 0;let p=class{constructor(d,l,R,B,V){this.a=d,this.b=l,this.c=R,this.d=B,this.e=V}text(d,l,R={}){d=this.f(d,R);const B=this.a.getValue(),V=l&&l.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(l?.map(n.$8h),R),type:2,contentPattern:d,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:B.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(d,l){const R=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const B={...d,wordSeparators:R.editor.wordSeparators};return this.j(d,l)&&(B.isCaseSensitive=!0),this.k(d)&&(B.isMultiline=!0),l.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=l.notebookSearchConfig.includeMarkupInput),l.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=l.notebookSearchConfig.includeMarkupPreview),l.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=l.notebookSearchConfig.includeCodeInput),l.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=l.notebookSearchConfig.includeOutput),B}file(d,l={}){return{...this.h(d,l),type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey}}g(d,l){return d?(d=Array.isArray(d)?d.map(y):y(d),l?this.parseSearchPaths(d):{pattern:s(...Array.isArray(d)?d:[d])}):{}}h(d=[],l={}){const R=this.g(l.includePattern,l.expandPatterns),B=this.g(l.excludePattern,l.expandPatterns),V=d.length>1,j=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(N=>this.q(N,l,B)):d.map(N=>this.r(N,l,B,V))).filter(N=>!!N),W={_reason:l._reason,folderQueries:j,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:B.pattern,includePattern:R.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const N=w.$Fb(w.$Pb(this.c.groups.map(ye=>ye.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ee=N.filter(ye=>(0,D.$II)(W,ye.fsPath)),X=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...W,...X}}const O=l.extraFileResources&&l.extraFileResources.filter(N=>(0,D.$II)(W,N.fsPath));return W.extraFileResources=O&&O.length?O:void 0,W}i(d){const l=[],R=new A.$yc,B={};let V=!1;return d.forEach(j=>{if(j.scheme===h.Schemas.walkThrough)return;if((0,g.$xg)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:E.$kc(j.fsPath)});let N=R.get(O);N||(V=!0,N={folder:O,includePattern:{}},l.push(N),R.set(O,N));const ee=E.$jc(O.fsPath,j.fsPath);(0,k.$Hf)(N.includePattern)[ee.replace(/\\/g,"/")]=!0}else j.fsPath&&(V=!0,B[j.fsPath]=!0)}),{folderQueries:l,includePattern:B,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(d,l){if(l.isSmartCase){if(d.isRegExp){if(P.$nf(d.pattern,!0))return!0}else if(P.$nf(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,b.$mB)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const l=X=>E.$gc(X)||/^\.\.?([\/\\]|$)/.test(X),B=(Array.isArray(d)?d:i(d)).map(X=>{const ye=this.e.resolvedUserHome;return ye?(0,F.$mv)(X,ye.scheme===h.Schemas.file?ye.fsPath:ye.path):X}),V=M.$I(B,X=>l(X)?"searchPaths":"exprSegments"),j=(V.exprSegments||[]).map(X=>P.$Ie(X,"/")).map(X=>P.$Ie(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),W={},O=this.m(V.searchPaths||[]);O&&O.length&&(W.searchPaths=O);const N=w.$Pb(j),ee=s(...N);return ee&&(W.pattern=ee),W}l(d,l){return l.disregardExcludeSettings?void 0:(0,D.$HI)(d,!l.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const l=d.flatMap(B=>{let{pathPortion:V,globPortion:j}=r(B);return j&&(j=$(j)),this.n(V).flatMap(O=>this.o(O,j))}),R=new Map;return l.forEach(B=>{const V=B.searchPath.toString(),j=R.get(V);j?B.pattern&&(j.pattern=j.pattern||{},j.pattern[B.pattern]=!0):R.set(V,{searchPath:B.searchPath,pattern:B.pattern?s(B.pattern):void 0})}),Array.from(R.values())}n(d){if(E.$gc(d)){const l=this.b.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==h.Schemas.file?[{searchPath:l[0].uri.with({path:d})}]:[{searchPath:a.URI.file(E.$fc(d))}]}if(this.b.getWorkbenchState()===2){const l=this.b.getWorkspace().folders[0].uri;if(d=y(d),d.startsWith("../")||d===".."){const B=E.$ec.resolve(l.path,d);return[{searchPath:l.with({path:B})}]}const R=$(d);return[{searchPath:l,pattern:R}]}else{if(d==="./"||d===".\\")return[];{const l=d.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(V=>{const j=l.match(new RegExp(`^${P.$De(V.name)}(?:/(.*)|$)`));return j?{match:j,folder:V}:null}).filter(k.$Ef);if(B.length)return B.map(V=>{const j=V.match[1];return{searchPath:V.folder.uri,pattern:j&&$(j)}});{const V=d.match(/\.[\/\\](.+)[\/\\]?/),j=V?V[1]:d,W=m.localize(0,null,j);throw new Error(W)}}}}o(d,l){const R=d.pattern&&l?`${d.pattern}/${l}`:d.pattern||l,B=[{searchPath:d.searchPath,pattern:R}];return R&&!R.endsWith("**")&&B.push({searchPath:d.searchPath,pattern:R+"/**"}),B}q(d,l,R){const B=this.r((0,n.$8h)(d.searchPath),l,R,!1);return B?{...B,includePattern:d.pattern}:null}r(d,l,R,B){let V;const j=a.URI.isUri(d)?d:d.uri;if(R.searchPaths){const X=R.searchPaths.filter(ye=>(0,g.$mg)(ye.searchPath,j))[0];if(X&&!X.pattern)return null;X&&(V=X.pattern)}const W=this.a.getValue({resource:j}),N={...this.l(W,l)||{},...V||{}},ee=a.URI.isUri(d)?(0,g.$qg)(d):d.name;return{folder:j,folderName:B?ee:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof l.disregardParentIgnoreFiles=="boolean"?l.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!W.search.followSymlinks}}};e.$LJ=p,e.$LJ=p=Ke([Ve(0,f.$gi),Ve(1,n.$Vh),Ve(2,c.$9B),Ve(3,t.$7i),Ve(4,v.$JJ)],p);function r(u){const d=u.match(/[\*\{\}\(\)\[\]\?]/);if(d){const l=d.index,R=u.substr(0,l).match(/[/|\\][^/\\]*$/);if(R){let B=u.substr(0,R.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:u.substr((R.index||0)+1)}}}return{pathPortion:u}}function s(...u){return u.length?u.reduce((d,l)=>(d[l]=!0,d),Object.create(null)):void 0}function i(u){return C.$rj(u,",").map(d=>d.trim()).filter(d=>!!d.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function y(u){return u.replace(/\\/g,"/")}function $(u){return y(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(u){return u.replace(/([?*[\]])/g,"[$1]")}function I(u,d){u=w.$Kb(u,B=>B.toString());const l=[],R=d.getWorkspace();return u&&u.forEach(B=>{let V;if(d.getWorkbenchState()===2)V=(0,g.$vg)(R.folders[0].uri,B),V&&V!=="."&&(V="./"+V);else{const j=d.getWorkspaceFolder(B);if(j){const W=j.name;if(R.folders.filter(N=>N.name===W).length===1){const N=(0,g.$vg)(j.uri,B);N===""?V=`./${j.name}`:V=`./${j.name}/${N}`}else V=B.fsPath}}V&&l.push(S(V))}),l}e.$MJ=I}),define(Ae[268],Re([1,0,23,2,21,9,4,267,47,54]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlb=e.$ilb=void 0;const P=7e3;function k(f,t){const n=t.activationEvents;if(!n)return Promise.resolve(void 0);const c=[],v=[];for(const o of n)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||f.forceUsingSearch?v.push(y):c.push(y)}if(c.length===0&&v.length===0)return Promise.resolve(void 0);let D;const p=new Promise((o,y)=>{D=o}),r=o=>D({activationEvent:o}),s=Promise.all(c.map(o=>a(f,o,r))).then(()=>{}),i=b(f,t.identifier,v,r);return Promise.all([s,i]).then(()=>{D(void 0)}),p}e.$ilb=k;async function a(f,t,n){for(const c of f.folders)if(await f.exists(w.$tg(M.URI.revive(c),t))){n(`workspaceContains:${t}`);return}}async function b(f,t,n,c){if(n.length===0)return Promise.resolve(void 0);const v=new C.$Vd,D=f.checkExists(f.folders,n,v.token),p=setTimeout(async()=>{v.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let r=!1;try{r=await D}catch(s){F.$2(s)||F.$Y(s)}v.dispose(),clearTimeout(p),r&&c(`workspaceContains:${n.join(",")}`)}function m(f,t,n,c){const v=f.get(A.$Lh),D=f.get(E.$zI),r=v.createInstance(h.$LJ).file(t.map(s=>(0,g.$8h)(M.URI.revive(s))),{_reason:"checkExists",includePattern:n,exists:!0});return D.fileSearch(r,c).then(s=>!!s.limitHit,s=>F.$2(s)?!1:Promise.reject(s))}e.$jlb=m}),define(Ae[35],Re([1,0,148,19,87,23,13,6,49,2,14,3,34,209,84,33,26,106,9,20,25,188,7,97,4,27,85,17,71,86,63,5,268,83,190,12,81,59,22,82]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s,i,o,y,$,S,I,u,d,l,R,B,V,j,W,O,N){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=e.$jcc=e.$icc=e.$hcc=void 0,e.$hcc=(0,i.$Mh)("IHostUtils");let X=ee=class extends h.$Qc{constructor(ie,z,q,ue,we,ve,me,ke,re,he,se,oe){super(),this.X=oe,this.a=this.B(new d.$Ld),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=q,this.f=me,this.j=ue,this.m=we,this.s=ve,this.t=re,this.u=he,this.w=se,this.y=this.g.getProxy(k.$8J.MainThreadWorkspace),this.z=this.g.getProxy(k.$8J.MainThreadTelemetry),this.C=this.g.getProxy(k.$8J.MainThreadExtensionService),this.D=new A.$Qg,this.F=new A.$Qg,this.G=new A.$Qg,this.H=new A.$Qg,this.I=new ce(this.f.extensions.activationEvents),this.L=new n.$33b(this.I,this.f.extensions.allExtensions);const de=new v.$Yl(this.f.extensions.myExtensions);this.J=new n.$33b(this.I,le(this.L,de)),O.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new m.$1bc(this.g,this.s),this.N=new R.$acc(this.g),this.O=ke,this.h=ie.createChild(new S.$Kh([m.$2bc,this.M],[R.$bcc,this.N])),this.P=this.B(new b.$Zbc(this.J,this.L,{onExtensionActivationError:(Ie,L,K)=>{this.C.$onExtensionActivationError(Ie,c.$1(L),K)},actualActivateExtension:async(Ie,L)=>{if(n.$33b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,L),new b.$Ybc;const K=this.J.getExtensionDescription(Ie);return this.db(K,L)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){c.$Y(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Sg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const z=await this.C.$getExtension(ie);return z&&{...z,identifier:new v.$Xl(z.identifier.value),extensionLocation:g.URI.revive(z.extensionLocation)}}Z(ie,z){return this.P.activateByEvent(ie,z)}$(ie,z){return this.P.activateById(ie,z)}activateByIdWithErrors(ie,z){return this.$(ie,z).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(ie.fsPath);return g.URI.file(z)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new Ee(ie))),this.Q}async bb(ie){const z=E.$Sh.forUris(q=>F.$kg.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const ue=await this.ab(q.extensionLocation);z.set(ue,q)}})),z}cb(ie){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return z;const q=this.P.getActivatedExtension(ie);if(!q)return z;try{typeof q.module.deactivate=="function"&&(z=Promise.resolve(q.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(ue)}try{(0,h.$Lc)(q.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(ue)}return z}async db(ie,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,z).then(q=>{const ue=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,z),this.eb(ie,z,"success",ue),q},q=>{throw this.eb(ie,z,"failure"),q})}eb(ie,z,q,ue){const we=De(ie,z);this.z.$publicLog2("extensionActivationTimes",{...we,...ue||{},outcome:q})}fb(ie,z){const q=De(ie,z);this.z.$publicLog2("activatePlugin",q);const ue=this.ub(ie);if(!ue)return Promise.resolve(new b.$Xbc(b.$Ubc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${ie.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const we=new b.$Vbc(z.startup);return Promise.all([this.vb(ie,(0,F.$tg)(ie.extensionLocation,ue),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const z=new p.$4bc(ie,this.M),q=new p.$3bc(ie.identifier.value,!1,this.M),ue=new B.$ccc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,ve=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([z.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const me=this;let ke,re;const he=(0,t.$7E)(ie,"ipc")?this.f.messagePorts?.get(v.$Xl.toKey(ie.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:q,secrets:ue,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return M.$hc(ie.extensionLocation.fsPath,se)},get storagePath(){return me.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me.O.globalValue(ie).fsPath},get logPath(){return M.$hc(me.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return g.URI.joinPath(me.f.logsLocation,ie.identifier.value)},get storageUri(){return me.O.workspaceValue(ie)},get globalStorageUri(){return me.O.globalValue(ie)},get extensionMode(){return we},get extension(){return ke===void 0&&(ke=new Y(me,ie.identifier,ie,ve,!1)),ke},get extensionRuntime(){return(0,t.$8E)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!he)return;const se=d.Event.buffer(d.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),re={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return re}})})}static hb(ie,z,q,ue,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,z,q,ue,we).then(ve=>new b.$Wbc(!1,null,we.build(),q,ve,ue.subscriptions))}static ib(ie,z,q,ue,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ve=typeof global=="object"?global:self,me=q.activate.apply(ve,[ue]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(me).then(ke=>(we.activateResolveStop(),ke))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}jb(ie,z){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:z}).then(void 0,q=>{this.s.error(q)})}kb(ie,z=0){const ue=Date.now();(0,O.$A)(()=>{for(let we=z;we<ie.length;we+=1){const ve=ie[we];for(const me of ve.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-ue>50){this.kb(ie,we);break}else this.jb(ve,me)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const z=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(z)this.kb(q);else for(const ue of q)if(ue.activationEvents)for(const we of ue.activationEvents)we==="onStartupFinished"&&this.jb(ue,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const z=this.j.workspace?this.j.workspace.folders:[],q=this.nb(z),ue=this.pb(),we=Promise.all([ue,ie,q]).then(()=>{});return Promise.race([we,(0,A.$Sg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(ie,z))).then(()=>{})}async ob(ie,z){if(this.isActivated(z.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:q||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,me,ke)=>this.y.$checkExists(ve,me,ke)},we=await(0,l.$ilb)(ue,z);if(we)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:z}=this.f.environment;if(!ie||!z)throw new Error(w.localize(0,null));const q=await this.vb(null,z,new b.$Vbc(!1));if(!q||typeof q.run!="function")throw new Error(w.localize(1,null,z.toString()));return new Promise((ue,we)=>{const ve=(re,he)=>{re?(O.$s&&this.s.error("Test runner called back with error",re),we(re)):(O.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof he=="number"&&he>0?1:0))},me=(0,F.$hg)(z),ke=q.run(me,ve);ke&&ke.then&&ke.then(()=>{O.$s&&this.s.info("Test runner finished successfully."),ue(0)}).catch(re=>{O.$s&&this.s.error("Test runner finished with error",re),we(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Sg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,z){return this.R[ie]=z,(0,h.$Oc)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:z}=await this.sb(ie);return z?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const z=ie.indexOf("+");if(z===-1)throw new r.$dK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,z){const q=W.$Hd.create(!1),ue=()=>`[resolveAuthority(${(0,s.$Pk)(ie)},${z})][${q.elapsed()}ms] `,we=Q=>this.s.info(`${ue()}${Q}`),ve=Q=>this.s.warn(`${ue()}${Q}`),me=(Q,J=void 0)=>this.s.error(`${ue()}${Q}`,J),ke=Q=>{if(Q instanceof r.$dK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},re=async Q=>{we(`activating resolver for ${Q}...`);const{resolver:J,authorityPrefix:x}=await this.sb(Q);if(!J)throw me(`no resolver for ${x}`),new r.$dK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:Q}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(re)).catch(async Q=>{if(!(Q instanceof r.$dK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return ve(`resolving nested authorities failed: ${Q.message}`),[await re(ie)]})}catch(Q){return ke(Q)}const oe=new A.$3g;oe.cancelAndSet(()=>we("waiting..."),1e3);let de,Ie;for(const[Q,{authorityPrefix:J,resolver:x,remoteAuthority:ae}]of se.entries())try{if(Q===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${J}`),de=await x.resolve(ae,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${J}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,r.$cK.isManagedResolvedAuthority(de)?de:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await x.resolveExecServer?.(ae,{resolveAttempt:z,execServer:Ie}),!Ie)throw new r.$dK(`Exec server was not available for ${ae}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Fe){return C.mark(`code/extHost/didResolveAuthorityError/${J}`),me("returned an error",Fe),oe.dispose(),ke(Fe)}oe.dispose();const L={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures},K={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.$cK.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let G;if(r.$cK.isManagedResolvedAuthority(de)){const Q=z;this.X.setFactory(Q,de.makeConnection),G={authority:ie,connectTo:new s.$Mk(Q),connectionToken:de.connectionToken}}else G={authority:ie,connectTo:new s.$Nk(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:L}}}async $getCanonicalURI(ie,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Pk)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const ue=g.URI.revive(z);if(typeof q.getCanonicalURI>"u")return ue;const we=await(0,A.$Kg)(()=>q.getCanonicalURI(ue));return we||ue}$startExtensionHost(ie){ie.toAdd.forEach(ue=>ue.extensionLocation=g.URI.revive(ue.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,z){return z===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,z){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,z),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=g.URI.revive(ve.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie),ue=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const z=D.$_d.alloc(ie),q=Math.random()%256;for(let ue=0;ue<ie;ue++)z.writeUInt8(q,ue);return z}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$icc=X,e.$icc=X=ee=Ke([Ve(0,i.$Lh),Ve(1,e.$hcc),Ve(2,$.$9L),Ve(3,f.$Nbc),Ve(4,a.$Qbc),Ve(5,P.$7i),Ve(6,o.$mM),Ve(7,y.$7bc),Ve(8,I.$Ovb),Ve(9,u.$9bc),Ve(10,j.$ecc),Ve(11,N.$fcc)],X);function ye($e,ie,z,q){$e.addActivationEvents(q.addActivationEvents);const ue=new n.$33b($e,ie.getAllExtensionDescriptions());ue.deltaExtensions(q.toAdd,q.toRemove);const we=new v.$Yl(z.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of q.myToRemove)we.delete(me);for(const me of q.myToAdd)we.add(me);const ve=le(ue,we);return{globalRegistry:ue,myExtensions:ve}}function De($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$jcc=(0,i.$Mh)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(ie,z,q,ue,we){this.#e=ie,this.#t=z,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=M.$fc((0,F.$hg)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=ue,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$kcc=Y;function le($e,ie){return $e.getAllExtensionDescriptions().filter(z=>ie.has(z.identifier))}class Ee{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$lcc=Ee;class ce{constructor(ie){this.a=new v.$Zl,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const z of Object.keys(ie))this.a.set(z,ie[z])}}}),define(Ae[269],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;let f=class{constructor(D,p,r,s,i,o,y){this.c=D,this.d=p,this.e=r,this.f=s,this.g=i,this.h=o,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const D=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const p=await this.g.getExtensionPathIndex();this.register(new n(this.c,p,this.d,D,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,p,this.h.environment.appUriScheme))}register(D){if("nodeModuleName"in D)if(Array.isArray(D.nodeModuleName))for(const p of D.nodeModuleName)this.a.set(p,D);else this.a.set(D.nodeModuleName,D);typeof D.alternativeModuleName=="function"&&this.b.push(p=>D.alternativeModuleName(p))}};e.$Hdc=f,e.$Hdc=f=Ke([Ve(2,P.$Lh),Ve(3,F.$Qbc),Ve(4,k.$jcc),Ve(5,g.$mM),Ve(6,a.$7i)],f);let t=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(D){if(D.environment.appRoot&&m.a.size){const p=(0,b.$De)(this.c(D.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${p}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(D){if(!this.b)return;const p=this.b.exec(this.c(D));if(!p)return;const[,r,s,i]=p,o=m.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),r+o+i}c(D){return D.replace(/\\/g,"/")}};t=m=Ke([Ve(0,g.$mM)],t);class n{constructor(D,p,r,s,i){this.c=D,this.d=p,this.e=r,this.f=s,this.g=i,this.nodeModuleName="vscode",this.a=new h.$Zl}load(D,p){const r=this.d.findSubstr(p);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((i,o)=>s+=`	${o} -> ${i.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${p}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$2E,this.e,this.f)}return this.b}}let c=class{constructor(D,p,r){this.e=D,this.f=p,this.nodeModuleName=["open","opn"],this.d=r.getProxy(C.$8J.MainThreadTelemetry);const s=r.getProxy(C.$8J.MainThreadWindow);this.c=(i,o)=>{const y=M.URI.parse(i);return o?this.g(i,o):y.scheme==="http"||y.scheme==="https"?s.$openUri(y,i,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?s.$openUri(y,i,{}):this.g(i,o)}}load(D,p,r){const s=this.e.findSubstr(p);return s&&(this.a=s.identifier.value,this.h()),this.b=r(D),this.c}g(D,p){return this.i(),this.b(D,p)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([Ve(2,E.$9L)],c)}),define(Ae[112],Re([1,0,48,6,19,74,4,60,61,35,7,33,200,34]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=void 0,e.$Rcc=(0,A.$Mh)("IExtHostVariableResolverProvider");class m extends a.$0M{constructor(n,c,v,D,p,r,s){function i(){if(v){const o=v.activeEditor();if(o)return o.document.uri;const y=D.tabGroups.all.find($=>$.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof P.$PL||y.input instanceof P.$UL)return y.input.modified;if(y.input instanceof P.$OL||y.input instanceof P.$TL||y.input instanceof P.$RL)return y.input.uri}}}super({getFolderUri:o=>{const y=r.folders.filter($=>$.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,y)=>p.getConfiguration(void 0,o).get(y),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return C.$fc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=i();if(o){const y=c.getWorkspaceFolder(o);if(y)return C.$fc(y.uri.fsPath)}}},getSelectedText:()=>{if(v){const o=v.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(v){const o=v.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>n.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(F.env))}}let f=class extends M.$Qc{constructor(n,c,v,D,p){super(),this.b=n,this.c=c,this.g=v,this.h=D,this.j=p,this.a=new w.$T(async()=>{const r=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,r,i,this.m())})}getResolver(){return this.a.value}m(){}};e.$Scc=f,e.$Scc=f=Ke([Ve(0,g.$jcc),Ve(1,k.$Nbc),Ve(2,h.$hM),Ve(3,b.$Qbc),Ve(4,E.$Pcc)],f)}),define(Ae[113],Re([1,0,13,5,2,4,3,61,35,17,7,33,193,195,34,112]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=void 0,e.$Tcc=(0,F.$Mh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,i,o,y,$,S){this.E=i,this.F=o,this.G=y,this.H=$,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Ld,this.n=new M.$Ld,this.o=new M.$Ld,this.u=new M.$Ld,this.k=s.getProxy(A.$8J.MainThreadDebugService),this.y=new M.$Ld,this.A=new M.$Ld,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(u=>{this.J(I)}),this.J(I)})}asDebugSourceUri(s,i){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,$="?";return i&&(y+=`${$}session=${encodeURIComponent(i.id)}`,$="&"),y+=`${$}ref=${o.sourceReference}`,C.URI.parse(y)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const i=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const $ of y)(0,b.$mF)($)&&i.push($.type)}this.k.$registerDebugTypes(i)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(i=>s.push(i)),s}addBreakpoints(s){const i=s.filter($=>{const S=$.id;return this.w.has(S)?!1:(this.w.set(S,$),!0)});this.U(i,[],[]);const o=[],y=new Map;for(const $ of i)if($ instanceof P.$9K){let S=y.get($.location.uri.toString());S||(S={type:"sourceMulti",uri:$.location.uri,lines:[]},y.set($.location.uri.toString(),S),o.push(S)),S.lines.push({id:$.id,enabled:$.enabled,condition:$.condition,hitCondition:$.hitCondition,logMessage:$.logMessage,line:$.location.range.start.line,character:$.location.range.start.character})}else $ instanceof P.$0K&&o.push({type:"function",id:$.id,enabled:$.enabled,hitCondition:$.hitCondition,logMessage:$.logMessage,condition:$.condition,functionName:$.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){const i=s.filter(S=>this.w.delete(S.id));this.U([],i,[]);const o=i.filter(S=>S instanceof P.$9K).map(S=>S.id),y=i.filter(S=>S instanceof P.$0K).map(S=>S.id),$=i.filter(S=>S instanceof P.$$K).map(S=>S.id);return this.k.$unregisterBreakpoints(o,y,$)}startDebugging(s,i,o){return this.k.$startDebugging(s?s.uri:void 0,i,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,o){if(!i)return new P.$0J(()=>{});const y=this.d++;return this.f.push({type:s,handle:y,provider:i}),this.k.$registerDebugConfigurationProvider(s,o,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,y),new P.$0J(()=>{this.f=this.f.filter($=>$.provider!==i),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(s,i,o){if(!o)return new P.$0J(()=>{});if(!this.Q(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.N(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:i,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(i,y),new P.$0J(()=>{this.h=this.h.filter($=>$.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new P.$0J(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:i}),new P.$0J(()=>{this.j=this.j.filter(y=>y.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let o;const y=await this.W(s);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,i)}K(s,i){if(s.type==="implementation")return new D(s.implementation)}L(){}async $startDASession(s,i){const o=this,y=await this.V(i);return this.S(this.N(y.type),y).then($=>{if(!$)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const S=this.M($),I=this.K(S,y);if(!I)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const u=I;return this.B.set(s,u),this.R(y).then(d=>(d&&this.C.set(s,d),u.onMessage(async l=>{if(l.type==="request"&&l.command==="handshake"){const R=l,B={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);B.body={signature:V},u.sendResponse(B)}else throw new Error("no signer")}catch(V){B.success=!1,B.message=V.message,u.sendResponse(B)}}else d&&d.onDidSendMessage&&d.onDidSendMessage(l),l=(0,b.$rF)(l,!0),o.k.$acceptDAMessage(s,l)}),u.onError(l=>{d&&d.onError&&d.onError(l),this.k.$acceptDAError(s,l.name,l.message,l.stack)}),u.onExit(l=>{d&&d.onExit&&d.onExit(l??void 0,void 0),this.k.$acceptDAExit(s,l??void 0,void 0)}),d&&d.onWillStartSession&&d.onWillStartSession(),u.startSession()))})}$sendDAMessage(s,i){i=(0,b.$qF)(i,!1);const o=this.C.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(i),this.B.get(s)?.sendMessage(i)}$stopDASession(s){const i=this.C.get(s);this.C.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const o=this.B.get(s);return this.B.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],o=[],y=[];if(s.added)for(const $ of s.added){const S=$.id;if(S&&!this.w.has(S)){let I;if($.type==="function")I=new P.$0K($.functionName,$.enabled,$.condition,$.hitCondition,$.logMessage);else if($.type==="data")I=new P.$$K($.label,$.dataId,$.canPersist,$.enabled,$.hitCondition,$.condition,$.logMessage);else{const u=C.URI.revive($.uri);I=new P.$9K(new P.$jK(u,new P.$$J($.line,$.character)),$.enabled,$.condition,$.hitCondition,$.logMessage)}(0,P.$7K)(I,S),this.w.set(S,I),i.push(I)}}if(s.removed)for(const $ of s.removed){const S=this.w.get($);S&&(this.w.delete($),o.push(S))}if(s.changed){for(const $ of s.changed)if($.id){const S=this.w.get($.id);if(S){if(S instanceof P.$0K&&$.type==="function"){const I=S;I.enabled=$.enabled,I.condition=$.condition,I.hitCondition=$.hitCondition,I.logMessage=$.logMessage,I.functionName=$.functionName}else if(S instanceof P.$9K&&$.type==="source"){const I=S;I.enabled=$.enabled,I.condition=$.condition,I.hitCondition=$.hitCondition,I.logMessage=$.logMessage,I.location=new P.$jK(C.URI.revive($.uri),new P.$$J($.line,$.character))}y.push(S)}}}this.U(i,o,y)}async $acceptStackFrameFocus(s){let i;const o=s.sessionId?await this.V(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?i=new P.$eL(o,s.threadId):i=new P.$dL(o,s.threadId,s.frameId),this.z=i,this.A.fire(this.z)}$provideDebugConfigurations(s,i,o){return(0,w.$Kg)(async()=>{const y=this.P(s);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const $=await this.W(i);return y.provideDebugConfigurations($,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(s,i,o,y){return(0,w.$Kg)(async()=>{const $=this.P(s);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(i);return $.resolveDebugConfiguration(S,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,o,y){return(0,w.$Kg)(async()=>{const $=this.P(s);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(i);return $.resolveDebugConfigurationWithSubstitutedVariables(S,o,y)})}async $provideDebugAdapter(s,i){const o=this.O(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(i);return this.S(o,y).then($=>{if(!$)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M($)})}async $acceptDebugSessionStarted(s){const i=await this.V(s);this.m.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.V(s);i&&(this.n.fire(i),this.l.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,i){(await this.V(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const y={session:await this.V(s),event:i.event,body:i.body};this.u.fire(y)}M(s){if(s instanceof P.$_K)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.$aL)return{type:"server",port:s.port,host:s.host};if(s instanceof P.$bL)return{type:"pipeServer",path:s.path};if(s instanceof P.$cL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const i=this.h.filter(o=>o.type===s);if(i.length>0)return i[0].factory}O(s){const i=this.h.filter(o=>o.handle===s);if(i.length>0)return i[0].factory}P(s){const i=this.f.filter(o=>o.handle===s);if(i.length>0)return i[0].provider}Q(s,i){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===i)return!0}}return!1}R(s){const o=s.configuration.type,y=this.j.filter($=>$.type===o||$.type==="*").map($=>(0,w.$Kg)(()=>$.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(y).then($=>{const S=$.filter(I=>!!I);if(S.length>0)return new v(S)}),new Promise($=>setTimeout(()=>$(void 0),1e3))]).catch($=>{})}async S(s,i){const o=i.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$aL(o));if(s){const $=await this.F.getExtensionRegistry();return(0,w.$Kg)(()=>s.createDebugAdapterDescriptor(i,this.T(i,$))).then(S=>{if(S)return S})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(i,y))}T(s,i){}U(s,i,o){(s.length>0||i.length>0||o.length>0)&&this.y.fire(Object.freeze({added:s,removed:i,changed:o}))}async V(s){if(s)if(typeof s=="string"){const i=this.l.get(s);if(i)return i}else{let i=this.l.get(s.id);if(!i){const o=await this.W(s.folderUri),y=s.parent?this.l.get(s.parent):void 0;i=new n(this.k,s.id,s.type,s.name,o,s.configuration,y),this.l.set(i.id,i),this.k.$sessionCached(i.id)}return i}throw new Error("cannot find session")}W(s){if(s){const i=C.URI.revive(s);return this.E.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};e.$Ucc=t,e.$Ucc=t=Ke([Ve(0,g.$9L),Ve(1,k.$Nbc),Ve(2,E.$jcc),Ve(3,m.$Qbc),Ve(4,h.$Pcc),Ve(5,f.$Rcc)],t);class n{constructor(s,i,o,y,$,S,I){this.d=s,this.f=i,this.g=o,this.h=y,this.i=$,this.j=S,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,i){return this.d.$customDebugAdapterRequest(this.f,s,i)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Vcc=n;class c{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.$Wcc=c;class v{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.d.forEach(o=>o.onExit?o.onExit(s,i):void 0)}}class D extends a.$Pcb{constructor(s){super(),this.h=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let p=class extends t{constructor(s,i,o,y,$,S){super(s,i,o,y,$,S)}};e.$Xcc=p,e.$Xcc=p=Ke([Ve(0,g.$9L),Ve(1,k.$Nbc),Ve(2,E.$jcc),Ve(3,m.$Qbc),Ve(4,h.$Pcc),Ve(5,f.$Rcc)],p)}),define(Ae[270],Re([1,0,9,87,2,3,261,14,70,71,27,172,17,56,35,58]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class t{static async installEarlyHandler(v){Error.stackTraceLimit=100;const D=v.get(h.$7i),r=v.get(a.$9L).getProxy(F.$8J.MainThreadErrors);w.setUnexpectedErrorHandler(s=>{D.error(s);const i=w.$1(s);r.$onUnexpectedError(i)})}static async installFullHandler(v){const D=v.get(h.$7i),p=v.get(a.$9L),r=v.get(m.$jcc),s=v.get(f.$qM),i=p.getProxy(F.$8J.MainThreadExtensionService),o=p.getProxy(F.$8J.MainThreadErrors),y=await r.getExtensionPathIndex(),$=new WeakMap;function S(d,l){if($.has(d))return $.get(d).stack;let R="",B,V;for(const W of l)R+=`
	at ${W.toString()}`,V=W.getFileName(),!B&&V&&(B=y.findSubstr(C.URI.file(V)));const j=`${d.name||"Error"}: ${d.message||""}${R}`;return $.set(d,{extensionIdentifier:B?.identifier,stack:j}),j}const I=Symbol("prepareStackTrace wrapped");let u=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(d){if(d===S||!d||d[I]){u=d||S;return}u=function(l,R){return S(l,R),d.call(Error,l,R)},Object.assign(u,{[I]:!0})}}),w.setUnexpectedErrorHandler(d=>{D.error(d);const l=w.$1(d),R=$.get(d);if(!R?.extensionIdentifier){o.$onUnexpectedError(l);return}i.$onExtensionRuntimeError(R.extensionIdentifier,l);const B=s.onExtensionError(R.extensionIdentifier,d);D.trace("forwarded error to extension?",B,R)})}}e.$Idc=t;class n{constructor(v,D,p,r,s){this.a=p,this.b=new A.$_3b(v,null,r),D=n.e(D,this.b);const i=new g.$Kh(...(0,E.$pr)());i.set(P.$mM,{_serviceBrand:void 0,...D,messagePorts:s}),i.set(a.$9L,new a.$0L(this.b)),i.set(b.$Kbc,new b.$Lbc(r)),i.set(m.$hcc,p);const o=new k.$8p(i,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(h.$7i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",D),this.c=o.invokeFunction(y=>y.get(m.$jcc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(v){const D=this.b.getProxy(F.$8J.MainThreadExtensionService);return C.URI.revive(await D.$asBrowserUri(v))}terminate(v){this.c.terminate(v)}static e(v,D){v.extensions.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(D.transformIncomingURIs(r.extensionLocation))}),v.environment.appRoot=C.URI.revive(D.transformIncomingURIs(v.environment.appRoot));const p=v.environment.extensionDevelopmentLocationURI;return p&&(v.environment.extensionDevelopmentLocationURI=p.map(r=>C.URI.revive(D.transformIncomingURIs(r)))),v.environment.extensionTestsLocationURI=C.URI.revive(D.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=C.URI.revive(D.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=C.URI.revive(D.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=C.URI.revive(D.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=C.URI.revive(D.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=C.URI.revive(D.transformIncomingURIs(v.logsLocation)),v.workspace=D.transformIncomingURIs(v.workspace),v}}e.$Jdc=n}),define(Ae[271],Re([1,0,18,13,21,41,12,19,23,2,47]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=e.$1cc=e.$Zcc=void 0;class k{constructor(c,v,D,p){this.d=c,this.e=v,this.f=D,this.g=p,this.a=null,this.b=!1,this.c=0}search(c,v){const D=this.d.folderQueries||[],p=new C.$Vd(v);return new Promise((r,s)=>{this.a=new b(c);let i=!1;const o=(y,$)=>{if(!i&&!this.b){const S=this.h(y);f(y)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,i=!0,p.cancel(),y=this.j(y,this.d.maxResults-this.c));const I=this.h(y);this.c+=I,(I>0||!f(y))&&this.a.add(y,$)}};Promise.all(D.map((y,$)=>this.k(y,S=>o(S,$),p.token))).then(y=>{p.dispose(),this.a.flush();const $=y.some(S=>!!S&&!!S.limitHit);r({limitHit:this.b||$,messages:(0,w.$Pb)(y.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},y=>{p.dispose();const $=(0,F.$xi)(y);s(new Error($))})})}h(c){return f(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,v){const D=Array.isArray(c.ranges)?c.ranges:[c.ranges],p=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:D.slice(0,v),preview:{matches:p.slice(0,v),text:c.preview.text},uri:c.uri}}async k(c,v,D){const p=new P.$SI(this.d,c),r=[],s={report:y=>{if(!this.l(y))return;const $=c.folder.scheme===A.Schemas.file?(0,P.$TI)(()=>this.f.readdir(E.$sg(y.uri))):void 0,S=E.$vg(c.folder,y.uri);if(S){const I=p.includedInQuery(S,h.$lc(S),$);(0,M.$Eg)(I)?r.push(I.then(u=>{u&&v(y)})):I&&v(y)}}},i=this.n(c),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),i,s,D);return r.length&&await Promise.all(r),o}l(c){if(f(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const v=(0,P.$RI)(this.d.includePattern,c.includePattern),D=(0,P.$RI)(this.d.excludePattern,c.excludePattern),p={folder:g.URI.from(c.folder),excludes:D,includes:v,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.$Zcc=k;function a(n){return{isCaseSensitive:n.isCaseSensitive||!1,isRegExp:n.isRegExp||!1,isWordMatch:n.isWordMatch||!1,isMultiline:n.isMultiline||!1,pattern:n.pattern}}class b{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,v=>this.g(v))}add(c,v){this.d&&(this.b!==v||!E.$mg(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=v,this.d={resource:c.uri,results:[]}),this.d.results.push(m(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$1cc=b;function m(n){return f(n)?{preview:{matches:(0,w.$Zb)(n.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:n.preview.text},ranges:(0,w.$Zb)(n.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:n.text,lineNumber:n.lineNumber}}function f(n){return!!n.preview}e.$2cc=f;class t{static{this.a=4e3}static{this.b=50}constructor(c,v){this.g=c,this.h=v,this.c=0,this.d=[],this.e=0}addItem(c,v){c&&this.j(c,v)}addItems(c,v){c&&this.k(c,v)}j(c,v){this.d.push(c),this.e+=v,this.l()}k(c,v){this.d=this.d.concat(c),this.e+=v,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$3cc=t}),define(Ae[114],Re([1,0,6,3,4,266,17,56,14,2,271]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=e.$4cc=void 0,e.$4cc=(0,C.$Mh)("IExtHostSearch");let k=class{constructor(f,t,n){this.k=f,this.l=t,this.n=n,this.c=this.k.getProxy(M.$8J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$Ycc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const n=this.d++;return this.e.set(n,t),this.c.$registerTextSearchProvider(n,this.o(f)),(0,w.$Oc)(()=>{this.g.delete(f),this.e.delete(n),this.c.$unregisterProvider(n)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const n=this.d++;return this.h.set(n,t),this.c.$registerFileSearchProvider(n,this.o(f)),(0,w.$Oc)(()=>{this.i.delete(f),this.h.delete(n),this.c.$unregisterProvider(n)})}$provideFileSearchResults(f,t,n,c){const v=a(n),D=this.h.get(f);if(D)return this.j.fileSearch(v,D,p=>{this.c.$handleFileMatch(f,t,p.map(r=>r.resource))},c);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,n,c){const v=this.e.get(f);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const D=a(n);return this.q(D,v).search(r=>this.c.$handleTextMatch(f,t,r),c)}$enableExtensionHostSearch(){}q(f,t){return new P.$Zcc(f,t,{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"textSearchProvider")}};e.$5cc=k,e.$5cc=k=Ke([Ve(0,A.$9L),Ve(1,h.$Kbc),Ve(2,E.$7i)],k);function a(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(f=>g.URI.revive(f))}}e.$6cc=a;function b(m){return{...m,folder:g.URI.revive(m.folder)}}}),define(Ae[272],Re([1,0,21,9,5,29,2,135,283,124,133,38,3,79,224,223,31,225,34,227,228,229,203,230,60,35,233,234,239,240,242,109,207,248,249,251,84,63,253,210,8,7,53,256,64,108,33,20,198,238,52,107,111,113,114,14,56,17,27,243,196,86,80,217,254,85,62,259,257,258,218,39,252,255,83,61,58,244,110,245,12,95,206,189,236,6,26,194,81,185,246,247,219,235,205,237,82,250,221,222,216,232,220]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s,i,o,y,$,S,I,u,d,l,R,B,V,j,W,O,N,ee,X,ye,De,Pe,Y,le,Ee,ce,$e,ie,z,q,ue,we,ve,me,ke,re,he,se,oe,de,Ie,L,K,G,Q,J,x,ae,Fe,je,Qe,He,_e,Ye,xe,it,tt,ze,st,_,Z,pe,Be,Ne,Ze,rt,gt,yt,Pt,Zt,qt,bt,jt,Ft,Ut,At,Rt,Ot,Bt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;function Wt(at){const ut=at.get(re.$mM),Ht=at.get(Fe.$Abc),Ct=at.get(G.$6bc),Dt=at.get(o.$jcc),ht=at.get(le.$Nbc),St=at.get(Ye.$qM),Tt=at.get(c.$Qbc),Et=at.get(me.$Kbc),qe=at.get(ke.$9L),Nt=at.get(j.$2bc),Ce=at.get(K.$7bc),Me=at.get(ve.$8i),ge=at.get(ve.$7i),H=at.get(oe.$Ovb),Le=at.get(de.$Dbc),Ue=at.get(Y.$Hcc),Ge=at.get(He.$bcc),We=at.get(_e.$Pcc),et=at.get(Ft.$fcc);qe.set(a.$9J.ExtHostFileSystemInfo,Ht),qe.set(a.$9J.ExtHostLogLevelServiceShape,Me),qe.set(a.$9J.ExtHostWorkspace,ht),qe.set(a.$9J.ExtHostConfiguration,Tt),qe.set(a.$9J.ExtHostExtensionService,Dt),qe.set(a.$9J.ExtHostStorage,Nt),qe.set(a.$9J.ExtHostTunnelService,H),qe.set(a.$9J.ExtHostWindow,Ue),qe.set(a.$9J.ExtHostSecretState,Ge),qe.set(a.$9J.ExtHostTelemetry,St),qe.set(a.$9J.ExtHostEditorTabs,We),qe.set(a.$9J.ExtHostManagedSockets,et);const pt=qe.set(a.$9J.ExtHostDecorations,at.get(z.$Lcc)),vt=qe.set(a.$9J.ExtHostDocumentsAndEditors,at.get(i.$hM)),dt=qe.set(a.$9J.ExtHostCommands,at.get(t.$sM)),ft=qe.set(a.$9J.ExtHostTerminalService,at.get(W.$9bc)),mt=qe.set(a.$9J.ExtHostDebugService,at.get(ue.$Tcc)),gi=qe.set(a.$9J.ExtHostSearch,at.get(we.$4cc)),Jt=qe.set(a.$9J.ExtHostTask,at.get(q.$Occ)),Ei=qe.set(a.$9J.ExtHostOutputService,at.get(d.$rcc)),Vt=qe.set(a.$9J.ExtHostLocalization,at.get(rt.$ecc)),mi=qe.set(a.$9J.ExtHostUrls,new De.$Acc(qe)),It=qe.set(a.$9J.ExtHostDocuments,new s.$ybc(qe,vt)),Di=qe.set(a.$9J.ExtHostDocumentContentProviders,new p.$Sbc(qe,vt,ge)),Vi=qe.set(a.$9J.ExtHostDocumentSaveParticipant,new r.$Tbc(ge,It,qe.getProxy(a.$8J.MainThreadBulkEdits))),kt=qe.set(a.$9J.ExtHostNotebook,new he.$0cc(qe,dt,vt,It,Ct)),ti=qe.set(a.$9J.ExtHostNotebookDocuments,new Z.$pdc(kt)),$i=qe.set(a.$9J.ExtHostNotebookEditors,new _.$odc(ge,kt)),si=qe.set(a.$9J.ExtHostNotebookKernels,new xe.$ldc(qe,ut,kt,dt,ge)),ki=qe.set(a.$9J.ExtHostNotebookRenderers,new tt.$ndc(qe,kt)),Si=qe.set(a.$9J.ExtHostNotebookDocumentSaveParticipant,new bt.$vdc(ge,kt,qe.getProxy(a.$8J.MainThreadBulkEdits))),Mt=qe.set(a.$9J.ExtHostEditors,new O.$ycc(qe,vt)),pi=qe.set(a.$9J.ExtHostTreeViews,new N.$zcc(qe.getProxy(a.$8J.MainThreadTreeViews),dt,ge)),Ii=qe.set(a.$9J.ExtHostEditorInsets,new ce.$Icc(qe.getProxy(a.$8J.MainThreadEditorInsets),Mt,ut.remote)),oi=qe.set(a.$9J.ExtHostDiagnostics,new v.$Cbc(qe,ge,Ht,vt)),ai=qe.set(a.$9J.ExtHostLanguages,new I.$occ(qe,It,dt.converter,Et)),ct=qe.set(a.$9J.ExtHostLanguageFeatures,new S.$Gbc(qe,Et,It,dt,oi,ge,Le,St)),qi=qe.set(a.$9J.ExtHostFileSystem,new y.$mcc(qe,ct)),Xt=qe.set(a.$9J.ExtHostFileSystemEventService,new $.$ncc(qe,ge,vt)),ii=qe.set(a.$9J.ExtHostQuickOpen,(0,R.$tcc)(qe,ht,dt)),vi=qe.set(a.$9J.ExtHostSCM,new B.$vcc(qe,dt,It,ge)),Ci=qe.set(a.$9J.ExtHostQuickDiff,new Pt.$sdc(qe,Et)),Ki=qe.set(a.$9J.ExtHostShare,new Ut.$xdc(qe,Et)),Pi=qe.set(a.$9J.ExtHostComments,(0,n.$Jbc)(qe,dt,It)),bi=qe.set(a.$9J.ExtHostProgress,new l.$scc(qe.getProxy(a.$8J.MainThreadProgress))),Ji=qe.set(a.$9J.ExtHosLabelService,new $e.$Jcc(qe)),Ai=qe.set(a.$9J.ExtHostTheming,new se.$$cc(qe)),ci=qe.set(a.$9J.ExtHostAuthentication,new Ie.$_cc(qe)),Hi=qe.set(a.$9J.ExtHostTimeline,new L.$bdc(qe,dt)),wi=qe.set(a.$9J.ExtHostWebviews,new Pe.$Dcc(qe,ut.remote,ht,ge,Le)),Ri=qe.set(a.$9J.ExtHostWebviewPanels,new x.$ddc(qe,wi,ht)),cn=qe.set(a.$9J.ExtHostCustomEditors,new J.$edc(qe,It,Ce,wi,Ri)),Mi=qe.set(a.$9J.ExtHostWebviewViews,new Q.$cdc(qe,wi)),ni=qe.set(a.$9J.ExtHostTesting,new je.$gdc(qe,dt,vt)),un=qe.set(a.$9J.ExtHostUriOpeners,new Qe.$kdc(qe)),ln=qe.set(a.$9J.ExtHostProfileContentHandlers,new yt.$rdc(qe));qe.set(a.$9J.ExtHostInteractive,new pe.$qdc(qe,kt,vt,dt,ge));const Gi=qe.set(a.$9J.ExtHostInlineChat,new qt.$udc(qe,dt,It,ge)),fi=qe.set(a.$9J.ExtHostChatProvider,new At.$ydc(qe,ge)),Qi=qe.set(a.$9J.ExtHostChatAgents,new Kt.$Cdc(qe,fi,ge)),Zi=qe.set(a.$9J.ExtHostChatVariables,new Rt.$zdc(qe)),ui=qe.set(a.$9J.ExtHostChat,new Zt.$tdc(qe,ge)),Xi=qe.set(a.$9J.ExtHostAiRelatedInformation,new Ot.$Adc(qe)),Li=qe.set(a.$9J.ExtHostAiEmbeddingVector,new Bt.$Bdc(qe)),Yi=qe.set(a.$9J.ExtHostIssueReporter,new jt.$wdc(qe)),Yt=qe.set(a.$9J.ExtHostStatusBar,new V.$xcc(qe,dt.converter)),yi=Object.values(a.$9J);qe.assertRegistered(yi);const hn=new ae.$fdc(qe,vt),Gt=new f.$Ibc(qe),li=new u.$pcc(qe,ge),Ti=new D.$Rbc(qe);return m.$Hbc.register(dt),function(Oe,_t,Fi){const $t=function(){let te=!Oe.isUnderDevelopment;function fe(){te||(ge.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(nt){if(Array.isArray(nt))nt.forEach(Te);else if(typeof nt=="string")fe();else{const wt=nt;typeof wt.scheme>"u"&&fe(),typeof wt.exclusive=="boolean"&&(0,Ne.$8E)(Oe,"documentFiltersExclusive")}return nt}}(),_i={getSession(te,fe,Te){return ci.getSession(Oe,te,fe,Te)},getSessions(te,fe){return(0,Ne.$8E)(Oe,"authGetSessions"),ci.getSessions(Oe,te,fe)},async hasSession(te,fe){return(0,Ne.$8E)(Oe,"authSession"),!!await ci.getSession(Oe,te,fe,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,fe,Te,nt){return ci.registerAuthenticationProvider(te,fe,Te,nt)}},xi={registerCommand(te,fe,Te){return dt.registerCommand(!0,te,fe,Te,void 0,Oe)},registerTextEditorCommand(te,fe,Te){return dt.registerCommand(!0,te,(...nt)=>{const wt=Mt.getActiveTextEditor();if(!wt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Lt=>{fe.apply(Te,[wt,Lt,...nt])}).then(Lt=>{Lt||ge.warn("Edits from command "+te+" were not applied.")},Lt=>{ge.warn("An error occurred while running command "+te,Lt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(te,fe,Te)=>((0,Ne.$8E)(Oe,"diffCommand"),dt.registerCommand(!0,te,async(...nt)=>{const wt=vt.activeEditor(!0);if(!wt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(wt.id);fe.apply(Te,[Lt,...nt])},void 0,void 0,Oe)),executeCommand(te,...fe){return dt.executeCommand(te,...fe)},getCommands(te=!1){return dt.getCommands(te)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return ft.getDefaultShell(!1)},get onDidChangeShell(){return ft.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$8E)(Oe,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$8E)(Oe,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$pM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,fe){return Ye.$oM.validateSender(te),St.instantiateLogger(Oe,te,fe)},openExternal(te,fe){return Ue.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return mi.createAppUri(te);try{return await Ue.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(fe){if((0,st.$1T)(te,ze.Schemas.http)||(0,st.$1T)(te,ze.Schemas.https))return te;throw fe}},get remoteName(){return(0,ie.$Rk)(ut.remote.authority)},get remoteAuthority(){return(0,Ne.$8E)(Oe,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return ge.getLevel()},get onDidChangeLogLevel(){return ge.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.$8E)(Oe,"handleIssueUri"),Yi.registerIssueUriRequestHandler(Oe,te)},get appQuality(){return(0,Ne.$8E)(Oe,"resolvers"),ut.quality},get appCommit(){return(0,Ne.$8E)(Oe,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(te,fe,Te){return ni.createTestController(Oe,te,fe,Te)},createTestObserver(){return(0,Ne.$8E)(Oe,"testObserver"),ni.createTestObserver()},runTests(te){return(0,Ne.$8E)(Oe,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,Ne.$8E)(Oe,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Ne.$8E)(Oe,"testObserver"),ni.results}},hi=ut.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,tn={getExtension(te,fe){(0,Ne.$7E)(Oe,"extensionsAny")||(fe=!1);const Te=_t.mine.getExtensionDescription(te);if(Te)return new o.$kcc(Dt,Oe.identifier,Te,hi,!1);if(fe){const nt=_t.all.getExtensionDescription(te);if(nt)return new o.$kcc(Dt,Oe.identifier,nt,hi,!0)}},get all(){const te=[];for(const fe of _t.mine.getAllExtensionDescriptions())te.push(new o.$kcc(Dt,Oe.identifier,fe,hi,!1));return te},get allAcrossExtensionHosts(){(0,Ne.$8E)(Oe,"extensionsAny");const te=new Ee.$Yl(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),fe=[];for(const Te of _t.all.getAllExtensionDescriptions()){const nt=!te.has(Te.identifier);fe.push(new o.$kcc(Dt,Oe.identifier,Te,hi,nt))}return fe},get onDidChange(){return(0,Ne.$7E)(Oe,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,fe){return ai.changeLanguage(te.uri,fe)},match(te,fe){const Te=It.getDocumentData(fe.uri)?.notebook;return(0,P.$iE)(ee.LanguageSelector.from(te),fe.uri,fe.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,fe,Te){return ct.registerCodeActionProvider(Oe,$t(te),fe,Te)},registerDocumentPasteEditProvider(te,fe,Te){return(0,Ne.$8E)(Oe,"documentPaste"),ct.registerDocumentPasteEditProvider(Oe,$t(te),fe,Te)},registerCodeLensProvider(te,fe){return ct.registerCodeLensProvider(Oe,$t(te),fe)},registerDefinitionProvider(te,fe){return ct.registerDefinitionProvider(Oe,$t(te),fe)},registerDeclarationProvider(te,fe){return ct.registerDeclarationProvider(Oe,$t(te),fe)},registerImplementationProvider(te,fe){return ct.registerImplementationProvider(Oe,$t(te),fe)},registerTypeDefinitionProvider(te,fe){return ct.registerTypeDefinitionProvider(Oe,$t(te),fe)},registerHoverProvider(te,fe){return ct.registerHoverProvider(Oe,$t(te),fe,Oe.identifier)},registerEvaluatableExpressionProvider(te,fe){return ct.registerEvaluatableExpressionProvider(Oe,$t(te),fe,Oe.identifier)},registerInlineValuesProvider(te,fe){return ct.registerInlineValuesProvider(Oe,$t(te),fe,Oe.identifier)},registerDocumentHighlightProvider(te,fe){return ct.registerDocumentHighlightProvider(Oe,$t(te),fe)},registerLinkedEditingRangeProvider(te,fe){return ct.registerLinkedEditingRangeProvider(Oe,$t(te),fe)},registerReferenceProvider(te,fe){return ct.registerReferenceProvider(Oe,$t(te),fe)},registerRenameProvider(te,fe){return ct.registerRenameProvider(Oe,$t(te),fe)},registerDocumentSymbolProvider(te,fe,Te){return ct.registerDocumentSymbolProvider(Oe,$t(te),fe,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,fe){return ct.registerDocumentFormattingEditProvider(Oe,$t(te),fe)},registerDocumentRangeFormattingEditProvider(te,fe){return ct.registerDocumentRangeFormattingEditProvider(Oe,$t(te),fe)},registerOnTypeFormattingEditProvider(te,fe,Te,...nt){return ct.registerOnTypeFormattingEditProvider(Oe,$t(te),fe,[Te].concat(nt))},registerDocumentSemanticTokensProvider(te,fe,Te){return ct.registerDocumentSemanticTokensProvider(Oe,$t(te),fe,Te)},registerDocumentRangeSemanticTokensProvider(te,fe,Te){return ct.registerDocumentRangeSemanticTokensProvider(Oe,$t(te),fe,Te)},registerSignatureHelpProvider(te,fe,Te,...nt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Oe,$t(te),fe,Te):ct.registerSignatureHelpProvider(Oe,$t(te),fe,typeof Te>"u"?[]:[Te,...nt])},registerCompletionItemProvider(te,fe,...Te){return ct.registerCompletionItemProvider(Oe,$t(te),fe,Te)},registerInlineCompletionItemProvider(te,fe,Te){return fe.handleDidShowCompletionItem&&(0,Ne.$8E)(Oe,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$8E)(Oe,"inlineCompletionsAdditions"),Te&&(0,Ne.$8E)(Oe,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Oe,$t(te),fe,Te)},registerDocumentLinkProvider(te,fe){return ct.registerDocumentLinkProvider(Oe,$t(te),fe)},registerColorProvider(te,fe){return ct.registerColorProvider(Oe,$t(te),fe)},registerFoldingRangeProvider(te,fe){return ct.registerFoldingRangeProvider(Oe,$t(te),fe)},registerSelectionRangeProvider(te,fe){return ct.registerSelectionRangeProvider(Oe,te,fe)},registerCallHierarchyProvider(te,fe){return ct.registerCallHierarchyProvider(Oe,te,fe)},registerTypeHierarchyProvider(te,fe){return ct.registerTypeHierarchyProvider(Oe,te,fe)},setLanguageConfiguration:(te,fe)=>ct.setLanguageConfiguration(Oe,te,fe),getTokenInformationAtPosition(te,fe){return(0,Ne.$8E)(Oe,"tokenInformation"),ai.tokenAtPosition(te,fe)},registerInlayHintsProvider(te,fe){return ct.registerInlayHintsProvider(Oe,te,fe)},createLanguageStatusItem(te,fe){return ai.createLanguageStatusItem(Oe,te,fe)},registerDocumentDropEditProvider(te,fe,Te){return ct.registerDocumentOnDropEditProvider(Oe,te,fe,(0,Ne.$7E)(Oe,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,fe,Te){const nt=await(A.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Mt.showTextDocument(nt,fe,Te)},createTextEditorDecorationType(te){return Mt.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,fe,Te){return Mt.onDidChangeActiveTextEditor(te,fe,Te)},onDidChangeVisibleTextEditors(te,fe,Te){return Mt.onDidChangeVisibleTextEditors(te,fe,Te)},onDidChangeTextEditorSelection(te,fe,Te){return Mt.onDidChangeTextEditorSelection(te,fe,Te)},onDidChangeTextEditorOptions(te,fe,Te){return Mt.onDidChangeTextEditorOptions(te,fe,Te)},onDidChangeTextEditorVisibleRanges(te,fe,Te){return Mt.onDidChangeTextEditorVisibleRanges(te,fe,Te)},onDidChangeTextEditorViewColumn(te,fe,Te){return Mt.onDidChangeTextEditorViewColumn(te,fe,Te)},onDidCloseTerminal(te,fe,Te){return ft.onDidCloseTerminal(te,fe,Te)},onDidOpenTerminal(te,fe,Te){return ft.onDidOpenTerminal(te,fe,Te)},onDidChangeActiveTerminal(te,fe,Te){return ft.onDidChangeActiveTerminal(te,fe,Te)},onDidChangeTerminalDimensions(te,fe,Te){return(0,Ne.$8E)(Oe,"terminalDimensions"),ft.onDidChangeTerminalDimensions(te,fe,Te)},onDidChangeTerminalState(te,fe,Te){return ft.onDidChangeTerminalState(te,fe,Te)},onDidWriteTerminalData(te,fe,Te){return(0,Ne.$8E)(Oe,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(te,fe,Te)},onDidExecuteTerminalCommand(te,fe,Te){return(0,Ne.$8E)(Oe,"terminalExecuteCommandEvent"),ft.onDidExecuteTerminalCommand(te,fe,Te)},get state(){return Ue.getState(Oe)},onDidChangeWindowState(te,fe,Te){return Ue.onDidChangeWindowState(te,fe,Te)},showInformationMessage(te,...fe){return li.showMessage(Oe,F.default.Info,te,fe[0],fe.slice(1))},showWarningMessage(te,...fe){return li.showMessage(Oe,F.default.Warning,te,fe[0],fe.slice(1))},showErrorMessage(te,...fe){return li.showMessage(Oe,F.default.Error,te,fe[0],fe.slice(1))},showQuickPick(te,fe,Te){return ii.showQuickPick(Oe,te,fe,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,fe){return ii.showInput(te,fe)},showOpenDialog(te){return Ti.showOpenDialog(Oe,te)},showSaveDialog(te){return Ti.showSaveDialog(te)},createStatusBarItem(te,fe,Te){let nt,wt,Lt;return typeof te=="string"?(nt=te,wt=fe,Lt=Te):(wt=te,Lt=fe),Yt.createStatusBarEntry(Oe,nt,wt,Lt)},setStatusBarMessage(te,fe){return Yt.setStatusBarMessage(te,fe)},withScmProgress(te){return Le.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),bi.withProgress(Oe,{location:X.ProgressLocation.SourceControl},(fe,Te)=>te({report(nt){}}))},withProgress(te,fe){return bi.withProgress(Oe,te,fe)},createOutputChannel(te,fe){return Ei.createOutputChannel(te,fe,Oe)},createWebviewPanel(te,fe,Te,nt){return Ri.createWebviewPanel(Oe,te,fe,Te,nt)},createWebviewTextEditorInset(te,fe,Te,nt){return(0,Ne.$8E)(Oe,"editorInsets"),Ii.createWebviewEditorInset(te,fe,Te,nt,Oe)},createTerminal(te,fe,Te){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):ft.createTerminalFromOptions(te):ft.createTerminal(te,fe,Te)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTerminalProfileProvider(te,fe){return ft.registerProfileProvider(Oe,te,fe)},registerTerminalQuickFixProvider(te,fe){return(0,Ne.$8E)(Oe,"terminalQuickFixProvider"),ft.registerTerminalQuickFixProvider(te,Oe.identifier.value,fe)},registerTreeDataProvider(te,fe){return pi.registerTreeDataProvider(te,fe,Oe)},createTreeView(te,fe){return pi.createTreeView(te,fe,Oe)},registerWebviewPanelSerializer:(te,fe)=>Ri.registerWebviewPanelSerializer(Oe,te,fe),registerCustomEditorProvider:(te,fe,Te={})=>cn.registerCustomEditorProvider(Oe,te,fe,Te),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,Oe)},registerUriHandler(te){return mi.registerUriHandler(Oe,te)},createQuickPick(){return ii.createQuickPick(Oe)},createInputBox(){return ii.createInputBox(Oe)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,fe,Te){return Ai.onDidChangeActiveColorTheme(te,fe,Te)},registerWebviewViewProvider(te,fe,Te){return Mi.registerWebviewViewProvider(Oe,te,fe,Te?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,fe,Te){return kt.onDidChangeActiveNotebookEditor(te,fe,Te)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,fe,Te){return $i.onDidChangeNotebookEditorSelection(te,fe,Te)},onDidChangeNotebookEditorVisibleRanges(te,fe,Te){return $i.onDidChangeNotebookEditorVisibleRanges(te,fe,Te)},showNotebookDocument(te,fe){return kt.showNotebookDocument(te,fe)},registerExternalUriOpener(te,fe,Te){return(0,Ne.$8E)(Oe,"externalUriOpener"),un.registerExternalUriOpener(Oe.identifier,te,fe,Te)},registerProfileContentHandler(te,fe){return(0,Ne.$8E)(Oe,"profileContentHandlers"),ln.registrProfileContentHandler(Oe,te,fe)},registerQuickDiffProvider(te,fe,Te,nt){return(0,Ne.$8E)(Oe,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(te),fe,Te,nt)},get tabGroups(){return We.tabGroups},registerShareProvider(te,fe){return(0,Ne.$8E)(Oe,"shareProvider"),Ki.registerShareProvider($t(te),fe)}},sn={get rootPath(){return Le.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new M.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new M.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new M.$7("workspaceFile")},updateWorkspaceFolders:(te,fe,...Te)=>ht.updateWorkspaceFolders(Oe,te,fe||0,...Te),onDidChangeWorkspaceFolders:function(te,fe,Te){return ht.onDidChangeWorkspace(te,fe,Te)},asRelativePath:(te,fe)=>ht.getRelativePath(te,fe),findFiles:(te,fe,Te,nt)=>ht.findFiles(te,fe,Te,Oe.identifier,nt),findTextInFiles:(te,fe,Te,nt)=>{(0,Ne.$8E)(Oe,"findTextInFiles");let wt,Lt;return typeof fe=="object"?(wt=fe,Lt=Te):(wt={},Lt=fe,nt=Te),ht.findTextInFiles(te,wt||{},Lt,Oe.identifier,nt)},save:te=>((0,Ne.$8E)(Oe,"saveEditor"),ht.save(te)),saveAs:te=>((0,Ne.$8E)(Oe,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,fe){return hn.applyWorkspaceEdit(te,Oe,fe)},createFileSystemWatcher:(te,fe,Te,nt)=>Xt.createFileSystemWatcher(ht,Oe,te,fe,Te,nt),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$7("textDocuments")},openTextDocument(te){let fe;const Te=te;if(typeof te=="string")fe=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))fe=Promise.resolve(te);else if(!Te||typeof Te=="object")fe=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(nt=>It.ensureDocumentData(nt).then(wt=>wt.document))},onDidOpenTextDocument:(te,fe,Te)=>It.onDidAddDocument(te,fe,Te),onDidCloseTextDocument:(te,fe,Te)=>It.onDidRemoveDocument(te,fe,Te),onDidChangeTextDocument:(te,fe,Te)=>It.onDidChangeDocument(te,fe,Te),onDidSaveTextDocument:(te,fe,Te)=>It.onDidSaveDocument(te,fe,Te),onWillSaveTextDocument:(te,fe,Te)=>Vi.getOnWillSaveTextDocumentEvent(Oe)(te,fe,Te),get notebookDocuments(){return kt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,fe){let Te;if(A.URI.isUri(te))Te=te,await kt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await kt.createNotebookDocument({viewType:te,content:fe}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,fe,Te){return ti.onDidSaveNotebookDocument(te,fe,Te)},onDidChangeNotebookDocument(te,fe,Te){return ti.onDidChangeNotebookDocument(te,fe,Te)},onWillSaveNotebookDocument(te,fe,Te){return Si.getOnWillSaveNotebookDocumentEvent(Oe)(te,fe,Te)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(te,fe,Te,nt){return kt.registerNotebookSerializer(Oe,te,fe,Te,(0,Ne.$7E)(Oe,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(te,fe,Te)=>Fi.onDidChangeConfiguration(te,fe,Te),getConfiguration(te,fe){return fe=arguments.length===1?void 0:fe,Fi.getConfiguration(te,fe,Oe)},registerTextDocumentContentProvider(te,fe){return Di.registerTextDocumentContentProvider(te,fe)},registerTaskProvider:(te,fe)=>(Le.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(Oe,te,fe)),registerFileSystemProvider(te,fe,Te){return(0,Be.$Nc)(qi.registerFileSystemProvider(Oe,te,fe,Te),Ct.addFileSystemProvider(te,fe,Te))},get fs(){return Ct.value},registerFileSearchProvider:(te,fe)=>((0,Ne.$8E)(Oe,"fileSearchProvider"),gi.registerFileSearchProvider(te,fe)),registerTextSearchProvider:(te,fe)=>((0,Ne.$8E)(Oe,"textSearchProvider"),gi.registerTextSearchProvider(te,fe)),registerRemoteAuthorityResolver:(te,fe)=>((0,Ne.$8E)(Oe,"resolvers"),Dt.registerRemoteAuthorityResolver(te,fe)),registerResourceLabelFormatter:te=>((0,Ne.$8E)(Oe,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.$8E)(Oe,"resolvers"),Dt.getRemoteExecServer(te)),onDidCreateFiles:(te,fe,Te)=>Xt.onDidCreateFile(te,fe,Te),onDidDeleteFiles:(te,fe,Te)=>Xt.onDidDeleteFile(te,fe,Te),onDidRenameFiles:(te,fe,Te)=>Xt.onDidRenameFile(te,fe,Te),onWillCreateFiles:(te,fe,Te)=>Xt.getOnWillCreateFileEvent(Oe)(te,fe,Te),onWillDeleteFiles:(te,fe,Te)=>Xt.getOnWillDeleteFileEvent(Oe)(te,fe,Te),onWillRenameFiles:(te,fe,Te)=>Xt.getOnWillRenameFileEvent(Oe)(te,fe,Te),openTunnel:te=>((0,Ne.$8E)(Oe,"tunnels"),H.openTunnel(Oe,te).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ne.$8E)(Oe,"tunnels"),H.getTunnels()},onDidChangeTunnels:(te,fe,Te)=>((0,Ne.$8E)(Oe,"tunnels"),H.onDidChangeTunnels(te,fe,Te)),registerPortAttributesProvider:(te,fe)=>((0,Ne.$8E)(Oe,"portsAttributes"),H.registerPortsAttributesProvider(te,fe)),registerTunnelProvider:(te,fe)=>((0,Ne.$8E)(Oe,"tunnelFactory"),H.registerTunnelProvider(te,fe)),registerTimelineProvider:(te,fe)=>((0,Ne.$8E)(Oe,"timeline"),Hi.registerTimelineProvider(te,fe,Oe.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Ne.$8E)(Oe,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,fe,Te)=>ht.onDidGrantWorkspaceTrust(te,fe,Te),registerEditSessionIdentityProvider:(te,fe)=>((0,Ne.$8E)(Oe,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,fe)),onWillCreateEditSessionIdentity:(te,fe,Te)=>((0,Ne.$8E)(Oe,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Oe)(te,fe,Te)),registerCanonicalUriProvider:(te,fe)=>((0,Ne.$8E)(Oe,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,fe)),getCanonicalUri:(te,fe,Te)=>((0,Ne.$8E)(Oe,"canonicalUriProvider"),ht.provideCanonicalUri(te,fe,Te))},fn={get inputBox(){return Le.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Oe)},createSourceControl(te,fe,Te){return vi.createSourceControl(Oe,te,fe,Te)}},on={createCommentController(te,fe){return Pi.createCommentController(Oe,te,fe)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(te,fe,Te){return mt.onDidStartDebugSession(te,fe,Te)},onDidTerminateDebugSession(te,fe,Te){return mt.onDidTerminateDebugSession(te,fe,Te)},onDidChangeActiveDebugSession(te,fe,Te){return mt.onDidChangeActiveDebugSession(te,fe,Te)},onDidReceiveDebugSessionCustomEvent(te,fe,Te){return mt.onDidReceiveDebugSessionCustomEvent(te,fe,Te)},onDidChangeBreakpoints(te,fe,Te){return mt.onDidChangeBreakpoints(te,fe,Te)},onDidChangeStackFrameFocus(te,fe,Te){return(0,Ne.$8E)(Oe,"debugFocus"),mt.onDidChangeStackFrameFocus(te,fe,Te)},registerDebugConfigurationProvider(te,fe,Te){return mt.registerDebugConfigurationProvider(te,fe,Te||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,fe){return mt.registerDebugAdapterDescriptorFactory(Oe,te,fe)},registerDebugAdapterTrackerFactory(te,fe){return mt.registerDebugAdapterTrackerFactory(te,fe)},startDebugging(te,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(te,fe,{parentSession:Te}):mt.startDebugging(te,fe,Te||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,fe){return mt.asDebugSourceUri(te,fe)}},Oi={registerTaskProvider:(te,fe)=>Jt.registerTaskProvider(Oe,te,fe),fetchTasks:te=>Jt.fetchTasks(te),executeTask:te=>Jt.executeTask(Oe,te),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(te,fe,Te)=>Jt.onDidStartTask(te,fe,Te),onDidEndTask:(te,fe,Te)=>Jt.onDidEndTask(te,fe,Te),onDidStartTaskProcess:(te,fe,Te)=>Jt.onDidStartTaskProcess(te,fe,Te),onDidEndTaskProcess:(te,fe,Te)=>Jt.onDidEndTaskProcess(te,fe,Te)},Ni={createNotebookController(te,fe,Te,nt,wt){return si.createNotebookController(Oe,te,fe,Te,nt,(0,Ne.$7E)(Oe,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,fe)=>kt.registerNotebookCellStatusBarItemProvider(Oe,te,fe),createRendererMessaging(te){return ki.createRendererMessaging(Oe,te)},createNotebookControllerDetectionTask(te){return(0,Ne.$8E)(Oe,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Oe,te)},registerKernelSourceActionProvider(te,fe){return(0,Ne.$8E)(Oe,"notebookKernelSource"),si.registerKernelSourceActionProvider(Oe,te,fe)},onDidChangeNotebookCellExecutionState(te,fe,Te){return(0,Ne.$8E)(Oe,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,fe,Te)}},zi={t(...te){if(typeof te[0]=="string"){const fe=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return Vt.getMessage(Oe.identifier.value,{message:fe,args:Te})}return Vt.getMessage(Oe.identifier.value,te[0])},get bundle(){return Vt.getBundle(Oe.identifier.value)},get uri(){return Vt.getBundleUri(Oe.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(te,fe){return(0,Ne.$8E)(Oe,"interactive"),Gi.registerProvider(Oe,te,fe={label:fe?.label??Oe.displayName??Oe.name})},registerInteractiveSessionProvider(te,fe){return(0,Ne.$8E)(Oe,"interactive"),ui.registerChatProvider(Oe,te,fe)},addInteractiveRequest(te){return(0,Ne.$8E)(Oe,"interactive"),ui.addChatRequest(te)},sendInteractiveRequestToProvider(te,fe){return(0,Ne.$8E)(Oe,"interactive"),ui.sendInteractiveRequestToProvider(te,fe)},get onDidPerformUserAction(){return(0,Ne.$8E)(Oe,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(te,fe){return(0,Ne.$8E)(Oe,"interactive"),ui.transferChatSession(te,fe)}},ji={getRelatedInformation(te,fe){return(0,Ne.$8E)(Oe,"aiRelatedInformation"),Xi.getRelatedInformation(Oe,te,fe)},registerRelatedInformationProvider(te,fe){return(0,Ne.$8E)(Oe,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(Oe,te,fe)},registerEmbeddingVectorProvider(te,fe){return(0,Ne.$8E)(Oe,"aiRelatedInformation"),Li.registerEmbeddingVectorProvider(Oe,te,fe)}},Ui={registerChatResponseProvider(te,fe,Te){return(0,Ne.$8E)(Oe,"chatProvider"),fi.registerProvider(Oe.identifier,te,fe,Te)},requestChatAccess(te){return(0,Ne.$8E)(Oe,"chatRequestAccess"),fi.requestChatResponseProvider(Oe.identifier,te)},registerVariable(te,fe,Te){return(0,Ne.$8E)(Oe,"chatVariables"),Zi.registerVariableResolver(Oe,te,fe,Te)},registerMappedEditsProvider(te,fe){return(0,Ne.$8E)(Oe,"mappedEditsProvider"),ct.registerMappedEditsProvider(Oe,te,fe)},registerAgent(te,fe,Te){return(0,Ne.$8E)(Oe,"chatAgents"),Qi.registerAgent(Oe.identifier,te,fe,Te)}};return{version:ut.version,ai:ji,authentication:_i,commands:xi,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Ni,scm:fn,tasks:Oi,tests:dn,window:rn,workspace:sn,Breakpoint:X.$8K,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatMessage:X.$XL,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$uK,CallHierarchyItem:X.$tK,CallHierarchyOutgoingCall:X.$vK,CancellationError:M.$3,CancellationTokenSource:w.$Vd,CandidatePortSource:a.CandidatePortSource,CodeAction:X.$qK,CodeActionKind:X.$rK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$wK,Color:X.$JK,ColorInformation:X.$KK,ColorPresentation:X.$LK,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$DK,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$EK,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$TK,DebugAdapterExecutable:X.$_K,DebugAdapterInlineImplementation:X.$cL,DebugAdapterNamedPipeServer:X.$bL,DebugAdapterServer:X.$aL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$lK,DiagnosticRelatedInformation:X.$kK,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$0J,DocumentHighlight:X.$nK,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$IK,DocumentSymbol:X.$pK,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$fL,InlineValueText:X.$gL,InlineValueVariableLookup:X.$hL,InlineValueEvaluatableExpression:X.$iL,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:C.$Ld,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$sL,FileDecoration2:X.$sL,FileSystemError:X.$kL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:X.$lL,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$0K,InlineCompletionItem:X.$FK,InlineCompletionList:X.$GK,Hover:X.$mK,IndentAction:g.IndentAction,Location:X.$jK,MarkdownString:X.$xK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:X.$yK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$$J,ProcessExecution:X.$RK,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$rL,Range:X.$_J,RelativePattern:X.$6K,Selection:X.$aK,SelectionRange:X.$sK,SemanticTokens:X.$oL,SemanticTokensBuilder:X.$nL,SemanticTokensEdit:X.$pL,SemanticTokensEdits:X.$qL,SemanticTokensLegend:X.$mL,ShellExecution:X.$SK,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$AK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$zK,SnippetString:X.$iK,SourceBreakpoint:X.$9K,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$oK,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$UK,TaskGroup:X.$QK,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$MK,TerminalQuickFixExecuteTerminalCommand:X.$OK,TerminalQuickFixOpener:X.$NK,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$PK,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$eK,SnippetTextEdit:X.$gK,TextEditorCursorStyle:h.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$5K,ThemeIcon:X.$4K,TreeItem:X.$VK,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$NL,UIKind:b.UIKind,Uri:A.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$hK,DocumentDropEdit:X.$2K,DocumentPasteEdit:X.$3K,InlayHint:X.$CK,InlayHintLabelPart:X.$BK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$dK,ResolvedAuthority:X.$bK,ManagedResolvedAuthority:X.$cK,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$CL,NotebookRange:X.$uL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$vL,NotebookData:X.$wL,NotebookRendererScript:X.$AL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$yL,NotebookCellOutputItem:X.$xL,NotebookCellStatusBarItem:X.$zL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$fK,NotebookKernelSourceAction:X.$BL,PortAttributes:X.$EL,LinkedEditingRanges:X.$DL,TestResultState:X.TestResultState,TestRunRequest:X.$FL,TestMessage:X.$GL,TestMessage2:X.$GL,TestTag:X.$HL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$1K,DataTransferItem:X.$WK,CoveredCount:X.$IL,FileCoverage:X.$JL,StatementCoverage:X.$KL,BranchCoverage:X.$LL,FunctionCoverage:X.$ML,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$OL,TabInputTextDiff:X.$PL,TabInputTextMerge:X.$QL,TabInputCustom:X.$RL,TabInputNotebook:X.$TL,TabInputNotebookDiff:X.$UL,TabInputWebview:X.$SL,TabInputTerminal:X.$VL,TabInputInteractiveWindow:X.$WL,TelemetryTrustedValue:ye.$bo,LogLevel:ve.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$dL,ThreadFocus:X.$eL,RelatedInformationType:X.RelatedInformationType}}}e.$Ddc=Wt}),define(Ae[273],Re([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,39,83,58,61,241,14,112,81,82]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s,i,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$or)(o.$ecc,o.$dcc,1),(0,w.$or)(s.$8i,r.$Edc,1),(0,w.$or)(f.$Dbc,f.$Ebc,1),(0,w.$or)(h.$sM,h.$rM,0),(0,w.$or)(A.$Qbc,A.$Obc,0),(0,w.$or)(n.$6bc,n.$5bc,0),(0,w.$or)(k.$Tcc,k.$Xcc,0),(0,w.$or)(F.$Lcc,F.$Kcc,0),(0,w.$or)(E.$hM,E.$gM,0),(0,w.$or)(y.$fcc,y.$gcc,0),(0,w.$or)(c.$Abc,c.$zbc,0),(0,w.$or)(M.$rcc,M.$qcc,1),(0,w.$or)(a.$4cc,a.$5cc,0),(0,w.$or)(b.$2bc,b.$1bc,0),(0,w.$or)(P.$Occ,P.$Ncc,0),(0,w.$or)(g.$9bc,g.$_bc,0),(0,w.$or)(m.$Ovb,m.$Pvb,0),(0,w.$or)(t.$Hcc,t.$Gcc,0),(0,w.$or)(C.$Nbc,C.$Mbc,0),(0,w.$or)(v.$bcc,v.$acc,0),(0,w.$or)(D.$qM,D.$nM,0),(0,w.$or)(p.$Pcc,p.$Qcc,0),(0,w.$or)(i.$Rcc,i.$Scc,0)}),define(Ae[274],Re([1,0,272,35,2,269,7,13,260]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;class g extends F.$Hdc{j(){}getModule(b,m){for(const f of this.b){const t=f(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends M.$icc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(E.$Mfc);const b=this.h.invokeFunction(w.$Ddc);this.r=this.h.createInstance(g,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,m,f){m=m.with({path:k(m.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const n=C.URI.revive(await this.C.$asBrowserUri(m)),c=await fetch(n.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const v=await c.text(),D=`${m.toString(!0)}#vscode-extension`,p=`${v}
//# sourceURL=${D}`;let r;try{r=new Function("module","exports","require",p)}catch(y){throw console.error(t?`Loading code for extension ${t} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${m.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}b&&await this.w.initializeLocalizedMessages(b);const s={},i={exports:s},o=y=>{const $=this.r.getModule(y,m);if($===void 0)throw new Error(`Cannot load module '${y}'`);return $};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(i,s,o),i.exports!==s?i.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,h.$Sg)(10)}}e.$Nfc=P;function k(a,b){return a.endsWith(b)?a:a+b}}),define(Ae[275],Re([1,0,69,70,14,35,187,85,274]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$or)(C.$7i,new w.$Jh(A.$Gdc,[!0],!0)),(0,M.$or)(F.$jcc,E.$Nfc,0),(0,M.$or)(h.$7bc,h.$8bc,0)}),define(Ae[284],Re([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(r){return/^(file|vscode-remote):/i.test(r)}const m=fetch.bind(self);function f(r){self.fetch=async function(s,i){return s instanceof Request||b(String(s))&&(s=(await r(P.URI.parse(String(s)))).toString(!0)),m(s,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,i,o,y,$){(async()=>(b(i.toString())&&(i=(await r(P.URI.parse(i.toString()))).toString(!0)),super.open(s,i,o??!0,y,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,i){if(/^file:/i.test(s.toString()))s=g.$ag.uriToBrowserUri(P.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(u){function d(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,`${g.Schemas.vscodeFileResource}://${g.$_f}`):B}const l=fetch.bind(self);self.fetch=function(B,V){return B instanceof Request?l(B,V):l(d(B),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,V,j,W,O){return super.open(B,d(V),j??!0,W,O)}};const R=importScripts.bind(self);self.importScripts=(...B)=>{R(...B.map(d))},R(u)}.toString()}('${s}'))`;i=i||{},i.name=i.name||h.$lc(s.toString());const $=new Blob([y],{type:"application/javascript"}),S=URL.createObjectURL($);return new r(S,i)}}else self.Worker=class extends A.$Ofc{constructor(r,s){super(a,r,{name:h.$lc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){k()}};class n{constructor(){const s=new MessageChannel,i=new M.$Ld;let o=!1;a(s.port2,[s.port2]),s.port1.onmessage=y=>{const{data:$}=y;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const S=w.$_d.wrap(new Uint8Array($,0,$.byteLength));if((0,C.$7l)(S,2)){o=!0,v("received terminate message from renderer");return}i.fire(S)},this.protocol={onMessage:i.event,send:y=>{if(!o){const $=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);s.port1.postMessage($,[$])}}}}}function c(r){return new Promise(s=>{const i=r.onMessage(o=>{i.dispose();const y=JSON.parse(o.toString());r.send((0,C.$6l)(0)),s({protocol:r,initData:y})});r.send((0,C.$6l)(1))})}let v=r=>k();function D(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function p(){E.mark("code/extHost/willConnectToRenderer");const r=new n;return{onmessage(s){D(s)&&c(r.protocol).then(i=>{E.mark("code/extHost/didWaitForInitData");const o=new F.$Jdc(i.protocol,i.initData,t,null,s.data);f(y=>o.asBrowserUri(y)),v=y=>o.terminate(y)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4a0e77678c0295b518151ae2d706436bab96ef4f/core/vs/workbench/api/worker/extensionHostWorker.js.map
